/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/base/common/errors","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/map","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","fs","vs/editor/common/core/position","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/hash","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/errorMessage","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/codicons","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","os","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/tunnel","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","path","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ge=function(J){for(var e=[],p=0,L=J.length;p<L;p++)e[p]=me[J[p]];return e};define(me[52],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(L,C){if(!L)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=p}),define(me[69],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const p=Object.prototype.hasOwnProperty;function L(i){const P=[];for(let c in i)p.call(i,c)&&P.push(i[c]);return P}e.values=L;function C(i,P){for(let c in i)if(p.call(i,c)&&P({key:c,value:i[c]},function(){delete i[c]})===!1)return}e.forEach=C;function S(i,P){const c=Object.create(null);for(const u of i){const a=P(u);let g=c[a];g||(g=c[a]=[]),g.push(u)}return c}e.groupBy=S;function T(i){const P=Object.create(null);return i&&i.forEach((c,u)=>{P[u]=c}),P}e.fromMap=T;function I(i,P){const c=[],u=[];for(let a of i)P.has(a)||c.push(a);for(let a of P)i.has(a)||u.push(a);return{removed:c,added:u}}e.diffSets=I;function D(i,P){const c=[],u=[];for(let[a,g]of i)P.has(a)||c.push(g);for(let[a,g]of P)i.has(a)||u.push(g);return{removed:c,added:u}}e.diffMaps=D;class A{constructor(){this.map=new Map}add(P,c){let u=this.map.get(P);u||(u=new Set,this.map.set(P,u)),u.add(c)}delete(P,c){const u=this.map.get(P);!u||(u.delete(c),u.size===0&&this.map.delete(P))}forEach(P,c){const u=this.map.get(P);!u||u.forEach(c)}}e.SetMap=A}),define(me[53],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(T){return(I,D,A)=>{let i=null,P=null;if(typeof A.value=="function"?(i="value",P=A.value):typeof A.get=="function"&&(i="get",P=A.get),!P)throw new Error("not supported");A[i]=T(P,D)}}e.createDecorator=p;function L(T,I,D){let A=null,i=null;if(typeof D.value=="function"?(A="value",i=D.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(A="get",i=D.get),!i)throw new Error("not supported");const P=`$memoize$${I}`;D[A]=function(...c){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,c)}),this[P]}}e.memoize=L;function C(T,I,D){return p((A,i)=>{const P=`$debounce$${i}`,c=`$debounce$result$${i}`;return function(...u){this[c]||(this[c]=D?D():void 0),clearTimeout(this[P]),I&&(this[c]=I(this[c],...u),u=[this[c]]),this[P]=setTimeout(()=>{A.apply(this,u),this[c]=D?D():void 0},T)}})}e.debounce=C;function S(T,I,D){return p((A,i)=>{const P=`$throttle$timer$${i}`,c=`$throttle$result$${i}`,u=`$throttle$lastRun$${i}`,a=`$throttle$pending$${i}`;return function(...g){if(this[c]||(this[c]=D?D():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),I&&(this[c]=I(this[c],...g)),this[a])return;const w=this[u]+T;w<=Date.now()?(this[u]=Date.now(),A.apply(this,[this[c]]),this[c]=D?D():void 0):(this[a]=!0,this[P]=setTimeout(()=>{this[a]=!1,this[u]=Date.now(),A.apply(this,[this[c]]),this[c]=D?D():void 0},w-Date.now()))}})}e.throttle=S}),define(me[15],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(s=>{s(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=p,e.errorHandler=new p;function L(v){e.errorHandler.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=L;function C(v){D(v)||e.errorHandler.onUnexpectedError(v)}e.onUnexpectedError=C;function S(v){D(v)||e.errorHandler.onUnexpectedExternalError(v)}e.onUnexpectedExternalError=S;function T(v){if(v instanceof Error){let{name:t,message:s}=v;const r=v.stacktrace||v.stack;return{$isError:!0,name:t,message:s,stack:r}}return v}e.transformErrorForSerialization=T;const I="Canceled";function D(v){return v instanceof Error&&v.name===I&&v.message===I}e.isPromiseCanceledError=D;class A extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=A;function i(){const v=new Error(I);return v.name=v.message,v}e.canceled=i;function P(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.illegalArgument=P;function c(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.illegalState=c;function u(v){return v?new Error(`readonly property '${v} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=u;function a(v){const t=new Error(`${v} has been disposed`);return t.name="DISPOSED",t}e.disposed=a;function g(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.getErrorMessage=g;class w extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=w;class _ extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=_;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function d(v){const t=v;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=d;function h(v,t=Object.create(null)){const s=new Error(v);return t.actions&&(s.actions=t.actions),s}e.createErrorWithActions=h}),define(me[18],ge([0,1,15]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(x,K=0){return x[x.length-(1+K)]}e.tail=L;function C(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}e.tail2=C;function S(x,K,ee=(de,Se)=>de===Se){if(x===K)return!0;if(!x||!K||x.length!==K.length)return!1;for(let de=0,Se=x.length;de<Se;de++)if(!ee(x[de],K[de]))return!1;return!0}e.equals=S;function T(x,K,ee){let de=0,Se=x.length-1;for(;de<=Se;){const De=(de+Se)/2|0,Le=ee(x[De],K);if(Le<0)de=De+1;else if(Le>0)Se=De-1;else return De}return-(de+1)}e.binarySearch=T;function I(x,K){let ee=0,de=x.length;if(de===0)return 0;for(;ee<de;){const Se=Math.floor((ee+de)/2);K(x[Se])?de=Se:ee=Se+1}return ee}e.findFirstInSorted=I;function D(x,K,ee){if(x=x|0,x>=K.length)throw new TypeError("invalid index");let de=K[Math.floor(K.length*Math.random())],Se=[],De=[],Le=[];for(let qe of K){const We=ee(qe,de);We<0?Se.push(qe):We>0?De.push(qe):Le.push(qe)}return x<Se.length?D(x,Se,ee):x<Se.length+Le.length?Le[0]:D(x-(Se.length+Le.length),De,ee)}e.quickSelect=D;function A(x,K){const ee=[];let de;for(const Se of x.slice(0).sort(K))!de||K(de[0],Se)!==0?(de=[Se],ee.push(de)):de.push(Se);return ee}e.groupBy=A;function i(x,K,ee){const de=[];function Se(qe,We,je){if(We===0&&je.length===0)return;const W=de[de.length-1];W&&W.start+W.deleteCount===qe?(W.deleteCount+=We,W.toInsert.push(...je)):de.push({start:qe,deleteCount:We,toInsert:je})}let De=0,Le=0;for(;;){if(De===x.length){Se(De,0,K.slice(Le));break}if(Le===K.length){Se(De,x.length-De,[]);break}const qe=x[De],We=K[Le],je=ee(qe,We);je===0?(De+=1,Le+=1):je<0?(Se(De,1,[]),De+=1):je>0&&(Se(De,0,[We]),Le+=1)}return de}e.sortedDiff=i;function P(x,K,ee){const de=i(x,K,ee),Se=[],De=[];for(const Le of de)Se.push(...x.slice(Le.start,Le.start+Le.deleteCount)),De.push(...Le.toInsert);return{removed:Se,added:De}}e.delta=P;function c(x,K,ee){if(ee===0)return[];const de=x.slice(0,ee).sort(K);return a(x,K,de,ee,x.length),de}e.top=c;function u(x,K,ee,de,Se){return ee===0?Promise.resolve([]):new Promise((De,Le)=>{(async()=>{const qe=x.length,We=x.slice(0,ee).sort(K);for(let je=ee,W=Math.min(ee+de,qe);je<qe;je=W,W=Math.min(W+de,qe)){if(je>ee&&await new Promise(Z=>setTimeout(Z)),Se&&Se.isCancellationRequested)throw(0,p.canceled)();a(x,K,We,je,W)}return We})().then(De,Le)})}e.topAsync=u;function a(x,K,ee,de,Se){for(const De=ee.length;de<Se;de++){const Le=x[de];if(K(Le,ee[De-1])<0){ee.pop();const qe=I(ee,We=>K(Le,We)<0);ee.splice(qe,0,Le)}}}function g(x){return x.filter(K=>!!K)}e.coalesce=g;function w(x){let K=0;for(let ee=0;ee<x.length;ee++)x[ee]&&(x[K]=x[ee],K+=1);x.length=K}e.coalesceInPlace=w;function _(x,K,ee){x.splice(ee,0,x.splice(K,1)[0])}e.move=_;function b(x){return!Array.isArray(x)||x.length===0}e.isFalsyOrEmpty=b;function d(x){return Array.isArray(x)&&x.length>0}e.isNonEmptyArray=d;function h(x,K){if(!K)return x.filter((de,Se)=>x.indexOf(de)===Se);const ee=Object.create(null);return x.filter(de=>{const Se=K(de);return ee[Se]?!1:(ee[Se]=!0,!0)})}e.distinct=h;function v(x){const K=new Set;return x.filter(ee=>K.has(ee)?!1:(K.add(ee),!0))}e.distinctES6=v;function t(x){const K=Object.create(null);return ee=>{const de=x(ee);return K[de]?!1:(K[de]=!0,!0)}}e.uniqueFilter=t;function s(x,K){for(let ee=x.length-1;ee>=0;ee--){const de=x[ee];if(K(de))return ee}return-1}e.lastIndex=s;function r(x,K){return x.length>0?x[0]:K}e.firstOrDefault=r;function n(x,K,ee=(de,Se)=>de===Se){let de=0;for(let Se=0,De=Math.min(x.length,K.length);Se<De&&ee(x[Se],K[Se]);Se++)de++;return de}e.commonPrefixLength=n;function l(x){return[].concat(...x)}e.flatten=l;function f(x,K){let ee=typeof K=="number"?x:0;typeof K=="number"?ee=x:(ee=0,K=x);const de=[];if(ee<=K)for(let Se=ee;Se<K;Se++)de.push(Se);else for(let Se=ee;Se>K;Se--)de.push(Se);return de}e.range=f;function m(x,K,ee){return x.reduce((de,Se)=>(de[K(Se)]=ee?ee(Se):Se,de),Object.create(null))}e.index=m;function E(x,K){return x.push(K),()=>y(x,K)}e.insert=E;function y(x,K){const ee=x.indexOf(K);if(ee>-1)return x.splice(ee,1),K}e.remove=y;function o(x,K,ee){const de=x.slice(0,K),Se=x.slice(K);return de.concat(ee,Se)}e.arrayInsert=o;function k(x,K){let ee;if(typeof K=="number"){let de=K;ee=()=>{const Se=Math.sin(de++)*179426549;return Se-Math.floor(Se)}}else ee=Math.random;for(let de=x.length-1;de>0;de-=1){const Se=Math.floor(ee()*(de+1)),De=x[de];x[de]=x[Se],x[Se]=De}}e.shuffle=k;function F(x,K){const ee=x.indexOf(K);ee>-1&&(x.splice(ee,1),x.unshift(K))}e.pushToStart=F;function $(x,K){const ee=x.indexOf(K);ee>-1&&(x.splice(ee,1),x.push(K))}e.pushToEnd=$;function Q(x,K){return Array.isArray(x)?x.map(K):K(x)}e.mapArrayOrNot=Q;function oe(x){return Array.isArray(x)?x:[x]}e.asArray=oe;function j(x){return x[Math.floor(Math.random()*x.length)]}e.getRandomElement=j;function O(x,K){for(const ee of x){const de=K(ee);if(de!==void 0)return de}}e.mapFind=O;function B(x,K,ee){const de=z(x,K),Se=x.length,De=ee.length;x.length=Se+De;for(let Le=Se-1;Le>=de;Le--)x[Le+De]=x[Le];for(let Le=0;Le<De;Le++)x[Le+de]=ee[Le]}e.insertInto=B;function R(x,K,ee,de){const Se=z(x,K),De=x.splice(Se,ee);return B(x,Se,de),De}e.splice=R;function z(x,K){return K<0?Math.max(K+x.length,0):Math.min(K,x.length)}function N(x,K){let ee=Number.MAX_SAFE_INTEGER,de=0;return x.forEach((Se,De)=>{const Le=K(Se);Le<ee&&(ee=Le,de=De)}),de}e.minIndex=N;function M(x,K){let ee=Number.MIN_SAFE_INTEGER,de=0;return x.forEach((Se,De)=>{const Le=K(Se);Le>ee&&(ee=Le,de=De)}),de}e.maxIndex=M;class q{constructor(K){this.items=K,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(K){let ee=this.firstIdx;for(;ee<this.items.length&&K(this.items[ee]);)ee++;const de=ee===this.firstIdx?null:this.items.slice(this.firstIdx,ee);return this.firstIdx=ee,de}takeFromEndWhile(K){let ee=this.lastIdx;for(;ee>=0&&K(this.items[ee]);)ee--;const de=ee===this.lastIdx?null:this.items.slice(ee+1,this.lastIdx+1);return this.lastIdx=ee,de}}e.ArrayQueue=q}),define(me[70],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(L){const C=this;let S=!1,T;return function(){return S||(S=!0,T=L.apply(C,arguments)),T}}e.once=p}),define(me[71],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class p{constructor(C){this._prefix=C,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=p,e.defaultGenerator=new p("id#")}),define(me[72],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(L){function C(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}L.is=C;const S=Object.freeze([]);function T(){return S}L.empty=T;function*I(v){yield v}L.single=I;function D(v){return v||S}L.from=D;function A(v){return!v||v[Symbol.iterator]().next().done===!0}L.isEmpty=A;function i(v){return v[Symbol.iterator]().next().value}L.first=i;function P(v,t){for(const s of v)if(t(s))return!0;return!1}L.some=P;function c(v,t){for(const s of v)if(t(s))return s}L.find=c;function*u(v,t){for(const s of v)t(s)&&(yield s)}L.filter=u;function*a(v,t){let s=0;for(const r of v)yield t(r,s++)}L.map=a;function*g(...v){for(const t of v)for(const s of t)yield s}L.concat=g;function*w(v){for(const t of v)for(const s of t)yield s}L.concatNested=w;function _(v,t,s){let r=s;for(const n of v)r=t(r,n);return r}L.reduce=_;function*b(v,t,s=v.length){for(t<0&&(t+=v.length),s<0?s+=v.length:s>v.length&&(s=v.length);t<s;t++)yield v[t]}L.slice=b;function d(v,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,v];const r=v[Symbol.iterator]();for(let n=0;n<t;n++){const l=r.next();if(l.done)return[s,L.empty()];s.push(l.value)}return[s,{[Symbol.iterator](){return r}}]}L.consume=d;function h(v,t,s=(r,n)=>r===n){const r=v[Symbol.iterator](),n=t[Symbol.iterator]();for(;;){const l=r.next(),f=n.next();if(l.done!==f.done)return!1;if(l.done)return!0;if(!s(l.value,f.value))return!1}}L.equals=h})(p=e.Iterable||(e.Iterable={}))}),define(me[54],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var S;(function(t){t.DEFAULT={allowTrailingComma:!0}})(S=e.ParseOptions||(e.ParseOptions={}));function T(t,s=!1){let r=0,n=t.length,l="",f=0,m=16,E=0;function y(j){let O=0,B=0;for(;O<j;){const R=t.charCodeAt(r);if(R>=48&&R<=57)B=B*16+R-48;else if(R>=65&&R<=70)B=B*16+R-65+10;else if(R>=97&&R<=102)B=B*16+R-97+10;else break;r++,O++}return O<j&&(B=-1),B}function o(j){r=j,l="",f=0,m=16,E=0}function k(){const j=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&A(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&A(t.charCodeAt(r)))for(r++;r<t.length&&A(t.charCodeAt(r));)r++;else return E=3,t.substring(j,r);let O=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&A(t.charCodeAt(r))){for(r++;r<t.length&&A(t.charCodeAt(r));)r++;O=r}else E=3;return t.substring(j,O)}function F(){let j="",O=r;for(;;){if(r>=n){j+=t.substring(O,r),E=2;break}const B=t.charCodeAt(r);if(B===34){j+=t.substring(O,r),r++;break}if(B===92){if(j+=t.substring(O,r),r++,r>=n){E=2;break}switch(t.charCodeAt(r++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:const z=y(4);z>=0?j+=String.fromCharCode(z):E=4;break;default:E=5}O=r;continue}if(B>=0&&B<=31)if(D(B)){j+=t.substring(O,r),E=2;break}else E=6;r++}return j}function $(){if(l="",E=0,f=r,r>=n)return f=n,m=17;let j=t.charCodeAt(r);if(I(j)){do r++,l+=String.fromCharCode(j),j=t.charCodeAt(r);while(I(j));return m=15}if(D(j))return r++,l+=String.fromCharCode(j),j===13&&t.charCodeAt(r)===10&&(r++,l+=`
`),m=14;switch(j){case 123:return r++,m=1;case 125:return r++,m=2;case 91:return r++,m=3;case 93:return r++,m=4;case 58:return r++,m=6;case 44:return r++,m=5;case 34:return r++,l=F(),m=10;case 47:const O=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<n&&!D(t.charCodeAt(r));)r++;return l=t.substring(O,r),m=12}if(t.charCodeAt(r+1)===42){r+=2;const B=n-1;let R=!1;for(;r<B;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,R=!0;break}r++}return R||(r++,E=1),l=t.substring(O,r),m=13}return l+=String.fromCharCode(j),r++,m=16;case 45:if(l+=String.fromCharCode(j),r++,r===n||!A(t.charCodeAt(r)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=k(),m=11;default:for(;r<n&&Q(j);)r++,j=t.charCodeAt(r);if(f!==r){switch(l=t.substring(f,r),l){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return l+=String.fromCharCode(j),r++,m=16}}function Q(j){if(I(j)||D(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let j;do j=$();while(j>=12&&j<=15);return j}return{setPosition:o,getPosition:()=>r,scan:s?oe:$,getToken:()=>m,getTokenValue:()=>l,getTokenOffset:()=>f,getTokenLength:()=>r-f,getTokenError:()=>E}}e.createScanner=T;function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function A(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function P(t,s){const r=[],n=new Object;let l;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function E(y,o,k,F){f.value=y,f.offset=o,f.length=k,f.type=F,f.colonOffset=void 0,l=f}try{d(t,{onObjectBegin:(y,o)=>{if(s<=y)throw n;l=void 0,m=s>y,r.push("")},onObjectProperty:(y,o,k)=>{if(s<o||(E(y,o,k,"property"),r[r.length-1]=y,s<=o+k))throw n},onObjectEnd:(y,o)=>{if(s<=y)throw n;l=void 0,r.pop()},onArrayBegin:(y,o)=>{if(s<=y)throw n;l=void 0,r.push(0)},onArrayEnd:(y,o)=>{if(s<=y)throw n;l=void 0,r.pop()},onLiteralValue:(y,o,k)=>{if(s<o||(E(y,o,k,v(y)),s<=o+k))throw n},onSeparator:(y,o,k)=>{if(s<=o)throw n;if(y===":"&&l&&l.type==="property")l.colonOffset=o,m=!1,l=void 0;else if(y===","){const F=r[r.length-1];typeof F=="number"?r[r.length-1]=F+1:(m=!0,r[r.length-1]=""),l=void 0}}})}catch(y){if(y!==n)throw y}return{path:r,previousNode:l,isAtPropertyKey:m,matches:y=>{let o=0;for(let k=0;o<y.length&&k<r.length;k++)if(y[o]===r[k]||y[o]==="*")o++;else if(y[o]!=="**")return!1;return o===y.length}}}e.getLocation=P;function c(t,s=[],r=S.DEFAULT){let n=null,l=[];const f=[];function m(y){Array.isArray(l)?l.push(y):n!==null&&(l[n]=y)}return d(t,{onObjectBegin:()=>{const y={};m(y),f.push(l),l=y,n=null},onObjectProperty:y=>{n=y},onObjectEnd:()=>{l=f.pop()},onArrayBegin:()=>{const y=[];m(y),f.push(l),l=y,n=null},onArrayEnd:()=>{l=f.pop()},onLiteralValue:m,onError:(y,o,k)=>{s.push({error:y,offset:o,length:k})}},r),l[0]}e.parse=c;function u(t,s=[],r=S.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(y){n.type==="property"&&(n.length=y-n.offset,n=n.parent)}function f(y){return n.children.push(y),y}d(t,{onObjectBegin:y=>{n=f({type:"object",offset:y,length:-1,parent:n,children:[]})},onObjectProperty:(y,o,k)=>{n=f({type:"property",offset:o,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:y,offset:o,length:k,parent:n})},onObjectEnd:(y,o)=>{n.length=y+o-n.offset,n=n.parent,l(y+o)},onArrayBegin:(y,o)=>{n=f({type:"array",offset:y,length:-1,parent:n,children:[]})},onArrayEnd:(y,o)=>{n.length=y+o-n.offset,n=n.parent,l(y+o)},onLiteralValue:(y,o,k)=>{f({type:v(y),offset:o,length:k,parent:n,value:y}),l(o+k)},onSeparator:(y,o,k)=>{n.type==="property"&&(y===":"?n.colonOffset=o:y===","&&l(o))},onError:(y,o,k)=>{s.push({error:y,offset:o,length:k})}},r);const E=n.children[0];return E&&delete E.parent,E}e.parseTree=u;function a(t,s){if(!t)return;let r=t;for(let n of s)if(typeof n=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let l=!1;for(const f of r.children)if(Array.isArray(f.children)&&f.children[0].value===n){r=f.children[1],l=!0;break}if(!l)return}else{const l=n;if(r.type!=="array"||l<0||!Array.isArray(r.children)||l>=r.children.length)return;r=r.children[l]}return r}e.findNodeAtLocation=a;function g(t){if(!t.parent||!t.parent.children)return[];const s=g(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;s.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&s.push(r)}return s}e.getNodePath=g;function w(t){switch(t.type){case"array":return t.children.map(w);case"object":const s=Object.create(null);for(let r of t.children){const n=r.children[1];n&&(s[r.children[0].value]=w(n))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=w;function _(t,s,r=!1){return s>=t.offset&&s<t.offset+t.length||r&&s===t.offset+t.length}e.contains=_;function b(t,s,r=!1){if(_(t,s,r)){const n=t.children;if(Array.isArray(n))for(let l=0;l<n.length&&n[l].offset<=s;l++){const f=b(n[l],s,r);if(f)return f}return t}}e.findNodeAtOffset=b;function d(t,s,r=S.DEFAULT){const n=T(t,!1);function l(ee){return ee?()=>ee(n.getTokenOffset(),n.getTokenLength()):()=>!0}function f(ee){return ee?de=>ee(de,n.getTokenOffset(),n.getTokenLength()):()=>!0}const m=l(s.onObjectBegin),E=f(s.onObjectProperty),y=l(s.onObjectEnd),o=l(s.onArrayBegin),k=l(s.onArrayEnd),F=f(s.onLiteralValue),$=f(s.onSeparator),Q=l(s.onComment),oe=f(s.onError),j=r&&r.disallowComments,O=r&&r.allowTrailingComma;function B(){for(;;){const ee=n.scan();switch(n.getTokenError()){case 4:R(14);break;case 5:R(15);break;case 3:R(13);break;case 1:j||R(11);break;case 2:R(12);break;case 6:R(16);break}switch(ee){case 12:case 13:j?R(10):Q();break;case 16:R(1);break;case 15:case 14:break;default:return ee}}}function R(ee,de=[],Se=[]){if(oe(ee),de.length+Se.length>0){let De=n.getToken();for(;De!==17;){if(de.indexOf(De)!==-1){B();break}else if(Se.indexOf(De)!==-1)break;De=B()}}}function z(ee){const de=n.getTokenValue();return ee?F(de):E(de),B(),!0}function N(){switch(n.getToken()){case 11:let ee=0;try{ee=JSON.parse(n.getTokenValue()),typeof ee!="number"&&(R(2),ee=0)}catch(de){R(2)}F(ee);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return B(),!0}function M(){return n.getToken()!==10?(R(3,[],[2,5]),!1):(z(!1),n.getToken()===6?($(":"),B(),K()||R(4,[],[2,5])):R(5,[],[2,5]),!0)}function q(){m(),B();let ee=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ee||R(4,[],[]),$(","),B(),n.getToken()===2&&O)break}else ee&&R(6,[],[]);M()||R(4,[],[2,5]),ee=!0}return y(),n.getToken()!==2?R(7,[2],[]):B(),!0}function x(){o(),B();let ee=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ee||R(4,[],[]),$(","),B(),n.getToken()===4&&O)break}else ee&&R(6,[],[]);K()||R(4,[],[4,5]),ee=!0}return k(),n.getToken()!==4?R(8,[4],[]):B(),!0}function K(){switch(n.getToken()){case 3:return x();case 1:return q();case 10:return z(!0);default:return N()}}return B(),n.getToken()===17?r.allowEmptyContent?!0:(R(4,[],[]),!1):K()?(n.getToken()!==17&&R(9,[],[]),!0):(R(4,[],[]),!1)}e.visit=d;function h(t,s){let r=T(t),n=[],l,f=0,m;do switch(m=r.getPosition(),l=r.scan(),l){case 12:case 13:case 17:f!==m&&n.push(t.substring(f,m)),s!==void 0&&n.push(r.getTokenValue().replace(/[^\r\n]/g,s)),f=r.getPosition();break}while(l!==17);return n.join("")}e.stripComments=h;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(me[134],ge([0,1,54]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(D,A,i){let P,c,u,a,g;if(A){for(a=A.offset,g=a+A.length,u=a;u>0&&!I(D,u-1);)u--;let f=g;for(;f<D.length&&!I(D,f);)f++;c=D.substring(u,f),P=S(c,i)}else c=D,P=0,u=0,a=0,g=D.length;const w=T(i,D);let _=!1,b=0,d;i.insertSpaces?d=C(" ",i.tabSize||4):d="	";const h=(0,p.createScanner)(c,!1);let v=!1;function t(){return w+C(d,P+b)}function s(){let f=h.scan();for(_=!1;f===15||f===14;)_=_||f===14,f=h.scan();return v=f===16||h.getTokenError()!==0,f}const r=[];function n(f,m,E){!v&&m<g&&E>a&&D.substring(m,E)!==f&&r.push({offset:m,length:E-m,content:f})}let l=s();if(l!==17){const f=h.getTokenOffset()+u,m=C(d,P);n(m,u,f)}for(;l!==17;){let f=h.getTokenOffset()+h.getTokenLength()+u,m=s(),E="";for(;!_&&(m===12||m===13);){const o=h.getTokenOffset()+u;n(" ",f,o),f=h.getTokenOffset()+h.getTokenLength()+u,E=m===12?t():"",m=s()}if(m===2)l!==1&&(b--,E=t());else if(m===4)l!==3&&(b--,E=t());else{switch(l){case 3:case 1:b++,E=t();break;case 5:case 12:E=t();break;case 13:_?E=t():E=" ";break;case 6:E=" ";break;case 10:if(m===6){E="";break}case 7:case 8:case 9:case 11:case 2:case 4:m===12||m===13?E=" ":m!==5&&m!==17&&(v=!0);break;case 16:v=!0;break}_&&(m===12||m===13)&&(E=t())}const y=h.getTokenOffset()+u;n(E,f,y),l=m}return r}e.format=L;function C(D,A){let i="";for(let P=0;P<A;P++)i+=D;return i}function S(D,A){let i=0,P=0;const c=A.tabSize||4;for(;i<D.length;){const u=D.charAt(i);if(u===" ")P++;else if(u==="	")P+=c;else break;i++}return Math.floor(P/c)}function T(D,A){for(let i=0;i<A.length;i++){const P=A.charAt(i);if(P==="\r")return i+1<A.length&&A.charAt(i+1)===`
`?`\r
`:"\r";if(P===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=T;function I(D,A){return`\r
`.indexOf(D.charAt(A))!==-1}e.isEOL=I}),define(me[135],ge([0,1,54,134]),function(J,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function C(A,i,P){return S(A,i,void 0,P)}e.removeProperty=C;function S(A,i,P,c,u){const a=i.slice(),g=[],w=(0,p.parseTree)(A,g);let _,b;for(;a.length>0&&(b=a.pop(),_=(0,p.findNodeAtLocation)(w,a),_===void 0&&P!==void 0);)typeof b=="string"?P={[b]:P}:P=[P];if(_)if(_.type==="object"&&typeof b=="string"&&Array.isArray(_.children)){const d=(0,p.findNodeAtLocation)(_,[b]);if(d!==void 0)if(P===void 0){if(!d.parent)throw new Error("Malformed AST");const h=_.children.indexOf(d.parent);let v,t=d.parent.offset+d.parent.length;if(h>0){const s=_.children[h-1];v=s.offset+s.length}else v=_.offset+1,_.children.length>1&&(t=_.children[1].offset);return T(A,{offset:v,length:t-v,content:""},c)}else return T(A,{offset:d.offset,length:d.length,content:JSON.stringify(P)},c);else{if(P===void 0)return[];const h=`${JSON.stringify(b)}: ${JSON.stringify(P)}`,v=u?u(_.children.map(s=>s.children[0].value)):_.children.length;let t;if(v>0){const s=_.children[v-1];t={offset:s.offset+s.length,length:0,content:","+h}}else _.children.length===0?t={offset:_.offset+1,length:0,content:h}:t={offset:_.offset+1,length:0,content:h+","};return T(A,t,c)}}else if(_.type==="array"&&typeof b=="number"&&Array.isArray(_.children))if(P!==void 0){const d=`${JSON.stringify(P)}`;let h;if(_.children.length===0||b===0)h={offset:_.offset+1,length:0,content:_.children.length===0?d:d+","};else{const v=b===-1||b>_.children.length?_.children.length:b,t=_.children[v-1];h={offset:t.offset+t.length,length:0,content:","+d}}return T(A,h,c)}else{const d=b,h=_.children[d];let v;if(_.children.length===1)v={offset:_.offset+1,length:_.length-2,content:""};else if(_.children.length-1===d){const t=_.children[d-1],s=t.offset+t.length,r=_.offset+_.length;v={offset:s,length:r-2-s,content:""}}else v={offset:h.offset,length:_.children[d+1].offset-h.offset,content:""};return T(A,v,c)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${_.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return T(A,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(P)},c)}}e.setProperty=S;function T(A,i,P){let c=I(A,i),u=i.offset,a=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;u>0&&!(0,L.isEOL)(c,u-1);)u--;for(;a<c.length&&!(0,L.isEOL)(c,a);)a++}const g=(0,L.format)(c,{offset:u,length:a-u},P);for(let _=g.length-1;_>=0;_--){const b=g[_];c=I(c,b),u=Math.min(u,b.offset),a=Math.max(a,b.offset+b.length),a+=b.content.length-b.length}const w=A.length-(c.length-a)-u;return[{offset:u,length:w,content:c.substring(u,a)}]}e.withFormatting=T;function I(A,i){return A.substring(0,i.offset)+i.content+A.substring(i.offset+i.length)}e.applyEdit=I;function D(A,i){let P=i.slice(0).sort((u,a)=>{const g=u.offset-a.offset;return g===0?u.length-a.length:g}),c=A.length;for(let u=P.length-1;u>=0;u--){let a=P[u];if(a.offset+a.length<=c)A=I(A,a);else throw new Error("Overlapping edit");c=a.offset}return A}e.applyEdits=D}),define(me[136],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class p{constructor(C){this.executor=C,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(C){this._error=C}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(C){return new p(()=>C(this.getValue()))}}e.Lazy=p}),define(me[6],ge([0,1,70,72]),function(J,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const C=!1;let S=null;function T(r){S=r}if(e.setDisposableTracker=T,C){const r="__is_disposable_tracked__";T(new class{trackDisposable(n){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[r]||console.log(l)},3e3)}setParent(n,l){if(n&&n!==b.None)try{n[r]=!0}catch{}}markAsDisposed(n){if(n&&n!==b.None)try{n[r]=!0}catch{}}markAsSingleton(n){}})}function I(r){return S?.trackDisposable(r),r}function D(r){S?.markAsDisposed(r)}function A(r,n){S?.setParent(r,n)}function i(r,n){if(!!S)for(const l of r)S.setParent(l,n)}function P(r){return S?.markAsSingleton(r),r}e.markAsSingleton=P;class c extends Error{constructor(n){super(`Encountered errors while disposing of store. Errors: [${n.join(", ")}]`);this.errors=n}}e.MultiDisposeError=c;function u(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=u;function a(r){if(L.Iterable.is(r)){let n=[];for(const l of r)if(l)try{l.dispose()}catch(f){n.push(f)}if(n.length===1)throw n[0];if(n.length>1)throw new c(n);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=a;function g(...r){const n=w(()=>a(r));return i(r,n),n}e.combinedDisposable=g;function w(r){const n=I({dispose:(0,p.once)(()=>{D(n),r()})});return n}e.toDisposable=w;class _{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(D(this),this._isDisposed=!0,this.clear())}clear(){try{a(this._toDispose.values())}finally{this._toDispose.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return A(n,this),this._isDisposed?_.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(n),n}}e.DisposableStore=_,_.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this._store=new _,I(this),A(this._store,this)}dispose(){D(this),this._store.dispose()}_register(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(n)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class d{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(n){this._isDisposed||n===this._value||(this._value?.dispose(),n&&A(n,this),this._value=n)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,D(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const n=this._value;return this._value=void 0,n&&A(n,null),n}}e.MutableDisposable=d;class h{constructor(n){this._disposable=n,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=h;class v{constructor(){this.references=new Map}acquire(n,...l){let f=this.references.get(n);f||(f={counter:0,object:this.createReferencedObject(n,...l)},this.references.set(n,f));const{object:m}=f,E=(0,p.once)(()=>{--f.counter==0&&(this.destroyReferencedObject(n,f.object),this.references.delete(n))});return f.counter++,{object:m,dispose:E}}}e.ReferenceCollection=v;class t{constructor(n){this.referenceCollection=n}async acquire(n,...l){const f=this.referenceCollection.acquire(n,...l);try{return{object:await f.object,dispose:()=>f.dispose()}}catch(m){throw f.dispose(),m}}}e.AsyncReferenceCollection=t;class s{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=s}),define(me[92],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(S){this.element=S,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class L{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let S=this._first;for(;S!==p.Undefined;){const T=S.next;S.prev=p.Undefined,S.next=p.Undefined,S=T}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(S){return this._insert(S,!1)}push(S){return this._insert(S,!0)}_insert(S,T){const I=new p(S);if(this._first===p.Undefined)this._first=I,this._last=I;else if(T){const A=this._last;this._last=I,I.prev=A,A.next=I}else{const A=this._first;this._first=I,I.next=A,A.prev=I}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(I))}}shift(){if(this._first!==p.Undefined){const S=this._first.element;return this._remove(this._first),S}}pop(){if(this._last!==p.Undefined){const S=this._last.element;return this._remove(this._last),S}}_remove(S){if(S.prev!==p.Undefined&&S.next!==p.Undefined){const T=S.prev;T.next=S.next,S.next.prev=T}else S.prev===p.Undefined&&S.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):S.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):S.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let S=this._first;for(;S!==p.Undefined;)yield S.element,S=S.next}}e.LinkedList=L}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(J=typeof globalThis!="undefined"?globalThis:J||self,J.marked=e())}(this,function(){"use strict";function J(Ce,ke){for(var Te=0;Te<ke.length;Te++){var le=ke[Te];le.enumerable=le.enumerable||!1,le.configurable=!0,"value"in le&&(le.writable=!0),Object.defineProperty(Ce,le.key,le)}}function e(Ce,ke,Te){return ke&&J(Ce.prototype,ke),Te&&J(Ce,Te),Ce}function p(Ce,ke){if(!!Ce){if(typeof Ce=="string")return L(Ce,ke);var Te=Object.prototype.toString.call(Ce).slice(8,-1);if(Te==="Object"&&Ce.constructor&&(Te=Ce.constructor.name),Te==="Map"||Te==="Set")return Array.from(Ce);if(Te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Te))return L(Ce,ke)}}function L(Ce,ke){(ke==null||ke>Ce.length)&&(ke=Ce.length);for(var Te=0,le=new Array(ke);Te<ke;Te++)le[Te]=Ce[Te];return le}function C(Ce,ke){var Te;if(typeof Symbol=="undefined"||Ce[Symbol.iterator]==null){if(Array.isArray(Ce)||(Te=p(Ce))||ke&&Ce&&typeof Ce.length=="number"){Te&&(Ce=Te);var le=0;return function(){return le>=Ce.length?{done:!0}:{done:!1,value:Ce[le++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Te=Ce[Symbol.iterator](),Te.next.bind(Te)}function S(Ce){var ke={exports:{}};return Ce(ke,ke.exports),ke.exports}var T=S(function(Ce){function ke(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Te(le){Ce.exports.defaults=le}Ce.exports={defaults:ke(),getDefaults:ke,changeDefaults:Te}}),I=/[&<>"']/,D=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,P={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},c=function(ke){return P[ke]};function u(Ce,ke){if(ke){if(I.test(Ce))return Ce.replace(D,c)}else if(A.test(Ce))return Ce.replace(i,c);return Ce}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(Ce){return Ce.replace(a,function(ke,Te){return Te=Te.toLowerCase(),Te==="colon"?":":Te.charAt(0)==="#"?Te.charAt(1)==="x"?String.fromCharCode(parseInt(Te.substring(2),16)):String.fromCharCode(+Te.substring(1)):""})}var w=/(^|[^\[])\^/g;function _(Ce,ke){Ce=Ce.source||Ce,ke=ke||"";var Te={replace:function(ce,pe){return pe=pe.source||pe,pe=pe.replace(w,"$1"),Ce=Ce.replace(ce,pe),Te},getRegex:function(){return new RegExp(Ce,ke)}};return Te}var b=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Ce,ke,Te){if(Ce){var le;try{le=decodeURIComponent(g(Te)).replace(b,"").toLowerCase()}catch(ce){return null}if(le.indexOf("javascript:")===0||le.indexOf("vbscript:")===0||le.indexOf("data:")===0)return null}ke&&!d.test(Te)&&(Te=n(ke,Te));try{Te=encodeURI(Te).replace(/%25/g,"%")}catch(ce){return null}return Te}var v={},t=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(Ce,ke){v[" "+Ce]||(t.test(Ce)?v[" "+Ce]=Ce+"/":v[" "+Ce]=E(Ce,"/",!0)),Ce=v[" "+Ce];var Te=Ce.indexOf(":")===-1;return ke.substring(0,2)==="//"?Te?ke:Ce.replace(s,"$1")+ke:ke.charAt(0)==="/"?Te?ke:Ce.replace(r,"$1")+ke:Ce+ke}var l={exec:function(){}};function f(Ce){for(var ke=1,Te,le;ke<arguments.length;ke++){Te=arguments[ke];for(le in Te)Object.prototype.hasOwnProperty.call(Te,le)&&(Ce[le]=Te[le])}return Ce}function m(Ce,ke){var Te=Ce.replace(/\|/g,function(pe,Ee,G){for(var ve=!1,ye=Ee;--ye>=0&&G[ye]==="\\";)ve=!ve;return ve?"|":" |"}),le=Te.split(/ \|/),ce=0;if(le.length>ke)le.splice(ke);else for(;le.length<ke;)le.push("");for(;ce<le.length;ce++)le[ce]=le[ce].trim().replace(/\\\|/g,"|");return le}function E(Ce,ke,Te){var le=Ce.length;if(le===0)return"";for(var ce=0;ce<le;){var pe=Ce.charAt(le-ce-1);if(pe===ke&&!Te)ce++;else if(pe!==ke&&Te)ce++;else break}return Ce.substr(0,le-ce)}function y(Ce,ke){if(Ce.indexOf(ke[1])===-1)return-1;for(var Te=Ce.length,le=0,ce=0;ce<Te;ce++)if(Ce[ce]==="\\")ce++;else if(Ce[ce]===ke[0])le++;else if(Ce[ce]===ke[1]&&(le--,le<0))return ce;return-1}function o(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function k(Ce,ke){if(ke<1)return"";for(var Te="";ke>1;)ke&1&&(Te+=Ce),ke>>=1,Ce+=Ce;return Te+Ce}var F={escape:u,unescape:g,edit:_,cleanUrl:h,resolveUrl:n,noopTest:l,merge:f,splitCells:m,rtrim:E,findClosingBracket:y,checkSanitizeDeprecation:o,repeatString:k},$=T.defaults,Q=F.rtrim,oe=F.splitCells,j=F.escape,O=F.findClosingBracket;function B(Ce,ke,Te){var le=ke.href,ce=ke.title?j(ke.title):null,pe=Ce[1].replace(/\\([\[\]])/g,"$1");return Ce[0].charAt(0)!=="!"?{type:"link",raw:Te,href:le,title:ce,text:pe}:{type:"image",raw:Te,href:le,title:ce,text:j(pe)}}function R(Ce,ke){var Te=Ce.match(/^(\s+)(?:```)/);if(Te===null)return ke;var le=Te[1];return ke.split(`
`).map(function(ce){var pe=ce.match(/^\s+/);if(pe===null)return ce;var Ee=pe[0];return Ee.length>=le.length?ce.slice(le.length):ce}).join(`
`)}var z=function(){function Ce(Te){this.options=Te||$}var ke=Ce.prototype;return ke.space=function(le){var ce=this.rules.block.newline.exec(le);if(ce)return ce[0].length>1?{type:"space",raw:ce[0]}:{raw:`
`}},ke.code=function(le){var ce=this.rules.block.code.exec(le);if(ce){var pe=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:Q(pe,`
`)}}},ke.fences=function(le){var ce=this.rules.block.fences.exec(le);if(ce){var pe=ce[0],Ee=R(pe,ce[3]||"");return{type:"code",raw:pe,lang:ce[2]?ce[2].trim():ce[2],text:Ee}}},ke.heading=function(le){var ce=this.rules.block.heading.exec(le);if(ce){var pe=ce[2].trim();if(/#$/.test(pe)){var Ee=Q(pe,"#");(this.options.pedantic||!Ee||/ $/.test(Ee))&&(pe=Ee.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:pe}}},ke.nptable=function(le){var ce=this.rules.block.nptable.exec(le);if(ce){var pe={type:"table",header:oe(ce[1].replace(/^ *| *\| *$/g,"")),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ce[3]?ce[3].replace(/\n$/,"").split(`
`):[],raw:ce[0]};if(pe.header.length===pe.align.length){var Ee=pe.align.length,G;for(G=0;G<Ee;G++)/^ *-+: *$/.test(pe.align[G])?pe.align[G]="right":/^ *:-+: *$/.test(pe.align[G])?pe.align[G]="center":/^ *:-+ *$/.test(pe.align[G])?pe.align[G]="left":pe.align[G]=null;for(Ee=pe.cells.length,G=0;G<Ee;G++)pe.cells[G]=oe(pe.cells[G],pe.header.length);return pe}}},ke.hr=function(le){var ce=this.rules.block.hr.exec(le);if(ce)return{type:"hr",raw:ce[0]}},ke.blockquote=function(le){var ce=this.rules.block.blockquote.exec(le);if(ce){var pe=ce[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ce[0],text:pe}}},ke.list=function(le){var ce=this.rules.block.list.exec(le);if(ce){var pe=ce[0],Ee=ce[2],G=Ee.length>1,ve={type:"list",raw:pe,ordered:G,start:G?+Ee.slice(0,-1):"",loose:!1,items:[]},ye=ce[0].match(this.rules.block.item),Ae=!1,Ne,Ge,et,Qe,Xe,lt,dt,_t,at=ye.length;et=this.rules.block.listItemStart.exec(ye[0]);for(var be=0;be<at;be++){if(Ne=ye[be],pe=Ne,be!==at-1){if(Qe=this.rules.block.listItemStart.exec(ye[be+1]),this.options.pedantic?Qe[1].length>et[1].length:Qe[1].length>et[0].length||Qe[1].length>3){ye.splice(be,2,ye[be]+`
`+ye[be+1]),be--,at--;continue}else(!this.options.pedantic||this.options.smartLists?Qe[2][Qe[2].length-1]!==Ee[Ee.length-1]:G===(Qe[2].length===1))&&(Xe=ye.slice(be+1).join(`
`),ve.raw=ve.raw.substring(0,ve.raw.length-Xe.length),be=at-1);et=Qe}Ge=Ne.length,Ne=Ne.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ne.indexOf(`
 `)&&(Ge-=Ne.length,Ne=this.options.pedantic?Ne.replace(/^ {1,4}/gm,""):Ne.replace(new RegExp("^ {1,"+Ge+"}","gm"),"")),lt=Ae||/\n\n(?!\s*$)/.test(Ne),be!==at-1&&(Ae=Ne.charAt(Ne.length-1)===`
`,lt||(lt=Ae)),lt&&(ve.loose=!0),this.options.gfm&&(dt=/^\[[ xX]\] /.test(Ne),_t=void 0,dt&&(_t=Ne[1]!==" ",Ne=Ne.replace(/^\[[ xX]\] +/,""))),ve.items.push({type:"list_item",raw:pe,task:dt,checked:_t,loose:lt,text:Ne})}return ve}},ke.html=function(le){var ce=this.rules.block.html.exec(le);if(ce)return{type:this.options.sanitize?"paragraph":"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):j(ce[0]):ce[0]}},ke.def=function(le){var ce=this.rules.block.def.exec(le);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var pe=ce[1].toLowerCase().replace(/\s+/g," ");return{tag:pe,raw:ce[0],href:ce[2],title:ce[3]}}},ke.table=function(le){var ce=this.rules.block.table.exec(le);if(ce){var pe={type:"table",header:oe(ce[1].replace(/^ *| *\| *$/g,"")),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ce[3]?ce[3].replace(/\n$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=ce[0];var Ee=pe.align.length,G;for(G=0;G<Ee;G++)/^ *-+: *$/.test(pe.align[G])?pe.align[G]="right":/^ *:-+: *$/.test(pe.align[G])?pe.align[G]="center":/^ *:-+ *$/.test(pe.align[G])?pe.align[G]="left":pe.align[G]=null;for(Ee=pe.cells.length,G=0;G<Ee;G++)pe.cells[G]=oe(pe.cells[G].replace(/^ *\| *| *\| *$/g,""),pe.header.length);return pe}}},ke.lheading=function(le){var ce=this.rules.block.lheading.exec(le);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1]}},ke.paragraph=function(le){var ce=this.rules.block.paragraph.exec(le);if(ce)return{type:"paragraph",raw:ce[0],text:ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1]}},ke.text=function(le){var ce=this.rules.block.text.exec(le);if(ce)return{type:"text",raw:ce[0],text:ce[0]}},ke.escape=function(le){var ce=this.rules.inline.escape.exec(le);if(ce)return{type:"escape",raw:ce[0],text:j(ce[1])}},ke.tag=function(le,ce,pe){var Ee=this.rules.inline.tag.exec(le);if(Ee)return!ce&&/^<a /i.test(Ee[0])?ce=!0:ce&&/^<\/a>/i.test(Ee[0])&&(ce=!1),!pe&&/^<(pre|code|kbd|script)(\s|>)/i.test(Ee[0])?pe=!0:pe&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Ee[0])&&(pe=!1),{type:this.options.sanitize?"text":"html",raw:Ee[0],inLink:ce,inRawBlock:pe,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Ee[0]):j(Ee[0]):Ee[0]}},ke.link=function(le){var ce=this.rules.inline.link.exec(le);if(ce){var pe=ce[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var Ee=Q(pe.slice(0,-1),"\\");if((pe.length-Ee.length)%2==0)return}else{var G=O(ce[2],"()");if(G>-1){var ve=ce[0].indexOf("!")===0?5:4,ye=ve+ce[1].length+G;ce[2]=ce[2].substring(0,G),ce[0]=ce[0].substring(0,ye).trim(),ce[3]=""}}var Ae=ce[2],Ne="";if(this.options.pedantic){var Ge=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);Ge&&(Ae=Ge[1],Ne=Ge[3])}else Ne=ce[3]?ce[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(pe)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),B(ce,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:Ne&&Ne.replace(this.rules.inline._escapes,"$1")},ce[0])}},ke.reflink=function(le,ce){var pe;if((pe=this.rules.inline.reflink.exec(le))||(pe=this.rules.inline.nolink.exec(le))){var Ee=(pe[2]||pe[1]).replace(/\s+/g," ");if(Ee=ce[Ee.toLowerCase()],!Ee||!Ee.href){var G=pe[0].charAt(0);return{type:"text",raw:G,text:G}}return B(pe,Ee,pe[0])}},ke.emStrong=function(le,ce,pe){pe===void 0&&(pe="");var Ee=this.rules.inline.emStrong.lDelim.exec(le);if(!!Ee&&!(Ee[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var G=Ee[1]||Ee[2]||"";if(!G||G&&(pe===""||this.rules.inline.punctuation.exec(pe))){var ve=Ee[0].length-1,ye,Ae,Ne=ve,Ge=0,et=Ee[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(et.lastIndex=0,ce=ce.slice(-1*le.length+ve);(Ee=et.exec(ce))!=null;)if(ye=Ee[1]||Ee[2]||Ee[3]||Ee[4]||Ee[5]||Ee[6],!!ye){if(Ae=ye.length,Ee[3]||Ee[4]){Ne+=Ae;continue}else if((Ee[5]||Ee[6])&&ve%3&&!((ve+Ae)%3)){Ge+=Ae;continue}if(Ne-=Ae,!(Ne>0)){if(Ne+Ge-Ae<=0&&!ce.slice(et.lastIndex).match(et)&&(Ae=Math.min(Ae,Ae+Ne+Ge)),Math.min(ve,Ae)%2)return{type:"em",raw:le.slice(0,ve+Ee.index+Ae+1),text:le.slice(1,ve+Ee.index+Ae)};if(Math.min(ve,Ae)%2==0)return{type:"strong",raw:le.slice(0,ve+Ee.index+Ae+1),text:le.slice(2,ve+Ee.index+Ae-1)}}}}}},ke.codespan=function(le){var ce=this.rules.inline.code.exec(le);if(ce){var pe=ce[2].replace(/\n/g," "),Ee=/[^ ]/.test(pe),G=/^ /.test(pe)&&/ $/.test(pe);return Ee&&G&&(pe=pe.substring(1,pe.length-1)),pe=j(pe,!0),{type:"codespan",raw:ce[0],text:pe}}},ke.br=function(le){var ce=this.rules.inline.br.exec(le);if(ce)return{type:"br",raw:ce[0]}},ke.del=function(le){var ce=this.rules.inline.del.exec(le);if(ce)return{type:"del",raw:ce[0],text:ce[2]}},ke.autolink=function(le,ce){var pe=this.rules.inline.autolink.exec(le);if(pe){var Ee,G;return pe[2]==="@"?(Ee=j(this.options.mangle?ce(pe[1]):pe[1]),G="mailto:"+Ee):(Ee=j(pe[1]),G=Ee),{type:"link",raw:pe[0],text:Ee,href:G,tokens:[{type:"text",raw:Ee,text:Ee}]}}},ke.url=function(le,ce){var pe;if(pe=this.rules.inline.url.exec(le)){var Ee,G;if(pe[2]==="@")Ee=j(this.options.mangle?ce(pe[0]):pe[0]),G="mailto:"+Ee;else{var ve;do ve=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(ve!==pe[0]);Ee=j(pe[0]),pe[1]==="www."?G="http://"+Ee:G=Ee}return{type:"link",raw:pe[0],text:Ee,href:G,tokens:[{type:"text",raw:Ee,text:Ee}]}}},ke.inlineText=function(le,ce,pe){var Ee=this.rules.inline.text.exec(le);if(Ee){var G;return ce?G=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Ee[0]):j(Ee[0]):Ee[0]:G=j(this.options.smartypants?pe(Ee[0]):Ee[0]),{type:"text",raw:Ee[0],text:G}}},Ce}(),N=F.noopTest,M=F.edit,q=F.merge,x={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:N,table:N,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};x._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,x._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,x.def=M(x.def).replace("label",x._label).replace("title",x._title).getRegex(),x.bullet=/(?:[*+-]|\d{1,9}[.)])/,x.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,x.item=M(x.item,"gm").replace(/bull/g,x.bullet).getRegex(),x.listItemStart=M(/^( *)(bull)/).replace("bull",x.bullet).getRegex(),x.list=M(x.list).replace(/bull/g,x.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+x.def.source+")").getRegex(),x._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",x._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,x.html=M(x.html,"i").replace("comment",x._comment).replace("tag",x._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),x.paragraph=M(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",x._tag).getRegex(),x.blockquote=M(x.blockquote).replace("paragraph",x.paragraph).getRegex(),x.normal=q({},x),x.gfm=q({},x.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),x.gfm.nptable=M(x.gfm.nptable).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",x._tag).getRegex(),x.gfm.table=M(x.gfm.table).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",x._tag).getRegex(),x.pedantic=q({},x.normal,{html:M(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",x._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:N,paragraph:M(x.normal._paragraph).replace("hr",x.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",x.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var K={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:N,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:N,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};K._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",K.punctuation=M(K.punctuation).replace(/punctuation/g,K._punctuation).getRegex(),K.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,K.escapedEmSt=/\\\*|\\_/g,K._comment=M(x._comment).replace("(?:-->|$)","-->").getRegex(),K.emStrong.lDelim=M(K.emStrong.lDelim).replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimAst=M(K.emStrong.rDelimAst,"g").replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimUnd=M(K.emStrong.rDelimUnd,"g").replace(/punct/g,K._punctuation).getRegex(),K._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,K._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,K._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,K.autolink=M(K.autolink).replace("scheme",K._scheme).replace("email",K._email).getRegex(),K._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,K.tag=M(K.tag).replace("comment",K._comment).replace("attribute",K._attribute).getRegex(),K._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,K._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,K._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,K.link=M(K.link).replace("label",K._label).replace("href",K._href).replace("title",K._title).getRegex(),K.reflink=M(K.reflink).replace("label",K._label).getRegex(),K.reflinkSearch=M(K.reflinkSearch,"g").replace("reflink",K.reflink).replace("nolink",K.nolink).getRegex(),K.normal=q({},K),K.pedantic=q({},K.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:M(/^!?\[(label)\]\((.*?)\)/).replace("label",K._label).getRegex(),reflink:M(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",K._label).getRegex()}),K.gfm=q({},K.normal,{escape:M(K.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),K.gfm.url=M(K.gfm.url,"i").replace("email",K.gfm._extended_email).getRegex(),K.breaks=q({},K.gfm,{br:M(K.br).replace("{2,}","*").getRegex(),text:M(K.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ee={block:x,inline:K},de=T.defaults,Se=ee.block,De=ee.inline,Le=F.repeatString;function qe(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function We(Ce){var ke="",Te,le,ce=Ce.length;for(Te=0;Te<ce;Te++)le=Ce.charCodeAt(Te),Math.random()>.5&&(le="x"+le.toString(16)),ke+="&#"+le+";";return ke}var je=function(){function Ce(Te){this.tokens=[],this.tokens.links=Object.create(null),this.options=Te||de,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var le={block:Se.normal,inline:De.normal};this.options.pedantic?(le.block=Se.pedantic,le.inline=De.pedantic):this.options.gfm&&(le.block=Se.gfm,this.options.breaks?le.inline=De.breaks:le.inline=De.gfm),this.tokenizer.rules=le}Ce.lex=function(le,ce){var pe=new Ce(ce);return pe.lex(le)},Ce.lexInline=function(le,ce){var pe=new Ce(ce);return pe.inlineTokens(le)};var ke=Ce.prototype;return ke.lex=function(le){return le=le.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(le,this.tokens,!0),this.inline(this.tokens),this.tokens},ke.blockTokens=function(le,ce,pe){ce===void 0&&(ce=[]),pe===void 0&&(pe=!0),this.options.pedantic&&(le=le.replace(/^ +$/gm,""));for(var Ee,G,ve,ye;le;){if(Ee=this.tokenizer.space(le)){le=le.substring(Ee.raw.length),Ee.type&&ce.push(Ee);continue}if(Ee=this.tokenizer.code(le)){le=le.substring(Ee.raw.length),ye=ce[ce.length-1],ye&&ye.type==="paragraph"?(ye.raw+=`
`+Ee.raw,ye.text+=`
`+Ee.text):ce.push(Ee);continue}if(Ee=this.tokenizer.fences(le)){le=le.substring(Ee.raw.length),ce.push(Ee);continue}if(Ee=this.tokenizer.heading(le)){le=le.substring(Ee.raw.length),ce.push(Ee);continue}if(Ee=this.tokenizer.nptable(le)){le=le.substring(Ee.raw.length),ce.push(Ee);continue}if(Ee=this.tokenizer.hr(le)){le=le.substring(Ee.raw.length),ce.push(Ee);continue}if(Ee=this.tokenizer.blockquote(le)){le=le.substring(Ee.raw.length),Ee.tokens=this.blockTokens(Ee.text,[],pe),ce.push(Ee);continue}if(Ee=this.tokenizer.list(le)){for(le=le.substring(Ee.raw.length),ve=Ee.items.length,G=0;G<ve;G++)Ee.items[G].tokens=this.blockTokens(Ee.items[G].text,[],!1);ce.push(Ee);continue}if(Ee=this.tokenizer.html(le)){le=le.substring(Ee.raw.length),ce.push(Ee);continue}if(pe&&(Ee=this.tokenizer.def(le))){le=le.substring(Ee.raw.length),this.tokens.links[Ee.tag]||(this.tokens.links[Ee.tag]={href:Ee.href,title:Ee.title});continue}if(Ee=this.tokenizer.table(le)){le=le.substring(Ee.raw.length),ce.push(Ee);continue}if(Ee=this.tokenizer.lheading(le)){le=le.substring(Ee.raw.length),ce.push(Ee);continue}if(pe&&(Ee=this.tokenizer.paragraph(le))){le=le.substring(Ee.raw.length),ce.push(Ee);continue}if(Ee=this.tokenizer.text(le)){le=le.substring(Ee.raw.length),ye=ce[ce.length-1],ye&&ye.type==="text"?(ye.raw+=`
`+Ee.raw,ye.text+=`
`+Ee.text):ce.push(Ee);continue}if(le){var Ae="Infinite loop on byte: "+le.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return ce},ke.inline=function(le){var ce,pe,Ee,G,ve,ye,Ae=le.length;for(ce=0;ce<Ae;ce++)switch(ye=le[ce],ye.type){case"paragraph":case"text":case"heading":{ye.tokens=[],this.inlineTokens(ye.text,ye.tokens);break}case"table":{for(ye.tokens={header:[],cells:[]},G=ye.header.length,pe=0;pe<G;pe++)ye.tokens.header[pe]=[],this.inlineTokens(ye.header[pe],ye.tokens.header[pe]);for(G=ye.cells.length,pe=0;pe<G;pe++)for(ve=ye.cells[pe],ye.tokens.cells[pe]=[],Ee=0;Ee<ve.length;Ee++)ye.tokens.cells[pe][Ee]=[],this.inlineTokens(ve[Ee],ye.tokens.cells[pe][Ee]);break}case"blockquote":{this.inline(ye.tokens);break}case"list":{for(G=ye.items.length,pe=0;pe<G;pe++)this.inline(ye.items[pe].tokens);break}}return le},ke.inlineTokens=function(le,ce,pe,Ee){ce===void 0&&(ce=[]),pe===void 0&&(pe=!1),Ee===void 0&&(Ee=!1);var G,ve,ye=le,Ae,Ne,Ge;if(this.tokens.links){var et=Object.keys(this.tokens.links);if(et.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(ye))!=null;)et.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(ye=ye.slice(0,Ae.index)+"["+Le("a",Ae[0].length-2)+"]"+ye.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(ye))!=null;)ye=ye.slice(0,Ae.index)+"["+Le("a",Ae[0].length-2)+"]"+ye.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(ye))!=null;)ye=ye.slice(0,Ae.index)+"++"+ye.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;le;){if(Ne||(Ge=""),Ne=!1,G=this.tokenizer.escape(le)){le=le.substring(G.raw.length),ce.push(G);continue}if(G=this.tokenizer.tag(le,pe,Ee)){le=le.substring(G.raw.length),pe=G.inLink,Ee=G.inRawBlock;var Qe=ce[ce.length-1];Qe&&G.type==="text"&&Qe.type==="text"?(Qe.raw+=G.raw,Qe.text+=G.text):ce.push(G);continue}if(G=this.tokenizer.link(le)){le=le.substring(G.raw.length),G.type==="link"&&(G.tokens=this.inlineTokens(G.text,[],!0,Ee)),ce.push(G);continue}if(G=this.tokenizer.reflink(le,this.tokens.links)){le=le.substring(G.raw.length);var Xe=ce[ce.length-1];G.type==="link"?(G.tokens=this.inlineTokens(G.text,[],!0,Ee),ce.push(G)):Xe&&G.type==="text"&&Xe.type==="text"?(Xe.raw+=G.raw,Xe.text+=G.text):ce.push(G);continue}if(G=this.tokenizer.emStrong(le,ye,Ge)){le=le.substring(G.raw.length),G.tokens=this.inlineTokens(G.text,[],pe,Ee),ce.push(G);continue}if(G=this.tokenizer.codespan(le)){le=le.substring(G.raw.length),ce.push(G);continue}if(G=this.tokenizer.br(le)){le=le.substring(G.raw.length),ce.push(G);continue}if(G=this.tokenizer.del(le)){le=le.substring(G.raw.length),G.tokens=this.inlineTokens(G.text,[],pe,Ee),ce.push(G);continue}if(G=this.tokenizer.autolink(le,We)){le=le.substring(G.raw.length),ce.push(G);continue}if(!pe&&(G=this.tokenizer.url(le,We))){le=le.substring(G.raw.length),ce.push(G);continue}if(G=this.tokenizer.inlineText(le,Ee,qe)){le=le.substring(G.raw.length),G.raw.slice(-1)!=="_"&&(Ge=G.raw.slice(-1)),Ne=!0,ve=ce[ce.length-1],ve&&ve.type==="text"?(ve.raw+=G.raw,ve.text+=G.text):ce.push(G);continue}if(le){var lt="Infinite loop on byte: "+le.charCodeAt(0);if(this.options.silent){console.error(lt);break}else throw new Error(lt)}}return ce},e(Ce,null,[{key:"rules",get:function(){return{block:Se,inline:De}}}]),Ce}(),W=T.defaults,Z=F.cleanUrl,te=F.escape,ae=function(){function Ce(Te){this.options=Te||W}var ke=Ce.prototype;return ke.code=function(le,ce,pe){var Ee=(ce||"").match(/\S*/)[0];if(this.options.highlight){var G=this.options.highlight(le,Ee);G!=null&&G!==le&&(pe=!0,le=G)}return le=le.replace(/\n$/,"")+`
`,Ee?'<pre><code class="'+this.options.langPrefix+te(Ee,!0)+'">'+(pe?le:te(le,!0))+`</code></pre>
`:"<pre><code>"+(pe?le:te(le,!0))+`</code></pre>
`},ke.blockquote=function(le){return`<blockquote>
`+le+`</blockquote>
`},ke.html=function(le){return le},ke.heading=function(le,ce,pe,Ee){return this.options.headerIds?"<h"+ce+' id="'+this.options.headerPrefix+Ee.slug(pe)+'">'+le+"</h"+ce+`>
`:"<h"+ce+">"+le+"</h"+ce+`>
`},ke.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ke.list=function(le,ce,pe){var Ee=ce?"ol":"ul",G=ce&&pe!==1?' start="'+pe+'"':"";return"<"+Ee+G+`>
`+le+"</"+Ee+`>
`},ke.listitem=function(le){return"<li>"+le+`</li>
`},ke.checkbox=function(le){return"<input "+(le?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ke.paragraph=function(le){return"<p>"+le+`</p>
`},ke.table=function(le,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+le+`</thead>
`+ce+`</table>
`},ke.tablerow=function(le){return`<tr>
`+le+`</tr>
`},ke.tablecell=function(le,ce){var pe=ce.header?"th":"td",Ee=ce.align?"<"+pe+' align="'+ce.align+'">':"<"+pe+">";return Ee+le+"</"+pe+`>
`},ke.strong=function(le){return"<strong>"+le+"</strong>"},ke.em=function(le){return"<em>"+le+"</em>"},ke.codespan=function(le){return"<code>"+le+"</code>"},ke.br=function(){return this.options.xhtml?"<br/>":"<br>"},ke.del=function(le){return"<del>"+le+"</del>"},ke.link=function(le,ce,pe){if(le=Z(this.options.sanitize,this.options.baseUrl,le),le===null)return pe;var Ee='<a href="'+te(le)+'"';return ce&&(Ee+=' title="'+ce+'"'),Ee+=">"+pe+"</a>",Ee},ke.image=function(le,ce,pe){if(le=Z(this.options.sanitize,this.options.baseUrl,le),le===null)return pe;var Ee='<img src="'+le+'" alt="'+pe+'"';return ce&&(Ee+=' title="'+ce+'"'),Ee+=this.options.xhtml?"/>":">",Ee},ke.text=function(le){return le},Ce}(),Y=function(){function Ce(){}var ke=Ce.prototype;return ke.strong=function(le){return le},ke.em=function(le){return le},ke.codespan=function(le){return le},ke.del=function(le){return le},ke.html=function(le){return le},ke.text=function(le){return le},ke.link=function(le,ce,pe){return""+pe},ke.image=function(le,ce,pe){return""+pe},ke.br=function(){return""},Ce}(),se=function(){function Ce(){this.seen={}}var ke=Ce.prototype;return ke.serialize=function(le){return le.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ke.getNextSafeSlug=function(le,ce){var pe=le,Ee=0;if(this.seen.hasOwnProperty(pe)){Ee=this.seen[le];do Ee++,pe=le+"-"+Ee;while(this.seen.hasOwnProperty(pe))}return ce||(this.seen[le]=Ee,this.seen[pe]=0),pe},ke.slug=function(le,ce){ce===void 0&&(ce={});var pe=this.serialize(le);return this.getNextSafeSlug(pe,ce.dryrun)},Ce}(),we=T.defaults,Fe=F.unescape,ze=function(){function Ce(Te){this.options=Te||we,this.options.renderer=this.options.renderer||new ae,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Y,this.slugger=new se}Ce.parse=function(le,ce){var pe=new Ce(ce);return pe.parse(le)},Ce.parseInline=function(le,ce){var pe=new Ce(ce);return pe.parseInline(le)};var ke=Ce.prototype;return ke.parse=function(le,ce){ce===void 0&&(ce=!0);var pe="",Ee,G,ve,ye,Ae,Ne,Ge,et,Qe,Xe,lt,dt,_t,at,be,Ie,he,V,Me=le.length;for(Ee=0;Ee<Me;Ee++)switch(Xe=le[Ee],Xe.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(Xe.tokens),Xe.depth,Fe(this.parseInline(Xe.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(Xe.text,Xe.lang,Xe.escaped);continue}case"table":{for(et="",Ge="",ye=Xe.header.length,G=0;G<ye;G++)Ge+=this.renderer.tablecell(this.parseInline(Xe.tokens.header[G]),{header:!0,align:Xe.align[G]});for(et+=this.renderer.tablerow(Ge),Qe="",ye=Xe.cells.length,G=0;G<ye;G++){for(Ne=Xe.tokens.cells[G],Ge="",Ae=Ne.length,ve=0;ve<Ae;ve++)Ge+=this.renderer.tablecell(this.parseInline(Ne[ve]),{header:!1,align:Xe.align[ve]});Qe+=this.renderer.tablerow(Ge)}pe+=this.renderer.table(et,Qe);continue}case"blockquote":{Qe=this.parse(Xe.tokens),pe+=this.renderer.blockquote(Qe);continue}case"list":{for(lt=Xe.ordered,dt=Xe.start,_t=Xe.loose,ye=Xe.items.length,Qe="",G=0;G<ye;G++)be=Xe.items[G],Ie=be.checked,he=be.task,at="",be.task&&(V=this.renderer.checkbox(Ie),_t?be.tokens.length>0&&be.tokens[0].type==="text"?(be.tokens[0].text=V+" "+be.tokens[0].text,be.tokens[0].tokens&&be.tokens[0].tokens.length>0&&be.tokens[0].tokens[0].type==="text"&&(be.tokens[0].tokens[0].text=V+" "+be.tokens[0].tokens[0].text)):be.tokens.unshift({type:"text",text:V}):at+=V),at+=this.parse(be.tokens,_t),Qe+=this.renderer.listitem(at,he,Ie);pe+=this.renderer.list(Qe,lt,dt);continue}case"html":{pe+=this.renderer.html(Xe.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(Xe.tokens));continue}case"text":{for(Qe=Xe.tokens?this.parseInline(Xe.tokens):Xe.text;Ee+1<Me&&le[Ee+1].type==="text";)Xe=le[++Ee],Qe+=`
`+(Xe.tokens?this.parseInline(Xe.tokens):Xe.text);pe+=ce?this.renderer.paragraph(Qe):Qe;continue}default:{var Be='Token with "'+Xe.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}return pe},ke.parseInline=function(le,ce){ce=ce||this.renderer;var pe="",Ee,G,ve=le.length;for(Ee=0;Ee<ve;Ee++)switch(G=le[Ee],G.type){case"escape":{pe+=ce.text(G.text);break}case"html":{pe+=ce.html(G.text);break}case"link":{pe+=ce.link(G.href,G.title,this.parseInline(G.tokens,ce));break}case"image":{pe+=ce.image(G.href,G.title,G.text);break}case"strong":{pe+=ce.strong(this.parseInline(G.tokens,ce));break}case"em":{pe+=ce.em(this.parseInline(G.tokens,ce));break}case"codespan":{pe+=ce.codespan(G.text);break}case"br":{pe+=ce.br();break}case"del":{pe+=ce.del(this.parseInline(G.tokens,ce));break}case"text":{pe+=ce.text(G.text);break}default:{var ye='Token with "'+G.type+'" type was not found.';if(this.options.silent){console.error(ye);return}else throw new Error(ye)}}return pe},Ce}(),_e=F.merge,Ze=F.checkSanitizeDeprecation,X=F.escape,ie=T.getDefaults,fe=T.changeDefaults,$e=T.defaults;function xe(Ce,ke,Te){if(typeof Ce=="undefined"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof ke=="function"&&(Te=ke,ke=null),ke=_e({},xe.defaults,ke||{}),Ze(ke),Te){var le=ke.highlight,ce;try{ce=je.lex(Ce,ke)}catch(ve){return Te(ve)}var pe=function(ye){var Ae;if(!ye)try{Ae=ze.parse(ce,ke)}catch(Ne){ye=Ne}return ke.highlight=le,ye?Te(ye):Te(null,Ae)};if(!le||le.length<3||(delete ke.highlight,!ce.length))return pe();var Ee=0;xe.walkTokens(ce,function(ve){ve.type==="code"&&(Ee++,setTimeout(function(){le(ve.text,ve.lang,function(ye,Ae){if(ye)return pe(ye);Ae!=null&&Ae!==ve.text&&(ve.text=Ae,ve.escaped=!0),Ee--,Ee===0&&pe()})},0))}),Ee===0&&pe();return}try{var G=je.lex(Ce,ke);return ke.walkTokens&&xe.walkTokens(G,ke.walkTokens),ze.parse(G,ke)}catch(ve){if(ve.message+=`
Please report this to https://github.com/markedjs/marked.`,ke.silent)return"<p>An error occurred:</p><pre>"+X(ve.message+"",!0)+"</pre>";throw ve}}xe.options=xe.setOptions=function(Ce){return _e(xe.defaults,Ce),fe(xe.defaults),xe},xe.getDefaults=ie,xe.defaults=$e,xe.use=function(Ce){var ke=_e({},Ce);if(Ce.renderer&&function(){var le=xe.defaults.renderer||new ae,ce=function(G){var ve=le[G];le[G]=function(){for(var ye=arguments.length,Ae=new Array(ye),Ne=0;Ne<ye;Ne++)Ae[Ne]=arguments[Ne];var Ge=Ce.renderer[G].apply(le,Ae);return Ge===!1&&(Ge=ve.apply(le,Ae)),Ge}};for(var pe in Ce.renderer)ce(pe);ke.renderer=le}(),Ce.tokenizer&&function(){var le=xe.defaults.tokenizer||new z,ce=function(G){var ve=le[G];le[G]=function(){for(var ye=arguments.length,Ae=new Array(ye),Ne=0;Ne<ye;Ne++)Ae[Ne]=arguments[Ne];var Ge=Ce.tokenizer[G].apply(le,Ae);return Ge===!1&&(Ge=ve.apply(le,Ae)),Ge}};for(var pe in Ce.tokenizer)ce(pe);ke.tokenizer=le}(),Ce.walkTokens){var Te=xe.defaults.walkTokens;ke.walkTokens=function(le){Ce.walkTokens(le),Te&&Te(le)}}xe.setOptions(ke)},xe.walkTokens=function(Ce,ke){for(var Te=C(Ce),le;!(le=Te()).done;){var ce=le.value;switch(ke(ce),ce.type){case"table":{for(var pe=C(ce.tokens.header),Ee;!(Ee=pe()).done;){var G=Ee.value;xe.walkTokens(G,ke)}for(var ve=C(ce.tokens.cells),ye;!(ye=ve()).done;)for(var Ae=ye.value,Ne=C(Ae),Ge;!(Ge=Ne()).done;){var et=Ge.value;xe.walkTokens(et,ke)}break}case"list":{xe.walkTokens(ce.items,ke);break}default:ce.tokens&&xe.walkTokens(ce.tokens,ke)}}},xe.parseInline=function(Ce,ke){if(typeof Ce=="undefined"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");ke=_e({},xe.defaults,ke||{}),Ze(ke);try{var Te=je.lexInline(Ce,ke);return ke.walkTokens&&xe.walkTokens(Te,ke.walkTokens),ze.parseInline(Te,ke)}catch(le){if(le.message+=`
Please report this to https://github.com/markedjs/marked.`,ke.silent)return"<p>An error occurred:</p><pre>"+X(le.message+"",!0)+"</pre>";throw le}},xe.Parser=ze,xe.parser=ze.parse,xe.Renderer=ae,xe.TextRenderer=Y,xe.Lexer=je,xe.lexer=je.lex,xe.Tokenizer=z,xe.Slugger=se,xe.parse=xe;var tt=xe;return tt}),define(me[73],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function p(T,I,D){return Math.min(Math.max(T,I),D)}e.clamp=p;function L(T,I){return(I+T%I)%I}e.rot=L;class C{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=C;class S{constructor(){this._n=1,this._val=0}update(I){return this._val=this._val+(I-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=S}),function(){function J(C){const S=[];typeof C=="number"&&S.push("code/timeOrigin",C);function T(D){S.push(D,Date.now())}function I(){const D=[];for(let A=0;A<S.length;A+=2)D.push({name:S[A],startTime:S[A+1]});return D}return{mark:T,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const T of performance.getEntriesByType("mark"))S.push({name:T.name,startTime:Math.round(C+T.startTime)});return S}};if(typeof process=="object"){const C=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function p(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=p(L))}(),define(me[11],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const p="en";let L=!1,C=!1,S=!1,T=!1,I=!1,D=!1,A=!1,i,P=p,c,u;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?a=e.globals.vscode.process:typeof process!="undefined"&&(a=process);const g=typeof a?.versions?.electron=="string"&&a.type==="renderer";if(e.isElectronSandboxed=g&&a?.sandboxed,e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=a?.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!g)u=navigator.userAgent,L=u.indexOf("Windows")>=0,C=u.indexOf("Macintosh")>=0,A=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=u.indexOf("Linux")>=0,D=!0,i=navigator.language,P=i;else if(typeof a=="object"){L=a.platform==="win32",C=a.platform==="darwin",S=a.platform==="linux",T=S&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,i=p,P=p;const r=a.env.VSCODE_NLS_CONFIG;if(r)try{const n=JSON.parse(r),l=n.availableLanguages["*"];i=n.locale,P=l||p,c=n._translationsConfigFile}catch(n){}I=!0}else console.error("Unable to resolve platform.");var w;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function _(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=_;let b=0;C?b=1:L?b=3:S&&(b=2),e.isWindows=L,e.isMacintosh=C,e.isLinux=S,e.isLinuxSnap=T,e.isNative=I,e.isWeb=D,e.isIOS=A,e.platform=b,e.userAgent=u,e.language=P;var d;(function(r){function n(){return e.language}r.value=n;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=l;function f(){return e.language==="en"}r.isDefault=f})(d=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=c,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",m=>{if(m.data&&m.data.vscodeSetImmediateId)for(let E=0,y=l.length;E<y;E++){const o=l[E];if(o.id===m.data.vscodeSetImmediateId){l.splice(E,1),o.callback();return}}});let f=0;return m=>{const E=++f;l.push({id:E,callback:m}),e.globals.postMessage({vscodeSetImmediateId:E},"*")}}if(typeof a?.nextTick=="function")return a.nextTick.bind(a);const n=Promise.resolve();return l=>n.then(l)}();var h;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(h=e.OperatingSystem||(e.OperatingSystem={})),e.OS=C||A?2:L?1:3;let v=!0,t=!1;function s(){if(!t){t=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,v=new Uint16Array(r.buffer)[0]===(2<<8)+1}return v}e.isLittleEndian=s}),define(me[37],ge([0,1,11]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const C=p.globals.vscode.process;L={get platform(){return C.platform},get env(){return C.env},cwd(){return C.cwd()},nextTick(S){return(0,p.setImmediate)(S)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(C){return process.nextTick(C)}}:L={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},nextTick(C){return(0,p.setImmediate)(C)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(me[9],ge([0,1,37]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,C=97,S=90,T=122,I=46,D=47,A=92,i=58,P=63;class c extends Error{constructor(h,v,t){let s;typeof v=="string"&&v.indexOf("not ")===0?(s="must not be",v=v.replace(/^not /,"")):s="must be";const r=h.indexOf(".")!==-1?"property":"argument";let n=`The "${h}" ${r} ${s} of type ${v}`;n+=`. Received type ${typeof t}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function u(d,h){if(typeof d!="string")throw new c(h,"string",d)}function a(d){return d===D||d===A}function g(d){return d===D}function w(d){return d>=L&&d<=S||d>=C&&d<=T}function _(d,h,v,t){let s="",r=0,n=-1,l=0,f=0;for(let m=0;m<=d.length;++m){if(m<d.length)f=d.charCodeAt(m);else{if(t(f))break;f=D}if(t(f)){if(!(n===m-1||l===1))if(l===2){if(s.length<2||r!==2||s.charCodeAt(s.length-1)!==I||s.charCodeAt(s.length-2)!==I){if(s.length>2){const E=s.lastIndexOf(v);E===-1?(s="",r=0):(s=s.slice(0,E),r=s.length-1-s.lastIndexOf(v)),n=m,l=0;continue}else if(s.length!==0){s="",r=0,n=m,l=0;continue}}h&&(s+=s.length>0?`${v}..`:"..",r=2)}else s.length>0?s+=`${v}${d.slice(n+1,m)}`:s=d.slice(n+1,m),r=m-n-1;n=m,l=0}else f===I&&l!==-1?++l:l=-1}return s}function b(d,h){if(h===null||typeof h!="object")throw new c("pathObject","Object",h);const v=h.dir||h.root,t=h.base||`${h.name||""}${h.ext||""}`;return v?v===h.root?`${v}${t}`:`${v}${d}${t}`:t}e.win32={resolve(...d){let h="",v="",t=!1;for(let s=d.length-1;s>=-1;s--){let r;if(s>=0){if(r=d[s],u(r,"path"),r.length===0)continue}else h.length===0?r=p.cwd():(r=p.env[`=${h}`]||p.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==h.toLowerCase()&&r.charCodeAt(2)===A)&&(r=`${h}\\`));const n=r.length;let l=0,f="",m=!1;const E=r.charCodeAt(0);if(n===1)a(E)&&(l=1,m=!0);else if(a(E))if(m=!0,a(r.charCodeAt(1))){let y=2,o=y;for(;y<n&&!a(r.charCodeAt(y));)y++;if(y<n&&y!==o){const k=r.slice(o,y);for(o=y;y<n&&a(r.charCodeAt(y));)y++;if(y<n&&y!==o){for(o=y;y<n&&!a(r.charCodeAt(y));)y++;(y===n||y!==o)&&(f=`\\\\${k}\\${r.slice(o,y)}`,l=y)}}}else l=1;else w(E)&&r.charCodeAt(1)===i&&(f=r.slice(0,2),l=2,n>2&&a(r.charCodeAt(2))&&(m=!0,l=3));if(f.length>0)if(h.length>0){if(f.toLowerCase()!==h.toLowerCase())continue}else h=f;if(t){if(h.length>0)break}else if(v=`${r.slice(l)}\\${v}`,t=m,m&&h.length>0)break}return v=_(v,!t,"\\",a),t?`${h}\\${v}`:`${h}${v}`||"."},normalize(d){u(d,"path");const h=d.length;if(h===0)return".";let v=0,t,s=!1;const r=d.charCodeAt(0);if(h===1)return g(r)?"\\":d;if(a(r))if(s=!0,a(d.charCodeAt(1))){let l=2,f=l;for(;l<h&&!a(d.charCodeAt(l));)l++;if(l<h&&l!==f){const m=d.slice(f,l);for(f=l;l<h&&a(d.charCodeAt(l));)l++;if(l<h&&l!==f){for(f=l;l<h&&!a(d.charCodeAt(l));)l++;if(l===h)return`\\\\${m}\\${d.slice(f)}\\`;l!==f&&(t=`\\\\${m}\\${d.slice(f,l)}`,v=l)}}}else v=1;else w(r)&&d.charCodeAt(1)===i&&(t=d.slice(0,2),v=2,h>2&&a(d.charCodeAt(2))&&(s=!0,v=3));let n=v<h?_(d.slice(v),!s,"\\",a):"";return n.length===0&&!s&&(n="."),n.length>0&&a(d.charCodeAt(h-1))&&(n+="\\"),t===void 0?s?`\\${n}`:n:s?`${t}\\${n}`:`${t}${n}`},isAbsolute(d){u(d,"path");const h=d.length;if(h===0)return!1;const v=d.charCodeAt(0);return a(v)||h>2&&w(v)&&d.charCodeAt(1)===i&&a(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let h,v;for(let r=0;r<d.length;++r){const n=d[r];u(n,"path"),n.length>0&&(h===void 0?h=v=n:h+=`\\${n}`)}if(h===void 0)return".";let t=!0,s=0;if(typeof v=="string"&&a(v.charCodeAt(0))){++s;const r=v.length;r>1&&a(v.charCodeAt(1))&&(++s,r>2&&(a(v.charCodeAt(2))?++s:t=!1))}if(t){for(;s<h.length&&a(h.charCodeAt(s));)s++;s>=2&&(h=`\\${h.slice(s)}`)}return e.win32.normalize(h)},relative(d,h){if(u(d,"from"),u(h,"to"),d===h)return"";const v=e.win32.resolve(d),t=e.win32.resolve(h);if(v===t||(d=v.toLowerCase(),h=t.toLowerCase(),d===h))return"";let s=0;for(;s<d.length&&d.charCodeAt(s)===A;)s++;let r=d.length;for(;r-1>s&&d.charCodeAt(r-1)===A;)r--;const n=r-s;let l=0;for(;l<h.length&&h.charCodeAt(l)===A;)l++;let f=h.length;for(;f-1>l&&h.charCodeAt(f-1)===A;)f--;const m=f-l,E=n<m?n:m;let y=-1,o=0;for(;o<E;o++){const F=d.charCodeAt(s+o);if(F!==h.charCodeAt(l+o))break;F===A&&(y=o)}if(o!==E){if(y===-1)return t}else{if(m>E){if(h.charCodeAt(l+o)===A)return t.slice(l+o+1);if(o===2)return t.slice(l+o)}n>E&&(d.charCodeAt(s+o)===A?y=o:o===2&&(y=3)),y===-1&&(y=0)}let k="";for(o=s+y+1;o<=r;++o)(o===r||d.charCodeAt(o)===A)&&(k+=k.length===0?"..":"\\..");return l+=y,k.length>0?`${k}${t.slice(l,f)}`:(t.charCodeAt(l)===A&&++l,t.slice(l,f))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const h=e.win32.resolve(d);if(h.length<=2)return d;if(h.charCodeAt(0)===A){if(h.charCodeAt(1)===A){const v=h.charCodeAt(2);if(v!==P&&v!==I)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(w(h.charCodeAt(0))&&h.charCodeAt(1)===i&&h.charCodeAt(2)===A)return`\\\\?\\${h}`;return d},dirname(d){u(d,"path");const h=d.length;if(h===0)return".";let v=-1,t=0;const s=d.charCodeAt(0);if(h===1)return a(s)?d:".";if(a(s)){if(v=t=1,a(d.charCodeAt(1))){let l=2,f=l;for(;l<h&&!a(d.charCodeAt(l));)l++;if(l<h&&l!==f){for(f=l;l<h&&a(d.charCodeAt(l));)l++;if(l<h&&l!==f){for(f=l;l<h&&!a(d.charCodeAt(l));)l++;if(l===h)return d;l!==f&&(v=t=l+1)}}}}else w(s)&&d.charCodeAt(1)===i&&(v=h>2&&a(d.charCodeAt(2))?3:2,t=v);let r=-1,n=!0;for(let l=h-1;l>=t;--l)if(a(d.charCodeAt(l))){if(!n){r=l;break}}else n=!1;if(r===-1){if(v===-1)return".";r=v}return d.slice(0,r)},basename(d,h){h!==void 0&&u(h,"ext"),u(d,"path");let v=0,t=-1,s=!0,r;if(d.length>=2&&w(d.charCodeAt(0))&&d.charCodeAt(1)===i&&(v=2),h!==void 0&&h.length>0&&h.length<=d.length){if(h===d)return"";let n=h.length-1,l=-1;for(r=d.length-1;r>=v;--r){const f=d.charCodeAt(r);if(a(f)){if(!s){v=r+1;break}}else l===-1&&(s=!1,l=r+1),n>=0&&(f===h.charCodeAt(n)?--n==-1&&(t=r):(n=-1,t=l))}return v===t?t=l:t===-1&&(t=d.length),d.slice(v,t)}for(r=d.length-1;r>=v;--r)if(a(d.charCodeAt(r))){if(!s){v=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":d.slice(v,t)},extname(d){u(d,"path");let h=0,v=-1,t=0,s=-1,r=!0,n=0;d.length>=2&&d.charCodeAt(1)===i&&w(d.charCodeAt(0))&&(h=t=2);for(let l=d.length-1;l>=h;--l){const f=d.charCodeAt(l);if(a(f)){if(!r){t=l+1;break}continue}s===-1&&(r=!1,s=l+1),f===I?v===-1?v=l:n!==1&&(n=1):v!==-1&&(n=-1)}return v===-1||s===-1||n===0||n===1&&v===s-1&&v===t+1?"":d.slice(v,s)},format:b.bind(null,"\\"),parse(d){u(d,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return h;const v=d.length;let t=0,s=d.charCodeAt(0);if(v===1)return a(s)?(h.root=h.dir=d,h):(h.base=h.name=d,h);if(a(s)){if(t=1,a(d.charCodeAt(1))){let y=2,o=y;for(;y<v&&!a(d.charCodeAt(y));)y++;if(y<v&&y!==o){for(o=y;y<v&&a(d.charCodeAt(y));)y++;if(y<v&&y!==o){for(o=y;y<v&&!a(d.charCodeAt(y));)y++;y===v?t=y:y!==o&&(t=y+1)}}}}else if(w(s)&&d.charCodeAt(1)===i){if(v<=2)return h.root=h.dir=d,h;if(t=2,a(d.charCodeAt(2))){if(v===3)return h.root=h.dir=d,h;t=3}}t>0&&(h.root=d.slice(0,t));let r=-1,n=t,l=-1,f=!0,m=d.length-1,E=0;for(;m>=t;--m){if(s=d.charCodeAt(m),a(s)){if(!f){n=m+1;break}continue}l===-1&&(f=!1,l=m+1),s===I?r===-1?r=m:E!==1&&(E=1):r!==-1&&(E=-1)}return l!==-1&&(r===-1||E===0||E===1&&r===l-1&&r===n+1?h.base=h.name=d.slice(n,l):(h.name=d.slice(n,r),h.base=d.slice(n,l),h.ext=d.slice(r,l))),n>0&&n!==t?h.dir=d.slice(0,n-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let h="",v=!1;for(let t=d.length-1;t>=-1&&!v;t--){const s=t>=0?d[t]:p.cwd();u(s,"path"),s.length!==0&&(h=`${s}/${h}`,v=s.charCodeAt(0)===D)}return h=_(h,!v,"/",g),v?`/${h}`:h.length>0?h:"."},normalize(d){if(u(d,"path"),d.length===0)return".";const h=d.charCodeAt(0)===D,v=d.charCodeAt(d.length-1)===D;return d=_(d,!h,"/",g),d.length===0?h?"/":v?"./":".":(v&&(d+="/"),h?`/${d}`:d)},isAbsolute(d){return u(d,"path"),d.length>0&&d.charCodeAt(0)===D},join(...d){if(d.length===0)return".";let h;for(let v=0;v<d.length;++v){const t=d[v];u(t,"path"),t.length>0&&(h===void 0?h=t:h+=`/${t}`)}return h===void 0?".":e.posix.normalize(h)},relative(d,h){if(u(d,"from"),u(h,"to"),d===h||(d=e.posix.resolve(d),h=e.posix.resolve(h),d===h))return"";const v=1,t=d.length,s=t-v,r=1,n=h.length-r,l=s<n?s:n;let f=-1,m=0;for(;m<l;m++){const y=d.charCodeAt(v+m);if(y!==h.charCodeAt(r+m))break;y===D&&(f=m)}if(m===l)if(n>l){if(h.charCodeAt(r+m)===D)return h.slice(r+m+1);if(m===0)return h.slice(r+m)}else s>l&&(d.charCodeAt(v+m)===D?f=m:m===0&&(f=0));let E="";for(m=v+f+1;m<=t;++m)(m===t||d.charCodeAt(m)===D)&&(E+=E.length===0?"..":"/..");return`${E}${h.slice(r+f)}`},toNamespacedPath(d){return d},dirname(d){if(u(d,"path"),d.length===0)return".";const h=d.charCodeAt(0)===D;let v=-1,t=!0;for(let s=d.length-1;s>=1;--s)if(d.charCodeAt(s)===D){if(!t){v=s;break}}else t=!1;return v===-1?h?"/":".":h&&v===1?"//":d.slice(0,v)},basename(d,h){h!==void 0&&u(h,"ext"),u(d,"path");let v=0,t=-1,s=!0,r;if(h!==void 0&&h.length>0&&h.length<=d.length){if(h===d)return"";let n=h.length-1,l=-1;for(r=d.length-1;r>=0;--r){const f=d.charCodeAt(r);if(f===D){if(!s){v=r+1;break}}else l===-1&&(s=!1,l=r+1),n>=0&&(f===h.charCodeAt(n)?--n==-1&&(t=r):(n=-1,t=l))}return v===t?t=l:t===-1&&(t=d.length),d.slice(v,t)}for(r=d.length-1;r>=0;--r)if(d.charCodeAt(r)===D){if(!s){v=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":d.slice(v,t)},extname(d){u(d,"path");let h=-1,v=0,t=-1,s=!0,r=0;for(let n=d.length-1;n>=0;--n){const l=d.charCodeAt(n);if(l===D){if(!s){v=n+1;break}continue}t===-1&&(s=!1,t=n+1),l===I?h===-1?h=n:r!==1&&(r=1):h!==-1&&(r=-1)}return h===-1||t===-1||r===0||r===1&&h===t-1&&h===v+1?"":d.slice(h,t)},format:b.bind(null,"/"),parse(d){u(d,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return h;const v=d.charCodeAt(0)===D;let t;v?(h.root="/",t=1):t=0;let s=-1,r=0,n=-1,l=!0,f=d.length-1,m=0;for(;f>=t;--f){const E=d.charCodeAt(f);if(E===D){if(!l){r=f+1;break}continue}n===-1&&(l=!1,n=f+1),E===I?s===-1?s=f:m!==1&&(m=1):s!==-1&&(m=-1)}if(n!==-1){const E=r===0&&v?1:r;s===-1||m===0||m===1&&s===n-1&&s===r+1?h.base=h.name=d.slice(E,n):(h.name=d.slice(E,s),h.base=d.slice(E,n),h.ext=d.slice(s,n))}return r>0?h.dir=d.slice(0,r-1):v&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[137],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var p;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(p=e.Source||(e.Source={}));var L;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(S,...T){const I=T.reduce((i,P)=>(i[P]=!0,i),{}),D=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(i=>!I[i]).forEach(i=>{for(let P=0;P<D.length;P++)if(i.search(D[P])!==-1){delete S[i];break}})}e.sanitizeProcessEnvironment=C}),define(me[44],ge([0,1,11]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=p.globals.performance&&typeof p.globals.performance.now=="function";class C{constructor(T){this._highResolution=L&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new C(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=C}),define(me[3],ge([0,1,15,70,6,92,44]),function(J,e,p,L,C,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var I;(function(d){d.None=()=>C.Disposable.None;function h(j){return(O,B=null,R)=>{let z=!1,N;return N=j(M=>{if(!z)return N?N.dispose():z=!0,O.call(B,M)},null,R),z&&N.dispose(),N}}d.once=h;function v(j,O){return f((B,R=null,z)=>j(N=>B.call(R,O(N)),null,z))}d.map=v;function t(j,O){return f((B,R=null,z)=>j(N=>{O(N),B.call(R,N)},null,z))}d.forEach=t;function s(j,O){return f((B,R=null,z)=>j(N=>O(N)&&B.call(R,N),null,z))}d.filter=s;function r(j){return j}d.signal=r;function n(...j){return(O,B=null,R)=>(0,C.combinedDisposable)(...j.map(z=>z(N=>O.call(B,N),null,R)))}d.any=n;function l(j,O,B){let R=B;return v(j,z=>(R=O(R,z),R))}d.reduce=l;function f(j){let O;const B=new c({onFirstListenerAdd(){O=j(B.fire,B)},onLastListenerRemove(){O.dispose()}});return B.event}function m(j,O,B=100,R=!1,z){let N,M,q,x=0;const K=new c({leakWarningThreshold:z,onFirstListenerAdd(){N=j(ee=>{x++,M=O(M,ee),R&&!q&&(K.fire(M),M=void 0),clearTimeout(q),q=setTimeout(()=>{const de=M;M=void 0,q=void 0,(!R||x>1)&&K.fire(de),x=0},B)})},onLastListenerRemove(){N.dispose()}});return K.event}d.debounce=m;function E(j,O=(B,R)=>B===R){let B=!0,R;return s(j,z=>{const N=B||!O(z,R);return B=!1,R=z,N})}d.latch=E;function y(j,O){return[d.filter(j,O),d.filter(j,B=>!O(B))]}d.split=y;function o(j,O=!1,B=[]){let R=B.slice(),z=j(q=>{R?R.push(q):M.fire(q)});const N=()=>{R&&R.forEach(q=>M.fire(q)),R=null},M=new c({onFirstListenerAdd(){z||(z=j(q=>M.fire(q)))},onFirstListenerDidAdd(){R&&(O?setTimeout(N):N())},onLastListenerRemove(){z&&z.dispose(),z=null}});return M.event}d.buffer=o;class k{constructor(O){this.event=O}map(O){return new k(v(this.event,O))}forEach(O){return new k(t(this.event,O))}filter(O){return new k(s(this.event,O))}reduce(O,B){return new k(l(this.event,O,B))}latch(){return new k(E(this.event))}debounce(O,B=100,R=!1,z){return new k(m(this.event,O,B,R,z))}on(O,B,R){return this.event(O,B,R)}once(O,B,R){return h(this.event)(O,B,R)}}function F(j){return new k(j)}d.chain=F;function $(j,O,B=R=>R){const R=(...q)=>M.fire(B(...q)),z=()=>j.on(O,R),N=()=>j.removeListener(O,R),M=new c({onFirstListenerAdd:z,onLastListenerRemove:N});return M.event}d.fromNodeEventEmitter=$;function Q(j,O,B=R=>R){const R=(...q)=>M.fire(B(...q)),z=()=>j.addEventListener(O,R),N=()=>j.removeEventListener(O,R),M=new c({onFirstListenerAdd:z,onLastListenerRemove:N});return M.event}d.fromDOMEventEmitter=Q;function oe(j){return new Promise(O=>h(j)(O))}d.toPromise=oe})(I=e.Event||(e.Event={}));class D{constructor(h){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${h}_${D._idPool++}`}start(h){this._stopWatch=new T.StopWatch(!0),this._listenerCount=h}stop(){if(this._stopWatch){const h=this._stopWatch.elapsed();this._elapsedOverall+=h,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${h.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let A=-1;function i(d){const h=A;return A=d,{dispose(){A=h}}}e.setGlobalLeakWarningThreshold=i;class P{constructor(h,v=Math.random().toString(18).slice(2,5)){this.customThreshold=h,this.name=v,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(h){let v=A;if(typeof this.customThreshold=="number"&&(v=this.customThreshold),v<=0||h<v)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(t)||0;if(this._stacks.set(t,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=v*.5;let r,n=0;for(const[l,f]of this._stacks)(!r||n<f)&&(r=l,n=f);console.warn(`[${this.name}] potential listener LEAK detected, having ${h} listeners already. MOST frequent listener (${n}):`),console.warn(r)}return()=>{const r=this._stacks.get(t)||0;this._stacks.set(t,r-1)}}}class c{constructor(h){this._disposed=!1,this._options=h,this._leakageMon=A>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(h,v,t)=>{this._listeners||(this._listeners=new S.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(v?[h,v]:h);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,h,v);const n=this._leakageMon?.check(this._listeners.size),l=(0,C.toDisposable)(()=>{n&&n(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof C.DisposableStore?t.add(l):Array.isArray(t)&&t.push(l),l}),this._event}fire(h){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S.LinkedList);for(let v of this._listeners)this._deliveryQueue.push([v,h]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[v,t]=this._deliveryQueue.shift();try{typeof v=="function"?v.call(void 0,t):v[0].call(v[1],t)}catch(s){(0,p.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=c;class u extends c{async fireAsync(h,v,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new S.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,h]);for(;this._asyncDeliveryQueue.size>0&&!v.isCancellationRequested;){const[s,r]=this._asyncDeliveryQueue.shift(),n=[],l={...r,waitUntil:f=>{if(Object.isFrozen(n))throw new Error("waitUntil can NOT be called asynchronous");t&&(f=t(f,typeof s=="function"?s:s[0])),n.push(f)}};try{typeof s=="function"?s.call(void 0,l):s[0].call(s[1],l)}catch(f){(0,p.onUnexpectedError)(f);continue}Object.freeze(n),await Promise.allSettled(n).then(f=>{for(const m of f)m.status==="rejected"&&(0,p.onUnexpectedError)(m.reason)})}}}}e.AsyncEmitter=u;class a extends c{constructor(h){super(h);this._isPaused=0,this._eventQueue=new S.LinkedList,this._mergeFn=h?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const h=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(h))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(h){this._listeners&&(this._isPaused!==0?this._eventQueue.push(h):super.fire(h))}}e.PauseableEmitter=a;class g extends a{constructor(h){super(h);this._delay=h.delay??100}fire(h){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(h)}}e.DebounceEmitter=g;class w{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(h){const v={event:h,listener:null};this.events.push(v),this.hasListeners&&this.hook(v);const t=()=>{this.hasListeners&&this.unhook(v);const s=this.events.indexOf(v);this.events.splice(s,1)};return(0,C.toDisposable)((0,L.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(h=>this.hook(h))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(h=>this.unhook(h))}hook(h){h.listener=h.event(v=>this.emitter.fire(v))}unhook(h){h.listener&&h.listener.dispose(),h.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=w;class _{constructor(){this.buffers=[]}wrapEvent(h){return(v,t,s)=>h(r=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>v.call(t,r)):v.call(t,r)},void 0,s)}bufferEvents(h){const v=[];this.buffers.push(v);const t=h();return this.buffers.pop(),v.forEach(s=>s()),t}}e.EventBufferer=_;class b{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=C.Disposable.None,this.emitter=new c({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(h){this.inputEvent=h,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=h(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=b}),define(me[21],ge([0,1,3]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(I,D){const A=setTimeout(I.bind(D),0);return{dispose(){clearTimeout(A)}}});var C;(function(I){function D(A){return A===I.None||A===I.Cancelled||A instanceof S?!0:!A||typeof A!="object"?!1:typeof A.isCancellationRequested=="boolean"&&typeof A.onCancellationRequested=="function"}I.isCancellationToken=D,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(C=e.CancellationToken||(e.CancellationToken={}));class S{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new S),this._token}cancel(){this._token?this._token instanceof S&&this._token.cancel():this._token=C.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof S&&this._token.dispose():this._token=C.None}}e.CancellationTokenSource=T}),define(me[74],ge([0,1,3]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new p.Emitter}add(P){const c=this._icons.get(P.id);c?P.description?c.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const C=new L;e.iconRegistry=C;function S(i,P){return new I(i,P)}e.registerCodicon=S;function T(i){return i?i.replace(/\$\((.*?)\)/g,(P,c)=>` ${c} `).trim():""}e.getCodiconAriaLabel=T;class I{constructor(P,c,u){this.id=P,this.definition=c,this.description=u,C.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=I;function D(i,P){const c=["codicon","codicon-"+i];return P&&c.push("codicon-modifier-"+P),c}e.getClassNamesArray=D;var A;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const P=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function c(g){if(g instanceof I)return["codicon","codicon-"+g.id];const w=P.exec(g.id);if(!w)return c(I.error);let[,_,b]=w;const d=["codicon","codicon-"+_];return b&&d.push("codicon-modifier-"+b.substr(1)),d}i.asClassNameArray=c;function u(g){return c(g).join(" ")}i.asClassName=u;function a(g){return"."+c(g).join(".")}i.asCSSSelector=a})(A=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(I=e.Codicon||(e.Codicon={}))}),define(me[93],ge([0,1,15,6]),function(J,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function C(d){const h=d;return h?[h.on,h.pause,h.resume,h.destroy].every(v=>typeof v=="function"):!1}e.isReadableStream=C;function S(d){const h=d;return h?C(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=S;function T(d,h){return new I(d,h)}e.newWriteableStream=T;class I{constructor(h,v){this.reducer=h,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(v=>this.pendingWritePromises.push(v))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h!="undefined"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(v=>v(h))}emitError(h){this.listeners.error.length===0?(0,p.onUnexpectedError)(h):this.listeners.error.slice(0).forEach(v=>v(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,v){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(h,v){if(this.state.destroyed)return;let t;switch(h){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const s=t.indexOf(v);s>=0&&t.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(d,h){const v=[];let t;for(;(t=d.read())!==null;)v.push(t);return h(v)}e.consumeReadable=D;function A(d,h,v){const t=[];let s;for(;(s=d.read())!==null&&t.length<v;)t.push(s);return s===null&&t.length>0?h(t):{read:()=>{if(t.length>0)return t.shift();if(typeof s!="undefined"){const r=s;return s=void 0,r}return d.read()}}}e.peekReadable=A;function i(d,h){return new Promise((v,t)=>{const s=[];P(d,{onData:r=>{h&&s.push(r)},onError:r=>{h?t(r):v(void 0)},onEnd:()=>{v(h?h(s):void 0)}})})}e.consumeStream=i;function P(d,h){d.on("error",v=>h.onError(v)),d.on("end",()=>h.onEnd()),d.on("data",v=>h.onData(v))}e.listenStream=P;function c(d,h){return new Promise((v,t)=>{const s=new L.DisposableStore,r=[],n=m=>{if(r.push(m),r.length>h)return s.dispose(),d.pause(),v({stream:d,buffer:r,ended:!1})},l=m=>t(m),f=()=>v({stream:d,buffer:r,ended:!0});s.add((0,L.toDisposable)(()=>d.removeListener("error",l))),d.on("error",l),s.add((0,L.toDisposable)(()=>d.removeListener("end",f))),d.on("end",f),s.add((0,L.toDisposable)(()=>d.removeListener("data",n))),d.on("data",n)})}e.peekStream=c;function u(d,h){const v=T(h);return v.end(d),v}e.toStream=u;function a(){const d=T(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=a;function g(d){let h=!1;return{read:()=>h?null:(h=!0,d)}}e.toReadable=g;function w(d,h,v){const t=T(v);return P(d,{onData:s=>t.write(h.data(s)),onError:s=>t.error(h.error?h.error(s):s),onEnd:()=>t.end()}),t}e.transform=w;function _(d,h,v){let t=!1;return{read:()=>{const s=h.read();return t?s:(t=!0,s!==null?v([d,s]):d)}}}e.prefixedReadable=_;function b(d,h,v){let t=!1;const s=T(v);return P(h,{onData:r=>t?s.write(r):(t=!0,s.write(v([d,r]))),onError:r=>s.error(r),onEnd:()=>{t||(t=!0,s.write(d)),s.end()}}),s}e.prefixedStream=b}),define(me[8],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function p(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=p;const L=/{(\d+)}/g;function C(G,...ve){return ve.length===0?G:G.replace(L,function(ye,Ae){const Ne=parseInt(Ae,10);return isNaN(Ne)||Ne<0||Ne>=ve.length?ye:ve[Ne]})}e.format=C;const S=/{([^}]+)}/g;function T(G,ve){return G.replace(S,(ye,Ae)=>ve[Ae]??ye)}e.format2=T;function I(G){return G.replace(/[<>&]/g,function(ve){switch(ve){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ve}})}e.escape=I;function D(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=D;function A(G,ve){let ye=0;const Ae=ve.charCodeAt(0);for(let Ne=G.length-1;Ne>=0;Ne--)G.charCodeAt(Ne)===Ae&&ye++;return ye}e.count=A;function i(G,ve,ye="\u2026"){return G.length<=ve?G:`${G.substr(0,ve)}${ye}`}e.truncate=i;function P(G,ve=" "){const ye=c(G,ve);return u(ye,ve)}e.trim=P;function c(G,ve){if(!G||!ve)return G;const ye=ve.length;if(ye===0||G.length===0)return G;let Ae=0;for(;G.indexOf(ve,Ae)===Ae;)Ae=Ae+ye;return G.substring(Ae)}e.ltrim=c;function u(G,ve){if(!G||!ve)return G;const ye=ve.length,Ae=G.length;if(ye===0||Ae===0)return G;let Ne=Ae,Ge=-1;for(;Ge=G.lastIndexOf(ve,Ne-1),!(Ge===-1||Ge+ye!==Ne);){if(Ge===0)return"";Ne=Ge}return G.substring(0,Ne)}e.rtrim=u;function a(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=a;function g(G){return G.replace(/\*/g,"")}e.stripWildcards=g;function w(G,ve,ye={}){if(!G)throw new Error("Cannot create regex from empty string");ve||(G=D(G)),ye.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let Ae="";return ye.global&&(Ae+="g"),ye.matchCase||(Ae+="i"),ye.multiline&&(Ae+="m"),ye.unicode&&(Ae+="u"),new RegExp(G,Ae)}e.createRegExp=w;function _(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=_;function b(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function d(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=d;function h(G){return G.split(/\r\n|\r|\n/)}e.splitLines=h;function v(G){for(let ve=0,ye=G.length;ve<ye;ve++){const Ae=G.charCodeAt(ve);if(Ae!==32&&Ae!==9)return ve}return-1}e.firstNonWhitespaceIndex=v;function t(G,ve=0,ye=G.length){for(let Ae=ve;Ae<ye;Ae++){const Ne=G.charCodeAt(Ae);if(Ne!==32&&Ne!==9)return G.substring(ve,Ae)}return G.substring(ve,ye)}e.getLeadingWhitespace=t;function s(G,ve=G.length-1){for(let ye=ve;ye>=0;ye--){const Ae=G.charCodeAt(ye);if(Ae!==32&&Ae!==9)return ye}return-1}e.lastNonWhitespaceIndex=s;function r(G,ve){return G<ve?-1:G>ve?1:0}e.compare=r;function n(G,ve,ye=0,Ae=G.length,Ne=0,Ge=ve.length){for(;ye<Ae&&Ne<Ge;ye++,Ne++){let Xe=G.charCodeAt(ye),lt=ve.charCodeAt(Ne);if(Xe<lt)return-1;if(Xe>lt)return 1}const et=Ae-ye,Qe=Ge-Ne;return et<Qe?-1:et>Qe?1:0}e.compareSubstring=n;function l(G,ve){return f(G,ve,0,G.length,0,ve.length)}e.compareIgnoreCase=l;function f(G,ve,ye=0,Ae=G.length,Ne=0,Ge=ve.length){for(;ye<Ae&&Ne<Ge;ye++,Ne++){let Xe=G.charCodeAt(ye),lt=ve.charCodeAt(Ne);if(Xe===lt)continue;const dt=Xe-lt;if(!(dt===32&&E(lt))&&!(dt===-32&&E(Xe)))return m(Xe)&&m(lt)?dt:n(G.toLowerCase(),ve.toLowerCase(),ye,Ae,Ne,Ge)}const et=Ae-ye,Qe=Ge-Ne;return et<Qe?-1:et>Qe?1:0}e.compareSubstringIgnoreCase=f;function m(G){return G>=97&&G<=122}e.isLowerAsciiLetter=m;function E(G){return G>=65&&G<=90}e.isUpperAsciiLetter=E;function y(G){return m(G)||E(G)}function o(G,ve){return G.length===ve.length&&k(G,ve)}e.equalsIgnoreCase=o;function k(G,ve,ye=G.length){for(let Ae=0;Ae<ye;Ae++){const Ne=G.charCodeAt(Ae),Ge=ve.charCodeAt(Ae);if(Ne!==Ge){if(y(Ne)&&y(Ge)){const et=Math.abs(Ne-Ge);if(et!==0&&et!==32)return!1}else if(String.fromCharCode(Ne).toLowerCase()!==String.fromCharCode(Ge).toLowerCase())return!1}}return!0}function F(G,ve){const ye=ve.length;return ve.length>G.length?!1:k(G,ve,ye)}e.startsWithIgnoreCase=F;function $(G,ve){let ye,Ae=Math.min(G.length,ve.length);for(ye=0;ye<Ae;ye++)if(G.charCodeAt(ye)!==ve.charCodeAt(ye))return ye;return Ae}e.commonPrefixLength=$;function Q(G,ve){let ye,Ae=Math.min(G.length,ve.length);const Ne=G.length-1,Ge=ve.length-1;for(ye=0;ye<Ae;ye++)if(G.charCodeAt(Ne-ye)!==ve.charCodeAt(Ge-ye))return ye;return Ae}e.commonSuffixLength=Q;function oe(G){return 55296<=G&&G<=56319}e.isHighSurrogate=oe;function j(G){return 56320<=G&&G<=57343}e.isLowSurrogate=j;function O(G,ve){return(G-55296<<10)+(ve-56320)+65536}e.computeCodePoint=O;function B(G,ve,ye){const Ae=G.charCodeAt(ye);if(oe(Ae)&&ye+1<ve){const Ne=G.charCodeAt(ye+1);if(j(Ne))return O(Ae,Ne)}return Ae}e.getNextCodePoint=B;function R(G,ve){const ye=G.charCodeAt(ve-1);if(j(ye)&&ve>1){const Ae=G.charCodeAt(ve-2);if(oe(Ae))return O(Ae,ye)}return ye}function z(G,ve){const ye=Ce.getInstance(),Ae=ve,Ne=G.length,Ge=B(G,Ne,ve);ve+=Ge>=65536?2:1;let et=ye.getGraphemeBreakType(Ge);for(;ve<Ne;){const Qe=B(G,Ne,ve),Xe=ye.getGraphemeBreakType(Qe);if(xe(et,Xe))break;ve+=Qe>=65536?2:1,et=Xe}return ve-Ae}e.nextCharLength=z;function N(G,ve){const ye=Ce.getInstance(),Ae=ve,Ne=R(G,ve);ve-=Ne>=65536?2:1;let Ge=ye.getGraphemeBreakType(Ne);for(;ve>0;){const et=R(G,ve),Qe=ye.getGraphemeBreakType(et);if(xe(Qe,Ge))break;ve-=et>=65536?2:1,Ge=Qe}return Ae-ve}e.prevCharLength=N;function M(G,ve){const ye=Ce.getInstance(),Ae=G.length,Ne=ve,Ge=B(G,Ae,ve),et=ye.getGraphemeBreakType(Ge);ve+=Ge>=65536?2:1;let Qe=et;for(;ve<Ae;){const lt=B(G,Ae,ve),dt=ye.getGraphemeBreakType(lt);if(xe(Qe,dt))break;ve+=lt>=65536?2:1,Qe=dt}const Xe=ve;for(ve=Ne,Qe=et;ve>0;){const lt=R(G,ve),dt=ye.getGraphemeBreakType(lt);if(xe(dt,Qe))break;ve-=lt>=65536?2:1,Qe=dt}return[ve,Xe]}function q(G,ve){return ve>0&&j(G.charCodeAt(ve))?M(G,ve-1):M(G,ve)}e.getCharContainingOffset=q;function x(G){const ve=G.length;let ye=0,Ae=0;for(;Ae<ve;){const et=B(G,ve,Ae);Ae+=et>=65536?2:1,et<128?ye+=1:et<2048?ye+=2:et<65536?ye+=3:ye+=4}const Ne=new Uint8Array(ye);Ae=0;let Ge=0;for(;Ae<ve;){const et=B(G,ve,Ae);Ae+=et>=65536?2:1,et<128?Ne[Ge++]=et:et<2048?(Ne[Ge++]=192|(et&1984)>>>6,Ne[Ge++]=128|(et&63)>>>0):et<65536?(Ne[Ge++]=224|(et&61440)>>>12,Ne[Ge++]=128|(et&4032)>>>6,Ne[Ge++]=128|(et&63)>>>0):(Ne[Ge++]=240|(et&1835008)>>>18,Ne[Ge++]=128|(et&258048)>>>12,Ne[Ge++]=128|(et&4032)>>>6,Ne[Ge++]=128|(et&63)>>>0)}return Ne}e.encodeUTF8=x;function K(G){const ve=G.byteLength,ye=[];let Ae=0;for(;Ae<ve;){const Ne=G[Ae];let Ge;if(Ne>=240&&Ae+3<ve?Ge=(G[Ae++]&7)<<18>>>0|(G[Ae++]&63)<<12>>>0|(G[Ae++]&63)<<6>>>0|(G[Ae++]&63)<<0>>>0:Ne>=224&&Ae+2<ve?Ge=(G[Ae++]&15)<<12>>>0|(G[Ae++]&63)<<6>>>0|(G[Ae++]&63)<<0>>>0:Ne>=192&&Ae+1<ve?Ge=(G[Ae++]&31)<<6>>>0|(G[Ae++]&63)<<0>>>0:Ge=G[Ae++],Ge>=0&&Ge<=55295||Ge>=57344&&Ge<=65535)ye.push(String.fromCharCode(Ge));else if(Ge>=65536&&Ge<=1114111){const et=Ge-65536,Qe=55296+((et&1047552)>>>10),Xe=56320+((et&1023)>>>0);ye.push(String.fromCharCode(Qe)),ye.push(String.fromCharCode(Xe))}else ye.push(String.fromCharCode(65533))}return ye.join("")}e.decodeUTF8=K;const ee=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function de(G){return ee.test(G)}e.containsRTL=de;const Se=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function De(G){return Se.test(G)}e.containsEmoji=De;const Le=/^[\t\n\r\x20-\x7E]*$/;function qe(G){return Le.test(G)}e.isBasicASCII=qe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function We(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=We;function je(G){for(let ve=0,ye=G.length;ve<ye;ve++)if(W(G.charCodeAt(ve)))return!0;return!1}e.containsFullWidthCharacter=je;function W(G){return G=+G,G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=W;function Z(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129003||G>=129280&&G<=129535||G>=129648&&G<=129750}e.isEmojiImprecise=Z;function te(G,ve){if(G.length<ve)return G;const ye=/\b/g;let Ae=0;for(;ye.test(G)&&!(G.length-ye.lastIndex<ve);)Ae=ye.lastIndex,ye.lastIndex+=1;return G.substring(Ae).replace(/^\s/,"")}e.lcut=te;const ae=/\x1B\x5B[12]?K/g,Y=/\x1b\[\d+m/g,se=/\x1b\[0?m/g;function we(G){return G&&(G=G.replace(ae,""),G=G.replace(Y,""),G=G.replace(se,"")),G}e.removeAnsiEscapeCodes=we,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Fe(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Fe;function ze(G){return Fe(G)?G.substr(1):G}e.stripUTF8BOM=ze;function _e(G,ve){if(!G||!ve||G.length<ve.length)return!1;const ye=ve.length,Ae=G.toLowerCase();let Ne=0,Ge=-1;for(;Ne<ye;){const et=Ae.indexOf(ve[Ne],Ge+1);if(et<0)return!1;Ge=et,Ne++}return!0}e.fuzzyContains=_e;function Ze(G,ve=!1){return G?(ve&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=Ze;function X(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=X;function ie(G,ve=1){if(ve===0)return"";let ye=-1;do ye=G.indexOf(`
`,ye+1),ve--;while(ve>0&&ye>=0);return ye===-1?G:(G[ye-1]==="\r"&&ye--,G.substr(0,ye))}e.getNLines=ie;function fe(G){const ve=90-65+1;return G=G%(2*ve),G<ve?String.fromCharCode(97+G):String.fromCharCode(65+G-ve)}e.singleLetterHash=fe;function $e(G){return Ce.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=$e;function xe(G,ve){return G===0?ve!==5&&ve!==7:G===2&&ve===3?!1:G===4||G===2||G===3||ve===4||ve===2||ve===3?!0:!(G===8&&(ve===8||ve===9||ve===11||ve===12)||(G===11||G===9)&&(ve===9||ve===10)||(G===12||G===10)&&ve===10||ve===5||ve===13||ve===7||G===1||G===13&&ve===14||G===6&&ve===6)}e.breakBetweenGraphemeBreakType=xe;var tt;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(tt=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ce{constructor(){this._data=ke()}static getInstance(){return Ce._INSTANCE||(Ce._INSTANCE=new Ce),Ce._INSTANCE}getGraphemeBreakType(ve){if(ve<32)return ve===10?3:ve===13?2:4;if(ve<127)return 0;const ye=this._data,Ae=ye.length/3;let Ne=1;for(;Ne<=Ae;)if(ve<ye[3*Ne])Ne=2*Ne;else if(ve>ye[3*Ne+1])Ne=2*Ne+1;else return ye[3*Ne+2];return 0}}Ce._INSTANCE=null;function ke(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Te(G,ve){if(G===0)return 0;const ye=le(G,ve);if(ye!==void 0)return ye;const Ae=R(ve,G);return G-=ce(Ae),G}e.getLeftDeleteOffset=Te;function le(G,ve){let ye=R(ve,G);for(G-=ce(ye);pe(ye)||ye===65039||ye===8419;){if(G===0)return;ye=R(ve,G),G-=ce(ye)}if(!!Z(ye)){if(G>=0){const Ae=R(ve,G);Ae===8205&&(G-=ce(Ae))}return G}}function ce(G){return G>=65536?2:1}function pe(G){return 127995<=G&&G<=127999}var Ee;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(Ee||(Ee={}))}),define(me[22],ge([0,1,8,93]),function(J,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer!="undefined",S=typeof TextEncoder!="undefined",T=typeof TextDecoder!="undefined";let I,D;class A{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return C?new A(Buffer.allocUnsafe(m)):new A(new Uint8Array(m))}static wrap(m){return C&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new A(m)}static fromString(m,E){return!(E?.dontUseNodeBuffer||!1)&&C?new A(Buffer.from(m)):S?(I||(I=new TextEncoder),new A(I.encode(m))):new A(p.encodeUTF8(m))}static concat(m,E){if(typeof E=="undefined"){E=0;for(let k=0,F=m.length;k<F;k++)E+=m[k].byteLength}const y=A.alloc(E);let o=0;for(let k=0,F=m.length;k<F;k++){const $=m[k];y.set($,o),o+=$.byteLength}return y}toString(){return C?this.buffer.toString():T?(D||(D=new TextDecoder),D.decode(this.buffer)):p.decodeUTF8(this.buffer)}slice(m,E){return new A(this.buffer.subarray(m,E))}set(m,E){m instanceof A?this.buffer.set(m.buffer,E):this.buffer.set(m,E)}readUInt32BE(m){return c(this.buffer,m)}writeUInt32BE(m,E){u(this.buffer,m,E)}readUInt32LE(m){return a(this.buffer,m)}writeUInt32LE(m,E){g(this.buffer,m,E)}readUInt8(m){return w(this.buffer,m)}writeUInt8(m,E){_(this.buffer,m,E)}}e.VSBuffer=A;function i(f,m){return f[m+0]<<0>>>0|f[m+1]<<8>>>0}e.readUInt16LE=i;function P(f,m,E){f[E+0]=m&255,m=m>>>8,f[E+1]=m&255}e.writeUInt16LE=P;function c(f,m){return f[m]*2**24+f[m+1]*2**16+f[m+2]*2**8+f[m+3]}e.readUInt32BE=c;function u(f,m,E){f[E+3]=m,m=m>>>8,f[E+2]=m,m=m>>>8,f[E+1]=m,m=m>>>8,f[E]=m}e.writeUInt32BE=u;function a(f,m){return f[m+0]<<0>>>0|f[m+1]<<8>>>0|f[m+2]<<16>>>0|f[m+3]<<24>>>0}e.readUInt32LE=a;function g(f,m,E){f[E+0]=m&255,m=m>>>8,f[E+1]=m&255,m=m>>>8,f[E+2]=m&255,m=m>>>8,f[E+3]=m&255}e.writeUInt32LE=g;function w(f,m){return f[m]}e.readUInt8=w;function _(f,m,E){f[E]=m}e.writeUInt8=_;function b(f){return L.consumeReadable(f,m=>A.concat(m))}e.readableToBuffer=b;function d(f){return L.toReadable(f)}e.bufferToReadable=d;function h(f){return L.consumeStream(f,m=>A.concat(m))}e.streamToBuffer=h;async function v(f){return f.ended?A.concat(f.buffer):A.concat([...f.buffer,await h(f.stream)])}e.bufferedStreamToBuffer=v;function t(f){return L.toStream(f,m=>A.concat(m))}e.bufferToStream=t;function s(f){return L.transform(f,{data:m=>typeof m=="string"?A.fromString(m):A.wrap(m)},m=>A.concat(m))}e.streamToBufferReadableStream=s;function r(f){return L.newWriteableStream(m=>A.concat(m),f)}e.newWriteableBufferStream=r;function n(f,m){return L.prefixedReadable(f,m,E=>A.concat(E))}e.prefixedBufferReadable=n;function l(f,m){return L.prefixedStream(f,m,E=>A.concat(E))}e.prefixedBufferStream=l}),define(me[55],ge([0,1,8]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(_){return C(_,0)}e.hash=L;function C(_,b){switch(typeof _){case"object":return _===null?S(349,b):Array.isArray(_)?D(_,b):A(_,b);case"string":return I(_,b);case"boolean":return T(_,b);case"number":return S(_,b);case"undefined":return S(937,b);default:return S(617,b)}}e.doHash=C;function S(_,b){return(b<<5)-b+_|0}function T(_,b){return S(_?433:863,b)}function I(_,b){b=S(149417,b);for(let d=0,h=_.length;d<h;d++)b=S(_.charCodeAt(d),b);return b}e.stringHash=I;function D(_,b){return b=S(104579,b),_.reduce((d,h)=>C(h,d),b)}function A(_,b){return b=S(181387,b),Object.keys(_).sort().reduce((d,h)=>(d=I(h,d),C(_[h],d)),b)}class i{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=C(b,this._value),this._value}}e.Hasher=i;var P;(function(_){_[_.BLOCK_SIZE=64]="BLOCK_SIZE",_[_.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function c(_,b,d=32){const h=d-b,v=~((1<<h)-1);return(_<<b|(v&_)>>>h)>>>0}function u(_,b=0,d=_.byteLength,h=0){for(let v=0;v<d;v++)_[b+v]=h}function a(_,b,d="0"){for(;_.length<b;)_=d+_;return _}function g(_,b=32){return _ instanceof ArrayBuffer?Array.from(new Uint8Array(_)).map(d=>d.toString(16).padStart(2,"0")).join(""):a((_>>>0).toString(16),b/4)}e.toHexString=g;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const d=b.length;if(d===0)return;const h=this._buff;let v=this._buffLen,t=this._leftoverHighSurrogate,s,r;for(t!==0?(s=t,r=-1,t=0):(s=b.charCodeAt(0),r=0);;){let n=s;if(p.isHighSurrogate(s))if(r+1<d){const l=b.charCodeAt(r+1);p.isLowSurrogate(l)?(r++,n=p.computeCodePoint(s,l)):n=65533}else{t=s;break}else p.isLowSurrogate(s)&&(n=65533);if(v=this._push(h,v,n),r++,r<d)s=b.charCodeAt(r);else break}this._buffLen=v,this._leftoverHighSurrogate=t}_push(b,d,h){return h<128?b[d++]=h:h<2048?(b[d++]=192|(h&1984)>>>6,b[d++]=128|(h&63)>>>0):h<65536?(b[d++]=224|(h&61440)>>>12,b[d++]=128|(h&4032)>>>6,b[d++]=128|(h&63)>>>0):(b[d++]=240|(h&1835008)>>>18,b[d++]=128|(h&258048)>>>12,b[d++]=128|(h&4032)>>>6,b[d++]=128|(h&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,u(this._buff,this._buffLen),this._buffLen>56&&(this._step(),u(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=w._bigBlock32,d=this._buffDV;for(let m=0;m<64;m+=4)b.setUint32(m,d.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)b.setUint32(m,c(b.getUint32(m-12,!1)^b.getUint32(m-32,!1)^b.getUint32(m-56,!1)^b.getUint32(m-64,!1),1),!1);let h=this._h0,v=this._h1,t=this._h2,s=this._h3,r=this._h4,n,l,f;for(let m=0;m<80;m++)m<20?(n=v&t|~v&s,l=1518500249):m<40?(n=v^t^s,l=1859775393):m<60?(n=v&t|v&s|t&s,l=2400959708):(n=v^t^s,l=3395469782),f=c(h,5)+n+r+l+b.getUint32(m*4,!1)&4294967295,r=s,s=t,t=c(v,30),v=h,h=f;this._h0=this._h0+h&4294967295,this._h1=this._h1+v&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[56],ge([0,1,8]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(L||(L={})),function(C){const S="error",T="warning",I="warn",D="info",A="ignore";function i(c){return c?p.equalsIgnoreCase(S,c)?C.Error:p.equalsIgnoreCase(T,c)||p.equalsIgnoreCase(I,c)?C.Warning:p.equalsIgnoreCase(D,c)?C.Info:C.Ignore:C.Ignore}C.fromValue=i;function P(c){switch(c){case C.Error:return S;case C.Warning:return T;case C.Info:return D;default:return A}}C.toString=P}(L||(L={})),e.default=L}),define(me[14],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(m){return Array.isArray(m)}e.isArray=p;function L(m){return typeof m=="string"}e.isString=L;function C(m){return Array.isArray(m)&&m.every(E=>L(E))}e.isStringArray=C;function S(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}e.isObject=S;function T(m){return typeof m=="number"&&!isNaN(m)}e.isNumber=T;function I(m){return!!m&&typeof m[Symbol.iterator]=="function"}e.isIterable=I;function D(m){return m===!0||m===!1}e.isBoolean=D;function A(m){return typeof m=="undefined"}e.isUndefined=A;function i(m){return!P(m)}e.isDefined=i;function P(m){return A(m)||m===null}e.isUndefinedOrNull=P;function c(m,E){if(!m)throw new Error(E?`Unexpected type, expected '${E}'`:"Unexpected type")}e.assertType=c;function u(m){if(P(m))throw new Error("Assertion Failed: argument is undefined or null");return m}e.assertIsDefined=u;function a(...m){const E=[];for(let y=0;y<m.length;y++){const o=m[y];if(P(o))throw new Error(`Assertion Failed: argument at index ${y} is undefined or null`);E.push(o)}return E}e.assertAllDefined=a;const g=Object.prototype.hasOwnProperty;function w(m){if(!S(m))return!1;for(let E in m)if(g.call(m,E))return!1;return!0}e.isEmptyObject=w;function _(m){return typeof m=="function"}e.isFunction=_;function b(...m){return m.length>0&&m.every(_)}e.areFunctions=b;function d(m,E){const y=Math.min(m.length,E.length);for(let o=0;o<y;o++)h(m[o],E[o])}e.validateConstraints=d;function h(m,E){if(L(E)){if(typeof m!==E)throw new Error(`argument does not match constraint: typeof ${E}`)}else if(_(E)){try{if(m instanceof E)return}catch{}if(!P(m)&&m.constructor===E||E.length===1&&E.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function v(m){let E=[],y=Object.getPrototypeOf(m);for(;Object.prototype!==y;)E=E.concat(Object.getOwnPropertyNames(y)),y=Object.getPrototypeOf(y);return E}e.getAllPropertyNames=v;function t(m){const E=[];for(const y of v(m))typeof m[y]=="function"&&E.push(y);return E}e.getAllMethodNames=t;function s(m,E){const y=k=>function(){const F=Array.prototype.slice.call(arguments,0);return E(k,F)};let o={};for(const k of m)o[k]=y(k);return o}e.createProxyObject=s;function r(m){return m===null?void 0:m}e.withNullAsUndefined=r;function n(m){return typeof m=="undefined"?null:m}e.withUndefinedAsNull=n;function l(m){return class{constructor(){return new Proxy({},{get(E,y){if(E[y])return E[y];throw new Error(`Not Implemented: ${m}->${String(y)}`)}})}}}e.NotImplementedProxy=l;function f(m,E="Unreachable"){throw new Error(E)}e.assertNever=f}),define(me[29],ge([0,1,11,8,9,14]),function(J,e,p,L,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(r){return r===47||r===92}e.isPathSeparator=T;function I(r){return r.replace(/[\\/]/g,C.posix.sep)}e.toSlashes=I;function D(r){return r.indexOf("/")===-1&&(r=I(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=D;function A(r,n=C.posix.sep){if(!r)return"";const l=r.length,f=r.charCodeAt(0);if(T(f)){if(T(r.charCodeAt(1))&&!T(r.charCodeAt(2))){let E=3;const y=E;for(;E<l&&!T(r.charCodeAt(E));E++);if(y!==E&&!T(r.charCodeAt(E+1))){for(E+=1;E<l;E++)if(T(r.charCodeAt(E)))return r.slice(0,E+1).replace(/[\\/]/g,n)}}return n}else if(_(f)&&r.charCodeAt(1)===58)return T(r.charCodeAt(2))?r.slice(0,2)+n:r.slice(0,2);let m=r.indexOf("://");if(m!==-1){for(m+=3;m<l;m++)if(T(r.charCodeAt(m)))return r.slice(0,m+1)}return""}e.getRoot=A;function i(r){if(!p.isWindows||!r||r.length<5)return!1;let n=r.charCodeAt(0);if(n!==92||(n=r.charCodeAt(1),n!==92))return!1;let l=2;const f=l;for(;l<r.length&&(n=r.charCodeAt(l),n!==92);l++);return!(f===l||(n=r.charCodeAt(l+1),isNaN(n)||n===92))}e.isUNC=i;const P=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(r,n=p.isWindows){const l=n?P:c;return!(!r||r.length===0||/^\s+$/.test(r)||(l.lastIndex=0,l.test(r))||n&&u.test(r)||r==="."||r===".."||n&&r[r.length-1]==="."||n&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=a;function g(r,n,l){const f=r===n;return!l||f?f:!r||!n?!1:(0,L.equalsIgnoreCase)(r,n)}e.isEqual=g;function w(r,n,l,f=C.sep){if(r===n)return!0;if(!r||!n||n.length>r.length)return!1;if(l){if(!(0,L.startsWithIgnoreCase)(r,n))return!1;if(n.length===r.length)return!0;let E=n.length;return n.charAt(n.length-1)===f&&E--,r.charAt(E)===f}return n.charAt(n.length-1)!==f&&(n+=f),r.indexOf(n)===0}e.isEqualOrParent=w;function _(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=_;function b(r,n){return p.isWindows&&r.endsWith(":")&&(r+=C.sep),(0,C.isAbsolute)(r)||(r=(0,C.join)(n,r)),r=(0,C.normalize)(r),p.isWindows?(r=(0,L.rtrim)(r,C.sep),r.endsWith(":")&&(r+=C.sep)):(r=(0,L.rtrim)(r,C.sep),r||(r=C.sep)),r}e.sanitizeFilePath=b;function d(r){const n=(0,C.normalize)(r);return p.isWindows?r.length>3?!1:h(n)&&(r.length===2||n.charCodeAt(2)===92):n===C.posix.sep}e.isRootOrDriveLetter=d;function h(r){return p.isWindows?_(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function v(r){return h(r)?r[0]:void 0}e.getDriveLetter=v;function t(r,n,l){return n.length>r.length?-1:r===n?0:(l&&(r=r.toLowerCase(),n=n.toLowerCase()),r.indexOf(n))}e.indexOfPath=t;function s(r){const n=r.split(":");let l,f,m;if(n.forEach(E=>{const y=Number(E);(0,S.isNumber)(y)?f===void 0?f=y:m===void 0&&(m=y):l=l?[l,E].join(":"):E}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:f!==void 0?f:void 0,column:m!==void 0?m:f!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(me[25],ge([0,1,14]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const w=Array.isArray(g)?[]:{};return Object.keys(g).forEach(_=>{g[_]&&typeof g[_]=="object"?w[_]=L(g[_]):w[_]=g[_]}),w}e.deepClone=L;function C(g){if(!g||typeof g!="object")return g;const w=[g];for(;w.length>0;){const _=w.shift();Object.freeze(_);for(const b in _)if(S.call(_,b)){const d=_[b];typeof d=="object"&&!Object.isFrozen(d)&&w.push(d)}}return g}e.deepFreeze=C;const S=Object.prototype.hasOwnProperty;function T(g,w){return I(g,w,new Set)}e.cloneAndChange=T;function I(g,w,_){if((0,p.isUndefinedOrNull)(g))return g;const b=w(g);if(typeof b!="undefined")return b;if((0,p.isArray)(g)){const d=[];for(const h of g)d.push(I(h,w,_));return d}if((0,p.isObject)(g)){if(_.has(g))throw new Error("Cannot clone recursive data-structure");_.add(g);const d={};for(let h in g)S.call(g,h)&&(d[h]=I(g[h],w,_));return _.delete(g),d}return g}function D(g,w,_=!0){return(0,p.isObject)(g)?((0,p.isObject)(w)&&Object.keys(w).forEach(b=>{b in g?_&&((0,p.isObject)(g[b])&&(0,p.isObject)(w[b])?D(g[b],w[b],_):g[b]=w[b]):g[b]=w[b]}),g):w}e.mixin=D;function A(g,w){if(g===w)return!0;if(g==null||w===null||w===void 0||typeof g!=typeof w||typeof g!="object"||Array.isArray(g)!==Array.isArray(w))return!1;let _,b;if(Array.isArray(g)){if(g.length!==w.length)return!1;for(_=0;_<g.length;_++)if(!A(g[_],w[_]))return!1}else{const d=[];for(b in g)d.push(b);d.sort();const h=[];for(b in w)h.push(b);if(h.sort(),!A(d,h))return!1;for(_=0;_<d.length;_++)if(!A(g[d[_]],w[d[_]]))return!1}return!0}e.equals=A;function i(g){const w=new Set;return JSON.stringify(g,(_,b)=>{if((0,p.isObject)(b)||Array.isArray(b)){if(w.has(b))return"[Circular]";w.add(b)}return b})}e.safeStringify=i;function P(g,w,_){const b=w(g);return typeof b=="undefined"?_:b}e.getOrDefault=P;function c(g,w){const _=Object.create(null);return!g||!w||Object.keys(w).forEach(d=>{const h=g[d],v=w[d];A(h,v)||(_[d]=v)}),_}e.distinct=c;function u(g,w){const _=w.toLowerCase(),b=Object.keys(g).find(d=>d.toLowerCase()===_);return b?g[b]:g[w]}e.getCaseInsensitive=u;function a(g,w){const _=Object.create(null);for(const b of Object.keys(g))w(b,g[b])&&(_[b]=g[b]);return _}e.filter=a}),define(me[94],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var p;(function(S){S[S.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",S[S.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",S[S.MAX_UINT_8=255]="MAX_UINT_8",S[S.MAX_UINT_16=65535]="MAX_UINT_16",S[S.MAX_UINT_32=4294967295]="MAX_UINT_32",S[S.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(p=e.Constants||(e.Constants={}));function L(S){return S<0?0:S>255?255:S|0}e.toUint8=L;function C(S){return S<0?0:S>4294967295?4294967295:S|0}e.toUint32=C}),define(me[2],ge([0,1,11,9]),function(J,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,S=/^\//,T=/^\/\//;function I(r,n){if(!r.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!C.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!S.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(r,n){return!r&&!n?"file":r}function A(r,n){switch(r){case"https":case"http":case"file":n?n[0]!==P&&(n=P+n):n=P;break}return n}const i="",P="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{constructor(n,l,f,m,E,y=!1){typeof n=="object"?(this.scheme=n.scheme||i,this.authority=n.authority||i,this.path=n.path||i,this.query=n.query||i,this.fragment=n.fragment||i):(this.scheme=D(n,y),this.authority=l||i,this.path=A(this.scheme,f||i),this.query=m||i,this.fragment=E||i,I(this,y))}static isUri(n){return n instanceof u?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return d(this,!1)}with(n){if(!n)return this;let{scheme:l,authority:f,path:m,query:E,fragment:y}=n;return l===void 0?l=this.scheme:l===null&&(l=i),f===void 0?f=this.authority:f===null&&(f=i),m===void 0?m=this.path:m===null&&(m=i),E===void 0?E=this.query:E===null&&(E=i),y===void 0?y=this.fragment:y===null&&(y=i),l===this.scheme&&f===this.authority&&m===this.path&&E===this.query&&y===this.fragment?this:new g(l,f,m,E,y)}static parse(n,l=!1){const f=c.exec(n);return f?new g(f[2]||i,s(f[4]||i),s(f[5]||i),s(f[7]||i),s(f[9]||i),l):new g(i,i,i,i,i)}static file(n){let l=i;if(p.isWindows&&(n=n.replace(/\\/g,P)),n[0]===P&&n[1]===P){const f=n.indexOf(P,2);f===-1?(l=n.substring(2),n=P):(l=n.substring(2,f),n=n.substring(f)||P)}return new g("file",l,n,i,i)}static from(n){const l=new g(n.scheme,n.authority,n.path,n.query,n.fragment);return I(l,!0),l}static joinPath(n,...l){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return p.isWindows&&n.scheme==="file"?f=u.file(L.win32.join(d(n,!0),...l)).path:f=L.posix.join(n.path,...l),n.with({path:f})}toString(n=!1){return h(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof u)return n;{const l=new g(n);return l._formatted=n.external,l._fsPath=n._sep===a?n.fsPath:null,l}}else return n}}e.URI=u;const a=p.isWindows?1:void 0;class g extends u{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(n=!1){return n?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=a),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function _(r,n){let l,f=-1;for(let m=0;m<r.length;m++){const E=r.charCodeAt(m);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||n&&E===47)f!==-1&&(l+=encodeURIComponent(r.substring(f,m)),f=-1),l!==void 0&&(l+=r.charAt(m));else{l===void 0&&(l=r.substr(0,m));const y=w[E];y!==void 0?(f!==-1&&(l+=encodeURIComponent(r.substring(f,m)),f=-1),l+=y):f===-1&&(f=m)}}return f!==-1&&(l+=encodeURIComponent(r.substring(f))),l!==void 0?l:r}function b(r){let n;for(let l=0;l<r.length;l++){const f=r.charCodeAt(l);f===35||f===63?(n===void 0&&(n=r.substr(0,l)),n+=w[f]):n!==void 0&&(n+=r[l])}return n!==void 0?n:r}function d(r,n){let l;return r.authority&&r.path.length>1&&r.scheme==="file"?l=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?n?l=r.path.substr(1):l=r.path[1].toLowerCase()+r.path.substr(2):l=r.path,p.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=d;function h(r,n){const l=n?b:_;let f="",{scheme:m,authority:E,path:y,query:o,fragment:k}=r;if(m&&(f+=m,f+=":"),(E||m==="file")&&(f+=P,f+=P),E){let F=E.indexOf("@");if(F!==-1){const $=E.substr(0,F);E=E.substr(F+1),F=$.indexOf(":"),F===-1?f+=l($,!1):(f+=l($.substr(0,F),!1),f+=":",f+=l($.substr(F+1),!1)),f+="@"}E=E.toLowerCase(),F=E.indexOf(":"),F===-1?f+=l(E,!1):(f+=l(E.substr(0,F),!1),f+=E.substr(F))}if(y){if(y.length>=3&&y.charCodeAt(0)===47&&y.charCodeAt(2)===58){const F=y.charCodeAt(1);F>=65&&F<=90&&(y=`/${String.fromCharCode(F+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===58){const F=y.charCodeAt(0);F>=65&&F<=90&&(y=`${String.fromCharCode(F+32)}:${y.substr(2)}`)}f+=l(y,!0)}return o&&(f+="?",f+=l(o,!1)),k&&(f+="#",f+=n?k:_(k,!1)),f}function v(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+v(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(t)?r.replace(t,n=>v(n)):r}});var nt=this&&this.__classPrivateFieldSet||function(J,e,p,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(J,p):C?C.value=p:e.set(J,p),p},Ue=this&&this.__classPrivateFieldGet||function(J,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(J):L?L.value:e.get(J)};define(me[23],ge([0,1,2,8]),function(J,e,p,L){"use strict";var C,S,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(t,s,r){let n=t.get(s);return n===void 0&&(n=r,t.set(s,n)),n}e.getOrSet=I;function D(t){const s=[];return t.forEach((r,n)=>{s.push(`${n} => ${r}`)}),`Map(${t.size}) {${s.join(", ")}}`}e.mapToString=D;function A(t){const s=[];return t.forEach(r=>{s.push(r)}),`Set(${t.size}) {${s.join(", ")}}`}e.setToString=A;class i{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const r=s.charCodeAt(0),n=this._value.charCodeAt(this._pos);return r-n}value(){return this._value[this._pos]}}e.StringIterator=i;class P{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,L.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class c{constructor(s=!0,r=!0){this._splitOnBackslash=s,this._caseSensitive=r}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,L.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=c;var u;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(u||(u={}));class a{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new c(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,L.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class g{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class w{constructor(s){this._iter=s}static forUris(s=()=>!1){return new w(new a(s))}static forPaths(){return new w(new c)}static forStrings(){return new w(new i)}static forConfigKeys(){return new w(new P)}clear(){this._root=void 0}set(s,r){const n=this._iter.reset(s);let l;for(this._root||(this._root=new g,this._root.segment=n.value()),l=this._root;;){const m=n.cmp(l.segment);if(m>0)l.left||(l.left=new g,l.left.segment=n.value()),l=l.left;else if(m<0)l.right||(l.right=new g,l.right.segment=n.value()),l=l.right;else if(n.hasNext())n.next(),l.mid||(l.mid=new g,l.mid.segment=n.value()),l=l.mid;else break}const f=l.value;return l.value=r,l.key=s,f}get(s){return this._getNode(s)?.value}_getNode(s){const r=this._iter.reset(s);let n=this._root;for(;n;){const l=r.cmp(n.segment);if(l>0)n=n.left;else if(l<0)n=n.right;else if(r.hasNext())r.next(),n=n.mid;else break}return n}has(s){const r=this._getNode(s);return!(r?.value===void 0&&r?.mid===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,r){const n=this._iter.reset(s),l=[];let f=this._root;for(;f;){const m=n.cmp(f.segment);if(m>0)l.push([1,f]),f=f.left;else if(m<0)l.push([-1,f]),f=f.right;else if(n.hasNext())n.next(),l.push([0,f]),f=f.mid;else{for(r?(f.left=void 0,f.mid=void 0,f.right=void 0):f.value=void 0;l.length>0&&f.isEmpty();){let[E,y]=l.pop();switch(E){case 1:y.left=void 0;break;case 0:y.mid=void 0;break;case-1:y.right=void 0;break}f=y}break}}}findSubstr(s){const r=this._iter.reset(s);let n=this._root,l;for(;n;){const f=r.cmp(n.segment);if(f>0)n=n.left;else if(f<0)n=n.right;else if(r.hasNext())r.next(),l=n.value||l,n=n.mid;else break}return n&&n.value||l}findSuperstr(s){const r=this._iter.reset(s);let n=this._root;for(;n;){const l=r.cmp(n.segment);if(l>0)n=n.left;else if(l<0)n=n.right;else if(r.hasNext())r.next(),n=n.mid;else return n.mid?this._entries(n.mid):void 0}}forEach(s){for(const[r,n]of this)s(n,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){if(!s)return;const r=[s];for(;r.length>0;){const n=r.pop();n&&(n.value&&(yield[n.key,n.value]),n.left&&r.push(n.left),n.mid&&r.push(n.mid),n.right&&r.push(n.right))}}}e.TernarySearchTree=w;class _{constructor(s,r){this[C]="ResourceMap",s instanceof _?(this.map=new Map(s.map),this.toKey=r??_.defaultToKey):(this.map=new Map,this.toKey=s??_.defaultToKey)}set(s,r){return this.map.set(this.toKey(s),r),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,r){typeof r!="undefined"&&(s=s.bind(r));for(let[n,l]of this.map)s(l,p.URI.parse(n),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield p.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[p.URI.parse(s[0]),s[1]]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[p.URI.parse(s[0]),s[1]]}}e.ResourceMap=_,_.defaultToKey=t=>t.toString();var b;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class d{constructor(){this[S]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,r=0){const n=this._map.get(s);if(!!n)return r!==0&&this.touch(n,r),n.value}set(s,r,n=0){let l=this._map.get(s);if(l)l.value=r,n!==0&&this.touch(l,n);else{switch(l={key:s,value:r,next:void 0,previous:void 0},n){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(s,l),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const r=this._map.get(s);if(!!r)return this._map.delete(s),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,r){const n=this._state;let l=this._head;for(;l;){if(r?s.bind(r)(l.value,l.key,this):s(l.value,l.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const s=this,r=this._state;let n=this._head;const l={[Symbol.iterator](){return l},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const f={value:n.key,done:!1};return n=n.next,f}else return{value:void 0,done:!0}}};return l}values(){const s=this,r=this._state;let n=this._head;const l={[Symbol.iterator](){return l},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const f={value:n.value,done:!1};return n=n.next,f}else return{value:void 0,done:!0}}};return l}entries(){const s=this,r=this._state;let n=this._head;const l={[Symbol.iterator](){return l},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const f={value:[n.key,n.value],done:!1};return n=n.next,f}else return{value:void 0,done:!0}}};return l}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let r=this._head,n=this.size;for(;r&&n>s;)this._map.delete(r.key),r=r.next,n--;this._head=r,this._size=n,r&&(r.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const r=s.next,n=s.previous;if(!r||!n)throw new Error("Invalid list");r.previous=n,n.next=r}s.next=void 0,s.previous=void 0,this._state++}touch(s,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(s===this._head)return;const n=s.next,l=s.previous;s===this._tail?(l.next=void 0,this._tail=l):(n.previous=l,l.next=n),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(r===2){if(s===this._tail)return;const n=s.next,l=s.previous;s===this._head?(n.previous=void 0,this._head=n):(n.previous=l,l.next=n),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((r,n)=>{s.push([n,r])}),s}fromJSON(s){this.clear();for(const[r,n]of s)this.set(r,n)}}e.LinkedMap=d;class h extends d{constructor(s,r=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,r=2){return super.get(s,r)}peek(s){return super.get(s,0)}set(s,r){return super.set(s,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=h;class v{constructor(s){T.set(this,void 0),nt(this,T,s,"f")}get size(){return Ue(this,T,"f").size}forEach(s,r){Ue(this,T,"f").forEach(s,r)}get(s){return Ue(this,T,"f").get(s)}has(s){return Ue(this,T,"f").has(s)}entries(){return Ue(this,T,"f").entries()}keys(){return Ue(this,T,"f").keys()}values(){return Ue(this,T,"f").values()}[(T=new WeakMap,Symbol.iterator)](){return Ue(this,T,"f").entries()}}e.ReadonlyMapView=v}),define(me[95],ge([0,1,23,8]),function(J,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function C(...Y){return function(se,we){for(let Fe=0,ze=Y.length;Fe<ze;Fe++){const _e=Y[Fe](se,we);if(_e)return _e}return null}}e.or=C,e.matchesStrictPrefix=S.bind(void 0,!1),e.matchesPrefix=S.bind(void 0,!0);function S(Y,se,we){if(!we||we.length<se.length)return null;let Fe;return Y?Fe=L.startsWithIgnoreCase(we,se):Fe=we.indexOf(se)===0,Fe?se.length>0?[{start:0,end:se.length}]:[]:null}function T(Y,se){const we=se.toLowerCase().indexOf(Y.toLowerCase());return we===-1?null:[{start:we,end:we+Y.length}]}e.matchesContiguousSubString=T;function I(Y,se){return D(Y.toLowerCase(),se.toLowerCase(),0,0)}e.matchesSubString=I;function D(Y,se,we,Fe){if(we===Y.length)return[];if(Fe===se.length)return null;if(Y[we]===se[Fe]){let ze=null;return(ze=D(Y,se,we+1,Fe+1))?_({start:Fe,end:Fe+1},ze):null}return D(Y,se,we,Fe+1)}function A(Y){return 97<=Y&&Y<=122}function i(Y){return 65<=Y&&Y<=90}e.isUpper=i;function P(Y){return 48<=Y&&Y<=57}function c(Y){return Y===32||Y===9||Y===10||Y===13}const u=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Y=>u.add(Y.charCodeAt(0)));function a(Y){return c(Y)||u.has(Y)}function g(Y,se){return Y===se||a(Y)&&a(se)}function w(Y){return A(Y)||i(Y)||P(Y)}function _(Y,se){return se.length===0?se=[Y]:Y.end===se[0].start?se[0].start=Y.start:se.unshift(Y),se}function b(Y,se){for(let we=se;we<Y.length;we++){const Fe=Y.charCodeAt(we);if(i(Fe)||P(Fe)||we>0&&!w(Y.charCodeAt(we-1)))return we}return Y.length}function d(Y,se,we,Fe){if(we===Y.length)return[];if(Fe===se.length)return null;if(Y[we]!==se[Fe].toLowerCase())return null;{let ze=null,_e=Fe+1;for(ze=d(Y,se,we+1,Fe+1);!ze&&(_e=b(se,_e))<se.length;)ze=d(Y,se,we+1,_e),_e++;return ze===null?null:_({start:Fe,end:Fe+1},ze)}}function h(Y){let se=0,we=0,Fe=0,ze=0,_e=0;for(let $e=0;$e<Y.length;$e++)_e=Y.charCodeAt($e),i(_e)&&se++,A(_e)&&we++,w(_e)&&Fe++,P(_e)&&ze++;const Ze=se/Y.length,X=we/Y.length,ie=Fe/Y.length,fe=ze/Y.length;return{upperPercent:Ze,lowerPercent:X,alphaPercent:ie,numericPercent:fe}}function v(Y){const{upperPercent:se,lowerPercent:we}=Y;return we===0&&se>.6}function t(Y){const{upperPercent:se,lowerPercent:we,alphaPercent:Fe,numericPercent:ze}=Y;return we>.2&&se<.8&&Fe>.6&&ze<.2}function s(Y){let se=0,we=0,Fe=0,ze=0;for(let _e=0;_e<Y.length;_e++)Fe=Y.charCodeAt(_e),i(Fe)&&se++,A(Fe)&&we++,c(Fe)&&ze++;return(se===0||we===0)&&ze===0?Y.length<=30:se<=5}function r(Y,se){if(!se||(se=se.trim(),se.length===0)||!s(Y)||se.length>60)return null;const we=h(se);if(!t(we)){if(!v(we))return null;se=se.toLowerCase()}let Fe=null,ze=0;for(Y=Y.toLowerCase();ze<se.length&&(Fe=d(Y,se,0,ze))===null;)ze=b(se,ze+1);return Fe}e.matchesCamelCase=r;function n(Y,se,we=!1){if(!se||se.length===0)return null;let Fe=null,ze=0;for(Y=Y.toLowerCase(),se=se.toLowerCase();ze<se.length&&(Fe=l(Y,se,0,ze,we))===null;)ze=f(se,ze+1);return Fe}e.matchesWords=n;function l(Y,se,we,Fe,ze){if(we===Y.length)return[];if(Fe===se.length)return null;if(g(Y.charCodeAt(we),se.charCodeAt(Fe))){let _e=null,Ze=Fe+1;if(_e=l(Y,se,we+1,Fe+1,ze),!ze)for(;!_e&&(Ze=f(se,Ze))<se.length;)_e=l(Y,se,we+1,Ze,ze),Ze++;return _e===null?null:_({start:Fe,end:Fe+1},_e)}else return null}function f(Y,se){for(let we=se;we<Y.length;we++)if(a(Y.charCodeAt(we))||we>0&&a(Y.charCodeAt(we-1)))return we;return Y.length}const m=C(e.matchesPrefix,r,T),E=C(e.matchesPrefix,r,I),y=new p.LRUCache(1e4);function o(Y,se,we=!1){if(typeof Y!="string"||typeof se!="string")return null;let Fe=y.get(Y);Fe||(Fe=new RegExp(L.convertSimple2RegExpPattern(Y),"i"),y.set(Y,Fe));const ze=Fe.exec(se);return ze?[{start:ze.index,end:ze.index+ze[0].length}]:we?E(Y,se):m(Y,se)}e.matchesFuzzy=o;function k(Y,se){const we=qe(Y,Y.toLowerCase(),0,se,se.toLowerCase(),0,!0);return we?$(we):null}e.matchesFuzzy2=k;function F(Y,se,we,Fe,ze,_e){const Ze=Math.min(13,Y.length);for(;we<Ze;we++){const X=qe(Y,se,we,Fe,ze,_e,!1);if(X)return X}return[0,_e]}e.anyScore=F;function $(Y){if(typeof Y=="undefined")return[];const se=[],we=Y[1];for(let Fe=Y.length-1;Fe>1;Fe--){const ze=Y[Fe]+we,_e=se[se.length-1];_e&&_e.end===ze?_e.end=ze+1:se.push({start:ze,end:ze+1})}return se}e.createMatches=$;const Q=128;function oe(){const Y=[],se=[];for(let we=0;we<=Q;we++)se[we]=0;for(let we=0;we<=Q;we++)Y.push(se.slice(0));return Y}function j(Y){const se=[];for(let we=0;we<=Y;we++)se[we]=0;return se}const O=j(2*Q),B=j(2*Q),R=oe(),z=oe(),N=oe(),M=!1;function q(Y,se,we,Fe,ze){function _e(X,ie,fe=" "){for(;X.length<ie;)X=fe+X;return X}let Ze=` |   |${Fe.split("").map(X=>_e(X,3)).join("|")}
`;for(let X=0;X<=we;X++)X===0?Ze+=" |":Ze+=`${se[X-1]}|`,Ze+=Y[X].slice(0,ze+1).map(ie=>_e(ie.toString(),3)).join("|")+`
`;return Ze}function x(Y,se,we,Fe){Y=Y.substr(se),we=we.substr(Fe),console.log(q(z,Y,Y.length,we,we.length)),console.log(q(N,Y,Y.length,we,we.length)),console.log(q(R,Y,Y.length,we,we.length))}function K(Y,se){if(se<0||se>=Y.length)return!1;const we=Y.codePointAt(se);switch(we){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(we)}}function ee(Y,se){if(se<0||se>=Y.length)return!1;switch(Y.charCodeAt(se)){case 32:case 9:return!0;default:return!1}}function de(Y,se,we){return se[Y]!==we[Y]}function Se(Y,se,we,Fe,ze,_e,Ze=!1){for(;se<we&&ze<_e;)Y[se]===Fe[ze]&&(Ze&&(O[se]=ze),se+=1),ze+=1;return se===we}e.isPatternInWord=Se;var De;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(De||(De={}));var Le;(function(Y){Y.Default=[-100,0];function se(we){return!we||we.length===2&&we[0]===-100&&we[1]===0}Y.isDefault=se})(Le=e.FuzzyScore||(e.FuzzyScore={}));function qe(Y,se,we,Fe,ze,_e,Ze){const X=Y.length>Q?Q:Y.length,ie=Fe.length>Q?Q:Fe.length;if(we>=X||_e>=ie||X-we>ie-_e||!Se(se,we,X,ze,_e,ie,!0))return;We(X,ie,we,_e,se,ze);let fe=1,$e=1,xe=we,tt=_e;const Ce=[!1];for(fe=1,xe=we;xe<X;fe++,xe++){const pe=O[xe],Ee=B[xe],G=xe+1<X?B[xe+1]:ie;for($e=pe-_e+1,tt=pe;tt<G;$e++,tt++){let ve=Number.MIN_SAFE_INTEGER,ye=!1;tt<=Ee&&(ve=je(Y,se,xe,we,Fe,ze,tt,ie,_e,R[fe-1][$e-1]===0,Ce));let Ae=0;ve!==Number.MAX_SAFE_INTEGER&&(ye=!0,Ae=ve+z[fe-1][$e-1]);const Ne=tt>pe,Ge=Ne?z[fe][$e-1]+(R[fe][$e-1]>0?-5:0):0,et=tt>pe+1&&R[fe][$e-1]>0,Qe=et?z[fe][$e-2]+(R[fe][$e-2]>0?-5:0):0;if(et&&(!Ne||Qe>=Ge)&&(!ye||Qe>=Ae))z[fe][$e]=Qe,N[fe][$e]=3,R[fe][$e]=0;else if(Ne&&(!ye||Ge>=Ae))z[fe][$e]=Ge,N[fe][$e]=2,R[fe][$e]=0;else if(ye)z[fe][$e]=Ae,N[fe][$e]=1,R[fe][$e]=R[fe-1][$e-1]+1;else throw new Error("not possible")}}if(M&&x(Y,we,Fe,_e),!Ce[0]&&!Ze)return;fe--,$e--;const ke=[z[fe][$e],_e];let Te=0,le=0;for(;fe>=1;){let pe=$e;do{const Ee=N[fe][pe];if(Ee===3)pe=pe-2;else if(Ee===2)pe=pe-1;else break}while(pe>=1);Te>1&&se[we+fe-1]===ze[_e+$e-1]&&!de(pe+_e-1,Fe,ze)&&Te+1>R[fe][pe]&&(pe=$e),pe===$e?Te++:Te=1,le||(le=pe),fe--,$e=pe-1,ke.push($e)}ie===X&&(ke[0]+=2);const ce=le-X;return ke[0]-=ce,ke}e.fuzzyScore=qe;function We(Y,se,we,Fe,ze,_e){let Ze=Y-1,X=se-1;for(;Ze>=we&&X>=Fe;)ze[Ze]===_e[X]&&(B[Ze]=X,Ze--),X--}function je(Y,se,we,Fe,ze,_e,Ze,X,ie,fe,$e){if(se[we]!==_e[Ze])return Number.MIN_SAFE_INTEGER;let xe=1,tt=!1;return Ze===we-Fe?xe=Y[we]===ze[Ze]?7:5:de(Ze,ze,_e)&&(Ze===0||!de(Ze-1,ze,_e))?(xe=Y[we]===ze[Ze]?7:5,tt=!0):K(_e,Ze)&&(Ze===0||!K(_e,Ze-1))?xe=5:(K(_e,Ze-1)||ee(_e,Ze-1))&&(xe=5,tt=!0),xe>1&&we===Fe&&($e[0]=!0),tt||(tt=de(Ze,ze,_e)||K(_e,Ze-1)||ee(_e,Ze-1)),we===Fe?Ze>ie&&(xe-=tt?3:5):fe?xe+=tt?2:0:xe+=tt?0:1,Ze+1===X&&(xe-=tt?3:5),xe}function W(Y,se,we,Fe,ze,_e,Ze){return te(Y,se,we,Fe,ze,_e,!0,Ze)}e.fuzzyScoreGracefulAggressive=W;function Z(Y,se,we,Fe,ze,_e,Ze){return te(Y,se,we,Fe,ze,_e,!1,Ze)}e.fuzzyScoreGraceful=Z;function te(Y,se,we,Fe,ze,_e,Ze,X){let ie=qe(Y,se,we,Fe,ze,_e,X);if(ie&&!Ze)return ie;if(Y.length>=3){const fe=Math.min(7,Y.length-1);for(let $e=we+1;$e<fe;$e++){const xe=ae(Y,$e);if(xe){const tt=qe(xe,xe.toLowerCase(),we,Fe,ze,_e,X);tt&&(tt[0]-=3,(!ie||tt[0]>ie[0])&&(ie=tt))}}}return ie}function ae(Y,se){if(se+1>=Y.length)return;const we=Y[se],Fe=Y[se+1];if(we!==Fe)return Y.slice(0,se)+Fe+we+Y.slice(se+2)}}),define(me[138],ge([0,1,74,95,8]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const S=new RegExp(`\\$\\(${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${S.source}`,"g");function I(g){return g.replace(T,(w,_)=>_?w:`\\${w}`)}e.escapeIcons=I;const D=new RegExp(`\\\\${S.source}`,"g");function A(g){return g.replace(D,w=>`\\${w}`)}e.markdownEscapeEscapedIcons=A;const i=new RegExp(`(\\s)?(\\\\)?${S.source}(\\s)?`,"g");function P(g){return g.indexOf(e.iconStartMarker)===-1?g:g.replace(i,(w,_,b,d)=>b?w:_||d||"")}e.stripIcons=P;function c(g){const w=g.indexOf(e.iconStartMarker);return w===-1?{text:g}:u(g,w)}e.parseLabelWithIcons=c;function u(g,w){const _=[];let b="";function d(f){if(f){b+=f;for(const m of f)_.push(t)}}let h=-1,v="",t=0,s,r,n=w;const l=g.length;for(d(g.substr(0,w));n<l;)s=g[n],r=g[n+1],s===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(h=n,d(v),v=e.iconStartMarker,n++):s===")"&&h!==-1?(t+=n-h+1,h=-1,v=""):h!==-1?/^[a-z0-9\-]$/i.test(s)?v+=s:(d(v),h=-1,v=""):d(s),n++;return d(v),{text:b,iconOffsets:_}}function a(g,w,_=!1){const{text:b,iconOffsets:d}=w;if(!d||d.length===0)return(0,L.matchesFuzzy)(g,b,_);const h=(0,C.ltrim)(b," "),v=b.length-h.length,t=(0,L.matchesFuzzy)(g,h,_);if(t)for(const s of t){const r=d[s.start+v]+v;s.start+=r,s.end+=r}return t}e.matchesFuzzyIconAware=a}),define(me[96],ge([0,1,138,15]),function(J,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var C;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(C=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(u="",a=!1){if(this.value=u,typeof this.value!="string")throw(0,L.illegalArgument)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1)}appendText(u,a=0){return this.value+=A(this.supportThemeIcons?(0,p.escapeIcons)(u):u).replace(/([ \t]+)/g,(g,w)=>"&nbsp;".repeat(w.length)).replace(/^>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,a){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=a,this.value+="\n```\n",this}}e.MarkdownString=S;function T(c){return I(c)?!c.value:Array.isArray(c)?c.every(T):!0}e.isEmptyMarkdownString=T;function I(c){return c instanceof S?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.isMarkdownString=I;function D(c,u){return c===u?!0:!c||!u?!1:c.value===u.value&&c.isTrusted===u.isTrusted&&c.supportThemeIcons===u.supportThemeIcons}e.markdownStringEqual=D;function A(c){return c.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=A;function i(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=i;function P(c){const u=[],a=c.split("|").map(w=>w.trim());c=a[0];const g=a[1];if(g){const w=/height=(\d+)/.exec(g),_=/width=(\d+)/.exec(g),b=w?w[1]:"",d=_?_[1]:"",h=isFinite(parseInt(d)),v=isFinite(parseInt(b));h&&u.push(`width="${d}"`),v&&u.push(`height="${b}"`)}return{href:c,dimensions:u}}e.parseHrefAndDimensions=P}),define(me[57],ge([0,1,22,8,2]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function S(i){return JSON.stringify(i,D)}e.stringify=S;function T(i){let P=JSON.parse(i);return P=A(P),P}e.parse=T;var I;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(I=e.MarshalledId||(e.MarshalledId={}));function D(i,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,L.regExpFlags)(P)}:P}function A(i,P=0){if(!i||P>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return C.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof p.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let c=0;c<i.length;++c)i[c]=A(i[c],P+1);else for(const c in i)Object.hasOwnProperty.call(i,c)&&(i[c]=A(i[c],P+1))}return i}e.revive=A}),define(me[10],ge([0,1,2,11]),function(J,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var C;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp"})(C=e.Schemas||(e.Schemas={}));class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,A,i){this._hosts[D]=A,this._ports[D]=i}setConnectionToken(D,A){this._connectionTokens[D]=A}rewrite(D){if(this._delegate)return this._delegate(D);const A=D.authority;let i=this._hosts[A];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const P=this._ports[A],c=this._connectionTokens[A];let u=`path=${encodeURIComponent(D.path)}`;return typeof c=="string"&&(u+=`&tkn=${encodeURIComponent(c)}`),p.URI.from({scheme:L.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${i}:${P}`,path:"/vscode-remote-resource",query:u})}}e.RemoteAuthorities=new S;class T{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(D,A,i){const P=this.toUri(D,A);if(P.scheme===C.vscodeRemote)return e.RemoteAuthorities.rewrite(P);let c=!1;return L.isNative&&(i||L.isPreferringBrowserCodeLoad)&&P.scheme===C.file&&(c=!0),P.scheme===C.file&&typeof L.globals.importScripts=="function"&&L.globals.origin==="vscode-file://vscode-app"&&(c=!0),c?P.with({scheme:C.vscodeFileResource,authority:P.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(D,A){const i=this.toUri(D,A);return i.scheme===C.vscodeFileResource?i.with({scheme:C.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(D,A){return p.URI.isUri(D)?D:p.URI.parse(A.toUrl(D))}}e.FileAccess=new T}),define(me[75],ge([0,1,23]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new p.LRUCache(1e4);function C(A){return D(A,"NFC",L)}e.normalizeNFC=C;const S=new p.LRUCache(1e4);function T(A){return D(A,"NFD",S)}e.normalizeNFD=T;const I=/[^\u0000-\u0080]/;function D(A,i,P){if(!A)return A;const c=P.get(A);if(c)return c;let u;return I.test(A)?u=A.normalize(i):u=A,P.set(A,u),u}e.removeAccents=function(){const A=/[\u0300-\u036f]/g;return function(i){return T(i).replace(A,"")}}()}),define(me[24],ge([0,1,29,9,2,8,10,11]),function(J,e,p,L,C,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(u){return(0,C.uriToFsPath)(u,!0)}e.originalFSPath=D;class A{constructor(a){this._ignorePathCasing=a}compare(a,g,w=!1){return a===g?0:(0,S.compare)(this.getComparisonKey(a,w),this.getComparisonKey(g,w))}isEqual(a,g,w=!1){return a===g?!0:!a||!g?!1:this.getComparisonKey(a,w)===this.getComparisonKey(g,w)}getComparisonKey(a,g=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,g,w=!1){if(a.scheme===g.scheme){if(a.scheme===T.Schemas.file)return p.isEqualOrParent(D(a),D(g),this._ignorePathCasing(a))&&a.query===g.query&&(w||a.fragment===g.fragment);if((0,e.isEqualAuthority)(a.authority,g.authority))return p.isEqualOrParent(a.path,g.path,this._ignorePathCasing(a),"/")&&a.query===g.query&&(w||a.fragment===g.fragment)}return!1}joinPath(a,...g){return C.URI.joinPath(a,...g)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return L.posix.basename(a.path)}extname(a){return L.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let g;return a.scheme===T.Schemas.file?g=C.URI.file(L.dirname(D(a))).path:(g=L.posix.dirname(a.path),a.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),g="/")),a.with({path:g})}normalizePath(a){if(!a.path.length)return a;let g;return a.scheme===T.Schemas.file?g=C.URI.file(L.normalize(D(a))).path:g=L.posix.normalize(a.path),a.with({path:g})}relativePath(a,g){if(a.scheme!==g.scheme||!(0,e.isEqualAuthority)(a.authority,g.authority))return;if(a.scheme===T.Schemas.file){const b=L.relative(D(a),D(g));return I.isWindows?p.toSlashes(b):b}let w=a.path||"/",_=g.path||"/";if(this._ignorePathCasing(a)){let b=0;for(const d=Math.min(w.length,_.length);b<d&&!(w.charCodeAt(b)!==_.charCodeAt(b)&&w.charAt(b).toLowerCase()!==_.charAt(b).toLowerCase());b++);w=_.substr(0,b)+w.substr(b)}return L.posix.relative(w,_)}resolvePath(a,g){if(a.scheme===T.Schemas.file){const w=C.URI.file(L.resolve(D(a),g));return a.with({authority:w.authority,path:w.path})}return g=p.toPosixPath(g),a.with({path:L.posix.resolve(a.path,g)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,g){return a===g||(0,S.equalsIgnoreCase)(a,g)}hasTrailingPathSeparator(a,g=L.sep){if(a.scheme===T.Schemas.file){const w=D(a);return w.length>p.getRoot(w).length&&w[w.length-1]===g}else{const w=a.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,g=L.sep){return(0,e.hasTrailingPathSeparator)(a,g)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,g=L.sep){let w=!1;if(a.scheme===T.Schemas.file){const _=D(a);w=_!==void 0&&_.length===p.getRoot(_).length&&_[_.length-1]===g}else{g="/";const _=a.path;w=_.length===1&&_.charCodeAt(_.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(a,g)?a.with({path:a.path+"/"}):a}}e.ExtUri=A,e.extUri=new A(()=>!1),e.extUriBiasedIgnorePathCase=new A(u=>u.scheme===T.Schemas.file?!I.isLinux:!0),e.extUriIgnorePathCase=new A(u=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(u,a){const g=[];for(let w=0;w<u.length;w++){const _=a(u[w]);u.some((b,d)=>d===w?!1:(0,e.isEqualOrParent)(_,a(b)))||g.push(u[w])}return g}e.distinctParents=i;var P;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function a(g){const w=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(d=>{const[h,v]=d.split(":");h&&v&&w.set(h,v)});const b=g.path.substring(0,g.path.indexOf(";"));return b&&w.set(u.META_DATA_MIME,b),w}u.parseMetaData=a})(P=e.DataUri||(e.DataUri={}));function c(u,a,g){if(a){let w=u.path;return w&&w[0]!==L.posix.sep&&(w=L.posix.sep+w),u.with({scheme:g,authority:a,path:w})}return u.with({scheme:g})}e.toLocalResource=c}),define(me[17],ge([0,1,21,15,3,6,24]),function(J,e,p,L,C,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(B){return!!B&&typeof B.then=="function"}e.isThenable=I;function D(B){const R=new p.CancellationTokenSource,z=B(R.token),N=new Promise((M,q)=>{const x=R.token.onCancellationRequested(()=>{x.dispose(),R.dispose(),q((0,L.canceled)())});Promise.resolve(z).then(K=>{x.dispose(),R.dispose(),M(K)},K=>{x.dispose(),R.dispose(),q(K)})});return new class{cancel(){R.cancel()}then(M,q){return N.then(M,q)}catch(M){return this.then(void 0,M)}finally(M){return N.finally(M)}}}e.createCancelablePromise=D;function A(B,R,z){return Promise.race([B,new Promise(N=>R.onCancellationRequested(()=>N(z)))])}e.raceCancellation=A;async function i(B){let R=-1;const z=B.map((M,q)=>M.then(x=>(R=q,x))),N=await Promise.race(z);return B.forEach((M,q)=>{q!==R&&M.cancel()}),N}e.raceCancellablePromises=i;function P(B,R,z){let N;const M=setTimeout(()=>{N?.(void 0),z?.()},R);return Promise.race([B.finally(()=>clearTimeout(M)),new Promise(q=>N=q)])}e.raceTimeout=P;function c(B){return new Promise((R,z)=>{const N=B();I(N)?N.then(R,z):R(N)})}e.asPromise=c;class u{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(R){if(this.activePromise){if(this.queuedPromiseFactory=R,!this.queuedPromise){const z=()=>{this.queuedPromise=null;const N=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,N};this.queuedPromise=new Promise(N=>{this.activePromise.then(z,z).then(N)})}return new Promise((z,N)=>{this.queuedPromise.then(z,N)})}return this.activePromise=R(),new Promise((z,N)=>{this.activePromise.then(M=>{this.activePromise=null,z(M)},M=>{this.activePromise=null,N(M)})})}}e.Throttler=u;class a{constructor(){this.current=Promise.resolve(null)}queue(R){return this.current=this.current.then(()=>R(),()=>R())}}e.Sequencer=a;class g{constructor(){this.promiseMap=new Map}queue(R,z){const M=(this.promiseMap.get(R)??Promise.resolve()).catch(()=>{}).then(z).finally(()=>{this.promiseMap.get(R)===M&&this.promiseMap.delete(R)});return this.promiseMap.set(R,M),M}}e.SequencerByKey=g;class w{constructor(R){this.defaultDelay=R,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(R,z=this.defaultDelay){return this.task=R,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((N,M)=>{this.doResolve=N,this.doReject=M}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const N=this.task;return this.task=null,N()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},z),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=w;class _{constructor(R){this.delayer=new w(R),this.throttler=new u}trigger(R,z){return this.delayer.trigger(()=>this.throttler.queue(R),z)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=_;class b{constructor(){this._isOpen=!1,this._promise=new Promise((R,z)=>{this._completePromise=R})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=b;class d extends b{constructor(R){super();this._timeout=setTimeout(()=>this.open(),R)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function h(B,R){return R?new Promise((z,N)=>{const M=setTimeout(()=>{q.dispose(),z()},B),q=R.onCancellationRequested(()=>{clearTimeout(M),q.dispose(),N((0,L.canceled)())})}):D(z=>h(B,z))}e.timeout=h;function v(B,R=0){const z=setTimeout(B,R);return(0,S.toDisposable)(()=>clearTimeout(z))}e.disposableTimeout=v;function t(B){const R=[];let z=0;const N=B.length;function M(){return z<N?B[z++]():null}function q(x){x!=null&&R.push(x);const K=M();return K?K.then(q):Promise.resolve(R)}return Promise.resolve(null).then(q)}e.sequence=t;function s(B,R=N=>!!N,z=null){let N=0;const M=B.length,q=()=>{if(N>=M)return Promise.resolve(z);const x=B[N++];return Promise.resolve(x()).then(ee=>R(ee)?Promise.resolve(ee):q())};return q()}e.first=s;function r(B,R=N=>!!N,z=null){if(B.length===0)return Promise.resolve(z);let N=B.length;const M=()=>{N=-1;for(const q of B)q.cancel?.()};return new Promise((q,x)=>{for(const K of B)K.then(ee=>{--N>=0&&R(ee)?(M(),q(ee)):N===0&&q(z)}).catch(ee=>{--N>=0&&(M(),x(ee))})})}e.firstParallel=r;class n{constructor(R){this._size=0,this.maxDegreeOfParalellism=R,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new C.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(R){return this._size++,new Promise((z,N)=>{this.outstandingPromises.push({factory:R,c:z,e:N}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const R=this.outstandingPromises.shift();this.runningPromises++;const z=R.factory();z.then(R.c,R.e),z.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=n;class l extends n{constructor(){super(1)}}e.Queue=l;class f{constructor(){this.queues=new Map}queueFor(R,z=T.extUri){const N=z.getComparisonKey(R);let M=this.queues.get(N);return M||(M=new l,C.Event.once(M.onFinished)(()=>{M?.dispose(),this.queues.delete(N)}),this.queues.set(N,M)),M}dispose(){this.queues.forEach(R=>R.dispose()),this.queues.clear()}}e.ResourceQueue=f;class m{constructor(R,z){this._token=-1,typeof R=="function"&&typeof z=="number"&&this.setIfNotSet(R,z)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(R,z){this.cancel(),this._token=setTimeout(()=>{this._token=-1,R()},z)}setIfNotSet(R,z){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,R()},z))}}e.TimeoutTimer=m;class E{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(R,z){this.cancel(),this._token=setInterval(()=>{R()},z)}}e.IntervalTimer=E;class y{constructor(R,z){this.timeoutToken=-1,this.runner=R,this.timeout=z,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(R=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,R)}get delay(){return this.timeout}set delay(R){this.timeout=R}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=y;class o extends y{constructor(R,z){super(R,z);this.units=[]}work(R){this.units.push(R),this.isScheduled()||this.schedule()}doRun(){const R=this.units;this.units=[],this.runner&&this.runner(R)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=o;class k extends S.Disposable{constructor(R,z,N,M){super();this.maxWorkChunkSize=R,this.maxPendingWork=z,this.throttleDelay=N,this.handler=M,this.pendingWork=[],this.throttler=this._register(new S.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(R){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+R.length>this.maxPendingWork)return!1}else if(this.pending+R.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...R),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new y(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=k,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const B=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=R=>{const z=setTimeout(()=>R(B));let N=!1;return{dispose(){N||(N=!0,clearTimeout(z))}}}}else e.runWhenIdle=(B,R)=>{const z=requestIdleCallback(B,typeof R=="number"?{timeout:R}:void 0);let N=!1;return{dispose(){N||(N=!0,cancelIdleCallback(z))}}}}();class F{constructor(R){this._didRun=!1,this._executor=()=>{try{this._value=R()}catch(z){this._error=z}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=F;async function $(B,R,z){let N;for(let M=0;M<z;M++)try{return await B()}catch(q){N=q,await h(R)}throw N}e.retry=$;class Q{hasPending(R){return this._pending?typeof R=="number"?this._pending.taskId===R:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(R,z,N){return this._pending={taskId:R,cancel:()=>N?.(),promise:z},z.then(()=>this.donePending(R),()=>this.donePending(R)),z}donePending(R){this._pending&&R===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const R=this._next;this._next=void 0,R.run().then(R.promiseResolve,R.promiseReject)}}setNext(R){if(this._next)this._next.run=R;else{let z,N;const M=new Promise((q,x)=>{z=q,N=x});this._next={run:R,promise:M,promiseResolve:z,promiseReject:N}}return this._next.promise}}e.TaskSequentializer=Q;class oe{constructor(R){this.interval=R,this.lastIncrementTime=0,this.value=0}increment(){const R=Date.now();return R-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=R,this.value=0),this.value++,this.value}}e.IntervalCounter=oe;class j{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((R,z)=>{this.completeCallback=R,this.errorCallback=z})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(R){return new Promise(z=>{this.completeCallback(R),this.resolved=!0,z()})}error(R){return new Promise(z=>{this.errorCallback(R),this.rejected=!0,z()})}cancel(){new Promise(R=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,R()})}}e.DeferredPromise=j;var O;(function(B){async function R(z){let N;const M=await Promise.all(z.map(q=>q.then(x=>x,x=>{N||(N=x)})));if(typeof N!="undefined")throw N;return M}B.settled=R})(O=e.Promises||(e.Promises={}))}),define(me[97],ge([0,1,9,17]),function(J,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const C=new L.IdleValue(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),S=new L.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new L.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function I(y,o,k=!1){const F=y||"",$=o||"",Q=C.value.collator.compare(F,$);return C.value.collatorIsNumeric&&Q===0&&F!==$?F<$?-1:1:Q}e.compareFileNames=I;function D(y,o){const k=S.value.collator;return y=y||"",o=o||"",v(k,y,o)}e.compareFileNamesDefault=D;function A(y,o){const k=S.value.collator;return y=y||"",o=o||"",n(y,o)||v(k,y,o)}e.compareFileNamesUpper=A;function i(y,o){const k=S.value.collator;return y=y||"",o=o||"",r(y,o)||v(k,y,o)}e.compareFileNamesLower=i;function P(y,o){return y=y||"",o=o||"",y===o?0:y<o?-1:1}e.compareFileNamesUnicode=P;function c(y,o,k=!1){k||(y=y&&y.toLowerCase(),o=o&&o.toLowerCase());const[F,$]=d(y),[Q,oe]=d(o);return F!==Q?F<Q?-1:1:$===oe?0:$<oe?-1:1}e.noIntlCompareFileNames=c;function u(y,o){const[k,F]=d(y),[$,Q]=d(o);let oe=C.value.collator.compare(F,Q);if(oe===0){if(C.value.collatorIsNumeric&&F!==Q)return F<Q?-1:1;if(oe=C.value.collator.compare(k,$),C.value.collatorIsNumeric&&oe===0&&k!==$)return k<$?-1:1}return oe}e.compareFileExtensions=u;function a(y,o){y=y||"",o=o||"";const k=h(y),F=h(o),$=S.value.collator,Q=T.value.collator;return v(Q,k,F)||v($,y,o)}e.compareFileExtensionsDefault=a;function g(y,o){y=y||"",o=o||"";const k=h(y),F=h(o),$=S.value.collator,Q=T.value.collator;return v(Q,k,F)||n(y,o)||v($,y,o)}e.compareFileExtensionsUpper=g;function w(y,o){y=y||"",o=o||"";const k=h(y),F=h(o),$=S.value.collator,Q=T.value.collator;return v(Q,k,F)||r(y,o)||v($,y,o)}e.compareFileExtensionsLower=w;function _(y,o){y=y||"",o=o||"";const k=h(y).toLowerCase(),F=h(o).toLowerCase();return k!==F?k<F?-1:1:y!==o?y<o?-1:1:0}e.compareFileExtensionsUnicode=_;const b=/^(.*?)(\.([^.]*))?$/;function d(y,o=!1){const k=y?b.exec(y):[];let F=[k&&k[1]||"",k&&k[3]||""];return o&&(!F[0]&&F[1]||F[0]&&F[0].charAt(0)===".")&&(F=[F[0]+"."+F[1],""]),F}function h(y){const o=y?b.exec(y):[];return o&&o[1]&&o[1].charAt(0)!=="."&&o[3]||""}function v(y,o,k){let F=y.compare(o,k);return F!==0?F:o.length!==k.length?o.length<k.length?-1:1:0}function t(y){const o=y.charAt(0);return o.toLocaleUpperCase()!==o}function s(y){const o=y.charAt(0);return o.toLocaleLowerCase()!==o}function r(y,o){return t(y)&&s(o)?-1:s(y)&&t(o)?1:0}function n(y,o){return s(y)&&t(o)?-1:t(y)&&s(o)?1:0}function l(y,o,k=!1){return k||(y=y&&y.toLowerCase(),o=o&&o.toLowerCase()),y===o?0:y<o?-1:1}function f(y,o,k=!1){const F=y.split(p.sep),$=o.split(p.sep),Q=F.length-1,oe=$.length-1;let j,O;for(let B=0;;B++){if(j=Q===B,O=oe===B,j&&O)return I(F[B],$[B],k);if(j)return-1;if(O)return 1;const R=l(F[B],$[B],k);if(R!==0)return R}}e.comparePaths=f;function m(y,o,k){const F=y.toLowerCase(),$=o.toLowerCase(),Q=E(y,o,k);if(Q)return Q;const oe=F.endsWith(k),j=$.endsWith(k);if(oe!==j)return oe?-1:1;const O=I(F,$);return O!==0?O:F.localeCompare($)}e.compareAnything=m;function E(y,o,k){const F=y.toLowerCase(),$=o.toLowerCase(),Q=F.startsWith(k),oe=$.startsWith(k);if(Q!==oe)return Q?-1:1;if(Q&&oe){if(F.length<$.length)return-1;if(F.length>$.length)return 1}return 0}e.compareByPrefix=E}),define(me[98],ge([0,1,97,95,9,11,8]),function(J,e,p,L,C,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const I=0,D=[I,[]];function A(j,O,B,R){if(!j||!O)return D;const z=j.length,N=O.length;if(z<N)return D;const M=j.toLowerCase();return!R&&!M.includes(B)?D:i(O,B,N,j,M,z)}e.scoreFuzzy=A;function i(j,O,B,R,z,N){const M=[],q=[];for(let de=0;de<B;de++){const Se=de*N,De=Se-N,Le=de>0,qe=j[de],We=O[de];for(let je=0;je<N;je++){const W=je>0,Z=Se+je,te=Z-1,ae=De+je-1,Y=W?M[te]:0,se=Le&&W?M[ae]:0,we=Le&&W?q[ae]:0;let Fe;!se&&Le?Fe=0:Fe=P(qe,We,R,z,je,we),Fe&&se+Fe>=Y?(q[Z]=we+1,M[Z]=se+Fe):(q[Z]=I,M[Z]=Y)}}const x=[];let K=B-1,ee=N-1;for(;K>=0&&ee>=0;){const de=K*N+ee;q[de]===I||(x.push(ee),K--),ee--}return[M[B*N-1],x.reverse()]}function P(j,O,B,R,z,N){let M=0;if(!c(O,R[z]))return M;if(M+=1,N>0&&(M+=N*5),j===B[z]&&(M+=1),z===0)M+=8;else{const q=u(B.charCodeAt(z-1));q?M+=q:(0,L.isUpper)(B.charCodeAt(z))&&(M+=2)}return M}function c(j,O){return j===O?!0:j==="/"||j==="\\"?O==="/"||O==="\\":!1}function u(j){switch(j){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const a=[void 0,[]];function g(j,O,B=0,R=0){const z=O;return z.values&&z.values.length>1?w(j,z.values,B,R):_(j,O,B,R)}e.scoreFuzzy2=g;function w(j,O,B,R){let z=0;const N=[];for(const M of O){const[q,x]=_(j,M,B,R);if(typeof q!="number")return a;z+=q,N.push(...x)}return[z,f(N)]}function _(j,O,B,R){const z=(0,L.fuzzyScore)(O.original,O.originalLowercase,B,j,j.toLowerCase(),R,!0);return z?[z[0],(0,L.createMatches)(z)]:a}const b=Object.freeze({score:0}),d=1<<18,h=1<<17,v=1<<16;function t(j,O,B,R,z){if(!j||!O.normalized)return b;const N=R.getItemLabel(j);if(!N)return b;const M=R.getItemDescription(j);let q;M?q=`${N}${M}${O.normalized}${Array.isArray(O.values)?O.values.length:""}${B}`:q=`${N}${O.normalized}${Array.isArray(O.values)?O.values.length:""}${B}`;const x=z[q];if(x)return x;const K=s(N,M,R.getItemPath(j),O,B);return z[q]=K,K}e.scoreItemFuzzy=t;function s(j,O,B,R,z){const N=!B||!R.containsPathSeparator;return B&&(S.isLinux?R.pathNormalized===B:(0,T.equalsIgnoreCase)(R.pathNormalized,B))?{score:d,labelMatch:[{start:0,end:j.length}],descriptionMatch:O?[{start:0,end:O.length}]:void 0}:R.values&&R.values.length>1?r(j,O,B,R.values,N,z):n(j,O,B,R,N,z)}function r(j,O,B,R,z,N){let M=0;const q=[],x=[];for(const K of R){const{score:ee,labelMatch:de,descriptionMatch:Se}=n(j,O,B,K,z,N);if(ee===I)return b;M+=ee,de&&q.push(...de),Se&&x.push(...Se)}return{score:M,labelMatch:f(q),descriptionMatch:f(x)}}function n(j,O,B,R,z,N){if(z||!O){const[M,q]=A(j,R.normalized,R.normalizedLowercase,N);if(M){const x=(0,L.matchesPrefix)(R.normalized,j);let K;return x?(K=h,K+=Math.round(R.normalized.length/j.length*100)):K=v,{score:K+M,labelMatch:x||l(q)}}}if(O){let M=O;B&&(M=`${O}${C.sep}`);const q=M.length,x=`${M}${j}`,[K,ee]=A(x,R.normalized,R.normalizedLowercase,N);if(K){const de=l(ee),Se=[],De=[];return de.forEach(Le=>{Le.start<q&&Le.end>q?(Se.push({start:0,end:Le.end-q}),De.push({start:Le.start,end:q})):Le.start>=q?Se.push({start:Le.start-q,end:Le.end-q}):De.push(Le)}),{score:K,labelMatch:Se,descriptionMatch:De}}}return b}function l(j){const O=[];if(!j)return O;let B;for(const R of j)B&&B.end===R?B.end+=1:(B={start:R,end:R+1},O.push(B));return O}function f(j){const O=j.sort((z,N)=>z.start-N.start),B=[];let R;for(const z of O)!R||!m(R,z)?(R=z,B.push(z)):(R.start=Math.min(R.start,z.start),R.end=Math.max(R.end,z.end));return B}function m(j,O){return!(j.end<O.start||O.end<j.start)}function E(j,O,B,R,z,N){const M=t(j,B,R,z,N),q=t(O,B,R,z,N),x=M.score,K=q.score;if((x===d||K===d)&&x!==K)return x===d?-1:1;if(x>v||K>v){if(x!==K)return x>K?-1:1;if(x<h&&K<h){const We=o(M.labelMatch,q.labelMatch);if(We!==0)return We}const Le=z.getItemLabel(j)||"",qe=z.getItemLabel(O)||"";if(Le.length!==qe.length)return Le.length-qe.length}if(x!==K)return x>K?-1:1;const ee=Array.isArray(M.labelMatch)&&M.labelMatch.length>0,de=Array.isArray(q.labelMatch)&&q.labelMatch.length>0;if(ee&&!de)return-1;if(de&&!ee)return 1;const Se=y(j,M,z),De=y(O,q,z);return Se&&De&&Se!==De?De>Se?-1:1:k(j,O,B,z)}e.compareItemsByFuzzyScore=E;function y(j,O,B){let R=-1,z=-1;if(O.descriptionMatch&&O.descriptionMatch.length?R=O.descriptionMatch[0].start:O.labelMatch&&O.labelMatch.length&&(R=O.labelMatch[0].start),O.labelMatch&&O.labelMatch.length){if(z=O.labelMatch[O.labelMatch.length-1].end,O.descriptionMatch&&O.descriptionMatch.length){const N=B.getItemDescription(j);N&&(z+=N.length)}}else O.descriptionMatch&&O.descriptionMatch.length&&(z=O.descriptionMatch[O.descriptionMatch.length-1].end);return z-R}function o(j,O){if(!j&&!O||(!j||!j.length)&&(!O||!O.length))return 0;if(!O||!O.length)return-1;if(!j||!j.length)return 1;const B=j[0].start,z=j[j.length-1].end-B,N=O[0].start,q=O[O.length-1].end-N;return z===q?0:q<z?1:-1}function k(j,O,B,R){const z=R.getItemLabel(j)||"",N=R.getItemLabel(O)||"",M=R.getItemDescription(j),q=R.getItemDescription(O),x=z.length+(M?M.length:0),K=N.length+(q?q.length:0);if(x!==K)return x-K;const ee=R.getItemPath(j),de=R.getItemPath(O);return ee&&de&&ee.length!==de.length?ee.length-de.length:z!==N?(0,p.compareAnything)(z,N,B.normalized):M&&q&&M!==q?(0,p.compareAnything)(M,q,B.normalized):ee&&de&&ee!==de?(0,p.compareAnything)(ee,de,B.normalized):0}const F=" ";function $(j){typeof j!="string"&&(j="");const O=j.toLowerCase(),{pathNormalized:B,normalized:R,normalizedLowercase:z}=Q(j),N=B.indexOf(C.sep)>=0;let M;const q=j.split(F);if(q.length>1)for(const x of q){const{pathNormalized:K,normalized:ee,normalizedLowercase:de}=Q(x);ee&&(M||(M=[]),M.push({original:x,originalLowercase:x.toLowerCase(),pathNormalized:K,normalized:ee,normalizedLowercase:de}))}return{original:j,originalLowercase:O,pathNormalized:B,normalized:R,normalizedLowercase:z,values:M,containsPathSeparator:N}}e.prepareQuery=$;function Q(j){let O;S.isWindows?O=j.replace(/\//g,C.sep):O=j.replace(/\\/g,C.sep);const B=(0,T.stripWildcards)(O).replace(/\s/g,"");return{pathNormalized:O,normalized:B,normalizedLowercase:B.toLowerCase()}}function oe(j){return Array.isArray(j)?$(j.map(O=>O.original).join(F)):$(j.original)}e.pieceToQuery=oe}),define(me[30],ge([0,1,8,29,9,23,17]),function(J,e,p,L,C,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I;const D="**",A="/",i="[/\\\\]",P="[^/\\\\]",c=/\//g;function u(M){switch(M){case 0:return"";case 1:return`${P}*?`;default:return`(?:${i}|${P}+${i}|${i}${P}+)*?`}}function a(M,q){if(!M)return[];const x=[];let K=!1,ee=!1,de="";for(const Se of M){switch(Se){case q:if(!K&&!ee){x.push(de),de="";continue}break;case"{":K=!0;break;case"}":K=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}de+=Se}return de&&x.push(de),x}e.splitGlobAware=a;function g(M){if(!M)return"";let q="";const x=a(M,A);if(x.every(K=>K===D))q=".*";else{let K=!1;x.forEach((ee,de)=>{if(ee===D){K||(q+=u(2),K=!0);return}let Se=!1,De="",Le=!1,qe="";for(const We of ee){if(We!=="}"&&Se){De+=We;continue}if(Le&&(We!=="]"||!qe)){let je;We==="-"?je=We:(We==="^"||We==="!")&&!qe?je="^":We===A?je="":je=p.escapeRegExpCharacters(We),qe+=je;continue}switch(We){case"{":Se=!0;continue;case"[":Le=!0;continue;case"}":q+=`(?:${a(De,",").map(Z=>g(Z)).join("|")})`,Se=!1,De="";break;case"]":q+="["+qe+"]",Le=!1,qe="";break;case"?":q+=P;continue;case"*":q+=u(1);continue;default:q+=p.escapeRegExpCharacters(We)}}de<x.length-1&&(x[de+1]!==D||de+2<x.length)&&(q+=i),K=!1})}return q}const w=/^\*\*\/\*\.[\w\.-]+$/,_=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new S.LRUCache(1e4),s=function(){return!1},r=function(){return null};function n(M,q){if(!M)return r;let x;typeof M!="string"?x=M.pattern:x=M,x=x.trim();const K=`${x}_${!!q.trimForExclusions}`;let ee=t.get(K);if(ee)return l(ee,M);let de;if(w.test(x)){const Se=x.substr(4);ee=function(De,Le){return typeof De=="string"&&De.endsWith(Se)?x:null}}else(de=_.exec(f(x,q)))?ee=m(de[1],x):(q.trimForExclusions?d:b).test(x)?ee=E(x,q):(de=h.exec(f(x,q)))?ee=y(de[1].substr(1),x,!0):(de=v.exec(f(x,q)))?ee=y(de[1],x,!1):ee=o(x);return t.set(K,ee),l(ee,M)}function l(M,q){return typeof q=="string"?M:function(x,K){return L.isEqualOrParent(x,q.base)?M(C.relative(q.base,x),K):null}}function f(M,q){return q.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function m(M,q){const x=`/${M}`,K=`\\${M}`,ee=function(Se,De){return typeof Se!="string"?null:De?De===M?q:null:Se===M||Se.endsWith(x)||Se.endsWith(K)?q:null},de=[M];return ee.basenames=de,ee.patterns=[q],ee.allBasenames=de,ee}function E(M,q){const x=N(M.slice(1,-1).split(",").map(De=>n(De,q)).filter(De=>De!==r),M),K=x.length;if(!K)return r;if(K===1)return x[0];const ee=function(De,Le){for(let qe=0,We=x.length;qe<We;qe++)if(x[qe](De,Le))return M;return null},de=x.find(De=>!!De.allBasenames);de&&(ee.allBasenames=de.allBasenames);const Se=x.reduce((De,Le)=>Le.allPaths?De.concat(Le.allPaths):De,[]);return Se.length&&(ee.allPaths=Se),ee}function y(M,q,x){const K=C.sep===C.posix.sep,ee=K?M:M.replace(c,C.sep),de=C.sep+ee,Se=C.posix.sep+M,De=x?function(Le,qe){return typeof Le=="string"&&(Le===ee||Le.endsWith(de)||!K&&(Le===M||Le.endsWith(Se)))?q:null}:function(Le,qe){return typeof Le=="string"&&(Le===ee||!K&&Le===M)?q:null};return De.allPaths=[(x?"*/":"./")+M],De}function o(M){try{const q=new RegExp(`^${g(M)}$`);return function(x){return q.lastIndex=0,typeof x=="string"&&q.test(x)?M:null}}catch(q){return r}}function k(M,q,x){return!M||typeof q!="string"?!1:F(M)(q,void 0,x)}e.match=k;function F(M,q={}){if(!M)return s;if(typeof M=="string"||j(M)){const x=n(M,q);if(x===r)return s;const K=function(ee,de){return!!x(ee,de)};return x.allBasenames&&(K.allBasenames=x.allBasenames),x.allPaths&&(K.allPaths=x.allPaths),K}return R(M,q)}e.parse=F;function $(M){if(!M)return;let q;return x=>(q||(q=(M()||Promise.resolve([])).then(K=>K?oe(K):{})),q.then(K=>!!K[x]))}e.hasSiblingPromiseFn=$;function Q(M){if(!M)return;let q;return x=>{if(!q){const K=M();q=K?oe(K):{}}return!!q[x]}}e.hasSiblingFn=Q;function oe(M){const q={};for(const x of M)q[x]=!0;return q}function j(M){const q=M;return q&&typeof q.base=="string"&&typeof q.pattern=="string"}e.isRelativePattern=j;function O(M){return M.allBasenames||[]}e.getBasenameTerms=O;function B(M){return M.allPaths||[]}e.getPathTerms=B;function R(M,q){const x=N(Object.getOwnPropertyNames(M).map(De=>z(De,M[De],q)).filter(De=>De!==r)),K=x.length;if(!K)return r;if(!x.some(De=>!!De.requiresSiblings)){if(K===1)return x[0];const De=function(We,je){for(let W=0,Z=x.length;W<Z;W++){const te=x[W](We,je);if(te)return te}return null},Le=x.find(We=>!!We.allBasenames);Le&&(De.allBasenames=Le.allBasenames);const qe=x.reduce((We,je)=>je.allPaths?We.concat(je.allPaths):We,[]);return qe.length&&(De.allPaths=qe),De}const ee=function(De,Le,qe){let We;for(let je=0,W=x.length;je<W;je++){const Z=x[je];Z.requiresSiblings&&qe&&(Le||(Le=C.basename(De)),We||(We=Le.substr(0,Le.length-C.extname(De).length)));const te=Z(De,Le,We,qe);if(te)return te}return null},de=x.find(De=>!!De.allBasenames);de&&(ee.allBasenames=de.allBasenames);const Se=x.reduce((De,Le)=>Le.allPaths?De.concat(Le.allPaths):De,[]);return Se.length&&(ee.allPaths=Se),ee}function z(M,q,x){if(q===!1)return r;const K=n(M,x);if(K===r)return r;if(typeof q=="boolean")return K;if(q){const ee=q.when;if(typeof ee=="string"){const de=(Se,De,Le,qe)=>{if(!qe||!K(Se,De))return null;const We=ee.replace("$(basename)",Le),je=qe(We);return(0,T.isThenable)(je)?je.then(W=>W?M:null):je?M:null};return de.requiresSiblings=!0,de}}return K}function N(M,q){const x=M.filter(De=>!!De.basenames);if(x.length<2)return M;const K=x.reduce((De,Le)=>{const qe=Le.basenames;return qe?De.concat(qe):De},[]);let ee;if(q){ee=[];for(let De=0,Le=K.length;De<Le;De++)ee.push(q)}else ee=x.reduce((De,Le)=>{const qe=Le.patterns;return qe?De.concat(qe):De},[]);const de=function(De,Le){if(typeof De!="string")return null;if(!Le){let We;for(We=De.length;We>0;We--){const je=De.charCodeAt(We-1);if(je===47||je===92)break}Le=De.substr(We)}const qe=K.indexOf(Le);return qe!==-1?ee[qe]:null};de.basenames=K,de.patterns=ee,de.allBasenames=K;const Se=M.filter(De=>!De.basenames);return Se.push(de),Se}}),define(me[76],ge([0,1,2,9,8,10,11,24,29]),function(J,e,p,L,C,S,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function A(n,l,f){if(typeof n=="string"&&(n=p.URI.file(n)),f){const E=f.getWorkspaceFolder(n);if(E){const y=f.getWorkspace().folders.length>1;let o;if((0,I.isEqual)(E.uri,n)?o="":o=(0,I.relativePath)(E.uri,n),y){const k=E.name?E.name:(0,I.basename)(E.uri);o=o?k+" \u2022 "+o:k}return o}}if(n.scheme!==S.Schemas.file&&n.scheme!==S.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,D.hasDriveLetter)(n.fsPath))return(0,L.normalize)(P(n.fsPath));let m=(0,L.normalize)(n.fsPath);return!T.isWindows&&l?.userHome&&(m=u(m,l.userHome.fsPath)),m}e.getPathLabel=A;function i(n){if(!n)return;typeof n=="string"&&(n=p.URI.file(n));const l=(0,I.basename)(n)||(n.scheme===S.Schemas.file?n.fsPath:n.path);return T.isWindows&&(0,D.isRootOrDriveLetter)(l)?P(l):l}e.getBaseLabel=i;function P(n){return(0,D.hasDriveLetter)(n)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=P;let c=Object.create(null);function u(n,l){if(T.isWindows||!n||!l)return n;let f=c.original===l?c.normalized:void 0;return f||(f=`${(0,C.rtrim)(l,L.posix.sep)}${L.posix.sep}`,c={original:l,normalized:f}),(T.isLinux?n.startsWith(f):(0,C.startsWithIgnoreCase)(n,f))&&(n=`~/${n.substr(f.length)}`),n}e.tildify=u;function a(n,l){return n.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=a;const g="\u2026",w="\\\\",_="~";function b(n,l=L.sep){const f=new Array(n.length);let m=!1;for(let E=0;E<n.length;E++){let y=n[E];if(y===""){f[E]=`.${l}`;continue}if(!y){f[E]=y;continue}m=!0;let o="";y.indexOf(w)===0?(o=y.substr(0,y.indexOf(w)+w.length),y=y.substr(y.indexOf(w)+w.length)):y.indexOf(l)===0?(o=y.substr(0,y.indexOf(l)+l.length),y=y.substr(y.indexOf(l)+l.length)):y.indexOf(_)===0&&(o=y.substr(0,y.indexOf(_)+_.length),y=y.substr(y.indexOf(_)+_.length));const k=y.split(l);for(let F=1;m&&F<=k.length;F++)for(let $=k.length-F;m&&$>=0;$--){m=!1;let Q=k.slice($,$+F).join(l);for(let oe=0;!m&&oe<n.length;oe++)if(oe!==E&&n[oe]&&n[oe].indexOf(Q)>-1){const j=$+F===k.length,O=$>0&&n[oe].indexOf(l)>-1?l+Q:Q,B=n[oe].endsWith(O);m=!j||B}if(!m){let oe="";(k[0].endsWith(":")||o!=="")&&($===1&&($=0,F++,Q=k[0]+l+Q),$>0&&(oe=k[0]+l),oe=o+oe),$>0&&(oe=oe+g+l),oe=oe+Q,$+F<k.length&&(oe=oe+l+g),f[E]=oe}}m&&(f[E]=y)}return f}e.shorten=b;var d;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function h(n,l=Object.create(null)){const f=[];let m=!1,E="";for(const y of n)if(y==="$"||m&&y==="{")E&&f.push({value:E,type:d.TEXT}),E="",m=!0;else if(y==="}"&&m){const o=l[E];if(typeof o=="string")o.length&&f.push({value:o,type:d.VARIABLE});else if(o){const k=f[f.length-1];(!k||k.type!==d.SEPARATOR)&&f.push({value:o.label,type:d.SEPARATOR})}E="",m=!1}else E+=y;return E&&!m&&f.push({value:E,type:d.TEXT}),f.filter((y,o)=>{if(y.type===d.SEPARATOR){const k=f[o-1],F=f[o+1];return[k,F].every($=>$&&($.type===d.VARIABLE||$.type===d.TEXT)&&$.value.length>0)}return!0}).map(y=>y.value).join("")}e.template=h;function v(n,l){return T.isMacintosh||l?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):n.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=v;function t(n,l){return T.isMacintosh||l?n.replace(/\(&&\w\)|&&/g,""):T.isWindows?n.replace(/&&|&/g,f=>f==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function s(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=s;function r(n){const l=n.indexOf("/")!==-1?L.posix:L.win32,f=l.basename(n),m=l.dirname(n);return f.length?{name:f,parentPath:m}:{name:m,parentPath:""}}e.splitName=r}),define(me[99],ge([0,1,9,8,30,10,24]),function(J,e,p,L,C,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var I;(function(s){s.text="text/plain",s.binary="application/octet-stream",s.unknown="application/unknown",s.markdown="text/markdown"})(I=e.Mimes||(e.Mimes={}));let D=[],A=[],i=[];function P(s,r=!1){const n=c(s);D.push(n),n.userConfigured?i.push(n):A.push(n),r&&!n.userConfigured&&D.forEach(l=>{l.mime===n.mime||l.userConfigured||(n.extension&&l.extension===n.extension&&console.warn(`Overwriting extension <<${n.extension}>> to now point to mime <<${n.mime}>>`),n.filename&&l.filename===n.filename&&console.warn(`Overwriting filename <<${n.filename}>> to now point to mime <<${n.mime}>>`),n.filepattern&&l.filepattern===n.filepattern&&console.warn(`Overwriting filepattern <<${n.filepattern}>> to now point to mime <<${n.mime}>>`),n.firstline&&l.firstline===n.firstline&&console.warn(`Overwriting firstline <<${n.firstline}>> to now point to mime <<${n.mime}>>`))})}e.registerTextMime=P;function c(s){return{id:s.id,mime:s.mime,filename:s.filename,extension:s.extension,filepattern:s.filepattern,firstline:s.firstline,userConfigured:s.userConfigured,filenameLowercase:s.filename?s.filename.toLowerCase():void 0,extensionLowercase:s.extension?s.extension.toLowerCase():void 0,filepatternLowercase:s.filepattern?s.filepattern.toLowerCase():void 0,filepatternOnPath:s.filepattern?s.filepattern.indexOf(p.posix.sep)>=0:!1}}function u(s){s?(D=D.filter(r=>!r.userConfigured),i=[]):(D=[],A=[],i=[])}e.clearTextMimes=u;function a(s,r){let n;if(s)switch(s.scheme){case S.Schemas.file:n=s.fsPath;break;case S.Schemas.data:n=T.DataUri.parseMetaData(s).get(T.DataUri.META_DATA_LABEL);break;default:n=s.path}if(!n)return[I.unknown];n=n.toLowerCase();const l=(0,p.basename)(n),f=g(n,l,i);if(f)return[f,I.text];const m=g(n,l,A);if(m)return[m,I.text];if(r){const E=w(r);if(E)return[E,I.text]}return[I.unknown]}e.guessMimeTypes=a;function g(s,r,n){let l=null,f=null,m=null;for(let E=n.length-1;E>=0;E--){const y=n[E];if(r===y.filenameLowercase){l=y;break}if(y.filepattern&&(!f||y.filepattern.length>f.filepattern.length)){const o=y.filepatternOnPath?s:r;(0,C.match)(y.filepatternLowercase,o)&&(f=y)}y.extension&&(!m||y.extension.length>m.extension.length)&&r.endsWith(y.extensionLowercase)&&(m=y)}return l?l.mime:f?f.mime:m?m.mime:null}function w(s){if((0,L.startsWithUTF8BOM)(s)&&(s=s.substr(1)),s.length>0)for(let r=D.length-1;r>=0;r--){const n=D[r];if(!n.firstline)continue;const l=s.match(n.firstline);if(l&&l.length>0)return n.mime}return null}function _(s){return s?typeof s=="string"?s===I.binary||s===I.text||s===I.unknown:s.length===1&&_(s[0]):!0}e.isUnspecific=_;const b={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function d(s){const r=(0,p.extname)(s);return b[r.toLowerCase()]}e.getMediaMime=d;function h(s){for(const r in b)if(b[r]===s)return r}e.getExtensionForMimeType=h;const v=/^(.+)\/(.+?)(;.+)?$/;function t(s,r){const n=v.exec(s);return n?`${n[1].toLowerCase()}/${n[2].toLowerCase()}${n[3]??""}`:r?void 0:s}e.normalizeMimeType=t}),define(me[100],ge([0,1,2]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(i){return i.toJSON()}class C{constructor(P){this._uriTransformer=P}transformIncoming(P){const c=this._uriTransformer.transformIncoming(P);return c===P?P:L(p.URI.from(c))}transformOutgoing(P){const c=this._uriTransformer.transformOutgoing(P);return c===P?P:L(p.URI.from(c))}transformOutgoingURI(P){const c=this._uriTransformer.transformOutgoing(P);return c===P?P:p.URI.from(c)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function S(i,P,c){if(!i||c>200)return null;if(typeof i=="object"){if(i instanceof p.URI)return P.transformOutgoing(i);for(let u in i)if(Object.hasOwnProperty.call(i,u)){const a=S(i[u],P,c+1);a!==null&&(i[u]=a)}}return null}function T(i,P){const c=S(i,P,0);return c===null?i:c}e.transformOutgoingURIs=T;function I(i,P,c,u){if(!i||u>200)return null;if(typeof i=="object"){if(i.$mid===1)return c?p.URI.revive(P.transformIncoming(i)):P.transformIncoming(i);for(let a in i)if(Object.hasOwnProperty.call(i,a)){const g=I(i[a],P,c,u+1);g!==null&&(i[a]=g)}}return null}function D(i,P){const c=I(i,P,!1,0);return c===null?i:c}e.transformIncomingURIs=D;function A(i,P){const c=I(i,P,!0,0);return c===null?i:c}e.transformAndReviveIncomingURIs=A}),define(me[32],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(D){return p.test(D)}e.isUUID=L;const C=new Uint8Array(16),S=[];for(let D=0;D<256;D++)S.push(D.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(D){for(let A=0;A<D.length;A++)D[A]=Math.floor(Math.random()*256);return D};function I(){T(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let D=0,A="";return A+=S[C[D++]],A+=S[C[D++]],A+=S[C[D++]],A+=S[C[D++]],A+="-",A+=S[C[D++]],A+=S[C[D++]],A+="-",A+=S[C[D++]],A+=S[C[D++]],A+="-",A+=S[C[D++]],A+=S[C[D++]],A+="-",A+=S[C[D++]],A+=S[C[D++]],A+=S[C[D++]],A+=S[C[D++]],A+=S[C[D++]],A+=S[C[D++]],A}e.generateUuid=I}),define(me[139],ge([0,1,101]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(S="utf8"){this.stringDecoder=new p.StringDecoder(S),this.remaining=null}write(S){const T=[],I=this.remaining?this.remaining+this.stringDecoder.write(S):this.stringDecoder.write(S);if(I.length<1)return T;let D=0,A,i=D;for(;i<I.length;)if(A=I.charCodeAt(i),A===13||A===10){if(T.push(I.substring(D,i)),i++,i<I.length){const P=A;A=I.charCodeAt(i),(P===13&&A===10||P===10&&A===13)&&i++}D=i}else i++;return this.remaining=D<I.length?I.substr(D):null,T}end(){return this.remaining}}e.LineDecoder=L}),define(me[28],ge([0,1,45,102,283,9,17,11,29,32,75,24,2]),function(J,e,p,L,C,S,T,I,D,A,i,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var u;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(u=e.RimRafMode||(e.RimRafMode={}));async function a(O,B=u.UNLINK){if((0,D.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return B===u.UNLINK?w(O):g(O)}async function g(O){try{const B=(0,S.join)((0,L.tmpdir)(),(0,A.generateUuid)());try{await e.Promises.rename(O,B)}catch(R){return w(O)}w(B).catch(R=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function w(O){return e.Promises.rmdir(O,{recursive:!0,maxRetries:3})}function _(O){if((0,D.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync(O,{recursive:!0})}e.rimrafSync=_;async function b(O,B){return v(await(B?d(O):(0,C.promisify)(p.readdir)(O)))}async function d(O){try{return await(0,C.promisify)(p.readdir)(O,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const B=[],R=await b(O);for(const z of R){let N=!1,M=!1,q=!1;try{const x=await e.Promises.lstat((0,S.join)(O,z));N=x.isFile(),M=x.isDirectory(),q=x.isSymbolicLink()}catch(x){console.warn("[node.js fs] unexpected error from lstat after readdir: ",x)}B.push({name:z,isFile:()=>N,isDirectory:()=>M,isSymbolicLink:()=>q})}return B}function h(O){return v(p.readdirSync(O))}e.readdirSync=h;function v(O){return O.map(B=>typeof B=="string"?I.isMacintosh?(0,i.normalizeNFC)(B):B:(B.name=I.isMacintosh?(0,i.normalizeNFC)(B.name):B.name,B))}async function t(O){const B=await b(O),R=[];for(const z of B)await r.existsDirectory((0,S.join)(O,z))&&R.push(z);return R}function s(O,B=1e3){return new Promise(R=>{let z=!1;const N=setInterval(()=>{z||(z=!0,p.access(O,M=>{z=!1,M&&(clearInterval(N),R(void 0))}))},B)})}e.whenDeleted=s;var r;(function(O){async function B(N){let M;try{if(M=await e.Promises.lstat(N),!M.isSymbolicLink())return{stat:M}}catch(q){}try{return{stat:await e.Promises.stat(N),symbolicLink:M?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};if(I.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(N)),symbolicLink:{dangling:!1}}}catch(x){if(x.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};throw x}throw q}}O.stat=B;async function R(N){try{const{stat:M,symbolicLink:q}=await O.stat(N);return M.isFile()&&q?.dangling!==!0}catch(M){}return!1}O.existsFile=R;async function z(N){try{const{stat:M,symbolicLink:q}=await O.stat(N);return M.isDirectory()&&q?.dangling!==!0}catch(M){}return!1}O.existsDirectory=z})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new T.ResourceQueue;function l(O,B,R){return n.queueFor(c.URI.file(O),P.extUriBiasedIgnorePathCase).queue(()=>{const z=y(R);return new Promise((N,M)=>m(O,B,z,q=>q?M(q):N()))})}let f=!0;function m(O,B,R,z){if(!f)return p.writeFile(O,B,{mode:R.mode,flag:R.flag},z);p.open(O,R.flag,R.mode,(N,M)=>{if(N)return z(N);p.writeFile(M,B,q=>{if(q)return p.close(M,()=>z(q));p.fdatasync(M,x=>(x&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",x),f=!1),p.close(M,K=>z(K))))})})}function E(O,B,R){const z=y(R);if(!f)return p.writeFileSync(O,B,{mode:z.mode,flag:z.flag});const N=p.openSync(O,z.flag,z.mode);try{p.writeFileSync(N,B);try{p.fdatasyncSync(N)}catch(M){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",M),f=!1}}finally{p.closeSync(N)}}e.writeFileSync=E;function y(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function o(O,B){if(O===B)return;async function R(z){try{const N=await e.Promises.lstat(z);if(N.isDirectory()||N.isSymbolicLink())return;await e.Promises.utimes(z,N.atime,new Date)}catch(N){}}try{await e.Promises.rename(O,B),await R(B)}catch(z){if(O.toLowerCase()!==B.toLowerCase()&&z.code==="EXDEV"||O.endsWith("."))await k(O,B,{preserveSymlinks:!1}),await a(O,u.MOVE),await R(B);else throw z}}async function k(O,B,R){return $(O,B,{root:{source:O,target:B},options:R,handledSourcePaths:new Set})}const F=511;async function $(O,B,R){if(R.handledSourcePaths.has(O))return;R.handledSourcePaths.add(O);const{stat:z,symbolicLink:N}=await r.stat(O);if(N){if(R.options.preserveSymlinks)try{return await j(O,B,R)}catch(M){console.warn("[node.js fs] copy of symlink failed: ",M)}if(N.dangling)return}return z.isDirectory()?Q(O,B,z.mode&F,R):oe(O,B,z.mode&F)}async function Q(O,B,R,z){await e.Promises.mkdir(B,{recursive:!0,mode:R});const N=await b(O);for(const M of N)await $((0,S.join)(O,M),(0,S.join)(B,M),z)}async function oe(O,B,R){await e.Promises.copyFile(O,B),await e.Promises.chmod(B,R)}async function j(O,B,R){let z=await e.Promises.readlink(O);(0,D.isEqualOrParent)(z,R.root.source,!I.isLinux)&&(z=(0,S.join)(R.root.target,z.substr(R.root.source.length+1))),await e.Promises.symlink(z,B)}e.Promises=new class{get access(){return(0,C.promisify)(p.access)}get stat(){return(0,C.promisify)(p.stat)}get lstat(){return(0,C.promisify)(p.lstat)}get utimes(){return(0,C.promisify)(p.utimes)}get read(){return(0,C.promisify)(p.read)}get readFile(){return(0,C.promisify)(p.readFile)}get write(){return(0,C.promisify)(p.write)}get appendFile(){return(0,C.promisify)(p.appendFile)}get fdatasync(){return(0,C.promisify)(p.fdatasync)}get truncate(){return(0,C.promisify)(p.truncate)}get rename(){return(0,C.promisify)(p.rename)}get copyFile(){return(0,C.promisify)(p.copyFile)}get open(){return(0,C.promisify)(p.open)}get close(){return(0,C.promisify)(p.close)}get symlink(){return(0,C.promisify)(p.symlink)}get readlink(){return(0,C.promisify)(p.readlink)}get chmod(){return(0,C.promisify)(p.chmod)}get mkdir(){return(0,C.promisify)(p.mkdir)}get unlink(){return(0,C.promisify)(p.unlink)}get rmdir(){return(0,C.promisify)(p.rmdir)}get realpath(){return(0,C.promisify)(p.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return t}get writeFile(){return l}get rm(){return a}get move(){return o}get copy(){return k}}}),define(me[103],ge([0,1,45,8,9,28]),function(J,e,p,L,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function T(i){const P=(0,C.dirname)(i);if(i===P)return i;const c=((0,C.basename)(i)||i).toLowerCase();try{const a=(0,S.readdirSync)(P).filter(g=>g.toLowerCase()===c);if(a.length===1){const g=T(P);if(g)return(0,C.join)(g,a[0])}else if(a.length>1){const g=a.indexOf(c);if(g>=0){const w=T(P);if(w)return(0,C.join)(w,a[g])}}}catch(u){}return null}e.realcaseSync=T;async function I(i){try{return await S.Promises.realpath(i)}catch(P){const c=A(i);return await S.Promises.access(c,p.constants.R_OK),c}}e.realpath=I;function D(i){try{return p.realpathSync(i)}catch(P){const c=A(i);return p.accessSync(c,p.constants.R_OK),c}}e.realpathSync=D;function A(i){return(0,L.rtrim)((0,C.normalize)(i),C.sep)}});var Ve=this&&this.__decorate||function(J,e,p,L){var C=arguments.length,S=C<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,p):L,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate(J,e,p,L);else for(var I=J.length-1;I>=0;I--)(T=J[I])&&(S=(C<3?T(S):C>3?T(e,p,S):T(e,p))||S);return C>3&&S&&Object.defineProperty(e,p,S),S};define(me[104],ge([0,1,3,6,17,21,15,22,18,14,57,8,53]),function(J,e,p,L,C,S,T,I,D,A,i,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var u;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(u=e.RequestType||(e.RequestType={}));function a(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function w(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var _;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(_||(_={}));class b{constructor(M){this.buffer=M,this.pos=0}read(M){const q=this.buffer.slice(this.pos,this.pos+M);return this.pos+=q.byteLength,q}}class d{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}var h;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object"})(h||(h={}));function v(N){const M=I.VSBuffer.alloc(4);return M.writeUInt32BE(N,0),M}function t(N){return N.read(4).readUInt32BE(0)}function s(N){const M=I.VSBuffer.alloc(1);return M.writeUInt8(N,0),M}const r={Undefined:s(h.Undefined),String:s(h.String),Buffer:s(h.Buffer),VSBuffer:s(h.VSBuffer),Array:s(h.Array),Object:s(h.Object)},n=typeof Buffer!="undefined";function l(N,M){if(typeof M=="undefined")N.write(r.Undefined);else if(typeof M=="string"){const q=I.VSBuffer.fromString(M);N.write(r.String),N.write(v(q.byteLength)),N.write(q)}else if(n&&Buffer.isBuffer(M)){const q=I.VSBuffer.wrap(M);N.write(r.Buffer),N.write(v(q.byteLength)),N.write(q)}else if(M instanceof I.VSBuffer)N.write(r.VSBuffer),N.write(v(M.byteLength)),N.write(M);else if(Array.isArray(M)){N.write(r.Array),N.write(v(M.length));for(const q of M)l(N,q)}else{const q=I.VSBuffer.fromString(JSON.stringify(M));N.write(r.Object),N.write(v(q.byteLength)),N.write(q)}}function f(N){switch(N.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return N.read(t(N)).toString();case h.Buffer:return N.read(t(N)).buffer;case h.VSBuffer:return N.read(t(N));case h.Array:{const q=t(N),x=[];for(let K=0;K<q;K++)x.push(f(N));return x}case h.Object:return JSON.parse(N.read(t(N)).toString())}}class m{constructor(M,q,x=null,K=1e3){this.protocol=M,this.ctx=q,this.logger=x,this.timeoutDelay=K,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ee=>this.onRawMessage(ee)),this.sendResponse({type:200})}registerChannel(M,q){this.channels.set(M,q),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const q=this.send([M.type]);this.logger&&this.logger.logOutgoing(q,0,1,w(M.type));return}case 201:case 202:case 204:case 203:{const q=this.send([M.type,M.id],M.data);this.logger&&this.logger.logOutgoing(q,M.id,1,w(M.type),M.data);return}}}send(M,q=void 0){const x=new d;return l(x,M),l(x,q),this.sendBuffer(x.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(q){return 0}}onRawMessage(M){const q=new b(M),x=f(q),K=f(q),ee=x[0];switch(ee){case 100:return this.logger&&this.logger.logIncoming(M.byteLength,x[1],1,`${a(ee)}: ${x[2]}.${x[3]}`,K),this.onPromise({type:ee,id:x[1],channelName:x[2],name:x[3],arg:K});case 102:return this.logger&&this.logger.logIncoming(M.byteLength,x[1],1,`${a(ee)}: ${x[2]}.${x[3]}`,K),this.onEventListen({type:ee,id:x[1],channelName:x[2],name:x[3],arg:K});case 101:return this.logger&&this.logger.logIncoming(M.byteLength,x[1],1,`${a(ee)}`),this.disposeActiveRequest({type:ee,id:x[1]});case 103:return this.logger&&this.logger.logIncoming(M.byteLength,x[1],1,`${a(ee)}`),this.disposeActiveRequest({type:ee,id:x[1]})}}onPromise(M){const q=this.channels.get(M.channelName);if(!q){this.collectPendingRequest(M);return}const x=new S.CancellationTokenSource;let K;try{K=q.call(this.ctx,M.name,M.arg,x.token)}catch(Se){K=Promise.reject(Se)}const ee=M.id;K.then(Se=>{this.sendResponse({id:ee,data:Se,type:201}),this.activeRequests.delete(M.id)},Se=>{Se instanceof Error?this.sendResponse({id:ee,data:{message:Se.message,name:Se.name,stack:Se.stack?Se.stack.split?Se.stack.split(`
`):Se.stack:void 0},type:202}):this.sendResponse({id:ee,data:Se,type:203}),this.activeRequests.delete(M.id)});const de=(0,L.toDisposable)(()=>x.cancel());this.activeRequests.set(M.id,de)}onEventListen(M){const q=this.channels.get(M.channelName);if(!q){this.collectPendingRequest(M);return}const x=M.id,ee=q.listen(this.ctx,M.name,M.arg)(de=>this.sendResponse({id:x,data:de,type:204}));this.activeRequests.set(M.id,ee)}disposeActiveRequest(M){const q=this.activeRequests.get(M.id);q&&(q.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let q=this.pendingRequests.get(M.channelName);q||(q=[],this.pendingRequests.set(M.channelName,q));const x=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:M,timeoutTimer:x})}flushPendingRequests(M){const q=this.pendingRequests.get(M);if(q){for(const x of q)switch(clearTimeout(x.timeoutTimer),x.request.type){case 100:this.onPromise(x.request);break;case 102:this.onEventListen(x.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}e.ChannelServer=m;var E;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(E=e.RequestInitiator||(e.RequestInitiator={}));class y{constructor(M,q=null){this.protocol=M,this.isDisposed=!1,this.state=_.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(x=>this.onBuffer(x)),this.logger=q}getChannel(M){const q=this;return{call(x,K,ee){return q.isDisposed?Promise.reject(T.canceled()):q.requestPromise(M,x,K,ee)},listen(x,K){return q.isDisposed?Promise.reject(T.canceled()):q.requestEvent(M,x,K)}}}requestPromise(M,q,x,K=S.CancellationToken.None){const ee=this.lastRequestId++,Se={id:ee,type:100,channelName:M,name:q,arg:x};if(K.isCancellationRequested)return Promise.reject(T.canceled());let De;return new Promise((qe,We)=>{if(K.isCancellationRequested)return We(T.canceled());const je=()=>{const ae=Y=>{switch(Y.type){case 201:this.handlers.delete(ee),qe(Y.data);break;case 202:this.handlers.delete(ee);const se=new Error(Y.data.message);se.stack=Y.data.stack,se.name=Y.data.name,We(se);break;case 203:this.handlers.delete(ee),We(Y.data);break}};this.handlers.set(ee,ae),this.sendRequest(Se)};let W=null;this.state===_.Idle?je():(W=(0,C.createCancelablePromise)(ae=>this.whenInitialized()),W.then(()=>{W=null,je()}));const Z=()=>{W?(W.cancel(),W=null):this.sendRequest({id:ee,type:101}),We(T.canceled())},te=K.onCancellationRequested(Z);De=(0,L.combinedDisposable)((0,L.toDisposable)(Z),te),this.activeRequests.add(De)}).finally(()=>{this.activeRequests.delete(De)})}requestEvent(M,q,x){const K=this.lastRequestId++,de={id:K,type:102,channelName:M,name:q,arg:x};let Se=null;const De=new p.Emitter({onFirstListenerAdd:()=>{Se=(0,C.createCancelablePromise)(qe=>this.whenInitialized()),Se.then(()=>{Se=null,this.activeRequests.add(De),this.sendRequest(de)})},onLastListenerRemove:()=>{Se?(Se.cancel(),Se=null):(this.activeRequests.delete(De),this.sendRequest({id:K,type:103}))}}),Le=qe=>De.fire(qe.data);return this.handlers.set(K,Le),De.event}sendRequest(M){switch(M.type){case 100:case 102:{const q=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger&&this.logger.logOutgoing(q,M.id,0,`${a(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const q=this.send([M.type,M.id]);this.logger&&this.logger.logOutgoing(q,M.id,0,a(M.type));return}}}send(M,q=void 0){const x=new d;return l(x,M),l(x,q),this.sendBuffer(x.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(q){return 0}}onBuffer(M){const q=new b(M),x=f(q),K=f(q),ee=x[0];switch(ee){case 200:return this.logger&&this.logger.logIncoming(M.byteLength,0,0,w(ee)),this.onResponse({type:x[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(M.byteLength,x[1],0,w(ee),K),this.onResponse({type:x[0],id:x[1],data:K})}}onResponse(M){if(M.type===200){this.state=_.Idle,this._onDidInitialize.fire();return}const q=this.handlers.get(M.id);q&&q(M)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===_.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}Ve([c.memoize],y.prototype,"onDidInitializePromise",null),e.ChannelClient=y;class o{constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,M(({protocol:q,onDidClientDisconnect:x})=>{p.Event.once(q.onMessage)(ee=>{const de=new b(ee),Se=f(de),De=new m(q,Se),Le=new y(q);this.channels.forEach((We,je)=>De.registerChannel(je,We));const qe={channelServer:De,channelClient:Le,ctx:Se};this._connections.add(qe),this._onDidAddConnection.fire(qe),x(()=>{De.dispose(),Le.dispose(),this._connections.delete(qe),this._onDidRemoveConnection.fire(qe)})})})}get connections(){const M=[];return this._connections.forEach(q=>M.push(q)),M}getChannel(M,q){const x=this;return{call(K,ee,de){let Se;if((0,A.isFunction)(q)){let Le=(0,D.getRandomElement)(x.connections.filter(q));Se=Le?Promise.resolve(Le):p.Event.toPromise(p.Event.filter(x.onDidAddConnection,q))}else Se=q.routeCall(x,K,ee);const De=Se.then(Le=>Le.channelClient.getChannel(M));return F(De).call(K,ee,de)},listen(K,ee){if((0,A.isFunction)(q))return x.getMulticastEvent(M,q,K,ee);const de=q.routeEvent(x,K,ee).then(Se=>Se.channelClient.getChannel(M));return F(de).listen(K,ee)}}}getMulticastEvent(M,q,x,K){const ee=this;let de=new L.DisposableStore;const Se=new p.Emitter({onFirstListenerAdd:()=>{de=new L.DisposableStore;const De=new p.EventMultiplexer,Le=new Map,qe=je=>{const Z=je.channelClient.getChannel(M).listen(x,K),te=De.add(Z);Le.set(je,te)},We=je=>{const W=Le.get(je);!W||(W.dispose(),Le.delete(je))};ee.connections.filter(q).forEach(qe),p.Event.filter(ee.onDidAddConnection,q)(qe,void 0,de),ee.onDidRemoveConnection(We,void 0,de),De.event(Se.fire,Se,de),de.add(De)},onLastListenerRemove:()=>{de.dispose()}});return Se.event}registerChannel(M,q){this.channels.set(M,q),this._connections.forEach(x=>{x.channelServer.registerChannel(M,q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=o;class k{constructor(M,q,x=null){const K=new d;l(K,q),M.send(K.buffer),this.channelClient=new y(M,x),this.channelServer=new m(M,q,x)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,q){this.channelServer.registerChannel(M,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=k;function F(N){return{call(M,q,x){return N.then(K=>K.call(M,q,x))},listen(M,q){const x=new p.Relay;return N.then(K=>x.input=K.listen(M,q)),x.event}}}e.getDelayedChannel=F;function $(N){let M=!1;return{call(q,x,K){return M?N.call(q,x,K):(0,C.timeout)(0).then(()=>M=!0).then(()=>N.call(q,x,K))},listen(q,x){if(M)return N.listen(q,x);const K=new p.Relay;return(0,C.timeout)(0).then(()=>M=!0).then(()=>K.input=N.listen(q,x)),K.event}}}e.getNextTickChannel=$;class Q{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const q of M.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await p.Event.toPromise(M.onDidAddConnection),await this.route(M)}}e.StaticRouter=Q;var oe;(function(N){function M(K,ee){const de=K,Se=ee&&ee.disableMarshalling,De=new Map;for(const Le in de)x(Le)&&De.set(Le,p.Event.buffer(de[Le],!0));return new class{listen(Le,qe){const We=De.get(qe);if(We)return We;throw new Error(`Event not found: ${qe}`)}call(Le,qe,We){const je=de[qe];if(typeof je=="function"){if(!Se&&Array.isArray(We))for(let W=0;W<We.length;W++)We[W]=(0,i.revive)(We[W]);return je.apply(de,We)}throw new Error(`Method not found: ${qe}`)}}}N.fromService=M;function q(K,ee){const de=ee&&ee.disableMarshalling;return new Proxy({},{get(Se,De){if(typeof De=="string")return ee?.properties?.has(De)?ee.properties.get(De):x(De)?K.listen(De):async function(...Le){let qe;ee&&!(0,A.isUndefinedOrNull)(ee.context)?qe=[ee.context,...Le]:qe=Le;const We=await K.call(De,qe);return de?We:(0,i.revive)(We)};throw new Error(`Property not found: ${String(De)}`)}})}N.toService=q;function x(K){return K[0]==="o"&&K[1]==="n"&&P.isUpperAsciiLetter(K.charCodeAt(2))}})(oe=e.ProxyChannel||(e.ProxyChannel={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){let M=N.toString();if(M!=="[object Object]")return M}return N}function B(N){return Array.isArray(N)?N.map(O):O(N)}function R(N,M,q,x,K,ee,de){de=B(de);const Se=j[K],De=Se[x%Se.length];let Le=[`%c[${N}]%c[${String(M).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(x).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${De}`];/\($/.test(ee)?(Le=Le.concat(de),Le.push(")")):Le.push(de),console.log.apply(console,Le)}e.logWithColors=R;class z{constructor(M,q){this._outgoingPrefix=M,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,q,x,K,ee){this._totalOutgoing+=M,R(this._outgoingPrefix,this._totalOutgoing,M,q,x,K,ee)}logIncoming(M,q,x,K,ee){this._totalIncoming+=M,R(this._incomingPrefix,this._totalIncoming,M,q,x,K,ee)}}e.IPCLogger=z}),define(me[105],ge([0,1,3,104,6,22,11,37]),function(J,e,p,L,C,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var D;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(D=e.SocketCloseEventType||(e.SocketCloseEventType={}));let A=null;function i(){return A||(A=S.VSBuffer.alloc(0)),A}class P{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,l){if(n===0)return i();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const y=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=n),y}if(this._chunks[0].byteLength>n){const y=this._chunks[0].slice(0,n);return l&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),y}let f=S.VSBuffer.alloc(n),m=0,E=0;for(;n>0;){const y=this._chunks[E];if(y.byteLength>n){const o=y.slice(0,n);f.set(o,m),m+=n,l&&(this._chunks[E]=y.slice(n),this._totalLength-=n),n-=n}else f.set(y,m),m+=y.byteLength,l?(this._chunks.shift(),this._totalLength-=y.byteLength):E++,n-=y.byteLength}return f}}e.ChunkStream=P;var c;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(c||(c={}));var u;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(u=e.ProtocolConstants||(e.ProtocolConstants={}));class a{constructor(n,l,f,m){this.type=n,this.id=l,this.ack=f,this.data=m,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends C.Disposable{constructor(n){super();this._onMessage=this._register(new p.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new P,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5);else{const f=this._state.messageType,m=this._state.id,E=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new a(f,m,E,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class w{constructor(n){this._isDisposed=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(n){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=S.VSBuffer.alloc(13);l.writeUInt8(n.type,0),l.writeUInt32BE(n.id,1),l.writeUInt32BE(n.ack,5),l.writeUInt32BE(n.data.byteLength,9),this._writeSoon(l,n.data)}_bufferAdd(n,l){const f=this._totalLength===0;return this._data.push(n,l),this._totalLength+=n.byteLength+l.byteLength,f}_bufferTake(){const n=S.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,l){this._bufferAdd(n,l)&&T.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class _ extends C.Disposable{constructor(n){super();this._onMessage=new p.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new p.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new w(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new a(1,0,0,n))}}e.Protocol=_;class b extends L.IPCClient{constructor(n,l,f=null){super(n,l,f);this.protocol=n}static fromSocket(n,l){return new b(new _(n),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=b;class d{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new p.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,I.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=d;class h{constructor(n){this.data=n,this.next=null}}class v{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],l=0,f=this._first;for(;f;)n[l++]=f.data,f=f.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const l=new h(n);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class t{constructor(){this.lastRuns=[];const n=Date.now();for(let l=0;l<t._HISTORY_LENGTH;l++)this.lastRuns[l]=n-1e3*l;setInterval(()=>{for(let l=t._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const n=Date.now(),l=(1+t._HISTORY_LENGTH)*1e3;let f=0;for(let m=0;m<t._HISTORY_LENGTH;m++)n-this.lastRuns[m]<=l&&f++;return 1-f/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class s{constructor(n,l=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new d,this.onControlMessage=this._onControlMessage.event,this._onMessage=new d,this.onMessage=this._onMessage.event,this._onDidDispose=new d,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new d,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new d,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new v,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=n,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),l&&this._socketReader.acceptChunk(l),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,C.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new a(5,0,0,i());this._socketWriter.write(n),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const n=Date.now()-this._socketWriter.lastWriteTime;if(n>=5e3){const l=new a(4,0,0,i());this._socketWriter.write(l),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-n+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const n=Date.now()-this._socketReader.lastReadTime;if(n>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-n,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,l){this._isReconnecting=!0,this._socketDisposables=(0,C.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=n,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1;const n=this._outgoingUnackMsg.toArray();for(let l=0,f=n.length;l<f;l++)this._socketWriter.write(n[l]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(n.type===1){if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new a(6,0,0,i())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data)}else if(n.type===2)this._onControlMessage.fire(n.data);else if(n.type===5)this._onDidDispose.fire();else if(n.type===6){const l=this._outgoingUnackMsg.toArray();for(let f=0,m=l.length;f<m;f++)this._socketWriter.write(l[f]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const f=new a(1,l,this._incomingAckId,n);this._outgoingUnackMsg.push(f),this._isReconnecting||(this._socketWriter.write(f),this._recvAckCheck())}sendControl(n){const l=new a(2,0,0,n);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const n=this._outgoingUnackMsg.peek(),l=Date.now()-n.writtenTime;if(l>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-l,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new a(3,0,this._incomingAckId,i());this._socketWriter.write(n)}}e.PersistentProtocol=s}),define(me[106],ge([0,1,94]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(I){let D=(0,p.toUint8)(I);this._defaultValue=D,this._asciiMap=L._createAsciiMap(D),this._map=new Map}static _createAsciiMap(I){let D=new Uint8Array(256);for(let A=0;A<256;A++)D[A]=I;return D}set(I,D){let A=(0,p.toUint8)(D);I>=0&&I<256?this._asciiMap[I]=A:this._map.set(I,A)}get(I){return I>=0&&I<256?this._asciiMap[I]:this._map.get(I)||this._defaultValue}}e.CharacterClassifier=L;var C;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(C||(C={}));class S{constructor(){this._actual=new L(0)}add(I){this._actual.set(I,1)}has(I){return this._actual.get(I)===1}}e.CharacterSet=S}),define(me[140],ge([0,1,106]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(T){T[T.Regular=0]="Regular",T[T.Whitespace=1]="Whitespace",T[T.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class C extends p.CharacterClassifier{constructor(I){super(0);for(let D=0,A=I.length;D<A;D++)this.set(I.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=C;function S(T){let I={};return D=>(I.hasOwnProperty(D)||(I[D]=T(D)),I[D])}e.getMapForWordSeparators=S(T=>new C(T))}),define(me[46],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class p{constructor(C,S){this.lineNumber=C,this.column=S}with(C=this.lineNumber,S=this.column){return C===this.lineNumber&&S===this.column?this:new p(C,S)}delta(C=0,S=0){return this.with(this.lineNumber+C,this.column+S)}equals(C){return p.equals(this,C)}static equals(C,S){return!C&&!S?!0:!!C&&!!S&&C.lineNumber===S.lineNumber&&C.column===S.column}isBefore(C){return p.isBefore(this,C)}static isBefore(C,S){return C.lineNumber<S.lineNumber?!0:S.lineNumber<C.lineNumber?!1:C.column<S.column}isBeforeOrEqual(C){return p.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,S){return C.lineNumber<S.lineNumber?!0:S.lineNumber<C.lineNumber?!1:C.column<=S.column}static compare(C,S){let T=C.lineNumber|0,I=S.lineNumber|0;if(T===I){let D=C.column|0,A=S.column|0;return D-A}return T-I}clone(){return new p(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new p(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}}e.Position=p}),define(me[40],ge([0,1,46]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(S,T,I,D){S>I||S===I&&T>D?(this.startLineNumber=I,this.startColumn=D,this.endLineNumber=S,this.endColumn=T):(this.startLineNumber=S,this.startColumn=T,this.endLineNumber=I,this.endColumn=D)}isEmpty(){return L.isEmpty(this)}static isEmpty(S){return S.startLineNumber===S.endLineNumber&&S.startColumn===S.endColumn}containsPosition(S){return L.containsPosition(this,S)}static containsPosition(S,T){return!(T.lineNumber<S.startLineNumber||T.lineNumber>S.endLineNumber||T.lineNumber===S.startLineNumber&&T.column<S.startColumn||T.lineNumber===S.endLineNumber&&T.column>S.endColumn)}containsRange(S){return L.containsRange(this,S)}static containsRange(S,T){return!(T.startLineNumber<S.startLineNumber||T.endLineNumber<S.startLineNumber||T.startLineNumber>S.endLineNumber||T.endLineNumber>S.endLineNumber||T.startLineNumber===S.startLineNumber&&T.startColumn<S.startColumn||T.endLineNumber===S.endLineNumber&&T.endColumn>S.endColumn)}strictContainsRange(S){return L.strictContainsRange(this,S)}static strictContainsRange(S,T){return!(T.startLineNumber<S.startLineNumber||T.endLineNumber<S.startLineNumber||T.startLineNumber>S.endLineNumber||T.endLineNumber>S.endLineNumber||T.startLineNumber===S.startLineNumber&&T.startColumn<=S.startColumn||T.endLineNumber===S.endLineNumber&&T.endColumn>=S.endColumn)}plusRange(S){return L.plusRange(this,S)}static plusRange(S,T){let I,D,A,i;return T.startLineNumber<S.startLineNumber?(I=T.startLineNumber,D=T.startColumn):T.startLineNumber===S.startLineNumber?(I=T.startLineNumber,D=Math.min(T.startColumn,S.startColumn)):(I=S.startLineNumber,D=S.startColumn),T.endLineNumber>S.endLineNumber?(A=T.endLineNumber,i=T.endColumn):T.endLineNumber===S.endLineNumber?(A=T.endLineNumber,i=Math.max(T.endColumn,S.endColumn)):(A=S.endLineNumber,i=S.endColumn),new L(I,D,A,i)}intersectRanges(S){return L.intersectRanges(this,S)}static intersectRanges(S,T){let I=S.startLineNumber,D=S.startColumn,A=S.endLineNumber,i=S.endColumn,P=T.startLineNumber,c=T.startColumn,u=T.endLineNumber,a=T.endColumn;return I<P?(I=P,D=c):I===P&&(D=Math.max(D,c)),A>u?(A=u,i=a):A===u&&(i=Math.min(i,a)),I>A||I===A&&D>i?null:new L(I,D,A,i)}equalsRange(S){return L.equalsRange(this,S)}static equalsRange(S,T){return!!S&&!!T&&S.startLineNumber===T.startLineNumber&&S.startColumn===T.startColumn&&S.endLineNumber===T.endLineNumber&&S.endColumn===T.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(S){return new p.Position(S.endLineNumber,S.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(S){return new p.Position(S.startLineNumber,S.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(S,T){return new L(this.startLineNumber,this.startColumn,S,T)}setStartPosition(S,T){return new L(S,T,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(S){return new L(S.startLineNumber,S.startColumn,S.startLineNumber,S.startColumn)}static fromPositions(S,T=S){return new L(S.lineNumber,S.column,T.lineNumber,T.column)}static lift(S){return S?new L(S.startLineNumber,S.startColumn,S.endLineNumber,S.endColumn):null}static isIRange(S){return S&&typeof S.startLineNumber=="number"&&typeof S.startColumn=="number"&&typeof S.endLineNumber=="number"&&typeof S.endColumn=="number"}static areIntersectingOrTouching(S,T){return!(S.endLineNumber<T.startLineNumber||S.endLineNumber===T.startLineNumber&&S.endColumn<T.startColumn||T.endLineNumber<S.startLineNumber||T.endLineNumber===S.startLineNumber&&T.endColumn<S.startColumn)}static areIntersecting(S,T){return!(S.endLineNumber<T.startLineNumber||S.endLineNumber===T.startLineNumber&&S.endColumn<=T.startColumn||T.endLineNumber<S.startLineNumber||T.endLineNumber===S.startLineNumber&&T.endColumn<=S.startColumn)}static compareRangesUsingStarts(S,T){if(S&&T){const A=S.startLineNumber|0,i=T.startLineNumber|0;if(A===i){const P=S.startColumn|0,c=T.startColumn|0;if(P===c){const u=S.endLineNumber|0,a=T.endLineNumber|0;if(u===a){const g=S.endColumn|0,w=T.endColumn|0;return g-w}return u-a}return P-c}return A-i}return(S?1:0)-(T?1:0)}static compareRangesUsingEnds(S,T){return S.endLineNumber===T.endLineNumber?S.endColumn===T.endColumn?S.startLineNumber===T.startLineNumber?S.startColumn-T.startColumn:S.startLineNumber-T.startLineNumber:S.endColumn-T.endColumn:S.endLineNumber-T.endLineNumber}static spansMultipleLines(S){return S.endLineNumber>S.startLineNumber}}e.Range=L}),define(me[141],ge([0,1,46,40]),function(J,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var C;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(C=e.SelectionDirection||(e.SelectionDirection={}));class S extends L.Range{constructor(I,D,A,i){super(I,D,A,i);this.selectionStartLineNumber=I,this.selectionStartColumn=D,this.positionLineNumber=A,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(I){return S.selectionsEqual(this,I)}static selectionsEqual(I,D){return I.selectionStartLineNumber===D.selectionStartLineNumber&&I.selectionStartColumn===D.selectionStartColumn&&I.positionLineNumber===D.positionLineNumber&&I.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(I,D){return this.getDirection()===0?new S(this.startLineNumber,this.startColumn,I,D):new S(I,D,this.startLineNumber,this.startColumn)}getPosition(){return new p.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(I,D){return this.getDirection()===0?new S(I,D,this.endLineNumber,this.endColumn):new S(this.endLineNumber,this.endColumn,I,D)}static fromPositions(I,D=I){return new S(I.lineNumber,I.column,D.lineNumber,D.column)}static liftSelection(I){return new S(I.selectionStartLineNumber,I.selectionStartColumn,I.positionLineNumber,I.positionColumn)}static selectionsArrEqual(I,D){if(I&&!D||!I&&D)return!1;if(!I&&!D)return!0;if(I.length!==D.length)return!1;for(let A=0,i=I.length;A<i;A++)if(!this.selectionsEqual(I[A],D[A]))return!1;return!0}static isISelection(I){return I&&typeof I.selectionStartLineNumber=="number"&&typeof I.selectionStartColumn=="number"&&typeof I.positionLineNumber=="number"&&typeof I.positionColumn=="number"}static createWithDirection(I,D,A,i,P){return P===0?new S(I,D,A,i):new S(A,i,I,D)}}e.Selection=S}),define(me[107],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var p;(function(a){a[a.Left=1]="Left",a[a.Center=2]="Center",a[a.Right=4]="Right",a[a.Full=7]="Full"})(p=e.OverviewRulerLane||(e.OverviewRulerLane={}));var L;(function(a){a[a.Inline=1]="Inline",a[a.Gutter=2]="Gutter"})(L=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(a){a[a.TextDefined=0]="TextDefined",a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var S;(function(a){a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(S=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var T;(function(a){a[a.LF=0]="LF",a[a.CRLF=1]="CRLF"})(T=e.EndOfLineSequence||(e.EndOfLineSequence={}));class I{constructor(g){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,g.tabSize|0),this.indentSize=g.tabSize|0,this.insertSpaces=Boolean(g.insertSpaces),this.defaultEOL=g.defaultEOL|0,this.trimAutoWhitespace=Boolean(g.trimAutoWhitespace)}equals(g){return this.tabSize===g.tabSize&&this.indentSize===g.indentSize&&this.insertSpaces===g.insertSpaces&&this.defaultEOL===g.defaultEOL&&this.trimAutoWhitespace===g.trimAutoWhitespace}createChangeEvent(g){return{tabSize:this.tabSize!==g.tabSize,indentSize:this.indentSize!==g.indentSize,insertSpaces:this.insertSpaces!==g.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==g.trimAutoWhitespace}}}e.TextModelResolvedOptions=I;class D{constructor(g,w){this._findMatchBrand=void 0,this.range=g,this.matches=w}}e.FindMatch=D;var A;(function(a){a[a.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",a[a.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",a[a.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",a[a.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(A=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(a){a[a.Left=0]="Left",a[a.Right=1]="Right",a[a.None=2]="None"})(i=e.PositionAffinity||(e.PositionAffinity={}));var P;(function(a){a[a.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(P=e.ModelConstants||(e.ModelConstants={}));class c{constructor(g,w,_,b,d,h){this.identifier=g,this.range=w,this.text=_,this.forceMoveMarkers=b,this.isAutoWhitespaceEdit=d,this._isTracked=h}}e.ValidAnnotatedEditOperation=c;class u{constructor(g,w,_){this.reverseEdits=g,this.changes=w,this.trimAutoWhitespaceLineNumbers=_}}e.ApplyEditsResult=u}),define(me[142],ge([0,1,8,140,46,40,107]),function(J,e,p,L,C,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const I=999;class D{constructor(d,h,v,t){this.searchString=d,this.isRegex=h,this.matchCase=v,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let d;this.isRegex?d=A(this.searchString):d=this.searchString.indexOf(`
`)>=0;let h=null;try{h=p.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:d,global:!0,unicode:!0})}catch(t){return null}if(!h)return null;let v=!this.isRegex&&!d;return v&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(v=this.matchCase),new i(h,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,v?this.searchString:null)}}e.SearchParams=D;function A(b){if(!b||b.length===0)return!1;for(let d=0,h=b.length;d<h;d++)if(b.charCodeAt(d)===92){if(d++,d>=h)break;const t=b.charCodeAt(d);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=A;class i{constructor(d,h,v){this.regex=d,this.wordSeparators=h,this.simpleSearch=v}}e.SearchData=i;function P(b,d,h){if(!h)return new T.FindMatch(b,null);let v=[];for(let t=0,s=d.length;t<s;t++)v[t]=d[t];return new T.FindMatch(b,v)}e.createFindMatch=P;class c{constructor(d){let h=[],v=0;for(let t=0,s=d.length;t<s;t++)d.charCodeAt(t)===10&&(h[v++]=t);this._lineFeedsOffsets=h}findLineFeedCountBeforeOffset(d){const h=this._lineFeedsOffsets;let v=0,t=h.length-1;if(t===-1||d<=h[0])return 0;for(;v<t;){const s=v+((t-v)/2>>0);h[s]>=d?t=s-1:h[s+1]>=d?(v=s,t=s):v=s+1}return v+1}}class u{static findMatches(d,h,v,t,s){const r=h.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(d,v,new _(r.wordSeparators,r.regex),t,s):this._doFindMatchesLineByLine(d,v,r,t,s):[]}static _getMultilineMatchRange(d,h,v,t,s,r){let n,l=0;t?(l=t.findLineFeedCountBeforeOffset(s),n=h+s+l):n=h+s;let f;if(t){let o=t.findLineFeedCountBeforeOffset(s+r.length)-l;f=n+r.length+o}else f=n+r.length;const m=d.getPositionAt(n),E=d.getPositionAt(f);return new S.Range(m.lineNumber,m.column,E.lineNumber,E.column)}static _doFindMatchesMultiline(d,h,v,t,s){const r=d.getOffsetAt(h.getStartPosition()),n=d.getValueInRange(h,1),l=d.getEOL()===`\r
`?new c(n):null,f=[];let m=0,E;for(v.reset(0);E=v.next(n);)if(f[m++]=P(this._getMultilineMatchRange(d,r,n,l,E.index,E[0]),E,t),m>=s)return f;return f}static _doFindMatchesLineByLine(d,h,v,t,s){const r=[];let n=0;if(h.startLineNumber===h.endLineNumber){const f=d.getLineContent(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);return n=this._findMatchesInLine(v,f,h.startLineNumber,h.startColumn-1,n,r,t,s),r}const l=d.getLineContent(h.startLineNumber).substring(h.startColumn-1);n=this._findMatchesInLine(v,l,h.startLineNumber,h.startColumn-1,n,r,t,s);for(let f=h.startLineNumber+1;f<h.endLineNumber&&n<s;f++)n=this._findMatchesInLine(v,d.getLineContent(f),f,0,n,r,t,s);if(n<s){const f=d.getLineContent(h.endLineNumber).substring(0,h.endColumn-1);n=this._findMatchesInLine(v,f,h.endLineNumber,0,n,r,t,s)}return r}static _findMatchesInLine(d,h,v,t,s,r,n,l){const f=d.wordSeparators;if(!n&&d.simpleSearch){const y=d.simpleSearch,o=y.length,k=h.length;let F=-o;for(;(F=h.indexOf(y,F+o))!==-1;)if((!f||w(f,h,k,F,o))&&(r[s++]=new T.FindMatch(new S.Range(v,F+1+t,v,F+1+o+t),null),s>=l))return s;return s}const m=new _(d.wordSeparators,d.regex);let E;m.reset(0);do if(E=m.next(h),E&&(r[s++]=P(new S.Range(v,E.index+1+t,v,E.index+1+E[0].length+t),E,n),s>=l))return s;while(E);return s}static findNextMatch(d,h,v,t){const s=h.parseSearchRequest();if(!s)return null;const r=new _(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindNextMatchMultiline(d,v,r,t):this._doFindNextMatchLineByLine(d,v,r,t)}static _doFindNextMatchMultiline(d,h,v,t){const s=new C.Position(h.lineNumber,1),r=d.getOffsetAt(s),n=d.getLineCount(),l=d.getValueInRange(new S.Range(s.lineNumber,s.column,n,d.getLineMaxColumn(n)),1),f=d.getEOL()===`\r
`?new c(l):null;v.reset(h.column-1);let m=v.next(l);return m?P(this._getMultilineMatchRange(d,r,l,f,m.index,m[0]),m,t):h.lineNumber!==1||h.column!==1?this._doFindNextMatchMultiline(d,new C.Position(1,1),v,t):null}static _doFindNextMatchLineByLine(d,h,v,t){const s=d.getLineCount(),r=h.lineNumber,n=d.getLineContent(r),l=this._findFirstMatchInLine(v,n,r,h.column,t);if(l)return l;for(let f=1;f<=s;f++){const m=(r+f-1)%s,E=d.getLineContent(m+1),y=this._findFirstMatchInLine(v,E,m+1,1,t);if(y)return y}return null}static _findFirstMatchInLine(d,h,v,t,s){d.reset(t-1);const r=d.next(h);return r?P(new S.Range(v,r.index+1,v,r.index+1+r[0].length),r,s):null}static findPreviousMatch(d,h,v,t){const s=h.parseSearchRequest();if(!s)return null;const r=new _(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindPreviousMatchMultiline(d,v,r,t):this._doFindPreviousMatchLineByLine(d,v,r,t)}static _doFindPreviousMatchMultiline(d,h,v,t){const s=this._doFindMatchesMultiline(d,new S.Range(1,1,h.lineNumber,h.column),v,t,10*I);if(s.length>0)return s[s.length-1];const r=d.getLineCount();return h.lineNumber!==r||h.column!==d.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(d,new C.Position(r,d.getLineMaxColumn(r)),v,t):null}static _doFindPreviousMatchLineByLine(d,h,v,t){const s=d.getLineCount(),r=h.lineNumber,n=d.getLineContent(r).substring(0,h.column-1),l=this._findLastMatchInLine(v,n,r,t);if(l)return l;for(let f=1;f<=s;f++){const m=(s+r-f-1)%s,E=d.getLineContent(m+1),y=this._findLastMatchInLine(v,E,m+1,t);if(y)return y}return null}static _findLastMatchInLine(d,h,v,t){let s=null,r;for(d.reset(0);r=d.next(h);)s=P(new S.Range(v,r.index+1,v,r.index+1+r[0].length),r,t);return s}}e.TextModelSearch=u;function a(b,d,h,v,t){if(v===0)return!0;const s=d.charCodeAt(v-1);if(b.get(s)!==0||s===13||s===10)return!0;if(t>0){const r=d.charCodeAt(v);if(b.get(r)!==0)return!0}return!1}function g(b,d,h,v,t){if(v+t===h)return!0;const s=d.charCodeAt(v+t);if(b.get(s)!==0||s===13||s===10)return!0;if(t>0){const r=d.charCodeAt(v+t-1);if(b.get(r)!==0)return!0}return!1}function w(b,d,h,v,t){return a(b,d,h,v,t)&&g(b,d,h,v,t)}e.isValidMatch=w;class _{constructor(d,h){this._wordSeparators=d,this._searchRegex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(d){this._searchRegex.lastIndex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(d){const h=d.length;let v;do{if(this._prevMatchStartIndex+this._prevMatchLength===h||(v=this._searchRegex.exec(d),!v))return null;const t=v.index,s=v[0].length;if(t===this._prevMatchStartIndex&&s===this._prevMatchLength){if(s===0){p.getNextCodePoint(d,h,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=s,!this._wordSeparators||w(this._wordSeparators,d,h,t,s))return v}while(v);return null}}e.Searcher=_}),define(me[108],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function p(I=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const A of e.USUAL_WORD_SEPARATORS)I.indexOf(A)>=0||(D+="\\"+A);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=p();function L(I){let D=e.DEFAULT_WORD_REGEXP;if(I&&I instanceof RegExp)if(I.global)D=I;else{let A="g";I.ignoreCase&&(A+="i"),I.multiline&&(A+="m"),I.unicode&&(A+="u"),D=new RegExp(I.source,A)}return D.lastIndex=0,D}e.ensureValidWordDefinition=L;const C={maxLen:1e3,windowSize:15,timeBudget:150};function S(I,D,A,i,P=C){if(A.length>P.maxLen){let w=I-P.maxLen/2;return w<0?w=0:i+=w,A=A.substring(w,I+P.maxLen/2),S(I,D,A,i,P)}const c=Date.now(),u=I-1-i;let a=-1,g=null;for(let w=1;!(Date.now()-c>=P.timeBudget);w++){const _=u-P.windowSize*w;D.lastIndex=Math.max(0,_);const b=T(D,A,u,a);if(!b&&g||(g=b,_<=0))break;a=_}if(g){let w={word:g[0],startColumn:i+1+g.index,endColumn:i+1+g.index+g[0].length};return D.lastIndex=0,w}return null}e.getWordAtText=S;function T(I,D,A,i){let P;for(;P=I.exec(D);){const c=P.index||0;if(c<=A&&I.lastIndex>=A)return P;if(i>0&&c>i)return null}return null}}),define(me[143],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var p;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(p=e.IndentAction||(e.IndentAction={}));class L{constructor(I){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=I.open,this.close=I.close,this._standardTokenMask=0,Array.isArray(I.notIn))for(let D=0,A=I.notIn.length;D<A;D++)switch(I.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(I){return(this._standardTokenMask&I)==0}}e.StandardAutoClosingPairConditional=L;class C{constructor(I){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of I)S(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),S(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),S(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),S(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&S(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=C;function S(T,I,D){T.has(I)?T.get(I).push(D):T.set(I,[D])}}),define(me[77],ge([0,1,30,9]),function(J,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function C(S,T,I,D){if(Array.isArray(S)){let A=0;for(const i of S){const P=C(i,T,I,D);if(P===10)return P;P>A&&(A=P)}return A}else{if(typeof S=="string")return D?S==="*"?5:S===I?10:0:0;if(S){const{language:A,pattern:i,scheme:P,hasAccessToAllModels:c}=S;if(!D&&!c)return 0;let u=0;if(P)if(P===T.scheme)u=10;else if(P==="*")u=5;else return 0;if(A)if(A===I)u=10;else if(A==="*")u=Math.max(u,5);else return 0;if(i){let a;if(typeof i=="string"?a=i:a={...i,base:(0,L.normalize)(i.base)},a===T.fsPath||(0,p.match)(a,T.fsPath))u=10;else return 0}return u}else return 0}}e.score=C}),define(me[144],ge([0,1,106]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(u){u[u.Invalid=0]="Invalid",u[u.Start=1]="Start",u[u.H=2]="H",u[u.HT=3]="HT",u[u.HTT=4]="HTT",u[u.HTTP=5]="HTTP",u[u.F=6]="F",u[u.FI=7]="FI",u[u.FIL=8]="FIL",u[u.BeforeColon=9]="BeforeColon",u[u.AfterColon=10]="AfterColon",u[u.AlmostThere=11]="AlmostThere",u[u.End=12]="End",u[u.Accept=13]="Accept",u[u.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class C{constructor(a,g,w){const _=new Uint8Array(a*g);for(let b=0,d=a*g;b<d;b++)_[b]=w;this._data=_,this.rows=a,this.cols=g}get(a,g){return this._data[a*this.cols+g]}set(a,g,w){this._data[a*this.cols+g]=w}}e.Uint8Matrix=C;class S{constructor(a){let g=0,w=0;for(let b=0,d=a.length;b<d;b++){let[h,v,t]=a[b];v>g&&(g=v),h>w&&(w=h),t>w&&(w=t)}g++,w++;let _=new C(w,g,0);for(let b=0,d=a.length;b<d;b++){let[h,v,t]=a[b];_.set(h,v,t)}this._states=_,this._maxCharCode=g}nextState(a,g){return g<0||g>=this._maxCharCode?0:this._states.get(a,g)}}e.StateMachine=S;let T=null;function I(){return T===null&&(T=new S([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),T}var D;(function(u){u[u.None=0]="None",u[u.ForceTermination=1]="ForceTermination",u[u.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let A=null;function i(){if(A===null){A=new p.CharacterClassifier(0);const u=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let g=0;g<u.length;g++)A.set(u.charCodeAt(g),1);const a=".,;";for(let g=0;g<a.length;g++)A.set(a.charCodeAt(g),2)}return A}class P{static _createLink(a,g,w,_,b){let d=b-1;do{const h=g.charCodeAt(d);if(a.get(h)!==2)break;d--}while(d>_);if(_>0){const h=g.charCodeAt(_-1),v=g.charCodeAt(d);(h===40&&v===41||h===91&&v===93||h===123&&v===125)&&d--}return{range:{startLineNumber:w,startColumn:_+1,endLineNumber:w,endColumn:d+2},url:g.substring(_,d+1)}}static computeLinks(a,g=I()){const w=i();let _=[];for(let b=1,d=a.getLineCount();b<=d;b++){const h=a.getLineContent(b),v=h.length;let t=0,s=0,r=0,n=1,l=!1,f=!1,m=!1,E=!1;for(;t<v;){let y=!1;const o=h.charCodeAt(t);if(n===13){let k;switch(o){case 40:l=!0,k=0;break;case 41:k=l?0:1;break;case 91:m=!0,f=!0,k=0;break;case 93:m=!1,k=f?0:1;break;case 123:E=!0,k=0;break;case 125:k=E?0:1;break;case 39:k=r===34||r===96?0:1;break;case 34:k=r===39||r===96?0:1;break;case 96:k=r===39||r===34?0:1;break;case 42:k=r===42?1:0;break;case 124:k=r===124?1:0;break;case 32:k=m?0:1;break;default:k=w.get(o)}k===1&&(_.push(P._createLink(w,h,b,s,t)),y=!0)}else if(n===12){let k;o===91?(f=!0,k=0):k=w.get(o),k===1?y=!0:n=13}else n=g.nextState(n,o),n===0&&(y=!0);y&&(n=1,l=!1,f=!1,E=!1,s=t+1,r=o),t++}n===13&&_.push(P._createLink(w,h,b,s,v))}return _}}e.LinkComputer=P;function c(u){return!u||typeof u.getLineCount!="function"||typeof u.getLineContent!="function"?[]:P.computeLinks(u)}e.computeLinks=c}),define(me[145],ge([0,1,3,6]),function(J,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class C{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new p.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(T){this._onDidChange.fire({changedLanguages:T,changedColorMap:!1})}register(T,I){return this._map.set(T,I),this.fire([T]),(0,L.toDisposable)(()=>{this._map.get(T)===I&&(this._map.delete(T),this.fire([T]))})}registerPromise(T,I){let D=null,A=!1;return this._promises.set(T,I.then(i=>{this._promises.delete(T),!(A||!i)&&(D=this.register(T,i))})),(0,L.toDisposable)(()=>{A=!0,D&&D.dispose()})}getPromise(T){const I=this.get(T);if(I)return Promise.resolve(I);const D=this._promises.get(T);return D?D.then(A=>this.get(T)):null}get(T){return this._map.get(T)||null}setColorMap(T){this._colorMap=T,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=C}),define(me[109],ge([0,1,22,11]),function(J,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var C;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(C||(C={}));function S(P){for(let c=0,u=P.length;c<u;c+=4){const a=P[c+0],g=P[c+1],w=P[c+2],_=P[c+3];P[c+0]=_,P[c+1]=w,P[c+2]=g,P[c+3]=a}}function T(P){const c=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return L.isLittleEndian()||S(c),p.VSBuffer.wrap(c)}function I(P){const c=P.buffer;if(L.isLittleEndian()||S(c),c.byteOffset%4==0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const u=new Uint8Array(c.byteLength);return u.set(c),new Uint32Array(u.buffer,u.byteOffset,u.length/4)}}function D(P){const c=new Uint32Array(A(P));let u=0;if(c[u++]=P.id,P.type==="full")c[u++]=1,c[u++]=P.data.length,c.set(P.data,u),u+=P.data.length;else{c[u++]=2,c[u++]=P.deltas.length;for(const a of P.deltas)c[u++]=a.start,c[u++]=a.deleteCount,a.data?(c[u++]=a.data.length,c.set(a.data,u),u+=a.data.length):c[u++]=0}return T(c)}e.encodeSemanticTokensDto=D;function A(P){let c=0;if(c+=1+1,P.type==="full")c+=1+P.data.length;else{c+=1,c+=(1+1+1)*P.deltas.length;for(const u of P.deltas)u.data&&(c+=u.data.length)}return c}function i(P){const c=I(P);let u=0;const a=c[u++];if(c[u++]===1){const b=c[u++],d=c.subarray(u,u+b);return u+=b,{id:a,type:"full",data:d}}const w=c[u++];let _=[];for(let b=0;b<w;b++){const d=c[u++],h=c[u++],v=c[u++];let t;v>0&&(t=c.subarray(u,u+v),u+=v),_[b]={start:d,deleteCount:h,data:t}}return{id:a,type:"delta",deltas:_}}e.decodeSemanticTokensDto=i}),define(me[110],ge([0,1,94]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class L{constructor(T,I){this._prefixSumIndexOfResultBrand=void 0,this.index=T,this.remainder=I}}e.PrefixSumIndexOfResult=L;class C{constructor(T){this.values=T,this.prefixSum=new Uint32Array(T.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(T,I){T=(0,p.toUint32)(T);const D=this.values,A=this.prefixSum,i=I.length;return i===0?!1:(this.values=new Uint32Array(D.length+i),this.values.set(D.subarray(0,T),0),this.values.set(D.subarray(T),T+i),this.values.set(I,T),T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(A.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(T,I){return T=(0,p.toUint32)(T),I=(0,p.toUint32)(I),this.values[T]===I?!1:(this.values[T]=I,T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),!0)}removeValues(T,I){T=(0,p.toUint32)(T),I=(0,p.toUint32)(I);const D=this.values,A=this.prefixSum;if(T>=D.length)return!1;let i=D.length-T;return I>=i&&(I=i),I===0?!1:(this.values=new Uint32Array(D.length-I),this.values.set(D.subarray(0,T),0),this.values.set(D.subarray(T+I),T),this.prefixSum=new Uint32Array(this.values.length),T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(A.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(T){return T<0?0:(T=(0,p.toUint32)(T),this._getPrefixSum(T))}_getPrefixSum(T){if(T<=this.prefixSumValidIndex[0])return this.prefixSum[T];let I=this.prefixSumValidIndex[0]+1;I===0&&(this.prefixSum[0]=this.values[0],I++),T>=this.values.length&&(T=this.values.length-1);for(let D=I;D<=T;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],T),this.prefixSum[T]}getIndexOf(T){T=Math.floor(T),this.getTotalSum();let I=0,D=this.values.length-1,A=0,i=0,P=0;for(;I<=D;)if(A=I+(D-I)/2|0,i=this.prefixSum[A],P=i-this.values[A],T<P)D=A-1;else if(T>=i)I=A+1;else break;return new L(A,T-P)}}e.PrefixSumComputer=C}),define(me[146],ge([0,1,8,46,110]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class S{constructor(I,D,A,i){this._uri=I,this._lines=D,this._eol=A,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(I){I.eol&&I.eol!==this._eol&&(this._eol=I.eol,this._lineStarts=null);const D=I.changes;for(const A of D)this._acceptDeleteRange(A.range),this._acceptInsertText(new L.Position(A.range.startLineNumber,A.range.startColumn),A.text);this._versionId=I.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const I=this._eol.length,D=this._lines.length,A=new Uint32Array(D);for(let i=0;i<D;i++)A[i]=this._lines[i].length+I;this._lineStarts=new C.PrefixSumComputer(A)}}_setLineText(I,D){this._lines[I]=D,this._lineStarts&&this._lineStarts.changeValue(I,this._lines[I].length+this._eol.length)}_acceptDeleteRange(I){if(I.startLineNumber===I.endLineNumber){if(I.startColumn===I.endColumn)return;this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.startLineNumber-1].substring(I.endColumn-1));return}this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.endLineNumber-1].substring(I.endColumn-1)),this._lines.splice(I.startLineNumber,I.endLineNumber-I.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(I.startLineNumber,I.endLineNumber-I.startLineNumber)}_acceptInsertText(I,D){if(D.length===0)return;let A=(0,p.splitLines)(D);if(A.length===1){this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+A[0]+this._lines[I.lineNumber-1].substring(I.column-1));return}A[A.length-1]+=this._lines[I.lineNumber-1].substring(I.column-1),this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+A[0]);let i=new Uint32Array(A.length-1);for(let P=1;P<A.length;P++)this._lines.splice(I.lineNumber+P-1,0,A[P]),i[P-1]=A[P].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(I.lineNumber,i)}}e.MirrorTextModel=S}),define(me[147],ge([19,20]),function(J,e){return J.create("vs/base/common/date",e)}),define(me[148],ge([0,1,147]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,C=L*60,S=C*24,T=S*7,I=S*30,D=S*365;function A(P,c){typeof P!="number"&&(P=P.getTime());const u=Math.round((new Date().getTime()-P)/1e3);if(u<-30)return(0,p.localize)(0,null,A(new Date().getTime()+u*1e3,!1));if(u<30)return(0,p.localize)(1,null);let a;return u<L?(a=u,c?a===1?(0,p.localize)(2,null,a):(0,p.localize)(3,null,a):a===1?(0,p.localize)(4,null,a):(0,p.localize)(5,null,a)):u<C?(a=Math.floor(u/L),c?a===1?(0,p.localize)(6,null,a):(0,p.localize)(7,null,a):a===1?(0,p.localize)(8,null,a):(0,p.localize)(9,null,a)):u<S?(a=Math.floor(u/C),c?a===1?(0,p.localize)(10,null,a):(0,p.localize)(11,null,a):a===1?(0,p.localize)(12,null,a):(0,p.localize)(13,null,a)):u<T?(a=Math.floor(u/S),c?a===1?(0,p.localize)(14,null,a):(0,p.localize)(15,null,a):a===1?(0,p.localize)(16,null,a):(0,p.localize)(17,null,a)):u<I?(a=Math.floor(u/T),c?a===1?(0,p.localize)(18,null,a):(0,p.localize)(19,null,a):a===1?(0,p.localize)(20,null,a):(0,p.localize)(21,null,a)):u<D?(a=Math.floor(u/I),c?a===1?(0,p.localize)(22,null,a):(0,p.localize)(23,null,a):a===1?(0,p.localize)(24,null,a):(0,p.localize)(25,null,a)):(a=Math.floor(u/D),c?a===1?(0,p.localize)(26,null,a):(0,p.localize)(27,null,a):a===1?(0,p.localize)(28,null,a):(0,p.localize)(29,null,a))}e.fromNow=A;function i(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(me[149],ge([19,20]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(me[58],ge([0,1,149,14,18]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function S(A,i){return i&&(A.stack||A.stacktrace)?p.localize(0,null,I(A),T(A.stack)||T(A.stacktrace)):I(A)}function T(A){return Array.isArray(A)?A.join(`
`):A}function I(A){return typeof A.code=="string"&&typeof A.errno=="number"&&typeof A.syscall=="string"?p.localize(1,null,A.message):A.message||p.localize(2,null)}function D(A=null,i=!1){if(!A)return p.localize(3,null);if(Array.isArray(A)){const P=C.coalesce(A),c=D(P[0],i);return P.length>1?p.localize(4,null,c,P.length):c}if(L.isString(A))return A;if(A.detail){const P=A.detail;if(P.error)return S(P.error,i);if(P.exception)return S(P.exception,i)}return A.stack?S(A,i):A.message?A.message:p.localize(5,null)}e.toErrorMessage=D}),define(me[150],ge([19,20]),function(J,e){return J.create("vs/base/node/processes",e)}),define(me[111],ge([0,1,9,28,38,150,37,14,25,29,11,139,10]),function(J,e,p,L,C,S,T,I,D,A,i,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function u(h){switch(h){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function a(h,v){if(i.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};v&&(t.cwd=v);const s=C.execFile("taskkill",["/T","/F","/PID",h.pid.toString()],t);return new Promise(r=>{s.once("error",n=>{r({success:!1,error:n})}),s.once("exit",(n,l)=>{r(n===0?{success:!0}:{success:!1,code:n!==null?n:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?u(t.status):1})}else if(i.isLinux||i.isMacintosh)try{const t=c.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(s=>{C.execFile(t,[h.pid.toString()],{encoding:"utf8",shell:!0},(r,n,l)=>{s(r?{success:!1,error:r}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else h.kill("SIGKILL");return Promise.resolve({success:!0})}function g(h=T.env){return h.comspec||"cmd.exe"}e.getWindowsShell=g;class w{constructor(v,t,s,r){if(t!==void 0&&s!==void 0&&r!==void 0)this.cmd=v,this.args=t,this.shell=s,this.options=r;else{const n=v;this.cmd=n.command,this.shell=n.isShellCommand,this.args=n.args.slice(0),this.options=n.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const n=Object.create(null);Object.keys(T.env).forEach(l=>{n[l]=T.env[l]}),Object.keys(this.options.env).forEach(l=>{n[l]=this.options.env[l]}),this.options.env=n}}getSanitizedCommand(){let v=this.cmd.toLowerCase();const t=v.lastIndexOf(p.sep);return t!==-1&&(v=v.substring(t+1)),w.WellKnowCommands[v]?v:"other"}start(v){return i.isWindows&&(this.options&&this.options.cwd&&A.isUNC(this.options.cwd)||!this.options&&A.isUNC(T.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(t=>{let s,r;const n=new Promise((l,f)=>{s=l,r=f});if(t){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=C.exec(l,this.options,(f,m,E)=>{this.childProcess=null;const y=f;y&&y.killed?r({killed:this.terminateRequested,stdout:m.toString(),stderr:E.toString()}):this.handleExec(s,v,f,m,E)})}else{let l=null;const f=m=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(m,s,v,r);const E={terminated:this.terminateRequested};I.isNumber(m)&&(E.cmdCode=m),s(E)};if(this.shell&&i.isWindows){const m=D.deepClone(this.options);m.windowsVerbatimArguments=!0,m.detached=!1;let E=!1,y=!1;const o=[];let k=this.ensureQuotes(this.cmd);o.push(k.value),E=k.quoted,this.args&&this.args.forEach($=>{k=this.ensureQuotes($),o.push(k.value),y=y&&k.quoted});const F=["/s","/c"];E?y?F.push('"'+o.join(" ")+'"'):o.length>1?F.push('"'+o[0]+'" '+o.slice(1).join(" ")):F.push('"'+o[0]+'"'):F.push(o.join(" ")),l=C.spawn(g(),F,m)}else this.cmd&&(l=C.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(I.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",m=>{this.childProcess=null,r({terminated:this.terminateRequested,error:m})}),l.pid&&(this.childProcess.on("close",f),this.handleSpawn(l,s,v,r,!0)))}return n})}handleClose(v,t,s,r){}ensureQuotes(v){return w.regexp.test(v)?{value:'"'+v+'"',quoted:!0}:{value:v,quoted:v.length>0&&v[0]==='"'&&v[v.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(v=>v.pid,v=>-1):new Promise(v=>{this.pidResolve=v})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(v=>(this.terminateRequested=!0,a(v,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),v=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(v=>{if(!this.shell||!i.isWindows)return v(!1);const t=C.spawn(g(),["/s","/c"]);t.on("error",s=>v(!0)),t.on("exit",s=>v(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class _ extends w{constructor(v,t,s,r){super(v,t,s,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(v,t,s,r,n){[r,n].forEach((l,f)=>{const m=new P.LineDecoder;m.write(l).forEach(o=>{t({line:o,source:f===0?0:1})});const y=m.end();y&&t({line:y,source:f===0?0:1})}),v({terminated:this.terminateRequested,error:s})}handleSpawn(v,t,s,r,n){const l=new P.LineDecoder,f=new P.LineDecoder;v.stdout.on("data",m=>{l.write(m).forEach(y=>s({line:y,source:0}))}),v.stderr.on("data",m=>{f.write(m).forEach(y=>s({line:y,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=f}handleClose(v,t,s,r){const n=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;n&&s({line:n,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&s({line:l,source:1})}}e.LineProcess=_;function b(h){let v=[],t=!1;const s=function(r){if(t){v.push(r);return}(!h.send(r,l=>{if(l&&console.error(l),t=!1,v.length>0){const f=v.slice(0);v=[],f.forEach(m=>s(m))}})||i.isWindows)&&(t=!0)};return{send:s}}e.createQueuedSender=b;var d;(function(h){async function v(t,s,r){if(p.isAbsolute(t))return t;if(s===void 0&&(s=T.cwd()),p.dirname(t)!=="."||(r===void 0&&I.isString(T.env.PATH)&&(r=T.env.PATH.split(p.delimiter)),r===void 0||r.length===0))return p.join(s,t);async function l(f){return await L.Promises.exists(f)?!(await L.Promises.stat(f)).isDirectory():!1}for(let f of r){let m;if(p.isAbsolute(f)?m=p.join(f,t):m=p.join(s,f,t),await l(m))return m;let E=m+".com";if(await l(E)||(E=m+".exe",await l(E)))return E}return p.join(s,t)}h.findExecutable=v})(d=e.win32||(e.win32={}))}),define(me[151],ge([19,20]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(me[112],ge([0,1,151,11,108]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class T{constructor(ie){this._values=ie}hasChanged(ie){return this._values[ie]}}e.ConfigurationChangedEvent=T;class I{constructor(){this._values=[]}_read(ie){return this._values[ie]}get(ie){return this._values[ie]}_write(ie,fe){this._values[ie]=fe}}e.ValidatedEditorOptions=I;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class A{constructor(ie,fe,$e,xe){this.id=ie,this.name=fe,this.defaultValue=$e,this.schema=xe}compute(ie,fe,$e){return $e}}class i{constructor(ie,fe=null){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0,this.deps=fe}validate(ie){return this.defaultValue}}class P{constructor(ie,fe,$e,xe){this.id=ie,this.name=fe,this.defaultValue=$e,this.schema=xe}validate(ie){return typeof ie=="undefined"?this.defaultValue:ie}compute(ie,fe,$e){return $e}}function c(X,ie){return typeof X=="undefined"?ie:X==="false"?!1:Boolean(X)}e.boolean=c;class u extends P{constructor(ie,fe,$e,xe=void 0){typeof xe!="undefined"&&(xe.type="boolean",xe.default=$e),super(ie,fe,$e,xe)}validate(ie){return c(ie,this.defaultValue)}}class a extends P{constructor(ie,fe,$e,xe,tt,Ce=void 0){typeof Ce!="undefined"&&(Ce.type="integer",Ce.default=$e,Ce.minimum=xe,Ce.maximum=tt),super(ie,fe,$e,Ce),this.minimum=xe,this.maximum=tt}static clampedInt(ie,fe,$e,xe){if(typeof ie=="undefined")return fe;let tt=parseInt(ie,10);return isNaN(tt)?fe:(tt=Math.max($e,tt),tt=Math.min(xe,tt),tt|0)}validate(ie){return a.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}class g extends P{constructor(ie,fe,$e,xe,tt){typeof tt!="undefined"&&(tt.type="number",tt.default=$e),super(ie,fe,$e,tt),this.validationFn=xe}static clamp(ie,fe,$e){return ie<fe?fe:ie>$e?$e:ie}static float(ie,fe){if(typeof ie=="number")return ie;if(typeof ie=="undefined")return fe;const $e=parseFloat(ie);return isNaN($e)?fe:$e}validate(ie){return this.validationFn(g.float(ie,this.defaultValue))}}class w extends P{static string(ie,fe){return typeof ie!="string"?fe:ie}constructor(ie,fe,$e,xe=void 0){typeof xe!="undefined"&&(xe.type="string",xe.default=$e),super(ie,fe,$e,xe)}validate(ie){return w.string(ie,this.defaultValue)}}function _(X,ie,fe){return typeof X!="string"||fe.indexOf(X)===-1?ie:X}e.stringSet=_;class b extends P{constructor(ie,fe,$e,xe,tt=void 0){typeof tt!="undefined"&&(tt.type="string",tt.enum=xe,tt.default=$e),super(ie,fe,$e,tt),this._allowedValues=xe}validate(ie){return _(ie,this.defaultValue,this._allowedValues)}}class d extends A{constructor(ie,fe,$e,xe,tt,Ce,ke=void 0){typeof ke!="undefined"&&(ke.type="string",ke.enum=tt,ke.default=xe),super(ie,fe,$e,ke),this._allowedValues=tt,this._convert=Ce}validate(ie){return typeof ie!="string"?this.defaultValue:this._allowedValues.indexOf(ie)===-1?this.defaultValue:this._convert(ie)}}function h(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class v extends A{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",description:p.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,fe,$e){return $e===0?ie.accessibilitySupport:$e}}class t extends A{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:p.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const fe=ie;return{insertSpace:c(fe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(fe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var n;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(n=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function l(X){switch(X){case n.Line:return"line";case n.Block:return"block";case n.Underline:return"underline";case n.LineThin:return"line-thin";case n.BlockOutline:return"block-outline";case n.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function f(X){switch(X){case"line":return n.Line;case"block":return n.Block;case"underline":return n.Underline;case"line-thin":return n.LineThin;case"block-outline":return n.BlockOutline;case"underline-thin":return n.UnderlineThin}}class m extends i{constructor(){super(125,[63,31])}compute(ie,fe,$e){const xe=["monaco-editor"];return fe.get(31)&&xe.push(fe.get(31)),ie.extraEditorClassName&&xe.push(ie.extraEditorClassName),fe.get(63)==="default"?xe.push("mouse-default"):fe.get(63)==="copy"&&xe.push("mouse-copy"),fe.get(98)&&xe.push("showUnused"),fe.get(123)&&xe.push("showDeprecated"),xe.join(" ")}}class E extends u{constructor(){super(30,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(ie,fe,$e){return $e&&ie.emptySelectionClipboard}}class y extends A{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ie.seedSearchStringFromSelection,description:p.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[p.localize(9,null),p.localize(10,null),p.localize(11,null)],description:p.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:p.localize(13,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:p.localize(14,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:p.localize(15,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const fe=ie;return{cursorMoveOnType:c(fe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:c(fe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":_(fe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(fe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(fe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(fe.loop,this.defaultValue.loop)}}}class o extends A{constructor(){super(41,"fontLigatures",o.OFF,{anyOf:[{type:"boolean",description:p.localize(16,null)},{type:"string",description:p.localize(17,null)}],description:p.localize(18,null),default:!1})}validate(ie){return typeof ie=="undefined"?this.defaultValue:typeof ie=="string"?ie==="false"?o.OFF:ie==="true"?o.ON:ie:Boolean(ie)?o.ON:o.OFF}}e.EditorFontLigatures=o,o.OFF='"liga" off, "calt" off',o.ON='"liga" on, "calt" on';class k extends i{constructor(){super(40)}compute(ie,fe,$e){return ie.fontInfo}}class F extends P{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(19,null)})}validate(ie){let fe=g.float(ie,this.defaultValue);return fe===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(fe,6,100)}compute(ie,fe,$e){return ie.fontInfo.fontSize}}class $ extends A{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:$.MINIMUM_VALUE,maximum:$.MAXIMUM_VALUE,errorMessage:p.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:$.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(21,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(a.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,$.MINIMUM_VALUE,$.MAXIMUM_VALUE))}}$.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],$.MINIMUM_VALUE=1,$.MAXIMUM_VALUE=1e3;class Q extends A{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},fe={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[p.localize(22,null),p.localize(23,null),p.localize(24,null)]},$e=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(25,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(26,null),...fe},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(27,null),...fe},"editor.gotoLocation.multipleDeclarations":{description:p.localize(28,null),...fe},"editor.gotoLocation.multipleImplementations":{description:p.localize(29,null),...fe},"editor.gotoLocation.multipleReferences":{description:p.localize(30,null),...fe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,enum:$e,description:p.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,enum:$e,description:p.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,enum:$e,description:p.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,enum:$e,description:p.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,enum:$e,description:p.localize(35,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const fe=ie;return{multiple:_(fe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:fe.multipleDefinitions??_(fe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:fe.multipleTypeDefinitions??_(fe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:fe.multipleDeclarations??_(fe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:fe.multipleImplementations??_(fe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:fe.multipleReferences??_(fe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(fe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(fe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(fe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(fe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(fe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class oe extends A{constructor(){const ie={enabled:!0,delay:300,sticky:!0};super(50,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:p.localize(36,null)},"editor.hover.delay":{type:"number",default:ie.delay,description:p.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:p.localize(38,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const fe=ie;return{enabled:c(fe.enabled,this.defaultValue.enabled),delay:a.clampedInt(fe.delay,this.defaultValue.delay,0,1e4),sticky:c(fe.sticky,this.defaultValue.sticky)}}}var j;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(j=e.RenderMinimap||(e.RenderMinimap={}));class O extends i{constructor(){super(128,[46,55,35,62,90,57,58,92,115,118,119,120,2])}compute(ie,fe,$e){return O.computeLayout(fe,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio})}static computeContainedMinimapLineCount(ie){const fe=ie.height/ie.lineHeight,$e=ie.scrollBeyondLastLine?fe-1:0,xe=(ie.viewLineCount+$e)/(ie.pixelRatio*ie.height),tt=Math.floor(ie.viewLineCount/xe);return{typicalViewportLineCount:fe,extraLinesBeyondLastLine:$e,desiredRatio:xe,minimapLineCount:tt}}static _computeMinimapLayout(ie,fe){const $e=ie.outerWidth,xe=ie.outerHeight,tt=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(tt*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const Ce=fe.stableMinimapLayoutInput,ke=Ce&&ie.outerHeight===Ce.outerHeight&&ie.lineHeight===Ce.lineHeight&&ie.typicalHalfwidthCharacterWidth===Ce.typicalHalfwidthCharacterWidth&&ie.pixelRatio===Ce.pixelRatio&&ie.scrollBeyondLastLine===Ce.scrollBeyondLastLine&&ie.minimap.enabled===Ce.minimap.enabled&&ie.minimap.side===Ce.minimap.side&&ie.minimap.size===Ce.minimap.size&&ie.minimap.showSlider===Ce.minimap.showSlider&&ie.minimap.renderCharacters===Ce.minimap.renderCharacters&&ie.minimap.maxColumn===Ce.minimap.maxColumn&&ie.minimap.scale===Ce.minimap.scale&&ie.verticalScrollbarWidth===Ce.verticalScrollbarWidth&&ie.isViewportWrapping===Ce.isViewportWrapping,Te=ie.lineHeight,le=ie.typicalHalfwidthCharacterWidth,ce=ie.scrollBeyondLastLine,pe=ie.minimap.renderCharacters;let Ee=tt>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const G=ie.minimap.maxColumn,ve=ie.minimap.size,ye=ie.minimap.side,Ae=ie.verticalScrollbarWidth,Ne=ie.viewLineCount,Ge=ie.remainingWidth,et=ie.isViewportWrapping,Qe=pe?2:3;let Xe=Math.floor(tt*xe);const lt=Xe/tt;let dt=!1,_t=!1,at=Qe*Ee,be=Ee/tt,Ie=1;if(ve==="fill"||ve==="fit"){const{typicalViewportLineCount:ct,extraLinesBeyondLastLine:mt,desiredRatio:kt,minimapLineCount:yt}=O.computeContainedMinimapLineCount({viewLineCount:Ne,scrollBeyondLastLine:ce,height:xe,lineHeight:Te,pixelRatio:tt});if(Ne/yt>1)dt=!0,_t=!0,Ee=1,at=1,be=Ee/tt;else{let gt=!1,ht=Ee+1;if(ve==="fit"){const Et=Math.ceil((Ne+mt)*at);et&&ke&&Ge<=fe.stableFitRemainingWidth?(gt=!0,ht=fe.stableFitMaxMinimapScale):gt=Et>Xe}if(ve==="fill"||gt){dt=!0;const Et=Ee;at=Math.min(Te*tt,Math.max(1,Math.floor(1/kt))),et&&ke&&Ge<=fe.stableFitRemainingWidth&&(ht=fe.stableFitMaxMinimapScale),Ee=Math.min(ht,Math.max(1,Math.floor(at/Qe))),Ee>Et&&(Ie=Math.min(2,Ee/Et)),be=Ee/tt/Ie,Xe=Math.ceil(Math.max(ct,Ne+mt)*at),et?(fe.stableMinimapLayoutInput=ie,fe.stableFitRemainingWidth=Ge,fe.stableFitMaxMinimapScale=Ee):(fe.stableMinimapLayoutInput=null,fe.stableFitRemainingWidth=0)}}}const he=Math.floor(G*be),V=Math.min(he,Math.max(0,Math.floor((Ge-Ae-2)*be/(le+be)))+e.MINIMAP_GUTTER_WIDTH);let Me=Math.floor(tt*V);const Be=Me/tt;Me=Math.floor(Me*Ie);const Ye=pe?1:2,Ke=ye==="left"?0:$e-V-Ae;return{renderMinimap:Ye,minimapLeft:Ke,minimapWidth:V,minimapHeightIsEditorHeight:dt,minimapIsSampling:_t,minimapScale:Ee,minimapLineHeight:at,minimapCanvasInnerWidth:Me,minimapCanvasInnerHeight:Xe,minimapCanvasOuterWidth:Be,minimapCanvasOuterHeight:lt}}static computeLayout(ie,fe){const $e=fe.outerWidth|0,xe=fe.outerHeight|0,tt=fe.lineHeight|0,Ce=fe.lineNumbersDigitCount|0,ke=fe.typicalHalfwidthCharacterWidth,Te=fe.maxDigitWidth,le=fe.pixelRatio,ce=fe.viewLineCount,pe=ie.get(120),Ee=pe==="inherit"?ie.get(119):pe,G=Ee==="inherit"?ie.get(115):Ee,ve=ie.get(118),ye=ie.get(2),Ae=fe.isDominatedByLongLines,Ne=ie.get(46),Ge=ie.get(57).renderType!==0,et=ie.get(58),Qe=ie.get(92),Xe=ie.get(62),lt=ie.get(90),dt=lt.verticalScrollbarSize,_t=lt.verticalHasArrows,at=lt.arrowSize,be=lt.horizontalScrollbarSize,Ie=ie.get(55),he=ie.get(35);let V;if(typeof Ie=="string"&&/^\d+(\.\d+)?ch$/.test(Ie)){const Pt=parseFloat(Ie.substr(0,Ie.length-2));V=a.clampedInt(Pt*ke,0,0,1e3)}else V=a.clampedInt(Ie,0,0,1e3);he&&(V+=16);let Me=0;if(Ge){const Pt=Math.max(Ce,et);Me=Math.round(Pt*Te)}let Be=0;Ne&&(Be=tt);let Ye=0,Ke=Ye+Be,ct=Ke+Me,mt=ct+V;const kt=$e-Be-Me-V;let yt=!1,wt=!1,gt=-1;ye!==2&&(Ee==="inherit"&&Ae?(yt=!0,wt=!0):G==="on"||G==="bounded"?wt=!0:G==="wordWrapColumn"&&(gt=ve));const ht=O._computeMinimapLayout({outerWidth:$e,outerHeight:xe,lineHeight:tt,typicalHalfwidthCharacterWidth:ke,pixelRatio:le,scrollBeyondLastLine:Qe,minimap:Xe,verticalScrollbarWidth:dt,viewLineCount:ce,remainingWidth:kt,isViewportWrapping:wt},fe.memory||new D);ht.renderMinimap!==0&&ht.minimapLeft===0&&(Ye+=ht.minimapWidth,Ke+=ht.minimapWidth,ct+=ht.minimapWidth,mt+=ht.minimapWidth);const Et=kt-ht.minimapWidth,ft=Math.max(1,Math.floor((Et-dt-2)/ke)),Nt=_t?at:0;return wt&&(gt=Math.max(1,ft),G==="bounded"&&(gt=Math.min(gt,ve))),{width:$e,height:xe,glyphMarginLeft:Ye,glyphMarginWidth:Be,lineNumbersLeft:Ke,lineNumbersWidth:Me,decorationsLeft:ct,decorationsWidth:V,contentLeft:mt,contentWidth:Et,minimap:ht,viewportColumn:ft,isWordWrapMinified:yt,isViewportWrapping:wt,wrappingColumn:gt,verticalScrollbarWidth:dt,horizontalScrollbarHeight:be,overviewRuler:{top:Nt,width:dt,height:xe-2*Nt,right:0}}}}e.EditorLayoutInfoComputer=O;class B extends A{constructor(){const ie={enabled:!0};super(54,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"boolean",default:ie.enabled,description:p.localize(39,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:c(ie.enabled,this.defaultValue.enabled)}}}class R extends A{constructor(){const ie={enabled:!0,fontSize:0,fontFamily:""};super(124,"inlayHints",ie,{"editor.inlayHints.enabled":{type:"boolean",default:ie.enabled,description:p.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:ie.fontSize,markdownDescription:p.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:ie.fontFamily,description:p.localize(42,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const fe=ie;return{enabled:c(fe.enabled,this.defaultValue.enabled),fontSize:a.clampedInt(fe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(fe.fontFamily,this.defaultValue.fontFamily)}}}class z extends g{constructor(){super(56,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ie=>g.clamp(ie,0,150),{markdownDescription:p.localize(43,null)})}compute(ie,fe,$e){return ie.fontInfo.lineHeight}}class N extends A{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(62,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:p.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(45,null),p.localize(46,null),p.localize(47,null)],default:ie.size,description:p.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:p.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:p.localize(50,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:p.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:p.localize(53,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const fe=ie;return{enabled:c(fe.enabled,this.defaultValue.enabled),size:_(fe.size,this.defaultValue.size,["proportional","fill","fit"]),side:_(fe.side,this.defaultValue.side,["right","left"]),showSlider:_(fe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(fe.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(fe.scale,1,1,3),maxColumn:a.clampedInt(fe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function M(X){return X==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class q extends A{constructor(){super(72,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(55,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const fe=ie;return{top:a.clampedInt(fe.top,0,0,1e3),bottom:a.clampedInt(fe.bottom,0,0,1e3)}}}class x extends A{constructor(){const ie={enabled:!0,cycle:!1};super(73,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:p.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:p.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const fe=ie;return{enabled:c(fe.enabled,this.defaultValue.enabled),cycle:c(fe.cycle,this.defaultValue.cycle)}}}class K extends i{constructor(){super(126)}compute(ie,fe,$e){return ie.pixelRatio}}class ee extends A{constructor(){const ie={other:!0,comments:!1,strings:!1};super(76,"quickSuggestions",ie,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ie.strings,description:p.localize(58,null)},comments:{type:"boolean",default:ie.comments,description:p.localize(59,null)},other:{type:"boolean",default:ie.other,description:p.localize(60,null)}}}],default:ie,description:p.localize(61,null)});this.defaultValue=ie}validate(ie){if(typeof ie=="boolean")return ie;if(ie&&typeof ie=="object"){const fe=ie,$e={other:c(fe.other,this.defaultValue.other),comments:c(fe.comments,this.defaultValue.comments),strings:c(fe.strings,this.defaultValue.strings)};return $e.other&&$e.comments&&$e.strings?!0:!$e.other&&!$e.comments&&!$e.strings?!1:$e}return this.defaultValue}}var de;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(de=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Se extends A{constructor(){super(57,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(62,null),p.localize(63,null),p.localize(64,null),p.localize(65,null)],default:"on",description:p.localize(66,null)})}validate(ie){let fe=this.defaultValue.renderType,$e=this.defaultValue.renderFn;return typeof ie!="undefined"&&(typeof ie=="function"?(fe=4,$e=ie):ie==="interval"?fe=3:ie==="relative"?fe=2:ie==="on"?fe=1:fe=0),{renderType:fe,renderFn:$e}}}function De(X){const ie=X.get(85);return ie==="editable"?X.get(78):ie!=="on"}e.filterValidationDecorations=De;class Le extends A{constructor(){const ie=[],fe={type:"number",description:p.localize(67,null)};super(89,"rulers",ie,{type:"array",items:{anyOf:[fe,{type:["object"],properties:{column:fe,color:{type:"string",description:p.localize(68,null),format:"color-hex"}}}]},default:ie,description:p.localize(69,null)})}validate(ie){if(Array.isArray(ie)){let fe=[];for(let $e of ie)if(typeof $e=="number")fe.push({column:a.clampedInt($e,0,0,1e4),color:null});else if($e&&typeof $e=="object"){const xe=$e;fe.push({column:a.clampedInt(xe.column,0,0,1e4),color:xe.color})}return fe.sort(($e,xe)=>$e.column-xe.column),fe}return this.defaultValue}}function qe(X,ie){if(typeof X!="string")return ie;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class We extends A{constructor(){const ie={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(90,"scrollbar",ie,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(70,null),p.localize(71,null),p.localize(72,null)],default:"auto",description:p.localize(73,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(74,null),p.localize(75,null),p.localize(76,null)],default:"auto",description:p.localize(77,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ie.verticalScrollbarSize,description:p.localize(78,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ie.horizontalScrollbarSize,description:p.localize(79,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ie.scrollByPage,description:p.localize(80,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const fe=ie,$e=a.clampedInt(fe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=a.clampedInt(fe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(fe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:qe(fe.vertical,this.defaultValue.vertical),horizontal:qe(fe.horizontal,this.defaultValue.horizontal),useShadows:c(fe.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(fe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(fe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(fe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(fe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:$e,horizontalSliderSize:a.clampedInt(fe.horizontalSliderSize,$e,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:a.clampedInt(fe.verticalSliderSize,xe,0,1e3),scrollByPage:c(fe.scrollByPage,this.defaultValue.scrollByPage)}}}class je extends A{constructor(){const ie={enabled:!1,mode:"subwordSmart"};super(52,"inlineSuggest",ie,{"editor.inlineSuggest.enabled":{type:"boolean",default:ie.enabled,description:p.localize(81,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[p.localize(82,null),p.localize(83,null),p.localize(84,null)],default:ie.mode,description:p.localize(85,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const fe=ie;return{enabled:c(fe.enabled,this.defaultValue.enabled),mode:_(fe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class W extends A{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(104,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(86,null),p.localize(87,null)],default:ie.insertMode,description:p.localize(88,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:p.localize(89,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:p.localize(90,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:p.localize(91,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:p.localize(92,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:p.localize(93,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:p.localize(94,null)},"editor.suggest.preview":{type:"boolean",default:ie.preview,description:p.localize(95,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[p.localize(96,null),p.localize(97,null),p.localize(98,null)],default:ie.previewMode,description:p.localize(99,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:p.localize(100,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(101,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(102,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(103,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(104,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(105,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(106,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(107,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(108,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(109,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(110,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(111,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(112,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(113,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(114,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(115,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(116,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(117,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(118,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(119,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(120,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(121,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(122,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(123,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(124,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(125,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(126,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(127,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(128,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(129,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(130,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(131,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const fe=ie;return{insertMode:_(fe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(fe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(fe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(fe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(fe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:c(fe.showIcons,this.defaultValue.showIcons),showStatusBar:c(fe.showStatusBar,this.defaultValue.showStatusBar),preview:c(fe.preview,this.defaultValue.preview),previewMode:_(fe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(fe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(fe.showMethods,this.defaultValue.showMethods),showFunctions:c(fe.showFunctions,this.defaultValue.showFunctions),showConstructors:c(fe.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(fe.showDeprecated,this.defaultValue.showDeprecated),showFields:c(fe.showFields,this.defaultValue.showFields),showVariables:c(fe.showVariables,this.defaultValue.showVariables),showClasses:c(fe.showClasses,this.defaultValue.showClasses),showStructs:c(fe.showStructs,this.defaultValue.showStructs),showInterfaces:c(fe.showInterfaces,this.defaultValue.showInterfaces),showModules:c(fe.showModules,this.defaultValue.showModules),showProperties:c(fe.showProperties,this.defaultValue.showProperties),showEvents:c(fe.showEvents,this.defaultValue.showEvents),showOperators:c(fe.showOperators,this.defaultValue.showOperators),showUnits:c(fe.showUnits,this.defaultValue.showUnits),showValues:c(fe.showValues,this.defaultValue.showValues),showConstants:c(fe.showConstants,this.defaultValue.showConstants),showEnums:c(fe.showEnums,this.defaultValue.showEnums),showEnumMembers:c(fe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(fe.showKeywords,this.defaultValue.showKeywords),showWords:c(fe.showWords,this.defaultValue.showWords),showColors:c(fe.showColors,this.defaultValue.showColors),showFiles:c(fe.showFiles,this.defaultValue.showFiles),showReferences:c(fe.showReferences,this.defaultValue.showReferences),showFolders:c(fe.showFolders,this.defaultValue.showFolders),showTypeParameters:c(fe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(fe.showSnippets,this.defaultValue.showSnippets),showUsers:c(fe.showUsers,this.defaultValue.showUsers),showIssues:c(fe.showIssues,this.defaultValue.showIssues)}}}class Z extends A{constructor(){super(100,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(132,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class te extends i{constructor(){super(127,[78])}compute(ie,fe,$e){return fe.get(78)?!0:ie.tabFocusMode}}var ae;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(ae=e.WrappingIndent||(e.WrappingIndent={}));function Y(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class se extends i{constructor(){super(129,[128])}compute(ie,fe,$e){const xe=fe.get(128);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}const we="Consolas, 'Courier New', monospace",Fe="Menlo, Monaco, 'Courier New', monospace",ze="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?Fe:L.isLinux?ze:we,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function _e(X){return e.editorOptionsRegistry[X.id]=X,X}var Ze;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.codeLens=12]="codeLens",X[X.codeLensFontFamily=13]="codeLensFontFamily",X[X.codeLensFontSize=14]="codeLensFontSize",X[X.colorDecorators=15]="colorDecorators",X[X.columnSelection=16]="columnSelection",X[X.comments=17]="comments",X[X.contextmenu=18]="contextmenu",X[X.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",X[X.cursorBlinking=20]="cursorBlinking",X[X.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",X[X.cursorStyle=22]="cursorStyle",X[X.cursorSurroundingLines=23]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",X[X.cursorWidth=25]="cursorWidth",X[X.disableLayerHinting=26]="disableLayerHinting",X[X.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",X[X.domReadOnly=28]="domReadOnly",X[X.dragAndDrop=29]="dragAndDrop",X[X.emptySelectionClipboard=30]="emptySelectionClipboard",X[X.extraEditorClassName=31]="extraEditorClassName",X[X.fastScrollSensitivity=32]="fastScrollSensitivity",X[X.find=33]="find",X[X.fixedOverflowWidgets=34]="fixedOverflowWidgets",X[X.folding=35]="folding",X[X.foldingStrategy=36]="foldingStrategy",X[X.foldingHighlight=37]="foldingHighlight",X[X.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=39]="fontFamily",X[X.fontInfo=40]="fontInfo",X[X.fontLigatures=41]="fontLigatures",X[X.fontSize=42]="fontSize",X[X.fontWeight=43]="fontWeight",X[X.formatOnPaste=44]="formatOnPaste",X[X.formatOnType=45]="formatOnType",X[X.glyphMargin=46]="glyphMargin",X[X.gotoLocation=47]="gotoLocation",X[X.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",X[X.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",X[X.hover=50]="hover",X[X.inDiffEditor=51]="inDiffEditor",X[X.inlineSuggest=52]="inlineSuggest",X[X.letterSpacing=53]="letterSpacing",X[X.lightbulb=54]="lightbulb",X[X.lineDecorationsWidth=55]="lineDecorationsWidth",X[X.lineHeight=56]="lineHeight",X[X.lineNumbers=57]="lineNumbers",X[X.lineNumbersMinChars=58]="lineNumbersMinChars",X[X.linkedEditing=59]="linkedEditing",X[X.links=60]="links",X[X.matchBrackets=61]="matchBrackets",X[X.minimap=62]="minimap",X[X.mouseStyle=63]="mouseStyle",X[X.mouseWheelScrollSensitivity=64]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=65]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=66]="multiCursorMergeOverlapping",X[X.multiCursorModifier=67]="multiCursorModifier",X[X.multiCursorPaste=68]="multiCursorPaste",X[X.occurrencesHighlight=69]="occurrencesHighlight",X[X.overviewRulerBorder=70]="overviewRulerBorder",X[X.overviewRulerLanes=71]="overviewRulerLanes",X[X.padding=72]="padding",X[X.parameterHints=73]="parameterHints",X[X.peekWidgetDefaultFocus=74]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=75]="definitionLinkOpensInPeek",X[X.quickSuggestions=76]="quickSuggestions",X[X.quickSuggestionsDelay=77]="quickSuggestionsDelay",X[X.readOnly=78]="readOnly",X[X.renameOnType=79]="renameOnType",X[X.renderControlCharacters=80]="renderControlCharacters",X[X.renderIndentGuides=81]="renderIndentGuides",X[X.renderFinalNewline=82]="renderFinalNewline",X[X.renderLineHighlight=83]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=84]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=85]="renderValidationDecorations",X[X.renderWhitespace=86]="renderWhitespace",X[X.revealHorizontalRightPadding=87]="revealHorizontalRightPadding",X[X.roundedSelection=88]="roundedSelection",X[X.rulers=89]="rulers",X[X.scrollbar=90]="scrollbar",X[X.scrollBeyondLastColumn=91]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=92]="scrollBeyondLastLine",X[X.scrollPredominantAxis=93]="scrollPredominantAxis",X[X.selectionClipboard=94]="selectionClipboard",X[X.selectionHighlight=95]="selectionHighlight",X[X.selectOnLineNumbers=96]="selectOnLineNumbers",X[X.showFoldingControls=97]="showFoldingControls",X[X.showUnused=98]="showUnused",X[X.snippetSuggestions=99]="snippetSuggestions",X[X.smartSelect=100]="smartSelect",X[X.smoothScrolling=101]="smoothScrolling",X[X.stickyTabStops=102]="stickyTabStops",X[X.stopRenderingLineAfter=103]="stopRenderingLineAfter",X[X.suggest=104]="suggest",X[X.suggestFontSize=105]="suggestFontSize",X[X.suggestLineHeight=106]="suggestLineHeight",X[X.suggestOnTriggerCharacters=107]="suggestOnTriggerCharacters",X[X.suggestSelection=108]="suggestSelection",X[X.tabCompletion=109]="tabCompletion",X[X.tabIndex=110]="tabIndex",X[X.unusualLineTerminators=111]="unusualLineTerminators",X[X.useShadowDOM=112]="useShadowDOM",X[X.useTabStops=113]="useTabStops",X[X.wordSeparators=114]="wordSeparators",X[X.wordWrap=115]="wordWrap",X[X.wordWrapBreakAfterCharacters=116]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=117]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=118]="wordWrapColumn",X[X.wordWrapOverride1=119]="wordWrapOverride1",X[X.wordWrapOverride2=120]="wordWrapOverride2",X[X.wrappingIndent=121]="wrappingIndent",X[X.wrappingStrategy=122]="wrappingStrategy",X[X.showDeprecated=123]="showDeprecated",X[X.inlayHints=124]="inlayHints",X[X.editorClassName=125]="editorClassName",X[X.pixelRatio=126]="pixelRatio",X[X.tabFocusMode=127]="tabFocusMode",X[X.layoutInfo=128]="layoutInfo",X[X.wrappingInfo=129]="wrappingInfo"})(Ze=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:_e(new u(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(133,null)})),acceptSuggestionOnEnter:_e(new b(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(134,null),""],markdownDescription:p.localize(135,null)})),accessibilitySupport:_e(new v),accessibilityPageSize:_e(new a(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(136,null)})),ariaLabel:_e(new w(4,"ariaLabel",p.localize(137,null))),autoClosingBrackets:_e(new b(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(138,null),p.localize(139,null),""],description:p.localize(140,null)})),autoClosingDelete:_e(new b(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(141,null),""],description:p.localize(142,null)})),autoClosingOvertype:_e(new b(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(143,null),""],description:p.localize(144,null)})),autoClosingQuotes:_e(new b(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(145,null),p.localize(146,null),""],description:p.localize(147,null)})),autoIndent:_e(new d(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],h,{enumDescriptions:[p.localize(148,null),p.localize(149,null),p.localize(150,null),p.localize(151,null),p.localize(152,null)],description:p.localize(153,null)})),automaticLayout:_e(new u(10,"automaticLayout",!1)),autoSurround:_e(new b(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(154,null),p.localize(155,null),p.localize(156,null),""],description:p.localize(157,null)})),stickyTabStops:_e(new u(102,"stickyTabStops",!1,{description:p.localize(158,null)})),codeLens:_e(new u(12,"codeLens",!0,{description:p.localize(159,null)})),codeLensFontFamily:_e(new w(13,"codeLensFontFamily","",{description:p.localize(160,null)})),codeLensFontSize:_e(new a(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(161,null)})),colorDecorators:_e(new u(15,"colorDecorators",!0,{description:p.localize(162,null)})),columnSelection:_e(new u(16,"columnSelection",!1,{description:p.localize(163,null)})),comments:_e(new t),contextmenu:_e(new u(18,"contextmenu",!0)),copyWithSyntaxHighlighting:_e(new u(19,"copyWithSyntaxHighlighting",!0,{description:p.localize(164,null)})),cursorBlinking:_e(new d(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:p.localize(165,null)})),cursorSmoothCaretAnimation:_e(new u(21,"cursorSmoothCaretAnimation",!1,{description:p.localize(166,null)})),cursorStyle:_e(new d(22,"cursorStyle",n.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],f,{description:p.localize(167,null)})),cursorSurroundingLines:_e(new a(23,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(168,null)})),cursorSurroundingLinesStyle:_e(new b(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(169,null),p.localize(170,null)],description:p.localize(171,null)})),cursorWidth:_e(new a(25,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(172,null)})),disableLayerHinting:_e(new u(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:_e(new u(27,"disableMonospaceOptimizations",!1)),domReadOnly:_e(new u(28,"domReadOnly",!1)),dragAndDrop:_e(new u(29,"dragAndDrop",!0,{description:p.localize(173,null)})),emptySelectionClipboard:_e(new E),extraEditorClassName:_e(new w(31,"extraEditorClassName","")),fastScrollSensitivity:_e(new g(32,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:p.localize(174,null)})),find:_e(new y),fixedOverflowWidgets:_e(new u(34,"fixedOverflowWidgets",!1)),folding:_e(new u(35,"folding",!0,{description:p.localize(175,null)})),foldingStrategy:_e(new b(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(176,null),p.localize(177,null)],description:p.localize(178,null)})),foldingHighlight:_e(new u(37,"foldingHighlight",!0,{description:p.localize(179,null)})),unfoldOnClickAfterEndOfLine:_e(new u(38,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(180,null)})),fontFamily:_e(new w(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(181,null)})),fontInfo:_e(new k),fontLigatures2:_e(new o),fontSize:_e(new F),fontWeight:_e(new $),formatOnPaste:_e(new u(44,"formatOnPaste",!1,{description:p.localize(182,null)})),formatOnType:_e(new u(45,"formatOnType",!1,{description:p.localize(183,null)})),glyphMargin:_e(new u(46,"glyphMargin",!0,{description:p.localize(184,null)})),gotoLocation:_e(new Q),hideCursorInOverviewRuler:_e(new u(48,"hideCursorInOverviewRuler",!1,{description:p.localize(185,null)})),highlightActiveIndentGuide:_e(new u(49,"highlightActiveIndentGuide",!0,{description:p.localize(186,null)})),hover:_e(new oe),inDiffEditor:_e(new u(51,"inDiffEditor",!1)),letterSpacing:_e(new g(53,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>g.clamp(X,-5,20),{description:p.localize(187,null)})),lightbulb:_e(new B),lineDecorationsWidth:_e(new P(55,"lineDecorationsWidth",10)),lineHeight:_e(new z),lineNumbers:_e(new Se),lineNumbersMinChars:_e(new a(58,"lineNumbersMinChars",5,1,300)),linkedEditing:_e(new u(59,"linkedEditing",!1,{description:p.localize(188,null)})),links:_e(new u(60,"links",!0,{description:p.localize(189,null)})),matchBrackets:_e(new b(61,"matchBrackets","always",["always","near","never"],{description:p.localize(190,null)})),minimap:_e(new N),mouseStyle:_e(new b(63,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:_e(new g(64,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:p.localize(191,null)})),mouseWheelZoom:_e(new u(65,"mouseWheelZoom",!1,{markdownDescription:p.localize(192,null)})),multiCursorMergeOverlapping:_e(new u(66,"multiCursorMergeOverlapping",!0,{description:p.localize(193,null)})),multiCursorModifier:_e(new d(67,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],M,{markdownEnumDescriptions:[p.localize(194,null),p.localize(195,null)],markdownDescription:p.localize(196,null)})),multiCursorPaste:_e(new b(68,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(197,null),p.localize(198,null)],markdownDescription:p.localize(199,null)})),occurrencesHighlight:_e(new u(69,"occurrencesHighlight",!0,{description:p.localize(200,null)})),overviewRulerBorder:_e(new u(70,"overviewRulerBorder",!0,{description:p.localize(201,null)})),overviewRulerLanes:_e(new a(71,"overviewRulerLanes",3,0,3)),padding:_e(new q),parameterHints:_e(new x),peekWidgetDefaultFocus:_e(new b(74,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(202,null),p.localize(203,null)],description:p.localize(204,null)})),definitionLinkOpensInPeek:_e(new u(75,"definitionLinkOpensInPeek",!1,{description:p.localize(205,null)})),quickSuggestions:_e(new ee),quickSuggestionsDelay:_e(new a(77,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(206,null)})),readOnly:_e(new u(78,"readOnly",!1)),renameOnType:_e(new u(79,"renameOnType",!1,{description:p.localize(207,null),markdownDeprecationMessage:p.localize(208,null)})),renderControlCharacters:_e(new u(80,"renderControlCharacters",!1,{description:p.localize(209,null)})),renderIndentGuides:_e(new u(81,"renderIndentGuides",!0,{description:p.localize(210,null)})),renderFinalNewline:_e(new u(82,"renderFinalNewline",!0,{description:p.localize(211,null)})),renderLineHighlight:_e(new b(83,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(212,null)],description:p.localize(213,null)})),renderLineHighlightOnlyWhenFocus:_e(new u(84,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(214,null)})),renderValidationDecorations:_e(new b(85,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:_e(new b(86,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(215,null),p.localize(216,null),p.localize(217,null),""],description:p.localize(218,null)})),revealHorizontalRightPadding:_e(new a(87,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:_e(new u(88,"roundedSelection",!0,{description:p.localize(219,null)})),rulers:_e(new Le),scrollbar:_e(new We),scrollBeyondLastColumn:_e(new a(91,"scrollBeyondLastColumn",5,0,1073741824,{description:p.localize(220,null)})),scrollBeyondLastLine:_e(new u(92,"scrollBeyondLastLine",!0,{description:p.localize(221,null)})),scrollPredominantAxis:_e(new u(93,"scrollPredominantAxis",!0,{description:p.localize(222,null)})),selectionClipboard:_e(new u(94,"selectionClipboard",!0,{description:p.localize(223,null),included:L.isLinux})),selectionHighlight:_e(new u(95,"selectionHighlight",!0,{description:p.localize(224,null)})),selectOnLineNumbers:_e(new u(96,"selectOnLineNumbers",!0)),showFoldingControls:_e(new b(97,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[p.localize(225,null),p.localize(226,null)],description:p.localize(227,null)})),showUnused:_e(new u(98,"showUnused",!0,{description:p.localize(228,null)})),showDeprecated:_e(new u(123,"showDeprecated",!0,{description:p.localize(229,null)})),inlayHints:_e(new R),snippetSuggestions:_e(new b(99,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(230,null),p.localize(231,null),p.localize(232,null),p.localize(233,null)],description:p.localize(234,null)})),smartSelect:_e(new Z),smoothScrolling:_e(new u(101,"smoothScrolling",!1,{description:p.localize(235,null)})),stopRenderingLineAfter:_e(new a(103,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:_e(new W),inlineSuggest:_e(new je),suggestFontSize:_e(new a(105,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(236,null)})),suggestLineHeight:_e(new a(106,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(237,null)})),suggestOnTriggerCharacters:_e(new u(107,"suggestOnTriggerCharacters",!0,{description:p.localize(238,null)})),suggestSelection:_e(new b(108,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(239,null),p.localize(240,null),p.localize(241,null)],description:p.localize(242,null)})),tabCompletion:_e(new b(109,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(243,null),p.localize(244,null),p.localize(245,null)],description:p.localize(246,null)})),tabIndex:_e(new a(110,"tabIndex",0,-1,1073741824)),unusualLineTerminators:_e(new b(111,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(247,null),p.localize(248,null),p.localize(249,null)],description:p.localize(250,null)})),useShadowDOM:_e(new u(112,"useShadowDOM",!0)),useTabStops:_e(new u(113,"useTabStops",!0,{description:p.localize(251,null)})),wordSeparators:_e(new w(114,"wordSeparators",C.USUAL_WORD_SEPARATORS,{description:p.localize(252,null)})),wordWrap:_e(new b(115,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(253,null),p.localize(254,null),p.localize(255,null),p.localize(256,null)],description:p.localize(257,null)})),wordWrapBreakAfterCharacters:_e(new w(116,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:_e(new w(117,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:_e(new a(118,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(258,null)})),wordWrapOverride1:_e(new b(119,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:_e(new b(120,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:_e(new d(121,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Y,{enumDescriptions:[p.localize(259,null),p.localize(260,null),p.localize(261,null),p.localize(262,null)],description:p.localize(263,null)})),wrappingStrategy:_e(new b(122,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[p.localize(264,null),p.localize(265,null)],description:p.localize(266,null)})),editorClassName:_e(new m),pixelRatio:_e(new K),tabFocusMode:_e(new te),layoutInfo:_e(new O),wrappingInfo:_e(new se)}}),define(me[152],ge([19,20]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[153],ge([19,20]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[154],ge([19,20]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[155],ge([19,20]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(me[156],ge([19,20]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(me[157],ge([19,20]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(me[158],ge([19,20]),function(J,e){return J.create("vs/platform/workspaces/common/workspaces",e)}),define(me[159],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[160],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[161],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(me[162],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[163],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[164],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[165],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[166],ge([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[167],ge([19,20]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(me[168],ge([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[169],ge([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[170],ge([19,20]),function(J,e){return J.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[171],ge([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[172],ge([19,20]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[173],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var p;(function(T){T[T.ACTIVATE=1]="ACTIVATE",T[T.RESTORE=2]="RESTORE",T[T.PRESERVE=3]="PRESERVE"})(p=e.EditorActivation||(e.EditorActivation={}));var L;(function(T){T[T.PICK=0]="PICK",T[T.DISABLED=1]="DISABLED",T[T.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(L=e.EditorResolution||(e.EditorResolution={}));var C;(function(T){T[T.API=0]="API",T[T.USER=1]="USER"})(C=e.EditorOpenContext||(e.EditorOpenContext={}));var S;(function(T){T[T.Center=0]="Center",T[T.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",T[T.NearTop=2]="NearTop",T[T.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(S=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[174],ge([0,1,154]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function S(c){return c=c.trim(),c==="*"||L.test(c)}e.isValidVersionStr=S;function T(c){if(!S(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let u=c.match(L);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.parseVersion=T;function I(c){if(!c)return null;let u=c.majorBase,a=c.majorMustEqual,g=c.minorBase,w=c.minorMustEqual,_=c.patchBase,b=c.patchMustEqual;c.hasCaret&&(u===0||(w=!1),b=!1);let d=0;if(c.preRelease){const h=C.exec(c.preRelease);if(h){const[,v,t,s]=h;d=Date.UTC(Number(v),Number(t)-1,Number(s))}}return{majorBase:u,majorMustEqual:a,minorBase:g,minorMustEqual:w,patchBase:_,patchMustEqual:b,isMinimum:c.hasGreaterEquals,notBefore:d}}e.normalizeVersion=I;function D(c,u,a){let g;typeof c=="string"?g=I(T(c)):g=c;let w;u instanceof Date?w=u.getTime():typeof u=="string"&&(w=new Date(u).getTime());let _;if(typeof a=="string"?_=I(T(a)):_=a,!g||!_)return!1;let b=g.majorBase,d=g.minorBase,h=g.patchBase,v=_.majorBase,t=_.minorBase,s=_.patchBase,r=_.notBefore,n=_.majorMustEqual,l=_.minorMustEqual,f=_.patchMustEqual;return _.isMinimum?b>v?!0:b<v?!1:d>t?!0:d<t||w&&w<r?!1:h>=s:(b===1&&v===0&&(!n||!l||!f)&&(v=1,t=0,s=0,n=!0,l=!1,f=!1),b<v?!1:b>v?!n:d<t?!1:d>t?!l:h<s?!1:h>s?!f:!(w&&w<r))}e.isValidVersion=D;function A(c,u,a,g){return a.isBuiltin||typeof a.main=="undefined"?!0:P(c,u,a.engines.vscode,g)}e.isValidExtensionVersion=A;function i(c,u,a){return c==="*"||P(u,a,c)}e.isEngineValid=i;function P(c,u,a,g=[]){let w=I(T(a));if(!w)return g.push(p.localize(0,null,a)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return g.push(p.localize(1,null,a)),!1}else if(!w.majorMustEqual)return g.push(p.localize(2,null,a)),!1;return D(c,u,w)?!0:(g.push(p.localize(3,null,c,a)),!1)}}),define(me[113],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class p{constructor(C,S=[],T=!1){this.ctor=C,this.staticArguments=S,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=p}),define(me[78],ge([0,1,113]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function C(T,I,D){I instanceof p.SyncDescriptor||(I=new p.SyncDescriptor(I,[],D)),L.push([T,I])}e.registerSingleton=C;function S(){return L}e.getSingletonServiceDescriptors=S}),define(me[175],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(S){this.incoming=new Map,this.outgoing=new Map,this.data=S}}e.Node=p;class L{constructor(S){this._hashFn=S,this._nodes=new Map}roots(){const S=[];for(let T of this._nodes.values())T.outgoing.size===0&&S.push(T);return S}insertEdge(S,T){const I=this.lookupOrInsertNode(S),D=this.lookupOrInsertNode(T);I.outgoing.set(this._hashFn(T),D),D.incoming.set(this._hashFn(S),I)}removeNode(S){const T=this._hashFn(S);this._nodes.delete(T);for(let I of this._nodes.values())I.outgoing.delete(T),I.incoming.delete(T)}lookupOrInsertNode(S){const T=this._hashFn(S);let I=this._nodes.get(T);return I||(I=new p(S),this._nodes.set(T,I)),I}lookup(S){return this._nodes.get(this._hashFn(S))}isEmpty(){return this._nodes.size===0}toString(){let S=[];for(let[T,I]of this._nodes)S.push(`${T}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return S.join(`
`)}findCycleSlow(){for(let[S,T]of this._nodes){const I=new Set([S]),D=this._findCycle(T,I);if(D)return D}}_findCycle(S,T){for(let[I,D]of S.outgoing){if(T.has(I))return[...T,I].join(" -> ");T.add(I);const A=this._findCycle(D,T);if(A)return A;T.delete(I)}}}e.Graph=L}),define(me[4],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function D(A){return A[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=D})(p=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function L(I,D,A,i){D[p.DI_TARGET]===D?D[p.DI_DEPENDENCIES].push({id:I,index:A,optional:i}):(D[p.DI_DEPENDENCIES]=[{id:I,index:A,optional:i}],D[p.DI_TARGET]=D)}function C(I){if(p.serviceIds.has(I))return p.serviceIds.get(I);const D=function(A,i,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(D,A,P,!1)};return D.toString=()=>I,p.serviceIds.set(I,D),D}e.createDecorator=C;function S(I){return I}e.refineServiceDecorator=S;function T(I){return function(D,A,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(I,D,i,!0)}}e.optional=T}),define(me[176],ge([0,1,4]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,p.createDecorator)("modelService");function L(C){return!C.isTooLargeForSyncing()&&!C.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(me[177],ge([0,1,3,55,6,23,73,77,176]),function(J,e,p,L,C,S,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function A(c){return typeof c=="string"?!1:Array.isArray(c)?c.every(A):!!c.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new p.Emitter}get onDidChange(){return this._onDidChange.event}register(u,a){let g={selector:u,provider:a,_score:-1,_time:this._clock++};return this._entries.push(g),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,C.toDisposable)(()=>{if(g){let w=this._entries.indexOf(g);w>=0&&(this._entries.splice(w,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),g=void 0)}})}has(u){return this.all(u).length>0}all(u){if(!u)return[];this._updateScores(u);const a=[];for(let g of this._entries)g._score>0&&a.push(g.provider);return a}ordered(u){const a=[];return this._orderedForEach(u,g=>a.push(g.provider)),a}orderedGroups(u){const a=[];let g,w;return this._orderedForEach(u,_=>{g&&w===_._score?g.push(_.provider):(w=_._score,g=[_.provider],a.push(g))}),a}_orderedForEach(u,a){if(!!u){this._updateScores(u);for(const g of this._entries)g._score>0&&a(g)}}_updateScores(u){let a={uri:u.uri.toString(),language:u.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===a.language&&this._lastCandidate.uri===a.uri)){this._lastCandidate=a;for(let g of this._entries)if(g._score=(0,I.score)(g.selector,u.uri,u.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(u)),A(g.selector)&&g._score>0){for(let w of this._entries)w._score=0;g._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(u,a){return u._score<a._score?1:u._score>a._score?-1:u._time<a._time?1:u._time>a._time?-1:0}}e.LanguageFeatureRegistry=i;class P{constructor(u,a,g=Number.MAX_SAFE_INTEGER){this._registry=u,this.min=a,this.max=g,this._cache=new S.LRUCache(50,.7)}_key(u){return u.id+(0,L.hash)(this._registry.all(u))}_clamp(u){return u===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(u*1.3)))}get(u){const a=this._key(u),g=this._cache.get(a);return this._clamp(g?.value)}update(u,a){const g=this._key(u);let w=this._cache.get(g);return w||(w=new T.MovingAverage,this._cache.set(g,w)),w.update(a),this.get(u)}}e.LanguageFeatureRequestDelays=P}),define(me[79],ge([0,1,2,40,177,145,74]),function(J,e,p,L,C,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var I;(function(o){o[o.Null=0]="Null",o[o.PlainText=1]="PlainText"})(I=e.LanguageId||(e.LanguageId={}));class D{constructor(k,F){this.language=k,this.id=F}}e.LanguageIdentifier=D;var A;(function(o){o[o.NotSet=-1]="NotSet",o[o.None=0]="None",o[o.Italic=1]="Italic",o[o.Bold=2]="Bold",o[o.Underline=4]="Underline"})(A=e.FontStyle||(e.FontStyle={}));var i;(function(o){o[o.None=0]="None",o[o.DefaultForeground=1]="DefaultForeground",o[o.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var P;(function(o){o[o.Other=0]="Other",o[o.Comment=1]="Comment",o[o.String=2]="String",o[o.RegEx=4]="RegEx"})(P=e.StandardTokenType||(e.StandardTokenType={}));var c;(function(o){o[o.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",o[o.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",o[o.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",o[o.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",o[o.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",o[o.ITALIC_MASK=2048]="ITALIC_MASK",o[o.BOLD_MASK=4096]="BOLD_MASK",o[o.UNDERLINE_MASK=8192]="UNDERLINE_MASK",o[o.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",o[o.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",o[o.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",o[o.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",o[o.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",o[o.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",o[o.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",o[o.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",o[o.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",o[o.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(c=e.MetadataConsts||(e.MetadataConsts={}));class u{static getLanguageId(k){return(k&255)>>>0}static getTokenType(k){return(k&1792)>>>8}static getFontStyle(k){return(k&14336)>>>11}static getForeground(k){return(k&8372224)>>>14}static getBackground(k){return(k&4286578688)>>>23}static getClassNameFromMetadata(k){let F=this.getForeground(k),$="mtk"+F,Q=this.getFontStyle(k);return Q&1&&($+=" mtki"),Q&2&&($+=" mtkb"),Q&4&&($+=" mtku"),$}static getInlineStyleFromMetadata(k,F){const $=this.getForeground(k),Q=this.getFontStyle(k);let oe=`color: ${F[$]};`;return Q&1&&(oe+="font-style: italic;"),Q&2&&(oe+="font-weight: bold;"),Q&4&&(oe+="text-decoration: underline;"),oe}}e.TokenMetadata=u;var a;(function(o){o[o.Method=0]="Method",o[o.Function=1]="Function",o[o.Constructor=2]="Constructor",o[o.Field=3]="Field",o[o.Variable=4]="Variable",o[o.Class=5]="Class",o[o.Struct=6]="Struct",o[o.Interface=7]="Interface",o[o.Module=8]="Module",o[o.Property=9]="Property",o[o.Event=10]="Event",o[o.Operator=11]="Operator",o[o.Unit=12]="Unit",o[o.Value=13]="Value",o[o.Constant=14]="Constant",o[o.Enum=15]="Enum",o[o.EnumMember=16]="EnumMember",o[o.Keyword=17]="Keyword",o[o.Text=18]="Text",o[o.Color=19]="Color",o[o.File=20]="File",o[o.Reference=21]="Reference",o[o.Customcolor=22]="Customcolor",o[o.Folder=23]="Folder",o[o.TypeParameter=24]="TypeParameter",o[o.User=25]="User",o[o.Issue=26]="Issue",o[o.Snippet=27]="Snippet"})(a=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let o=Object.create(null);return o[0]="symbol-method",o[1]="symbol-function",o[2]="symbol-constructor",o[3]="symbol-field",o[4]="symbol-variable",o[5]="symbol-class",o[6]="symbol-struct",o[7]="symbol-interface",o[8]="symbol-module",o[9]="symbol-property",o[10]="symbol-event",o[11]="symbol-operator",o[12]="symbol-unit",o[13]="symbol-value",o[14]="symbol-constant",o[15]="symbol-enum",o[16]="symbol-enum-member",o[17]="symbol-keyword",o[27]="symbol-snippet",o[18]="symbol-text",o[19]="symbol-color",o[20]="symbol-file",o[21]="symbol-reference",o[22]="symbol-customcolor",o[23]="symbol-folder",o[24]="symbol-type-parameter",o[25]="account",o[26]="issues",function(k){const F=o[k];let $=F&&T.iconRegistry.get(F);return $||(console.info("No codicon found for CompletionItemKind "+k),$=T.Codicon.symbolProperty),$.classNames}}(),e.completionKindFromString=function(){let o=Object.create(null);return o.method=0,o.function=1,o.constructor=2,o.field=3,o.variable=4,o.class=5,o.struct=6,o.interface=7,o.module=8,o.property=9,o.event=10,o.operator=11,o.unit=12,o.value=13,o.constant=14,o.enum=15,o["enum-member"]=16,o.enumMember=16,o.keyword=17,o.snippet=27,o.text=18,o.color=19,o.file=20,o.reference=21,o.customcolor=22,o.folder=23,o["type-parameter"]=24,o.typeParameter=24,o.account=25,o.issue=26,function(k,F){let $=o[k];return typeof $=="undefined"&&!F&&($=9),$}}();var g;(function(o){o[o.Deprecated=1]="Deprecated"})(g=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(o){o[o.KeepWhitespace=1]="KeepWhitespace",o[o.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var _;(function(o){o[o.Invoke=0]="Invoke",o[o.TriggerCharacter=1]="TriggerCharacter",o[o.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(_=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var b;(function(o){o[o.Automatic=0]="Automatic",o[o.Explicit=1]="Explicit"})(b=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var d;(function(o){o[o.Invoke=1]="Invoke",o[o.Auto=2]="Auto"})(d=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var h;(function(o){o[o.Invoke=1]="Invoke",o[o.TriggerCharacter=2]="TriggerCharacter",o[o.ContentChange=3]="ContentChange"})(h=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var v;(function(o){o[o.Text=0]="Text",o[o.Read=1]="Read",o[o.Write=2]="Write"})(v=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(o){return o&&p.URI.isUri(o.uri)&&L.Range.isIRange(o.range)&&(L.Range.isIRange(o.originSelectionRange)||L.Range.isIRange(o.targetSelectionRange))}e.isLocationLink=t;var s;(function(o){o[o.File=0]="File",o[o.Module=1]="Module",o[o.Namespace=2]="Namespace",o[o.Package=3]="Package",o[o.Class=4]="Class",o[o.Method=5]="Method",o[o.Property=6]="Property",o[o.Field=7]="Field",o[o.Constructor=8]="Constructor",o[o.Enum=9]="Enum",o[o.Interface=10]="Interface",o[o.Function=11]="Function",o[o.Variable=12]="Variable",o[o.Constant=13]="Constant",o[o.String=14]="String",o[o.Number=15]="Number",o[o.Boolean=16]="Boolean",o[o.Array=17]="Array",o[o.Object=18]="Object",o[o.Key=19]="Key",o[o.Null=20]="Null",o[o.EnumMember=21]="EnumMember",o[o.Struct=22]="Struct",o[o.Event=23]="Event",o[o.Operator=24]="Operator",o[o.TypeParameter=25]="TypeParameter"})(s=e.SymbolKind||(e.SymbolKind={}));var r;(function(o){o[o.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var n;(function(o){const k=new Map;k.set("file",0),k.set("module",1),k.set("namespace",2),k.set("package",3),k.set("class",4),k.set("method",5),k.set("property",6),k.set("field",7),k.set("constructor",8),k.set("enum",9),k.set("interface",10),k.set("function",11),k.set("variable",12),k.set("constant",13),k.set("string",14),k.set("number",15),k.set("boolean",16),k.set("array",17),k.set("object",18),k.set("key",19),k.set("null",20),k.set("enum-member",21),k.set("struct",22),k.set("event",23),k.set("operator",24),k.set("type-parameter",25);const F=new Map;F.set(0,"file"),F.set(1,"module"),F.set(2,"namespace"),F.set(3,"package"),F.set(4,"class"),F.set(5,"method"),F.set(6,"property"),F.set(7,"field"),F.set(8,"constructor"),F.set(9,"enum"),F.set(10,"interface"),F.set(11,"function"),F.set(12,"variable"),F.set(13,"constant"),F.set(14,"string"),F.set(15,"number"),F.set(16,"boolean"),F.set(17,"array"),F.set(18,"object"),F.set(19,"key"),F.set(20,"null"),F.set(21,"enum-member"),F.set(22,"struct"),F.set(23,"event"),F.set(24,"operator"),F.set(25,"type-parameter");function $(j){return k.get(j)}o.fromString=$;function Q(j){return F.get(j)}o.toString=Q;function oe(j,O){const B=F.get(j);let R=B&&T.iconRegistry.get("symbol-"+B);return R||(console.info("No codicon found for SymbolKind "+j),R=T.Codicon.symbolProperty),`${O?"inline":"block"} ${R.classNames}`}o.toCssClassName=oe})(n=e.SymbolKinds||(e.SymbolKinds={}));class l{constructor(k){this.value=k}}e.FoldingRangeKind=l,l.Comment=new l("comment"),l.Imports=new l("imports"),l.Region=new l("region");var f;(function(o){o[o.Collapsed=0]="Collapsed",o[o.Expanded=1]="Expanded"})(f=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var m;(function(o){o[o.Editing=0]="Editing",o[o.Preview=1]="Preview"})(m=e.CommentMode||(e.CommentMode={}));var E;(function(o){o[o.Other=0]="Other",o[o.Type=1]="Type",o[o.Parameter=2]="Parameter"})(E=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new C.LanguageFeatureRegistry,e.RenameProviderRegistry=new C.LanguageFeatureRegistry,e.CompletionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new C.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new C.LanguageFeatureRegistry,e.HoverProviderRegistry=new C.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new C.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new C.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new C.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new C.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new C.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.LinkProviderRegistry=new C.LanguageFeatureRegistry,e.ColorProviderRegistry=new C.LanguageFeatureRegistry,e.SelectionRangeRegistry=new C.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.TokenizationRegistry=new S.TokenizationRegistryImpl;var y;(function(o){o[o.None=0]="None",o[o.Option=1]="Option",o[o.Default=2]="Default",o[o.Preferred=3]="Preferred"})(y=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[80],ge([0,1,8,4,11]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let S=C.userAgent||"";const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",C.isMacintosh),T.set("isLinux",C.isLinux),T.set("isWindows",C.isWindows),T.set("isWeb",C.isWeb),T.set("isMacNative",C.isMacintosh&&!C.isWeb),T.set("isEdge",S.indexOf("Edg/")>=0),T.set("isFirefox",S.indexOf("Firefox")>=0),T.set("isChrome",S.indexOf("Chrome")>=0),T.set("isSafari",S.indexOf("Safari")>=0);const I=Object.prototype.hasOwnProperty;var D;(function(y){y[y.False=0]="False",y[y.True=1]="True",y[y.Defined=2]="Defined",y[y.Not=3]="Not",y[y.Equals=4]="Equals",y[y.NotEquals=5]="NotEquals",y[y.And=6]="And",y[y.Regex=7]="Regex",y[y.NotRegex=8]="NotRegex",y[y.Or=9]="Or",y[y.In=10]="In",y[y.NotIn=11]="NotIn",y[y.Greater=12]="Greater",y[y.GreaterEquals=13]="GreaterEquals",y[y.Smaller=14]="Smaller",y[y.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class A{static false(){return P.INSTANCE}static true(){return c.INSTANCE}static has(o){return u.create(o)}static equals(o,k){return a.create(o,k)}static notEquals(o,k){return _.create(o,k)}static regex(o,k){return s.create(o,k)}static in(o,k){return g.create(o,k)}static not(o){return b.create(o)}static and(...o){return n.create(o)}static or(...o){return l.create(o)}static greater(o,k){return d.create(o,k)}static less(o,k){return v.create(o,k)}static deserialize(o,k=!1){if(!!o)return this._deserializeOrExpression(o,k)}static _deserializeOrExpression(o,k){let F=o.split("||");return l.create(F.map($=>this._deserializeAndExpression($,k)))}static _deserializeAndExpression(o,k){let F=o.split("&&");return n.create(F.map($=>this._deserializeOne($,k)))}static _deserializeOne(o,k){if(o=o.trim(),o.indexOf("!=")>=0){let F=o.split("!=");return _.create(F[0].trim(),this._deserializeValue(F[1],k))}if(o.indexOf("==")>=0){let F=o.split("==");return a.create(F[0].trim(),this._deserializeValue(F[1],k))}if(o.indexOf("=~")>=0){let F=o.split("=~");return s.create(F[0].trim(),this._deserializeRegexValue(F[1],k))}if(o.indexOf(" in ")>=0){let F=o.split(" in ");return g.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(o)){const F=o.split(">=");return h.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(o)){const F=o.split(">");return d.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(o)){const F=o.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(o)){const F=o.split("<");return v.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(o)?b.create(o.substr(1).trim()):u.create(o)}static _deserializeValue(o,k){if(o=o.trim(),o==="true")return!0;if(o==="false")return!1;let F=/^'([^']*)'$/.exec(o);return F?F[1].trim():o}static _deserializeRegexValue(o,k){if((0,p.isFalsyOrWhitespace)(o)){if(k)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=o.indexOf("/"),$=o.lastIndexOf("/");if(F===$||F<0){if(k)throw new Error(`bad regexp-value '${o}', missing /-enclosure`);return console.warn(`bad regexp-value '${o}', missing /-enclosure`),null}let Q=o.slice(F+1,$),oe=o[$+1]==="i"?"i":"";try{return new RegExp(Q,oe)}catch(j){if(k)throw new Error(`bad regexp-value '${o}', parse error: ${j}`);return console.warn(`bad regexp-value '${o}', parse error: ${j}`),null}}}e.ContextKeyExpr=A;function i(y,o){return y.cmp(o)}class P{constructor(){this.type=0}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!1}serialize(){return"false"}keys(){return[]}map(o){return this}negate(){return c.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class c{constructor(){this.type=1}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!0}serialize(){return"true"}keys(){return[]}map(o){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=c,c.INSTANCE=new c;class u{constructor(o){this.key=o,this.type=2}static create(o){const k=T.get(o);return typeof k=="boolean"?k?c.INSTANCE:P.INSTANCE:new u(o)}cmp(o){return o.type!==this.type?this.type-o.type:m(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!!o.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(o){return o.mapDefined(this.key)}negate(){return b.create(this.key)}}e.ContextKeyDefinedExpr=u;class a{constructor(o,k){this.key=o,this.value=k,this.type=4}static create(o,k){if(typeof k=="boolean")return k?u.create(o):b.create(o);const F=T.get(o);return typeof F=="boolean"?k===(F?"true":"false")?c.INSTANCE:P.INSTANCE:new a(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:E(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(o){return o.mapEquals(this.key,this.value)}negate(){return _.create(this.key,this.value)}}e.ContextKeyEqualsExpr=a;class g{constructor(o,k){this.key=o,this.valueKey=k,this.type=10}static create(o,k){return new g(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:E(this.key,this.valueKey,o.key,o.valueKey)}equals(o){return o.type===this.type?this.key===o.key&&this.valueKey===o.valueKey:!1}evaluate(o){const k=o.getValue(this.valueKey),F=o.getValue(this.key);return Array.isArray(k)?k.indexOf(F)>=0:typeof F=="string"&&typeof k=="object"&&k!==null?I.call(k,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(o){return o.mapIn(this.key,this.valueKey)}negate(){return w.create(this)}}e.ContextKeyInExpr=g;class w{constructor(o){this._actual=o,this.type=11}static create(o){return new w(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new w(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotInExpr=w;class _{constructor(o,k){this.key=o,this.value=k,this.type=5}static create(o,k){if(typeof k=="boolean")return k?b.create(o):u.create(o);const F=T.get(o);return typeof F=="boolean"?k===(F?"true":"false")?P.INSTANCE:c.INSTANCE:new _(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:E(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(o){return o.mapNotEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=_;class b{constructor(o){this.key=o,this.type=3}static create(o){const k=T.get(o);return typeof k=="boolean"?k?P.INSTANCE:c.INSTANCE:new b(o)}cmp(o){return o.type!==this.type?this.type-o.type:m(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!o.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(o){return o.mapNot(this.key)}negate(){return u.create(this.key)}}e.ContextKeyNotExpr=b;class d{constructor(o,k){this.key=o,this.value=k,this.type=12}static create(o,k){return new d(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:E(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=d;class h{constructor(o,k){this.key=o,this.value=k,this.type=13}static create(o,k){return new h(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:E(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreaterEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=h;class v{constructor(o,k){this.key=o,this.value=k,this.type=14}static create(o,k){return new v(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:E(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmaller(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeySmallerExpr=v;class t{constructor(o,k){this.key=o,this.value=k,this.type=15}static create(o,k){return new t(o,k)}cmp(o){return o.type!==this.type?this.type-o.type:E(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmallerEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class s{constructor(o,k){this.key=o,this.regexp=k,this.type=7}static create(o,k){return new s(o,k)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.key<o.key)return-1;if(this.key>o.key)return 1;const k=this.regexp?this.regexp.source:"",F=o.regexp?o.regexp.source:"";return k<F?-1:k>F?1:0}equals(o){if(o.type===this.type){const k=this.regexp?this.regexp.source:"",F=o.regexp?o.regexp.source:"";return this.key===o.key&&k===F}return!1}evaluate(o){let k=o.getValue(this.key);return this.regexp?this.regexp.test(k):!1}serialize(){const o=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${o}`}keys(){return[this.key]}map(o){return o.mapRegex(this.key,this.regexp)}negate(){return r.create(this)}}e.ContextKeyRegexExpr=s;class r{constructor(o){this._actual=o,this.type=8}static create(o){return new r(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new r(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class n{constructor(o){this.expr=o,this.type=6}static create(o){return n._normalizeArr(o)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let k=0,F=this.expr.length;k<F;k++){const $=i(this.expr[k],o.expr[k]);if($!==0)return $}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let k=0,F=this.expr.length;k<F;k++)if(!this.expr[k].equals(o.expr[k]))return!1;return!0}return!1}evaluate(o){for(let k=0,F=this.expr.length;k<F;k++)if(!this.expr[k].evaluate(o))return!1;return!0}static _normalizeArr(o){const k=[];let F=!1;for(const $ of o)if(!!$){if($.type===1){F=!0;continue}if($.type===0)return P.INSTANCE;if($.type===6){k.push(...$.expr);continue}k.push($)}if(k.length===0&&F)return c.INSTANCE;if(k.length!==0){if(k.length===1)return k[0];for(k.sort(i);k.length>1;){const $=k[k.length-1];if($.type!==9)break;k.pop();const Q=k.pop(),oe=l.create($.expr.map(j=>n.create([j,Q])));oe&&(k.push(oe),k.sort(i))}return k.length===1?k[0]:new n(k)}}serialize(){return this.expr.map(o=>o.serialize()).join(" && ")}keys(){const o=[];for(let k of this.expr)o.push(...k.keys());return o}map(o){return new n(this.expr.map(k=>k.map(o)))}negate(){let o=[];for(let k of this.expr)o.push(k.negate());return l.create(o)}}e.ContextKeyAndExpr=n;class l{constructor(o){this.expr=o,this.type=9}static create(o){const k=l._normalizeArr(o);if(k.length!==0)return k.length===1?k[0]:new l(k)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let k=0,F=this.expr.length;k<F;k++){const $=i(this.expr[k],o.expr[k]);if($!==0)return $}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let k=0,F=this.expr.length;k<F;k++)if(!this.expr[k].equals(o.expr[k]))return!1;return!0}return!1}evaluate(o){for(let k=0,F=this.expr.length;k<F;k++)if(this.expr[k].evaluate(o))return!0;return!1}static _normalizeArr(o){let k=[],F=!1;if(o){for(let $=0,Q=o.length;$<Q;$++){const oe=o[$];if(!!oe){if(oe.type===0){F=!0;continue}if(oe.type===1)return[c.INSTANCE];if(oe.type===9){k=k.concat(oe.expr);continue}k.push(oe)}}if(k.length===0&&F)return[P.INSTANCE];k.sort(i)}return k}serialize(){return this.expr.map(o=>o.serialize()).join(" || ")}keys(){const o=[];for(let k of this.expr)o.push(...k.keys());return o}map(o){return new l(this.expr.map(k=>k.map(o)))}negate(){let o=[];for(let F of this.expr)o.push(F.negate());const k=F=>F.type===9?F.expr:[F];for(;o.length>1;){const F=o.shift(),$=o.shift(),Q=[];for(const oe of k(F))for(const j of k($))Q.push(A.and(oe,j));o.unshift(A.or(...Q))}return o[0]}}e.ContextKeyOrExpr=l;class f extends u{constructor(o,k,F){super(o);this._defaultValue=k,typeof F=="object"?f._info.push({...F,key:o}):F!==!0&&f._info.push({key:o,description:F,type:k!=null?typeof k:void 0})}static all(){return f._info.values()}bindTo(o){return o.createKey(this.key,this._defaultValue)}getValue(o){return o.getContextKeyValue(this.key)}toNegated(){return A.not(this.key)}isEqualTo(o){return A.equals(this.key,o)}notEqualsTo(o){return A.notEquals(this.key,o)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(y,o){return y<o?-1:y>o?1:0}function E(y,o,k,F){return y<k?-1:y>k?1:o<F?-1:o>F?1:0}}),define(me[178],ge([0,1,4]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)}),define(me[179],ge([0,1,153,4,10]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function S(P){return P&&typeof P=="object"&&typeof P.id=="string"&&(!P.uuid||typeof P.uuid=="string")}e.isIExtensionIdentifier=S;var T;(function(P){P[P.NoneOrRelevance=0]="NoneOrRelevance",P[P.LastUpdatedDate=1]="LastUpdatedDate",P[P.Title=2]="Title",P[P.PublisherName=3]="PublisherName",P[P.InstallCount=4]="InstallCount",P[P.PublishedDate=5]="PublishedDate",P[P.AverageRating=6]="AverageRating",P[P.WeightedRating=12]="WeightedRating"})(T=e.SortBy||(e.SortBy={}));var I;(function(P){P[P.Default=0]="Default",P[P.Ascending=1]="Ascending",P[P.Descending=2]="Descending"})(I=e.SortOrder||(e.SortOrder={}));var D;(function(P){P.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var A;(function(P){P[P.None=0]="None",P[P.Install=1]="Install",P[P.Update=2]="Update"})(A=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class i extends Error{constructor(c,u){super(c);this.code=u,this.name=u}}e.ExtensionManagementError=i,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=C.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,p.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,p.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,L.createDecorator)("IExtensionManagementCLIService")}),define(me[26],ge([0,1,8,4]),function(J,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function C(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=C;function S(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=S,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class I{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,c){if(typeof P=="undefined"||P===null)return typeof c=="undefined"||c===null;if(typeof c=="undefined"||c===null)return!1;if(typeof P=="string"||typeof c=="string"){let u=typeof P=="string"?P:P.value,a=typeof c=="string"?c:c.value;return p.equalsIgnoreCase(u,a)}return P._lower===c._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}e.ExtensionIdentifier=I;function D(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function A(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=A,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[180],ge([0,1,8,26]),function(J,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function C(a,g){return a.uuid&&g.uuid?a.uuid===g.uuid:a.id===g.id?!0:(0,p.compareIgnoreCase)(a.id,g.id)===0}e.areSameExtensions=C;class S{constructor(g,w){this.version=w,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof S?C(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=S;function T(a,g){return`${a}.${g}`}e.getExtensionId=T;function I(a){return a.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function D(a,g){return I(T(a,g))}e.getGalleryExtensionId=D;function A(a,g){const w=[],_=b=>{for(const d of w)if(d.some(h=>C(g(h),g(b))))return d;return null};for(const b of a){const d=_(b);d?d.push(b):w.push([b])}return w}e.groupByExtension=A;function i(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function P(a){return{id:a.identifier.id,name:a.name,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),...a.telemetryData}}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function c(a){const g=new Set;for(const w of a)w.malicious&&g.add(w.id.id);return g}e.getMaliciousExtensionsSet=c;function u(a,g){const w=[],_=g.manifest.extensionDependencies?.slice(0)??[];for(;_.length;){const b=_.shift();if(b&&w.every(d=>!C(d.identifier,{id:b}))){const d=a.filter(h=>C(h.identifier,{id:b}));d.length===1&&(w.push(d[0]),_.push(...d[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}e.getExtensionDependencies=u}),define(me[181],ge([0,1,4]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,p.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,p.createDecorator)("externalTerminal")}),define(me[182],ge([0,1,38,9,111,155,28,11,181,10,137]),function(J,e,p,L,C,S,T,I,D,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=S.localize(0,null);class c{async getDefaultTerminalForPlatforms(){const h=await g.getDefaultTerminalLinuxReady();return{windows:u.getDefaultTerminalWindows(),linux:h,osx:"xterm"}}}class u extends c{openTerminal(h,v){return this.spawnTerminal(p,h,C.getWindowsShell(),v)}spawnTerminal(h,v,t,s){const r=v.windowsExec||u.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const n=L.basename(r).toLowerCase();if(n==="cmder"||n==="cmder.exe")return h.spawn(r,s?[s]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return r.indexOf(" ")>=0&&l.push('""'),l.push(r),(n==="wt"||n==="wt.exe")&&l.push("-d ."),new Promise((f,m)=>{const E=w(process),y=h.spawn(t,l,{cwd:s,env:E});y.on("error",m),y.on("exit",()=>f())})}runInTerminal(h,v,t,s,r){const n="windowsExec"in r&&r.windowsExec?r.windowsExec:u.getDefaultTerminalWindows();return new Promise((l,f)=>{const m=`"${v} - ${P}"`,E=`""${t.join('" "')}" & pause"`,y=["/c","start",m,"/wait",n,"/c",E],o=Object.assign({},w(process),s);Object.keys(o).filter($=>o[$]===null).forEach($=>delete o[$]);const k={cwd:v,env:o,windowsVerbatimArguments:!0};p.spawn(u.CMD,y,k).on("error",$=>{f(_($))}),l(void 0)})}static getDefaultTerminalWindows(){if(!u._DEFAULT_TERMINAL_WINDOWS){const h=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");u._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${h?"Sysnative":"System32"}\\cmd.exe`}return u._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=u,u.CMD="cmd.exe";class a extends c{openTerminal(h,v){return this.spawnTerminal(p,h,v)}runInTerminal(h,v,t,s,r){const n=r.osxExec||D.DEFAULT_TERMINAL_OSX;return new Promise((l,f)=>{if(n===D.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const m=n===D.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",y=[A.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${m}.scpt`,J).fsPath,"-t",h||P,"-w",v];for(let F of t)y.push("-a"),y.push(F);if(s){const F=Object.assign({},w(process),s);for(let $ in F){const Q=F[$];Q===null?(y.push("-u"),y.push($)):(y.push("-e"),y.push(`${$}=${Q}`))}}let o="";const k=p.spawn(a.OSASCRIPT,y);k.on("error",F=>{f(_(F))}),k.stderr.on("data",F=>{o+=F.toString()}),k.on("exit",F=>{if(F===0)l(void 0);else if(o){const $=o.split(`
`,1);f(new Error($[0]))}else f(new Error(S.localize(1,null,m,F)))})}else f(new Error(S.localize(2,null,n)))})}spawnTerminal(h,v,t){const s=v.osxExec||D.DEFAULT_TERMINAL_OSX;return new Promise((r,n)=>{const l=["-a",s];t&&l.push(t);const f=w(process),m=h.spawn("/usr/bin/open",l,{cwd:t,env:f});m.on("error",n),m.on("exit",()=>r())})}}e.MacExternalTerminalService=a,a.OSASCRIPT="/usr/bin/osascript";class g extends c{openTerminal(h,v){return this.spawnTerminal(p,h,v)}runInTerminal(h,v,t,s,r){const n=r.linuxExec?Promise.resolve(r.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((l,f)=>{let m=[];n.then(E=>{E.indexOf("gnome-terminal")>=0?m.push("-x"):m.push("-e"),m.push("bash"),m.push("-c");const y=`${b(t)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;m.push(`''${y}''`);const o=Object.assign({},w(process),s);Object.keys(o).filter(Q=>o[Q]===null).forEach(Q=>delete o[Q]);const k={cwd:v,env:o};let F="";const $=p.spawn(E,m,k);$.on("error",Q=>{f(_(Q))}),$.stderr.on("data",Q=>{F+=Q.toString()}),$.on("exit",Q=>{if(Q===0)l(void 0);else if(F){const oe=F.split(`
`,1);f(new Error(oe[0]))}else f(new Error(S.localize(4,null,E,Q)))})})})}static async getDefaultTerminalLinuxReady(){return g._DEFAULT_TERMINAL_LINUX_READY||(g._DEFAULT_TERMINAL_LINUX_READY=new Promise(async h=>{I.isLinux?await T.Promises.exists("/etc/debian_version")?h("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?h("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?h("konsole"):process.env.COLORTERM?h(process.env.COLORTERM):process.env.TERM?h(process.env.TERM):h("xterm"):h("xterm")})),g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(h,v,t){const s=v.linuxExec?Promise.resolve(v.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((r,n)=>{s.then(l=>{const f=w(process),m=h.spawn(l,[],{cwd:t,env:f});m.on("error",n),m.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=S.localize(3,null);function w(d){const h=d.env;return(0,i.sanitizeProcessEnvironment)(h),h}function _(d){return"errno"in d&&d.errno==="ENOENT"&&"path"in d&&typeof d.path=="string"?new Error(S.localize(5,null,d.path)):d}function b(d){let h="";for(let v of d)v.indexOf(" ")>=0?h+='"'+v+'"':h+=v,h+=" ";return h}}),define(me[41],ge([0,1,156,9,2,4,8,14,23]),function(J,e,p,L,C,S,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function A(O){return O.create===!0}e.isFileOpenForWriteOptions=A;var i;(function(O){O[O.Unknown=0]="Unknown",O[O.File=1]="File",O[O.Directory=2]="Directory",O[O.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var P;(function(O){O[O.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var c;(function(O){O[O.FileReadWrite=2]="FileReadWrite",O[O.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",O[O.FileReadStream=16]="FileReadStream",O[O.FileFolderCopy=8]="FileFolderCopy",O[O.PathCaseSensitive=1024]="PathCaseSensitive",O[O.Readonly=2048]="Readonly",O[O.Trash=4096]="Trash",O[O.FileWriteUnlock=8192]="FileWriteUnlock"})(c=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function u(O){return!!(O.capabilities&2)}e.hasReadWriteCapability=u;function a(O){return!!(O.capabilities&8)}e.hasFileFolderCopyCapability=a;function g(O){return!!(O.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function w(O){return!!(O.capabilities&16)}e.hasFileReadStreamCapability=w;var _;(function(O){O.FileExists="EntryExists",O.FileNotFound="EntryNotFound",O.FileNotADirectory="EntryNotADirectory",O.FileIsADirectory="EntryIsADirectory",O.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",O.FileTooLarge="EntryTooLarge",O.FileWriteLocked="EntryWriteLocked",O.NoPermissions="NoPermissions",O.Unavailable="Unavailable",O.Unknown="Unknown"})(_=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(B,R){super(B);this.code=R}}e.FileSystemProviderError=b;function d(O,B){const R=new b(O.toString(),B);return v(R,B),R}e.createFileSystemProviderError=d;function h(O){return O||d((0,p.localize)(0,null),_.Unknown)}e.ensureFileSystemProviderError=h;function v(O,B){return O.name=B?`${B} (FileSystemError)`:"FileSystemError",O}e.markAsFileSystemProviderError=v;function t(O){if(!O)return _.Unknown;if(O instanceof b)return O.code;const B=/^(.+) \(FileSystemError\)$/.exec(O.name);if(!B)return _.Unknown;switch(B[1]){case _.FileExists:return _.FileExists;case _.FileIsADirectory:return _.FileIsADirectory;case _.FileNotADirectory:return _.FileNotADirectory;case _.FileNotFound:return _.FileNotFound;case _.FileExceedsMemoryLimit:return _.FileExceedsMemoryLimit;case _.FileTooLarge:return _.FileTooLarge;case _.FileWriteLocked:return _.FileWriteLocked;case _.NoPermissions:return _.NoPermissions;case _.Unavailable:return _.Unavailable}return _.Unknown}e.toFileSystemProviderErrorCode=t;function s(O){if(O instanceof E)return O.fileOperationResult;switch(t(O)){case _.FileNotFound:return 1;case _.FileIsADirectory:return 0;case _.FileNotADirectory:return 10;case _.FileWriteLocked:return 5;case _.NoPermissions:return 6;case _.FileExists:return 4;case _.FileExceedsMemoryLimit:return 9;case _.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var r;(function(O){O[O.CREATE=0]="CREATE",O[O.DELETE=1]="DELETE",O[O.MOVE=2]="MOVE",O[O.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class n{constructor(B,R,z){this.resource=B,this.operation=R,this.target=z}isOperation(B){return this.operation===B}}e.FileOperationEvent=n;var l;(function(O){O[O.UPDATED=0]="UPDATED",O[O.ADDED=1]="ADDED",O[O.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class f{constructor(B,R){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const z of B)switch(z.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>R)),this.added.set(z.resource,z);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>R)),this.updated.set(z.resource,z);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>R)),this.deleted.set(z.resource,z);break}}contains(B,...R){return this.doContains(B,{includeChildren:!1},...R)}affects(B,...R){return this.doContains(B,{includeChildren:!0},...R)}doContains(B,R,...z){if(!B)return!1;const N=z.length>0;return!!((!N||z.includes(1))&&(this.added?.get(B)||R.includeChildren&&this.added?.findSuperstr(B))||(!N||z.includes(0))&&(this.updated?.get(B)||R.includeChildren&&this.updated?.findSuperstr(B))||(!N||z.includes(2))&&(this.deleted?.findSubstr(B)||R.includeChildren&&this.deleted?.findSuperstr(B)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=f;function m(O,B,R){return!O||!B||O===B||B.length>O.length?!1:(B.charAt(B.length-1)!==L.sep&&(B+=L.sep),R?(0,T.startsWithIgnoreCase)(O,B):O.indexOf(B)===0)}e.isParent=m;class E extends Error{constructor(B,R,z){super(B);this.fileOperationResult=R,this.options=z}}e.FileOperationError=E;class y extends E{constructor(B,R,z){super(B,2,z);this.stat=R}}e.NotModifiedSinceFileOperationError=y;var o;(function(O){O[O.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",O[O.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",O[O.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",O[O.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",O[O.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",O[O.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",O[O.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",O[O.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",O[O.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",O[O.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",O[O.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",O[O.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(o=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var k;(function(O){O[O.FILE=0]="FILE",O[O.FOLDER=1]="FOLDER",O[O.ROOT_FOLDER=2]="ROOT_FOLDER"})(k=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(O){if(!(typeof O.size!="number"||typeof O.mtime!="number"))return O.mtime.toString(29)+O.size.toString(31)}e.etag=F;async function $(O,B){if(!B.canHandleResource(C.URI.from({scheme:O.scheme})))return new Promise(R=>{const z=B.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===O.scheme&&N.added&&(z.dispose(),R())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class Q{static formatSize(B){return(0,I.isNumber)(B)||(B=0),B<Q.KB?(0,p.localize)(1,null,B.toFixed(0)):B<Q.MB?(0,p.localize)(2,null,(B/Q.KB).toFixed(2)):B<Q.GB?(0,p.localize)(3,null,(B/Q.MB).toFixed(2)):B<Q.TB?(0,p.localize)(4,null,(B/Q.GB).toFixed(2)):(0,p.localize)(5,null,(B/Q.TB).toFixed(2))}}e.ByteSize=Q,Q.KB=1024,Q.MB=Q.KB*Q.KB,Q.GB=Q.MB*Q.KB,Q.TB=Q.GB*Q.KB;var oe;(function(O){O[O.IA32=0]="IA32",O[O.OTHER=1]="OTHER"})(oe=e.Arch||(e.Arch={}));function j(O){return{maxFileSize:O===0?300*Q.MB:16*Q.GB,maxHeapSize:O===0?700*Q.MB:2*700*Q.MB}}e.getPlatformLimits=j}),define(me[81],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...C){this._entries=new Map;for(let[S,T]of C)this.set(S,T)}set(C,S){const T=this._entries.get(C);return this._entries.set(C,S),T}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=p}),define(me[183],ge([0,1,15,175,113,4,81,17]),function(J,e,p,L,C,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class A extends Error{constructor(a){super("cyclic dependency between services");this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class i{constructor(a=new T.ServiceCollection,g=!1,w){this._activeInstantiations=new Set,this._services=a,this._strict=g,this._parent=w,this._services.set(S.IInstantiationService,this)}createChild(a){return new i(a,this._strict,this)}invokeFunction(a,...g){let w=c.traceInvocation(a),_=!1;try{return a({get:(d,h)=>{if(_)throw(0,p.illegalState)("service accessor is only valid during the invocation of its target method");const v=this._getOrCreateServiceInstance(d,w);if(!v&&h!==S.optional)throw new Error(`[invokeFunction] unknown service '${d}'`);return v}},...g)}finally{_=!0,w.stop()}}createInstance(a,...g){let w,_;return a instanceof C.SyncDescriptor?(w=c.traceCreation(a.ctor),_=this._createInstance(a.ctor,a.staticArguments.concat(g),w)):(w=c.traceCreation(a),_=this._createInstance(a,g,w)),w.stop(),_}_createInstance(a,g=[],w){let _=S._util.getServiceDependencies(a).sort((h,v)=>h.index-v.index),b=[];for(const h of _){let v=this._getOrCreateServiceInstance(h.id,w);if(!v&&this._strict&&!h.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${h.id}.`);b.push(v)}let d=_.length>0?_[0].index:g.length;if(g.length!==d){console.warn(`[createInstance] First service dependency of ${a.name} at position ${d+1} conflicts with ${g.length} static arguments`);let h=d-g.length;h>0?g=g.concat(new Array(h)):g=g.slice(0,d)}return new a(...[...g,...b])}_setServiceInstance(a,g){if(this._services.get(a)instanceof C.SyncDescriptor)this._services.set(a,g);else if(this._parent)this._parent._setServiceInstance(a,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let g=this._services.get(a);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):g}_getOrCreateServiceInstance(a,g){let w=this._getServiceInstanceOrDescriptor(a);return w instanceof C.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,w,g.branch(a,!0)):(g.branch(a,!1),w)}_safeCreateAndCacheServiceInstance(a,g,w){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,g,w)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,g,w){const _=new L.Graph(h=>h.id.toString());let b=0;const d=[{id:a,desc:g,_trace:w}];for(;d.length;){const h=d.pop();if(_.lookupOrInsertNode(h),b++>1e3)throw new A(_);for(let v of S._util.getServiceDependencies(h.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(v.id);if(!t&&!v.optional&&console.warn(`[createInstance] ${a} depends on ${v.id} which is NOT registered.`),t instanceof C.SyncDescriptor){const s={id:v.id,desc:t,_trace:h._trace.branch(v.id,!0)};_.insertEdge(h,s),d.push(s)}}}for(;;){const h=_.roots();if(h.length===0){if(!_.isEmpty())throw new A(_);break}for(const{data:v}of h){if(this._getServiceInstanceOrDescriptor(v.id)instanceof C.SyncDescriptor){const s=this._createServiceInstanceWithOwner(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this._setServiceInstance(v.id,s)}_.removeNode(v)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,g,w=[],_,b){if(this._services.get(a)instanceof C.SyncDescriptor)return this._createServiceInstance(g,w,_,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,g,w,_,b);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(a,g=[],w,_){if(w){const b=new I.IdleValue(()=>this._createInstance(a,g,_));return new Proxy(Object.create(null),{get(d,h){if(h in d)return d[h];let v=b.value,t=v[h];return typeof t!="function"||(t=t.bind(v),d[h]=t),t},set(d,h,v){return b.value[h]=v,!0}})}else return this._createInstance(a,g,_)}}e.InstantiationService=i;var P;(function(u){u[u.Creation=0]="Creation",u[u.Invocation=1]="Invocation",u[u.Branch=2]="Branch"})(P||(P={}));class c{constructor(a,g){this.type=a,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return D?new c(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(a){return D?new c(0,a.name):c._None}branch(a,g){let w=new c(2,a.toString());return this._dep.push([a,g,w]),w}stop(){let a=Date.now()-this._start;c._totals+=a;let g=!1;function w(b,d){let h=[],v=new Array(b+1).join("	");for(const[t,s,r]of d._dep)if(s&&r){g=!0,h.push(`${v}CREATES -> ${t}`);let n=w(b+1,r);n&&h.push(n)}else h.push(`${v}uses -> ${t}`);return h.join(`
`)}let _=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(a>2||g)&&console.log(_.join(`
`))}}c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(me[12],ge([0,1,4,6,11,3,58]),function(J,e,p,L,C,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,p.createDecorator)("logService"),e.ILoggerService=(0,p.createDecorator)("loggerService");function I(){return new Date().toISOString()}var D;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class A extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new S.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=A;class i extends A{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...s){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([t,...s]))}debug(t,...s){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([t,...s]))}info(t,...s){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([t,...s]))}warn(t,...s){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([t,...s]))}error(t,...s){if(this.checkLogLevel(D.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(D.Error,this.format(r))}else this.log(D.Error,this.format([t,...s]))}critical(t,...s){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([t,...s]))}flush(){}format(t){let s="";for(let r=0;r<t.length;r++){let n=t[r];if(typeof n=="object")try{n=JSON.stringify(n)}catch(l){}s+=(r>0?" ":"")+n}return s}}e.AbstractMessageLogger=i;class P extends A{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!C.isWindows}trace(t,...s){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,t,...s):console.log(`[main ${I()}]`,t,...s))}debug(t,...s){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,t,...s):console.log(`[main ${I()}]`,t,...s))}info(t,...s){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,t,...s):console.log(`[main ${I()}]`,t,...s))}warn(t,...s){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,t,...s):console.warn(`[main ${I()}]`,t,...s))}error(t,...s){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,t,...s):console.error(`[main ${I()}]`,t,...s))}critical(t,...s){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,t,...s):console.error(`[main ${I()}]`,t,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class c extends A{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...s){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",t,...s)}debug(t,...s){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...s)}info(t,...s){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",t,...s)}warn(t,...s){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",t,...s)}error(t,...s){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",t,...s)}critical(t,...s){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...s)}dispose(){}flush(){}}e.ConsoleLogger=c;class u extends A{constructor(t,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(s)}trace(t,...s){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(t),...s])}debug(t,...s){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(t),...s])}info(t,...s){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(t),...s])}warn(t,...s){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(t),...s])}error(t,...s){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(t),...s])}critical(t,...s){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(t),...s])}extractMessage(t){return typeof t=="string"?t:(0,T.toErrorMessage)(t,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=u;class a extends A{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const s of this.logServices)s.setLevel(t);super.setLevel(t)}trace(t,...s){for(const r of this.logServices)r.trace(t,...s)}debug(t,...s){for(const r of this.logServices)r.debug(t,...s)}info(t,...s){for(const r of this.logServices)r.info(t,...s)}warn(t,...s){for(const r of this.logServices)r.warn(t,...s)}error(t,...s){for(const r of this.logServices)r.error(t,...s)}critical(t,...s){for(const r of this.logServices)r.critical(t,...s)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=a;class g extends L.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...s){this.logger.trace(t,...s)}debug(t,...s){this.logger.debug(t,...s)}info(t,...s){this.logger.info(t,...s)}warn(t,...s){this.logger.warn(t,...s)}error(t,...s){this.logger.error(t,...s)}critical(t,...s){this.logger.critical(t,...s)}flush(){this.logger.flush()}}e.LogService=g;class w extends L.Disposable{constructor(t,s){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(r))}))}createLogger(t,s){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,s?.always?D.Trace:this.logLevel,s),this.loggers.set(t.toString(),r),s?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class _{constructor(){this.onDidChangeLogLevel=new S.Emitter().event}setLevel(t){}getLevel(){return D.Info}trace(t,...s){}debug(t,...s){}info(t,...s){}warn(t,...s){}error(t,...s){}critical(t,...s){}dispose(){}flush(){}}e.NullLogService=_;function b(v){if(v.verbose)return D.Trace;if(typeof v.logLevel=="string"){const t=d(v.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function d(v){switch(v){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=d;function h(v){switch(v){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=h}),define(me[114],ge([0,1,12,41]),function(J,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function C(D,A,i,P){try{const c=await new Promise((u,a)=>{J(["spdlog"],u,a)});return c.setFlushOn(p.LogLevel.Trace),c.createAsyncRotatingLogger(D,A,i,P)}catch(c){console.error(c)}return null}function S(D,A,i,P){const c=J.__$__nodeRequire("spdlog");return c.setFlushOn(p.LogLevel.Trace),c.createRotatingLogger(D,A,i,P)}e.createRotatingLogger=S;function T(D,A,i){switch(A){case p.LogLevel.Trace:D.trace(i);break;case p.LogLevel.Debug:D.debug(i);break;case p.LogLevel.Info:D.info(i);break;case p.LogLevel.Warning:D.warn(i);break;case p.LogLevel.Error:D.error(i);break;case p.LogLevel.Critical:D.critical(i);break;default:throw new Error("Invalid log level")}}class I extends p.AbstractMessageLogger{constructor(A,i,P,c){super();this.name=A,this.filepath=i,this.rotating=P,this.buffer=[],this.setLevel(c),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(u=>{this._logger&&this._logger.setLevel(u)}))}_createSpdLogLogger(){const A=this.rotating?6:1,i=30/A*L.ByteSize.MB;return C(this.name,this.filepath,i,A).then(P=>{if(P){this._logger=P,this._logger.setLevel(this.getLevel());for(const{level:c,message:u}of this.buffer)T(this._logger,c,u);this.buffer=[]}})}log(A,i){this._logger?T(this._logger,A,i):this.getLevel()<=A&&this.buffer.push({level:A,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=I}),define(me[115],ge([0,1,4,157,56]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var S;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(S=e.MarkerTag||(e.MarkerTag={}));var T;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(T=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function A(a,g){return g-a}D.compare=A;const i=Object.create(null);i[D.Error]=(0,L.localize)(0,null),i[D.Warning]=(0,L.localize)(1,null),i[D.Info]=(0,L.localize)(2,null);function P(a){return i[a]||""}D.toString=P;function c(a){switch(a){case C.default.Error:return D.Error;case C.default.Warning:return D.Warning;case C.default.Info:return D.Info;case C.default.Ignore:return D.Hint}}D.fromSeverity=c;function u(a){switch(a){case D.Error:return C.default.Error;case D.Warning:return C.default.Warning;case D.Info:return C.default.Info;case D.Hint:return C.default.Ignore}}D.toSeverity=u}(T=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(D){const A="";function i(c){return P(c,!0)}D.makeKey=i;function P(c,u){let a=[A];return c.source?a.push(c.source.replace("\xA6","\\\xA6")):a.push(A),c.code?typeof c.code=="string"?a.push(c.code.replace("\xA6","\\\xA6")):a.push(c.code.value.replace("\xA6","\\\xA6")):a.push(A),c.severity!==void 0&&c.severity!==null?a.push(T.toString(c.severity)):a.push(A),c.message&&u?a.push(c.message.replace("\xA6","\\\xA6")):a.push(A),c.startLineNumber!==void 0&&c.startLineNumber!==null?a.push(c.startLineNumber.toString()):a.push(A),c.startColumn!==void 0&&c.startColumn!==null?a.push(c.startColumn.toString()):a.push(A),c.endLineNumber!==void 0&&c.endLineNumber!==null?a.push(c.endLineNumber.toString()):a.push(A),c.endColumn!==void 0&&c.endColumn!==null?a.push(c.endColumn.toString()):a.push(A),a.push(A),a.join("\xA6")}D.makeKeyOptionalMessage=P})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,p.createDecorator)("markerService")}),define(me[184],ge([0,1,56,4,3]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=p.default,e.INotificationService=(0,L.createDecorator)("notificationService");var S;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.GLOBAL=1]="GLOBAL"})(S=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var T;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(T=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new D,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=I;class D{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=D}),define(me[185],ge([0,1,6,8,2,4]),function(J,e,p,L,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,S.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return p.Disposable.None},registerValidator(){return p.Disposable.None},registerExternalUriResolver(){return p.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return p.Disposable.None},async open(){return!1},async resolveExternalUri(I){return{resolved:I,dispose(){}}}});function T(I,D){return C.URI.isUri(I)?(0,L.equalsIgnoreCase)(I.scheme,D):(0,L.startsWithIgnoreCase)(I,D+":")}e.matchesScheme=T}),define(me[186],ge([0,1,10,11,37,24]),function(J,e,p,L,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const I=L.globals.vscode.context.configuration();if(I)T=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const I=(0,S.dirname)(p.FileAccess.asFileUri("",J));T=J.__$__nodeRequire((0,S.joinPath)(I,"product.json").fsPath);const D=J.__$__nodeRequire((0,S.joinPath)(I,"package.json").fsPath);C.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`}),Object.assign(T,{version:D.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.59.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=T});var He=this&&this.__param||function(J,e){return function(p,L){e(p,L,J)}};define(me[116],ge([0,1,4,21,6,17]),function(J,e,p,L,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,p.createDecorator)("progressService");var T;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(T=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class I{constructor(P){this.callback=P}get value(){return this._value}report(P){this._value=P,this.callback(this._value)}}e.Progress=I,I.None=Object.freeze({report(){}});let D=class extends C.Disposable{constructor(P,c){super();this.deferred=new S.DeferredPromise,c.withProgress(P,u=>(this.reporter=u,this.lastStep&&u.report(this.lastStep),this.deferred.p)),this._register((0,C.toDisposable)(()=>this.deferred.complete()))}report(P){this.reporter?this.reporter.report(P):this.lastStep=P}};D=Ve([He(1,e.IProgressService)],D),e.UnmanagedProgress=D;class A extends C.Disposable{constructor(P){super();this.progressIndicator=P,this.currentOperationId=0,this.currentOperationDisposables=this._register(new C.DisposableStore)}start(P){this.stop();const c=++this.currentOperationId,u=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{c===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},P),this.currentOperationDisposables.add((0,C.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,C.toDisposable)(()=>u.cancel())),this.currentOperationDisposables.add((0,C.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:c,token:u.token,stop:()=>this.doStop(c),isCurrent:()=>this.currentOperationId===c}}stop(){this.doStop(this.currentOperationId)}doStop(P){this.currentOperationId===P&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=A,e.IEditorProgressService=(0,p.createDecorator)("editorProgressService")}),define(me[42],ge([0,1,14,52]),function(J,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(T,I){L.ok(p.isString(T)),L.ok(p.isObject(I)),L.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,I)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new C}),define(me[187],ge([0,1,42,3]),function(J,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class S{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,A){this.schemasById[C(D)]=A,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new S;p.Registry.add(e.Extensions.JSONContribution,T)}),define(me[82],ge([0,1,152,3,42,14,187]),function(J,e,p,L,C,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var I;(function(_){_.Multiline="multilineText",_.Singleline="singlelineText"})(I=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(_){_[_.APPLICATION=1]="APPLICATION",_[_.MACHINE=2]="MACHINE",_[_.WINDOW=3]="WINDOW",_[_.RESOURCE=4]="RESOURCE",_[_.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",_[_.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const A=C.Registry.as(T.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:p.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(b,d=!0){this.registerConfigurations([b],d)}registerConfigurations(b,d=!0){const h=[];b.forEach(v=>{h.push(...this.validateAndRegisterProperties(v,d,v.extensionInfo)),this.configurationContributors.push(v),this.registerJSONConfiguration(v)}),A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterConfigurations(b){const d=[],h=v=>{if(v.properties)for(const t in v.properties)d.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,v.properties[t]);v.allOf&&v.allOf.forEach(t=>h(t))};for(const v of b){h(v);const t=this.configurationContributors.indexOf(v);t!==-1&&this.configurationContributors.splice(t,1)}A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}registerDefaultConfigurations(b){const d=[],h=[];for(const v of b)for(const t in v)if(d.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...v[t]};const s={type:"object",default:this.defaultValues[t],description:p.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};h.push(c(t)),this.configurationProperties[t]=s,this.defaultLanguageConfigurationOverridesNode.properties[t]=s}else{this.defaultValues[t]=v[t];const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.registerOverrideIdentifiers(h),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterDefaultConfigurations(b){const d=[];for(const h of b)for(const v in h)if(d.push(v),delete this.defaultValues[v],e.OVERRIDE_PROPERTY_PATTERN.test(v))delete this.configurationProperties[v],delete this.defaultLanguageConfigurationOverridesNode.properties[v];else{const t=this.configurationProperties[v];t&&(this.updatePropertyDefaultValue(v,t),this.updateSchema(v,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}notifyConfigurationSchemaUpdated(...b){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(b){for(const d of b)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(b,d=!0,h,v=3){v=S.isUndefinedOrNull(b.scope)?v:b.scope;let t=[],s=b.properties;if(s)for(let n in s){if(d&&g(n)){delete s[n];continue}const l=s[n];if(this.updatePropertyDefaultValue(n,l),e.OVERRIDE_PROPERTY_PATTERN.test(n)?l.scope=void 0:(l.scope=S.isUndefinedOrNull(l.scope)?v:l.scope,l.restricted=S.isUndefinedOrNull(l.restricted)?!!h?.restrictedConfigurations?.includes(n):l.restricted),s[n].hasOwnProperty("included")&&!s[n].included){this.excludedConfigurationProperties[n]=s[n],delete s[n];continue}else this.configurationProperties[n]=s[n];!s[n].deprecationMessage&&s[n].markdownDeprecationMessage&&(s[n].deprecationMessage=s[n].markdownDeprecationMessage),t.push(n)}let r=b.allOf;if(r)for(let n of r)t.push(...this.validateAndRegisterProperties(n,d,h,v));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(b){const d=h=>{let v=h.properties;if(v)for(const s in v)this.updateSchema(s,v[s]);let t=h.allOf;t&&t.forEach(d)};d(b)}updateSchema(b,d){switch(e.allSettings.properties[b]=d,d.scope){case 1:e.applicationSettings.properties[b]=d;break;case 2:e.machineSettings.properties[b]=d;break;case 6:e.machineOverridableSettings.properties[b]=d;break;case 3:e.windowSettings.properties[b]=d;break;case 4:e.resourceSettings.properties[b]=d;break;case 5:e.resourceSettings.properties[b]=d,this.resourceLanguageSettingsSchema.properties[b]=d;break}}removeFromSchema(b,d){switch(delete e.allSettings.properties[b],d.scope){case 1:delete e.applicationSettings.properties[b];break;case 2:delete e.machineSettings.properties[b];break;case 6:delete e.machineOverridableSettings.properties[b];break;case 3:delete e.windowSettings.properties[b];break;case 4:case 5:delete e.resourceSettings.properties[b];break}}updateOverridePropertyPatternKey(){for(const b of this.overrideIdentifiers.values()){const d=`[${b}]`,h={type:"object",description:p.localize(2,null),errorMessage:p.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,h),e.allSettings.properties[d]=h,e.applicationSettings.properties[d]=h,e.machineSettings.properties[d]=h,e.machineOverridableSettings.properties[d]=h,e.windowSettings.properties[d]=h,e.resourceSettings.properties[d]=h}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(b,d){let h=this.defaultValues[b];S.isUndefined(h)&&(h=d.default),S.isUndefined(h)&&(h=u(d.type)),d.default=h}}const P="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(P);function c(_){return _.substring(1,_.length-1)}e.overrideIdentifierFromKey=c;function u(_){switch(Array.isArray(_)?_[0]:_){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const a=new i;C.Registry.add(e.Extensions.Configuration,a);function g(_){return _.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(_)?p.localize(5,null,_):a.getConfigurationProperties()[_]!==void 0?p.localize(6,null,_):null:p.localize(4,null)}e.validateProperty=g;function w(){const _=[],b=a.getConfigurationProperties();for(const d of Object.keys(b))_.push([d,b[d].scope]);return _.push(["launch",4]),_.push(["task",4]),_}e.getScopes=w}),define(me[117],ge([0,1,25,14,2,42,4,82]),function(J,e,p,L,C,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function D(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof C.URI)}e.isConfigurationOverrides=D;var A;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function P(s,r){const n=r?s?r.keys.filter(k=>s.keys.indexOf(k)===-1):[...r.keys]:[],l=s?r?s.keys.filter(k=>r.keys.indexOf(k)===-1):[...s.keys]:[],f=[];if(r&&s){for(const k of s.keys)if(r.keys.indexOf(k)!==-1){const F=_(s.contents,k),$=_(r.contents,k);p.equals(F,$)||f.push(k)}}const m=[],E=k=>{const F={};for(const $ of k)for(const Q of $.identifiers)F[v(Q)]=$;return F},y=r?E(r.overrides):{},o=s?E(s.overrides):{};if(Object.keys(y).length)for(const k of n){const F=y[k];F&&m.push([(0,I.overrideIdentifierFromKey)(k),F.keys])}if(Object.keys(o).length)for(const k of l){const F=o[k];F&&m.push([(0,I.overrideIdentifierFromKey)(k),F.keys])}if(Object.keys(y).length&&Object.keys(o).length)for(const k of f){const F=o[k],$=y[k];if(F&&$){const Q=P({contents:F.contents,keys:F.keys,overrides:[]},{contents:$.contents,keys:$.keys,overrides:[]});m.push([(0,I.overrideIdentifierFromKey)(k),[...Q.added,...Q.removed,...Q.updated]])}}return{added:n,removed:l,updated:f,overrides:m}}e.compare=P;function c(s,r){const n=[];for(const l of Object.keys(s))if(I.OVERRIDE_PROPERTY_PATTERN.test(l)){const f={};for(const m in s[l])f[m]=s[l][m];n.push({identifiers:[(0,I.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(f),contents:u(f,r)})}return n}e.toOverrides=c;function u(s,r){const n=Object.create(null);for(let l in s)a(n,l,s[l],r);return n}e.toValuesTree=u;function a(s,r,n,l){const f=r.split("."),m=f.pop();let E=s;for(let y=0;y<f.length;y++){let o=f[y],k=E[o];switch(typeof k){case"undefined":k=E[o]=Object.create(null);break;case"object":break;default:l(`Ignoring ${r} as ${f.slice(0,y+1).join(".")} is ${JSON.stringify(k)}`);return}E=k}if(typeof E=="object"&&E!==null)try{E[m]=n}catch(y){l(`Ignoring ${r} as ${f.join(".")} is ${JSON.stringify(E)}`)}else l(`Ignoring ${r} as ${f.join(".")} is ${JSON.stringify(E)}`)}e.addToValueTree=a;function g(s,r){const n=r.split(".");w(s,n)}e.removeFromValueTree=g;function w(s,r){const n=r.shift();if(r.length===0){delete s[n];return}if(Object.keys(s).indexOf(n)!==-1){const l=s[n];typeof l=="object"&&!Array.isArray(l)&&(w(l,r),Object.keys(l).length===0&&delete s[n])}}function _(s,r,n){function l(E,y){let o=E;for(const k of y){if(typeof o!="object"||o===null)return;o=o[k]}return o}const f=r.split("."),m=l(s,f);return typeof m=="undefined"?n:m}e.getConfigurationValue=_;function b(s,r,n){Object.keys(r).forEach(l=>{l!=="__proto__"&&(l in s?L.isObject(s[l])&&L.isObject(r[l])?b(s[l],r[l],n):n&&(s[l]=r[l]):s[l]=r[l])})}e.merge=b;function d(){const s=S.Registry.as(I.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=d;function h(){const s=Object.create(null),r=S.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(let n in r){let l=r[n].default;a(s,n,l,f=>console.error(`Conflict in default settings: ${f}`))}return s}e.getDefaultValues=h;function v(s){return`[${s}]`}e.keyFromOverrideIdentifier=v;function t(s,r,n){const l=s.inspect(r),f=s.inspect(n);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:l.defaultValue}e.getMigratedSettingValue=t}),define(me[188],ge([0,1,54,23,18,14,25,2,82,117,42,6,3]),function(J,e,p,L,C,S,T,I,D,A,i,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class u{constructor(t={},s=[],r=[]){this._contents=t,this._keys=s,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,A.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,s){const r=this.getContentsForOverrideIdentifer(s);return r?t?(0,A.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.keys;return[]}override(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let r={};for(const n of C.distinct([...Object.keys(this.contents),...Object.keys(s)])){let l=this.contents[n],f=s[n];f&&(typeof l=="object"&&typeof f=="object"?(l=T.deepClone(l),this.mergeContents(l,f)):l=f),r[n]=l}return new u(r,this.keys,this.overrides)}merge(...t){const s=T.deepClone(this.contents),r=T.deepClone(this.overrides),n=[...this.keys];for(const l of t){this.mergeContents(s,l.contents);for(const f of l.overrides){const[m]=r.filter(E=>C.equals(E.identifiers,f.identifiers));m?this.mergeContents(m.contents,f.contents):r.push(T.deepClone(f))}for(const f of l.keys)n.indexOf(f)===-1&&n.push(f)}return new u(s,n,r)}freeze(){return this.isFrozen=!0,this}mergeContents(t,s){for(const r of Object.keys(s)){if(r in t&&S.isObject(t[r])&&S.isObject(s[r])){this.mergeContents(t[r],s[r]);continue}t[r]=T.deepClone(s[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?T.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,s){this.addKey(t),(0,A.addToValueTree)(this.contents,t,s,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,A.removeFromValueTree)(this.contents,t)}addKey(t){let s=this.keys.length;for(let r=0;r<s;r++)t.indexOf(this.keys[r])===0&&(s=r);this.keys.splice(s,1,t)}removeKey(t){let s=this.keys.indexOf(t);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=u;class a extends u{constructor(){const t=(0,A.getDefaultValues)(),s=(0,A.getConfigurationKeys)(),r=[];for(const n of Object.keys(t))D.OVERRIDE_PROPERTY_PATTERN.test(n)&&r.push({identifiers:[(0,D.overrideIdentifierFromKey)(n).trim()],keys:Object.keys(t[n]),contents:(0,A.toValuesTree)(t[n],l=>console.error(`Conflict in default settings file: ${l}`))});super(t,s,r)}}e.DefaultConfigurationModel=a;class g{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new u}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!S.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:r,keys:n,overrides:l,restricted:f}=this.doParseRaw(t,s);this._configurationModel=new u(r,n,l),this._restrictedConfigurations=f||[]}doParseContent(t){let s={},r=null,n=[],l=[],f=[];function m(y){Array.isArray(n)?n.push(y):r&&(n[r]=y)}let E={onObjectBegin:()=>{let y={};m(y),l.push(n),n=y,r=null},onObjectProperty:y=>{r=y},onObjectEnd:()=>{n=l.pop()},onArrayBegin:()=>{let y=[];m(y),l.push(n),n=y,r=null},onArrayEnd:()=>{n=l.pop()},onLiteralValue:m,onError:(y,o,k)=>{f.push({error:y,offset:o,length:k})}};if(t)try{p.visit(t,E),s=n[0]||{}}catch(y){console.error(`Error while parsing settings file ${this._name}: ${y}`),this._parseErrors=[y]}return s}doParseRaw(t,s){const r=i.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),n=this.filter(t,r,!0,s);t=n.raw;const l=(0,A.toValuesTree)(t,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),f=Object.keys(t),m=(0,A.toOverrides)(t,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:l,keys:f,overrides:m,restricted:n.restricted}}filter(t,s,r,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:t,restricted:[]};const l={},f=[];for(let m in t)if(D.OVERRIDE_PROPERTY_PATTERN.test(m)&&r){const E=this.filter(t[m],s,!1,n);l[m]=E.raw,f.push(...E.restricted)}else{const E=s[m],y=E?typeof E.scope!="undefined"?E.scope:3:void 0;E?.restricted&&f.push(m),(y===void 0||n.scopes===void 0||n.scopes.includes(y))&&(n.skipRestricted&&E?.restricted||(l[m]=t[m]))}return{raw:l,restricted:f}}}e.ConfigurationModelParser=g;class w extends P.Disposable{constructor(t,s,r,n){super();this.userSettingsResource=t,this.scopes=s,this.fileService=n,this._onDidChange=this._register(new c.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(c.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new u}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=w;class _{constructor(t,s,r=new u,n=new u,l=new L.ResourceMap,f=new u,m=new L.ResourceMap,E=!0){this._defaultConfiguration=t,this._localUserConfiguration=s,this._remoteUserConfiguration=r,this._workspaceConfiguration=n,this._folderConfigurations=l,this._memoryConfiguration=f,this._memoryConfigurationByResource=m,this._freeze=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(t,s,r){return this.getConsolidateConfigurationModel(s,r).getValue(t)}updateValue(t,s,r={}){let n;r.resource?(n=this._memoryConfigurationByResource.get(r.resource),n||(n=new u,this._memoryConfigurationByResource.set(r.resource,n))):n=this._memoryConfiguration,s===void 0?n.removeValue(t):n.setValue(t,s),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,r){const n=this.getConsolidateConfigurationModel(s,r),l=this.getFolderConfigurationModelForResource(s.resource,r),f=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,m=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),E=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),y=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),o=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),k=r?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,F=l?s.overrideIdentifier?l.freeze().override(s.overrideIdentifier).getValue(t):l.freeze().getValue(t):void 0,$=s.overrideIdentifier?f.override(s.overrideIdentifier).getValue(t):f.getValue(t),Q=n.getValue(t),oe=C.distinct(C.flatten(n.overrides.map(j=>j.identifiers))).filter(j=>n.getOverrideValue(t,j)!==void 0);return{defaultValue:m,userValue:E,userLocalValue:y,userRemoteValue:o,workspaceValue:k,workspaceFolderValue:F,memoryValue:$,value:Q,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,user:E!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userLocal:y!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userRemote:o!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspace:k!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:l?.freeze().getValue(t),override:s.overrideIdentifier?l?.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:f.getValue(t),override:s.overrideIdentifier?f.getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:oe.length?oe:void 0}}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const r=s.filter(n=>D.OVERRIDE_PROPERTY_PATTERN.test(n)).map(n=>{const l=(0,D.overrideIdentifierFromKey)(n),f=this._defaultConfiguration.getKeysForOverrideIdentifier(l),m=t.getKeysForOverrideIdentifier(l),E=[...m.filter(y=>f.indexOf(y)===-1),...f.filter(y=>m.indexOf(y)===-1),...f.filter(y=>!T.equals(this._defaultConfiguration.override(l).getValue(y),t.override(l).getValue(y)))];return[l,E]});return this.updateDefaultConfiguration(t),{keys:s,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:r,removed:n,overrides:l}=(0,A.compare)(this.localUserConfiguration,t),f=[...s,...r,...n];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:r,removed:n,overrides:l}=(0,A.compare)(this.remoteUserConfiguration,t);let f=[...s,...r,...n];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:r,removed:n,overrides:l}=(0,A.compare)(this.workspaceConfiguration,t);let f=[...s,...r,...n];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:l}}compareAndUpdateFolderConfiguration(t,s){const r=this.folderConfigurations.get(t),{added:n,updated:l,removed:f,overrides:m}=(0,A.compare)(r,s);let E=[...n,...l,...f];return(E.length||!r)&&this.updateFolderConfiguration(t,s),{keys:E,overrides:m}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:n,removed:l,overrides:f}=(0,A.compare)(s,void 0);return{keys:[...r,...n,...l],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,s){let r=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},s){let r=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const n=s.getFolder(t);n&&(r=this.getFolderConsolidatedConfiguration(n.uri)||r);const l=this._memoryConfigurationByResource.get(t);l&&(r=r.merge(l))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const r=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(t);n?(s=r.merge(n),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(t,s)):s=r}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const r=s.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:r,overrides:n,keys:l}=this._folderConfigurations.get(s);return t.push([s,{contents:r,overrides:n,keys:l}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>t.add(s)),this.userConfiguration.freeze().keys.forEach(s=>t.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(n=>s.add(n))),[...s.values()]}static parse(t){const s=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),n=this.parseConfigurationModel(t.workspace),l=t.folders.reduce((f,m)=>(f.set(I.URI.revive(m[0]),this.parseConfigurationModel(m[1])),f),new L.ResourceMap);return new _(s,r,new u,n,l,new u,new L.ResourceMap,!1)}static parseConfigurationModel(t){return new u(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=_;function b(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const t=new Set,s=new Map;for(const n of v)n.keys.forEach(l=>t.add(l)),n.overrides.forEach(([l,f])=>{const m=(0,L.getOrSet)(s,l,new Set);f.forEach(E=>m.add(E))});const r=[];return s.forEach((n,l)=>r.push([l,[...n.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=b;class d{constructor(t,s,r,n){this.change=t,this.previous=s,this.currentConfiguraiton=r,this.currentWorkspace=n,this._previousConfiguration=void 0;const l=new Set;t.keys.forEach(m=>l.add(m)),t.overrides.forEach(([,m])=>m.forEach(E=>l.add(E))),this.affectedKeys=[...l.values()];const f=new u;this.affectedKeys.forEach(m=>f.setValue(m,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=_.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(s){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!T.equals(r,n)}return!0}return!1}doesAffectedKeysTreeContains(t,s){let r=(0,A.toValuesTree)({[s]:!0},()=>{}),n;for(;typeof r=="object"&&(n=Object.keys(r)[0]);){if(t=t[n],!t)return!1;r=r[n]}return!0}}e.ConfigurationChangeEvent=d;class h extends d{constructor(t,s,r,n){super({keys:t.allKeys(),overrides:[]},void 0,t,s);this.source=r,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=h}),define(me[118],ge([0,1,4]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,p.createDecorator)("remoteAuthorityResolverService");var L;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class C extends Error{constructor(T,I=L.Unknown,D){super(T);this._message=T,this._code=I,this._detail=D,this.isHandled=I===L.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype)}static isTemporarilyNotAvailable(T){return T instanceof C&&T._code===L.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof C&&T._code===L.NoResolverFound}static isHandled(T){return T instanceof C&&T.isHandled}}e.RemoteAuthorityResolverError=C}),define(me[83],ge([0,1,10]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(A){return A.scheme===p.Schemas.vscodeRemote?A.authority:void 0}e.getRemoteAuthority=L;function C(A){if(!A)return;const i=A.indexOf("+");return i<0?A:A.substr(0,i)}e.getRemoteName=C;function S(A){return A.scheme!==p.Schemas.file&&A.scheme!==p.Schemas.vscodeRemote}e.isVirtualResource=S;function T(A){if(A.folders.length)return A.folders.every(i=>S(i.uri))?A.folders[0].uri:void 0;if(A.configuration&&S(A.configuration))return A.configuration}e.getVirtualWorkspaceLocation=T;function I(A){return T(A)?.scheme}e.getVirtualWorkspaceScheme=I;function D(A){return T(A)!==void 0}e.isVirtualWorkspace=D}),define(me[189],ge([0,1,3,11,4,12]),function(J,e,p,L,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,C.createDecorator)("tunnelService");var T;(function(u){u.Http="http",u.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(u){u[u.Notify=1]="Notify",u[u.OpenBrowser=2]="OpenBrowser",u[u.OpenPreview=3]="OpenPreview",u[u.Silent=4]="Silent",u[u.Ignore=5]="Ignore",u[u.OpenBrowserOnce=6]="OpenBrowserOnce"})(I=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function D(u){if(u.scheme!=="http"&&u.scheme!=="https")return;const a=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(u.authority);if(!!a)return{address:a[1],port:+a[2]}}e.extractLocalHostUriMetaDataForPortMapping=D,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function A(u){return e.LOCALHOST_ADDRESSES.indexOf(u)>=0}e.isLocalhost=A,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function i(u){return e.ALL_INTERFACES_ADDRESSES.indexOf(u)>=0}e.isAllInterfaces=i;function P(u,a){return a?a!==1&&u<1024:!L.isWindows&&u<1024}e.isPortPrivileged=P;let c=class{constructor(a){this.logService=a,this._onTunnelOpened=new p.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new p.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new p.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(a,g){return this._tunnelProvider=a,a?(this._canElevate=g.elevation,this._canMakePublic=g.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async a=>{const g=[],w=Array.from(this._tunnels.values());for(let _ of w){const b=Array.from(_.values());for(let d of b){const h=await d.value;h&&g.push(h)}}a(g)})}async dispose(){for(const a of this._tunnels.values()){for(const{value:g}of a.values())await g.then(w=>w?.dispose());a.clear()}this._tunnels.clear()}openTunnel(a,g,w,_,b=!1,d=!1,h){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${w} on local port ${_}.`),!a)return;g||(g="localhost");const v=this.retainOrCreateTunnel(a,g,w,_,b,d,h);return v?v.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,w);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(t);return(t.tunnelRemoteHost!==g||t.tunnelRemotePort!==w)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),v)}makeTunnel(a){return{tunnelRemotePort:a.tunnelRemotePort,tunnelRemoteHost:a.tunnelRemoteHost,tunnelLocalPort:a.tunnelLocalPort,localAddress:a.localAddress,public:a.public,protocol:a.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${a.tunnelRemoteHost}:${a.tunnelRemotePort} `);const g=this._tunnels.get(a.tunnelRemoteHost);if(g){const w=g.get(a.tunnelRemotePort);w&&(w.refcount--,await this.tryDisposeTunnel(a.tunnelRemoteHost,a.tunnelRemotePort,w))}}}}async tryDisposeTunnel(a,g,w){if(w.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${a}:${g}.`);const _=w.value.then(async b=>{b&&(await b.dispose(!0),this._onTunnelClosed.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this._tunnels.has(a)&&this._tunnels.get(a).delete(g),_}}async closeTunnel(a,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${a}:${g} `);const w=this._tunnels.get(a);if(w&&w.has(g)){const _=w.get(g);_.refcount=0,await this.tryDisposeTunnel(a,g,_)}}addTunnelToMap(a,g,w){this._tunnels.has(a)||this._tunnels.set(a,new Map),this._tunnels.get(a).set(g,{refcount:1,value:w})}async removeEmptyTunnelFromMap(a,g){const w=this._tunnels.get(a);w&&(await w.get(g)||w.delete(g),w.size===0&&this._tunnels.delete(a))}getTunnelFromMap(a,g){let w=[a];A(a)?(w.push(...e.LOCALHOST_ADDRESSES),w.push(...e.ALL_INTERFACES_ADDRESSES)):i(a)&&w.push(...e.ALL_INTERFACES_ADDRESSES);const _=w.map(b=>this._tunnels.get(b));for(const b of _){const d=b?.get(g);if(d)return d}}canTunnel(a){return!!D(a)}createWithProvider(a,g,w,_,b,d,h){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${w} on local port ${_}.`);const t={elevationRequired:b?P(_===void 0?w:_):!1},s={remoteAddress:{host:g,port:w},localAddressPort:_,public:d,protocol:h},r=a.forwardPort(s,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(g,w,r),r}};c=Ve([He(0,S.ILogService)],c),e.AbstractTunnelService=c}),define(me[190],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class p{vsda(){return new Promise((C,S)=>J(["vsda"],C,S))}async sign(C){try{const S=await this.vsda(),T=new S.signer;if(T)return T.sign(C)}catch(S){}return C}}e.SignService=p}),define(me[191],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class p{constructor(C){this._callback=C,this._terminalBufferMap=new Map}dispose(){for(const C of this._terminalBufferMap.values())C.dispose()}startBuffering(C,S,T=5){let I;return I=S(D=>{const A=typeof D=="string"?D:D.data;let i=this._terminalBufferMap.get(C);if(i){i.data.push(A);return}const P=setTimeout(()=>this.flushBuffer(C),T);i={data:[A],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(C),I.dispose()}},this._terminalBufferMap.set(C,i)}),I}stopBuffering(C){const S=this._terminalBufferMap.get(C);S&&S.dispose()}flushBuffer(C){const S=this._terminalBufferMap.get(C);S&&(this._terminalBufferMap.delete(C),this._callback(C,S.data.join("")))}}e.TerminalDataBufferer=p}),define(me[192],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var p;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(p=e.ColorScheme||(e.ColorScheme={}))}),define(me[193],ge([0,1,4,6,42,3,192,74]),function(J,e,p,L,C,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,p.createDecorator)("themeService");var D;(function(w){function _(b){return b&&typeof b=="object"&&typeof b.id=="string"}w.isThemeColor=_})(D=e.ThemeColor||(e.ThemeColor={}));function A(w){return{id:w}}e.themeColorFromId=A;var i;(function(w){function _(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||D.isThemeColor(s.color))}w.isThemeIcon=_;const b=new RegExp(`^\\$\\((${I.CSSIcon.iconNameExpression}(?:${I.CSSIcon.iconModifierExpression})?)\\)$`);function d(s){const r=b.exec(s);if(!r)return;let[,n]=r;return{id:n}}w.fromString=d;function h(s,r){let n=s.id;const l=n.lastIndexOf("~");return l!==-1&&(n=n.substring(0,l)),r&&(n=`${n}~${r}`),{id:n}}w.modify=h;function v(s,r){return s.id===r.id&&s.color?.id===r.color?.id}w.isEqual=v;function t(s,r){return{id:s.id,color:r?A(r):void 0}}w.asThemeIcon=t,w.asClassNameArray=I.CSSIcon.asClassNameArray,w.asClassName=I.CSSIcon.asClassName,w.asCSSSelector=I.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=I.Codicon.file,e.FolderThemeIcon=I.Codicon.folder;function P(w){switch(w){case T.ColorScheme.DARK:return"vs-dark";case T.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class c{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new S.Emitter}onColorThemeChange(_){return this.themingParticipants.push(_),this.onThemingParticipantAddedEmitter.fire(_),(0,L.toDisposable)(()=>{const b=this.themingParticipants.indexOf(_);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let u=new c;C.Registry.add(e.Extensions.ThemingContribution,u);function a(w){return u.onColorThemeChange(w)}e.registerThemingParticipant=a;class g extends L.Disposable{constructor(_){super();this.themeService=_,this.theme=_.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(_){this.theme=_,this.updateStyles()}updateStyles(){}getColor(_,b){let d=this.theme.getColor(_);return d&&b&&(d=b(d,this.theme)),d?d.toString():null}}e.Themable=g}),define(me[47],ge([0,1,2,24,4,23]),function(J,e,p,L,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var T;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function I(c){const u=c;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}e.isWorkspace=I;function D(c){const u=c;return!!(u&&typeof u=="object"&&p.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}e.isWorkspaceFolder=D;class A{constructor(u,a,g,w){this._id=u,this._configuration=g,this._ignorePathCasing=w,this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(u){this._id=u.id,this._configuration=u.configuration,this._ignorePathCasing=u._ignorePathCasing,this.folders=u.folders}get folders(){return this._folders}set folders(u){this._folders=u,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(u){this._configuration=u}getFolder(u){return u&&this._foldersMap.findSubstr(u.with({scheme:u.scheme,authority:u.authority,path:u.path}))||null}updateFoldersMap(){this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing);for(const u of this.folders)this._foldersMap.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=A;class i{constructor(u,a){this.raw=a,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,L.joinPath)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function P(c){return new i({uri:c,index:0,name:(0,L.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=P}),define(me[194],ge([0,1,4,158,47,2,11,9,24,135,54,10,76,29,83]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,L.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function w(O){return(typeof O=="string"?(0,I.extname)(O):(0,D.extname)(O))===g}e.hasWorkspaceFileExtension=w,e.IWorkspacesService=(0,p.createDecorator)("workspacesService");function _(O){return O.hasOwnProperty("workspace")}e.isRecentWorkspace=_;function b(O){return O.hasOwnProperty("folderUri")}e.isRecentFolder=b;function d(O){return O.hasOwnProperty("fileUri")}e.isRecentFile=d;function h(O){const B=O;return typeof B?.id=="string"&&S.URI.isUri(B.uri)}e.isSingleFolderWorkspaceIdentifier=h;function v(O){if(O.configuration)return{id:O.id,configPath:O.configuration};if(O.folders.length===1)return{id:O.id,uri:O.folders[0].uri}}e.toWorkspaceIdentifier=v;function t(O){const B=O;return typeof B?.id=="string"&&S.URI.isUri(B.configPath)}e.isWorkspaceIdentifier=t;function s(O){const B=O;if(B?.uri)return{id:B.id,uri:S.URI.revive(B.uri)};const R=O;if(R?.configPath)return{id:R.id,configPath:S.URI.revive(R.configPath)};if(O?.id)return{id:O.id}}e.reviveIdentifier=s;function r(O,B){return D.extUriBiasedIgnorePathCase.isEqualOrParent(O,B.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function n(O){return l(O)||f(O)}e.isStoredWorkspaceFolder=n;function l(O){const B=O;return typeof B?.path=="string"&&(!B.name||typeof B.name=="string")}e.isRawFileWorkspaceFolder=l;function f(O){const B=O;return typeof B?.uri=="string"&&(!B.name||typeof B.name=="string")}e.isRawUriWorkspaceFolder=f;function m(O,B,R,z,N=!T.isWindows,M){if(O.scheme!==z.scheme)return{name:R,uri:O.toString(!0)};let q=B?void 0:M.relativePath(z,O);if(q!==void 0)q.length===0?q=".":T.isWindows&&O.scheme===P.Schemas.file&&!N&&(q=q.replace(/\//g,"\\"));else if(O.scheme===P.Schemas.file)q=O.fsPath,T.isWindows&&(q=(0,c.normalizeDriveLetter)(q),N&&(q=(0,u.toSlashes)(q)));else{if(!M.isEqualAuthority(O.authority,z.authority))return{name:R,uri:O.toString(!0)};q=O.path}return{name:R,path:q}}e.getStoredWorkspaceFolder=m;function E(O,B,R){let z=[],N=new Set;const M=R.dirname(B);for(let q of O){let x;if(l(q))q.path&&(x=R.resolvePath(M,q.path));else if(f(q))try{x=S.URI.parse(q.uri),x.path[0]!=="/"&&(x=x.with({path:"/"+x.path}))}catch(K){console.warn(K)}if(x){let K=R.getComparisonKey(x);if(!N.has(K)){N.add(K);const ee=q.name||R.basenameOrAuthority(x);z.push(new C.WorkspaceFolder({uri:x,name:ee,index:z.length},q))}}}return z}e.toWorkspaceFolders=E;function y(O,B,R,z,N){let M=o(B,O);const q=N.dirname(B),x=N.dirname(z),K=[],ee=k(M.folders);for(const Le of M.folders){const qe=l(Le)?N.resolvePath(q,Le.path):S.URI.parse(Le.uri);let We;R?We=!1:We=!l(Le)||(0,I.isAbsolute)(Le.path),K.push(m(qe,We,Le.name,x,ee,N))}const de={insertSpaces:!1,tabSize:4,eol:T.isLinux||T.isMacintosh?`
`:`\r
`},Se=A.setProperty(O,["folders"],K,de);let De=A.applyEdits(O,Se);return M.remoteAuthority===(0,a.getRemoteAuthority)(z)&&(De=A.applyEdits(De,A.removeProperty(De,["remoteAuthority"],de))),De}e.rewriteWorkspaceFileForNewLocation=y;function o(O,B){let R=i.parse(B);if(R&&Array.isArray(R.folders))R.folders=R.folders.filter(z=>n(z));else throw new Error(`${O} looks like an invalid workspace file.`);return R}function k(O){return T.isWindows?O.some(B=>l(B)&&B.path.indexOf("/")>=0):!0}e.useSlashForPath=k;function F(O){return O.workspace&&typeof O.workspace=="object"&&typeof O.workspace.id=="string"&&typeof O.workspace.configPath=="string"}function $(O){return typeof O.folderUri=="string"}function Q(O){return typeof O.fileUri=="string"}function oe(O,B){const R={workspaces:[],files:[]};if(O){const z=function(M,q){for(let x=0;x<M.length;x++)try{q(M[x],x)}catch(K){B.warn(`Error restoring recent entry ${JSON.stringify(M[x])}: ${K.toString()}. Skip entry.`)}},N=O;if(Array.isArray(N.entries))z(N.entries,M=>{const q=M.label,x=M.remoteAuthority;F(M)?R.workspaces.push({label:q,remoteAuthority:x,workspace:{id:M.workspace.id,configPath:S.URI.parse(M.workspace.configPath)}}):$(M)?R.workspaces.push({label:q,remoteAuthority:x,folderUri:S.URI.parse(M.folderUri)}):Q(M)&&R.files.push({label:q,remoteAuthority:x,fileUri:S.URI.parse(M.fileUri)})});else{const M=O;Array.isArray(M.workspaces3)&&z(M.workspaces3,(q,x)=>{const K=Array.isArray(M.workspaceLabels)&&M.workspaceLabels[x]||void 0;typeof q=="object"&&typeof q.id=="string"&&typeof q.configURIPath=="string"?R.workspaces.push({label:K,workspace:{id:q.id,configPath:S.URI.parse(q.configURIPath)}}):typeof q=="string"&&R.workspaces.push({label:K,folderUri:S.URI.parse(q)})}),Array.isArray(M.files2)&&z(M.files2,(q,x)=>{const K=Array.isArray(M.fileLabels)&&M.fileLabels[x]||void 0;typeof q=="string"&&R.files.push({label:K,fileUri:S.URI.parse(q)})})}}return R}e.restoreRecentlyOpened=oe;function j(O){const B={entries:[]};for(const R of O.workspaces)b(R)?B.entries.push({folderUri:R.folderUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority}):B.entries.push({workspace:{id:R.workspace.id,configPath:R.workspace.configPath.toString()},label:R.label,remoteAuthority:R.remoteAuthority});for(const R of O.files)B.entries.push({fileUri:R.fileUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority});return B}e.toStoreData=j}),define(me[84],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class p{constructor(C){this.id=C,this._data=new Map,this._idPool=1}add(C){const S=this._idPool++;return this._data.set(S,C),this.logDebugInfo(),S}get(C,S){return this._data.has(C)?this._data.get(C)[S]:void 0}delete(C){this._data.delete(C),this.logDebugInfo()}logDebugInfo(){!p.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=p,p.enableDebugLogging=!1}),define(me[48],ge([0,1,2,3,4]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class S{constructor(){this._onDidChangeTabs=new L.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(I){this._tabs=I.map(D=>({name:D.name,group:D.group,resource:p.URI.revive(D.resource),isActive:D.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=S}),define(me[59],ge([0,1,10,4]),function(J,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(p.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(T,I){I===null?this._providerInfo.delete(T):this._providerInfo.set(T,I)}isFreeScheme(T){return!this._providerInfo.has(T)&&!this._systemSchemes.has(T)}getCapabilities(T){return this._providerInfo.get(T)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=(0,L.createDecorator)("IExtHostFileSystemInfo")}),define(me[27],ge([0,1,4]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,p.createDecorator)("IExtHostInitDataService")}),define(me[195],ge([0,1,2]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class L{constructor(S,T,I){this._extHostNotebooks=T,this._textDocumentsAndEditors=I}$willAddInteractiveDocument(S,T,I,D){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],modeId:I,uri:S,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(p.URI.revive(D))?.apiNotebook}]})}$willRemoveInteractiveDocument(S,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[S]})}}e.ExtHostInteractive=L}),define(me[196],ge([0,1,17]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(T,I,D){this._deferredPromises=new Map,this._id=T,this._shared=I,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(A=>(this._value=A,this)),this._storageListener=this._storage.onDidChangeStorage(A=>{A.shared===this._shared&&A.key===this._id&&(this._value=A.value)}),this._scheduler=new p.RunOnceScheduler(()=>{const A=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of A.values())i.complete()}catch(i){for(const P of A.values())P.error(i)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,I){let D=this._value[T];return typeof D=="undefined"&&(D=I),D}update(T,I){this._value[T]=I;let D=this._deferredPromises.get(T);if(D!==void 0)return D.p;const A=new p.DeferredPromise;return this._deferredPromises.set(T,A),this._scheduler.isScheduled()||this._scheduler.schedule(),A.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class C extends L{constructor(T,I){super(T.identifier.value,!0,I);this._extension=T}setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}}e.ExtensionGlobalMemento=C}),define(me[197],ge([0,1,3,2,12]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let S=class{constructor(I,D){this._logService=I,this._notebooksAndEditors=D,this._onDidChangeNotebookDocumentMetadata=new p.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new p.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(I,D,A){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(I)).acceptModelChanged(D,A)}$acceptDirtyStateChanged(I,D){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(I)).acceptDirty(D)}$acceptModelSaved(I){const D=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(I));this._onDidSaveNotebookDocument.fire(D.apiNotebook)}$acceptDocumentPropertiesChanged(I,D){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",I.path,D);const A=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(I));A.acceptDocumentPropertiesChanged(D),D.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:A.apiNotebook})}};S=Ve([He(0,C.ILogService)],S),e.ExtHostNotebookDocuments=S}),define(me[13],ge([0,1,4]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,p.createDecorator)("IExtHostRpcService");class L{constructor(S){this.getProxy=S.getProxy.bind(S),this.set=S.set.bind(S),this.assertRegistered=S.assertRegistered.bind(S),this.drain=S.drain.bind(S)}}e.ExtHostRpcService=L});var nt=this&&this.__classPrivateFieldSet||function(J,e,p,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(J,p):C?C.value=p:e.set(J,p),p},Ue=this&&this.__classPrivateFieldGet||function(J,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(J):L?L.value:e.get(J)};define(me[198],ge([0,1,26,3]),function(J,e,p,L){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class S{constructor(I,D){C.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=p.ExtensionIdentifier.toKey(I.identifier),nt(this,C,D,"f"),Ue(this,C,"f").onDidChangePassword(A=>{A.extensionId===this._id&&this._onDidChange.fire({key:A.key})})}get(I){return Ue(this,C,"f").get(this._id,I)}store(I,D){return Ue(this,C,"f").store(this._id,I,D)}delete(I){return Ue(this,C,"f").delete(this._id,I)}}e.ExtensionSecrets=S,C=new WeakMap}),define(me[119],ge([0,1,4,3]),function(J,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class C{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(T){this._enabled=T}$onDidChangeTelemetryEnabled(T){this._enabled=T,this._onDidChangeTelemetryEnabled.fire(T)}}e.ExtHostTelemetry=C,e.IExtHostTelemetry=(0,p.createDecorator)("IExtHostTelemetry")}),define(me[85],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemImpl=e.createTestItemCollection=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var p;(function(g){g[g.Upsert=0]="Upsert",g[g.RemoveChild=1]="RemoveChild",g[g.Invalidated=2]="Invalidated",g[g.SetProp=3]="SetProp",g[g.Bulk=4]="Bulk"})(p=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const L=new WeakMap,C=g=>{let w=L.get(g);return w||(w={},L.set(g,w)),w};e.getPrivateApiFor=C;const S=(g,w,_,b)=>{let d=_;return{enumerable:!0,configurable:!1,get(){return d},set(h){b(d,h)||(d=h,g.listener?.({op:3,key:w,value:h}))}}},T=(g,w)=>g===w,I={range:(g,w)=>g===w?!0:!g||!w?!1:g.isEqual(w),label:T,description:T,busy:T,error:T,canResolveChildren:T},D=Object.keys(I),A=(g,w)=>({range:S(g,"range",void 0,I.range),label:S(g,"label",w,I.label),description:S(g,"description",void 0,I.description),canResolveChildren:S(g,"canResolveChildren",!1,I.canResolveChildren),busy:S(g,"busy",!1,I.busy),error:S(g,"error",void 0,I.error)}),i=(g,w)=>{const _=new Map;for(const b of D)I[b](g[b],w[b])||_.set(b,w[b]);return _};e.diffTestItems=i;class P extends Error{constructor(w){super(`Attempted to insert a duplicate test item ID ${w}`)}}e.DuplicateTestItemError=P;class c extends Error{constructor(w){super(`TestItem with ID "${w}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=c;const u=g=>{const w=(0,e.getPrivateApiFor)(g);let _,b=new Map;return{get all(){return _||(_=Object.freeze([...b.values()])),_},set all(d){const h=new Map,v=new Set(b.keys()),t={op:4,ops:[]};for(const s of d){if(!(s instanceof a))throw new c(s.id);if(h.has(s.id))throw new P(s.id);h.set(s.id,s),v.delete(s.id),t.ops.push({op:0,item:s})}for(const s of v.keys())t.ops.push({op:1,id:s});w.listener?.(t),b=h,_=void 0},add(d){if(!(d instanceof a))throw new c(d.id);b.set(d.id,d),_=void 0,w.listener?.({op:0,item:d})},remove(d){b.delete(d)&&(_=void 0,w.listener?.({op:1,id:d}))},get(d){return b.get(d)},toJSON(){return this.all}}};e.createTestItemCollection=u;class a{constructor(w,_,b){const d=(0,e.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:w,enumerable:!0,writable:!1},uri:{value:b,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent}},children:{value:(0,e.createTestItemCollection)(this),enumerable:!0,writable:!1},...A(d,_)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=a}),define(me[49],ge([0,1,4,3,13]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var S;(function(I){function D(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,protocol:i.protocol}}I.fromApiTunnel=D;function A(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public,protocol:i.protocol}}I.fromServiceTunnel=A})(S=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,p.createDecorator)("IExtHostTunnelService");let T=class{constructor(D){this.onDidChangeTunnels=new L.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,A){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,A){return{dispose:()=>{}}}async $providePortAttributes(D,A,i,P,c){return[]}async $forwardPort(D,A){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=Ve([He(0,C.IExtHostRpcService)],T),e.ExtHostTunnelService=T});var nt=this&&this.__classPrivateFieldSet||function(J,e,p,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(J,p):C?C.value=p:e.set(J,p),p},Ue=this&&this.__classPrivateFieldGet||function(J,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(J):L?L.value:e.get(J)};define(me[7],ge([0,1,18,15,96,23,99,14,2,32,41,118]),function(J,e,p,L,C,S,T,I,D,A,i,P){"use strict";var c,u,a,g,w,_,b,d,h,v,t,s,r,n,l,f,m,E,y,o;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestMessage=e.TestRunRequest=e.TestRunConfigurationGroup=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function k(H){function U(){return Reflect.construct(H,arguments,this.constructor)}return Object.defineProperty(U,"name",Object.getOwnPropertyDescriptor(H,"name")),Object.setPrototypeOf(U,H),Object.setPrototypeOf(U.prototype,H.prototype),U}let F=w=class{constructor(U){c.set(this,void 0),nt(this,c,U,"f")}static from(...U){let re=U;return new w(function(){if(re){for(const Pe of re)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();re=void 0}})}dispose(){typeof Ue(this,c,"f")=="function"&&(Ue(this,c,"f").call(this),nt(this,c,void 0,"f"))}};c=new WeakMap,F=w=Ve([k],F),e.Disposable=F;let $=_=class{constructor(U,re){if(U<0)throw(0,L.illegalArgument)("line must be non-negative");if(re<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=U,this._character=re}static Min(...U){if(U.length===0)throw new TypeError;let re=U[0];for(let Pe=1;Pe<U.length;Pe++){const Je=U[Pe];Je.isBefore(re)&&(re=Je)}return re}static Max(...U){if(U.length===0)throw new TypeError;let re=U[0];for(let Pe=1;Pe<U.length;Pe++){const Je=U[Pe];Je.isAfter(re)&&(re=Je)}return re}static isPosition(U){if(!U)return!1;if(U instanceof _)return!0;let{line:re,character:Pe}=U;return typeof re=="number"&&typeof Pe=="number"}get line(){return this._line}get character(){return this._character}isBefore(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<U._character}isBeforeOrEqual(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<=U._character}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this._line===U._line&&this._character===U._character}compareTo(U){return this._line<U._line?-1:this._line>U.line?1:this._character<U._character?-1:this._character>U._character?1:0}translate(U,re=0){if(U===null||re===null)throw(0,L.illegalArgument)();let Pe;return typeof U=="undefined"?Pe=0:typeof U=="number"?Pe=U:(Pe=typeof U.lineDelta=="number"?U.lineDelta:0,re=typeof U.characterDelta=="number"?U.characterDelta:0),Pe===0&&re===0?this:new _(this.line+Pe,this.character+re)}with(U,re=this.character){if(U===null||re===null)throw(0,L.illegalArgument)();let Pe;return typeof U=="undefined"?Pe=this.line:typeof U=="number"?Pe=U:(Pe=typeof U.line=="number"?U.line:this.line,re=typeof U.character=="number"?U.character:this.character),Pe===this.line&&re===this.character?this:new _(Pe,re)}toJSON(){return{line:this.line,character:this.character}}};$=_=Ve([k],$),e.Position=$;let Q=b=class{constructor(U,re,Pe,Je){let it,rt;if(typeof U=="number"&&typeof re=="number"&&typeof Pe=="number"&&typeof Je=="number"?(it=new $(U,re),rt=new $(Pe,Je)):U instanceof $&&re instanceof $&&(it=U,rt=re),!it||!rt)throw new Error("Invalid arguments");it.isBefore(rt)?(this._start=it,this._end=rt):(this._start=rt,this._end=it)}static isRange(U){return U instanceof b?!0:U?$.isPosition(U.start)&&$.isPosition(U.end):!1}get start(){return this._start}get end(){return this._end}contains(U){return U instanceof b?this.contains(U._start)&&this.contains(U._end):U instanceof $?!(U.isBefore(this._start)||this._end.isBefore(U)):!1}isEqual(U){return this._start.isEqual(U._start)&&this._end.isEqual(U._end)}intersection(U){const re=$.Max(U.start,this._start),Pe=$.Min(U.end,this._end);if(!re.isAfter(Pe))return new b(re,Pe)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const re=$.Min(U.start,this._start),Pe=$.Max(U.end,this.end);return new b(re,Pe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(U,re=this.end){if(U===null||re===null)throw(0,L.illegalArgument)();let Pe;return U?$.isPosition(U)?Pe=U:(Pe=U.start||this.start,re=U.end||this.end):Pe=this.start,Pe.isEqual(this._start)&&re.isEqual(this.end)?this:new b(Pe,re)}toJSON(){return[this.start,this.end]}};Q=b=Ve([k],Q),e.Range=Q;let oe=d=class extends Q{constructor(U,re,Pe,Je){let it,rt;if(typeof U=="number"&&typeof re=="number"&&typeof Pe=="number"&&typeof Je=="number"?(it=new $(U,re),rt=new $(Pe,Je)):U instanceof $&&re instanceof $&&(it=U,rt=re),!it||!rt)throw new Error("Invalid arguments");super(it,rt);this._anchor=it,this._active=rt}static isSelection(U){return U instanceof d?!0:U?Q.isRange(U)&&$.isPosition(U.anchor)&&$.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};oe=d=Ve([k],oe),e.Selection=oe;class j{constructor(U,re,Pe){if(typeof U!="string"||U.length===0)throw(0,L.illegalArgument)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,L.illegalArgument)("port");if(typeof Pe!="undefined"&&(typeof Pe!="string"||Pe.length===0||!/^[0-9A-Za-z\-]+$/.test(Pe)))throw(0,L.illegalArgument)("connectionToken");this.host=U,this.port=Math.round(re),this.connectionToken=Pe}}e.ResolvedAuthority=j;class O extends Error{constructor(U,re=P.RemoteAuthorityResolverErrorCode.Unknown,Pe){super(U);this._message=U,this._code=re,this._detail=Pe,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,O.prototype)}static NotAvailable(U,re){return new O(U,P.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(U){return new O(U,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=O;var B;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(B=e.EndOfLine||(e.EndOfLine={}));var R;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(R=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let z=h=class{constructor(U,re){this._range=U,this._newText=re}static isTextEdit(U){return U instanceof h?!0:U?Q.isRange(U)&&typeof U.newText=="string":!1}static replace(U,re){return new h(U,re)}static insert(U,re){return h.replace(new Q(U,U),re)}static delete(U){return h.replace(U,"")}static setEndOfLine(U){const re=new h(new Q(new $(0,0),new $(0,0)),"");return re.newEol=U,re}get range(){return this._range}set range(U){if(U&&!Q.isRange(U))throw(0,L.illegalArgument)("range");this._range=U}get newText(){return this._newText||""}set newText(U){if(U&&typeof U!="string")throw(0,L.illegalArgument)("newText");this._newText=U}get newEol(){return this._newEol}set newEol(U){if(U&&typeof U!="number")throw(0,L.illegalArgument)("newEol");this._newEol=U}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};z=h=Ve([k],z),e.TextEdit=z;var N;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace"})(N=e.FileEditType||(e.FileEditType={}));let M=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(U,re,Pe,Je){this._edits.push({_type:1,from:U,to:re,options:Pe,metadata:Je})}createFile(U,re,Pe){this._edits.push({_type:1,from:void 0,to:U,options:re,metadata:Pe})}deleteFile(U,re,Pe){this._edits.push({_type:1,from:U,to:void 0,options:re,metadata:Pe})}replaceNotebookMetadata(U,re,Pe){this._edits.push({_type:3,metadata:Pe,uri:U,edit:{editType:5,metadata:re},notebookMetadata:re})}replaceNotebookCells(U,re,Pe,Je,it){let rt,ot,St=[],It;if(Bt.isNotebookRange(re)&&Mt.isNotebookCellDataArray(Pe)&&!Mt.isNotebookCellDataArray(Je)?(rt=re.start,ot=re.end,St=Pe,It=Je):typeof re=="number"&&typeof Pe=="number"&&Mt.isNotebookCellDataArray(Je)&&(rt=re,ot=Pe,St=Je,It=it),rt===void 0||ot===void 0)throw new Error("Invalid arguments");(rt!==ot||St.length>0)&&this._edits.push({_type:5,uri:U,index:rt,count:ot-rt,cells:St,metadata:It})}replaceNotebookCellMetadata(U,re,Pe,Je){this._edits.push({_type:3,metadata:Je,uri:U,edit:{editType:8,index:re,metadata:Pe}})}replace(U,re,Pe,Je){this._edits.push({_type:2,uri:U,edit:new z(re,Pe),metadata:Je})}insert(U,re,Pe,Je){this.replace(U,new Q(re,re),Pe,Je)}delete(U,re,Pe){this.replace(U,re,"",Pe)}has(U){return this._edits.some(re=>re._type===2&&re.uri.toString()===U.toString())}set(U,re){if(re)for(const Pe of re)Pe&&this._edits.push({_type:2,uri:U,edit:Pe});else{for(let Pe=0;Pe<this._edits.length;Pe++){const Je=this._edits[Pe];Je._type===2&&Je.uri.toString()===U.toString()&&(this._edits[Pe]=void 0)}(0,p.coalesceInPlace)(this._edits)}}get(U){const re=[];for(let Pe of this._edits)Pe._type===2&&Pe.uri.toString()===U.toString()&&re.push(Pe.edit);return re}entries(){const U=new S.ResourceMap;for(let re of this._edits)if(re._type===2){let Pe=U.get(re.uri);Pe||(Pe=[re.uri,[]],U.set(re.uri,Pe)),Pe[1].push(re.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};M=Ve([k],M),e.WorkspaceEdit=M;let q=v=class{constructor(U){this._tabstop=1,this.value=U||""}static isSnippetString(U){return U instanceof v?!0:U?typeof U.value=="string":!1}static _escape(U){return U.replace(/\$|}|\\/g,"\\$&")}appendText(U){return this.value+=v._escape(U),this}appendTabstop(U=this._tabstop++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,re=this._tabstop++){if(typeof U=="function"){const Pe=new v;Pe._tabstop=this._tabstop,U(Pe),this._tabstop=Pe._tabstop,U=Pe.value}else U=v._escape(U);return this.value+="${",this.value+=re,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,re=this._tabstop++){const Pe=U.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable(U,re){if(typeof re=="function"){const Pe=new v;Pe._tabstop=this._tabstop,re(Pe),this._tabstop=Pe._tabstop,re=Pe.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,re&&(this.value+=":",this.value+=re),this.value+="}",this}};q=v=Ve([k],q),e.SnippetString=q;var x;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(x=e.DiagnosticTag||(e.DiagnosticTag={}));var K;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(K=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ee=t=class{constructor(U,re){if(this.uri=U,re)if(re instanceof Q)this.range=re;else if(re instanceof $)this.range=new Q(re,re);else throw new Error("Illegal argument")}static isLocation(U){return U instanceof t?!0:U?Q.isRange(U.range)&&D.URI.isUri(U.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ee=t=Ve([k],ee),e.Location=ee;let de=class{constructor(U,re){this.location=U,this.message=re}static is(U){return U?typeof U.message=="string"&&U.location&&Q.isRange(U.location.range)&&D.URI.isUri(U.location.uri):!1}static isEqual(U,re){return U===re?!0:!U||!re?!1:U.message===re.message&&U.location.range.isEqual(re.location.range)&&U.location.uri.toString()===re.location.uri.toString()}};de=Ve([k],de),e.DiagnosticRelatedInformation=de;let Se=class{constructor(U,re,Pe=K.Error){if(!Q.isRange(U))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=U,this.message=re,this.severity=Pe}toJSON(){return{severity:K[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,re){return U===re?!0:!U||!re?!1:U.message===re.message&&U.severity===re.severity&&U.code===re.code&&U.severity===re.severity&&U.source===re.source&&U.range.isEqual(re.range)&&(0,p.equals)(U.tags,re.tags)&&(0,p.equals)(U.relatedInformation,re.relatedInformation,de.isEqual)}};Se=Ve([k],Se),e.Diagnostic=Se;let De=class{constructor(U,re){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=re}};De=Ve([k],De),e.Hover=De;var Le;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(Le=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let qe=class{constructor(U,re=Le.Text){this.range=U,this.kind=re}toJSON(){return{range:this.range,kind:Le[this.kind]}}};qe=Ve([k],qe),e.DocumentHighlight=qe;var We;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(We=e.SymbolKind||(e.SymbolKind={}));var je;(function(H){H[H.Deprecated=1]="Deprecated"})(je=e.SymbolTag||(e.SymbolTag={}));let W=s=class{constructor(U,re,Pe,Je,it){this.name=U,this.kind=re,this.containerName=it,typeof Pe=="string"&&(this.containerName=Pe),Je instanceof ee?this.location=Je:Pe instanceof Q&&(this.location=new ee(Je,Pe)),s.validate(this)}static validate(U){if(!U.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:We[this.kind],location:this.location,containerName:this.containerName}}};W=s=Ve([k],W),e.SymbolInformation=W;let Z=r=class{constructor(U,re,Pe,Je,it){this.name=U,this.detail=re,this.kind=Pe,this.range=Je,this.selectionRange=it,this.children=[],r.validate(this)}static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children&&U.children.forEach(r.validate)}};Z=r=Ve([k],Z),e.DocumentSymbol=Z;var te;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(U,re){this.title=U,this.kind=re}};ae=Ve([k],ae),e.CodeAction=ae;let Y=n=class{constructor(U){this.value=U}append(U){return new n(this.value?this.value+n.sep+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+n.sep)}};Y.sep=".",Y=n=Ve([k],Y),e.CodeActionKind=Y,Y.Empty=new Y(""),Y.QuickFix=Y.Empty.append("quickfix"),Y.Refactor=Y.Empty.append("refactor"),Y.RefactorExtract=Y.Refactor.append("extract"),Y.RefactorInline=Y.Refactor.append("inline"),Y.RefactorRewrite=Y.Refactor.append("rewrite"),Y.Source=Y.Empty.append("source"),Y.SourceOrganizeImports=Y.Source.append("organizeImports"),Y.SourceFixAll=Y.Source.append("fixAll");let se=class{constructor(U,re){if(this.range=U,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};se=Ve([k],se),e.SelectionRange=se;class we{constructor(U,re,Pe,Je,it,rt){this.kind=U,this.name=re,this.detail=Pe,this.uri=Je,this.range=it,this.selectionRange=rt}}e.CallHierarchyItem=we;class Fe{constructor(U,re){this.fromRanges=re,this.from=U}}e.CallHierarchyIncomingCall=Fe;class ze{constructor(U,re){this.fromRanges=re,this.to=U}}e.CallHierarchyOutgoingCall=ze;let _e=class{constructor(U,re){this.range=U,this.command=re}get isResolved(){return!!this.command}};_e=Ve([k],_e),e.CodeLens=_e;let Ze=l=class{constructor(U,re=!1){u.set(this,void 0),nt(this,u,new C.MarkdownString(U,{supportThemeIcons:re}),"f")}static isMarkdownString(U){return U instanceof l?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}get value(){return Ue(this,u,"f").value}set value(U){Ue(this,u,"f").value=U}get isTrusted(){return Ue(this,u,"f").isTrusted}set isTrusted(U){Ue(this,u,"f").isTrusted=U}get supportThemeIcons(){return Ue(this,u,"f").supportThemeIcons}set supportThemeIcons(U){Ue(this,u,"f").supportThemeIcons=U}appendText(U){return Ue(this,u,"f").appendText(U),this}appendMarkdown(U){return Ue(this,u,"f").appendMarkdown(U),this}appendCodeblock(U,re){return Ue(this,u,"f").appendCodeblock(re??"",U),this}};u=new WeakMap,Ze=l=Ve([k],Ze),e.MarkdownString=Ze;let X=class{constructor(U,re){this.label=U,this.documentation=re}};X=Ve([k],X),e.ParameterInformation=X;let ie=class{constructor(U,re){this.label=U,this.documentation=re,this.parameters=[]}};ie=Ve([k],ie),e.SignatureInformation=ie;let fe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};fe=Ve([k],fe),e.SignatureHelp=fe;var $e;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})($e=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var xe;(function(H){H[H.Other=0]="Other",H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(xe=e.InlayHintKind||(e.InlayHintKind={}));let tt=class{constructor(U,re,Pe){this.text=U,this.position=re,this.kind=Pe}};tt=Ve([k],tt),e.InlayHint=tt;var Ce;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ke;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(ke=e.CompletionItemKind||(e.CompletionItemKind={}));var Te;(function(H){H[H.Deprecated=1]="Deprecated"})(Te=e.CompletionItemTag||(e.CompletionItemTag={}));let le=class{constructor(U,re){this.label=U,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&ke[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};le=Ve([k],le),e.CompletionItem=le;let ce=class{constructor(U=[],re=!1){this.items=U,this.isIncomplete=re}};ce=Ve([k],ce),e.CompletionList=ce;let pe=class{constructor(U,re,Pe){this.text=U,this.range=re,this.command=Pe}};pe=Ve([k],pe),e.InlineSuggestion=pe;let Ee=class{constructor(U){this.items=U}};Ee=Ve([k],Ee),e.InlineSuggestions=Ee;var G;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(G=e.ViewColumn||(e.ViewColumn={}));var ve;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(ve=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ye;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(ye=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ae;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(Ae=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ne;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Ne=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ge;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(Ge=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var et;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(et=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Qe;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(Qe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(H){function U(re){switch(re){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=U}(Ge=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Xe=class{constructor(U,re){if(re&&!D.URI.isUri(re))throw(0,L.illegalArgument)("target");if(!Q.isRange(U)||U.isEmpty)throw(0,L.illegalArgument)("range");this.range=U,this.target=re}};Xe=Ve([k],Xe),e.DocumentLink=Xe;let lt=class{constructor(U,re,Pe,Je){this.red=U,this.green=re,this.blue=Pe,this.alpha=Je}};lt=Ve([k],lt),e.Color=lt;let dt=class{constructor(U,re){if(re&&!(re instanceof lt))throw(0,L.illegalArgument)("color");if(!Q.isRange(U)||U.isEmpty)throw(0,L.illegalArgument)("range");this.range=U,this.color=re}};dt=Ve([k],dt),e.ColorInformation=dt;let _t=class{constructor(U){if(!U||typeof U!="string")throw(0,L.illegalArgument)("label");this.label=U}};_t=Ve([k],_t),e.ColorPresentation=_t;var at;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(at=e.ColorFormat||(e.ColorFormat={}));var be;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(be=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Ie{constructor(U,re,Pe){if(this.startIndex=U,this.length=re,this.tooltip=Pe,typeof U!="number"||U<0)throw(0,L.illegalArgument)("startIndex");if(typeof re!="number"||re<1)throw(0,L.illegalArgument)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=Ie;class he{constructor(U){this.options=U,typeof U!="object"&&(0,L.illegalArgument)("options")}}e.TerminalProfile=he;var V;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(V=e.TaskRevealKind||(e.TaskRevealKind={}));var Me;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(Me=e.TaskPanelKind||(e.TaskPanelKind={}));let Be=f=class{constructor(U,re){if(typeof U!="string"||typeof re!="string")throw(0,L.illegalArgument)("name");this._id=U}static from(U){switch(U){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}get id(){return this._id}};Be.Clean=new f("clean","Clean"),Be.Build=new f("build","Build"),Be.Rebuild=new f("rebuild","Rebuild"),Be.Test=new f("test","Test"),Be=f=Ve([k],Be),e.TaskGroup=Be;function Ye(H){let U="";for(let re=0;re<H.length;re++)U+=H[re].replace(/,/g,",,")+",";return U}let Ke=class{constructor(U,re,Pe){if(typeof U!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=U,re!==void 0&&(Array.isArray(re)?(this._args=re,this._options=Pe):this._options=re)}get process(){return this._process}set process(U){if(typeof U!="string")throw(0,L.illegalArgument)("process");this._process=U}get args(){return this._args}set args(U){Array.isArray(U)||(U=[]),this._args=U}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("process"),this._process!==void 0&&U.push(this._process),this._args&&this._args.length>0)for(let re of this._args)U.push(re);return Ye(U)}};Ke=Ve([k],Ke),e.ProcessExecution=Ke;let ct=class{constructor(U,re,Pe){if(this._args=[],Array.isArray(re)){if(!U)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,L.illegalArgument)("command");this._command=U,this._args=re,this._options=Pe}else{if(typeof U!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=U,this._options=re}}get commandLine(){return this._commandLine}set commandLine(U){if(typeof U!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=U}get command(){return this._command?this._command:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,L.illegalArgument)("command");this._command=U}get args(){return this._args}set args(U){this._args=U||[]}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("shell"),this._commandLine!==void 0&&U.push(this._commandLine),this._command!==void 0&&U.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let re of this._args)U.push(typeof re=="string"?re:re.value);return Ye(U)}};ct=Ve([k],ct),e.ShellExecution=ct;var mt;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(mt=e.ShellQuoting||(e.ShellQuoting={}));var kt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(kt=e.TaskScope||(e.TaskScope={}));class yt{constructor(U){this._callback=U}computeId(){return"customExecution"+(0,A.generateUuid)()}set callback(U){this._callback=U}get callback(){return this._callback}}e.CustomExecution=yt;let wt=m=class{constructor(U,re,Pe,Je,it,rt){this.__deprecated=!1,this._definition=this.definition=U;let ot;typeof re=="string"?(this._name=this.name=re,this._source=this.source=Pe,this.execution=Je,ot=it,this.__deprecated=!0):re===kt.Global||re===kt.Workspace?(this.target=re,this._name=this.name=Pe,this._source=this.source=Je,this.execution=it,ot=rt):(this.target=re,this._name=this.name=Pe,this._source=this.source=Je,this.execution=it,ot=rt),typeof ot=="string"?(this._problemMatchers=[ot],this._hasDefinedMatchers=!0):Array.isArray(ot)?(this._problemMatchers=ot,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(U){this.__id=U}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ke?this._definition={type:m.ProcessType,id:this._execution.computeId()}:this._execution instanceof ct?this._definition={type:m.ShellType,id:this._execution.computeId()}:this._execution instanceof yt?this._definition={type:m.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:m.EmptyType,id:(0,A.generateUuid)()}}get definition(){return this._definition}set definition(U){if(U==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=U}get scope(){return this._scope}set target(U){this.clear(),this._scope=U}get name(){return this._name}set name(U){if(typeof U!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=U}get execution(){return this._execution}set execution(U){U===null&&(U=void 0),this.clear(),this._execution=U;const re=this._definition.type;(m.EmptyType===re||m.ProcessType===re||m.ShellType===re||m.ExtensionCallbackType===re)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(U){if(Array.isArray(U))this.clear(),this._problemMatchers=U,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.clear(),this._isBackground=U}get source(){return this._source}set source(U){if(typeof U!="string"||U.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=U}get group(){return this._group}set group(U){U===null&&(U=void 0),this.clear(),this._group=U}get detail(){return this._detail}set detail(U){U===null&&(U=void 0),this._detail=U}get presentationOptions(){return this._presentationOptions}set presentationOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._presentationOptions=U}get runOptions(){return this._runOptions}set runOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._runOptions=U}};wt.ExtensionCallbackType="customExecution",wt.ProcessType="process",wt.ShellType="shell",wt.EmptyType="$empty",wt=m=Ve([k],wt),e.Task=wt;var gt;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(gt=e.ProgressLocation||(e.ProgressLocation={}));let ht=class{constructor(U,re=Et.None){this.collapsibleState=re,D.URI.isUri(U)?this.resourceUri=U:this.label=U}};ht=Ve([k],ht),e.TreeItem=ht;var Et;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(Et=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ft=class{constructor(U,re){this.id=U,this.color=re}};ft=Ve([k],ft),e.ThemeIcon=ft,ft.File=new ft("file"),ft.Folder=new ft("folder");let Nt=class{constructor(U){this.id=U}};Nt=Ve([k],Nt),e.ThemeColor=Nt;var Pt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(Pt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Kt=class{constructor(U,re){if(typeof U!="string"&&(!U||!D.URI.isUri(U)&&!D.URI.isUri(U.uri)))throw(0,L.illegalArgument)("base");if(typeof re!="string")throw(0,L.illegalArgument)("pattern");typeof U=="string"?(this.baseFolder=D.URI.file(U),this.base=U):D.URI.isUri(U)?(this.baseFolder=U,this.base=U.fsPath):(this.baseFolder=U.uri,this.base=U.uri.fsPath),this.pattern=re}};Kt=Ve([k],Kt),e.RelativePattern=Kt;let Ut=class{constructor(U,re,Pe,Je){this.enabled=typeof U=="boolean"?U:!0,typeof re=="string"&&(this.condition=re),typeof Pe=="string"&&(this.hitCondition=Pe),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this._id||(this._id=(0,A.generateUuid)()),this._id}};Ut=Ve([k],Ut),e.Breakpoint=Ut;let Ct=class extends Ut{constructor(U,re,Pe,Je,it){super(re,Pe,Je,it);if(U===null)throw(0,L.illegalArgument)("location");this.location=U}};Ct=Ve([k],Ct),e.SourceBreakpoint=Ct;let Qt=class extends Ut{constructor(U,re,Pe,Je,it){super(re,Pe,Je,it);this.functionName=U}};Qt=Ve([k],Qt),e.FunctionBreakpoint=Qt;let Xt=class extends Ut{constructor(U,re,Pe,Je,it,rt,ot){super(Je,it,rt,ot);if(!re)throw(0,L.illegalArgument)("dataId");this.label=U,this.dataId=re,this.canPersist=Pe}};Xt=Ve([k],Xt),e.DataBreakpoint=Xt;let pt=class{constructor(U,re,Pe){this.command=U,this.args=re||[],this.options=Pe}};pt=Ve([k],pt),e.DebugAdapterExecutable=pt;let jt=class{constructor(U,re){this.port=U,this.host=re}};jt=Ve([k],jt),e.DebugAdapterServer=jt;let zt=class{constructor(U){this.path=U}};zt=Ve([k],zt),e.DebugAdapterNamedPipeServer=zt;let Yt=class{constructor(U){this.implementation=U}};Yt=Ve([k],Yt),e.DebugAdapterInlineImplementation=Yt;let Jt=class{constructor(U,re){this.range=U,this.expression=re}};Jt=Ve([k],Jt),e.EvaluatableExpression=Jt;var At;(function(H){H[H.Automatic=0]="Automatic",H[H.Explicit=1]="Explicit"})(At=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let qt=class{constructor(U,re){this.range=U,this.text=re}};qt=Ve([k],qt),e.InlineValueText=qt;let Zt=class{constructor(U,re,Pe=!0){this.range=U,this.variableName=re,this.caseSensitiveLookup=Pe}};Zt=Ve([k],Zt),e.InlineValueVariableLookup=Zt;let Ht=class{constructor(U,re){this.range=U,this.expression=re}};Ht=Ve([k],Ht),e.InlineValueEvaluatableExpression=Ht;let ut=class{constructor(U,re){this.frameId=U,this.stoppedLocation=re}};ut=Ve([k],ut),e.InlineValueContext=ut;var En;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(En=e.FileChangeType||(e.FileChangeType={}));let Rt=E=class extends Error{constructor(U,re=i.FileSystemProviderErrorCode.Unknown,Pe){super(D.URI.isUri(U)?U.toString(!0):U);this.code=Pe?.name??"Unknown",(0,i.markAsFileSystemProviderError)(this,re),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,E.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}static FileExists(U){return new E(U,i.FileSystemProviderErrorCode.FileExists,E.FileExists)}static FileNotFound(U){return new E(U,i.FileSystemProviderErrorCode.FileNotFound,E.FileNotFound)}static FileNotADirectory(U){return new E(U,i.FileSystemProviderErrorCode.FileNotADirectory,E.FileNotADirectory)}static FileIsADirectory(U){return new E(U,i.FileSystemProviderErrorCode.FileIsADirectory,E.FileIsADirectory)}static NoPermissions(U){return new E(U,i.FileSystemProviderErrorCode.NoPermissions,E.NoPermissions)}static Unavailable(U){return new E(U,i.FileSystemProviderErrorCode.Unavailable,E.Unavailable)}};Rt=E=Ve([k],Rt),e.FileSystemError=Rt;let xt=class{constructor(U,re,Pe){this.start=U,this.end=re,this.kind=Pe}};xt=Ve([k],xt),e.FoldingRange=xt;var un;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(un=e.FoldingRangeKind||(e.FoldingRangeKind={}));var _n;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(_n=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var dn;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(dn=e.CommentMode||(e.CommentMode={}));class Sn{constructor(U,re=[]){this.tokenTypes=U,this.tokenModifiers=re}}e.SemanticTokensLegend=Sn;function hn(H){return typeof H=="undefined"||(0,I.isStringArray)(H)}class Vt{constructor(U){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,U){this._hasLegend=!0;for(let re=0,Pe=U.tokenTypes.length;re<Pe;re++)this._tokenTypeStrToInt.set(U.tokenTypes[re],re);for(let re=0,Pe=U.tokenModifiers.length;re<Pe;re++)this._tokenModifierStrToInt.set(U.tokenModifiers[re],re)}}push(U,re,Pe,Je,it){if(typeof U=="number"&&typeof re=="number"&&typeof Pe=="number"&&typeof Je=="number"&&(typeof it=="number"||typeof it=="undefined"))return typeof it=="undefined"&&(it=0),this._pushEncoded(U,re,Pe,Je,it);if(Q.isRange(U)&&typeof re=="string"&&hn(Pe))return this._push(U,re,Pe);throw(0,L.illegalArgument)()}_push(U,re,Pe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(re))throw new Error("`tokenType` is not in the provided legend");const Je=U.start.line,it=U.start.character,rt=U.end.character-U.start.character,ot=this._tokenTypeStrToInt.get(re);let St=0;if(Pe)for(const It of Pe){if(!this._tokenModifierStrToInt.has(It))throw new Error("`tokenModifier` is not in the provided legend");const Ft=this._tokenModifierStrToInt.get(It);St|=1<<Ft>>>0}this._pushEncoded(Je,it,rt,ot,St)}_pushEncoded(U,re,Pe,Je,it){if(this._dataIsSortedAndDeltaEncoded&&(U<this._prevLine||U===this._prevLine&&re<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let It=0,Ft=0;for(let Ot=0;Ot<St;Ot++){let $t=this._data[5*Ot],ln=this._data[5*Ot+1];$t===0?($t=It,ln+=Ft):$t+=It,this._data[5*Ot]=$t,this._data[5*Ot+1]=ln,It=$t,Ft=ln}}let rt=U,ot=re;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(rt-=this._prevLine,rt===0&&(ot-=this._prevChar)),this._data[this._dataLen++]=rt,this._data[this._dataLen++]=ot,this._data[this._dataLen++]=Pe,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=it,this._prevLine=U,this._prevChar=re}static _sortAndDeltaEncode(U){let re=[];const Pe=U.length/5|0;for(let ot=0;ot<Pe;ot++)re[ot]=ot;re.sort((ot,St)=>{const It=U[5*ot],Ft=U[5*St];if(It===Ft){const Ot=U[5*ot+1],$t=U[5*St+1];return Ot-$t}return It-Ft});const Je=new Uint32Array(U.length);let it=0,rt=0;for(let ot=0;ot<Pe;ot++){const St=5*re[ot],It=U[St+0],Ft=U[St+1],Ot=U[St+2],$t=U[St+3],ln=U[St+4],Nn=It-it,jn=Nn===0?Ft-rt:Ft,cn=5*ot;Je[cn+0]=Nn,Je[cn+1]=jn,Je[cn+2]=Ot,Je[cn+3]=$t,Je[cn+4]=ln,it=It,rt=Ft}return Je}build(U){return this._dataIsSortedAndDeltaEncoded?new en(new Uint32Array(this._data),U):new en(Vt._sortAndDeltaEncode(this._data),U)}}e.SemanticTokensBuilder=Vt;class en{constructor(U,re){this.resultId=re,this.data=U}}e.SemanticTokens=en;class tn{constructor(U,re,Pe){this.start=U,this.deleteCount=re,this.data=Pe}}e.SemanticTokensEdit=tn;class nn{constructor(U,re){this.resultId=re,this.edits=U}}e.SemanticTokensEdits=nn;var yn;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(yn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Dn;(function(H){H[H.Initial=1]="Initial",H[H.Dynamic=2]="Dynamic"})(Dn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Lt=class{constructor(){}};Lt.Back={iconPath:new ft("arrow-left")},Lt=Ve([k],Lt),e.QuickInputButtons=Lt;var Cn;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(Cn=e.ExtensionKind||(e.ExtensionKind={}));class kn{constructor(U,re,Pe){this.badge=U,this.tooltip=re,this.color=Pe}static validate(U){if(U.badge&&U.badge.length!==1&&U.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=kn;let rn=class{constructor(U){this.kind=U}};rn=Ve([k],rn),e.ColorTheme=rn;var In;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast"})(In=e.ColorThemeKind||(e.ColorThemeKind={}));class Bt{constructor(U,re){if(U<0)throw(0,L.illegalArgument)("start must be positive");if(re<0)throw(0,L.illegalArgument)("end must be positive");U<=re?(this._start=U,this._end=re):(this._start=re,this._end=U)}static isNotebookRange(U){return U instanceof Bt?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(U){let re=this._start,Pe=this._end;return U.start!==void 0&&(re=U.start),U.end!==void 0&&(Pe=U.end),re===this._start&&Pe===this._end?this:new Bt(re,Pe)}}e.NotebookRange=Bt;class Mt{constructor(U,re,Pe,Je,it,rt,ot){this.kind=U,this.value=re,this.languageId=Pe,this.mime=Je,this.outputs=it??[],this.metadata=rt,this.executionSummary=ot,Mt.validate(this)}static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(re=>Mt.isNotebookCellData(re))}static isNotebookCellData(U){return!0}}e.NotebookCellData=Mt;class fn{constructor(U){this.cells=U}}e.NotebookData=fn;class Tt{constructor(U,re){this.data=U,this.mime=re;const Pe=(0,T.normalizeMimeType)(re,!0);if(!Pe)throw new Error("INVALID mime type, must not be empty or falsy: "+re);this.mime=Pe}static isNotebookCellOutputItem(U){return U instanceof Tt?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const re={name:U.name,message:U.message,stack:U.stack};return Tt.json(re,"application/vnd.code.notebook.error")}static stdout(U){return Tt.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return Tt.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,re="application/octet-stream"){return new Tt(U,re)}static text(U,re=T.Mimes.text){const Pe=Ue(Tt,a,"f",g).encode(String(U));return new Tt(Pe,re)}static json(U,re="application/json"){const Pe=JSON.stringify(U,void 0,"	");return Tt.text(Pe,re)}}e.NotebookCellOutputItem=Tt,a=Tt,g={value:new TextEncoder};class Oe{constructor(U,re,Pe){this.items=Oe.ensureUniqueMimeTypes(U,!0),typeof re=="string"?(this.id=re,this.metadata=Pe):(this.id=(0,A.generateUuid)(),this.metadata=re??Pe)}static isNotebookCellOutput(U){return U instanceof Oe?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&(0,I.isArray)(U.items)}static ensureUniqueMimeTypes(U,re=!1){const Pe=new Set,Je=new Set;for(let it=0;it<U.length;it++){const rt=U[it],ot=(0,T.normalizeMimeType)(rt.mime);if(!Pe.has(ot)){Pe.add(ot);continue}Je.add(it),re&&console.warn(`DUPLICATED mime type '${rt.mime}' will be dropped`)}return Je.size===0?U:U.filter((it,rt)=>!Je.has(rt))}}e.NotebookCellOutput=Oe;var sn;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(sn=e.NotebookCellKind||(e.NotebookCellKind={}));var mn;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(mn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var vt;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(vt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pn;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Pn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class An{constructor(U,re){this.text=U,this.alignment=re}}e.NotebookCellStatusBarItem=An;var gn;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(gn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class pn{constructor(U,re=[]){this.uri=U,this.provides=(0,p.asArray)(re)}}e.NotebookRendererScript=pn;let on=class{constructor(U,re){this.label=U,this.timestamp=re}};on=Ve([k],on),e.TimelineItem=on;var Tn;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(Tn=e.ExtensionMode||(e.ExtensionMode={}));var Rn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(Rn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ln;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=4]="RegEx"})(Ln=e.StandardTokenType||(e.StandardTokenType={}));class vn{constructor(U,re){this.ranges=U,this.wordPattern=re}}e.LinkedEditingRanges=vn;class Fn{constructor(U,re){this._port=U,this._autoForwardAction=re}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fn;var Mn;(function(H){H[H.Unset=0]="Unset",H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(Mn=e.TestResultState||(e.TestResultState={}));var wn;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information",H[H.Hint=3]="Hint"})(wn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var On;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(On=e.TestRunConfigurationGroup||(e.TestRunConfigurationGroup={}));let an=class{constructor(U,re,Pe){this.include=U,this.exclude=re,this.configuration=Pe}};an=Ve([k],an),e.TestRunRequest=an;let ne=y=class{constructor(U){this.message=U,this.severity=wn.Error}static diff(U,re,Pe){const Je=new y(U);return Je.expectedOutput=re,Je.actualOutput=Pe,Je}};ne=y=Ve([k],ne),e.TestMessage=ne;let ue=class{constructor(U,re){this.covered=U,this.total=re}};ue=Ve([k],ue),e.CoveredCount=ue;let Re=o=class{constructor(U,re,Pe,Je){this.uri=U,this.statementCoverage=re,this.branchCoverage=Pe,this.functionCoverage=Je}static fromDetails(U,re){const Pe=new ue(0,0),Je=new ue(0,0),it=new ue(0,0);for(const ot of re)if("branches"in ot){Pe.total+=1,Pe.covered+=ot.executionCount>0?1:0;for(const St of ot.branches)Je.total+=1,Je.covered+=St.executionCount>0?1:0}else it.total+=1,it.covered+=ot.executionCount>0?1:0;const rt=new o(U,Pe,Je.total>0?Je:void 0,it.total>0?it:void 0);return rt.detailedCoverage=re,rt}};Re=o=Ve([k],Re),e.FileCoverage=Re;let st=class{constructor(U,re,Pe=[]){this.executionCount=U,this.location=re,this.branches=Pe}};st=Ve([k],st),e.StatementCoverage=st;let bt=class{constructor(U,re){this.executionCount=U,this.location=re}};bt=Ve([k],bt),e.BranchCoverage=bt;let Dt=class{constructor(U,re){this.executionCount=U,this.location=re}};Dt=Ve([k],Dt),e.FunctionCoverage=Dt;var Wn;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(Wn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Hn;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(Hn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var zn;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(zn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Vn{constructor(U,re,Pe,Je,it,rt){this.kind=U,this.name=re,this.detail=Pe,this.uri=Je,this.range=it,this.selectionRange=rt}}e.TypeHierarchyItem=Vn}),define(me[120],ge([0,1,52,10,8,146,108,7,18]),function(J,e,p,L,C,S,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const A=new Map;function i(a,g){g?A.set(a,g):A.delete(a)}e.setWordDefinitionFor=i;function P(a){return A.get(a)}e.getWordDefinitionFor=P;class c extends S.MirrorTextModel{constructor(g,w,_,b,d,h,v,t){super(w,_,b,d);this._proxy=g,this._languageId=h,this._isDirty=v,this._notebook=t,this._isDisposed=!1}dispose(){(0,p.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(g){return(0,D.equals)(this._lines,g)}get document(){if(!this._document){const g=this;this._document={get uri(){return g._uri},get fileName(){return g._uri.fsPath},get isUntitled(){return g._uri.scheme===L.Schemas.untitled},get languageId(){return g._languageId},get version(){return g._versionId},get isClosed(){return g._isDisposed},get isDirty(){return g._isDirty},get notebook(){return g._notebook},save(){return g._save()},getText(w){return w?g._getTextInRange(w):g.getText()},get eol(){return g._eol===`
`?I.EndOfLine.LF:I.EndOfLine.CRLF},get lineCount(){return g._lines.length},lineAt(w){return g._lineAt(w)},offsetAt(w){return g._offsetAt(w)},positionAt(w){return g._positionAt(w)},validateRange(w){return g._validateRange(w)},validatePosition(w){return g._validatePosition(w)},getWordRangeAtPosition(w,_){return g._getWordRangeAtPosition(w,_)}}}return Object.freeze(this._document)}_acceptLanguageId(g){(0,p.ok)(!this._isDisposed),this._languageId=g}_acceptIsDirty(g){(0,p.ok)(!this._isDisposed),this._isDirty=g}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(g){const w=this._validateRange(g);if(w.isEmpty)return"";if(w.isSingleLine)return this._lines[w.start.line].substring(w.start.character,w.end.character);const _=this._eol,b=w.start.line,d=w.end.line,h=[];h.push(this._lines[b].substring(w.start.character));for(let v=b+1;v<d;v++)h.push(this._lines[v]);return h.push(this._lines[d].substring(0,w.end.character)),h.join(_)}_lineAt(g){let w;if(g instanceof I.Position?w=g.line:typeof g=="number"&&(w=g),typeof w!="number"||w<0||w>=this._lines.length||Math.floor(w)!==w)throw new Error("Illegal value for `line`");return new u(w,this._lines[w],w===this._lines.length-1)}_offsetAt(g){return g=this._validatePosition(g),this._ensureLineStarts(),this._lineStarts.getPrefixSum(g.line-1)+g.character}_positionAt(g){g=Math.floor(g),g=Math.max(0,g),this._ensureLineStarts();const w=this._lineStarts.getIndexOf(g),_=this._lines[w.index].length;return new I.Position(w.index,Math.min(w.remainder,_))}_validateRange(g){if(!(g instanceof I.Range))throw new Error("Invalid argument");const w=this._validatePosition(g.start),_=this._validatePosition(g.end);return w===g.start&&_===g.end?g:new I.Range(w.line,w.character,_.line,_.character)}_validatePosition(g){if(!(g instanceof I.Position))throw new Error("Invalid argument");if(this._lines.length===0)return g.with(0,0);let{line:w,character:_}=g,b=!1;if(w<0)w=0,_=0,b=!0;else if(w>=this._lines.length)w=this._lines.length-1,_=this._lines[w].length,b=!0;else{const d=this._lines[w].length;_<0?(_=0,b=!0):_>d&&(_=d,b=!0)}return b?new I.Position(w,_):g}_getWordRangeAtPosition(g,w){const _=this._validatePosition(g);if(!w)w=P(this._languageId);else if((0,C.regExpLeadsToEndlessLoop)(w))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${w.source}' because it matches the empty string.`);const b=(0,T.getWordAtText)(_.character+1,(0,T.ensureValidWordDefinition)(w),this._lines[_.line],0);if(b)return new I.Range(_.line,b.startColumn-1,_.line,b.endColumn-1)}}e.ExtHostDocumentData=c;class u{constructor(g,w,_){this._line=g,this._text=w,this._isLastLine=_}get lineNumber(){return this._line}get text(){return this._text}get range(){return new I.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new I.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=u}),define(me[199],ge([0,1,7,3,110,6,77,23,2,32]),function(J,e,p,L,C,S,T,I,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(c,u,a,g){this._notebook=a,this._selector=g,this._disposables=new S.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,A.generateUuid)()}),this._init(),this._disposables.add(u.onDidChangeDocument(_=>{const b=this._cellUris.get(_.document.uri);b!==void 0&&(this._cellLengths.changeValue(b,this._cells[b].document.getText().length+1),this._cellLines.changeValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const w=_=>{_===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(c.onDidChangeNotebookCells(_=>w(_.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new I.ResourceMap;const c=[],u=[];for(const a of this._notebook.getCells())a.kind===p.NotebookCellKind.Code&&(!this._selector||(0,T.score)(this._selector,a.document.uri,a.document.languageId,!0))&&(this._cellUris.set(a.document.uri,this._cells.length),this._cells.push(a),c.push(a.document.getText().length+1),u.push(a.document.lineCount));this._cellLengths=new C.PrefixSumComputer(new Uint32Array(c)),this._cellLines=new C.PrefixSumComputer(new Uint32Array(u))}get version(){return this._versionId}getText(c){if(!c){let b="";for(const d of this._cells)b+=d.document.getText()+`
`;return b=b.slice(0,-1),b}if(c.isEmpty)return"";const u=this.locationAt(c.start),a=this.locationAt(c.end),g=this._cellUris.get(u.uri),w=this._cellUris.get(a.uri);if(g===void 0||w===void 0)return"";if(g===w)return this._cells[g].document.getText(new p.Range(u.range.start,a.range.end));const _=[this._cells[g].document.getText(new p.Range(u.range.start,new p.Position(this._cells[g].document.lineCount,0)))];for(let b=g+1;b<w;b++)_.push(this._cells[b].document.getText());return _.push(this._cells[w].document.getText(new p.Range(new p.Position(0,0),a.range.end))),_.join(`
`)}offsetAt(c){const u=this._cellLines.getIndexOf(c.line),a=this._cellLengths.getPrefixSum(u.index-1),g=this._cells[u.index].document.offsetAt(c.with(u.remainder));return a+g}positionAt(c){if(typeof c=="number"){const a=this._cellLengths.getIndexOf(c),g=this._cellLines.getPrefixSum(a.index-1);return this._cells[a.index].document.positionAt(a.remainder).translate(g)}const u=this._cellUris.get(c.uri);if(u!==void 0){const a=this._cellLines.getPrefixSum(u-1);return new p.Position(a+c.range.start.line,c.range.start.character)}return new p.Position(0,0)}locationAt(c){p.Range.isRange(c)||(c=new p.Range(c,c));const u=this._cellLines.getIndexOf(c.start.line);let a=u;c.isEmpty||(a=this._cellLines.getIndexOf(c.end.line));const g=new p.Position(u.remainder,c.start.character),w=new p.Position(a.remainder,c.end.character),_=new p.Range(g,w),b=this._cells[u.index];return new p.Location(b.document.uri,b.document.validateRange(_))}contains(c){return this._cellUris.has(c)}validateRange(c){const u=this.validatePosition(c.start),a=this.validatePosition(c.end);return c.with(u,a)}validatePosition(c){const u=this._cellLines.getIndexOf(c.line),a=new p.Position(u.remainder,c.character),g=this._cells[u.index].document.validatePosition(a),w=this._cellLines.getPrefixSum(u.index-1);return new p.Position(w+g.line,g.character)}}e.ExtHostNotebookConcatDocument=i}),define(me[200],ge([0,1,7,13,3]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let S=class{constructor(I){this._actual=new p.ColorTheme(p.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new C.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(I){let D=I==="light"?p.ColorThemeKind.Light:I==="dark"?p.ColorThemeKind.Dark:p.ColorThemeKind.HighContrast;this._actual=new p.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};S=Ve([He(0,L.IExtHostRpcService)],S),e.ExtHostTheming=S}),define(me[60],ge([0,1,4]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,p.createDecorator)("IURITransformerService");class L{constructor(S){S?(this.transformIncoming=S.transformIncoming.bind(S),this.transformOutgoing=S.transformOutgoing.bind(S),this.transformOutgoingURI=S.transformOutgoingURI.bind(S),this.transformOutgoingScheme=S.transformOutgoingScheme.bind(S)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=L}),define(me[201],ge([0,1,22]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(D){let A=this.buffers.indexOf(D);return A<0&&(A=this.buffers.length,this.buffers.push(D)),A}}function C(I,D){if(D.serializeBuffersForPostMessage){const A=new L,i=(u,a)=>{if(a instanceof ArrayBuffer){const g=A.add(a);return{$$vscode_array_buffer_reference$$:!0,index:g}}else if(ArrayBuffer.isView(a)){const g=S(a);if(g){const w=A.add(a.buffer);return{$$vscode_array_buffer_reference$$:!0,index:w,view:{type:g,byteLength:a.byteLength,byteOffset:a.byteOffset}}}}return a},P=JSON.stringify(I,i),c=A.buffers.map(u=>{const a=new Uint8Array(u);return p.VSBuffer.wrap(a)});return{message:P,buffers:c}}else return{message:JSON.stringify(I),buffers:[]}}e.serializeWebviewMessage=C;function S(I){switch(I.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(I,D){const A=D.map(c=>{const u=new ArrayBuffer(c.byteLength);return new Uint8Array(u).set(c.buffer),u}),i=D.length?(c,u)=>{if(typeof u=="object"&&u.$$vscode_array_buffer_reference$$){const a=u,{index:g}=a,w=A[g];if(a.view)switch(a.view.type){case 1:return new Int8Array(w,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(w,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(w,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(w,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(w,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(w,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(w,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(w,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(w,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(w,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(w,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return w}return u}:void 0;return{message:JSON.parse(I,i),arrayBuffers:A}}e.deserializeWebviewMessage=T}),define(me[86],ge([0,1,10,2]),function(J,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function C(S,T){return S.scheme===p.Schemas.http||S.scheme===p.Schemas.https?S:(T&&T.authority&&T.isRemote&&S.scheme===p.Schemas.file&&(S=L.URI.from({scheme:p.Schemas.vscodeRemote,authority:T.authority,path:S.path})),L.URI.from({scheme:p.Schemas.https,authority:`${S.scheme}+${S.authority}.${e.webviewRootResourceAuthority}`,path:S.path,fragment:S.fragment,query:S.query}))}e.asWebviewUri=C}),define(me[202],ge([0,1,3,6,86]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class S{constructor(I,D,A){this._proxy=I,this._editors=D,this._initData=A,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const i=D.getVisibleTextEditors();for(const P of this._insets.values())i.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this._insets.forEach(I=>I.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(I,D,A,i,P){let c;for(const d of this._editors.getVisibleTextEditors(!0))if(d.value===I){c=d;break}if(!c)throw new Error("not a visible editor");const u=this,a=this._handlePool++,g=new p.Emitter,w=new p.Emitter,_=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(d){return(0,C.asWebviewUri)(d,u._initData.remote)}get cspSource(){return C.webviewGenericCspSource}set options(d){this._options=d,u._proxy.$setOptions(a,d)}get options(){return this._options}set html(d){this._html=d,u._proxy.$setHtml(a,d)}get html(){return this._html}get onDidReceiveMessage(){return g.event}postMessage(d){return u._proxy.$postMessage(a,d)}},b=new class{constructor(){this.editor=I,this.line=D,this.height=A,this.webview=_,this.onDidDispose=w.event}dispose(){u._insets.has(a)&&(u._insets.delete(a),u._proxy.$disposeEditorInset(a),w.fire(),w.dispose(),g.dispose())}};return this._proxy.$createEditorInset(a,c.id,c.value.document.uri,D+1,A,i||{},P.identifier,P.extensionLocation),this._insets.set(a,{editor:I,inset:b,onDidReceiveMessage:g}),b}$onDidDispose(I){const D=this._insets.get(I);D&&D.inset.dispose()}$onDidReceiveMessage(I,D){const A=this._insets.get(I);A&&A.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=S}),define(me[203],ge([0,1,167,14,2,6,4,80,42,18,10]),function(J,e,p,L,C,S,T,I,D,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,p.localize)(0,null),providerDisplayName:(0,p.localize)(1,null)},e.ActiveEditorDirtyContext=new I.RawContextKey("activeEditorIsDirty",!1,(0,p.localize)(2,null)),e.ActiveEditorPinnedContext=new I.RawContextKey("activeEditorIsNotPreview",!1,(0,p.localize)(3,null)),e.ActiveEditorStickyContext=new I.RawContextKey("activeEditorIsPinned",!1,(0,p.localize)(4,null)),e.ActiveEditorReadonlyContext=new I.RawContextKey("activeEditorIsReadonly",!1,(0,p.localize)(5,null)),e.ActiveEditorCanRevertContext=new I.RawContextKey("activeEditorCanRevert",!1,(0,p.localize)(6,null)),e.ActiveEditorContext=new I.RawContextKey("activeEditor",null,{type:"string",description:(0,p.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new I.RawContextKey("activeEditorAvailableEditorIds","",(0,p.localize)(8,null)),e.TextCompareEditorVisibleContext=new I.RawContextKey("textCompareEditorVisible",!1,(0,p.localize)(9,null)),e.TextCompareEditorActiveContext=new I.RawContextKey("textCompareEditorActive",!1,(0,p.localize)(10,null)),e.EditorGroupEditorsCountContext=new I.RawContextKey("groupEditorsCount",0,(0,p.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new I.RawContextKey("activeEditorGroupEmpty",!1,(0,p.localize)(12,null)),e.ActiveEditorGroupIndexContext=new I.RawContextKey("activeEditorGroupIndex",0,(0,p.localize)(13,null)),e.ActiveEditorGroupLastContext=new I.RawContextKey("activeEditorGroupLast",!1,(0,p.localize)(14,null)),e.MultipleEditorGroupsContext=new I.RawContextKey("multipleEditorGroups",!1,(0,p.localize)(15,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new I.RawContextKey("editorIsOpen",!1,(0,p.localize)(16,null)),e.InEditorZenModeContext=new I.RawContextKey("inZenMode",!1,(0,p.localize)(17,null)),e.IsCenteredLayoutContext=new I.RawContextKey("isCenteredLayout",!1,(0,p.localize)(18,null)),e.SplitEditorsVertically=new I.RawContextKey("splitEditorsVertically",!1,(0,p.localize)(19,null)),e.EditorAreaVisibleContext=new I.RawContextKey("editorAreaVisible",!0,(0,p.localize)(20,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function P(o){return typeof o?.getViewState=="function"}e.isTextEditorPane=P;function c(o){if(d(o))return!1;const k=o;return C.URI.isUri(k?.resource)}e.isResourceEditorInput=c;function u(o){if(d(o))return!1;const k=o;return k?.original!==void 0&&k.modified!==void 0}e.isResourceDiffEditorInput=u;function a(o){if(d(o))return!1;const k=o;return k?k?.resource===void 0||k.resource.scheme===i.Schemas.untitled||k.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=a;var g;(function(o){o[o.SHORT=0]="SHORT",o[o.MEDIUM=1]="MEDIUM",o[o.LONG=2]="LONG"})(g=e.Verbosity||(e.Verbosity={}));var w;(function(o){o[o.EXPLICIT=1]="EXPLICIT",o[o.AUTO=2]="AUTO",o[o.FOCUS_CHANGE=3]="FOCUS_CHANGE",o[o.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(w=e.SaveReason||(e.SaveReason={}));var _;(function(o){o[o.None=0]="None",o[o.Readonly=2]="Readonly",o[o.Untitled=4]="Untitled",o[o.Singleton=8]="Singleton",o[o.RequiresTrust=16]="RequiresTrust"})(_=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class b extends S.Disposable{}e.AbstractEditorInput=b;function d(o){return o instanceof b}e.isEditorInput=d;function h(o){const k=o;return C.URI.isUri(k?.preferredResource)}function v(o){const k=o;return d(k?.primary)&&d(k?.secondary)}e.isSideBySideEditorInput=v;function t(o){return d(o?.editor)}e.isEditorInputWithOptions=t;function s(o){const k=o;return t(o)&&k?.group!==void 0}e.isEditorInputWithOptionsAndGroup=s;function r(o){const k=o;return typeof k?.groupId=="number"&&d(k.editor)}e.isEditorIdentifier=r;var n;(function(o){o[o.PRIMARY=1]="PRIMARY",o[o.SECONDARY=2]="SECONDARY",o[o.BOTH=3]="BOTH"})(n=e.SideBySideEditor||(e.SideBySideEditor={}));class l{getOriginalUri(k,F){if(!k)return;const $=v(k)?k.primary:u(k)?k.modified:void 0,Q=v(k)?k.secondary:u(k)?k.original:void 0;if(F?.supportSideBySide&&$&&Q){if(F?.supportSideBySide===n.BOTH)return{primary:this.getOriginalUri($,{filterByScheme:F.filterByScheme}),secondary:this.getOriginalUri(Q,{filterByScheme:F.filterByScheme})};k=F.supportSideBySide===n.PRIMARY?$:Q}if(u(k))return;const oe=h(k)?k.preferredResource:k.resource;return!oe||!F||!F.filterByScheme?oe:this.filterUri(oe,F.filterByScheme)}getCanonicalUri(k,F){if(!k)return;const $=v(k)?k.primary:u(k)?k.modified:void 0,Q=v(k)?k.secondary:u(k)?k.original:void 0;if(F?.supportSideBySide&&$&&Q){if(F?.supportSideBySide===n.BOTH)return{primary:this.getCanonicalUri($,{filterByScheme:F.filterByScheme}),secondary:this.getCanonicalUri(Q,{filterByScheme:F.filterByScheme})};k=F.supportSideBySide===n.PRIMARY?$:Q}if(u(k))return;const oe=k.resource;return!oe||!F||!F.filterByScheme?oe:this.filterUri(oe,F.filterByScheme)}filterUri(k,F){if(Array.isArray(F)){if(F.some($=>k.scheme===$))return k}else if(F===k.scheme)return k}}e.EditorResourceAccessor=new l;var f;(function(o){o[o.LEFT=0]="LEFT",o[o.RIGHT=1]="RIGHT"})(f=e.CloseDirection||(e.CloseDirection={}));class m{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(k){const F=this.instantiationService=k.get(T.IInstantiationService);for(const[$,Q]of this.editorSerializerConstructors)this.createEditorSerializer($,Q,F);this.editorSerializerConstructors.clear()}createEditorSerializer(k,F,$){const Q=$.createInstance(F);this.editorSerializerInstances.set(k,Q)}registerFileEditorFactory(k){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=k}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(k,F){if(this.editorSerializerConstructors.has(k)||this.editorSerializerInstances.has(k))throw new Error(`A editor serializer with type ID '${k}' was already registered.`);return this.instantiationService?this.createEditorSerializer(k,F,this.instantiationService):this.editorSerializerConstructors.set(k,F),(0,S.toDisposable)(()=>{this.editorSerializerConstructors.delete(k),this.editorSerializerInstances.delete(k)})}getEditorSerializer(k){return this.editorSerializerInstances.get(typeof k=="string"?k:k.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new m);async function E(o,k){if(!o||!o.length)return[];const F=await Promise.all(o.map(async $=>{const Q=C.URI.revive($.fileUri);if(!Q||(await k.activateProvider(Q.scheme),!k.canHandleResource(Q)))return;const oe=typeof $.exists=="boolean"?$.exists:await k.exists(Q);if(!oe&&$.openOnlyIfExists)return;const j=oe&&typeof $.lineNumber=="number"?{selection:{startLineNumber:$.lineNumber,startColumn:$.columnNumber||1},pinned:!0,override:$.editorOverrideId}:{pinned:!0,override:$.editorOverrideId};let O;return oe?O={resource:Q,options:j,forceFile:!0}:O={resource:Q,options:j,forceUntitled:!0},O}));return(0,A.coalesce)(F)}e.pathsToEditors=E;var y;(function(o){o[o.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",o[o.SEQUENTIAL=1]="SEQUENTIAL"})(y=e.EditorsOrder||(e.EditorsOrder={}))}),define(me[121],ge([0,1,3,17,168]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class S{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new p.Emitter,this._onExit=new p.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(I){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=I}onEvent(I){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=I}onRequest(I){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=I}sendResponse(I){I.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${I.command}`)):this.internalSend("response",I)}sendRequest(I,D,A,i){const P={command:I};if(D&&Object.keys(D).length>0&&(P.arguments=D),this.internalSend("request",P),typeof i=="number"){const c=setTimeout(()=>{clearTimeout(c);const u=this.pendingRequests.get(P.seq);if(u){this.pendingRequests.delete(P.seq);const a={type:"response",seq:0,request_seq:P.seq,success:!1,command:I,message:(0,C.localize)(0,null,i,I)};u(a)}},i)}return A&&this.pendingRequests.set(P.seq,A),P.seq}acceptMessage(I){this.messageCallback?this.messageCallback(I):(this.queue.push(I),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(I,D){return I.type!=="event"||D.type!=="event"}async processQueue(){let I;for(;this.queue.length;){if((!I||this.needsTaskBoundaryBetween(this.queue[0],I))&&await(0,L.timeout)(0),I=this.queue.shift(),!I)return;switch(I.type){case"event":this.eventCallback&&this.eventCallback(I);break;case"request":this.requestCallback&&this.requestCallback(I);break;case"response":const D=I,A=this.pendingRequests.get(D.request_seq);A&&(this.pendingRequests.delete(D.request_seq),A(D));break}}}internalSend(I,D){D.type=I,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const I=new Map;this.pendingRequests.forEach((D,A)=>I.set(A,D)),await(0,L.timeout)(500),I.forEach((D,A)=>{D({type:"response",seq:0,request_seq:A,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(A)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=S}),define(me[204],ge([0,1,8,2,9,25,10]),function(J,e,p,L,C,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const I=/{([^}]+)}/g;function D(s,r,n){return s.replace(I,function(l,f){return r&&f.length>0&&f[0]!=="_"?l:n&&n.hasOwnProperty(f)?n[f]:l})}e.formatPII=D;function A(s){const r={};for(const n of Object.keys(s))n.startsWith("!")||(r[n]=s[n]);return r}e.filterExceptionsFromTelemetry=A;function i(s){return s.configuration.request==="attach"&&!P(s)&&(!s.parentSession||i(s.parentSession))}e.isSessionAttach=i;function P(s){let r=s.configuration.type;if(!!r)return r==="vslsShare"&&(r=s.configuration.adapterProxy.configuration.type),(0,p.equalsIgnoreCase)(r,"extensionhost")||(0,p.equalsIgnoreCase)(r,"pwa-extensionhost")?s:s.parentSession?P(s.parentSession):void 0}e.getExtensionHostDebugSession=P;function c(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=c;function u(s,r,n){let l,f=0,m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,E=null;for(;E=m.exec(s);){let y=E.index+1,o=y+E[0].length;if(y<=r&&o>=n){l=E[0],f=y;break}}if(l){let y=/\w+/g,o=null;for(;(o=y.exec(l))&&!(o.index+1+f+o[0].length>=n););o&&(l=l.substring(0,y.lastIndex))}return l?{start:f,end:f+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=u;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function g(s){return!!(s&&s.match(a))}e.isUri=g;function w(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(g(s.path))return L.URI.parse(s.path);if((0,C.isAbsolute)(s.path))return L.URI.file(s.path)}return s.path}function _(s){if(typeof s.path=="object"){const r=L.URI.revive(s.path);if(r)return r.scheme===T.Schemas.file?r.fsPath:r.toString()}return s.path}function b(s,r){const n=r?w:_,l=(0,S.deepClone)(s);return h(l,(f,m)=>{f&&m&&(m.path=n(m))}),l}e.convertToDAPaths=b;function d(s,r){const n=r?w:_,l=(0,S.deepClone)(s);return h(l,(f,m)=>{!f&&m&&(m.path=n(m))}),l}e.convertToVSCPaths=d;function h(s,r){switch(s.type){case"event":const n=s;switch(n.event){case"output":r(!1,n.body.source);break;case"loadedSource":r(!1,n.body.source);break;case"breakpoint":r(!1,n.body.breakpoint.source);break;default:break}break;case"request":const l=s;switch(l.command){case"setBreakpoints":r(!0,l.arguments.source);break;case"breakpointLocations":r(!0,l.arguments.source);break;case"source":r(!0,l.arguments.source);break;case"gotoTargets":r(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(m=>r(!1,m));break;default:break}break;case"response":const f=s;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(m=>r(!1,m.source));break;case"loadedSources":f.body.sources.forEach(m=>r(!1,m));break;case"scopes":f.body.scopes.forEach(m=>r(!1,m.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(m=>r(!1,m.source));break;case"setBreakpoints":f.body.breakpoints.forEach(m=>r(!1,m.source));break;default:break}break}}function v(s){return s.filter(r=>!r.presentation?.hidden).sort((r,n)=>r.presentation?n.presentation?r.presentation.group?n.presentation.group?r.presentation.group!==n.presentation.group?r.presentation.group.localeCompare(n.presentation.group):t(r.presentation.order,n.presentation.order):-1:n.presentation.group?1:t(r.presentation.order,n.presentation.order):-1:n.presentation?1:0)}e.getVisibleAndSorted=v;function t(s,r){return typeof s!="number"?typeof r!="number"?0:1:typeof r!="number"?-1:s-r}}),define(me[205],ge([0,1,28,38,169,122,9,8,25,11,179,121]),function(J,e,p,L,C,S,T,I,D,A,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class c extends P.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(b,d){this.outputStream=d,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,b.on("data",h=>this.handleData(h))}sendMessage(b){if(this.outputStream){const d=JSON.stringify(b);this.outputStream.write(`Content-Length: ${Buffer.byteLength(d,"utf8")}${c.TWO_CRLF}${d}`,"utf8")}}handleData(b){for(this.rawData=Buffer.concat([this.rawData,b]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const d=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,d.length>0)try{this.acceptMessage(JSON.parse(d))}catch(h){this._onError.fire(new Error((h.message||h)+`
`+d))}continue}}else{const d=this.rawData.indexOf(c.TWO_CRLF);if(d!==-1){const v=this.rawData.toString("utf8",0,d).split(c.HEADER_LINESEPARATOR);for(const t of v){const s=t.split(c.HEADER_FIELDSEPARATOR);s[0]==="Content-Length"&&(this.contentLength=Number(s[1]))}this.rawData=this.rawData.slice(d+c.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=c,c.TWO_CRLF=`\r
\r
`,c.HEADER_LINESEPARATOR=/\r?\n/,c.HEADER_FIELDSEPARATOR=/: */;class u extends c{startSession(){return new Promise((b,d)=>{let h=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),b(),h=!0}),this.socket.on("close",()=>{h?this._onError.fire(new Error("connection closed")):d(new Error("connection closed"))}),this.socket.on("error",v=>{h?this._onError.fire(v):d(v)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=u;class a extends u{constructor(b){super();this.adapterServer=b}createConnection(b){return S.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",b)}}e.SocketDebugAdapter=a;class g extends u{constructor(b){super();this.adapterServer=b}createConnection(b){return S.createConnection(this.adapterServer.path,b)}}e.NamedPipeDebugAdapter=g;class w extends c{constructor(b,d,h){super();this.adapterExecutable=b,this.debugType=d,this.outputService=h}async startSession(){const b=this.adapterExecutable.command,d=this.adapterExecutable.args,h=this.adapterExecutable.options||{};try{if(b)if(T.isAbsolute(b)){if(!await p.Promises.exists(b))throw new Error(C.localize(0,null,b))}else b.indexOf("/")<0&&b.indexOf("\\")<0;else throw new Error(C.localize(1,null,this.debugType));let v=process.env;if(h.env&&Object.keys(h.env).length>0&&(v=D.mixin(D.deepClone(process.env),h.env)),b==="node")if(Array.isArray(d)&&d.length>0){const s=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:v,execArgv:s?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};h.cwd&&(r.cwd=h.cwd);const n=L.fork(d[0],d.slice(1),r);if(!n.pid)throw new Error(C.localize(2,null,d[0]));this.serverProcess=n}else throw new Error(C.localize(3,null));else{const s={env:v};h.cwd&&(s.cwd=h.cwd),this.serverProcess=L.spawn(b,d,s)}this.serverProcess.on("error",s=>{this._onError.fire(s)}),this.serverProcess.on("exit",(s,r)=>{this._onExit.fire(s)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",s=>{this._onError.fire(s)}),this.serverProcess.stdin.on("error",s=>{this._onError.fire(s)});const t=this.outputService;if(t){const s=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{const n=t.getChannel(i.ExtensionsChannelId);n&&n.append(s(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(v){this._onError.fire(v)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),A.isWindows?new Promise((b,d)=>{const h=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(v,t,s){if(v)return d(v)});h.on("exit",b),h.on("error",d)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(b,d){if(!b)return;const h=Object.create(null);b.runtime&&(b.runtime.indexOf("./")===0?h.runtime=T.join(d,b.runtime):h.runtime=b.runtime),b.runtimeArgs&&(h.runtimeArgs=b.runtimeArgs),b.program&&(T.isAbsolute(b.program)?h.program=b.program:h.program=T.join(d,b.program)),b.args&&(h.args=b.args);const v=b;return v.win&&(h.win=w.extract(v.win,d)),v.winx86&&(h.winx86=w.extract(v.winx86,d)),v.windows&&(h.windows=w.extract(v.windows,d)),v.osx&&(h.osx=w.extract(v.osx,d)),v.linux&&(h.linux=w.extract(v.linux,d)),h}static platformAdapterExecutable(b,d){let h=Object.create(null);d=d.toLowerCase();for(const l of b)if(l.contributes){const f=l.contributes.debuggers;f&&f.length>0&&f.filter(m=>typeof m.type=="string"&&I.equalsIgnoreCase(m.type,d)).forEach(m=>{const E=w.extract(m,l.extensionLocation.fsPath);h=D.mixin(h,E,l.isBuiltin)})}let v;A.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?v=h.winx86||h.win||h.windows:A.isWindows?v=h.win||h.windows:A.isMacintosh?v=h.osx:A.isLinux&&(v=h.linux),v=v||h;let t=v.program||h.program;const s=v.args||h.args;let r=v.runtime||h.runtime;const n=v.runtimeArgs||h.runtimeArgs;if(r)return{type:"executable",command:r,args:(n||[]).concat(typeof t=="string"?[t]:[]).concat(s||[])};if(t)return{type:"executable",command:t,args:s||[]}}}e.ExecutableDebugAdapter=w}),define(me[206],ge([0,1,38,11,29,182]),function(J,e,p,L,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function T(c,u){return new Promise((a,g)=>{let w="";const _=p.spawn(c,u);_.pid&&_.stdout.on("data",b=>{w+=b.toString()}),_.on("error",b=>{g(b)}),_.on("close",b=>{a(w)})})}let I;function D(c,u){if(!I)if(L.isWindows)I=new S.WindowsExternalTerminalService;else if(L.isMacintosh)I=new S.MacExternalTerminalService;else if(L.isLinux)I=new S.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const a=u.getConfiguration("terminal");return I.runInTerminal(c.title,c.cwd,c.args,c.env||{},a.external||{})}e.runInExternalTerminal=D;function A(c){return c?L.isWindows?new Promise(async u=>{(await new Promise((g,w)=>{J(["windows-process-tree"],g,w)})).getProcessTree(c,g=>{u(g.children.length>0)})}):T("/usr/bin/pgrep",["-lP",String(c)]).then(u=>{const a=u.trim();return!(a.length===0||a.indexOf(" tmux")>=0)},u=>!0):Promise.resolve(!0)}e.hasChildProcesses=A;var i;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(i||(i={}));function P(c,u,a,g){c=c.trim().toLowerCase();let w;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?w=1:c.indexOf("cmd.exe")>=0?w=0:c.indexOf("bash")>=0?w=2:L.isWindows?w=0:w=2;let _,b=" ";switch(w){case 1:if(_=h=>(h=h.replace(/\'/g,"''"),h.length>0&&h.charAt(h.length-1)==="\\"?`'${h}\\'`:`'${h}'`),a){const h=(0,C.getDriveLetter)(a);h&&(b+=`${h}:; `),b+=`cd ${_(a)}; `}if(g)for(let h in g){const v=g[h];v===null?b+=`Remove-Item env:${h}; `:b+=`\${env:${h}}='${v}'; `}if(u.length>0){const h=_(u.shift());b+=h[0]==="'"?`& ${h} `:`${h} `;for(let v of u)b+=`${_(v)} `}break;case 0:if(_=h=>(h=h.replace(/\"/g,'""'),h.indexOf(" ")>=0||h.indexOf('"')>=0||h.length===0?`"${h}"`:h),a){const h=(0,C.getDriveLetter)(a);h&&(b+=`${h}: && `),b+=`cd ${_(a)} && `}if(g){b+='cmd /C "';for(let h in g){let v=g[h];v===null?b+=`set "${h}=" && `:(v=v.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),b+=`set "${h}=${v}" && `)}}for(let h of u)b+=`${_(h)} `;g&&(b+='"');break;case 2:_=h=>(h=h.replace(/(["'\\\$])/g,"\\$1"),h.indexOf(" ")>=0||h.indexOf(";")>=0||h.length===0?`"${h}"`:h);const d=h=>/[^\w@%\/+=,.:^-]/.test(h)?`'${h.replace(/'/g,"'\\''")}'`:h;if(a&&(b+=`cd ${_(a)} ; `),g){b+="/usr/bin/env";for(let h in g){const v=g[h];v===null?b+=` -u ${d(h)}`:b+=` ${d(`${h}=${v}`)}`}b+=" "}for(let h of u)b+=`${_(h)} `;break}return b}e.prepareCommand=P}),define(me[87],ge([0,1,30,99,10,9,11,80]),function(J,e,p,L,C,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var D;(function(o){o[o.Markup=1]="Markup",o[o.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var A;(function(o){o[o.Running=1]="Running",o[o.Idle=2]="Idle"})(A=e.NotebookRunState||(e.NotebookRunState={}));var i;(function(o){o[o.Pending=2]="Pending",o[o.Executing=3]="Executing"})(i=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var P;(function(o){o[o.WithHardKernelDependency=0]="WithHardKernelDependency",o[o.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",o[o.Pure=2]="Pure",o[o.Never=3]="Never"})(P=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var c;(function(o){o.Always="always",o.Never="never",o.Optional="optional"})(c=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var u;(function(o){o[o.ModelChange=1]="ModelChange",o[o.Move=2]="Move",o[o.ChangeLanguage=5]="ChangeLanguage",o[o.Initialize=6]="Initialize",o[o.ChangeCellMetadata=7]="ChangeCellMetadata",o[o.Output=8]="Output",o[o.OutputItem=9]="OutputItem",o[o.ChangeCellContent=10]="ChangeCellContent",o[o.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",o[o.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",o[o.ChangeCellMime=13]="ChangeCellMime",o[o.Unknown=100]="Unknown"})(u=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var a;(function(o){o[o.Handle=0]="Handle",o[o.Index=1]="Index"})(a=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(o){o[o.Replace=1]="Replace",o[o.Output=2]="Output",o[o.Metadata=3]="Metadata",o[o.CellLanguage=4]="CellLanguage",o[o.DocumentMetadata=5]="DocumentMetadata",o[o.Move=6]="Move",o[o.OutputItems=7]="OutputItems",o[o.PartialMetadata=8]="PartialMetadata",o[o.PartialInternalMetadata=9]="PartialInternalMetadata"})(g=e.CellEditType||(e.CellEditType={}));var w;(function(o){o.scheme=C.Schemas.vscodeNotebookCell;const k=/^ch(\d{7,})/;function F(O,B){return O.with({scheme:o.scheme,fragment:`ch${B.toString().padStart(7,"0")}${O.scheme!==C.Schemas.file?O.scheme:""}`})}o.generate=F;function $(O){if(O.scheme!==o.scheme)return;const B=k.exec(O.fragment);return B?{handle:Number(B[1]),notebook:O.with({scheme:O.fragment.substr(B[0].length)||C.Schemas.file,fragment:null})}:void 0}o.parse=$;function Q(O){if(O.scheme!==C.Schemas.vscodeNotebookCellMetadata)return;const B=k.exec(O.fragment);return B?{handle:Number(B[1]),notebook:O.with({scheme:O.fragment.substr(B[0].length)||C.Schemas.file,fragment:null})}:void 0}o.parseCellMetadataUri=Q;function oe(O,B,R){return O.with({scheme:R,fragment:`ch${B.toString().padStart(7,"0")}${O.scheme!==C.Schemas.file?O.scheme:""}`})}o.generateCellUri=oe;function j(O,B){if(O.scheme!==B)return;const R=k.exec(O.fragment);return R?{handle:Number(R[1]),notebook:O.with({scheme:O.fragment.substr(R[0].length)||C.Schemas.file,fragment:null})}:void 0}o.parseCellUri=j})(w=e.CellUri||(e.CellUri={}));const _=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function b(o){return _.get(o)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=b;function d(o){return _.get(o)?.supportedByCore??!1}e.mimeTypeSupportedByCore=d;function h(o){return _.get(o)?.mergeable??!1}e.mimeTypeIsMergeable=h;function v(o,k){return T.isWindows&&(o=o.replace(/\//g,"\\"),k=k.replace(/\//g,"\\")),p.match(o,k)}function t(o,k,F){let $=0;for(let Q=0;Q<k.length;Q++){if(v(k[Q],o))return $;$++}for(let Q=0;Q<F.length;Q++){if(v(F[Q],o))return $;$++}return $}function s(o,k,F){return o.sort(($,Q)=>t($,k,F)-t(Q,k,F))}e.sortMimeTypes=s;function r(o,k,F,$=(Q,oe)=>Q===oe){const Q=[];function oe(B,R,z){if(R===0&&z.length===0)return;const N=Q[Q.length-1];N&&N.start+N.deleteCount===B?(N.deleteCount+=R,N.toInsert.push(...z)):Q.push({start:B,deleteCount:R,toInsert:z})}let j=0,O=0;for(;;){if(j===o.length){oe(j,0,k.slice(O));break}if(O===k.length){oe(j,o.length-j,[]);break}const B=o[j],R=k[O];if($(B,R)){j+=1,O+=1;continue}F(R)?(oe(j,1,[]),j+=1):(oe(j,0,[R]),O+=1)}return Q}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new I.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(o){o.default="default",o.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function l(o){const k=o;return!!((typeof k.include=="string"||p.isRelativePattern(k.include))&&(typeof k.exclude=="string"||p.isRelativePattern(k.exclude)))}e.isDocumentExcludePattern=l;function f(o,k,F){if(Array.isArray(o.viewType)&&o.viewType.indexOf(k)>=0||o.viewType===k)return!0;if(o.filenamePattern){let $=l(o.filenamePattern)?o.filenamePattern.include:o.filenamePattern,Q=l(o.filenamePattern)?o.filenamePattern.exclude:void 0;if(p.match($,(0,S.basename)(F.fsPath).toLowerCase()))return!(Q&&p.match(Q,(0,S.basename)(F.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=f;class m{constructor(k){this.textModel=k}getElements(){const k=new Int32Array(this.textModel.cells.length);for(let F=0;F<this.textModel.cells.length;F++)k[F]=this.textModel.cells[F].getHashValue();return k}}e.CellSequence=m,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var E;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(E=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class y{static create(k){return`${y._prefix}${k}`}static parse(k){if(k.startsWith(y._prefix))return k.substr(y._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=y,y._prefix="notebook/"}),define(me[207],ge([0,1,171,4,80]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new C.RawContextKey("customExecutionSupported",!0,p.localize(0,null)),e.ShellExecutionSupportedContext=new C.RawContextKey("shellExecutionSupported",!1,p.localize(1,null)),e.ProcessExecutionSupportedContext=new C.RawContextKey("processExecutionSupported",!1,p.localize(2,null)),e.ITaskService=(0,L.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[208],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function p(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=p;function L(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=L}),define(me[123],ge([0,1,7]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.testRunConfigurationBitsetList=e.TestRunConfigurationBitset=e.identifyTest=e.TestResultState=void 0,Object.defineProperty(e,"TestResultState",{enumerable:!0,get:function(){return p.TestResultState}});const L=P=>({testId:P.item.extId,controllerId:P.controllerId});e.identifyTest=L;var C;(function(P){P[P.Run=2]="Run",P[P.Debug=4]="Debug",P[P.Coverage=8]="Coverage",P[P.HasNonDefaultConfig=16]="HasNonDefaultConfig",P[P.HasConfigurable=32]="HasConfigurable"})(C=e.TestRunConfigurationBitset||(e.TestRunConfigurationBitset={})),e.testRunConfigurationBitsetList=[2,4,8,16];var S;(function(P){P[P.NotExpandable=0]="NotExpandable",P[P.Expandable=1]="Expandable",P[P.BusyExpanding=2]="BusyExpanding",P[P.Expanded=3]="Expanded"})(S=e.TestItemExpandState||(e.TestItemExpandState={}));const T=(P,c)=>{c.expand!==void 0&&(P.expand=c.expand),c.item!==void 0&&(P.item=P.item?Object.assign(P.item,c.item):c.item)};e.applyTestItemUpdate=T;var I;(function(P){P[P.Function=0]="Function",P[P.Statement=1]="Statement"})(I=e.DetailType||(e.DetailType={}));var D;(function(P){P[P.Add=0]="Add",P[P.Update=1]="Update",P[P.Remove=2]="Remove",P[P.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",P[P.Retire=4]="Retire"})(D=e.TestDiffOpType||(e.TestDiffOpType={}));class A{add(c){}update(c){}remove(c,u){}complete(){}}e.IncrementalChangeCollector=A;class i{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(c){const u=this.createChangeCollector();for(const a of c)switch(a[0]){case 0:{const g=a[1];if(g.parent){if(this.items.has(g.parent)){const w=this.items.get(g.parent);w.children.add(g.item.extId);const _=this.createItem(g,w);this.items.set(g.item.extId,_),u.add(_)}}else{const w=this.createItem(g);this.roots.add(w),this.items.set(g.item.extId,w),u.add(w)}g.expand===2&&this.busyControllerCount++;break}case 1:{const g=a[1],w=this.items.get(g.extId);if(!w)break;g.expand!==void 0&&(w.expand===2&&this.busyControllerCount--,g.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(w,g),u.update(w);break}case 2:{const g=this.items.get(a[1]);if(!g)break;g.parent?this.items.get(g.parent).children.delete(g.item.extId):this.roots.delete(g);const w=[[a[1]]];for(;w.length;)for(const _ of w.pop()){const b=this.items.get(_);b&&(w.push(b.children),this.items.delete(_),u.remove(b,b!==g),b.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(a[1]);break;case 3:this.updatePendingRoots(a[1]);break}u.complete()}retireTest(c){}updatePendingRoots(c){this.pendingRootCount+=c}createChangeCollector(){return new A}}e.AbstractIncrementalTestCollection=i}),define(me[209],ge([0,1,9,37,14,25,11,76,172]),function(J,e,p,L,C,S,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class A{constructor(P,c,u){this._contributedVariables=new Map,this._context=P,this._labelService=c,u&&(this._envVariablesPromise=u.then(a=>this.prepareEnv(a)))}prepareEnv(P){if(T.isWindows){const c=Object.create(null);return Object.keys(P).forEach(u=>{c[u.toLowerCase()]=P[u]}),c}return P}resolveWithEnvironment(P,c,u){return this.recursiveResolve(this.prepareEnv(P),c?c.uri:void 0,u)}async resolveAsync(P,c){return this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,c)}async resolveAnyBase(P,c,u,a){const g=S.deepClone(c);return T.isWindows&&g.windows?Object.keys(g.windows).forEach(w=>g[w]=g.windows[w]):T.isMacintosh&&g.osx?Object.keys(g.osx).forEach(w=>g[w]=g.osx[w]):T.isLinux&&g.linux&&Object.keys(g.linux).forEach(w=>g[w]=g.linux[w]),delete g.windows,delete g.osx,delete g.linux,this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,g,u,a)}async resolveAnyAsync(P,c,u){return this.resolveAnyBase(P,c,u)}async resolveAnyMap(P,c,u){const a=new Map;return{newConfig:await this.resolveAnyBase(P,c,u,a),resolvedVariables:a}}resolveWithInteractionReplace(P,c,u,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,c,u,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,c){if(this._contributedVariables.has(P))throw new Error("Variable "+P+" is contributed twice.");this._contributedVariables.set(P,c)}recursiveResolve(P,c,u,a,g){if(C.isString(u))return this.resolveString(P,c,u,a,g);if(C.isArray(u))return u.map(w=>this.recursiveResolve(P,c,w,a,g));if(C.isObject(u)){let w=Object.create(null);return Object.keys(u).forEach(_=>{const b=this.resolveString(P,c,_,a,g);w[b]=this.recursiveResolve(P,c,u[_],a,g)}),w}return u}resolveString(P,c,u,a,g){return u.replace(A.VARIABLE_REGEXP,(_,b)=>{if(b.includes(A.VARIABLE_LHS))return _;let d=this.evaluateSingleVariable(P,_,b,c,a);return g&&g.set(b,d),d!==_&&C.isString(d)&&d.match(A.VARIABLE_REGEXP)&&(d=this.resolveString(P,c,d,a,g)),d})}fsPath(P){return this._labelService?this._labelService.getUriLabel(P,{noPrefix:!0}):P.fsPath}evaluateSingleVariable(P,c,u,a,g){let w;const _=u.split(":");_.length>1&&(u=_[0],w=_[1]);const b=()=>{const v=this._context.getFilePath();if(v)return v;throw new Error((0,D.localize)(0,null,c))},d=()=>{const v=b();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,D.localize)(1,null,c,p.basename(v)))},h=()=>{if(w){const v=this._context.getFolderUri(w);if(v)return v;throw new Error((0,D.localize)(2,null,c,w))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,c)):new Error((0,D.localize)(4,null,c))};switch(u){case"env":if(w){if(P){const v=P[T.isWindows?w.toLowerCase():w];if(C.isString(v))return v}return""}throw new Error((0,D.localize)(5,null,c));case"config":if(w){const v=this._context.getConfigurationValue(a,w);if(C.isUndefinedOrNull(v))throw new Error((0,D.localize)(6,null,c,w));if(C.isObject(v))throw new Error((0,D.localize)(7,null,c,w));return v}throw new Error((0,D.localize)(8,null,c));case"command":return this.resolveFromMap(c,w,g,"command");case"input":return this.resolveFromMap(c,w,g,"input");default:switch(u){case"workspaceRoot":case"workspaceFolder":return(0,I.normalizeDriveLetter)(this.fsPath(h()));case"cwd":return a||w?(0,I.normalizeDriveLetter)(this.fsPath(h())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return p.basename(this.fsPath(h()));case"lineNumber":const v=this._context.getLineNumber();if(v)return v;throw new Error((0,D.localize)(9,null,c));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,D.localize)(10,null,c));case"file":return b();case"fileWorkspaceFolder":return d();case"relativeFile":return a||w?p.relative(this.fsPath(h()),b()):b();case"relativeFileDirname":const s=p.dirname(b());if(a||w){const f=p.relative(this.fsPath(h()),s);return f.length===0?".":f}return s;case"fileDirname":return p.dirname(b());case"fileExtname":return p.extname(b());case"fileBasename":return p.basename(b());case"fileBasenameNoExtension":const r=p.basename(b());return r.slice(0,r.length-p.extname(r).length);case"fileDirnameBasename":return p.basename(p.dirname(b()));case"execPath":const n=this._context.getExecPath();return n||c;case"execInstallFolder":const l=this._context.getAppRoot();return l||c;case"pathSeparator":return p.sep;default:try{const f=w?`${u}:${w}`:u;return this.resolveFromMap(c,f,g,void 0)}catch(f){return c}}}}resolveFromMap(P,c,u,a){if(c&&u){const g=a===void 0?u[c]:u[a+":"+c];if(typeof g=="string")return g;throw new Error((0,D.localize)(11,null,P))}return P}}e.AbstractVariableResolverService=A,A.VARIABLE_LHS="${",A.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[124],ge([0,1,4,203]),function(J,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,p.createDecorator)("editorGroupsService");var C;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(C=e.GroupDirection||(e.GroupDirection={}));var S;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(S=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var I;(function(g){g[g.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(I=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));function A(g){const w=g;return(0,L.isEditorInput)(w?.editor)&&(0,L.isEditorInput)(w?.replacement)}e.isEditorReplacement=A;var i;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(i=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(g){g[g.GROUP_ACTIVE=0]="GROUP_ACTIVE",g[g.GROUP_INDEX=1]="GROUP_INDEX",g[g.EDITOR_OPEN=2]="EDITOR_OPEN",g[g.EDITOR_CLOSE=3]="EDITOR_CLOSE",g[g.EDITOR_MOVE=4]="EDITOR_MOVE",g[g.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",g[g.EDITOR_LABEL=6]="EDITOR_LABEL",g[g.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",g[g.EDITOR_PIN=8]="EDITOR_PIN",g[g.EDITOR_STICKY=9]="EDITOR_STICKY",g[g.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(P=e.GroupChangeKind||(e.GroupChangeKind={}));var c;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(c=e.OpenEditorContext||(e.OpenEditorContext={}));function u(g){const w=g;return!!w&&typeof w.id=="number"&&Array.isArray(w.editors)}e.isEditorGroup=u;function a(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=a}),define(me[210],ge([0,1,4,124]),function(J,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,p.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function C(S){const T=S;return typeof S=="number"||(0,L.isEditorGroup)(T)}e.isPreferredGroup=C}),define(me[16],ge([0,1,18,96,284,57,25,14,2,40,79,173,115,85,87,210,7]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var _;(function(be){function Ie(V){const{selectionStartLineNumber:Me,selectionStartColumn:Be,positionLineNumber:Ye,positionColumn:Ke}=V,ct=new w.Position(Me-1,Be-1),mt=new w.Position(Ye-1,Ke-1);return new w.Selection(ct,mt)}be.to=Ie;function he(V){const{anchor:Me,active:Be}=V;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}be.from=he})(_=e.Selection||(e.Selection={}));var b;(function(be){function Ie(V){if(!V)return;const{start:Me,end:Be}=V;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}be.from=Ie;function he(V){if(!V)return;const{startLineNumber:Me,startColumn:Be,endLineNumber:Ye,endColumn:Ke}=V;return new w.Range(Me-1,Be-1,Ye-1,Ke-1)}be.to=he})(b=e.Range||(e.Range={}));var d;(function(be){function Ie(he){switch(he){case 1:return w.StandardTokenType.Comment;case 0:return w.StandardTokenType.Other;case 4:return w.StandardTokenType.RegEx;case 2:return w.StandardTokenType.String}}be.to=Ie})(d=e.TokenType||(e.TokenType={}));var h;(function(be){function Ie(V){return new w.Position(V.lineNumber-1,V.column-1)}be.to=Ie;function he(V){return{lineNumber:V.line+1,column:V.character+1}}be.from=he})(h=e.Position||(e.Position={}));var v;(function(be){function Ie(V){switch(V){case w.DiagnosticTag.Unnecessary:return 1;case w.DiagnosticTag.Deprecated:return 2}}be.from=Ie;function he(V){switch(V){case 1:return w.DiagnosticTag.Unnecessary;case 2:return w.DiagnosticTag.Deprecated;default:return}}be.to=he})(v=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(be){function Ie(V){let Me;return V.code&&((0,I.isString)(V.code)||(0,I.isNumber)(V.code)?Me=String(V.code):Me={value:String(V.code.value),target:V.code.target}),{...b.from(V.range),message:V.message,source:V.source,code:Me,severity:r.from(V.severity),relatedInformation:V.relatedInformation&&V.relatedInformation.map(s.from),tags:Array.isArray(V.tags)?(0,p.coalesce)(V.tags.map(v.from)):void 0}}be.from=Ie;function he(V){const Me=new w.Diagnostic(b.to(V),V.message,r.to(V.severity));return Me.source=V.source,Me.code=(0,I.isString)(V.code)?V.code:V.code?.value,Me.relatedInformation=V.relatedInformation&&V.relatedInformation.map(s.to),Me.tags=V.tags&&(0,p.coalesce)(V.tags.map(v.to)),Me}be.to=he})(t=e.Diagnostic||(e.Diagnostic={}));var s;(function(be){function Ie(V){return{...b.from(V.location.range),message:V.message,resource:V.location.uri}}be.from=Ie;function he(V){return new w.DiagnosticRelatedInformation(new w.Location(V.resource,b.to(V)),V.message)}be.to=he})(s=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var r;(function(be){function Ie(V){switch(V){case w.DiagnosticSeverity.Error:return c.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return c.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return c.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return c.MarkerSeverity.Hint}return c.MarkerSeverity.Error}be.from=Ie;function he(V){switch(V){case c.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case c.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case c.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case c.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}be.to=he})(r=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var n;(function(be){function Ie(V){return typeof V=="number"&&V>=w.ViewColumn.One?V-1:V===w.ViewColumn.Beside?g.SIDE_GROUP:g.ACTIVE_GROUP}be.from=Ie;function he(V){if(typeof V=="number"&&V>=0)return V+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=he})(n=e.ViewColumn||(e.ViewColumn={}));function l(be){return typeof be.range!="undefined"}function f(be){return be.length===0?!0:!!l(be[0])}e.isDecorationOptionsArr=f;var m;(function(be){function Ie(Ke){return Ke.map(be.from)}be.fromMany=Ie;function he(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function V(Ke){let ct;if(he(Ke)){const{language:wt,value:gt}=Ke;ct={value:"```"+wt+`
`+gt+"\n```\n"}}else w.MarkdownString.isMarkdownString(Ke)?ct={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons}:typeof Ke=="string"?ct={value:Ke}:ct={value:""};const mt=Object.create(null);ct.uris=mt;const kt=wt=>{try{let gt=D.URI.parse(wt,!0);gt=gt.with({query:Me(gt.query,mt)}),mt[wt]=gt}catch(gt){}return""},yt=new C.Renderer;return yt.link=kt,yt.image=wt=>kt(L.parseHrefAndDimensions(wt).href),C(ct.value,{renderer:yt}),ct}be.from=V;function Me(Ke,ct){if(!Ke)return Ke;let mt;try{mt=(0,S.parse)(Ke)}catch(yt){}if(!mt)return Ke;let kt=!1;return mt=(0,T.cloneAndChange)(mt,yt=>{if(D.URI.isUri(yt)){const wt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[wt]=yt,kt=!0,wt}else return}),kt?JSON.stringify(mt):Ke}function Be(Ke){const ct=new w.MarkdownString(Ke.value,Ke.supportThemeIcons);return ct.isTrusted=Ke.isTrusted,ct}be.to=Be;function Ye(Ke){if(!!Ke)return typeof Ke=="string"?Ke:be.from(Ke)}be.fromStrict=Ye})(m=e.MarkdownString||(e.MarkdownString={}));function E(be){return f(be)?be.map(Ie=>({range:b.from(Ie.range),hoverMessage:Array.isArray(Ie.hoverMessage)?m.fromMany(Ie.hoverMessage):Ie.hoverMessage?m.from(Ie.hoverMessage):void 0,renderOptions:Ie.renderOptions})):be.map(Ie=>({range:b.from(Ie)}))}e.fromRangeOrRangeWithMessage=E;function y(be){return typeof be=="undefined"?be:typeof be=="string"?D.URI.file(be):be}e.pathOrURIToURI=y;var o;(function(be){function Ie(he){return typeof he=="undefined"?he:{contentText:he.contentText,contentIconPath:he.contentIconPath?y(he.contentIconPath):void 0,border:he.border,borderColor:he.borderColor,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,color:he.color,backgroundColor:he.backgroundColor,margin:he.margin,width:he.width,height:he.height}}be.from=Ie})(o=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var k;(function(be){function Ie(he){return typeof he=="undefined"?he:{backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?y(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?o.from(he.before):void 0,after:he.after?o.from(he.after):void 0}}be.from=Ie})(k=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(be){function Ie(he){if(typeof he=="undefined")return he;switch(he){case w.DecorationRangeBehavior.OpenOpen:return 0;case w.DecorationRangeBehavior.ClosedClosed:return 1;case w.DecorationRangeBehavior.OpenClosed:return 2;case w.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=Ie})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var $;(function(be){function Ie(he){return{isWholeLine:he.isWholeLine,rangeBehavior:he.rangeBehavior?F.from(he.rangeBehavior):void 0,overviewRulerLane:he.overviewRulerLane,light:he.light?k.from(he.light):void 0,dark:he.dark?k.from(he.dark):void 0,backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?y(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?o.from(he.before):void 0,after:he.after?o.from(he.after):void 0}}be.from=Ie})($=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var Q;(function(be){function Ie(V){return{text:V.newText,eol:V.newEol&&ie.from(V.newEol),range:b.from(V.range)}}be.from=Ie;function he(V){const Me=new w.TextEdit(b.to(V.range),V.text);return Me.newEol=typeof V.eol=="undefined"?void 0:ie.to(V.eol),Me}be.to=he})(Q=e.TextEdit||(e.TextEdit={}));var oe;(function(be){function Ie(V,Me,Be){const Ye={edits:[]};if(V instanceof w.WorkspaceEdit)for(let Ke of V._allEntries())if(Ke._type===1)Ye.edits.push({_type:1,oldUri:Ke.from,newUri:Ke.to,options:Ke.options,metadata:Ke.metadata});else if(Ke._type===2){const ct=Me?.getDocument(Ke.uri);Ye.edits.push({_type:2,resource:Ke.uri,edit:Q.from(Ke.edit),modelVersionId:ct?.version,metadata:Ke.metadata})}else Ke._type===3?Ye.edits.push({_type:3,metadata:Ke.metadata,resource:Ke.uri,edit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Be?.getNotebookDocument(Ke.uri,!0)?.apiNotebook.version}):Ke._type===5&&Ye.edits.push({_type:3,metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Be?.getNotebookDocument(Ke.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(Ee.from)}});return Ye}be.from=Ie;function he(V){const Me=new w.WorkspaceEdit;for(const Be of V.edits)Be.edit?Me.replace(D.URI.revive(Be.resource),b.to(Be.edit.range),Be.edit.text):Me.renameFile(D.URI.revive(Be.oldUri),D.URI.revive(Be.newUri),Be.options);return Me}be.to=he})(oe=e.WorkspaceEdit||(e.WorkspaceEdit={}));var j;(function(be){const Ie=Object.create(null);Ie[w.SymbolKind.File]=0,Ie[w.SymbolKind.Module]=1,Ie[w.SymbolKind.Namespace]=2,Ie[w.SymbolKind.Package]=3,Ie[w.SymbolKind.Class]=4,Ie[w.SymbolKind.Method]=5,Ie[w.SymbolKind.Property]=6,Ie[w.SymbolKind.Field]=7,Ie[w.SymbolKind.Constructor]=8,Ie[w.SymbolKind.Enum]=9,Ie[w.SymbolKind.Interface]=10,Ie[w.SymbolKind.Function]=11,Ie[w.SymbolKind.Variable]=12,Ie[w.SymbolKind.Constant]=13,Ie[w.SymbolKind.String]=14,Ie[w.SymbolKind.Number]=15,Ie[w.SymbolKind.Boolean]=16,Ie[w.SymbolKind.Array]=17,Ie[w.SymbolKind.Object]=18,Ie[w.SymbolKind.Key]=19,Ie[w.SymbolKind.Null]=20,Ie[w.SymbolKind.EnumMember]=21,Ie[w.SymbolKind.Struct]=22,Ie[w.SymbolKind.Event]=23,Ie[w.SymbolKind.Operator]=24,Ie[w.SymbolKind.TypeParameter]=25;function he(Me){return typeof Ie[Me]=="number"?Ie[Me]:6}be.from=he;function V(Me){for(const Be in Ie)if(Ie[Be]===Me)return Number(Be);return w.SymbolKind.Property}be.to=V})(j=e.SymbolKind||(e.SymbolKind={}));var O;(function(be){function Ie(V){switch(V){case w.SymbolTag.Deprecated:return 1}}be.from=Ie;function he(V){switch(V){case 1:return w.SymbolTag.Deprecated}}be.to=he})(O=e.SymbolTag||(e.SymbolTag={}));var B;(function(be){function Ie(V){return{name:V.name,kind:j.from(V.kind),tags:V.tags&&V.tags.map(O.from),containerName:V.containerName,location:q.from(V.location)}}be.from=Ie;function he(V){const Me=new w.SymbolInformation(V.name,j.to(V.kind),V.containerName,q.to(V.location));return Me.tags=V.tags&&V.tags.map(O.to),Me}be.to=he})(B=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var R;(function(be){function Ie(V){const Me={name:V.name||"!!MISSING: name!!",detail:V.detail,range:b.from(V.range),selectionRange:b.from(V.selectionRange),kind:j.from(V.kind),tags:V.tags?.map(O.from)??[]};return V.children&&(Me.children=V.children.map(Ie)),Me}be.from=Ie;function he(V){const Me=new w.DocumentSymbol(V.name,V.detail,j.to(V.kind),b.to(V.range),b.to(V.selectionRange));return(0,p.isNonEmptyArray)(V.tags)&&(Me.tags=V.tags.map(O.to)),V.children&&(Me.children=V.children.map(he)),Me}be.to=he})(R=e.DocumentSymbol||(e.DocumentSymbol={}));var z;(function(be){function Ie(V){const Me=new w.CallHierarchyItem(j.to(V.kind),V.name,V.detail||"",D.URI.revive(V.uri),b.to(V.range),b.to(V.selectionRange));return Me._sessionId=V._sessionId,Me._itemId=V._itemId,Me}be.to=Ie;function he(V,Me,Be){if(Me=Me??V._sessionId,Be=Be??V._itemId,Me===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Be,name:V.name,detail:V.detail,kind:j.from(V.kind),uri:V.uri,range:b.from(V.range),selectionRange:b.from(V.selectionRange),tags:V.tags?.map(O.from)}}be.from=he})(z=e.CallHierarchyItem||(e.CallHierarchyItem={}));var N;(function(be){function Ie(he){return new w.CallHierarchyIncomingCall(z.to(he.from),he.fromRanges.map(V=>b.to(V)))}be.to=Ie})(N=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var M;(function(be){function Ie(he){return new w.CallHierarchyOutgoingCall(z.to(he.to),he.fromRanges.map(V=>b.to(V)))}be.to=Ie})(M=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var q;(function(be){function Ie(V){return{range:V.range&&b.from(V.range),uri:V.uri}}be.from=Ie;function he(V){return new w.Location(D.URI.revive(V.uri),b.to(V.range))}be.to=he})(q=e.location||(e.location={}));var x;(function(be){function Ie(V){const Me=V,Be=V;return{originSelectionRange:Me.originSelectionRange?b.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Be.uri,range:b.from(Me.targetRange?Me.targetRange:Be.range),targetSelectionRange:Me.targetSelectionRange?b.from(Me.targetSelectionRange):void 0}}be.from=Ie;function he(V){return{targetUri:D.URI.revive(V.uri),targetRange:b.to(V.range),targetSelectionRange:V.targetSelectionRange?b.to(V.targetSelectionRange):void 0,originSelectionRange:V.originSelectionRange?b.to(V.originSelectionRange):void 0}}be.to=he})(x=e.DefinitionLink||(e.DefinitionLink={}));var K;(function(be){function Ie(V){return{range:b.from(V.range),contents:m.fromMany(V.contents)}}be.from=Ie;function he(V){return new w.Hover(V.contents.map(m.to),b.to(V.range))}be.to=he})(K=e.Hover||(e.Hover={}));var ee;(function(be){function Ie(V){return{range:b.from(V.range),expression:V.expression}}be.from=Ie;function he(V){return new w.EvaluatableExpression(b.to(V.range),V.expression)}be.to=he})(ee=e.EvaluatableExpression||(e.EvaluatableExpression={}));var de;(function(be){function Ie(V){if(V instanceof w.InlineValueText)return{type:"text",range:b.from(V.range),text:V.text};if(V instanceof w.InlineValueVariableLookup)return{type:"variable",range:b.from(V.range),variableName:V.variableName,caseSensitiveLookup:V.caseSensitiveLookup};if(V instanceof w.InlineValueEvaluatableExpression)return{type:"expression",range:b.from(V.range),expression:V.expression};throw new Error("Unknown 'InlineValue' type")}be.from=Ie;function he(V){switch(V.type){case"text":return{range:b.to(V.range),text:V.text};case"variable":return{range:b.to(V.range),variableName:V.variableName,caseSensitiveLookup:V.caseSensitiveLookup};case"expression":return{range:b.to(V.range),expression:V.expression}}}be.to=he})(de=e.InlineValue||(e.InlineValue={}));var Se;(function(be){function Ie(V){return{frameId:V.frameId,stoppedLocation:b.from(V.stoppedLocation)}}be.from=Ie;function he(V){return new w.InlineValueContext(V.frameId,b.to(V.stoppedLocation))}be.to=he})(Se=e.InlineValueContext||(e.InlineValueContext={}));var De;(function(be){function Ie(V){return{range:b.from(V.range),kind:V.kind}}be.from=Ie;function he(V){return new w.DocumentHighlight(b.to(V.range),V.kind)}be.to=he})(De=e.DocumentHighlight||(e.DocumentHighlight={}));var Le;(function(be){function Ie(he){switch(he){case 1:return w.CompletionTriggerKind.TriggerCharacter;case 2:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return w.CompletionTriggerKind.Invoke}}be.to=Ie})(Le=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var qe;(function(be){function Ie(he){return{triggerKind:Le.to(he.triggerKind),triggerCharacter:he.triggerCharacter}}be.to=Ie})(qe=e.CompletionContext||(e.CompletionContext={}));var We;(function(be){function Ie(V){switch(V){case w.CompletionItemTag.Deprecated:return 1}}be.from=Ie;function he(V){switch(V){case 1:return w.CompletionItemTag.Deprecated}}be.to=he})(We=e.CompletionItemTag||(e.CompletionItemTag={}));var je;(function(be){const Ie=new Map([[w.CompletionItemKind.Method,0],[w.CompletionItemKind.Function,1],[w.CompletionItemKind.Constructor,2],[w.CompletionItemKind.Field,3],[w.CompletionItemKind.Variable,4],[w.CompletionItemKind.Class,5],[w.CompletionItemKind.Interface,7],[w.CompletionItemKind.Struct,6],[w.CompletionItemKind.Module,8],[w.CompletionItemKind.Property,9],[w.CompletionItemKind.Unit,12],[w.CompletionItemKind.Value,13],[w.CompletionItemKind.Constant,14],[w.CompletionItemKind.Enum,15],[w.CompletionItemKind.EnumMember,16],[w.CompletionItemKind.Keyword,17],[w.CompletionItemKind.Snippet,27],[w.CompletionItemKind.Text,18],[w.CompletionItemKind.Color,19],[w.CompletionItemKind.File,20],[w.CompletionItemKind.Reference,21],[w.CompletionItemKind.Folder,23],[w.CompletionItemKind.Event,10],[w.CompletionItemKind.Operator,11],[w.CompletionItemKind.TypeParameter,24],[w.CompletionItemKind.Issue,26],[w.CompletionItemKind.User,25]]);function he(Be){return Ie.get(Be)??9}be.from=he;const V=new Map([[0,w.CompletionItemKind.Method],[1,w.CompletionItemKind.Function],[2,w.CompletionItemKind.Constructor],[3,w.CompletionItemKind.Field],[4,w.CompletionItemKind.Variable],[5,w.CompletionItemKind.Class],[7,w.CompletionItemKind.Interface],[6,w.CompletionItemKind.Struct],[8,w.CompletionItemKind.Module],[9,w.CompletionItemKind.Property],[12,w.CompletionItemKind.Unit],[13,w.CompletionItemKind.Value],[14,w.CompletionItemKind.Constant],[15,w.CompletionItemKind.Enum],[16,w.CompletionItemKind.EnumMember],[17,w.CompletionItemKind.Keyword],[27,w.CompletionItemKind.Snippet],[18,w.CompletionItemKind.Text],[19,w.CompletionItemKind.Color],[20,w.CompletionItemKind.File],[21,w.CompletionItemKind.Reference],[23,w.CompletionItemKind.Folder],[10,w.CompletionItemKind.Event],[11,w.CompletionItemKind.Operator],[24,w.CompletionItemKind.TypeParameter],[25,w.CompletionItemKind.User],[26,w.CompletionItemKind.Issue]]);function Me(Be){return V.get(Be)??w.CompletionItemKind.Property}be.to=Me})(je=e.CompletionItemKind||(e.CompletionItemKind={}));var W;(function(be){function Ie(he,V){const Me=new w.CompletionItem(he.label);return Me.insertText=he.insertText,Me.kind=je.to(he.kind),Me.tags=he.tags?.map(We.to),Me.detail=he.detail,Me.documentation=L.isMarkdownString(he.documentation)?m.to(he.documentation):he.documentation,Me.sortText=he.sortText,Me.filterText=he.filterText,Me.preselect=he.preselect,Me.commitCharacters=he.commitCharacters,A.Range.isIRange(he.range)?Me.range=b.to(he.range):typeof he.range=="object"&&(Me.range={inserting:b.to(he.range.insert),replacing:b.to(he.range.replace)}),Me.keepWhitespace=typeof he.insertTextRules=="undefined"?!1:Boolean(he.insertTextRules&1),typeof he.insertTextRules!="undefined"&&he.insertTextRules&4?Me.insertText=new w.SnippetString(he.insertText):(Me.insertText=he.insertText,Me.textEdit=Me.range instanceof w.Range?new w.TextEdit(Me.range,Me.insertText):void 0),he.additionalTextEdits&&he.additionalTextEdits.length>0&&(Me.additionalTextEdits=he.additionalTextEdits.map(Be=>Q.to(Be))),Me.command=V&&he.command?V.fromInternal(he.command):void 0,Me}be.to=Ie})(W=e.CompletionItem||(e.CompletionItem={}));var Z;(function(be){function Ie(V){return{label:V.label,documentation:V.documentation?m.fromStrict(V.documentation):void 0}}be.from=Ie;function he(V){return{label:V.label,documentation:L.isMarkdownString(V.documentation)?m.to(V.documentation):V.documentation}}be.to=he})(Z=e.ParameterInformation||(e.ParameterInformation={}));var te;(function(be){function Ie(V){return{label:V.label,documentation:V.documentation?m.fromStrict(V.documentation):void 0,parameters:Array.isArray(V.parameters)?V.parameters.map(Z.from):[],activeParameter:V.activeParameter}}be.from=Ie;function he(V){return{label:V.label,documentation:L.isMarkdownString(V.documentation)?m.to(V.documentation):V.documentation,parameters:Array.isArray(V.parameters)?V.parameters.map(Z.to):[],activeParameter:V.activeParameter}}be.to=he})(te=e.SignatureInformation||(e.SignatureInformation={}));var ae;(function(be){function Ie(V){return{activeSignature:V.activeSignature,activeParameter:V.activeParameter,signatures:Array.isArray(V.signatures)?V.signatures.map(te.from):[]}}be.from=Ie;function he(V){return{activeSignature:V.activeSignature,activeParameter:V.activeParameter,signatures:Array.isArray(V.signatures)?V.signatures.map(te.to):[]}}be.to=he})(ae=e.SignatureHelp||(e.SignatureHelp={}));var Y;(function(be){function Ie(V){return{text:V.text,position:h.from(V.position),kind:se.from(V.kind??w.InlayHintKind.Other),whitespaceBefore:V.whitespaceBefore,whitespaceAfter:V.whitespaceAfter}}be.from=Ie;function he(V){const Me=new w.InlayHint(V.text,h.to(V.position),se.to(V.kind));return Me.whitespaceAfter=V.whitespaceAfter,Me.whitespaceBefore=V.whitespaceBefore,Me}be.to=he})(Y=e.InlayHint||(e.InlayHint={}));var se;(function(be){function Ie(V){return V}be.from=Ie;function he(V){return V}be.to=he})(se=e.InlayHintKind||(e.InlayHintKind={}));var we;(function(be){function Ie(V){return{range:b.from(V.range),url:V.target,tooltip:V.tooltip}}be.from=Ie;function he(V){let Me;if(V.url)try{Me=typeof V.url=="string"?D.URI.parse(V.url,!0):D.URI.revive(V.url)}catch(Be){}return new w.DocumentLink(b.to(V.range),Me)}be.to=he})(we=e.DocumentLink||(e.DocumentLink={}));var Fe;(function(be){function Ie(V){const Me=new w.ColorPresentation(V.label);return V.textEdit&&(Me.textEdit=Q.to(V.textEdit)),V.additionalTextEdits&&(Me.additionalTextEdits=V.additionalTextEdits.map(Be=>Q.to(Be))),Me}be.to=Ie;function he(V){return{label:V.label,textEdit:V.textEdit?Q.from(V.textEdit):void 0,additionalTextEdits:V.additionalTextEdits?V.additionalTextEdits.map(Me=>Q.from(Me)):void 0}}be.from=he})(Fe=e.ColorPresentation||(e.ColorPresentation={}));var ze;(function(be){function Ie(V){return new w.Color(V[0],V[1],V[2],V[3])}be.to=Ie;function he(V){return[V.red,V.green,V.blue,V.alpha]}be.from=he})(ze=e.Color||(e.Color={}));var _e;(function(be){function Ie(V){return{range:b.from(V.range)}}be.from=Ie;function he(V){return new w.SelectionRange(b.to(V.range))}be.to=he})(_e=e.SelectionRange||(e.SelectionRange={}));var Ze;(function(be){function Ie(he){switch(he){case 2:return w.TextDocumentSaveReason.AfterDelay;case 1:return w.TextDocumentSaveReason.Manual;case 3:case 4:return w.TextDocumentSaveReason.FocusOut}}be.to=Ie})(Ze=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var X;(function(be){function Ie(V){switch(V){case w.TextEditorLineNumbersStyle.Off:return 0;case w.TextEditorLineNumbersStyle.Relative:return 2;case w.TextEditorLineNumbersStyle.On:default:return 1}}be.from=Ie;function he(V){switch(V){case 0:return w.TextEditorLineNumbersStyle.Off;case 2:return w.TextEditorLineNumbersStyle.Relative;case 1:default:return w.TextEditorLineNumbersStyle.On}}be.to=he})(X=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ie;(function(be){function Ie(V){if(V===w.EndOfLine.CRLF)return 1;if(V===w.EndOfLine.LF)return 0}be.from=Ie;function he(V){if(V===1)return w.EndOfLine.CRLF;if(V===0)return w.EndOfLine.LF}be.to=he})(ie=e.EndOfLine||(e.EndOfLine={}));var fe;(function(be){function Ie(he){if(typeof he=="object")return he.viewId;switch(he){case w.ProgressLocation.SourceControl:return 3;case w.ProgressLocation.Window:return 10;case w.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=Ie})(fe=e.ProgressLocation||(e.ProgressLocation={}));var $e;(function(be){function Ie(he){const V={start:he.start+1,end:he.end+1};return he.kind&&(V.kind=xe.from(he.kind)),V}be.from=Ie})($e=e.FoldingRange||(e.FoldingRange={}));var xe;(function(be){function Ie(he){if(he)switch(he){case w.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case w.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case w.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}be.from=Ie})(xe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var tt;(function(be){function Ie(he){if(he)return{pinned:typeof he.preview=="boolean"?!he.preview:void 0,inactive:he.background,preserveFocus:he.preserveFocus,selection:typeof he.selection=="object"?b.from(he.selection):void 0,override:typeof he.override=="boolean"?P.EditorResolution.DISABLED:void 0}}be.from=Ie})(tt=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ce;(function(be){function Ie(V){return V instanceof w.RelativePattern||typeof V=="string"?V:he(V)?new w.RelativePattern(V.base,V.pattern):V}be.from=Ie;function he(V){const Me=V;return Me&&typeof Me.base=="string"&&typeof Me.pattern=="string"}})(Ce=e.GlobPattern||(e.GlobPattern={}));var ke;(function(be){function Ie(he){if(he){if(Array.isArray(he))return he.map(Ie);if(typeof he=="string")return he;{const V=he;return{language:V.language,scheme:V.scheme,pattern:typeof V.pattern=="undefined"?void 0:Ce.from(V.pattern),exclusive:V.exclusive}}}else return}be.from=Ie})(ke=e.LanguageSelector||(e.LanguageSelector={}));var Te;(function(be){function Ie(V){return{start:V.start,end:V.end}}be.from=Ie;function he(V){return new w.NotebookRange(V.start,V.end)}be.to=he})(Te=e.NotebookRange||(e.NotebookRange={}));var le;(function(be){function Ie(V){return{timing:typeof V.runStartTime=="number"&&typeof V.runEndTime=="number"?{startTime:V.runStartTime,endTime:V.runEndTime}:void 0,executionOrder:V.executionOrder,success:V.lastRunSuccess}}be.to=Ie;function he(V){return{lastRunSuccess:V.success,runStartTime:V.timing?.startTime,runEndTime:V.timing?.endTime,executionOrder:V.executionOrder}}be.from=he})(le=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var ce;(function(be){function Ie(V){switch(V){case w.NotebookCellKind.Markup:return a.CellKind.Markup;case w.NotebookCellKind.Code:default:return a.CellKind.Code}}be.from=Ie;function he(V){switch(V){case a.CellKind.Markup:return w.NotebookCellKind.Markup;case a.CellKind.Code:default:return w.NotebookCellKind.Code}}be.to=he})(ce=e.NotebookCellKind||(e.NotebookCellKind={}));var pe;(function(be){function Ie(V){const Me={metadata:V.metadata??Object.create(null),cells:[]};for(let Be of V.cells)w.NotebookCellData.validate(Be),Me.cells.push(Ee.from(Be));return Me}be.from=Ie;function he(V){const Me=new w.NotebookData(V.cells.map(Ee.to));return(0,I.isEmptyObject)(V.metadata)||(Me.metadata=V.metadata),Me}be.to=he})(pe=e.NotebookData||(e.NotebookData={}));var Ee;(function(be){function Ie(V){return{cellKind:ce.from(V.kind),language:V.languageId,mime:V.mime,source:V.value,metadata:V.metadata,internalMetadata:le.from(V.executionSummary??{}),outputs:V.outputs?V.outputs.map(ve.from):[]}}be.from=Ie;function he(V){return new w.NotebookCellData(ce.to(V.cellKind),V.source,V.language,V.mime,V.outputs?V.outputs.map(ve.to):void 0,V.metadata,V.internalMetadata?le.to(V.internalMetadata):void 0)}be.to=he})(Ee=e.NotebookCellData||(e.NotebookCellData={}));var G;(function(be){function Ie(V){return{mime:V.mime,valueBytes:Array.from(V.data)}}be.from=Ie;function he(V){return new w.NotebookCellOutputItem(new Uint8Array(V.valueBytes),V.mime)}be.to=he})(G=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ve;(function(be){function Ie(V){return{outputId:V.id,items:V.items.map(G.from),metadata:V.metadata}}be.from=Ie;function he(V){const Me=V.items.map(G.to);return new w.NotebookCellOutput(Me,V.outputId,V.metadata)}be.to=he})(ve=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ye;(function(be){function Ie(Be){if(Be!=null){if(Be instanceof w.RelativePattern||typeof Be=="string")return Be;if(Me(Be))return new w.RelativePattern(Be.base,Be.pattern);if(V(Be))return{include:Ce.from(Be.include)||void 0,exclude:Ce.from(Be.exclude)||void 0}}}be.from=Ie;function he(Be){return typeof Be=="string"?Be:Me(Be)?{base:Be.base,pattern:Be.pattern}:{include:Be.include,exclude:Be.exclude}}be.to=he;function V(Be){const Ye=Be,Ke=Ce.from(Ye.include);if(!(Ke&&Ke instanceof w.RelativePattern||typeof Ke=="string"))return!1;const ct=Ce.from(Ye.exclude);return!!(ct&&ct instanceof w.RelativePattern||typeof ct=="string")}function Me(Be){const Ye=Be;return Ye&&typeof Ye.base=="string"&&typeof Ye.pattern=="string"}})(ye=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ae;(function(be){function Ie(he){return{backgroundColor:he.backgroundColor,borderColor:he.borderColor,top:he.top?o.from(he.top):void 0}}be.from=Ie})(Ae=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ne;(function(be){function Ie(he,V,Me){const Be=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{alignment:he.alignment===w.NotebookCellStatusBarAlignment.Left?1:2,command:V.toInternal(Be,Me),text:he.text,tooltip:he.tooltip,accessibilityInformation:he.accessibilityInformation,priority:he.priority}}be.from=Ie})(Ne=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ge;(function(be){function Ie(he){return{transientOutputs:he?.transientOutputs??!1,transientCellMetadata:he?.transientCellMetadata??{},transientDocumentMetadata:he?.transientDocumentMetadata??{}}}be.from=Ie})(Ge=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var et;(function(be){function Ie(V){return{uri:V.uri,provides:V.provides}}be.from=Ie;function he(V){return new w.NotebookRendererScript(D.URI.revive(V.uri),V.provides)}be.to=he})(et=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Qe;(function(be){function Ie(V){return{message:m.fromStrict(V.message)||"",severity:V.severity,expectedOutput:V.expectedOutput,actualOutput:V.actualOutput,location:V.location?q.from(V.location):void 0}}be.from=Ie;function he(V){const Me=new w.TestMessage(typeof V.message=="string"?V.message:m.to(V.message));return Me.severity=V.severity,Me.actualOutput=V.actualOutput,Me.expectedOutput=V.expectedOutput,Me}be.to=he})(Qe=e.TestMessage||(e.TestMessage={}));var Xe;(function(be){function Ie(Ye){return{extId:Ye.id,label:Ye.label,uri:Ye.uri,range:b.from(Ye.range)||null,description:Ye.description||null,error:Ye.error&&m.fromStrict(Ye.error)||null}}be.from=Ie;function he(Ye){return{extId:Ye.id,label:Ye.label,uri:Ye.uri,range:b.from(Ye.range)||null,description:Ye.description||null,error:null}}be.fromResultSnapshot=he;function V(Ye){return{id:Ye.extId,label:Ye.label,uri:D.URI.revive(Ye.uri),range:b.to(Ye.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Ye.description||void 0}}be.toPlain=V;function Me(Ye){const Ke=new u.TestItemImpl(Ye.extId,Ye.label,D.URI.revive(Ye.uri));return Ke.range=b.to(Ye.range||void 0),Ke.description=Ye.description||void 0,Ke}be.to=Me;function Be(Ye){let Ke;for(const ct of Ye.tests){const mt=Me(ct.item);(0,u.getPrivateApiFor)(mt).parent=Ke,Ke=mt}return Ke}be.toItemFromContext=Be})(Xe=e.TestItem||(e.TestItem={}));var lt;(function(be){const Ie=(V,Me)=>({...Xe.toPlain(V.item),taskStates:V.tasks.map(Be=>({state:Be.state,duration:Be.duration,messages:Be.messages.map(Qe.to)})),children:V.children.map(Be=>Me.get(Be)).filter(I.isDefined).map(Be=>Ie(Be,Me))});function he(V){const Me=[],Be=new Map;for(const Ye of V.items)Be.set(Ye.item.extId,Ye),V.request.targets.some(Ke=>Ke.controllerId===Ye.controllerId&&Ke.testIds.includes(Ye.item.extId))&&Me.push(Ye);return{completedAt:V.completedAt,results:Me.map(Ye=>Ie(Ye,Be))}}be.to=he})(lt=e.TestResults||(e.TestResults={}));var dt;(function(be){function Ie(Be){return{covered:Be.covered,total:Be.covered}}function he(Be){return"line"in Be?h.from(Be):b.from(Be)}function V(Be){return"branches"in Be?{count:Be.executionCount,location:he(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Ye=>({count:Ye.executionCount,location:Ye.location&&he(Ye.location)})):void 0}:{type:0,count:Be.executionCount,location:he(Be.location)}}be.fromDetailed=V;function Me(Be){return{uri:Be.uri,statement:Ie(Be.statementCoverage),branch:Be.branchCoverage&&Ie(Be.branchCoverage),function:Be.functionCoverage&&Ie(Be.functionCoverage),details:Be.detailedCoverage?.map(V)}}be.fromFile=Me})(dt=e.TestCoverage||(e.TestCoverage={}));var _t;(function(be){function Ie(he){switch(he){case 1:return w.CodeActionTriggerKind.Invoke;case 2:return w.CodeActionTriggerKind.Automatic}}be.to=Ie})(_t=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var at;(function(be){function Ie(V){const Me=new w.TypeHierarchyItem(j.to(V.kind),V.name,V.detail||"",D.URI.revive(V.uri),b.to(V.range),b.to(V.selectionRange));return Me._sessionId=V._sessionId,Me._itemId=V._itemId,Me}be.to=Ie;function he(V,Me,Be){if(Me=Me??V._sessionId,Be=Be??V._itemId,Me===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Be,kind:j.from(V.kind),name:V.name,detail:V.detail??"",uri:V.uri,range:b.from(V.range),selectionRange:b.from(V.selectionRange),tags:V.tags?.map(O.from)}}be.from=he})(at=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(me[211],ge([0,1,2,15,7,16,92]),function(J,e,p,L,C,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class I{constructor(A,i,P,c={timeout:1500,errors:3}){this._logService=A,this._documents=i,this._mainThreadBulkEdits=P,this._thresholds=c,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(A){return(i,P,c)=>{const a={dispose:this._callbacks.push([i,P,A])};return Array.isArray(c)&&c.push(a),a}}async $participateInSave(A,i){const P=p.URI.revive(A);let c=!1;const u=setTimeout(()=>c=!0,this._thresholds.timeout),a=[];try{for(let g of[...this._callbacks]){if(c)break;const w=this._documents.getDocument(P),_=await this._deliverEventAsyncAndBlameBadListeners(g,{document:w,reason:S.TextDocumentSaveReason.to(i)});a.push(_)}}finally{clearTimeout(u)}return a}_deliverEventAsyncAndBlameBadListeners([A,i,P],c){const u=this._badListeners.get(A);return typeof u=="number"&&u>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(P,A,i,c).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const g=this._badListeners.get(A);this._badListeners.set(A,g?g+1:1),typeof g=="number"&&g>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(A,i,P,c){const u=[],a=Date.now(),{document:g,reason:w}=c,{version:_}=g,b=Object.freeze({document:g,reason:w,waitUntil(d){if(Object.isFrozen(u))throw(0,L.illegalState)("waitUntil can not be called async");u.push(Promise.resolve(d))}});try{i.apply(P,[b])}catch(d){return Promise.reject(d)}return Object.freeze(u),new Promise((d,h)=>{const v=setTimeout(()=>h(new Error("timeout")),this._thresholds.timeout);return Promise.all(u).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(v),d(t)}).catch(t=>{clearTimeout(v),h(t)})}).then(d=>{const h={edits:[]};for(const v of d)if(Array.isArray(v)&&v.every(t=>t instanceof C.TextEdit))for(const{newText:t,newEol:s,range:r}of v)h.edits.push({_type:2,resource:g.uri,edit:{range:r&&S.Range.from(r),text:t,eol:s&&S.EndOfLine.from(s)}});if(h.edits.length!==0)return _===g.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(h):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=I}),define(me[212],ge([0,1,3,30,2,16,7]),function(J,e,p,L,C,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class I{constructor(i,P,c,u,a){this._onDidCreate=new p.Emitter,this._onDidChange=new p.Emitter,this._onDidDelete=new p.Emitter,this._config=0,c&&(this._config+=1),u&&(this._config+=2),a&&(this._config+=4);const g=(0,L.parse)(P),w=i(_=>{if(!c)for(let b of _.created){const d=C.URI.revive(b);g(d.fsPath)&&this._onDidCreate.fire(d)}if(!u)for(let b of _.changed){const d=C.URI.revive(b);g(d.fsPath)&&this._onDidChange.fire(d)}if(!a)for(let b of _.deleted){const d=C.URI.revive(b);g(d.fsPath)&&this._onDidDelete.fire(d)}});this._disposable=T.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class D{constructor(i,P,c){this._logService=P,this._extHostDocumentsAndEditors=c,this._onFileSystemEvent=new p.Emitter,this._onDidRenameFile=new p.Emitter,this._onDidCreateFile=new p.Emitter,this._onDidDeleteFile=new p.Emitter,this._onWillRenameFile=new p.AsyncEmitter,this._onWillCreateFile=new p.AsyncEmitter,this._onWillDeleteFile=new p.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(i,P,c,u){return new I(this._onFileSystemEvent.event,i,P,c,u)}$onFileEvent(i){this._onFileSystemEvent.fire(i)}$onDidRunFileOperation(i,P){switch(i){case 2:this._onDidRenameFile.fire(Object.freeze({files:P.map(c=>({oldUri:C.URI.revive(c.source),newUri:C.URI.revive(c.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:P.map(c=>C.URI.revive(c.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:P.map(c=>C.URI.revive(c.target))}));break;default:}}getOnWillRenameFileEvent(i){return this._createWillExecuteEvent(i,this._onWillRenameFile)}getOnWillCreateFileEvent(i){return this._createWillExecuteEvent(i,this._onWillCreateFile)}getOnWillDeleteFileEvent(i){return this._createWillExecuteEvent(i,this._onWillDeleteFile)}_createWillExecuteEvent(i,P){return(c,u,a)=>{const g=function(_){c.call(u,_)};return g.extension=i,P.event(g,void 0,a)}}async $onWillRunFileOperation(i,P,c,u){switch(i){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:P.map(a=>({oldUri:C.URI.revive(a.source),newUri:C.URI.revive(a.target)}))},c,u);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:P.map(a=>C.URI.revive(a.target))},c,u);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:P.map(a=>C.URI.revive(a.target))},c,u)}}async _fireWillEvent(i,P,c,u){const a=new Set,g=[];if(await i.fireAsync(P,u,async(_,b)=>{const d=Date.now(),h=await Promise.resolve(_);h instanceof T.WorkspaceEdit&&(g.push(h),a.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-d>c&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),u.isCancellationRequested||g.length===0)return;const w={edits:[]};for(let _ of g){let{edits:b}=S.WorkspaceEdit.from(_,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(b)}return{edit:w,extensionNames:Array.from(a)}}}e.ExtHostFileSystemEventService=D}),define(me[213],ge([0,1,10,25,2,16,7,87]),function(J,e,p,L,C,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(c,u,a,g){this.start=c,this.deletedCount=u,this.deletedItems=a,this.items=g}static asApiEvents(c){return c.map(u=>({start:u.start,deletedCount:u.deletedCount,deletedItems:u.deletedItems,items:u.items.map(a=>a.apiCell)}))}}class A{constructor(c,u,a){this.notebook=c,this._extHostDocument=u,this._cellData=a,this.handle=a.handle,this.uri=C.URI.revive(a.uri),this.cellKind=a.cellKind,this._outputs=a.outputs.map(S.NotebookCellOutput.to),this._internalMetadata=a.internalMetadata??{},this._metadata=a.metadata??{},this._previousResult=S.NotebookCellExecutionSummary.to(a.internalMetadata??{})}static asModelAddData(c,u){return{EOL:u.eol,lines:u.source,modeId:u.language,uri:u.uri,isDirty:!1,versionId:1,notebook:c}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const c=this,u=this._extHostDocument.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return c.notebook.getCellIndex(c)},notebook:c.notebook.apiNotebook,kind:S.NotebookCellKind.to(this._cellData.cellKind),document:u.document,get mime(){return c._mime},set mime(a){c._mime=a},get outputs(){return c._outputs.slice(0)},get metadata(){return c._metadata},get executionSummary(){return c._previousResult}})}return this._apiCell}setOutputs(c){this._outputs=c.map(S.NotebookCellOutput.to)}setOutputItems(c,u,a){const g=a.map(S.NotebookCellOutputItem.to),w=this._outputs.find(_=>_.id===c);w&&(u||(w.items.length=0),w.items.push(...g))}setMetadata(c){this._metadata=c}setInternalMetadata(c){this._internalMetadata=c,this._previousResult=S.NotebookCellExecutionSummary.to(c)}setMime(c){}}e.ExtHostCell=A;class i{constructor(c,u,a,g,w,_){this._proxy=c,this._textDocumentsAndEditors=u,this._textDocuments=a,this._emitter=g,this.uri=w,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=_.viewType,this._metadata=_.metadata??Object.create(null),this._spliceNotebookCells([[0,0,_.cells]],!0),this._versionId=_.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const c=this;this._notebook={get uri(){return c.uri},get version(){return c._versionId},get notebookType(){return c._notebookType},get isDirty(){return c._isDirty},get isUntitled(){return c.uri.scheme===p.Schemas.untitled},get isClosed(){return c._disposed},get metadata(){return c._metadata},get cellCount(){return c._cells.length},cellAt(u){return u=c._validateIndex(u),c._cells[u].apiCell},getCells(u){return(u?c._getCells(u):c._cells).map(g=>g.apiCell)},save(){return c._save()}}}return this._notebook}updateBackup(c){this._backup?.delete(),this._backup=c}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(c){c.metadata&&(this._metadata={...this._metadata,...c.metadata})}acceptDirty(c){this._isDirty=c}acceptModelChanged(c,u){this._versionId=c.versionId,this._isDirty=u;for(const a of c.rawEvents)a.kind===I.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1):a.kind===I.NotebookCellsChangeType.Move?this._moveCell(a.index,a.newIdx):a.kind===I.NotebookCellsChangeType.Output?this._setCellOutputs(a.index,a.outputs):a.kind===I.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems):a.kind===I.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(a.index,a.language):a.kind===I.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(a.index,a.mime):a.kind===I.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(a.index,a.metadata):a.kind===I.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(a.index,a.internalMetadata)}_validateIndex(c){return c=c|0,c<0?0:c>=this._cells.length?this._cells.length-1:c}_validateRange(c){let u=c.start|0,a=c.end|0;return u<0&&(u=0),a>this._cells.length&&(a=this._cells.length),c.with({start:u,end:a})}_getCells(c){c=this._validateRange(c);const u=[];for(let a=c.start;a<c.end;a++)u.push(this._cells[a]);return u}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(c,u){if(this._disposed)return;const a=[],g=[],w=[];c.reverse().forEach(_=>{const d=_[2].map(t=>{const s=new A(this,this._textDocumentsAndEditors,t);return u||g.push(A.asModelAddData(this.apiNotebook,t)),s}),h=new D(_[0],_[1],[],d),v=this._cells.splice(_[0],_[1],...d);for(const t of v)w.push(t.uri),h.deletedItems.push(t.apiCell);a.push(h)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:w}),u||this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(a)}))}_moveCell(c,u){const a=this._cells.splice(c,1);this._cells.splice(u,0,...a);const g=[new D(c,1,a.map(w=>w.apiCell),[]),new D(u,0,[],a)];this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(g)}))}_setCellOutputs(c,u){const a=this._cells[c];a.setOutputs(u),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[a.apiCell]}))}_setCellOutputItems(c,u,a,g){const w=this._cells[c];w.setOutputItems(u,a,g),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[w.apiCell]}))}_changeCellLanguage(c,u){const a=this._cells[c];a.apiCell.document.languageId!==u&&this._textDocuments.$acceptModelModeChanged(a.uri,u)}_changeCellMime(c,u){const a=this._cells[c];a.apiCell.mime=u}_changeCellMetadata(c,u){const a=this._cells[c],g=a.apiCell.metadata;a.setMetadata(u);const w=a.apiCell.metadata;(0,L.equals)(g,w)||this._emitter.emitCellMetadataChange((0,L.deepFreeze)({document:this.apiNotebook,cell:a.apiCell}))}_changeCellInternalMetadata(c,u){const a=this._cells[c],g=a.internalMetadata;if(a.setInternalMetadata(u),g.runState!==u.runState){const w=u.runState??T.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,L.deepFreeze)({document:this.apiNotebook,cell:a.apiCell,state:w}))}}getCellFromApiCell(c){return this._cells.find(u=>u.apiCell===c)}getCellFromIndex(c){return this._cells[c]}getCell(c){return this._cells.find(u=>u.handle===c)}getCellIndex(c){return this._cells.indexOf(c)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(me[125],ge([0,1,7,16,15]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class S{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,A){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:D,metadata:A})}replaceCells(D,A,i){this._throwIfFinalized(),!(D===A&&i.length===0)&&this._collectedEdits.push({editType:1,index:D,count:A-D,cells:i.map(L.NotebookCellData.from)})}}class T{constructor(D,A,i,P,c,u){this.id=D,this._proxy=A,this.notebookData=i,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=c,this._visibleRanges=P,this._viewColumn=u}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.apiNotebook},get selections(){return D._selections},set selections(A){if(!Array.isArray(A)||!A.every(p.NotebookRange.isNotebookRange))throw(0,C.illegalArgument)("selections");D._selections=A,D._trySetSelections(A)},get visibleRanges(){return D._visibleRanges},revealRange(A,i){D._proxy.$tryRevealRange(D.id,L.NotebookRange.from(A),i??p.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(A){const i=new S(this.document.version);return A(i),D._applyEdit(i.finalize())},setDecorations(A,i){return D.setDecorations(A,i)}},T.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_trySetSelections(D){this._proxy.$trySetSelections(this.id,D.map(L.NotebookRange.from))}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const A=[];let i=-1;for(let P=0;P<D.cellEdits.length;P++){if(i<0){A.push(D.cellEdits[P]),i++;continue}const u=A[i],a=D.cellEdits[P];if(u.editType===1&&a.editType===1&&u.index===a.index){u.cells.push(...D.cellEdits[P].cells),u.count+=D.cellEdits[P].count;continue}A.push(D.cellEdits[P]),i++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,A)}setDecorations(D,A){if(!(A.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return A.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(A),D.key)}}e.ExtHostNotebookEditor=T,T.apiEditorsToExtHost=new WeakMap}),define(me[214],ge([0,1,16,116,161,21,53]),function(J,e,p,L,C,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class I{constructor(P){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=P}withProgress(P,c,u){const a=this._handles++,{title:g,location:w,cancellable:_}=c,b={label:(0,C.localize)(0,null,P.displayName||P.name),id:P.identifier.value};return this._proxy.$startProgress(a,{location:p.ProgressLocation.from(w),title:g,source:b,cancellable:_},P),this._withProgress(a,u,!!_)}_withProgress(P,c,u){let a;u&&(a=new S.CancellationTokenSource,this._mapHandleToCancellationSource.set(P,a));const g=_=>{this._proxy.$progressEnd(_),this._mapHandleToCancellationSource.delete(_),a&&a.dispose()};let w;try{w=c(new A(this._proxy,P),u&&a?a.token:S.CancellationToken.None)}catch(_){throw g(P),_}return w.then(_=>g(P),_=>g(P)),w}$acceptProgressCanceled(P){const c=this._mapHandleToCancellationSource.get(P);c&&(c.cancel(),this._mapHandleToCancellationSource.delete(P))}}e.ExtHostProgress=I;function D(i,P){return i.message=P.message,typeof P.increment=="number"&&(typeof i.increment=="number"?i.increment+=P.increment:i.increment=P.increment),i}class A extends L.Progress{constructor(P,c){super(u=>this.throttledReport(u));this._proxy=P,this._handle=c}throttledReport(P){this._proxy.$progressReport(this._handle,P)}}Ve([(0,T.throttle)(100,(i,P)=>D(i,P),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(me[126],ge([0,1,52,15,71,16,7]),function(J,e,p,L,C,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class I{constructor(c,u,a){const g=I._Keys.nextId();c.$registerTextEditorDecorationType(u.identifier,g,S.DecorationRenderOptions.from(a)),this.value=Object.freeze({key:g,dispose(){c.$removeTextEditorDecorationType(g)}})}}e.TextEditorDecorationType=I,I._Keys=new C.IdGenerator("TextEditorDecorationType");class D{constructor(c,u){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=u.undoStopBefore,this._undoStopAfter=u.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,u){this._throwIfFinalized();let a=null;if(c instanceof T.Position)a=new T.Range(c,c);else if(c instanceof T.Range)a=c;else throw new Error("Unrecognized location");this._pushEdit(a,u,!1)}insert(c,u){this._throwIfFinalized(),this._pushEdit(new T.Range(c,c),u,!0)}delete(c){this._throwIfFinalized();let u=null;if(c instanceof T.Range)u=c;else throw new Error("Unrecognized location");this._pushEdit(u,null,!0)}_pushEdit(c,u,a){const g=this._document.validateRange(c);this._collectedEdits.push({range:g,text:u,forceMoveMarkers:a})}setEndOfLine(c){if(this._throwIfFinalized(),c!==T.EndOfLine.LF&&c!==T.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=c}}e.TextEditorEdit=D;class A{constructor(c,u,a,g){this._proxy=c,this._id=u,this._accept(a),this._logService=g;const w=this;this.value={get tabSize(){return w._tabSize},set tabSize(_){w._setTabSize(_)},get insertSpaces(){return w._insertSpaces},set insertSpaces(_){w._setInsertSpaces(_)},get cursorStyle(){return w._cursorStyle},set cursorStyle(_){w._setCursorStyle(_)},get lineNumbers(){return w._lineNumbers},set lineNumbers(_){w._setLineNumbers(_)}}}_accept(c){this._tabSize=c.tabSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=S.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const u=Math.floor(c);return u>0?u:null}if(typeof c=="string"){const u=parseInt(c,10);return isNaN(u)?null:u>0?u:null}return null}_setTabSize(c){const u=this._validateTabSize(c);if(u!==null){if(typeof u=="number"){if(this._tabSize===u)return;this._tabSize=u}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:u}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:Boolean(c)}_setInsertSpaces(c){const u=this._validateInsertSpaces(c);if(typeof u=="boolean"){if(this._insertSpaces===u)return;this._insertSpaces=u}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:u}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:S.TextEditorLineNumbersStyle.from(c)})))}assign(c){const u={};let a=!1;if(typeof c.tabSize!="undefined"){const g=this._validateTabSize(c.tabSize);g==="auto"?(a=!0,u.tabSize=g):typeof g=="number"&&this._tabSize!==g&&(this._tabSize=g,a=!0,u.tabSize=g)}if(typeof c.insertSpaces!="undefined"){const g=this._validateInsertSpaces(c.insertSpaces);g==="auto"?(a=!0,u.insertSpaces=g):this._insertSpaces!==g&&(this._insertSpaces=g,a=!0,u.insertSpaces=g)}typeof c.cursorStyle!="undefined"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,a=!0,u.cursorStyle=c.cursorStyle),typeof c.lineNumbers!="undefined"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,a=!0,u.lineNumbers=S.TextEditorLineNumbersStyle.from(c.lineNumbers)),a&&this._warnOnError(this._proxy.$trySetOptions(this._id,u))}_warnOnError(c){c.catch(u=>this._logService.warn(u))}}e.ExtHostTextEditorOptions=A;class i{constructor(c,u,a,g,w,_,b,d){this.id=c,this._proxy=u,this._logService=a,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=w,this._options=new A(this._proxy,this.id,_,a),this._visibleRanges=b,this._viewColumn=d;const h=this;this.value=Object.freeze({get document(){return g.getValue()},set document(v){throw(0,L.readonly)("document")},get selection(){return h._selections&&h._selections[0]},set selection(v){if(!(v instanceof T.Selection))throw(0,L.illegalArgument)("selection");h._selections=[v],h._trySetSelection()},get selections(){return h._selections},set selections(v){if(!Array.isArray(v)||v.some(t=>!(t instanceof T.Selection)))throw(0,L.illegalArgument)("selections");h._selections=v,h._trySetSelection()},get visibleRanges(){return h._visibleRanges},set visibleRanges(v){throw(0,L.readonly)("visibleRanges")},get options(){return h._options.value},set options(v){h._disposed||h._options.assign(v)},get viewColumn(){return h._viewColumn},set viewColumn(v){throw(0,L.readonly)("viewColumn")},edit(v,t={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new D(g.getValue(),t);return v(s),h._applyEdit(s)},insertSnippet(v,t,s={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=h._selections.map(n=>S.Range.from(n));else if(t instanceof T.Position){const{lineNumber:n,column:l}=S.Position.from(t);r=[{startLineNumber:n,startColumn:l,endLineNumber:n,endColumn:l}]}else if(t instanceof T.Range)r=[S.Range.from(t)];else{r=[];for(const n of t)if(n instanceof T.Range)r.push(S.Range.from(n));else{const{lineNumber:l,column:f}=S.Position.from(n);r.push({startLineNumber:l,startColumn:f,endLineNumber:l,endColumn:f})}}return u.$tryInsertSnippet(c,v.value,r,s)},setDecorations(v,t){const s=t.length===0;s&&!h._hasDecorationsForKey.has(v.key)||(s?h._hasDecorationsForKey.delete(v.key):h._hasDecorationsForKey.add(v.key),h._runOnProxy(()=>{if(S.isDecorationOptionsArr(t))return u.$trySetDecorations(c,v.key,S.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let n=0,l=t.length;n<l;n++){const f=t[n];r[4*n]=f.start.line+1,r[4*n+1]=f.start.character+1,r[4*n+2]=f.end.line+1,r[4*n+3]=f.end.character+1}return u.$trySetDecorationsFast(c,v.key,r)}}))},revealRange(v,t){h._runOnProxy(()=>u.$tryRevealRange(c,S.Range.from(v),t||T.TextEditorRevealType.Default))},show(v){u.$tryShowEditor(c,S.ViewColumn.from(v))},hide(){u.$tryHideEditor(c)}})}dispose(){(0,p.ok)(!this._disposed),this._disposed=!0}_acceptOptions(c){(0,p.ok)(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){(0,p.ok)(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){(0,p.ok)(!this._disposed),this._viewColumn=c}_acceptSelections(c){(0,p.ok)(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(S.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const u=c.finalize();if(u.edits.length===0&&!u.setEndOfLine)return Promise.resolve(!0);const a=u.edits.map(w=>w.range);a.sort((w,_)=>w.end.line===_.end.line?w.end.character===_.end.character?w.start.line===_.start.line?w.start.character-_.start.character:w.start.line-_.start.line:w.end.character-_.end.character:w.end.line-_.end.line);for(let w=0,_=a.length-1;w<_;w++){const b=a[w].end;if(a[w+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=u.edits.map(w=>({range:S.Range.from(w.range),text:w.text,forceMoveMarkers:w.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,u.documentVersionId,g,{setEndOfLine:typeof u.setEndOfLine=="number"?S.EndOfLine.from(u.setEndOfLine):void 0,undoStopBefore:u.undoStopBefore,undoStopAfter:u.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,u=>(u instanceof Error&&u.name==="DISPOSED"||this._logService.warn(u),null))}}e.ExtHostTextEditor=i}),define(me[215],ge([0,1,164,24,2,3,6,17,7,14,18,16,21]),function(J,e,p,L,C,S,T,I,D,A,i,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function u(w,_){if((0,A.isString)(w))return{label:w};if(w&&typeof w=="object"&&typeof w.label=="string"){let b;return Array.isArray(w.highlights)&&(b=w.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),b=b.length?b:void 0),{label:w.label,highlights:b}}}class a{constructor(_,b,d){this._proxy=_,this.commands=b,this.logService=d,this.treeViews=new Map;function h(v){return v&&v.$treeViewId&&v.$treeItemHandle}b.registerArgumentProcessor({processArgument:v=>h(v)?this.convertArgument(v):Array.isArray(v)&&v.length>0?v.map(t=>h(t)?this.convertArgument(t):t):v})}registerTreeDataProvider(_,b,d){const h=this.createTreeView(_,{treeDataProvider:b},d);return{dispose:()=>h.dispose()}}createTreeView(_,b,d){if(!b||!b.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const h=b.dragAndDropController!==void 0,v=this._proxy.$registerTreeViewDataProvider(_,{showCollapseAll:!!b.showCollapseAll,canSelectMany:!!b.canSelectMany,canDragAndDrop:h}),t=this.createExtHostTreeView(_,b,d);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(s){t.message=s},get title(){return t.title},set title(s){t.title=s},get description(){return t.description},set description(s){t.description=s},reveal:(s,r)=>t.reveal(s,r),dispose:async()=>{await v,this.treeViews.delete(_),t.dispose()}}}$getChildren(_,b){const d=this.treeViews.get(_);return d?d.getChildren(b):Promise.reject(new Error((0,p.localize)(0,null,_)))}$onDrop(_,b,d){const h=this.treeViews.get(_);return h?h.onDrop(b,d):Promise.reject(new Error((0,p.localize)(1,null,_)))}async $hasResolve(_){const b=this.treeViews.get(_);if(!b)throw new Error((0,p.localize)(2,null,_));return b.hasResolve}$resolve(_,b,d){const h=this.treeViews.get(_);if(!h)throw new Error((0,p.localize)(3,null,_));return h.resolveTreeItem(b,d)}$setExpanded(_,b,d){const h=this.treeViews.get(_);if(!h)throw new Error((0,p.localize)(4,null,_));h.setExpanded(b,d)}$setSelection(_,b){const d=this.treeViews.get(_);if(!d)throw new Error((0,p.localize)(5,null,_));d.setSelection(b)}$setVisible(_,b){const d=this.treeViews.get(_);if(!d)throw new Error((0,p.localize)(6,null,_));d.setVisible(b)}createExtHostTreeView(_,b,d){const h=new g(_,b,this._proxy,this.commands.converter,this.logService,d);return this.treeViews.set(_,h),h}convertArgument(_){const b=this.treeViews.get(_.$treeViewId);return b?b.getExtensionElement(_.$treeItemHandle):null}}e.ExtHostTreeViews=a;class g extends T.Disposable{constructor(_,b,d,h,v,t){super();if(this.viewId=_,this.proxy=d,this.commands=h,this.logService=v,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new S.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new S.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new S.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new S.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new S.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new c.CancellationTokenSource,t.contributes&&t.contributes.views)for(const n in t.contributes.views)for(const l of t.contributes.views[n])l.id===_&&(this._title=l.name);this.dataProvider=b.treeDataProvider,this.dndController=b.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(n=>this._onDidChangeData.fire({message:!1,element:n}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(n=>this._onDidChangeData.fire({message:!1,element:n})));let s,r;this._register(S.Event.debounce(this._onDidChangeData.event,(n,l)=>(n||(n={message:!1,elements:[]}),l.element!==!1&&(s||(s=new Promise(f=>r=f),this.refreshPromise=this.refreshPromise.then(()=>s)),Array.isArray(l.element)?n.elements.push(...l.element):n.elements.push(l.element)),l.message&&(n.message=!0),n),200,!0)(({message:n,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const f=r;return s=null,this.refresh(l).then(()=>f())})),n&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(_=>this.getExtensionElement(_)).filter(_=>!(0,A.isUndefinedOrNull)(_))}getChildren(_){const b=_?this.getExtensionElement(_):void 0;if(_&&!b)return this.logService.error(`No tree item with id '${_}' found.`),Promise.resolve([]);const d=this.getChildrenNodes(_);return(d?Promise.resolve(d):this.fetchChildrenNodes(b)).then(h=>h.map(v=>v.item))}getExtensionElement(_){return this.elements.get(_)}reveal(_,b){b=b||{select:!0,focus:!1};const d=(0,A.isUndefinedOrNull)(b.select)?!0:b.select,h=(0,A.isUndefinedOrNull)(b.focus)?!1:b.focus,v=(0,A.isUndefinedOrNull)(b.expand)?!1:b.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):_?this.refreshPromise.then(()=>this.resolveUnknownParentChain(_)).then(t=>this.resolveTreeNode(_,t[t.length-1]).then(s=>this.proxy.$reveal(this.viewId,{item:s.item,parentChain:t.map(r=>r.item)},{select:d,focus:h,expand:v})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:d,focus:h,expand:v})}get message(){return this._message}set message(_){this._message=_,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(_){this._title=_,this.proxy.$setTitle(this.viewId,_,this._description)}get description(){return this._description}set description(_){this._description=_,this.proxy.$setTitle(this.viewId,this._title,_)}setExpanded(_,b){const d=this.getExtensionElement(_);d&&(b?this._onDidExpandElement.fire(Object.freeze({element:d})):this._onDidCollapseElement.fire(Object.freeze({element:d})))}setSelection(_){(0,i.equals)(this._selectedHandles,_)||(this._selectedHandles=_,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(_){_!==this._visible&&(this._visible=_,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(_,b){const d=_.map(v=>this.getExtensionElement(v)).filter(v=>!(0,A.isUndefinedOrNull)(v)),h=this.getExtensionElement(b);return d&&h?(0,I.asPromise)(()=>this.dndController?.onDrop(d,h)):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(_,b){if(!this.dataProvider.resolveTreeItem)return;const d=this.elements.get(_);if(d){const h=this.nodes.get(d);if(h){const v=await this.dataProvider.resolveTreeItem(h.extensionItem,d,b)??h.extensionItem;return h.item.tooltip=this.getTooltip(v.tooltip),h.item.command=this.getCommand(h.disposableStore,v.command),h.item}}}resolveUnknownParentChain(_){return this.resolveParent(_).then(b=>b?this.resolveUnknownParentChain(b).then(d=>this.resolveTreeNode(b,d[d.length-1]).then(h=>(d.push(h),d))):Promise.resolve([]))}resolveParent(_){const b=this.nodes.get(_);return b?Promise.resolve(b.parent?this.elements.get(b.parent.item.handle):void 0):(0,I.asPromise)(()=>this.dataProvider.getParent(_))}resolveTreeNode(_,b){const d=this.nodes.get(_);return d?Promise.resolve(d):(0,I.asPromise)(()=>this.dataProvider.getTreeItem(_)).then(h=>this.createHandle(_,h,b,!0)).then(h=>this.getChildren(b?b.item.handle:void 0).then(()=>{const v=this.getExtensionElement(h);if(v){const t=this.nodes.get(v);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${h}`)}))}getChildrenNodes(_){if(_){let b;if(typeof _=="string"){const d=this.getExtensionElement(_);b=d?this.nodes.get(d):void 0}else b=_;return b&&b.children||null}return this.roots}async fetchChildrenNodes(_){this.clearChildren(_);const b=new c.CancellationTokenSource(this._refreshCancellationSource.token);try{const d=_?this.nodes.get(_):void 0,h=await this.dataProvider.getChildren(_);if(b.token.isCancellationRequested)return[];const v=await Promise.all((0,i.coalesce)(h||[]).map(async t=>{const s=await this.dataProvider.getTreeItem(t);return s&&!b.token.isCancellationRequested?this.createAndRegisterTreeNode(t,s,d):null}));return b.token.isCancellationRequested?[]:(0,i.coalesce)(v)}finally{b.dispose()}}refresh(_){if(_.some(d=>!d))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new c.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const d=this.getHandlesToRefresh(_);if(d.length)return this.refreshHandles(d)}return Promise.resolve(void 0)}getHandlesToRefresh(_){const b=new Set,d=_.map(v=>this.nodes.get(v));for(const v of d)if(v&&!b.has(v.item.handle)){let t=v;for(;t&&t.parent&&d.findIndex(s=>t&&t.parent&&s&&s.item.handle===t.parent.item.handle)===-1;){const s=this.elements.get(t.parent.item.handle);t=s?this.nodes.get(s):void 0}t&&!t.parent&&b.add(v.item.handle)}const h=[];return b.forEach(v=>{const t=this.elements.get(v);if(t){const s=this.nodes.get(t);s&&(!s.parent||!b.has(s.parent.item.handle))&&h.push(v)}}),h}refreshHandles(_){const b={};return Promise.all(_.map(d=>this.refreshNode(d).then(h=>{h&&(b[d]=h.item)}))).then(()=>Object.keys(b).length?this.proxy.$refresh(this.viewId,b):void 0)}refreshNode(_){const b=this.getExtensionElement(_);if(b){const d=this.nodes.get(b);if(d)return this.clearChildren(b),(0,I.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(h=>{if(h){const v=this.createTreeNode(b,h,d.parent);return this.updateNodeCache(b,v,d,d.parent),d.dispose(),v}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(_,b,d){const h=this.createTreeNode(_,b,d);if(b.id&&this.elements.has(h.item.handle))throw new Error((0,p.localize)(7,null,b.id));return this.addNodeToCache(_,h),this.addNodeToParentCache(h,d),h}getTooltip(_){return D.MarkdownString.isMarkdownString(_)?P.MarkdownString.from(_):_}getCommand(_,b){return b?this.commands.toInternal(b,_):void 0}createTreeNode(_,b,d){const h=new T.DisposableStore,v=this.createHandle(_,b,d),t=this.getLightIconPath(b);return{item:{handle:v,parentHandle:d?d.item.handle:void 0,label:u(b.label,this.extension),description:b.description,resourceUri:b.resourceUri,tooltip:this.getTooltip(b.tooltip),command:this.getCommand(h,b.command),contextValue:b.contextValue,icon:t,iconDark:this.getDarkIconPath(b)||t,themeIcon:this.getThemeIcon(b),collapsibleState:(0,A.isUndefinedOrNull)(b.collapsibleState)?D.TreeItemCollapsibleState.None:b.collapsibleState,accessibilityInformation:b.accessibilityInformation},extensionItem:b,parent:d,children:void 0,disposableStore:h,dispose(){h.dispose()}}}getThemeIcon(_){return _.iconPath instanceof D.ThemeIcon?_.iconPath:void 0}createHandle(_,{id:b,label:d,resourceUri:h},v,t){if(b)return`${g.ID_HANDLE_PREFIX}/${b}`;const s=u(d,this.extension),r=v?v.item.handle:g.LABEL_HANDLE_PREFIX;let n=s?s.label:h?(0,L.basename)(h):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const l=this.nodes.has(_)?this.nodes.get(_).item.handle:void 0,f=this.getChildrenNodes(v)||[];let m,E=0;do{if(m=`${r}/${E}:${n}`,t||!this.elements.has(m)||l===m)break;E++}while(E<=f.length);return m}getLightIconPath(_){if(_.iconPath&&!(_.iconPath instanceof D.ThemeIcon))return typeof _.iconPath=="string"||C.URI.isUri(_.iconPath)?this.getIconPath(_.iconPath):this.getIconPath(_.iconPath.light)}getDarkIconPath(_){if(_.iconPath&&!(_.iconPath instanceof D.ThemeIcon)&&_.iconPath.dark)return this.getIconPath(_.iconPath.dark)}getIconPath(_){return C.URI.isUri(_)?_:C.URI.file(_)}addNodeToCache(_,b){this.elements.set(b.item.handle,_),this.nodes.set(_,b)}updateNodeCache(_,b,d,h){this.elements.delete(b.item.handle),this.nodes.delete(_),b.item.handle!==d.item.handle&&this.elements.delete(d.item.handle),this.addNodeToCache(_,b);const v=this.getChildrenNodes(h)||[],t=v.filter(s=>s.item.handle===d.item.handle)[0];t&&v.splice(v.indexOf(t),1,b)}addNodeToParentCache(_,b){b?(b.children||(b.children=[]),b.children.push(_)):(this.roots||(this.roots=[]),this.roots.push(_))}clearChildren(_){if(_){const b=this.nodes.get(_);if(b){if(b.children)for(const d of b.children){const h=this.elements.get(d.item.handle);h&&this.clear(h)}b.children=void 0}}else this.clearAll()}clear(_){const b=this.nodes.get(_);if(b){if(b.children)for(const d of b.children){const h=this.elements.get(d.item.handle);h&&this.clear(h)}this.nodes.delete(_),this.elements.delete(b.item.handle),b.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(_=>_.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}g.LABEL_HANDLE_PREFIX="0",g.ID_HANDLE_PREFIX="1"}),define(me[216],ge([0,1,17,3,6,14,85,16,123]),function(J,e,p,L,C,S,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=void 0;var A;(function(c){c[c.Disconnected=0]="Disconnected",c[c.IsChild=1]="IsChild",c[c.IsParent=2]="IsParent",c[c.IsSame=3]="IsSame"})(A=e.TestPosition||(e.TestPosition={}));class i{constructor(){this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(u){if(this.map.has(u.actual.id))throw new Error(`Attempted to insert a duplicate test item ID ${u.actual.id}`);this.map.set(u.actual.id,u),u.parent||this._roots.add(u)}has(u){return this.map.has(u)}delete(u){const a=this.map.get(u);return a?(this.map.delete(u),this._roots.delete(a),!0):!1}get(u){return this.map.get(u)}comparePositions(u,a){const g=typeof u=="string"?this.map.get(u):u,w=typeof a=="string"?this.map.get(a):a;if(!g||!w)return 0;if(g===w)return 3;for(let _=this.map.get(w.parent);_;_=this.map.get(_.parent))if(_===g)return 1;for(let _=this.map.get(g.parent);_;_=this.map.get(_.parent))if(_===w)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=i;class P extends C.Disposable{constructor(u){super();this.controllerId=u,this.debounceSendDiff=this._register(new p.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.root=new T.TestItemImpl(`${this.controllerId}Root`,this.controllerId,void 0),this.tree=new i,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.upsertItem(this.root,null)}set resolveHandler(u){this._resolveHandler=u;for(const a of this.tree)this.updateExpandability(a)}collectDiff(){const u=this.diff;return this.diff=[],u}pushDiff(u){const a=this.diff[this.diff.length-1];if(a&&u[0]===1){if(a[0]===1&&a[1].extId===u[1].extId){(0,D.applyTestItemUpdate)(a[1],u[1]);return}if(a[0]===0&&a[1].item.extId===u[1].extId){(0,D.applyTestItemUpdate)(a[1],u[1]);return}}this.diff.push(u),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(u,a){const g=this.tree.get(u);if(!!g){if((g.expandLevels===void 0||a>g.expandLevels)&&(g.expandLevels=a),g.expand===1){const w=this.resolveChildren(g);return w.isOpen()?this.expandChildren(g,a-1):w.wait().then(()=>this.expandChildren(g,a-1))}else if(g.expand===3)return g.resolveBarrier?.isOpen()===!1?g.resolveBarrier.wait().then(()=>this.expandChildren(g,a-1)):this.expandChildren(g,a-1)}}dispose(){for(const u of this.tree)(0,T.getPrivateApiFor)(u.actual).listener=void 0;this.diff=[],super.dispose()}onTestItemEvent(u,a){const g=u?.actual.id;switch(a.op){case 2:this.pushDiff([4,g]);break;case 1:this.removeItem(a.id);break;case 0:this.upsertItem(a.item,u);break;case 4:for(const b of a.ops)this.onTestItemEvent(u,b);break;case 3:const{key:w,value:_}=a;switch(w){case"canResolveChildren":this.updateExpandability(u);break;case"range":this.pushDiff([1,{extId:g,item:{range:I.Range.from(_)}}]);break;case"error":this.pushDiff([1,{extId:g,item:{error:I.MarkdownString.fromStrict(_)||null}}]);break;default:this.pushDiff([1,{extId:g,item:{[w]:_??null}}]);break}break;default:(0,S.assertNever)(a)}}upsertItem(u,a){if(!(u instanceof T.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${u.id} did not`);let g=this.tree.get(u.id);if(g&&g.parent!==a?.actual.id&&((g.actual.parent??this.root).children.remove(u.id),g=void 0),!g){const d=a?a.actual.id:null,h=a?a.expandLevels:1;g={actual:u,parent:d,expandLevels:h?h-1:void 0,expand:0},this.tree.add(g),this.pushDiff([0,{parent:d,controllerId:this.controllerId,expand:g.expand,item:I.TestItem.from(u)}]),this.connectItemAndChildren(u,g,a);return}if(g.actual===u){this.connectItem(u,g,a);return}const w=g.actual.children.all,_=g.actual,b=(0,T.diffTestItems)(_,u);(0,T.getPrivateApiFor)(_).listener=void 0,g.actual=u,g.expand=0;for(const[d,h]of b)this.onTestItemEvent(g,{op:3,key:d,value:h});this.connectItemAndChildren(u,g,a);for(const d of w)!u.children.get(d.id)&&this.tree.get(d.id)?.parent===u.id&&this.removeItem(d.id)}connectItem(u,a,g){const w=(0,T.getPrivateApiFor)(u);w.parent=g&&g.actual!==this.root?g.actual:void 0,w.listener=_=>this.onTestItemEvent(a,_),this.updateExpandability(a)}connectItemAndChildren(u,a,g){this.connectItem(u,a,g);for(const w of u.children.all)this.upsertItem(w,a)}updateExpandability(u){let a;this._resolveHandler?u.resolveBarrier?a=u.resolveBarrier.isOpen()?3:2:a=u.actual.canResolveChildren?1:0:a=0,a!==u.expand&&(u.expand=a,this.pushDiff([1,{extId:u.actual.id,expand:a}]),a===1&&u.expandLevels!==void 0&&this.resolveChildren(u))}expandChildren(u,a){if(a<0)return;const g=u.actual.children.all.map(w=>this.expand(w.id,a)).filter(p.isThenable);if(g.length)return Promise.all(g).then(()=>{})}resolveChildren(u){if(u.resolveBarrier)return u.resolveBarrier;if(!this._resolveHandler){const w=new p.Barrier;return w.open(),w}u.expand=2,this.pushExpandStateUpdate(u);const a=u.resolveBarrier=new p.Barrier;let g;try{g=this._resolveHandler(u.actual)}catch(w){u.actual.error=w.stack||w.message}return(0,p.isThenable)(g)?g.catch(w=>u.actual.error=w.stack||w.message).then(()=>{a.open(),this.updateExpandability(u)}):(a.open(),this.updateExpandability(u)),u.resolveBarrier}pushExpandStateUpdate(u){this.pushDiff([1,{extId:u.actual.id,expand:u.expand}])}removeItem(u){const a=this.tree.get(u);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff([2,u]);const g=[a];for(;g.length;){const w=g.pop();if(!!w){(0,T.getPrivateApiFor)(w.actual).listener=void 0,this.tree.delete(w.actual.id);for(const _ of w.actual.children.all)g.push(this.tree.get(_.id))}}}flushDiff(){const u=this.collectDiff();u.length&&this.diffOpEmitter.fire(u)}}e.SingleUseTestCollection=P}),define(me[217],ge([0,1,4,178]),function(J,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,p.refineServiceDecorator)(L.IEnvironmentService)}),define(me[218],ge([0,1,26,3,9]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class S{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=S;class T{constructor(i){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(p.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(p.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let P of i.activationEvents)P==="onUri"&&(P=`onUri:${p.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(P)||this._activationMap.set(P,[]),this._activationMap.get(P).push(i)}}keepOnly(i){const P=new Set;i.forEach(c=>P.add(p.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>P.has(p.ExtensionIdentifier.toKey(c.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,P){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const c=T._findLoopingExtensions(this._extensionDescriptions);if(P=P.concat(c.map(u=>u.identifier)),P.length>0){const u=new Set;P.forEach(a=>u.add(p.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!u.has(p.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new S(c)}static _findLoopingExtensions(i){const P=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(w){this._nodesSet.has(w)||(this._nodesSet.add(w),this._nodesArr.push(w))}addArc(w,_){this.addNode(w),this.addNode(_),this._arcs.has(w)?this._arcs.get(w).push(_):this._arcs.set(w,[_])}getArcs(w){return this._arcs.has(w)?this._arcs.get(w):[]}hasOnlyGoodArcs(w,_){const b=P.getArcs(w);for(let d=0;d<b.length;d++)if(!_.has(b[d]))return!1;return!0}getNodes(){return this._nodesArr}};let c=new Map;for(let w of i){const _=p.ExtensionIdentifier.toKey(w.identifier);if(c.set(_,w),w.extensionDependencies)for(let b of w.extensionDependencies){const d=p.ExtensionIdentifier.toKey(b);P.addArc(_,d)}}let u=new Set;P.getNodes().filter(w=>P.getArcs(w).length===0).forEach(w=>u.add(w));let a=P.getNodes().filter(w=>!u.has(w)),g;do{g=!1;for(let w=0;w<a.length;w++){const _=a[w];P.hasOnlyGoodArcs(_,u)&&(a.splice(w,1),w--,u.add(_),g=!0)}}while(g);return a.map(w=>c.get(w))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(p.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const P=this._activationMap.get(i);return P?P.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const P=this._extensionsMap.get(p.ExtensionIdentifier.toKey(i));return P||void 0}}e.ExtensionDescriptionRegistry=T;var I;(function(A){A[A.Builtin=0]="Builtin",A[A.User=1]="User",A[A.Dev=2]="Dev"})(I||(I={}));function D(A,i){const P=A.isBuiltin?0:A.isUnderDevelopment?2:1,c=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(P!==c)return P-c;const u=C.posix.basename(A.extensionLocation.path),a=C.posix.basename(i.extensionLocation.path);return u<a?-1:u>a?1:0}}),define(me[219],ge([0,1,22]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var C;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(C=e.MessageType||(e.MessageType={}));function S(I){const D=p.VSBuffer.alloc(1);switch(I){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=S;function T(I,D){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=T}),define(me[34],ge([0,1,3,2,4,26,180]),function(J,e,p,L,C,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new S.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,C.createDecorator)("extensionService");class I{constructor(b){this.dependency=b}}e.MissingExtensionDependency=I;var D;(function(_){_[_.LocalProcess=0]="LocalProcess",_[_.LocalWebWorker=1]="LocalWebWorker",_[_.Remote=2]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));class A{constructor(b,d,h,v){this.codeLoadingTime=b,this.activateCallTime=d,this.activateResolvedTime=h,this.activationReason=v}}e.ActivationTimes=A;class i{constructor(b,d){this.description=b,this.value=d}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var P;(function(_){_[_.Normal=0]="Normal",_[_.Immediate=1]="Immediate"})(P=e.ActivationKind||(e.ActivationKind={}));function c(_){_.enableProposedApi||u(_)}e.checkProposedApiEnabled=c;function u(_){throw new Error(`[${_.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${_.identifier.value}`)}e.throwProposedApiError=u;function a(_){return{type:_.isBuiltin?0:1,isBuiltin:_.isBuiltin||_.isUserBuiltin,identifier:{id:(0,T.getGalleryExtensionId)(_.publisher,_.name),uuid:_.uuid},manifest:_,location:_.extensionLocation}}e.toExtension=a;function g(_,b){return{identifier:new S.ExtensionIdentifier(_.identifier.id),isBuiltin:_.type===0,isUserBuiltin:_.type===1&&_.isBuiltin,isUnderDevelopment:!!b,extensionLocation:_.location,..._.manifest,uuid:_.identifier.uuid}}e.toExtensionDescription=g;class w{constructor(){this.onDidRegisterExtensions=p.Event.None,this.onDidChangeExtensionsStatus=p.Event.None,this.onDidChangeExtensions=p.Event.None,this.onWillActivateByEvent=p.Event.None,this.onDidChangeResponsiveChange=p.Event.None}activateByEvent(b){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(b){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(b){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(b){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(b,d){return Promise.resolve()}_onWillActivateExtension(b){}_onDidActivateExtension(b,d,h,v,t){}_onDidActivateExtensionError(b,d){}_onExtensionRuntimeError(b,d){}_onExtensionHostExit(b){}}e.NullExtensionService=w}),define(me[220],ge([0,1,26,34,12]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const S=Promise.resolve(void 0);class T{constructor(a,g,w,_){this.startup=a,this.codeLoadingTime=g,this.activateCallTime=w,this.activateResolvedTime=_}}e.ExtensionActivationTimes=T,T.NONE=new T(!1,-1,-1,-1);class I{constructor(a){this._startup=a,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(a,g){return a===-1||g===-1?-1:g-a}build(){return new T(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=I;class D{constructor(a,g,w,_,b,d){this.activationFailed=a,this.activationFailedError=g,this.activationTimes=w,this.module=_,this.exports=b,this.subscriptions=d}}e.ActivatedExtension=D;class A extends D{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=A;class i extends D{constructor(){super(!1,null,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class P extends D{constructor(a){super(!0,a,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=P;let c=class{constructor(a,g,w,_,b){this._logService=b,this._registry=a,this._resolvedExtensionsSet=new Set,g.forEach(d=>this._resolvedExtensionsSet.add(p.ExtensionIdentifier.toKey(d))),this._hostExtensionsMap=new Map,w.forEach(d=>this._hostExtensionsMap.set(p.ExtensionIdentifier.toKey(d),d)),this._host=_,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(a){const g=p.ExtensionIdentifier.toKey(a);return this._activatedExtensions.has(g)}getActivatedExtension(a){const g=p.ExtensionIdentifier.toKey(a),w=this._activatedExtensions.get(g);if(!w)throw new Error("Extension `"+a.value+"` is not known or not activated");return w}activateByEvent(a,g){if(this._alreadyActivatedEvents[a])return S;const w=this._registry.getExtensionDescriptionsForActivationEvent(a);return this._activateExtensions(w.map(_=>({id:_.identifier,reason:{startup:g,extensionId:_.identifier,activationEvent:a}}))).then(()=>{this._alreadyActivatedEvents[a]=!0})}activateById(a,g){const w=this._registry.getExtensionDescription(a);if(!w)throw new Error("Extension `"+a+"` is not known");return this._activateExtensions([{id:w.identifier,reason:g}])}_handleActivateRequest(a,g,w){if(this._hostExtensionsMap.has(p.ExtensionIdentifier.toKey(a.id))){g[p.ExtensionIdentifier.toKey(a.id)]=a;return}const _=this._registry.getExtensionDescription(a.id);if(!_){const h=new Error(`Cannot activate unknown extension '${a.id.value}'`);this._host.onExtensionActivationError(a.id,h,new L.MissingExtensionDependency(a.id.value)),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(a.id),new P(h));return}const b=typeof _.extensionDependencies=="undefined"?[]:_.extensionDependencies;let d=!0;for(let h=0,v=b.length;h<v;h++){const t=b[h];if(this._resolvedExtensionsSet.has(p.ExtensionIdentifier.toKey(t)))continue;const s=this._activatedExtensions.get(p.ExtensionIdentifier.toKey(t));if(s&&!s.activationFailed)continue;if(s&&s.activationFailed){const f=_.displayName||_.identifier.value,m=this._registry.getExtensionDescription(t),E=m&&m.displayName||t,y=new Error(`Cannot activate the '${f}' extension because its dependency '${E}' failed to activate`);y.detail=s.activationFailedError,this._host.onExtensionActivationError(_.identifier,y,null),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(_.identifier),new P(y));return}if(this._hostExtensionsMap.has(p.ExtensionIdentifier.toKey(t))){d=!1,g[p.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(p.ExtensionIdentifier.toKey(t)),reason:a.reason};continue}const r=this._registry.getExtensionDescription(t);if(r){d=!1,g[p.ExtensionIdentifier.toKey(t)]={id:r.identifier,reason:a.reason};continue}const n=_.displayName||_.identifier.value,l=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(_.identifier,l,new L.MissingExtensionDependency(t)),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(_.identifier),new P(l));return}d?g[p.ExtensionIdentifier.toKey(_.identifier)]=a:w.push(a)}_activateExtensions(a){if(a.length===0||(a=a.filter(b=>!this._activatedExtensions.has(p.ExtensionIdentifier.toKey(b.id))),a.length===0))return Promise.resolve(void 0);const g=Object.create(null),w=[];for(let b=0,d=a.length;b<d;b++)this._handleActivateRequest(a[b],g,w);for(let b=0,d=w.length;b<d;b++){const h=p.ExtensionIdentifier.toKey(w[b].id);g[h]&&delete g[h]}const _=Object.keys(g).map(b=>g[b]);return w.length===0?Promise.all(_.map(b=>this._activateExtension(b.id,b.reason))).then(b=>{}):this._activateExtensions(_).then(b=>this._activateExtensions(w))}_activateExtension(a,g){const w=p.ExtensionIdentifier.toKey(a);if(this._activatedExtensions.has(w))return Promise.resolve(void 0);const _=this._activatingExtensions.get(w);if(_)return _;const b=this._host.actualActivateExtension(a,g).then(void 0,d=>{const h=new Error;return d&&d.name&&(h.name=d.name),d&&d.message?h.message=`Activating extension '${a.value}' failed: ${d.message}.`:h.message=`Activating extension '${a.value}' failed: ${d}.`,d&&d.stack&&(h.stack=d.stack),this._host.onExtensionActivationError(a,h,null),this._logService.error(`Activating extension ${a.value} failed due to an error:`),this._logService.error(d),new P(d)}).then(d=>{this._activatedExtensions.set(w,d),this._activatingExtensions.delete(w)});return this._activatingExtensions.set(w,b),b}};c=Ve([He(4,C.ILogService)],c),e.ExtensionsActivator=c}),define(me[221],ge([0,1,12,34,27,10,114]),function(J,e,p,L,C,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let I=class extends p.LogService{constructor(A){if(A.logFile.scheme!==S.Schemas.file)throw new Error("Only file-logging supported");super(new T.SpdLogLogger(L.ExtensionHostLogFileName,A.logFile.fsPath,!0,A.logLevel))}$setLevel(A){this.setLevel(A)}};I=Ve([He(0,C.IExtHostInitDataService)],I),e.ExtHostLogService=I}),define(me[222],ge([0,1,15]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((S,T)=>{this._actualOk=S,this._actualErr=T,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(S){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=S,this._actual&&this._actualOk(S))}resolveErr(S){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=S,this._actual?this._actualErr(S):(0,p.onUnexpectedError)(S))}then(S,T){return this._ensureActual().then(S,T)}catch(S){return this._ensureActual().then(void 0,S)}finally(S){return this._ensureActual().finally(S)}}e.LazyPromise=L}),define(me[127],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class p{constructor(D,A){this._proxyIdentifierBrand=void 0,this.isMain=D,this.sid=A,this.nid=++p.count}}e.ProxyIdentifier=p,p.count=0;const L=[];function C(I){const D=new p(!0,I);return L[D.nid]=D,D}e.createMainContextProxyIdentifier=C;function S(I){const D=new p(!1,I);return L[D.nid]=D,D}e.createExtHostContextProxyIdentifier=S;function T(I){return L[I].sid}e.getStringIdentifierForProxy=T}),define(me[5],ge([0,1,57,2,127]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var S;(function(d){d[d.Desktop=1]="Desktop",d[d.Web=2]="Web"})(S=e.UIKind||(e.UIKind={}));var T;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var A;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(A=e.CellOutputKind||(e.CellOutputKind={}));var i;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var P;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(P=e.CandidatePortSource||(e.CandidatePortSource={}));var c;(function(d){d.name="$ident";function h(t,s){return Object.defineProperty(t,d.name,{value:s,enumerable:!0}),t}d.mixin=h;function v(t){return t[d.name]}d.of=v})(c=e.ObjectIdentifier||(e.ObjectIdentifier={}));class u{static mixin(h){return h._id=u._n++,h}}e.IdObject=u,u._n=0;var a;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.command="m",d.kindModifier="n"})(a=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(d){d[d.File=1]="File",d[d.Text=2]="Text",d[d.Cell=3]="Cell"})(w=e.WorkspaceEditType||(e.WorkspaceEditType={}));function _(d){if(d&&d.edits)for(const h of d.edits)typeof h.resource=="object"?h.resource=L.URI.revive(h.resource):(h.newUri=L.URI.revive(h.newUri),h.oldUri=L.URI.revive(h.oldUri)),h.metadata&&h.metadata.iconPath&&(h.metadata=(0,p.revive)(h.metadata));return d}e.reviveWorkspaceEditDto=_;var b;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,C.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,C.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,C.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,C.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,C.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,C.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,C.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,C.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,C.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,C.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,C.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,C.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,C.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,C.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,C.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,C.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,C.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,C.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,C.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,C.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,C.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,C.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,C.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,C.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,C.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,C.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,C.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,C.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,C.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,C.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,C.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,C.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,C.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,C.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,C.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,C.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,C.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,C.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,C.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,C.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,C.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,C.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,C.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,C.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,C.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,C.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,C.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,C.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,C.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,C.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,C.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,C.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,C.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,C.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,C.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,C.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,C.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,C.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,C.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,C.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,C.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,C.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[88],ge([0,1,5,3,4]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class S{constructor(I){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=I.getProxy(p.MainContext.MainThreadSecretState)}async $onDidChangePassword(I){this._onDidChangePassword.fire(I)}get(I,D){return this._proxy.$getPassword(I,D)}store(I,D,A){return this._proxy.$setPassword(I,D,A)}delete(I,D){return this._proxy.$deletePassword(I,D)}}e.ExtHostSecretState=S,e.IExtHostSecretState=(0,C.createDecorator)("IExtHostSecretState")}),define(me[61],ge([0,1,4,12,5,13]),function(J,e,p,L,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,p.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(D,A){this._extHostLogService=A,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(C.MainContext.MainThreadTelemetry)}report(D,A,i){const P=this.getUsageKey(D,A);this._reportedUsages.has(P)||(this._reportedUsages.add(P),A.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:A.identifier.value,apiId:D}))}getUsageKey(D,A){return`${D}-${A.identifier.value}`}};T=Ve([He(0,S.IExtHostRpcService),He(1,L.ILogService)],T),e.ExtHostApiDeprecationService=T,e.NullApiDeprecationService=Object.freeze(new class{report(I,D,A){}})}),define(me[223],ge([0,1,3,5,7,26]),function(J,e,p,L,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new p.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}async getSession(D,A,i,P={}){const c=S.ExtensionIdentifier.toKey(D.identifier),u=this._inFlightRequests.get(c)||[],a=[...i].sort().join(" ");let g=u.find(w=>w.scopes===a);if(g)return g.result;{const w=this._getSession(D,c,A,i,P);g={scopes:a,result:w},u.push(g),this._inFlightRequests.set(c,u);try{await w}finally{const _=u.findIndex(b=>b.scopes===a);_>-1&&(u.splice(_),this._inFlightRequests.set(c,u))}return w}}async _getSession(D,A,i,P,c={}){await this._proxy.$ensureProvider(i);const u=D.displayName||D.name;return this._proxy.$getSession(i,P,A,u,c)}async removeSession(D,A){const i=this._authenticationProviders.get(D);return i?i.provider.removeSession(A):this._proxy.$removeSession(D,A)}registerAuthenticationProvider(D,A,i,P){if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:A,provider:i,options:P??{supportsMultipleAccounts:!1}}),this._providers.find(u=>u.id===D)||this._providers.push({id:D,label:A});const c=i.onDidChangeSessions(u=>{this._proxy.$sendDidChangeSessions(D,{added:u.added??[],changed:u.changed??[],removed:u.removed??[]})});return this._proxy.$registerAuthenticationProvider(D,A,P?.supportsMultipleAccounts??!1),new C.Disposable(()=>{c.dispose(),this._authenticationProviders.delete(D);const u=this._providers.findIndex(a=>a.id===D);u>-1&&this._providers.splice(u),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,A){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.createSession(A));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,A){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,A){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,A){return this._onDidChangeSessions.fire({provider:{id:D,label:A}}),Promise.resolve()}}e.ExtHostAuthentication=T}),define(me[224],ge([0,1,5,13,16]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let S=class{constructor(I,D){this._extHostDocumentsAndEditors=D,this._proxy=I.getProxy(p.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(I){const D=C.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};S=Ve([He(0,L.IExtHostRpcService)],S),e.ExtHostBulkEdits=S}),define(me[225],ge([0,1,5]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(S){const T=S.getProxy(p.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(I){return T.$writeText(I)}})}}e.ExtHostClipboard=L}),define(me[50],ge([0,1,14,7,16,25,5,18,12,57,40,46,2,6,4,13]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let w=class{constructor(t,s){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(T.MainContext.MainThreadCommands),this._logService=s,this.converter=new _(this,r=>{const n=this._apiCommands.get(r);return n?.result===d.Void?n:void 0},s),this._argumentProcessors=[{processArgument(r){return(0,A.revive)(r)}},{processArgument(r){return(0,S.cloneAndChange)(r,function(n){if(i.Range.isIRange(n))return C.Range.to(n);if(P.Position.isIPosition(n))return C.Position.to(n);if(i.Range.isIRange(n.range)&&c.URI.isUri(n.uri))return C.location.to(n);if(!Array.isArray(n))return n})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const s=this.registerCommand(!1,t.id,async(...r)=>{const n=t.args.map((f,m)=>{if(!f.validate(r[m]))throw new Error(`Invalid argument '${f.name}' when running '${t.id}', received: ${r[m]}`);return f.convert(r[m])}),l=await this.executeCommand(t.internalId,...n);return t.result.convert(l,r,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new L.Disposable(()=>{s.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,s,r,n,l){if(this._logService.trace("ExtHostCommands#registerCommand",s),!s.trim().length)throw new Error("invalid id");if(this._commands.has(s))throw new Error(`command '${s}' already exists`);return this._commands.set(s,{callback:r,thisArg:n,description:l}),t&&this._proxy.$registerCommand(s),new L.Disposable(()=>{this._commands.delete(s)&&t&&this._proxy.$unregisterCommand(s)})}executeCommand(t,...s){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,s,!0)}async _doExecuteCommand(t,s,r){if(this._commands.has(t))return this._executeContributedCommand(t,s);{const n=(0,S.cloneAndChange)(s,function(l){if(l instanceof L.Position)return C.Position.from(l);if(l instanceof L.Range)return C.Range.from(l);if(l instanceof L.Location)return C.location.from(l);if(L.NotebookRange.isNotebookRange(l))return C.NotebookRange.from(l);if(!Array.isArray(l))return l});try{const l=await this._proxy.$executeCommand(t,n,r);return(0,A.revive)(l)}catch(l){if(l instanceof Error&&l.message==="$executeCommand:retry")return this._doExecuteCommand(t,s,!1);throw l}}}async _executeContributedCommand(t,s){const r=this._commands.get(t);if(!r)throw new Error("Unknown command");let{callback:n,thisArg:l,description:f}=r;if(f)for(let m=0;m<f.args.length;m++)try{(0,p.validateConstraint)(s[m],f.args[m].constraint)}catch(E){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${f.args[m].name}' - ${f.args[m].description}`)}try{return await n.apply(l,s)}catch(m){if(t===this.converter.delegatingCommandId){const E=this.converter.getActualCommand(...s);E&&(t=E.command)}throw this._logService.error(m,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...s){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(s=s.map(r=>this._argumentProcessors.reduce((n,l)=>l.processArgument(n),r)),this._executeContributedCommand(t,s)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(s=>(t&&(s=s.filter(r=>r[0]!=="_")),s))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[s,r]of this._commands){let{description:n}=r;n&&(t[s]=n)}return Promise.resolve(t)}};w=Ve([He(0,g.IExtHostRpcService),He(1,D.ILogService)],w),e.ExtHostCommands=w,e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class _{constructor(t,s,r){this._commands=t,this._lookupApiCommand=s,this._logService=r,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,s){if(!t)return;const r={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return r;const n=this._lookupApiCommand(t.command);if(n)r.id=n.internalId,r.arguments=n.args.map((l,f)=>l.convert(t.arguments&&t.arguments[f]));else if((0,I.isNonEmptyArray)(t.arguments)){const l=++this._cachIdPool;this._cache.set(l,t),s.add((0,u.toDisposable)(()=>{this._cache.delete(l),this._logService.trace("CommandsConverter#DISPOSE",l)})),r.$ident=l,r.id=this.delegatingCommandId,r.arguments=[l],this._logService.trace("CommandsConverter#CREATE",t.command,l)}return r}fromInternal(t){const s=T.ObjectIdentifier.of(t);return typeof s=="number"?this._cache.get(s):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const s=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],s?s.command:"MISSING"),s?this._commands.executeCommand(s.command,...s.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=_;class b{constructor(t,s,r,n){this.name=t,this.description=s,this.validate=r,this.convert=n}optional(){return new b(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,s){return new b(t??this.name,s??this.description,this.validate,this.convert)}}e.ApiCommandArgument=b,b.Uri=new b("uri","Uri of a text document",v=>c.URI.isUri(v),v=>v),b.Position=new b("position","A position in a text document",v=>L.Position.isPosition(v),C.Position.from),b.Range=new b("range","A range in a text document",v=>L.Range.isRange(v),C.Range.from),b.Selection=new b("selection","A selection in a text document",v=>L.Selection.isSelection(v),C.Selection.from),b.Number=new b("number","",v=>typeof v=="number",v=>v),b.String=new b("string","",v=>typeof v=="string",v=>v),b.CallHierarchyItem=new b("item","A call hierarchy item",v=>v instanceof L.CallHierarchyItem,C.CallHierarchyItem.from),b.TypeHierarchyItem=new b("item","A type hierarchy item",v=>v instanceof L.TypeHierarchyItem,C.TypeHierarchyItem.from);class d{constructor(t,s){this.description=t,this.convert=s}}e.ApiCommandResult=d,d.Void=new d("no result",v=>v);class h{constructor(t,s,r,n,l){this.id=t,this.internalId=s,this.description=r,this.args=n,this.result=l}}e.ApiCommand=h}),define(me[226],ge([0,1,16,7,79,50,18,109]),function(J,e,p,L,C,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",i(p.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,u)=>{if((0,T.isFalsyOrEmpty)(c))return;class a extends L.SymbolInformation{static to(w){const _=new a(w.name,p.SymbolKind.to(w.kind),w.containerName||"",new L.Location(u[0],p.Range.to(w.range)));return _.detail=w.detail,_.range=_.location.range,_.selectionRange=p.Range.to(w.selectionRange),_.children=w.children?w.children.map(a.to):[],_}}return c.map(a.to)})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(p.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(p.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",c=>typeof c=="string",c=>c),new S.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(p.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",i(p.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",i(p.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",c=>Array.isArray(c)&&c.every(u=>L.Position.isPosition(u)),c=>c.map(p.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",c=>c.map(u=>{let a;for(const g of u.reverse())a=new L.SelectionRange(p.Range.to(g),a);return a}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",c=>{const u=[];if(Array.isArray(c))for(let a of c)u.push(...a[1].map(p.WorkspaceSymbol.to));return u})),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(p.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(p.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(p.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",c=>{if(!!c){if(c.rejectReason)throw new Error(c.rejectReason);return p.WorkspaceEdit.to(c)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(p.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new L.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const u=(0,I.decodeSemanticTokensDto)(c);if(u.type==="full")return new L.SemanticTokens(u.data,void 0)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new L.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const u=(0,I.decodeSemanticTokensDto)(c);if(u.type==="full")return new L.SemanticTokens(u.data,void 0)})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(c,u,a)=>{if(!c)return new L.CompletionList([]);const g=c.suggestions.map(w=>p.CompletionItem.to(w,a));return new L.CompletionList(g,c.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",c=>{if(c)return p.SignatureHelp.to(c)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(c,u,a)=>i(g=>new L.CodeLens(p.Range.to(g.range),g.command&&a.fromInternal(g.command)))(c))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>L.Range.isRange(c),c=>L.Selection.isSelection(c)?p.Selection.from(c):p.Range.from(c)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(c,u,a)=>i(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(g.command)}else{const w=new L.CodeAction(g.title,g.kind?new L.CodeActionKind(g.kind):void 0);return g.edit&&(w.edit=p.WorkspaceEdit.to(g.edit)),g.command&&(w.command=a.fromInternal(g.command)),w.isPreferred=g.isPreferred,w}})(c))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(u=>new L.ColorInformation(p.Range.to(u.range),p.Color.to(u.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",c=>c instanceof L.Color,p.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:p.Range.from(c.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(p.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of Inlay objects",c=>c.map(p.InlayHint.to))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",i(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(u=>p.NotebookExclusiveDocumentPattern.to(u))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",c=>c.map(p.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[p.ViewColumn.from(c.viewColumn),p.TextEditorOpenOptions.from(c)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[p.ViewColumn.from(c.viewColumn),p.TextEditorOpenOptions.from(c)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[p.ViewColumn.from(c.viewColumn),p.TextEditorOpenOptions.from(c)]).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(p.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(p.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(p.TypeHierarchyItem.to)))];class A{static register(u){D.forEach(u.registerApiCommand,u)}}e.ExtHostApiCommands=A;function i(c){return u=>{if(Array.isArray(u))return u.map(c)}}function P(c){if(!Array.isArray(c))return;const u=[];for(const a of c)C.isLocationLink(a)?u.push(p.DefinitionLink.to(a)):u.push(p.location.to(a));return u}}),define(me[227],ge([0,1,17,53,3,6,2,79,26,16,7,5]),function(J,e,p,L,C,S,T,I,D,A,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function c(u,a,g){const w=u.getProxy(P.MainContext.MainThreadComments);class _{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,a.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const l=this._commentControllers.get(n.handle);return l||n}else if(n&&n.$mid===7){const l=this._commentControllers.get(n.commentControlHandle);if(!l)return n;const f=l.getCommentThread(n.commentThreadHandle);return f||n}else if(n&&n.$mid===8){const l=this._commentControllers.get(n.thread.commentControlHandle);if(!l)return n;const f=l.getCommentThread(n.thread.commentThreadHandle);return f?{thread:f,text:n.text}:n}else if(n&&n.$mid===9){const l=this._commentControllers.get(n.thread.commentControlHandle);if(!l)return n;const f=l.getCommentThread(n.thread.commentThreadHandle);if(!f)return n;let m=n.commentUniqueId,E=f.getCommentByUniqueId(m);return E||n}else if(n&&n.$mid===10){const l=this._commentControllers.get(n.thread.commentControlHandle);if(!l)return n;const f=l.getCommentThread(n.thread.commentThreadHandle);if(!f)return n;let m=n.text,E=n.commentUniqueId,y=f.getCommentByUniqueId(E);return y?(y.body=m,y):n}return n}})}createCommentController(n,l,f){const m=_.handlePool++,E=new d(n,m,l,f);this._commentControllers.set(E.handle,E);const y=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(n.identifier))||[];return y.push(E),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(n.identifier),y),E.value}$createCommentThreadTemplate(n,l,f){const m=this._commentControllers.get(n);!m||m.$createCommentThreadTemplate(l,f)}async $updateCommentThreadTemplate(n,l,f){const m=this._commentControllers.get(n);!m||m.$updateCommentThreadTemplate(l,f)}$deleteCommentThread(n,l){const f=this._commentControllers.get(n);f&&f.$deleteCommentThread(l)}$provideCommentingRanges(n,l,f){const m=this._commentControllers.get(n);if(!m||!m.commentingRangeProvider)return Promise.resolve(void 0);const E=g.getDocument(T.URI.revive(l));return(0,p.asPromise)(()=>m.commentingRangeProvider.provideCommentingRanges(E,f)).then(y=>y?y.map(o=>A.Range.from(o)):void 0)}$toggleReaction(n,l,f,m,E){const y=this._commentControllers.get(n);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,p.asPromise)(()=>{const o=y.getCommentThread(l);if(o){const k=o.getCommentByUniqueId(m.uniqueIdInThread);if(y!==void 0&&k&&y.reactionHandler)return y.reactionHandler(k,t(E))}return Promise.resolve(void 0)})}dispose(){}}_.handlePool=0;class b{constructor(n,l,f,m,E,y,o){this._commentControllerHandle=l,this._id=f,this._uri=m,this._range=E,this._comments=y,this.handle=b._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new C.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new S.MutableDisposable,this._acceptInputDisposables.value=new S.DisposableStore,this._id===void 0&&(this._id=`${n}.${this.handle}`),w.$createCommentThread(l,this.handle,this._id,this._uri,A.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this._localDisposables.push({dispose:()=>{w.$deleteCommentThread(l,this.handle)}});const k=this;this.value={get uri(){return k.uri},get range(){return k.range},set range(F){k.range=F},get comments(){return k.comments},set comments(F){k.comments=F},get collapsibleState(){return k.collapsibleState},set collapsibleState(F){k.collapsibleState=F},get canReply(){return k.canReply},set canReply(F){k.canReply=F},get contextValue(){return k.contextValue},set contextValue(F){k.contextValue=F},get label(){return k.label},set label(F){k.label=F},dispose:()=>{k.dispose()}}}set threadId(n){this._id=n}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(n){n.isEqual(this._range)||(this._range=n,this.modifications.range=n,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(n){this._canReply!==n&&(this._canReply=n,this.modifications.canReply=n,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(n){this._label=n,this.modifications.label=n,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(n){this._contextValue=n,this.modifications.contextValue=n,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(n){this._comments=n,this.modifications.comments=n,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(n){this._collapseState=n,this.modifications.collapsibleState=n,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new S.DisposableStore);const n=f=>Object.prototype.hasOwnProperty.call(this.modifications,f),l={};n("range")&&(l.range=A.Range.from(this._range)),n("label")&&(l.label=this.label),n("contextValue")&&(l.contextValue=this.contextValue),n("comments")&&(l.comments=this._comments.map(f=>h(this,f,this._commentsMap))),n("collapsibleState")&&(l.collapseState=s(this._collapseState)),n("canReply")&&(l.canReply=this.canReply),this.modifications={},w.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,l)}getCommentByUniqueId(n){for(let l of this._commentsMap){let f=l[0],m=l[1];if(n===m)return f}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(n=>n.dispose())}}b._handlePool=0,Ve([(0,L.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class d{constructor(n,l,f,m){this._extension=n,this._handle=l,this._id=f,this._label=m,this._threads=new Map,w.$registerCommentController(this.handle,f,m);const E=this;this.value=Object.freeze({id:E.id,label:E.label,get options(){return E.options},set options(y){E.options=y},get commentingRangeProvider(){return E.commentingRangeProvider},set commentingRangeProvider(y){E.commentingRangeProvider=y},get reactionHandler(){return E.reactionHandler},set reactionHandler(y){E.reactionHandler=y},createCommentThread(y,o,k){return E.createCommentThread(y,o,k).value},dispose:()=>{E.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{w.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(n){this._reactionHandler=n,w.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!n})}get options(){return this._options}set options(n){this._options=n,w.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(n,l,f,m){if(typeof n=="string"){const E=new b(this.id,this.handle,n,l,f,m,this._extension.identifier);return this._threads.set(E.handle,E),E}else{const E=new b(this.id,this.handle,void 0,n,l,f,this._extension.identifier);return this._threads.set(E.handle,E),E}}$createCommentThreadTemplate(n,l){const f=new b(this.id,this.handle,void 0,T.URI.revive(n),A.Range.to(l),[],this._extension.identifier);return f.collapsibleState=I.CommentThreadCollapsibleState.Expanded,this._threads.set(f.handle,f),f}$updateCommentThreadTemplate(n,l){let f=this._threads.get(n);f&&(f.range=A.Range.to(l))}$deleteCommentThread(n){let l=this._threads.get(n);l&&l.dispose(),this._threads.delete(n)}getCommentThread(n){return this._threads.get(n)}dispose(){this._threads.forEach(n=>{n.dispose()}),this._localDisposables.forEach(n=>n.dispose())}}function h(r,n,l){let f=l.get(n);f||(f=++r.commentHandle,l.set(n,f));const m=n.author&&n.author.iconPath?n.author.iconPath.toString():void 0;return{mode:n.mode,contextValue:n.contextValue,uniqueIdInThread:f,body:A.MarkdownString.from(n.body),userName:n.author.name,userIconPath:m,label:n.label,commentReactions:n.reactions?n.reactions.map(E=>v(E)):void 0}}function v(r){return{label:r.label,iconPath:r.iconPath?A.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function t(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?T.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function s(r){if(r!==void 0)switch(r){case i.CommentThreadCollapsibleState.Expanded:return I.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return I.CommentThreadCollapsibleState.Collapsed}return I.CommentThreadCollapsibleState.Collapsed}return new _}e.createExtHostComments=c}),define(me[128],ge([0,1,2,5,7,4,13,12,18,8,9]),function(J,e,p,L,C,S,T,I,D,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let P=class bn{constructor(u,a){this._logService=a,this._provider=new Map,this._proxy=u.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(u,a){const g=bn._handlePool++;this._provider.set(g,{provider:u,extensionId:a}),this._proxy.$registerDecorationProvider(g,a.value);const w=u.onDidChangeFileDecorations&&u.onDidChangeFileDecorations(_=>{if(!_){this._proxy.$onDidChange(g,null);return}let b=(0,D.asArray)(_);if(b.length<=bn._maxEventSize){this._proxy.$onDidChange(g,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,b.length);const d=b.map(t=>({uri:t,rank:(0,A.count)(t.path,"/")})),h=(0,D.groupBy)(d,(t,s)=>t.rank-s.rank||(0,A.compare)(t.uri.path,s.uri.path));let v=[];e:for(let t of h){let s;for(let r of t){let n=(0,i.dirname)(r.uri.path);if(s!==n&&(s=n,v.push(r.uri)>=bn._maxEventSize))break e}}this._proxy.$onDidChange(g,v)});return new C.Disposable(()=>{w?.dispose(),this._proxy.$unregisterDecorationProvider(g),this._provider.delete(g)})}async $provideDecorations(u,a,g){if(!this._provider.has(u))return Object.create(null);const w=Object.create(null),{provider:_,extensionId:b}=this._provider.get(u);return await Promise.all(a.map(async d=>{try{const{uri:h,id:v}=d,t=await Promise.resolve(_.provideFileDecoration(p.URI.revive(h),g));if(!t)return;try{C.FileDecoration.validate(t),w[v]=[t.propagate,t.tooltip,t.badge,t.color]}catch(s){this._logService.warn(`INVALID decoration from extension '${b.value}': ${s}`)}}catch(h){this._logService.error(h)}})),w}};P._handlePool=0,P._maxEventSize=250,P=Ve([He(0,T.IExtHostRpcService),He(1,I.ILogService)],P),e.ExtHostDecorations=P,e.IExtHostDecorations=(0,S.createDecorator)("IExtHostDecorations")}),define(me[228],ge([0,1,159,115,2,5,7,16,3,12,23]),function(J,e,p,L,C,S,T,I,D,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class P{constructor(a,g,w,_,b){this._name=a,this._owner=g,this._maxDiagnosticsPerFile=w,this._proxy=_,this._onDidChangeDiagnostics=b,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,g){if(!a){this.clear();return}this._checkDisposed();let w=[];if(C.URI.isUri(a)){if(!g){this.delete(a);return}this._data.set(a,g.slice()),w=[a]}else if(Array.isArray(a)){w=[];let b;a=[...a].sort(P._compareIndexedTuplesByUri);for(const d of a){const[h,v]=d;if((!b||h.toString()!==b.toString())&&(b&&this._data.get(b).length===0&&this._data.delete(b),b=h,w.push(h),this._data.set(h,[])),v){const t=this._data.get(h);t&&t.push(...v)}else{const t=this._data.get(h);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(w),!this._proxy)return;const _=[];for(let b of w){let d=[];const h=this._data.get(b);if(h)if(h.length>this._maxDiagnosticsPerFile){d=[];const v=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let s of h)if(s.severity===v[t]&&d.push(I.Diagnostic.from(s))===this._maxDiagnosticsPerFile)break e;d.push({severity:L.MarkerSeverity.Info,message:(0,p.localize)(0,null,h.length-this._maxDiagnosticsPerFile),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=h.map(v=>I.Diagnostic.from(v));_.push([b,d])}this._proxy.$changeMany(this._owner,_)}delete(a){this._checkDisposed(),this._onDidChangeDiagnostics.fire([a]),this._data.delete(a),this._proxy&&this._proxy.$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(a,g){this._checkDisposed();for(let w of this._data.keys())a.apply(g,[w,this.get(w),this])}get(a){this._checkDisposed();const g=this._data.get(a);return Array.isArray(g)?Object.freeze(g.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(this._data.get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,g){return a[0].toString()<g[0].toString()?-1:a[0].toString()>g[0].toString()?1:0}}e.DiagnosticCollection=P;let c=class Gt{constructor(a,g){this._logService=g,this._collections=new Map,this._onDidChangeDiagnostics=new D.DebounceEmitter({merge:w=>w.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this._onDidChangeDiagnostics.event,Gt._mapper),this._proxy=a.getProxy(S.MainContext.MainThreadDiagnostics)}static _mapper(a){const g=new i.ResourceMap;for(const w of a)g.set(w,w);return{uris:Object.freeze(Array.from(g.values()))}}createDiagnosticCollection(a,g){const{_collections:w,_proxy:_,_onDidChangeDiagnostics:b,_logService:d}=this,h=new class{$changeMany(s,r){_.$changeMany(s,r),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,s,r.length===0?"CLEARING":r)}$clear(s){_.$clear(s),d.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,s)}dispose(){_.dispose()}};let v;if(!g)g="_generated_diagnostic_collection_name_#"+Gt._idPool++,v=g;else if(!w.has(g))v=g;else{this._logService.warn(`DiagnosticCollection with name '${g}' does already exist.`);do v=g+Gt._idPool++;while(w.has(v))}return new class extends P{constructor(){super(g,v,Gt._maxDiagnosticsPerFile,h,b);w.set(v,this)}dispose(){super.dispose(),w.delete(v)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const g=new Map,w=[];for(const _ of this._collections.values())_.forEach((b,d)=>{let h=g.get(b.toString());typeof h=="undefined"&&(h=w.length,g.set(b.toString(),h),w.push([b,[]])),w[h][1]=w[h][1].concat(...d)});return w}}_getDiagnostics(a){let g=[];for(let w of this._collections.values())w.has(a)&&(g=g.concat(w.get(a)));return g}$acceptMarkersChange(a){if(!this._mirrorCollection){const g="_generated_mirror",w=new P(g,g,Gt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(g,w),this._mirrorCollection=w}for(const[g,w]of a)this._mirrorCollection.set(C.URI.revive(g),w.map(I.Diagnostic.to))}};c._idPool=0,c._maxDiagnosticsPerFile=1e3,c=Ve([He(1,A.ILogService)],c),e.ExtHostDiagnostics=c}),define(me[229],ge([0,1,2,5]),function(J,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class C{constructor(T){this._proxy=T.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(T){return this._proxy.$showOpenDialog(T).then(I=>I?I.map(D=>p.URI.revive(D)):void 0)}showSaveDialog(T){return this._proxy.$showSaveDialog(T).then(I=>I?p.URI.revive(I):void 0)}}e.ExtHostDialogs=C}),define(me[230],ge([0,1,15,2,7,5,10,21,8]),function(J,e,p,L,C,S,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class A{constructor(P,c,u){this._documentsAndEditors=c,this._logService=u,this._documentContentProviders=new Map,this._proxy=P.getProxy(S.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,c){if(Object.keys(T.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const u=A._handlePool++;this._documentContentProviders.set(u,c),this._proxy.$registerTextContentProvider(u,P);let a;return typeof c.onDidChange=="function"&&(a=c.onDidChange(g=>{if(g.scheme!==P){this._logService.warn(`Provider for scheme '${P}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(g)&&this.$provideTextDocumentContent(u,g).then(w=>{if(!w&&typeof w!="string")return;const _=this._documentsAndEditors.getDocument(g);if(!_)return;const b=(0,D.splitLines)(w);if(!_.equalLines(b))return this._proxy.$onVirtualDocumentChange(g,w)},p.onUnexpectedError)})),new C.Disposable(()=>{this._documentContentProviders.delete(u)&&this._proxy.$unregisterTextContentProvider(u),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(P,c){const u=this._documentContentProviders.get(P);return u?Promise.resolve(u.provideTextDocumentContent(L.URI.revive(c),I.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=A,A._handlePool=0}),define(me[231],ge([0,1,3,6,2,5,120,16,14,25,7]),function(J,e,p,L,C,S,T,I,D,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class P{constructor(u,a){this._onDidAddDocument=new p.Emitter,this._onDidRemoveDocument=new p.Emitter,this._onDidChangeDocument=new p.Emitter,this._onDidSaveDocument=new p.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=u.getProxy(S.MainContext.MainThreadDocuments),this._documentsAndEditors=a,this._documentsAndEditors.onDidRemoveDocuments(g=>{for(const w of g)this._onDidRemoveDocument.fire(w.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(g=>{for(const w of g)this._onDidAddDocument.fire(w.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(u){if(!u)return;const a=this._documentsAndEditors.getDocument(u);if(a)return a}getDocument(u){const a=this.getDocumentData(u);if(!a?.document)throw new Error(`Unable to retrieve document from URI '${u}'`);return a.document}ensureDocumentData(u){const a=this._documentsAndEditors.getDocument(u);if(a)return Promise.resolve(a);let g=this._documentLoader.get(u.toString());return g||(g=this._proxy.$tryOpenDocument(u).then(w=>{this._documentLoader.delete(u.toString());const _=C.URI.revive(w);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(_))},w=>(this._documentLoader.delete(u.toString()),Promise.reject(w))),this._documentLoader.set(u.toString(),g)),g}createDocumentData(u){return this._proxy.$tryCreateDocument(u).then(a=>C.URI.revive(a))}$acceptModelModeChanged(u,a){const g=C.URI.revive(u),w=this._documentsAndEditors.getDocument(g);if(!w)throw new Error("unknown document");this._onDidRemoveDocument.fire(w.document),w._acceptLanguageId(a),this._onDidAddDocument.fire(w.document)}$acceptModelSaved(u){const a=C.URI.revive(u),g=this._documentsAndEditors.getDocument(a);if(!g)throw new Error("unknown document");this.$acceptDirtyStateChanged(u,!1),this._onDidSaveDocument.fire(g.document)}$acceptDirtyStateChanged(u,a){const g=C.URI.revive(u),w=this._documentsAndEditors.getDocument(g);if(!w)throw new Error("unknown document");w._acceptIsDirty(a),this._onDidChangeDocument.fire({document:w.document,contentChanges:[],reason:void 0})}$acceptModelChanged(u,a,g){const w=C.URI.revive(u),_=this._documentsAndEditors.getDocument(w);if(!_)throw new Error("unknown document");_._acceptIsDirty(g),_.onEvents(a);let b;a.isUndoing?b=i.TextDocumentChangeReason.Undo:a.isRedoing&&(b=i.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,A.deepFreeze)({document:_.document,contentChanges:a.changes.map(d=>({range:I.Range.to(d.range),rangeOffset:d.rangeOffset,rangeLength:d.rangeLength,text:d.text})),reason:b}))}setWordDefinitionFor(u,a){(0,T.setWordDefinitionFor)(u,a)}}e.ExtHostDocuments=P}),define(me[43],ge([0,1,52,3,6,2,4,5,120,13,126,16,12,23,10,72,136]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class _{constructor(h){this.value=h,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(h,v){this._extHostRpc=h,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new u.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(h){this.acceptDocumentsAndEditorsDelta(h)}acceptDocumentsAndEditorsDelta(h){const v=[],t=[],s=[];if(h.removedDocuments)for(const r of h.removedDocuments){const n=S.URI.revive(r),l=this._documents.get(n);l?.unref()&&(this._documents.delete(n),v.push(l.value))}if(h.addedDocuments)for(const r of h.addedDocuments){const n=S.URI.revive(r.uri);let l=this._documents.get(n);if(l&&n.scheme!==a.Schemas.vscodeNotebookCell&&n.scheme!==a.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);l||(l=new _(new D.ExtHostDocumentData(this._extHostRpc.getProxy(I.MainContext.MainThreadDocuments),n,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(n,l),t.push(l.value)),l.ref()}if(h.removedEditors)for(const r of h.removedEditors){const n=this._editors.get(r);this._editors.delete(r),n&&s.push(n)}if(h.addedEditors)for(const r of h.addedEditors){const n=S.URI.revive(r.documentUri);p.ok(this._documents.has(n),`document '${n}' does not exist`),p.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const l=this._documents.get(n).value,f=new i.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(I.MainContext.MainThreadTextEditors),this._logService,new w.Lazy(()=>l.document),r.selections.map(P.Selection.to),r.options,r.visibleRanges.map(m=>P.Range.to(m)),typeof r.editorPosition=="number"?P.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,f)}h.newActiveEditor!==void 0&&(p.ok(h.newActiveEditor===null||this._editors.has(h.newActiveEditor),`active editor '${h.newActiveEditor}' does not exist`),this._activeEditorId=h.newActiveEditor),(0,C.dispose)(v),(0,C.dispose)(s),h.removedDocuments&&this._onDidRemoveDocuments.fire(v),h.addedDocuments&&this._onDidAddDocuments.fire(t),(h.removedEditors||h.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),h.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(h){return this._documents.get(h)?.value}allDocuments(){return g.Iterable.map(this._documents.values(),h=>h.value)}getEditor(h){return this._editors.get(h)}activeEditor(h){if(!this._activeEditorId)return;const v=this._editors.get(this._activeEditorId);return h?v:v?.value}allEditors(){return[...this._editors.values()]}};b=Ve([He(0,A.IExtHostRpcService),He(1,c.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[232],ge([0,1,2,5,6,7,16,144,8,22]),function(J,e,p,L,C,S,T,I,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(u){this._stateMachine=void 0,this._schemes.push(u)}delete(u){const a=this._schemes.indexOf(u);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const u=this._schemes.sort(),a=[];let g,w,_=14,b=14;for(const d of u){let h=g?(0,D.commonPrefixLength)(g,d):0;for(h===0?w=1:w=b;h<d.length;h++)h+1===d.length?(_=b,b=9):b+=1,a.push([w,d.toUpperCase().charCodeAt(h),b]),a.push([w,d.toLowerCase().charCodeAt(h),b]),w=b;g=d,b=_}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new I.StateMachine(a)}}provideDocumentLinks(u){this._initStateMachine();const a=[],g=I.LinkComputer.computeLinks({getLineContent(w){return u.lineAt(w-1).text},getLineCount(){return u.lineCount}},this._stateMachine);for(const w of g){const _=T.DocumentLink.to(w);_.target&&a.push(_)}return a}}class P{constructor(u,a){this._extHostLanguageFeatures=a,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=u.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(u,a,g,w={},_){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const b=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(b,g),this._enableProposedApi.set(b,_??!1);let d=2;w.isCaseSensitive&&(d+=1024),w.isReadonly&&(d+=2048),typeof g.copy=="function"&&(d+=8),typeof g.open=="function"&&typeof g.close=="function"&&typeof g.read=="function"&&typeof g.write=="function"&&(d+=4),this._proxy.$registerFileSystemProvider(b,a,d).catch(v=>{console.error(`FAILED to register filesystem provider of ${u.value}-extension for the scheme ${a}`),console.error(v)});const h=g.onDidChangeFile(v=>{const t=[];for(const s of v){let{uri:r,type:n}=s;if(r.scheme!==a)continue;let l;switch(n){case S.FileChangeType.Changed:l=0;break;case S.FileChangeType.Created:l=1;break;case S.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:r,type:l})}this._proxy.$onFileSystemChange(b,t)});return(0,C.toDisposable)(()=>{h.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(b),this._enableProposedApi.delete(b),this._proxy.$unregisterProvider(b)})}static _asIStat(u,a){const{type:g,ctime:w,mtime:_,size:b,permissions:d}=u;return a?{type:g,ctime:w,mtime:_,size:b,permissions:d}:{type:g,ctime:w,mtime:_,size:b}}$stat(u,a){return Promise.resolve(this._getFsProvider(u).stat(p.URI.revive(a))).then(g=>P._asIStat(g,this._enableProposedApi.get(u)??!1))}$readdir(u,a){return Promise.resolve(this._getFsProvider(u).readDirectory(p.URI.revive(a)))}$readFile(u,a){return Promise.resolve(this._getFsProvider(u).readFile(p.URI.revive(a))).then(g=>A.VSBuffer.wrap(g))}$writeFile(u,a,g,w){return Promise.resolve(this._getFsProvider(u).writeFile(p.URI.revive(a),g.buffer,w))}$delete(u,a,g){return Promise.resolve(this._getFsProvider(u).delete(p.URI.revive(a),g))}$rename(u,a,g,w){return Promise.resolve(this._getFsProvider(u).rename(p.URI.revive(a),p.URI.revive(g),w))}$copy(u,a,g,w){const _=this._getFsProvider(u);if(!_.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(_.copy(p.URI.revive(a),p.URI.revive(g),w))}$mkdir(u,a){return Promise.resolve(this._getFsProvider(u).createDirectory(p.URI.revive(a)))}$watch(u,a,g,w){const _=this._getFsProvider(u).watch(p.URI.revive(g),w);this._watches.set(a,_)}$unwatch(u,a){const g=this._watches.get(a);g&&(g.dispose(),this._watches.delete(a))}$open(u,a,g){const w=this._getFsProvider(u);if(!w.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(w.open(p.URI.revive(a),g))}$close(u,a){const g=this._getFsProvider(u);if(!g.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(g.close(a))}$read(u,a,g,w){const _=this._getFsProvider(u);if(!_.read)throw new Error('FileSystemProvider does not implement "read"');const b=A.VSBuffer.alloc(w);return Promise.resolve(_.read(a,g,b.buffer,0,w)).then(d=>b.slice(0,d))}$write(u,a,g,w){const _=this._getFsProvider(u);if(!_.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(_.write(a,g,w.buffer,0,w.byteLength))}_getFsProvider(u){const a=this._fsProvider.get(u);if(!a){const g=new Error;throw g.name="ENOPRO",g.message="no provider",g}return a}}e.ExtHostFileSystem=P}),define(me[89],ge([0,1,5,41,7,22,4,13,59]),function(J,e,p,L,C,S,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let A=class Wt{constructor(P,c){const u=P.getProxy(p.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(a){return u.$stat(a).catch(Wt._handleError)},readDirectory(a){return u.$readdir(a).catch(Wt._handleError)},createDirectory(a){return u.$mkdir(a).catch(Wt._handleError)},async readFile(a){return u.$readFile(a).then(g=>g.buffer).catch(Wt._handleError)},writeFile(a,g){return u.$writeFile(a,S.VSBuffer.wrap(g)).catch(Wt._handleError)},delete(a,g){return u.$delete(a,{recursive:!1,useTrash:!1,...g}).catch(Wt._handleError)},rename(a,g,w){return u.$rename(a,g,{overwrite:!1,...w}).catch(Wt._handleError)},copy(a,g,w){return u.$copy(a,g,{overwrite:!1,...w}).catch(Wt._handleError)},isWritableFileSystem(a){const g=c.getCapabilities(a);if(typeof g=="number")return!(g&2048)}})}static _handleError(P){if(!(P instanceof Error))throw new C.FileSystemError(String(P));if(P.name==="ENOPRO")throw C.FileSystemError.Unavailable(P.message);switch(P.name){case L.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(P.message);case L.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(P.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(P.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(P.message);case L.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(P.message);case L.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(P.message);default:throw new C.FileSystemError(P.message,P.name)}}};A=Ve([He(0,I.IExtHostRpcService),He(1,D.IExtHostFileSystemInfo)],A),e.ExtHostConsumerFileSystem=A,e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(me[233],ge([0,1,6,5]),function(J,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class C{constructor(T){this._handlePool=0,this._proxy=T.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const I=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(I,T),(0,p.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(I)})}}e.ExtHostLabelService=C}),define(me[234],ge([0,1,2,25,16,7,5,8,40,18,14,141,6,109,71,84,44,15,3]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a,g,w,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class d{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentSymbols(W,Z){const te=this._documents.getDocument(W),ae=await this._provider.provideDocumentSymbols(te,Z);if(!(0,A.isFalsyOrEmpty)(ae))return ae[0]instanceof S.DocumentSymbol?ae.map(C.DocumentSymbol.from):d._asDocumentSymbolTree(ae)}static _asDocumentSymbolTree(W){W=W.slice(0).sort((ae,Y)=>{let se=ae.location.range.start.compareTo(Y.location.range.start);return se===0&&(se=Y.location.range.end.compareTo(ae.location.range.end)),se});const Z=[],te=[];for(const ae of W){const Y={name:ae.name||"!!MISSING: name!!",kind:C.SymbolKind.from(ae.kind),tags:ae.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:C.Range.from(ae.location.range),selectionRange:C.Range.from(ae.location.range),children:[]};for(;;){if(te.length===0){te.push(Y),Z.push(Y);break}const se=te[te.length-1];if(D.Range.containsRange(se.range,Y.range)&&!D.Range.equalsRange(se.range,Y.range)){se.children&&se.children.push(Y),te.push(Y);break}te.pop()}}return Z}}class h{constructor(W,Z,te){this._documents=W,this._commands=Z,this._provider=te,this._cache=new g.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(W,Z){const te=this._documents.getDocument(W),ae=await this._provider.provideCodeLenses(te,Z);if(!ae||Z.isCancellationRequested)return;const Y=this._cache.add(ae),se=new c.DisposableStore;this._disposables.set(Y,se);const we={cacheId:Y,lenses:[]};for(let Fe=0;Fe<ae.length;Fe++)we.lenses.push({cacheId:[Y,Fe],range:C.Range.from(ae[Fe].range),command:this._commands.toInternal(ae[Fe].command,se)});return we}async resolveCodeLens(W,Z){const te=W.cacheId&&this._cache.get(...W.cacheId);if(!te)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||te.isResolved?ae=te:ae=await this._provider.resolveCodeLens(te,Z),ae||(ae=te),Z.isCancellationRequested)return;const Y=W.cacheId&&this._disposables.get(W.cacheId[0]);if(!!Y)return W.command=this._commands.toInternal(ae.command??h._badCmd,Y),W}releaseCodeLenses(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}}h._badCmd={command:"missing",title:"!!MISSING: command!!"};function v(je){return Array.isArray(je)?je.map(C.DefinitionLink.from):je?[C.DefinitionLink.from(je)]:[]}class t{constructor(W,Z){this._documents=W,this._provider=Z}async provideDefinition(W,Z,te){const ae=this._documents.getDocument(W),Y=C.Position.to(Z),se=await this._provider.provideDefinition(ae,Y,te);return v(se)}}class s{constructor(W,Z){this._documents=W,this._provider=Z}async provideDeclaration(W,Z,te){const ae=this._documents.getDocument(W),Y=C.Position.to(Z),se=await this._provider.provideDeclaration(ae,Y,te);return v(se)}}class r{constructor(W,Z){this._documents=W,this._provider=Z}async provideImplementation(W,Z,te){const ae=this._documents.getDocument(W),Y=C.Position.to(Z),se=await this._provider.provideImplementation(ae,Y,te);return v(se)}}class n{constructor(W,Z){this._documents=W,this._provider=Z}async provideTypeDefinition(W,Z,te){const ae=this._documents.getDocument(W),Y=C.Position.to(Z),se=await this._provider.provideTypeDefinition(ae,Y,te);return v(se)}}class l{constructor(W,Z){this._documents=W,this._provider=Z}async provideHover(W,Z,te){const ae=this._documents.getDocument(W),Y=C.Position.to(Z),se=await this._provider.provideHover(ae,Y,te);if(!(!se||(0,A.isFalsyOrEmpty)(se.contents)))return se.range||(se.range=ae.getWordRangeAtPosition(Y)),se.range||(se.range=new S.Range(Y,Y)),C.Hover.from(se)}}class f{constructor(W,Z){this._documents=W,this._provider=Z}async provideEvaluatableExpression(W,Z,te){const ae=this._documents.getDocument(W),Y=C.Position.to(Z),se=await this._provider.provideEvaluatableExpression(ae,Y,te);if(se)return C.EvaluatableExpression.from(se)}}class m{constructor(W,Z){this._documents=W,this._provider=Z}async provideInlineValues(W,Z,te,ae){const Y=this._documents.getDocument(W),se=await this._provider.provideInlineValues(Y,C.Range.to(Z),C.InlineValueContext.to(te),ae);if(Array.isArray(se))return se.map(we=>C.InlineValue.from(we))}}class E{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentHighlights(W,Z,te){const ae=this._documents.getDocument(W),Y=C.Position.to(Z),se=await this._provider.provideDocumentHighlights(ae,Y,te);if(Array.isArray(se))return se.map(C.DocumentHighlight.from)}}class y{constructor(W,Z){this._documents=W,this._provider=Z}async provideLinkedEditingRanges(W,Z,te){const ae=this._documents.getDocument(W),Y=C.Position.to(Z),se=await this._provider.provideLinkedEditingRanges(ae,Y,te);if(se&&Array.isArray(se.ranges))return{ranges:(0,A.coalesce)(se.ranges.map(C.Range.from)),wordPattern:se.wordPattern}}}class o{constructor(W,Z){this._documents=W,this._provider=Z}async provideReferences(W,Z,te,ae){const Y=this._documents.getDocument(W),se=C.Position.to(Z),we=await this._provider.provideReferences(Y,se,te,ae);if(Array.isArray(we))return we.map(C.location.from)}}class k{constructor(W,Z,te,ae,Y,se,we){this._documents=W,this._commands=Z,this._diagnostics=te,this._provider=ae,this._logService=Y,this._extension=se,this._apiDeprecation=we,this._cache=new g.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(W,Z,te,ae){const Y=this._documents.getDocument(W),se=P.Selection.isISelection(Z)?C.Selection.to(Z):C.Range.to(Z),we=[];for(const ie of this._diagnostics.getDiagnostics(W))if(se.intersection(ie.range)&&we.push(ie)>k._maxCodeActionsPerFile)break;const Fe={diagnostics:we,only:te.only?new S.CodeActionKind(te.only):void 0,triggerKind:C.CodeActionTriggerKind.to(te.trigger)},ze=await this._provider.provideCodeActions(Y,se,Fe,ae);if(!(0,A.isNonEmptyArray)(ze)||ae.isCancellationRequested)return;const _e=this._cache.add(ze),Ze=new c.DisposableStore;this._disposables.set(_e,Ze);const X=[];for(let ie=0;ie<ze.length;ie++){const fe=ze[ie];!fe||(k._isCommand(fe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),X.push({_isSynthetic:!0,title:fe.title,command:this._commands.toInternal(fe,Ze)})):(Fe.only&&(fe.kind?Fe.only.contains(fe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Fe.only.value} 'requested but returned code action is of kind '${fe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Fe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),X.push({cacheId:[_e,ie],title:fe.title,command:fe.command&&this._commands.toInternal(fe.command,Ze),diagnostics:fe.diagnostics&&fe.diagnostics.map(C.Diagnostic.from),edit:fe.edit&&C.WorkspaceEdit.from(fe.edit),kind:fe.kind&&fe.kind.value,isPreferred:fe.isPreferred,disabled:fe.disabled?.reason})))}return{cacheId:_e,actions:X}}async resolveCodeAction(W,Z){const[te,ae]=W,Y=this._cache.get(te,ae);if(!Y||k._isCommand(Y)||!this._provider.resolveCodeAction)return;const se=await this._provider.resolveCodeAction(Y,Z)??Y;return se?.edit?C.WorkspaceEdit.from(se.edit):void 0}releaseCodeActions(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}static _isCommand(W){return typeof W.command=="string"&&typeof W.title=="string"}}k._maxCodeActionsPerFile=1e3;class F{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentFormattingEdits(W,Z,te){const ae=this._documents.getDocument(W),Y=await this._provider.provideDocumentFormattingEdits(ae,Z,te);if(Array.isArray(Y))return Y.map(C.TextEdit.from)}}class ${constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentRangeFormattingEdits(W,Z,te,ae){const Y=this._documents.getDocument(W),se=C.Range.to(Z),we=await this._provider.provideDocumentRangeFormattingEdits(Y,se,te,ae);if(Array.isArray(we))return we.map(C.TextEdit.from)}}class Q{constructor(W,Z){this._documents=W,this._provider=Z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(W,Z,te,ae,Y){const se=this._documents.getDocument(W),we=C.Position.to(Z),Fe=await this._provider.provideOnTypeFormattingEdits(se,we,te,ae,Y);if(Array.isArray(Fe))return Fe.map(C.TextEdit.from)}}class oe{constructor(W,Z){this._provider=W,this._logService=Z,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(W,Z){const te=T.IdObject.mixin({symbols:[]}),ae=await this._provider.provideWorkspaceSymbols(W,Z);if((0,A.isNonEmptyArray)(ae))for(const Y of ae){if(!Y)continue;if(!Y.name){this._logService.warn("INVALID SymbolInformation, lacks name",Y);continue}const se=T.IdObject.mixin(C.WorkspaceSymbol.from(Y));this._symbolCache.set(se._id,Y),te.symbols.push(se)}return te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te}async resolveWorkspaceSymbol(W,Z){if(typeof this._provider.resolveWorkspaceSymbol!="function")return W;const te=this._symbolCache.get(W._id);if(te){const ae=await this._provider.resolveWorkspaceSymbol(te,Z);return ae&&(0,L.mixin)(W,C.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(W){const Z=this._resultCache.get(W);if(Z){for(let[te,ae]=Z;te<=ae;te++)this._symbolCache.delete(te);this._resultCache.delete(W)}}}class j{constructor(W,Z,te){this._documents=W,this._provider=Z,this._logService=te}static supportsResolving(W){return typeof W.prepareRename=="function"}async provideRenameEdits(W,Z,te,ae){const Y=this._documents.getDocument(W),se=C.Position.to(Z);try{const we=await this._provider.provideRenameEdits(Y,se,te,ae);return we?C.WorkspaceEdit.from(we):void 0}catch(we){const Fe=j._asMessage(we);return Fe?{rejectReason:Fe,edits:void 0}:Promise.reject(we)}}async resolveRenameLocation(W,Z,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(W),Y=C.Position.to(Z);try{const se=await this._provider.prepareRename(ae,Y,te);let we,Fe;if(S.Range.isRange(se)?(we=se,Fe=ae.getText(se)):(0,i.isObject)(se)&&(we=se.range,Fe=se.placeholder),!we||!Fe)return;if(we.start.line>Y.line||we.end.line<Y.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(we),text:Fe}}catch(se){const we=j._asMessage(se);return we?{rejectReason:we,range:void 0,text:void 0}:Promise.reject(se)}}static _asMessage(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class O{constructor(W,Z){this.resultId=W,this.tokens=Z}}class B{constructor(W,Z){this._documents=W,this._provider=Z,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(W,Z,te){const ae=this._documents.getDocument(W),Y=Z!==0?this._previousResults.get(Z):null;let se=typeof Y?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ae,Y.resultId,te):await this._provider.provideDocumentSemanticTokens(ae,te);return Y&&this._previousResults.delete(Z),se?(se=B._fixProvidedSemanticTokens(se),this._send(B._convertToEdits(Y,se),se)):null}async releaseDocumentSemanticColoring(W){this._previousResults.delete(W)}static _fixProvidedSemanticTokens(W){return B._isSemanticTokens(W)?B._isCorrectSemanticTokens(W)?W:new S.SemanticTokens(new Uint32Array(W.data),W.resultId):B._isSemanticTokensEdits(W)?B._isCorrectSemanticTokensEdits(W)?W:new S.SemanticTokensEdits(W.edits.map(Z=>new S.SemanticTokensEdit(Z.start,Z.deleteCount,Z.data?new Uint32Array(Z.data):Z.data)),W.resultId):W}static _isSemanticTokens(W){return W&&!!W.data}static _isCorrectSemanticTokens(W){return W.data instanceof Uint32Array}static _isSemanticTokensEdits(W){return W&&Array.isArray(W.edits)}static _isCorrectSemanticTokensEdits(W){for(const Z of W.edits)if(!(Z.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(W,Z){if(!B._isSemanticTokens(Z)||!W||!W.tokens)return Z;const te=W.tokens,ae=te.length,Y=Z.data,se=Y.length;let we=0;const Fe=Math.min(ae,se);for(;we<Fe&&te[we]===Y[we];)we++;if(we===ae&&we===se)return new S.SemanticTokensEdits([],Z.resultId);let ze=0;const _e=Fe-we;for(;ze<_e&&te[ae-ze-1]===Y[se-ze-1];)ze++;return new S.SemanticTokensEdits([{start:we,deleteCount:ae-we-ze,data:Y.subarray(we,se-ze)}],Z.resultId)}_send(W,Z){if(B._isSemanticTokens(W)){const te=this._nextResultId++;return this._previousResults.set(te,new O(W.resultId,W.data)),(0,u.encodeSemanticTokensDto)({id:te,type:"full",data:W.data})}if(B._isSemanticTokensEdits(W)){const te=this._nextResultId++;return B._isSemanticTokens(Z)?this._previousResults.set(te,new O(Z.resultId,Z.data)):this._previousResults.set(te,new O(W.resultId)),(0,u.encodeSemanticTokensDto)({id:te,type:"delta",deltas:(W.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=B;class R{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentRangeSemanticTokens(W,Z,te){const ae=this._documents.getDocument(W),Y=await this._provider.provideDocumentRangeSemanticTokens(ae,C.Range.to(Z),te);return Y?this._send(Y):null}_send(W){return(0,u.encodeSemanticTokensDto)({id:0,type:"full",data:W.data})}}e.DocumentRangeSemanticTokensAdapter=R;class z{constructor(W,Z,te,ae,Y){this._documents=W,this._commands=Z,this._provider=te,this._apiDeprecation=ae,this._extension=Y,this._cache=new g.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}async provideCompletionItems(W,Z,te,ae){const Y=this._documents.getDocument(W),se=C.Position.to(Z),we=Y.getWordRangeAtPosition(se)||new S.Range(se,se),Fe=we.with({end:se}),ze=new w.StopWatch(!0),_e=await this._provider.provideCompletionItems(Y,se,ae,C.CompletionContext.to(te));if(!_e||ae.isCancellationRequested)return;const Ze=Array.isArray(_e)?new S.CompletionList(_e):_e,X=z.supportsResolving(this._provider)?this._cache.add(Ze.items):this._cache.add([]),ie=new c.DisposableStore;this._disposables.set(X,ie);const fe=[],$e={x:X,b:fe,a:{replace:C.Range.from(we),insert:C.Range.from(Fe)},c:Ze.isIncomplete||void 0,d:ze.elapsed()};for(let xe=0;xe<Ze.items.length;xe++){const tt=Ze.items[xe],Ce=this._convertCompletionItem(tt,[X,xe],Fe,we);fe.push(Ce)}return $e}async resolveCompletionItem(W,Z){if(typeof this._provider.resolveCompletionItem!="function")return;const te=this._cache.get(...W);if(!te)return;const ae=await this._provider.resolveCompletionItem(te,Z);if(!!ae)return this._convertCompletionItem(ae,W)}releaseCompletionItems(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}_convertCompletionItem(W,Z,te,ae){const Y=this._disposables.get(Z[0]);if(!Y)throw Error("DisposableStore is missing...");const se={x:Z,a:W.label,b:W.kind!==void 0?C.CompletionItemKind.from(W.kind):void 0,n:W.tags&&W.tags.map(C.CompletionItemTag.from),c:W.detail,d:typeof W.documentation=="undefined"?void 0:C.MarkdownString.fromStrict(W.documentation),e:W.sortText!==W.label?W.sortText:void 0,f:W.filterText!==W.label?W.filterText:void 0,g:W.preselect||void 0,i:W.keepWhitespace?1:0,k:W.commitCharacters,l:W.additionalTextEdits&&W.additionalTextEdits.map(C.TextEdit.from),m:this._commands.toInternal(W.command,Y)};W.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),se.h=W.textEdit.newText):typeof W.insertText=="string"?se.h=W.insertText:W.insertText instanceof S.SnippetString&&(se.h=W.insertText.value,se.i|=4);let we;return W.textEdit?we=W.textEdit.range:W.range&&(we=W.range),S.Range.isRange(we)?se.j=C.Range.from(we):we&&(!te?.isEqual(we.inserting)||!ae?.isEqual(we.replacing))&&(se.j={insert:C.Range.from(we.inserting),replace:C.Range.from(we.replacing)}),se}}class N{constructor(W,Z,te){this._documents=W,this._provider=Z,this._commands=te,this._cache=new g.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(W,Z,te,ae){const Y=this._documents.getDocument(W),se=C.Position.to(Z),we=await this._provider.provideInlineCompletionItems(Y,se,te,ae);if(!we||ae.isCancellationRequested)return;const Fe=(0,i.isArray)(we)?{items:we}:we,ze=this._cache.add(Fe.items);let _e;return{pid:ze,items:Fe.items.map((Ze,X)=>{let ie;return Ze.command&&(_e||(_e=new c.DisposableStore,this._disposables.set(ze,_e)),ie=this._commands.toInternal(Ze.command,_e)),{text:Ze.text,range:Ze.range?C.Range.from(Ze.range):void 0,command:ie,idx:X}})}}disposeCompletions(W){this._cache.delete(W);const Z=this._disposables.get(W);Z&&Z.clear(),this._disposables.delete(W)}handleDidShowCompletionItem(W,Z){const te=this._cache.get(W,Z);te&&M.get(this._provider).fireOnDidShowCompletionItem({completionItem:te})}}class M{constructor(){this._onDidShowCompletionItemEmitter=new b.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(W){let Z=M.map.get(W);return Z||(Z=new M,M.map.set(W,Z)),Z}fireOnDidShowCompletionItem(W){this._onDidShowCompletionItemEmitter.fire(W)}}e.InlineCompletionController=M,M.map=new WeakMap;class q{constructor(W,Z){this._documents=W,this._provider=Z,this._cache=new g.Cache("SignatureHelp")}async provideSignatureHelp(W,Z,te,ae){const Y=this._documents.getDocument(W),se=C.Position.to(Z),we=this.reviveContext(te),Fe=await this._provider.provideSignatureHelp(Y,se,ae,we);if(Fe){const ze=this._cache.add([Fe]);return{...C.SignatureHelp.from(Fe),id:ze}}}reviveContext(W){let Z;if(W.activeSignatureHelp){const te=C.SignatureHelp.to(W.activeSignatureHelp),ae=this._cache.get(W.activeSignatureHelp.id,0);ae?(Z=ae,Z.activeSignature=te.activeSignature,Z.activeParameter=te.activeParameter):Z=te}return{...W,activeSignatureHelp:Z}}releaseSignatureHelp(W){this._cache.delete(W)}}class x{constructor(W,Z){this._documents=W,this._provider=Z}async provideInlayHints(W,Z,te){const ae=this._documents.getDocument(W),Y=await this._provider.provideInlayHints(ae,C.Range.to(Z),te);return Y?{hints:Y.map(C.InlayHint.from)}:void 0}}class K{constructor(W,Z){this._documents=W,this._provider=Z,this._cache=new g.Cache("DocumentLink")}async provideLinks(W,Z){const te=this._documents.getDocument(W),ae=await this._provider.provideDocumentLinks(te,Z);if(!(!Array.isArray(ae)||ae.length===0)&&!Z.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(K._validateLink).map(C.DocumentLink.from)};{const Y=this._cache.add(ae),se={links:[],id:Y};for(let we=0;we<ae.length;we++){if(!K._validateLink(ae[we]))continue;const Fe=C.DocumentLink.from(ae[we]);Fe.cacheId=[Y,we],se.links.push(Fe)}return se}}}static _validateLink(W){return W.target&&W.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(W,Z){if(typeof this._provider.resolveDocumentLink!="function")return;const te=this._cache.get(...W);if(!te)return;const ae=await this._provider.resolveDocumentLink(te,Z);if(!(!ae||!K._validateLink(ae)))return C.DocumentLink.from(ae)}releaseLinks(W){this._cache.delete(W)}}class ee{constructor(W,Z){this._documents=W,this._provider=Z}async provideColors(W,Z){const te=this._documents.getDocument(W),ae=await this._provider.provideDocumentColors(te,Z);return Array.isArray(ae)?ae.map(se=>({color:C.Color.from(se.color),range:C.Range.from(se.range)})):[]}async provideColorPresentations(W,Z,te){const ae=this._documents.getDocument(W),Y=C.Range.to(Z.range),se=C.Color.to(Z.color),we=await this._provider.provideColorPresentations(se,{document:ae,range:Y},te);if(!!Array.isArray(we))return we.map(C.ColorPresentation.from)}}class de{constructor(W,Z){this._documents=W,this._provider=Z}async provideFoldingRanges(W,Z,te){const ae=this._documents.getDocument(W),Y=await this._provider.provideFoldingRanges(ae,Z,te);if(!!Array.isArray(Y))return Y.map(C.FoldingRange.from)}}class Se{constructor(W,Z,te){this._documents=W,this._provider=Z,this._logService=te}async provideSelectionRanges(W,Z,te){const ae=this._documents.getDocument(W),Y=Z.map(C.Position.to),se=await this._provider.provideSelectionRanges(ae,Y,te);if(!(0,A.isNonEmptyArray)(se))return[];if(se.length!==Y.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const we=[];for(let Fe=0;Fe<Y.length;Fe++){const ze=[];we.push(ze);let _e=Y[Fe],Ze=se[Fe];for(;;){if(!Ze.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(ze.push(C.SelectionRange.from(Ze)),!Ze.parent)break;_e=Ze.range,Ze=Ze.parent}}return we}}class De{constructor(W,Z){this._documents=W,this._provider=Z,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(W,Z,te){const ae=this._documents.getDocument(W),Y=C.Position.to(Z),se=await this._provider.prepareCallHierarchy(ae,Y,te);if(!se)return;const we=this._idPool.nextId();return this._cache.set(we,new Map),Array.isArray(se)?se.map(Fe=>this._cacheAndConvertItem(we,Fe)):[this._cacheAndConvertItem(we,se)]}async provideCallsTo(W,Z,te){const ae=this._itemFromCache(W,Z);if(!ae)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyIncomingCalls(ae,te);if(!!Y)return Y.map(se=>({from:this._cacheAndConvertItem(W,se.from),fromRanges:se.fromRanges.map(we=>C.Range.from(we))}))}async provideCallsFrom(W,Z,te){const ae=this._itemFromCache(W,Z);if(!ae)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyOutgoingCalls(ae,te);if(!!Y)return Y.map(se=>({to:this._cacheAndConvertItem(W,se.to),fromRanges:se.fromRanges.map(we=>C.Range.from(we))}))}releaseSession(W){this._cache.delete(W)}_cacheAndConvertItem(W,Z){const te=this._cache.get(W),ae=C.CallHierarchyItem.from(Z,W,te.size.toString(36));return te.set(ae._itemId,Z),ae}_itemFromCache(W,Z){return this._cache.get(W)?.get(Z)}}class Le{constructor(W,Z){this._documents=W,this._provider=Z,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(W,Z,te){const ae=this._documents.getDocument(W),Y=C.Position.to(Z),se=await this._provider.prepareTypeHierarchy(ae,Y,te);if(!se)return;const we=this._idPool.nextId();return this._cache.set(we,new Map),Array.isArray(se)?se.map(Fe=>this._cacheAndConvertItem(we,Fe)):[this._cacheAndConvertItem(we,se)]}async provideSupertypes(W,Z,te){const ae=this._itemFromCache(W,Z);if(!ae)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySupertypes(ae,te);if(!!Y)return Y.map(se=>this._cacheAndConvertItem(W,se))}async provideSubtypes(W,Z,te){const ae=this._itemFromCache(W,Z);if(!ae)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySubtypes(ae,te);if(!!Y)return Y.map(se=>this._cacheAndConvertItem(W,se))}releaseSession(W){this._cache.delete(W)}_cacheAndConvertItem(W,Z){const te=this._cache.get(W),ae=C.TypeHierarchyItem.from(Z,W,te.size.toString(36));return te.set(ae._itemId,Z),ae}_itemFromCache(W,Z){return this._cache.get(W)?.get(Z)}}class qe{constructor(W,Z){this.adapter=W,this.extension=Z}}class We{constructor(W,Z,te,ae,Y,se,we){this._adapter=new Map,this._uriTransformer=Z,this._proxy=W.getProxy(T.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=ae,this._diagnostics=Y,this._logService=se,this._apiDeprecation=we}_transformDocumentSelector(W){return(0,A.coalesce)((0,A.asArray)(W).map(Z=>this._doTransformDocumentSelector(Z)))}_doTransformDocumentSelector(W){if(typeof W=="string")return{$serialized:!0,language:W};if(W)return{$serialized:!0,language:W.language,scheme:this._transformScheme(W.scheme),pattern:typeof W.pattern=="undefined"?void 0:C.GlobPattern.from(W.pattern),exclusive:W.exclusive}}_transformScheme(W){return this._uriTransformer&&typeof W=="string"?this._uriTransformer.transformOutgoingScheme(W):W}_createDisposable(W){return new S.Disposable(()=>{this._adapter.delete(W),this._proxy.$unregister(W)})}_nextHandle(){return We._handlePool++}_withAdapter(W,Z,te,ae,Y=!1){const se=this._adapter.get(W);if(!se)return Promise.resolve(ae);if(se.adapter instanceof Z){let we;se.extension&&(we=Date.now(),this._logService.trace(`[${se.extension.identifier.value}] INVOKE provider '${Z.name}'`));const Fe=te(se.adapter,se.extension),ze=se.extension;return ze&&Promise.resolve(Fe).then(()=>this._logService.trace(`[${ze.identifier.value}] provider DONE after ${Date.now()-we}ms`),_e=>{Y&&_e instanceof _.CancellationError||(this._logService.error(`[${ze.identifier.value}] provider FAILED`),this._logService.error(_e))}),Fe}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(W,Z){const te=this._nextHandle();return this._adapter.set(te,new qe(W,Z)),te}static _extLabel(W){return W.displayName||W.name}registerDocumentSymbolProvider(W,Z,te,ae){const Y=this._addNewAdapter(new d(this._documents,te),W),se=ae&&ae.label||We._extLabel(W);return this._proxy.$registerDocumentSymbolProvider(Y,this._transformDocumentSelector(Z),se),this._createDisposable(Y)}$provideDocumentSymbols(W,Z,te){return this._withAdapter(W,d,ae=>ae.provideDocumentSymbols(p.URI.revive(Z),te),void 0)}registerCodeLensProvider(W,Z,te){const ae=this._nextHandle(),Y=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new qe(new h(this._documents,this._commands.converter,te),W)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(Z),Y);let se=this._createDisposable(ae);if(Y!==void 0){const we=te.onDidChangeCodeLenses(Fe=>this._proxy.$emitCodeLensEvent(Y));se=S.Disposable.from(se,we)}return se}$provideCodeLenses(W,Z,te){return this._withAdapter(W,h,ae=>ae.provideCodeLenses(p.URI.revive(Z),te),void 0)}$resolveCodeLens(W,Z,te){return this._withAdapter(W,h,ae=>ae.resolveCodeLens(Z,te),void 0)}$releaseCodeLenses(W,Z){this._withAdapter(W,h,te=>Promise.resolve(te.releaseCodeLenses(Z)),void 0)}registerDefinitionProvider(W,Z,te){const ae=this._addNewAdapter(new t(this._documents,te),W);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideDefinition(W,Z,te,ae){return this._withAdapter(W,t,Y=>Y.provideDefinition(p.URI.revive(Z),te,ae),[])}registerDeclarationProvider(W,Z,te){const ae=this._addNewAdapter(new s(this._documents,te),W);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideDeclaration(W,Z,te,ae){return this._withAdapter(W,s,Y=>Y.provideDeclaration(p.URI.revive(Z),te,ae),[])}registerImplementationProvider(W,Z,te){const ae=this._addNewAdapter(new r(this._documents,te),W);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideImplementation(W,Z,te,ae){return this._withAdapter(W,r,Y=>Y.provideImplementation(p.URI.revive(Z),te,ae),[])}registerTypeDefinitionProvider(W,Z,te){const ae=this._addNewAdapter(new n(this._documents,te),W);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideTypeDefinition(W,Z,te,ae){return this._withAdapter(W,n,Y=>Y.provideTypeDefinition(p.URI.revive(Z),te,ae),[])}registerHoverProvider(W,Z,te,ae){const Y=this._addNewAdapter(new l(this._documents,te),W);return this._proxy.$registerHoverProvider(Y,this._transformDocumentSelector(Z)),this._createDisposable(Y)}$provideHover(W,Z,te,ae){return this._withAdapter(W,l,Y=>Y.provideHover(p.URI.revive(Z),te,ae),void 0)}registerEvaluatableExpressionProvider(W,Z,te,ae){const Y=this._addNewAdapter(new f(this._documents,te),W);return this._proxy.$registerEvaluatableExpressionProvider(Y,this._transformDocumentSelector(Z)),this._createDisposable(Y)}$provideEvaluatableExpression(W,Z,te,ae){return this._withAdapter(W,f,Y=>Y.provideEvaluatableExpression(p.URI.revive(Z),te,ae),void 0)}registerInlineValuesProvider(W,Z,te,ae){const Y=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new m(this._documents,te),W);this._proxy.$registerInlineValuesProvider(se,this._transformDocumentSelector(Z),Y);let we=this._createDisposable(se);if(Y!==void 0){const Fe=te.onDidChangeInlineValues(ze=>this._proxy.$emitInlineValuesEvent(Y));we=S.Disposable.from(we,Fe)}return we}$provideInlineValues(W,Z,te,ae,Y){return this._withAdapter(W,m,se=>se.provideInlineValues(p.URI.revive(Z),te,ae,Y),void 0)}registerDocumentHighlightProvider(W,Z,te){const ae=this._addNewAdapter(new E(this._documents,te),W);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideDocumentHighlights(W,Z,te,ae){return this._withAdapter(W,E,Y=>Y.provideDocumentHighlights(p.URI.revive(Z),te,ae),void 0)}registerLinkedEditingRangeProvider(W,Z,te){const ae=this._addNewAdapter(new y(this._documents,te),W);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideLinkedEditingRanges(W,Z,te,ae){return this._withAdapter(W,y,async Y=>{const se=await Y.provideLinkedEditingRanges(p.URI.revive(Z),te,ae);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?We._serializeRegExp(se.wordPattern):void 0}},void 0)}registerReferenceProvider(W,Z,te){const ae=this._addNewAdapter(new o(this._documents,te),W);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideReferences(W,Z,te,ae,Y){return this._withAdapter(W,o,se=>se.provideReferences(p.URI.revive(Z),te,ae,Y),void 0)}registerCodeActionProvider(W,Z,te,ae){const Y=new c.DisposableStore,se=this._addNewAdapter(new k(this._documents,this._commands.converter,this._diagnostics,te,this._logService,W,this._apiDeprecation),W);return this._proxy.$registerQuickFixSupport(se,this._transformDocumentSelector(Z),{providedKinds:ae?.providedCodeActionKinds?.map(we=>we.value),documentation:ae?.documentation?.map(we=>({kind:we.kind.value,command:this._commands.converter.toInternal(we.command,Y)}))},We._extLabel(W),Boolean(te.resolveCodeAction)),Y.add(this._createDisposable(se)),Y}$provideCodeActions(W,Z,te,ae,Y){return this._withAdapter(W,k,se=>se.provideCodeActions(p.URI.revive(Z),te,ae,Y),void 0)}$resolveCodeAction(W,Z,te){return this._withAdapter(W,k,ae=>ae.resolveCodeAction(Z,te),void 0)}$releaseCodeActions(W,Z){this._withAdapter(W,k,te=>Promise.resolve(te.releaseCodeActions(Z)),void 0)}registerDocumentFormattingEditProvider(W,Z,te){const ae=this._addNewAdapter(new F(this._documents,te),W);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(Z),W.identifier,W.displayName||W.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(W,Z,te,ae){return this._withAdapter(W,F,Y=>Y.provideDocumentFormattingEdits(p.URI.revive(Z),te,ae),void 0)}registerDocumentRangeFormattingEditProvider(W,Z,te){const ae=this._addNewAdapter(new $(this._documents,te),W);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(Z),W.identifier,W.displayName||W.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(W,Z,te,ae,Y){return this._withAdapter(W,$,se=>se.provideDocumentRangeFormattingEdits(p.URI.revive(Z),te,ae,Y),void 0)}registerOnTypeFormattingEditProvider(W,Z,te,ae){const Y=this._addNewAdapter(new Q(this._documents,te),W);return this._proxy.$registerOnTypeFormattingSupport(Y,this._transformDocumentSelector(Z),ae,W.identifier),this._createDisposable(Y)}$provideOnTypeFormattingEdits(W,Z,te,ae,Y,se){return this._withAdapter(W,Q,we=>we.provideOnTypeFormattingEdits(p.URI.revive(Z),te,ae,Y,se),void 0)}registerWorkspaceSymbolProvider(W,Z){const te=this._addNewAdapter(new oe(Z,this._logService),W);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols(W,Z,te){return this._withAdapter(W,oe,ae=>ae.provideWorkspaceSymbols(Z,te),{symbols:[]})}$resolveWorkspaceSymbol(W,Z,te){return this._withAdapter(W,oe,ae=>ae.resolveWorkspaceSymbol(Z,te),void 0)}$releaseWorkspaceSymbols(W,Z){this._withAdapter(W,oe,te=>te.releaseWorkspaceSymbols(Z),void 0)}registerRenameProvider(W,Z,te){const ae=this._addNewAdapter(new j(this._documents,te,this._logService),W);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(Z),j.supportsResolving(te)),this._createDisposable(ae)}$provideRenameEdits(W,Z,te,ae,Y){return this._withAdapter(W,j,se=>se.provideRenameEdits(p.URI.revive(Z),te,ae,Y),void 0)}$resolveRenameLocation(W,Z,te,ae){return this._withAdapter(W,j,Y=>Y.resolveRenameLocation(p.URI.revive(Z),te,ae),void 0)}registerDocumentSemanticTokensProvider(W,Z,te,ae){const Y=this._nextHandle(),se=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Y,new qe(new B(this._documents,te),W)),this._proxy.$registerDocumentSemanticTokensProvider(Y,this._transformDocumentSelector(Z),ae,se);let we=this._createDisposable(Y);if(se){const Fe=te.onDidChangeSemanticTokens(ze=>this._proxy.$emitDocumentSemanticTokensEvent(se));we=S.Disposable.from(we,Fe)}return we}$provideDocumentSemanticTokens(W,Z,te,ae){return this._withAdapter(W,B,Y=>Y.provideDocumentSemanticTokens(p.URI.revive(Z),te,ae),null,!0)}$releaseDocumentSemanticTokens(W,Z){this._withAdapter(W,B,te=>te.releaseDocumentSemanticColoring(Z),void 0)}registerDocumentRangeSemanticTokensProvider(W,Z,te,ae){const Y=this._addNewAdapter(new R(this._documents,te),W);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Y,this._transformDocumentSelector(Z),ae),this._createDisposable(Y)}$provideDocumentRangeSemanticTokens(W,Z,te,ae){return this._withAdapter(W,R,Y=>Y.provideDocumentRangeSemanticTokens(p.URI.revive(Z),te,ae),null,!0)}registerCompletionItemProvider(W,Z,te,ae){const Y=this._addNewAdapter(new z(this._documents,this._commands.converter,te,this._apiDeprecation,W),W);return this._proxy.$registerSuggestSupport(Y,this._transformDocumentSelector(Z),ae,z.supportsResolving(te),`${W.identifier.value}(${ae.join("")})`),this._createDisposable(Y)}$provideCompletionItems(W,Z,te,ae,Y){return this._withAdapter(W,z,se=>se.provideCompletionItems(p.URI.revive(Z),te,ae,Y),void 0)}$resolveCompletionItem(W,Z,te){return this._withAdapter(W,z,ae=>ae.resolveCompletionItem(Z,te),void 0)}$releaseCompletionItems(W,Z){this._withAdapter(W,z,te=>te.releaseCompletionItems(Z),void 0)}registerInlineCompletionsProvider(W,Z,te){const ae=this._addNewAdapter(new N(this._documents,te,this._commands.converter),W);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideInlineCompletions(W,Z,te,ae,Y){return this._withAdapter(W,N,se=>se.provideInlineCompletions(p.URI.revive(Z),te,ae,Y),void 0)}$handleInlineCompletionDidShow(W,Z,te){this._withAdapter(W,N,async ae=>{ae.handleDidShowCompletionItem(Z,te)},void 0)}$freeInlineCompletionsList(W,Z){this._withAdapter(W,N,async te=>{te.disposeCompletions(Z)},void 0)}registerSignatureHelpProvider(W,Z,te,ae){const Y=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,se=this._addNewAdapter(new q(this._documents,te),W);return this._proxy.$registerSignatureHelpProvider(se,this._transformDocumentSelector(Z),Y),this._createDisposable(se)}$provideSignatureHelp(W,Z,te,ae,Y){return this._withAdapter(W,q,se=>se.provideSignatureHelp(p.URI.revive(Z),te,ae,Y),void 0)}$releaseSignatureHelp(W,Z){this._withAdapter(W,q,te=>te.releaseSignatureHelp(Z),void 0)}registerInlayHintsProvider(W,Z,te){const ae=typeof te.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Y=this._addNewAdapter(new x(this._documents,te),W);this._proxy.$registerInlayHintsProvider(Y,this._transformDocumentSelector(Z),ae);let se=this._createDisposable(Y);if(ae!==void 0){const we=te.onDidChangeInlayHints(Fe=>this._proxy.$emitInlayHintsEvent(ae));se=S.Disposable.from(se,we)}return se}$provideInlayHints(W,Z,te,ae){return this._withAdapter(W,x,Y=>Y.provideInlayHints(p.URI.revive(Z),te,ae),void 0)}registerDocumentLinkProvider(W,Z,te){const ae=this._addNewAdapter(new K(this._documents,te),W);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(Z),typeof te.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(W,Z,te){return this._withAdapter(W,K,ae=>ae.provideLinks(p.URI.revive(Z),te),void 0)}$resolveDocumentLink(W,Z,te){return this._withAdapter(W,K,ae=>ae.resolveLink(Z,te),void 0)}$releaseDocumentLinks(W,Z){this._withAdapter(W,K,te=>te.releaseLinks(Z),void 0)}registerColorProvider(W,Z,te){const ae=this._addNewAdapter(new ee(this._documents,te),W);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideDocumentColors(W,Z,te){return this._withAdapter(W,ee,ae=>ae.provideColors(p.URI.revive(Z),te),[])}$provideColorPresentations(W,Z,te,ae){return this._withAdapter(W,ee,Y=>Y.provideColorPresentations(p.URI.revive(Z),te,ae),void 0)}registerFoldingRangeProvider(W,Z,te){const ae=this._nextHandle(),Y=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new qe(new de(this._documents,te),W)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(Z),Y);let se=this._createDisposable(ae);if(Y!==void 0){const we=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Y));se=S.Disposable.from(se,we)}return se}$provideFoldingRanges(W,Z,te,ae){return this._withAdapter(W,de,Y=>Y.provideFoldingRanges(p.URI.revive(Z),te,ae),void 0)}registerSelectionRangeProvider(W,Z,te){const ae=this._addNewAdapter(new Se(this._documents,te,this._logService),W);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$provideSelectionRanges(W,Z,te,ae){return this._withAdapter(W,Se,Y=>Y.provideSelectionRanges(p.URI.revive(Z),te,ae),[])}registerCallHierarchyProvider(W,Z,te){const ae=this._addNewAdapter(new De(this._documents,te),W);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$prepareCallHierarchy(W,Z,te,ae){return this._withAdapter(W,De,Y=>Promise.resolve(Y.prepareSession(p.URI.revive(Z),te,ae)),void 0)}$provideCallHierarchyIncomingCalls(W,Z,te,ae){return this._withAdapter(W,De,Y=>Y.provideCallsTo(Z,te,ae),void 0)}$provideCallHierarchyOutgoingCalls(W,Z,te,ae){return this._withAdapter(W,De,Y=>Y.provideCallsFrom(Z,te,ae),void 0)}$releaseCallHierarchy(W,Z){this._withAdapter(W,De,te=>Promise.resolve(te.releaseSession(Z)),void 0)}registerTypeHierarchyProvider(W,Z,te){const ae=this._addNewAdapter(new Le(this._documents,te),W);return this._proxy.$registerTypeHierarchyProvider(ae,this._transformDocumentSelector(Z)),this._createDisposable(ae)}$prepareTypeHierarchy(W,Z,te,ae){return this._withAdapter(W,Le,Y=>Promise.resolve(Y.prepareSession(p.URI.revive(Z),te,ae)),void 0)}$provideTypeHierarchySupertypes(W,Z,te,ae){return this._withAdapter(W,Le,Y=>Y.provideSupertypes(Z,te,ae),void 0)}$provideTypeHierarchySubtypes(W,Z,te,ae){return this._withAdapter(W,Le,Y=>Y.provideSubtypes(Z,te,ae),void 0)}$releaseTypeHierarchy(W,Z){this._withAdapter(W,Le,te=>Promise.resolve(te.releaseSession(Z)),void 0)}static _serializeRegExp(W){return{pattern:W.source,flags:(0,I.regExpFlags)(W)}}static _serializeIndentationRule(W){return{decreaseIndentPattern:We._serializeRegExp(W.decreaseIndentPattern),increaseIndentPattern:We._serializeRegExp(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?We._serializeRegExp(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?We._serializeRegExp(W.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(W){return{beforeText:We._serializeRegExp(W.beforeText),afterText:W.afterText?We._serializeRegExp(W.afterText):void 0,previousLineText:W.previousLineText?We._serializeRegExp(W.previousLineText):void 0,action:W.action}}static _serializeOnEnterRules(W){return W.map(We._serializeOnEnterRule)}setLanguageConfiguration(W,Z,te){let{wordPattern:ae}=te;if(ae&&(0,I.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(Z,ae):this._documents.setWordDefinitionFor(Z,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const Y=this._nextHandle(),se={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?We._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?We._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?We._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Y,Z,se),this._createDisposable(Y)}$setWordDefinitions(W){for(const Z of W)this._documents.setWordDefinitionFor(Z.languageId,new RegExp(Z.regexSource,Z.regexFlags))}}e.ExtHostLanguageFeatures=We,We._handlePool=0}),define(me[235],ge([0,1,5,16,7]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(I,D){this._proxy=I.getProxy(p.MainContext.MainThreadLanguages),this._documents=D}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(I,D){await this._proxy.$changeLanguage(I,D);const A=this._documents.getDocumentData(I);if(!A)throw new Error(`document '${I.toString}' NOT found`);return A.document}async tokenAtPosition(I,D){const A=I.version,i=L.Position.from(D),P=await this._proxy.$tokensAtPosition(I.uri,i),c={type:C.StandardTokenType.Other,range:I.getWordRangeAtPosition(D)??new C.Range(D.line,D.character,D.line,D.character)};if(!P)return c;const u={range:L.Range.to(P.range),type:L.TokenType.to(P.type)};return!u.range.contains(D)||A!==I.version?c:u}}e.ExtHostLanguages=S}),define(me[236],ge([0,1,5,12,34]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function S(I){return I&&I.title}let T=class{constructor(D,A){this._logService=A,this._proxy=D.getProxy(p.MainContext.MainThreadMessageService)}showMessage(D,A,i,P,c){const u={extension:D};let a;typeof P=="string"||S(P)?a=[P,...c]:(u.modal=P?.modal,u.useCustom=P?.useCustom,u.detail=P?.detail,a=c),u.useCustom&&(0,C.checkProposedApiEnabled)(D);const g=[];for(let w=0;w<a.length;w++){const _=a[w];if(typeof _=="string")g.push({title:_,handle:w,isCloseAffordance:!1});else if(typeof _=="object"){let{title:b,isCloseAffordance:d}=_;g.push({title:b,isCloseAffordance:!!d,handle:w})}else this._logService.warn("Invalid message item:",_)}return this._proxy.$showMessage(A,i,u,g).then(w=>{if(typeof w=="number")return a[w]})}};T=Ve([He(1,L.ILogService)],T),e.ExtHostMessageService=T}),define(me[237],ge([0,1,22,3,55,6,23,8,14,2,84,5,16,7,213,125]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class w{constructor(b,d,h,v,t){this._textDocumentsAndEditors=h,this._textDocuments=v,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new i.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=b.getProxy(P.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=b.getProxy(P.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=b.getProxy(P.MainContext.MainThreadNotebookEditors),this._commandsConverter=d.converter,d.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const r=s.notebookEditor?.notebookUri,n=s.cell.handle,f=this._documents.get(r)?.getCell(n);if(f)return f.apiCell}return s}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(b=>b.apiEditor)}getEditorById(b){const d=this._editors.get(b);if(!d)throw new Error(`unknown text editor: ${b}. known editors: ${[...this._editors.keys()]} `);return d}getIdByEditor(b){for(const[d,h]of this._editors)if(h.apiEditor===b)return d}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(b,d){const h=this._documents.get(b);if(!h&&!d)throw new Error(`NO notebook document for '${b}'`);return h}_getProviderData(b){const d=this._notebookContentProviders.get(b);if(!d)throw new Error(`NO provider for '${b}'`);return d}registerNotebookContentProvider(b,d,h,v,t){if((0,I.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(d))throw new Error(`Notebook provider for '${d}' already registered`);this._notebookContentProviders.set(d,{extension:b,provider:h});let s;return h.onDidChangeNotebookContentOptions&&(s=h.onDidChangeNotebookContentOptions(()=>{const r=c.NotebookDocumentContentOptions.from(h.options);this._notebookProxy.$updateNotebookProviderOptions(d,r)})),this._notebookProxy.$registerNotebookProvider({id:b.identifier,location:b.extensionLocation},d,c.NotebookDocumentContentOptions.from(v),w._convertNotebookRegistrationData(b,t)),new u.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(d),this._notebookProxy.$unregisterNotebookProvider(d)})}static _convertNotebookRegistrationData(b,d){if(!d)return;const h=d.filenamePattern.map(v=>c.NotebookExclusiveDocumentPattern.from(v)).filter(v=>v!==void 0);if(d.filenamePattern&&!h){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:d.displayName,filenamePattern:h,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,d,h){const v=w._notebookStatusBarItemProviderHandlePool++,t=typeof h.onDidChangeCellStatusBarItems=="function"?w._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(v,h),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(v,t,d);let s;return t!==void 0&&(s=h.onDidChangeCellStatusBarItems(r=>this._notebookProxy.$emitCellStatusBarEvent(t))),new u.Disposable(()=>{this._notebookStatusBarItemProviders.delete(v),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(v,t),s&&s.dispose()})}async createNotebookDocument(b){const d=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:b.viewType,content:b.content&&c.NotebookData.from(b.content)});return A.URI.revive(d)}async openNotebookDocument(b){const d=this._documents.get(b);if(d)return d.apiNotebook;const h=await this._notebookDocumentsProxy.$tryOpenNotebook(b),v=this._documents.get(A.URI.revive(h));return(0,D.assertIsDefined)(v?.apiNotebook)}async showNotebookDocument(b,d){A.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let h;typeof d=="object"?h={position:c.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(c.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:h={preserveFocus:!1};const v=await this._notebookEditorsProxy.$tryShowNotebookDocument(b.uri,b.notebookType,h),t=v&&this._editors.get(v)?.apiEditor;if(t)return t;throw v?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,d,h,v){const t=this._notebookStatusBarItemProviders.get(b),s=A.URI.revive(d),r=this._documents.get(s);if(!r||!t)return;const n=r.getCellFromIndex(h);if(!n)return;const l=await t.provideCellStatusBarItems(n.apiCell,v);if(!l)return;const f=new S.DisposableStore,m=this._statusBarCache.add([f]),y=(Array.isArray(l)?l:[l]).map(o=>c.NotebookStatusBarItem.from(o,this._commandsConverter,f));return{cacheId:m,items:y}}$releaseNotebookCellStatusBarItems(b){this._statusBarCache.delete(b)}registerNotebookSerializer(b,d,h,v,t){if((0,I.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,h),this._notebookProxy.$registerNotebookSerializer(s,{id:b.identifier,location:b.extensionLocation},d,c.NotebookDocumentContentOptions.from(v),w._convertNotebookRegistrationData(b,t)),(0,S.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(b,d,h){const v=this._notebookSerializer.get(b);if(!v)throw new Error("NO serializer found");const t=await v.deserializeNotebook(d.buffer,h);return c.NotebookData.from(t)}async $notebookToData(b,d,h){const v=this._notebookSerializer.get(b);if(!v)throw new Error("NO serializer found");const t=await v.serializeNotebook(c.NotebookData.to(d),h);return p.VSBuffer.wrap(t)}async $openNotebook(b,d,h,v,t){const{provider:s}=this._getProviderData(b),r=await s.openNotebook(A.URI.revive(d),{backupId:h,untitledDocumentData:v?.buffer},t);return{metadata:r.metadata??Object.create(null),cells:r.cells.map(c.NotebookCellData.from)}}async $saveNotebook(b,d,h){const v=this.getNotebookDocument(A.URI.revive(d)),{provider:t}=this._getProviderData(b);return await t.saveNotebook(v.apiNotebook,h),!0}async $saveNotebookAs(b,d,h,v){const t=this.getNotebookDocument(A.URI.revive(d)),{provider:s}=this._getProviderData(b);return await s.saveNotebookAs(A.URI.revive(h),t.apiNotebook,v),!0}async $backupNotebook(b,d,h){const v=this.getNotebookDocument(A.URI.revive(d)),t=this._getProviderData(b),s=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension),r=String((0,C.hash)([v.uri.toString(),this._backupIdPool++])),n=A.URI.joinPath(s,r),l=await t.provider.backupNotebook(v.apiNotebook,{destination:n},h);return v.updateBackup(l),l.id}_createExtHostEditor(b,d,h){if(this._editors.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const v=new g.ExtHostNotebookEditor(d,this._notebookEditorsProxy,b,h.visibleRanges.map(c.NotebookRange.to),h.selections.map(c.NotebookRange.to),typeof h.viewColumn=="number"?c.ViewColumn.to(h.viewColumn):void 0);this._editors.set(d,v)}$acceptDocumentAndEditorsDelta(b){if(b.removedDocuments)for(const h of b.removedDocuments){const v=A.URI.revive(h),t=this._documents.get(v);t&&(t.dispose(),this._documents.delete(v),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:t.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(t.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===v.toString()&&this._editors.delete(s.id)}if(b.addedDocuments){const h=[];for(const v of b.addedDocuments){const t=A.URI.revive(v.uri);if(this._documents.has(t))throw new Error(`adding EXISTING notebook ${t} `);const s=this,r=new a.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(n){s._onDidChangeNotebookCells.fire(n)},emitCellOutputsChange(n){s._onDidChangeCellOutputs.fire(n)},emitCellMetadataChange(n){s._onDidChangeCellMetadata.fire(n)},emitCellExecutionStateChange(n){s._onDidChangeCellExecutionState.fire(n)}},t,v);h.push(...v.cells.map(n=>a.ExtHostCell.asModelAddData(r.apiNotebook,n))),this._documents.get(t)?.dispose(),this._documents.set(t,r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:h}),this._onDidOpenNotebookDocument.fire(r.apiNotebook)}}if(b.addedEditors)for(const h of b.addedEditors){if(this._editors.has(h.id))return;const v=A.URI.revive(h.documentUri),t=this._documents.get(v);t&&this._createExtHostEditor(t,h.id,h)}const d=[];if(b.removedEditors)for(const h of b.removedEditors){const v=this._editors.get(h);v&&(this._editors.delete(h),this._activeNotebookEditor?.id===v.id&&(this._activeNotebookEditor=void 0),d.push(v))}if(b.visibleEditors){this._visibleNotebookEditors=b.visibleEditors.map(v=>this._editors.get(v)).filter(v=>!!v);const h=new Set;this._visibleNotebookEditors.forEach(v=>h.add(v.id));for(const v of this._editors.values()){const t=h.has(v.id);v._acceptVisibility(t)}this._visibleNotebookEditors=[...this._editors.values()].map(v=>v).filter(v=>v.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}b.newActiveEditor===null?this._activeNotebookEditor=void 0:b.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(b.newActiveEditor)),b.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=w,w._notebookStatusBarItemProviderHandlePool=0}),define(me[238],ge([0,1,3,71,12,5,13,16]),function(J,e,p,L,C,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class D{constructor(P,c){const u=D._Keys.nextId();P.$registerNotebookEditorDecorationType(u,I.NotebookDecorationRenderOptions.from(c)),this.value={key:u,dispose(){P.$removeNotebookEditorDecorationType(u)}}}}D._Keys=new L.IdGenerator("NotebookEditorDecorationType");let A=class{constructor(P,c,u){this._logService=P,this._extHostRpc=c,this._notebooksAndEditors=u,this._onDidChangeNotebookEditorSelection=new p.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new p.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(P){return new D(this._extHostRpc.getProxy(S.MainContext.MainThreadNotebookEditors),P).value}$acceptEditorPropertiesChanged(P,c){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",P,c);const u=this._notebooksAndEditors.getEditorById(P);c.visibleRanges&&u._acceptVisibleRanges(c.visibleRanges.ranges.map(I.NotebookRange.to)),c.selections&&u._acceptSelections(c.selections.selections.map(I.NotebookRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:u.apiEditor,visibleRanges:u.apiEditor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:u.apiEditor,selections:u.apiEditor.selections}))}$acceptEditorViewColumns(P){for(const c in P)this._notebooksAndEditors.getEditorById(c)._acceptViewColumn(I.ViewColumn.to(P[c]))}};A=Ve([He(0,C.ILogService),He(1,T.IExtHostRpcService)],A),e.ExtHostNotebookEditors=A}),define(me[239],ge([0,1,3,6,5,26,2,16,86,23,17,87,21,18,12,7,34]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let _=class{constructor(t,s,r,n){this._initData=s,this._extHostNotebook=r,this._logService=n,this._activeExecutions=new A.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(C.MainContext.MainThreadNotebookKernels)}createNotebookController(t,s,r,n,l,f){for(let N of this._kernelData.values())if(N.controller.id===s&&S.ExtensionIdentifier.equals(t.identifier,N.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const m=this._handlePool++,E=this;this._logService.trace(`NotebookController[${m}], CREATED by ${t.identifier.value}, ${s}`);const y=()=>console.warn(`NO execute handler from notebook controller '${Q.id}' of extension: '${t.identifier}'`);let o=!1;const k=new L.DisposableStore,F=new p.Emitter,$=new p.Emitter,Q={id:`${t.identifier.value}/${s}`,notebookType:r,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:n||t.identifier.value,preloads:f?f.map(I.NotebookRendererScript.from):[]};let oe=l??y,j;this._proxy.$addKernel(m,Q).catch(N=>{console.log(N),o=!0});let O=0;const B=()=>{if(o)return;const N=++O;Promise.resolve().then(()=>{N===O&&this._proxy.$updateKernel(m,Q)})},R=new A.ResourceMap,z={get id(){return s},get notebookType(){return Q.notebookType},onDidChangeSelectedNotebooks:F.event,get label(){return Q.label},set label(N){Q.label=N??t.displayName??t.name,B()},get detail(){return Q.detail??""},set detail(N){Q.detail=N,B()},get description(){return Q.description??""},set description(N){Q.description=N,B()},get supportedLanguages(){return Q.supportedLanguages},set supportedLanguages(N){Q.supportedLanguages=N,B()},get supportsExecutionOrder(){return Q.supportsExecutionOrder??!1},set supportsExecutionOrder(N){Q.supportsExecutionOrder=N,B()},get rendererScripts(){return Q.preloads?Q.preloads.map(I.NotebookRendererScript.to):[]},get executeHandler(){return oe},set executeHandler(N){oe=N??y},get interruptHandler(){return j},set interruptHandler(N){j=N,Q.supportsInterrupt=Boolean(N),B()},createNotebookCellExecution(N){if(o)throw new Error("notebook controller is DISPOSED");if(!R.has(N.notebook.uri))throw E._logService.trace(`NotebookController[${m}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(R.keys()).map(M=>M.toString())),new Error(`notebook controller is NOT associated to notebook: ${N.notebook.uri.toString()}`);return E._createNotebookCellExecution(N)},dispose:()=>{o||(this._logService.trace(`NotebookController[${m}], DISPOSED`),o=!0,this._kernelData.delete(m),k.dispose(),F.dispose(),$.dispose(),this._proxy.$removeKernel(m))},updateNotebookAffinity(N,M){E._proxy.$updateNotebookPriority(m,N.uri,M)},onDidReceiveMessage:$.event,postMessage(N,M){return(0,w.checkProposedApiEnabled)(t),E._proxy.$postMessage(m,M&&E._extHostNotebook.getIdByEditor(M),N)},asWebviewUri(N){return(0,w.checkProposedApiEnabled)(t),(0,D.asWebviewUri)(N,E._initData.remote)}};return this._kernelData.set(m,{extensionId:t.identifier,controller:z,onDidReceiveMessage:$,onDidChangeSelection:F,associatedNotebooks:R}),z}$acceptNotebookAssociation(t,s,r){const n=this._kernelData.get(t);if(n){const l=this._extHostNotebook.getNotebookDocument(T.URI.revive(s));r?n.associatedNotebooks.set(l.uri,!0):n.associatedNotebooks.delete(l.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,l.uri.toString(),r),n.onDidChangeSelection.fire({selected:r,notebook:l.apiNotebook})}}async $executeCells(t,s,r){const n=this._kernelData.get(t);if(!n)return;const l=this._extHostNotebook.getNotebookDocument(T.URI.revive(s)),f=[];for(let m of r){const E=l.getCell(m);E&&f.push(E.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,l.uri.toString(),f.length),await n.controller.executeHandler.call(n.controller,f,l.apiNotebook,n.controller)}catch(m){this._logService.error(`NotebookController[${t}] execute cells FAILED`,m),console.error(m)}}async $cancelCells(t,s,r){const n=this._kernelData.get(t);if(!n)return;const l=this._extHostNotebook.getNotebookDocument(T.URI.revive(s));if(n.controller.interruptHandler)await n.controller.interruptHandler.call(n.controller,l.apiNotebook);else for(let f of r){const m=l.getCell(f);m&&this._activeExecutions.get(m.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,s,r){const n=this._kernelData.get(t);if(!n)return;const l=this._extHostNotebook.getEditorById(s);n.onDidReceiveMessage.fire(Object.freeze({editor:l.apiEditor,message:r}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const r=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!r)throw new Error("invalid cell");if(this._activeExecutions.has(r.uri))throw new Error(`duplicate execution for ${r.uri}`);const n=new d(r.notebook,r,this._proxy);this._activeExecutions.set(r.uri,n);const l=n.onDidChangeState(()=>{n.state===b.Resolved&&(n.dispose(),l.dispose(),this._activeExecutions.delete(r.uri))});return n.asApiObject()}};_=Ve([He(3,a.ILogService)],_),e.ExtHostNotebookKernels=_;var b;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(b||(b={}));class d extends L.Disposable{constructor(t,s,r){super();this._document=t,this._cell=s,this._proxy=r,this._onDidChangeState=new p.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=b.Init,this._tokenSource=this._register(new c.CancellationTokenSource),this._collector=new h(10,n=>this.applyEdits(n)),this._executionOrder=s.internalMetadata.executionOrder,this.mixinMetadata({runState:P.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyExecutionEdits(this._document.uri,t)}verifyStateForOutput(){if(this._state===b.Init)throw new Error("Must call start before modifying cell output");if(this._state===b.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){this.applyEdits([{editType:9,handle:this._cell.handle,internalMetadata:t}])}cellIndexToHandle(t){let s=this._cell;if(t&&(s=this._document.getCellFromApiCell(t)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(t){return t.map(s=>{const r=g.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return r===s.items?I.NotebookCellOutput.from(s):I.NotebookCellOutput.from({items:r,id:s.id,metadata:s.metadata})})}async updateOutputs(t,s,r){const n=this.cellIndexToHandle(s),l=this.validateAndConvertOutputs((0,u.asArray)(t));return this.applyEditSoon({editType:2,handle:n,append:r,outputs:l})}async updateOutputItems(t,s,r){return t=g.NotebookCellOutput.ensureUniqueMimeTypes((0,u.asArray)(t),!0),this.applyEditSoon({editType:7,items:t.map(I.NotebookCellOutputItem.from),outputId:s.id,append:r})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(r){t._executionOrder=r,t.mixinMetadata({executionOrder:r})},start(r){if(t._state===b.Resolved||t._state===b.Started)throw new Error("Cannot call start again");t._state=b.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:P.NotebookCellExecutionState.Executing,runStartTime:r??null})},end(r,n){if(t._state===b.Resolved)throw new Error("Cannot call resolve twice");t._state=b.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:r??null,runEndTime:n??null})},clearOutput(r){return t.verifyStateForOutput(),t.updateOutputs([],r,!1)},appendOutput(r,n){return t.verifyStateForOutput(),t.updateOutputs(r,n,!0)},replaceOutput(r,n){return t.verifyStateForOutput(),t.updateOutputs(r,n,!1)},appendOutputItems(r,n){return t.verifyStateForOutput(),t.updateOutputItems(r,n,!0)},replaceOutputItems(r,n){return t.verifyStateForOutput(),t.updateOutputItems(r,n,!1)}})}}class h{constructor(t,s){this.delay=t,this.callback=s,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=(0,i.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const s=this.batch;return this.batch=[],this.callback(s)})),this.waitPromise}}}),define(me[240],ge([0,1,3,5,125]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class S{constructor(I,D){this._extHostNotebook=D,this._rendererMessageEmitters=new Map,this.proxy=I.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(I,D,A){const i=this._extHostNotebook.getEditorById(I);this._rendererMessageEmitters.get(D)?.fire({editor:i.apiEditor,message:A})}createRendererMessaging(I){return{onDidReceiveMessage:(...A)=>this.getOrCreateEmitterFor(I).event(...A),postMessage:(A,i)=>{const P=C.ExtHostNotebookEditor.apiEditorsToExtHost.get(A);if(!P)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(P.id,I,i)}}}getOrCreateEmitterFor(I){let D=this._rendererMessageEmitters.get(I);return D||(D=new p.Emitter({onLastListenerRemove:()=>{D?.dispose(),this._rendererMessageEmitters.delete(I)}}),this._rendererMessageEmitters.set(I,D),D)}}e.ExtHostNotebookRenderers=S}),define(me[62],ge([0,1,5,3,6,22,4,13]),function(J,e,p,L,C,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends C.Disposable{constructor(a,g,w,_,b){super();this._onDidAppend=this._register(new L.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=a,this._proxy=b,this._id=b.$register(this.name,g,w,_),this._disposed=!1,this._offset=0}get name(){return this._name}append(a){this.validate(),this._offset+=a?S.VSBuffer.fromString(a).byteLength:0}update(){this._id.then(a=>this._proxy.$update(a))}appendLine(a){this.validate(),this.append(a+`
`)}clear(){this.validate();const a=this._offset;this._id.then(g=>this._proxy.$clear(g,a))}show(a,g){this.validate(),this._id.then(w=>this._proxy.$reveal(w,!!(typeof a=="boolean"?a:g)))}hide(){this.validate(),this._id.then(a=>this._proxy.$close(a))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(a=>this._proxy.$dispose(a)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class A extends D{constructor(a,g,w){super(a,!1,void 0,g,w)}append(a){super.append(a),this._id.then(g=>this._proxy.$append(g,a)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=A;class i extends D{constructor(a,g,w){super(a,!0,g,void 0,w)}append(a){throw new Error("Not supported")}}class P{constructor(a,g){this.name=a,this._channel=g}append(a){this._channel.then(g=>g.append(a))}appendLine(a){this._channel.then(g=>g.appendLine(a))}clear(){this._channel.then(a=>a.clear())}show(a,g){this._channel.then(w=>w.show(a,g))}hide(){this._channel.then(a=>a.hide())}dispose(){this._channel.then(a=>a.dispose())}}e.LazyOutputChannel=P;let c=class{constructor(a){this._proxy=a.getProxy(p.MainContext.MainThreadOutputService)}$setVisibleChannel(a){}createOutputChannel(a,g){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");return new A(g.identifier.value,a,this._proxy)}createOutputChannelFromLogFile(a,g){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");if(!g)throw new Error("illegal argument `file`. must not be falsy");return new i(a,g,this._proxy)}};c=Ve([He(0,I.IExtHostRpcService)],c),e.ExtHostOutputService=c,e.IExtHostOutputService=(0,T.createDecorator)("IExtHostOutputService")}),define(me[241],ge([0,1,17,21,3,6,5,2,7,15,18,56]),function(J,e,p,L,C,S,T,I,D,A,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function c(u,a,g){const w=u.getProxy(T.MainContext.MainThreadQuickOpen);class _{constructor(n,l){this._sessions=new Map,this._instances=0,this._workspace=n,this._commands=l}showQuickPick(n,l,f,m=L.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(n),y=++this._instances,o=w.$show(y,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},m),k={},F=o.then(()=>k);return Promise.race([F,E]).then($=>{if($!==k)return E.then(Q=>{const oe=[];for(let j=0;j<Q.length;j++){const O=Q[j];let B,R,z,N,M;typeof O=="string"?B=O:(B=O.label,R=O.description,z=O.detail,N=O.picked,M=O.alwaysShow),oe.push({label:B,description:R,handle:j,detail:z,picked:N,alwaysShow:M})}return f&&typeof f.onDidSelectItem=="function"&&(this._onDidSelectItem=j=>{f.onDidSelectItem(Q[j])}),w.$setItems(y,oe),o.then(j=>{if(typeof j=="number")return Q[j];if(Array.isArray(j))return j.map(O=>Q[O])})})}).then(void 0,$=>{if(!(0,A.isPromiseCanceledError)($))return w.$setError(y,$),Promise.reject($)})}$onItemSelected(n){this._onDidSelectItem&&this._onDidSelectItem(n)}showInput(n,l=L.CancellationToken.None){return this._validateInput=n?n.validateInput:void 0,w.$input(n,typeof this._validateInput=="function",l).then(void 0,f=>{if(!(0,A.isPromiseCanceledError)(f))return Promise.reject(f)})}$validateInput(n){return this._validateInput?(0,p.asPromise)(()=>this._validateInput(n)):Promise.resolve(void 0)}async showWorkspaceFolderPick(n,l=L.CancellationToken.None){const f=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!f)return;const m=await this._workspace.getWorkspaceFolders2();if(!!m)return m.find(E=>E.uri.toString()===f.uri.toString())}createQuickPick(n,l){const f=new t(n,l,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}createInputBox(n){const l=new s(n,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}$onDidChangeValue(n,l){const f=this._sessions.get(n);f&&f._fireDidChangeValue(l)}$onDidAccept(n){const l=this._sessions.get(n);l&&l._fireDidAccept()}$onDidChangeActive(n,l){const f=this._sessions.get(n);f instanceof t&&f._fireDidChangeActive(l)}$onDidChangeSelection(n,l){const f=this._sessions.get(n);f instanceof t&&f._fireDidChangeSelection(l)}$onDidTriggerButton(n,l){const f=this._sessions.get(n);f&&f._fireDidTriggerButton(l)}$onDidHide(n){const l=this._sessions.get(n);l&&l._fireDidHide()}}class b{constructor(n,l){this._extensionId=n,this._onDidDispose=l,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new C.Emitter,this._onDidChangeValueEmitter=new C.Emitter,this._onDidTriggerButtonEmitter=new C.Emitter,this._onDidHideEmitter=new C.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(n){this._title=n,this.update({title:n})}get step(){return this._steps}set step(n){this._steps=n,this.update({step:n})}get totalSteps(){return this._totalSteps}set totalSteps(n){this._totalSteps=n,this.update({totalSteps:n})}get enabled(){return this._enabled}set enabled(n){this._enabled=n,this.update({enabled:n})}get busy(){return this._busy}set busy(n){this._busy=n,this.update({busy:n})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(n){this._ignoreFocusOut=n,this.update({ignoreFocusOut:n})}get value(){return this._value}set value(n){this._value=n,this.update({value:n})}get placeholder(){return this._placeholder}set placeholder(n){this._placeholder=n,this.update({placeholder:n})}get buttons(){return this._buttons}set buttons(n){this._buttons=n.slice(),this._handlesToButtons.clear(),n.forEach((l,f)=>{const m=l===D.QuickInputButtons.Back?-1:f;this._handlesToButtons.set(m,l)}),this.update({buttons:n.map((l,f)=>({iconPath:d(l.iconPath),tooltip:l.tooltip,handle:l===D.QuickInputButtons.Back?-1:f}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(n){this._value=n,this._onDidChangeValueEmitter.fire(n)}_fireDidTriggerButton(n){const l=this._handlesToButtons.get(n);l&&this._onDidTriggerButtonEmitter.fire(l)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,S.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),w.$dispose(this._id))}update(n){if(!this._disposed){for(const l of Object.keys(n)){const f=n[l];this._pendingUpdate[l]=f===void 0?null:f}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){w.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}b._nextId=1;function d(r){if(r instanceof D.ThemeIcon)return{id:r.id};const n=v(r),l=h(r);return{dark:typeof n=="string"?I.URI.file(n):n,light:typeof l=="string"?I.URI.file(l):l}}function h(r){return typeof r=="object"&&"light"in r?r.light:r}function v(r){return typeof r=="object"&&"dark"in r?r.dark:r}class t extends b{constructor(n,l,f){super(n,f);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new C.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new C.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(n){this._items=n.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),n.forEach((l,f)=>{this._handlesToItems.set(f,l),this._itemsToHandles.set(l,f)}),this.update({items:n.map((l,f)=>({label:l.label,description:l.description,handle:f,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(n){this._canSelectMany=n,this.update({canSelectMany:n})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(n){this._matchOnDescription=n,this.update({matchOnDescription:n})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(n){this._matchOnDetail=n,this.update({matchOnDetail:n})}get sortByLabel(){return this._sortByLabel}set sortByLabel(n){this._sortByLabel=n,this.update({sortByLabel:n})}get activeItems(){return this._activeItems}set activeItems(n){this._activeItems=n.filter(l=>this._itemsToHandles.has(l)),this.update({activeItems:this._activeItems.map(l=>this._itemsToHandles.get(l))})}get selectedItems(){return this._selectedItems}set selectedItems(n){this._selectedItems=n.filter(l=>this._itemsToHandles.has(l)),this.update({selectedItems:this._selectedItems.map(l=>this._itemsToHandles.get(l))})}_fireDidChangeActive(n){const l=(0,i.coalesce)(n.map(f=>this._handlesToItems.get(f)));this._activeItems=l,this._onDidChangeActiveEmitter.fire(l)}_fireDidChangeSelection(n){const l=(0,i.coalesce)(n.map(f=>this._handlesToItems.get(f)));this._selectedItems=l,this._onDidChangeSelectionEmitter.fire(l)}}class s extends b{constructor(n,l){super(n,l);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(n){this._password=n,this.update({password:n})}get prompt(){return this._prompt}set prompt(n){this._prompt=n,this.update({prompt:n})}get validationMessage(){return this._validationMessage}set validationMessage(n){this._validationMessage=n,this.update({validationMessage:n,severity:n?P.default.Error:P.default.Ignore})}}return new _(a,g)}e.createExtHostQuickOpen=c}),define(me[242],ge([0,1,2,3,53,6,17,5,18,97,12,26,34,193]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function a(l){if(l)return typeof l.iconPath=="string"?p.URI.file(l.iconPath):p.URI.isUri(l.iconPath)||u.ThemeIcon.isThemeIcon(l.iconPath)?l.iconPath:void 0}function g(l,f){if(!l.iconPath&&!f.iconPath)return 0;if(l.iconPath){if(!f.iconPath)return 1}else return-1;const m=typeof l.iconPath=="string"?l.iconPath:p.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id,E=typeof f.iconPath=="string"?f.iconPath:p.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,A.comparePaths)(m,E)}function w(l,f){let m=0;if(l.strikeThrough!==f.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==f.faded)return l.faded?1:-1;if(l.tooltip!==f.tooltip)return(l.tooltip||"").localeCompare(f.tooltip||"");if(m=g(l,f),m!==0)return m;if(l.light&&f.light)m=g(l.light,f.light);else{if(l.light)return 1;if(f.light)return-1}if(m!==0)return m;if(l.dark&&f.dark)m=g(l.dark,f.dark);else{if(l.dark)return 1;if(f.dark)return-1}return m}function _(l,f){if(l.command!==f.command)return l.command<f.command?-1:1;if(l.title!==f.title)return l.title<f.title?-1:1;if(l.tooltip!==f.tooltip){if(l.tooltip!==void 0&&f.tooltip!==void 0)return l.tooltip<f.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(l.arguments===f.arguments)return 0;if(l.arguments)if(f.arguments){if(l.arguments.length!==f.arguments.length)return l.arguments.length-f.arguments.length}else return 1;else return-1;for(let m=0;m<l.arguments.length;m++){const E=l.arguments[m],y=f.arguments[m];if(E!==y)return E<y?-1:1}return 0}function b(l,f){let m=(0,A.comparePaths)(l.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(m!==0)return m;if(l.command&&f.command)m=_(l.command,f.command);else{if(l.command)return 1;if(f.command)return-1}if(m!==0)return m;if(l.decorations&&f.decorations)m=w(l.decorations,f.decorations);else{if(l.decorations)return 1;if(f.decorations)return-1}return m}function d(l,f){for(let m=0;m<l.length;m++)if(l[m]!==f[m])return!1;return!0}function h(l,f){return l.command===f.command&&l.title===f.title&&l.tooltip===f.tooltip&&(l.arguments&&f.arguments?d(l.arguments,f.arguments):l.arguments===f.arguments)}function v(l,f){return(0,D.equals)(l,f,h)}class t{constructor(f,m,E){this._extension=f,this._proxy=m,this._sourceControlHandle=E,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(f){this._proxy.$setInputBoxValue(this._sourceControlHandle,f),this.updateValue(f)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(f){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,f),this._placeholder=f}get validateInput(){return(0,c.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(f){if((0,c.checkProposedApiEnabled)(this._extension),f&&typeof f!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=f,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!f)}get visible(){return this._visible}set visible(f){f=!!f,this._visible!==f&&(this._visible=f,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,f))}focus(){(0,c.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(f,m){(0,c.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,f,m)}$onInputBoxValueChange(f){this.updateValue(f)}updateValue(f){this._value=f,this._onDidChange.fire(f)}}e.ExtHostSCMInputBox=t;class s{constructor(f,m,E,y,o){this._proxy=f,this._commands=m,this._sourceControlHandle=E,this._id=y,this._label=o,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=s._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(f){this._label=f,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,f)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(f){this._hideWhenEmpty=f,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(f){this._resourceStates=[...f],this._onDidUpdateResourceStates.fire()}getResourceState(f){return this._resourceStatesMap.get(f)}$executeResourceCommand(f,m){const E=this._resourceStatesCommandsMap.get(f);return E?(0,T.asPromise)(()=>this._commands.executeCommand(E.command,...E.arguments||[],m)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this._resourceStates].sort(b),E=(0,D.sortedDiff)(this._resourceSnapshot,f,b).map(k=>{const F=k.toInsert.map($=>{const Q=this._resourceHandlePool++;this._resourceStatesMap.set(Q,$);const oe=$.resourceUri;let j;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const ee=new S.DisposableStore;j=this._commands.converter.toInternal($.command,ee),this._resourceStatesDisposablesMap.set(Q,ee)}else this._resourceStatesCommandsMap.set(Q,$.command);const O=a($.decorations),B=$.decorations&&a($.decorations.light)||O,R=$.decorations&&a($.decorations.dark)||O,z=[B,R],N=$.decorations&&$.decorations.tooltip||"",M=$.decorations&&!!$.decorations.strikeThrough,q=$.decorations&&!!$.decorations.faded,x=$.contextValue||"";return{rawResource:[Q,oe,z,N,M,q,x,j],handle:Q}});return{start:k.start,deleteCount:k.deleteCount,toInsert:F}}),y=E.map(({start:k,deleteCount:F,toInsert:$})=>[k,F,$.map(Q=>Q.rawResource)]),o=E.reverse();for(const{start:k,deleteCount:F,toInsert:$}of o){const Q=$.map(j=>j.handle),oe=this._handlesSnapshot.splice(k,F,...Q);for(const j of oe)this._resourceStatesMap.delete(j),this._resourceStatesCommandsMap.delete(j),this._resourceStatesDisposablesMap.get(j)?.dispose(),this._resourceStatesDisposablesMap.delete(j)}return this._resourceSnapshot=f,y}dispose(){this._disposed=!0,this._onDidDispose.fire()}}s._handlePool=0;class r{constructor(f,m,E,y,o,k){this._proxy=m,this._commands=E,this._id=y,this._label=o,this._rootUri=k,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new S.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new S.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=r._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new t(f,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,y,o,k)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(f){this._count!==f&&(this._count=f,this._proxy.$updateSourceControl(this.handle,{count:f}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(f){this._quickDiffProvider=f,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!f})}get commitTemplate(){return this._commitTemplate}set commitTemplate(f){f!==this._commitTemplate&&(this._commitTemplate=f,this._proxy.$updateSourceControl(this.handle,{commitTemplate:f}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(f){this._acceptInputDisposables.value=new S.DisposableStore,this._acceptInputCommand=f;const m=this._commands.converter.toInternal(f,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:m})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(f){if(this._statusBarCommands&&f&&v(this._statusBarCommands,f))return;this._statusBarDisposables.value=new S.DisposableStore,this._statusBarCommands=f;const m=(f||[]).map(E=>this._commands.converter.toInternal(E,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:m})}get selected(){return this._selected}createResourceGroup(f,m){const E=new s(this._proxy,this._commands,this.handle,f,m),y=L.Event.once(E.onDidDispose)(()=>this.createdResourceGroups.delete(E));return this.createdResourceGroups.set(E,y),this.eventuallyAddResourceGroups(),E}eventuallyAddResourceGroups(){const f=[],m=[];for(const[E,y]of this.createdResourceGroups){y.dispose();const o=E.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(E),this.eventuallyUpdateResourceStates()});L.Event.once(E.onDidDispose)(()=>{this.updatedResourceGroups.delete(E),o.dispose(),this._groups.delete(E.handle),this._proxy.$unregisterGroup(this.handle,E.handle)}),f.push([E.handle,E.id,E.label,E.features]);const k=E._takeResourceStateSnapshot();k.length>0&&m.push([E.handle,k]),this._groups.set(E.handle,E)}this._proxy.$registerGroups(this.handle,f,m),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const f=[];this.updatedResourceGroups.forEach(m=>{const E=m._takeResourceStateSnapshot();E.length!==0&&f.push([m.handle,E])}),f.length>0&&this._proxy.$spliceResourceStates(this.handle,f),this.updatedResourceGroups.clear()}getResourceGroup(f){return this._groups.get(f)}setSelectionState(f){this._selected=f,this._onDidChangeSelection.fire(f)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(f=>f.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}r._handlePool=0,Ve([(0,C.debounce)(100)],r.prototype,"eventuallyAddResourceGroups",null),Ve([(0,C.debounce)(100)],r.prototype,"eventuallyUpdateResourceStates",null);let n=class Un{constructor(f,m,E){this._commands=m,this.logService=E,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=f.getProxy(I.MainContext.MainThreadSCM),this._telemetry=f.getProxy(I.MainContext.MainThreadTelemetry),m.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===3){const o=this._sourceControls.get(y.sourceControlHandle);if(!o)return y;const k=o.getResourceGroup(y.groupHandle);return k?k.getResourceState(y.handle):y}else if(y&&y.$mid===4){const o=this._sourceControls.get(y.sourceControlHandle);return o?o.getResourceGroup(y.groupHandle):y}else if(y&&y.$mid===5){const o=this._sourceControls.get(y.handle);return o||y}return y}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(f,m,E,y){this.logService.trace("ExtHostSCM#createSourceControl",f.identifier.value,m,E,y),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const o=Un._handlePool++,k=new r(f,this._proxy,this._commands,m,E,y);this._sourceControls.set(o,k);const F=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(f.identifier))||[];return F.push(k),this._sourceControlsByExtension.set(P.ExtensionIdentifier.toKey(f.identifier),F),k}getLastInputBox(f){this.logService.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const m=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(f.identifier)),E=m&&m[m.length-1];return E&&E.inputBox}$provideOriginalResource(f,m,E){const y=p.URI.revive(m);this.logService.trace("ExtHostSCM#$provideOriginalResource",f,y.toString());const o=this._sourceControls.get(f);return!o||!o.quickDiffProvider||!o.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>o.quickDiffProvider.provideOriginalResource(y,E)).then(k=>k||null)}$onInputBoxValueChange(f,m){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",f);const E=this._sourceControls.get(f);return E&&E.inputBox.$onInputBoxValueChange(m),Promise.resolve(void 0)}$executeResourceCommand(f,m,E,y){this.logService.trace("ExtHostSCM#$executeResourceCommand",f,m,E);const o=this._sourceControls.get(f);if(!o)return Promise.resolve(void 0);const k=o.getResourceGroup(m);return k?k.$executeResourceCommand(E,y):Promise.resolve(void 0)}$validateInput(f,m,E){this.logService.trace("ExtHostSCM#$validateInput",f);const y=this._sourceControls.get(f);return!y||!y.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>y.inputBox.validateInput(m,E)).then(o=>o?Promise.resolve([o.message,o.type]):Promise.resolve(void 0))}$setSelectedSourceControl(f){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this._sourceControls.get(f)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=f,Promise.resolve(void 0)}};n._handlePool=0,n=Ve([He(2,i.ILogService)],n),e.ExtHostSCM=n});var nt=this&&this.__classPrivateFieldSet||function(J,e,p,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(J,p):C?C.value=p:e.set(J,p),p},Ue=this&&this.__classPrivateFieldGet||function(J,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(J):L?L.value:e.get(J)};define(me[243],ge([0,1,7,5,162,6,16]),function(J,e,p,L,C,S,T){"use strict";var I,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class A{constructor(u,a,g,w,_=p.StatusBarAlignment.Left,b){I.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new S.DisposableStore,nt(this,I,u,"f"),nt(this,D,a,"f"),this._entryId=A.ID_GEN++,this._extension=g,this._id=w,this._alignment=_,this._priority=b}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(u){this._text=u,this.update()}set name(u){this._name=u,this.update()}set tooltip(u){this._tooltip=u,this.update()}set color(u){this._color=u,this.update()}set backgroundColor(u){u&&!A.ALLOWED_BACKGROUND_COLORS.has(u.id)&&(u=void 0),this._backgroundColor=u,this.update()}set command(u){this._command?.fromApi!==u&&(this._internalCommandRegistration.clear(),typeof u=="string"?this._command={fromApi:u,internal:Ue(this,D,"f").toInternal({title:"",command:u},this._internalCommandRegistration)}:u?this._command={fromApi:u,internal:Ue(this,D,"f").toInternal(u,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(u){this._accessibilityInformation=u,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,I,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let u;this._extension?this._id?u=`${this._extension.identifier.value}.${this._id}`:u=this._extension.identifier.value:u=this._id;let a;this._name?a=this._name:a=(0,C.localize)(0,null,this._extension.displayName||this._extension.name);let g=this._color;this._backgroundColor&&(g=A.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const w=this._tooltip?T.MarkdownString.fromStrict(this._tooltip):void 0;Ue(this,I,"f").$setEntry(this._entryId,u,a,this._text,w,this._command?.internal,g,this._backgroundColor,this._alignment===p.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=A,I=new WeakMap,D=new WeakMap,A.ID_GEN=0,A.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new p.ThemeColor("statusBarItem.errorForeground")]]);class i{constructor(u){this._messages=[],this._item=u.createStatusBarEntry(void 0,"status.extensionMessage",p.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,C.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(u){const a={message:u};return this._messages.unshift(a),this._update(),new p.Disposable(()=>{const g=this._messages.indexOf(a);g>=0&&(this._messages.splice(g,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class P{constructor(u,a){this._proxy=u.getProxy(L.MainContext.MainThreadStatusBar),this._commands=a,this._statusMessage=new i(this)}createStatusBarEntry(u,a,g,w){return new A(this._proxy,this._commands,u,a,g,w)}setStatusBarMessage(u,a){const g=this._statusMessage.setMessage(u);let w;return typeof a=="number"?w=setTimeout(()=>g.dispose(),a):typeof a!="undefined"&&a.then(()=>g.dispose(),()=>g.dispose()),new p.Disposable(()=>{g.dispose(),clearTimeout(w)})}}e.ExtHostStatusBar=P}),define(me[90],ge([0,1,5,3,4]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class S{constructor(I){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=I.getProxy(p.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(I,D){this._proxy.$registerExtensionStorageKeysToSync(I,D)}getValue(I,D,A){return this._proxy.$getValue(I,D).then(i=>i||A)}setValue(I,D,A){return this._proxy.$setValue(I,D,A)}$acceptValue(I,D,A){this._onDidChangeStorage.fire({shared:I,key:D,value:A})}}e.ExtHostStorage=S,e.IExtHostStorage=(0,C.createDecorator)("IExtHostStorage")}),define(me[63],ge([0,1,4,27,12,89,2]),function(J,e,p,L,C,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,p.createDecorator)("IExtensionStoragePaths");let I=class{constructor(A,i,P){this._logService=i,this._extHostFileSystem=P,this._workspace=A.workspace??void 0,this._environment=A.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(c=>this._value=c)}async _getWorkspaceStorageURI(A){return T.URI.joinPath(this._environment.workspaceStorageHome,A)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const A=this._workspace.id,i=await this._getWorkspaceStorageURI(A);try{return await this._extHostFileSystem.value.stat(i),this._logService.trace("[ExtHostStorage] storage dir already exists",i),i}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",i),await this._extHostFileSystem.value.createDirectory(i),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(i,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),i}catch(P){this._logService.error("[ExtHostStorage]",P);return}}workspaceValue(A){if(this._value)return T.URI.joinPath(this._value,A.identifier.value)}globalValue(A){return T.URI.joinPath(this._environment.globalStorageHome,A.identifier.value.toLowerCase())}onWillDeactivateAll(){}};I=Ve([He(0,L.IExtHostInitDataService),He(1,C.ILogService),He(2,S.IExtHostConsumerFileSystem)],I),e.ExtensionStoragePaths=I}),define(me[33],ge([0,1,3,5,4,2,13,6,7,163,15,208,21,32,191,14]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,C.createDecorator)("IExtHostTerminalService");class w{constructor(r,n,l,f){this._proxy=r,this._id=n,this._creationOptions=l,this._name=f,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(E=>this._pidPromiseComplete=E);const m=this;this.value={get name(){return m._name||""},get processId(){return m._pidPromise},get creationOptions(){return m._creationOptions},get exitStatus(){return m._exitStatus},sendText(E,y=!0){m._checkDisposed(),m._proxy.$sendText(m._id,E,y)},show(E){m._checkDisposed(),m._proxy.$show(m._id,E)},hide(){m._checkDisposed(),m._proxy.$hide(m._id)},dispose(){m._disposed||(m._disposed=!0,m._proxy.$dispose(m._id))},get dimensions(){if(!(m._cols===void 0||m._rows===void 0))return{columns:m._cols,rows:m._rows}}}}async create(r,n){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:r.name,shellPath:(0,g.withNullAsUndefined)(r.shellPath),shellArgs:(0,g.withNullAsUndefined)(r.shellArgs),cwd:(0,g.withNullAsUndefined)(r.cwd),env:(0,g.withNullAsUndefined)(r.env),icon:(0,g.withNullAsUndefined)(t(r.iconPath)),initialText:(0,g.withNullAsUndefined)(r.message),strictEnv:(0,g.withNullAsUndefined)(r.strictEnv),hideFromUser:(0,g.withNullAsUndefined)(r.hideFromUser),isFeatureTerminal:(0,g.withNullAsUndefined)(n?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,g.withNullAsUndefined)(n?.useShellEnvironment),isSplitTerminal:n?.isSplitTerminal,target:n?.target})}async createExtensionTerminal(r,n,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:l,isSplitTerminal:r,target:n}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(r){this._name=r}setExitCode(r){this._exitStatus=Object.freeze({code:r})}setDimensions(r,n){return r===this._cols&&n===this._rows||r===0||n===0?!1:(this._cols=r,this._rows=n,!0)}_setProcessId(r){this._pidPromiseComplete?(this._pidPromiseComplete(r),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==r&&(this._pidPromise=Promise.resolve(r))})}}e.ExtHostTerminal=w;class _{constructor(r){this._pty=r,this.id=0,this.shouldPersist=!1,this._onProcessData=new p.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new p.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new p.Emitter,this._onProcessTitleChanged=new p.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new p.Emitter,this._onProcessShellTypeChanged=new p.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(r){this._pty.handleInput&&this._pty.handleInput(r)}resize(r,n){this._pty.setDimensions&&this._pty.setDimensions({columns:r,rows:n})}async processBinary(r){}acknowledgeDataEvent(r){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(r){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(n=>this._onProcessTitleChanged.fire(n)),this._pty.open(r||void 0),this._pty.setDimensions&&r&&this._pty.setDimensions(r),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=_;let b=1,d=class extends I.Disposable{constructor(r,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new p.Emitter,this._onDidOpenTerminal=new p.Emitter,this._onDidChangeActiveTerminal=new p.Emitter,this._onDidChangeTerminalDimensions=new p.Emitter,this._proxy=n.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new p.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(r),this._register({dispose:()=>{for(const[l,f]of this._terminalProcesses)f.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(r=>r.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(r){return(r?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(r){return(r?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(r,n){const l=new w(this._proxy,(0,u.generateUuid)(),r,r.name),f=new _(r.pty);return l.createExtensionTerminal(n?.isSplitTerminal,n?.target,t(r.iconPath)).then(m=>{const E=this._setupExtHostProcessListeners(m,f);this._terminalProcessDisposables[m]=E}),this._terminals.push(l),l.value}attachPtyToTerminal(r,n){if(!this._getTerminalById(r))throw new Error(`Cannot resolve terminal with id ${r} for virtual process`);const f=new _(n),m=this._setupExtHostProcessListeners(r,f);this._terminalProcessDisposables[r]=m}async $acceptActiveTerminalChanged(r){const n=this._activeTerminal;if(r===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const l=this._getTerminalById(r);l&&(this._activeTerminal=l,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(r,n){const l=this._getTerminalById(r);l&&this._onDidWriteTerminalData.fire({terminal:l.value,data:n})}async $acceptTerminalDimensions(r,n,l){const f=this._getTerminalById(r);f&&f.setDimensions(n,l)&&this._onDidChangeTerminalDimensions.fire({terminal:f.value,dimensions:f.value.dimensions})}async $acceptTerminalMaximumDimensions(r,n,l){this._terminalProcesses.get(r)?.resize(n,l)}async $acceptTerminalTitleChange(r,n){const l=this._getTerminalById(r);l&&(l.name=n)}async $acceptTerminalClosed(r,n){const l=this._getTerminalObjectIndexById(this._terminals,r);if(l!==null){const f=this._terminals.splice(l,1)[0];f.setExitCode(n),this._onDidCloseTerminal.fire(f.value)}}$acceptTerminalOpened(r,n,l,f){if(n){const y=this._getTerminalObjectIndexById(this._terminals,n);if(y!==null){this._terminals[y]._id=r,this._onDidOpenTerminal.fire(this.terminals[y]),this._terminals[y].isOpen=!0;return}}const m={name:f.name,shellPath:f.executable,shellArgs:f.args,cwd:typeof f.cwd=="string"?f.cwd:S.URI.revive(f.cwd),env:f.env,hideFromUser:f.hideFromUser},E=new w(this._proxy,r,m,l);this._terminals.push(E),this._onDidOpenTerminal.fire(E.value),E.isOpen=!0}async $acceptTerminalProcessId(r,n){const l=this._getTerminalById(r);l&&l._setProcessId(n)}async $startExtensionTerminal(r,n){const l=this._getTerminalById(r);if(!l)return{message:(0,A.localize)(0,null,r)};l.isOpen||await new Promise(m=>{const E=this.onDidOpenTerminal(async y=>{y===l.value&&(E.dispose(),m())})});const f=this._terminalProcesses.get(r);f?f.startSendingEvents(n):this._extensionTerminalAwaitingStart[r]={initialDimensions:n}}_setupExtHostProcessListeners(r,n){const l=new I.DisposableStore;l.add(n.onProcessReady(m=>this._proxy.$sendProcessReady(r,m.pid,m.cwd))),l.add(n.onProcessTitleChanged(m=>this._proxy.$sendProcessTitle(r,m))),this._bufferer.startBuffering(r,n.onProcessData),l.add(n.onProcessExit(m=>this._onProcessExit(r,m))),n.onProcessOverrideDimensions&&l.add(n.onProcessOverrideDimensions(m=>this._proxy.$sendOverrideDimensions(r,m))),this._terminalProcesses.set(r,n);const f=this._extensionTerminalAwaitingStart[r];return f&&n instanceof _&&(n.startSendingEvents(f.initialDimensions),delete this._extensionTerminalAwaitingStart[r]),l}$acceptProcessAckDataEvent(r,n){this._terminalProcesses.get(r)?.acknowledgeDataEvent(n)}$acceptProcessInput(r,n){this._terminalProcesses.get(r)?.input(n)}$acceptProcessResize(r,n,l){try{this._terminalProcesses.get(r)?.resize(n,l)}catch(f){if(f.code!=="EPIPE"&&f.code!=="ERR_IPC_CHANNEL_CLOSED")throw f}}$acceptProcessShutdown(r,n){this._terminalProcesses.get(r)?.shutdown(n)}$acceptProcessRequestInitialCwd(r){this._terminalProcesses.get(r)?.getInitialCwd().then(n=>this._proxy.$sendProcessInitialCwd(r,n))}$acceptProcessRequestCwd(r){this._terminalProcesses.get(r)?.getCwd().then(n=>this._proxy.$sendProcessCwd(r,n))}$acceptProcessRequestLatency(r){return r}registerLinkProvider(r){return this._linkProviders.add(r),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(r),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(r,n,l){if(this._profileProviders.has(n))throw new Error(`Terminal profile provider "${n}" already registered`);return this._profileProviders.set(n,l),this._proxy.$registerProfileProvider(n,r.identifier.value),new D.Disposable(()=>{this._profileProviders.delete(n),this._proxy.$unregisterProfileProvider(n)})}async $createContributedProfileTerminal(r,n){const l=new c.CancellationTokenSource().token,f=await this._profileProviders.get(r)?.provideTerminalProfile(l);if(!l.isCancellationRequested){if(!f||!("options"in f))throw new Error(`No terminal profile options provided for id "${r}"`);if("pty"in f.options){this.createExtensionTerminal(f.options,n);return}this.createTerminalFromOptions(f.options,n)}}async $provideLinks(r,n){const l=this._getTerminalById(r);if(!l)return[];this._terminalLinkCache.delete(r);const f=this._terminalLinkCancellationSource.get(r);f&&f.dispose(!0);const m=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(r,m);const E=[],y={terminal:l.value,line:n},o=[];for(const $ of this._linkProviders)o.push(new Promise(async Q=>{m.token.onCancellationRequested(()=>Q({provider:$,links:[]}));const oe=await $.provideTerminalLinks(y,m.token)||[];m.token.isCancellationRequested||Q({provider:$,links:oe})}));const k=await Promise.all(o);if(m.token.isCancellationRequested)return[];const F=new Map;for(const $ of k)$&&$.links.length>0&&E.push(...$.links.map(Q=>{const oe={id:b++,startIndex:Q.startIndex,length:Q.length,label:Q.tooltip};return F.set(oe.id,{provider:$.provider,link:Q}),oe}));return this._terminalLinkCache.set(r,F),E}$activateLink(r,n){const l=this._terminalLinkCache.get(r)?.get(n);!l||l.provider.handleTerminalLink(l.link)}_onProcessExit(r,n){this._bufferer.stopBuffering(r),this._terminalProcesses.delete(r),delete this._extensionTerminalAwaitingStart[r];const l=this._terminalProcessDisposables[r];l&&(l.dispose(),delete this._terminalProcessDisposables[r]),this._proxy.$sendProcessExit(r,n)}_getTerminalById(r){return this._getTerminalObjectById(this._terminals,r)}_getTerminalObjectById(r,n){const l=this._getTerminalObjectIndexById(r,n);return l!==null?r[l]:null}_getTerminalObjectIndexById(r,n){let l=null;return r.some((f,m)=>f._id===n?(l=m,!0):!1),l}getEnvironmentVariableCollection(r){let n=this._environmentVariableCollections.get(r.identifier.value);return n||(n=new h,this._setEnvironmentVariableCollection(r.identifier.value,n)),n}_syncEnvironmentVariableCollection(r,n){const l=(0,P.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(r,n.persistent,l.length===0?void 0:l)}$initEnvironmentVariableCollections(r){r.forEach(n=>{const l=n[0],f=new h(n[1]);this._setEnvironmentVariableCollection(l,f)})}$acceptDefaultProfile(r,n){this._defaultProfile=r,this._defaultAutomationProfile=n}_setEnvironmentVariableCollection(r,n){this._environmentVariableCollections.set(r,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(r,n)})}};d=Ve([He(1,T.IExtHostRpcService)],d),e.BaseExtHostTerminalService=d;class h{constructor(r){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new p.Emitter,this.map=new Map(r)}get persistent(){return this._persistent}set persistent(r){this._persistent=r,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(r,n){this._setIfDiffers(r,{value:n,type:D.EnvironmentVariableMutatorType.Replace})}append(r,n){this._setIfDiffers(r,{value:n,type:D.EnvironmentVariableMutatorType.Append})}prepend(r,n){this._setIfDiffers(r,{value:n,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(r,n){const l=this.map.get(r);(!l||l.value!==n.value||l.type!==n.type)&&(this.map.set(r,n),this._onDidChangeCollection.fire())}get(r){return this.map.get(r)}forEach(r,n){this.map.forEach((l,f)=>r.call(n,f,l,this))}delete(r){this.map.delete(r),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=h;let v=class extends d{constructor(r){super(!1,r)}createTerminal(r,n,l){throw new i.NotSupportedError}createTerminalFromOptions(r,n){throw new i.NotSupportedError}};v=Ve([He(0,T.IExtHostRpcService)],v),e.WorkerExtHostTerminalService=v;function t(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}});var nt=this&&this.__classPrivateFieldSet||function(J,e,p,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(J,p):C?C.value=p:e.set(J,p),p},Ue=this&&this.__classPrivateFieldGet||function(J,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(J):L?L.value:e.get(J)};define(me[244],ge([0,1,17,22,21,3,70,55,72,6,25,14,32,5,13,85,16,7,216,123]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a,g,w,_,b,d){"use strict";var h,v,t,s,r,n,l;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunConfigurationImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let f=class{constructor(R,z){this.resultsChangedEmitter=new S.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(u.MainContext.MainThreadTesting),this.observer=new oe(this.proxy),this.runTracker=new E(this.proxy),z.registerArgumentProcessor({processArgument:N=>N?.$mid===13?w.TestItem.toItemFromContext(N):N})}createTestController(R,z){const N=new A.DisposableStore,M=N.add(new b.SingleUseTestCollection(R)),q=N.add(new p.RunOnceScheduler(()=>M.expand(M.root.id,0),0)),x=new Map,K=this.proxy,ee={items:M.root.children,get label(){return z},set label(Se){z=Se,M.root.label=Se,K.$updateControllerLabel(R,z)},get id(){return R},createRunConfiguration:(Se,De,Le,qe)=>{let We=(0,I.hash)(Se);for(;x.has(We);)We++;const je=new j(this.proxy,R,We,Se,De,Le,qe);return x.set(We,je),je},createTestRun:(Se,De,Le=!0)=>this.runTracker.createTestRun(R,M,Se,De,Le),set resolveChildrenHandler(Se){M.resolveHandler=Se,Se&&q.schedule()},get resolveChildrenHandler(){return M.resolveHandler},dispose:()=>{N.dispose()}};ee.createTestITem=this.createTestItem.bind(this),K.$registerTestController(R,z),N.add((0,A.toDisposable)(()=>K.$unregisterTestController(R)));const de={controller:ee,collection:M,configurations:x};return this.controllers.set(R,de),N.add((0,A.toDisposable)(()=>this.controllers.delete(R))),N.add(M.onDidGenerateDiff(Se=>K.$publishDiff(R,Se))),ee}createTestItem(R,z,N){return new g.TestItemImpl(R,z,N)}createTestObserver(){return this.observer.checkout()}async runTests(R,z=C.CancellationToken.None){const N=y(R);if(!N)throw new Error("The request passed to `vscode.test.runTests` must include a configuration");const M=this.controllers.get(N.controllerId);if(!M)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:R.include?.map(q=>q.id)??[M.collection.root.id],profileGroup:O[N.group],profileId:N.configId,controllerId:N.controllerId}],exclude:R.exclude?.map(q=>({testId:q.id,controllerId:N.controllerId}))},z)}$provideFileCoverage(R,z,N){return D.Iterable.find(this.runTracker.trackers,M=>M.id===R)?.getCoverage(z)?.provideFileCoverage(N)??Promise.resolve([])}$resolveFileCoverage(R,z,N,M){return D.Iterable.find(this.runTracker.trackers,q=>q.id===R)?.getCoverage(z)?.resolveFileCoverage(N,M)??Promise.resolve([])}$configureRunConfig(R,z){this.controllers.get(R)?.configurations.get(z)?.configureHandler?.()}$publishTestResults(R){this.results=Object.freeze(R.map(z=>(0,i.deepFreeze)(w.TestResults.to(z))).concat(this.results).sort((z,N)=>N.completedAt-z.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest({controllerId:R,testId:z},N){const M=this.controllers.get(R)?.collection;M&&(await M.expand(z,N<0?Infinity:N),M.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R)}async $runControllerTests(R,z){const N=this.controllers.get(R.controllerId);if(!N)return;const{collection:M,configurations:q}=N,x=q.get(R.configId);if(!x)return;const K=R.testIds.map(De=>M.tree.get(De)).filter(P.isDefined),ee=R.excludeExtIds.map(De=>N.collection.tree.get(De)).filter(P.isDefined).filter(De=>K.some(Le=>M.tree.comparePositions(Le,De)===1));if(!K.length)return;const de=new _.TestRunRequest(K.map(De=>De.actual),ee.map(De=>De.actual),x),Se=this.runTracker.prepareForMainThreadTestRun(de,o.fromInternal(R,N.collection),z);try{await x.runHandler(de,z)}finally{Se.isRunning&&!z.isCancellationRequested&&await S.Event.toPromise(Se.onEnd),this.runTracker.cancelRunById(R.runId)}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};f=Ve([He(0,a.IExtHostRpcService)],f),e.ExtHostTesting=f;class m extends A.Disposable{constructor(R,z,N){super();this.dto=R,this.proxy=z,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new S.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new C.CancellationTokenSource(N)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:M}of this.tasks.values())M.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const z=(0,c.generateUuid)(),N=new k(this.proxy,this.dto.id,z),M=new F(R,this.cts.token,z,N,this.dto,this.sharedTestIds,this.proxy,()=>{this.tasks.delete(M.taskId),this.isRunning||this.dispose()});return this.tasks.set(M.taskId,{run:M,coverage:N}),M}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}}class E{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,z,N){return this.getTracker(R,z,N)}cancelRunById(R){for(const z of this.tracked.values())if(z.id===R){z.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,z,N,M,q){const x=this.tracked.get(N);if(x)return x.createRun(M);const K=o.fromPublic(R,z,N),ee=y(N);this.proxy.$startedExtensionTestRun({controllerId:R,config:ee&&{group:O[ee.group],id:ee.configId},exclude:N.exclude?.map(Se=>Se.id)??[],id:K.id,include:N.include?.map(Se=>Se.id)??[z.root.id],persist:q});const de=this.getTracker(N,K);return de.onEnd(()=>this.proxy.$finishedExtensionTestRun(K.id)),de.createRun(M)}getTracker(R,z,N){const M=new m(z,this.proxy,N);return this.tracked.set(R,M),M.onEnd(()=>this.tracked.delete(R)),M}}e.TestRunCoordinator=E;const y=B=>{if(!!B.configuration){if(!(B.configuration instanceof j))throw new Error("TestRunRequest.configuration is not an instance created from TestController.createRunConfiguration");return B.configuration}};class o{constructor(R,z,N,M,q){this.controllerId=R,this.id=z,this.include=N,this.exclude=M,this.colllection=q}static fromPublic(R,z,N){return new o(R,(0,c.generateUuid)(),N.include&&new Set(N.include.map(M=>M.id)),new Set(N.exclude?.map(M=>M.id)??D.Iterable.empty()),z)}static fromInternal(R,z){return new o(R.controllerId,R.runId,R.testIds.includes(z.root.id)?void 0:new Set(R.testIds),new Set(R.excludeExtIds),z)}isIncluded(R){for(let z=R;z;z=z.parent){if(this.include?.has(z.id))return!0;if(this.exclude.has(z.id))return!1}return this.include===void 0}}e.TestRunDto=o;class k{constructor(R,z,N){this.proxy=R,this.runId=z,this.taskId=N}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(w.TestCoverage.fromFile)??[]}catch(z){throw this.fileCoverage=void 0,z}}async resolveFileCoverage(R,z){const N=await this.fileCoverage;let M=N?.[R];return!this._coverageProvider||!N||!M?[]:(M.detailedCoverage||(M=N[R]=await this._coverageProvider.resolveFileCoverage?.(M,z)??M),M.detailedCoverage?.map(w.TestCoverage.fromDetailed)??[])}}class F{constructor(R,z,N,M,q,x,K,ee){this.name=R,this.token=z,this.taskId=N,h.set(this,void 0),v.set(this,void 0),t.set(this,void 0),s.set(this,void 0),r.set(this,void 0),n.set(this,!1),nt(this,s,ee,"f"),nt(this,h,K,"f"),nt(this,v,q,"f"),nt(this,r,M,"f"),nt(this,t,x,"f"),K.$startedTestRunTask(q.id,{id:this.taskId,name:R,running:!0})}set coverageProvider(R){Ue(this,r,"f").coverageProvider=R}get coverageProvider(){return Ue(this,r,"f").coverageProvider}setState(R,z,N){!Ue(this,n,"f")&&Ue(this,v,"f").isIncluded(R)&&(this.ensureTestIsKnown(R),Ue(this,h,"f").$updateTestStateInRun(Ue(this,v,"f").id,this.taskId,R.id,z,N))}appendMessage(R,z){!Ue(this,n,"f")&&Ue(this,v,"f").isIncluded(R)&&(this.ensureTestIsKnown(R),Ue(this,h,"f").$appendTestMessageInRun(Ue(this,v,"f").id,this.taskId,R.id,w.TestMessage.from(z)))}appendOutput(R){Ue(this,n,"f")||Ue(this,h,"f").$appendOutputToRun(Ue(this,v,"f").id,this.taskId,L.VSBuffer.fromString(R))}end(){Ue(this,n,"f")||(nt(this,n,!0,"f"),Ue(this,h,"f").$finishedTestRunTask(Ue(this,v,"f").id,this.taskId),Ue(this,s,"f").call(this))}ensureTestIsKnown(R){const z=Ue(this,t,"f");if(z.has(R.id))return;const N=[];for(;N.unshift(w.TestItem.from(R)),!(z.has(R.id)||(z.add(R.id),!R.parent));)R=R.parent;const M=Ue(this,v,"f").colllection.root;z.has(M.id)||(z.add(M.id),N.unshift(w.TestItem.from(M))),Ue(this,h,"f").$addTestsToRun(Ue(this,v,"f").controllerId,Ue(this,v,"f").id,N)}}h=new WeakMap,v=new WeakMap,t=new WeakMap,s=new WeakMap,r=new WeakMap,n=new WeakMap;class $ extends d.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,w.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:z,removed:N}=this;return{get added(){return[...R].map(M=>M.revived)},get updated(){return[...z].map(M=>M.revived)},get removed(){return[...N].map(M=>M.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class Q extends d.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new S.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,z){return{...R,revived:w.TestItem.toPlain(R.item),depth:z?z.depth+1:0,children:new Set}}createChangeCollector(){return new $(this.changeEmitter)}}e.MirroredTestCollection=Q;class oe{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(z=>z.revived)},dispose:(0,T.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new Q;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class j{constructor(R,z,N,M,q,x,K=!1){this.controllerId=z,this.configId=N,this._label=M,this.group=q,this.runHandler=x,this._isDefault=K,l.set(this,void 0),nt(this,l,R,"f");const ee=O[q];if(typeof ee!="number")throw new Error(`Unknown TestRunConfiguration.group ${q}`);Ue(this,l,"f").$publishTestRunConfig({profileId:N,controllerId:z,label:M,group:ee,isDefault:K,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,Ue(this,l,"f").$updateTestRunConfig(this.controllerId,this.configId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,Ue(this,l,"f").$updateTestRunConfig(this.controllerId,this.configId,{isDefault:R}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,Ue(this,l,"f").$updateTestRunConfig(this.controllerId,this.configId,{hasConfigurationHandler:!!R}))}dispose(){Ue(this,l,"f").$removeTestRunConfig(this.controllerId,this.configId)}}e.TestRunConfigurationImpl=j,l=new WeakMap;const O={[_.TestRunConfigurationGroup.Coverage]:8,[_.TestRunConfigurationGroup.Debug]:4,[_.TestRunConfigurationGroup.Run]:2}}),define(me[245],ge([0,1,3,18,5,126,16,7]),function(J,e,p,L,C,S,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(i,P){this._extHostDocumentsAndEditors=P,this._onDidChangeTextEditorSelection=new p.Emitter,this._onDidChangeTextEditorOptions=new p.Emitter,this._onDidChangeTextEditorVisibleRanges=new p.Emitter,this._onDidChangeTextEditorViewColumn=new p.Emitter,this._onDidChangeActiveTextEditor=new p.Emitter,this._onDidChangeVisibleTextEditors=new p.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(C.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(c=>this._onDidChangeVisibleTextEditors.fire(c)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(c=>this._onDidChangeActiveTextEditor.fire(c))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const P=this._extHostDocumentsAndEditors.allEditors();return i?P:P.map(c=>c.value)}async showTextDocument(i,P,c){let u;typeof P=="number"?u={position:T.ViewColumn.from(P),preserveFocus:c}:typeof P=="object"?u={position:T.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?T.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:u={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(i.uri,u),g=a&&this._extHostDocumentsAndEditors.getEditor(a);if(g)return g.value;throw a?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i,P){return new S.TextEditorDecorationType(this._proxy,i,P).value}$acceptEditorPropertiesChanged(i,P){const c=this._extHostDocumentsAndEditors.getEditor(i);if(!c)throw new Error("unknown text editor");if(P.options&&c._acceptOptions(P.options),P.selections){const u=P.selections.selections.map(T.Selection.to);c._acceptSelections(u)}if(P.visibleRanges){const u=L.coalesce(P.visibleRanges.map(T.Range.to));c._acceptVisibleRanges(u)}if(P.options&&this._onDidChangeTextEditorOptions.fire({textEditor:c.value,options:{...P.options,lineNumbers:T.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const u=I.TextEditorSelectionChangeKind.fromValue(P.selections.source),a=P.selections.selections.map(T.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:c.value,selections:a,kind:u})}if(P.visibleRanges){const u=L.coalesce(P.visibleRanges.map(T.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:c.value,visibleRanges:u})}}$acceptEditorPositionData(i){for(const P in i){const c=this._extHostDocumentsAndEditors.getEditor(P);if(!c)throw new Error("Unknown text editor");const u=T.ViewColumn.to(i[P]);c.value.viewColumn!==u&&(c._acceptViewColumn(u),this._onDidChangeTextEditorViewColumn.fire({textEditor:c.value,viewColumn:u}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=D}),define(me[246],ge([0,1,2,4,5,6,7]),function(J,e,p,L,C,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class I{constructor(i,P){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(C.MainContext.MainThreadTimeline),P.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===11){const u=c.uri===void 0?void 0:p.URI.revive(c.uri);return this._itemsBySourceAndUriMap.get(c.source)?.get(D(u))?.get(c.handle)}return c}})}async $getTimeline(i,P,c,u,a){return this._providers.get(i)?.provideTimeline(p.URI.revive(P),c,u,a)}registerTimelineProvider(i,P,c,u){const a=new S.DisposableStore,g=this.convertTimelineItem(P.id,u,a).bind(this);let w;P.onDidChange&&(w=P.onDidChange(b=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:P.id}),this));const _=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...P,scheme:i,onDidChange:void 0,async provideTimeline(b,d,h,v){v?.resetCache&&(a.clear(),_.get(P.id)?.clear());const t=await P.provideTimeline(b,d,h);if(t==null)return;const s=g(b,v);return{...t,source:P.id,items:t.items.map(s)}},dispose(){for(const b of _.values())b.get(P.id)?.clear();w?.dispose(),a.dispose()}})}convertTimelineItem(i,P,c){return(u,a)=>{let g;if(a?.cacheResults){let w=this._itemsBySourceAndUriMap.get(i);w===void 0&&(w=new Map,this._itemsBySourceAndUriMap.set(i,w));const _=D(u);g=w.get(_),g===void 0&&(g=new Map,w.set(_,g))}return w=>{const{iconPath:_,...b}=w,d=`${i}|${w.id??w.timestamp}`;g?.set(d,w);let h,v,t;return w.iconPath&&(_ instanceof T.ThemeIcon?t={id:_.id,color:_.color}:p.URI.isUri(_)?(h=_,v=_):{light:h,dark:v}=_),{...b,id:b.id??void 0,handle:d,source:i,command:w.command?P.toInternal(w.command,c):void 0,icon:h,iconDark:v,themeIcon:t,accessibilityInformation:w.accessibilityInformation}}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,S.toDisposable)(()=>{for(const c of this._itemsBySourceAndUriMap.values())c.get(i.id)?.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=I;function D(A){return A?.toString()}}),define(me[247],ge([0,1,6,10,2,5]),function(J,e,p,L,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{constructor(D){this._openers=new Map,this._proxy=D.getProxy(S.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,A,i,P){if(this._openers.has(A))throw new Error(`Opener with id '${A}' already registered`);const c=P.schemes.find(u=>!T.supportedSchemes.has(u));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(A,i),this._proxy.$registerUriOpener(A,P.schemes,D,P.label),(0,p.toDisposable)(()=>{this._openers.delete(A),this._proxy.$unregisterUriOpener(A)})}async $canOpenUri(D,A,i){const P=this._openers.get(D);if(!P)throw new Error(`Unknown opener with id: ${D}`);const c=C.URI.revive(A);return P.canOpenExternalUri(c,i)}async $openUri(D,A,i){const P=this._openers.get(D);if(!P)throw new Error(`Unknown opener id: '${D}'`);return P.openExternalUri(C.URI.revive(A.resolvedUri),{sourceUri:C.URI.revive(A.sourceUri)},i)}}e.ExtHostUriOpeners=T,T.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(me[248],ge([0,1,5,2,6,15,26]),function(J,e,p,L,C,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class I{constructor(A){this.handles=new Set,this.handlers=new Map,this._proxy=A.getProxy(p.MainContext.MainThreadUrls)}registerUriHandler(A,i){if(this.handles.has(T.ExtensionIdentifier.toKey(A)))throw new Error(`Protocol handler already registered for extension ${A}`);const P=I.HandlePool++;return this.handles.add(T.ExtensionIdentifier.toKey(A)),this.handlers.set(P,i),this._proxy.$registerUriHandler(P,A),(0,C.toDisposable)(()=>{this.handles.delete(T.ExtensionIdentifier.toKey(A)),this.handlers.delete(P),this._proxy.$unregisterUriHandler(P)})}$handleExternalUri(A,i){const P=this.handlers.get(A);if(!P)return Promise.resolve(void 0);try{P.handleUri(L.URI.revive(i))}catch(c){(0,S.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(A){return L.URI.revive(await this._proxy.$createAppUri(A))}}e.ExtHostUrls=I,I.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(J,e,p,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(J,p):C?C.value=p:e.set(J,p),p},Ue=this&&this.__classPrivateFieldGet||function(J,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(J):L?L.value:e.get(J)};define(me[64],ge([0,1,3,2,174,201,86,5]),function(J,e,p,L,C,S,T,I){"use strict";var D,A,i,P,c,u,a,g,w,_,b,d;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class h{constructor(m,E,y,o,k,F,$){D.set(this,void 0),A.set(this,void 0),i.set(this,void 0),P.set(this,void 0),c.set(this,void 0),u.set(this,void 0),a.set(this,""),g.set(this,void 0),w.set(this,!1),_.set(this,!1),b.set(this,!1),this._onMessageEmitter=new p.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,d.set(this,new p.Emitter),this._onDidDispose=Ue(this,d,"f").event,nt(this,D,m,"f"),nt(this,A,E,"f"),nt(this,g,y,"f"),nt(this,P,o,"f"),nt(this,c,k,"f"),nt(this,u,F,"f"),nt(this,b,v(F),"f"),nt(this,i,$,"f")}dispose(){nt(this,w,!0,"f"),Ue(this,d,"f").fire(),Ue(this,d,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return nt(this,_,!0,"f"),(0,T.asWebviewUri)(m,Ue(this,P,"f").remote)}get cspSource(){return T.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ue(this,a,"f")}set html(m){this.assertNotDisposed(),Ue(this,a,"f")!==m&&(nt(this,a,m,"f"),!Ue(this,_,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(nt(this,_,!0,"f"),Ue(this,i,"f").report("Webview vscode-resource: uris",Ue(this,u,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,A,"f").$setHtml(Ue(this,D,"f"),m))}get options(){return this.assertNotDisposed(),Ue(this,g,"f")}set options(m){this.assertNotDisposed(),Ue(this,A,"f").$setOptions(Ue(this,D,"f"),r(Ue(this,u,"f"),Ue(this,c,"f"),m)),nt(this,g,m,"f")}async postMessage(m){if(Ue(this,w,"f"))return!1;const E=(0,S.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:Ue(this,b,"f")});return Ue(this,A,"f").$postMessage(Ue(this,D,"f"),E.message,...E.buffers)}assertNotDisposed(){if(Ue(this,w,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=h,D=new WeakMap,A=new WeakMap,i=new WeakMap,P=new WeakMap,c=new WeakMap,u=new WeakMap,a=new WeakMap,g=new WeakMap,w=new WeakMap,_=new WeakMap,b=new WeakMap,d=new WeakMap;function v(f){try{const m=(0,C.normalizeVersion)((0,C.parseVersion)(f.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=v;class t{constructor(m,E,y,o,k){this.initData=E,this.workspace=y,this._logService=o,this._deprecationService=k,this._webviews=new Map,this._webviewProxy=m.getProxy(I.MainContext.MainThreadWebviews)}$onMessage(m,E,...y){const o=this.getWebview(m);if(o){const{message:k}=(0,S.deserializeWebviewMessage)(E,y);o._onMessageEmitter.fire(k)}}$onMissingCsp(m,E){this._logService.warn(`${E} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,E,y){const o=new h(m,this._webviewProxy,n(E),this.initData,this.workspace,y,this._deprecationService);return this._webviews.set(m,o),o._onDidDispose(()=>{this._webviews.delete(m)}),o}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=t;function s(f){return{id:f.identifier,location:f.extensionLocation}}e.toExtensionData=s;function r(f,m,E){return{enableCommandUris:E.enableCommandUris,enableScripts:E.enableScripts,portMapping:E.portMapping,localResourceRoots:E.localResourceRoots||l(f,m)}}e.serializeWebviewOptions=r;function n(f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots?.map(m=>L.URI.from(m))}}e.reviveOptions=n;function l(f,m){return[...(m?.getWorkspaceFolders()||[]).map(E=>E.uri),f.extensionLocation]}}),define(me[249],ge([0,1,21,55,6,10,24,2,16,64,84,5,7]),function(J,e,p,L,C,S,T,I,D,A,i,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class u{constructor(t,s){this.document=t,this._storagePath=s,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,s){await this.getEdit(t).undo(),s||this.disposeBackup()}async redo(t,s){await this.getEdit(t).redo(),s||this.disposeBackup()}disposeEdits(t){for(const s of t)this._edits.delete(s)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=h(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const s=this._edits.get(t,0);if(!s)throw new Error("No edit found");return s}}class a{constructor(){this._documents=new Map}get(t,s){return this._documents.get(this.key(t,s))}add(t,s,r){const n=this.key(t,s.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${t} resource:${s.uri}`);const l=new u(s,r);return this._documents.set(n,l),l}delete(t,s){const r=this.key(t,s.uri);this._documents.delete(r)}key(t,s){return`${t}@@@${s}`}}var g;(function(v){v[v.Text=0]="Text",v[v.Custom=1]="Custom"})(g||(g={}));class w{constructor(){this._providers=new Map}addTextProvider(t,s,r){return this.add(0,t,s,r)}addCustomProvider(t,s,r){return this.add(1,t,s,r)}get(t){return this._providers.get(t)}add(t,s,r,n){if(this._providers.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this._providers.set(s,{type:t,extension:r,provider:n}),new c.Disposable(()=>this._providers.delete(s))}}class _{constructor(t,s,r,n,l){this._extHostDocuments=s,this._extensionStoragePaths=r,this._extHostWebview=n,this._extHostWebviewPanels=l,this._editorProviders=new w,this._documents=new a,this._proxy=t.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,s,r,n){const l=new C.DisposableStore;return b(r)?(l.add(this._editorProviders.addTextProvider(s,t,r)),this._proxy.$registerTextEditorProvider((0,A.toExtensionData)(t),s,n.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,A.shouldSerializeBuffersForPostMessage)(t))):(l.add(this._editorProviders.addCustomProvider(s,t,r)),this.supportEditing(r)&&l.add(r.onDidChangeCustomDocument(f=>{const m=this.getCustomDocumentEntry(s,f.document.uri);if(d(f)){const E=m.addEdit(f);this._proxy.$onDidEdit(f.document.uri,s,E,f.label)}else this._proxy.$onContentChange(f.document.uri,s)})),this._proxy.$registerCustomEditorProvider((0,A.toExtensionData)(t),s,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,(0,A.shouldSerializeBuffersForPostMessage)(t))),c.Disposable.from(l,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(s)}))}async $createCustomDocument(t,s,r,n,l){const f=this._editorProviders.get(s);if(!f)throw new Error(`No provider found for '${s}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${s}'`);const m=I.URI.revive(t),E=await f.provider.openCustomDocument(m,{backupId:r,untitledDocumentData:n?.buffer},l);let y;return this.supportEditing(f.provider)&&this._extensionStoragePaths&&(y=this._extensionStoragePaths.workspaceValue(f.extension)??this._extensionStoragePaths.globalValue(f.extension)),this._documents.add(s,E,y),{editable:this.supportEditing(f.provider)}}async $disposeCustomDocument(t,s){const r=this._editorProviders.get(s);if(!r)throw new Error(`No provider found for '${s}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${s}'`);const n=I.URI.revive(t),{document:l}=this.getCustomDocumentEntry(s,n);this._documents.delete(s,l),l.dispose()}async $resolveWebviewEditor(t,s,r,n,l,f){const m=this._editorProviders.get(r);if(!m)throw new Error(`No provider found for '${r}'`);const E=D.ViewColumn.to(l),y=this._extHostWebview.createNewWebview(s,n.webviewOptions,m.extension),o=this._extHostWebviewPanels.createNewWebviewPanel(s,r,n.title,E,n.panelOptions,y),k=I.URI.revive(t);switch(m.type){case 1:{const{document:F}=this.getCustomDocumentEntry(r,k);return m.provider.resolveCustomEditor(F,o,f)}case 0:{const F=this._extHostDocuments.getDocument(k);return m.provider.resolveCustomTextEditor(F,o,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,s,r){this.getCustomDocumentEntry(s,t).disposeEdits(r)}async $onMoveCustomEditor(t,s,r){const n=this._editorProviders.get(r);if(!n)throw new Error(`No provider found for '${r}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const l=this._extHostWebviewPanels.getWebviewPanel(t);if(!l)throw new Error("No webview found");const f=I.URI.revive(s),m=this._extHostDocuments.getDocument(f);await n.provider.moveCustomTextEditor(m,l,p.CancellationToken.None)}async $undo(t,s,r,n){return this.getCustomDocumentEntry(s,t).undo(r,n)}async $redo(t,s,r,n){return this.getCustomDocumentEntry(s,t).redo(r,n)}async $revert(t,s,r){const n=this.getCustomDocumentEntry(s,t);await this.getCustomEditorProvider(s).revertCustomDocument(n.document,r),n.disposeBackup()}async $onSave(t,s,r){const n=this.getCustomDocumentEntry(s,t);await this.getCustomEditorProvider(s).saveCustomDocument(n.document,r),n.disposeBackup()}async $onSaveAs(t,s,r,n){const l=this.getCustomDocumentEntry(s,t);return this.getCustomEditorProvider(s).saveCustomDocumentAs(l.document,I.URI.revive(r),n)}async $backup(t,s,r){const n=this.getCustomDocumentEntry(s,t),f=await this.getCustomEditorProvider(s).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},r);return n.updateBackup(f),f.id}getCustomDocumentEntry(t,s){const r=this._documents.get(t,I.URI.revive(s));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(t){const r=this._editorProviders.get(t)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=_;function b(v){return typeof v.resolveCustomTextEditor=="function"}function d(v){return typeof v.undo=="function"&&typeof v.redo=="function"}function h(v){const t=v.scheme===S.Schemas.file||v.scheme===S.Schemas.untitled?v.fsPath:v.toString();return(0,L.hash)(t)+""}});var nt=this&&this.__classPrivateFieldSet||function(J,e,p,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(J,p):C?C.value=p:e.set(J,p),p},Ue=this&&this.__classPrivateFieldGet||function(J,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(J):L?L.value:e.get(J)};define(me[250],ge([0,1,3,6,2,32,16,64,5,7]),function(J,e,p,L,C,S,T,I,D,A){"use strict";var i,P,c,u,a,g,w,_,b,d,h,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends L.Disposable{constructor(f,m,E,y,o,k,F){super();i.set(this,void 0),P.set(this,void 0),c.set(this,void 0),u.set(this,void 0),a.set(this,void 0),g.set(this,void 0),w.set(this,void 0),_.set(this,void 0),b.set(this,!0),d.set(this,!0),h.set(this,!1),v.set(this,this._register(new p.Emitter)),this.onDidDispose=Ue(this,v,"f").event,t.set(this,this._register(new p.Emitter)),this.onDidChangeViewState=Ue(this,t,"f").event,nt(this,i,f,"f"),nt(this,P,m,"f"),nt(this,c,E,"f"),nt(this,a,k,"f"),nt(this,_,o,"f"),nt(this,g,y,"f"),nt(this,u,F,"f")}dispose(){Ue(this,h,"f")||(nt(this,h,!0,"f"),Ue(this,v,"f").fire(),Ue(this,P,"f").$disposeWebview(Ue(this,i,"f")),Ue(this,u,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,u,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,c,"f")}get title(){return this.assertNotDisposed(),Ue(this,g,"f")}set title(f){this.assertNotDisposed(),Ue(this,g,"f")!==f&&(nt(this,g,f,"f"),Ue(this,P,"f").$setTitle(Ue(this,i,"f"),f))}get iconPath(){return this.assertNotDisposed(),Ue(this,w,"f")}set iconPath(f){this.assertNotDisposed(),Ue(this,w,"f")!==f&&(nt(this,w,f,"f"),Ue(this,P,"f").$setIconPath(Ue(this,i,"f"),C.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return Ue(this,a,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,_,"f")=="number"&&Ue(this,_,"f")<0))return Ue(this,_,"f")}get active(){return this.assertNotDisposed(),Ue(this,d,"f")}get visible(){return this.assertNotDisposed(),Ue(this,b,"f")}_updateViewState(f){Ue(this,h,"f")||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(nt(this,d,f.active,"f"),nt(this,b,f.visible,"f"),nt(this,_,f.viewColumn,"f"),Ue(this,t,"f").fire({webviewPanel:this}))}reveal(f,m){this.assertNotDisposed(),Ue(this,P,"f").$reveal(Ue(this,i,"f"),{viewColumn:f?T.ViewColumn.from(f):void 0,preserveFocus:!!m})}assertNotDisposed(){if(Ue(this,h,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,P=new WeakMap,c=new WeakMap,u=new WeakMap,a=new WeakMap,g=new WeakMap,w=new WeakMap,_=new WeakMap,b=new WeakMap,d=new WeakMap,h=new WeakMap,v=new WeakMap,t=new WeakMap;class r{constructor(f,m,E){this.webviews=m,this.workspace=E,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=f.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,S.generateUuid)()}createWebviewPanel(f,m,E,y,o={}){const k=typeof y=="object"?y.viewColumn:y,F={viewColumn:T.ViewColumn.from(k),preserveFocus:typeof y=="object"&&!!y.preserveFocus},$=(0,I.shouldSerializeBuffersForPostMessage)(f),Q=r.newHandle();this._proxy.$createWebviewPanel((0,I.toExtensionData)(f),Q,m,{title:E,panelOptions:n(o),webviewOptions:(0,I.serializeWebviewOptions)(f,this.workspace,o),serializeBuffersForPostMessage:$},F);const oe=this.webviews.createNewWebview(Q,o,f);return this.createNewWebviewPanel(Q,m,E,k,o,oe)}$onDidChangeWebviewPanelViewStates(f){const m=Object.keys(f);m.sort((E,y)=>{const o=f[E],k=f[y];return o.active?1:k.active?-1:+o.visible-+k.visible});for(const E of m){const y=this.getWebviewPanel(E);if(!y)continue;const o=f[E];y._updateViewState({active:o.active,visible:o.visible,viewColumn:T.ViewColumn.to(o.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this._webviewPanels.delete(f),this.webviews.deleteWebview(f)}registerWebviewPanelSerializer(f,m,E){if(this._serializers.has(m))throw new Error(`Serializer for '${m}' already registered`);return this._serializers.set(m,{serializer:E,extension:f}),this._proxy.$registerSerializer(m,{serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(f)}),new A.Disposable(()=>{this._serializers.delete(m),this._proxy.$unregisterSerializer(m)})}async $deserializeWebviewPanel(f,m,E,y){const o=this._serializers.get(m);if(!o)throw new Error(`No serializer found for '${m}'`);const{serializer:k,extension:F}=o,$=this.webviews.createNewWebview(f,E.webviewOptions,F),Q=this.createNewWebviewPanel(f,m,E.title,y,E.panelOptions,$);await k.deserializeWebviewPanel(Q,E.state)}createNewWebviewPanel(f,m,E,y,o,k){const F=new s(f,this._proxy,m,E,y,o,k);return this._webviewPanels.set(f,F),F}getWebviewPanel(f){return this._webviewPanels.get(f)}}e.ExtHostWebviewPanels=r;function n(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(J,e,p,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(J,p):C?C.value=p:e.set(J,p),p},Ue=this&&this.__classPrivateFieldGet||function(J,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(J):L?L.value:e.get(J)};define(me[251],ge([0,1,3,6,64,5,7]),function(J,e,p,L,C,S,T){"use strict";var I,D,A,i,P,c,u,a,g,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class _ extends L.Disposable{constructor(h,v,t,s,r,n){super();I.set(this,void 0),D.set(this,void 0),A.set(this,void 0),i.set(this,void 0),P.set(this,!1),c.set(this,void 0),u.set(this,void 0),a.set(this,void 0),g.set(this,this._register(new p.Emitter)),this.onDidChangeVisibility=Ue(this,g,"f").event,w.set(this,this._register(new p.Emitter)),this.onDidDispose=Ue(this,w,"f").event,nt(this,A,t,"f"),nt(this,u,s,"f"),nt(this,I,h,"f"),nt(this,D,v,"f"),nt(this,i,r,"f"),nt(this,c,n,"f")}dispose(){Ue(this,P,"f")||(nt(this,P,!0,"f"),Ue(this,w,"f").fire(),Ue(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,u,"f")}set title(h){this.assertNotDisposed(),Ue(this,u,"f")!==h&&(nt(this,u,h,"f"),Ue(this,D,"f").$setWebviewViewTitle(Ue(this,I,"f"),h))}get description(){return this.assertNotDisposed(),Ue(this,a,"f")}set description(h){this.assertNotDisposed(),Ue(this,a,"f")!==h&&(nt(this,a,h,"f"),Ue(this,D,"f").$setWebviewViewDescription(Ue(this,I,"f"),h))}get visible(){return Ue(this,c,"f")}get webview(){return Ue(this,i,"f")}get viewType(){return Ue(this,A,"f")}_setVisible(h){h===Ue(this,c,"f")||Ue(this,P,"f")||(nt(this,c,h,"f"),Ue(this,g,"f").fire())}show(h){this.assertNotDisposed(),Ue(this,D,"f").$show(Ue(this,I,"f"),!!h)}assertNotDisposed(){if(Ue(this,P,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,D=new WeakMap,A=new WeakMap,i=new WeakMap,P=new WeakMap,c=new WeakMap,u=new WeakMap,a=new WeakMap,g=new WeakMap,w=new WeakMap;class b{constructor(h,v){this._extHostWebview=v,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=h.getProxy(S.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(h,v,t,s){if(this._viewProviders.has(v))throw new Error(`View provider for '${v}' already registered`);return this._viewProviders.set(v,{provider:t,extension:h}),this._proxy.$registerWebviewViewProvider((0,C.toExtensionData)(h),v,{retainContextWhenHidden:s?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new T.Disposable(()=>{this._viewProviders.delete(v),this._proxy.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(h,v,t,s,r){const n=this._viewProviders.get(v);if(!n)throw new Error(`No view provider found for '${v}'`);const{provider:l,extension:f}=n,m=this._extHostWebview.createNewWebview(h,{},f),E=new _(h,this._proxy,v,t,m,!0);this._webviewViews.set(h,E),await l.resolveWebviewView(E,{state:s},r)}async $onDidChangeWebviewViewVisibility(h,v){this.getWebviewView(h)._setVisible(v)}async $disposeWebviewView(h){const v=this.getWebviewView(h);this._webviewViews.delete(h),v.dispose(),this._extHostWebview.deleteWebview(h)}getWebviewView(h){const v=this._webviewViews.get(h);if(!v)throw new Error("No webview found");return v}}e.ExtHostWebviewViews=b}),define(me[129],ge([0,1,3,5,2,10,8,4,13]),function(J,e,p,L,C,S,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let A=class xn{constructor(P){this._onDidChangeWindowState=new p.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=xn.InitialState,this._proxy=P.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(c=>this.$onDidChangeWindowFocus(c))}get state(){return this._state}$onDidChangeWindowFocus(P){P!==this._state.focused&&(this._state={...this._state,focused:P},this._onDidChangeWindowState.fire(this._state))}openUri(P,c){let u;if(typeof P=="string"){u=P;try{P=C.URI.parse(P)}catch(a){return Promise.reject(`Invalid uri - '${P}'`)}}return(0,T.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===S.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this._proxy.$openUri(P,u,c)}async asExternalUri(P,c){if((0,T.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const u=await this._proxy.$asExternalUri(P,c);return C.URI.from(u)}};A.InitialState={focused:!0},A=Ve([He(0,D.IExtHostRpcService)],A),e.ExtHostWindow=A,e.IExtHostWindow=(0,I.createDecorator)("IExtHostWindow")}),define(me[252],ge([0,1,9,102,32,50,6,5,2,13]),function(J,e,p,L,C,S,T,I,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let i=class extends T.Disposable{constructor(c,u){super();const a=c.getProxy(I.MainContext.MainThreadDownloadService);u.registerCommand(!1,"_workbench.downloadResource",async g=>{const w=D.URI.file((0,p.join)((0,L.tmpdir)(),(0,C.generateUuid)()));return await a.$download(g,w),w})}};i=Ve([He(0,A.IExtHostRpcService),He(1,S.IExtHostCommands)],i),e.ExtHostDownloadService=i}),define(me[253],ge([0,1,2,9,148,28,62,27,13,6,12,114,41]),function(J,e,p,L,C,S,T,I,D,A,i,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class u{constructor(_,b,d){this.name=_,this.file=b,this.appender=d}static async create(_,b){const d=await(0,P.createRotatingLogger)(_,b,30*c.ByteSize.MB,1);return d.clearFormatters(),new u(_,b,d)}append(_){this.appender.critical(_)}flush(){this.appender.flush()}}class a extends T.AbstractExtHostOutputChannel{constructor(_,b,d,h){super(_,!1,p.URI.file(b.file),d,h);this._appender=b}append(_){super.append(_),this._appender.append(_),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(_,b){this._appender.flush(),super.show(_,b)}clear(){this._appender.flush(),super.clear()}}let g=class extends T.ExtHostOutputService{constructor(_,b,d){super(_);this.logService=b,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new A.MutableDisposable,this._logsLocation=d.logsLocation}$setVisibleChannel(_){if(_){const b=this._channels.get(_);b&&(this._visibleChannelDisposable.value=b.onDidAppend(()=>b.update()))}}createOutputChannel(_,b){if(_=_.trim(),!_)throw new Error("illegal argument `name`. must not be falsy");const d=this._doCreateOutChannel(_,b);return d.then(h=>h._id.then(v=>this._channels.set(v,h))),new T.LazyOutputChannel(_,d)}async _doCreateOutChannel(_,b){try{const d=(0,L.join)(this._logsLocation.fsPath,`output_logging_${(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await S.SymlinkSupport.existsDirectory(d)||await S.Promises.mkdir(d,{recursive:!0});const v=`${this._namePool++}-${_.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=p.URI.file((0,L.join)(d,`${v}.log`)),s=await u.create(v,t.fsPath);return new a(_,s,b.identifier.value,this._proxy)}catch(d){return this.logService.error(d),new T.ExtHostPushOutputChannel(_,b.identifier.value,this._proxy)}}};g=Ve([He(0,D.IExtHostRpcService),He(1,i.ILogService),He(2,I.IExtHostInitDataService)],g),e.ExtHostOutputService2=g}),define(me[254],ge([0,1,45,285,2,63,6,10,17]),function(J,e,p,L,C,S,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class A extends S.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(v){const t=await super._getWorkspaceStorageURI(v);if(t.scheme!==I.Schemas.file)return t;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${t.fsPath}.`),t;const s=t.fsPath;let r=0;do{let n;r===0?n=s:n=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${r}`:`${s}-${r}`,await i(n);const l=L.join(n,"vscode.lock"),f=await a(this._logService,l,!1);if(f)return this._workspaceStorageLock=f,process.on("exit",()=>{f.dispose()}),C.URI.file(n);r++}while(r<10);return t}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=A;async function i(h){try{await p.promises.stat(h);return}catch{}try{await p.promises.mkdir(h,{recursive:!0})}catch{}}const P=1e3,c=10*60*1e3;class u extends T.Disposable{constructor(v,t){super();this.logService=v,this.filename=t,this._timer=this._register(new D.IntervalTimer),this._timer.cancelAndSet(async()=>{const s=await g(v,t);(!s||s.pid!==process.pid)&&(v.info(`Lock '${t}': The lock was lost unexpectedly.`),this._timer.cancel());try{await p.promises.utimes(t,new Date,new Date)}catch(r){v.error(r),v.info(`Lock '${t}': Could not update mtime.`)}},P)}dispose(){super.dispose();try{p.unlinkSync(this.filename)}catch(v){}}async setWillRelease(v){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${v} ms.`);try{const t={pid:process.pid,willReleaseAt:Date.now()+v};await p.promises.writeFile(this.filename,JSON.stringify(t),{flag:"w"})}catch(t){this.logService.error(t)}}}async function a(h,v,t){try{const r={pid:process.pid,willReleaseAt:0};await p.promises.writeFile(v,JSON.stringify(r),{flag:"wx"})}catch(r){h.error(r)}const s=await g(h,v);return!s||s.pid!==process.pid?t?(h.info(`Lock '${v}': Could not acquire lock, giving up.`),null):(h.info(`Lock '${v}': Could not acquire lock, checking if the file is stale.`),b(h,v)):(h.info(`Lock '${v}': Lock acquired.`),new u(h,v))}async function g(h,v){let t;try{t=await p.promises.readFile(v)}catch(s){return h.error(s),null}try{return JSON.parse(String(t))}catch(s){return h.error(s),null}}async function w(h,v){let t;try{t=await p.promises.stat(v)}catch(s){return h.error(s),0}return t.mtime.getTime()}function _(h){try{return process.kill(h,0),!0}catch(v){return!1}}async function b(h,v){const t=await g(h,v);if(!t)return h.info(`Lock '${v}': Could not read pid of lock holder.`),d(h,v);if(t.willReleaseAt){let f=t.willReleaseAt-Date.now();if(f<5e3){for(f>0?h.info(`Lock '${v}': The lockfile is scheduled to be released in ${f} ms.`):h.info(`Lock '${v}': The lockfile is scheduled to have been released.`);f>0;){if(await(0,D.timeout)(Math.min(100,f)),await w(h,v)===0)return d(h,v);f=t.willReleaseAt-Date.now()}return d(h,v)}}if(!_(t.pid))return h.info(`Lock '${v}': The pid ${t.pid} appears to be gone.`),d(h,v);const s=await w(h,v),r=Date.now()-s;if(r<=c)return h.info(`Lock '${v}': The lock does not look stale, elapsed: ${r} ms, giving up.`),null;h.info(`Lock '${v}': The lock looks stale, waiting for 2s.`),await(0,D.timeout)(2e3);const n=await w(h,v),l=Date.now()-n;return l<=c?(h.info(`Lock '${v}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null):(h.info(`Lock '${v}': The lock looks stale even after waiting for 2s.`),d(h,v))}async function d(h,v){h.info(`Lock '${v}': Deleting a stale lock.`);try{await p.promises.unlink(v)}catch(t){}return a(h,v,!0)}}),define(me[255],ge([0,1,32,13,33]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let S=class extends C.BaseExtHostTerminalService{constructor(I){super(!0,I)}createTerminal(I,D,A){return this.createTerminalFromOptions({name:I,shellPath:D,shellArgs:A})}createTerminalFromOptions(I,D){const A=new C.ExtHostTerminal(this._proxy,(0,p.generateUuid)(),I,I.name);return this._terminals.push(A),A.create(I,D),A.value}};S=Ve([He(0,L.IExtHostRpcService)],S),e.ExtHostTerminalService=S}),define(me[256],ge([0,1,5,13,6,27,2,38,24,28,7,11,49,3,189,73,12]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class _{constructor(m,E,y){this.remoteAddress=m,this.localAddress=E,this._dispose=y,this._onDispose=new u.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function b(f){const m=f.trim().split(`
`),E=[];return m.forEach(o=>{const k=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(o);k&&k.length>=3&&E.push({pid:parseInt(k[1],10),socket:parseInt(k[2],10)})}),E.reduce((o,k)=>(o[k.socket]=k,o),{})}e.getSockets=b;function d(...f){const m=[].concat(...f.map(v));return[...new Map(m.filter(E=>E.st==="0A").map(E=>{const y=E.local_address.split(":");return{socket:parseInt(E.inode,10),ip:h(y[0]),port:parseInt(y[1],16)}}).map(E=>[E.ip+":"+E.port,E])).values()]}e.loadListeningPorts=d;function h(f){let m="";if(f.length===8)for(let E=f.length-2;E>=0;E-=2)m+=parseInt(f.substr(E,2),16),E!==0&&(m+=".");else for(let E=f.length-4;E>=0;E-=4)m+=parseInt(f.substr(E,4),16).toString(16),E!==0&&(m+=":");return m}e.parseIpAddress=h;function v(f){const m=f.trim().split(`
`),E=m.shift().trim().split(/\s+/).filter(o=>o!=="rx_queue"&&o!=="tm->when");return m.map(o=>o.trim().split(/\s+/).reduce((k,F,$)=>(k[E[$]||$]=F,k),{}))}e.loadConnectionTable=v;function t(f){return!!f.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||f.indexOf("out/vs/server/main.js")!==-1||f.indexOf("_productName=VSCode")!==-1}function s(f){const m=f.trim().split(`
`),E=[];return m.forEach(y=>{const o=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(y);o&&o.length>=4&&E.push({pid:parseInt(o[1],10),ppid:parseInt(o[2]),cmd:o[3]})}),E}e.getRootProcesses=s;async function r(f,m,E){const y=E.reduce((k,F)=>(k[F.pid]=F,k),{}),o=[];return f.forEach(({socket:k,ip:F,port:$})=>{const Q=m[k]?m[k].pid:void 0,oe=Q?y[Q]?.cmd:void 0;Q&&oe&&!t(oe)&&o.push({host:F,port:$,detail:oe,pid:Q})}),o}e.findPorts=r;function n(f,m,E){const y=new Map,o=s(m);for(const k of f){const F=E.get(k.port);if(F){y.set(k.port,F);continue}const $=o.find(Q=>Q.cmd.includes(`${k.port}`));if($){let Q=$,oe;do oe=o.find(j=>j.ppid===Q.pid),oe&&(Q=oe);while(oe);y.set(k.port,{host:k.ip,port:k.port,pid:Q.pid,detail:Q.cmd,ppid:Q.ppid})}else y.set(k.port,{host:k.ip,port:k.port,ppid:Number.MAX_VALUE})}return y}e.tryFindRootPorts=n;let l=class extends C.Disposable{constructor(m,E,y){super();this.logService=y,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new u.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=m.getProxy(p.MainContext.MainThreadTunnelService),P.isLinux&&E.remote.isRemote&&E.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(m,E){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${m.identifier.value} called openTunnel API for ${E.remoteAddress.host}:${E.remoteAddress.port}.`);const y=await this._proxy.$openTunnel(E,m.displayName);if(y){const o=new _(y.remoteAddress,y.localAddress,()=>this._proxy.$closeTunnel(y.remoteAddress));return this._register(o),o}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(m){return Math.max(m*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(m,E){const y=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(y,{selector:m,provider:E}),this._proxy.$registerPortsAttributesProvider(m,y),new i.Disposable(()=>{this._portAttributesProviders.delete(y),this._proxy.$unregisterPortsAttributesProvider(y)})}async $providePortAttributes(m,E,y,o,k){const F=[];for(const Q of m){const oe=this._portAttributesProviders.get(Q);if(!oe)return[];F.push(...await Promise.all(E.map(async j=>oe.provider.providePortAttributes(j,y,o,k))))}const $=F.filter(Q=>!!Q);return $.length>0?$.map(Q=>({autoForwardAction:Q.autoForwardAction,port:Q.port})):[]}async $registerCandidateFinder(m){if(m&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=m;let E=new g.MovingAverage,y;for(;this._candidateFindingEnabled;){const o=new Date().getTime(),k=(await this.findCandidatePorts()).filter($=>(0,a.isLocalhost)($.host)||(0,a.isAllInterfaces)($.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${k.map($=>$.port).join(", ")}`);const F=new Date().getTime()-o;E.update(F),(!y||JSON.stringify(y)!==JSON.stringify(k))&&(y=k,await this._proxy.$onFoundNewCandidates(y)),await new Promise($=>setTimeout(()=>$(),this.calculateDelay(E.value)))}}async setTunnelExtensionFunctions(m){return m?(m.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(m.candidatePortSource),m.showCandidatePort&&(this._showCandidatePort=m.showCandidatePort,this._proxy.$setCandidateFilter()),m.tunnelFactory&&(this._forwardPortProvider=m.tunnelFactory,this._proxy.$setTunnelProvider(m.tunnelFeatures??{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,C.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(m,E){if(this._extensionTunnels.has(m.host)){const y=this._extensionTunnels.get(m.host);y.has(m.port)&&(E&&y.get(m.port).disposeListener.dispose(),await y.get(m.port).tunnel.dispose(),y.delete(m.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(m,E){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const y=this._forwardPortProvider(m,E);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),y!==void 0){const o=await y;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(m.remoteAddress.host)||this._extensionTunnels.set(m.remoteAddress.host,new Map);const k=this._register(o.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(o.remoteAddress))));return this._extensionTunnels.get(m.remoteAddress.host).set(m.remoteAddress.port,{tunnel:o,disposeListener:k}),c.TunnelDto.fromApiTunnel(o)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(y){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(m){const E=await Promise.all(m.map(o=>this._showCandidatePort(o.host,o.port,o.detail??""))),y=m.filter((o,k)=>E[k]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${m.map(o=>o.port).join(", ")} to ${y.map(o=>o.port).join(", ")}`),y}async findCandidatePorts(){let m="",E="";try{m=await A.Promises.readFile("/proc/net/tcp","utf8"),E=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch(B){}const y=d(m,E),o=await new Promise(B=>{(0,I.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(R,z,N)=>{B(z)})}),k=b(o),F=await A.Promises.readdir("/proc"),$=[];for(let B of F)try{const R=Number(B),z=D.joinPath(T.URI.file("/proc"),B);if((await A.Promises.stat(z.fsPath)).isDirectory()&&!isNaN(R)){const M=await A.Promises.readlink(D.joinPath(z,"cwd").fsPath),q=await A.Promises.readFile(D.joinPath(z,"cmdline").fsPath,"utf8");$.push({pid:R,cwd:M,cmd:q})}}catch(R){}const Q=[],oe=y.filter(B=>{const R=k[B.socket];return R||Q.push(B),R}),j=r(oe,k,$);let O;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${Q.length}`),Q.length>0){const B=await new Promise(R=>{(0,I.exec)("ps -F -A -l | grep root",(z,N,M)=>{R(N)})});this._foundRootPorts=n(Q,B,this._foundRootPorts),O=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${O.join(", ")}`)}return j.then(B=>O?B.concat(O):B)}};l=Ve([He(0,L.IExtHostRpcService),He(1,S.IExtHostInitDataService),He(2,w.ILogService)],l),e.ExtHostTunnelService=l}),define(me[257],ge([0,1,17,21,15,3,6,100,222,127,22]),function(J,e,p,L,C,S,T,I,D,A,i){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function c(n,l){try{return JSON.stringify(n,l)}catch(f){return"null"}}function u(n,l){return JSON.stringify(n,l)}function a(n){return n?(l,f)=>f&&f.$mid===1?n.transformOutgoing(f):f:null}var g;(function(n){n[n.LocalSide=0]="LocalSide",n[n.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));var w;(function(n){n[n.Responsive=0]="Responsive",n[n.Unresponsive=1]="Unresponsive"})(w=e.ResponsiveState||(e.ResponsiveState={}));const _=()=>{},b=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class h extends T.Disposable{constructor(l,f=null,m=null){super();this[P]=!0,this._onDidChangeResponsiveState=this._register(new S.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=l,this._logger=f,this._uriTransformer=m,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let E=0,y=A.ProxyIdentifier.count;E<y;E++)this._locals[E]=null,this._proxies[E]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new p.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(E=>this._receiveOneMessage(E))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(l=>{this._pendingRPCReplies[l].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(l){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(l){this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(l){this._responsiveState!==l&&(this._responsiveState=l,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(l){return this._uriTransformer?(0,I.transformIncomingURIs)(l,this._uriTransformer):l}getProxy(l){const{nid:f,sid:m}=l;return this._proxies[f]||(this._proxies[f]=this._createProxy(f,m)),this._proxies[f]}_createProxy(l,f){let m={get:(E,y)=>(typeof y=="string"&&!E[y]&&y.charCodeAt(0)===36&&(E[y]=(...o)=>this._remoteCall(l,y,o)),y===d?f:E[y])};return new Proxy(Object.create(null),m)}set(l,f){return this._locals[l.nid]=f,f}assertRegistered(l){for(let f=0,m=l.length;f<m;f++){const E=l[f];if(!this._locals[E.nid])throw new Error(`Missing actor ${E.sid} (isMain: ${E.isMain})`)}}_receiveOneMessage(l){if(this._isDisposed)return;const f=l.byteLength,m=v.read(l,0),E=m.readUInt8(),y=m.readUInt32();switch(E){case 1:case 2:{let{rpcId:o,method:k,args:F}=t.deserializeRequestJSONArgs(m);this._uriTransformer&&(F=(0,I.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(f,y,o,k,F,E===2);break}case 3:case 4:{let{rpcId:o,method:k,args:F}=t.deserializeRequestMixedArgs(m);this._uriTransformer&&(F=(0,I.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(f,y,o,k,F,E===4);break}case 5:{this._logger&&this._logger.logIncoming(f,y,0,"ack"),this._onDidReceiveAcknowledge(y);break}case 6:{this._receiveCancel(f,y);break}case 7:{this._receiveReply(f,y,void 0);break}case 9:{let o=t.deserializeReplyOKJSON(m);this._uriTransformer&&(o=(0,I.transformIncomingURIs)(o,this._uriTransformer)),this._receiveReply(f,y,o);break}case 8:{let o=t.deserializeReplyOKVSBuffer(m);this._receiveReply(f,y,o);break}case 10:{let o=t.deserializeReplyErrError(m);this._uriTransformer&&(o=(0,I.transformIncomingURIs)(o,this._uriTransformer)),this._receiveReplyErr(f,y,o);break}case 11:{this._receiveReplyErr(f,y,void 0);break}default:console.error("received unexpected message"),console.error(l)}}_receiveRequest(l,f,m,E,y,o){this._logger&&this._logger.logIncoming(l,f,1,`receiveRequest ${(0,A.getStringIdentifierForProxy)(m)}.${E}(`,y);const k=String(f);let F,$;if(o){const oe=new L.CancellationTokenSource;y.push(oe.token),F=this._invokeHandler(m,E,y),$=()=>oe.cancel()}else F=this._invokeHandler(m,E,y),$=_;this._cancelInvokedHandlers[k]=$;const Q=t.serializeAcknowledged(f);this._logger&&this._logger.logOutgoing(Q.byteLength,f,1,"ack"),this._protocol.send(Q),F.then(oe=>{delete this._cancelInvokedHandlers[k];const j=t.serializeReplyOK(f,oe,this._uriReplacer);this._logger&&this._logger.logOutgoing(j.byteLength,f,1,"reply:",oe),this._protocol.send(j)},oe=>{delete this._cancelInvokedHandlers[k];const j=t.serializeReplyErr(f,oe);this._logger&&this._logger.logOutgoing(j.byteLength,f,1,"replyErr:",oe),this._protocol.send(j)})}_receiveCancel(l,f){this._logger&&this._logger.logIncoming(l,f,1,"receiveCancel");const m=String(f);this._cancelInvokedHandlers[m]&&this._cancelInvokedHandlers[m]()}_receiveReply(l,f,m){this._logger&&this._logger.logIncoming(l,f,0,"receiveReply:",m);const E=String(f);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const y=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E],y.resolveOk(m)}_receiveReplyErr(l,f,m){this._logger&&this._logger.logIncoming(l,f,0,"receiveReplyErr:",m);const E=String(f);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const y=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E];let o;m&&(m.$isError?(o=new Error,o.name=m.name,o.message=m.message,o.stack=m.stack):o=m),y.resolveErr(o)}_invokeHandler(l,f,m){try{return Promise.resolve(this._doInvokeHandler(l,f,m))}catch(E){return Promise.reject(E)}}_doInvokeHandler(l,f,m){const E=this._locals[l];if(!E)throw new Error("Unknown actor "+(0,A.getStringIdentifierForProxy)(l));let y=E[f];if(typeof y!="function")throw new Error("Unknown method "+f+" on actor "+(0,A.getStringIdentifierForProxy)(l));return y.apply(E,m)}_remoteCall(l,f,m){if(this._isDisposed)return Promise.reject(C.canceled());let E=null;if(m.length>0&&L.CancellationToken.isCancellationToken(m[m.length-1])&&(E=m.pop()),E&&E.isCancellationRequested)return Promise.reject(C.canceled());const y=t.serializeRequestArguments(m,this._uriReplacer),o=++this._lastMessageId,k=String(o),F=new D.LazyPromise;E&&E.onCancellationRequested(()=>{const Q=t.serializeCancel(o);this._logger&&this._logger.logOutgoing(Q.byteLength,o,0,"cancel"),this._protocol.send(t.serializeCancel(o))}),this._pendingRPCReplies[k]=F,this._onWillSendRequest(o);const $=t.serializeRequest(o,l,f,y,!!E);return this._logger&&this._logger.logOutgoing($.byteLength,o,0,`request: ${(0,A.getStringIdentifierForProxy)(l)}.${f}(`,m),this._protocol.send($),F}}e.RPCProtocol=h,P=b,h.UNRESPONSIVE_TIME=3*1e3;class v{constructor(l,f){this._buff=l,this._offset=f}static alloc(l,f,m){let E=new v(i.VSBuffer.alloc(m+1+4),0);return E.writeUInt8(l),E.writeUInt32(f),E}static read(l,f){return new v(l,f)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(l){this._buff.writeUInt8(l,this._offset),this._offset+=1}readUInt8(){const l=this._buff.readUInt8(this._offset);return this._offset+=1,l}writeUInt32(l){this._buff.writeUInt32BE(l,this._offset),this._offset+=4}readUInt32(){const l=this._buff.readUInt32BE(this._offset);return this._offset+=4,l}static sizeShortString(l){return 1+l.byteLength}writeShortString(l){this._buff.writeUInt8(l.byteLength,this._offset),this._offset+=1,this._buff.set(l,this._offset),this._offset+=l.byteLength}readShortString(){const l=this._buff.readUInt8(this._offset);this._offset+=1;const m=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,m}static sizeLongString(l){return 4+l.byteLength}writeLongString(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readLongString(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const m=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,m}writeBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}static sizeVSBuffer(l){return 4+l.byteLength}writeVSBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readVSBuffer(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const f=this._buff.slice(this._offset,this._offset+l);return this._offset+=l,f}static sizeMixedArray(l,f){let m=0;m+=1;for(let E=0,y=l.length;E<y;E++){const o=l[E],k=f[E];switch(m+=1,k){case 1:m+=this.sizeLongString(o);break;case 2:m+=this.sizeVSBuffer(o);break;case 3:break}}return m}writeMixedArray(l,f){this._buff.writeUInt8(l.length,this._offset),this._offset+=1;for(let m=0,E=l.length;m<E;m++){const y=l[m];switch(f[m]){case 1:this.writeUInt8(1),this.writeLongString(y);break;case 2:this.writeUInt8(2),this.writeVSBuffer(y);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const l=this._buff.readUInt8(this._offset);this._offset+=1;let f=new Array(l);for(let m=0;m<l;m++)switch(this.readUInt8()){case 1:f[m]=this.readLongString();break;case 2:f[m]=this.readVSBuffer();break;case 3:f[m]=void 0;break}return f}}class t{static _arrayContainsBufferOrUndefined(l){for(let f=0,m=l.length;f<m;f++)if(l[f]instanceof i.VSBuffer||typeof l[f]=="undefined")return!0;return!1}static serializeRequestArguments(l,f){if(this._arrayContainsBufferOrUndefined(l)){let m=[],E=[];for(let y=0,o=l.length;y<o;y++){const k=l[y];k instanceof i.VSBuffer?(m[y]=k,E[y]=2):typeof k=="undefined"?(m[y]=i.VSBuffer.alloc(0),E[y]=3):(m[y]=i.VSBuffer.fromString(u(k,f)),E[y]=1)}return{type:"mixed",args:m,argsType:E}}return{type:"simple",args:u(l,f)}}static serializeRequest(l,f,m,E,y){return E.type==="mixed"?this._requestMixedArgs(l,f,m,E.args,E.argsType,y):this._requestJSONArgs(l,f,m,E.args,y)}static _requestJSONArgs(l,f,m,E,y){const o=i.VSBuffer.fromString(m),k=i.VSBuffer.fromString(E);let F=0;F+=v.sizeUInt8(),F+=v.sizeShortString(o),F+=v.sizeLongString(k);let $=v.alloc(y?2:1,l,F);return $.writeUInt8(f),$.writeShortString(o),$.writeLongString(k),$.buffer}static deserializeRequestJSONArgs(l){const f=l.readUInt8(),m=l.readShortString(),E=l.readLongString();return{rpcId:f,method:m,args:JSON.parse(E)}}static _requestMixedArgs(l,f,m,E,y,o){const k=i.VSBuffer.fromString(m);let F=0;F+=v.sizeUInt8(),F+=v.sizeShortString(k),F+=v.sizeMixedArray(E,y);let $=v.alloc(o?4:3,l,F);return $.writeUInt8(f),$.writeShortString(k),$.writeMixedArray(E,y),$.buffer}static deserializeRequestMixedArgs(l){const f=l.readUInt8(),m=l.readShortString(),E=l.readMixedArray(),y=new Array(E.length);for(let o=0,k=E.length;o<k;o++){const F=E[o];typeof F=="string"?y[o]=JSON.parse(F):y[o]=F}return{rpcId:f,method:m,args:y}}static serializeAcknowledged(l){return v.alloc(5,l,0).buffer}static serializeCancel(l){return v.alloc(6,l,0).buffer}static serializeReplyOK(l,f,m){return typeof f=="undefined"?this._serializeReplyOKEmpty(l):f instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(l,f):this._serializeReplyOKJSON(l,c(f,m))}static _serializeReplyOKEmpty(l){return v.alloc(7,l,0).buffer}static _serializeReplyOKVSBuffer(l,f){let m=0;m+=v.sizeVSBuffer(f);let E=v.alloc(8,l,m);return E.writeVSBuffer(f),E.buffer}static deserializeReplyOKVSBuffer(l){return l.readVSBuffer()}static _serializeReplyOKJSON(l,f){const m=i.VSBuffer.fromString(f);let E=0;E+=v.sizeLongString(m);let y=v.alloc(9,l,E);return y.writeLongString(m),y.buffer}static deserializeReplyOKJSON(l){const f=l.readLongString();return JSON.parse(f)}static serializeReplyErr(l,f){return f?this._serializeReplyErrEror(l,f):this._serializeReplyErrEmpty(l)}static _serializeReplyErrEror(l,f){const m=i.VSBuffer.fromString(c(C.transformErrorForSerialization(f),null));let E=0;E+=v.sizeLongString(m);let y=v.alloc(10,l,E);return y.writeLongString(m),y.buffer}static deserializeReplyErrError(l){const f=l.readLongString();return JSON.parse(f)}static _serializeReplyErrEmpty(l){return v.alloc(11,l,0).buffer}}var s;(function(n){n[n.RequestJSONArgs=1]="RequestJSONArgs",n[n.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",n[n.RequestMixedArgs=3]="RequestMixedArgs",n[n.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",n[n.Acknowledged=5]="Acknowledged",n[n.Cancel=6]="Cancel",n[n.ReplyOKEmpty=7]="ReplyOKEmpty",n[n.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",n[n.ReplyOKJSON=9]="ReplyOKJSON",n[n.ReplyErrError=10]="ReplyErrError",n[n.ReplyErrEmpty=11]="ReplyErrEmpty"})(s||(s={}));var r;(function(n){n[n.String=1]="String",n[n.VSBuffer=2]="VSBuffer",n[n.Undefined=3]="Undefined"})(r||(r={}))}),define(me[258],ge([0,1,4]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,p.createDecorator)("remoteAgentService")}),define(me[259],ge([0,1,10,9,11,2,4,83,47,217,258]),function(J,e,p,L,C,S,T,I,D,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,T.createDecorator)("pathService");let P=class Bn{constructor(u,a,g,w){this.localUserHome=u,this.remoteAgentService=a,this.environmentService=g,this.contextService=w,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||C.OS)(),this.resolveUserHome=(async()=>{const _=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=_?.userHome||u})()}get defaultUriScheme(){return Bn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(u,a){if(u.remoteAuthority)return p.Schemas.vscodeRemote;const g=(0,I.getVirtualWorkspaceScheme)(a.getWorkspace());if(g)return g;const w=a.getWorkspace().folders[0];if(w)return w.uri.scheme;const _=a.getWorkspace().configuration;return _?_.scheme:p.Schemas.file}async userHome(u){return u?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(u=>u===1?L.win32:L.posix)}async fileURI(u){let a="";if(await this.resolveOS===1&&(u=u.replace(/\\/g,"/")),u[0]==="/"&&u[1]==="/"){const w=u.indexOf("/",2);w===-1?(a=u.substring(2),u="/"):(a=u.substring(2,w),u=u.substring(w)||"/")}return S.URI.from({scheme:p.Schemas.file,authority:a,path:u,query:"",fragment:""})}};P=Ve([He(1,i.IRemoteAgentService),He(2,A.IWorkbenchEnvironmentService),He(3,D.IWorkspaceContextService)],P),e.AbstractPathService=P}),define(me[65],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class p{constructor(T,I){this.line=T,this.character=I}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,I){return new p(0,0)}with(T){return new p(0,0)}}e.Position=p;class L{constructor(T,I,D,A){this.isEmpty=!1,this.isSingleLine=!1,this.start=new p(T,I),this.end=new p(D,A)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new L(0,0,0,0)}with(T){return new L(0,0,0,0)}}e.Range=L;var C;(function(S){S[S.Information=1]="Information",S[S.Warning=2]="Warning"})(C=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(me[31],ge([0,1,18,30,25,29,8,4,9,15,65]),function(J,e,p,L,C,S,T,I,D,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const P="\u27EA ",c=" characters skipped \u27EB",u=(P.length+c.length+5)*2;e.ISearchService=(0,I.createDecorator)("searchService");var a;(function(R){R[R.file=0]="file",R[R.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var g;(function(R){R[R.File=1]="File",R[R.Text=2]="Text"})(g=e.QueryType||(e.QueryType={}));function w(R){return!!R.preview}e.resultIsMatch=w;function _(R){return!!R.resource}e.isFileMatch=_;function b(R){return!!R.message}e.isProgressMessage=b;var d;(function(R){R[R.Normal=0]="Normal",R[R.NewSearchStarted=1]="NewSearchStarted"})(d=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class h{constructor(z){this.resource=z,this.results=[]}}e.FileMatch=h;class v{constructor(z,N,M){this.ranges=N;const q=Array.isArray(N)?N:[N];if(M&&M.matchLines===1&&t(q)){z=(0,T.getNLines)(z,M.matchLines);let x="",K=0,ee=0;const de=Math.floor(M.charsPerLine/5),Se=[];for(const De of q){const Le=Math.max(De.startColumn-de,0),qe=De.startColumn+M.charsPerLine;if(Le>ee+de+u){const We=P+(Le-ee)+c;x+=We+z.slice(Le,qe),K+=Le-(ee+We.length)}else x+=z.slice(ee,qe);Se.push(new r(0,De.startColumn-K,De.endColumn-K)),ee=qe}this.preview={text:x,matches:Array.isArray(this.ranges)?Se:Se[0]}}else{const x=Array.isArray(N)?N[0].startLineNumber:N.startLineNumber;this.preview={text:z,matches:(0,p.mapArrayOrNot)(N,K=>new s(K.startLineNumber-x,K.startColumn,K.endLineNumber-x,K.endColumn))}}}}e.TextSearchMatch=v;function t(R){const z=R[0].startLineNumber;for(const N of R)if(N.startLineNumber!==z||N.endLineNumber!==z)return!1;return!0}class s{constructor(z,N,M,q){this.startLineNumber=z,this.startColumn=N,this.endLineNumber=M,this.endColumn=q}}e.SearchRange=s;class r extends s{constructor(z,N,M){super(z,N,z,M)}}e.OneLineRange=r;var n;(function(R){R.Default="default",R.FileNames="fileNames",R.Type="type",R.Modified="modified",R.CountDescending="countDescending",R.CountAscending="countAscending"})(n=e.SearchSortOrder||(e.SearchSortOrder={}));function l(R,z=!0){const N=R&&R.files&&R.files.exclude,M=z&&R&&R.search&&R.search.exclude;if(!N&&!M)return;if(!N||!M)return N||M;let q=Object.create(null);return q=C.mixin(q,C.deepClone(N)),q=C.mixin(q,C.deepClone(M),!0),q}e.getExcludes=l;function f(R,z){return R.excludePattern&&L.match(R.excludePattern,z)?!1:R.includePattern||R.usingSearchPaths?R.includePattern&&L.match(R.includePattern,z)?!0:R.usingSearchPaths?!!R.folderQueries&&R.folderQueries.some(N=>{const M=N.folder.fsPath;if(S.isEqualOrParent(z,M)){const q=D.relative(M,z);return!N.includePattern||!!L.match(N.includePattern,q)}else return!1}):!1:!0}e.pathIncludedInQuery=f;var m;(function(R){R[R.unknownEncoding=1]="unknownEncoding",R[R.regexParseError=2]="regexParseError",R[R.globParseError=3]="globParseError",R[R.invalidLiteral=4]="invalidLiteral",R[R.rgProcessError=5]="rgProcessError",R[R.other=6]="other",R[R.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class E extends Error{constructor(z,N){super(z);this.code=N}}e.SearchError=E;function y(R){const z=R.message;if((0,A.isPromiseCanceledError)(R))return new E(z,m.canceled);try{const N=JSON.parse(z);return new E(N.message,N.code)}catch(N){return new E(z,m.other)}}e.deserializeSearchError=y;function o(R){const z={message:R.message,code:R.code};return new Error(JSON.stringify(z))}e.serializeSearchError=o;function k(R){return R.type==="error"?!0:R.type==="success"}e.isSerializedSearchComplete=k;function F(R){return R.type==="success"}e.isSerializedSearchSuccess=F;function $(R){return!!R.path}e.isSerializedFileMatch=$;function Q(R,z){const N=R.searchPath?R.searchPath:R.relativePath;return(0,T.fuzzyContains)(N,z)}e.isFilePatternMatch=Q;class oe{constructor(z){this.path=z,this.results=[]}addMatch(z){this.results.push(z)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=oe;function j(R,z){const N={...R||{},...z||{}};return Object.keys(N).filter(M=>{const q=N[M];return typeof q=="boolean"&&q})}e.resolvePatternsForProvider=j;class O{constructor(z,N){this._parsedIncludeExpression=null,this._excludeExpression={...z.excludePattern||{},...N.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let M=z.includePattern;N.includePattern&&(M?M={...M,...N.includePattern}:M=N.includePattern),M&&(this._parsedIncludeExpression=L.parse(M))}includedInQuerySync(z,N,M){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(z,N,M)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(z,N,M))}includedInQuery(z,N,M){return Promise.resolve(this._parsedExcludeExpression(z,N,M)).then(x=>!!x).then(x=>x?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(z,N,M)).then(K=>!!K):Promise.resolve(!0)).then(x=>x)}hasSiblingExcludeClauses(){return B(this._excludeExpression)}}e.QueryGlobTester=O;function B(R){for(const z in R)if(typeof R[z]!="boolean")return!0;return!1}}),define(me[35],ge([0,1,18,17,21,3,23,10,73,24,8,14,2,165,4,12,184,47,59,27,13,7,31,5]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a,g,w,_,b,d,h,v,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(k,F,$){return new A.ExtUri(Q=>m(Q,$)).isEqual(k,F)}function n(k,F,$){return r(k.uri,F.uri,$)?0:(0,i.compare)(k.uri.toString(),F.uri.toString())}function l(k,F,$){return k.index!==F.index?k.index<F.index?-1:1:r(k.uri,F.uri,$)?(0,i.compare)(k.name,F.name):(0,i.compare)(k.uri.toString(),F.uri.toString())}function f(k,F,$,Q){const oe=k.slice(0).sort((O,B)=>$(O,B,Q)),j=F.slice(0).sort((O,B)=>$(O,B,Q));return(0,p.delta)(oe,j,(O,B)=>$(O,B,Q))}function m(k,F){const $=F.getCapabilities(k.scheme);return!($&&$&1024)}class E extends _.Workspace{constructor(F,$,Q,oe,j,O){super(F,Q.map(B=>new _.WorkspaceFolder(B)),oe,O);this._name=$,this._isUntitled=j,this._workspaceFolders=[],this._structure=T.TernarySearchTree.forUris(O),Q.forEach(B=>{this._workspaceFolders.push(B),this._structure.set(B.uri,B)})}static toExtHostWorkspace(F,$,Q,oe){if(!F)return{workspace:null,added:[],removed:[]};const{id:j,name:O,folders:B,configuration:R,isUntitled:z}=F,N=[],M=$;$?B.forEach((ee,de)=>{const Se=c.URI.revive(ee.uri),De=E._findFolder(Q||$,Se,oe);De?(De.name=ee.name,De.index=ee.index,N.push(De)):N.push({uri:Se,name:ee.name,index:de})}):N.push(...B.map(({uri:ee,name:de,index:Se})=>({uri:c.URI.revive(ee),name:de,index:Se}))),N.sort((ee,de)=>ee.index<de.index?-1:1);const q=new E(j,O,N,R?c.URI.revive(R):null,!!z,ee=>m(ee,oe)),{added:x,removed:K}=f(M?M.workspaceFolders:[],q.workspaceFolders,n,oe);return{workspace:q,added:x,removed:K}}static _findFolder(F,$,Q){for(let oe=0;oe<F.folders.length;oe++){const j=F.workspaceFolders[oe];if(r(j.uri,$,Q))return j}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,$){return $&&this._structure.get(F)&&(F=(0,A.dirname)(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let y=class{constructor(F,$,Q,oe){this._onDidChangeWorkspace=new S.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new S.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=oe,this._extHostFileSystemInfo=Q,this._requestIdProvider=new D.Counter,this._barrier=new L.Barrier,this._proxy=F.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(s.MainContext.MainThreadMessageService);const j=$.workspace;this._confirmedWorkspace=j?new E(j.id,j.name,[],j.configuration?c.URI.revive(j.configuration):null,!!j.isUntitled,O=>m(O,Q)):void 0}$initializeWorkspace(F,$){this._trusted=$,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?c.URI.from({scheme:I.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,$,Q,...oe){const j=[];if(Array.isArray(oe)&&oe.forEach(N=>{c.URI.isUri(N.uri)&&!j.some(M=>r(M.uri,N.uri,this._extHostFileSystemInfo))&&j.push({uri:N.uri,name:N.name||(0,A.basenameOrAuthority)(N.uri)})}),this._unconfirmedWorkspace||[$,Q].some(N=>typeof N!="number"||N<0)||Q===0&&j.length===0)return!1;const O=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if($+Q>O.length)return!1;const B=O.slice(0);B.splice($,Q,...j.map(N=>({uri:N.uri,name:N.name||(0,A.basenameOrAuthority)(N.uri),index:void 0})));for(let N=0;N<B.length;N++){const M=B[N];if(B.some((q,x)=>x!==N&&r(M.uri,q.uri,this._extHostFileSystemInfo)))return!1}B.forEach((N,M)=>N.index=M);const{added:R,removed:z}=f(O,B,l,this._extHostFileSystemInfo);if(R.length===0&&z.length===0)return!1;if(this._proxy){const N=F.displayName||F.name;this._proxy.$updateWorkspaceFolders(N,$,Q,j).then(void 0,M=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(w.Severity.Error,(0,u.localize)(0,null,N,M.toString()),{extension:F},[])})}return this.trySetWorkspaceFolders(B),!0}getWorkspaceFolder(F,$){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,$)}async getWorkspaceFolder2(F,$){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,$)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!this._actualWorkspace)return;const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,$){let Q,oe="";if(typeof F=="string"?(Q=c.URI.file(F),oe=F):typeof F!="undefined"&&(Q=F,oe=F.fsPath),!Q)return oe;const j=this.getWorkspaceFolder(Q,!0);if(!j)return oe;typeof $=="undefined"&&this._actualWorkspace&&($=this._actualWorkspace.folders.length>1);let O=(0,A.relativePath)(j.uri,Q);return $&&j.name&&(O=`${j.name}/${O}`),O}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=E.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:$,added:Q,removed:oe}=E.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=$||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:Q,removed:oe}))}findFiles(F,$,Q,oe,j=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${oe.value}, entryPoint: findFiles`);let O;if($===null?O=!1:$&&(typeof $=="string"?O=$:O=$.pattern),j&&j.isCancellationRequested)return Promise.resolve([]);const{includePattern:B,folder:R}=o(F);return this._proxy.$startFileSearch((0,P.withUndefinedAsNull)(B),(0,P.withUndefinedAsNull)(R),(0,P.withUndefinedAsNull)(O),(0,P.withUndefinedAsNull)(Q),j).then(z=>Array.isArray(z)?z.map(N=>c.URI.revive(N)):[])}async findTextInFiles(F,$,Q,oe,j=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${oe.value}, entryPoint: findTextInFiles`);const O=this._requestIdProvider.getNext(),B=typeof $.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:R,folder:z}=o($.include),N=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,M={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:B,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:R,excludePattern:N},q=!1;if(this._activeSearchCallbacks[O]=x=>{if(q)return;const K=c.URI.revive(x.resource);x.results.forEach(ee=>{(0,t.resultIsMatch)(ee)?Q({uri:K,preview:{text:ee.preview.text,matches:(0,p.mapArrayOrNot)(ee.preview.matches,de=>new v.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))},ranges:(0,p.mapArrayOrNot)(ee.ranges,de=>new v.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))}):Q({uri:K,text:ee.text,lineNumber:ee.lineNumber})})},j.isCancellationRequested)return{};try{const x=await this._proxy.$startTextSearch(F,(0,P.withUndefinedAsNull)(z),M,O,j);return delete this._activeSearchCallbacks[O],x||{}}catch(x){throw delete this._activeSearchCallbacks[O],x}}$handleTextSearchResult(F,$){this._activeSearchCallbacks[$]&&this._activeSearchCallbacks[$](F)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}get trusted(){return this._trusted}requestWorkspaceTrust(F){return this._proxy.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};y=Ve([He(0,h.IExtHostRpcService),He(1,d.IExtHostInitDataService),He(2,b.IExtHostFileSystemInfo),He(3,g.ILogService)],y),e.ExtHostWorkspace=y,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function o(k){let F,$;return k&&(typeof k=="string"?F=k:(F=k.pattern,$=k.baseFolder||c.URI.file(k.base))),{includePattern:F,folder:$}}}),define(me[36],ge([0,1,25,3,35,5,7,188,82,14,17,4,13,12,2]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function g(s,r){if(r){const n=r.split(".");let l=s;for(let f=0;l&&f<n.length;f++)l=l[n[f]];return l}}function w(s){return s instanceof a.URI}function _(s){return s&&s.uri instanceof a.URI&&s.languageId&&typeof s.languageId=="string"}function b(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function d(s){return s&&s.uri instanceof a.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function h(s){if(w(s))return{resource:s};if(_(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(b(s))return{overrideIdentifier:s.languageId};if(d(s))return{resource:s.uri};if(s===null)return{resource:null}}let v=class{constructor(r,n,l){this._proxy=r.getProxy(S.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=l,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new t(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,n){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(r,n))}};v=Ve([He(0,c.IExtHostRpcService),He(1,C.IExtHostWorkspace),He(2,u.ILogService)],v),e.ExtHostConfiguration=v;class t{constructor(r,n,l,f){this._onDidChangeConfiguration=new L.Emitter,this._proxy=r,this._logService=f,this._extHostWorkspace=n,this._configuration=I.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,n){const l={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=I.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,l))}getConfiguration(r,n,l){const f=h(n)||{},m=this._toReadonlyValue(r?g(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,f,l?.identifier);function E(o){if(o==null)return null;if(typeof o=="boolean")return o?1:4;switch(o){case T.ConfigurationTarget.Global:return 1;case T.ConfigurationTarget.Workspace:return 4;case T.ConfigurationTarget.WorkspaceFolder:return 5}}const y={has(o){return typeof g(m,o)!="undefined"},get:(o,k)=>{this._validateConfigurationAccess(r?`${r}.${o}`:o,f,l?.identifier);let F=g(m,o);if(typeof F=="undefined")F=k;else{let $;const Q=(oe,j)=>{let O;const B=()=>{$=$||(0,p.deepClone)(m),O=O||g($,j)};return(0,A.isObject)(oe)?new Proxy(oe,{get:(R,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return B(),()=>O;if($)return O=O||g($,j),O[z];const N=R[z];return typeof z=="string"?Q(N,`${j}.${z}`):N},set:(R,z,N)=>(B(),O&&(O[z]=N),!0),deleteProperty:(R,z)=>(B(),O&&delete O[z],!0),defineProperty:(R,z,N)=>(B(),O&&Object.defineProperty(O,z,N),!0)}):oe};F=Q(F,o)}return F},update:(o,k,F,$)=>{o=r?`${r}.${o}`:o;const Q=E(F);return k!==void 0?this._proxy.$updateConfigurationOption(Q,o,k,f,$):this._proxy.$removeConfigurationOption(Q,o,f,$)},inspect:o=>{o=r?`${r}.${o}`:o;const k=(0,p.deepClone)(this._configuration.inspect(o,f,this._extHostWorkspace.workspace));if(k)return{key:o,defaultValue:k.default?.value,globalValue:k.user?.value,workspaceValue:k.workspace?.value,workspaceFolderValue:k.workspaceFolder?.value,defaultLanguageValue:k.default?.override,globalLanguageValue:k.user?.override,workspaceLanguageValue:k.workspace?.override,workspaceFolderLanguageValue:k.workspaceFolder?.override,languageIds:k.overrideIdentifiers}}};return typeof m=="object"&&(0,p.mixin)(y,m,!1),Object.freeze(y)}_toReadonlyValue(r){const n=l=>(0,A.isObject)(l)?new Proxy(l,{get:(f,m)=>n(f[m]),set:(f,m,E)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(m)}' of object`)},deleteProperty:(f,m)=>{throw new Error(`TypeError: Cannot delete read only property '${String(m)}' of object`)},defineProperty:(f,m)=>{throw new Error(`TypeError: Cannot define property '${String(m)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return n(r)}_validateConfigurationAccess(r,n,l){const f=D.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),m=l?`[${l.value}] `:"";if(f===4){typeof n?.resource=="undefined"&&this._logService.warn(`${m}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){n?.resource&&this._logService.warn(`${m}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,n){const l=new I.ConfigurationChangeEvent(r,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,m)=>l.affectsConfiguration(f,h(m))})}_toMap(r){return r.reduce((n,l)=>(n.set(l[0],l[1]),n),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(J,e,p,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(J,p):C?C.value=p:e.set(J,p),p},Ue=this&&this.__classPrivateFieldGet||function(J,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(J):L?L.value:e.get(J)};define(me[66],ge([0,1,2,17,3,5,7,35,43,36,21,33,13,27,4,10,11,12,61,207,15]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a,g,w,_,b,d,h){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(oe){function j(B){if(B!=null)return B}oe.from=j;function O(B){if(B!=null)return B}oe.to=O})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var s;(function(oe){function j(B){if(B!=null)return B}oe.from=j;function O(B){if(B!=null)return B}oe.to=O})(s=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(oe){function j(B){if(B!=null)return B}oe.from=j;function O(B){if(B!=null)return B}oe.to=O})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(oe){function j(R){if(R){const z=R;return z&&!!z.process}else return!1}oe.is=j;function O(R){if(R==null)return;const z={process:R.process,args:R.args};return R.options&&(z.options=r.from(R.options)),z}oe.from=O;function B(R){if(R!=null)return new T.ProcessExecution(R.process,R.args,R.options)}oe.to=B})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var l;(function(oe){function j(B){if(B!=null)return B}oe.from=j;function O(B){if(B!=null)return B}oe.to=O})(l=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var f;(function(oe){function j(R){if(R){const z=R;return z&&(!!z.commandLine||!!z.command)}else return!1}oe.is=j;function O(R){if(R==null)return;const z={};return R.commandLine!==void 0?z.commandLine=R.commandLine:(z.command=R.command,z.args=R.args),R.options&&(z.options=l.from(R.options)),z}oe.from=O;function B(R){if(!(R==null||R.command===void 0&&R.commandLine===void 0))return R.commandLine?new T.ShellExecution(R.commandLine,R.options):new T.ShellExecution(R.command,R.args?R.args:[],R.options)}oe.to=B})(f=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var m;(function(oe){function j(R){if(R){let z=R;return z&&z.customExecution==="customExecution"}else return!1}oe.is=j;function O(R){return{customExecution:"customExecution"}}oe.from=O;function B(R,z){return z.get(R)}oe.to=B})(m=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var E;(function(oe){function j(O,B){let R;return O.scope!==void 0&&typeof O.scope!="number"?R=O.scope.uri:O.scope!==void 0&&typeof O.scope=="number"&&(O.scope===T.TaskScope.Workspace&&B&&B.workspaceFile?R=B.workspaceFile:R=d.USER_TASKS_GROUP_KEY),{id:O._id,workspaceFolder:R}}oe.from=j})(E=e.TaskHandleDTO||(e.TaskHandleDTO={}));var y;(function(oe){function j(R,z){if(R==null)return[];const N=[];for(let M of R){const q=O(M,z);q&&N.push(q)}return N}oe.fromMany=j;function O(R,z){if(R==null)return;let N;R.execution instanceof T.ProcessExecution?N=n.from(R.execution):R.execution instanceof T.ShellExecution?N=f.from(R.execution):R.execution&&R.execution instanceof T.CustomExecution&&(N=m.from(R.execution));const M=t.from(R.definition);let q;if(R.scope?typeof R.scope=="number"?q=R.scope:q=R.scope.uri:q=T.TaskScope.Workspace,!M||!q)return;const x=R.group?R.group.id:void 0;return{_id:R._id,definition:M,name:R.name,source:{extensionId:z.identifier.value,label:R.source,scope:q},execution:N,isBackground:R.isBackground,group:x,presentationOptions:s.from(R.presentationOptions),problemMatchers:R.problemMatchers,hasDefinedMatchers:R.hasDefinedMatchers,runOptions:R.runOptions?R.runOptions:{reevaluateOnRerun:!0},detail:R.detail}}oe.from=O;async function B(R,z,N){if(R==null)return;let M;n.is(R.execution)?M=n.to(R.execution):f.is(R.execution)?M=f.to(R.execution):m.is(R.execution)&&(M=m.to(R._id,N));const q=t.to(R.definition);let x;if(R.source&&(R.source.scope!==void 0?typeof R.source.scope=="number"?x=R.source.scope:x=await z.resolveWorkspaceFolder(p.URI.revive(R.source.scope)):x=T.TaskScope.Workspace),!q||!x)return;const K=new T.Task(q,x,R.name,R.source.label,M,R.problemMatchers);return R.isBackground!==void 0&&(K.isBackground=R.isBackground),R.group!==void 0&&(K.group=T.TaskGroup.from(R.group)),R.presentationOptions&&(K.presentationOptions=s.to(R.presentationOptions)),R._id&&(K._id=R._id),R.detail&&(K.detail=R.detail),K}oe.to=B})(y=e.TaskDTO||(e.TaskDTO={}));var o;(function(oe){function j(B){return B}oe.from=j;function O(B){if(!!B)return Object.assign(Object.create(null),B)}oe.to=O})(o=e.TaskFilterDTO||(e.TaskFilterDTO={}));class k{constructor(j,O,B){this._id=O,this._task=B,v.set(this,void 0),nt(this,v,j,"f")}get task(){return this._task}terminate(){Ue(this,v,"f").terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}v=new WeakMap;var F;(function(oe){function j(O){return{id:O._id,task:void 0}}oe.from=j})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let $=class{constructor(j,O,B,R,z,N,M,q){this._onDidExecuteTask=new C.Emitter,this._onDidTerminateTask=new C.Emitter,this._onDidTaskProcessStarted=new C.Emitter,this._onDidTaskProcessEnded=new C.Emitter,this._proxy=j.getProxy(S.MainContext.MainThreadTask),this._workspaceProvider=B,this._editorService=R,this._configurationService=z,this._terminalService=N,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=M,this._deprecationService=q,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(j,O,B){if(!B)return new T.Disposable(()=>{});const R=this.nextHandle();return this._handlers.set(R,{type:O,provider:B,extension:j}),this._proxy.$registerTaskProvider(R,O),new T.Disposable(()=>{this._handlers.delete(R),this._proxy.$unregisterTaskProvider(R)})}registerTaskSystem(j,O){this._proxy.$registerTaskSystem(j,O)}fetchTasks(j){return this._proxy.$fetchTasks(o.from(j)).then(async O=>{const B=[];for(let R of O){const z=await y.to(R,this._workspaceProvider,this._providedCustomExecutions2);z&&B.push(z)}return B})}get taskExecutions(){const j=[];return this._taskExecutions.forEach(O=>j.push(O)),j}terminateTask(j){if(!(j instanceof k))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(j._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(j,O,B){const R=this._providedCustomExecutions2.get(j.id);if(R){if(this._activeCustomExecutions2.get(j.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(j.id,R),this._terminalService.attachPtyToTerminal(O,await R.callback(B))}this._lastStartedTask=j.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(j)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(j){const O=await this.getTaskExecution(j);this._taskExecutionPromises.delete(j.id),this._taskExecutions.delete(j.id),this.customExecutionComplete(j),this._onDidTerminateTask.fire({execution:O})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(j){const O=await this.getTaskExecution(j.id);this._onDidTaskProcessStarted.fire({execution:O,processId:j.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(j){const O=await this.getTaskExecution(j.id);this._onDidTaskProcessEnded.fire({execution:O,exitCode:j.exitCode})}$provideTasks(j,O){const B=this._handlers.get(j);if(!B)return Promise.reject(new Error("no handler found"));const R=[],z=(0,L.asPromise)(()=>B.provider.provideTasks(i.CancellationToken.None)).then(N=>this.provideTasksInternal(O,R,B,N));return new Promise(N=>{z.then(M=>{Promise.all(R).then(()=>{N(M)})})})}async $resolveTask(j,O){const B=this._handlers.get(j);if(!B)return Promise.reject(new Error("no handler found"));if(O.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${O.definition.type}] cannot be resolved by provider of type [${B.type}].`);const R=await y.to(O,this._workspaceProvider,this._providedCustomExecutions2);if(!R)throw new Error("Unexpected: Task cannot be resolved.");const z=await B.provider.resolveTask(R,i.CancellationToken.None);if(!z)return;this.checkDeprecation(z,B);const N=y.from(z,B.extension);if(!N)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==R.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(N.execution)&&await this.addCustomExecution(N,z,!0),await this.resolveTaskInternal(N)}nextHandle(){return this._handleCounter++}async addCustomExecution(j,O,B){const R=await this._proxy.$createTaskId(j);!B&&!this._providedCustomExecutions2.has(R)&&this._notProvidedCustomExecutions.add(R),this._providedCustomExecutions2.set(R,O.execution)}async getTaskExecution(j,O){if(typeof j=="string"){const z=this._taskExecutionPromises.get(j);if(!z)throw new Error("Unexpected: The specified task is missing an execution");return z}let B=this._taskExecutionPromises.get(j.id);if(B)return B;const R=new Promise(async(z,N)=>{const M=O||await y.to(j.task,this._workspaceProvider,this._providedCustomExecutions2);M?z(new k(this,j.id,M)):N("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(j.id,R),R.then(z=>(this._taskExecutions.set(j.id,z),z),z=>Promise.reject(z))}checkDeprecation(j,O){j._deprecated&&this._deprecationService.report("Task.constructor",O.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(j){this._activeCustomExecutions2.get(j.id)&&this._activeCustomExecutions2.delete(j.id),this._notProvidedCustomExecutions.has(j.id)&&this._lastStartedTask!==j.id&&(this._providedCustomExecutions2.delete(j.id),this._notProvidedCustomExecutions.delete(j.id));let B=this._notProvidedCustomExecutions.values(),R=B.next();for(;!R.done;)!this._activeCustomExecutions2.has(R.value)&&this._lastStartedTask!==R.value&&(this._providedCustomExecutions2.delete(R.value),this._notProvidedCustomExecutions.delete(R.value)),R=B.next()}};$=Ve([He(0,c.IExtHostRpcService),He(1,u.IExtHostInitDataService),He(2,I.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,A.IExtHostConfiguration),He(5,P.IExtHostTerminalService),He(6,_.ILogService),He(7,b.IExtHostApiDeprecationService)],$),e.ExtHostTaskBase=$;let Q=class extends ${constructor(j,O,B,R,z,N,M,q){super(j,O,B,R,z,N,M,q);this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:"",platform:w.PlatformToString(0)})}async executeTask(j,O){if(!O.execution)throw new Error("Tasks to execute must include an execution");const B=y.from(O,j);if(B===void 0)throw new Error("Task is not valid");if(m.is(B.execution))await this.addCustomExecution(B,O,!1);else throw new h.NotSupportedError;const R=await this.getTaskExecution(await this._proxy.$getTaskExecution(B),O);return this._proxy.$executeTask(B).catch(z=>{throw new Error(z)}),R}provideTasksInternal(j,O,B,R){const z=[];if(R)for(let N of R){this.checkDeprecation(N,B),(!N.definition||!j[N.definition.type])&&this._logService.warn(`The task [${N.source}, ${N.name}] uses an undefined task type. The task will be ignored in the future.`);const M=y.from(N,B.extension);M&&m.is(M.execution)?(z.push(M),O.push(this.addCustomExecution(M,N,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:z,extension:B.extension}}async resolveTaskInternal(j){if(m.is(j.execution))return j;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(j,O){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,O,B){}};Q=Ve([He(0,c.IExtHostRpcService),He(1,u.IExtHostInitDataService),He(2,I.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,A.IExtHostConfiguration),He(5,P.IExtHostTerminalService),He(6,_.ILogService),He(7,b.IExtHostApiDeprecationService)],Q),e.WorkerExtHostTask=Q,e.IExtHostTask=(0,a.createDecorator)("IExtHostTask")}),define(me[260],ge([0,1,18,69,30,76,23,10,9,24,8,14,2,142,170,117,47,124,259,31]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a,g,w,_,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let h=class{constructor(E,y,o,k){this.configurationService=E,this.workspaceContextService=y,this.editorGroupsService=o,this.pathService=k}text(E,y,o={}){E=this.getContentPattern(E,o);const k=this.configurationService.getValue(),F=y&&y.some(Q=>!this.configurationService.getValue({resource:Q}).search.useRipgrep);return{...this.commonQuery(y?.map(w.toWorkspaceFolder),o),type:2,contentPattern:E,previewOptions:o.previewOptions,maxFileSize:o.maxFileSize,usePCRE2:k.search.usePCRE2||F||!1,beforeContext:o.beforeContext,afterContext:o.afterContext,userDisabledExcludesAndIgnoreFiles:o.disregardExcludeSettings&&o.disregardIgnoreFiles}}getContentPattern(E,y){const o=this.configurationService.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const k={...E,wordSeparators:o.editor.wordSeparators};return this.isCaseSensitive(E,y)&&(k.isCaseSensitive=!0),this.isMultiline(E)&&(k.isMultiline=!0),k}file(E,y={}){return{...this.commonQuery(E,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey}}handleIncludeExclude(E,y){return E?(E=Array.isArray(E)?E.map(n):n(E),y?this.parseSearchPaths(E):{pattern:t(...Array.isArray(E)?E:[E])}):{}}commonQuery(E=[],y={}){const o=this.handleIncludeExclude(y.includePattern,y.expandPatterns),k=this.handleIncludeExclude(y.excludePattern,y.expandPatterns),F=E.length>1,$=(o.searchPaths&&o.searchPaths.length?o.searchPaths.map(j=>this.getFolderQueryForSearchPath(j,y,k)):E.map(j=>this.getFolderQueryForRoot(j,y,k,F))).filter(j=>!!j),Q={_reason:y._reason,folderQueries:$,usingSearchPaths:!!(o.searchPaths&&o.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:k.pattern,includePattern:o.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const O=p.coalesce(p.flatten(this.editorGroupsService.groups.map(R=>R.editors.map(z=>z.resource)))).filter(R=>(0,d.pathIncludedInQuery)(Q,R.fsPath)),B=this.commonQueryFromFileList(O);return{...Q,...B}}const oe=y.extraFileResources&&y.extraFileResources.filter(j=>(0,d.pathIncludedInQuery)(Q,j.fsPath));return Q.extraFileResources=oe&&oe.length?oe:void 0,Q}commonQueryFromFileList(E){const y=[],o=new T.ResourceMap,k={};let F=!1;return E.forEach($=>{if($.scheme===I.Schemas.walkThrough)return;if((0,A.isAbsolutePath)($)){const oe=this.workspaceContextService.getWorkspaceFolder($)?.uri??$.with({path:D.dirname($.fsPath)});let j=o.get(oe);j||(F=!0,j={folder:oe,includePattern:{}},y.push(j),o.set(oe,j));const O=D.relative(oe.fsPath,$.fsPath);(0,P.assertIsDefined)(j.includePattern)[O.replace(/\\/g,"/")]=!0}else $.fsPath&&(F=!0,k[$.fsPath]=!0)}),{folderQueries:y,includePattern:k,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}isCaseSensitive(E,y){if(y.isSmartCase){if(E.isRegExp){if(i.containsUppercaseCharacter(E.pattern,!0))return!0}else if(i.containsUppercaseCharacter(E.pattern))return!0}return!!E.isCaseSensitive}isMultiline(E){return E.isMultiline||E.isRegExp&&(0,u.isMultilineRegexSource)(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const y=B=>D.isAbsolute(B)||/^\.\.?([\/\\]|$)/.test(B),k=(Array.isArray(E)?E:s(E)).map(B=>{const R=this.pathService.resolvedUserHome;return R?(0,S.untildify)(B,R.scheme===I.Schemas.file?R.fsPath:R.path):B}),F=L.groupBy(k,B=>y(B)?"searchPaths":"exprSegments"),$=(F.exprSegments||[]).map(B=>i.rtrim(B,"/")).map(B=>i.rtrim(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),r(B))),Q={},oe=this.expandSearchPathPatterns(F.searchPaths||[]);oe&&oe.length&&(Q.searchPaths=oe);const j=p.flatten($),O=t(...j);return O&&(Q.pattern=O),Q}getExcludesForFolder(E,y){return y.disregardExcludeSettings?void 0:(0,d.getExcludes)(E,!y.disregardSearchExcludeSettings)}expandSearchPathPatterns(E){if(!E||!E.length)return[];const y=p.flatten(E.map(k=>{let{pathPortion:F,globPortion:$}=v(k);$&&($=l($));const Q=this.expandOneSearchPath(F);return p.flatten(Q.map(oe=>this.resolveOneSearchPathPattern(oe,$)))})),o=new Map;return y.forEach(k=>{const F=k.searchPath.toString(),$=o.get(F);$?k.pattern&&($.pattern=$.pattern||{},$.pattern[k.pattern]=!0):o.set(F,{searchPath:k.searchPath,pattern:k.pattern?t(k.pattern):void 0})}),Array.from(o.values())}expandOneSearchPath(E){if(D.isAbsolute(E)){const y=this.workspaceContextService.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==I.Schemas.file?[{searchPath:y[0].uri.with({path:E})}]:[{searchPath:c.URI.file(D.normalize(E))}]}if(this.workspaceContextService.getWorkbenchState()===2){const y=this.workspaceContextService.getWorkspace().folders[0].uri;if(E=n(E),E.startsWith("../")||E===".."){const k=D.posix.resolve(y.path,E);return[{searchPath:y.with({path:k})}]}const o=l(E);return[{searchPath:y,pattern:o}]}else{if(E==="./"||E===".\\")return[];{const y=E.replace(/^\.[\/\\]/,""),k=this.workspaceContextService.getWorkspace().folders.map(F=>{const $=y.match(new RegExp(`^${i.escapeRegExpCharacters(F.name)}(?:/(.*)|$)`));return $?{match:$,folder:F}:null}).filter(P.isDefined);if(k.length)return k.map(F=>{const $=F.match[1];return{searchPath:F.folder.uri,pattern:$&&l($)}});{const F=E.match(/\.[\/\\](.+)[\/\\]?/),$=F?F[1]:E,Q=a.localize(0,null,$);throw new Error(Q)}}}}resolveOneSearchPathPattern(E,y){const o=E.pattern&&y?`${E.pattern}/${y}`:E.pattern||y,k=[{searchPath:E.searchPath,pattern:o}];return o&&!o.endsWith("**")&&k.push({searchPath:E.searchPath,pattern:o+"/**"}),k}getFolderQueryForSearchPath(E,y,o){const k=this.getFolderQueryForRoot((0,w.toWorkspaceFolder)(E.searchPath),y,o,!1);return k?{...k,includePattern:E.pattern}:null}getFolderQueryForRoot(E,y,o,k){let F;const $=c.URI.isUri(E)?E:E.uri;if(o.searchPaths){const B=o.searchPaths.filter(R=>(0,A.isEqual)(R.searchPath,$))[0];if(B&&!B.pattern)return null;B&&(F=B.pattern)}const Q=this.configurationService.getValue({resource:$}),j={...this.getExcludesForFolder(Q,y)||{},...F||{}},O=c.URI.isUri(E)?(0,A.basename)(E):E.name;return{folder:$,folderName:k?O:void 0,excludePattern:Object.keys(j).length>0?j:void 0,fileEncoding:Q.files&&Q.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!Q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!Q.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!Q.search.followSymlinks}}};h=Ve([He(0,g.IConfigurationService),He(1,w.IWorkspaceContextService),He(2,_.IEditorGroupsService),He(3,b.IPathService)],h),e.QueryBuilder=h;function v(m){const E=m.match(/[\*\{\}\(\)\[\]\?]/);if(E){const y=E.index,o=m.substr(0,y).match(/[/|\\][^/\\]*$/);if(o){let k=m.substr(0,o.index);return k.match(/[/\\]/)||(k+="/"),{pathPortion:k,globPortion:m.substr((o.index||0)+1)}}}return{pathPortion:m}}function t(...m){return m.length?m.reduce((E,y)=>(E[y]=!0,E),Object.create(null)):void 0}function s(m){return C.splitGlobAware(m,",").map(E=>E.trim()).filter(E=>!!E.length)}function r(m){return[`**/${m}/**`,`**/${m}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function n(m){return m.replace(/\\/g,"/")}function l(m){return n(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(m,E){m=p.distinct(m,k=>k.toString());const y=[],o=E.getWorkspace();return m&&m.forEach(k=>{let F;if(E.getWorkbenchState()===2)F=(0,A.relativePath)(o.folders[0].uri,k),F&&F!=="."&&(F="./"+F);else{const $=E.getWorkspaceFolder(k);if($){const Q=$.name;if(o.folders.filter(j=>j.name===Q).length===1){const j=(0,A.relativePath)($.uri,k);j===""?F=`./${$.name}`:F=`./${$.name}/${j}`}else F=k.fsPath}}F&&y.push(F)}),y}e.resolveResourcesForSearchIncludes=f}),define(me[261],ge([0,1,24,2,21,15,4,260,31,47]),function(J,e,p,L,C,S,T,I,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function P(g,w){const _=w.activationEvents;if(!_)return Promise.resolve(void 0);const b=[],d=[];for(const n of _)if(/^workspaceContains:/.test(n)){const l=n.substr("workspaceContains:".length);l.indexOf("*")>=0||l.indexOf("?")>=0||g.forceUsingSearch?d.push(l):b.push(l)}if(b.length===0&&d.length===0)return Promise.resolve(void 0);let h;const v=new Promise((n,l)=>{h=n}),t=n=>h({activationEvent:n}),s=Promise.all(b.map(n=>c(g,n,t))).then(()=>{}),r=u(g,w.identifier,d,t);return Promise.all([s,r]).then(()=>{h(void 0)}),v}e.checkActivateWorkspaceContainsExtension=P;async function c(g,w,_){for(const b of g.folders)if(await g.exists(p.joinPath(L.URI.revive(b),w))){_(`workspaceContains:${w}`);return}}async function u(g,w,_,b){if(_.length===0)return Promise.resolve(void 0);const d=new C.CancellationTokenSource,h=g.checkExists(g.folders,_,d.token),v=setTimeout(async()=>{d.cancel(),b(`workspaceContainsTimeout:${_.join(",")}`)},i);let t=!1;try{t=await h}catch(s){S.isPromiseCanceledError(s)||S.onUnexpectedError(s)}d.dispose(),clearTimeout(v),t&&b(`workspaceContains:${_.join(",")}`)}function a(g,w,_,b){const d=g.get(T.IInstantiationService),h=g.get(D.ISearchService),t=d.createInstance(I.QueryBuilder).file(w.map(s=>(0,A.toWorkspaceFolder)(L.URI.revive(s))),{_reason:"checkExists",includePattern:_,exists:!0});return h.fileSearch(t,b).then(s=>!!s.limitHit,s=>S.isPromiseCanceledError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=a});var nt=this&&this.__classPrivateFieldSet||function(J,e,p,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(J,p):C?C.value=p:e.set(J,p),p},Ue=this&&this.__classPrivateFieldGet||function(J,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(J):L?L.value:e.get(J)};define(me[39],ge([0,1,160,9,67,24,17,6,23,2,12,5,36,220,90,35,34,218,15,26,22,196,7,118,4,27,63,13,81,49,33,3,261,88,198]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a,g,w,_,b,d,h,v,t,s,r,n,l,f,m,E,y,o,k,F,$){"use strict";var Q,oe,j;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let O=class $n extends I.Disposable{constructor(N,M,q,x,K,ee,de,Se,De,Le){super();this._onDidChangeRemoteConnectionData=this._register(new o.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=M,this._extHostContext=q,this._initData=de,this._extHostWorkspace=x,this._extHostConfiguration=K,this._logService=ee,this._extHostTunnelService=De,this._extHostTerminalService=Le,this._disposables=new I.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(P.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(P.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(P.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._registry=new _.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new F.ExtHostSecretState(this._extHostContext),this._storagePath=Se,this._instaService=N.createChild(new m.ServiceCollection([a.IExtHostStorage,this._storage],[F.IExtHostSecretState,this._secretState]));const qe=new Set;this._initData.hostExtensions.forEach(We=>qe.add(d.ExtensionIdentifier.toKey(We))),this._activator=new u.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(We,je,W)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(We,b.transformErrorForSerialization(je),W)},actualActivateExtension:async(We,je)=>{if(qe.has(d.ExtensionIdentifier.toKey(We)))return await this._mainThreadExtensionsProxy.$activateExtension(We,je),new u.HostExtension;const W=this._registry.getExtensionDescription(We);return this._activateExtension(W,je)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),C.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(N){b.onUnexpectedError(N)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let N=[];try{N=this._registry.getAllExtensionDescriptions().map(K=>K.identifier).filter(K=>this.isActivated(K)).map(K=>this._deactivate(K))}catch(M){}await Promise.all(N)}isActivated(N){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(N):!1}_activateByEvent(N,M){return this._activator.activateByEvent(N,M)}_activateById(N,M){return this._activator.activateById(N,M)}activateByIdWithErrors(N,M){return this._activateById(N,M).then(()=>{const q=this._activator.getActivatedExtension(N);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(N=>this._registry)}getExtensionExports(N){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(N).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const N=D.TernarySearchTree.forPaths(),M=this._registry.getAllExtensionDescriptions().map(q=>{if(!!this._getEntryPoint(q))return this._hostUtils.realpath(q.extensionLocation.fsPath).then(x=>N.set(A.URI.file(x).fsPath,q))});this._extensionPathIndex=Promise.all(M).then(()=>N)}return this._extensionPathIndex}_deactivate(N){let M=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(N))return M;const q=this._activator.getActivatedExtension(N);if(!q)return M;try{typeof q.module.deactivate=="function"&&(M=Promise.resolve(q.module.deactivate()).then(void 0,x=>(this._logService.error(x),Promise.resolve(void 0))))}catch(x){this._logService.error(x)}try{(0,I.dispose)(q.subscriptions)}catch(x){this._logService.error(x)}return M}async _activateExtension(N,M){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(N.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(N.identifier),this._doActivateExtension(N,M).then(q=>{const x=q.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(N.identifier,x.codeLoadingTime,x.activateCallTime,x.activateResolvedTime,M),this._logExtensionActivationTimes(N,M,"success",x),q},q=>{throw this._logExtensionActivationTimes(N,M,"failure"),q})}_logExtensionActivationTimes(N,M,q,x){const K=B(N,M);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...K,...x||{},outcome:q})}_doActivateExtension(N,M){const q=B(N,M);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",q);const x=this._getEntryPoint(N);if(!x)return Promise.resolve(new u.EmptyExtension(u.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${N.identifier.value} ${JSON.stringify(M)}`),this._logService.flush();const K=new u.ExtensionActivationTimesBuilder(M.startup);return Promise.all([this._loadCommonJSModule(N.identifier,(0,S.joinPath)(N.extensionLocation,x),K),this._loadExtensionContext(N)]).then(ee=>(C.mark(`code/extHost/willActivateExtension/${N.identifier.value}`),$n._callActivate(this._logService,N.identifier,ee[0],ee[1],K))).then(ee=>(C.mark(`code/extHost/didActivateExtension/${N.identifier.value}`),ee))}_loadExtensionContext(N){const M=new v.ExtensionGlobalMemento(N,this._storage),q=new v.ExtensionMemento(N.identifier.value,!1,this._storage),x=new $.ExtensionSecrets(N,this._secretState),K=N.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ee=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${N.identifier.value}`),Promise.all([M.whenReady,q.whenReady,this._storagePath.whenReady]).then(()=>{const de=this;let Se;return Object.freeze({globalState:M,workspaceState:q,secrets:x,subscriptions:[],get extensionUri(){return N.extensionLocation},get extensionPath(){return N.extensionLocation.fsPath},asAbsolutePath(De){return L.join(N.extensionLocation.fsPath,De)},get storagePath(){return de._storagePath.workspaceValue(N)?.fsPath},get globalStoragePath(){return de._storagePath.globalValue(N).fsPath},get logPath(){return L.join(de._initData.logsLocation.fsPath,N.identifier.value)},get logUri(){return A.URI.joinPath(de._initData.logsLocation,N.identifier.value)},get storageUri(){return de._storagePath.workspaceValue(N)},get globalStorageUri(){return de._storagePath.globalValue(N)},get extensionMode(){return K},get extension(){return Se===void 0&&(Se=new R(de,N.identifier,N,ee)),Se},get extensionRuntime(){return(0,w.checkProposedApiEnabled)(N),de.extensionRuntime},get environmentVariableCollection(){return de._extHostTerminalService.getEnvironmentVariableCollection(N)}})})}static _callActivate(N,M,q,x,K){return q=q||{activate:void 0,deactivate:void 0},this._callActivateOptional(N,M,q,x,K).then(ee=>new u.ActivatedExtension(!1,null,K.build(),q,ee,x.subscriptions))}static _callActivateOptional(N,M,q,x,K){if(typeof q.activate=="function")try{K.activateCallStart(),N.trace(`ExtensionService#_callActivateOptional ${M.value}`);const ee=typeof global=="object"?global:self,de=q.activate.apply(ee,[x]);return K.activateCallStop(),K.activateResolveStart(),Promise.resolve(de).then(Se=>(K.activateResolveStop(),Se))}catch(ee){return Promise.reject(ee)}else return Promise.resolve(q)}_activateOneStartupFinished(N,M){this._activateById(N.identifier,{startup:!1,extensionId:N.identifier,activationEvent:M}).then(void 0,q=>{this._logService.error(q)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(C.getMarks());for(const N of this._registry.getAllExtensionDescriptions())if(N.activationEvents)for(const M of N.activationEvents)M==="onStartupFinished"&&this._activateOneStartupFinished(N,M)}_handleEagerExtensions(){const N=this._activateByEvent("*",!0).then(void 0,K=>{this._logService.error(K)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(K=>this._handleWorkspaceContainsEagerExtensions(K.added)));const M=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],q=this._handleWorkspaceContainsEagerExtensions(M),x=Promise.all([N,q]).then(()=>{});return Promise.race([x,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),x}_handleWorkspaceContainsEagerExtensions(N){return N.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(M=>this._handleWorkspaceContainsEagerExtension(N,M))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(N,M){if(this.isActivated(M.identifier))return;const q=!this._initData.remote.isRemote&&!!this._initData.remote.authority,x={folders:N.map(ee=>ee.uri),forceUsingSearch:q,exists:ee=>this._hostUtils.exists(ee.fsPath),checkExists:(ee,de,Se)=>this._mainThreadWorkspaceProxy.$checkExists(ee,de,Se)},K=await(0,k.checkActivateWorkspaceContainsExtension)(x,M);if(!!K)return this._activateById(M.identifier,{startup:!0,extensionId:M.identifier,activationEvent:K.activationEvent}).then(void 0,ee=>this._logService.error(ee))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(N){throw console.error(N),N}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:N,extensionTestsLocationURI:M}=this._initData.environment;if(!N||!M)throw new Error(p.localize(0,null));const q=await this._loadCommonJSModule(null,M,new u.ExtensionActivationTimesBuilder(!1));if(!q||typeof q.run!="function")throw new Error(p.localize(1,null,M.toString()));return new Promise((x,K)=>{const ee=(De,Le)=>{De?K(De):x(typeof Le=="number"&&Le>0?1:0)},de=(0,S.originalFSPath)(M),Se=q.run(de,ee);Se&&Se.then&&Se.then(()=>{x(0)}).catch(De=>{K(De.toString())})})}async $extensionTestsExit(N){this._logService.info(`extension host terminating: test runner requested exit with code ${N}`),this._logService.info(`exiting with code ${N}`),this._logService.flush(),this._hostUtils.exit(N)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(N,M){return this._resolvers[N]=M,(0,I.toDisposable)(()=>{delete this._resolvers[N]})}async _activateAndGetResolver(N){const M=N.indexOf("+");if(M===-1)throw new Error("Not an authority that can be resolved!");const q=N.substr(0,M);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${q}`,!1),{authorityPrefix:q,resolver:this._resolvers[q]}}async $resolveAuthority(N,M){const{authorityPrefix:q,resolver:x}=await this._activateAndGetResolver(N);if(!x)return{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${q}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(x)),C.mark(`code/extHost/willResolveAuthority/${q}`);const K=await x.resolve(N,{resolveAttempt:M});C.mark(`code/extHost/didResolveAuthorityOK/${q}`);const ee={authority:N,host:K.host,port:K.port,connectionToken:K.connectionToken},de={extensionHostEnv:K.extensionHostEnv,isTrusted:K.isTrusted};return{type:"ok",value:{authority:ee,options:de,tunnelInformation:{environmentTunnels:K.environmentTunnels}}}}catch(K){if(C.mark(`code/extHost/didResolveAuthorityError/${q}`),K instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K}}async $getCanonicalURI(N,M){const{authorityPrefix:q,resolver:x}=await this._activateAndGetResolver(N);if(!x)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${q}`);const K=A.URI.revive(M);if(typeof x.getCanonicalURI=="undefined")return K;const ee=await(0,T.asPromise)(()=>x.getCanonicalURI(K));return ee||K}$startExtensionHost(N){return this._registry.keepOnly(N),this._startExtensionHost()}$activateByEvent(N,M){return M===1?this._activateByEvent(N,!1):this._readyToRunExtensions.wait().then(q=>this._activateByEvent(N,!1))}async $activate(N,M){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(N)?(await this._activateById(N,M),!0):!1}async $deltaExtensions(N,M){N.forEach(x=>x.extensionLocation=A.URI.revive(x.extensionLocation));const q=await this.getExtensionPathIndex();return await Promise.all(M.map(async x=>{const K=this._registry.getExtensionDescription(x);if(!K)return;const ee=await this._hostUtils.realpath(K.extensionLocation.fsPath);q.delete(A.URI.file(ee).fsPath)})),await Promise.all(N.map(async x=>{const K=await this._hostUtils.realpath(x.extensionLocation.fsPath);q.set(A.URI.file(K).fsPath,x)})),this._registry.deltaExtensions(N,M),Promise.resolve(void 0)}async $test_latency(N){return N}async $test_up(N){return N.byteLength}async $test_down(N){let M=h.VSBuffer.alloc(N),q=Math.random()%256;for(let x=0;x<N;x++)M.writeUInt8(q,x);return M}async $updateRemoteConnectionData(N){this._remoteConnectionData=N,this._onDidChangeRemoteConnectionData.fire()}};O=Ve([He(0,r.IInstantiationService),He(1,e.IHostUtils),He(2,f.IExtHostRpcService),He(3,g.IExtHostWorkspace),He(4,c.IExtHostConfiguration),He(5,i.ILogService),He(6,n.IExtHostInitDataService),He(7,l.IExtensionStoragePaths),He(8,E.IExtHostTunnelService),He(9,y.IExtHostTerminalService)],O),e.AbstractExtHostExtensionService=O;function B(z,N){return{id:z.identifier.value,name:z.name,extensionVersion:z.version,publisherDisplayName:z.publisher,activationEvents:z.activationEvents?z.activationEvents.join(","):null,isBuiltin:z.isBuiltin,reason:N.activationEvent,reasonId:N.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class R{constructor(N,M,q,x){Q.set(this,void 0),oe.set(this,void 0),j.set(this,void 0),nt(this,Q,N,"f"),nt(this,oe,M,"f"),nt(this,j,q.identifier,"f"),this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=L.normalize((0,S.originalFSPath)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=x}get isActive(){return Ue(this,Q,"f").isActivated(Ue(this,j,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ue(this,Q,"f").getExtensionExports(Ue(this,j,"f"))}activate(){return Ue(this,Q,"f").activateByIdWithErrors(Ue(this,j,"f"),{startup:!1,extensionId:Ue(this,oe,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=R,Q=new WeakMap,oe=new WeakMap,j=new WeakMap}),define(me[51],ge([0,1,9,2,3,17,5,7,121,35,39,43,209,36,204,13,4,14,37,48]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a,g,w,_,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,w.createDecorator)("IExtHostDebugService");let h=class{constructor(m,E,y,o,k,F){this._workspaceService=E,this._extensionService=y,this._editorsService=o,this._configurationService=k,this._editorTabs=F,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new C.Emitter,this._onDidTerminateDebugSession=new C.Emitter,this._onDidChangeActiveDebugSession=new C.Emitter,this._onDidReceiveDebugSessionCustomEvent=new C.Emitter,this._debugServiceProxy=m.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new C.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then($=>{$.onDidChange(Q=>{this.registerAllDebugTypes($)}),this.registerAllDebugTypes($)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(m,E){const y=m;if(typeof y.sourceReference=="number"&&y.sourceReference>0){let o=`debug:${encodeURIComponent(y.path||"")}`,k="?";return E&&(o+=`${k}session=${encodeURIComponent(E.id)}`,k="&"),o+=`${k}ref=${y.sourceReference}`,L.URI.parse(o)}else{if(y.path)return L.URI.file(y.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(m){const E=[];for(const y of m.getAllExtensionDescriptions())if(y.contributes){const o=y.contributes.debuggers;if(o&&o.length>0)for(const k of o)(0,a.isDebuggerMainContribution)(k)&&E.push(k.type)}this._debugServiceProxy.$registerDebugTypes(E)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const m=[];return this._breakpoints.forEach(E=>m.push(E)),m}addBreakpoints(m){this.startBreakpoints();const E=m.filter(k=>{const F=k.id;return this._breakpoints.has(F)?!1:(this._breakpoints.set(F,k),!0)});this.fireBreakpointChanges(E,[],[]);const y=[],o=new Map;for(const k of E)if(k instanceof I.SourceBreakpoint){let F=o.get(k.location.uri.toString());F||(F={type:"sourceMulti",uri:k.location.uri,lines:[]},o.set(k.location.uri.toString(),F),y.push(F)),F.lines.push({id:k.id,enabled:k.enabled,condition:k.condition,hitCondition:k.hitCondition,logMessage:k.logMessage,line:k.location.range.start.line,character:k.location.range.start.character})}else k instanceof I.FunctionBreakpoint&&y.push({type:"function",id:k.id,enabled:k.enabled,hitCondition:k.hitCondition,logMessage:k.logMessage,condition:k.condition,functionName:k.functionName});return this._debugServiceProxy.$registerBreakpoints(y)}removeBreakpoints(m){this.startBreakpoints();const E=m.filter(F=>this._breakpoints.delete(F.id));this.fireBreakpointChanges([],E,[]);const y=E.filter(F=>F instanceof I.SourceBreakpoint).map(F=>F.id),o=E.filter(F=>F instanceof I.FunctionBreakpoint).map(F=>F.id),k=E.filter(F=>F instanceof I.DataBreakpoint).map(F=>F.id);return this._debugServiceProxy.$unregisterBreakpoints(y,o,k)}startDebugging(m,E,y){return this._debugServiceProxy.$startDebugging(m?m.uri:void 0,E,{parentSessionID:y.parentSession?y.parentSession.id:void 0,repl:y.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:y.noDebug,compact:y.compact})}stopDebugging(m){return this._debugServiceProxy.$stopDebugging(m?m.id:void 0)}registerDebugConfigurationProvider(m,E,y){if(!E)return new I.Disposable(()=>{});const o=this._configProviderHandleCounter++;return this._configProviders.push({type:m,handle:o,provider:E}),this._debugServiceProxy.$registerDebugConfigurationProvider(m,y,!!E.provideDebugConfigurations,!!E.resolveDebugConfiguration,!!E.resolveDebugConfigurationWithSubstitutedVariables,o),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(k=>k.provider!==E),this._debugServiceProxy.$unregisterDebugConfigurationProvider(o)})}registerDebugAdapterDescriptorFactory(m,E,y){if(!y)return new I.Disposable(()=>{});if(!this.definesDebugType(m,E))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${E}' debugger.`);if(this.getAdapterDescriptorFactoryByType(E))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const o=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:E,handle:o,factory:y}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(E,o),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(k=>k.factory!==y),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(o)})}registerDebugAdapterTrackerFactory(m,E){if(!E)return new I.Disposable(()=>{});const y=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:m,handle:y,factory:E}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(o=>o.factory!==E)})}async $runInTerminal(m,E){return Promise.resolve(void 0)}async $substituteVariables(m,E){if(!this._variableResolver){const[k,F]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(k||[],this._editorsService,F)}let y;const o=await this.getFolder(m);return o&&(y={uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(y,E)}createDebugAdapter(m,E){if(m.type==="implementation")return new n(m.implementation)}createSignService(){}async $startDASession(m,E){const y=this,o=await this.getSession(E);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(o.type),o).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}' (extension might have failed to activate)`);const F=this.convertToDto(k),$=this.createDebugAdapter(F,o);if(!$)throw new Error(`Couldn't create a debug adapter for type '${o.type}'.`);const Q=$;return this._debugAdapters.set(m,Q),this.getDebugAdapterTrackers(o).then(oe=>(oe&&this._debugAdaptersTrackers.set(m,oe),Q.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const O=j,B={type:"response",seq:0,command:O.command,request_seq:O.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const R=await this._signService.sign(O.arguments.value);B.body={signature:R},Q.sendResponse(B)}else throw new Error("no signer")}catch(R){B.success=!1,B.message=R.message,Q.sendResponse(B)}}else oe&&oe.onDidSendMessage&&oe.onDidSendMessage(j),j=(0,a.convertToVSCPaths)(j,!0),y._debugServiceProxy.$acceptDAMessage(m,j)}),Q.onError(j=>{oe&&oe.onError&&oe.onError(j),this._debugServiceProxy.$acceptDAError(m,j.name,j.message,j.stack)}),Q.onExit(j=>{oe&&oe.onExit&&oe.onExit((0,_.withNullAsUndefined)(j),void 0),this._debugServiceProxy.$acceptDAExit(m,(0,_.withNullAsUndefined)(j),void 0)}),oe&&oe.onWillStartSession&&oe.onWillStartSession(),Q.startSession()))})}$sendDAMessage(m,E){E=(0,a.convertToDAPaths)(E,!1);const y=this._debugAdaptersTrackers.get(m);y&&y.onWillReceiveMessage&&y.onWillReceiveMessage(E);const o=this._debugAdapters.get(m);o&&o.sendMessage(E)}$stopDASession(m){const E=this._debugAdaptersTrackers.get(m);this._debugAdaptersTrackers.delete(m),E&&E.onWillStopSession&&E.onWillStopSession();const y=this._debugAdapters.get(m);return this._debugAdapters.delete(m),y?y.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(m){const E=[],y=[],o=[];if(m.added)for(const k of m.added){const F=k.id;if(F&&!this._breakpoints.has(F)){let $;if(k.type==="function")$=new I.FunctionBreakpoint(k.functionName,k.enabled,k.condition,k.hitCondition,k.logMessage);else if(k.type==="data")$=new I.DataBreakpoint(k.label,k.dataId,k.canPersist,k.enabled,k.hitCondition,k.condition,k.logMessage);else{const Q=L.URI.revive(k.uri);$=new I.SourceBreakpoint(new I.Location(Q,new I.Position(k.line,k.character)),k.enabled,k.condition,k.hitCondition,k.logMessage)}$._id=F,this._breakpoints.set(F,$),E.push($)}}if(m.removed)for(const k of m.removed){const F=this._breakpoints.get(k);F&&(this._breakpoints.delete(k),y.push(F))}if(m.changed){for(const k of m.changed)if(k.id){const F=this._breakpoints.get(k.id);if(F){if(F instanceof I.FunctionBreakpoint&&k.type==="function"){const $=F;$.enabled=k.enabled,$.condition=k.condition,$.hitCondition=k.hitCondition,$.logMessage=k.logMessage,$.functionName=k.functionName}else if(F instanceof I.SourceBreakpoint&&k.type==="source"){const $=F;$.enabled=k.enabled,$.condition=k.condition,$.hitCondition=k.hitCondition,$.logMessage=k.logMessage,$.location=new I.Location(L.URI.revive(k.uri),new I.Position(k.line,k.character))}o.push(F)}}}this.fireBreakpointChanges(E,y,o)}$provideDebugConfigurations(m,E,y){return(0,S.asPromise)(async()=>{const o=this.getConfigProviderByHandle(m);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const k=await this.getFolder(E);return o.provideDebugConfigurations(k,y)}).then(o=>{if(!o)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return o})}$resolveDebugConfiguration(m,E,y,o){return(0,S.asPromise)(async()=>{const k=this.getConfigProviderByHandle(m);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const F=await this.getFolder(E);return k.resolveDebugConfiguration(F,y,o)})}$resolveDebugConfigurationWithSubstitutedVariables(m,E,y,o){return(0,S.asPromise)(async()=>{const k=this.getConfigProviderByHandle(m);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const F=await this.getFolder(E);return k.resolveDebugConfigurationWithSubstitutedVariables(F,y,o)})}async $provideDebugAdapter(m,E){const y=this.getAdapterDescriptorFactoryByHandle(m);if(!y)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const o=await this.getSession(E);return this.getAdapterDescriptor(y,o).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}'`);return this.convertToDto(k)})}async $acceptDebugSessionStarted(m){const E=await this.getSession(m);this._onDidStartDebugSession.fire(E)}async $acceptDebugSessionTerminated(m){const E=await this.getSession(m);E&&(this._onDidTerminateDebugSession.fire(E),this._debugSessions.delete(E.id))}async $acceptDebugSessionActiveChanged(m){this._activeDebugSession=m?await this.getSession(m):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(m,E){const y=await this.getSession(m);y&&y._acceptNameChanged(E)}async $acceptDebugSessionCustomEvent(m,E){const o={session:await this.getSession(m),event:E.event,body:E.body};this._onDidReceiveDebugSessionCustomEvent.fire(o)}convertToDto(m){if(m instanceof I.DebugAdapterExecutable)return{type:"executable",command:m.command,args:m.args,options:m.options};if(m instanceof I.DebugAdapterServer)return{type:"server",port:m.port,host:m.host};if(m instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:m.path};if(m instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:m.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(m){const E=this._adapterFactories.filter(y=>y.type===m);if(E.length>0)return E[0].factory}getAdapterDescriptorFactoryByHandle(m){const E=this._adapterFactories.filter(y=>y.handle===m);if(E.length>0)return E[0].factory}getConfigProviderByHandle(m){const E=this._configProviders.filter(y=>y.handle===m);if(E.length>0)return E[0].provider}definesDebugType(m,E){if(m.contributes){const y=m.contributes.debuggers;if(y&&y.length>0){for(const o of y)if(o.label&&o.type&&o.type===E)return!0}}return!1}getDebugAdapterTrackers(m){const y=m.configuration.type,o=this._trackerFactories.filter(k=>k.type===y||k.type==="*").map(k=>(0,S.asPromise)(()=>k.factory.createDebugAdapterTracker(m)).then(F=>F,F=>null));return Promise.race([Promise.all(o).then(k=>{const F=k.filter($=>!!$);if(F.length>0)return new r(F)}),new Promise((k,F)=>{const $=setTimeout(()=>{clearTimeout($),F(new Error("timeout"))},1e3)})]).catch(k=>{})}async getAdapterDescriptor(m,E){const y=E.configuration.debugServer;if(typeof y=="number")return Promise.resolve(new I.DebugAdapterServer(y));if(m){const k=await this._extensionService.getExtensionRegistry();return(0,S.asPromise)(()=>m.createDebugAdapterDescriptor(E,this.daExecutableFromPackage(E,k))).then(F=>{if(F)return F})}const o=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(E,o))}daExecutableFromPackage(m,E){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(m,E,y){(m.length>0||E.length>0||y.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:m,removed:E,changed:y}))}async getSession(m){if(m)if(typeof m=="string"){const E=this._debugSessions.get(m);if(E)return E}else{let E=this._debugSessions.get(m.id);if(!E){const y=await this.getFolder(m.folderUri),o=m.parent?this._debugSessions.get(m.parent):void 0;E=new v(this._debugServiceProxy,m.id,m.type,m.name,y,m.configuration,o),this._debugSessions.set(E.id,E),this._debugServiceProxy.$sessionCached(E.id)}return E}throw new Error("cannot find session")}getFolder(m){if(m){const E=L.URI.revive(m);return this._workspaceService.resolveWorkspaceFolder(E)}return Promise.resolve(void 0)}};h=Ve([He(0,g.IExtHostRpcService),He(1,A.IExtHostWorkspace),He(2,i.IExtHostExtensionService),He(3,P.IExtHostDocumentsAndEditors),He(4,u.IExtHostConfiguration),He(5,d.IExtHostEditorTabs)],h),e.ExtHostDebugServiceBase=h;class v{constructor(m,E,y,o,k,F,$){this._debugServiceProxy=m,this._id=E,this._type=y,this._name=o,this._workspaceFolder=k,this._configuration=F,this._parentSession=$}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(m){this._name=m,this._debugServiceProxy.$setDebugSessionName(this._id,m)}get parentSession(){return this._parentSession}_acceptNameChanged(m){this._name=m}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(m,E){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,m,E)}getDebugProtocolBreakpoint(m){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,m.id)}}e.ExtHostDebugSession=v;class t{constructor(m){this.value=Object.freeze({append(E){m.$appendDebugConsole(E)},appendLine(E){this.append(E+`
`)}})}}e.ExtHostDebugConsole=t;class s extends c.AbstractVariableResolverService{constructor(m,E,y,o,k){function F(){if(E){const $=E.activeEditor();if($)return $.document.uri;const Q=o.tabs.filter(oe=>oe.isActive);if(Q.length>0)return Q[0].resource}}super({getFolderUri:$=>{const Q=m.filter(oe=>oe.name===$);if(Q&&Q.length>0)return Q[0].uri},getWorkspaceFolderCount:()=>m.length,getConfigurationValue:($,Q)=>y.getConfiguration(void 0,$).get(Q),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{const $=F();if($)return p.normalize($.fsPath)},getWorkspaceFolderPathForFile:()=>{if(k){const $=F();if($){const Q=k.getWorkspaceFolder($);if(Q)return p.normalize(Q.uri.fsPath)}}},getSelectedText:()=>{if(E){const $=E.activeEditor();if($&&!$.selection.isEmpty)return $.document.getText($.selection)}},getLineNumber:()=>{if(E){const $=E.activeEditor();if($)return String($.selection.end.line+1)}}},void 0,Promise.resolve(b.env))}}e.ExtHostVariableResolverService=s;class r{constructor(m){this.trackers=m}onWillStartSession(){this.trackers.forEach(m=>m.onWillStartSession?m.onWillStartSession():void 0)}onWillReceiveMessage(m){this.trackers.forEach(E=>E.onWillReceiveMessage?E.onWillReceiveMessage(m):void 0)}onDidSendMessage(m){this.trackers.forEach(E=>E.onDidSendMessage?E.onDidSendMessage(m):void 0)}onWillStopSession(){this.trackers.forEach(m=>m.onWillStopSession?m.onWillStopSession():void 0)}onError(m){this.trackers.forEach(E=>E.onError?E.onError(m):void 0)}onExit(m,E){this.trackers.forEach(y=>y.onExit?y.onExit(m,E):void 0)}}class n extends D.AbstractDebugAdapter{constructor(m){super();this.implementation=m,m.onDidSendMessage(E=>{this.acceptMessage(E)})}startSession(){return Promise.resolve(void 0)}sendMessage(m){this.implementation.handleMessage(m)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let l=class extends h{constructor(m,E,y,o,k,F){super(m,E,y,o,k,F)}createVariableResolver(m,E,y){return new s(m,E,y,this._editorTabs)}};l=Ve([He(0,g.IExtHostRpcService),He(1,A.IExtHostWorkspace),He(2,i.IExtHostExtensionService),He(3,P.IExtHostDocumentsAndEditors),He(4,u.IExtHostConfiguration),He(5,d.IExtHostEditorTabs)],l),e.WorkerExtHostDebugService=l}),define(me[262],ge([0,1,67,2,5,36,34,26,13,27,4,39,37,12]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(d,h,v,t,s,r,n){this._apiFactory=d,this._extensionRegistry=h,this._instaService=v,this._extHostConfiguration=t,this._extHostExtensionService=s,this._initData=r,this._logService=n,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),p.mark("code/extHost/willWaitForConfig");const d=await this._extHostConfiguration.getConfigProvider();p.mark("code/extHost/didWaitForConfig");const h=await this._extHostExtensionService.getExtensionPathIndex();this.register(new g(this._apiFactory,h,this._extensionRegistry,d,this._logService)),this.register(this._instaService.createInstance(w)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(_,h,this._initData.environment.appUriScheme))}register(d){if(Array.isArray(d.nodeModuleName))for(let h of d.nodeModuleName)this._factories.set(h,d);else this._factories.set(d.nodeModuleName,d);typeof d.alternativeModuleName=="function"&&this._alternatives.push(h=>d.alternativeModuleName(h))}};a=Ve([He(2,i.IInstantiationService),He(3,S.IExtHostConfiguration),He(4,P.IExtHostExtensionService),He(5,A.IExtHostInitDataService),He(6,u.ILogService)],a),e.RequireInterceptor=a;class g{constructor(d,h,v,t,s){this._apiFactory=d,this._extensionPaths=h,this._extensionRegistry=v,this._configProvider=t,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(d,h){const v=this._extensionPaths.findSubstr(h.fsPath);if(v){let t=this._extApiImpl.get(I.ExtensionIdentifier.toKey(v.identifier));return t||(t=this._apiFactory(v,this._extensionRegistry,this._configProvider),this._extApiImpl.set(I.ExtensionIdentifier.toKey(v.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((s,r)=>t+=`	${r} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${h.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let w=class{constructor(d,h){this.nodeModuleName="keytar";const{environment:v}=h,t=d.getProxy(C.MainContext.MainThreadKeytar);if(v.appRoot){let s=v.appRoot.fsPath;c.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,r)=>t.$getPassword(s,r),setPassword:(s,r,n)=>t.$setPassword(s,r,n),deletePassword:(s,r)=>t.$deletePassword(s,r),findPassword:s=>t.$findPassword(s),findCredentials(s){return t.$findCredentials(s)}}}load(d,h){return this._impl}alternativeModuleName(d){const h=d.length;if(h<=7||!this.alternativeNames)return;const v=h-7;if((d.charAt(v)==="/"||d.charAt(v)==="\\")&&d.endsWith("keytar")&&(d=d.replace(/\\/g,"/"),this.alternativeNames.has(d)))return"keytar"}};w=Ve([He(0,D.IExtHostRpcService),He(1,A.IExtHostInitDataService)],w);let _=class{constructor(d,h,v){this._extensionPaths=d,this._appUriScheme=h,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=v.getProxy(C.MainContext.MainThreadTelemetry);const t=v.getProxy(C.MainContext.MainThreadWindow);this._impl=(s,r)=>{const n=L.URI.parse(s);return r?this.callOriginal(s,r):n.scheme==="http"||n.scheme==="https"?t.$openUri(n,s,{allowTunneling:!0}):n.scheme==="mailto"||n.scheme===this._appUriScheme?t.$openUri(n,s,{}):this.callOriginal(s,r)}}load(d,h,v){const t=this._extensionPaths.findSubstr(h.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=v(d),this._impl}callOriginal(d,h){return this.sendNoForwardTelemetry(),this._original(d,h)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};_=Ve([He(2,D.IExtHostRpcService)],_)}),define(me[263],ge([0,1,166,11,7,205,35,39,43,36,33,13,51,190,17,206,48]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let _=class extends c.ExtHostDebugServiceBase{constructor(h,v,t,s,r,n,l){super(h,v,t,s,r,l);this._terminalService=n,this._integratedTerminalInstances=new b}createDebugAdapter(h,v){switch(h.type){case"server":return new S.SocketDebugAdapter(h);case"pipeServer":return new S.NamedPipeDebugAdapter(h);case"executable":return new S.ExecutableDebugAdapter(h,v.type)}return super.createDebugAdapter(h,v)}daExecutableFromPackage(h,v){const t=S.ExecutableDebugAdapter.platformAdapterExecutable(v.getAllExtensionDescriptions(),h.type);if(t)return new C.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new u.SignService}async $runInTerminal(h,v){if(h.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(F=>{this._integratedTerminalInstances.onTerminalClosed(F)}));const t=await this._configurationService.getConfigProvider(),s=this._terminalService.getDefaultShell(!0),r=this._terminalService.getDefaultShellArgs(!0),n=h.title||p.localize(0,null),l=JSON.stringify({shell:s,shellArgs:r});let f=await this._integratedTerminalInstances.checkout(l,n),m,E=!1;if(f)m=h.cwd;else{const F={shellPath:s,shellArgs:r,cwd:h.cwd,name:n,iconPath:new C.ThemeIcon("debug")};E=!0,f=this._terminalService.createTerminalFromOptions(F,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(f,l)}f.show(!0);const y=await f.processId;E?await new Promise(F=>setTimeout(F,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(s.indexOf("powershell")>=0||s.indexOf("pwsh")>=0||s.indexOf("cmd.exe")>=0?f.sendText("cls"):s.indexOf("bash")>=0?f.sendText("clear"):L.isWindows?f.sendText("cls"):f.sendText("clear"));const o=(0,g.prepareCommand)(s,h.args,m,h.env);f.sendText(o);const k=this.onDidTerminateDebugSession(F=>{F.id===v&&(this._integratedTerminalInstances.free(f),k.dispose())});return y}else if(h.kind==="external")return(0,g.runInExternalTerminal)(h,await this._configurationService.getConfigProvider());return super.$runInTerminal(h,v)}createVariableResolver(h,v,t){return new c.ExtHostVariableResolverService(h,v,t,this._editorTabs,this._workspaceService)}};_=Ve([He(0,P.IExtHostRpcService),He(1,T.IExtHostWorkspace),He(2,I.IExtHostExtensionService),He(3,D.IExtHostDocumentsAndEditors),He(4,A.IExtHostConfiguration),He(5,i.IExtHostTerminalService),He(6,w.IExtHostEditorTabs)],_),e.ExtHostDebugService=_;class b{constructor(){this._terminalInstances=new Map}async checkout(h,v){const s=[...this._terminalInstances.entries()].map(([r,n])=>(0,a.createCancelablePromise)(async l=>{if(r.name!==v||n.lastUsedAt!==-1&&await(0,g.hasChildProcesses)(await r.processId))return null;const f=Date.now();return n.lastUsedAt+b.minUseDelay>f||l.isCancellationRequested||n.config!==h?null:(n.lastUsedAt=f,r)}));return await(0,a.firstParallel)(s,r=>!!r)}insert(h,v){this._terminalInstances.set(h,{lastUsedAt:Date.now(),config:v})}free(h){const v=this._terminalInstances.get(h);v&&(v.lastUsedAt=-1)}onTerminalClosed(h){this._terminalInstances.delete(h)}}b.minUseDelay=1e3}),define(me[264],ge([0,1,9,2,111,35,51,43,36,33,13,27,66,10,12,61,48]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let _=class extends c.ExtHostTaskBase{constructor(d,h,v,t,s,r,n,l,f){super(d,h,v,t,s,r,n,l);this.workspaceService=v,this.editorTabs=f,h.remote.isRemote&&h.remote.authority?this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:h.remote.authority,platform:process.platform}):this.registerTaskSystem(u.Schemas.file,{scheme:u.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(d,h){const v=h;if(!h.execution&&v._id===void 0)throw new Error("Tasks to execute must include an execution");if(v._id!==void 0){const t=c.TaskHandleDTO.from(v,this.workspaceService),s=await this._proxy.$getTaskExecution(t);if(s.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.getTaskExecution(s,h);return this._proxy.$executeTask(t).catch(()=>{}),r}else{const t=c.TaskDTO.from(h,d);if(t===void 0)return Promise.reject(new Error("Task is not valid"));c.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,h,!1);const s=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),h);return this._proxy.$executeTask(t).catch(()=>{}),s}}provideTasksInternal(d,h,v,t){const s=[];if(t)for(let r of t){this.checkDeprecation(r,v),(!r.definition||!d[r.definition.type])&&this._logService.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const n=c.TaskDTO.from(r,v.extension);n&&(s.push(n),c.CustomExecutionDTO.is(n.execution)&&h.push(this.addCustomExecution(n,r,!0)))}return{tasks:s,extension:v.extension}}async resolveTaskInternal(d){return d}async getVariableResolver(d){if(this._variableResolver===void 0){const h=await this._configurationService.getConfigProvider();this._variableResolver=new T.ExtHostVariableResolverService(d,this._editorService,h,this.editorTabs,this.workspaceService)}return this._variableResolver}async $resolveVariables(d,h){const v=L.URI.revive(d),t={process:void 0,variables:Object.create(null)},s=await this._workspaceProvider.resolveWorkspaceFolder(v),r=await this._workspaceProvider.getWorkspaceFolders2();if(!r||!s)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const n=await this.getVariableResolver(r),l={uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}};for(let f of h.variables)t.variables[f]=await n.resolveAsync(l,f);if(h.process!==void 0){let f;if(h.process.path!==void 0){f=h.process.path.split(p.delimiter);for(let m=0;m<f.length;m++)f[m]=await n.resolveAsync(l,f[m])}t.process=await C.win32.findExecutable(await n.resolveAsync(l,h.process.name),h.process.cwd!==void 0?await n.resolveAsync(l,h.process.cwd):void 0,f)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(d,h,v){return C.win32.findExecutable(d,h,v)}};_=Ve([He(0,i.IExtHostRpcService),He(1,P.IExtHostInitDataService),He(2,S.IExtHostWorkspace),He(3,I.IExtHostDocumentsAndEditors),He(4,D.IExtHostConfiguration),He(5,A.IExtHostTerminalService),He(6,a.ILogService),He(7,g.IExtHostApiDeprecationService),He(8,w.IExtHostEditorTabs)],_),e.ExtHostTask=_}),define(me[265],ge([0,1,17,15,67,6,2,5,257,12,78,81,27,183,13,60,39,33]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a,g,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(h,v,t,s){this._disposables=new S.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new D.RPCProtocol(h,null,s),v=b._transform(v,this._rpcProtocol);const r=new P.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());r.set(c.IExtHostInitDataService,{_serviceBrand:void 0,...v}),r.set(a.IExtHostRpcService,new a.ExtHostRpcService(this._rpcProtocol)),r.set(g.IURITransformerService,new g.URITransformerService(s)),r.set(w.IHostUtils,t);const n=new u.InstantiationService(r,!0),l=n.invokeFunction(y=>y.get(_.IExtHostTerminalService));this._disposables.add(l),this._logService=n.invokeFunction(y=>y.get(A.ILogService)),C.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",v),this._extensionService=n.invokeFunction(y=>y.get(w.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const f=new WeakMap;this._extensionService.getExtensionPathIndex().then(y=>{Error.prepareStackTrace=(o,k)=>{let F="",$,Q;for(const oe of k)F+=`
	at ${oe.toString()}`,Q=oe.getFileName(),!$&&Q&&($=y.findSubstr(Q));return f.set(o,$),`${o.name||"Error"}: ${o.message||""}${F}`}});const m=this._rpcProtocol.getProxy(I.MainContext.MainThreadExtensionService),E=this._rpcProtocol.getProxy(I.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(y=>{const o=L.transformErrorForSerialization(y),k=f.get(y);k?m.$onExtensionRuntimeError(k.identifier,o):E.$onUnexpectedError(o)})}terminate(h){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${h}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const v=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,p.timeout)(4e3),v]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(h,v){h.extensions.forEach(s=>s.extensionLocation=T.URI.revive(v.transformIncomingURIs(s.extensionLocation))),h.environment.appRoot=T.URI.revive(v.transformIncomingURIs(h.environment.appRoot));const t=h.environment.extensionDevelopmentLocationURI;return t&&(h.environment.extensionDevelopmentLocationURI=t.map(s=>T.URI.revive(v.transformIncomingURIs(s)))),h.environment.extensionTestsLocationURI=T.URI.revive(v.transformIncomingURIs(h.environment.extensionTestsLocationURI)),h.environment.globalStorageHome=T.URI.revive(v.transformIncomingURIs(h.environment.globalStorageHome)),h.environment.workspaceStorageHome=T.URI.revive(v.transformIncomingURIs(h.environment.workspaceStorageHome)),h.logsLocation=T.URI.revive(v.transformIncomingURIs(h.logsLocation)),h.logFile=T.URI.revive(v.transformIncomingURIs(h.logFile)),h.workspace=v.transformIncomingURIs(h.workspace),h}}e.ExtensionHostMain=b}),define(me[266],ge([0,1,9,21,58,30,24,44,31]),function(J,e,p,L,C,S,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class A{constructor(c,u,a){this.config=c,this.provider=u,this.sessionToken=a,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&S.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&S.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const u=this.config.folderQueries||[];return new Promise((a,g)=>{const w=_=>{this.resultCount++,c(_)};if(this.isCanceled)return a({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(_=>{const b=_.toString(),d=p.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,d)||this.matchFile(w,{base:_,basename:d})}),Promise.all(u.map(_=>this.searchInFolder(_,w))).then(_=>{a({limitHit:this.isLimitHit,stats:_[0]||void 0})},_=>{g(new Error((0,C.toErrorMessage)(_)))})})}async searchInFolder(c,u){const a=new L.CancellationTokenSource,g=this.getSearchOptionsForFolder(c),w=this.initDirectoryTree(),_=new D.QueryGlobTester(this.config,c),b=!_.hasSiblingExcludeClauses();let d;try{this.activeCancellationTokens.add(a),d=I.StopWatch.create();const h=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},g,a.token),v=d.elapsed(),t=I.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(h&&h.forEach(s=>{const r=p.posix.relative(c.folder.path,s.path);if(b){const n=p.basename(s.path);this.matchFile(u,{base:c.folder,relativePath:r,basename:n});return}this.addDirectoryEntries(w,c.folder,r,u)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(w,_,u),{providerTime:v,postProcessTime:t.elapsed()})}finally{a.dispose(),this.activeCancellationTokens.delete(a)}}getSearchOptionsForFolder(c){const u=(0,D.resolvePatternsForProvider)(this.config.includePattern,c.includePattern),a=(0,D.resolvePatternsForProvider)(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:a,includes:u,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},u,a,g){if(a===this.filePattern){const _=p.basename(this.filePattern);this.matchFile(g,{base:u,relativePath:this.filePattern,basename:_})}function w(_){const b=p.basename(_),d=p.dirname(_);let h=c[d];h||(h=c[d]=[],w(d)),h.push({base:u,relativePath:_,basename:b})}w(a)}matchDirectoryTree({rootEntries:c,pathToEntries:u},a,g){const w=this,_=this.filePattern;function b(d){const h=S.hasSiblingFn(()=>d.map(v=>v.basename));for(let v=0,t=d.length;v<t;v++){const s=d[v],{relativePath:r,basename:n}=s;if(!a.includedInQuerySync(r,n,_!==n?h:void 0))continue;const l=u[r];if(l)b(l);else{if(r===_)continue;w.matchFile(g,s)}if(w.isLimitHit)break}}b(c)}matchFile(c,u){(!this.includePattern||u.relativePath&&this.includePattern(u.relativePath,u.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(u))}}class i{constructor(){this.sessions=new Map}fileSearch(c,u,a,g){const w=this.getSessionTokenSource(c.cacheKey),_=new A(c,u,w&&w.token);let b=0;const d=h=>{b+=h.length,a(h.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(_,i.BATCH_SIZE,d,g).then(h=>({limitHit:h.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:h.stats}}))}clearCache(c){const u=this.getSessionTokenSource(c);u&&u.cancel()}getSessionTokenSource(c){if(!!c)return this.sessions.has(c)||this.sessions.set(c,new L.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:T.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,u,a,g){g.onCancellationRequested(()=>{c.cancel()});const w=b=>{b&&(_.push(b),u>0&&_.length>=u&&(a(_),_=[]))};let _=[];return c.search(w).then(b=>(_.length&&a(_),b),b=>(_.length&&a(_),Promise.reject(b)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(me[130],ge([0,1,9,18,21,58,24,30,2,31,10,14]),function(J,e,p,L,C,S,T,I,D,A,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class c{constructor(d,h,v){this.query=d,this.provider=h,this.fileUtils=v,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(d,h){const v=this.query.folderQueries||[],t=new C.CancellationTokenSource;return h.onCancellationRequested(()=>t.cancel()),new Promise((s,r)=>{this.collector=new a(d);let n=!1;const l=(f,m)=>{if(!n&&!this.isLimitHit){const E=this.resultSize(f);w(f)&&typeof this.query.maxResults=="number"&&this.resultCount+E>this.query.maxResults&&(this.isLimitHit=!0,n=!0,t.cancel(),f=this.trimResultToSize(f,this.query.maxResults-this.resultCount));const y=this.resultSize(f);this.resultCount+=y,(y>0||!w(f))&&this.collector.add(f,m)}};Promise.all(v.map((f,m)=>this.searchInFolder(f,E=>l(E,m),t.token))).then(f=>{t.dispose(),this.collector.flush();const m=f.some(E=>!!E&&!!E.limitHit);s({limitHit:this.isLimitHit||m,messages:(0,L.flatten)(f.map(E=>E?.message?(0,P.isArray)(E.message)?E.message:[E.message]:[])),stats:{type:"textSearchProvider"}})},f=>{t.dispose();const m=(0,S.toErrorMessage)(f);r(new Error(m))})})}resultSize(d){return w(d)?Array.isArray(d.ranges)?d.ranges.length:1:0}trimResultToSize(d,h){const v=Array.isArray(d.ranges)?d.ranges:[d.ranges],t=Array.isArray(d.preview.matches)?d.preview.matches:[d.preview.matches];return{ranges:v.slice(0,h),preview:{matches:t.slice(0,h),text:d.preview.text},uri:d.uri}}async searchInFolder(d,h,v){const t=new A.QueryGlobTester(this.query,d),s=[],r={report:f=>{if(!this.validateProviderResult(f))return;const m=d.folder.scheme===i.Schemas.file?I.hasSiblingPromiseFn(()=>this.fileUtils.readdir(T.dirname(f.uri))):void 0,E=T.relativePath(d.folder,f.uri);E&&s.push(t.includedInQuery(E,p.basename(E),m).then(y=>{y&&h(f)}))}},n=this.getSearchOptionsForFolder(d),l=await this.provider.provideTextSearchResults(u(this.query.contentPattern),n,r,v);return await Promise.all(s),l}validateProviderResult(d){if(w(d)){if(Array.isArray(d.ranges)){if(!Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(d.preview.matches.length!==d.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(d){const h=(0,A.resolvePatternsForProvider)(this.query.includePattern,d.includePattern),v=(0,A.resolvePatternsForProvider)(this.query.excludePattern,d.excludePattern),t={folder:D.URI.from(d.folder),excludes:v,includes:h,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,encoding:d.fileEncoding&&this.fileUtils.toCanonicalName(d.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=c;function u(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class a{constructor(d){this._onResult=d,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new _(512,h=>this.sendItems(h))}add(d,h){this._currentFileMatch&&(this._currentFolderIdx!==h||!T.isEqual(this._currentUri,d.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=h,this._currentFileMatch={resource:d.uri,results:[]}),this._currentFileMatch.results.push(g(d))}pushToCollector(){const d=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,d)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(d){this._onResult(d)}}e.TextSearchResultsCollector=a;function g(b){return w(b)?{preview:{matches:(0,L.mapArrayOrNot)(b.preview.matches,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character})),text:b.preview.text},ranges:(0,L.mapArrayOrNot)(b.ranges,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function w(b){return!!b.preview}e.extensionResultIsMatch=w;class _{constructor(d,h){this.maxBatchSize=d,this.cb=h,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(d,h){!d||this.addItemToBatch(d,h)}addItems(d,h){!d||this.addItemsToBatch(d,h)}addItemToBatch(d,h){this.batch.push(d),this.batchSize+=h,this.onUpdate()}addItemsToBatch(d,h){this.batch=this.batch.concat(d),this.batchSize+=h,this.onUpdate()}onUpdate(){this.totalNumberCompleted<_.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},_.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=_,_.TIMEOUT=4e3,_.START_BATCH_AFTER_COUNT=50}),define(me[68],ge([0,1,6,5,4,266,13,60,12,2,130]),function(J,e,p,L,C,S,T,I,D,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,C.createDecorator)("IExtHostSearch");let P=class{constructor(g,w,_){this.extHostRpc=g,this._uriTransformer=w,this._logService=_,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new S.FileSearchManager}_transformScheme(g){return this._uriTransformer.transformOutgoingScheme(g)}registerTextSearchProvider(g,w){if(this._textSearchUsedSchemes.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this._textSearchUsedSchemes.add(g);const _=this._handlePool++;return this._textSearchProvider.set(_,w),this._proxy.$registerTextSearchProvider(_,this._transformScheme(g)),(0,p.toDisposable)(()=>{this._textSearchUsedSchemes.delete(g),this._textSearchProvider.delete(_),this._proxy.$unregisterProvider(_)})}registerFileSearchProvider(g,w){if(this._fileSearchUsedSchemes.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this._fileSearchUsedSchemes.add(g);const _=this._handlePool++;return this._fileSearchProvider.set(_,w),this._proxy.$registerFileSearchProvider(_,this._transformScheme(g)),(0,p.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(g),this._fileSearchProvider.delete(_),this._proxy.$unregisterProvider(_)})}$provideFileSearchResults(g,w,_,b){const d=c(_),h=this._fileSearchProvider.get(g);if(h)return this._fileSearchManager.fileSearch(d,h,v=>{this._proxy.$handleFileMatch(g,w,v.map(t=>t.resource))},b);throw new Error("unknown provider: "+g)}$clearCache(g){return this._fileSearchManager.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,w,_,b){const d=this._textSearchProvider.get(g);if(!d||!d.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const h=c(_);return this.createTextSearchManager(h,d).search(t=>this._proxy.$handleTextMatch(g,w,t),b)}createTextSearchManager(g,w){return new i.TextSearchManager(g,w,{readdir:_=>Promise.resolve([]),toCanonicalName:_=>_})}};P=Ve([He(0,T.IExtHostRpcService),He(1,I.IURITransformerService),He(2,D.ILogService)],P),e.ExtHostSearch=P;function c(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(u),extraFileResources:a.extraFileResources&&a.extraFileResources.map(g=>A.URI.revive(g))}}e.reviveQuery=c;function u(a){return{...a,folder:A.URI.revive(a.folder)}}}),define(me[267],ge([0,1,21,15,3,56,2,112,107,143,77,41,5,226,225,50,227,36,228,229,230,211,231,43,39,232,212,234,235,236,62,214,241,242,243,90,33,245,215,16,7,248,64,129,35,34,69,202,233,83,128,66,51,68,12,60,13,27,237,200,49,61,223,246,199,63,89,251,249,250,224,59,244,247,88,48,119,239,65,240,10,185,238,197,195]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a,g,w,_,b,d,h,v,t,s,r,n,l,f,m,E,y,o,k,F,$,Q,oe,j,O,B,R,z,N,M,q,x,K,ee,de,Se,De,Le,qe,We,je,W,Z,te,ae,Y,se,we,Fe,ze,_e,Ze,X,ie,fe,$e,xe,tt,Ce,ke,Te,le,ce,pe,Ee,G,ve,ye,Ae,Ne,Ge){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function et(Qe){const Xe=Qe.get(te.IExtHostInitDataService),lt=Qe.get(tt.IExtHostFileSystemInfo),dt=Qe.get(X.IExtHostConsumerFileSystem),_t=Qe.get(r.IExtHostExtensionService),at=Qe.get(q.IExtHostWorkspace),be=Qe.get(ce.IExtHostTelemetry),Ie=Qe.get(_.IExtHostConfiguration),he=Qe.get(W.IURITransformerService),V=Qe.get(Z.IExtHostRpcService),Me=Qe.get(Q.IExtHostStorage),Be=Qe.get(Ze.IExtensionStoragePaths),Ye=Qe.get(je.ILogService),Ke=Qe.get(se.IExtHostTunnelService),ct=Qe.get(we.IExtHostApiDeprecationService),mt=Qe.get(M.IExtHostWindow),kt=Qe.get(Te.IExtHostSecretState),yt=Qe.get(le.IExtHostEditorTabs);V.set(c.ExtHostContext.ExtHostFileSystemInfo,lt),V.set(c.ExtHostContext.ExtHostLogService,Ye),V.set(c.ExtHostContext.ExtHostWorkspace,at),V.set(c.ExtHostContext.ExtHostConfiguration,Ie),V.set(c.ExtHostContext.ExtHostExtensionService,_t),V.set(c.ExtHostContext.ExtHostStorage,Me),V.set(c.ExtHostContext.ExtHostTunnelService,Ke),V.set(c.ExtHostContext.ExtHostWindow,mt),V.set(c.ExtHostContext.ExtHostSecretState,kt),V.set(c.ExtHostContext.ExtHostTelemetry,be),V.set(c.ExtHostContext.ExtHostEditorTabs,yt);const wt=V.set(c.ExtHostContext.ExtHostDecorations,Qe.get(De.IExtHostDecorations)),gt=V.set(c.ExtHostContext.ExtHostDocumentsAndEditors,Qe.get(s.IExtHostDocumentsAndEditors)),ht=V.set(c.ExtHostContext.ExtHostCommands,Qe.get(g.IExtHostCommands)),Et=V.set(c.ExtHostContext.ExtHostTerminalService,Qe.get(oe.IExtHostTerminalService)),ft=V.set(c.ExtHostContext.ExtHostDebugService,Qe.get(qe.IExtHostDebugService)),Nt=V.set(c.ExtHostContext.ExtHostSearch,Qe.get(We.IExtHostSearch)),Pt=V.set(c.ExtHostContext.ExtHostTask,Qe.get(Le.IExtHostTask)),Kt=V.set(c.ExtHostContext.ExtHostOutputService,Qe.get(y.IExtHostOutputService)),Ut=V.set(c.ExtHostContext.ExtHostUrls,new z.ExtHostUrls(V)),Ct=V.set(c.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(V,gt)),Qt=V.set(c.ExtHostContext.ExtHostDocumentContentProviders,new h.ExtHostDocumentContentProvider(V,gt,Ye)),Xt=V.set(c.ExtHostContext.ExtHostDocumentSaveParticipant,new v.ExtHostDocumentSaveParticipant(Ye,Ct,V.getProxy(c.MainContext.MainThreadBulkEdits))),pt=V.set(c.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(V,ht,gt,Ct,Be)),jt=V.set(c.ExtHostContext.ExtHostNotebookDocuments,new Ne.ExtHostNotebookDocuments(Ye,pt)),zt=V.set(c.ExtHostContext.ExtHostNotebookEditors,new Ae.ExtHostNotebookEditors(Ye,V,pt)),Yt=V.set(c.ExtHostContext.ExtHostNotebookKernels,new pe.ExtHostNotebookKernels(V,Xe,pt,Ye)),Jt=V.set(c.ExtHostContext.ExtHostNotebookRenderers,new G.ExtHostNotebookRenderers(V,pt)),At=V.set(c.ExtHostContext.ExtHostEditors,new j.ExtHostEditors(V,gt)),qt=V.set(c.ExtHostContext.ExtHostTreeViews,new O.ExtHostTreeViews(V.getProxy(c.MainContext.MainThreadTreeViews),ht,Ye)),Zt=V.set(c.ExtHostContext.ExtHostEditorInsets,new ee.ExtHostEditorInsets(V.getProxy(c.MainContext.MainThreadEditorInsets),At,Xe)),Ht=V.set(c.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(V,Ye)),ut=V.set(c.ExtHostContext.ExtHostLanguageFeatures,new f.ExtHostLanguageFeatures(V,he,Ct,ht,Ht,Ye,ct)),En=V.set(c.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(V,ut)),Rt=V.set(c.ExtHostContext.ExtHostFileSystemEventService,new l.ExtHostFileSystemEventService(V,Ye,gt)),xt=V.set(c.ExtHostContext.ExtHostQuickOpen,(0,k.createExtHostQuickOpen)(V,at,ht)),un=V.set(c.ExtHostContext.ExtHostSCM,new F.ExtHostSCM(V,ht,Ye)),_n=V.set(c.ExtHostContext.ExtHostComments,(0,w.createExtHostComments)(V,ht,Ct)),dn=V.set(c.ExtHostContext.ExtHostProgress,new o.ExtHostProgress(V.getProxy(c.MainContext.MainThreadProgress))),Sn=V.set(c.ExtHostContext.ExtHosLabelService,new de.ExtHostLabelService(V)),hn=V.set(c.ExtHostContext.ExtHostTheming,new Y.ExtHostTheming(V)),Vt=V.set(c.ExtHostContext.ExtHostAuthentication,new Fe.ExtHostAuthentication(V)),en=V.set(c.ExtHostContext.ExtHostTimeline,new ze.ExtHostTimeline(V,ht)),tn=V.set(c.ExtHostContext.ExtHostWebviews,new N.ExtHostWebviews(V,{remote:Xe.remote},at,Ye,ct)),nn=V.set(c.ExtHostContext.ExtHostWebviewPanels,new $e.ExtHostWebviewPanels(V,tn,at)),yn=V.set(c.ExtHostContext.ExtHostCustomEditors,new fe.ExtHostCustomEditors(V,Ct,Be,tn,nn)),Dn=V.set(c.ExtHostContext.ExtHostWebviewViews,new ie.ExtHostWebviewViews(V,tn)),Lt=V.set(c.ExtHostContext.ExtHostTesting,new Ce.ExtHostTesting(V,ht)),Cn=V.set(c.ExtHostContext.ExtHostUriOpeners,new ke.ExtHostUriOpeners(V));V.set(c.ExtHostContext.ExtHostInteractive,new Ge.ExtHostInteractive(V,pt,gt));const kn=(0,K.values)(c.ExtHostContext);V.assertRegistered(kn);const rn=new xe.ExtHostBulkEdits(V,gt),In=new a.ExtHostClipboard(V),Bt=new E.ExtHostMessageService(V,Ye),Mt=new d.ExtHostDialogs(V),fn=new $.ExtHostStatusBar(V,ht.converter),Tt=new m.ExtHostLanguages(V,Ct);return u.ExtHostApiCommands.register(ht),function(Oe,sn,mn){const vt=function(){let ne=!Oe.isUnderDevelopment;function ue(Re){ne||(Ye.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Re(st){if(Array.isArray(st))st.forEach(Re);else if(typeof st=="string")ue(st);else{const bt=st;typeof bt.scheme=="undefined"&&ue(st),!Oe.enableProposedApi&&typeof bt.exclusive=="boolean"&&(0,x.throwProposedApiError)(Oe)}return st}}(),Pn={getSession(ne,ue,Re){return Vt.getSession(Oe,ne,ue,Re)},get onDidChangeSessions(){return Vt.onDidChangeSessions},registerAuthenticationProvider(ne,ue,Re,st){return Vt.registerAuthenticationProvider(ne,ue,Re,st)}},An={registerCommand(ne,ue,Re){return ht.registerCommand(!0,ne,ue,Re)},registerTextEditorCommand(ne,ue,Re){return ht.registerCommand(!0,ne,(...st)=>{const bt=At.getActiveTextEditor();if(!bt){Ye.warn("Cannot execute "+ne+" because there is no active text editor.");return}return bt.edit(Dt=>{ue.apply(Re,[bt,Dt,...st])}).then(Dt=>{Dt||Ye.warn("Edits from command "+ne+" were not applied.")},Dt=>{Ye.warn("An error occurred while running command "+ne,Dt)})})},registerDiffInformationCommand:(ne,ue,Re)=>((0,x.checkProposedApiEnabled)(Oe),ht.registerCommand(!0,ne,async(...st)=>{const bt=gt.activeEditor(!0);if(!bt){Ye.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Dt=await At.getDiffInformation(bt.id);ue.apply(Re,[Dt,...st])})),executeCommand(ne,...ue){return ht.executeCommand(ne,...ue)},getCommands(ne=!1){return ht.getCommands(ne)}},gn={get machineId(){return Xe.telemetryInfo.machineId},get sessionId(){return Xe.telemetryInfo.sessionId},get language(){return Xe.environment.appLanguage},get appName(){return Xe.environment.appName},get appRoot(){return Xe.environment.appRoot?.fsPath??""},get uriScheme(){return Xe.environment.appUriScheme},get clipboard(){return In.value},get shell(){return Et.getDefaultShell(!1)},get isTelemetryEnabled(){return be.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return be.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ne=Date.now()-new Date(Xe.telemetryInfo.firstSessionDate).getTime();return isNaN(ne)?!1:ne<1e3*60*60*24},openExternal(ne,ue){return mt.openUri(ne,{allowTunneling:!!Xe.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===Xe.environment.appUriScheme)return Ut.createAppUri(ne);try{return await mt.asExternalUri(ne,{allowTunneling:!!Xe.remote.authority})}catch(ue){if((0,ye.matchesScheme)(ne,ve.Schemas.http)||(0,ye.matchesScheme)(ne,ve.Schemas.https))return ne;throw ue}},get remoteName(){return(0,Se.getRemoteName)(Xe.remote.authority)},get uiKind(){return Xe.uiKind}};Xe.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=Xe.remote.isRemote?R.ExtensionKind.Workspace:R.ExtensionKind.UI,on={createTestController(ne,ue){return(0,x.checkProposedApiEnabled)(Oe),Lt.createTestController(ne,ue)},createTestItem(ne,ue,Re){return(0,x.checkProposedApiEnabled)(Oe),Lt.createTestItem(ne,ue,Re)},createTestObserver(){return(0,x.checkProposedApiEnabled)(Oe),Lt.createTestObserver()},runTests(ne){return(0,x.checkProposedApiEnabled)(Oe),Lt.runTests(ne)},get onDidChangeTestResults(){return(0,x.checkProposedApiEnabled)(Oe),Lt.onResultsChanged},get testResults(){return(0,x.checkProposedApiEnabled)(Oe),Lt.results}},Tn={getExtension(ne){const ue=sn.getExtensionDescription(ne);if(ue)return new r.Extension(_t,Oe.identifier,ue,pn)},get all(){return sn.getAllExtensionDescriptions().map(ne=>new r.Extension(_t,Oe.identifier,ne,pn))},get onDidChange(){return sn.onDidChange}},Rn={createDiagnosticCollection(ne){return Ht.createDiagnosticCollection(Oe.identifier,ne)},get onDidChangeDiagnostics(){return Ht.onDidChangeDiagnostics},getDiagnostics:ne=>Ht.getDiagnostics(ne),getLanguages(){return Tt.getLanguages()},setTextDocumentLanguage(ne,ue){return Tt.changeLanguage(ne.uri,ue)},match(ne,ue){return(0,i.score)(B.LanguageSelector.from(ne),ue.uri,ue.languageId,!0)},registerCodeActionsProvider(ne,ue,Re){return ut.registerCodeActionProvider(Oe,vt(ne),ue,Re)},registerCodeLensProvider(ne,ue){return ut.registerCodeLensProvider(Oe,vt(ne),ue)},registerDefinitionProvider(ne,ue){return ut.registerDefinitionProvider(Oe,vt(ne),ue)},registerDeclarationProvider(ne,ue){return ut.registerDeclarationProvider(Oe,vt(ne),ue)},registerImplementationProvider(ne,ue){return ut.registerImplementationProvider(Oe,vt(ne),ue)},registerTypeDefinitionProvider(ne,ue){return ut.registerTypeDefinitionProvider(Oe,vt(ne),ue)},registerHoverProvider(ne,ue){return ut.registerHoverProvider(Oe,vt(ne),ue,Oe.identifier)},registerEvaluatableExpressionProvider(ne,ue){return ut.registerEvaluatableExpressionProvider(Oe,vt(ne),ue,Oe.identifier)},registerInlineValuesProvider(ne,ue){return ut.registerInlineValuesProvider(Oe,vt(ne),ue,Oe.identifier)},registerDocumentHighlightProvider(ne,ue){return ut.registerDocumentHighlightProvider(Oe,vt(ne),ue)},registerLinkedEditingRangeProvider(ne,ue){return ut.registerLinkedEditingRangeProvider(Oe,vt(ne),ue)},registerReferenceProvider(ne,ue){return ut.registerReferenceProvider(Oe,vt(ne),ue)},registerRenameProvider(ne,ue){return ut.registerRenameProvider(Oe,vt(ne),ue)},registerDocumentSymbolProvider(ne,ue,Re){return ut.registerDocumentSymbolProvider(Oe,vt(ne),ue,Re)},registerWorkspaceSymbolProvider(ne){return ut.registerWorkspaceSymbolProvider(Oe,ne)},registerDocumentFormattingEditProvider(ne,ue){return ut.registerDocumentFormattingEditProvider(Oe,vt(ne),ue)},registerDocumentRangeFormattingEditProvider(ne,ue){return ut.registerDocumentRangeFormattingEditProvider(Oe,vt(ne),ue)},registerOnTypeFormattingEditProvider(ne,ue,Re,...st){return ut.registerOnTypeFormattingEditProvider(Oe,vt(ne),ue,[Re].concat(st))},registerDocumentSemanticTokensProvider(ne,ue,Re){return ut.registerDocumentSemanticTokensProvider(Oe,vt(ne),ue,Re)},registerDocumentRangeSemanticTokensProvider(ne,ue,Re){return ut.registerDocumentRangeSemanticTokensProvider(Oe,vt(ne),ue,Re)},registerSignatureHelpProvider(ne,ue,Re,...st){return typeof Re=="object"?ut.registerSignatureHelpProvider(Oe,vt(ne),ue,Re):ut.registerSignatureHelpProvider(Oe,vt(ne),ue,typeof Re=="undefined"?[]:[Re,...st])},registerCompletionItemProvider(ne,ue,...Re){return ut.registerCompletionItemProvider(Oe,vt(ne),ue,Re)},registerInlineCompletionItemProvider(ne,ue){return(0,x.checkProposedApiEnabled)(Oe),ut.registerInlineCompletionsProvider(Oe,vt(ne),ue)},registerDocumentLinkProvider(ne,ue){return ut.registerDocumentLinkProvider(Oe,vt(ne),ue)},registerColorProvider(ne,ue){return ut.registerColorProvider(Oe,vt(ne),ue)},registerFoldingRangeProvider(ne,ue){return ut.registerFoldingRangeProvider(Oe,vt(ne),ue)},registerSelectionRangeProvider(ne,ue){return ut.registerSelectionRangeProvider(Oe,ne,ue)},registerCallHierarchyProvider(ne,ue){return ut.registerCallHierarchyProvider(Oe,ne,ue)},setLanguageConfiguration:(ne,ue)=>ut.setLanguageConfiguration(Oe,ne,ue),getTokenInformationAtPosition(ne,ue){return(0,x.checkProposedApiEnabled)(Oe),Tt.tokenAtPosition(ne,ue)},registerInlayHintsProvider(ne,ue){return(0,x.checkProposedApiEnabled)(Oe),ut.registerInlayHintsProvider(Oe,ne,ue)},registerTypeHierarchyProvider(ne,ue){return(0,x.checkProposedApiEnabled)(Oe),ut.registerTypeHierarchyProvider(Oe,ne,ue)}},Ln={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return Et.activeTerminal},get terminals(){return Et.terminals},async showTextDocument(ne,ue,Re){const st=await(T.URI.isUri(ne)?Promise.resolve(vn.openTextDocument(ne)):Promise.resolve(ne));return At.showTextDocument(st,ue,Re)},createTextEditorDecorationType(ne){return At.createTextEditorDecorationType(Oe,ne)},onDidChangeActiveTextEditor(ne,ue,Re){return At.onDidChangeActiveTextEditor(ne,ue,Re)},onDidChangeVisibleTextEditors(ne,ue,Re){return At.onDidChangeVisibleTextEditors(ne,ue,Re)},onDidChangeTextEditorSelection(ne,ue,Re){return At.onDidChangeTextEditorSelection(ne,ue,Re)},onDidChangeTextEditorOptions(ne,ue,Re){return At.onDidChangeTextEditorOptions(ne,ue,Re)},onDidChangeTextEditorVisibleRanges(ne,ue,Re){return At.onDidChangeTextEditorVisibleRanges(ne,ue,Re)},onDidChangeTextEditorViewColumn(ne,ue,Re){return At.onDidChangeTextEditorViewColumn(ne,ue,Re)},onDidCloseTerminal(ne,ue,Re){return Et.onDidCloseTerminal(ne,ue,Re)},onDidOpenTerminal(ne,ue,Re){return Et.onDidOpenTerminal(ne,ue,Re)},onDidChangeActiveTerminal(ne,ue,Re){return Et.onDidChangeActiveTerminal(ne,ue,Re)},onDidChangeTerminalDimensions(ne,ue,Re){return(0,x.checkProposedApiEnabled)(Oe),Et.onDidChangeTerminalDimensions(ne,ue,Re)},onDidWriteTerminalData(ne,ue,Re){return(0,x.checkProposedApiEnabled)(Oe),Et.onDidWriteTerminalData(ne,ue,Re)},get state(){return mt.state},onDidChangeWindowState(ne,ue,Re){return mt.onDidChangeWindowState(ne,ue,Re)},showInformationMessage(ne,...ue){return Bt.showMessage(Oe,S.default.Info,ne,ue[0],ue.slice(1))},showWarningMessage(ne,...ue){return Bt.showMessage(Oe,S.default.Warning,ne,ue[0],ue.slice(1))},showErrorMessage(ne,...ue){return Bt.showMessage(Oe,S.default.Error,ne,ue[0],ue.slice(1))},showQuickPick(ne,ue,Re){return xt.showQuickPick(ne,!!Oe.enableProposedApi,ue,Re)},showWorkspaceFolderPick(ne){return xt.showWorkspaceFolderPick(ne)},showInputBox(ne,ue){return xt.showInput(ne,ue)},showOpenDialog(ne){return Mt.showOpenDialog(ne)},showSaveDialog(ne){return Mt.showSaveDialog(ne)},createStatusBarItem(ne,ue,Re){let st,bt,Dt;return typeof ne=="string"?(st=ne,bt=ue,Dt=Re):(bt=ne,Dt=ue),fn.createStatusBarEntry(Oe,st,bt,Dt)},setStatusBarMessage(ne,ue){return fn.setStatusBarMessage(ne,ue)},withScmProgress(ne){return ct.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),dn.withProgress(Oe,{location:R.ProgressLocation.SourceControl},(ue,Re)=>ne({report(st){}}))},withProgress(ne,ue){return dn.withProgress(Oe,ne,ue)},createOutputChannel(ne){return Kt.createOutputChannel(ne,Oe)},createWebviewPanel(ne,ue,Re,st){return nn.createWebviewPanel(Oe,ne,ue,Re,st)},createWebviewTextEditorInset(ne,ue,Re,st){return(0,x.checkProposedApiEnabled)(Oe),Zt.createWebviewEditorInset(ne,ue,Re,st,Oe)},createTerminal(ne,ue,Re){return typeof ne=="object"?"pty"in ne?Et.createExtensionTerminal(ne):Et.createTerminalFromOptions(ne):Et.createTerminal(ne,ue,Re)},registerTerminalLinkProvider(ne){return Et.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,ue){return Et.registerProfileProvider(Oe,ne,ue)},registerTreeDataProvider(ne,ue){return qt.registerTreeDataProvider(ne,ue,Oe)},createTreeView(ne,ue){return qt.createTreeView(ne,ue,Oe)},registerWebviewPanelSerializer:(ne,ue)=>nn.registerWebviewPanelSerializer(Oe,ne,ue),registerCustomEditorProvider:(ne,ue,Re={})=>yn.registerCustomEditorProvider(Oe,ne,ue,Re),registerFileDecorationProvider(ne){return wt.registerFileDecorationProvider(ne,Oe.identifier)},registerUriHandler(ne){return Ut.registerUriHandler(Oe.identifier,ne)},createQuickPick(){return xt.createQuickPick(Oe.identifier,!!Oe.enableProposedApi)},createInputBox(){return xt.createInputBox(Oe.identifier)},get activeColorTheme(){return hn.activeColorTheme},onDidChangeActiveColorTheme(ne,ue,Re){return hn.onDidChangeActiveColorTheme(ne,ue,Re)},registerWebviewViewProvider(ne,ue,Re){return Dn.registerWebviewViewProvider(Oe,ne,ue,Re?.webviewOptions)},get activeNotebookEditor(){return(0,x.checkProposedApiEnabled)(Oe),pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,ue,Re){return(0,x.checkProposedApiEnabled)(Oe),pt.onDidChangeActiveNotebookEditor(ne,ue,Re)},get visibleNotebookEditors(){return(0,x.checkProposedApiEnabled)(Oe),pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,x.checkProposedApiEnabled)(Oe),pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,ue,Re){return(0,x.checkProposedApiEnabled)(Oe),zt.onDidChangeNotebookEditorSelection(ne,ue,Re)},onDidChangeNotebookEditorVisibleRanges(ne,ue,Re){return(0,x.checkProposedApiEnabled)(Oe),zt.onDidChangeNotebookEditorVisibleRanges(ne,ue,Re)},showNotebookDocument(ne,ue){return(0,x.checkProposedApiEnabled)(Oe),pt.showNotebookDocument(ne,ue)},registerExternalUriOpener(ne,ue,Re){return(0,x.checkProposedApiEnabled)(Oe),Cn.registerExternalUriOpener(Oe.identifier,ne,ue,Re)},get openEditors(){return(0,x.checkProposedApiEnabled)(Oe),yt.tabs},get onDidChangeOpenEditors(){return(0,x.checkProposedApiEnabled)(Oe),yt.onDidChangeTabs},getInlineCompletionItemController(ne){return(0,x.checkProposedApiEnabled)(Oe),f.InlineCompletionController.get(ne)}},vn={get rootPath(){return ct.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),at.getPath()},set rootPath(ne){throw L.readonly()},getWorkspaceFolder(ne){return at.getWorkspaceFolder(ne)},get workspaceFolders(){return at.getWorkspaceFolders()},get name(){return at.name},set name(ne){throw L.readonly()},get workspaceFile(){return at.workspaceFile},set workspaceFile(ne){throw L.readonly()},updateWorkspaceFolders:(ne,ue,...Re)=>at.updateWorkspaceFolders(Oe,ne,ue||0,...Re),onDidChangeWorkspaceFolders:function(ne,ue,Re){return at.onDidChangeWorkspace(ne,ue,Re)},asRelativePath:(ne,ue)=>at.getRelativePath(ne,ue),findFiles:(ne,ue,Re,st)=>at.findFiles(B.GlobPattern.from(ne),B.GlobPattern.from(ue),Re,Oe.identifier,st),findTextInFiles:(ne,ue,Re,st)=>{let bt,Dt;return typeof ue=="object"?(bt=ue,Dt=Re):(bt={},Dt=ue,st=Re),at.findTextInFiles(ne,bt||{},Dt,Oe.identifier,st)},saveAll:ne=>at.saveAll(ne),applyEdit(ne){return rn.applyWorkspaceEdit(ne)},createFileSystemWatcher:(ne,ue,Re,st)=>Rt.createFileSystemWatcher(B.GlobPattern.from(ne),ue,Re,st),get textDocuments(){return Ct.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw L.readonly()},openTextDocument(ne){let ue;const Re=ne;if(typeof ne=="string")ue=Promise.resolve(T.URI.file(ne));else if(T.URI.isUri(ne))ue=Promise.resolve(ne);else if(!Re||typeof Re=="object")ue=Ct.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(st=>Ct.ensureDocumentData(st).then(bt=>bt.document))},onDidOpenTextDocument:(ne,ue,Re)=>Ct.onDidAddDocument(ne,ue,Re),onDidCloseTextDocument:(ne,ue,Re)=>Ct.onDidRemoveDocument(ne,ue,Re),onDidChangeTextDocument:(ne,ue,Re)=>Ct.onDidChangeDocument(ne,ue,Re),onDidSaveTextDocument:(ne,ue,Re)=>Ct.onDidSaveDocument(ne,ue,Re),onWillSaveTextDocument:(ne,ue,Re)=>Xt.getOnWillSaveTextDocumentEvent(Oe)(ne,ue,Re),get notebookDocuments(){return pt.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,ue){let Re;if(T.URI.isUri(ne))Re=ne,await pt.openNotebookDocument(ne);else if(typeof ne=="string")Re=T.URI.revive(await pt.createNotebookDocument({viewType:ne,content:ue}));else throw new Error("Invalid arguments");return pt.getNotebookDocument(Re).apiNotebook},get onDidOpenNotebookDocument(){return pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return pt.onDidCloseNotebookDocument},registerNotebookSerializer(ne,ue,Re,st){return pt.registerNotebookSerializer(Oe,ne,ue,Re,Oe.enableProposedApi?st:void 0)},registerNotebookContentProvider:(ne,ue,Re,st)=>((0,x.checkProposedApiEnabled)(Oe),pt.registerNotebookContentProvider(Oe,ne,ue,Re,Oe.enableProposedApi?st:void 0)),onDidChangeConfiguration:(ne,ue,Re)=>mn.onDidChangeConfiguration(ne,ue,Re),getConfiguration(ne,ue){return ue=arguments.length===1?void 0:ue,mn.getConfiguration(ne,ue,Oe)},registerTextDocumentContentProvider(ne,ue){return Qt.registerTextDocumentContentProvider(ne,ue)},registerTaskProvider:(ne,ue)=>(ct.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),Pt.registerTaskProvider(Oe,ne,ue)),registerFileSystemProvider(ne,ue,Re){return En.registerFileSystemProvider(Oe.identifier,ne,ue,Re,Oe.enableProposedApi)},get fs(){return dt.value},registerFileSearchProvider:(ne,ue)=>((0,x.checkProposedApiEnabled)(Oe),Nt.registerFileSearchProvider(ne,ue)),registerTextSearchProvider:(ne,ue)=>((0,x.checkProposedApiEnabled)(Oe),Nt.registerTextSearchProvider(ne,ue)),registerRemoteAuthorityResolver:(ne,ue)=>((0,x.checkProposedApiEnabled)(Oe),_t.registerRemoteAuthorityResolver(ne,ue)),registerResourceLabelFormatter:ne=>((0,x.checkProposedApiEnabled)(Oe),Sn.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,ue,Re)=>Rt.onDidCreateFile(ne,ue,Re),onDidDeleteFiles:(ne,ue,Re)=>Rt.onDidDeleteFile(ne,ue,Re),onDidRenameFiles:(ne,ue,Re)=>Rt.onDidRenameFile(ne,ue,Re),onWillCreateFiles:(ne,ue,Re)=>Rt.getOnWillCreateFileEvent(Oe)(ne,ue,Re),onWillDeleteFiles:(ne,ue,Re)=>Rt.getOnWillDeleteFileEvent(Oe)(ne,ue,Re),onWillRenameFiles:(ne,ue,Re)=>Rt.getOnWillRenameFileEvent(Oe)(ne,ue,Re),openTunnel:ne=>((0,x.checkProposedApiEnabled)(Oe),Ke.openTunnel(Oe,ne).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,x.checkProposedApiEnabled)(Oe),Ke.getTunnels()},onDidChangeTunnels:(ne,ue,Re)=>((0,x.checkProposedApiEnabled)(Oe),Ke.onDidChangeTunnels(ne,ue,Re)),registerPortAttributesProvider:(ne,ue)=>((0,x.checkProposedApiEnabled)(Oe),Ke.registerPortsAttributesProvider(ne,ue)),registerTimelineProvider:(ne,ue)=>((0,x.checkProposedApiEnabled)(Oe),en.registerTimelineProvider(ne,ue,Oe.identifier,ht.converter)),get isTrusted(){return at.trusted},requestWorkspaceTrust:ne=>((0,x.checkProposedApiEnabled)(Oe),at.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,ue,Re)=>at.onDidGrantWorkspaceTrust(ne,ue,Re)},Fn={get inputBox(){return ct.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),un.getLastInputBox(Oe)},createSourceControl(ne,ue,Re){return un.createSourceControl(Oe,ne,ue,Re)}},Mn={createCommentController(ne,ue){return _n.createCommentController(Oe,ne,ue)}},wn={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},onDidStartDebugSession(ne,ue,Re){return ft.onDidStartDebugSession(ne,ue,Re)},onDidTerminateDebugSession(ne,ue,Re){return ft.onDidTerminateDebugSession(ne,ue,Re)},onDidChangeActiveDebugSession(ne,ue,Re){return ft.onDidChangeActiveDebugSession(ne,ue,Re)},onDidReceiveDebugSessionCustomEvent(ne,ue,Re){return ft.onDidReceiveDebugSessionCustomEvent(ne,ue,Re)},onDidChangeBreakpoints(ne,ue,Re){return ft.onDidChangeBreakpoints(ne,ue,Re)},registerDebugConfigurationProvider(ne,ue,Re){return ft.registerDebugConfigurationProvider(ne,ue,Re||R.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,ue){return ft.registerDebugAdapterDescriptorFactory(Oe,ne,ue)},registerDebugAdapterTrackerFactory(ne,ue){return ft.registerDebugAdapterTrackerFactory(ne,ue)},startDebugging(ne,ue,Re){return!Re||typeof Re=="object"&&"configuration"in Re?ft.startDebugging(ne,ue,{parentSession:Re}):ft.startDebugging(ne,ue,Re||{})},stopDebugging(ne){return ft.stopDebugging(ne)},addBreakpoints(ne){return ft.addBreakpoints(ne)},removeBreakpoints(ne){return ft.removeBreakpoints(ne)},asDebugSourceUri(ne,ue){return ft.asDebugSourceUri(ne,ue)}},On={registerTaskProvider:(ne,ue)=>Pt.registerTaskProvider(Oe,ne,ue),fetchTasks:ne=>Pt.fetchTasks(ne),executeTask:ne=>Pt.executeTask(Oe,ne),get taskExecutions(){return Pt.taskExecutions},onDidStartTask:(ne,ue,Re)=>Pt.onDidStartTask(ne,ue,Re),onDidEndTask:(ne,ue,Re)=>Pt.onDidEndTask(ne,ue,Re),onDidStartTaskProcess:(ne,ue,Re)=>Pt.onDidStartTaskProcess(ne,ue,Re),onDidEndTaskProcess:(ne,ue,Re)=>Pt.onDidEndTaskProcess(ne,ue,Re)},an={createNotebookController(ne,ue,Re,st,bt){return Yt.createNotebookController(Oe,ne,ue,Re,st,Oe.enableProposedApi?bt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,ue)=>pt.registerNotebookCellStatusBarItemProvider(Oe,ne,ue),get onDidSaveNotebookDocument(){return(0,x.checkProposedApiEnabled)(Oe),jt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ne){return(0,x.checkProposedApiEnabled)(Oe),zt.createNotebookEditorDecorationType(ne)},createRendererMessaging(ne){return(0,x.checkProposedApiEnabled)(Oe),Jt.createRendererMessaging(ne)},onDidChangeNotebookDocumentMetadata(ne,ue,Re){return(0,x.checkProposedApiEnabled)(Oe),jt.onDidChangeNotebookDocumentMetadata(ne,ue,Re)},onDidChangeNotebookCells(ne,ue,Re){return(0,x.checkProposedApiEnabled)(Oe),pt.onDidChangeNotebookCells(ne,ue,Re)},onDidChangeNotebookCellExecutionState(ne,ue,Re){return(0,x.checkProposedApiEnabled)(Oe),pt.onDidChangeNotebookCellExecutionState(ne,ue,Re)},onDidChangeCellOutputs(ne,ue,Re){return(0,x.checkProposedApiEnabled)(Oe),pt.onDidChangeCellOutputs(ne,ue,Re)},onDidChangeCellMetadata(ne,ue,Re){return(0,x.checkProposedApiEnabled)(Oe),pt.onDidChangeCellMetadata(ne,ue,Re)},createConcatTextDocument(ne,ue){return(0,x.checkProposedApiEnabled)(Oe),new _e.ExtHostNotebookConcatDocument(pt,Ct,ne,ue)}};return{version:Xe.version,authentication:Pn,commands:An,comments:Mn,debug:wn,env:gn,extensions:Tn,languages:Rn,notebooks:an,scm:Fn,tasks:On,test:on,window:Ln,workspace:vn,Breakpoint:R.Breakpoint,CallHierarchyIncomingCall:R.CallHierarchyIncomingCall,CallHierarchyItem:R.CallHierarchyItem,CallHierarchyOutgoingCall:R.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:p.CancellationTokenSource,CandidatePortSource:c.CandidatePortSource,CodeAction:R.CodeAction,CodeActionKind:R.CodeActionKind,CodeActionTriggerKind:R.CodeActionTriggerKind,CodeLens:R.CodeLens,Color:R.Color,ColorInformation:R.ColorInformation,ColorPresentation:R.ColorPresentation,ColorThemeKind:R.ColorThemeKind,CommentMode:R.CommentMode,CommentThreadCollapsibleState:R.CommentThreadCollapsibleState,CompletionItem:R.CompletionItem,CompletionItemKind:R.CompletionItemKind,CompletionItemTag:R.CompletionItemTag,CompletionList:R.CompletionList,CompletionTriggerKind:R.CompletionTriggerKind,ConfigurationTarget:R.ConfigurationTarget,CustomExecution:R.CustomExecution,DebugAdapterExecutable:R.DebugAdapterExecutable,DebugAdapterInlineImplementation:R.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:R.DebugAdapterNamedPipeServer,DebugAdapterServer:R.DebugAdapterServer,DebugConfigurationProviderTriggerKind:R.DebugConfigurationProviderTriggerKind,DebugConsoleMode:R.DebugConsoleMode,DecorationRangeBehavior:R.DecorationRangeBehavior,Diagnostic:R.Diagnostic,DiagnosticRelatedInformation:R.DiagnosticRelatedInformation,DiagnosticSeverity:R.DiagnosticSeverity,DiagnosticTag:R.DiagnosticTag,Disposable:R.Disposable,DocumentHighlight:R.DocumentHighlight,DocumentHighlightKind:R.DocumentHighlightKind,DocumentLink:R.DocumentLink,DocumentSymbol:R.DocumentSymbol,EndOfLine:R.EndOfLine,EnvironmentVariableMutatorType:R.EnvironmentVariableMutatorType,EvaluatableExpression:R.EvaluatableExpression,InlineValueText:R.InlineValueText,InlineValueVariableLookup:R.InlineValueVariableLookup,InlineValueEvaluatableExpression:R.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:R.InlineCompletionTriggerKind,EventEmitter:C.Emitter,ExtensionKind:R.ExtensionKind,ExtensionMode:R.ExtensionMode,ExternalUriOpenerPriority:R.ExternalUriOpenerPriority,FileChangeType:R.FileChangeType,FileDecoration:R.FileDecoration,FileSystemError:R.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:R.FoldingRange,FoldingRangeKind:R.FoldingRangeKind,FunctionBreakpoint:R.FunctionBreakpoint,InlineCompletionItem:R.InlineSuggestion,InlineCompletionList:R.InlineSuggestions,Hover:R.Hover,IndentAction:A.IndentAction,Location:R.Location,MarkdownString:R.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:R.ParameterInformation,PortAutoForwardAction:R.PortAutoForwardAction,Position:R.Position,ProcessExecution:R.ProcessExecution,ProgressLocation:R.ProgressLocation,QuickInputButtons:R.QuickInputButtons,Range:R.Range,RelativePattern:R.RelativePattern,Selection:R.Selection,SelectionRange:R.SelectionRange,SemanticTokens:R.SemanticTokens,SemanticTokensBuilder:R.SemanticTokensBuilder,SemanticTokensEdit:R.SemanticTokensEdit,SemanticTokensEdits:R.SemanticTokensEdits,SemanticTokensLegend:R.SemanticTokensLegend,ShellExecution:R.ShellExecution,ShellQuoting:R.ShellQuoting,SignatureHelp:R.SignatureHelp,SignatureHelpTriggerKind:R.SignatureHelpTriggerKind,SignatureInformation:R.SignatureInformation,SnippetString:R.SnippetString,SourceBreakpoint:R.SourceBreakpoint,StandardTokenType:R.StandardTokenType,StatusBarAlignment:R.StatusBarAlignment,SymbolInformation:R.SymbolInformation,SymbolKind:R.SymbolKind,SymbolTag:R.SymbolTag,Task:R.Task,TaskGroup:R.TaskGroup,TaskPanelKind:R.TaskPanelKind,TaskRevealKind:R.TaskRevealKind,TaskScope:R.TaskScope,TerminalLink:R.TerminalLink,TerminalProfile:R.TerminalProfile,TextDocumentSaveReason:R.TextDocumentSaveReason,TextEdit:R.TextEdit,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:R.TextEditorLineNumbersStyle,TextEditorRevealType:R.TextEditorRevealType,TextEditorSelectionChangeKind:R.TextEditorSelectionChangeKind,TextDocumentChangeReason:R.TextDocumentChangeReason,ThemeColor:R.ThemeColor,ThemeIcon:R.ThemeIcon,TreeItem:R.TreeItem,TreeItemCollapsibleState:R.TreeItemCollapsibleState,TypeHierarchyItem:R.TypeHierarchyItem,UIKind:c.UIKind,Uri:T.URI,ViewColumn:R.ViewColumn,WorkspaceEdit:R.WorkspaceEdit,InlayHint:R.InlayHint,InlayHintKind:R.InlayHintKind,RemoteAuthorityResolverError:R.RemoteAuthorityResolverError,ResolvedAuthority:R.ResolvedAuthority,SourceControlInputBoxValidationType:R.SourceControlInputBoxValidationType,ExtensionRuntime:R.ExtensionRuntime,TimelineItem:R.TimelineItem,NotebookRange:R.NotebookRange,NotebookCellKind:R.NotebookCellKind,NotebookCellExecutionState:R.NotebookCellExecutionState,NotebookCellData:R.NotebookCellData,NotebookData:R.NotebookData,NotebookRendererScript:R.NotebookRendererScript,NotebookCellStatusBarAlignment:R.NotebookCellStatusBarAlignment,NotebookEditorRevealType:R.NotebookEditorRevealType,NotebookCellOutput:R.NotebookCellOutput,NotebookCellOutputItem:R.NotebookCellOutputItem,NotebookCellStatusBarItem:R.NotebookCellStatusBarItem,NotebookControllerAffinity:R.NotebookControllerAffinity,PortAttributes:R.PortAttributes,LinkedEditingRanges:R.LinkedEditingRanges,TestResultState:R.TestResultState,TestRunRequest:R.TestRunRequest,TestMessage:R.TestMessage,TestRunConfigurationGroup:R.TestRunConfigurationGroup,TextSearchCompleteMessageType:Ee.TextSearchCompleteMessageType,TestMessageSeverity:R.TestMessageSeverity,CoveredCount:R.CoveredCount,FileCoverage:R.FileCoverage,StatementCoverage:R.StatementCoverage,BranchCoverage:R.BranchCoverage,FunctionCoverage:R.FunctionCoverage,WorkspaceTrustState:R.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=et}),define(me[268],ge([0,1,78,62,35,128,36,50,43,33,66,51,68,90,49,61,129,89,59,88,119,48]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a,g,w,_,b,d,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,p.registerSingleton)(g.IExtHostApiDeprecationService,g.ExtHostApiDeprecationService),(0,p.registerSingleton)(I.IExtHostCommands,I.ExtHostCommands),(0,p.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration),(0,p.registerSingleton)(_.IExtHostConsumerFileSystem,_.ExtHostConsumerFileSystem),(0,p.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService),(0,p.registerSingleton)(S.IExtHostDecorations,S.ExtHostDecorations),(0,p.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,p.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo),(0,p.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService),(0,p.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch),(0,p.registerSingleton)(u.IExtHostStorage,u.ExtHostStorage),(0,p.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,p.registerSingleton)(A.IExtHostTerminalService,A.WorkerExtHostTerminalService),(0,p.registerSingleton)(a.IExtHostTunnelService,a.ExtHostTunnelService),(0,p.registerSingleton)(w.IExtHostWindow,w.ExtHostWindow),(0,p.registerSingleton)(C.IExtHostWorkspace,C.ExtHostWorkspace),(0,p.registerSingleton)(d.IExtHostSecretState,d.ExtHostSecretState),(0,p.registerSingleton)(h.IExtHostTelemetry,h.ExtHostTelemetry),(0,p.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs)}),define(me[91],ge([0,1,18,12,31,65]),function(J,e,p,L,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function T(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=T;function I(P,c,u,a){const g=(0,p.mapArrayOrNot)(u,D),w=new C.TextSearchMatch(c,g,a),_=w.preview.matches;return{ranges:(0,p.mapArrayOrNot)(g,A),uri:P,preview:{text:w.preview.text,matches:(0,p.mapArrayOrNot)(_,A)}}}e.createTextSearchResult=I;function D(P){return new C.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function A(P){return new S.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let i=class{constructor(c,u){this.prefix=c,this.logService=u}appendLine(c){this.logService.debug(`${this.prefix}#search`,c)}};i=Ve([He(1,L.ILogService)],i),e.OutputChannel=i}),define(me[269],ge([0,1,93,22]),function(J,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function C(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(s=>s===t)}e.isUTFEncoding=C,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const S=512,T=512,I=512*8,D=512*128;class A{constructor(s){this.iconvLiteDecoder=s}static async create(s){let r;if(s!==e.UTF8)r=(await new Promise((l,f)=>{J(["iconv-lite-umd"],l,f)})).getDecoder(u(s));else{const n=new TextDecoder;r={write(l){return n.decode(l,{stream:!0})},end(){return n.decode()}}}return new A(r)}write(s){return this.iconvLiteDecoder.write(s)}end(){return this.iconvLiteDecoder.end()}}function i(t,s){const r=s.minBytesRequiredForDetection??s.guessEncoding?I:T;return new Promise((n,l)=>{const f=(0,p.newWriteableStream)(k=>k.join("")),m=[];let E=0,y;const o=async()=>{try{const k=await v({buffer:L.VSBuffer.concat(m),bytesRead:E},s.guessEncoding);k.encoding=await s.overwriteEncoding(k.encoding),y=await A.create(k.encoding);const F=y.write(L.VSBuffer.concat(m).buffer);f.write(F),m.length=0,E=0,n({stream:f,detected:k})}catch(k){l(k)}};(0,p.listenStream)(t,{onData:async k=>{y?f.write(y.write(k.buffer)):(m.push(k),E+=k.byteLength,E>=r&&(t.pause(),await o(),setTimeout(()=>t.resume())))},onError:k=>f.error(k),onEnd:async()=>{y||await o(),f.end(y?.end())}})})}e.toDecodeStream=i;async function P(t,s,r){const l=(await new Promise((E,y)=>{J(["iconv-lite-umd"],E,y)})).getEncoder(u(s),r);let f=!1,m=!1;return{read(){if(m)return null;const E=t.read();if(typeof E!="string"){if(m=!0,!f&&r?.addBOM)switch(s){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const y=l.end();return y&&y.length>0?(f=!0,L.VSBuffer.wrap(y)):null}return f=!0,L.VSBuffer.wrap(l.write(E))}}}e.toEncodeReadable=P;async function c(t){return(await new Promise((r,n)=>{J(["iconv-lite-umd"],r,n)})).encodingExists(u(t))}e.encodingExists=c;function u(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=u;function a(t,s){if(!t||s<e.UTF16be_BOM.length)return null;const r=t.readUInt8(0),n=t.readUInt8(1);if(r===e.UTF16be_BOM[0]&&n===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&n===e.UTF16le_BOM[1])return e.UTF16le;if(s<e.UTF8_BOM.length)return null;const l=t.readUInt8(2);return r===e.UTF8_BOM[0]&&n===e.UTF8_BOM[1]&&l===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=a;const g=["ascii","utf-16","utf-32"];async function w(t){const s=await new Promise((m,E)=>{J(["jschardet"],m,E)}),r=t.slice(0,D),n=d(r.buffer),l=s.detect(n);if(!l||!l.encoding)return null;const f=l.encoding.toLowerCase();return 0<=g.indexOf(f)?null:b(l.encoding)}const _={ibm866:"cp866",big5:"cp950"};function b(t){const s=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return _[s]||s}function d(t){let s="";for(let r=0;r<t.length;r++)s+=String.fromCharCode(t[r]);return s}function h(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const s=t.match(/windows(\d+)/);return s?"windows-"+s[1]:t}}e.toCanonicalName=h;function v({buffer:t,bytesRead:s},r){let n=a(t,s),l=!1;if(n!==e.UTF16be&&n!==e.UTF16le&&t){let f=!0,m=!0,E=!1;for(let y=0;y<s&&y<S;y++){const o=y%2==1,k=t.readUInt8(y)===0;if(k&&(E=!0),f&&(o&&!k||!o&&k)&&(f=!1),m&&(o&&k||!o&&!k)&&(m=!1),k&&!f&&!m)break}E&&(f?n=e.UTF16le:m?n=e.UTF16be:l=!0)}return r&&!l&&!n&&t?w(t.slice(0,s)).then(f=>({seemsBinary:!1,encoding:f})):{seemsBinary:l,encoding:n}}e.detectEncodingFromBuffer=v,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[131],ge([0,1,269,28,130]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class S extends C.TextSearchManager{constructor(I,D,A=L){super(I,D,{readdir:i=>A.Promises.readdir(i.fsPath),toCanonicalName:i=>(0,p.toCanonicalName)(i)})}}e.NativeTextSearchManager=S}),define(me[270],ge([0,1,271,286,287,2,288]),function(J,e,p,L,C,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function I(P,c,u,a,g,w){const _=w.environment.useHostProxy,b=typeof _=="boolean"?_:!w.remote.isRemote,d=(0,T.createProxyResolver)({resolveProxy:v=>P.resolveProxy(v),getHttpProxySetting:()=>c.getConfiguration("http").get("proxy"),log:(v,t,...s)=>{switch(v){case T.LogLevel.Trace:a.trace(t,...s);break;case T.LogLevel.Debug:a.debug(t,...s);break;case T.LogLevel.Info:a.info(t,...s);break;case T.LogLevel.Warning:a.warn(t,...s);break;case T.LogLevel.Error:a.error(t,...s);break;case T.LogLevel.Critical:a.critical(t,...s);break;case T.LogLevel.Off:break;default:r(v,t,s);break}function r(n,l,...f){a.error("Unknown log level",n),a.error(l,...f)}},getLogLevel:()=>a.getLevel(),proxyResolveTelemetry:v=>{g.$publicLog2("resolveProxy",v)},useHostProxy:b,env:process.env}),h=D(c,d);return i(u,h)}e.connectProxyResolver=I;function D(P,c){const u={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(g=>{u.config=P.getConfiguration("http").get("proxySupport")||"off"});const a={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(g=>{a.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},p,(0,T.createHttpPatch)(p,c,{config:"off"},a,!0)),on:Object.assign({},p,(0,T.createHttpPatch)(p,c,{config:"on"},a,!0)),override:Object.assign({},p,(0,T.createHttpPatch)(p,c,{config:"override"},a,!0)),onRequest:Object.assign({},p,(0,T.createHttpPatch)(p,c,u,a,!0)),default:Object.assign(p,(0,T.createHttpPatch)(p,c,u,a,!1))},https:{off:Object.assign({},L,(0,T.createHttpPatch)(L,c,{config:"off"},a,!0)),on:Object.assign({},L,(0,T.createHttpPatch)(L,c,{config:"on"},a,!0)),override:Object.assign({},L,(0,T.createHttpPatch)(L,c,{config:"override"},a,!0)),onRequest:Object.assign({},L,(0,T.createHttpPatch)(L,c,u,a,!0)),default:Object.assign(L,(0,T.createHttpPatch)(L,c,u,a,!1))},tls:Object.assign(C,(0,T.createTlsPatch)(C))}}const A=new Map;function i(P,c){return P.getExtensionPathIndex().then(u=>{const a=J.__$__nodeRequire("module"),g=a._load;a._load=function(_,b,d){if(_==="tls")return c.tls;if(_!=="http"&&_!=="https")return g.apply(this,arguments);const h=c[_],v=u.findSubstr(S.URI.file(b.filename).fsPath);let t=A.get(v);if(t||A.set(v,t={}),!t[_]){let s=h.default;v&&v.enableProposedApi&&(s=h[v.proxySupport]||h.onRequest),t[_]={...s}}return t[_]}})}}),define(me[272],ge([0,1,38,9,75,29,11,8,91,273]),function(J,e,p,L,C,S,T,I,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const i=A.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(d,h,v,t){const s=c(d,h,v,t),r=h.folder.fsPath;return{cmd:p.spawn(i,s.args,{cwd:r}),rgDiskPath:i,siblingClauses:s.siblingClauses,rgArgs:s,cwd:r}}e.spawnRipgrepCmd=P;function c(d,h,v,t){const s=["--files","--hidden","--case-sensitive"];a([h],v,!1).forEach(n=>{const l=(0,D.anchorGlob)(n);if(s.push("-g",l),T.isMacintosh){const f=(0,C.normalizeNFD)(l);f!==l&&s.push("-g",f)}});const r=u([h],t,void 0,!1);return r.globArgs.forEach(n=>{const l=`!${(0,D.anchorGlob)(n)}`;if(s.push("-g",l),T.isMacintosh){const f=(0,C.normalizeNFD)(l);f!==l&&s.push("-g",f)}}),h.disregardIgnoreFiles!==!1?s.push("--no-ignore"):s.push("--no-ignore-parent"),h.ignoreSymlinks||s.push("--follow"),d.exists&&s.push("--quiet"),s.push("--no-config"),h.disregardGlobalIgnoreFiles&&s.push("--no-ignore-global"),{args:s,siblingClauses:r.siblingClauses}}function u(d,h,v,t=!0){const s=[];let r={};return d.forEach(n=>{const l=Object.assign({},n.excludePattern||{},h||{}),f=g(l,t?n.folder.fsPath:void 0,v);s.push(...f.globArgs),f.siblingClauses&&(r=Object.assign(r,f.siblingClauses))}),{globArgs:s,siblingClauses:r}}e.foldersToRgExcludeGlobs=u;function a(d,h,v=!0){const t=[];return d.forEach(s=>{const r=Object.assign({},h||{},s.includePattern||{}),n=g(r,v?s.folder.fsPath:void 0);t.push(...n.globArgs)}),t}e.foldersToIncludeGlobs=a;function g(d,h,v){const t=[],s={};return Object.keys(d).forEach(r=>{if(v&&v.has(r)||!r)return;const n=d[r];r=_(h?w(h,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof n=="boolean"&&n?(r.startsWith("\\\\")&&(r+="**"),t.push(b(r))):n&&n.when&&(s[r]=n)}),{globArgs:t,siblingClauses:s}}function w(d,h){return L.isAbsolute(h)?h:L.join(d,h)}e.getAbsoluteGlob=w;function _(d){return d=I.rtrim(d,"\\"),I.rtrim(d,"/")}function b(d){return S.getRoot(d).toLowerCase()==="c:/"?d.replace(/^c:[/\\]/i,"/"):d}e.fixDriveC=b}),define(me[274],ge([0,1,38,45,9,101,18,58,30,75,29,11,44,8,14,28,31,272,98]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a,g,w,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const d=new Set;process.on("exit",()=>{d.forEach(r=>r())});class h{constructor(n){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=n,this.filePattern=n.filePattern||"",this.includePattern=n.includePattern&&D.parse(n.includePattern),this.maxResults=n.maxResults||null,this.exists=!!n.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,b.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=n.excludePattern&&D.parse(n.excludePattern),this.folderExcludePatterns=new Map,n.folderQueries.forEach(l=>{const f=Object.assign({},l.excludePattern||{},this.config.excludePattern||{}),m=l.folder.fsPath;n.folderQueries.map(E=>E.folder.fsPath).filter(E=>E!==m).forEach(E=>{(0,i.isEqualOrParent)(E,m)&&(f[C.relative(m,E)]=!0)}),this.folderExcludePatterns.set(m,new t(f,m))})}cancel(){this.isCanceled=!0}walk(n,l,f,m,E){if(this.fileWalkSW=c.StopWatch.create(!1),this.isCanceled)return E(null,this.isLimitHit);l.forEach(y=>{const o=C.basename(y.fsPath);this.globalExcludePattern&&this.globalExcludePattern(y.fsPath,o)||this.matchFile(f,{relativePath:y.fsPath,searchPath:void 0})}),this.cmdSW=c.StopWatch.create(!1),this.parallel(n,(y,o)=>{this.call(this.cmdTraversal,this,y,f,m,k=>{if(k){const F=(0,I.toErrorMessage)(k);console.error(F),this.errors.push(F),o(k,void 0)}else o(null,void 0)})},(y,o)=>{this.fileWalkSW.stop();const k=y?T.coalesce(y)[0]:null;E(k,this.isLimitHit)})}parallel(n,l,f){const m=new Array(n.length),E=new Array(n.length);let y=!1,o=0;if(n.length===0)return f(null,[]);n.forEach((k,F)=>{l(k,($,Q)=>{if($?(y=!0,m[F]=null,E[F]=$):(m[F]=Q,E[F]=null),++o===n.length)return f(y?E:null,m)})})}call(n,l,...f){try{n.apply(l,f)}catch(m){f[f.length-1](m)}}cmdTraversal(n,l,f,m){const E=n.folder.fsPath,y=P.isMacintosh;let o;const k=()=>o&&o.kill();d.add(k);let F=R=>{d.delete(k),F=()=>{},m(R)},$="";const Q=this.initDirectoryTree();let oe;const j=(0,_.spawnRipgrepCmd)(this.config,n,this.config.includePattern,this.folderExcludePatterns.get(n.folder.fsPath).expression);o=j.cmd,oe=!Object.keys(j.siblingClauses).length;const O=j.rgArgs.args.map(R=>R.match(/^-/)?R:`'${R}'`).join(" ");let B=`${j.rgDiskPath} ${O}
 - cwd: ${j.cwd}`;j.rgArgs.siblingClauses&&(B+=`
 - Sibling clauses: ${JSON.stringify(j.rgArgs.siblingClauses)}`),f({message:B}),this.cmdResultCount=0,this.collectStdout(o,"utf8",f,(R,z,N)=>{if(R){F(R);return}if(this.isLimitHit){F();return}const q=($+(y?A.normalizeNFC(z||""):z)).split(`
`);if(N){const x=q.length;q[x-1]=q[x-1].trim(),q[x-1]||q.pop()}else $=q.pop()||"";if(q.length&&q[0].indexOf(`
`)!==-1){F(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=q.length,oe){for(const x of q)if(this.matchFile(l,{base:E,relativePath:x,searchPath:this.getSearchPath(n,x)}),this.isLimitHit){k();break}(N||this.isLimitHit)&&F();return}this.addDirectoryEntries(n,Q,E,q,l),N&&(this.matchDirectoryTree(Q,E,l),F())})}spawnFindCmd(n){const l=this.folderExcludePatterns.get(n.folder.fsPath),f=l.getBasenameTerms(),m=l.getPathTerms(),E=["-L","."];if(f.length||m.length){E.push("-not","(","(");for(const y of f)E.push("-name",y),E.push("-o");for(const y of m)E.push("-path",y),E.push("-o");E.pop(),E.push(")","-prune",")")}return E.push("-type","f"),p.spawn("find",E,{cwd:n.folder.fsPath})}readStdout(n,l,f){let m="";this.collectStdout(n,l,()=>{},(E,y,o)=>{if(E){f(E);return}m+=y,o&&f(null,m)})}collectStdout(n,l,f,m){let E=(k,F,$)=>{(k||$)&&(E=()=>{},this.cmdSW&&this.cmdSW.stop()),m(k,F,$)},y=!1;n.stdout?(this.forwardData(n.stdout,l,E),n.stdout.once("data",()=>y=!0)):f({message:"stdout is null"});let o;n.stderr?o=this.collectData(n.stderr):f({message:"stderr is null"}),n.on("error",k=>{E(k)}),n.on("close",k=>{let F;!y&&(F=this.decodeData(o,l))&&s(F)?E(new Error(`command failed with error code ${k}: ${this.decodeData(o,l)}`)):(this.exists&&k===0&&(this.isLimitHit=!0),E(null,"",!0))})}forwardData(n,l,f){const m=new S.StringDecoder(l);return n.on("data",E=>{f(null,m.write(E))}),m}collectData(n){const l=[];return n.on("data",f=>{l.push(f)}),l}decodeData(n,l){const f=new S.StringDecoder(l);return n.map(m=>f.write(m)).join("")}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries(n,{pathToEntries:l},f,m,E){m.indexOf(this.filePattern)!==-1&&this.matchFile(E,{base:f,relativePath:this.filePattern,searchPath:this.getSearchPath(n,this.filePattern)});const y=o=>{const k=C.basename(o),F=C.dirname(o);let $=l[F];$||($=l[F]=[],y(F)),$.push({base:f,relativePath:o,basename:k,searchPath:this.getSearchPath(n,o)})};m.forEach(y)}matchDirectoryTree({rootEntries:n,pathToEntries:l},f,m){const E=this,y=this.folderExcludePatterns.get(f),o=this.filePattern;function k(F){E.directoriesWalked++;const $=D.hasSiblingFn(()=>F.map(Q=>Q.basename));for(let Q=0,oe=F.length;Q<oe;Q++){const j=F[Q],{relativePath:O,basename:B}=j;if(y.test(O,B,o!==B?$:void 0))continue;const R=l[O];if(R)k(R);else{if(E.filesWalked++,O===o)continue;E.matchFile(m,j)}if(E.isLimitHit)break}}k(n)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(n,l,f,m,E){const y=n.folder,o=D.hasSiblingFn(()=>f);this.parallel(f,(k,F)=>{if(this.isCanceled||this.isLimitHit)return F(null);const $=l?[l,k].join(C.sep):k;if(this.folderExcludePatterns.get(n.folder.fsPath).test($,k,this.config.filePattern!==k?o:void 0))return F(null);const Q=[y.fsPath,$].join(C.sep);L.lstat(Q,(oe,j)=>{if(oe||this.isCanceled||this.isLimitHit)return F(null);this.statLinkIfNeeded(Q,j,(O,B)=>O||this.isCanceled||this.isLimitHit?F(null):B.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(Q,j,(R,z)=>R||this.isCanceled||this.isLimitHit||(z=z||"",this.walkedPaths[z])?F(null):(this.walkedPaths[z]=!0,g.Promises.readdir(Q).then(N=>{if(this.isCanceled||this.isLimitHit)return F(null);this.doWalk(n,$,N,m,M=>F(M||null))},N=>{F(null)})))):(this.filesWalked++,$===this.filePattern||this.maxFilesize&&a.isNumber(B.size)&&B.size>this.maxFilesize||this.matchFile(m,{base:y.fsPath,relativePath:$,searchPath:this.getSearchPath(n,$)}),F(null,void 0)))})},k=>{const F=k&&T.coalesce(k);return E(F&&F.length>0?F[0]:void 0)})}matchFile(n,l){this.isFileMatch(l)&&(!this.includePattern||this.includePattern(l.relativePath,C.basename(l.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||n(l))}isFileMatch(n){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,w.isFilePatternMatch)(n,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(n,l,f){return l.isSymbolicLink()?L.stat(n,f):f(null,l)}realPathIfNeeded(n,l,f){return l.isSymbolicLink()?L.realpath(n,(m,E)=>m?f(m):f(null,E)):f(null,n)}getSearchPath(n,l){return n.folderName?C.join(n.folderName,l):l}}e.FileWalker=h;class v{constructor(n){this.folderQueries=n.folderQueries,this.extraFiles=n.extraFileResources||[],this.walker=new h(n)}search(n,l,f){this.walker.walk(this.folderQueries,this.extraFiles,n,l,(m,E)=>{f(m,{limitHit:E,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=v;class t{constructor(n,l){this.expression=n,this.root=l,this.init(n)}init(n){let l,f;Object.keys(n).filter(m=>n[m]).forEach(m=>{C.isAbsolute(m)?(l=l||D.getEmptyExpression(),l[m]=n[m]):(f=f||D.getEmptyExpression(),f[m]=n[m])}),this.absoluteParsedExpr=l&&D.parse(l,{trimForExclusions:!0}),this.relativeParsedExpr=f&&D.parse(f,{trimForExclusions:!0})}test(n,l,f){return this.relativeParsedExpr&&this.relativeParsedExpr(n,l,f)||this.absoluteParsedExpr&&this.absoluteParsedExpr(C.join(this.root,n),l,f)}getBasenameTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...D.getBasenameTerms(this.relativeParsedExpr)),n}getPathTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...D.getPathTerms(this.relativeParsedExpr)),n}}function s(r){const n=r.trim().split(`
`),l=n[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return u.uppercaseFirstLetter(n[n.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}e.rgErrorMsgForDisplay=s}),define(me[132],ge([0,1,38,289,101,18,69,30,9,8,2,31,65,290,273,91]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const w=a.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class _{constructor(y){this.outputChannel=y}provideTextSearchResults(y,o,k,F){return this.outputChannel.appendLine(`provideTextSearchResults ${y.pattern}, ${JSON.stringify({...o,folder:o.folder.toString()})}`),new Promise(($,Q)=>{F.onCancellationRequested(()=>M());const oe=s(y,o),j=o.folder.fsPath,O=oe.map(de=>de.match(/^-/)?de:`'${de}'`).join(" ");this.outputChannel.appendLine(`${w} ${O}
 - cwd: ${j}`);let B=p.spawn(w,oe,{cwd:j});B.on("error",de=>{console.error(de),this.outputChannel.appendLine("Error: "+(de&&de.message)),Q((0,P.serializeSearchError)(new P.SearchError(de&&de.message,P.SearchErrorCode.rgProcessError)))});let R=!1;const z=new h(o.maxResults,j,o.previewOptions);z.on("result",de=>{R=!0,x="",k.report(de)});let N=!1;const M=()=>{N=!0,B&&B.kill(),z&&z.cancel()};let q=!1;z.on("hitLimit",()=>{q=!0,M()});let x="";B.stdout.on("data",de=>{z.handleData(de),R||(x+=de)});let K=!1;B.stdout.once("data",()=>K=!0);let ee="";B.stderr.on("data",de=>{const Se=de.toString();this.outputChannel.appendLine(Se),ee+=Se}),B.on("close",()=>{if(this.outputChannel.appendLine(K?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(R?"Got result from parser":"No result from parser"),x&&this.outputChannel.appendLine(`Got data without result: ${x}`),this.outputChannel.appendLine(""),N)$({limitHit:q});else{z.flush(),B=null;let de;ee&&!K&&(de=b(ee))?Q((0,P.serializeSearchError)(new P.SearchError(de.message,de.code))):$({limitHit:q})}})})}}e.RipgrepTextSearchEngine=_;function b(E){const y=E.split(`
`),o=y[0].trim();if(y.some(F=>F.startsWith("regex parse error")))return new P.SearchError(d(y),P.SearchErrorCode.regexParseError);const k=o.match(/grep config error: unknown encoding: (.*)/);if(k)return new P.SearchError(`Unknown encoding: ${k[1]}`,P.SearchErrorCode.unknownEncoding);if(o.startsWith("error parsing glob"))return new P.SearchError(o.charAt(0).toUpperCase()+o.substr(1),P.SearchErrorCode.globParseError);if(o.startsWith("the literal"))return new P.SearchError(o.charAt(0).toUpperCase()+o.substr(1),P.SearchErrorCode.invalidLiteral);if(o.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(o,P.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function d(E){const y=["Regex parse error"],o=E.filter(k=>k.startsWith("PCRE2:"));if(o.length>=1){const k=o[0].replace("PCRE2:","");if(k.indexOf(":")!==-1&&k.split(":").length>=2){const F=k.split(":")[1];y.push(":"+F)}}return y.join("")}e.buildRegexParseError=d;class h extends L.EventEmitter{constructor(y,o,k){super();this.maxResults=y,this.rootFolder=o,this.previewOptions=k,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new C.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(y,o){return super.on(y,o),this}handleData(y){if(this.isDone)return;const o=typeof y=="string"?y:this.stringDecoder.write(y);this.handleDecodedData(o)}handleDecodedData(y){let o=y.indexOf(`
`);const k=this.remainder+y;if(o>=0)o+=this.remainder.length;else{this.remainder=k;return}let F=0;for(;o>=0;)this.handleLine(k.substring(F,o).trim()),F=o+1,o=k.indexOf(`
`,F);this.remainder=k.substring(F)}handleLine(y){if(this.isDone||!y)return;let o;try{o=JSON.parse(y)}catch(k){throw new Error(`malformed line from rg: ${y}`)}if(o.type==="match"){const k=v(o.data.path),F=i.URI.file(D.join(this.rootFolder,k)),$=this.createTextSearchMatch(o.data,F);this.onResult($),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(o.type==="context"){const k=v(o.data.path),F=i.URI.file(D.join(this.rootFolder,k));this.createTextSearchContext(o.data,F).forEach(Q=>this.onResult(Q))}}createTextSearchMatch(y,o){const k=y.line_number-1,F=v(y.lines),$=Buffer.from(F);let Q=0,oe=0,j=k;y.submatches.length===0&&y.submatches.push(F.length?{start:0,end:1,match:{text:F[0]}}:{start:0,end:0,match:{text:""}});const O=(0,S.coalesce)(y.submatches.map((B,R)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const z=v(B.match),N=$.slice(Q,B.start).toString().length,M=oe+N,q=t(z),x=j,K=q.numLines+x,ee=q.numLines>0?q.lastLineLength:q.lastLineLength+M;return Q=B.end,oe=ee,j=K,new c.Range(x,M,K,ee)}));return(0,g.createTextSearchResult)(o,F,O,this.previewOptions)}createTextSearchContext(y,o){const k=v(y.lines),F=y.line_number;return k.replace(/\r?\n$/,"").split(`
`).map(($,Q)=>({text:$,uri:o,lineNumber:F+Q}))}onResult(y){this.emit("result",y)}}e.RipgrepParser=h;function v(E){return E.bytes?Buffer.from(E.bytes,"base64").toString():E.text}function t(E){const y=/\n/g;let o=0,k=-1,F;for(;F=y.exec(E);)o++,k=F.index;const $=k>=0?E.length-k-1:E.length;return{numLines:o,lastLineLength:$}}function s(E,y){const o=["--hidden"];o.push(E.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:k,otherIncludes:F}=(0,T.groupBy)(y.includes,Q=>Q.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(F&&F.length){const Q=new Set;F.forEach(oe=>{Q.add(oe)}),o.push("-g","!*"),Q.forEach(oe=>{r(oe).map(g.anchorGlob).forEach(j=>{o.push("-g",j)})})}k&&k.length&&k.forEach(Q=>{o.push("-g",Q)}),y.excludes.map(g.anchorGlob).forEach(Q=>o.push("-g",`!${Q}`)),y.maxFileSize&&o.push("--max-filesize",y.maxFileSize+""),y.useIgnoreFiles?o.push("--no-ignore-parent"):o.push("--no-ignore"),y.followSymlinks&&o.push("--follow"),y.encoding&&y.encoding!=="utf8"&&o.push("--encoding",y.encoding),E.pattern==="--"&&(E.isRegExp=!0,E.pattern="\\-\\-"),E.isMultiline&&!E.isRegExp&&(E.pattern=(0,A.escapeRegExpCharacters)(E.pattern),E.isRegExp=!0),y.usePCRE2&&o.push("--pcre2"),o.push("--crlf"),E.isRegExp&&(E.pattern=n(E.pattern),o.push("--auto-hybrid-regex"));let $;if(E.isWordMatch){const oe=(0,A.createRegExp)(E.pattern,!!E.isRegExp,{wholeWord:E.isWordMatch}).source.replace(/\\\//g,"/");o.push("--regexp",oe)}else if(E.isRegExp){let Q=f(E.pattern);Q=m(Q),o.push("--regexp",Q)}else $=E.pattern,o.push("--fixed-strings");return o.push("--no-config"),y.useGlobalIgnoreFiles||o.push("--no-ignore-global"),o.push("--json"),E.isMultiline&&o.push("--multiline"),y.beforeContext&&o.push("--before-context",y.beforeContext+""),y.afterContext&&o.push("--after-context",y.afterContext+""),o.push("--"),$&&o.push($),o.push("."),o}function r(E){const y=(0,I.splitGlobAware)(E,"/");return y.map((o,k)=>y.slice(0,k+1).join("/"))}e.spreadGlobComponents=r;function n(E){const y=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;E.match(y);)E=E.replace(y,"$1\\x{$2}");const o=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;E.match(o);)E=E.replace(o,"$1\\x{$2}");return E}e.unicodeEscapesToPCRE2=n;const l=E=>E.type==="Assertion"&&E.kind==="lookbehind";function f(E){let y;try{y=new u.RegExpParser().parsePattern(E)}catch{return E}let o="",k=0;const F=(oe,j,O)=>{o+=E.slice(k,oe)+O,k=j},$=[];return new u.RegExpVisitor({onCharacterEnter(oe){if(oe.raw!=="\\n")return;const j=$[0];if(!j)F(oe.start,oe.end,"\\r?\\n");else if(!$.some(l))if(j.type==="CharacterClass")if(j.negate){const O=E.slice(j.start+2,oe.start)+E.slice(oe.end,j.end-1);F(j.start,j.end,"(?!\\r?\\n"+(O?`|[${O}]`:"")+")")}else{const O=E.slice(j.start+1,oe.start)+E.slice(oe.end,j.end-1);F(j.start,j.end,O===""?"\\r?\\n":`(?:[${O}]|\\r?\\n)`)}else j.type==="Quantifier"&&F(oe.start,oe.end,"(?:\\r?\\n)")},onQuantifierEnter(oe){$.unshift(oe)},onQuantifierLeave(){$.shift()},onCharacterClassRangeEnter(oe){$.unshift(oe)},onCharacterClassRangeLeave(){$.shift()},onCharacterClassEnter(oe){$.unshift(oe)},onCharacterClassLeave(){$.shift()},onAssertionEnter(oe){l(oe)&&$.push(oe)},onAssertionLeave(oe){$[0]===oe&&$.shift()}}).visit(y),o+=E.slice(k),o}e.fixRegexNewline=f;function m(E){return E.replace(/\n/g,"\\r?\\n")}e.fixNewline=m}),define(me[275],ge([0,1,21,132,116,10]),function(J,e,p,L,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class T{constructor(A){this.outputChannel=A,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(A,i,P,c){const u=new L.RipgrepTextSearchEngine(this.outputChannel);if(i.folder.scheme===S.Schemas.userData){const a={...i,folder:i.folder.with({scheme:S.Schemas.file})},g=new C.Progress(w=>P.report({...w,uri:w.uri.with({scheme:i.folder.scheme})}));return this.withToken(c,w=>u.provideTextSearchResults(A,a,g,w))}else return this.withToken(c,a=>u.provideTextSearchResults(A,i,P,a))}async withToken(A,i){const P=I(A);this.inProgress.add(P);const c=await i(P.token);return this.inProgress.delete(P),c}dispose(){this.inProgress.forEach(A=>A.cancel())}}e.RipgrepSearchProvider=T;function I(D){const A=new p.CancellationTokenSource;return D.onCancellationRequested(()=>A.cancel()),A}}),define(me[276],ge([0,1,28,132,131]),function(J,e,p,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class S{constructor(D){this.query=D}search(D,A,i){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(u){i({message:u})}},c=new C.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(P),p);return new Promise((u,a)=>c.search(g=>{A(g.map(T))},D).then(g=>u({limitHit:g.limitHit,type:"success"}),a))}}e.TextSearchEngineAdapter=S;function T(I){return{path:I.resource&&I.resource.fsPath,results:I.results,numMatches:(I.results||[]).reduce((D,A)=>{if(A.ranges){const i=A;return D+(Array.isArray(i.ranges)?i.ranges.length:1)}else return D+1},0)}}}),define(me[277],ge([0,1,45,291,18,17,15,3,98,9,44,2,41,31,274,276]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,L.gracefulify(p);class w{constructor(){this.caches=Object.create(null)}fileSearch(t){let s;const r=d(t),n=new I.Emitter({onFirstListenerDidAdd:()=>{s=(0,S.createCancelablePromise)(l=>this.doFileSearchWithEngine(a.Engine,r,f=>n.fire(f),l)),s.then(l=>n.fire(l),l=>n.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onLastListenerRemove:()=>{s.cancel()}});return n.event}textSearch(t){let s;const r=d(t),n=new I.Emitter({onFirstListenerDidAdd:()=>{s=(0,S.createCancelablePromise)(l=>this.ripgrepTextSearch(r,f=>n.fire(f),l)),s.then(l=>n.fire(l),l=>n.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onLastListenerRemove:()=>{s.cancel()}});return n.event}ripgrepTextSearch(t,s,r){return t.maxFileSize=(0,c.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new g.TextSearchEngineAdapter(t).search(r,s,s)}doFileSearch(t,s,r){return this.doFileSearchWithEngine(a.Engine,t,s,r)}doFileSearchWithEngine(t,s,r,n,l=w.BATCH_SIZE){let f=0;const m=y=>{Array.isArray(y)?(f+=y.length,r(y.map(o=>this.rawMatchToSearchItem(o)))):y.relativePath?(f++,r(this.rawMatchToSearchItem(y))):r(y)};if(s.sortByScore){let y=this.trySortedSearchFromCache(s,m,n);if(!y){const o=s.maxResults?Object.assign({},s,{maxResults:null}):s,k=new t(o);y=this.doSortedSearch(k,s,r,m,n)}return new Promise((o,k)=>{y.then(([F,$])=>{const Q=$.map(oe=>this.rawMatchToSearchItem(oe));this.sendProgress(Q,r,l),o(F)},k)})}const E=new t(s);return this.doSearch(E,m,l,n).then(y=>({limitHit:y.limitHit,type:"success",stats:{detailStats:y.stats,type:"searchProcess",fromCache:!1,resultCount:f,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,A.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,s,r,n,l){const f=new I.Emitter;let m=(0,S.createCancelablePromise)(y=>{let o=[];const k=F=>{Array.isArray(F)?o=F:(n(F),f.fire(F))};return this.doSearch(t,k,-1,y).then(F=>[F,o])}),E;if(s.cacheKey){E=this.getOrCreateCache(s.cacheKey);const y={promise:m,event:f.event,resolved:!1};E.resultsToSearchCache[s.filePattern||""]=y,m.then(()=>{y.resolved=!0},o=>{delete E.resultsToSearchCache[s.filePattern||""]}),m=this.preventCancellation(m)}return m.then(([y,o])=>{const k=E?E.scorerCache:Object.create(null),F=(typeof s.maxResults!="number"||s.maxResults>0)&&i.StopWatch.create(!1);return this.sortResults(s,o,k,l).then($=>{const Q=F?F.elapsed():-1;return[{type:"success",stats:{detailStats:y.stats,sortingTime:Q,fromCache:!1,type:"searchProcess",workspaceFolderCount:s.folderQueries.length,resultCount:$.length},messages:y.messages,limitHit:y.limitHit||typeof s.maxResults=="number"&&o.length>s.maxResults},$]})})}getOrCreateCache(t){const s=this.caches[t];return s||(this.caches[t]=new _)}trySortedSearchFromCache(t,s,r){const n=t.cacheKey&&this.caches[t.cacheKey];if(!n)return;const l=this.getResultsFromCache(n,t.filePattern||"",s,r);if(l)return l.then(([f,m,E])=>{const y=i.StopWatch.create(!1);return this.sortResults(t,m,n.scorerCache,r).then(o=>{const k=y.elapsed(),F={fromCache:!0,detailStats:E,type:"searchProcess",resultCount:m.length,sortingTime:k};return[{type:"success",limitHit:f.limitHit||typeof t.maxResults=="number"&&m.length>t.maxResults,stats:F},o]})})}sortResults(t,s,r,n){const l=(0,D.prepareQuery)(t.filePattern||""),f=(E,y)=>(0,D.compareItemsByFuzzyScore)(E,y,l,!0,b,r),m=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return C.topAsync(s,f,m,1e4,n)}sendProgress(t,s,r){if(r&&r>0)for(let n=0;n<t.length;n+=r)s(t.slice(n,n+r));else s(t)}getResultsFromCache(t,s,r,n){const l=i.StopWatch.create(!1),f=s.indexOf(A.sep)>=0;let m;for(const k in t.resultsToSearchCache)if(s.startsWith(k)){if(f&&k.indexOf(A.sep)<0&&k!=="")continue;const F=t.resultsToSearchCache[k];m={promise:this.preventCancellation(F.promise),event:F.event,resolved:F.resolved};break}if(!m)return null;const E=l.elapsed(),y=i.StopWatch.create(!1),o=m.event(r);return n&&n.onCancellationRequested(()=>{o.dispose()}),m.promise.then(([k,F])=>{if(n&&n.isCancellationRequested)throw(0,T.canceled)();const $=[],Q=(0,D.prepareQuery)(s).normalizedLowercase;for(const oe of F)!(0,u.isFilePatternMatch)(oe,Q)||$.push(oe);return[k,$,{cacheWasResolved:m.resolved,cacheLookupTime:E,cacheFilterTime:y.elapsed(),cacheEntryCount:F.length}]})}doSearch(t,s,r,n){return new Promise((l,f)=>{let m=[];n&&n.onCancellationRequested(()=>t.cancel()),t.search(E=>{E&&(r?(m.push(E),r>0&&m.length>=r&&(s(m),m=[])):s(E))},E=>{s(E)},(E,y)=>{m.length&&s(m),E?f(E):l(y)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(s,r){return t.then(s,r)}catch(s){return this.then(void 0,s)}finally(s){return t.finally(s)}}}}e.SearchService=w,w.BATCH_SIZE=512;class _{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const b=new class{getItemLabel(v){return(0,A.basename)(v.relativePath)}getItemDescription(v){return(0,A.dirname)(v.relativePath)}getItemPath(v){return v.relativePath}};function d(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(h),extraFileResources:v.extraFileResources&&v.extraFileResources.map(t=>P.URI.revive(t))}}function h(v){return{...v,folder:P.URI.revive(v.folder)}}}),define(me[278],ge([0,1,6,2,28,12,31,277,275,91,13,60,27,68,10,131]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let w=class extends u.ExtHostSearch{constructor(b,d,h,v){super(b,h,v);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new A.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(a.Schemas.userData,new D.RipgrepSearchProvider(t)),d.remote.isRemote&&d.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const b=new A.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(a.Schemas.file,new D.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(a.Schemas.file,new I.SearchService)}registerInternalFileSearchProvider(b,d){const h=this._handlePool++;return this._internalFileSearchProvider=d,this._internalFileSearchHandle=h,this._proxy.$registerFileSearchProvider(h,this._transformScheme(b)),(0,p.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(h)})}$provideFileSearchResults(b,d,h,v){const t=(0,u.reviveQuery)(h);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,d,t,v):super.$provideFileSearchResults(b,d,h,v)}doInternalFileSearch(b,d,h,v){const t=s=>{if((0,T.isSerializedFileMatch)(s)&&(s=[s]),Array.isArray(s)){this._proxy.$handleFileMatch(b,d,s.map(r=>L.URI.file(r.path)));return}s.message&&this._logService.debug("ExtHostSearch",s.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(h,t,v)}$clearCache(b){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,d){return new g.NativeTextSearchManager(b,d)}};w=Ve([He(0,i.IExtHostRpcService),He(1,c.IExtHostInitDataService),He(2,P.IURITransformerService),He(3,S.ILogService)],w),e.NativeExtHostSearch=w}),define(me[133],ge([0,1,292,122,293,3,104,9,102,32,6,22,105,15,11]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(m){this.socket=m,this._errorListener=E=>{if(E){if(E.code==="EPIPE")return;(0,u.onUnexpectedError)(E)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(m){const E=y=>m(P.VSBuffer.wrap(y));return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(m){const E=y=>{m({type:0,hadError:y,error:void 0})};return this.socket.on("close",E),{dispose:()=>this.socket.off("close",E)}}onEnd(m){return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(m){if(!this.socket.destroyed)try{this.socket.write(m.buffer,E=>{if(E){if(E.code==="EPIPE")return;(0,u.onUnexpectedError)(E)}})}catch(E){if(E.code==="EPIPE")return;(0,u.onUnexpectedError)(E)}}end(){this.socket.end()}drain(){return new Promise((m,E)=>{if(this.socket.bufferSize===0){m();return}const y=()=>{this.socket.off("close",y),this.socket.off("end",y),this.socket.off("error",y),this.socket.off("timeout",y),this.socket.off("drain",y),m()};this.socket.on("close",y),this.socket.on("end",y),this.socket.on("error",y),this.socket.on("timeout",y),this.socket.on("drain",y)})}}e.NodeSocket=g;var w;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(w||(w={}));var _;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(_||(_={}));class b extends i.Disposable{constructor(m,E,y,o){super();this._onDidZlibFlush=this._register(new S.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new S.Emitter),this._onClose=this._register(new S.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=m,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=E,this._recordInflateBytes=o,E?(this._zlibInflate=C.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",k=>{console.error(k),(0,u.onUnexpectedError)(k),this._onClose.fire({type:0,hadError:!0,error:k})}),this._zlibInflate.on("data",k=>{this._pendingInflateData.push(k)}),y&&(this._zlibInflate.write(y.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=C.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",k=>{console.error(k),(0,u.onUnexpectedError)(k),this._onClose.fire({type:0,hadError:!0,error:k})}),this._zlibDeflate.on("data",k=>{this._pendingDeflateData.push(k)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new c.ChunkStream,this._register(this.socket.onData(k=>this._acceptChunk(k))),this._register(this.socket.onClose(k=>this._onClose.fire(k)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?P.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):P.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(m){return this._onData.event(m)}onClose(m){return this._onClose.event(m)}onEnd(m){return this.socket.onEnd(m)}write(m){this._totalOutgoingDataBytes+=m.byteLength,this._zlibDeflate?(this._zlibDeflate.write(m.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let E=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,E=E.slice(0,E.length-4),this._isEnded||this._write(P.VSBuffer.wrap(E),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(m,!1)}_write(m,E){let y=2;m.byteLength<126?y+=0:m.byteLength<2**16?y+=2:y+=8;const o=P.VSBuffer.alloc(y);if(E?o.writeUInt8(194,0):o.writeUInt8(130,0),m.byteLength<126)o.writeUInt8(m.byteLength,1);else if(m.byteLength<2**16){o.writeUInt8(126,1);let k=1;o.writeUInt8(m.byteLength>>>8&255,++k),o.writeUInt8(m.byteLength>>>0&255,++k)}else{o.writeUInt8(127,1);let k=1;o.writeUInt8(0,++k),o.writeUInt8(0,++k),o.writeUInt8(0,++k),o.writeUInt8(0,++k),o.writeUInt8(m.byteLength>>>24&255,++k),o.writeUInt8(m.byteLength>>>16&255,++k),o.writeUInt8(m.byteLength>>>8&255,++k),o.writeUInt8(m.byteLength>>>0&255,++k)}this._totalOutgoingWireBytes+=o.byteLength+m.byteLength,this.socket.write(P.VSBuffer.concat([o,m]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(m){if(m.byteLength!==0){for(this._totalIncomingWireBytes+=m.byteLength,this._incomingData.acceptChunk(m);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const E=this._incomingData.peek(this._state.readLen),o=(E.readUInt8(0)&128)>>>7,k=E.readUInt8(1),F=(k&128)>>>7,$=k&127;this._state.state=2,this._state.readLen=2+(F?4:0)+($===126?2:0)+($===127?8:0),this._state.fin=o,this._state.mask=0}else if(this._state.state===2){const E=this._incomingData.read(this._state.readLen),y=E.readUInt8(1),o=(y&128)>>>7;let k=y&127,F=1;k===126?k=E.readUInt8(++F)*2**8+E.readUInt8(++F):k===127&&(k=E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*2**24+E.readUInt8(++F)*2**16+E.readUInt8(++F)*2**8+E.readUInt8(++F));let $=0;o&&($=E.readUInt8(++F)*2**24+E.readUInt8(++F)*2**16+E.readUInt8(++F)*2**8+E.readUInt8(++F)),this._state.state=3,this._state.readLen=k,this._state.mask=$}else if(this._state.state===3){const E=this._incomingData.read(this._state.readLen);d(E,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(E.buffer)),this._zlibInflate.write(E.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const y=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=y.length,this._onData.fire(P.VSBuffer.wrap(y))})):(this._totalIncomingDataBytes+=E.byteLength,this._onData.fire(E))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await S.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=b;function d(f,m){if(m===0)return;let E=f.byteLength>>>2;for(let Q=0;Q<E;Q++){const oe=f.readUInt32BE(Q*4);f.writeUInt32BE(oe^m,Q*4)}let y=E*4,o=f.byteLength-y;const k=m>>>24&255,F=m>>>16&255,$=m>>>8&255;o>=1&&f.writeUInt8(f.readUInt8(y)^k,y),o>=2&&f.writeUInt8(f.readUInt8(y+1)^F,y+1),o>=3&&f.writeUInt8(f.readUInt8(y+2)^$,y+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const h={[2]:107,[1]:103};function v(){const f=(0,A.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let m;return e.XDG_RUNTIME_DIR?m=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):m=(0,I.join)((0,D.tmpdir)(),`vscode-ipc-${f}.sock`),s(m),m}e.createRandomIPCHandle=v;function t(f,m,E){const y=(0,p.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${y}-${E}-${m}-sock`;let o;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?o=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-${y.substr(0,8)}-${E}-${m}.sock`):o=(0,I.join)(f,`${E}-${m}.sock`),s(o),o}e.createStaticIPCHandle=t;function s(f){const m=h[a.platform];typeof m=="number"&&f.length>=m&&console.warn(`WARNING: IPC handle "${f}" is longer than ${m} chars, try a shorter --user-data-dir`)}class r extends T.IPCServer{constructor(m){super(r.toClientConnectionEvent(m));this.server=m}static toClientConnectionEvent(m){const E=S.Event.fromNodeEventEmitter(m,"connection");return S.Event.map(E,y=>({protocol:new c.Protocol(new g(y)),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(y,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function n(f){return new Promise((m,E)=>{const y=(0,L.createServer)();y.on("error",E),y.listen(f,()=>{y.removeListener("error",E),m(new r(y))})})}e.serve=n;function l(f,m){return new Promise((E,y)=>{const o=(0,L.createConnection)(f,()=>{o.removeListener("error",y),E(c.Client.fromSocket(new g(o),m))});o.once("error",y)})}e.connect=l}),define(me[279],ge([0,1,133,271,45,50,2,194,12]),function(J,e,p,L,C,S,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class A{constructor(c,u,a){this._commands=c,this.logService=u,this._ipcHandlePath=a,this._server=L.createServer((g,w)=>this.onRequest(g,w)),this.setup().catch(g=>(u.error(g),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",c=>this.logService.error(c))}catch(c){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(c,u){const a=[];c.setEncoding("utf8"),c.on("data",g=>a.push(g)),c.on("end",()=>{const g=JSON.parse(a.join(""));switch(g.type){case"open":this.open(g,u);break;case"openExternal":this.openExternal(g,u);break;case"status":this.getStatus(g,u);break;case"extensionManagement":this.manageExtensions(g,u).catch(this.logService.error);break;default:u.writeHead(404),u.write(`Unknown message type: ${g.type}`,w=>{w&&this.logService.error(w)}),u.end();break}})}open(c,u){let{fileURIs:a,folderURIs:g,forceNewWindow:w,diffMode:_,addMode:b,forceReuseWindow:d,gotoLineMode:h,waitMarkerFilePath:v}=c;const t=[];if(Array.isArray(g))for(const s of g)try{t.push({folderUri:T.URI.parse(s)})}catch(r){}if(Array.isArray(a))for(const s of a)try{(0,I.hasWorkspaceFileExtension)(s)?t.push({workspaceUri:T.URI.parse(s)}):t.push({fileUri:T.URI.parse(s)})}catch(r){}if(t.length){const s=v?T.URI.file(v):void 0,n={forceNewWindow:w,diffMode:_,addMode:b,gotoLineMode:h,forceReuseWindow:d,preferNewWindow:!d&&!s&&!b,waitMarkerFileURI:s};this._commands.executeCommand("_remoteCLI.windowOpen",t,n)}u.writeHead(200),u.end()}async openExternal(c,u){for(const a of c.uris){const g=T.URI.parse(a),w=g.scheme==="file"?g:a;await this._commands.executeCommand("_remoteCLI.openExternal",w)}u.writeHead(200),u.end()}async manageExtensions(c,u){try{const a=_=>_?.map(b=>/\.vsix$/i.test(b)?T.URI.parse(b):b),g={list:c.list,install:a(c.install),uninstall:a(c.uninstall),force:c.force},w=await this._commands.executeCommand("_remoteCLI.manageExtensions",g);u.writeHead(200),u.write(w)}catch(a){u.writeHead(500),u.write(String(a),g=>{g&&this.logService.error(g)})}u.end()}async getStatus(c,u){try{const a=await this._commands.executeCommand("_remoteCLI.getSystemStatus");u.writeHead(200),u.write(a),u.end()}catch(a){u.writeHead(500),u.write(String(a),g=>{g&&this.logService.error(g)}),u.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&C.existsSync(this._ipcHandlePath)&&C.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=A;let i=class extends A{constructor(c,u){super(c,u,(0,p.createRandomIPCHandle)())}};i=Ve([He(0,S.IExtHostCommands),He(1,D.ILogService)],i),e.CLIServer=i}),define(me[280],ge([0,1,67,267,262,5,270,39,252,2,10,7,279,103]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class a extends C.RequireInterceptor{_installInterceptor(){const _=this,b=J.__$__nodeRequire("module"),d=b._load;b._load=function(v,t,s){for(let r of _._alternatives){let n=r(v);if(n){v=n;break}}return _._factories.has(v)?_._factories.get(v).load(v,A.URI.file((0,u.realpathSync)(t.filename)),r=>d.apply(this,[r,t,s])):d.apply(this,arguments)}}}class g extends I.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=P.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const _=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(c.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(a,_,this._registry).install(),p.mark("code/extHost/didInitAPI");const d=await this._extHostConfiguration.getConfigProvider();await(0,T.connectProxyResolver)(this._extHostWorkspace,d,this,this._logService,this._mainThreadTelemetryProxy,this._initData),p.mark("code/extHost/didInitProxyResolver");const h=process.send,v=this._extHostContext.getProxy(S.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?h.apply(process,t):(v.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(_){return _.main}_loadCommonJSModule(_,b,d){if(b.scheme!==i.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let h=null;d.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();try{_&&p.mark(`code/extHost/willLoadExtensionCode/${_.value}`),h=J.__$__nodeRequire(b.fsPath)}catch(v){return Promise.reject(v)}finally{_&&p.mark(`code/extHost/didLoadExtensionCode/${_.value}`),d.codeLoadingStop()}return Promise.resolve(h)}async $setRemoteEnvironment(_){if(!!this._initData.remote.isRemote)for(const b in _){const d=_[b];d===null?delete process.env[b]:process.env[b]=d}}}e.ExtHostExtensionService=g}),define(me[281],ge([0,1,78,253,255,264,263,278,280,221,256,51,39,62,68,66,33,49,12,63,254]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a,g,w,_,b,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,p.registerSingleton)(c.IExtHostExtensionService,D.ExtHostExtensionService),(0,p.registerSingleton)(b.ILogService,A.ExtHostLogService),(0,p.registerSingleton)(d.IExtensionStoragePaths,h.ExtensionStoragePaths),(0,p.registerSingleton)(P.IExtHostDebugService,T.ExtHostDebugService),(0,p.registerSingleton)(u.IExtHostOutputService,L.ExtHostOutputService2),(0,p.registerSingleton)(a.IExtHostSearch,I.NativeExtHostSearch),(0,p.registerSingleton)(g.IExtHostTask,S.ExtHostTask),(0,p.registerSingleton)(w.IExtHostTerminalService,C.ExtHostTerminalService),(0,p.registerSingleton)(_.IExtHostTunnelService,i.ExtHostTunnelService)}),define(me[282],ge([0,1,122,294,67,15,105,133,186,219,265,22,100,28,103,17,112,268,281]),function(J,e,p,L,C,S,T,I,D,A,i,P,c,u,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let l=0;l<process.execArgv.length;l++)process.execArgv[l]==="--inspect-port=0"&&(process.execArgv.splice(l,1),l--)}();const _=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const n=J.__$__nodeRequire("module"),l=n._load;n._load=function(f){if(f==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return l.apply(this,arguments)}})();const b=process.exit.bind(process);function d(n){process.exit=function(l){if(n)b(l);else{const f=new Error("An extension called process.exit() and this was prevented.");console.warn(f.stack)}},process.crash=function(){const l=new Error("An extension called process.crash() and this was prevented.");console.warn(l.stack)}}let h=function(n){b()};function v(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((n,l)=>{let f=null,m=setTimeout(()=>{h("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const E=108e5,y=3e5,o=new g.RunOnceScheduler(()=>h("renderer disconnected for too long (1)"),E),k=new g.RunOnceScheduler(()=>h("renderer disconnected for too long (2)"),y);process.on("message",($,Q)=>{if($&&$.type==="VSCODE_EXTHOST_IPC_SOCKET"){const oe=P.VSBuffer.wrap(Buffer.from($.initialDataChunk,"base64"));let j;if($.skipWebSocketFrames)j=new I.NodeSocket(Q);else{const O=P.VSBuffer.wrap(Buffer.from($.inflateBytes,"base64"));j=new I.WebSocketNodeSocket(new I.NodeSocket(Q),$.permessageDeflate,O,!1)}f?(o.cancel(),k.cancel(),f.beginAcceptReconnection(j,oe),f.endAcceptReconnection()):(clearTimeout(m),f=new T.PersistentProtocol(j,oe),f.onDidDispose(()=>h("renderer disconnected")),n(f),f.onSocketClose(()=>{o.schedule()}))}if($&&$.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(k.isScheduled())return;o.isScheduled()&&k.schedule()}});const F={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(F)});{const n=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((l,f)=>{const m=p.createConnection(n,()=>{m.removeListener("error",f),l(new T.PersistentProtocol(new I.NodeSocket(m)))});m.once("error",f),m.on("close",()=>{h("renderer closed the socket")})})}}async function t(){const n=await v();return new class{constructor(){this._onMessage=new T.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,n.onMessage(l=>{(0,A.isMessageOfType)(l,2)?(this._terminating=!0,h("received terminate message from renderer")):this._onMessage.fire(l)})}send(l){this._terminating||n.send(l)}drain(){return n.drain()}}}function s(n){return new Promise(l=>{const f=n.onMessage(m=>{f.dispose();const E=JSON.parse(m.toString()),y=E.commit,o=D.default.commit;y&&o&&y!==o&&b(55);const k=[];process.on("unhandledRejection",(Q,oe)=>{k.push(oe),setTimeout(()=>{const j=k.indexOf(oe);j>=0&&oe.catch(O=>{k.splice(j,1),(0,S.isPromiseCanceledError)(O)||(console.warn(`rejected promise not handled within 1 second: ${O}`),O&&O.stack&&console.warn(`stack trace: ${O.stack}`),(0,S.onUnexpectedError)(Q))})},1e3)}),process.on("rejectionHandled",Q=>{const oe=k.indexOf(Q);oe>=0&&k.splice(oe,1)}),process.on("uncaughtException",function(Q){(0,S.onUnexpectedError)(Q)});let F=0;setInterval(function(){try{process.kill(E.parentPid,0),F=0}catch(Q){Q&&Q.code==="EPERM"?(F++,F>=3&&h(`parent process ${E.parentPid} does not exist anymore (3 x EPERM): ${Q.message} (code: ${Q.code}) (errno: ${Q.errno})`)):h(`parent process ${E.parentPid} does not exist anymore: ${Q.message} (code: ${Q.code}) (errno: ${Q.errno})`)}},1e3);let $;try{$=J.__$__nodeRequire("native-watchdog"),$.start(E.parentPid)}catch(Q){(0,S.onUnexpectedError)(Q)}n.send((0,A.createMessageOfType)(0)),l({protocol:n,initData:E})});n.send((0,A.createMessageOfType)(1))})}async function r(){C.mark("code/extHost/willConnectToRenderer");const n=await t();C.mark("code/extHost/didConnectToRenderer");const l=await s(n);C.mark("code/extHost/didWaitForInitData");const{initData:f}=l;d(!!f.environment.extensionTestsLocationURI),f.environment.useHostProxy=_.useHostProxy!==void 0?_.useHostProxy!=="false":void 0,f.environment.skipWorkspaceStorageLock=(0,w.boolean)(_.skipWorkspaceStorageLock,!1);const m=new class{exit(k){b(k)}exists(k){return u.Promises.exists(k)}realpath(k){return(0,a.realpath)(k)}};let E=null;if(f.remote.authority&&_.uriTransformerPath)try{const k=J.__$__nodeRequire(_.uriTransformerPath)(f.remote.authority);E=new c.URITransformer(k)}catch(o){console.error(o)}const y=new i.ExtensionHostMain(l.protocol,f,m,E);h=o=>y.terminate(o)}e.startExtensionHostProcess=r}),define(me[295],ge([0,1,282]),function(J,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,p.startExtensionHostProcess)().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/599f5d2c67571f84a045a59eb3423bc254ee87d9/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
