/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/network","vs/base/common/errors","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/platform/log/common/log","vs/base/common/async","vs/base/common/arrays","vs/base/common/cancellation","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/platform","vs/base/common/map","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/editor/common/core/position","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/process","vs/base/common/hash","vs/base/common/severity","vs/base/common/extpath","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],_e=function(ee){for(var e=[],m=0,F=ee.length;m<F;m++)e[m]=Ee[ee[m]];return e};define(Ee[39],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(F,D){if(!F)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=m}),define(Ee[77],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const m=Object.prototype.hasOwnProperty;function F(n){const k=[];for(let l in n)m.call(n,l)&&k.push(n[l]);return k}e.values=F;function D(n,k){for(let l in n)if(m.call(n,l)&&k({key:l,value:n[l]},function(){delete n[l]})===!1)return}e.forEach=D;function _(n,k){const l=Object.create(null);for(const h of n){const a=k(h);let d=l[a];d||(d=l[a]=[]),d.push(h)}return l}e.groupBy=_;function I(n){const k=Object.create(null);return n&&n.forEach((l,h)=>{k[h]=l}),k}e.fromMap=I;function S(n,k){const l=[],h=[];for(let a of n)k.has(a)||l.push(a);for(let a of k)n.has(a)||h.push(a);return{removed:l,added:h}}e.diffSets=S;function y(n,k){const l=[],h=[];for(let[a,d]of n)k.has(a)||l.push(d);for(let[a,d]of k)n.has(a)||h.push(d);return{removed:l,added:h}}e.diffMaps=y;class C{constructor(){this.map=new Map}add(k,l){let h=this.map.get(k);h||(h=new Set,this.map.set(k,h)),h.add(l)}delete(k,l){const h=this.map.get(k);!h||(h.delete(l),h.size===0&&this.map.delete(k))}forEach(k,l){const h=this.map.get(k);!h||h.forEach(l)}}e.SetMap=C}),define(Ee[48],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(I){return(S,y,C)=>{let n=null,k=null;if(typeof C.value=="function"?(n="value",k=C.value):typeof C.get=="function"&&(n="get",k=C.get),!k)throw new Error("not supported");C[n]=I(k,y)}}e.createDecorator=m;function F(I,S,y){let C=null,n=null;if(typeof y.value=="function"?(C="value",n=y.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(C="get",n=y.get),!n)throw new Error("not supported");const k=`$memoize$${S}`;y[C]=function(...l){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,l)}),this[k]}}e.memoize=F;function D(I,S,y){return m((C,n)=>{const k=`$debounce$${n}`,l=`$debounce$result$${n}`;return function(...h){this[l]||(this[l]=y?y():void 0),clearTimeout(this[k]),S&&(this[l]=S(this[l],...h),h=[this[l]]),this[k]=setTimeout(()=>{C.apply(this,h),this[l]=y?y():void 0},I)}})}e.debounce=D;function _(I,S,y){return m((C,n)=>{const k=`$throttle$timer$${n}`,l=`$throttle$result$${n}`,h=`$throttle$lastRun$${n}`,a=`$throttle$pending$${n}`;return function(...d){if(this[l]||(this[l]=y?y():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),S&&(this[l]=S(this[l],...d)),this[a])return;const f=this[h]+I;f<=Date.now()?(this[h]=Date.now(),C.apply(this,[this[l]]),this[l]=y?y():void 0):(this[a]=!0,this[k]=setTimeout(()=>{this[a]=!1,this[h]=Date.now(),C.apply(this,[this[l]]),this[l]=y?y():void 0},f-Date.now()))}})}e.throttle=_}),define(Ee[12],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(s=>{s(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=m,e.errorHandler=new m;function F(b){e.errorHandler.setUnexpectedErrorHandler(b)}e.setUnexpectedErrorHandler=F;function D(b){y(b)||e.errorHandler.onUnexpectedError(b)}e.onUnexpectedError=D;function _(b){y(b)||e.errorHandler.onUnexpectedExternalError(b)}e.onUnexpectedExternalError=_;function I(b){if(b instanceof Error){let{name:t,message:s}=b;const r=b.stacktrace||b.stack;return{$isError:!0,name:t,message:s,stack:r}}return b}e.transformErrorForSerialization=I;const S="Canceled";function y(b){return b instanceof Error&&b.name===S&&b.message===S}e.isPromiseCanceledError=y;class C extends Error{constructor(){super(S);this.name=this.message}}e.CancellationError=C;function n(){const b=new Error(S);return b.name=b.message,b}e.canceled=n;function k(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}e.illegalArgument=k;function l(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}e.illegalState=l;function h(b){return b?new Error(`readonly property '${b} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function a(b){const t=new Error(`${b} has been disposed`);return t.name="DISPOSED",t}e.disposed=a;function d(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}e.getErrorMessage=d;class f extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=f;class E extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=E;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function u(b){const t=b;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=u;function p(b,t=Object.create(null)){const s=new Error(b);return t.actions&&(s.actions=t.actions),s}e.createErrorWithActions=p}),define(Ee[17],_e([0,1,12]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function F(W,te=0){return W[W.length-(1+te)]}e.tail=F;function D(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=D;function _(W,te,ue=(ye,Te)=>ye===Te){if(W===te)return!0;if(!W||!te||W.length!==te.length)return!1;for(let ye=0,Te=W.length;ye<Te;ye++)if(!ue(W[ye],te[ye]))return!1;return!0}e.equals=_;function I(W,te,ue){let ye=0,Te=W.length-1;for(;ye<=Te;){const Re=(ye+Te)/2|0,$e=ue(W[Re],te);if($e<0)ye=Re+1;else if($e>0)Te=Re-1;else return Re}return-(ye+1)}e.binarySearch=I;function S(W,te){let ue=0,ye=W.length;if(ye===0)return 0;for(;ue<ye;){const Te=Math.floor((ue+ye)/2);te(W[Te])?ye=Te:ue=Te+1}return ue}e.findFirstInSorted=S;function y(W,te,ue){if(W=W|0,W>=te.length)throw new TypeError("invalid index");let ye=te[Math.floor(te.length*Math.random())],Te=[],Re=[],$e=[];for(let Ze of te){const Ve=ue(Ze,ye);Ve<0?Te.push(Ze):Ve>0?Re.push(Ze):$e.push(Ze)}return W<Te.length?y(W,Te,ue):W<Te.length+$e.length?$e[0]:y(W-(Te.length+$e.length),Re,ue)}e.quickSelect=y;function C(W,te){const ue=[];let ye;for(const Te of W.slice(0).sort(te))!ye||te(ye[0],Te)!==0?(ye=[Te],ue.push(ye)):ye.push(Te);return ue}e.groupBy=C;function n(W,te,ue){const ye=[];function Te(Ze,Ve,je){if(Ve===0&&je.length===0)return;const O=ye[ye.length-1];O&&O.start+O.deleteCount===Ze?(O.deleteCount+=Ve,O.toInsert.push(...je)):ye.push({start:Ze,deleteCount:Ve,toInsert:je})}let Re=0,$e=0;for(;;){if(Re===W.length){Te(Re,0,te.slice($e));break}if($e===te.length){Te(Re,W.length-Re,[]);break}const Ze=W[Re],Ve=te[$e],je=ue(Ze,Ve);je===0?(Re+=1,$e+=1):je<0?(Te(Re,1,[]),Re+=1):je>0&&(Te(Re,0,[Ve]),$e+=1)}return ye}e.sortedDiff=n;function k(W,te,ue){const ye=n(W,te,ue),Te=[],Re=[];for(const $e of ye)Te.push(...W.slice($e.start,$e.start+$e.deleteCount)),Re.push(...$e.toInsert);return{removed:Te,added:Re}}e.delta=k;function l(W,te,ue){if(ue===0)return[];const ye=W.slice(0,ue).sort(te);return a(W,te,ye,ue,W.length),ye}e.top=l;function h(W,te,ue,ye,Te){return ue===0?Promise.resolve([]):new Promise((Re,$e)=>{(async()=>{const Ze=W.length,Ve=W.slice(0,ue).sort(te);for(let je=ue,O=Math.min(ue+ye,Ze);je<Ze;je=O,O=Math.min(O+ye,Ze)){if(je>ue&&await new Promise(K=>setTimeout(K)),Te&&Te.isCancellationRequested)throw(0,m.canceled)();a(W,te,Ve,je,O)}return Ve})().then(Re,$e)})}e.topAsync=h;function a(W,te,ue,ye,Te){for(const Re=ue.length;ye<Te;ye++){const $e=W[ye];if(te($e,ue[Re-1])<0){ue.pop();const Ze=S(ue,Ve=>te($e,Ve)<0);ue.splice(Ze,0,$e)}}}function d(W){return W.filter(te=>!!te)}e.coalesce=d;function f(W){let te=0;for(let ue=0;ue<W.length;ue++)W[ue]&&(W[te]=W[ue],te+=1);W.length=te}e.coalesceInPlace=f;function E(W,te,ue){W.splice(ue,0,W.splice(te,1)[0])}e.move=E;function w(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=w;function u(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=u;function p(W,te){if(!te)return W.filter((ye,Te)=>W.indexOf(ye)===Te);const ue=Object.create(null);return W.filter(ye=>{const Te=te(ye);return ue[Te]?!1:(ue[Te]=!0,!0)})}e.distinct=p;function b(W){const te=new Set;return W.filter(ue=>te.has(ue)?!1:(te.add(ue),!0))}e.distinctES6=b;function t(W){const te=Object.create(null);return ue=>{const ye=W(ue);return te[ye]?!1:(te[ye]=!0,!0)}}e.uniqueFilter=t;function s(W,te){for(let ue=W.length-1;ue>=0;ue--){const ye=W[ue];if(te(ye))return ue}return-1}e.lastIndex=s;function r(W,te){return W.length>0?W[0]:te}e.firstOrDefault=r;function i(W,te,ue=(ye,Te)=>ye===Te){let ye=0;for(let Te=0,Re=Math.min(W.length,te.length);Te<Re&&ue(W[Te],te[Te]);Te++)ye++;return ye}e.commonPrefixLength=i;function c(W){return[].concat(...W)}e.flatten=c;function g(W,te){let ue=typeof te=="number"?W:0;typeof te=="number"?ue=W:(ue=0,te=W);const ye=[];if(ue<=te)for(let Te=ue;Te<te;Te++)ye.push(Te);else for(let Te=ue;Te>te;Te--)ye.push(Te);return ye}e.range=g;function v(W,te,ue){return W.reduce((ye,Te)=>(ye[te(Te)]=ue?ue(Te):Te,ye),Object.create(null))}e.index=v;function A(W,te){return W.push(te),()=>R(W,te)}e.insert=A;function R(W,te){const ue=W.indexOf(te);if(ue>-1)return W.splice(ue,1),te}e.remove=R;function o(W,te,ue){const ye=W.slice(0,te),Te=W.slice(te);return ye.concat(ue,Te)}e.arrayInsert=o;function P(W,te){let ue;if(typeof te=="number"){let ye=te;ue=()=>{const Te=Math.sin(ye++)*179426549;return Te-Math.floor(Te)}}else ue=Math.random;for(let ye=W.length-1;ye>0;ye-=1){const Te=Math.floor(ue()*(ye+1)),Re=W[ye];W[ye]=W[Te],W[Te]=Re}}e.shuffle=P;function L(W,te){const ue=W.indexOf(te);ue>-1&&(W.splice(ue,1),W.unshift(te))}e.pushToStart=L;function $(W,te){const ue=W.indexOf(te);ue>-1&&(W.splice(ue,1),W.push(te))}e.pushToEnd=$;function re(W,te){return Array.isArray(W)?W.map(te):te(W)}e.mapArrayOrNot=re;function he(W){return Array.isArray(W)?W:[W]}e.asArray=he;function Q(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=Q;function z(W,te){for(const ue of W){const ye=te(ue);if(ye!==void 0)return ye}}e.mapFind=z;function V(W,te,ue){const ye=G(W,te),Te=W.length,Re=ue.length;W.length=Te+Re;for(let $e=Te-1;$e>=ye;$e--)W[$e+Re]=W[$e];for(let $e=0;$e<Re;$e++)W[$e+ye]=ue[$e]}e.insertInto=V;function T(W,te,ue,ye){const Te=G(W,te),Re=W.splice(Te,ue);return V(W,Te,ye),Re}e.splice=T;function G(W,te){return te<0?Math.max(te+W.length,0):Math.min(te,W.length)}function B(W,te){let ue=Number.MAX_SAFE_INTEGER,ye=0;return W.forEach((Te,Re)=>{const $e=te(Te);$e<ue&&(ue=$e,ye=Re)}),ye}e.minIndex=B;function j(W,te){let ue=Number.MIN_SAFE_INTEGER,ye=0;return W.forEach((Te,Re)=>{const $e=te(Te);$e>ue&&(ue=$e,ye=Re)}),ye}e.maxIndex=j;class ce{constructor(te){this.items=te,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(te){let ue=this.firstIdx;for(;ue<this.items.length&&te(this.items[ue]);)ue++;const ye=ue===this.firstIdx?null:this.items.slice(this.firstIdx,ue);return this.firstIdx=ue,ye}takeFromEndWhile(te){let ue=this.lastIdx;for(;ue>=0&&te(this.items[ue]);)ue--;const ye=ue===this.lastIdx?null:this.items.slice(ue+1,this.lastIdx+1);return this.lastIdx=ue,ye}}e.ArrayQueue=ce}),define(Ee[49],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(F){const D=this;let _=!1,I;return function(){return _||(_=!0,I=F.apply(D,arguments)),I}}e.once=m}),define(Ee[50],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class m{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=m,e.defaultGenerator=new m("id#")}),define(Ee[51],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(F){function D(b){return b&&typeof b=="object"&&typeof b[Symbol.iterator]=="function"}F.is=D;const _=Object.freeze([]);function I(){return _}F.empty=I;function*S(b){yield b}F.single=S;function y(b){return b||_}F.from=y;function C(b){return!b||b[Symbol.iterator]().next().done===!0}F.isEmpty=C;function n(b){return b[Symbol.iterator]().next().value}F.first=n;function k(b,t){for(const s of b)if(t(s))return!0;return!1}F.some=k;function l(b,t){for(const s of b)if(t(s))return s}F.find=l;function*h(b,t){for(const s of b)t(s)&&(yield s)}F.filter=h;function*a(b,t){let s=0;for(const r of b)yield t(r,s++)}F.map=a;function*d(...b){for(const t of b)for(const s of t)yield s}F.concat=d;function*f(b){for(const t of b)for(const s of t)yield s}F.concatNested=f;function E(b,t,s){let r=s;for(const i of b)r=t(r,i);return r}F.reduce=E;function*w(b,t,s=b.length){for(t<0&&(t+=b.length),s<0?s+=b.length:s>b.length&&(s=b.length);t<s;t++)yield b[t]}F.slice=w;function u(b,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,b];const r=b[Symbol.iterator]();for(let i=0;i<t;i++){const c=r.next();if(c.done)return[s,F.empty()];s.push(c.value)}return[s,{[Symbol.iterator](){return r}}]}F.consume=u;function p(b,t,s=(r,i)=>r===i){const r=b[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const c=r.next(),g=i.next();if(c.done!==g.done)return!1;if(c.done)return!0;if(!s(c.value,g.value))return!1}}F.equals=p})(m=e.Iterable||(e.Iterable={}))}),define(Ee[108],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var _;(function(t){t.DEFAULT={allowTrailingComma:!0}})(_=e.ParseOptions||(e.ParseOptions={}));function I(t,s=!1){let r=0,i=t.length,c="",g=0,v=16,A=0;function R(Q){let z=0,V=0;for(;z<Q;){const T=t.charCodeAt(r);if(T>=48&&T<=57)V=V*16+T-48;else if(T>=65&&T<=70)V=V*16+T-65+10;else if(T>=97&&T<=102)V=V*16+T-97+10;else break;r++,z++}return z<Q&&(V=-1),V}function o(Q){r=Q,c="",g=0,v=16,A=0}function P(){const Q=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&C(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&C(t.charCodeAt(r)))for(r++;r<t.length&&C(t.charCodeAt(r));)r++;else return A=3,t.substring(Q,r);let z=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&C(t.charCodeAt(r))){for(r++;r<t.length&&C(t.charCodeAt(r));)r++;z=r}else A=3;return t.substring(Q,z)}function L(){let Q="",z=r;for(;;){if(r>=i){Q+=t.substring(z,r),A=2;break}const V=t.charCodeAt(r);if(V===34){Q+=t.substring(z,r),r++;break}if(V===92){if(Q+=t.substring(z,r),r++,r>=i){A=2;break}switch(t.charCodeAt(r++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:const G=R(4);G>=0?Q+=String.fromCharCode(G):A=4;break;default:A=5}z=r;continue}if(V>=0&&V<=31)if(y(V)){Q+=t.substring(z,r),A=2;break}else A=6;r++}return Q}function $(){if(c="",A=0,g=r,r>=i)return g=i,v=17;let Q=t.charCodeAt(r);if(S(Q)){do r++,c+=String.fromCharCode(Q),Q=t.charCodeAt(r);while(S(Q));return v=15}if(y(Q))return r++,c+=String.fromCharCode(Q),Q===13&&t.charCodeAt(r)===10&&(r++,c+=`
`),v=14;switch(Q){case 123:return r++,v=1;case 125:return r++,v=2;case 91:return r++,v=3;case 93:return r++,v=4;case 58:return r++,v=6;case 44:return r++,v=5;case 34:return r++,c=L(),v=10;case 47:const z=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!y(t.charCodeAt(r));)r++;return c=t.substring(z,r),v=12}if(t.charCodeAt(r+1)===42){r+=2;const V=i-1;let T=!1;for(;r<V;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,T=!0;break}r++}return T||(r++,A=1),c=t.substring(z,r),v=13}return c+=String.fromCharCode(Q),r++,v=16;case 45:if(c+=String.fromCharCode(Q),r++,r===i||!C(t.charCodeAt(r)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=P(),v=11;default:for(;r<i&&re(Q);)r++,Q=t.charCodeAt(r);if(g!==r){switch(c=t.substring(g,r),c){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return c+=String.fromCharCode(Q),r++,v=16}}function re(Q){if(S(Q)||y(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function he(){let Q;do Q=$();while(Q>=12&&Q<=15);return Q}return{setPosition:o,getPosition:()=>r,scan:s?he:$,getToken:()=>v,getTokenValue:()=>c,getTokenOffset:()=>g,getTokenLength:()=>r-g,getTokenError:()=>A}}e.createScanner=I;function S(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function C(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function k(t,s){const r=[],i=new Object;let c;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function A(R,o,P,L){g.value=R,g.offset=o,g.length=P,g.type=L,g.colonOffset=void 0,c=g}try{u(t,{onObjectBegin:(R,o)=>{if(s<=R)throw i;c=void 0,v=s>R,r.push("")},onObjectProperty:(R,o,P)=>{if(s<o||(A(R,o,P,"property"),r[r.length-1]=R,s<=o+P))throw i},onObjectEnd:(R,o)=>{if(s<=R)throw i;c=void 0,r.pop()},onArrayBegin:(R,o)=>{if(s<=R)throw i;c=void 0,r.push(0)},onArrayEnd:(R,o)=>{if(s<=R)throw i;c=void 0,r.pop()},onLiteralValue:(R,o,P)=>{if(s<o||(A(R,o,P,b(R)),s<=o+P))throw i},onSeparator:(R,o,P)=>{if(s<=o)throw i;if(R===":"&&c&&c.type==="property")c.colonOffset=o,v=!1,c=void 0;else if(R===","){const L=r[r.length-1];typeof L=="number"?r[r.length-1]=L+1:(v=!0,r[r.length-1]=""),c=void 0}}})}catch(R){if(R!==i)throw R}return{path:r,previousNode:c,isAtPropertyKey:v,matches:R=>{let o=0;for(let P=0;o<R.length&&P<r.length;P++)if(R[o]===r[P]||R[o]==="*")o++;else if(R[o]!=="**")return!1;return o===R.length}}}e.getLocation=k;function l(t,s=[],r=_.DEFAULT){let i=null,c=[];const g=[];function v(R){Array.isArray(c)?c.push(R):i!==null&&(c[i]=R)}return u(t,{onObjectBegin:()=>{const R={};v(R),g.push(c),c=R,i=null},onObjectProperty:R=>{i=R},onObjectEnd:()=>{c=g.pop()},onArrayBegin:()=>{const R=[];v(R),g.push(c),c=R,i=null},onArrayEnd:()=>{c=g.pop()},onLiteralValue:v,onError:(R,o,P)=>{s.push({error:R,offset:o,length:P})}},r),c[0]}e.parse=l;function h(t,s=[],r=_.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(R){i.type==="property"&&(i.length=R-i.offset,i=i.parent)}function g(R){return i.children.push(R),R}u(t,{onObjectBegin:R=>{i=g({type:"object",offset:R,length:-1,parent:i,children:[]})},onObjectProperty:(R,o,P)=>{i=g({type:"property",offset:o,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:R,offset:o,length:P,parent:i})},onObjectEnd:(R,o)=>{i.length=R+o-i.offset,i=i.parent,c(R+o)},onArrayBegin:(R,o)=>{i=g({type:"array",offset:R,length:-1,parent:i,children:[]})},onArrayEnd:(R,o)=>{i.length=R+o-i.offset,i=i.parent,c(R+o)},onLiteralValue:(R,o,P)=>{g({type:b(R),offset:o,length:P,parent:i,value:R}),c(o+P)},onSeparator:(R,o,P)=>{i.type==="property"&&(R===":"?i.colonOffset=o:R===","&&c(o))},onError:(R,o,P)=>{s.push({error:R,offset:o,length:P})}},r);const A=i.children[0];return A&&delete A.parent,A}e.parseTree=h;function a(t,s){if(!t)return;let r=t;for(let i of s)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let c=!1;for(const g of r.children)if(Array.isArray(g.children)&&g.children[0].value===i){r=g.children[1],c=!0;break}if(!c)return}else{const c=i;if(r.type!=="array"||c<0||!Array.isArray(r.children)||c>=r.children.length)return;r=r.children[c]}return r}e.findNodeAtLocation=a;function d(t){if(!t.parent||!t.parent.children)return[];const s=d(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;s.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&s.push(r)}return s}e.getNodePath=d;function f(t){switch(t.type){case"array":return t.children.map(f);case"object":const s=Object.create(null);for(let r of t.children){const i=r.children[1];i&&(s[r.children[0].value]=f(i))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=f;function E(t,s,r=!1){return s>=t.offset&&s<t.offset+t.length||r&&s===t.offset+t.length}e.contains=E;function w(t,s,r=!1){if(E(t,s,r)){const i=t.children;if(Array.isArray(i))for(let c=0;c<i.length&&i[c].offset<=s;c++){const g=w(i[c],s,r);if(g)return g}return t}}e.findNodeAtOffset=w;function u(t,s,r=_.DEFAULT){const i=I(t,!1);function c(ue){return ue?()=>ue(i.getTokenOffset(),i.getTokenLength()):()=>!0}function g(ue){return ue?ye=>ue(ye,i.getTokenOffset(),i.getTokenLength()):()=>!0}const v=c(s.onObjectBegin),A=g(s.onObjectProperty),R=c(s.onObjectEnd),o=c(s.onArrayBegin),P=c(s.onArrayEnd),L=g(s.onLiteralValue),$=g(s.onSeparator),re=c(s.onComment),he=g(s.onError),Q=r&&r.disallowComments,z=r&&r.allowTrailingComma;function V(){for(;;){const ue=i.scan();switch(i.getTokenError()){case 4:T(14);break;case 5:T(15);break;case 3:T(13);break;case 1:Q||T(11);break;case 2:T(12);break;case 6:T(16);break}switch(ue){case 12:case 13:Q?T(10):re();break;case 16:T(1);break;case 15:case 14:break;default:return ue}}}function T(ue,ye=[],Te=[]){if(he(ue),ye.length+Te.length>0){let Re=i.getToken();for(;Re!==17;){if(ye.indexOf(Re)!==-1){V();break}else if(Te.indexOf(Re)!==-1)break;Re=V()}}}function G(ue){const ye=i.getTokenValue();return ue?L(ye):A(ye),V(),!0}function B(){switch(i.getToken()){case 11:let ue=0;try{ue=JSON.parse(i.getTokenValue()),typeof ue!="number"&&(T(2),ue=0)}catch(ye){T(2)}L(ue);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return V(),!0}function j(){return i.getToken()!==10?(T(3,[],[2,5]),!1):(G(!1),i.getToken()===6?($(":"),V(),te()||T(4,[],[2,5])):T(5,[],[2,5]),!0)}function ce(){v(),V();let ue=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ue||T(4,[],[]),$(","),V(),i.getToken()===2&&z)break}else ue&&T(6,[],[]);j()||T(4,[],[2,5]),ue=!0}return R(),i.getToken()!==2?T(7,[2],[]):V(),!0}function W(){o(),V();let ue=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ue||T(4,[],[]),$(","),V(),i.getToken()===4&&z)break}else ue&&T(6,[],[]);te()||T(4,[],[4,5]),ue=!0}return P(),i.getToken()!==4?T(8,[4],[]):V(),!0}function te(){switch(i.getToken()){case 3:return W();case 1:return ce();case 10:return G(!0);default:return B()}}return V(),i.getToken()===17?r.allowEmptyContent?!0:(T(4,[],[]),!1):te()?(i.getToken()!==17&&T(9,[],[]),!0):(T(4,[],[]),!1)}e.visit=u;function p(t,s){let r=I(t),i=[],c,g=0,v;do switch(v=r.getPosition(),c=r.scan(),c){case 12:case 13:case 17:g!==v&&i.push(t.substring(g,v)),s!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,s)),g=r.getPosition();break}while(c!==17);return i.join("")}e.stripComments=p;function b(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=b}),define(Ee[109],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class m{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new m(()=>D(this.getValue()))}}e.Lazy=m}),define(Ee[7],_e([0,1,49,51]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let _=null;function I(r){_=r}if(e.setDisposableTracker=I,D){const r="__is_disposable_tracked__";I(new class{trackDisposable(i){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[r]||console.log(c)},3e3)}setParent(i,c){if(i&&i!==w.None)try{i[r]=!0}catch{}}markAsDisposed(i){if(i&&i!==w.None)try{i[r]=!0}catch{}}markAsSingleton(i){}})}function S(r){return _?.trackDisposable(r),r}function y(r){_?.markAsDisposed(r)}function C(r,i){_?.setParent(r,i)}function n(r,i){if(!!_)for(const c of r)_.setParent(c,i)}function k(r){return _?.markAsSingleton(r),r}e.markAsSingleton=k;class l extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=l;function h(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=h;function a(r){if(F.Iterable.is(r)){let i=[];for(const c of r)if(c)try{c.dispose()}catch(g){i.push(g)}if(i.length===1)throw i[0];if(i.length>1)throw new l(i);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=a;function d(...r){const i=f(()=>a(r));return n(r,i),i}e.combinedDisposable=d;function f(r){const i=S({dispose:(0,m.once)(()=>{y(i),r()})});return i}e.toDisposable=f;class E{constructor(){this._toDispose=new Set,this._isDisposed=!1,S(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}clear(){try{a(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return C(i,this),this._isDisposed?E.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=E,E.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new E,S(this),C(this._store,this)}dispose(){y(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class u{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&C(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&C(i,null),i}}e.MutableDisposable=u;class p{constructor(i){this._disposable=i,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=p;class b{constructor(){this.references=new Map}acquire(i,...c){let g=this.references.get(i);g||(g={counter:0,object:this.createReferencedObject(i,...c)},this.references.set(i,g));const{object:v}=g,A=(0,m.once)(()=>{--g.counter==0&&(this.destroyReferencedObject(i,g.object),this.references.delete(i))});return g.counter++,{object:v,dispose:A}}}e.ReferenceCollection=b;class t{constructor(i){this.referenceCollection=i}async acquire(i,...c){const g=this.referenceCollection.acquire(i,...c);try{return{object:await g.object,dispose:()=>g.dispose()}}catch(v){throw g.dispose(),v}}}e.AsyncReferenceCollection=t;class s{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=s}),define(Ee[78],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(_){this.element=_,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class F{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let _=this._first;for(;_!==m.Undefined;){const I=_.next;_.prev=m.Undefined,_.next=m.Undefined,_=I}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(_){return this._insert(_,!1)}push(_){return this._insert(_,!0)}_insert(_,I){const S=new m(_);if(this._first===m.Undefined)this._first=S,this._last=S;else if(I){const C=this._last;this._last=S,S.prev=C,C.next=S}else{const C=this._first;this._first=S,S.next=C,C.prev=S}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(S))}}shift(){if(this._first!==m.Undefined){const _=this._first.element;return this._remove(this._first),_}}pop(){if(this._last!==m.Undefined){const _=this._last.element;return this._remove(this._last),_}}_remove(_){if(_.prev!==m.Undefined&&_.next!==m.Undefined){const I=_.prev;I.next=_.next,_.next.prev=I}else _.prev===m.Undefined&&_.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):_.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):_.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let _=this._first;for(;_!==m.Undefined;)yield _.element,_=_.next}}e.LinkedList=F}),function(ee,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ee=typeof globalThis!="undefined"?globalThis:ee||self,ee.marked=e())}(this,function(){"use strict";function ee(Se,De){for(var Pe=0;Pe<De.length;Pe++){var ie=De[Pe];ie.enumerable=ie.enumerable||!1,ie.configurable=!0,"value"in ie&&(ie.writable=!0),Object.defineProperty(Se,ie.key,ie)}}function e(Se,De,Pe){return De&&ee(Se.prototype,De),Pe&&ee(Se,Pe),Se}function m(Se,De){if(!!Se){if(typeof Se=="string")return F(Se,De);var Pe=Object.prototype.toString.call(Se).slice(8,-1);if(Pe==="Object"&&Se.constructor&&(Pe=Se.constructor.name),Pe==="Map"||Pe==="Set")return Array.from(Se);if(Pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Pe))return F(Se,De)}}function F(Se,De){(De==null||De>Se.length)&&(De=Se.length);for(var Pe=0,ie=new Array(De);Pe<De;Pe++)ie[Pe]=Se[Pe];return ie}function D(Se,De){var Pe;if(typeof Symbol=="undefined"||Se[Symbol.iterator]==null){if(Array.isArray(Se)||(Pe=m(Se))||De&&Se&&typeof Se.length=="number"){Pe&&(Se=Pe);var ie=0;return function(){return ie>=Se.length?{done:!0}:{done:!1,value:Se[ie++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Pe=Se[Symbol.iterator](),Pe.next.bind(Pe)}function _(Se){var De={exports:{}};return Se(De,De.exports),De.exports}var I=_(function(Se){function De(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Pe(ie){Se.exports.defaults=ie}Se.exports={defaults:De(),getDefaults:De,changeDefaults:Pe}}),S=/[&<>"']/,y=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,n=/[<>"']|&(?!#?\w+;)/g,k={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l=function(De){return k[De]};function h(Se,De){if(De){if(S.test(Se))return Se.replace(y,l)}else if(C.test(Se))return Se.replace(n,l);return Se}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(Se){return Se.replace(a,function(De,Pe){return Pe=Pe.toLowerCase(),Pe==="colon"?":":Pe.charAt(0)==="#"?Pe.charAt(1)==="x"?String.fromCharCode(parseInt(Pe.substring(2),16)):String.fromCharCode(+Pe.substring(1)):""})}var f=/(^|[^\[])\^/g;function E(Se,De){Se=Se.source||Se,De=De||"";var Pe={replace:function(oe,fe){return fe=fe.source||fe,fe=fe.replace(f,"$1"),Se=Se.replace(oe,fe),Pe},getRegex:function(){return new RegExp(Se,De)}};return Pe}var w=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(Se,De,Pe){if(Se){var ie;try{ie=decodeURIComponent(d(Pe)).replace(w,"").toLowerCase()}catch(oe){return null}if(ie.indexOf("javascript:")===0||ie.indexOf("vbscript:")===0||ie.indexOf("data:")===0)return null}De&&!u.test(Pe)&&(Pe=i(De,Pe));try{Pe=encodeURI(Pe).replace(/%25/g,"%")}catch(oe){return null}return Pe}var b={},t=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(Se,De){b[" "+Se]||(t.test(Se)?b[" "+Se]=Se+"/":b[" "+Se]=A(Se,"/",!0)),Se=b[" "+Se];var Pe=Se.indexOf(":")===-1;return De.substring(0,2)==="//"?Pe?De:Se.replace(s,"$1")+De:De.charAt(0)==="/"?Pe?De:Se.replace(r,"$1")+De:Se+De}var c={exec:function(){}};function g(Se){for(var De=1,Pe,ie;De<arguments.length;De++){Pe=arguments[De];for(ie in Pe)Object.prototype.hasOwnProperty.call(Pe,ie)&&(Se[ie]=Pe[ie])}return Se}function v(Se,De){var Pe=Se.replace(/\|/g,function(fe,ve,x){for(var me=!1,we=ve;--we>=0&&x[we]==="\\";)me=!me;return me?"|":" |"}),ie=Pe.split(/ \|/),oe=0;if(ie.length>De)ie.splice(De);else for(;ie.length<De;)ie.push("");for(;oe<ie.length;oe++)ie[oe]=ie[oe].trim().replace(/\\\|/g,"|");return ie}function A(Se,De,Pe){var ie=Se.length;if(ie===0)return"";for(var oe=0;oe<ie;){var fe=Se.charAt(ie-oe-1);if(fe===De&&!Pe)oe++;else if(fe!==De&&Pe)oe++;else break}return Se.substr(0,ie-oe)}function R(Se,De){if(Se.indexOf(De[1])===-1)return-1;for(var Pe=Se.length,ie=0,oe=0;oe<Pe;oe++)if(Se[oe]==="\\")oe++;else if(Se[oe]===De[0])ie++;else if(Se[oe]===De[1]&&(ie--,ie<0))return oe;return-1}function o(Se){Se&&Se.sanitize&&!Se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(Se,De){if(De<1)return"";for(var Pe="";De>1;)De&1&&(Pe+=Se),De>>=1,Se+=Se;return Pe+Se}var L={escape:h,unescape:d,edit:E,cleanUrl:p,resolveUrl:i,noopTest:c,merge:g,splitCells:v,rtrim:A,findClosingBracket:R,checkSanitizeDeprecation:o,repeatString:P},$=I.defaults,re=L.rtrim,he=L.splitCells,Q=L.escape,z=L.findClosingBracket;function V(Se,De,Pe){var ie=De.href,oe=De.title?Q(De.title):null,fe=Se[1].replace(/\\([\[\]])/g,"$1");return Se[0].charAt(0)!=="!"?{type:"link",raw:Pe,href:ie,title:oe,text:fe}:{type:"image",raw:Pe,href:ie,title:oe,text:Q(fe)}}function T(Se,De){var Pe=Se.match(/^(\s+)(?:```)/);if(Pe===null)return De;var ie=Pe[1];return De.split(`
`).map(function(oe){var fe=oe.match(/^\s+/);if(fe===null)return oe;var ve=fe[0];return ve.length>=ie.length?oe.slice(ie.length):oe}).join(`
`)}var G=function(){function Se(Pe){this.options=Pe||$}var De=Se.prototype;return De.space=function(ie){var oe=this.rules.block.newline.exec(ie);if(oe)return oe[0].length>1?{type:"space",raw:oe[0]}:{raw:`
`}},De.code=function(ie){var oe=this.rules.block.code.exec(ie);if(oe){var fe=oe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:oe[0],codeBlockStyle:"indented",text:this.options.pedantic?fe:re(fe,`
`)}}},De.fences=function(ie){var oe=this.rules.block.fences.exec(ie);if(oe){var fe=oe[0],ve=T(fe,oe[3]||"");return{type:"code",raw:fe,lang:oe[2]?oe[2].trim():oe[2],text:ve}}},De.heading=function(ie){var oe=this.rules.block.heading.exec(ie);if(oe){var fe=oe[2].trim();if(/#$/.test(fe)){var ve=re(fe,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&(fe=ve.trim())}return{type:"heading",raw:oe[0],depth:oe[1].length,text:fe}}},De.nptable=function(ie){var oe=this.rules.block.nptable.exec(ie);if(oe){var fe={type:"table",header:he(oe[1].replace(/^ *| *\| *$/g,"")),align:oe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:oe[3]?oe[3].replace(/\n$/,"").split(`
`):[],raw:oe[0]};if(fe.header.length===fe.align.length){var ve=fe.align.length,x;for(x=0;x<ve;x++)/^ *-+: *$/.test(fe.align[x])?fe.align[x]="right":/^ *:-+: *$/.test(fe.align[x])?fe.align[x]="center":/^ *:-+ *$/.test(fe.align[x])?fe.align[x]="left":fe.align[x]=null;for(ve=fe.cells.length,x=0;x<ve;x++)fe.cells[x]=he(fe.cells[x],fe.header.length);return fe}}},De.hr=function(ie){var oe=this.rules.block.hr.exec(ie);if(oe)return{type:"hr",raw:oe[0]}},De.blockquote=function(ie){var oe=this.rules.block.blockquote.exec(ie);if(oe){var fe=oe[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:oe[0],text:fe}}},De.list=function(ie){var oe=this.rules.block.list.exec(ie);if(oe){var fe=oe[0],ve=oe[2],x=ve.length>1,me={type:"list",raw:fe,ordered:x,start:x?+ve.slice(0,-1):"",loose:!1,items:[]},we=oe[0].match(this.rules.block.item),Ie=!1,Ne,He,et,Ke,Qe,lt,dt,_t,at=we.length;et=this.rules.block.listItemStart.exec(we[0]);for(var pe=0;pe<at;pe++){if(Ne=we[pe],fe=Ne,pe!==at-1){if(Ke=this.rules.block.listItemStart.exec(we[pe+1]),this.options.pedantic?Ke[1].length>et[1].length:Ke[1].length>et[0].length||Ke[1].length>3){we.splice(pe,2,we[pe]+`
`+we[pe+1]),pe--,at--;continue}else(!this.options.pedantic||this.options.smartLists?Ke[2][Ke[2].length-1]!==ve[ve.length-1]:x===(Ke[2].length===1))&&(Qe=we.slice(pe+1).join(`
`),me.raw=me.raw.substring(0,me.raw.length-Qe.length),pe=at-1);et=Ke}He=Ne.length,Ne=Ne.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ne.indexOf(`
 `)&&(He-=Ne.length,Ne=this.options.pedantic?Ne.replace(/^ {1,4}/gm,""):Ne.replace(new RegExp("^ {1,"+He+"}","gm"),"")),lt=Ie||/\n\n(?!\s*$)/.test(Ne),pe!==at-1&&(Ie=Ne.charAt(Ne.length-1)===`
`,lt||(lt=Ie)),lt&&(me.loose=!0),this.options.gfm&&(dt=/^\[[ xX]\] /.test(Ne),_t=void 0,dt&&(_t=Ne[1]!==" ",Ne=Ne.replace(/^\[[ xX]\] +/,""))),me.items.push({type:"list_item",raw:fe,task:dt,checked:_t,loose:lt,text:Ne})}return me}},De.html=function(ie){var oe=this.rules.block.html.exec(ie);if(oe)return{type:this.options.sanitize?"paragraph":"html",raw:oe[0],pre:!this.options.sanitizer&&(oe[1]==="pre"||oe[1]==="script"||oe[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):Q(oe[0]):oe[0]}},De.def=function(ie){var oe=this.rules.block.def.exec(ie);if(oe){oe[3]&&(oe[3]=oe[3].substring(1,oe[3].length-1));var fe=oe[1].toLowerCase().replace(/\s+/g," ");return{tag:fe,raw:oe[0],href:oe[2],title:oe[3]}}},De.table=function(ie){var oe=this.rules.block.table.exec(ie);if(oe){var fe={type:"table",header:he(oe[1].replace(/^ *| *\| *$/g,"")),align:oe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:oe[3]?oe[3].replace(/\n$/,"").split(`
`):[]};if(fe.header.length===fe.align.length){fe.raw=oe[0];var ve=fe.align.length,x;for(x=0;x<ve;x++)/^ *-+: *$/.test(fe.align[x])?fe.align[x]="right":/^ *:-+: *$/.test(fe.align[x])?fe.align[x]="center":/^ *:-+ *$/.test(fe.align[x])?fe.align[x]="left":fe.align[x]=null;for(ve=fe.cells.length,x=0;x<ve;x++)fe.cells[x]=he(fe.cells[x].replace(/^ *\| *| *\| *$/g,""),fe.header.length);return fe}}},De.lheading=function(ie){var oe=this.rules.block.lheading.exec(ie);if(oe)return{type:"heading",raw:oe[0],depth:oe[2].charAt(0)==="="?1:2,text:oe[1]}},De.paragraph=function(ie){var oe=this.rules.block.paragraph.exec(ie);if(oe)return{type:"paragraph",raw:oe[0],text:oe[1].charAt(oe[1].length-1)===`
`?oe[1].slice(0,-1):oe[1]}},De.text=function(ie){var oe=this.rules.block.text.exec(ie);if(oe)return{type:"text",raw:oe[0],text:oe[0]}},De.escape=function(ie){var oe=this.rules.inline.escape.exec(ie);if(oe)return{type:"escape",raw:oe[0],text:Q(oe[1])}},De.tag=function(ie,oe,fe){var ve=this.rules.inline.tag.exec(ie);if(ve)return!oe&&/^<a /i.test(ve[0])?oe=!0:oe&&/^<\/a>/i.test(ve[0])&&(oe=!1),!fe&&/^<(pre|code|kbd|script)(\s|>)/i.test(ve[0])?fe=!0:fe&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ve[0])&&(fe=!1),{type:this.options.sanitize?"text":"html",raw:ve[0],inLink:oe,inRawBlock:fe,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ve[0]):Q(ve[0]):ve[0]}},De.link=function(ie){var oe=this.rules.inline.link.exec(ie);if(oe){var fe=oe[2].trim();if(!this.options.pedantic&&/^</.test(fe)){if(!/>$/.test(fe))return;var ve=re(fe.slice(0,-1),"\\");if((fe.length-ve.length)%2==0)return}else{var x=z(oe[2],"()");if(x>-1){var me=oe[0].indexOf("!")===0?5:4,we=me+oe[1].length+x;oe[2]=oe[2].substring(0,x),oe[0]=oe[0].substring(0,we).trim(),oe[3]=""}}var Ie=oe[2],Ne="";if(this.options.pedantic){var He=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);He&&(Ie=He[1],Ne=He[3])}else Ne=oe[3]?oe[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test(fe)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),V(oe,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:Ne&&Ne.replace(this.rules.inline._escapes,"$1")},oe[0])}},De.reflink=function(ie,oe){var fe;if((fe=this.rules.inline.reflink.exec(ie))||(fe=this.rules.inline.nolink.exec(ie))){var ve=(fe[2]||fe[1]).replace(/\s+/g," ");if(ve=oe[ve.toLowerCase()],!ve||!ve.href){var x=fe[0].charAt(0);return{type:"text",raw:x,text:x}}return V(fe,ve,fe[0])}},De.emStrong=function(ie,oe,fe){fe===void 0&&(fe="");var ve=this.rules.inline.emStrong.lDelim.exec(ie);if(!!ve&&!(ve[3]&&fe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var x=ve[1]||ve[2]||"";if(!x||x&&(fe===""||this.rules.inline.punctuation.exec(fe))){var me=ve[0].length-1,we,Ie,Ne=me,He=0,et=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(et.lastIndex=0,oe=oe.slice(-1*ie.length+me);(ve=et.exec(oe))!=null;)if(we=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!we){if(Ie=we.length,ve[3]||ve[4]){Ne+=Ie;continue}else if((ve[5]||ve[6])&&me%3&&!((me+Ie)%3)){He+=Ie;continue}if(Ne-=Ie,!(Ne>0)){if(Ne+He-Ie<=0&&!oe.slice(et.lastIndex).match(et)&&(Ie=Math.min(Ie,Ie+Ne+He)),Math.min(me,Ie)%2)return{type:"em",raw:ie.slice(0,me+ve.index+Ie+1),text:ie.slice(1,me+ve.index+Ie)};if(Math.min(me,Ie)%2==0)return{type:"strong",raw:ie.slice(0,me+ve.index+Ie+1),text:ie.slice(2,me+ve.index+Ie-1)}}}}}},De.codespan=function(ie){var oe=this.rules.inline.code.exec(ie);if(oe){var fe=oe[2].replace(/\n/g," "),ve=/[^ ]/.test(fe),x=/^ /.test(fe)&&/ $/.test(fe);return ve&&x&&(fe=fe.substring(1,fe.length-1)),fe=Q(fe,!0),{type:"codespan",raw:oe[0],text:fe}}},De.br=function(ie){var oe=this.rules.inline.br.exec(ie);if(oe)return{type:"br",raw:oe[0]}},De.del=function(ie){var oe=this.rules.inline.del.exec(ie);if(oe)return{type:"del",raw:oe[0],text:oe[2]}},De.autolink=function(ie,oe){var fe=this.rules.inline.autolink.exec(ie);if(fe){var ve,x;return fe[2]==="@"?(ve=Q(this.options.mangle?oe(fe[1]):fe[1]),x="mailto:"+ve):(ve=Q(fe[1]),x=ve),{type:"link",raw:fe[0],text:ve,href:x,tokens:[{type:"text",raw:ve,text:ve}]}}},De.url=function(ie,oe){var fe;if(fe=this.rules.inline.url.exec(ie)){var ve,x;if(fe[2]==="@")ve=Q(this.options.mangle?oe(fe[0]):fe[0]),x="mailto:"+ve;else{var me;do me=fe[0],fe[0]=this.rules.inline._backpedal.exec(fe[0])[0];while(me!==fe[0]);ve=Q(fe[0]),fe[1]==="www."?x="http://"+ve:x=ve}return{type:"link",raw:fe[0],text:ve,href:x,tokens:[{type:"text",raw:ve,text:ve}]}}},De.inlineText=function(ie,oe,fe){var ve=this.rules.inline.text.exec(ie);if(ve){var x;return oe?x=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ve[0]):Q(ve[0]):ve[0]:x=Q(this.options.smartypants?fe(ve[0]):ve[0]),{type:"text",raw:ve[0],text:x}}},Se}(),B=L.noopTest,j=L.edit,ce=L.merge,W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:B,table:B,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=j(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,W.item=j(W.item,"gm").replace(/bull/g,W.bullet).getRegex(),W.listItemStart=j(/^( *)(bull)/).replace("bull",W.bullet).getRegex(),W.list=j(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=j(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=j(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",W._tag).getRegex(),W.blockquote=j(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=ce({},W),W.gfm=ce({},W.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.nptable=j(W.gfm.nptable).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",W._tag).getRegex(),W.gfm.table=j(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",W._tag).getRegex(),W.pedantic=ce({},W.normal,{html:j(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:B,paragraph:j(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var te={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:B,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:B,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};te._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",te.punctuation=j(te.punctuation).replace(/punctuation/g,te._punctuation).getRegex(),te.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,te.escapedEmSt=/\\\*|\\_/g,te._comment=j(W._comment).replace("(?:-->|$)","-->").getRegex(),te.emStrong.lDelim=j(te.emStrong.lDelim).replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimAst=j(te.emStrong.rDelimAst,"g").replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimUnd=j(te.emStrong.rDelimUnd,"g").replace(/punct/g,te._punctuation).getRegex(),te._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,te._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,te._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,te.autolink=j(te.autolink).replace("scheme",te._scheme).replace("email",te._email).getRegex(),te._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,te.tag=j(te.tag).replace("comment",te._comment).replace("attribute",te._attribute).getRegex(),te._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,te._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,te._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,te.link=j(te.link).replace("label",te._label).replace("href",te._href).replace("title",te._title).getRegex(),te.reflink=j(te.reflink).replace("label",te._label).getRegex(),te.reflinkSearch=j(te.reflinkSearch,"g").replace("reflink",te.reflink).replace("nolink",te.nolink).getRegex(),te.normal=ce({},te),te.pedantic=ce({},te.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:j(/^!?\[(label)\]\((.*?)\)/).replace("label",te._label).getRegex(),reflink:j(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",te._label).getRegex()}),te.gfm=ce({},te.normal,{escape:j(te.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),te.gfm.url=j(te.gfm.url,"i").replace("email",te.gfm._extended_email).getRegex(),te.breaks=ce({},te.gfm,{br:j(te.br).replace("{2,}","*").getRegex(),text:j(te.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ue={block:W,inline:te},ye=I.defaults,Te=ue.block,Re=ue.inline,$e=L.repeatString;function Ze(Se){return Se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ve(Se){var De="",Pe,ie,oe=Se.length;for(Pe=0;Pe<oe;Pe++)ie=Se.charCodeAt(Pe),Math.random()>.5&&(ie="x"+ie.toString(16)),De+="&#"+ie+";";return De}var je=function(){function Se(Pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=Pe||ye,this.options.tokenizer=this.options.tokenizer||new G,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var ie={block:Te.normal,inline:Re.normal};this.options.pedantic?(ie.block=Te.pedantic,ie.inline=Re.pedantic):this.options.gfm&&(ie.block=Te.gfm,this.options.breaks?ie.inline=Re.breaks:ie.inline=Re.gfm),this.tokenizer.rules=ie}Se.lex=function(ie,oe){var fe=new Se(oe);return fe.lex(ie)},Se.lexInline=function(ie,oe){var fe=new Se(oe);return fe.inlineTokens(ie)};var De=Se.prototype;return De.lex=function(ie){return ie=ie.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ie,this.tokens,!0),this.inline(this.tokens),this.tokens},De.blockTokens=function(ie,oe,fe){oe===void 0&&(oe=[]),fe===void 0&&(fe=!0),this.options.pedantic&&(ie=ie.replace(/^ +$/gm,""));for(var ve,x,me,we;ie;){if(ve=this.tokenizer.space(ie)){ie=ie.substring(ve.raw.length),ve.type&&oe.push(ve);continue}if(ve=this.tokenizer.code(ie)){ie=ie.substring(ve.raw.length),we=oe[oe.length-1],we&&we.type==="paragraph"?(we.raw+=`
`+ve.raw,we.text+=`
`+ve.text):oe.push(ve);continue}if(ve=this.tokenizer.fences(ie)){ie=ie.substring(ve.raw.length),oe.push(ve);continue}if(ve=this.tokenizer.heading(ie)){ie=ie.substring(ve.raw.length),oe.push(ve);continue}if(ve=this.tokenizer.nptable(ie)){ie=ie.substring(ve.raw.length),oe.push(ve);continue}if(ve=this.tokenizer.hr(ie)){ie=ie.substring(ve.raw.length),oe.push(ve);continue}if(ve=this.tokenizer.blockquote(ie)){ie=ie.substring(ve.raw.length),ve.tokens=this.blockTokens(ve.text,[],fe),oe.push(ve);continue}if(ve=this.tokenizer.list(ie)){for(ie=ie.substring(ve.raw.length),me=ve.items.length,x=0;x<me;x++)ve.items[x].tokens=this.blockTokens(ve.items[x].text,[],!1);oe.push(ve);continue}if(ve=this.tokenizer.html(ie)){ie=ie.substring(ve.raw.length),oe.push(ve);continue}if(fe&&(ve=this.tokenizer.def(ie))){ie=ie.substring(ve.raw.length),this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(ie)){ie=ie.substring(ve.raw.length),oe.push(ve);continue}if(ve=this.tokenizer.lheading(ie)){ie=ie.substring(ve.raw.length),oe.push(ve);continue}if(fe&&(ve=this.tokenizer.paragraph(ie))){ie=ie.substring(ve.raw.length),oe.push(ve);continue}if(ve=this.tokenizer.text(ie)){ie=ie.substring(ve.raw.length),we=oe[oe.length-1],we&&we.type==="text"?(we.raw+=`
`+ve.raw,we.text+=`
`+ve.text):oe.push(ve);continue}if(ie){var Ie="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return oe},De.inline=function(ie){var oe,fe,ve,x,me,we,Ie=ie.length;for(oe=0;oe<Ie;oe++)switch(we=ie[oe],we.type){case"paragraph":case"text":case"heading":{we.tokens=[],this.inlineTokens(we.text,we.tokens);break}case"table":{for(we.tokens={header:[],cells:[]},x=we.header.length,fe=0;fe<x;fe++)we.tokens.header[fe]=[],this.inlineTokens(we.header[fe],we.tokens.header[fe]);for(x=we.cells.length,fe=0;fe<x;fe++)for(me=we.cells[fe],we.tokens.cells[fe]=[],ve=0;ve<me.length;ve++)we.tokens.cells[fe][ve]=[],this.inlineTokens(me[ve],we.tokens.cells[fe][ve]);break}case"blockquote":{this.inline(we.tokens);break}case"list":{for(x=we.items.length,fe=0;fe<x;fe++)this.inline(we.items[fe].tokens);break}}return ie},De.inlineTokens=function(ie,oe,fe,ve){oe===void 0&&(oe=[]),fe===void 0&&(fe=!1),ve===void 0&&(ve=!1);var x,me,we=ie,Ie,Ne,He;if(this.tokens.links){var et=Object.keys(this.tokens.links);if(et.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(we))!=null;)et.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(we=we.slice(0,Ie.index)+"["+$e("a",Ie[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(we))!=null;)we=we.slice(0,Ie.index)+"["+$e("a",Ie[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(we))!=null;)we=we.slice(0,Ie.index)+"++"+we.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ie;){if(Ne||(He=""),Ne=!1,x=this.tokenizer.escape(ie)){ie=ie.substring(x.raw.length),oe.push(x);continue}if(x=this.tokenizer.tag(ie,fe,ve)){ie=ie.substring(x.raw.length),fe=x.inLink,ve=x.inRawBlock;var Ke=oe[oe.length-1];Ke&&x.type==="text"&&Ke.type==="text"?(Ke.raw+=x.raw,Ke.text+=x.text):oe.push(x);continue}if(x=this.tokenizer.link(ie)){ie=ie.substring(x.raw.length),x.type==="link"&&(x.tokens=this.inlineTokens(x.text,[],!0,ve)),oe.push(x);continue}if(x=this.tokenizer.reflink(ie,this.tokens.links)){ie=ie.substring(x.raw.length);var Qe=oe[oe.length-1];x.type==="link"?(x.tokens=this.inlineTokens(x.text,[],!0,ve),oe.push(x)):Qe&&x.type==="text"&&Qe.type==="text"?(Qe.raw+=x.raw,Qe.text+=x.text):oe.push(x);continue}if(x=this.tokenizer.emStrong(ie,we,He)){ie=ie.substring(x.raw.length),x.tokens=this.inlineTokens(x.text,[],fe,ve),oe.push(x);continue}if(x=this.tokenizer.codespan(ie)){ie=ie.substring(x.raw.length),oe.push(x);continue}if(x=this.tokenizer.br(ie)){ie=ie.substring(x.raw.length),oe.push(x);continue}if(x=this.tokenizer.del(ie)){ie=ie.substring(x.raw.length),x.tokens=this.inlineTokens(x.text,[],fe,ve),oe.push(x);continue}if(x=this.tokenizer.autolink(ie,Ve)){ie=ie.substring(x.raw.length),oe.push(x);continue}if(!fe&&(x=this.tokenizer.url(ie,Ve))){ie=ie.substring(x.raw.length),oe.push(x);continue}if(x=this.tokenizer.inlineText(ie,ve,Ze)){ie=ie.substring(x.raw.length),x.raw.slice(-1)!=="_"&&(He=x.raw.slice(-1)),Ne=!0,me=oe[oe.length-1],me&&me.type==="text"?(me.raw+=x.raw,me.text+=x.text):oe.push(x);continue}if(ie){var lt="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(lt);break}else throw new Error(lt)}}return oe},e(Se,null,[{key:"rules",get:function(){return{block:Te,inline:Re}}}]),Se}(),O=I.defaults,K=L.cleanUrl,J=L.escape,se=function(){function Se(Pe){this.options=Pe||O}var De=Se.prototype;return De.code=function(ie,oe,fe){var ve=(oe||"").match(/\S*/)[0];if(this.options.highlight){var x=this.options.highlight(ie,ve);x!=null&&x!==ie&&(fe=!0,ie=x)}return ie=ie.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+J(ve,!0)+'">'+(fe?ie:J(ie,!0))+`</code></pre>
`:"<pre><code>"+(fe?ie:J(ie,!0))+`</code></pre>
`},De.blockquote=function(ie){return`<blockquote>
`+ie+`</blockquote>
`},De.html=function(ie){return ie},De.heading=function(ie,oe,fe,ve){return this.options.headerIds?"<h"+oe+' id="'+this.options.headerPrefix+ve.slug(fe)+'">'+ie+"</h"+oe+`>
`:"<h"+oe+">"+ie+"</h"+oe+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(ie,oe,fe){var ve=oe?"ol":"ul",x=oe&&fe!==1?' start="'+fe+'"':"";return"<"+ve+x+`>
`+ie+"</"+ve+`>
`},De.listitem=function(ie){return"<li>"+ie+`</li>
`},De.checkbox=function(ie){return"<input "+(ie?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(ie){return"<p>"+ie+`</p>
`},De.table=function(ie,oe){return oe&&(oe="<tbody>"+oe+"</tbody>"),`<table>
<thead>
`+ie+`</thead>
`+oe+`</table>
`},De.tablerow=function(ie){return`<tr>
`+ie+`</tr>
`},De.tablecell=function(ie,oe){var fe=oe.header?"th":"td",ve=oe.align?"<"+fe+' align="'+oe.align+'">':"<"+fe+">";return ve+ie+"</"+fe+`>
`},De.strong=function(ie){return"<strong>"+ie+"</strong>"},De.em=function(ie){return"<em>"+ie+"</em>"},De.codespan=function(ie){return"<code>"+ie+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(ie){return"<del>"+ie+"</del>"},De.link=function(ie,oe,fe){if(ie=K(this.options.sanitize,this.options.baseUrl,ie),ie===null)return fe;var ve='<a href="'+J(ie)+'"';return oe&&(ve+=' title="'+oe+'"'),ve+=">"+fe+"</a>",ve},De.image=function(ie,oe,fe){if(ie=K(this.options.sanitize,this.options.baseUrl,ie),ie===null)return fe;var ve='<img src="'+ie+'" alt="'+fe+'"';return oe&&(ve+=' title="'+oe+'"'),ve+=this.options.xhtml?"/>":">",ve},De.text=function(ie){return ie},Se}(),q=function(){function Se(){}var De=Se.prototype;return De.strong=function(ie){return ie},De.em=function(ie){return ie},De.codespan=function(ie){return ie},De.del=function(ie){return ie},De.html=function(ie){return ie},De.text=function(ie){return ie},De.link=function(ie,oe,fe){return""+fe},De.image=function(ie,oe,fe){return""+fe},De.br=function(){return""},Se}(),ne=function(){function Se(){this.seen={}}var De=Se.prototype;return De.serialize=function(ie){return ie.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(ie,oe){var fe=ie,ve=0;if(this.seen.hasOwnProperty(fe)){ve=this.seen[ie];do ve++,fe=ie+"-"+ve;while(this.seen.hasOwnProperty(fe))}return oe||(this.seen[ie]=ve,this.seen[fe]=0),fe},De.slug=function(ie,oe){oe===void 0&&(oe={});var fe=this.serialize(ie);return this.getNextSafeSlug(fe,oe.dryrun)},Se}(),ge=I.defaults,Me=L.unescape,We=function(){function Se(Pe){this.options=Pe||ge,this.options.renderer=this.options.renderer||new se,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new q,this.slugger=new ne}Se.parse=function(ie,oe){var fe=new Se(oe);return fe.parse(ie)},Se.parseInline=function(ie,oe){var fe=new Se(oe);return fe.parseInline(ie)};var De=Se.prototype;return De.parse=function(ie,oe){oe===void 0&&(oe=!0);var fe="",ve,x,me,we,Ie,Ne,He,et,Ke,Qe,lt,dt,_t,at,pe,Ce,le,U,Fe=ie.length;for(ve=0;ve<Fe;ve++)switch(Qe=ie[ve],Qe.type){case"space":continue;case"hr":{fe+=this.renderer.hr();continue}case"heading":{fe+=this.renderer.heading(this.parseInline(Qe.tokens),Qe.depth,Me(this.parseInline(Qe.tokens,this.textRenderer)),this.slugger);continue}case"code":{fe+=this.renderer.code(Qe.text,Qe.lang,Qe.escaped);continue}case"table":{for(et="",He="",we=Qe.header.length,x=0;x<we;x++)He+=this.renderer.tablecell(this.parseInline(Qe.tokens.header[x]),{header:!0,align:Qe.align[x]});for(et+=this.renderer.tablerow(He),Ke="",we=Qe.cells.length,x=0;x<we;x++){for(Ne=Qe.tokens.cells[x],He="",Ie=Ne.length,me=0;me<Ie;me++)He+=this.renderer.tablecell(this.parseInline(Ne[me]),{header:!1,align:Qe.align[me]});Ke+=this.renderer.tablerow(He)}fe+=this.renderer.table(et,Ke);continue}case"blockquote":{Ke=this.parse(Qe.tokens),fe+=this.renderer.blockquote(Ke);continue}case"list":{for(lt=Qe.ordered,dt=Qe.start,_t=Qe.loose,we=Qe.items.length,Ke="",x=0;x<we;x++)pe=Qe.items[x],Ce=pe.checked,le=pe.task,at="",pe.task&&(U=this.renderer.checkbox(Ce),_t?pe.tokens.length>0&&pe.tokens[0].type==="text"?(pe.tokens[0].text=U+" "+pe.tokens[0].text,pe.tokens[0].tokens&&pe.tokens[0].tokens.length>0&&pe.tokens[0].tokens[0].type==="text"&&(pe.tokens[0].tokens[0].text=U+" "+pe.tokens[0].tokens[0].text)):pe.tokens.unshift({type:"text",text:U}):at+=U),at+=this.parse(pe.tokens,_t),Ke+=this.renderer.listitem(at,le,Ce);fe+=this.renderer.list(Ke,lt,dt);continue}case"html":{fe+=this.renderer.html(Qe.text);continue}case"paragraph":{fe+=this.renderer.paragraph(this.parseInline(Qe.tokens));continue}case"text":{for(Ke=Qe.tokens?this.parseInline(Qe.tokens):Qe.text;ve+1<Fe&&ie[ve+1].type==="text";)Qe=ie[++ve],Ke+=`
`+(Qe.tokens?this.parseInline(Qe.tokens):Qe.text);fe+=oe?this.renderer.paragraph(Ke):Ke;continue}default:{var xe='Token with "'+Qe.type+'" type was not found.';if(this.options.silent){console.error(xe);return}else throw new Error(xe)}}return fe},De.parseInline=function(ie,oe){oe=oe||this.renderer;var fe="",ve,x,me=ie.length;for(ve=0;ve<me;ve++)switch(x=ie[ve],x.type){case"escape":{fe+=oe.text(x.text);break}case"html":{fe+=oe.html(x.text);break}case"link":{fe+=oe.link(x.href,x.title,this.parseInline(x.tokens,oe));break}case"image":{fe+=oe.image(x.href,x.title,x.text);break}case"strong":{fe+=oe.strong(this.parseInline(x.tokens,oe));break}case"em":{fe+=oe.em(this.parseInline(x.tokens,oe));break}case"codespan":{fe+=oe.codespan(x.text);break}case"br":{fe+=oe.br();break}case"del":{fe+=oe.del(this.parseInline(x.tokens,oe));break}case"text":{fe+=oe.text(x.text);break}default:{var we='Token with "'+x.type+'" type was not found.';if(this.options.silent){console.error(we);return}else throw new Error(we)}}return fe},Se}(),be=L.merge,Xe=L.checkSanitizeDeprecation,H=L.escape,X=I.getDefaults,de=I.changeDefaults,Be=I.defaults;function Ue(Se,De,Pe){if(typeof Se=="undefined"||Se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");if(typeof De=="function"&&(Pe=De,De=null),De=be({},Ue.defaults,De||{}),Xe(De),Pe){var ie=De.highlight,oe;try{oe=je.lex(Se,De)}catch(me){return Pe(me)}var fe=function(we){var Ie;if(!we)try{Ie=We.parse(oe,De)}catch(Ne){we=Ne}return De.highlight=ie,we?Pe(we):Pe(null,Ie)};if(!ie||ie.length<3||(delete De.highlight,!oe.length))return fe();var ve=0;Ue.walkTokens(oe,function(me){me.type==="code"&&(ve++,setTimeout(function(){ie(me.text,me.lang,function(we,Ie){if(we)return fe(we);Ie!=null&&Ie!==me.text&&(me.text=Ie,me.escaped=!0),ve--,ve===0&&fe()})},0))}),ve===0&&fe();return}try{var x=je.lex(Se,De);return De.walkTokens&&Ue.walkTokens(x,De.walkTokens),We.parse(x,De)}catch(me){if(me.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+H(me.message+"",!0)+"</pre>";throw me}}Ue.options=Ue.setOptions=function(Se){return be(Ue.defaults,Se),de(Ue.defaults),Ue},Ue.getDefaults=X,Ue.defaults=Be,Ue.use=function(Se){var De=be({},Se);if(Se.renderer&&function(){var ie=Ue.defaults.renderer||new se,oe=function(x){var me=ie[x];ie[x]=function(){for(var we=arguments.length,Ie=new Array(we),Ne=0;Ne<we;Ne++)Ie[Ne]=arguments[Ne];var He=Se.renderer[x].apply(ie,Ie);return He===!1&&(He=me.apply(ie,Ie)),He}};for(var fe in Se.renderer)oe(fe);De.renderer=ie}(),Se.tokenizer&&function(){var ie=Ue.defaults.tokenizer||new G,oe=function(x){var me=ie[x];ie[x]=function(){for(var we=arguments.length,Ie=new Array(we),Ne=0;Ne<we;Ne++)Ie[Ne]=arguments[Ne];var He=Se.tokenizer[x].apply(ie,Ie);return He===!1&&(He=me.apply(ie,Ie)),He}};for(var fe in Se.tokenizer)oe(fe);De.tokenizer=ie}(),Se.walkTokens){var Pe=Ue.defaults.walkTokens;De.walkTokens=function(ie){Se.walkTokens(ie),Pe&&Pe(ie)}}Ue.setOptions(De)},Ue.walkTokens=function(Se,De){for(var Pe=D(Se),ie;!(ie=Pe()).done;){var oe=ie.value;switch(De(oe),oe.type){case"table":{for(var fe=D(oe.tokens.header),ve;!(ve=fe()).done;){var x=ve.value;Ue.walkTokens(x,De)}for(var me=D(oe.tokens.cells),we;!(we=me()).done;)for(var Ie=we.value,Ne=D(Ie),He;!(He=Ne()).done;){var et=He.value;Ue.walkTokens(et,De)}break}case"list":{Ue.walkTokens(oe.items,De);break}default:oe.tokens&&Ue.walkTokens(oe.tokens,De)}}},Ue.parseInline=function(Se,De){if(typeof Se=="undefined"||Se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");De=be({},Ue.defaults,De||{}),Xe(De);try{var Pe=je.lexInline(Se,De);return De.walkTokens&&Ue.walkTokens(Pe,De.walkTokens),We.parseInline(Pe,De)}catch(ie){if(ie.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+H(ie.message+"",!0)+"</pre>";throw ie}},Ue.Parser=We,Ue.parser=We.parse,Ue.Renderer=se,Ue.TextRenderer=q,Ue.Lexer=je,Ue.lexer=je.lex,Ue.Tokenizer=G,Ue.Slugger=ne,Ue.parse=Ue;var tt=Ue;return tt}),define(Ee[79],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function m(I,S,y){return Math.min(Math.max(I,S),y)}e.clamp=m;function F(I,S){return(S+I%S)%S}e.rot=F;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class _{constructor(){this._n=1,this._val=0}update(S){return this._val=this._val+(S-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=_}),function(){function ee(D){const _=[];typeof D=="number"&&_.push("code/timeOrigin",D);function I(y){_.push(y,Date.now())}function S(){const y=[];for(let C=0;C<_.length;C+=2)y.push({name:_[C],startTime:_[C+1]});return y}return{mark:I,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const _=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const I of performance.getEntriesByType("mark"))_.push({name:I.name,startTime:Math.round(D+I.startTime)});return _}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function m(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=m(F))}(),define(Ee[21],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const m="en";let F=!1,D=!1,_=!1,I=!1,S=!1,y=!1,C=!1,n,k=m,l,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?a=e.globals.vscode.process:typeof process!="undefined"&&(a=process);const d=typeof a?.versions?.electron=="string"&&a.type==="renderer";if(e.isElectronSandboxed=d&&a?.sandboxed,e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=a?.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!d)h=navigator.userAgent,F=h.indexOf("Windows")>=0,D=h.indexOf("Macintosh")>=0,C=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=h.indexOf("Linux")>=0,y=!0,n=navigator.language,k=n;else if(typeof a=="object"){F=a.platform==="win32",D=a.platform==="darwin",_=a.platform==="linux",I=_&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,n=m,k=m;const r=a.env.VSCODE_NLS_CONFIG;if(r)try{const i=JSON.parse(r),c=i.availableLanguages["*"];n=i.locale,k=c||m,l=i._translationsConfigFile}catch(i){}S=!0}else console.error("Unable to resolve platform.");var f;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function E(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=E;let w=0;D?w=1:F?w=3:_&&(w=2),e.isWindows=F,e.isMacintosh=D,e.isLinux=_,e.isLinuxSnap=I,e.isNative=S,e.isWeb=y,e.isIOS=C,e.platform=w,e.userAgent=h,e.language=k;var u;(function(r){function i(){return e.language}r.value=i;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=c;function g(){return e.language==="en"}r.isDefault=g})(u=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=l,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",v=>{if(v.data&&v.data.vscodeSetImmediateId)for(let A=0,R=c.length;A<R;A++){const o=c[A];if(o.id===v.data.vscodeSetImmediateId){c.splice(A,1),o.callback();return}}});let g=0;return v=>{const A=++g;c.push({id:A,callback:v}),e.globals.postMessage({vscodeSetImmediateId:A},"*")}}if(typeof a?.nextTick=="function")return a.nextTick.bind(a);const i=Promise.resolve();return c=>i.then(c)}();var p;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(p=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||C?2:F?1:3;let b=!0,t=!1;function s(){if(!t){t=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,b=new Uint16Array(r.buffer)[0]===(2<<8)+1}return b}e.isLittleEndian=s}),define(Ee[40],_e([0,1,21]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let F;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const D=m.globals.vscode.process;F={get platform(){return D.platform},get env(){return D.env},cwd(){return D.cwd()},nextTick(_){return(0,m.setImmediate)(_)}}}else typeof process!="undefined"?F={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:F={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},nextTick(D){return(0,m.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.platform=F.platform,e.nextTick=F.nextTick}),define(Ee[14],_e([0,1,40]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const F=65,D=97,_=90,I=122,S=46,y=47,C=92,n=58,k=63;class l extends Error{constructor(p,b,t){let s;typeof b=="string"&&b.indexOf("not ")===0?(s="must not be",b=b.replace(/^not /,"")):s="must be";const r=p.indexOf(".")!==-1?"property":"argument";let i=`The "${p}" ${r} ${s} of type ${b}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function h(u,p){if(typeof u!="string")throw new l(p,"string",u)}function a(u){return u===y||u===C}function d(u){return u===y}function f(u){return u>=F&&u<=_||u>=D&&u<=I}function E(u,p,b,t){let s="",r=0,i=-1,c=0,g=0;for(let v=0;v<=u.length;++v){if(v<u.length)g=u.charCodeAt(v);else{if(t(g))break;g=y}if(t(g)){if(!(i===v-1||c===1))if(c===2){if(s.length<2||r!==2||s.charCodeAt(s.length-1)!==S||s.charCodeAt(s.length-2)!==S){if(s.length>2){const A=s.lastIndexOf(b);A===-1?(s="",r=0):(s=s.slice(0,A),r=s.length-1-s.lastIndexOf(b)),i=v,c=0;continue}else if(s.length!==0){s="",r=0,i=v,c=0;continue}}p&&(s+=s.length>0?`${b}..`:"..",r=2)}else s.length>0?s+=`${b}${u.slice(i+1,v)}`:s=u.slice(i+1,v),r=v-i-1;i=v,c=0}else g===S&&c!==-1?++c:c=-1}return s}function w(u,p){if(p===null||typeof p!="object")throw new l("pathObject","Object",p);const b=p.dir||p.root,t=p.base||`${p.name||""}${p.ext||""}`;return b?b===p.root?`${b}${t}`:`${b}${u}${t}`:t}e.win32={resolve(...u){let p="",b="",t=!1;for(let s=u.length-1;s>=-1;s--){let r;if(s>=0){if(r=u[s],h(r,"path"),r.length===0)continue}else p.length===0?r=m.cwd():(r=m.env[`=${p}`]||m.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==p.toLowerCase()&&r.charCodeAt(2)===C)&&(r=`${p}\\`));const i=r.length;let c=0,g="",v=!1;const A=r.charCodeAt(0);if(i===1)a(A)&&(c=1,v=!0);else if(a(A))if(v=!0,a(r.charCodeAt(1))){let R=2,o=R;for(;R<i&&!a(r.charCodeAt(R));)R++;if(R<i&&R!==o){const P=r.slice(o,R);for(o=R;R<i&&a(r.charCodeAt(R));)R++;if(R<i&&R!==o){for(o=R;R<i&&!a(r.charCodeAt(R));)R++;(R===i||R!==o)&&(g=`\\\\${P}\\${r.slice(o,R)}`,c=R)}}}else c=1;else f(A)&&r.charCodeAt(1)===n&&(g=r.slice(0,2),c=2,i>2&&a(r.charCodeAt(2))&&(v=!0,c=3));if(g.length>0)if(p.length>0){if(g.toLowerCase()!==p.toLowerCase())continue}else p=g;if(t){if(p.length>0)break}else if(b=`${r.slice(c)}\\${b}`,t=v,v&&p.length>0)break}return b=E(b,!t,"\\",a),t?`${p}\\${b}`:`${p}${b}`||"."},normalize(u){h(u,"path");const p=u.length;if(p===0)return".";let b=0,t,s=!1;const r=u.charCodeAt(0);if(p===1)return d(r)?"\\":u;if(a(r))if(s=!0,a(u.charCodeAt(1))){let c=2,g=c;for(;c<p&&!a(u.charCodeAt(c));)c++;if(c<p&&c!==g){const v=u.slice(g,c);for(g=c;c<p&&a(u.charCodeAt(c));)c++;if(c<p&&c!==g){for(g=c;c<p&&!a(u.charCodeAt(c));)c++;if(c===p)return`\\\\${v}\\${u.slice(g)}\\`;c!==g&&(t=`\\\\${v}\\${u.slice(g,c)}`,b=c)}}}else b=1;else f(r)&&u.charCodeAt(1)===n&&(t=u.slice(0,2),b=2,p>2&&a(u.charCodeAt(2))&&(s=!0,b=3));let i=b<p?E(u.slice(b),!s,"\\",a):"";return i.length===0&&!s&&(i="."),i.length>0&&a(u.charCodeAt(p-1))&&(i+="\\"),t===void 0?s?`\\${i}`:i:s?`${t}\\${i}`:`${t}${i}`},isAbsolute(u){h(u,"path");const p=u.length;if(p===0)return!1;const b=u.charCodeAt(0);return a(b)||p>2&&f(b)&&u.charCodeAt(1)===n&&a(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let p,b;for(let r=0;r<u.length;++r){const i=u[r];h(i,"path"),i.length>0&&(p===void 0?p=b=i:p+=`\\${i}`)}if(p===void 0)return".";let t=!0,s=0;if(typeof b=="string"&&a(b.charCodeAt(0))){++s;const r=b.length;r>1&&a(b.charCodeAt(1))&&(++s,r>2&&(a(b.charCodeAt(2))?++s:t=!1))}if(t){for(;s<p.length&&a(p.charCodeAt(s));)s++;s>=2&&(p=`\\${p.slice(s)}`)}return e.win32.normalize(p)},relative(u,p){if(h(u,"from"),h(p,"to"),u===p)return"";const b=e.win32.resolve(u),t=e.win32.resolve(p);if(b===t||(u=b.toLowerCase(),p=t.toLowerCase(),u===p))return"";let s=0;for(;s<u.length&&u.charCodeAt(s)===C;)s++;let r=u.length;for(;r-1>s&&u.charCodeAt(r-1)===C;)r--;const i=r-s;let c=0;for(;c<p.length&&p.charCodeAt(c)===C;)c++;let g=p.length;for(;g-1>c&&p.charCodeAt(g-1)===C;)g--;const v=g-c,A=i<v?i:v;let R=-1,o=0;for(;o<A;o++){const L=u.charCodeAt(s+o);if(L!==p.charCodeAt(c+o))break;L===C&&(R=o)}if(o!==A){if(R===-1)return t}else{if(v>A){if(p.charCodeAt(c+o)===C)return t.slice(c+o+1);if(o===2)return t.slice(c+o)}i>A&&(u.charCodeAt(s+o)===C?R=o:o===2&&(R=3)),R===-1&&(R=0)}let P="";for(o=s+R+1;o<=r;++o)(o===r||u.charCodeAt(o)===C)&&(P+=P.length===0?"..":"\\..");return c+=R,P.length>0?`${P}${t.slice(c,g)}`:(t.charCodeAt(c)===C&&++c,t.slice(c,g))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const p=e.win32.resolve(u);if(p.length<=2)return u;if(p.charCodeAt(0)===C){if(p.charCodeAt(1)===C){const b=p.charCodeAt(2);if(b!==k&&b!==S)return`\\\\?\\UNC\\${p.slice(2)}`}}else if(f(p.charCodeAt(0))&&p.charCodeAt(1)===n&&p.charCodeAt(2)===C)return`\\\\?\\${p}`;return u},dirname(u){h(u,"path");const p=u.length;if(p===0)return".";let b=-1,t=0;const s=u.charCodeAt(0);if(p===1)return a(s)?u:".";if(a(s)){if(b=t=1,a(u.charCodeAt(1))){let c=2,g=c;for(;c<p&&!a(u.charCodeAt(c));)c++;if(c<p&&c!==g){for(g=c;c<p&&a(u.charCodeAt(c));)c++;if(c<p&&c!==g){for(g=c;c<p&&!a(u.charCodeAt(c));)c++;if(c===p)return u;c!==g&&(b=t=c+1)}}}}else f(s)&&u.charCodeAt(1)===n&&(b=p>2&&a(u.charCodeAt(2))?3:2,t=b);let r=-1,i=!0;for(let c=p-1;c>=t;--c)if(a(u.charCodeAt(c))){if(!i){r=c;break}}else i=!1;if(r===-1){if(b===-1)return".";r=b}return u.slice(0,r)},basename(u,p){p!==void 0&&h(p,"ext"),h(u,"path");let b=0,t=-1,s=!0,r;if(u.length>=2&&f(u.charCodeAt(0))&&u.charCodeAt(1)===n&&(b=2),p!==void 0&&p.length>0&&p.length<=u.length){if(p===u)return"";let i=p.length-1,c=-1;for(r=u.length-1;r>=b;--r){const g=u.charCodeAt(r);if(a(g)){if(!s){b=r+1;break}}else c===-1&&(s=!1,c=r+1),i>=0&&(g===p.charCodeAt(i)?--i==-1&&(t=r):(i=-1,t=c))}return b===t?t=c:t===-1&&(t=u.length),u.slice(b,t)}for(r=u.length-1;r>=b;--r)if(a(u.charCodeAt(r))){if(!s){b=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":u.slice(b,t)},extname(u){h(u,"path");let p=0,b=-1,t=0,s=-1,r=!0,i=0;u.length>=2&&u.charCodeAt(1)===n&&f(u.charCodeAt(0))&&(p=t=2);for(let c=u.length-1;c>=p;--c){const g=u.charCodeAt(c);if(a(g)){if(!r){t=c+1;break}continue}s===-1&&(r=!1,s=c+1),g===S?b===-1?b=c:i!==1&&(i=1):b!==-1&&(i=-1)}return b===-1||s===-1||i===0||i===1&&b===s-1&&b===t+1?"":u.slice(b,s)},format:w.bind(null,"\\"),parse(u){h(u,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return p;const b=u.length;let t=0,s=u.charCodeAt(0);if(b===1)return a(s)?(p.root=p.dir=u,p):(p.base=p.name=u,p);if(a(s)){if(t=1,a(u.charCodeAt(1))){let R=2,o=R;for(;R<b&&!a(u.charCodeAt(R));)R++;if(R<b&&R!==o){for(o=R;R<b&&a(u.charCodeAt(R));)R++;if(R<b&&R!==o){for(o=R;R<b&&!a(u.charCodeAt(R));)R++;R===b?t=R:R!==o&&(t=R+1)}}}}else if(f(s)&&u.charCodeAt(1)===n){if(b<=2)return p.root=p.dir=u,p;if(t=2,a(u.charCodeAt(2))){if(b===3)return p.root=p.dir=u,p;t=3}}t>0&&(p.root=u.slice(0,t));let r=-1,i=t,c=-1,g=!0,v=u.length-1,A=0;for(;v>=t;--v){if(s=u.charCodeAt(v),a(s)){if(!g){i=v+1;break}continue}c===-1&&(g=!1,c=v+1),s===S?r===-1?r=v:A!==1&&(A=1):r!==-1&&(A=-1)}return c!==-1&&(r===-1||A===0||A===1&&r===c-1&&r===i+1?p.base=p.name=u.slice(i,c):(p.name=u.slice(i,r),p.base=u.slice(i,c),p.ext=u.slice(r,c))),i>0&&i!==t?p.dir=u.slice(0,i-1):p.dir=p.root,p},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let p="",b=!1;for(let t=u.length-1;t>=-1&&!b;t--){const s=t>=0?u[t]:m.cwd();h(s,"path"),s.length!==0&&(p=`${s}/${p}`,b=s.charCodeAt(0)===y)}return p=E(p,!b,"/",d),b?`/${p}`:p.length>0?p:"."},normalize(u){if(h(u,"path"),u.length===0)return".";const p=u.charCodeAt(0)===y,b=u.charCodeAt(u.length-1)===y;return u=E(u,!p,"/",d),u.length===0?p?"/":b?"./":".":(b&&(u+="/"),p?`/${u}`:u)},isAbsolute(u){return h(u,"path"),u.length>0&&u.charCodeAt(0)===y},join(...u){if(u.length===0)return".";let p;for(let b=0;b<u.length;++b){const t=u[b];h(t,"path"),t.length>0&&(p===void 0?p=t:p+=`/${t}`)}return p===void 0?".":e.posix.normalize(p)},relative(u,p){if(h(u,"from"),h(p,"to"),u===p||(u=e.posix.resolve(u),p=e.posix.resolve(p),u===p))return"";const b=1,t=u.length,s=t-b,r=1,i=p.length-r,c=s<i?s:i;let g=-1,v=0;for(;v<c;v++){const R=u.charCodeAt(b+v);if(R!==p.charCodeAt(r+v))break;R===y&&(g=v)}if(v===c)if(i>c){if(p.charCodeAt(r+v)===y)return p.slice(r+v+1);if(v===0)return p.slice(r+v)}else s>c&&(u.charCodeAt(b+v)===y?g=v:v===0&&(g=0));let A="";for(v=b+g+1;v<=t;++v)(v===t||u.charCodeAt(v)===y)&&(A+=A.length===0?"..":"/..");return`${A}${p.slice(r+g)}`},toNamespacedPath(u){return u},dirname(u){if(h(u,"path"),u.length===0)return".";const p=u.charCodeAt(0)===y;let b=-1,t=!0;for(let s=u.length-1;s>=1;--s)if(u.charCodeAt(s)===y){if(!t){b=s;break}}else t=!1;return b===-1?p?"/":".":p&&b===1?"//":u.slice(0,b)},basename(u,p){p!==void 0&&h(p,"ext"),h(u,"path");let b=0,t=-1,s=!0,r;if(p!==void 0&&p.length>0&&p.length<=u.length){if(p===u)return"";let i=p.length-1,c=-1;for(r=u.length-1;r>=0;--r){const g=u.charCodeAt(r);if(g===y){if(!s){b=r+1;break}}else c===-1&&(s=!1,c=r+1),i>=0&&(g===p.charCodeAt(i)?--i==-1&&(t=r):(i=-1,t=c))}return b===t?t=c:t===-1&&(t=u.length),u.slice(b,t)}for(r=u.length-1;r>=0;--r)if(u.charCodeAt(r)===y){if(!s){b=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":u.slice(b,t)},extname(u){h(u,"path");let p=-1,b=0,t=-1,s=!0,r=0;for(let i=u.length-1;i>=0;--i){const c=u.charCodeAt(i);if(c===y){if(!s){b=i+1;break}continue}t===-1&&(s=!1,t=i+1),c===S?p===-1?p=i:r!==1&&(r=1):p!==-1&&(r=-1)}return p===-1||t===-1||r===0||r===1&&p===t-1&&p===b+1?"":u.slice(p,t)},format:w.bind(null,"/"),parse(u){h(u,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return p;const b=u.charCodeAt(0)===y;let t;b?(p.root="/",t=1):t=0;let s=-1,r=0,i=-1,c=!0,g=u.length-1,v=0;for(;g>=t;--g){const A=u.charCodeAt(g);if(A===y){if(!c){r=g+1;break}continue}i===-1&&(c=!1,i=g+1),A===S?s===-1?s=g:v!==1&&(v=1):s!==-1&&(v=-1)}if(i!==-1){const A=r===0&&b?1:r;s===-1||v===0||v===1&&s===i-1&&s===r+1?p.base=p.name=u.slice(A,i):(p.name=u.slice(A,s),p.base=u.slice(A,i),p.ext=u.slice(s,i))}return r>0?p.dir=u.slice(0,r-1):b&&(p.dir="/"),p},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Ee[52],_e([0,1,21]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const F=m.globals.performance&&typeof m.globals.performance.now=="function";class D{constructor(I){this._highResolution=F&&I,this._startTime=this._now(),this._stopTime=-1}static create(I=!0){return new D(I)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=D}),define(Ee[3],_e([0,1,12,49,7,78,52]),function(ee,e,m,F,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var S;(function(u){u.None=()=>D.Disposable.None;function p(Q){return(z,V=null,T)=>{let G=!1,B;return B=Q(j=>{if(!G)return B?B.dispose():G=!0,z.call(V,j)},null,T),G&&B.dispose(),B}}u.once=p;function b(Q,z){return g((V,T=null,G)=>Q(B=>V.call(T,z(B)),null,G))}u.map=b;function t(Q,z){return g((V,T=null,G)=>Q(B=>{z(B),V.call(T,B)},null,G))}u.forEach=t;function s(Q,z){return g((V,T=null,G)=>Q(B=>z(B)&&V.call(T,B),null,G))}u.filter=s;function r(Q){return Q}u.signal=r;function i(...Q){return(z,V=null,T)=>(0,D.combinedDisposable)(...Q.map(G=>G(B=>z.call(V,B),null,T)))}u.any=i;function c(Q,z,V){let T=V;return b(Q,G=>(T=z(T,G),T))}u.reduce=c;function g(Q){let z;const V=new l({onFirstListenerAdd(){z=Q(V.fire,V)},onLastListenerRemove(){z.dispose()}});return V.event}function v(Q,z,V=100,T=!1,G){let B,j,ce,W=0;const te=new l({leakWarningThreshold:G,onFirstListenerAdd(){B=Q(ue=>{W++,j=z(j,ue),T&&!ce&&(te.fire(j),j=void 0),clearTimeout(ce),ce=setTimeout(()=>{const ye=j;j=void 0,ce=void 0,(!T||W>1)&&te.fire(ye),W=0},V)})},onLastListenerRemove(){B.dispose()}});return te.event}u.debounce=v;function A(Q,z=(V,T)=>V===T){let V=!0,T;return s(Q,G=>{const B=V||!z(G,T);return V=!1,T=G,B})}u.latch=A;function R(Q,z){return[u.filter(Q,z),u.filter(Q,V=>!z(V))]}u.split=R;function o(Q,z=!1,V=[]){let T=V.slice(),G=Q(ce=>{T?T.push(ce):j.fire(ce)});const B=()=>{T&&T.forEach(ce=>j.fire(ce)),T=null},j=new l({onFirstListenerAdd(){G||(G=Q(ce=>j.fire(ce)))},onFirstListenerDidAdd(){T&&(z?setTimeout(B):B())},onLastListenerRemove(){G&&G.dispose(),G=null}});return j.event}u.buffer=o;class P{constructor(z){this.event=z}map(z){return new P(b(this.event,z))}forEach(z){return new P(t(this.event,z))}filter(z){return new P(s(this.event,z))}reduce(z,V){return new P(c(this.event,z,V))}latch(){return new P(A(this.event))}debounce(z,V=100,T=!1,G){return new P(v(this.event,z,V,T,G))}on(z,V,T){return this.event(z,V,T)}once(z,V,T){return p(this.event)(z,V,T)}}function L(Q){return new P(Q)}u.chain=L;function $(Q,z,V=T=>T){const T=(...ce)=>j.fire(V(...ce)),G=()=>Q.on(z,T),B=()=>Q.removeListener(z,T),j=new l({onFirstListenerAdd:G,onLastListenerRemove:B});return j.event}u.fromNodeEventEmitter=$;function re(Q,z,V=T=>T){const T=(...ce)=>j.fire(V(...ce)),G=()=>Q.addEventListener(z,T),B=()=>Q.removeEventListener(z,T),j=new l({onFirstListenerAdd:G,onLastListenerRemove:B});return j.event}u.fromDOMEventEmitter=re;function he(Q){return new Promise(z=>p(Q)(z))}u.toPromise=he})(S=e.Event||(e.Event={}));class y{constructor(p){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${p}_${y._idPool++}`}start(p){this._stopWatch=new I.StopWatch(!0),this._listenerCount=p}stop(){if(this._stopWatch){const p=this._stopWatch.elapsed();this._elapsedOverall+=p,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${p.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let C=-1;function n(u){const p=C;return C=u,{dispose(){C=p}}}e.setGlobalLeakWarningThreshold=n;class k{constructor(p,b=Math.random().toString(18).slice(2,5)){this.customThreshold=p,this.name=b,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(p){let b=C;if(typeof this.customThreshold=="number"&&(b=this.customThreshold),b<=0||p<b)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(t)||0;if(this._stacks.set(t,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=b*.5;let r,i=0;for(const[c,g]of this._stacks)(!r||i<g)&&(r=c,i=g);console.warn(`[${this.name}] potential listener LEAK detected, having ${p} listeners already. MOST frequent listener (${i}):`),console.warn(r)}return()=>{const r=this._stacks.get(t)||0;this._stacks.set(t,r-1)}}}class l{constructor(p){this._disposed=!1,this._options=p,this._leakageMon=C>0?new k(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(p,b,t)=>{this._listeners||(this._listeners=new _.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(b?[p,b]:p);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,p,b);const i=this._leakageMon?.check(this._listeners.size),c=(0,D.toDisposable)(()=>{i&&i(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof D.DisposableStore?t.add(c):Array.isArray(t)&&t.push(c),c}),this._event}fire(p){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new _.LinkedList);for(let b of this._listeners)this._deliveryQueue.push([b,p]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[b,t]=this._deliveryQueue.shift();try{typeof b=="function"?b.call(void 0,t):b[0].call(b[1],t)}catch(s){(0,m.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=l;class h extends l{async fireAsync(p,b,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new _.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,p]);for(;this._asyncDeliveryQueue.size>0&&!b.isCancellationRequested;){const[s,r]=this._asyncDeliveryQueue.shift(),i=[],c={...r,waitUntil:g=>{if(Object.isFrozen(i))throw new Error("waitUntil can NOT be called asynchronous");t&&(g=t(g,typeof s=="function"?s:s[0])),i.push(g)}};try{typeof s=="function"?s.call(void 0,c):s[0].call(s[1],c)}catch(g){(0,m.onUnexpectedError)(g);continue}Object.freeze(i),await Promise.allSettled(i).then(g=>{for(const v of g)v.status==="rejected"&&(0,m.onUnexpectedError)(v.reason)})}}}}e.AsyncEmitter=h;class a extends l{constructor(p){super(p);this._isPaused=0,this._eventQueue=new _.LinkedList,this._mergeFn=p?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const p=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(p))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(p){this._listeners&&(this._isPaused!==0?this._eventQueue.push(p):super.fire(p))}}e.PauseableEmitter=a;class d extends a{constructor(p){super(p);this._delay=p.delay??100}fire(p){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(p)}}e.DebounceEmitter=d;class f{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(p){const b={event:p,listener:null};this.events.push(b),this.hasListeners&&this.hook(b);const t=()=>{this.hasListeners&&this.unhook(b);const s=this.events.indexOf(b);this.events.splice(s,1)};return(0,D.toDisposable)((0,F.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(p=>this.hook(p))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(p=>this.unhook(p))}hook(p){p.listener=p.event(b=>this.emitter.fire(b))}unhook(p){p.listener&&p.listener.dispose(),p.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=f;class E{constructor(){this.buffers=[]}wrapEvent(p){return(b,t,s)=>p(r=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>b.call(t,r)):b.call(t,r)},void 0,s)}bufferEvents(p){const b=[];this.buffers.push(b);const t=p();return this.buffers.pop(),b.forEach(s=>s()),t}}e.EventBufferer=E;class w{constructor(){this.listening=!1,this.inputEvent=S.None,this.inputEventListener=D.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(p){this.inputEvent=p,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=p(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=w}),define(Ee[18],_e([0,1,3]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const F=Object.freeze(function(S,y){const C=setTimeout(S.bind(y),0);return{dispose(){clearTimeout(C)}}});var D;(function(S){function y(C){return C===S.None||C===S.Cancelled||C instanceof _?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}S.isCancellationToken=y,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(D=e.CancellationToken||(e.CancellationToken={}));class _{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?F:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class I{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new _),this._token}cancel(){this._token?this._token instanceof _&&this._token.cancel():this._token=D.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof _&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=I}),define(Ee[53],_e([0,1,3]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class F{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(k){const l=this._icons.get(k.id);l?k.description?l.description=k.description:console.error(`Duplicate registration of codicon ${k.id}`):(this._icons.set(k.id,k),this._onDidRegister.fire(k))}get(k){return this._icons.get(k)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new F;e.iconRegistry=D;function _(n,k){return new S(n,k)}e.registerCodicon=_;function I(n){return n?n.replace(/\$\((.*?)\)/g,(k,l)=>` ${l} `).trim():""}e.getCodiconAriaLabel=I;class S{constructor(k,l,h){this.id=k,this.definition=l,this.description=h,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=S;function y(n,k){const l=["codicon","codicon-"+n];return k&&l.push("codicon-modifier-"+k),l}e.getClassNamesArray=y;var C;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const k=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function l(d){if(d instanceof S)return["codicon","codicon-"+d.id];const f=k.exec(d.id);if(!f)return l(S.error);let[,E,w]=f;const u=["codicon","codicon-"+E];return w&&u.push("codicon-modifier-"+w.substr(1)),u}n.asClassNameArray=l;function h(d){return l(d).join(" ")}n.asClassName=h;function a(d){return"."+l(d).join(".")}n.asCSSSelector=a})(C=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(S=e.Codicon||(e.Codicon={}))}),define(Ee[110],_e([0,1,12,7]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(u){const p=u;return p?[p.on,p.pause,p.resume,p.destroy].every(b=>typeof b=="function"):!1}e.isReadableStream=D;function _(u){const p=u;return p?D(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=_;function I(u,p){return new S(u,p)}e.newWriteableStream=I;class S{constructor(p,b){this.reducer=p,this.options=b,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(b=>this.pendingWritePromises.push(b))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p!="undefined"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(b=>b(p))}emitError(p){this.listeners.error.length===0?(0,m.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(b=>b(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,b){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(b),this.resume();break;case"end":this.listeners.end.push(b),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(b),this.state.flowing&&this.flowErrors();break}}removeListener(p,b){if(this.state.destroyed)return;let t;switch(p){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const s=t.indexOf(b);s>=0&&t.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const b=[...this.pendingWritePromises];this.pendingWritePromises.length=0,b.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(u,p){const b=[];let t;for(;(t=u.read())!==null;)b.push(t);return p(b)}e.consumeReadable=y;function C(u,p,b){const t=[];let s;for(;(s=u.read())!==null&&t.length<b;)t.push(s);return s===null&&t.length>0?p(t):{read:()=>{if(t.length>0)return t.shift();if(typeof s!="undefined"){const r=s;return s=void 0,r}return u.read()}}}e.peekReadable=C;function n(u,p){return new Promise((b,t)=>{const s=[];k(u,{onData:r=>{p&&s.push(r)},onError:r=>{p?t(r):b(void 0)},onEnd:()=>{b(p?p(s):void 0)}})})}e.consumeStream=n;function k(u,p){u.on("error",b=>p.onError(b)),u.on("end",()=>p.onEnd()),u.on("data",b=>p.onData(b))}e.listenStream=k;function l(u,p){return new Promise((b,t)=>{const s=new F.DisposableStore,r=[],i=v=>{if(r.push(v),r.length>p)return s.dispose(),u.pause(),b({stream:u,buffer:r,ended:!1})},c=v=>t(v),g=()=>b({stream:u,buffer:r,ended:!0});s.add((0,F.toDisposable)(()=>u.removeListener("error",c))),u.on("error",c),s.add((0,F.toDisposable)(()=>u.removeListener("end",g))),u.on("end",g),s.add((0,F.toDisposable)(()=>u.removeListener("data",i))),u.on("data",i)})}e.peekStream=l;function h(u,p){const b=I(p);return b.end(u),b}e.toStream=h;function a(){const u=I(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=a;function d(u){let p=!1;return{read:()=>p?null:(p=!0,u)}}e.toReadable=d;function f(u,p,b){const t=I(b);return k(u,{onData:s=>t.write(p.data(s)),onError:s=>t.error(p.error?p.error(s):s),onEnd:()=>t.end()}),t}e.transform=f;function E(u,p,b){let t=!1;return{read:()=>{const s=p.read();return t?s:(t=!0,s!==null?b([u,s]):u)}}}e.prefixedReadable=E;function w(u,p,b){let t=!1;const s=I(b);return k(p,{onData:r=>t?s.write(r):(t=!0,s.write(b([u,r]))),onError:r=>s.error(r),onEnd:()=>{t||(t=!0,s.write(u)),s.end()}}),s}e.prefixedStream=w}),define(Ee[8],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function m(x){return!x||typeof x!="string"?!0:x.trim().length===0}e.isFalsyOrWhitespace=m;const F=/{(\d+)}/g;function D(x,...me){return me.length===0?x:x.replace(F,function(we,Ie){const Ne=parseInt(Ie,10);return isNaN(Ne)||Ne<0||Ne>=me.length?we:me[Ne]})}e.format=D;const _=/{([^}]+)}/g;function I(x,me){return x.replace(_,(we,Ie)=>me[Ie]??we)}e.format2=I;function S(x){return x.replace(/[<>&]/g,function(me){switch(me){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return me}})}e.escape=S;function y(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function C(x,me){let we=0;const Ie=me.charCodeAt(0);for(let Ne=x.length-1;Ne>=0;Ne--)x.charCodeAt(Ne)===Ie&&we++;return we}e.count=C;function n(x,me,we="\u2026"){return x.length<=me?x:`${x.substr(0,me)}${we}`}e.truncate=n;function k(x,me=" "){const we=l(x,me);return h(we,me)}e.trim=k;function l(x,me){if(!x||!me)return x;const we=me.length;if(we===0||x.length===0)return x;let Ie=0;for(;x.indexOf(me,Ie)===Ie;)Ie=Ie+we;return x.substring(Ie)}e.ltrim=l;function h(x,me){if(!x||!me)return x;const we=me.length,Ie=x.length;if(we===0||Ie===0)return x;let Ne=Ie,He=-1;for(;He=x.lastIndexOf(me,Ne-1),!(He===-1||He+we!==Ne);){if(He===0)return"";Ne=He}return x.substring(0,Ne)}e.rtrim=h;function a(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=a;function d(x){return x.replace(/\*/g,"")}e.stripWildcards=d;function f(x,me,we={}){if(!x)throw new Error("Cannot create regex from empty string");me||(x=y(x)),we.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let Ie="";return we.global&&(Ie+="g"),we.matchCase||(Ie+="i"),we.multiline&&(Ie+="m"),we.unicode&&(Ie+="u"),new RegExp(x,Ie)}e.createRegExp=f;function E(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}e.regExpLeadsToEndlessLoop=E;function w(x){return!!x.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=w;function u(x){return(x.global?"g":"")+(x.ignoreCase?"i":"")+(x.multiline?"m":"")+(x.unicode?"u":"")}e.regExpFlags=u;function p(x){return x.split(/\r\n|\r|\n/)}e.splitLines=p;function b(x){for(let me=0,we=x.length;me<we;me++){const Ie=x.charCodeAt(me);if(Ie!==32&&Ie!==9)return me}return-1}e.firstNonWhitespaceIndex=b;function t(x,me=0,we=x.length){for(let Ie=me;Ie<we;Ie++){const Ne=x.charCodeAt(Ie);if(Ne!==32&&Ne!==9)return x.substring(me,Ie)}return x.substring(me,we)}e.getLeadingWhitespace=t;function s(x,me=x.length-1){for(let we=me;we>=0;we--){const Ie=x.charCodeAt(we);if(Ie!==32&&Ie!==9)return we}return-1}e.lastNonWhitespaceIndex=s;function r(x,me){return x<me?-1:x>me?1:0}e.compare=r;function i(x,me,we=0,Ie=x.length,Ne=0,He=me.length){for(;we<Ie&&Ne<He;we++,Ne++){let Qe=x.charCodeAt(we),lt=me.charCodeAt(Ne);if(Qe<lt)return-1;if(Qe>lt)return 1}const et=Ie-we,Ke=He-Ne;return et<Ke?-1:et>Ke?1:0}e.compareSubstring=i;function c(x,me){return g(x,me,0,x.length,0,me.length)}e.compareIgnoreCase=c;function g(x,me,we=0,Ie=x.length,Ne=0,He=me.length){for(;we<Ie&&Ne<He;we++,Ne++){let Qe=x.charCodeAt(we),lt=me.charCodeAt(Ne);if(Qe===lt)continue;const dt=Qe-lt;if(!(dt===32&&A(lt))&&!(dt===-32&&A(Qe)))return v(Qe)&&v(lt)?dt:i(x.toLowerCase(),me.toLowerCase(),we,Ie,Ne,He)}const et=Ie-we,Ke=He-Ne;return et<Ke?-1:et>Ke?1:0}e.compareSubstringIgnoreCase=g;function v(x){return x>=97&&x<=122}e.isLowerAsciiLetter=v;function A(x){return x>=65&&x<=90}e.isUpperAsciiLetter=A;function R(x){return v(x)||A(x)}function o(x,me){return x.length===me.length&&P(x,me)}e.equalsIgnoreCase=o;function P(x,me,we=x.length){for(let Ie=0;Ie<we;Ie++){const Ne=x.charCodeAt(Ie),He=me.charCodeAt(Ie);if(Ne!==He){if(R(Ne)&&R(He)){const et=Math.abs(Ne-He);if(et!==0&&et!==32)return!1}else if(String.fromCharCode(Ne).toLowerCase()!==String.fromCharCode(He).toLowerCase())return!1}}return!0}function L(x,me){const we=me.length;return me.length>x.length?!1:P(x,me,we)}e.startsWithIgnoreCase=L;function $(x,me){let we,Ie=Math.min(x.length,me.length);for(we=0;we<Ie;we++)if(x.charCodeAt(we)!==me.charCodeAt(we))return we;return Ie}e.commonPrefixLength=$;function re(x,me){let we,Ie=Math.min(x.length,me.length);const Ne=x.length-1,He=me.length-1;for(we=0;we<Ie;we++)if(x.charCodeAt(Ne-we)!==me.charCodeAt(He-we))return we;return Ie}e.commonSuffixLength=re;function he(x){return 55296<=x&&x<=56319}e.isHighSurrogate=he;function Q(x){return 56320<=x&&x<=57343}e.isLowSurrogate=Q;function z(x,me){return(x-55296<<10)+(me-56320)+65536}e.computeCodePoint=z;function V(x,me,we){const Ie=x.charCodeAt(we);if(he(Ie)&&we+1<me){const Ne=x.charCodeAt(we+1);if(Q(Ne))return z(Ie,Ne)}return Ie}e.getNextCodePoint=V;function T(x,me){const we=x.charCodeAt(me-1);if(Q(we)&&me>1){const Ie=x.charCodeAt(me-2);if(he(Ie))return z(Ie,we)}return we}function G(x,me){const we=Se.getInstance(),Ie=me,Ne=x.length,He=V(x,Ne,me);me+=He>=65536?2:1;let et=we.getGraphemeBreakType(He);for(;me<Ne;){const Ke=V(x,Ne,me),Qe=we.getGraphemeBreakType(Ke);if(Ue(et,Qe))break;me+=Ke>=65536?2:1,et=Qe}return me-Ie}e.nextCharLength=G;function B(x,me){const we=Se.getInstance(),Ie=me,Ne=T(x,me);me-=Ne>=65536?2:1;let He=we.getGraphemeBreakType(Ne);for(;me>0;){const et=T(x,me),Ke=we.getGraphemeBreakType(et);if(Ue(Ke,He))break;me-=et>=65536?2:1,He=Ke}return Ie-me}e.prevCharLength=B;function j(x,me){const we=Se.getInstance(),Ie=x.length,Ne=me,He=V(x,Ie,me),et=we.getGraphemeBreakType(He);me+=He>=65536?2:1;let Ke=et;for(;me<Ie;){const lt=V(x,Ie,me),dt=we.getGraphemeBreakType(lt);if(Ue(Ke,dt))break;me+=lt>=65536?2:1,Ke=dt}const Qe=me;for(me=Ne,Ke=et;me>0;){const lt=T(x,me),dt=we.getGraphemeBreakType(lt);if(Ue(dt,Ke))break;me-=lt>=65536?2:1,Ke=dt}return[me,Qe]}function ce(x,me){return me>0&&Q(x.charCodeAt(me))?j(x,me-1):j(x,me)}e.getCharContainingOffset=ce;function W(x){const me=x.length;let we=0,Ie=0;for(;Ie<me;){const et=V(x,me,Ie);Ie+=et>=65536?2:1,et<128?we+=1:et<2048?we+=2:et<65536?we+=3:we+=4}const Ne=new Uint8Array(we);Ie=0;let He=0;for(;Ie<me;){const et=V(x,me,Ie);Ie+=et>=65536?2:1,et<128?Ne[He++]=et:et<2048?(Ne[He++]=192|(et&1984)>>>6,Ne[He++]=128|(et&63)>>>0):et<65536?(Ne[He++]=224|(et&61440)>>>12,Ne[He++]=128|(et&4032)>>>6,Ne[He++]=128|(et&63)>>>0):(Ne[He++]=240|(et&1835008)>>>18,Ne[He++]=128|(et&258048)>>>12,Ne[He++]=128|(et&4032)>>>6,Ne[He++]=128|(et&63)>>>0)}return Ne}e.encodeUTF8=W;function te(x){const me=x.byteLength,we=[];let Ie=0;for(;Ie<me;){const Ne=x[Ie];let He;if(Ne>=240&&Ie+3<me?He=(x[Ie++]&7)<<18>>>0|(x[Ie++]&63)<<12>>>0|(x[Ie++]&63)<<6>>>0|(x[Ie++]&63)<<0>>>0:Ne>=224&&Ie+2<me?He=(x[Ie++]&15)<<12>>>0|(x[Ie++]&63)<<6>>>0|(x[Ie++]&63)<<0>>>0:Ne>=192&&Ie+1<me?He=(x[Ie++]&31)<<6>>>0|(x[Ie++]&63)<<0>>>0:He=x[Ie++],He>=0&&He<=55295||He>=57344&&He<=65535)we.push(String.fromCharCode(He));else if(He>=65536&&He<=1114111){const et=He-65536,Ke=55296+((et&1047552)>>>10),Qe=56320+((et&1023)>>>0);we.push(String.fromCharCode(Ke)),we.push(String.fromCharCode(Qe))}else we.push(String.fromCharCode(65533))}return we.join("")}e.decodeUTF8=te;const ue=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ye(x){return ue.test(x)}e.containsRTL=ye;const Te=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Re(x){return Te.test(x)}e.containsEmoji=Re;const $e=/^[\t\n\r\x20-\x7E]*$/;function Ze(x){return $e.test(x)}e.isBasicASCII=Ze,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Ve(x){return e.UNUSUAL_LINE_TERMINATORS.test(x)}e.containsUnusualLineTerminators=Ve;function je(x){for(let me=0,we=x.length;me<we;me++)if(O(x.charCodeAt(me)))return!0;return!1}e.containsFullWidthCharacter=je;function O(x){return x=+x,x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}e.isFullWidthCharacter=O;function K(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129003||x>=129280&&x<=129535||x>=129648&&x<=129750}e.isEmojiImprecise=K;function J(x,me){if(x.length<me)return x;const we=/\b/g;let Ie=0;for(;we.test(x)&&!(x.length-we.lastIndex<me);)Ie=we.lastIndex,we.lastIndex+=1;return x.substring(Ie).replace(/^\s/,"")}e.lcut=J;const se=/\x1B\x5B[12]?K/g,q=/\x1b\[\d+m/g,ne=/\x1b\[0?m/g;function ge(x){return x&&(x=x.replace(se,""),x=x.replace(q,""),x=x.replace(ne,"")),x}e.removeAnsiEscapeCodes=ge,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Me(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Me;function We(x){return Me(x)?x.substr(1):x}e.stripUTF8BOM=We;function be(x,me){if(!x||!me||x.length<me.length)return!1;const we=me.length,Ie=x.toLowerCase();let Ne=0,He=-1;for(;Ne<we;){const et=Ie.indexOf(me[Ne],He+1);if(et<0)return!1;He=et,Ne++}return!0}e.fuzzyContains=be;function Xe(x,me=!1){return x?(me&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}e.containsUppercaseCharacter=Xe;function H(x){return x.charAt(0).toUpperCase()+x.slice(1)}e.uppercaseFirstLetter=H;function X(x,me=1){if(me===0)return"";let we=-1;do we=x.indexOf(`
`,we+1),me--;while(me>0&&we>=0);return we===-1?x:(x[we-1]==="\r"&&we--,x.substr(0,we))}e.getNLines=X;function de(x){const me=90-65+1;return x=x%(2*me),x<me?String.fromCharCode(97+x):String.fromCharCode(65+x-me)}e.singleLetterHash=de;function Be(x){return Se.getInstance().getGraphemeBreakType(x)}e.getGraphemeBreakType=Be;function Ue(x,me){return x===0?me!==5&&me!==7:x===2&&me===3?!1:x===4||x===2||x===3||me===4||me===2||me===3?!0:!(x===8&&(me===8||me===9||me===11||me===12)||(x===11||x===9)&&(me===9||me===10)||(x===12||x===10)&&me===10||me===5||me===13||me===7||x===1||x===13&&me===14||x===6&&me===6)}e.breakBetweenGraphemeBreakType=Ue;var tt;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(tt=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Se{constructor(){this._data=De()}static getInstance(){return Se._INSTANCE||(Se._INSTANCE=new Se),Se._INSTANCE}getGraphemeBreakType(me){if(me<32)return me===10?3:me===13?2:4;if(me<127)return 0;const we=this._data,Ie=we.length/3;let Ne=1;for(;Ne<=Ie;)if(me<we[3*Ne])Ne=2*Ne;else if(me>we[3*Ne+1])Ne=2*Ne+1;else return we[3*Ne+2];return 0}}Se._INSTANCE=null;function De(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Pe(x,me){if(x===0)return 0;const we=ie(x,me);if(we!==void 0)return we;const Ie=T(me,x);return x-=oe(Ie),x}e.getLeftDeleteOffset=Pe;function ie(x,me){let we=T(me,x);for(x-=oe(we);fe(we)||we===65039||we===8419;){if(x===0)return;we=T(me,x),x-=oe(we)}if(!!K(we)){if(x>=0){const Ie=T(me,x);Ie===8205&&(x-=oe(Ie))}return x}}function oe(x){return x>=65536?2:1}function fe(x){return 127995<=x&&x<=127999}var ve;(function(x){x[x.zwj=8205]="zwj",x[x.emojiVariantSelector=65039]="emojiVariantSelector",x[x.enclosingKeyCap=8419]="enclosingKeyCap"})(ve||(ve={}))}),define(Ee[23],_e([0,1,8,110]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer!="undefined",_=typeof TextEncoder!="undefined",I=typeof TextDecoder!="undefined";let S,y;class C{constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}static alloc(v){return D?new C(Buffer.allocUnsafe(v)):new C(new Uint8Array(v))}static wrap(v){return D&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new C(v)}static fromString(v,A){return!(A?.dontUseNodeBuffer||!1)&&D?new C(Buffer.from(v)):_?(S||(S=new TextEncoder),new C(S.encode(v))):new C(m.encodeUTF8(v))}static concat(v,A){if(typeof A=="undefined"){A=0;for(let P=0,L=v.length;P<L;P++)A+=v[P].byteLength}const R=C.alloc(A);let o=0;for(let P=0,L=v.length;P<L;P++){const $=v[P];R.set($,o),o+=$.byteLength}return R}toString(){return D?this.buffer.toString():I?(y||(y=new TextDecoder),y.decode(this.buffer)):m.decodeUTF8(this.buffer)}slice(v,A){return new C(this.buffer.subarray(v,A))}set(v,A){v instanceof C?this.buffer.set(v.buffer,A):this.buffer.set(v,A)}readUInt32BE(v){return l(this.buffer,v)}writeUInt32BE(v,A){h(this.buffer,v,A)}readUInt32LE(v){return a(this.buffer,v)}writeUInt32LE(v,A){d(this.buffer,v,A)}readUInt8(v){return f(this.buffer,v)}writeUInt8(v,A){E(this.buffer,v,A)}}e.VSBuffer=C;function n(g,v){return g[v+0]<<0>>>0|g[v+1]<<8>>>0}e.readUInt16LE=n;function k(g,v,A){g[A+0]=v&255,v=v>>>8,g[A+1]=v&255}e.writeUInt16LE=k;function l(g,v){return g[v]*2**24+g[v+1]*2**16+g[v+2]*2**8+g[v+3]}e.readUInt32BE=l;function h(g,v,A){g[A+3]=v,v=v>>>8,g[A+2]=v,v=v>>>8,g[A+1]=v,v=v>>>8,g[A]=v}e.writeUInt32BE=h;function a(g,v){return g[v+0]<<0>>>0|g[v+1]<<8>>>0|g[v+2]<<16>>>0|g[v+3]<<24>>>0}e.readUInt32LE=a;function d(g,v,A){g[A+0]=v&255,v=v>>>8,g[A+1]=v&255,v=v>>>8,g[A+2]=v&255,v=v>>>8,g[A+3]=v&255}e.writeUInt32LE=d;function f(g,v){return g[v]}e.readUInt8=f;function E(g,v,A){g[A]=v}e.writeUInt8=E;function w(g){return F.consumeReadable(g,v=>C.concat(v))}e.readableToBuffer=w;function u(g){return F.toReadable(g)}e.bufferToReadable=u;function p(g){return F.consumeStream(g,v=>C.concat(v))}e.streamToBuffer=p;async function b(g){return g.ended?C.concat(g.buffer):C.concat([...g.buffer,await p(g.stream)])}e.bufferedStreamToBuffer=b;function t(g){return F.toStream(g,v=>C.concat(v))}e.bufferToStream=t;function s(g){return F.transform(g,{data:v=>typeof v=="string"?C.fromString(v):C.wrap(v)},v=>C.concat(v))}e.streamToBufferReadableStream=s;function r(g){return F.newWriteableStream(v=>C.concat(v),g)}e.newWriteableBufferStream=r;function i(g,v){return F.prefixedReadable(g,v,A=>C.concat(A))}e.prefixedBufferReadable=i;function c(g,v){return F.prefixedStream(g,v,A=>C.concat(A))}e.prefixedBufferStream=c}),define(Ee[41],_e([0,1,8]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function F(E){return D(E,0)}e.hash=F;function D(E,w){switch(typeof E){case"object":return E===null?_(349,w):Array.isArray(E)?y(E,w):C(E,w);case"string":return S(E,w);case"boolean":return I(E,w);case"number":return _(E,w);case"undefined":return _(937,w);default:return _(617,w)}}e.doHash=D;function _(E,w){return(w<<5)-w+E|0}function I(E,w){return _(E?433:863,w)}function S(E,w){w=_(149417,w);for(let u=0,p=E.length;u<p;u++)w=_(E.charCodeAt(u),w);return w}e.stringHash=S;function y(E,w){return w=_(104579,w),E.reduce((u,p)=>D(p,u),w)}function C(E,w){return w=_(181387,w),Object.keys(E).sort().reduce((u,p)=>(u=S(p,u),D(E[p],u)),w)}class n{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=D(w,this._value),this._value}}e.Hasher=n;var k;(function(E){E[E.BLOCK_SIZE=64]="BLOCK_SIZE",E[E.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function l(E,w,u=32){const p=u-w,b=~((1<<p)-1);return(E<<w|(b&E)>>>p)>>>0}function h(E,w=0,u=E.byteLength,p=0){for(let b=0;b<u;b++)E[w+b]=p}function a(E,w,u="0"){for(;E.length<w;)E=u+E;return E}function d(E,w=32){return E instanceof ArrayBuffer?Array.from(new Uint8Array(E)).map(u=>u.toString(16).padStart(2,"0")).join(""):a((E>>>0).toString(16),w/4)}e.toHexString=d;class f{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const u=w.length;if(u===0)return;const p=this._buff;let b=this._buffLen,t=this._leftoverHighSurrogate,s,r;for(t!==0?(s=t,r=-1,t=0):(s=w.charCodeAt(0),r=0);;){let i=s;if(m.isHighSurrogate(s))if(r+1<u){const c=w.charCodeAt(r+1);m.isLowSurrogate(c)?(r++,i=m.computeCodePoint(s,c)):i=65533}else{t=s;break}else m.isLowSurrogate(s)&&(i=65533);if(b=this._push(p,b,i),r++,r<u)s=w.charCodeAt(r);else break}this._buffLen=b,this._leftoverHighSurrogate=t}_push(w,u,p){return p<128?w[u++]=p:p<2048?(w[u++]=192|(p&1984)>>>6,w[u++]=128|(p&63)>>>0):p<65536?(w[u++]=224|(p&61440)>>>12,w[u++]=128|(p&4032)>>>6,w[u++]=128|(p&63)>>>0):(w[u++]=240|(p&1835008)>>>18,w[u++]=128|(p&258048)>>>12,w[u++]=128|(p&4032)>>>6,w[u++]=128|(p&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=f._bigBlock32,u=this._buffDV;for(let v=0;v<64;v+=4)w.setUint32(v,u.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)w.setUint32(v,l(w.getUint32(v-12,!1)^w.getUint32(v-32,!1)^w.getUint32(v-56,!1)^w.getUint32(v-64,!1),1),!1);let p=this._h0,b=this._h1,t=this._h2,s=this._h3,r=this._h4,i,c,g;for(let v=0;v<80;v++)v<20?(i=b&t|~b&s,c=1518500249):v<40?(i=b^t^s,c=1859775393):v<60?(i=b&t|b&s|t&s,c=2400959708):(i=b^t^s,c=3395469782),g=l(p,5)+i+r+c+w.getUint32(v*4,!1)&4294967295,r=s,s=t,t=l(b,30),b=p,p=g;this._h0=this._h0+p&4294967295,this._h1=this._h1+b&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=f,f._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Ee[42],_e([0,1,8]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(F||(F={})),function(D){const _="error",I="warning",S="warn",y="info",C="ignore";function n(l){return l?m.equalsIgnoreCase(_,l)?D.Error:m.equalsIgnoreCase(I,l)||m.equalsIgnoreCase(S,l)?D.Warning:m.equalsIgnoreCase(y,l)?D.Info:D.Ignore:D.Ignore}D.fromValue=n;function k(l){switch(l){case D.Error:return _;case D.Warning:return I;case D.Info:return y;default:return C}}D.toString=k}(F||(F={})),e.default=F}),define(Ee[10],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(v){return Array.isArray(v)}e.isArray=m;function F(v){return typeof v=="string"}e.isString=F;function D(v){return Array.isArray(v)&&v.every(A=>F(A))}e.isStringArray=D;function _(v){return typeof v=="object"&&v!==null&&!Array.isArray(v)&&!(v instanceof RegExp)&&!(v instanceof Date)}e.isObject=_;function I(v){return typeof v=="number"&&!isNaN(v)}e.isNumber=I;function S(v){return!!v&&typeof v[Symbol.iterator]=="function"}e.isIterable=S;function y(v){return v===!0||v===!1}e.isBoolean=y;function C(v){return typeof v=="undefined"}e.isUndefined=C;function n(v){return!k(v)}e.isDefined=n;function k(v){return C(v)||v===null}e.isUndefinedOrNull=k;function l(v,A){if(!v)throw new Error(A?`Unexpected type, expected '${A}'`:"Unexpected type")}e.assertType=l;function h(v){if(k(v))throw new Error("Assertion Failed: argument is undefined or null");return v}e.assertIsDefined=h;function a(...v){const A=[];for(let R=0;R<v.length;R++){const o=v[R];if(k(o))throw new Error(`Assertion Failed: argument at index ${R} is undefined or null`);A.push(o)}return A}e.assertAllDefined=a;const d=Object.prototype.hasOwnProperty;function f(v){if(!_(v))return!1;for(let A in v)if(d.call(v,A))return!1;return!0}e.isEmptyObject=f;function E(v){return typeof v=="function"}e.isFunction=E;function w(...v){return v.length>0&&v.every(E)}e.areFunctions=w;function u(v,A){const R=Math.min(v.length,A.length);for(let o=0;o<R;o++)p(v[o],A[o])}e.validateConstraints=u;function p(v,A){if(F(A)){if(typeof v!==A)throw new Error(`argument does not match constraint: typeof ${A}`)}else if(E(A)){try{if(v instanceof A)return}catch{}if(!k(v)&&v.constructor===A||A.length===1&&A.call(void 0,v)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=p;function b(v){let A=[],R=Object.getPrototypeOf(v);for(;Object.prototype!==R;)A=A.concat(Object.getOwnPropertyNames(R)),R=Object.getPrototypeOf(R);return A}e.getAllPropertyNames=b;function t(v){const A=[];for(const R of b(v))typeof v[R]=="function"&&A.push(R);return A}e.getAllMethodNames=t;function s(v,A){const R=P=>function(){const L=Array.prototype.slice.call(arguments,0);return A(P,L)};let o={};for(const P of v)o[P]=R(P);return o}e.createProxyObject=s;function r(v){return v===null?void 0:v}e.withNullAsUndefined=r;function i(v){return typeof v=="undefined"?null:v}e.withUndefinedAsNull=i;function c(v){return class{constructor(){return new Proxy({},{get(A,R){if(A[R])return A[R];throw new Error(`Not Implemented: ${v}->${String(R)}`)}})}}}e.NotImplementedProxy=c;function g(v,A="Unreachable"){throw new Error(A)}e.assertNever=g}),define(Ee[43],_e([0,1,21,8,14,10]),function(ee,e,m,F,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(r){return r===47||r===92}e.isPathSeparator=I;function S(r){return r.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=S;function y(r){return r.indexOf("/")===-1&&(r=S(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=y;function C(r,i=D.posix.sep){if(!r)return"";const c=r.length,g=r.charCodeAt(0);if(I(g)){if(I(r.charCodeAt(1))&&!I(r.charCodeAt(2))){let A=3;const R=A;for(;A<c&&!I(r.charCodeAt(A));A++);if(R!==A&&!I(r.charCodeAt(A+1))){for(A+=1;A<c;A++)if(I(r.charCodeAt(A)))return r.slice(0,A+1).replace(/[\\/]/g,i)}}return i}else if(E(g)&&r.charCodeAt(1)===58)return I(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let v=r.indexOf("://");if(v!==-1){for(v+=3;v<c;v++)if(I(r.charCodeAt(v)))return r.slice(0,v+1)}return""}e.getRoot=C;function n(r){if(!m.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let c=2;const g=c;for(;c<r.length&&(i=r.charCodeAt(c),i!==92);c++);return!(g===c||(i=r.charCodeAt(c+1),isNaN(i)||i===92))}e.isUNC=n;const k=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(r,i=m.isWindows){const c=i?k:l;return!(!r||r.length===0||/^\s+$/.test(r)||(c.lastIndex=0,c.test(r))||i&&h.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=a;function d(r,i,c){const g=r===i;return!c||g?g:!r||!i?!1:(0,F.equalsIgnoreCase)(r,i)}e.isEqual=d;function f(r,i,c,g=D.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(c){if(!(0,F.startsWithIgnoreCase)(r,i))return!1;if(i.length===r.length)return!0;let A=i.length;return i.charAt(i.length-1)===g&&A--,r.charAt(A)===g}return i.charAt(i.length-1)!==g&&(i+=g),r.indexOf(i)===0}e.isEqualOrParent=f;function E(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=E;function w(r,i){return m.isWindows&&r.endsWith(":")&&(r+=D.sep),(0,D.isAbsolute)(r)||(r=(0,D.join)(i,r)),r=(0,D.normalize)(r),m.isWindows?(r=(0,F.rtrim)(r,D.sep),r.endsWith(":")&&(r+=D.sep)):(r=(0,F.rtrim)(r,D.sep),r||(r=D.sep)),r}e.sanitizeFilePath=w;function u(r){const i=(0,D.normalize)(r);return m.isWindows?r.length>3?!1:p(i)&&(r.length===2||i.charCodeAt(2)===92):i===D.posix.sep}e.isRootOrDriveLetter=u;function p(r){return m.isWindows?E(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function b(r){return p(r)?r[0]:void 0}e.getDriveLetter=b;function t(r,i,c){return i.length>r.length?-1:r===i?0:(c&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=t;function s(r){const i=r.split(":");let c,g,v;if(i.forEach(A=>{const R=Number(A);(0,_.isNumber)(R)?g===void 0?g=R:v===void 0&&(v=R):c=c?[c,A].join(":"):A}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:g!==void 0?g:void 0,column:v!==void 0?v:g!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(Ee[24],_e([0,1,10]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function F(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const f=Array.isArray(d)?[]:{};return Object.keys(d).forEach(E=>{d[E]&&typeof d[E]=="object"?f[E]=F(d[E]):f[E]=d[E]}),f}e.deepClone=F;function D(d){if(!d||typeof d!="object")return d;const f=[d];for(;f.length>0;){const E=f.shift();Object.freeze(E);for(const w in E)if(_.call(E,w)){const u=E[w];typeof u=="object"&&!Object.isFrozen(u)&&f.push(u)}}return d}e.deepFreeze=D;const _=Object.prototype.hasOwnProperty;function I(d,f){return S(d,f,new Set)}e.cloneAndChange=I;function S(d,f,E){if((0,m.isUndefinedOrNull)(d))return d;const w=f(d);if(typeof w!="undefined")return w;if((0,m.isArray)(d)){const u=[];for(const p of d)u.push(S(p,f,E));return u}if((0,m.isObject)(d)){if(E.has(d))throw new Error("Cannot clone recursive data-structure");E.add(d);const u={};for(let p in d)_.call(d,p)&&(u[p]=S(d[p],f,E));return E.delete(d),u}return d}function y(d,f,E=!0){return(0,m.isObject)(d)?((0,m.isObject)(f)&&Object.keys(f).forEach(w=>{w in d?E&&((0,m.isObject)(d[w])&&(0,m.isObject)(f[w])?y(d[w],f[w],E):d[w]=f[w]):d[w]=f[w]}),d):f}e.mixin=y;function C(d,f){if(d===f)return!0;if(d==null||f===null||f===void 0||typeof d!=typeof f||typeof d!="object"||Array.isArray(d)!==Array.isArray(f))return!1;let E,w;if(Array.isArray(d)){if(d.length!==f.length)return!1;for(E=0;E<d.length;E++)if(!C(d[E],f[E]))return!1}else{const u=[];for(w in d)u.push(w);u.sort();const p=[];for(w in f)p.push(w);if(p.sort(),!C(u,p))return!1;for(E=0;E<u.length;E++)if(!C(d[u[E]],f[u[E]]))return!1}return!0}e.equals=C;function n(d){const f=new Set;return JSON.stringify(d,(E,w)=>{if((0,m.isObject)(w)||Array.isArray(w)){if(f.has(w))return"[Circular]";f.add(w)}return w})}e.safeStringify=n;function k(d,f,E){const w=f(d);return typeof w=="undefined"?E:w}e.getOrDefault=k;function l(d,f){const E=Object.create(null);return!d||!f||Object.keys(f).forEach(u=>{const p=d[u],b=f[u];C(p,b)||(E[u]=b)}),E}e.distinct=l;function h(d,f){const E=f.toLowerCase(),w=Object.keys(d).find(u=>u.toLowerCase()===E);return w?d[w]:d[f]}e.getCaseInsensitive=h;function a(d,f){const E=Object.create(null);for(const w of Object.keys(d))f(w,d[w])&&(E[w]=d[w]);return E}e.filter=a}),define(Ee[80],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var m;(function(_){_[_.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",_[_.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",_[_.MAX_UINT_8=255]="MAX_UINT_8",_[_.MAX_UINT_16=65535]="MAX_UINT_16",_[_.MAX_UINT_32=4294967295]="MAX_UINT_32",_[_.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(m=e.Constants||(e.Constants={}));function F(_){return _<0?0:_>255?255:_|0}e.toUint8=F;function D(_){return _<0?0:_>4294967295?4294967295:_|0}e.toUint32=D}),define(Ee[2],_e([0,1,21,14]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,_=/^\//,I=/^\/\//;function S(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!D.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!_.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(r,i){return!r&&!i?"file":r}function C(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==k&&(i=k+i):i=k;break}return i}const n="",k="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{constructor(i,c,g,v,A,R=!1){typeof i=="object"?(this.scheme=i.scheme||n,this.authority=i.authority||n,this.path=i.path||n,this.query=i.query||n,this.fragment=i.fragment||n):(this.scheme=y(i,R),this.authority=c||n,this.path=C(this.scheme,g||n),this.query=v||n,this.fragment=A||n,S(this,R))}static isUri(i){return i instanceof h?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return u(this,!1)}with(i){if(!i)return this;let{scheme:c,authority:g,path:v,query:A,fragment:R}=i;return c===void 0?c=this.scheme:c===null&&(c=n),g===void 0?g=this.authority:g===null&&(g=n),v===void 0?v=this.path:v===null&&(v=n),A===void 0?A=this.query:A===null&&(A=n),R===void 0?R=this.fragment:R===null&&(R=n),c===this.scheme&&g===this.authority&&v===this.path&&A===this.query&&R===this.fragment?this:new d(c,g,v,A,R)}static parse(i,c=!1){const g=l.exec(i);return g?new d(g[2]||n,s(g[4]||n),s(g[5]||n),s(g[7]||n),s(g[9]||n),c):new d(n,n,n,n,n)}static file(i){let c=n;if(m.isWindows&&(i=i.replace(/\\/g,k)),i[0]===k&&i[1]===k){const g=i.indexOf(k,2);g===-1?(c=i.substring(2),i=k):(c=i.substring(2,g),i=i.substring(g)||k)}return new d("file",c,i,n,n)}static from(i){const c=new d(i.scheme,i.authority,i.path,i.query,i.fragment);return S(c,!0),c}static joinPath(i,...c){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return m.isWindows&&i.scheme==="file"?g=h.file(F.win32.join(u(i,!0),...c)).path:g=F.posix.join(i.path,...c),i.with({path:g})}toString(i=!1){return p(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof h)return i;{const c=new d(i);return c._formatted=i.external,c._fsPath=i._sep===a?i.fsPath:null,c}}else return i}}e.URI=h;const a=m.isWindows?1:void 0;class d extends h{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(i=!1){return i?p(this,!0):(this._formatted||(this._formatted=p(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=a),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function E(r,i){let c,g=-1;for(let v=0;v<r.length;v++){const A=r.charCodeAt(v);if(A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57||A===45||A===46||A===95||A===126||i&&A===47)g!==-1&&(c+=encodeURIComponent(r.substring(g,v)),g=-1),c!==void 0&&(c+=r.charAt(v));else{c===void 0&&(c=r.substr(0,v));const R=f[A];R!==void 0?(g!==-1&&(c+=encodeURIComponent(r.substring(g,v)),g=-1),c+=R):g===-1&&(g=v)}}return g!==-1&&(c+=encodeURIComponent(r.substring(g))),c!==void 0?c:r}function w(r){let i;for(let c=0;c<r.length;c++){const g=r.charCodeAt(c);g===35||g===63?(i===void 0&&(i=r.substr(0,c)),i+=f[g]):i!==void 0&&(i+=r[c])}return i!==void 0?i:r}function u(r,i){let c;return r.authority&&r.path.length>1&&r.scheme==="file"?c=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?c=r.path.substr(1):c=r.path[1].toLowerCase()+r.path.substr(2):c=r.path,m.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=u;function p(r,i){const c=i?w:E;let g="",{scheme:v,authority:A,path:R,query:o,fragment:P}=r;if(v&&(g+=v,g+=":"),(A||v==="file")&&(g+=k,g+=k),A){let L=A.indexOf("@");if(L!==-1){const $=A.substr(0,L);A=A.substr(L+1),L=$.indexOf(":"),L===-1?g+=c($,!1):(g+=c($.substr(0,L),!1),g+=":",g+=c($.substr(L+1),!1)),g+="@"}A=A.toLowerCase(),L=A.indexOf(":"),L===-1?g+=c(A,!1):(g+=c(A.substr(0,L),!1),g+=A.substr(L))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const L=R.charCodeAt(1);L>=65&&L<=90&&(R=`/${String.fromCharCode(L+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const L=R.charCodeAt(0);L>=65&&L<=90&&(R=`${String.fromCharCode(L+32)}:${R.substr(2)}`)}g+=c(R,!0)}return o&&(g+="?",g+=c(o,!1)),P&&(g+="#",g+=i?P:E(P,!1)),g}function b(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+b(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(t)?r.replace(t,i=>b(i)):r}});var nt=this&&this.__classPrivateFieldSet||function(ee,e,m,F,D){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?D.call(ee,m):D?D.value=m:e.set(ee,m),m},Oe=this&&this.__classPrivateFieldGet||function(ee,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(ee):F?F.value:e.get(ee)};define(Ee[22],_e([0,1,2,8]),function(ee,e,m,F){"use strict";var D,_,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(t,s,r){let i=t.get(s);return i===void 0&&(i=r,t.set(s,i)),i}e.getOrSet=S;function y(t){const s=[];return t.forEach((r,i)=>{s.push(`${i} => ${r}`)}),`Map(${t.size}) {${s.join(", ")}}`}e.mapToString=y;function C(t){const s=[];return t.forEach(r=>{s.push(r)}),`Set(${t.size}) {${s.join(", ")}}`}e.setToString=C;class n{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const r=s.charCodeAt(0),i=this._value.charCodeAt(this._pos);return r-i}value(){return this._value[this._pos]}}e.StringIterator=n;class k{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,F.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=k;class l{constructor(s=!0,r=!0){this._splitOnBackslash=s,this._caseSensitive=r}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,F.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=l;var h;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(h||(h={}));class a{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,F.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,F.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,F.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,F.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class d{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class f{constructor(s){this._iter=s}static forUris(s=()=>!1){return new f(new a(s))}static forPaths(){return new f(new l)}static forStrings(){return new f(new n)}static forConfigKeys(){return new f(new k)}clear(){this._root=void 0}set(s,r){const i=this._iter.reset(s);let c;for(this._root||(this._root=new d,this._root.segment=i.value()),c=this._root;;){const v=i.cmp(c.segment);if(v>0)c.left||(c.left=new d,c.left.segment=i.value()),c=c.left;else if(v<0)c.right||(c.right=new d,c.right.segment=i.value()),c=c.right;else if(i.hasNext())i.next(),c.mid||(c.mid=new d,c.mid.segment=i.value()),c=c.mid;else break}const g=c.value;return c.value=r,c.key=s,g}get(s){return this._getNode(s)?.value}_getNode(s){const r=this._iter.reset(s);let i=this._root;for(;i;){const c=r.cmp(i.segment);if(c>0)i=i.left;else if(c<0)i=i.right;else if(r.hasNext())r.next(),i=i.mid;else break}return i}has(s){const r=this._getNode(s);return!(r?.value===void 0&&r?.mid===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,r){const i=this._iter.reset(s),c=[];let g=this._root;for(;g;){const v=i.cmp(g.segment);if(v>0)c.push([1,g]),g=g.left;else if(v<0)c.push([-1,g]),g=g.right;else if(i.hasNext())i.next(),c.push([0,g]),g=g.mid;else{for(r?(g.left=void 0,g.mid=void 0,g.right=void 0):g.value=void 0;c.length>0&&g.isEmpty();){let[A,R]=c.pop();switch(A){case 1:R.left=void 0;break;case 0:R.mid=void 0;break;case-1:R.right=void 0;break}g=R}break}}}findSubstr(s){const r=this._iter.reset(s);let i=this._root,c;for(;i;){const g=r.cmp(i.segment);if(g>0)i=i.left;else if(g<0)i=i.right;else if(r.hasNext())r.next(),c=i.value||c,i=i.mid;else break}return i&&i.value||c}findSuperstr(s){const r=this._iter.reset(s);let i=this._root;for(;i;){const c=r.cmp(i.segment);if(c>0)i=i.left;else if(c<0)i=i.right;else if(r.hasNext())r.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(s){for(const[r,i]of this)s(i,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){if(!s)return;const r=[s];for(;r.length>0;){const i=r.pop();i&&(i.value&&(yield[i.key,i.value]),i.left&&r.push(i.left),i.mid&&r.push(i.mid),i.right&&r.push(i.right))}}}e.TernarySearchTree=f;class E{constructor(s,r){this[D]="ResourceMap",s instanceof E?(this.map=new Map(s.map),this.toKey=r??E.defaultToKey):(this.map=new Map,this.toKey=s??E.defaultToKey)}set(s,r){return this.map.set(this.toKey(s),r),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,r){typeof r!="undefined"&&(s=s.bind(r));for(let[i,c]of this.map)s(c,m.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield m.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[m.URI.parse(s[0]),s[1]]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[m.URI.parse(s[0]),s[1]]}}e.ResourceMap=E,E.defaultToKey=t=>t.toString();var w;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class u{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,r=0){const i=this._map.get(s);if(!!i)return r!==0&&this.touch(i,r),i.value}set(s,r,i=0){let c=this._map.get(s);if(c)c.value=r,i!==0&&this.touch(c,i);else{switch(c={key:s,value:r,next:void 0,previous:void 0},i){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(s,c),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const r=this._map.get(s);if(!!r)return this._map.delete(s),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,r){const i=this._state;let c=this._head;for(;c;){if(r?s.bind(r)(c.value,c.key,this):s(c.value,c.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const s=this,r=this._state;let i=this._head;const c={[Symbol.iterator](){return c},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(i){const g={value:i.key,done:!1};return i=i.next,g}else return{value:void 0,done:!0}}};return c}values(){const s=this,r=this._state;let i=this._head;const c={[Symbol.iterator](){return c},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(i){const g={value:i.value,done:!1};return i=i.next,g}else return{value:void 0,done:!0}}};return c}entries(){const s=this,r=this._state;let i=this._head;const c={[Symbol.iterator](){return c},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(i){const g={value:[i.key,i.value],done:!1};return i=i.next,g}else return{value:void 0,done:!0}}};return c}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let r=this._head,i=this.size;for(;r&&i>s;)this._map.delete(r.key),r=r.next,i--;this._head=r,this._size=i,r&&(r.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const r=s.next,i=s.previous;if(!r||!i)throw new Error("Invalid list");r.previous=i,i.next=r}s.next=void 0,s.previous=void 0,this._state++}touch(s,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(s===this._head)return;const i=s.next,c=s.previous;s===this._tail?(c.next=void 0,this._tail=c):(i.previous=c,c.next=i),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(r===2){if(s===this._tail)return;const i=s.next,c=s.previous;s===this._head?(i.previous=void 0,this._head=i):(i.previous=c,c.next=i),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((r,i)=>{s.push([i,r])}),s}fromJSON(s){this.clear();for(const[r,i]of s)this.set(r,i)}}e.LinkedMap=u;class p extends u{constructor(s,r=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,r=2){return super.get(s,r)}peek(s){return super.get(s,0)}set(s,r){return super.set(s,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=p;class b{constructor(s){I.set(this,void 0),nt(this,I,s,"f")}get size(){return Oe(this,I,"f").size}forEach(s,r){Oe(this,I,"f").forEach(s,r)}get(s){return Oe(this,I,"f").get(s)}has(s){return Oe(this,I,"f").has(s)}entries(){return Oe(this,I,"f").entries()}keys(){return Oe(this,I,"f").keys()}values(){return Oe(this,I,"f").values()}[(I=new WeakMap,Symbol.iterator)](){return Oe(this,I,"f").entries()}}e.ReadonlyMapView=b}),define(Ee[111],_e([0,1,22,8]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...q){return function(ne,ge){for(let Me=0,We=q.length;Me<We;Me++){const be=q[Me](ne,ge);if(be)return be}return null}}e.or=D,e.matchesStrictPrefix=_.bind(void 0,!1),e.matchesPrefix=_.bind(void 0,!0);function _(q,ne,ge){if(!ge||ge.length<ne.length)return null;let Me;return q?Me=F.startsWithIgnoreCase(ge,ne):Me=ge.indexOf(ne)===0,Me?ne.length>0?[{start:0,end:ne.length}]:[]:null}function I(q,ne){const ge=ne.toLowerCase().indexOf(q.toLowerCase());return ge===-1?null:[{start:ge,end:ge+q.length}]}e.matchesContiguousSubString=I;function S(q,ne){return y(q.toLowerCase(),ne.toLowerCase(),0,0)}e.matchesSubString=S;function y(q,ne,ge,Me){if(ge===q.length)return[];if(Me===ne.length)return null;if(q[ge]===ne[Me]){let We=null;return(We=y(q,ne,ge+1,Me+1))?E({start:Me,end:Me+1},We):null}return y(q,ne,ge,Me+1)}function C(q){return 97<=q&&q<=122}function n(q){return 65<=q&&q<=90}e.isUpper=n;function k(q){return 48<=q&&q<=57}function l(q){return q===32||q===9||q===10||q===13}const h=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(q=>h.add(q.charCodeAt(0)));function a(q){return l(q)||h.has(q)}function d(q,ne){return q===ne||a(q)&&a(ne)}function f(q){return C(q)||n(q)||k(q)}function E(q,ne){return ne.length===0?ne=[q]:q.end===ne[0].start?ne[0].start=q.start:ne.unshift(q),ne}function w(q,ne){for(let ge=ne;ge<q.length;ge++){const Me=q.charCodeAt(ge);if(n(Me)||k(Me)||ge>0&&!f(q.charCodeAt(ge-1)))return ge}return q.length}function u(q,ne,ge,Me){if(ge===q.length)return[];if(Me===ne.length)return null;if(q[ge]!==ne[Me].toLowerCase())return null;{let We=null,be=Me+1;for(We=u(q,ne,ge+1,Me+1);!We&&(be=w(ne,be))<ne.length;)We=u(q,ne,ge+1,be),be++;return We===null?null:E({start:Me,end:Me+1},We)}}function p(q){let ne=0,ge=0,Me=0,We=0,be=0;for(let Be=0;Be<q.length;Be++)be=q.charCodeAt(Be),n(be)&&ne++,C(be)&&ge++,f(be)&&Me++,k(be)&&We++;const Xe=ne/q.length,H=ge/q.length,X=Me/q.length,de=We/q.length;return{upperPercent:Xe,lowerPercent:H,alphaPercent:X,numericPercent:de}}function b(q){const{upperPercent:ne,lowerPercent:ge}=q;return ge===0&&ne>.6}function t(q){const{upperPercent:ne,lowerPercent:ge,alphaPercent:Me,numericPercent:We}=q;return ge>.2&&ne<.8&&Me>.6&&We<.2}function s(q){let ne=0,ge=0,Me=0,We=0;for(let be=0;be<q.length;be++)Me=q.charCodeAt(be),n(Me)&&ne++,C(Me)&&ge++,l(Me)&&We++;return(ne===0||ge===0)&&We===0?q.length<=30:ne<=5}function r(q,ne){if(!ne||(ne=ne.trim(),ne.length===0)||!s(q)||ne.length>60)return null;const ge=p(ne);if(!t(ge)){if(!b(ge))return null;ne=ne.toLowerCase()}let Me=null,We=0;for(q=q.toLowerCase();We<ne.length&&(Me=u(q,ne,0,We))===null;)We=w(ne,We+1);return Me}e.matchesCamelCase=r;function i(q,ne,ge=!1){if(!ne||ne.length===0)return null;let Me=null,We=0;for(q=q.toLowerCase(),ne=ne.toLowerCase();We<ne.length&&(Me=c(q,ne,0,We,ge))===null;)We=g(ne,We+1);return Me}e.matchesWords=i;function c(q,ne,ge,Me,We){if(ge===q.length)return[];if(Me===ne.length)return null;if(d(q.charCodeAt(ge),ne.charCodeAt(Me))){let be=null,Xe=Me+1;if(be=c(q,ne,ge+1,Me+1,We),!We)for(;!be&&(Xe=g(ne,Xe))<ne.length;)be=c(q,ne,ge+1,Xe,We),Xe++;return be===null?null:E({start:Me,end:Me+1},be)}else return null}function g(q,ne){for(let ge=ne;ge<q.length;ge++)if(a(q.charCodeAt(ge))||ge>0&&a(q.charCodeAt(ge-1)))return ge;return q.length}const v=D(e.matchesPrefix,r,I),A=D(e.matchesPrefix,r,S),R=new m.LRUCache(1e4);function o(q,ne,ge=!1){if(typeof q!="string"||typeof ne!="string")return null;let Me=R.get(q);Me||(Me=new RegExp(F.convertSimple2RegExpPattern(q),"i"),R.set(q,Me));const We=Me.exec(ne);return We?[{start:We.index,end:We.index+We[0].length}]:ge?A(q,ne):v(q,ne)}e.matchesFuzzy=o;function P(q,ne){const ge=Ze(q,q.toLowerCase(),0,ne,ne.toLowerCase(),0,!0);return ge?$(ge):null}e.matchesFuzzy2=P;function L(q,ne,ge,Me,We,be){const Xe=Math.min(13,q.length);for(;ge<Xe;ge++){const H=Ze(q,ne,ge,Me,We,be,!1);if(H)return H}return[0,be]}e.anyScore=L;function $(q){if(typeof q=="undefined")return[];const ne=[],ge=q[1];for(let Me=q.length-1;Me>1;Me--){const We=q[Me]+ge,be=ne[ne.length-1];be&&be.end===We?be.end=We+1:ne.push({start:We,end:We+1})}return ne}e.createMatches=$;const re=128;function he(){const q=[],ne=[];for(let ge=0;ge<=re;ge++)ne[ge]=0;for(let ge=0;ge<=re;ge++)q.push(ne.slice(0));return q}function Q(q){const ne=[];for(let ge=0;ge<=q;ge++)ne[ge]=0;return ne}const z=Q(2*re),V=Q(2*re),T=he(),G=he(),B=he(),j=!1;function ce(q,ne,ge,Me,We){function be(H,X,de=" "){for(;H.length<X;)H=de+H;return H}let Xe=` |   |${Me.split("").map(H=>be(H,3)).join("|")}
`;for(let H=0;H<=ge;H++)H===0?Xe+=" |":Xe+=`${ne[H-1]}|`,Xe+=q[H].slice(0,We+1).map(X=>be(X.toString(),3)).join("|")+`
`;return Xe}function W(q,ne,ge,Me){q=q.substr(ne),ge=ge.substr(Me),console.log(ce(G,q,q.length,ge,ge.length)),console.log(ce(B,q,q.length,ge,ge.length)),console.log(ce(T,q,q.length,ge,ge.length))}function te(q,ne){if(ne<0||ne>=q.length)return!1;const ge=q.codePointAt(ne);switch(ge){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!F.isEmojiImprecise(ge)}}function ue(q,ne){if(ne<0||ne>=q.length)return!1;switch(q.charCodeAt(ne)){case 32:case 9:return!0;default:return!1}}function ye(q,ne,ge){return ne[q]!==ge[q]}function Te(q,ne,ge,Me,We,be,Xe=!1){for(;ne<ge&&We<be;)q[ne]===Me[We]&&(Xe&&(z[ne]=We),ne+=1),We+=1;return ne===ge}e.isPatternInWord=Te;var Re;(function(q){q[q.Diag=1]="Diag",q[q.Left=2]="Left",q[q.LeftLeft=3]="LeftLeft"})(Re||(Re={}));var $e;(function(q){q.Default=[-100,0];function ne(ge){return!ge||ge.length===2&&ge[0]===-100&&ge[1]===0}q.isDefault=ne})($e=e.FuzzyScore||(e.FuzzyScore={}));function Ze(q,ne,ge,Me,We,be,Xe){const H=q.length>re?re:q.length,X=Me.length>re?re:Me.length;if(ge>=H||be>=X||H-ge>X-be||!Te(ne,ge,H,We,be,X,!0))return;Ve(H,X,ge,be,ne,We);let de=1,Be=1,Ue=ge,tt=be;const Se=[!1];for(de=1,Ue=ge;Ue<H;de++,Ue++){const fe=z[Ue],ve=V[Ue],x=Ue+1<H?V[Ue+1]:X;for(Be=fe-be+1,tt=fe;tt<x;Be++,tt++){let me=Number.MIN_SAFE_INTEGER,we=!1;tt<=ve&&(me=je(q,ne,Ue,ge,Me,We,tt,X,be,T[de-1][Be-1]===0,Se));let Ie=0;me!==Number.MAX_SAFE_INTEGER&&(we=!0,Ie=me+G[de-1][Be-1]);const Ne=tt>fe,He=Ne?G[de][Be-1]+(T[de][Be-1]>0?-5:0):0,et=tt>fe+1&&T[de][Be-1]>0,Ke=et?G[de][Be-2]+(T[de][Be-2]>0?-5:0):0;if(et&&(!Ne||Ke>=He)&&(!we||Ke>=Ie))G[de][Be]=Ke,B[de][Be]=3,T[de][Be]=0;else if(Ne&&(!we||He>=Ie))G[de][Be]=He,B[de][Be]=2,T[de][Be]=0;else if(we)G[de][Be]=Ie,B[de][Be]=1,T[de][Be]=T[de-1][Be-1]+1;else throw new Error("not possible")}}if(j&&W(q,ge,Me,be),!Se[0]&&!Xe)return;de--,Be--;const De=[G[de][Be],be];let Pe=0,ie=0;for(;de>=1;){let fe=Be;do{const ve=B[de][fe];if(ve===3)fe=fe-2;else if(ve===2)fe=fe-1;else break}while(fe>=1);Pe>1&&ne[ge+de-1]===We[be+Be-1]&&!ye(fe+be-1,Me,We)&&Pe+1>T[de][fe]&&(fe=Be),fe===Be?Pe++:Pe=1,ie||(ie=fe),de--,Be=fe-1,De.push(Be)}X===H&&(De[0]+=2);const oe=ie-H;return De[0]-=oe,De}e.fuzzyScore=Ze;function Ve(q,ne,ge,Me,We,be){let Xe=q-1,H=ne-1;for(;Xe>=ge&&H>=Me;)We[Xe]===be[H]&&(V[Xe]=H,Xe--),H--}function je(q,ne,ge,Me,We,be,Xe,H,X,de,Be){if(ne[ge]!==be[Xe])return Number.MIN_SAFE_INTEGER;let Ue=1,tt=!1;return Xe===ge-Me?Ue=q[ge]===We[Xe]?7:5:ye(Xe,We,be)&&(Xe===0||!ye(Xe-1,We,be))?(Ue=q[ge]===We[Xe]?7:5,tt=!0):te(be,Xe)&&(Xe===0||!te(be,Xe-1))?Ue=5:(te(be,Xe-1)||ue(be,Xe-1))&&(Ue=5,tt=!0),Ue>1&&ge===Me&&(Be[0]=!0),tt||(tt=ye(Xe,We,be)||te(be,Xe-1)||ue(be,Xe-1)),ge===Me?Xe>X&&(Ue-=tt?3:5):de?Ue+=tt?2:0:Ue+=tt?0:1,Xe+1===H&&(Ue-=tt?3:5),Ue}function O(q,ne,ge,Me,We,be,Xe){return J(q,ne,ge,Me,We,be,!0,Xe)}e.fuzzyScoreGracefulAggressive=O;function K(q,ne,ge,Me,We,be,Xe){return J(q,ne,ge,Me,We,be,!1,Xe)}e.fuzzyScoreGraceful=K;function J(q,ne,ge,Me,We,be,Xe,H){let X=Ze(q,ne,ge,Me,We,be,H);if(X&&!Xe)return X;if(q.length>=3){const de=Math.min(7,q.length-1);for(let Be=ge+1;Be<de;Be++){const Ue=se(q,Be);if(Ue){const tt=Ze(Ue,Ue.toLowerCase(),ge,Me,We,be,H);tt&&(tt[0]-=3,(!X||tt[0]>X[0])&&(X=tt))}}}return X}function se(q,ne){if(ne+1>=q.length)return;const ge=q[ne],Me=q[ne+1];if(ge!==Me)return q.slice(0,ne)+Me+ge+q.slice(ne+2)}}),define(Ee[112],_e([0,1,53,111,8]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const _=new RegExp(`\\$\\(${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?\\)`,"g"),I=new RegExp(`(\\\\)?${_.source}`,"g");function S(d){return d.replace(I,(f,E)=>E?f:`\\${f}`)}e.escapeIcons=S;const y=new RegExp(`\\\\${_.source}`,"g");function C(d){return d.replace(y,f=>`\\${f}`)}e.markdownEscapeEscapedIcons=C;const n=new RegExp(`(\\s)?(\\\\)?${_.source}(\\s)?`,"g");function k(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(n,(f,E,w,u)=>w?f:E||u||"")}e.stripIcons=k;function l(d){const f=d.indexOf(e.iconStartMarker);return f===-1?{text:d}:h(d,f)}e.parseLabelWithIcons=l;function h(d,f){const E=[];let w="";function u(g){if(g){w+=g;for(const v of g)E.push(t)}}let p=-1,b="",t=0,s,r,i=f;const c=d.length;for(u(d.substr(0,f));i<c;)s=d[i],r=d[i+1],s===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(p=i,u(b),b=e.iconStartMarker,i++):s===")"&&p!==-1?(t+=i-p+1,p=-1,b=""):p!==-1?/^[a-z0-9\-]$/i.test(s)?b+=s:(u(b),p=-1,b=""):u(s),i++;return u(b),{text:w,iconOffsets:E}}function a(d,f,E=!1){const{text:w,iconOffsets:u}=f;if(!u||u.length===0)return(0,F.matchesFuzzy)(d,w,E);const p=(0,D.ltrim)(w," "),b=w.length-p.length,t=(0,F.matchesFuzzy)(d,p,E);if(t)for(const s of t){const r=u[s.start+b]+b;s.start+=r,s.end+=r}return t}e.matchesFuzzyIconAware=a}),define(Ee[81],_e([0,1,112,12]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var D;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(D=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class _{constructor(h="",a=!1){if(this.value=h,typeof this.value!="string")throw(0,F.illegalArgument)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1)}appendText(h,a=0){return this.value+=C(this.supportThemeIcons?(0,m.escapeIcons)(h):h).replace(/([ \t]+)/g,(d,f)=>"&nbsp;".repeat(f.length)).replace(/^>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,a){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=a,this.value+="\n```\n",this}}e.MarkdownString=_;function I(l){return S(l)?!l.value:Array.isArray(l)?l.every(I):!0}e.isEmptyMarkdownString=I;function S(l){return l instanceof _?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=S;function y(l,h){return l===h?!0:!l||!h?!1:l.value===h.value&&l.isTrusted===h.isTrusted&&l.supportThemeIcons===h.supportThemeIcons}e.markdownStringEqual=y;function C(l){return l.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function n(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function k(l){const h=[],a=l.split("|").map(f=>f.trim());l=a[0];const d=a[1];if(d){const f=/height=(\d+)/.exec(d),E=/width=(\d+)/.exec(d),w=f?f[1]:"",u=E?E[1]:"",p=isFinite(parseInt(u)),b=isFinite(parseInt(w));p&&h.push(`width="${u}"`),b&&h.push(`height="${w}"`)}return{href:l,dimensions:h}}e.parseHrefAndDimensions=k}),define(Ee[54],_e([0,1,23,8,2]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function _(n){return JSON.stringify(n,y)}e.stringify=_;function I(n){let k=JSON.parse(n);return k=C(k),k}e.parse=I;var S;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(S=e.MarshalledId||(e.MarshalledId={}));function y(n,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:(0,F.regExpFlags)(k)}:k}function C(n,k=0){if(!n||k>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return D.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof m.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let l=0;l<n.length;++l)n[l]=C(n[l],k+1);else for(const l in n)Object.hasOwnProperty.call(n,l)&&(n[l]=C(n[l],k+1))}return n}e.revive=C}),define(Ee[11],_e([0,1,2,21]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.userData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp"})(D=e.Schemas||(e.Schemas={}));class _{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,C,n){this._hosts[y]=C,this._ports[y]=n}setConnectionToken(y,C){this._connectionTokens[y]=C}rewrite(y){if(this._delegate)return this._delegate(y);const C=y.authority;let n=this._hosts[C];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const k=this._ports[C],l=this._connectionTokens[C];let h=`path=${encodeURIComponent(y.path)}`;return typeof l=="string"&&(h+=`&tkn=${encodeURIComponent(l)}`),m.URI.from({scheme:F.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${n}:${k}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new _;class I{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,C,n){const k=this.toUri(y,C);if(k.scheme===D.vscodeRemote)return e.RemoteAuthorities.rewrite(k);let l=!1;return F.isNative&&(n||F.isPreferringBrowserCodeLoad)&&k.scheme===D.file&&(l=!0),k.scheme===D.file&&typeof F.globals.importScripts=="function"&&F.globals.origin==="vscode-file://vscode-app"&&(l=!0),l?k.with({scheme:D.vscodeFileResource,authority:k.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):k}asFileUri(y,C){const n=this.toUri(y,C);return n.scheme===D.vscodeFileResource?n.with({scheme:D.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(y,C){return m.URI.isUri(y)?y:m.URI.parse(C.toUrl(y))}}e.FileAccess=new I}),define(Ee[25],_e([0,1,43,14,2,8,11,21]),function(ee,e,m,F,D,_,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(h){return(0,D.uriToFsPath)(h,!0)}e.originalFSPath=y;class C{constructor(a){this._ignorePathCasing=a}compare(a,d,f=!1){return a===d?0:(0,_.compare)(this.getComparisonKey(a,f),this.getComparisonKey(d,f))}isEqual(a,d,f=!1){return a===d?!0:!a||!d?!1:this.getComparisonKey(a,f)===this.getComparisonKey(d,f)}getComparisonKey(a,d=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,d,f=!1){if(a.scheme===d.scheme){if(a.scheme===I.Schemas.file)return m.isEqualOrParent(y(a),y(d),this._ignorePathCasing(a))&&a.query===d.query&&(f||a.fragment===d.fragment);if((0,e.isEqualAuthority)(a.authority,d.authority))return m.isEqualOrParent(a.path,d.path,this._ignorePathCasing(a),"/")&&a.query===d.query&&(f||a.fragment===d.fragment)}return!1}joinPath(a,...d){return D.URI.joinPath(a,...d)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return F.posix.basename(a.path)}extname(a){return F.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let d;return a.scheme===I.Schemas.file?d=D.URI.file(F.dirname(y(a))).path:(d=F.posix.dirname(a.path),a.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),d="/")),a.with({path:d})}normalizePath(a){if(!a.path.length)return a;let d;return a.scheme===I.Schemas.file?d=D.URI.file(F.normalize(y(a))).path:d=F.posix.normalize(a.path),a.with({path:d})}relativePath(a,d){if(a.scheme!==d.scheme||!(0,e.isEqualAuthority)(a.authority,d.authority))return;if(a.scheme===I.Schemas.file){const w=F.relative(y(a),y(d));return S.isWindows?m.toSlashes(w):w}let f=a.path||"/",E=d.path||"/";if(this._ignorePathCasing(a)){let w=0;for(const u=Math.min(f.length,E.length);w<u&&!(f.charCodeAt(w)!==E.charCodeAt(w)&&f.charAt(w).toLowerCase()!==E.charAt(w).toLowerCase());w++);f=E.substr(0,w)+f.substr(w)}return F.posix.relative(f,E)}resolvePath(a,d){if(a.scheme===I.Schemas.file){const f=D.URI.file(F.resolve(y(a),d));return a.with({authority:f.authority,path:f.path})}return d=m.toPosixPath(d),a.with({path:F.posix.resolve(a.path,d)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,d){return a===d||(0,_.equalsIgnoreCase)(a,d)}hasTrailingPathSeparator(a,d=F.sep){if(a.scheme===I.Schemas.file){const f=y(a);return f.length>m.getRoot(f).length&&f[f.length-1]===d}else{const f=a.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,d=F.sep){return(0,e.hasTrailingPathSeparator)(a,d)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,d=F.sep){let f=!1;if(a.scheme===I.Schemas.file){const E=y(a);f=E!==void 0&&E.length===m.getRoot(E).length&&E[E.length-1]===d}else{d="/";const E=a.path;f=E.length===1&&E.charCodeAt(E.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(a,d)?a.with({path:a.path+"/"}):a}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(h=>h.scheme===I.Schemas.file?!S.isLinux:!0),e.extUriIgnorePathCase=new C(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(h,a){const d=[];for(let f=0;f<h.length;f++){const E=a(h[f]);h.some((w,u)=>u===f?!1:(0,e.isEqualOrParent)(E,a(w)))||d.push(h[f])}return d}e.distinctParents=n;var k;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function a(d){const f=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(u=>{const[p,b]=u.split(":");p&&b&&f.set(p,b)});const w=d.path.substring(0,d.path.indexOf(";"));return w&&f.set(h.META_DATA_MIME,w),f}h.parseMetaData=a})(k=e.DataUri||(e.DataUri={}));function l(h,a,d){if(a){let f=h.path;return f&&f[0]!==F.posix.sep&&(f=F.posix.sep+f),h.with({scheme:d,authority:a,path:f})}return h.with({scheme:d})}e.toLocalResource=l}),define(Ee[16],_e([0,1,18,12,3,7,25]),function(ee,e,m,F,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(V){return!!V&&typeof V.then=="function"}e.isThenable=S;function y(V){const T=new m.CancellationTokenSource,G=V(T.token),B=new Promise((j,ce)=>{const W=T.token.onCancellationRequested(()=>{W.dispose(),T.dispose(),ce((0,F.canceled)())});Promise.resolve(G).then(te=>{W.dispose(),T.dispose(),j(te)},te=>{W.dispose(),T.dispose(),ce(te)})});return new class{cancel(){T.cancel()}then(j,ce){return B.then(j,ce)}catch(j){return this.then(void 0,j)}finally(j){return B.finally(j)}}}e.createCancelablePromise=y;function C(V,T,G){return Promise.race([V,new Promise(B=>T.onCancellationRequested(()=>B(G)))])}e.raceCancellation=C;async function n(V){let T=-1;const G=V.map((j,ce)=>j.then(W=>(T=ce,W))),B=await Promise.race(G);return V.forEach((j,ce)=>{ce!==T&&j.cancel()}),B}e.raceCancellablePromises=n;function k(V,T,G){let B;const j=setTimeout(()=>{B?.(void 0),G?.()},T);return Promise.race([V.finally(()=>clearTimeout(j)),new Promise(ce=>B=ce)])}e.raceTimeout=k;function l(V){return new Promise((T,G)=>{const B=V();S(B)?B.then(T,G):T(B)})}e.asPromise=l;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(T){if(this.activePromise){if(this.queuedPromiseFactory=T,!this.queuedPromise){const G=()=>{this.queuedPromise=null;const B=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,B};this.queuedPromise=new Promise(B=>{this.activePromise.then(G,G).then(B)})}return new Promise((G,B)=>{this.queuedPromise.then(G,B)})}return this.activePromise=T(),new Promise((G,B)=>{this.activePromise.then(j=>{this.activePromise=null,G(j)},j=>{this.activePromise=null,B(j)})})}}e.Throttler=h;class a{constructor(){this.current=Promise.resolve(null)}queue(T){return this.current=this.current.then(()=>T(),()=>T())}}e.Sequencer=a;class d{constructor(){this.promiseMap=new Map}queue(T,G){const j=(this.promiseMap.get(T)??Promise.resolve()).catch(()=>{}).then(G).finally(()=>{this.promiseMap.get(T)===j&&this.promiseMap.delete(T)});return this.promiseMap.set(T,j),j}}e.SequencerByKey=d;class f{constructor(T){this.defaultDelay=T,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(T,G=this.defaultDelay){return this.task=T,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,j)=>{this.doResolve=B,this.doReject=j}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},G),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,F.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=f;class E{constructor(T){this.delayer=new f(T),this.throttler=new h}trigger(T,G){return this.delayer.trigger(()=>this.throttler.queue(T),G)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class w{constructor(){this._isOpen=!1,this._promise=new Promise((T,G)=>{this._completePromise=T})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=w;class u extends w{constructor(T){super();this._timeout=setTimeout(()=>this.open(),T)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function p(V,T){return T?new Promise((G,B)=>{const j=setTimeout(()=>{ce.dispose(),G()},V),ce=T.onCancellationRequested(()=>{clearTimeout(j),ce.dispose(),B((0,F.canceled)())})}):y(G=>p(V,G))}e.timeout=p;function b(V,T=0){const G=setTimeout(V,T);return(0,_.toDisposable)(()=>clearTimeout(G))}e.disposableTimeout=b;function t(V){const T=[];let G=0;const B=V.length;function j(){return G<B?V[G++]():null}function ce(W){W!=null&&T.push(W);const te=j();return te?te.then(ce):Promise.resolve(T)}return Promise.resolve(null).then(ce)}e.sequence=t;function s(V,T=B=>!!B,G=null){let B=0;const j=V.length,ce=()=>{if(B>=j)return Promise.resolve(G);const W=V[B++];return Promise.resolve(W()).then(ue=>T(ue)?Promise.resolve(ue):ce())};return ce()}e.first=s;function r(V,T=B=>!!B,G=null){if(V.length===0)return Promise.resolve(G);let B=V.length;const j=()=>{B=-1;for(const ce of V)ce.cancel?.()};return new Promise((ce,W)=>{for(const te of V)te.then(ue=>{--B>=0&&T(ue)?(j(),ce(ue)):B===0&&ce(G)}).catch(ue=>{--B>=0&&(j(),W(ue))})})}e.firstParallel=r;class i{constructor(T){this._size=0,this.maxDegreeOfParalellism=T,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(T){return this._size++,new Promise((G,B)=>{this.outstandingPromises.push({factory:T,c:G,e:B}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const T=this.outstandingPromises.shift();this.runningPromises++;const G=T.factory();G.then(T.c,T.e),G.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class c extends i{constructor(){super(1)}}e.Queue=c;class g{constructor(){this.queues=new Map}queueFor(T,G=I.extUri){const B=G.getComparisonKey(T);let j=this.queues.get(B);return j||(j=new c,D.Event.once(j.onFinished)(()=>{j?.dispose(),this.queues.delete(B)}),this.queues.set(B,j)),j}dispose(){this.queues.forEach(T=>T.dispose()),this.queues.clear()}}e.ResourceQueue=g;class v{constructor(T,G){this._token=-1,typeof T=="function"&&typeof G=="number"&&this.setIfNotSet(T,G)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(T,G){this.cancel(),this._token=setTimeout(()=>{this._token=-1,T()},G)}setIfNotSet(T,G){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,T()},G))}}e.TimeoutTimer=v;class A{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(T,G){this.cancel(),this._token=setInterval(()=>{T()},G)}}e.IntervalTimer=A;class R{constructor(T,G){this.timeoutToken=-1,this.runner=T,this.timeout=G,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(T=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,T)}get delay(){return this.timeout}set delay(T){this.timeout=T}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class o extends R{constructor(T,G){super(T,G);this.units=[]}work(T){this.units.push(T),this.isScheduled()||this.schedule()}doRun(){const T=this.units;this.units=[],this.runner&&this.runner(T)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=o;class P extends _.Disposable{constructor(T,G,B,j){super();this.maxWorkChunkSize=T,this.maxPendingWork=G,this.throttleDelay=B,this.handler=j,this.pendingWork=[],this.throttler=this._register(new _.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(T){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+T.length>this.maxPendingWork)return!1}else if(this.pending+T.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...T),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=P,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const V=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=T=>{const G=setTimeout(()=>T(V));let B=!1;return{dispose(){B||(B=!0,clearTimeout(G))}}}}else e.runWhenIdle=(V,T)=>{const G=requestIdleCallback(V,typeof T=="number"?{timeout:T}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(G))}}}}();class L{constructor(T){this._didRun=!1,this._executor=()=>{try{this._value=T()}catch(G){this._error=G}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=L;async function $(V,T,G){let B;for(let j=0;j<G;j++)try{return await V()}catch(ce){B=ce,await p(T)}throw B}e.retry=$;class re{hasPending(T){return this._pending?typeof T=="number"?this._pending.taskId===T:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(T,G,B){return this._pending={taskId:T,cancel:()=>B?.(),promise:G},G.then(()=>this.donePending(T),()=>this.donePending(T)),G}donePending(T){this._pending&&T===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const T=this._next;this._next=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}setNext(T){if(this._next)this._next.run=T;else{let G,B;const j=new Promise((ce,W)=>{G=ce,B=W});this._next={run:T,promise:j,promiseResolve:G,promiseReject:B}}return this._next.promise}}e.TaskSequentializer=re;class he{constructor(T){this.interval=T,this.lastIncrementTime=0,this.value=0}increment(){const T=Date.now();return T-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=T,this.value=0),this.value++,this.value}}e.IntervalCounter=he;class Q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((T,G)=>{this.completeCallback=T,this.errorCallback=G})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(T){return new Promise(G=>{this.completeCallback(T),this.resolved=!0,G()})}error(T){return new Promise(G=>{this.errorCallback(T),this.rejected=!0,G()})}cancel(){new Promise(T=>{this.errorCallback((0,F.canceled)()),this.rejected=!0,T()})}}e.DeferredPromise=Q;var z;(function(V){async function T(G){let B;const j=await Promise.all(G.map(ce=>ce.then(W=>W,W=>{B||(B=W)})));if(typeof B!="undefined")throw B;return j}V.settled=T})(z=e.Promises||(e.Promises={}))}),define(Ee[113],_e([0,1,14,16]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new F.IdleValue(()=>{const R=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:R,collatorIsNumeric:R.resolvedOptions().numeric}}),_=new F.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),I=new F.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function S(R,o,P=!1){const L=R||"",$=o||"",re=D.value.collator.compare(L,$);return D.value.collatorIsNumeric&&re===0&&L!==$?L<$?-1:1:re}e.compareFileNames=S;function y(R,o){const P=_.value.collator;return R=R||"",o=o||"",b(P,R,o)}e.compareFileNamesDefault=y;function C(R,o){const P=_.value.collator;return R=R||"",o=o||"",i(R,o)||b(P,R,o)}e.compareFileNamesUpper=C;function n(R,o){const P=_.value.collator;return R=R||"",o=o||"",r(R,o)||b(P,R,o)}e.compareFileNamesLower=n;function k(R,o){return R=R||"",o=o||"",R===o?0:R<o?-1:1}e.compareFileNamesUnicode=k;function l(R,o,P=!1){P||(R=R&&R.toLowerCase(),o=o&&o.toLowerCase());const[L,$]=u(R),[re,he]=u(o);return L!==re?L<re?-1:1:$===he?0:$<he?-1:1}e.noIntlCompareFileNames=l;function h(R,o){const[P,L]=u(R),[$,re]=u(o);let he=D.value.collator.compare(L,re);if(he===0){if(D.value.collatorIsNumeric&&L!==re)return L<re?-1:1;if(he=D.value.collator.compare(P,$),D.value.collatorIsNumeric&&he===0&&P!==$)return P<$?-1:1}return he}e.compareFileExtensions=h;function a(R,o){R=R||"",o=o||"";const P=p(R),L=p(o),$=_.value.collator,re=I.value.collator;return b(re,P,L)||b($,R,o)}e.compareFileExtensionsDefault=a;function d(R,o){R=R||"",o=o||"";const P=p(R),L=p(o),$=_.value.collator,re=I.value.collator;return b(re,P,L)||i(R,o)||b($,R,o)}e.compareFileExtensionsUpper=d;function f(R,o){R=R||"",o=o||"";const P=p(R),L=p(o),$=_.value.collator,re=I.value.collator;return b(re,P,L)||r(R,o)||b($,R,o)}e.compareFileExtensionsLower=f;function E(R,o){R=R||"",o=o||"";const P=p(R).toLowerCase(),L=p(o).toLowerCase();return P!==L?P<L?-1:1:R!==o?R<o?-1:1:0}e.compareFileExtensionsUnicode=E;const w=/^(.*?)(\.([^.]*))?$/;function u(R,o=!1){const P=R?w.exec(R):[];let L=[P&&P[1]||"",P&&P[3]||""];return o&&(!L[0]&&L[1]||L[0]&&L[0].charAt(0)===".")&&(L=[L[0]+"."+L[1],""]),L}function p(R){const o=R?w.exec(R):[];return o&&o[1]&&o[1].charAt(0)!=="."&&o[3]||""}function b(R,o,P){let L=R.compare(o,P);return L!==0?L:o.length!==P.length?o.length<P.length?-1:1:0}function t(R){const o=R.charAt(0);return o.toLocaleUpperCase()!==o}function s(R){const o=R.charAt(0);return o.toLocaleLowerCase()!==o}function r(R,o){return t(R)&&s(o)?-1:s(R)&&t(o)?1:0}function i(R,o){return s(R)&&t(o)?-1:t(R)&&s(o)?1:0}function c(R,o,P=!1){return P||(R=R&&R.toLowerCase(),o=o&&o.toLowerCase()),R===o?0:R<o?-1:1}function g(R,o,P=!1){const L=R.split(m.sep),$=o.split(m.sep),re=L.length-1,he=$.length-1;let Q,z;for(let V=0;;V++){if(Q=re===V,z=he===V,Q&&z)return S(L[V],$[V],P);if(Q)return-1;if(z)return 1;const T=c(L[V],$[V],P);if(T!==0)return T}}e.comparePaths=g;function v(R,o,P){const L=R.toLowerCase(),$=o.toLowerCase(),re=A(R,o,P);if(re)return re;const he=L.endsWith(P),Q=$.endsWith(P);if(he!==Q)return he?-1:1;const z=S(L,$);return z!==0?z:L.localeCompare($)}e.compareAnything=v;function A(R,o,P){const L=R.toLowerCase(),$=o.toLowerCase(),re=L.startsWith(P),he=$.startsWith(P);if(re!==he)return re?-1:1;if(re&&he){if(L.length<$.length)return-1;if(L.length>$.length)return 1}return 0}e.compareByPrefix=A}),define(Ee[27],_e([0,1,8,43,14,22,16]),function(ee,e,m,F,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S;const y="**",C="/",n="[/\\\\]",k="[^/\\\\]",l=/\//g;function h(j){switch(j){case 0:return"";case 1:return`${k}*?`;default:return`(?:${n}|${k}+${n}|${n}${k}+)*?`}}function a(j,ce){if(!j)return[];const W=[];let te=!1,ue=!1,ye="";for(const Te of j){switch(Te){case ce:if(!te&&!ue){W.push(ye),ye="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}ye+=Te}return ye&&W.push(ye),W}e.splitGlobAware=a;function d(j){if(!j)return"";let ce="";const W=a(j,C);if(W.every(te=>te===y))ce=".*";else{let te=!1;W.forEach((ue,ye)=>{if(ue===y){te||(ce+=h(2),te=!0);return}let Te=!1,Re="",$e=!1,Ze="";for(const Ve of ue){if(Ve!=="}"&&Te){Re+=Ve;continue}if($e&&(Ve!=="]"||!Ze)){let je;Ve==="-"?je=Ve:(Ve==="^"||Ve==="!")&&!Ze?je="^":Ve===C?je="":je=m.escapeRegExpCharacters(Ve),Ze+=je;continue}switch(Ve){case"{":Te=!0;continue;case"[":$e=!0;continue;case"}":ce+=`(?:${a(Re,",").map(K=>d(K)).join("|")})`,Te=!1,Re="";break;case"]":ce+="["+Ze+"]",$e=!1,Ze="";break;case"?":ce+=k;continue;case"*":ce+=h(1);continue;default:ce+=m.escapeRegExpCharacters(Ve)}}ye<W.length-1&&(W[ye+1]!==y||ye+2<W.length)&&(ce+=n),te=!1})}return ce}const f=/^\*\*\/\*\.[\w\.-]+$/,E=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,b=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new _.LRUCache(1e4),s=function(){return!1},r=function(){return null};function i(j,ce){if(!j)return r;let W;typeof j!="string"?W=j.pattern:W=j,W=W.trim();const te=`${W}_${!!ce.trimForExclusions}`;let ue=t.get(te);if(ue)return c(ue,j);let ye;if(f.test(W)){const Te=W.substr(4);ue=function(Re,$e){return typeof Re=="string"&&Re.endsWith(Te)?W:null}}else(ye=E.exec(g(W,ce)))?ue=v(ye[1],W):(ce.trimForExclusions?u:w).test(W)?ue=A(W,ce):(ye=p.exec(g(W,ce)))?ue=R(ye[1].substr(1),W,!0):(ye=b.exec(g(W,ce)))?ue=R(ye[1],W,!1):ue=o(W);return t.set(te,ue),c(ue,j)}function c(j,ce){return typeof ce=="string"?j:function(W,te){return F.isEqualOrParent(W,ce.base)?j(D.relative(ce.base,W),te):null}}function g(j,ce){return ce.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function v(j,ce){const W=`/${j}`,te=`\\${j}`,ue=function(Te,Re){return typeof Te!="string"?null:Re?Re===j?ce:null:Te===j||Te.endsWith(W)||Te.endsWith(te)?ce:null},ye=[j];return ue.basenames=ye,ue.patterns=[ce],ue.allBasenames=ye,ue}function A(j,ce){const W=B(j.slice(1,-1).split(",").map(Re=>i(Re,ce)).filter(Re=>Re!==r),j),te=W.length;if(!te)return r;if(te===1)return W[0];const ue=function(Re,$e){for(let Ze=0,Ve=W.length;Ze<Ve;Ze++)if(W[Ze](Re,$e))return j;return null},ye=W.find(Re=>!!Re.allBasenames);ye&&(ue.allBasenames=ye.allBasenames);const Te=W.reduce((Re,$e)=>$e.allPaths?Re.concat($e.allPaths):Re,[]);return Te.length&&(ue.allPaths=Te),ue}function R(j,ce,W){const te=D.sep===D.posix.sep,ue=te?j:j.replace(l,D.sep),ye=D.sep+ue,Te=D.posix.sep+j,Re=W?function($e,Ze){return typeof $e=="string"&&($e===ue||$e.endsWith(ye)||!te&&($e===j||$e.endsWith(Te)))?ce:null}:function($e,Ze){return typeof $e=="string"&&($e===ue||!te&&$e===j)?ce:null};return Re.allPaths=[(W?"*/":"./")+j],Re}function o(j){try{const ce=new RegExp(`^${d(j)}$`);return function(W){return ce.lastIndex=0,typeof W=="string"&&ce.test(W)?j:null}}catch(ce){return r}}function P(j,ce,W){return!j||typeof ce!="string"?!1:L(j)(ce,void 0,W)}e.match=P;function L(j,ce={}){if(!j)return s;if(typeof j=="string"||Q(j)){const W=i(j,ce);if(W===r)return s;const te=function(ue,ye){return!!W(ue,ye)};return W.allBasenames&&(te.allBasenames=W.allBasenames),W.allPaths&&(te.allPaths=W.allPaths),te}return T(j,ce)}e.parse=L;function $(j){if(!j)return;let ce;return W=>(ce||(ce=(j()||Promise.resolve([])).then(te=>te?he(te):{})),ce.then(te=>!!te[W]))}e.hasSiblingPromiseFn=$;function re(j){if(!j)return;let ce;return W=>{if(!ce){const te=j();ce=te?he(te):{}}return!!ce[W]}}e.hasSiblingFn=re;function he(j){const ce={};for(const W of j)ce[W]=!0;return ce}function Q(j){const ce=j;return ce&&typeof ce.base=="string"&&typeof ce.pattern=="string"}e.isRelativePattern=Q;function z(j){return j.allBasenames||[]}e.getBasenameTerms=z;function V(j){return j.allPaths||[]}e.getPathTerms=V;function T(j,ce){const W=B(Object.getOwnPropertyNames(j).map(Re=>G(Re,j[Re],ce)).filter(Re=>Re!==r)),te=W.length;if(!te)return r;if(!W.some(Re=>!!Re.requiresSiblings)){if(te===1)return W[0];const Re=function(Ve,je){for(let O=0,K=W.length;O<K;O++){const J=W[O](Ve,je);if(J)return J}return null},$e=W.find(Ve=>!!Ve.allBasenames);$e&&(Re.allBasenames=$e.allBasenames);const Ze=W.reduce((Ve,je)=>je.allPaths?Ve.concat(je.allPaths):Ve,[]);return Ze.length&&(Re.allPaths=Ze),Re}const ue=function(Re,$e,Ze){let Ve;for(let je=0,O=W.length;je<O;je++){const K=W[je];K.requiresSiblings&&Ze&&($e||($e=D.basename(Re)),Ve||(Ve=$e.substr(0,$e.length-D.extname(Re).length)));const J=K(Re,$e,Ve,Ze);if(J)return J}return null},ye=W.find(Re=>!!Re.allBasenames);ye&&(ue.allBasenames=ye.allBasenames);const Te=W.reduce((Re,$e)=>$e.allPaths?Re.concat($e.allPaths):Re,[]);return Te.length&&(ue.allPaths=Te),ue}function G(j,ce,W){if(ce===!1)return r;const te=i(j,W);if(te===r)return r;if(typeof ce=="boolean")return te;if(ce){const ue=ce.when;if(typeof ue=="string"){const ye=(Te,Re,$e,Ze)=>{if(!Ze||!te(Te,Re))return null;const Ve=ue.replace("$(basename)",$e),je=Ze(Ve);return(0,I.isThenable)(je)?je.then(O=>O?j:null):je?j:null};return ye.requiresSiblings=!0,ye}}return te}function B(j,ce){const W=j.filter(Re=>!!Re.basenames);if(W.length<2)return j;const te=W.reduce((Re,$e)=>{const Ze=$e.basenames;return Ze?Re.concat(Ze):Re},[]);let ue;if(ce){ue=[];for(let Re=0,$e=te.length;Re<$e;Re++)ue.push(ce)}else ue=W.reduce((Re,$e)=>{const Ze=$e.patterns;return Ze?Re.concat(Ze):Re},[]);const ye=function(Re,$e){if(typeof Re!="string")return null;if(!$e){let Ve;for(Ve=Re.length;Ve>0;Ve--){const je=Re.charCodeAt(Ve-1);if(je===47||je===92)break}$e=Re.substr(Ve)}const Ze=te.indexOf($e);return Ze!==-1?ue[Ze]:null};ye.basenames=te,ye.patterns=ue,ye.allBasenames=te;const Te=j.filter(Re=>!Re.basenames);return Te.push(ye),Te}}),define(Ee[82],_e([0,1,2,14,8,11,21,25,43]),function(ee,e,m,F,D,_,I,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function C(i,c,g){if(typeof i=="string"&&(i=m.URI.file(i)),g){const A=g.getWorkspaceFolder(i);if(A){const R=g.getWorkspace().folders.length>1;let o;if((0,S.isEqual)(A.uri,i)?o="":o=(0,S.relativePath)(A.uri,i),R){const P=A.name?A.name:(0,S.basename)(A.uri);o=o?P+" \u2022 "+o:P}return o}}if(i.scheme!==_.Schemas.file&&i.scheme!==_.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(i.fsPath))return(0,F.normalize)(k(i.fsPath));let v=(0,F.normalize)(i.fsPath);return!I.isWindows&&c?.userHome&&(v=h(v,c.userHome.fsPath)),v}e.getPathLabel=C;function n(i){if(!i)return;typeof i=="string"&&(i=m.URI.file(i));const c=(0,S.basename)(i)||(i.scheme===_.Schemas.file?i.fsPath:i.path);return I.isWindows&&(0,y.isRootOrDriveLetter)(c)?k(c):c}e.getBaseLabel=n;function k(i){return(0,y.hasDriveLetter)(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=k;let l=Object.create(null);function h(i,c){if(I.isWindows||!i||!c)return i;let g=l.original===c?l.normalized:void 0;return g||(g=`${(0,D.rtrim)(c,F.posix.sep)}${F.posix.sep}`,l={original:c,normalized:g}),(I.isLinux?i.startsWith(g):(0,D.startsWithIgnoreCase)(i,g))&&(i=`~/${i.substr(g.length)}`),i}e.tildify=h;function a(i,c){return i.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=a;const d="\u2026",f="\\\\",E="~";function w(i,c=F.sep){const g=new Array(i.length);let v=!1;for(let A=0;A<i.length;A++){let R=i[A];if(R===""){g[A]=`.${c}`;continue}if(!R){g[A]=R;continue}v=!0;let o="";R.indexOf(f)===0?(o=R.substr(0,R.indexOf(f)+f.length),R=R.substr(R.indexOf(f)+f.length)):R.indexOf(c)===0?(o=R.substr(0,R.indexOf(c)+c.length),R=R.substr(R.indexOf(c)+c.length)):R.indexOf(E)===0&&(o=R.substr(0,R.indexOf(E)+E.length),R=R.substr(R.indexOf(E)+E.length));const P=R.split(c);for(let L=1;v&&L<=P.length;L++)for(let $=P.length-L;v&&$>=0;$--){v=!1;let re=P.slice($,$+L).join(c);for(let he=0;!v&&he<i.length;he++)if(he!==A&&i[he]&&i[he].indexOf(re)>-1){const Q=$+L===P.length,z=$>0&&i[he].indexOf(c)>-1?c+re:re,V=i[he].endsWith(z);v=!Q||V}if(!v){let he="";(P[0].endsWith(":")||o!=="")&&($===1&&($=0,L++,re=P[0]+c+re),$>0&&(he=P[0]+c),he=o+he),$>0&&(he=he+d+c),he=he+re,$+L<P.length&&(he=he+c+d),g[A]=he}}v&&(g[A]=R)}return g}e.shorten=w;var u;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function p(i,c=Object.create(null)){const g=[];let v=!1,A="";for(const R of i)if(R==="$"||v&&R==="{")A&&g.push({value:A,type:u.TEXT}),A="",v=!0;else if(R==="}"&&v){const o=c[A];if(typeof o=="string")o.length&&g.push({value:o,type:u.VARIABLE});else if(o){const P=g[g.length-1];(!P||P.type!==u.SEPARATOR)&&g.push({value:o.label,type:u.SEPARATOR})}A="",v=!1}else A+=R;return A&&!v&&g.push({value:A,type:u.TEXT}),g.filter((R,o)=>{if(R.type===u.SEPARATOR){const P=g[o-1],L=g[o+1];return[P,L].every($=>$&&($.type===u.VARIABLE||$.type===u.TEXT)&&$.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=p;function b(i,c){return I.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):i.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.mnemonicMenuLabel=b;function t(i,c){return I.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,""):I.isWindows?i.replace(/&&|&/g,g=>g==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function s(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=s;function r(i){const c=i.indexOf("/")!==-1?F.posix:F.win32,g=c.basename(i),v=c.dirname(i);return g.length?{name:g,parentPath:v}:{name:v,parentPath:""}}e.splitName=r}),define(Ee[83],_e([0,1,14,8,27,11,25]),function(ee,e,m,F,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var S;(function(s){s.text="text/plain",s.binary="application/octet-stream",s.unknown="application/unknown",s.markdown="text/markdown"})(S=e.Mimes||(e.Mimes={}));let y=[],C=[],n=[];function k(s,r=!1){const i=l(s);y.push(i),i.userConfigured?n.push(i):C.push(i),r&&!i.userConfigured&&y.forEach(c=>{c.mime===i.mime||c.userConfigured||(i.extension&&c.extension===i.extension&&console.warn(`Overwriting extension <<${i.extension}>> to now point to mime <<${i.mime}>>`),i.filename&&c.filename===i.filename&&console.warn(`Overwriting filename <<${i.filename}>> to now point to mime <<${i.mime}>>`),i.filepattern&&c.filepattern===i.filepattern&&console.warn(`Overwriting filepattern <<${i.filepattern}>> to now point to mime <<${i.mime}>>`),i.firstline&&c.firstline===i.firstline&&console.warn(`Overwriting firstline <<${i.firstline}>> to now point to mime <<${i.mime}>>`))})}e.registerTextMime=k;function l(s){return{id:s.id,mime:s.mime,filename:s.filename,extension:s.extension,filepattern:s.filepattern,firstline:s.firstline,userConfigured:s.userConfigured,filenameLowercase:s.filename?s.filename.toLowerCase():void 0,extensionLowercase:s.extension?s.extension.toLowerCase():void 0,filepatternLowercase:s.filepattern?s.filepattern.toLowerCase():void 0,filepatternOnPath:s.filepattern?s.filepattern.indexOf(m.posix.sep)>=0:!1}}function h(s){s?(y=y.filter(r=>!r.userConfigured),n=[]):(y=[],C=[],n=[])}e.clearTextMimes=h;function a(s,r){let i;if(s)switch(s.scheme){case _.Schemas.file:i=s.fsPath;break;case _.Schemas.data:i=I.DataUri.parseMetaData(s).get(I.DataUri.META_DATA_LABEL);break;default:i=s.path}if(!i)return[S.unknown];i=i.toLowerCase();const c=(0,m.basename)(i),g=d(i,c,n);if(g)return[g,S.text];const v=d(i,c,C);if(v)return[v,S.text];if(r){const A=f(r);if(A)return[A,S.text]}return[S.unknown]}e.guessMimeTypes=a;function d(s,r,i){let c=null,g=null,v=null;for(let A=i.length-1;A>=0;A--){const R=i[A];if(r===R.filenameLowercase){c=R;break}if(R.filepattern&&(!g||R.filepattern.length>g.filepattern.length)){const o=R.filepatternOnPath?s:r;(0,D.match)(R.filepatternLowercase,o)&&(g=R)}R.extension&&(!v||R.extension.length>v.extension.length)&&r.endsWith(R.extensionLowercase)&&(v=R)}return c?c.mime:g?g.mime:v?v.mime:null}function f(s){if((0,F.startsWithUTF8BOM)(s)&&(s=s.substr(1)),s.length>0)for(let r=y.length-1;r>=0;r--){const i=y[r];if(!i.firstline)continue;const c=s.match(i.firstline);if(c&&c.length>0)return i.mime}return null}function E(s){return s?typeof s=="string"?s===S.binary||s===S.text||s===S.unknown:s.length===1&&E(s[0]):!0}e.isUnspecific=E;const w={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function u(s){const r=(0,m.extname)(s);return w[r.toLowerCase()]}e.getMediaMime=u;function p(s){for(const r in w)if(w[r]===s)return r}e.getExtensionForMimeType=p;const b=/^(.+)\/(.+?)(;.+)?$/;function t(s,r){const i=b.exec(s);return i?`${i[1].toLowerCase()}/${i[2].toLowerCase()}${i[3]??""}`:r?void 0:s}e.normalizeMimeType=t}),define(Ee[114],_e([0,1,2]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function F(n){return n.toJSON()}class D{constructor(k){this._uriTransformer=k}transformIncoming(k){const l=this._uriTransformer.transformIncoming(k);return l===k?k:F(m.URI.from(l))}transformOutgoing(k){const l=this._uriTransformer.transformOutgoing(k);return l===k?k:F(m.URI.from(l))}transformOutgoingURI(k){const l=this._uriTransformer.transformOutgoing(k);return l===k?k:m.URI.from(l)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function _(n,k,l){if(!n||l>200)return null;if(typeof n=="object"){if(n instanceof m.URI)return k.transformOutgoing(n);for(let h in n)if(Object.hasOwnProperty.call(n,h)){const a=_(n[h],k,l+1);a!==null&&(n[h]=a)}}return null}function I(n,k){const l=_(n,k,0);return l===null?n:l}e.transformOutgoingURIs=I;function S(n,k,l,h){if(!n||h>200)return null;if(typeof n=="object"){if(n.$mid===1)return l?m.URI.revive(k.transformIncoming(n)):k.transformIncoming(n);for(let a in n)if(Object.hasOwnProperty.call(n,a)){const d=S(n[a],k,l,h+1);d!==null&&(n[a]=d)}}return null}function y(n,k){const l=S(n,k,!1,0);return l===null?n:l}e.transformIncomingURIs=y;function C(n,k){const l=S(n,k,!0,0);return l===null?n:l}e.transformAndReviveIncomingURIs=C}),define(Ee[35],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(y){return m.test(y)}e.isUUID=F;const D=new Uint8Array(16),_=[];for(let y=0;y<256;y++)_.push(y.toString(16).padStart(2,"0"));let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(y){for(let C=0;C<y.length;C++)y[C]=Math.floor(Math.random()*256);return y};function S(){I(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let y=0,C="";return C+=_[D[y++]],C+=_[D[y++]],C+=_[D[y++]],C+=_[D[y++]],C+="-",C+=_[D[y++]],C+=_[D[y++]],C+="-",C+=_[D[y++]],C+=_[D[y++]],C+="-",C+=_[D[y++]],C+=_[D[y++]],C+="-",C+=_[D[y++]],C+=_[D[y++]],C+=_[D[y++]],C+=_[D[y++]],C+=_[D[y++]],C+=_[D[y++]],C}e.generateUuid=S}),define(Ee[84],_e([0,1,80]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class F{constructor(S){let y=(0,m.toUint8)(S);this._defaultValue=y,this._asciiMap=F._createAsciiMap(y),this._map=new Map}static _createAsciiMap(S){let y=new Uint8Array(256);for(let C=0;C<256;C++)y[C]=S;return y}set(S,y){let C=(0,m.toUint8)(y);S>=0&&S<256?this._asciiMap[S]=C:this._map.set(S,C)}get(S){return S>=0&&S<256?this._asciiMap[S]:this._map.get(S)||this._defaultValue}}e.CharacterClassifier=F;var D;(function(I){I[I.False=0]="False",I[I.True=1]="True"})(D||(D={}));class _{constructor(){this._actual=new F(0)}add(S){this._actual.set(S,1)}has(S){return this._actual.get(S)===1}}e.CharacterSet=_}),define(Ee[115],_e([0,1,84]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var F;(function(I){I[I.Regular=0]="Regular",I[I.Whitespace=1]="Whitespace",I[I.WordSeparator=2]="WordSeparator"})(F=e.WordCharacterClass||(e.WordCharacterClass={}));class D extends m.CharacterClassifier{constructor(S){super(0);for(let y=0,C=S.length;y<C;y++)this.set(S.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=D;function _(I){let S={};return y=>(S.hasOwnProperty(y)||(S[y]=I(y)),S[y])}e.getMapForWordSeparators=_(I=>new D(I))}),define(Ee[36],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class m{constructor(D,_){this.lineNumber=D,this.column=_}with(D=this.lineNumber,_=this.column){return D===this.lineNumber&&_===this.column?this:new m(D,_)}delta(D=0,_=0){return this.with(this.lineNumber+D,this.column+_)}equals(D){return m.equals(this,D)}static equals(D,_){return!D&&!_?!0:!!D&&!!_&&D.lineNumber===_.lineNumber&&D.column===_.column}isBefore(D){return m.isBefore(this,D)}static isBefore(D,_){return D.lineNumber<_.lineNumber?!0:_.lineNumber<D.lineNumber?!1:D.column<_.column}isBeforeOrEqual(D){return m.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,_){return D.lineNumber<_.lineNumber?!0:_.lineNumber<D.lineNumber?!1:D.column<=_.column}static compare(D,_){let I=D.lineNumber|0,S=_.lineNumber|0;if(I===S){let y=D.column|0,C=_.column|0;return y-C}return I-S}clone(){return new m(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new m(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=m}),define(Ee[30],_e([0,1,36]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class F{constructor(_,I,S,y){_>S||_===S&&I>y?(this.startLineNumber=S,this.startColumn=y,this.endLineNumber=_,this.endColumn=I):(this.startLineNumber=_,this.startColumn=I,this.endLineNumber=S,this.endColumn=y)}isEmpty(){return F.isEmpty(this)}static isEmpty(_){return _.startLineNumber===_.endLineNumber&&_.startColumn===_.endColumn}containsPosition(_){return F.containsPosition(this,_)}static containsPosition(_,I){return!(I.lineNumber<_.startLineNumber||I.lineNumber>_.endLineNumber||I.lineNumber===_.startLineNumber&&I.column<_.startColumn||I.lineNumber===_.endLineNumber&&I.column>_.endColumn)}containsRange(_){return F.containsRange(this,_)}static containsRange(_,I){return!(I.startLineNumber<_.startLineNumber||I.endLineNumber<_.startLineNumber||I.startLineNumber>_.endLineNumber||I.endLineNumber>_.endLineNumber||I.startLineNumber===_.startLineNumber&&I.startColumn<_.startColumn||I.endLineNumber===_.endLineNumber&&I.endColumn>_.endColumn)}strictContainsRange(_){return F.strictContainsRange(this,_)}static strictContainsRange(_,I){return!(I.startLineNumber<_.startLineNumber||I.endLineNumber<_.startLineNumber||I.startLineNumber>_.endLineNumber||I.endLineNumber>_.endLineNumber||I.startLineNumber===_.startLineNumber&&I.startColumn<=_.startColumn||I.endLineNumber===_.endLineNumber&&I.endColumn>=_.endColumn)}plusRange(_){return F.plusRange(this,_)}static plusRange(_,I){let S,y,C,n;return I.startLineNumber<_.startLineNumber?(S=I.startLineNumber,y=I.startColumn):I.startLineNumber===_.startLineNumber?(S=I.startLineNumber,y=Math.min(I.startColumn,_.startColumn)):(S=_.startLineNumber,y=_.startColumn),I.endLineNumber>_.endLineNumber?(C=I.endLineNumber,n=I.endColumn):I.endLineNumber===_.endLineNumber?(C=I.endLineNumber,n=Math.max(I.endColumn,_.endColumn)):(C=_.endLineNumber,n=_.endColumn),new F(S,y,C,n)}intersectRanges(_){return F.intersectRanges(this,_)}static intersectRanges(_,I){let S=_.startLineNumber,y=_.startColumn,C=_.endLineNumber,n=_.endColumn,k=I.startLineNumber,l=I.startColumn,h=I.endLineNumber,a=I.endColumn;return S<k?(S=k,y=l):S===k&&(y=Math.max(y,l)),C>h?(C=h,n=a):C===h&&(n=Math.min(n,a)),S>C||S===C&&y>n?null:new F(S,y,C,n)}equalsRange(_){return F.equalsRange(this,_)}static equalsRange(_,I){return!!_&&!!I&&_.startLineNumber===I.startLineNumber&&_.startColumn===I.startColumn&&_.endLineNumber===I.endLineNumber&&_.endColumn===I.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(_){return new m.Position(_.endLineNumber,_.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(_){return new m.Position(_.startLineNumber,_.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(_,I){return new F(this.startLineNumber,this.startColumn,_,I)}setStartPosition(_,I){return new F(_,I,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(_){return new F(_.startLineNumber,_.startColumn,_.startLineNumber,_.startColumn)}static fromPositions(_,I=_){return new F(_.lineNumber,_.column,I.lineNumber,I.column)}static lift(_){return _?new F(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn):null}static isIRange(_){return _&&typeof _.startLineNumber=="number"&&typeof _.startColumn=="number"&&typeof _.endLineNumber=="number"&&typeof _.endColumn=="number"}static areIntersectingOrTouching(_,I){return!(_.endLineNumber<I.startLineNumber||_.endLineNumber===I.startLineNumber&&_.endColumn<I.startColumn||I.endLineNumber<_.startLineNumber||I.endLineNumber===_.startLineNumber&&I.endColumn<_.startColumn)}static areIntersecting(_,I){return!(_.endLineNumber<I.startLineNumber||_.endLineNumber===I.startLineNumber&&_.endColumn<=I.startColumn||I.endLineNumber<_.startLineNumber||I.endLineNumber===_.startLineNumber&&I.endColumn<=_.startColumn)}static compareRangesUsingStarts(_,I){if(_&&I){const C=_.startLineNumber|0,n=I.startLineNumber|0;if(C===n){const k=_.startColumn|0,l=I.startColumn|0;if(k===l){const h=_.endLineNumber|0,a=I.endLineNumber|0;if(h===a){const d=_.endColumn|0,f=I.endColumn|0;return d-f}return h-a}return k-l}return C-n}return(_?1:0)-(I?1:0)}static compareRangesUsingEnds(_,I){return _.endLineNumber===I.endLineNumber?_.endColumn===I.endColumn?_.startLineNumber===I.startLineNumber?_.startColumn-I.startColumn:_.startLineNumber-I.startLineNumber:_.endColumn-I.endColumn:_.endLineNumber-I.endLineNumber}static spansMultipleLines(_){return _.endLineNumber>_.startLineNumber}}e.Range=F}),define(Ee[116],_e([0,1,36,30]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var D;(function(I){I[I.LTR=0]="LTR",I[I.RTL=1]="RTL"})(D=e.SelectionDirection||(e.SelectionDirection={}));class _ extends F.Range{constructor(S,y,C,n){super(S,y,C,n);this.selectionStartLineNumber=S,this.selectionStartColumn=y,this.positionLineNumber=C,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(S){return _.selectionsEqual(this,S)}static selectionsEqual(S,y){return S.selectionStartLineNumber===y.selectionStartLineNumber&&S.selectionStartColumn===y.selectionStartColumn&&S.positionLineNumber===y.positionLineNumber&&S.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(S,y){return this.getDirection()===0?new _(this.startLineNumber,this.startColumn,S,y):new _(S,y,this.startLineNumber,this.startColumn)}getPosition(){return new m.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(S,y){return this.getDirection()===0?new _(S,y,this.endLineNumber,this.endColumn):new _(this.endLineNumber,this.endColumn,S,y)}static fromPositions(S,y=S){return new _(S.lineNumber,S.column,y.lineNumber,y.column)}static liftSelection(S){return new _(S.selectionStartLineNumber,S.selectionStartColumn,S.positionLineNumber,S.positionColumn)}static selectionsArrEqual(S,y){if(S&&!y||!S&&y)return!1;if(!S&&!y)return!0;if(S.length!==y.length)return!1;for(let C=0,n=S.length;C<n;C++)if(!this.selectionsEqual(S[C],y[C]))return!1;return!0}static isISelection(S){return S&&typeof S.selectionStartLineNumber=="number"&&typeof S.selectionStartColumn=="number"&&typeof S.positionLineNumber=="number"&&typeof S.positionColumn=="number"}static createWithDirection(S,y,C,n,k){return k===0?new _(S,y,C,n):new _(C,n,S,y)}}e.Selection=_}),define(Ee[85],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var m;(function(a){a[a.Left=1]="Left",a[a.Center=2]="Center",a[a.Right=4]="Right",a[a.Full=7]="Full"})(m=e.OverviewRulerLane||(e.OverviewRulerLane={}));var F;(function(a){a[a.Inline=1]="Inline",a[a.Gutter=2]="Gutter"})(F=e.MinimapPosition||(e.MinimapPosition={}));var D;(function(a){a[a.TextDefined=0]="TextDefined",a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(D=e.EndOfLinePreference||(e.EndOfLinePreference={}));var _;(function(a){a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(_=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var I;(function(a){a[a.LF=0]="LF",a[a.CRLF=1]="CRLF"})(I=e.EndOfLineSequence||(e.EndOfLineSequence={}));class S{constructor(d){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,d.tabSize|0),this.indentSize=d.tabSize|0,this.insertSpaces=Boolean(d.insertSpaces),this.defaultEOL=d.defaultEOL|0,this.trimAutoWhitespace=Boolean(d.trimAutoWhitespace)}equals(d){return this.tabSize===d.tabSize&&this.indentSize===d.indentSize&&this.insertSpaces===d.insertSpaces&&this.defaultEOL===d.defaultEOL&&this.trimAutoWhitespace===d.trimAutoWhitespace}createChangeEvent(d){return{tabSize:this.tabSize!==d.tabSize,indentSize:this.indentSize!==d.indentSize,insertSpaces:this.insertSpaces!==d.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==d.trimAutoWhitespace}}}e.TextModelResolvedOptions=S;class y{constructor(d,f){this._findMatchBrand=void 0,this.range=d,this.matches=f}}e.FindMatch=y;var C;(function(a){a[a.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",a[a.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",a[a.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",a[a.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var n;(function(a){a[a.Left=0]="Left",a[a.Right=1]="Right",a[a.None=2]="None"})(n=e.PositionAffinity||(e.PositionAffinity={}));var k;(function(a){a[a.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(k=e.ModelConstants||(e.ModelConstants={}));class l{constructor(d,f,E,w,u,p){this.identifier=d,this.range=f,this.text=E,this.forceMoveMarkers=w,this.isAutoWhitespaceEdit=u,this._isTracked=p}}e.ValidAnnotatedEditOperation=l;class h{constructor(d,f,E){this.reverseEdits=d,this.changes=f,this.trimAutoWhitespaceLineNumbers=E}}e.ApplyEditsResult=h}),define(Ee[117],_e([0,1,8,115,36,30,85]),function(ee,e,m,F,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const S=999;class y{constructor(u,p,b,t){this.searchString=u,this.isRegex=p,this.matchCase=b,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let u;this.isRegex?u=C(this.searchString):u=this.searchString.indexOf(`
`)>=0;let p=null;try{p=m.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:u,global:!0,unicode:!0})}catch(t){return null}if(!p)return null;let b=!this.isRegex&&!u;return b&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(b=this.matchCase),new n(p,this.wordSeparators?(0,F.getMapForWordSeparators)(this.wordSeparators):null,b?this.searchString:null)}}e.SearchParams=y;function C(w){if(!w||w.length===0)return!1;for(let u=0,p=w.length;u<p;u++)if(w.charCodeAt(u)===92){if(u++,u>=p)break;const t=w.charCodeAt(u);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=C;class n{constructor(u,p,b){this.regex=u,this.wordSeparators=p,this.simpleSearch=b}}e.SearchData=n;function k(w,u,p){if(!p)return new I.FindMatch(w,null);let b=[];for(let t=0,s=u.length;t<s;t++)b[t]=u[t];return new I.FindMatch(w,b)}e.createFindMatch=k;class l{constructor(u){let p=[],b=0;for(let t=0,s=u.length;t<s;t++)u.charCodeAt(t)===10&&(p[b++]=t);this._lineFeedsOffsets=p}findLineFeedCountBeforeOffset(u){const p=this._lineFeedsOffsets;let b=0,t=p.length-1;if(t===-1||u<=p[0])return 0;for(;b<t;){const s=b+((t-b)/2>>0);p[s]>=u?t=s-1:p[s+1]>=u?(b=s,t=s):b=s+1}return b+1}}class h{static findMatches(u,p,b,t,s){const r=p.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(u,b,new E(r.wordSeparators,r.regex),t,s):this._doFindMatchesLineByLine(u,b,r,t,s):[]}static _getMultilineMatchRange(u,p,b,t,s,r){let i,c=0;t?(c=t.findLineFeedCountBeforeOffset(s),i=p+s+c):i=p+s;let g;if(t){let o=t.findLineFeedCountBeforeOffset(s+r.length)-c;g=i+r.length+o}else g=i+r.length;const v=u.getPositionAt(i),A=u.getPositionAt(g);return new _.Range(v.lineNumber,v.column,A.lineNumber,A.column)}static _doFindMatchesMultiline(u,p,b,t,s){const r=u.getOffsetAt(p.getStartPosition()),i=u.getValueInRange(p,1),c=u.getEOL()===`\r
`?new l(i):null,g=[];let v=0,A;for(b.reset(0);A=b.next(i);)if(g[v++]=k(this._getMultilineMatchRange(u,r,i,c,A.index,A[0]),A,t),v>=s)return g;return g}static _doFindMatchesLineByLine(u,p,b,t,s){const r=[];let i=0;if(p.startLineNumber===p.endLineNumber){const g=u.getLineContent(p.startLineNumber).substring(p.startColumn-1,p.endColumn-1);return i=this._findMatchesInLine(b,g,p.startLineNumber,p.startColumn-1,i,r,t,s),r}const c=u.getLineContent(p.startLineNumber).substring(p.startColumn-1);i=this._findMatchesInLine(b,c,p.startLineNumber,p.startColumn-1,i,r,t,s);for(let g=p.startLineNumber+1;g<p.endLineNumber&&i<s;g++)i=this._findMatchesInLine(b,u.getLineContent(g),g,0,i,r,t,s);if(i<s){const g=u.getLineContent(p.endLineNumber).substring(0,p.endColumn-1);i=this._findMatchesInLine(b,g,p.endLineNumber,0,i,r,t,s)}return r}static _findMatchesInLine(u,p,b,t,s,r,i,c){const g=u.wordSeparators;if(!i&&u.simpleSearch){const R=u.simpleSearch,o=R.length,P=p.length;let L=-o;for(;(L=p.indexOf(R,L+o))!==-1;)if((!g||f(g,p,P,L,o))&&(r[s++]=new I.FindMatch(new _.Range(b,L+1+t,b,L+1+o+t),null),s>=c))return s;return s}const v=new E(u.wordSeparators,u.regex);let A;v.reset(0);do if(A=v.next(p),A&&(r[s++]=k(new _.Range(b,A.index+1+t,b,A.index+1+A[0].length+t),A,i),s>=c))return s;while(A);return s}static findNextMatch(u,p,b,t){const s=p.parseSearchRequest();if(!s)return null;const r=new E(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindNextMatchMultiline(u,b,r,t):this._doFindNextMatchLineByLine(u,b,r,t)}static _doFindNextMatchMultiline(u,p,b,t){const s=new D.Position(p.lineNumber,1),r=u.getOffsetAt(s),i=u.getLineCount(),c=u.getValueInRange(new _.Range(s.lineNumber,s.column,i,u.getLineMaxColumn(i)),1),g=u.getEOL()===`\r
`?new l(c):null;b.reset(p.column-1);let v=b.next(c);return v?k(this._getMultilineMatchRange(u,r,c,g,v.index,v[0]),v,t):p.lineNumber!==1||p.column!==1?this._doFindNextMatchMultiline(u,new D.Position(1,1),b,t):null}static _doFindNextMatchLineByLine(u,p,b,t){const s=u.getLineCount(),r=p.lineNumber,i=u.getLineContent(r),c=this._findFirstMatchInLine(b,i,r,p.column,t);if(c)return c;for(let g=1;g<=s;g++){const v=(r+g-1)%s,A=u.getLineContent(v+1),R=this._findFirstMatchInLine(b,A,v+1,1,t);if(R)return R}return null}static _findFirstMatchInLine(u,p,b,t,s){u.reset(t-1);const r=u.next(p);return r?k(new _.Range(b,r.index+1,b,r.index+1+r[0].length),r,s):null}static findPreviousMatch(u,p,b,t){const s=p.parseSearchRequest();if(!s)return null;const r=new E(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindPreviousMatchMultiline(u,b,r,t):this._doFindPreviousMatchLineByLine(u,b,r,t)}static _doFindPreviousMatchMultiline(u,p,b,t){const s=this._doFindMatchesMultiline(u,new _.Range(1,1,p.lineNumber,p.column),b,t,10*S);if(s.length>0)return s[s.length-1];const r=u.getLineCount();return p.lineNumber!==r||p.column!==u.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(u,new D.Position(r,u.getLineMaxColumn(r)),b,t):null}static _doFindPreviousMatchLineByLine(u,p,b,t){const s=u.getLineCount(),r=p.lineNumber,i=u.getLineContent(r).substring(0,p.column-1),c=this._findLastMatchInLine(b,i,r,t);if(c)return c;for(let g=1;g<=s;g++){const v=(s+r-g-1)%s,A=u.getLineContent(v+1),R=this._findLastMatchInLine(b,A,v+1,t);if(R)return R}return null}static _findLastMatchInLine(u,p,b,t){let s=null,r;for(u.reset(0);r=u.next(p);)s=k(new _.Range(b,r.index+1,b,r.index+1+r[0].length),r,t);return s}}e.TextModelSearch=h;function a(w,u,p,b,t){if(b===0)return!0;const s=u.charCodeAt(b-1);if(w.get(s)!==0||s===13||s===10)return!0;if(t>0){const r=u.charCodeAt(b);if(w.get(r)!==0)return!0}return!1}function d(w,u,p,b,t){if(b+t===p)return!0;const s=u.charCodeAt(b+t);if(w.get(s)!==0||s===13||s===10)return!0;if(t>0){const r=u.charCodeAt(b+t-1);if(w.get(r)!==0)return!0}return!1}function f(w,u,p,b,t){return a(w,u,p,b,t)&&d(w,u,p,b,t)}e.isValidMatch=f;class E{constructor(u,p){this._wordSeparators=u,this._searchRegex=p,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(u){this._searchRegex.lastIndex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(u){const p=u.length;let b;do{if(this._prevMatchStartIndex+this._prevMatchLength===p||(b=this._searchRegex.exec(u),!b))return null;const t=b.index,s=b[0].length;if(t===this._prevMatchStartIndex&&s===this._prevMatchLength){if(s===0){m.getNextCodePoint(u,p,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=s,!this._wordSeparators||f(this._wordSeparators,u,p,t,s))return b}while(b);return null}}e.Searcher=E}),define(Ee[86],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function m(S=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)S.indexOf(C)>=0||(y+="\\"+C);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=m();function F(S){let y=e.DEFAULT_WORD_REGEXP;if(S&&S instanceof RegExp)if(S.global)y=S;else{let C="g";S.ignoreCase&&(C+="i"),S.multiline&&(C+="m"),S.unicode&&(C+="u"),y=new RegExp(S.source,C)}return y.lastIndex=0,y}e.ensureValidWordDefinition=F;const D={maxLen:1e3,windowSize:15,timeBudget:150};function _(S,y,C,n,k=D){if(C.length>k.maxLen){let f=S-k.maxLen/2;return f<0?f=0:n+=f,C=C.substring(f,S+k.maxLen/2),_(S,y,C,n,k)}const l=Date.now(),h=S-1-n;let a=-1,d=null;for(let f=1;!(Date.now()-l>=k.timeBudget);f++){const E=h-k.windowSize*f;y.lastIndex=Math.max(0,E);const w=I(y,C,h,a);if(!w&&d||(d=w,E<=0))break;a=E}if(d){let f={word:d[0],startColumn:n+1+d.index,endColumn:n+1+d.index+d[0].length};return y.lastIndex=0,f}return null}e.getWordAtText=_;function I(S,y,C,n){let k;for(;k=S.exec(y);){const l=k.index||0;if(l<=C&&S.lastIndex>=C)return k;if(n>0&&l>n)return null}return null}}),define(Ee[118],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var m;(function(I){I[I.None=0]="None",I[I.Indent=1]="Indent",I[I.IndentOutdent=2]="IndentOutdent",I[I.Outdent=3]="Outdent"})(m=e.IndentAction||(e.IndentAction={}));class F{constructor(S){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=S.open,this.close=S.close,this._standardTokenMask=0,Array.isArray(S.notIn))for(let y=0,C=S.notIn.length;y<C;y++)switch(S.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(S){return(this._standardTokenMask&S)==0}}e.StandardAutoClosingPairConditional=F;class D{constructor(S){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of S)_(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),_(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),_(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),_(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&_(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=D;function _(I,S,y){I.has(S)?I.get(S).push(y):I.set(S,[y])}}),define(Ee[55],_e([0,1,27,14]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(_,I,S,y){if(Array.isArray(_)){let C=0;for(const n of _){const k=D(n,I,S,y);if(k===10)return k;k>C&&(C=k)}return C}else{if(typeof _=="string")return y?_==="*"?5:_===S?10:0:0;if(_){const{language:C,pattern:n,scheme:k,hasAccessToAllModels:l}=_;if(!y&&!l)return 0;let h=0;if(k)if(k===I.scheme)h=10;else if(k==="*")h=5;else return 0;if(C)if(C===S)h=10;else if(C==="*")h=Math.max(h,5);else return 0;if(n){let a;if(typeof n=="string"?a=n:a={...n,base:(0,F.normalize)(n.base)},a===I.fsPath||(0,m.match)(a,I.fsPath))h=10;else return 0}return h}else return 0}}e.score=D}),define(Ee[119],_e([0,1,84]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var F;(function(h){h[h.Invalid=0]="Invalid",h[h.Start=1]="Start",h[h.H=2]="H",h[h.HT=3]="HT",h[h.HTT=4]="HTT",h[h.HTTP=5]="HTTP",h[h.F=6]="F",h[h.FI=7]="FI",h[h.FIL=8]="FIL",h[h.BeforeColon=9]="BeforeColon",h[h.AfterColon=10]="AfterColon",h[h.AlmostThere=11]="AlmostThere",h[h.End=12]="End",h[h.Accept=13]="Accept",h[h.LastKnownState=14]="LastKnownState"})(F=e.State||(e.State={}));class D{constructor(a,d,f){const E=new Uint8Array(a*d);for(let w=0,u=a*d;w<u;w++)E[w]=f;this._data=E,this.rows=a,this.cols=d}get(a,d){return this._data[a*this.cols+d]}set(a,d,f){this._data[a*this.cols+d]=f}}e.Uint8Matrix=D;class _{constructor(a){let d=0,f=0;for(let w=0,u=a.length;w<u;w++){let[p,b,t]=a[w];b>d&&(d=b),p>f&&(f=p),t>f&&(f=t)}d++,f++;let E=new D(f,d,0);for(let w=0,u=a.length;w<u;w++){let[p,b,t]=a[w];E.set(p,b,t)}this._states=E,this._maxCharCode=d}nextState(a,d){return d<0||d>=this._maxCharCode?0:this._states.get(a,d)}}e.StateMachine=_;let I=null;function S(){return I===null&&(I=new _([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),I}var y;(function(h){h[h.None=0]="None",h[h.ForceTermination=1]="ForceTermination",h[h.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let C=null;function n(){if(C===null){C=new m.CharacterClassifier(0);const h=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<h.length;d++)C.set(h.charCodeAt(d),1);const a=".,;";for(let d=0;d<a.length;d++)C.set(a.charCodeAt(d),2)}return C}class k{static _createLink(a,d,f,E,w){let u=w-1;do{const p=d.charCodeAt(u);if(a.get(p)!==2)break;u--}while(u>E);if(E>0){const p=d.charCodeAt(E-1),b=d.charCodeAt(u);(p===40&&b===41||p===91&&b===93||p===123&&b===125)&&u--}return{range:{startLineNumber:f,startColumn:E+1,endLineNumber:f,endColumn:u+2},url:d.substring(E,u+1)}}static computeLinks(a,d=S()){const f=n();let E=[];for(let w=1,u=a.getLineCount();w<=u;w++){const p=a.getLineContent(w),b=p.length;let t=0,s=0,r=0,i=1,c=!1,g=!1,v=!1,A=!1;for(;t<b;){let R=!1;const o=p.charCodeAt(t);if(i===13){let P;switch(o){case 40:c=!0,P=0;break;case 41:P=c?0:1;break;case 91:v=!0,g=!0,P=0;break;case 93:v=!1,P=g?0:1;break;case 123:A=!0,P=0;break;case 125:P=A?0:1;break;case 39:P=r===34||r===96?0:1;break;case 34:P=r===39||r===96?0:1;break;case 96:P=r===39||r===34?0:1;break;case 42:P=r===42?1:0;break;case 124:P=r===124?1:0;break;case 32:P=v?0:1;break;default:P=f.get(o)}P===1&&(E.push(k._createLink(f,p,w,s,t)),R=!0)}else if(i===12){let P;o===91?(g=!0,P=0):P=f.get(o),P===1?R=!0:i=13}else i=d.nextState(i,o),i===0&&(R=!0);R&&(i=1,c=!1,g=!1,A=!1,s=t+1,r=o),t++}i===13&&E.push(k._createLink(f,p,w,s,b))}return E}}e.LinkComputer=k;function l(h){return!h||typeof h.getLineCount!="function"||typeof h.getLineContent!="function"?[]:k.computeLinks(h)}e.computeLinks=l}),define(Ee[120],_e([0,1,3,7]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class D{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new m.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(I){this._onDidChange.fire({changedLanguages:I,changedColorMap:!1})}register(I,S){return this._map.set(I,S),this.fire([I]),(0,F.toDisposable)(()=>{this._map.get(I)===S&&(this._map.delete(I),this.fire([I]))})}registerPromise(I,S){let y=null,C=!1;return this._promises.set(I,S.then(n=>{this._promises.delete(I),!(C||!n)&&(y=this.register(I,n))})),(0,F.toDisposable)(()=>{C=!0,y&&y.dispose()})}getPromise(I){const S=this.get(I);if(S)return Promise.resolve(S);const y=this._promises.get(I);return y?y.then(C=>this.get(I)):null}get(I){return this._map.get(I)||null}setColorMap(I){this._colorMap=I,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=D}),define(Ee[87],_e([0,1,23,21]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(D||(D={}));function _(k){for(let l=0,h=k.length;l<h;l+=4){const a=k[l+0],d=k[l+1],f=k[l+2],E=k[l+3];k[l+0]=E,k[l+1]=f,k[l+2]=d,k[l+3]=a}}function I(k){const l=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return F.isLittleEndian()||_(l),m.VSBuffer.wrap(l)}function S(k){const l=k.buffer;if(F.isLittleEndian()||_(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const h=new Uint8Array(l.byteLength);return h.set(l),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function y(k){const l=new Uint32Array(C(k));let h=0;if(l[h++]=k.id,k.type==="full")l[h++]=1,l[h++]=k.data.length,l.set(k.data,h),h+=k.data.length;else{l[h++]=2,l[h++]=k.deltas.length;for(const a of k.deltas)l[h++]=a.start,l[h++]=a.deleteCount,a.data?(l[h++]=a.data.length,l.set(a.data,h),h+=a.data.length):l[h++]=0}return I(l)}e.encodeSemanticTokensDto=y;function C(k){let l=0;if(l+=1+1,k.type==="full")l+=1+k.data.length;else{l+=1,l+=(1+1+1)*k.deltas.length;for(const h of k.deltas)h.data&&(l+=h.data.length)}return l}function n(k){const l=S(k);let h=0;const a=l[h++];if(l[h++]===1){const w=l[h++],u=l.subarray(h,h+w);return h+=w,{id:a,type:"full",data:u}}const f=l[h++];let E=[];for(let w=0;w<f;w++){const u=l[h++],p=l[h++],b=l[h++];let t;b>0&&(t=l.subarray(h,h+b),h+=b),E[w]={start:u,deleteCount:p,data:t}}return{id:a,type:"delta",deltas:E}}e.decodeSemanticTokensDto=n}),define(Ee[88],_e([0,1,80]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class F{constructor(I,S){this._prefixSumIndexOfResultBrand=void 0,this.index=I,this.remainder=S}}e.PrefixSumIndexOfResult=F;class D{constructor(I){this.values=I,this.prefixSum=new Uint32Array(I.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(I,S){I=(0,m.toUint32)(I);const y=this.values,C=this.prefixSum,n=S.length;return n===0?!1:(this.values=new Uint32Array(y.length+n),this.values.set(y.subarray(0,I),0),this.values.set(y.subarray(I),I+n),this.values.set(S,I),I-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=I-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(I,S){return I=(0,m.toUint32)(I),S=(0,m.toUint32)(S),this.values[I]===S?!1:(this.values[I]=S,I-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=I-1),!0)}removeValues(I,S){I=(0,m.toUint32)(I),S=(0,m.toUint32)(S);const y=this.values,C=this.prefixSum;if(I>=y.length)return!1;let n=y.length-I;return S>=n&&(S=n),S===0?!1:(this.values=new Uint32Array(y.length-S),this.values.set(y.subarray(0,I),0),this.values.set(y.subarray(I+S),I),this.prefixSum=new Uint32Array(this.values.length),I-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=I-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(I){return I<0?0:(I=(0,m.toUint32)(I),this._getPrefixSum(I))}_getPrefixSum(I){if(I<=this.prefixSumValidIndex[0])return this.prefixSum[I];let S=this.prefixSumValidIndex[0]+1;S===0&&(this.prefixSum[0]=this.values[0],S++),I>=this.values.length&&(I=this.values.length-1);for(let y=S;y<=I;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],I),this.prefixSum[I]}getIndexOf(I){I=Math.floor(I),this.getTotalSum();let S=0,y=this.values.length-1,C=0,n=0,k=0;for(;S<=y;)if(C=S+(y-S)/2|0,n=this.prefixSum[C],k=n-this.values[C],I<k)y=C-1;else if(I>=n)S=C+1;else break;return new F(C,I-k)}}e.PrefixSumComputer=D}),define(Ee[121],_e([0,1,8,36,88]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class _{constructor(S,y,C,n){this._uri=S,this._lines=y,this._eol=C,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(S){S.eol&&S.eol!==this._eol&&(this._eol=S.eol,this._lineStarts=null);const y=S.changes;for(const C of y)this._acceptDeleteRange(C.range),this._acceptInsertText(new F.Position(C.range.startLineNumber,C.range.startColumn),C.text);this._versionId=S.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const S=this._eol.length,y=this._lines.length,C=new Uint32Array(y);for(let n=0;n<y;n++)C[n]=this._lines[n].length+S;this._lineStarts=new D.PrefixSumComputer(C)}}_setLineText(S,y){this._lines[S]=y,this._lineStarts&&this._lineStarts.changeValue(S,this._lines[S].length+this._eol.length)}_acceptDeleteRange(S){if(S.startLineNumber===S.endLineNumber){if(S.startColumn===S.endColumn)return;this._setLineText(S.startLineNumber-1,this._lines[S.startLineNumber-1].substring(0,S.startColumn-1)+this._lines[S.startLineNumber-1].substring(S.endColumn-1));return}this._setLineText(S.startLineNumber-1,this._lines[S.startLineNumber-1].substring(0,S.startColumn-1)+this._lines[S.endLineNumber-1].substring(S.endColumn-1)),this._lines.splice(S.startLineNumber,S.endLineNumber-S.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(S.startLineNumber,S.endLineNumber-S.startLineNumber)}_acceptInsertText(S,y){if(y.length===0)return;let C=(0,m.splitLines)(y);if(C.length===1){this._setLineText(S.lineNumber-1,this._lines[S.lineNumber-1].substring(0,S.column-1)+C[0]+this._lines[S.lineNumber-1].substring(S.column-1));return}C[C.length-1]+=this._lines[S.lineNumber-1].substring(S.column-1),this._setLineText(S.lineNumber-1,this._lines[S.lineNumber-1].substring(0,S.column-1)+C[0]);let n=new Uint32Array(C.length-1);for(let k=1;k<C.length;k++)this._lines.splice(S.lineNumber+k-1,0,C[k]),n[k-1]=C[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(S.lineNumber,n)}}e.MirrorTextModel=_}),define(Ee[122],_e([19,20]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(Ee[56],_e([0,1,122,10,17]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function _(C,n){return n&&(C.stack||C.stacktrace)?m.localize(0,null,S(C),I(C.stack)||I(C.stacktrace)):S(C)}function I(C){return Array.isArray(C)?C.join(`
`):C}function S(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?m.localize(1,null,C.message):C.message||m.localize(2,null)}function y(C=null,n=!1){if(!C)return m.localize(3,null);if(Array.isArray(C)){const k=D.coalesce(C),l=y(k[0],n);return k.length>1?m.localize(4,null,l,k.length):l}if(F.isString(C))return C;if(C.detail){const k=C.detail;if(k.error)return _(k.error,n);if(k.exception)return _(k.exception,n)}return C.stack?_(C,n):C.message?C.message:m.localize(5,null)}e.toErrorMessage=y}),define(Ee[123],_e([19,20]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(Ee[124],_e([0,1,123,21,86]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var _;(function(H){H[H.None=0]="None",H[H.Keep=1]="Keep",H[H.Brackets=2]="Brackets",H[H.Advanced=3]="Advanced",H[H.Full=4]="Full"})(_=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class I{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=I;class S{constructor(){this._values=[]}_read(X){return this._values[X]}get(X){return this._values[X]}_write(X,de){this._values[X]=de}}e.ValidatedEditorOptions=S;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class C{constructor(X,de,Be,Ue){this.id=X,this.name=de,this.defaultValue=Be,this.schema=Ue}compute(X,de,Be){return Be}}class n{constructor(X,de=null){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0,this.deps=de}validate(X){return this.defaultValue}}class k{constructor(X,de,Be,Ue){this.id=X,this.name=de,this.defaultValue=Be,this.schema=Ue}validate(X){return typeof X=="undefined"?this.defaultValue:X}compute(X,de,Be){return Be}}function l(H,X){return typeof H=="undefined"?X:H==="false"?!1:Boolean(H)}e.boolean=l;class h extends k{constructor(X,de,Be,Ue=void 0){typeof Ue!="undefined"&&(Ue.type="boolean",Ue.default=Be),super(X,de,Be,Ue)}validate(X){return l(X,this.defaultValue)}}class a extends k{constructor(X,de,Be,Ue,tt,Se=void 0){typeof Se!="undefined"&&(Se.type="integer",Se.default=Be,Se.minimum=Ue,Se.maximum=tt),super(X,de,Be,Se),this.minimum=Ue,this.maximum=tt}static clampedInt(X,de,Be,Ue){if(typeof X=="undefined")return de;let tt=parseInt(X,10);return isNaN(tt)?de:(tt=Math.max(Be,tt),tt=Math.min(Ue,tt),tt|0)}validate(X){return a.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class d extends k{constructor(X,de,Be,Ue,tt){typeof tt!="undefined"&&(tt.type="number",tt.default=Be),super(X,de,Be,tt),this.validationFn=Ue}static clamp(X,de,Be){return X<de?de:X>Be?Be:X}static float(X,de){if(typeof X=="number")return X;if(typeof X=="undefined")return de;const Be=parseFloat(X);return isNaN(Be)?de:Be}validate(X){return this.validationFn(d.float(X,this.defaultValue))}}class f extends k{static string(X,de){return typeof X!="string"?de:X}constructor(X,de,Be,Ue=void 0){typeof Ue!="undefined"&&(Ue.type="string",Ue.default=Be),super(X,de,Be,Ue)}validate(X){return f.string(X,this.defaultValue)}}function E(H,X,de){return typeof H!="string"||de.indexOf(H)===-1?X:H}e.stringSet=E;class w extends k{constructor(X,de,Be,Ue,tt=void 0){typeof tt!="undefined"&&(tt.type="string",tt.enum=Ue,tt.default=Be),super(X,de,Be,tt),this._allowedValues=Ue}validate(X){return E(X,this.defaultValue,this._allowedValues)}}class u extends C{constructor(X,de,Be,Ue,tt,Se,De=void 0){typeof De!="undefined"&&(De.type="string",De.enum=tt,De.default=Ue),super(X,de,Be,De),this._allowedValues=tt,this._convert=Se}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function p(H){switch(H){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class b extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",description:m.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,de,Be){return Be===0?X.accessibilitySupport:Be}}class t extends C{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:m.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const de=X;return{insertSpace:l(de.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(de.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(H){H[H.Hidden=0]="Hidden",H[H.Blink=1]="Blink",H[H.Smooth=2]="Smooth",H[H.Phase=3]="Phase",H[H.Expand=4]="Expand",H[H.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(H){switch(H){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var i;(function(H){H[H.Line=1]="Line",H[H.Block=2]="Block",H[H.Underline=3]="Underline",H[H.LineThin=4]="LineThin",H[H.BlockOutline=5]="BlockOutline",H[H.UnderlineThin=6]="UnderlineThin"})(i=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function c(H){switch(H){case i.Line:return"line";case i.Block:return"block";case i.Underline:return"underline";case i.LineThin:return"line-thin";case i.BlockOutline:return"block-outline";case i.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=c;function g(H){switch(H){case"line":return i.Line;case"block":return i.Block;case"underline":return i.Underline;case"line-thin":return i.LineThin;case"block-outline":return i.BlockOutline;case"underline-thin":return i.UnderlineThin}}class v extends n{constructor(){super(125,[63,31])}compute(X,de,Be){const Ue=["monaco-editor"];return de.get(31)&&Ue.push(de.get(31)),X.extraEditorClassName&&Ue.push(X.extraEditorClassName),de.get(63)==="default"?Ue.push("mouse-default"):de.get(63)==="copy"&&Ue.push("mouse-copy"),de.get(98)&&Ue.push("showUnused"),de.get(123)&&Ue.push("showDeprecated"),Ue.join(" ")}}class A extends h{constructor(){super(30,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(X,de,Be){return Be&&X.emptySelectionClipboard}}class R extends C{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:X.seedSearchStringFromSelection,description:m.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[m.localize(9,null),m.localize(10,null),m.localize(11,null)],description:m.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:m.localize(13,null),included:F.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:m.localize(14,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:m.localize(15,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const de=X;return{cursorMoveOnType:l(de.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:l(de.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":E(de.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(de.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(de.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(de.loop,this.defaultValue.loop)}}}class o extends C{constructor(){super(41,"fontLigatures",o.OFF,{anyOf:[{type:"boolean",description:m.localize(16,null)},{type:"string",description:m.localize(17,null)}],description:m.localize(18,null),default:!1})}validate(X){return typeof X=="undefined"?this.defaultValue:typeof X=="string"?X==="false"?o.OFF:X==="true"?o.ON:X:Boolean(X)?o.ON:o.OFF}}e.EditorFontLigatures=o,o.OFF='"liga" off, "calt" off',o.ON='"liga" on, "calt" on';class P extends n{constructor(){super(40)}compute(X,de,Be){return X.fontInfo}}class L extends k{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(19,null)})}validate(X){let de=d.float(X,this.defaultValue);return de===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(de,6,100)}compute(X,de,Be){return X.fontInfo.fontSize}}class $ extends C{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:$.MINIMUM_VALUE,maximum:$.MAXIMUM_VALUE,errorMessage:m.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:$.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(21,null)})}validate(X){return X==="normal"||X==="bold"?X:String(a.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,$.MINIMUM_VALUE,$.MAXIMUM_VALUE))}}$.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],$.MINIMUM_VALUE=1,$.MAXIMUM_VALUE=1e3;class re extends C{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},de={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[m.localize(22,null),m.localize(23,null),m.localize(24,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(25,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(26,null),...de},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(27,null),...de},"editor.gotoLocation.multipleDeclarations":{description:m.localize(28,null),...de},"editor.gotoLocation.multipleImplementations":{description:m.localize(29,null),...de},"editor.gotoLocation.multipleReferences":{description:m.localize(30,null),...de},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Be,description:m.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Be,description:m.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Be,description:m.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Be,description:m.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Be,description:m.localize(35,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const de=X;return{multiple:E(de.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:de.multipleDefinitions??E(de.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:de.multipleTypeDefinitions??E(de.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:de.multipleDeclarations??E(de.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:de.multipleImplementations??E(de.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:de.multipleReferences??E(de.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:f.string(de.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:f.string(de.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:f.string(de.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:f.string(de.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:f.string(de.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class he extends C{constructor(){const X={enabled:!0,delay:300,sticky:!0};super(50,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:m.localize(36,null)},"editor.hover.delay":{type:"number",default:X.delay,description:m.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:m.localize(38,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const de=X;return{enabled:l(de.enabled,this.defaultValue.enabled),delay:a.clampedInt(de.delay,this.defaultValue.delay,0,1e4),sticky:l(de.sticky,this.defaultValue.sticky)}}}var Q;(function(H){H[H.None=0]="None",H[H.Text=1]="Text",H[H.Blocks=2]="Blocks"})(Q=e.RenderMinimap||(e.RenderMinimap={}));class z extends n{constructor(){super(128,[46,55,35,62,90,57,58,92,115,118,119,120,2])}compute(X,de,Be){return z.computeLayout(de,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const de=X.height/X.lineHeight,Be=X.scrollBeyondLastLine?de-1:0,Ue=(X.viewLineCount+Be)/(X.pixelRatio*X.height),tt=Math.floor(X.viewLineCount/Ue);return{typicalViewportLineCount:de,extraLinesBeyondLastLine:Be,desiredRatio:Ue,minimapLineCount:tt}}static _computeMinimapLayout(X,de){const Be=X.outerWidth,Ue=X.outerHeight,tt=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(tt*Ue),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ue};const Se=de.stableMinimapLayoutInput,De=Se&&X.outerHeight===Se.outerHeight&&X.lineHeight===Se.lineHeight&&X.typicalHalfwidthCharacterWidth===Se.typicalHalfwidthCharacterWidth&&X.pixelRatio===Se.pixelRatio&&X.scrollBeyondLastLine===Se.scrollBeyondLastLine&&X.minimap.enabled===Se.minimap.enabled&&X.minimap.side===Se.minimap.side&&X.minimap.size===Se.minimap.size&&X.minimap.showSlider===Se.minimap.showSlider&&X.minimap.renderCharacters===Se.minimap.renderCharacters&&X.minimap.maxColumn===Se.minimap.maxColumn&&X.minimap.scale===Se.minimap.scale&&X.verticalScrollbarWidth===Se.verticalScrollbarWidth&&X.isViewportWrapping===Se.isViewportWrapping,Pe=X.lineHeight,ie=X.typicalHalfwidthCharacterWidth,oe=X.scrollBeyondLastLine,fe=X.minimap.renderCharacters;let ve=tt>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const x=X.minimap.maxColumn,me=X.minimap.size,we=X.minimap.side,Ie=X.verticalScrollbarWidth,Ne=X.viewLineCount,He=X.remainingWidth,et=X.isViewportWrapping,Ke=fe?2:3;let Qe=Math.floor(tt*Ue);const lt=Qe/tt;let dt=!1,_t=!1,at=Ke*ve,pe=ve/tt,Ce=1;if(me==="fill"||me==="fit"){const{typicalViewportLineCount:ut,extraLinesBeyondLastLine:mt,desiredRatio:kt,minimapLineCount:St}=z.computeContainedMinimapLineCount({viewLineCount:Ne,scrollBeyondLastLine:oe,height:Ue,lineHeight:Pe,pixelRatio:tt});if(Ne/St>1)dt=!0,_t=!0,ve=1,at=1,pe=ve/tt;else{let gt=!1,ht=ve+1;if(me==="fit"){const Et=Math.ceil((Ne+mt)*at);et&&De&&He<=de.stableFitRemainingWidth?(gt=!0,ht=de.stableFitMaxMinimapScale):gt=Et>Qe}if(me==="fill"||gt){dt=!0;const Et=ve;at=Math.min(Pe*tt,Math.max(1,Math.floor(1/kt))),et&&De&&He<=de.stableFitRemainingWidth&&(ht=de.stableFitMaxMinimapScale),ve=Math.min(ht,Math.max(1,Math.floor(at/Ke))),ve>Et&&(Ce=Math.min(2,ve/Et)),pe=ve/tt/Ce,Qe=Math.ceil(Math.max(ut,Ne+mt)*at),et?(de.stableMinimapLayoutInput=X,de.stableFitRemainingWidth=He,de.stableFitMaxMinimapScale=ve):(de.stableMinimapLayoutInput=null,de.stableFitRemainingWidth=0)}}}const le=Math.floor(x*pe),U=Math.min(le,Math.max(0,Math.floor((He-Ie-2)*pe/(ie+pe)))+e.MINIMAP_GUTTER_WIDTH);let Fe=Math.floor(tt*U);const xe=Fe/tt;Fe=Math.floor(Fe*Ce);const Ye=fe?1:2,Ge=we==="left"?0:Be-U-Ie;return{renderMinimap:Ye,minimapLeft:Ge,minimapWidth:U,minimapHeightIsEditorHeight:dt,minimapIsSampling:_t,minimapScale:ve,minimapLineHeight:at,minimapCanvasInnerWidth:Fe,minimapCanvasInnerHeight:Qe,minimapCanvasOuterWidth:xe,minimapCanvasOuterHeight:lt}}static computeLayout(X,de){const Be=de.outerWidth|0,Ue=de.outerHeight|0,tt=de.lineHeight|0,Se=de.lineNumbersDigitCount|0,De=de.typicalHalfwidthCharacterWidth,Pe=de.maxDigitWidth,ie=de.pixelRatio,oe=de.viewLineCount,fe=X.get(120),ve=fe==="inherit"?X.get(119):fe,x=ve==="inherit"?X.get(115):ve,me=X.get(118),we=X.get(2),Ie=de.isDominatedByLongLines,Ne=X.get(46),He=X.get(57).renderType!==0,et=X.get(58),Ke=X.get(92),Qe=X.get(62),lt=X.get(90),dt=lt.verticalScrollbarSize,_t=lt.verticalHasArrows,at=lt.arrowSize,pe=lt.horizontalScrollbarSize,Ce=X.get(55),le=X.get(35);let U;if(typeof Ce=="string"&&/^\d+(\.\d+)?ch$/.test(Ce)){const Pt=parseFloat(Ce.substr(0,Ce.length-2));U=a.clampedInt(Pt*De,0,0,1e3)}else U=a.clampedInt(Ce,0,0,1e3);le&&(U+=16);let Fe=0;if(He){const Pt=Math.max(Se,et);Fe=Math.round(Pt*Pe)}let xe=0;Ne&&(xe=tt);let Ye=0,Ge=Ye+xe,ut=Ge+Fe,mt=ut+U;const kt=Be-xe-Fe-U;let St=!1,bt=!1,gt=-1;we!==2&&(ve==="inherit"&&Ie?(St=!0,bt=!0):x==="on"||x==="bounded"?bt=!0:x==="wordWrapColumn"&&(gt=me));const ht=z._computeMinimapLayout({outerWidth:Be,outerHeight:Ue,lineHeight:tt,typicalHalfwidthCharacterWidth:De,pixelRatio:ie,scrollBeyondLastLine:Ke,minimap:Qe,verticalScrollbarWidth:dt,viewLineCount:oe,remainingWidth:kt,isViewportWrapping:bt},de.memory||new y);ht.renderMinimap!==0&&ht.minimapLeft===0&&(Ye+=ht.minimapWidth,Ge+=ht.minimapWidth,ut+=ht.minimapWidth,mt+=ht.minimapWidth);const Et=kt-ht.minimapWidth,ft=Math.max(1,Math.floor((Et-dt-2)/De)),Ot=_t?at:0;return bt&&(gt=Math.max(1,ft),x==="bounded"&&(gt=Math.min(gt,me))),{width:Be,height:Ue,glyphMarginLeft:Ye,glyphMarginWidth:xe,lineNumbersLeft:Ge,lineNumbersWidth:Fe,decorationsLeft:ut,decorationsWidth:U,contentLeft:mt,contentWidth:Et,minimap:ht,viewportColumn:ft,isWordWrapMinified:St,isViewportWrapping:bt,wrappingColumn:gt,verticalScrollbarWidth:dt,horizontalScrollbarHeight:pe,overviewRuler:{top:Ot,width:dt,height:Ue-2*Ot,right:0}}}}e.EditorLayoutInfoComputer=z;class V extends C{constructor(){const X={enabled:!0};super(54,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:m.localize(39,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:l(X.enabled,this.defaultValue.enabled)}}}class T extends C{constructor(){const X={enabled:!0,fontSize:0,fontFamily:""};super(124,"inlayHints",X,{"editor.inlayHints.enabled":{type:"boolean",default:X.enabled,description:m.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:m.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,description:m.localize(42,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const de=X;return{enabled:l(de.enabled,this.defaultValue.enabled),fontSize:a.clampedInt(de.fontSize,this.defaultValue.fontSize,0,100),fontFamily:f.string(de.fontFamily,this.defaultValue.fontFamily)}}}class G extends d{constructor(){super(56,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>d.clamp(X,0,150),{markdownDescription:m.localize(43,null)})}compute(X,de,Be){return X.fontInfo.lineHeight}}class B extends C{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(62,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:m.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(45,null),m.localize(46,null),m.localize(47,null)],default:X.size,description:m.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:m.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:m.localize(50,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:m.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:m.localize(53,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const de=X;return{enabled:l(de.enabled,this.defaultValue.enabled),size:E(de.size,this.defaultValue.size,["proportional","fill","fit"]),side:E(de.side,this.defaultValue.side,["right","left"]),showSlider:E(de.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(de.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(de.scale,1,1,3),maxColumn:a.clampedInt(de.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function j(H){return H==="ctrlCmd"?F.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ce extends C{constructor(){super(72,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(55,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const de=X;return{top:a.clampedInt(de.top,0,0,1e3),bottom:a.clampedInt(de.bottom,0,0,1e3)}}}class W extends C{constructor(){const X={enabled:!0,cycle:!1};super(73,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:m.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:m.localize(57,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const de=X;return{enabled:l(de.enabled,this.defaultValue.enabled),cycle:l(de.cycle,this.defaultValue.cycle)}}}class te extends n{constructor(){super(126)}compute(X,de,Be){return X.pixelRatio}}class ue extends C{constructor(){const X={other:!0,comments:!1,strings:!1};super(76,"quickSuggestions",X,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:X.strings,description:m.localize(58,null)},comments:{type:"boolean",default:X.comments,description:m.localize(59,null)},other:{type:"boolean",default:X.other,description:m.localize(60,null)}}}],default:X,description:m.localize(61,null)});this.defaultValue=X}validate(X){if(typeof X=="boolean")return X;if(X&&typeof X=="object"){const de=X,Be={other:l(de.other,this.defaultValue.other),comments:l(de.comments,this.defaultValue.comments),strings:l(de.strings,this.defaultValue.strings)};return Be.other&&Be.comments&&Be.strings?!0:!Be.other&&!Be.comments&&!Be.strings?!1:Be}return this.defaultValue}}var ye;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval",H[H.Custom=4]="Custom"})(ye=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Te extends C{constructor(){super(57,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(62,null),m.localize(63,null),m.localize(64,null),m.localize(65,null)],default:"on",description:m.localize(66,null)})}validate(X){let de=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof X!="undefined"&&(typeof X=="function"?(de=4,Be=X):X==="interval"?de=3:X==="relative"?de=2:X==="on"?de=1:de=0),{renderType:de,renderFn:Be}}}function Re(H){const X=H.get(85);return X==="editable"?H.get(78):X!=="on"}e.filterValidationDecorations=Re;class $e extends C{constructor(){const X=[],de={type:"number",description:m.localize(67,null)};super(89,"rulers",X,{type:"array",items:{anyOf:[de,{type:["object"],properties:{column:de,color:{type:"string",description:m.localize(68,null),format:"color-hex"}}}]},default:X,description:m.localize(69,null)})}validate(X){if(Array.isArray(X)){let de=[];for(let Be of X)if(typeof Be=="number")de.push({column:a.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Ue=Be;de.push({column:a.clampedInt(Ue.column,0,0,1e4),color:Ue.color})}return de.sort((Be,Ue)=>Be.column-Ue.column),de}return this.defaultValue}}function Ze(H,X){if(typeof H!="string")return X;switch(H){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ve extends C{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(90,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(70,null),m.localize(71,null),m.localize(72,null)],default:"auto",description:m.localize(73,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(74,null),m.localize(75,null),m.localize(76,null)],default:"auto",description:m.localize(77,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:m.localize(78,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:m.localize(79,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:m.localize(80,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const de=X,Be=a.clampedInt(de.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ue=a.clampedInt(de.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(de.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ze(de.vertical,this.defaultValue.vertical),horizontal:Ze(de.horizontal,this.defaultValue.horizontal),useShadows:l(de.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(de.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(de.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(de.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(de.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:a.clampedInt(de.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Ue,verticalSliderSize:a.clampedInt(de.verticalSliderSize,Ue,0,1e3),scrollByPage:l(de.scrollByPage,this.defaultValue.scrollByPage)}}}class je extends C{constructor(){const X={enabled:!1,mode:"subwordSmart"};super(52,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:m.localize(81,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[m.localize(82,null),m.localize(83,null),m.localize(84,null)],default:X.mode,description:m.localize(85,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const de=X;return{enabled:l(de.enabled,this.defaultValue.enabled),mode:E(de.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class O extends C{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(104,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(86,null),m.localize(87,null)],default:X.insertMode,description:m.localize(88,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:m.localize(89,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:m.localize(90,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:m.localize(91,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:m.localize(92,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:m.localize(93,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:m.localize(94,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:m.localize(95,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[m.localize(96,null),m.localize(97,null),m.localize(98,null)],default:X.previewMode,description:m.localize(99,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:m.localize(100,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(101,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(102,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(103,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(104,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(105,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(106,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(107,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(108,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(109,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(110,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(111,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(112,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(113,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(114,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(115,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(116,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(117,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(118,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(119,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(120,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(121,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(122,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(123,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(124,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(125,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(126,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(127,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(128,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(129,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(130,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(131,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const de=X;return{insertMode:E(de.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(de.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(de.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(de.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(de.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:l(de.showIcons,this.defaultValue.showIcons),showStatusBar:l(de.showStatusBar,this.defaultValue.showStatusBar),preview:l(de.preview,this.defaultValue.preview),previewMode:E(de.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:l(de.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(de.showMethods,this.defaultValue.showMethods),showFunctions:l(de.showFunctions,this.defaultValue.showFunctions),showConstructors:l(de.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(de.showDeprecated,this.defaultValue.showDeprecated),showFields:l(de.showFields,this.defaultValue.showFields),showVariables:l(de.showVariables,this.defaultValue.showVariables),showClasses:l(de.showClasses,this.defaultValue.showClasses),showStructs:l(de.showStructs,this.defaultValue.showStructs),showInterfaces:l(de.showInterfaces,this.defaultValue.showInterfaces),showModules:l(de.showModules,this.defaultValue.showModules),showProperties:l(de.showProperties,this.defaultValue.showProperties),showEvents:l(de.showEvents,this.defaultValue.showEvents),showOperators:l(de.showOperators,this.defaultValue.showOperators),showUnits:l(de.showUnits,this.defaultValue.showUnits),showValues:l(de.showValues,this.defaultValue.showValues),showConstants:l(de.showConstants,this.defaultValue.showConstants),showEnums:l(de.showEnums,this.defaultValue.showEnums),showEnumMembers:l(de.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(de.showKeywords,this.defaultValue.showKeywords),showWords:l(de.showWords,this.defaultValue.showWords),showColors:l(de.showColors,this.defaultValue.showColors),showFiles:l(de.showFiles,this.defaultValue.showFiles),showReferences:l(de.showReferences,this.defaultValue.showReferences),showFolders:l(de.showFolders,this.defaultValue.showFolders),showTypeParameters:l(de.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(de.showSnippets,this.defaultValue.showSnippets),showUsers:l(de.showUsers,this.defaultValue.showUsers),showIssues:l(de.showIssues,this.defaultValue.showIssues)}}}class K extends C{constructor(){super(100,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(132,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class J extends n{constructor(){super(127,[78])}compute(X,de,Be){return de.get(78)?!0:X.tabFocusMode}}var se;(function(H){H[H.None=0]="None",H[H.Same=1]="Same",H[H.Indent=2]="Indent",H[H.DeepIndent=3]="DeepIndent"})(se=e.WrappingIndent||(e.WrappingIndent={}));function q(H){switch(H){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ne extends n{constructor(){super(129,[128])}compute(X,de,Be){const Ue=de.get(128);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Ue.isWordWrapMinified,isViewportWrapping:Ue.isViewportWrapping,wrappingColumn:Ue.wrappingColumn}}}const ge="Consolas, 'Courier New', monospace",Me="Menlo, Monaco, 'Courier New', monospace",We="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:F.isMacintosh?Me:F.isLinux?We:ge,fontWeight:"normal",fontSize:F.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function be(H){return e.editorOptionsRegistry[H.id]=H,H}var Xe;(function(H){H[H.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",H[H.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",H[H.accessibilitySupport=2]="accessibilitySupport",H[H.accessibilityPageSize=3]="accessibilityPageSize",H[H.ariaLabel=4]="ariaLabel",H[H.autoClosingBrackets=5]="autoClosingBrackets",H[H.autoClosingDelete=6]="autoClosingDelete",H[H.autoClosingOvertype=7]="autoClosingOvertype",H[H.autoClosingQuotes=8]="autoClosingQuotes",H[H.autoIndent=9]="autoIndent",H[H.automaticLayout=10]="automaticLayout",H[H.autoSurround=11]="autoSurround",H[H.codeLens=12]="codeLens",H[H.codeLensFontFamily=13]="codeLensFontFamily",H[H.codeLensFontSize=14]="codeLensFontSize",H[H.colorDecorators=15]="colorDecorators",H[H.columnSelection=16]="columnSelection",H[H.comments=17]="comments",H[H.contextmenu=18]="contextmenu",H[H.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",H[H.cursorBlinking=20]="cursorBlinking",H[H.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",H[H.cursorStyle=22]="cursorStyle",H[H.cursorSurroundingLines=23]="cursorSurroundingLines",H[H.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",H[H.cursorWidth=25]="cursorWidth",H[H.disableLayerHinting=26]="disableLayerHinting",H[H.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",H[H.domReadOnly=28]="domReadOnly",H[H.dragAndDrop=29]="dragAndDrop",H[H.emptySelectionClipboard=30]="emptySelectionClipboard",H[H.extraEditorClassName=31]="extraEditorClassName",H[H.fastScrollSensitivity=32]="fastScrollSensitivity",H[H.find=33]="find",H[H.fixedOverflowWidgets=34]="fixedOverflowWidgets",H[H.folding=35]="folding",H[H.foldingStrategy=36]="foldingStrategy",H[H.foldingHighlight=37]="foldingHighlight",H[H.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",H[H.fontFamily=39]="fontFamily",H[H.fontInfo=40]="fontInfo",H[H.fontLigatures=41]="fontLigatures",H[H.fontSize=42]="fontSize",H[H.fontWeight=43]="fontWeight",H[H.formatOnPaste=44]="formatOnPaste",H[H.formatOnType=45]="formatOnType",H[H.glyphMargin=46]="glyphMargin",H[H.gotoLocation=47]="gotoLocation",H[H.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",H[H.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",H[H.hover=50]="hover",H[H.inDiffEditor=51]="inDiffEditor",H[H.inlineSuggest=52]="inlineSuggest",H[H.letterSpacing=53]="letterSpacing",H[H.lightbulb=54]="lightbulb",H[H.lineDecorationsWidth=55]="lineDecorationsWidth",H[H.lineHeight=56]="lineHeight",H[H.lineNumbers=57]="lineNumbers",H[H.lineNumbersMinChars=58]="lineNumbersMinChars",H[H.linkedEditing=59]="linkedEditing",H[H.links=60]="links",H[H.matchBrackets=61]="matchBrackets",H[H.minimap=62]="minimap",H[H.mouseStyle=63]="mouseStyle",H[H.mouseWheelScrollSensitivity=64]="mouseWheelScrollSensitivity",H[H.mouseWheelZoom=65]="mouseWheelZoom",H[H.multiCursorMergeOverlapping=66]="multiCursorMergeOverlapping",H[H.multiCursorModifier=67]="multiCursorModifier",H[H.multiCursorPaste=68]="multiCursorPaste",H[H.occurrencesHighlight=69]="occurrencesHighlight",H[H.overviewRulerBorder=70]="overviewRulerBorder",H[H.overviewRulerLanes=71]="overviewRulerLanes",H[H.padding=72]="padding",H[H.parameterHints=73]="parameterHints",H[H.peekWidgetDefaultFocus=74]="peekWidgetDefaultFocus",H[H.definitionLinkOpensInPeek=75]="definitionLinkOpensInPeek",H[H.quickSuggestions=76]="quickSuggestions",H[H.quickSuggestionsDelay=77]="quickSuggestionsDelay",H[H.readOnly=78]="readOnly",H[H.renameOnType=79]="renameOnType",H[H.renderControlCharacters=80]="renderControlCharacters",H[H.renderIndentGuides=81]="renderIndentGuides",H[H.renderFinalNewline=82]="renderFinalNewline",H[H.renderLineHighlight=83]="renderLineHighlight",H[H.renderLineHighlightOnlyWhenFocus=84]="renderLineHighlightOnlyWhenFocus",H[H.renderValidationDecorations=85]="renderValidationDecorations",H[H.renderWhitespace=86]="renderWhitespace",H[H.revealHorizontalRightPadding=87]="revealHorizontalRightPadding",H[H.roundedSelection=88]="roundedSelection",H[H.rulers=89]="rulers",H[H.scrollbar=90]="scrollbar",H[H.scrollBeyondLastColumn=91]="scrollBeyondLastColumn",H[H.scrollBeyondLastLine=92]="scrollBeyondLastLine",H[H.scrollPredominantAxis=93]="scrollPredominantAxis",H[H.selectionClipboard=94]="selectionClipboard",H[H.selectionHighlight=95]="selectionHighlight",H[H.selectOnLineNumbers=96]="selectOnLineNumbers",H[H.showFoldingControls=97]="showFoldingControls",H[H.showUnused=98]="showUnused",H[H.snippetSuggestions=99]="snippetSuggestions",H[H.smartSelect=100]="smartSelect",H[H.smoothScrolling=101]="smoothScrolling",H[H.stickyTabStops=102]="stickyTabStops",H[H.stopRenderingLineAfter=103]="stopRenderingLineAfter",H[H.suggest=104]="suggest",H[H.suggestFontSize=105]="suggestFontSize",H[H.suggestLineHeight=106]="suggestLineHeight",H[H.suggestOnTriggerCharacters=107]="suggestOnTriggerCharacters",H[H.suggestSelection=108]="suggestSelection",H[H.tabCompletion=109]="tabCompletion",H[H.tabIndex=110]="tabIndex",H[H.unusualLineTerminators=111]="unusualLineTerminators",H[H.useShadowDOM=112]="useShadowDOM",H[H.useTabStops=113]="useTabStops",H[H.wordSeparators=114]="wordSeparators",H[H.wordWrap=115]="wordWrap",H[H.wordWrapBreakAfterCharacters=116]="wordWrapBreakAfterCharacters",H[H.wordWrapBreakBeforeCharacters=117]="wordWrapBreakBeforeCharacters",H[H.wordWrapColumn=118]="wordWrapColumn",H[H.wordWrapOverride1=119]="wordWrapOverride1",H[H.wordWrapOverride2=120]="wordWrapOverride2",H[H.wrappingIndent=121]="wrappingIndent",H[H.wrappingStrategy=122]="wrappingStrategy",H[H.showDeprecated=123]="showDeprecated",H[H.inlayHints=124]="inlayHints",H[H.editorClassName=125]="editorClassName",H[H.pixelRatio=126]="pixelRatio",H[H.tabFocusMode=127]="tabFocusMode",H[H.layoutInfo=128]="layoutInfo",H[H.wrappingInfo=129]="wrappingInfo"})(Xe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:be(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(133,null)})),acceptSuggestionOnEnter:be(new w(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(134,null),""],markdownDescription:m.localize(135,null)})),accessibilitySupport:be(new b),accessibilityPageSize:be(new a(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(136,null)})),ariaLabel:be(new f(4,"ariaLabel",m.localize(137,null))),autoClosingBrackets:be(new w(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(138,null),m.localize(139,null),""],description:m.localize(140,null)})),autoClosingDelete:be(new w(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(141,null),""],description:m.localize(142,null)})),autoClosingOvertype:be(new w(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(143,null),""],description:m.localize(144,null)})),autoClosingQuotes:be(new w(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(145,null),m.localize(146,null),""],description:m.localize(147,null)})),autoIndent:be(new u(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],p,{enumDescriptions:[m.localize(148,null),m.localize(149,null),m.localize(150,null),m.localize(151,null),m.localize(152,null)],description:m.localize(153,null)})),automaticLayout:be(new h(10,"automaticLayout",!1)),autoSurround:be(new w(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(154,null),m.localize(155,null),m.localize(156,null),""],description:m.localize(157,null)})),stickyTabStops:be(new h(102,"stickyTabStops",!1,{description:m.localize(158,null)})),codeLens:be(new h(12,"codeLens",!0,{description:m.localize(159,null)})),codeLensFontFamily:be(new f(13,"codeLensFontFamily","",{description:m.localize(160,null)})),codeLensFontSize:be(new a(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(161,null)})),colorDecorators:be(new h(15,"colorDecorators",!0,{description:m.localize(162,null)})),columnSelection:be(new h(16,"columnSelection",!1,{description:m.localize(163,null)})),comments:be(new t),contextmenu:be(new h(18,"contextmenu",!0)),copyWithSyntaxHighlighting:be(new h(19,"copyWithSyntaxHighlighting",!0,{description:m.localize(164,null)})),cursorBlinking:be(new u(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:m.localize(165,null)})),cursorSmoothCaretAnimation:be(new h(21,"cursorSmoothCaretAnimation",!1,{description:m.localize(166,null)})),cursorStyle:be(new u(22,"cursorStyle",i.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],g,{description:m.localize(167,null)})),cursorSurroundingLines:be(new a(23,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(168,null)})),cursorSurroundingLinesStyle:be(new w(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(169,null),m.localize(170,null)],description:m.localize(171,null)})),cursorWidth:be(new a(25,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(172,null)})),disableLayerHinting:be(new h(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:be(new h(27,"disableMonospaceOptimizations",!1)),domReadOnly:be(new h(28,"domReadOnly",!1)),dragAndDrop:be(new h(29,"dragAndDrop",!0,{description:m.localize(173,null)})),emptySelectionClipboard:be(new A),extraEditorClassName:be(new f(31,"extraEditorClassName","")),fastScrollSensitivity:be(new d(32,"fastScrollSensitivity",5,H=>H<=0?5:H,{markdownDescription:m.localize(174,null)})),find:be(new R),fixedOverflowWidgets:be(new h(34,"fixedOverflowWidgets",!1)),folding:be(new h(35,"folding",!0,{description:m.localize(175,null)})),foldingStrategy:be(new w(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(176,null),m.localize(177,null)],description:m.localize(178,null)})),foldingHighlight:be(new h(37,"foldingHighlight",!0,{description:m.localize(179,null)})),unfoldOnClickAfterEndOfLine:be(new h(38,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(180,null)})),fontFamily:be(new f(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(181,null)})),fontInfo:be(new P),fontLigatures2:be(new o),fontSize:be(new L),fontWeight:be(new $),formatOnPaste:be(new h(44,"formatOnPaste",!1,{description:m.localize(182,null)})),formatOnType:be(new h(45,"formatOnType",!1,{description:m.localize(183,null)})),glyphMargin:be(new h(46,"glyphMargin",!0,{description:m.localize(184,null)})),gotoLocation:be(new re),hideCursorInOverviewRuler:be(new h(48,"hideCursorInOverviewRuler",!1,{description:m.localize(185,null)})),highlightActiveIndentGuide:be(new h(49,"highlightActiveIndentGuide",!0,{description:m.localize(186,null)})),hover:be(new he),inDiffEditor:be(new h(51,"inDiffEditor",!1)),letterSpacing:be(new d(53,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,H=>d.clamp(H,-5,20),{description:m.localize(187,null)})),lightbulb:be(new V),lineDecorationsWidth:be(new k(55,"lineDecorationsWidth",10)),lineHeight:be(new G),lineNumbers:be(new Te),lineNumbersMinChars:be(new a(58,"lineNumbersMinChars",5,1,300)),linkedEditing:be(new h(59,"linkedEditing",!1,{description:m.localize(188,null)})),links:be(new h(60,"links",!0,{description:m.localize(189,null)})),matchBrackets:be(new w(61,"matchBrackets","always",["always","near","never"],{description:m.localize(190,null)})),minimap:be(new B),mouseStyle:be(new w(63,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:be(new d(64,"mouseWheelScrollSensitivity",1,H=>H===0?1:H,{markdownDescription:m.localize(191,null)})),mouseWheelZoom:be(new h(65,"mouseWheelZoom",!1,{markdownDescription:m.localize(192,null)})),multiCursorMergeOverlapping:be(new h(66,"multiCursorMergeOverlapping",!0,{description:m.localize(193,null)})),multiCursorModifier:be(new u(67,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],j,{markdownEnumDescriptions:[m.localize(194,null),m.localize(195,null)],markdownDescription:m.localize(196,null)})),multiCursorPaste:be(new w(68,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(197,null),m.localize(198,null)],markdownDescription:m.localize(199,null)})),occurrencesHighlight:be(new h(69,"occurrencesHighlight",!0,{description:m.localize(200,null)})),overviewRulerBorder:be(new h(70,"overviewRulerBorder",!0,{description:m.localize(201,null)})),overviewRulerLanes:be(new a(71,"overviewRulerLanes",3,0,3)),padding:be(new ce),parameterHints:be(new W),peekWidgetDefaultFocus:be(new w(74,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(202,null),m.localize(203,null)],description:m.localize(204,null)})),definitionLinkOpensInPeek:be(new h(75,"definitionLinkOpensInPeek",!1,{description:m.localize(205,null)})),quickSuggestions:be(new ue),quickSuggestionsDelay:be(new a(77,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(206,null)})),readOnly:be(new h(78,"readOnly",!1)),renameOnType:be(new h(79,"renameOnType",!1,{description:m.localize(207,null),markdownDeprecationMessage:m.localize(208,null)})),renderControlCharacters:be(new h(80,"renderControlCharacters",!1,{description:m.localize(209,null)})),renderIndentGuides:be(new h(81,"renderIndentGuides",!0,{description:m.localize(210,null)})),renderFinalNewline:be(new h(82,"renderFinalNewline",!0,{description:m.localize(211,null)})),renderLineHighlight:be(new w(83,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(212,null)],description:m.localize(213,null)})),renderLineHighlightOnlyWhenFocus:be(new h(84,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(214,null)})),renderValidationDecorations:be(new w(85,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:be(new w(86,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(215,null),m.localize(216,null),m.localize(217,null),""],description:m.localize(218,null)})),revealHorizontalRightPadding:be(new a(87,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:be(new h(88,"roundedSelection",!0,{description:m.localize(219,null)})),rulers:be(new $e),scrollbar:be(new Ve),scrollBeyondLastColumn:be(new a(91,"scrollBeyondLastColumn",5,0,1073741824,{description:m.localize(220,null)})),scrollBeyondLastLine:be(new h(92,"scrollBeyondLastLine",!0,{description:m.localize(221,null)})),scrollPredominantAxis:be(new h(93,"scrollPredominantAxis",!0,{description:m.localize(222,null)})),selectionClipboard:be(new h(94,"selectionClipboard",!0,{description:m.localize(223,null),included:F.isLinux})),selectionHighlight:be(new h(95,"selectionHighlight",!0,{description:m.localize(224,null)})),selectOnLineNumbers:be(new h(96,"selectOnLineNumbers",!0)),showFoldingControls:be(new w(97,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[m.localize(225,null),m.localize(226,null)],description:m.localize(227,null)})),showUnused:be(new h(98,"showUnused",!0,{description:m.localize(228,null)})),showDeprecated:be(new h(123,"showDeprecated",!0,{description:m.localize(229,null)})),inlayHints:be(new T),snippetSuggestions:be(new w(99,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(230,null),m.localize(231,null),m.localize(232,null),m.localize(233,null)],description:m.localize(234,null)})),smartSelect:be(new K),smoothScrolling:be(new h(101,"smoothScrolling",!1,{description:m.localize(235,null)})),stopRenderingLineAfter:be(new a(103,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:be(new O),inlineSuggest:be(new je),suggestFontSize:be(new a(105,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(236,null)})),suggestLineHeight:be(new a(106,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(237,null)})),suggestOnTriggerCharacters:be(new h(107,"suggestOnTriggerCharacters",!0,{description:m.localize(238,null)})),suggestSelection:be(new w(108,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(239,null),m.localize(240,null),m.localize(241,null)],description:m.localize(242,null)})),tabCompletion:be(new w(109,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(243,null),m.localize(244,null),m.localize(245,null)],description:m.localize(246,null)})),tabIndex:be(new a(110,"tabIndex",0,-1,1073741824)),unusualLineTerminators:be(new w(111,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(247,null),m.localize(248,null),m.localize(249,null)],description:m.localize(250,null)})),useShadowDOM:be(new h(112,"useShadowDOM",!0)),useTabStops:be(new h(113,"useTabStops",!0,{description:m.localize(251,null)})),wordSeparators:be(new f(114,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:m.localize(252,null)})),wordWrap:be(new w(115,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(253,null),m.localize(254,null),m.localize(255,null),m.localize(256,null)],description:m.localize(257,null)})),wordWrapBreakAfterCharacters:be(new f(116,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:be(new f(117,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:be(new a(118,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(258,null)})),wordWrapOverride1:be(new w(119,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:be(new w(120,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:be(new u(121,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],q,{enumDescriptions:[m.localize(259,null),m.localize(260,null),m.localize(261,null),m.localize(262,null)],description:m.localize(263,null)})),wrappingStrategy:be(new w(122,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[m.localize(264,null),m.localize(265,null)],description:m.localize(266,null)})),editorClassName:be(new v),pixelRatio:be(new te),tabFocusMode:be(new J),layoutInfo:be(new z),wrappingInfo:be(new ne)}}),define(Ee[125],_e([19,20]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[126],_e([19,20]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[127],_e([19,20]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(Ee[128],_e([19,20]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(Ee[129],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[130],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[131],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(Ee[132],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[133],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[134],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[135],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[136],_e([19,20]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(Ee[137],_e([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[138],_e([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(Ee[139],_e([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(Ee[140],_e([19,20]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[141],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var m;(function(I){I[I.ACTIVATE=1]="ACTIVATE",I[I.RESTORE=2]="RESTORE",I[I.PRESERVE=3]="PRESERVE"})(m=e.EditorActivation||(e.EditorActivation={}));var F;(function(I){I[I.PICK=0]="PICK",I[I.DISABLED=1]="DISABLED",I[I.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(F=e.EditorResolution||(e.EditorResolution={}));var D;(function(I){I[I.API=0]="API",I[I.USER=1]="USER"})(D=e.EditorOpenContext||(e.EditorOpenContext={}));var _;(function(I){I[I.Center=0]="Center",I[I.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",I[I.NearTop=2]="NearTop",I[I.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(_=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(Ee[142],_e([0,1,126]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const F=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function _(l){return l=l.trim(),l==="*"||F.test(l)}e.isValidVersionStr=_;function I(l){if(!_(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let h=l.match(F);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=I;function S(l){if(!l)return null;let h=l.majorBase,a=l.majorMustEqual,d=l.minorBase,f=l.minorMustEqual,E=l.patchBase,w=l.patchMustEqual;l.hasCaret&&(h===0||(f=!1),w=!1);let u=0;if(l.preRelease){const p=D.exec(l.preRelease);if(p){const[,b,t,s]=p;u=Date.UTC(Number(b),Number(t)-1,Number(s))}}return{majorBase:h,majorMustEqual:a,minorBase:d,minorMustEqual:f,patchBase:E,patchMustEqual:w,isMinimum:l.hasGreaterEquals,notBefore:u}}e.normalizeVersion=S;function y(l,h,a){let d;typeof l=="string"?d=S(I(l)):d=l;let f;h instanceof Date?f=h.getTime():typeof h=="string"&&(f=new Date(h).getTime());let E;if(typeof a=="string"?E=S(I(a)):E=a,!d||!E)return!1;let w=d.majorBase,u=d.minorBase,p=d.patchBase,b=E.majorBase,t=E.minorBase,s=E.patchBase,r=E.notBefore,i=E.majorMustEqual,c=E.minorMustEqual,g=E.patchMustEqual;return E.isMinimum?w>b?!0:w<b?!1:u>t?!0:u<t||f&&f<r?!1:p>=s:(w===1&&b===0&&(!i||!c||!g)&&(b=1,t=0,s=0,i=!0,c=!1,g=!1),w<b?!1:w>b?!i:u<t?!1:u>t?!c:p<s?!1:p>s?!g:!(f&&f<r))}e.isValidVersion=y;function C(l,h,a,d){return a.isBuiltin||typeof a.main=="undefined"?!0:k(l,h,a.engines.vscode,d)}e.isValidExtensionVersion=C;function n(l,h,a){return l==="*"||k(h,a,l)}e.isEngineValid=n;function k(l,h,a,d=[]){let f=S(I(a));if(!f)return d.push(m.localize(0,null,a)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return d.push(m.localize(1,null,a)),!1}else if(!f.majorMustEqual)return d.push(m.localize(2,null,a)),!1;return y(l,h,f)?!0:(d.push(m.localize(3,null,l,a)),!1)}}),define(Ee[89],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class m{constructor(D,_=[],I=!1){this.ctor=D,this.staticArguments=_,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=m}),define(Ee[57],_e([0,1,89]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const F=[];function D(I,S,y){S instanceof m.SyncDescriptor||(S=new m.SyncDescriptor(S,[],y)),F.push([I,S])}e.registerSingleton=D;function _(){return F}e.getSingletonServiceDescriptors=_}),define(Ee[143],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(_){this.incoming=new Map,this.outgoing=new Map,this.data=_}}e.Node=m;class F{constructor(_){this._hashFn=_,this._nodes=new Map}roots(){const _=[];for(let I of this._nodes.values())I.outgoing.size===0&&_.push(I);return _}insertEdge(_,I){const S=this.lookupOrInsertNode(_),y=this.lookupOrInsertNode(I);S.outgoing.set(this._hashFn(I),y),y.incoming.set(this._hashFn(_),S)}removeNode(_){const I=this._hashFn(_);this._nodes.delete(I);for(let S of this._nodes.values())S.outgoing.delete(I),S.incoming.delete(I)}lookupOrInsertNode(_){const I=this._hashFn(_);let S=this._nodes.get(I);return S||(S=new m(_),this._nodes.set(I,S)),S}lookup(_){return this._nodes.get(this._hashFn(_))}isEmpty(){return this._nodes.size===0}toString(){let _=[];for(let[I,S]of this._nodes)_.push(`${I}, (incoming)[${[...S.incoming.keys()].join(", ")}], (outgoing)[${[...S.outgoing.keys()].join(",")}]`);return _.join(`
`)}findCycleSlow(){for(let[_,I]of this._nodes){const S=new Set([_]),y=this._findCycle(I,S);if(y)return y}}_findCycle(_,I){for(let[S,y]of _.outgoing){if(I.has(S))return[...I,S].join(" -> ");I.add(S);const C=this._findCycle(y,I);if(C)return C;I.delete(S)}}}e.Graph=F}),define(Ee[4],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(S){S.serviceIds=new Map,S.DI_TARGET="$di$target",S.DI_DEPENDENCIES="$di$dependencies";function y(C){return C[S.DI_DEPENDENCIES]||[]}S.getServiceDependencies=y})(m=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function F(S,y,C,n){y[m.DI_TARGET]===y?y[m.DI_DEPENDENCIES].push({id:S,index:C,optional:n}):(y[m.DI_DEPENDENCIES]=[{id:S,index:C,optional:n}],y[m.DI_TARGET]=y)}function D(S){if(m.serviceIds.has(S))return m.serviceIds.get(S);const y=function(C,n,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(y,C,k,!1)};return y.toString=()=>S,m.serviceIds.set(S,y),y}e.createDecorator=D;function _(S){return S}e.refineServiceDecorator=_;function I(S){return function(y,C,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");F(S,y,n,!0)}}e.optional=I}),define(Ee[144],_e([0,1,4]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,m.createDecorator)("modelService");function F(D){return!D.isTooLargeForSyncing()&&!D.isForSimpleWidget}e.shouldSynchronizeModel=F}),define(Ee[145],_e([0,1,3,41,7,22,79,55,144]),function(ee,e,m,F,D,_,I,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function C(l){return typeof l=="string"?!1:Array.isArray(l)?l.every(C):!!l.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new m.Emitter}get onDidChange(){return this._onDidChange.event}register(h,a){let d={selector:h,provider:a,_score:-1,_time:this._clock++};return this._entries.push(d),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,D.toDisposable)(()=>{if(d){let f=this._entries.indexOf(d);f>=0&&(this._entries.splice(f,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),d=void 0)}})}has(h){return this.all(h).length>0}all(h){if(!h)return[];this._updateScores(h);const a=[];for(let d of this._entries)d._score>0&&a.push(d.provider);return a}ordered(h){const a=[];return this._orderedForEach(h,d=>a.push(d.provider)),a}orderedGroups(h){const a=[];let d,f;return this._orderedForEach(h,E=>{d&&f===E._score?d.push(E.provider):(f=E._score,d=[E.provider],a.push(d))}),a}_orderedForEach(h,a){if(!!h){this._updateScores(h);for(const d of this._entries)d._score>0&&a(d)}}_updateScores(h){let a={uri:h.uri.toString(),language:h.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===a.language&&this._lastCandidate.uri===a.uri)){this._lastCandidate=a;for(let d of this._entries)if(d._score=(0,S.score)(d.selector,h.uri,h.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(h)),C(d.selector)&&d._score>0){for(let f of this._entries)f._score=0;d._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(h,a){return h._score<a._score?1:h._score>a._score?-1:h._time<a._time?1:h._time>a._time?-1:0}}e.LanguageFeatureRegistry=n;class k{constructor(h,a,d=Number.MAX_SAFE_INTEGER){this._registry=h,this.min=a,this.max=d,this._cache=new _.LRUCache(50,.7)}_key(h){return h.id+(0,F.hash)(this._registry.all(h))}_clamp(h){return h===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(h*1.3)))}get(h){const a=this._key(h),d=this._cache.get(a);return this._clamp(d?.value)}update(h,a){const d=this._key(h);let f=this._cache.get(d);return f||(f=new I.MovingAverage,this._cache.set(d,f)),f.update(a),this.get(h)}}e.LanguageFeatureRequestDelays=k}),define(Ee[58],_e([0,1,2,30,145,120,53]),function(ee,e,m,F,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var S;(function(o){o[o.Null=0]="Null",o[o.PlainText=1]="PlainText"})(S=e.LanguageId||(e.LanguageId={}));class y{constructor(P,L){this.language=P,this.id=L}}e.LanguageIdentifier=y;var C;(function(o){o[o.NotSet=-1]="NotSet",o[o.None=0]="None",o[o.Italic=1]="Italic",o[o.Bold=2]="Bold",o[o.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var n;(function(o){o[o.None=0]="None",o[o.DefaultForeground=1]="DefaultForeground",o[o.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var k;(function(o){o[o.Other=0]="Other",o[o.Comment=1]="Comment",o[o.String=2]="String",o[o.RegEx=4]="RegEx"})(k=e.StandardTokenType||(e.StandardTokenType={}));var l;(function(o){o[o.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",o[o.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",o[o.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",o[o.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",o[o.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",o[o.ITALIC_MASK=2048]="ITALIC_MASK",o[o.BOLD_MASK=4096]="BOLD_MASK",o[o.UNDERLINE_MASK=8192]="UNDERLINE_MASK",o[o.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",o[o.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",o[o.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",o[o.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",o[o.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",o[o.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",o[o.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",o[o.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",o[o.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",o[o.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(l=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(P){return(P&255)>>>0}static getTokenType(P){return(P&1792)>>>8}static getFontStyle(P){return(P&14336)>>>11}static getForeground(P){return(P&8372224)>>>14}static getBackground(P){return(P&4286578688)>>>23}static getClassNameFromMetadata(P){let L=this.getForeground(P),$="mtk"+L,re=this.getFontStyle(P);return re&1&&($+=" mtki"),re&2&&($+=" mtkb"),re&4&&($+=" mtku"),$}static getInlineStyleFromMetadata(P,L){const $=this.getForeground(P),re=this.getFontStyle(P);let he=`color: ${L[$]};`;return re&1&&(he+="font-style: italic;"),re&2&&(he+="font-weight: bold;"),re&4&&(he+="text-decoration: underline;"),he}}e.TokenMetadata=h;var a;(function(o){o[o.Method=0]="Method",o[o.Function=1]="Function",o[o.Constructor=2]="Constructor",o[o.Field=3]="Field",o[o.Variable=4]="Variable",o[o.Class=5]="Class",o[o.Struct=6]="Struct",o[o.Interface=7]="Interface",o[o.Module=8]="Module",o[o.Property=9]="Property",o[o.Event=10]="Event",o[o.Operator=11]="Operator",o[o.Unit=12]="Unit",o[o.Value=13]="Value",o[o.Constant=14]="Constant",o[o.Enum=15]="Enum",o[o.EnumMember=16]="EnumMember",o[o.Keyword=17]="Keyword",o[o.Text=18]="Text",o[o.Color=19]="Color",o[o.File=20]="File",o[o.Reference=21]="Reference",o[o.Customcolor=22]="Customcolor",o[o.Folder=23]="Folder",o[o.TypeParameter=24]="TypeParameter",o[o.User=25]="User",o[o.Issue=26]="Issue",o[o.Snippet=27]="Snippet"})(a=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let o=Object.create(null);return o[0]="symbol-method",o[1]="symbol-function",o[2]="symbol-constructor",o[3]="symbol-field",o[4]="symbol-variable",o[5]="symbol-class",o[6]="symbol-struct",o[7]="symbol-interface",o[8]="symbol-module",o[9]="symbol-property",o[10]="symbol-event",o[11]="symbol-operator",o[12]="symbol-unit",o[13]="symbol-value",o[14]="symbol-constant",o[15]="symbol-enum",o[16]="symbol-enum-member",o[17]="symbol-keyword",o[27]="symbol-snippet",o[18]="symbol-text",o[19]="symbol-color",o[20]="symbol-file",o[21]="symbol-reference",o[22]="symbol-customcolor",o[23]="symbol-folder",o[24]="symbol-type-parameter",o[25]="account",o[26]="issues",function(P){const L=o[P];let $=L&&I.iconRegistry.get(L);return $||(console.info("No codicon found for CompletionItemKind "+P),$=I.Codicon.symbolProperty),$.classNames}}(),e.completionKindFromString=function(){let o=Object.create(null);return o.method=0,o.function=1,o.constructor=2,o.field=3,o.variable=4,o.class=5,o.struct=6,o.interface=7,o.module=8,o.property=9,o.event=10,o.operator=11,o.unit=12,o.value=13,o.constant=14,o.enum=15,o["enum-member"]=16,o.enumMember=16,o.keyword=17,o.snippet=27,o.text=18,o.color=19,o.file=20,o.reference=21,o.customcolor=22,o.folder=23,o["type-parameter"]=24,o.typeParameter=24,o.account=25,o.issue=26,function(P,L){let $=o[P];return typeof $=="undefined"&&!L&&($=9),$}}();var d;(function(o){o[o.Deprecated=1]="Deprecated"})(d=e.CompletionItemTag||(e.CompletionItemTag={}));var f;(function(o){o[o.KeepWhitespace=1]="KeepWhitespace",o[o.InsertAsSnippet=4]="InsertAsSnippet"})(f=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var E;(function(o){o[o.Invoke=0]="Invoke",o[o.TriggerCharacter=1]="TriggerCharacter",o[o.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(E=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var w;(function(o){o[o.Automatic=0]="Automatic",o[o.Explicit=1]="Explicit"})(w=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var u;(function(o){o[o.Invoke=1]="Invoke",o[o.Auto=2]="Auto"})(u=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var p;(function(o){o[o.Invoke=1]="Invoke",o[o.TriggerCharacter=2]="TriggerCharacter",o[o.ContentChange=3]="ContentChange"})(p=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var b;(function(o){o[o.Text=0]="Text",o[o.Read=1]="Read",o[o.Write=2]="Write"})(b=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(o){return o&&m.URI.isUri(o.uri)&&F.Range.isIRange(o.range)&&(F.Range.isIRange(o.originSelectionRange)||F.Range.isIRange(o.targetSelectionRange))}e.isLocationLink=t;var s;(function(o){o[o.File=0]="File",o[o.Module=1]="Module",o[o.Namespace=2]="Namespace",o[o.Package=3]="Package",o[o.Class=4]="Class",o[o.Method=5]="Method",o[o.Property=6]="Property",o[o.Field=7]="Field",o[o.Constructor=8]="Constructor",o[o.Enum=9]="Enum",o[o.Interface=10]="Interface",o[o.Function=11]="Function",o[o.Variable=12]="Variable",o[o.Constant=13]="Constant",o[o.String=14]="String",o[o.Number=15]="Number",o[o.Boolean=16]="Boolean",o[o.Array=17]="Array",o[o.Object=18]="Object",o[o.Key=19]="Key",o[o.Null=20]="Null",o[o.EnumMember=21]="EnumMember",o[o.Struct=22]="Struct",o[o.Event=23]="Event",o[o.Operator=24]="Operator",o[o.TypeParameter=25]="TypeParameter"})(s=e.SymbolKind||(e.SymbolKind={}));var r;(function(o){o[o.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var i;(function(o){const P=new Map;P.set("file",0),P.set("module",1),P.set("namespace",2),P.set("package",3),P.set("class",4),P.set("method",5),P.set("property",6),P.set("field",7),P.set("constructor",8),P.set("enum",9),P.set("interface",10),P.set("function",11),P.set("variable",12),P.set("constant",13),P.set("string",14),P.set("number",15),P.set("boolean",16),P.set("array",17),P.set("object",18),P.set("key",19),P.set("null",20),P.set("enum-member",21),P.set("struct",22),P.set("event",23),P.set("operator",24),P.set("type-parameter",25);const L=new Map;L.set(0,"file"),L.set(1,"module"),L.set(2,"namespace"),L.set(3,"package"),L.set(4,"class"),L.set(5,"method"),L.set(6,"property"),L.set(7,"field"),L.set(8,"constructor"),L.set(9,"enum"),L.set(10,"interface"),L.set(11,"function"),L.set(12,"variable"),L.set(13,"constant"),L.set(14,"string"),L.set(15,"number"),L.set(16,"boolean"),L.set(17,"array"),L.set(18,"object"),L.set(19,"key"),L.set(20,"null"),L.set(21,"enum-member"),L.set(22,"struct"),L.set(23,"event"),L.set(24,"operator"),L.set(25,"type-parameter");function $(Q){return P.get(Q)}o.fromString=$;function re(Q){return L.get(Q)}o.toString=re;function he(Q,z){const V=L.get(Q);let T=V&&I.iconRegistry.get("symbol-"+V);return T||(console.info("No codicon found for SymbolKind "+Q),T=I.Codicon.symbolProperty),`${z?"inline":"block"} ${T.classNames}`}o.toCssClassName=he})(i=e.SymbolKinds||(e.SymbolKinds={}));class c{constructor(P){this.value=P}}e.FoldingRangeKind=c,c.Comment=new c("comment"),c.Imports=new c("imports"),c.Region=new c("region");var g;(function(o){o[o.Collapsed=0]="Collapsed",o[o.Expanded=1]="Expanded"})(g=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var v;(function(o){o[o.Editing=0]="Editing",o[o.Preview=1]="Preview"})(v=e.CommentMode||(e.CommentMode={}));var A;(function(o){o[o.Other=0]="Other",o[o.Type=1]="Type",o[o.Parameter=2]="Parameter"})(A=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new D.LanguageFeatureRegistry,e.RenameProviderRegistry=new D.LanguageFeatureRegistry,e.CompletionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new D.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new D.LanguageFeatureRegistry,e.HoverProviderRegistry=new D.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new D.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new D.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new D.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new D.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new D.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.LinkProviderRegistry=new D.LanguageFeatureRegistry,e.ColorProviderRegistry=new D.LanguageFeatureRegistry,e.SelectionRangeRegistry=new D.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.TokenizationRegistry=new _.TokenizationRegistryImpl;var R;(function(o){o[o.None=0]="None",o[o.Option=1]="Option",o[o.Default=2]="Default",o[o.Preferred=3]="Preferred"})(R=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Ee[59],_e([0,1,8,4,21]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let _=D.userAgent||"";const I=new Map;I.set("false",!1),I.set("true",!0),I.set("isMac",D.isMacintosh),I.set("isLinux",D.isLinux),I.set("isWindows",D.isWindows),I.set("isWeb",D.isWeb),I.set("isMacNative",D.isMacintosh&&!D.isWeb),I.set("isEdge",_.indexOf("Edg/")>=0),I.set("isFirefox",_.indexOf("Firefox")>=0),I.set("isChrome",_.indexOf("Chrome")>=0),I.set("isSafari",_.indexOf("Safari")>=0);const S=Object.prototype.hasOwnProperty;var y;(function(R){R[R.False=0]="False",R[R.True=1]="True",R[R.Defined=2]="Defined",R[R.Not=3]="Not",R[R.Equals=4]="Equals",R[R.NotEquals=5]="NotEquals",R[R.And=6]="And",R[R.Regex=7]="Regex",R[R.NotRegex=8]="NotRegex",R[R.Or=9]="Or",R[R.In=10]="In",R[R.NotIn=11]="NotIn",R[R.Greater=12]="Greater",R[R.GreaterEquals=13]="GreaterEquals",R[R.Smaller=14]="Smaller",R[R.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return k.INSTANCE}static true(){return l.INSTANCE}static has(o){return h.create(o)}static equals(o,P){return a.create(o,P)}static notEquals(o,P){return E.create(o,P)}static regex(o,P){return s.create(o,P)}static in(o,P){return d.create(o,P)}static not(o){return w.create(o)}static and(...o){return i.create(o)}static or(...o){return c.create(o)}static greater(o,P){return u.create(o,P)}static less(o,P){return b.create(o,P)}static deserialize(o,P=!1){if(!!o)return this._deserializeOrExpression(o,P)}static _deserializeOrExpression(o,P){let L=o.split("||");return c.create(L.map($=>this._deserializeAndExpression($,P)))}static _deserializeAndExpression(o,P){let L=o.split("&&");return i.create(L.map($=>this._deserializeOne($,P)))}static _deserializeOne(o,P){if(o=o.trim(),o.indexOf("!=")>=0){let L=o.split("!=");return E.create(L[0].trim(),this._deserializeValue(L[1],P))}if(o.indexOf("==")>=0){let L=o.split("==");return a.create(L[0].trim(),this._deserializeValue(L[1],P))}if(o.indexOf("=~")>=0){let L=o.split("=~");return s.create(L[0].trim(),this._deserializeRegexValue(L[1],P))}if(o.indexOf(" in ")>=0){let L=o.split(" in ");return d.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(o)){const L=o.split(">=");return p.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(o)){const L=o.split(">");return u.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(o)){const L=o.split("<=");return t.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(o)){const L=o.split("<");return b.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(o)?w.create(o.substr(1).trim()):h.create(o)}static _deserializeValue(o,P){if(o=o.trim(),o==="true")return!0;if(o==="false")return!1;let L=/^'([^']*)'$/.exec(o);return L?L[1].trim():o}static _deserializeRegexValue(o,P){if((0,m.isFalsyOrWhitespace)(o)){if(P)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=o.indexOf("/"),$=o.lastIndexOf("/");if(L===$||L<0){if(P)throw new Error(`bad regexp-value '${o}', missing /-enclosure`);return console.warn(`bad regexp-value '${o}', missing /-enclosure`),null}let re=o.slice(L+1,$),he=o[$+1]==="i"?"i":"";try{return new RegExp(re,he)}catch(Q){if(P)throw new Error(`bad regexp-value '${o}', parse error: ${Q}`);return console.warn(`bad regexp-value '${o}', parse error: ${Q}`),null}}}e.ContextKeyExpr=C;function n(R,o){return R.cmp(o)}class k{constructor(){this.type=0}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!1}serialize(){return"false"}keys(){return[]}map(o){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class l{constructor(){this.type=1}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!0}serialize(){return"true"}keys(){return[]}map(o){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=l,l.INSTANCE=new l;class h{constructor(o){this.key=o,this.type=2}static create(o){const P=I.get(o);return typeof P=="boolean"?P?l.INSTANCE:k.INSTANCE:new h(o)}cmp(o){return o.type!==this.type?this.type-o.type:v(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!!o.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(o){return o.mapDefined(this.key)}negate(){return w.create(this.key)}}e.ContextKeyDefinedExpr=h;class a{constructor(o,P){this.key=o,this.value=P,this.type=4}static create(o,P){if(typeof P=="boolean")return P?h.create(o):w.create(o);const L=I.get(o);return typeof L=="boolean"?P===(L?"true":"false")?l.INSTANCE:k.INSTANCE:new a(o,P)}cmp(o){return o.type!==this.type?this.type-o.type:A(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(o){return o.mapEquals(this.key,this.value)}negate(){return E.create(this.key,this.value)}}e.ContextKeyEqualsExpr=a;class d{constructor(o,P){this.key=o,this.valueKey=P,this.type=10}static create(o,P){return new d(o,P)}cmp(o){return o.type!==this.type?this.type-o.type:A(this.key,this.valueKey,o.key,o.valueKey)}equals(o){return o.type===this.type?this.key===o.key&&this.valueKey===o.valueKey:!1}evaluate(o){const P=o.getValue(this.valueKey),L=o.getValue(this.key);return Array.isArray(P)?P.indexOf(L)>=0:typeof L=="string"&&typeof P=="object"&&P!==null?S.call(P,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(o){return o.mapIn(this.key,this.valueKey)}negate(){return f.create(this)}}e.ContextKeyInExpr=d;class f{constructor(o){this._actual=o,this.type=11}static create(o){return new f(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new f(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotInExpr=f;class E{constructor(o,P){this.key=o,this.value=P,this.type=5}static create(o,P){if(typeof P=="boolean")return P?w.create(o):h.create(o);const L=I.get(o);return typeof L=="boolean"?P===(L?"true":"false")?k.INSTANCE:l.INSTANCE:new E(o,P)}cmp(o){return o.type!==this.type?this.type-o.type:A(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(o){return o.mapNotEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=E;class w{constructor(o){this.key=o,this.type=3}static create(o){const P=I.get(o);return typeof P=="boolean"?P?k.INSTANCE:l.INSTANCE:new w(o)}cmp(o){return o.type!==this.type?this.type-o.type:v(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!o.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(o){return o.mapNot(this.key)}negate(){return h.create(this.key)}}e.ContextKeyNotExpr=w;class u{constructor(o,P){this.key=o,this.value=P,this.type=12}static create(o,P){return new u(o,P)}cmp(o){return o.type!==this.type?this.type-o.type:A(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=u;class p{constructor(o,P){this.key=o,this.value=P,this.type=13}static create(o,P){return new p(o,P)}cmp(o){return o.type!==this.type?this.type-o.type:A(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreaterEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=p;class b{constructor(o,P){this.key=o,this.value=P,this.type=14}static create(o,P){return new b(o,P)}cmp(o){return o.type!==this.type?this.type-o.type:A(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmaller(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeySmallerExpr=b;class t{constructor(o,P){this.key=o,this.value=P,this.type=15}static create(o,P){return new t(o,P)}cmp(o){return o.type!==this.type?this.type-o.type:A(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmallerEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class s{constructor(o,P){this.key=o,this.regexp=P,this.type=7}static create(o,P){return new s(o,P)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.key<o.key)return-1;if(this.key>o.key)return 1;const P=this.regexp?this.regexp.source:"",L=o.regexp?o.regexp.source:"";return P<L?-1:P>L?1:0}equals(o){if(o.type===this.type){const P=this.regexp?this.regexp.source:"",L=o.regexp?o.regexp.source:"";return this.key===o.key&&P===L}return!1}evaluate(o){let P=o.getValue(this.key);return this.regexp?this.regexp.test(P):!1}serialize(){const o=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${o}`}keys(){return[this.key]}map(o){return o.mapRegex(this.key,this.regexp)}negate(){return r.create(this)}}e.ContextKeyRegexExpr=s;class r{constructor(o){this._actual=o,this.type=8}static create(o){return new r(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new r(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class i{constructor(o){this.expr=o,this.type=6}static create(o){return i._normalizeArr(o)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let P=0,L=this.expr.length;P<L;P++){const $=n(this.expr[P],o.expr[P]);if($!==0)return $}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let P=0,L=this.expr.length;P<L;P++)if(!this.expr[P].equals(o.expr[P]))return!1;return!0}return!1}evaluate(o){for(let P=0,L=this.expr.length;P<L;P++)if(!this.expr[P].evaluate(o))return!1;return!0}static _normalizeArr(o){const P=[];let L=!1;for(const $ of o)if(!!$){if($.type===1){L=!0;continue}if($.type===0)return k.INSTANCE;if($.type===6){P.push(...$.expr);continue}P.push($)}if(P.length===0&&L)return l.INSTANCE;if(P.length!==0){if(P.length===1)return P[0];for(P.sort(n);P.length>1;){const $=P[P.length-1];if($.type!==9)break;P.pop();const re=P.pop(),he=c.create($.expr.map(Q=>i.create([Q,re])));he&&(P.push(he),P.sort(n))}return P.length===1?P[0]:new i(P)}}serialize(){return this.expr.map(o=>o.serialize()).join(" && ")}keys(){const o=[];for(let P of this.expr)o.push(...P.keys());return o}map(o){return new i(this.expr.map(P=>P.map(o)))}negate(){let o=[];for(let P of this.expr)o.push(P.negate());return c.create(o)}}e.ContextKeyAndExpr=i;class c{constructor(o){this.expr=o,this.type=9}static create(o){const P=c._normalizeArr(o);if(P.length!==0)return P.length===1?P[0]:new c(P)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let P=0,L=this.expr.length;P<L;P++){const $=n(this.expr[P],o.expr[P]);if($!==0)return $}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let P=0,L=this.expr.length;P<L;P++)if(!this.expr[P].equals(o.expr[P]))return!1;return!0}return!1}evaluate(o){for(let P=0,L=this.expr.length;P<L;P++)if(this.expr[P].evaluate(o))return!0;return!1}static _normalizeArr(o){let P=[],L=!1;if(o){for(let $=0,re=o.length;$<re;$++){const he=o[$];if(!!he){if(he.type===0){L=!0;continue}if(he.type===1)return[l.INSTANCE];if(he.type===9){P=P.concat(he.expr);continue}P.push(he)}}if(P.length===0&&L)return[k.INSTANCE];P.sort(n)}return P}serialize(){return this.expr.map(o=>o.serialize()).join(" || ")}keys(){const o=[];for(let P of this.expr)o.push(...P.keys());return o}map(o){return new c(this.expr.map(P=>P.map(o)))}negate(){let o=[];for(let L of this.expr)o.push(L.negate());const P=L=>L.type===9?L.expr:[L];for(;o.length>1;){const L=o.shift(),$=o.shift(),re=[];for(const he of P(L))for(const Q of P($))re.push(C.and(he,Q));o.unshift(C.or(...re))}return o[0]}}e.ContextKeyOrExpr=c;class g extends h{constructor(o,P,L){super(o);this._defaultValue=P,typeof L=="object"?g._info.push({...L,key:o}):L!==!0&&g._info.push({key:o,description:L,type:P!=null?typeof P:void 0})}static all(){return g._info.values()}bindTo(o){return o.createKey(this.key,this._defaultValue)}getValue(o){return o.getContextKeyValue(this.key)}toNegated(){return C.not(this.key)}isEqualTo(o){return C.equals(this.key,o)}notEqualsTo(o){return C.notEquals(this.key,o)}}e.RawContextKey=g,g._info=[],e.IContextKeyService=(0,F.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(R,o){return R<o?-1:R>o?1:0}function A(R,o,P,L){return R<P?-1:R>P?1:o<L?-1:o>L?1:0}}),define(Ee[146],_e([0,1,4]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(Ee[26],_e([0,1,8,4]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function D(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=D;function _(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=_,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class S{constructor(k){this.value=k,this._lower=k.toLowerCase()}static equals(k,l){if(typeof k=="undefined"||k===null)return typeof l=="undefined"||l===null;if(typeof l=="undefined"||l===null)return!1;if(typeof k=="string"||typeof l=="string"){let h=typeof k=="string"?k:k.value,a=typeof l=="string"?l:l.value;return m.equalsIgnoreCase(h,a)}return k._lower===l._lower}static toKey(k){return typeof k=="string"?k.toLowerCase():k._lower}}e.ExtensionIdentifier=S;function y(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function C(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=C,e.IBuiltinExtensionsScannerService=(0,F.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ee[147],_e([0,1,8,26]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(a,d){return a.uuid&&d.uuid?a.uuid===d.uuid:a.id===d.id?!0:(0,m.compareIgnoreCase)(a.id,d.id)===0}e.areSameExtensions=D;class _{constructor(d,f){this.version=f,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof _?D(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=_;function I(a,d){return`${a}.${d}`}e.getExtensionId=I;function S(a){return a.toLocaleLowerCase()}e.adoptToGalleryExtensionId=S;function y(a,d){return S(I(a,d))}e.getGalleryExtensionId=y;function C(a,d){const f=[],E=w=>{for(const u of f)if(u.some(p=>D(d(p),d(w))))return u;return null};for(const w of a){const u=E(w);u?u.push(w):f.push([w])}return f}e.groupByExtension=C;function n(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function k(a){return{id:a.identifier.id,name:a.name,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),...a.telemetryData}}e.getGalleryExtensionTelemetryData=k,e.BetterMergeId=new F.ExtensionIdentifier("pprice.better-merge");function l(a){const d=new Set;for(const f of a)f.malicious&&d.add(f.id.id);return d}e.getMaliciousExtensionsSet=l;function h(a,d){const f=[],E=d.manifest.extensionDependencies?.slice(0)??[];for(;E.length;){const w=E.shift();if(w&&f.every(u=>!D(u.identifier,{id:w}))){const u=a.filter(p=>D(p.identifier,{id:w}));u.length===1&&(f.push(u[0]),E.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return f}e.getExtensionDependencies=h}),define(Ee[60],_e([0,1,127,14,2,4,8,10,22]),function(ee,e,m,F,D,_,I,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,_.createDecorator)("fileService");function C(z){return z.create===!0}e.isFileOpenForWriteOptions=C;var n;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var k;(function(z){z[z.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var l;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=h;function a(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=a;function d(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function f(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=f;var E;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(V,T){super(V);this.code=T}}e.FileSystemProviderError=w;function u(z,V){const T=new w(z.toString(),V);return b(T,V),T}e.createFileSystemProviderError=u;function p(z){return z||u((0,m.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=p;function b(z,V){return z.name=V?`${V} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=b;function t(z){if(!z)return E.Unknown;if(z instanceof w)return z.code;const V=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!V)return E.Unknown;switch(V[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=t;function s(z){if(z instanceof A)return z.fileOperationResult;switch(t(z)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var r;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class i{constructor(V,T,G){this.resource=V,this.operation=T,this.target=G}isOperation(V){return this.operation===V}}e.FileOperationEvent=i;var c;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class g{constructor(V,T){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const G of V)switch(G.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>T)),this.added.set(G.resource,G);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>T)),this.updated.set(G.resource,G);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>T)),this.deleted.set(G.resource,G);break}}contains(V,...T){return this.doContains(V,{includeChildren:!1},...T)}affects(V,...T){return this.doContains(V,{includeChildren:!0},...T)}doContains(V,T,...G){if(!V)return!1;const B=G.length>0;return!!((!B||G.includes(1))&&(this.added?.get(V)||T.includeChildren&&this.added?.findSuperstr(V))||(!B||G.includes(0))&&(this.updated?.get(V)||T.includeChildren&&this.updated?.findSuperstr(V))||(!B||G.includes(2))&&(this.deleted?.findSubstr(V)||T.includeChildren&&this.deleted?.findSuperstr(V)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=g;function v(z,V,T){return!z||!V||z===V||V.length>z.length?!1:(V.charAt(V.length-1)!==F.sep&&(V+=F.sep),T?(0,I.startsWithIgnoreCase)(z,V):z.indexOf(V)===0)}e.isParent=v;class A extends Error{constructor(V,T,G){super(V);this.fileOperationResult=T,this.options=G}}e.FileOperationError=A;class R extends A{constructor(V,T,G){super(V,2,G);this.stat=T}}e.NotModifiedSinceFileOperationError=R;var o;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(o=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var P;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(P=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=L;async function $(z,V){if(!V.canHandleResource(D.URI.from({scheme:z.scheme})))return new Promise(T=>{const G=V.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===z.scheme&&B.added&&(G.dispose(),T())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class re{static formatSize(V){return(0,S.isNumber)(V)||(V=0),V<re.KB?(0,m.localize)(1,null,V.toFixed(0)):V<re.MB?(0,m.localize)(2,null,(V/re.KB).toFixed(2)):V<re.GB?(0,m.localize)(3,null,(V/re.MB).toFixed(2)):V<re.TB?(0,m.localize)(4,null,(V/re.GB).toFixed(2)):(0,m.localize)(5,null,(V/re.TB).toFixed(2))}}e.ByteSize=re,re.KB=1024,re.MB=re.KB*re.KB,re.GB=re.MB*re.KB,re.TB=re.GB*re.KB;var he;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(he=e.Arch||(e.Arch={}));function Q(z){return{maxFileSize:z===0?300*re.MB:16*re.GB,maxHeapSize:z===0?700*re.MB:2*700*re.MB}}e.getPlatformLimits=Q}),define(Ee[61],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...D){this._entries=new Map;for(let[_,I]of D)this.set(_,I)}set(D,_){const I=this._entries.get(D);return this._entries.set(D,_),I}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=m}),define(Ee[148],_e([0,1,12,143,89,4,61,16]),function(ee,e,m,F,D,_,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class C extends Error{constructor(a){super("cyclic dependency between services");this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class n{constructor(a=new I.ServiceCollection,d=!1,f){this._activeInstantiations=new Set,this._services=a,this._strict=d,this._parent=f,this._services.set(_.IInstantiationService,this)}createChild(a){return new n(a,this._strict,this)}invokeFunction(a,...d){let f=l.traceInvocation(a),E=!1;try{return a({get:(u,p)=>{if(E)throw(0,m.illegalState)("service accessor is only valid during the invocation of its target method");const b=this._getOrCreateServiceInstance(u,f);if(!b&&p!==_.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return b}},...d)}finally{E=!0,f.stop()}}createInstance(a,...d){let f,E;return a instanceof D.SyncDescriptor?(f=l.traceCreation(a.ctor),E=this._createInstance(a.ctor,a.staticArguments.concat(d),f)):(f=l.traceCreation(a),E=this._createInstance(a,d,f)),f.stop(),E}_createInstance(a,d=[],f){let E=_._util.getServiceDependencies(a).sort((p,b)=>p.index-b.index),w=[];for(const p of E){let b=this._getOrCreateServiceInstance(p.id,f);if(!b&&this._strict&&!p.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${p.id}.`);w.push(b)}let u=E.length>0?E[0].index:d.length;if(d.length!==u){console.warn(`[createInstance] First service dependency of ${a.name} at position ${u+1} conflicts with ${d.length} static arguments`);let p=u-d.length;p>0?d=d.concat(new Array(p)):d=d.slice(0,u)}return new a(...[...d,...w])}_setServiceInstance(a,d){if(this._services.get(a)instanceof D.SyncDescriptor)this._services.set(a,d);else if(this._parent)this._parent._setServiceInstance(a,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let d=this._services.get(a);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):d}_getOrCreateServiceInstance(a,d){let f=this._getServiceInstanceOrDescriptor(a);return f instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,f,d.branch(a,!0)):(d.branch(a,!1),f)}_safeCreateAndCacheServiceInstance(a,d,f){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,d,f)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,d,f){const E=new F.Graph(p=>p.id.toString());let w=0;const u=[{id:a,desc:d,_trace:f}];for(;u.length;){const p=u.pop();if(E.lookupOrInsertNode(p),w++>1e3)throw new C(E);for(let b of _._util.getServiceDependencies(p.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(b.id);if(!t&&!b.optional&&console.warn(`[createInstance] ${a} depends on ${b.id} which is NOT registered.`),t instanceof D.SyncDescriptor){const s={id:b.id,desc:t,_trace:p._trace.branch(b.id,!0)};E.insertEdge(p,s),u.push(s)}}}for(;;){const p=E.roots();if(p.length===0){if(!E.isEmpty())throw new C(E);break}for(const{data:b}of p){if(this._getServiceInstanceOrDescriptor(b.id)instanceof D.SyncDescriptor){const s=this._createServiceInstanceWithOwner(b.id,b.desc.ctor,b.desc.staticArguments,b.desc.supportsDelayedInstantiation,b._trace);this._setServiceInstance(b.id,s)}E.removeNode(b)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,d,f=[],E,w){if(this._services.get(a)instanceof D.SyncDescriptor)return this._createServiceInstance(d,f,E,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,d,f,E,w);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(a,d=[],f,E){if(f){const w=new S.IdleValue(()=>this._createInstance(a,d,E));return new Proxy(Object.create(null),{get(u,p){if(p in u)return u[p];let b=w.value,t=b[p];return typeof t!="function"||(t=t.bind(b),u[p]=t),t},set(u,p,b){return w.value[p]=b,!0}})}else return this._createInstance(a,d,E)}}e.InstantiationService=n;var k;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(k||(k={}));class l{constructor(a,d){this.type=a,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return y?new l(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(a){return y?new l(0,a.name):l._None}branch(a,d){let f=new l(2,a.toString());return this._dep.push([a,d,f]),f}stop(){let a=Date.now()-this._start;l._totals+=a;let d=!1;function f(w,u){let p=[],b=new Array(w+1).join("	");for(const[t,s,r]of u._dep)if(s&&r){d=!0,p.push(`${b}CREATES -> ${t}`);let i=f(w+1,r);i&&p.push(i)}else p.push(`${b}uses -> ${t}`);return p.join(`
`)}let E=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(a>2||d)&&console.log(E.join(`
`))}}l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(Ee[15],_e([0,1,4,7,21,3,56]),function(ee,e,m,F,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,m.createDecorator)("logService"),e.ILoggerService=(0,m.createDecorator)("loggerService");function S(){return new Date().toISOString()}var y;(function(b){b[b.Trace=0]="Trace",b[b.Debug=1]="Debug",b[b.Info=2]="Info",b[b.Warning=3]="Warning",b[b.Error=4]="Error",b[b.Critical=5]="Critical",b[b.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class C extends F.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new _.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class n extends C{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...s){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...s]))}debug(t,...s){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...s]))}info(t,...s){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...s]))}warn(t,...s){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...s]))}error(t,...s){if(this.checkLogLevel(y.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(y.Error,this.format(r))}else this.log(y.Error,this.format([t,...s]))}critical(t,...s){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...s]))}flush(){}format(t){let s="";for(let r=0;r<t.length;r++){let i=t[r];if(typeof i=="object")try{i=JSON.stringify(i)}catch(c){}s+=(r>0?" ":"")+i}return s}}e.AbstractMessageLogger=n;class k extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!D.isWindows}trace(t,...s){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${S()}][0m`,t,...s):console.log(`[main ${S()}]`,t,...s))}debug(t,...s){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${S()}][0m`,t,...s):console.log(`[main ${S()}]`,t,...s))}info(t,...s){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${S()}][0m`,t,...s):console.log(`[main ${S()}]`,t,...s))}warn(t,...s){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${S()}][0m`,t,...s):console.warn(`[main ${S()}]`,t,...s))}error(t,...s){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${S()}][0m`,t,...s):console.error(`[main ${S()}]`,t,...s))}critical(t,...s){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${S()}][0m`,t,...s):console.error(`[main ${S()}]`,t,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=k;class l extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...s){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...s)}debug(t,...s){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...s)}info(t,...s){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...s)}warn(t,...s){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...s)}error(t,...s){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...s)}critical(t,...s){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...s)}dispose(){}flush(){}}e.ConsoleLogger=l;class h extends C{constructor(t,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(s)}trace(t,...s){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...s])}debug(t,...s){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...s])}info(t,...s){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...s])}warn(t,...s){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...s])}error(t,...s){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...s])}critical(t,...s){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...s])}extractMessage(t){return typeof t=="string"?t:(0,I.toErrorMessage)(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class a extends C{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const s of this.logServices)s.setLevel(t);super.setLevel(t)}trace(t,...s){for(const r of this.logServices)r.trace(t,...s)}debug(t,...s){for(const r of this.logServices)r.debug(t,...s)}info(t,...s){for(const r of this.logServices)r.info(t,...s)}warn(t,...s){for(const r of this.logServices)r.warn(t,...s)}error(t,...s){for(const r of this.logServices)r.error(t,...s)}critical(t,...s){for(const r of this.logServices)r.critical(t,...s)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=a;class d extends F.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...s){this.logger.trace(t,...s)}debug(t,...s){this.logger.debug(t,...s)}info(t,...s){this.logger.info(t,...s)}warn(t,...s){this.logger.warn(t,...s)}error(t,...s){this.logger.error(t,...s)}critical(t,...s){this.logger.critical(t,...s)}flush(){this.logger.flush()}}e.LogService=d;class f extends F.Disposable{constructor(t,s){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(r))}))}createLogger(t,s){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,s?.always?y.Trace:this.logLevel,s),this.loggers.set(t.toString(),r),s?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=f;class E{constructor(){this.onDidChangeLogLevel=new _.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...s){}debug(t,...s){}info(t,...s){}warn(t,...s){}error(t,...s){}critical(t,...s){}dispose(){}flush(){}}e.NullLogService=E;function w(b){if(b.verbose)return y.Trace;if(typeof b.logLevel=="string"){const t=u(b.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=w;function u(b){switch(b){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=u;function p(b){switch(b){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=p}),define(Ee[90],_e([0,1,4,128,42]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var _;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(_=e.MarkerTag||(e.MarkerTag={}));var I;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(I=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function C(a,d){return d-a}y.compare=C;const n=Object.create(null);n[y.Error]=(0,F.localize)(0,null),n[y.Warning]=(0,F.localize)(1,null),n[y.Info]=(0,F.localize)(2,null);function k(a){return n[a]||""}y.toString=k;function l(a){switch(a){case D.default.Error:return y.Error;case D.default.Warning:return y.Warning;case D.default.Info:return y.Info;case D.default.Ignore:return y.Hint}}y.fromSeverity=l;function h(a){switch(a){case y.Error:return D.default.Error;case y.Warning:return D.default.Warning;case y.Info:return D.default.Info;case y.Hint:return D.default.Ignore}}y.toSeverity=h}(I=e.MarkerSeverity||(e.MarkerSeverity={}));var S;(function(y){const C="";function n(l){return k(l,!0)}y.makeKey=n;function k(l,h){let a=[C];return l.source?a.push(l.source.replace("\xA6","\\\xA6")):a.push(C),l.code?typeof l.code=="string"?a.push(l.code.replace("\xA6","\\\xA6")):a.push(l.code.value.replace("\xA6","\\\xA6")):a.push(C),l.severity!==void 0&&l.severity!==null?a.push(I.toString(l.severity)):a.push(C),l.message&&h?a.push(l.message.replace("\xA6","\\\xA6")):a.push(C),l.startLineNumber!==void 0&&l.startLineNumber!==null?a.push(l.startLineNumber.toString()):a.push(C),l.startColumn!==void 0&&l.startColumn!==null?a.push(l.startColumn.toString()):a.push(C),l.endLineNumber!==void 0&&l.endLineNumber!==null?a.push(l.endLineNumber.toString()):a.push(C),l.endColumn!==void 0&&l.endColumn!==null?a.push(l.endColumn.toString()):a.push(C),a.push(C),a.join("\xA6")}y.makeKeyOptionalMessage=k})(S=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,m.createDecorator)("markerService")}),define(Ee[149],_e([0,1,42,4,3]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=m.default,e.INotificationService=(0,F.createDecorator)("notificationService");var _;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.GLOBAL=1]="GLOBAL"})(_=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var I;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(I=e.NotificationsFilter||(e.NotificationsFilter={}));class S{constructor(){this.progress=new y,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=S;class y{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=y}),define(Ee[150],_e([0,1,7,8,2,4]),function(ee,e,m,F,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,_.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return m.Disposable.None},registerValidator(){return m.Disposable.None},registerExternalUriResolver(){return m.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return m.Disposable.None},async open(){return!1},async resolveExternalUri(S){return{resolved:S,dispose(){}}}});function I(S,y){return D.URI.isUri(S)?(0,F.equalsIgnoreCase)(S.scheme,y):(0,F.startsWithIgnoreCase)(S,y+":")}e.matchesScheme=I});var ze=this&&this.__decorate||function(ee,e,m,F){var D=arguments.length,_=D<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,m):F,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")_=Reflect.decorate(ee,e,m,F);else for(var S=ee.length-1;S>=0;S--)(I=ee[S])&&(_=(D<3?I(_):D>3?I(e,m,_):I(e,m))||_);return D>3&&_&&Object.defineProperty(e,m,_),_},qe=this&&this.__param||function(ee,e){return function(m,F){e(m,F,ee)}};define(Ee[151],_e([0,1,4,18,7,16]),function(ee,e,m,F,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,m.createDecorator)("progressService");var I;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(I=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class S{constructor(k){this.callback=k}get value(){return this._value}report(k){this._value=k,this.callback(this._value)}}e.Progress=S,S.None=Object.freeze({report(){}});let y=class extends D.Disposable{constructor(k,l){super();this.deferred=new _.DeferredPromise,l.withProgress(k,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};y=ze([qe(1,e.IProgressService)],y),e.UnmanagedProgress=y;class C extends D.Disposable{constructor(k){super();this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(k){this.stop();const l=++this.currentOperationId,h=new F.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>h.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:h.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=(0,m.createDecorator)("editorProgressService")}),define(Ee[31],_e([0,1,10,39]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(I,S){F.ok(m.isString(I)),F.ok(m.isObject(S)),F.ok(!this.data.has(I),"There is already an extension with this id"),this.data.set(I,S)}knows(I){return this.data.has(I)}as(I){return this.data.get(I)||null}}e.Registry=new D}),define(Ee[152],_e([0,1,31,3]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class _{constructor(){this._onDidChangeSchema=new F.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,C){this.schemasById[D(y)]=C,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const I=new _;m.Registry.add(e.Extensions.JSONContribution,I)}),define(Ee[62],_e([0,1,125,3,31,10,152]),function(ee,e,m,F,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(E){E.Multiline="multilineText",E.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const C=D.Registry.as(I.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new F.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new F.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:m.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,u=!0){this.registerConfigurations([w],u)}registerConfigurations(w,u=!0){const p=[];w.forEach(b=>{p.push(...this.validateAndRegisterProperties(b,u,b.extensionInfo)),this.configurationContributors.push(b),this.registerJSONConfiguration(b)}),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}deregisterConfigurations(w){const u=[],p=b=>{if(b.properties)for(const t in b.properties)u.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,b.properties[t]);b.allOf&&b.allOf.forEach(t=>p(t))};for(const b of w){p(b);const t=this.configurationContributors.indexOf(b);t!==-1&&this.configurationContributors.splice(t,1)}C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}registerDefaultConfigurations(w){const u=[],p=[];for(const b of w)for(const t in b)if(u.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...b[t]};const s={type:"object",default:this.defaultValues[t],description:m.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};p.push(l(t)),this.configurationProperties[t]=s,this.defaultLanguageConfigurationOverridesNode.properties[t]=s}else{this.defaultValues[t]=b[t];const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.registerOverrideIdentifiers(p),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterDefaultConfigurations(w){const u=[];for(const p of w)for(const b in p)if(u.push(b),delete this.defaultValues[b],e.OVERRIDE_PROPERTY_PATTERN.test(b))delete this.configurationProperties[b],delete this.defaultLanguageConfigurationOverridesNode.properties[b];else{const t=this.configurationProperties[b];t&&(this.updatePropertyDefaultValue(b,t),this.updateSchema(b,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const u of w)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,u=!0,p,b=3){b=_.isUndefinedOrNull(w.scope)?b:w.scope;let t=[],s=w.properties;if(s)for(let i in s){if(u&&d(i)){delete s[i];continue}const c=s[i];if(this.updatePropertyDefaultValue(i,c),e.OVERRIDE_PROPERTY_PATTERN.test(i)?c.scope=void 0:(c.scope=_.isUndefinedOrNull(c.scope)?b:c.scope,c.restricted=_.isUndefinedOrNull(c.restricted)?!!p?.restrictedConfigurations?.includes(i):c.restricted),s[i].hasOwnProperty("included")&&!s[i].included){this.excludedConfigurationProperties[i]=s[i],delete s[i];continue}else this.configurationProperties[i]=s[i];!s[i].deprecationMessage&&s[i].markdownDeprecationMessage&&(s[i].deprecationMessage=s[i].markdownDeprecationMessage),t.push(i)}let r=w.allOf;if(r)for(let i of r)t.push(...this.validateAndRegisterProperties(i,u,p,b));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const u=p=>{let b=p.properties;if(b)for(const s in b)this.updateSchema(s,b[s]);let t=p.allOf;t&&t.forEach(u)};u(w)}updateSchema(w,u){switch(e.allSettings.properties[w]=u,u.scope){case 1:e.applicationSettings.properties[w]=u;break;case 2:e.machineSettings.properties[w]=u;break;case 6:e.machineOverridableSettings.properties[w]=u;break;case 3:e.windowSettings.properties[w]=u;break;case 4:e.resourceSettings.properties[w]=u;break;case 5:e.resourceSettings.properties[w]=u,this.resourceLanguageSettingsSchema.properties[w]=u;break}}removeFromSchema(w,u){switch(delete e.allSettings.properties[w],u.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const u=`[${w}]`,p={type:"object",description:m.localize(2,null),errorMessage:m.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,p),e.allSettings.properties[u]=p,e.applicationSettings.properties[u]=p,e.machineSettings.properties[u]=p,e.machineOverridableSettings.properties[u]=p,e.windowSettings.properties[u]=p,e.resourceSettings.properties[u]=p}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,u){let p=this.defaultValues[w];_.isUndefined(p)&&(p=u.default),_.isUndefined(p)&&(p=h(u.type)),u.default=p}}const k="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(k);function l(E){return E.substring(1,E.length-1)}e.overrideIdentifierFromKey=l;function h(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const a=new n;D.Registry.add(e.Extensions.Configuration,a);function d(E){return E.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(E)?m.localize(5,null,E):a.getConfigurationProperties()[E]!==void 0?m.localize(6,null,E):null:m.localize(4,null)}e.validateProperty=d;function f(){const E=[],w=a.getConfigurationProperties();for(const u of Object.keys(w))E.push([u,w[u].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=f}),define(Ee[91],_e([0,1,24,10,2,31,4,62]),function(ee,e,m,F,D,_,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function y(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof D.URI)}e.isConfigurationOverrides=y;var C;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function k(s,r){const i=r?s?r.keys.filter(P=>s.keys.indexOf(P)===-1):[...r.keys]:[],c=s?r?s.keys.filter(P=>r.keys.indexOf(P)===-1):[...s.keys]:[],g=[];if(r&&s){for(const P of s.keys)if(r.keys.indexOf(P)!==-1){const L=E(s.contents,P),$=E(r.contents,P);m.equals(L,$)||g.push(P)}}const v=[],A=P=>{const L={};for(const $ of P)for(const re of $.identifiers)L[b(re)]=$;return L},R=r?A(r.overrides):{},o=s?A(s.overrides):{};if(Object.keys(R).length)for(const P of i){const L=R[P];L&&v.push([(0,S.overrideIdentifierFromKey)(P),L.keys])}if(Object.keys(o).length)for(const P of c){const L=o[P];L&&v.push([(0,S.overrideIdentifierFromKey)(P),L.keys])}if(Object.keys(R).length&&Object.keys(o).length)for(const P of g){const L=o[P],$=R[P];if(L&&$){const re=k({contents:L.contents,keys:L.keys,overrides:[]},{contents:$.contents,keys:$.keys,overrides:[]});v.push([(0,S.overrideIdentifierFromKey)(P),[...re.added,...re.removed,...re.updated]])}}return{added:i,removed:c,updated:g,overrides:v}}e.compare=k;function l(s,r){const i=[];for(const c of Object.keys(s))if(S.OVERRIDE_PROPERTY_PATTERN.test(c)){const g={};for(const v in s[c])g[v]=s[c][v];i.push({identifiers:[(0,S.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(g),contents:h(g,r)})}return i}e.toOverrides=l;function h(s,r){const i=Object.create(null);for(let c in s)a(i,c,s[c],r);return i}e.toValuesTree=h;function a(s,r,i,c){const g=r.split("."),v=g.pop();let A=s;for(let R=0;R<g.length;R++){let o=g[R],P=A[o];switch(typeof P){case"undefined":P=A[o]=Object.create(null);break;case"object":break;default:c(`Ignoring ${r} as ${g.slice(0,R+1).join(".")} is ${JSON.stringify(P)}`);return}A=P}if(typeof A=="object"&&A!==null)try{A[v]=i}catch(R){c(`Ignoring ${r} as ${g.join(".")} is ${JSON.stringify(A)}`)}else c(`Ignoring ${r} as ${g.join(".")} is ${JSON.stringify(A)}`)}e.addToValueTree=a;function d(s,r){const i=r.split(".");f(s,i)}e.removeFromValueTree=d;function f(s,r){const i=r.shift();if(r.length===0){delete s[i];return}if(Object.keys(s).indexOf(i)!==-1){const c=s[i];typeof c=="object"&&!Array.isArray(c)&&(f(c,r),Object.keys(c).length===0&&delete s[i])}}function E(s,r,i){function c(A,R){let o=A;for(const P of R){if(typeof o!="object"||o===null)return;o=o[P]}return o}const g=r.split("."),v=c(s,g);return typeof v=="undefined"?i:v}e.getConfigurationValue=E;function w(s,r,i){Object.keys(r).forEach(c=>{c!=="__proto__"&&(c in s?F.isObject(s[c])&&F.isObject(r[c])?w(s[c],r[c],i):i&&(s[c]=r[c]):s[c]=r[c])})}e.merge=w;function u(){const s=_.Registry.as(S.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=u;function p(){const s=Object.create(null),r=_.Registry.as(S.Extensions.Configuration).getConfigurationProperties();for(let i in r){let c=r[i].default;a(s,i,c,g=>console.error(`Conflict in default settings: ${g}`))}return s}e.getDefaultValues=p;function b(s){return`[${s}]`}e.keyFromOverrideIdentifier=b;function t(s,r,i){const c=s.inspect(r),g=s.inspect(i);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:c.defaultValue}e.getMigratedSettingValue=t}),define(Ee[153],_e([0,1,108,22,17,10,24,2,62,91,31,7,3]),function(ee,e,m,F,D,_,I,S,y,C,n,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(t={},s=[],r=[]){this._contents=t,this._keys=s,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,C.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,s){const r=this.getContentsForOverrideIdentifer(s);return r?t?(0,C.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.keys;return[]}override(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let r={};for(const i of D.distinct([...Object.keys(this.contents),...Object.keys(s)])){let c=this.contents[i],g=s[i];g&&(typeof c=="object"&&typeof g=="object"?(c=I.deepClone(c),this.mergeContents(c,g)):c=g),r[i]=c}return new h(r,this.keys,this.overrides)}merge(...t){const s=I.deepClone(this.contents),r=I.deepClone(this.overrides),i=[...this.keys];for(const c of t){this.mergeContents(s,c.contents);for(const g of c.overrides){const[v]=r.filter(A=>D.equals(A.identifiers,g.identifiers));v?this.mergeContents(v.contents,g.contents):r.push(I.deepClone(g))}for(const g of c.keys)i.indexOf(g)===-1&&i.push(g)}return new h(s,i,r)}freeze(){return this.isFrozen=!0,this}mergeContents(t,s){for(const r of Object.keys(s)){if(r in t&&_.isObject(t[r])&&_.isObject(s[r])){this.mergeContents(t[r],s[r]);continue}t[r]=I.deepClone(s[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?I.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,s){this.addKey(t),(0,C.addToValueTree)(this.contents,t,s,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,C.removeFromValueTree)(this.contents,t)}addKey(t){let s=this.keys.length;for(let r=0;r<s;r++)t.indexOf(this.keys[r])===0&&(s=r);this.keys.splice(s,1,t)}removeKey(t){let s=this.keys.indexOf(t);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=h;class a extends h{constructor(){const t=(0,C.getDefaultValues)(),s=(0,C.getConfigurationKeys)(),r=[];for(const i of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(i)&&r.push({identifiers:[(0,y.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,C.toValuesTree)(t[i],c=>console.error(`Conflict in default settings file: ${c}`))});super(t,s,r)}}e.DefaultConfigurationModel=a;class d{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!_.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:r,keys:i,overrides:c,restricted:g}=this.doParseRaw(t,s);this._configurationModel=new h(r,i,c),this._restrictedConfigurations=g||[]}doParseContent(t){let s={},r=null,i=[],c=[],g=[];function v(R){Array.isArray(i)?i.push(R):r&&(i[r]=R)}let A={onObjectBegin:()=>{let R={};v(R),c.push(i),i=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{i=c.pop()},onArrayBegin:()=>{let R=[];v(R),c.push(i),i=R,r=null},onArrayEnd:()=>{i=c.pop()},onLiteralValue:v,onError:(R,o,P)=>{g.push({error:R,offset:o,length:P})}};if(t)try{m.visit(t,A),s=i[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return s}doParseRaw(t,s){const r=n.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,r,!0,s);t=i.raw;const c=(0,C.toValuesTree)(t,A=>console.error(`Conflict in settings file ${this._name}: ${A}`)),g=Object.keys(t),v=(0,C.toOverrides)(t,A=>console.error(`Conflict in settings file ${this._name}: ${A}`));return{contents:c,keys:g,overrides:v,restricted:i.restricted}}filter(t,s,r,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:t,restricted:[]};const c={},g=[];for(let v in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(v)&&r){const A=this.filter(t[v],s,!1,i);c[v]=A.raw,g.push(...A.restricted)}else{const A=s[v],R=A?typeof A.scope!="undefined"?A.scope:3:void 0;A?.restricted&&g.push(v),(R===void 0||i.scopes===void 0||i.scopes.includes(R))&&(i.skipRestricted&&A?.restricted||(c[v]=t[v]))}return{raw:c,restricted:g}}}e.ConfigurationModelParser=d;class f extends k.Disposable{constructor(t,s,r,i){super();this.userSettingsResource=t,this.scopes=s,this.fileService=i,this._onDidChange=this._register(new l.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(l.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=f;class E{constructor(t,s,r=new h,i=new h,c=new F.ResourceMap,g=new h,v=new F.ResourceMap,A=!0){this._defaultConfiguration=t,this._localUserConfiguration=s,this._remoteUserConfiguration=r,this._workspaceConfiguration=i,this._folderConfigurations=c,this._memoryConfiguration=g,this._memoryConfigurationByResource=v,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new F.ResourceMap,this._userConfiguration=null}getValue(t,s,r){return this.getConsolidateConfigurationModel(s,r).getValue(t)}updateValue(t,s,r={}){let i;r.resource?(i=this._memoryConfigurationByResource.get(r.resource),i||(i=new h,this._memoryConfigurationByResource.set(r.resource,i))):i=this._memoryConfiguration,s===void 0?i.removeValue(t):i.setValue(t,s),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,r){const i=this.getConsolidateConfigurationModel(s,r),c=this.getFolderConfigurationModelForResource(s.resource,r),g=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,v=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),A=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),R=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),o=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),P=r?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,L=c?s.overrideIdentifier?c.freeze().override(s.overrideIdentifier).getValue(t):c.freeze().getValue(t):void 0,$=s.overrideIdentifier?g.override(s.overrideIdentifier).getValue(t):g.getValue(t),re=i.getValue(t),he=D.distinct(D.flatten(i.overrides.map(Q=>Q.identifiers))).filter(Q=>i.getOverrideValue(t,Q)!==void 0);return{defaultValue:v,userValue:A,userLocalValue:R,userRemoteValue:o,workspaceValue:P,workspaceFolderValue:L,memoryValue:$,value:re,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userRemote:o!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspace:P!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:c?.freeze().getValue(t),override:s.overrideIdentifier?c?.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:g.getValue(t),override:s.overrideIdentifier?g.getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:he.length?he:void 0}}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const r=s.filter(i=>y.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const c=(0,y.overrideIdentifierFromKey)(i),g=this._defaultConfiguration.getKeysForOverrideIdentifier(c),v=t.getKeysForOverrideIdentifier(c),A=[...v.filter(R=>g.indexOf(R)===-1),...g.filter(R=>v.indexOf(R)===-1),...g.filter(R=>!I.equals(this._defaultConfiguration.override(c).getValue(R),t.override(c).getValue(R)))];return[c,A]});return this.updateDefaultConfiguration(t),{keys:s,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:r,removed:i,overrides:c}=(0,C.compare)(this.localUserConfiguration,t),g=[...s,...r,...i];return g.length&&this.updateLocalUserConfiguration(t),{keys:g,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:r,removed:i,overrides:c}=(0,C.compare)(this.remoteUserConfiguration,t);let g=[...s,...r,...i];return g.length&&this.updateRemoteUserConfiguration(t),{keys:g,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:r,removed:i,overrides:c}=(0,C.compare)(this.workspaceConfiguration,t);let g=[...s,...r,...i];return g.length&&this.updateWorkspaceConfiguration(t),{keys:g,overrides:c}}compareAndUpdateFolderConfiguration(t,s){const r=this.folderConfigurations.get(t),{added:i,updated:c,removed:g,overrides:v}=(0,C.compare)(r,s);let A=[...i,...c,...g];return(A.length||!r)&&this.updateFolderConfiguration(t,s),{keys:A,overrides:v}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:i,removed:c,overrides:g}=(0,C.compare)(s,void 0);return{keys:[...r,...i,...c],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,s){let r=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},s){let r=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const i=s.getFolder(t);i&&(r=this.getFolderConsolidatedConfiguration(i.uri)||r);const c=this._memoryConfigurationByResource.get(t);c&&(r=r.merge(c))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const r=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(s=r.merge(i),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(t,s)):s=r}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const r=s.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:r,overrides:i,keys:c}=this._folderConfigurations.get(s);return t.push([s,{contents:r,overrides:i,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>t.add(s)),this.userConfiguration.freeze().keys.forEach(s=>t.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(i=>s.add(i))),[...s.values()]}static parse(t){const s=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),c=t.folders.reduce((g,v)=>(g.set(S.URI.revive(v[0]),this.parseConfigurationModel(v[1])),g),new F.ResourceMap);return new E(s,r,new h,i,c,new h,new F.ResourceMap,!1)}static parseConfigurationModel(t){return new h(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=E;function w(...b){if(b.length===0)return{keys:[],overrides:[]};if(b.length===1)return b[0];const t=new Set,s=new Map;for(const i of b)i.keys.forEach(c=>t.add(c)),i.overrides.forEach(([c,g])=>{const v=(0,F.getOrSet)(s,c,new Set);g.forEach(A=>v.add(A))});const r=[];return s.forEach((i,c)=>r.push([c,[...i.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=w;class u{constructor(t,s,r,i){this.change=t,this.previous=s,this.currentConfiguraiton=r,this.currentWorkspace=i,this._previousConfiguration=void 0;const c=new Set;t.keys.forEach(v=>c.add(v)),t.overrides.forEach(([,v])=>v.forEach(A=>c.add(A))),this.affectedKeys=[...c.values()];const g=new h;this.affectedKeys.forEach(v=>g.setValue(v,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(s){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!I.equals(r,i)}return!0}return!1}doesAffectedKeysTreeContains(t,s){let r=(0,C.toValuesTree)({[s]:!0},()=>{}),i;for(;typeof r=="object"&&(i=Object.keys(r)[0]);){if(t=t[i],!t)return!1;r=r[i]}return!0}}e.ConfigurationChangeEvent=u;class p extends u{constructor(t,s,r,i){super({keys:t.allKeys(),overrides:[]},void 0,t,s);this.source=r,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=p}),define(Ee[92],_e([0,1,4]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var F;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(F=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(I,S=F.Unknown,y){super(I);this._message=I,this._code=S,this._detail=y,this.isHandled=S===F.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(I){return I instanceof D&&I._code===F.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof D&&I._code===F.NoResolverFound}static isHandled(I){return I instanceof D&&I.isHandled}}e.RemoteAuthorityResolverError=D}),define(Ee[93],_e([0,1,11]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function F(C){return C.scheme===m.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=F;function D(C){if(!C)return;const n=C.indexOf("+");return n<0?C:C.substr(0,n)}e.getRemoteName=D;function _(C){return C.scheme!==m.Schemas.file&&C.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=_;function I(C){if(C.folders.length)return C.folders.every(n=>_(n.uri))?C.folders[0].uri:void 0;if(C.configuration&&_(C.configuration))return C.configuration}e.getVirtualWorkspaceLocation=I;function S(C){return I(C)?.scheme}e.getVirtualWorkspaceScheme=S;function y(C){return I(C)!==void 0}e.isVirtualWorkspace=y}),define(Ee[154],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class m{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,_,I=5){let S;return S=_(y=>{const C=typeof y=="string"?y:y.data;let n=this._terminalBufferMap.get(D);if(n){n.data.push(C);return}const k=setTimeout(()=>this.flushBuffer(D),I);n={data:[C],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(D),S.dispose()}},this._terminalBufferMap.set(D,n)}),S}stopBuffering(D){const _=this._terminalBufferMap.get(D);_&&_.dispose()}flushBuffer(D){const _=this._terminalBufferMap.get(D);_&&(this._terminalBufferMap.delete(D),this._callback(D,_.data.join("")))}}e.TerminalDataBufferer=m}),define(Ee[155],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(F){F.DARK="dark",F.LIGHT="light",F.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(Ee[156],_e([0,1,4,7,31,3,155,53]),function(ee,e,m,F,D,_,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,m.createDecorator)("themeService");var y;(function(f){function E(w){return w&&typeof w=="object"&&typeof w.id=="string"}f.isThemeColor=E})(y=e.ThemeColor||(e.ThemeColor={}));function C(f){return{id:f}}e.themeColorFromId=C;var n;(function(f){function E(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||y.isThemeColor(s.color))}f.isThemeIcon=E;const w=new RegExp(`^\\$\\((${S.CSSIcon.iconNameExpression}(?:${S.CSSIcon.iconModifierExpression})?)\\)$`);function u(s){const r=w.exec(s);if(!r)return;let[,i]=r;return{id:i}}f.fromString=u;function p(s,r){let i=s.id;const c=i.lastIndexOf("~");return c!==-1&&(i=i.substring(0,c)),r&&(i=`${i}~${r}`),{id:i}}f.modify=p;function b(s,r){return s.id===r.id&&s.color?.id===r.color?.id}f.isEqual=b;function t(s,r){return{id:s.id,color:r?C(r):void 0}}f.asThemeIcon=t,f.asClassNameArray=S.CSSIcon.asClassNameArray,f.asClassName=S.CSSIcon.asClassName,f.asCSSSelector=S.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=S.Codicon.file,e.FolderThemeIcon=S.Codicon.folder;function k(f){switch(f){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class l{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new _.Emitter}onColorThemeChange(E){return this.themingParticipants.push(E),this.onThemingParticipantAddedEmitter.fire(E),(0,F.toDisposable)(()=>{const w=this.themingParticipants.indexOf(E);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let h=new l;D.Registry.add(e.Extensions.ThemingContribution,h);function a(f){return h.onColorThemeChange(f)}e.registerThemingParticipant=a;class d extends F.Disposable{constructor(E){super();this.themeService=E,this.theme=E.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(E){this.theme=E,this.updateStyles()}updateStyles(){}getColor(E,w){let u=this.theme.getColor(E);return u&&w&&(u=w(u,this.theme)),u?u.toString():null}}e.Themable=d}),define(Ee[44],_e([0,1,2,25,4,22]),function(ee,e,m,F,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");var I;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(I=e.WorkbenchState||(e.WorkbenchState={}));function S(l){const h=l;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=S;function y(l){const h=l;return!!(h&&typeof h=="object"&&m.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=y;class C{constructor(h,a,d,f){this._id=h,this._configuration=d,this._ignorePathCasing=f,this._foldersMap=_.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(h){this._id=h.id,this._configuration=h.configuration,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=_.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=C;class n{constructor(h,a){this.raw=a,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,F.joinPath)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function k(l){return new n({uri:l,index:0,name:(0,F.basenameOrAuthority)(l)},{uri:l.toString()})}e.toWorkspaceFolder=k}),define(Ee[63],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class m{constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const _=this._idPool++;return this._data.set(_,D),this.logDebugInfo(),_}get(D,_){return this._data.has(D)?this._data.get(D)[_]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){!m.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=m,m.enableDebugLogging=!1}),define(Ee[64],_e([0,1,2,3,4]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,D.createDecorator)("IExtHostEditorTabs");class _{constructor(){this._onDidChangeTabs=new F.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(S){this._tabs=S.map(y=>({name:y.name,group:y.group,resource:m.URI.revive(y.resource),isActive:y.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=_}),define(Ee[45],_e([0,1,11,4]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class D{constructor(){this._systemSchemes=new Set(Object.keys(m.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(I,S){S===null?this._providerInfo.delete(I):this._providerInfo.set(I,S)}isFreeScheme(I){return!this._providerInfo.has(I)&&!this._systemSchemes.has(I)}getCapabilities(I){return this._providerInfo.get(I)}}e.ExtHostFileSystemInfo=D,e.IExtHostFileSystemInfo=(0,F.createDecorator)("IExtHostFileSystemInfo")}),define(Ee[28],_e([0,1,4]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,m.createDecorator)("IExtHostInitDataService")}),define(Ee[157],_e([0,1,2]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class F{constructor(_,I,S){this._extHostNotebooks=I,this._textDocumentsAndEditors=S}$willAddInteractiveDocument(_,I,S,y){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:I,lines:[""],modeId:S,uri:_,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(m.URI.revive(y))?.apiNotebook}]})}$willRemoveInteractiveDocument(_,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[_]})}}e.ExtHostInteractive=F}),define(Ee[158],_e([0,1,16]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class F{constructor(I,S,y){this._deferredPromises=new Map,this._id=I,this._shared=S,this._storage=y,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(C=>(this._value=C,this)),this._storageListener=this._storage.onDidChangeStorage(C=>{C.shared===this._shared&&C.key===this._id&&(this._value=C.value)}),this._scheduler=new m.RunOnceScheduler(()=>{const C=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of C.values())n.complete()}catch(n){for(const k of C.values())k.error(n)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,I])=>I!==void 0).map(([I])=>I)}get whenReady(){return this._init}get(I,S){let y=this._value[I];return typeof y=="undefined"&&(y=S),y}update(I,S){this._value[I]=S;let y=this._deferredPromises.get(I);if(y!==void 0)return y.p;const C=new m.DeferredPromise;return this._deferredPromises.set(I,C),this._scheduler.isScheduled()||this._scheduler.schedule(),C.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=F;class D extends F{constructor(I,S){super(I.identifier.value,!0,S);this._extension=I}setKeysForSync(I){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},I)}}e.ExtensionGlobalMemento=D}),define(Ee[159],_e([0,1,3,2,15]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let _=class{constructor(S,y){this._logService=S,this._notebooksAndEditors=y,this._onDidChangeNotebookDocumentMetadata=new m.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new m.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(S,y,C){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(S)).acceptModelChanged(y,C)}$acceptDirtyStateChanged(S,y){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(S)).acceptDirty(y)}$acceptModelSaved(S){const y=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(S));this._onDidSaveNotebookDocument.fire(y.apiNotebook)}$acceptDocumentPropertiesChanged(S,y){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",S.path,y);const C=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(S));C.acceptDocumentPropertiesChanged(y),y.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:C.apiNotebook})}};_=ze([qe(0,D.ILogService)],_),e.ExtHostNotebookDocuments=_}),define(Ee[13],_e([0,1,4]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,m.createDecorator)("IExtHostRpcService");class F{constructor(_){this.getProxy=_.getProxy.bind(_),this.set=_.set.bind(_),this.assertRegistered=_.assertRegistered.bind(_),this.drain=_.drain.bind(_)}}e.ExtHostRpcService=F});var nt=this&&this.__classPrivateFieldSet||function(ee,e,m,F,D){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?D.call(ee,m):D?D.value=m:e.set(ee,m),m},Oe=this&&this.__classPrivateFieldGet||function(ee,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(ee):F?F.value:e.get(ee)};define(Ee[160],_e([0,1,26,3]),function(ee,e,m,F){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class _{constructor(S,y){D.set(this,void 0),this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._id=m.ExtensionIdentifier.toKey(S.identifier),nt(this,D,y,"f"),Oe(this,D,"f").onDidChangePassword(C=>{C.extensionId===this._id&&this._onDidChange.fire({key:C.key})})}get(S){return Oe(this,D,"f").get(this._id,S)}store(S,y){return Oe(this,D,"f").store(this._id,S,y)}delete(S){return Oe(this,D,"f").delete(this._id,S)}}e.ExtensionSecrets=_,D=new WeakMap}),define(Ee[94],_e([0,1,4,3]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class D{constructor(){this._onDidChangeTelemetryEnabled=new F.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(I){this._enabled=I}$onDidChangeTelemetryEnabled(I){this._enabled=I,this._onDidChangeTelemetryEnabled.fire(I)}}e.ExtHostTelemetry=D,e.IExtHostTelemetry=(0,m.createDecorator)("IExtHostTelemetry")}),define(Ee[65],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemImpl=e.createTestItemCollection=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var m;(function(d){d[d.Upsert=0]="Upsert",d[d.RemoveChild=1]="RemoveChild",d[d.Invalidated=2]="Invalidated",d[d.SetProp=3]="SetProp",d[d.Bulk=4]="Bulk"})(m=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const F=new WeakMap,D=d=>{let f=F.get(d);return f||(f={},F.set(d,f)),f};e.getPrivateApiFor=D;const _=(d,f,E,w)=>{let u=E;return{enumerable:!0,configurable:!1,get(){return u},set(p){w(u,p)||(u=p,d.listener?.({op:3,key:f,value:p}))}}},I=(d,f)=>d===f,S={range:(d,f)=>d===f?!0:!d||!f?!1:d.isEqual(f),label:I,description:I,busy:I,error:I,canResolveChildren:I},y=Object.keys(S),C=(d,f)=>({range:_(d,"range",void 0,S.range),label:_(d,"label",f,S.label),description:_(d,"description",void 0,S.description),canResolveChildren:_(d,"canResolveChildren",!1,S.canResolveChildren),busy:_(d,"busy",!1,S.busy),error:_(d,"error",void 0,S.error)}),n=(d,f)=>{const E=new Map;for(const w of y)S[w](d[w],f[w])||E.set(w,f[w]);return E};e.diffTestItems=n;class k extends Error{constructor(f){super(`Attempted to insert a duplicate test item ID ${f}`)}}e.DuplicateTestItemError=k;class l extends Error{constructor(f){super(`TestItem with ID "${f}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=l;const h=d=>{const f=(0,e.getPrivateApiFor)(d);let E,w=new Map;return{get all(){return E||(E=Object.freeze([...w.values()])),E},set all(u){const p=new Map,b=new Set(w.keys()),t={op:4,ops:[]};for(const s of u){if(!(s instanceof a))throw new l(s.id);if(p.has(s.id))throw new k(s.id);p.set(s.id,s),b.delete(s.id),t.ops.push({op:0,item:s})}for(const s of b.keys())t.ops.push({op:1,id:s});f.listener?.(t),w=p,E=void 0},add(u){if(!(u instanceof a))throw new l(u.id);w.set(u.id,u),E=void 0,f.listener?.({op:0,item:u})},remove(u){w.delete(u)&&(E=void 0,f.listener?.({op:1,id:u}))},get(u){return w.get(u)},toJSON(){return this.all}}};e.createTestItemCollection=h;class a{constructor(f,E,w){const u=(0,e.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:f,enumerable:!0,writable:!1},uri:{value:w,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return u.parent}},children:{value:(0,e.createTestItemCollection)(this),enumerable:!0,writable:!1},...C(u,E)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=a}),define(Ee[66],_e([0,1,4,3,13]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var _;(function(S){function y(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,protocol:n.protocol}}S.fromApiTunnel=y;function C(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public,protocol:n.protocol}}S.fromServiceTunnel=C})(_=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,m.createDecorator)("IExtHostTunnelService");let I=class{constructor(y){this.onDidChangeTunnels=new F.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,C){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,C){return{dispose:()=>{}}}async $providePortAttributes(y,C,n,k,l){return[]}async $forwardPort(y,C){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};I=ze([qe(0,D.IExtHostRpcService)],I),e.ExtHostTunnelService=I});var nt=this&&this.__classPrivateFieldSet||function(ee,e,m,F,D){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?D.call(ee,m):D?D.value=m:e.set(ee,m),m},Oe=this&&this.__classPrivateFieldGet||function(ee,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(ee):F?F.value:e.get(ee)};define(Ee[6],_e([0,1,17,12,81,22,83,10,2,35,60,92]),function(ee,e,m,F,D,_,I,S,y,C,n,k){"use strict";var l,h,a,d,f,E,w,u,p,b,t,s,r,i,c,g,v,A,R,o;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestMessage=e.TestRunRequest=e.TestRunConfigurationGroup=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function P(N){function M(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(M,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(M,N),Object.setPrototypeOf(M.prototype,N.prototype),M}let L=f=class{constructor(M){l.set(this,void 0),nt(this,l,M,"f")}static from(...M){let Z=M;return new f(function(){if(Z){for(const ke of Z)ke&&typeof ke.dispose=="function"&&ke.dispose();Z=void 0}})}dispose(){typeof Oe(this,l,"f")=="function"&&(Oe(this,l,"f").call(this),nt(this,l,void 0,"f"))}};l=new WeakMap,L=f=ze([P],L),e.Disposable=L;let $=E=class{constructor(M,Z){if(M<0)throw(0,F.illegalArgument)("line must be non-negative");if(Z<0)throw(0,F.illegalArgument)("character must be non-negative");this._line=M,this._character=Z}static Min(...M){if(M.length===0)throw new TypeError;let Z=M[0];for(let ke=1;ke<M.length;ke++){const Je=M[ke];Je.isBefore(Z)&&(Z=Je)}return Z}static Max(...M){if(M.length===0)throw new TypeError;let Z=M[0];for(let ke=1;ke<M.length;ke++){const Je=M[ke];Je.isAfter(Z)&&(Z=Je)}return Z}static isPosition(M){if(!M)return!1;if(M instanceof E)return!0;let{line:Z,character:ke}=M;return typeof Z=="number"&&typeof ke=="number"}get line(){return this._line}get character(){return this._character}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,Z=0){if(M===null||Z===null)throw(0,F.illegalArgument)();let ke;return typeof M=="undefined"?ke=0:typeof M=="number"?ke=M:(ke=typeof M.lineDelta=="number"?M.lineDelta:0,Z=typeof M.characterDelta=="number"?M.characterDelta:0),ke===0&&Z===0?this:new E(this.line+ke,this.character+Z)}with(M,Z=this.character){if(M===null||Z===null)throw(0,F.illegalArgument)();let ke;return typeof M=="undefined"?ke=this.line:typeof M=="number"?ke=M:(ke=typeof M.line=="number"?M.line:this.line,Z=typeof M.character=="number"?M.character:this.character),ke===this.line&&Z===this.character?this:new E(ke,Z)}toJSON(){return{line:this.line,character:this.character}}};$=E=ze([P],$),e.Position=$;let re=w=class{constructor(M,Z,ke,Je){let it,rt;if(typeof M=="number"&&typeof Z=="number"&&typeof ke=="number"&&typeof Je=="number"?(it=new $(M,Z),rt=new $(ke,Je)):M instanceof $&&Z instanceof $&&(it=M,rt=Z),!it||!rt)throw new Error("Invalid arguments");it.isBefore(rt)?(this._start=it,this._end=rt):(this._start=rt,this._end=it)}static isRange(M){return M instanceof w?!0:M?$.isPosition(M.start)&&$.isPosition(M.end):!1}get start(){return this._start}get end(){return this._end}contains(M){return M instanceof w?this.contains(M._start)&&this.contains(M._end):M instanceof $?!(M.isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const Z=$.Max(M.start,this._start),ke=$.Min(M.end,this._end);if(!Z.isAfter(ke))return new w(Z,ke)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const Z=$.Min(M.start,this._start),ke=$.Max(M.end,this.end);return new w(Z,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,Z=this.end){if(M===null||Z===null)throw(0,F.illegalArgument)();let ke;return M?$.isPosition(M)?ke=M:(ke=M.start||this.start,Z=M.end||this.end):ke=this.start,ke.isEqual(this._start)&&Z.isEqual(this.end)?this:new w(ke,Z)}toJSON(){return[this.start,this.end]}};re=w=ze([P],re),e.Range=re;let he=u=class extends re{constructor(M,Z,ke,Je){let it,rt;if(typeof M=="number"&&typeof Z=="number"&&typeof ke=="number"&&typeof Je=="number"?(it=new $(M,Z),rt=new $(ke,Je)):M instanceof $&&Z instanceof $&&(it=M,rt=Z),!it||!rt)throw new Error("Invalid arguments");super(it,rt);this._anchor=it,this._active=rt}static isSelection(M){return M instanceof u?!0:M?re.isRange(M)&&$.isPosition(M.anchor)&&$.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};he=u=ze([P],he),e.Selection=he;class Q{constructor(M,Z,ke){if(typeof M!="string"||M.length===0)throw(0,F.illegalArgument)("host");if(typeof Z!="number"||Z===0||Math.round(Z)!==Z)throw(0,F.illegalArgument)("port");if(typeof ke!="undefined"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw(0,F.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(Z),this.connectionToken=ke}}e.ResolvedAuthority=Q;class z extends Error{constructor(M,Z=k.RemoteAuthorityResolverErrorCode.Unknown,ke){super(M);this._message=M,this._code=Z,this._detail=ke,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,z.prototype)}static NotAvailable(M,Z){return new z(M,k.RemoteAuthorityResolverErrorCode.NotAvailable,Z)}static TemporarilyNotAvailable(M){return new z(M,k.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=z;var V;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(V=e.EndOfLine||(e.EndOfLine={}));var T;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(T=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let G=p=class{constructor(M,Z){this._range=M,this._newText=Z}static isTextEdit(M){return M instanceof p?!0:M?re.isRange(M)&&typeof M.newText=="string":!1}static replace(M,Z){return new p(M,Z)}static insert(M,Z){return p.replace(new re(M,M),Z)}static delete(M){return p.replace(M,"")}static setEndOfLine(M){const Z=new p(new re(new $(0,0),new $(0,0)),"");return Z.newEol=M,Z}get range(){return this._range}set range(M){if(M&&!re.isRange(M))throw(0,F.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,F.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,F.illegalArgument)("newEol");this._newEol=M}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};G=p=ze([P],G),e.TextEdit=G;var B;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(B=e.FileEditType||(e.FileEditType={}));let j=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,Z,ke,Je){this._edits.push({_type:1,from:M,to:Z,options:ke,metadata:Je})}createFile(M,Z,ke){this._edits.push({_type:1,from:void 0,to:M,options:Z,metadata:ke})}deleteFile(M,Z,ke){this._edits.push({_type:1,from:M,to:void 0,options:Z,metadata:ke})}replaceNotebookMetadata(M,Z,ke){this._edits.push({_type:3,metadata:ke,uri:M,edit:{editType:5,metadata:Z},notebookMetadata:Z})}replaceNotebookCells(M,Z,ke,Je,it){let rt,ot,yt=[],It;if(Bt.isNotebookRange(Z)&&Lt.isNotebookCellDataArray(ke)&&!Lt.isNotebookCellDataArray(Je)?(rt=Z.start,ot=Z.end,yt=ke,It=Je):typeof Z=="number"&&typeof ke=="number"&&Lt.isNotebookCellDataArray(Je)&&(rt=Z,ot=ke,yt=Je,It=it),rt===void 0||ot===void 0)throw new Error("Invalid arguments");(rt!==ot||yt.length>0)&&this._edits.push({_type:5,uri:M,index:rt,count:ot-rt,cells:yt,metadata:It})}replaceNotebookCellMetadata(M,Z,ke,Je){this._edits.push({_type:3,metadata:Je,uri:M,edit:{editType:8,index:Z,metadata:ke}})}replace(M,Z,ke,Je){this._edits.push({_type:2,uri:M,edit:new G(Z,ke),metadata:Je})}insert(M,Z,ke,Je){this.replace(M,new re(Z,Z),ke,Je)}delete(M,Z,ke){this.replace(M,Z,"",ke)}has(M){return this._edits.some(Z=>Z._type===2&&Z.uri.toString()===M.toString())}set(M,Z){if(Z)for(const ke of Z)ke&&this._edits.push({_type:2,uri:M,edit:ke});else{for(let ke=0;ke<this._edits.length;ke++){const Je=this._edits[ke];Je._type===2&&Je.uri.toString()===M.toString()&&(this._edits[ke]=void 0)}(0,m.coalesceInPlace)(this._edits)}}get(M){const Z=[];for(let ke of this._edits)ke._type===2&&ke.uri.toString()===M.toString()&&Z.push(ke.edit);return Z}entries(){const M=new _.ResourceMap;for(let Z of this._edits)if(Z._type===2){let ke=M.get(Z.uri);ke||(ke=[Z.uri,[]],M.set(Z.uri,ke)),ke[1].push(Z.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};j=ze([P],j),e.WorkspaceEdit=j;let ce=b=class{constructor(M){this._tabstop=1,this.value=M||""}static isSnippetString(M){return M instanceof b?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}appendText(M){return this.value+=b._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,Z=this._tabstop++){if(typeof M=="function"){const ke=new b;ke._tabstop=this._tabstop,M(ke),this._tabstop=ke._tabstop,M=ke.value}else M=b._escape(M);return this.value+="${",this.value+=Z,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,Z=this._tabstop++){const ke=M.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=Z,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(M,Z){if(typeof Z=="function"){const ke=new b;ke._tabstop=this._tabstop,Z(ke),this._tabstop=ke._tabstop,Z=ke.value}else typeof Z=="string"&&(Z=Z.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,Z&&(this.value+=":",this.value+=Z),this.value+="}",this}};ce=b=ze([P],ce),e.SnippetString=ce;var W;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(W=e.DiagnosticTag||(e.DiagnosticTag={}));var te;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(te=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ue=t=class{constructor(M,Z){if(this.uri=M,Z)if(Z instanceof re)this.range=Z;else if(Z instanceof $)this.range=new re(Z,Z);else throw new Error("Illegal argument")}static isLocation(M){return M instanceof t?!0:M?re.isRange(M.range)&&y.URI.isUri(M.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ue=t=ze([P],ue),e.Location=ue;let ye=class{constructor(M,Z){this.location=M,this.message=Z}static is(M){return M?typeof M.message=="string"&&M.location&&re.isRange(M.location.range)&&y.URI.isUri(M.location.uri):!1}static isEqual(M,Z){return M===Z?!0:!M||!Z?!1:M.message===Z.message&&M.location.range.isEqual(Z.location.range)&&M.location.uri.toString()===Z.location.uri.toString()}};ye=ze([P],ye),e.DiagnosticRelatedInformation=ye;let Te=class{constructor(M,Z,ke=te.Error){if(!re.isRange(M))throw new TypeError("range must be set");if(!Z)throw new TypeError("message must be set");this.range=M,this.message=Z,this.severity=ke}toJSON(){return{severity:te[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,Z){return M===Z?!0:!M||!Z?!1:M.message===Z.message&&M.severity===Z.severity&&M.code===Z.code&&M.severity===Z.severity&&M.source===Z.source&&M.range.isEqual(Z.range)&&(0,m.equals)(M.tags,Z.tags)&&(0,m.equals)(M.relatedInformation,Z.relatedInformation,ye.isEqual)}};Te=ze([P],Te),e.Diagnostic=Te;let Re=class{constructor(M,Z){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=Z}};Re=ze([P],Re),e.Hover=Re;var $e;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})($e=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ze=class{constructor(M,Z=$e.Text){this.range=M,this.kind=Z}toJSON(){return{range:this.range,kind:$e[this.kind]}}};Ze=ze([P],Ze),e.DocumentHighlight=Ze;var Ve;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(Ve=e.SymbolKind||(e.SymbolKind={}));var je;(function(N){N[N.Deprecated=1]="Deprecated"})(je=e.SymbolTag||(e.SymbolTag={}));let O=s=class{constructor(M,Z,ke,Je,it){this.name=M,this.kind=Z,this.containerName=it,typeof ke=="string"&&(this.containerName=ke),Je instanceof ue?this.location=Je:ke instanceof re&&(this.location=new ue(Je,ke)),s.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ve[this.kind],location:this.location,containerName:this.containerName}}};O=s=ze([P],O),e.SymbolInformation=O;let K=r=class{constructor(M,Z,ke,Je,it){this.name=M,this.detail=Z,this.kind=ke,this.range=Je,this.selectionRange=it,this.children=[],r.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children&&M.children.forEach(r.validate)}};K=r=ze([P],K),e.DocumentSymbol=K;var J;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(J=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let se=class{constructor(M,Z){this.title=M,this.kind=Z}};se=ze([P],se),e.CodeAction=se;let q=i=class{constructor(M){this.value=M}append(M){return new i(this.value?this.value+i.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+i.sep)}};q.sep=".",q=i=ze([P],q),e.CodeActionKind=q,q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll");let ne=class{constructor(M,Z){if(this.range=M,this.parent=Z,Z&&!Z.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ne=ze([P],ne),e.SelectionRange=ne;class ge{constructor(M,Z,ke,Je,it,rt){this.kind=M,this.name=Z,this.detail=ke,this.uri=Je,this.range=it,this.selectionRange=rt}}e.CallHierarchyItem=ge;class Me{constructor(M,Z){this.fromRanges=Z,this.from=M}}e.CallHierarchyIncomingCall=Me;class We{constructor(M,Z){this.fromRanges=Z,this.to=M}}e.CallHierarchyOutgoingCall=We;let be=class{constructor(M,Z){this.range=M,this.command=Z}get isResolved(){return!!this.command}};be=ze([P],be),e.CodeLens=be;let Xe=c=class{constructor(M,Z=!1){h.set(this,void 0),nt(this,h,new D.MarkdownString(M,{supportThemeIcons:Z}),"f")}static isMarkdownString(M){return M instanceof c?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}get value(){return Oe(this,h,"f").value}set value(M){Oe(this,h,"f").value=M}get isTrusted(){return Oe(this,h,"f").isTrusted}set isTrusted(M){Oe(this,h,"f").isTrusted=M}get supportThemeIcons(){return Oe(this,h,"f").supportThemeIcons}set supportThemeIcons(M){Oe(this,h,"f").supportThemeIcons=M}appendText(M){return Oe(this,h,"f").appendText(M),this}appendMarkdown(M){return Oe(this,h,"f").appendMarkdown(M),this}appendCodeblock(M,Z){return Oe(this,h,"f").appendCodeblock(Z??"",M),this}};h=new WeakMap,Xe=c=ze([P],Xe),e.MarkdownString=Xe;let H=class{constructor(M,Z){this.label=M,this.documentation=Z}};H=ze([P],H),e.ParameterInformation=H;let X=class{constructor(M,Z){this.label=M,this.documentation=Z,this.parameters=[]}};X=ze([P],X),e.SignatureInformation=X;let de=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};de=ze([P],de),e.SignatureHelp=de;var Be;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(Be=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ue;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(Ue=e.InlayHintKind||(e.InlayHintKind={}));let tt=class{constructor(M,Z,ke){this.text=M,this.position=Z,this.kind=ke}};tt=ze([P],tt),e.InlayHint=tt;var Se;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Se=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var De;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(De=e.CompletionItemKind||(e.CompletionItemKind={}));var Pe;(function(N){N[N.Deprecated=1]="Deprecated"})(Pe=e.CompletionItemTag||(e.CompletionItemTag={}));let ie=class{constructor(M,Z){this.label=M,this.kind=Z}toJSON(){return{label:this.label,kind:this.kind&&De[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ie=ze([P],ie),e.CompletionItem=ie;let oe=class{constructor(M=[],Z=!1){this.items=M,this.isIncomplete=Z}};oe=ze([P],oe),e.CompletionList=oe;let fe=class{constructor(M,Z,ke){this.text=M,this.range=Z,this.command=ke}};fe=ze([P],fe),e.InlineSuggestion=fe;let ve=class{constructor(M){this.items=M}};ve=ze([P],ve),e.InlineSuggestions=ve;var x;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(x=e.ViewColumn||(e.ViewColumn={}));var me;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(me=e.StatusBarAlignment||(e.StatusBarAlignment={}));var we;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(we=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ie;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Ie=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ne;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Ne=e.TextEditorRevealType||(e.TextEditorRevealType={}));var He;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(He=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var et;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(et=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Ke;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(Ke=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function M(Z){switch(Z){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=M}(He=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Qe=class{constructor(M,Z){if(Z&&!y.URI.isUri(Z))throw(0,F.illegalArgument)("target");if(!re.isRange(M)||M.isEmpty)throw(0,F.illegalArgument)("range");this.range=M,this.target=Z}};Qe=ze([P],Qe),e.DocumentLink=Qe;let lt=class{constructor(M,Z,ke,Je){this.red=M,this.green=Z,this.blue=ke,this.alpha=Je}};lt=ze([P],lt),e.Color=lt;let dt=class{constructor(M,Z){if(Z&&!(Z instanceof lt))throw(0,F.illegalArgument)("color");if(!re.isRange(M)||M.isEmpty)throw(0,F.illegalArgument)("range");this.range=M,this.color=Z}};dt=ze([P],dt),e.ColorInformation=dt;let _t=class{constructor(M){if(!M||typeof M!="string")throw(0,F.illegalArgument)("label");this.label=M}};_t=ze([P],_t),e.ColorPresentation=_t;var at;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(at=e.ColorFormat||(e.ColorFormat={}));var pe;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(pe=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Ce{constructor(M,Z,ke){if(this.startIndex=M,this.length=Z,this.tooltip=ke,typeof M!="number"||M<0)throw(0,F.illegalArgument)("startIndex");if(typeof Z!="number"||Z<1)throw(0,F.illegalArgument)("length");if(ke!==void 0&&typeof ke!="string")throw(0,F.illegalArgument)("tooltip")}}e.TerminalLink=Ce;class le{constructor(M){this.options=M,typeof M!="object"&&(0,F.illegalArgument)("options")}}e.TerminalProfile=le;var U;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(U=e.TaskRevealKind||(e.TaskRevealKind={}));var Fe;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(Fe=e.TaskPanelKind||(e.TaskPanelKind={}));let xe=g=class{constructor(M,Z){if(typeof M!="string"||typeof Z!="string")throw(0,F.illegalArgument)("name");this._id=M}static from(M){switch(M){case"clean":return g.Clean;case"build":return g.Build;case"rebuild":return g.Rebuild;case"test":return g.Test;default:return}}get id(){return this._id}};xe.Clean=new g("clean","Clean"),xe.Build=new g("build","Build"),xe.Rebuild=new g("rebuild","Rebuild"),xe.Test=new g("test","Test"),xe=g=ze([P],xe),e.TaskGroup=xe;function Ye(N){let M="";for(let Z=0;Z<N.length;Z++)M+=N[Z].replace(/,/g,",,")+",";return M}let Ge=class{constructor(M,Z,ke){if(typeof M!="string")throw(0,F.illegalArgument)("process");this._args=[],this._process=M,Z!==void 0&&(Array.isArray(Z)?(this._args=Z,this._options=ke):this._options=Z)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,F.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(let Z of this._args)M.push(Z);return Ye(M)}};Ge=ze([P],Ge),e.ProcessExecution=Ge;let ut=class{constructor(M,Z,ke){if(this._args=[],Array.isArray(Z)){if(!M)throw(0,F.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,F.illegalArgument)("command");this._command=M,this._args=Z,this._options=ke}else{if(typeof M!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=M,this._options=Z}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,F.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let Z of this._args)M.push(typeof Z=="string"?Z:Z.value);return Ye(M)}};ut=ze([P],ut),e.ShellExecution=ut;var mt;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(mt=e.ShellQuoting||(e.ShellQuoting={}));var kt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(kt=e.TaskScope||(e.TaskScope={}));class St{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,C.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=St;let bt=v=class{constructor(M,Z,ke,Je,it,rt){this.__deprecated=!1,this._definition=this.definition=M;let ot;typeof Z=="string"?(this._name=this.name=Z,this._source=this.source=ke,this.execution=Je,ot=it,this.__deprecated=!0):Z===kt.Global||Z===kt.Workspace?(this.target=Z,this._name=this.name=ke,this._source=this.source=Je,this.execution=it,ot=rt):(this.target=Z,this._name=this.name=ke,this._source=this.source=Je,this.execution=it,ot=rt),typeof ot=="string"?(this._problemMatchers=[ot],this._hasDefinedMatchers=!0):Array.isArray(ot)?(this._problemMatchers=ot,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ge?this._definition={type:v.ProcessType,id:this._execution.computeId()}:this._execution instanceof ut?this._definition={type:v.ShellType,id:this._execution.computeId()}:this._execution instanceof St?this._definition={type:v.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:v.EmptyType,id:(0,C.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,F.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,F.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const Z=this._definition.type;(v.EmptyType===Z||v.ProcessType===Z||v.ShellType===Z||v.ExtensionCallbackType===Z)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,F.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};bt.ExtensionCallbackType="customExecution",bt.ProcessType="process",bt.ShellType="shell",bt.EmptyType="$empty",bt=v=ze([P],bt),e.Task=bt;var gt;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(gt=e.ProgressLocation||(e.ProgressLocation={}));let ht=class{constructor(M,Z=Et.None){this.collapsibleState=Z,y.URI.isUri(M)?this.resourceUri=M:this.label=M}};ht=ze([P],ht),e.TreeItem=ht;var Et;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(Et=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ft=class{constructor(M,Z){this.id=M,this.color=Z}};ft=ze([P],ft),e.ThemeIcon=ft,ft.File=new ft("file"),ft.Folder=new ft("folder");let Ot=class{constructor(M){this.id=M}};Ot=ze([P],Ot),e.ThemeColor=Ot;var Pt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(Pt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Kt=class{constructor(M,Z){if(typeof M!="string"&&(!M||!y.URI.isUri(M)&&!y.URI.isUri(M.uri)))throw(0,F.illegalArgument)("base");if(typeof Z!="string")throw(0,F.illegalArgument)("pattern");typeof M=="string"?(this.baseFolder=y.URI.file(M),this.base=M):y.URI.isUri(M)?(this.baseFolder=M,this.base=M.fsPath):(this.baseFolder=M.uri,this.base=M.uri.fsPath),this.pattern=Z}};Kt=ze([P],Kt),e.RelativePattern=Kt;let Ut=class{constructor(M,Z,ke,Je){this.enabled=typeof M=="boolean"?M:!0,typeof Z=="string"&&(this.condition=Z),typeof ke=="string"&&(this.hitCondition=ke),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this._id||(this._id=(0,C.generateUuid)()),this._id}};Ut=ze([P],Ut),e.Breakpoint=Ut;let Ct=class extends Ut{constructor(M,Z,ke,Je,it){super(Z,ke,Je,it);if(M===null)throw(0,F.illegalArgument)("location");this.location=M}};Ct=ze([P],Ct),e.SourceBreakpoint=Ct;let Qt=class extends Ut{constructor(M,Z,ke,Je,it){super(Z,ke,Je,it);this.functionName=M}};Qt=ze([P],Qt),e.FunctionBreakpoint=Qt;let Yt=class extends Ut{constructor(M,Z,ke,Je,it,rt,ot){super(Je,it,rt,ot);if(!Z)throw(0,F.illegalArgument)("dataId");this.label=M,this.dataId=Z,this.canPersist=ke}};Yt=ze([P],Yt),e.DataBreakpoint=Yt;let pt=class{constructor(M,Z,ke){this.command=M,this.args=Z||[],this.options=ke}};pt=ze([P],pt),e.DebugAdapterExecutable=pt;let qt=class{constructor(M,Z){this.port=M,this.host=Z}};qt=ze([P],qt),e.DebugAdapterServer=qt;let zt=class{constructor(M){this.path=M}};zt=ze([P],zt),e.DebugAdapterNamedPipeServer=zt;let Jt=class{constructor(M){this.implementation=M}};Jt=ze([P],Jt),e.DebugAdapterInlineImplementation=Jt;let Xt=class{constructor(M,Z){this.range=M,this.expression=Z}};Xt=ze([P],Xt),e.EvaluatableExpression=Xt;var At;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(At=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let jt=class{constructor(M,Z){this.range=M,this.text=Z}};jt=ze([P],jt),e.InlineValueText=jt;let Zt=class{constructor(M,Z,ke=!0){this.range=M,this.variableName=Z,this.caseSensitiveLookup=ke}};Zt=ze([P],Zt),e.InlineValueVariableLookup=Zt;let Ht=class{constructor(M,Z){this.range=M,this.expression=Z}};Ht=ze([P],Ht),e.InlineValueEvaluatableExpression=Ht;let ct=class{constructor(M,Z){this.frameId=M,this.stoppedLocation=Z}};ct=ze([P],ct),e.InlineValueContext=ct;var En;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(En=e.FileChangeType||(e.FileChangeType={}));let Rt=A=class extends Error{constructor(M,Z=n.FileSystemProviderErrorCode.Unknown,ke){super(y.URI.isUri(M)?M.toString(!0):M);this.code=ke?.name??"Unknown",(0,n.markAsFileSystemProviderError)(this,Z),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}static FileExists(M){return new A(M,n.FileSystemProviderErrorCode.FileExists,A.FileExists)}static FileNotFound(M){return new A(M,n.FileSystemProviderErrorCode.FileNotFound,A.FileNotFound)}static FileNotADirectory(M){return new A(M,n.FileSystemProviderErrorCode.FileNotADirectory,A.FileNotADirectory)}static FileIsADirectory(M){return new A(M,n.FileSystemProviderErrorCode.FileIsADirectory,A.FileIsADirectory)}static NoPermissions(M){return new A(M,n.FileSystemProviderErrorCode.NoPermissions,A.NoPermissions)}static Unavailable(M){return new A(M,n.FileSystemProviderErrorCode.Unavailable,A.Unavailable)}};Rt=A=ze([P],Rt),e.FileSystemError=Rt;let xt=class{constructor(M,Z,ke){this.start=M,this.end=Z,this.kind=ke}};xt=ze([P],xt),e.FoldingRange=xt;var cn;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(cn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var _n;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(_n=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var dn;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(dn=e.CommentMode||(e.CommentMode={}));class yn{constructor(M,Z=[]){this.tokenTypes=M,this.tokenModifiers=Z}}e.SemanticTokensLegend=yn;function hn(N){return typeof N=="undefined"||(0,S.isStringArray)(N)}class Vt{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let Z=0,ke=M.tokenTypes.length;Z<ke;Z++)this._tokenTypeStrToInt.set(M.tokenTypes[Z],Z);for(let Z=0,ke=M.tokenModifiers.length;Z<ke;Z++)this._tokenModifierStrToInt.set(M.tokenModifiers[Z],Z)}}push(M,Z,ke,Je,it){if(typeof M=="number"&&typeof Z=="number"&&typeof ke=="number"&&typeof Je=="number"&&(typeof it=="number"||typeof it=="undefined"))return typeof it=="undefined"&&(it=0),this._pushEncoded(M,Z,ke,Je,it);if(re.isRange(M)&&typeof Z=="string"&&hn(ke))return this._push(M,Z,ke);throw(0,F.illegalArgument)()}_push(M,Z,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(Z))throw new Error("`tokenType` is not in the provided legend");const Je=M.start.line,it=M.start.character,rt=M.end.character-M.start.character,ot=this._tokenTypeStrToInt.get(Z);let yt=0;if(ke)for(const It of ke){if(!this._tokenModifierStrToInt.has(It))throw new Error("`tokenModifier` is not in the provided legend");const Mt=this._tokenModifierStrToInt.get(It);yt|=1<<Mt>>>0}this._pushEncoded(Je,it,rt,ot,yt)}_pushEncoded(M,Z,ke,Je,it){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&Z<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let It=0,Mt=0;for(let Nt=0;Nt<yt;Nt++){let $t=this._data[5*Nt],ln=this._data[5*Nt+1];$t===0?($t=It,ln+=Mt):$t+=It,this._data[5*Nt]=$t,this._data[5*Nt+1]=ln,It=$t,Mt=ln}}let rt=M,ot=Z;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(rt-=this._prevLine,rt===0&&(ot-=this._prevChar)),this._data[this._dataLen++]=rt,this._data[this._dataLen++]=ot,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=it,this._prevLine=M,this._prevChar=Z}static _sortAndDeltaEncode(M){let Z=[];const ke=M.length/5|0;for(let ot=0;ot<ke;ot++)Z[ot]=ot;Z.sort((ot,yt)=>{const It=M[5*ot],Mt=M[5*yt];if(It===Mt){const Nt=M[5*ot+1],$t=M[5*yt+1];return Nt-$t}return It-Mt});const Je=new Uint32Array(M.length);let it=0,rt=0;for(let ot=0;ot<ke;ot++){const yt=5*Z[ot],It=M[yt+0],Mt=M[yt+1],Nt=M[yt+2],$t=M[yt+3],ln=M[yt+4],On=It-it,qn=On===0?Mt-rt:Mt,un=5*ot;Je[un+0]=On,Je[un+1]=qn,Je[un+2]=Nt,Je[un+3]=$t,Je[un+4]=ln,it=It,rt=Mt}return Je}build(M){return this._dataIsSortedAndDeltaEncoded?new en(new Uint32Array(this._data),M):new en(Vt._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=Vt;class en{constructor(M,Z){this.resultId=Z,this.data=M}}e.SemanticTokens=en;class tn{constructor(M,Z,ke){this.start=M,this.deleteCount=Z,this.data=ke}}e.SemanticTokensEdit=tn;class nn{constructor(M,Z){this.resultId=Z,this.edits=M}}e.SemanticTokensEdits=nn;var Sn;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(Sn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Dn;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(Dn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Ft=class{constructor(){}};Ft.Back={iconPath:new ft("arrow-left")},Ft=ze([P],Ft),e.QuickInputButtons=Ft;var Cn;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Cn=e.ExtensionKind||(e.ExtensionKind={}));class kn{constructor(M,Z,ke){this.badge=M,this.tooltip=Z,this.color=ke}static validate(M){if(M.badge&&M.badge.length!==1&&M.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=kn;let rn=class{constructor(M){this.kind=M}};rn=ze([P],rn),e.ColorTheme=rn;var In;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(In=e.ColorThemeKind||(e.ColorThemeKind={}));class Bt{constructor(M,Z){if(M<0)throw(0,F.illegalArgument)("start must be positive");if(Z<0)throw(0,F.illegalArgument)("end must be positive");M<=Z?(this._start=M,this._end=Z):(this._start=Z,this._end=M)}static isNotebookRange(M){return M instanceof Bt?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(M){let Z=this._start,ke=this._end;return M.start!==void 0&&(Z=M.start),M.end!==void 0&&(ke=M.end),Z===this._start&&ke===this._end?this:new Bt(Z,ke)}}e.NotebookRange=Bt;class Lt{constructor(M,Z,ke,Je,it,rt,ot){this.kind=M,this.value=Z,this.languageId=ke,this.mime=Je,this.outputs=it??[],this.metadata=rt,this.executionSummary=ot,Lt.validate(this)}static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(Z=>Lt.isNotebookCellData(Z))}static isNotebookCellData(M){return!0}}e.NotebookCellData=Lt;class fn{constructor(M){this.cells=M}}e.NotebookData=fn;class Tt{constructor(M,Z){this.data=M,this.mime=Z;const ke=(0,I.normalizeMimeType)(Z,!0);if(!ke)throw new Error("INVALID mime type, must not be empty or falsy: "+Z);this.mime=ke}static isNotebookCellOutputItem(M){return M instanceof Tt?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const Z={name:M.name,message:M.message,stack:M.stack};return Tt.json(Z,"application/vnd.code.notebook.error")}static stdout(M){return Tt.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return Tt.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,Z="application/octet-stream"){return new Tt(M,Z)}static text(M,Z=I.Mimes.text){const ke=Oe(Tt,a,"f",d).encode(String(M));return new Tt(ke,Z)}static json(M,Z="application/json"){const ke=JSON.stringify(M,void 0,"	");return Tt.text(ke,Z)}}e.NotebookCellOutputItem=Tt,a=Tt,d={value:new TextEncoder};class Le{constructor(M,Z,ke){this.items=Le.ensureUniqueMimeTypes(M,!0),typeof Z=="string"?(this.id=Z,this.metadata=ke):(this.id=(0,C.generateUuid)(),this.metadata=Z??ke)}static isNotebookCellOutput(M){return M instanceof Le?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&(0,S.isArray)(M.items)}static ensureUniqueMimeTypes(M,Z=!1){const ke=new Set,Je=new Set;for(let it=0;it<M.length;it++){const rt=M[it],ot=(0,I.normalizeMimeType)(rt.mime);if(!ke.has(ot)){ke.add(ot);continue}Je.add(it),Z&&console.warn(`DUPLICATED mime type '${rt.mime}' will be dropped`)}return Je.size===0?M:M.filter((it,rt)=>!Je.has(rt))}}e.NotebookCellOutput=Le;var sn;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(sn=e.NotebookCellKind||(e.NotebookCellKind={}));var mn;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(mn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var vt;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(vt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pn;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Pn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class An{constructor(M,Z){this.text=M,this.alignment=Z}}e.NotebookCellStatusBarItem=An;var gn;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(gn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class pn{constructor(M,Z=[]){this.uri=M,this.provides=(0,m.asArray)(Z)}}e.NotebookRendererScript=pn;let on=class{constructor(M,Z){this.label=M,this.timestamp=Z}};on=ze([P],on),e.TimelineItem=on;var Tn;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(Tn=e.ExtensionMode||(e.ExtensionMode={}));var Rn;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(Rn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Fn;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(Fn=e.StandardTokenType||(e.StandardTokenType={}));class vn{constructor(M,Z){this.ranges=M,this.wordPattern=Z}}e.LinkedEditingRanges=vn;class Mn{constructor(M,Z){this._port=M,this._autoForwardAction=Z}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Mn;var Ln;(function(N){N[N.Unset=0]="Unset",N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Ln=e.TestResultState||(e.TestResultState={}));var bn;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information",N[N.Hint=3]="Hint"})(bn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var Nn;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Nn=e.TestRunConfigurationGroup||(e.TestRunConfigurationGroup={}));let an=class{constructor(M,Z,ke){this.include=M,this.exclude=Z,this.configuration=ke}};an=ze([P],an),e.TestRunRequest=an;let Y=R=class{constructor(M){this.message=M,this.severity=bn.Error}static diff(M,Z,ke){const Je=new R(M);return Je.expectedOutput=Z,Je.actualOutput=ke,Je}};Y=R=ze([P],Y),e.TestMessage=Y;let ae=class{constructor(M,Z){this.covered=M,this.total=Z}};ae=ze([P],ae),e.CoveredCount=ae;let Ae=o=class{constructor(M,Z,ke,Je){this.uri=M,this.statementCoverage=Z,this.branchCoverage=ke,this.functionCoverage=Je}static fromDetails(M,Z){const ke=new ae(0,0),Je=new ae(0,0),it=new ae(0,0);for(const ot of Z)if("branches"in ot){ke.total+=1,ke.covered+=ot.executionCount>0?1:0;for(const yt of ot.branches)Je.total+=1,Je.covered+=yt.executionCount>0?1:0}else it.total+=1,it.covered+=ot.executionCount>0?1:0;const rt=new o(M,ke,Je.total>0?Je:void 0,it.total>0?it:void 0);return rt.detailedCoverage=Z,rt}};Ae=o=ze([P],Ae),e.FileCoverage=Ae;let st=class{constructor(M,Z,ke=[]){this.executionCount=M,this.location=Z,this.branches=ke}};st=ze([P],st),e.StatementCoverage=st;let wt=class{constructor(M,Z){this.executionCount=M,this.location=Z}};wt=ze([P],wt),e.BranchCoverage=wt;let Dt=class{constructor(M,Z){this.executionCount=M,this.location=Z}};Dt=ze([P],Dt),e.FunctionCoverage=Dt;var Wn;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Wn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Hn;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(Hn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var zn;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(zn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Vn{constructor(M,Z,ke,Je,it,rt){this.kind=M,this.name=Z,this.detail=ke,this.uri=Je,this.range=it,this.selectionRange=rt}}e.TypeHierarchyItem=Vn}),define(Ee[95],_e([0,1,39,11,8,121,86,6,17]),function(ee,e,m,F,D,_,I,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const C=new Map;function n(a,d){d?C.set(a,d):C.delete(a)}e.setWordDefinitionFor=n;function k(a){return C.get(a)}e.getWordDefinitionFor=k;class l extends _.MirrorTextModel{constructor(d,f,E,w,u,p,b,t){super(f,E,w,u);this._proxy=d,this._languageId=p,this._isDirty=b,this._notebook=t,this._isDisposed=!1}dispose(){(0,m.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(d){return(0,y.equals)(this._lines,d)}get document(){if(!this._document){const d=this;this._document={get uri(){return d._uri},get fileName(){return d._uri.fsPath},get isUntitled(){return d._uri.scheme===F.Schemas.untitled},get languageId(){return d._languageId},get version(){return d._versionId},get isClosed(){return d._isDisposed},get isDirty(){return d._isDirty},get notebook(){return d._notebook},save(){return d._save()},getText(f){return f?d._getTextInRange(f):d.getText()},get eol(){return d._eol===`
`?S.EndOfLine.LF:S.EndOfLine.CRLF},get lineCount(){return d._lines.length},lineAt(f){return d._lineAt(f)},offsetAt(f){return d._offsetAt(f)},positionAt(f){return d._positionAt(f)},validateRange(f){return d._validateRange(f)},validatePosition(f){return d._validatePosition(f)},getWordRangeAtPosition(f,E){return d._getWordRangeAtPosition(f,E)}}}return Object.freeze(this._document)}_acceptLanguageId(d){(0,m.ok)(!this._isDisposed),this._languageId=d}_acceptIsDirty(d){(0,m.ok)(!this._isDisposed),this._isDirty=d}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(d){const f=this._validateRange(d);if(f.isEmpty)return"";if(f.isSingleLine)return this._lines[f.start.line].substring(f.start.character,f.end.character);const E=this._eol,w=f.start.line,u=f.end.line,p=[];p.push(this._lines[w].substring(f.start.character));for(let b=w+1;b<u;b++)p.push(this._lines[b]);return p.push(this._lines[u].substring(0,f.end.character)),p.join(E)}_lineAt(d){let f;if(d instanceof S.Position?f=d.line:typeof d=="number"&&(f=d),typeof f!="number"||f<0||f>=this._lines.length||Math.floor(f)!==f)throw new Error("Illegal value for `line`");return new h(f,this._lines[f],f===this._lines.length-1)}_offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getPrefixSum(d.line-1)+d.character}_positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const f=this._lineStarts.getIndexOf(d),E=this._lines[f.index].length;return new S.Position(f.index,Math.min(f.remainder,E))}_validateRange(d){if(!(d instanceof S.Range))throw new Error("Invalid argument");const f=this._validatePosition(d.start),E=this._validatePosition(d.end);return f===d.start&&E===d.end?d:new S.Range(f.line,f.character,E.line,E.character)}_validatePosition(d){if(!(d instanceof S.Position))throw new Error("Invalid argument");if(this._lines.length===0)return d.with(0,0);let{line:f,character:E}=d,w=!1;if(f<0)f=0,E=0,w=!0;else if(f>=this._lines.length)f=this._lines.length-1,E=this._lines[f].length,w=!0;else{const u=this._lines[f].length;E<0?(E=0,w=!0):E>u&&(E=u,w=!0)}return w?new S.Position(f,E):d}_getWordRangeAtPosition(d,f){const E=this._validatePosition(d);if(!f)f=k(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(f))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${f.source}' because it matches the empty string.`);const w=(0,I.getWordAtText)(E.character+1,(0,I.ensureValidWordDefinition)(f),this._lines[E.line],0);if(w)return new S.Range(E.line,w.startColumn-1,E.line,w.endColumn-1)}}e.ExtHostDocumentData=l;class h{constructor(d,f,E){this._line=d,this._text=f,this._isLastLine=E}get lineNumber(){return this._line}get text(){return this._text}get range(){return new S.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new S.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(Ee[161],_e([0,1,6,3,88,7,55,22,2,35]),function(ee,e,m,F,D,_,I,S,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(l,h,a,d){this._notebook=a,this._selector=d,this._disposables=new _.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,C.generateUuid)()}),this._init(),this._disposables.add(h.onDidChangeDocument(E=>{const w=this._cellUris.get(E.document.uri);w!==void 0&&(this._cellLengths.changeValue(w,this._cells[w].document.getText().length+1),this._cellLines.changeValue(w,this._cells[w].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const f=E=>{E===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(E=>f(E.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new S.ResourceMap;const l=[],h=[];for(const a of this._notebook.getCells())a.kind===m.NotebookCellKind.Code&&(!this._selector||(0,I.score)(this._selector,a.document.uri,a.document.languageId,!0))&&(this._cellUris.set(a.document.uri,this._cells.length),this._cells.push(a),l.push(a.document.getText().length+1),h.push(a.document.lineCount));this._cellLengths=new D.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new D.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(l){if(!l){let w="";for(const u of this._cells)w+=u.document.getText()+`
`;return w=w.slice(0,-1),w}if(l.isEmpty)return"";const h=this.locationAt(l.start),a=this.locationAt(l.end),d=this._cellUris.get(h.uri),f=this._cellUris.get(a.uri);if(d===void 0||f===void 0)return"";if(d===f)return this._cells[d].document.getText(new m.Range(h.range.start,a.range.end));const E=[this._cells[d].document.getText(new m.Range(h.range.start,new m.Position(this._cells[d].document.lineCount,0)))];for(let w=d+1;w<f;w++)E.push(this._cells[w].document.getText());return E.push(this._cells[f].document.getText(new m.Range(new m.Position(0,0),a.range.end))),E.join(`
`)}offsetAt(l){const h=this._cellLines.getIndexOf(l.line),a=this._cellLengths.getPrefixSum(h.index-1),d=this._cells[h.index].document.offsetAt(l.with(h.remainder));return a+d}positionAt(l){if(typeof l=="number"){const a=this._cellLengths.getIndexOf(l),d=this._cellLines.getPrefixSum(a.index-1);return this._cells[a.index].document.positionAt(a.remainder).translate(d)}const h=this._cellUris.get(l.uri);if(h!==void 0){const a=this._cellLines.getPrefixSum(h-1);return new m.Position(a+l.range.start.line,l.range.start.character)}return new m.Position(0,0)}locationAt(l){m.Range.isRange(l)||(l=new m.Range(l,l));const h=this._cellLines.getIndexOf(l.start.line);let a=h;l.isEmpty||(a=this._cellLines.getIndexOf(l.end.line));const d=new m.Position(h.remainder,l.start.character),f=new m.Position(a.remainder,l.end.character),E=new m.Range(d,f),w=this._cells[h.index];return new m.Location(w.document.uri,w.document.validateRange(E))}contains(l){return this._cellUris.has(l)}validateRange(l){const h=this.validatePosition(l.start),a=this.validatePosition(l.end);return l.with(h,a)}validatePosition(l){const h=this._cellLines.getIndexOf(l.line),a=new m.Position(h.remainder,l.character),d=this._cells[h.index].document.validatePosition(a),f=this._cellLines.getPrefixSum(h.index-1);return new m.Position(f+d.line,d.character)}}e.ExtHostNotebookConcatDocument=n}),define(Ee[162],_e([0,1,6,13,3]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let _=class{constructor(S){this._actual=new m.ColorTheme(m.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(S){let y=S==="light"?m.ColorThemeKind.Light:S==="dark"?m.ColorThemeKind.Dark:m.ColorThemeKind.HighContrast;this._actual=new m.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};_=ze([qe(0,F.IExtHostRpcService)],_),e.ExtHostTheming=_}),define(Ee[67],_e([0,1,4]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,m.createDecorator)("IURITransformerService");class F{constructor(_){_?(this.transformIncoming=_.transformIncoming.bind(_),this.transformOutgoing=_.transformOutgoing.bind(_),this.transformOutgoingURI=_.transformOutgoingURI.bind(_),this.transformOutgoingScheme=_.transformOutgoingScheme.bind(_)):(this.transformIncoming=I=>I,this.transformOutgoing=I=>I,this.transformOutgoingURI=I=>I,this.transformOutgoingScheme=I=>I)}}e.URITransformerService=F}),define(Ee[163],_e([0,1,23]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class F{constructor(){this.buffers=[]}add(y){let C=this.buffers.indexOf(y);return C<0&&(C=this.buffers.length,this.buffers.push(y)),C}}function D(S,y){if(y.serializeBuffersForPostMessage){const C=new F,n=(h,a)=>{if(a instanceof ArrayBuffer){const d=C.add(a);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(a)){const d=_(a);if(d){const f=C.add(a.buffer);return{$$vscode_array_buffer_reference$$:!0,index:f,view:{type:d,byteLength:a.byteLength,byteOffset:a.byteOffset}}}}return a},k=JSON.stringify(S,n),l=C.buffers.map(h=>{const a=new Uint8Array(h);return m.VSBuffer.wrap(a)});return{message:k,buffers:l}}else return{message:JSON.stringify(S),buffers:[]}}e.serializeWebviewMessage=D;function _(S){switch(S.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function I(S,y){const C=y.map(l=>{const h=new ArrayBuffer(l.byteLength);return new Uint8Array(h).set(l.buffer),h}),n=y.length?(l,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const a=h,{index:d}=a,f=C[d];if(a.view)switch(a.view.type){case 1:return new Int8Array(f,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(f,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(f,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(f,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(f,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(f,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(f,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(f,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(f,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(f,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(f,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return f}return h}:void 0;return{message:JSON.parse(S,n),arrayBuffers:C}}e.deserializeWebviewMessage=I}),define(Ee[68],_e([0,1,11,2]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function D(_,I){return _.scheme===m.Schemas.http||_.scheme===m.Schemas.https?_:(I&&I.authority&&I.isRemote&&_.scheme===m.Schemas.file&&(_=F.URI.from({scheme:m.Schemas.vscodeRemote,authority:I.authority,path:_.path})),F.URI.from({scheme:m.Schemas.https,authority:`${_.scheme}+${_.authority}.${e.webviewRootResourceAuthority}`,path:_.path,fragment:_.fragment,query:_.query}))}e.asWebviewUri=D}),define(Ee[164],_e([0,1,3,7,68]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class _{constructor(S,y,C){this._proxy=S,this._editors=y,this._initData=C,this._handlePool=0,this._disposables=new F.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const n=y.getVisibleTextEditors();for(const k of this._insets.values())n.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this._insets.forEach(S=>S.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(S,y,C,n,k){let l;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===S){l=u;break}if(!l)throw new Error("not a visible editor");const h=this,a=this._handlePool++,d=new m.Emitter,f=new m.Emitter,E=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(u){return(0,D.asWebviewUri)(u,h._initData.remote)}get cspSource(){return D.webviewGenericCspSource}set options(u){this._options=u,h._proxy.$setOptions(a,u)}get options(){return this._options}set html(u){this._html=u,h._proxy.$setHtml(a,u)}get html(){return this._html}get onDidReceiveMessage(){return d.event}postMessage(u){return h._proxy.$postMessage(a,u)}},w=new class{constructor(){this.editor=S,this.line=y,this.height=C,this.webview=E,this.onDidDispose=f.event}dispose(){h._insets.has(a)&&(h._insets.delete(a),h._proxy.$disposeEditorInset(a),f.fire(),f.dispose(),d.dispose())}};return this._proxy.$createEditorInset(a,l.id,l.value.document.uri,y+1,C,n||{},k.identifier,k.extensionLocation),this._insets.set(a,{editor:S,inset:w,onDidReceiveMessage:d}),w}$onDidDispose(S){const y=this._insets.get(S);y&&y.inset.dispose()}$onDidReceiveMessage(S,y){const C=this._insets.get(S);C&&C.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=_}),define(Ee[165],_e([0,1,136,10,2,7,4,59,31,17,11]),function(ee,e,m,F,D,_,I,S,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,m.localize)(0,null),providerDisplayName:(0,m.localize)(1,null)},e.ActiveEditorDirtyContext=new S.RawContextKey("activeEditorIsDirty",!1,(0,m.localize)(2,null)),e.ActiveEditorPinnedContext=new S.RawContextKey("activeEditorIsNotPreview",!1,(0,m.localize)(3,null)),e.ActiveEditorStickyContext=new S.RawContextKey("activeEditorIsPinned",!1,(0,m.localize)(4,null)),e.ActiveEditorReadonlyContext=new S.RawContextKey("activeEditorIsReadonly",!1,(0,m.localize)(5,null)),e.ActiveEditorCanRevertContext=new S.RawContextKey("activeEditorCanRevert",!1,(0,m.localize)(6,null)),e.ActiveEditorContext=new S.RawContextKey("activeEditor",null,{type:"string",description:(0,m.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new S.RawContextKey("activeEditorAvailableEditorIds","",(0,m.localize)(8,null)),e.TextCompareEditorVisibleContext=new S.RawContextKey("textCompareEditorVisible",!1,(0,m.localize)(9,null)),e.TextCompareEditorActiveContext=new S.RawContextKey("textCompareEditorActive",!1,(0,m.localize)(10,null)),e.EditorGroupEditorsCountContext=new S.RawContextKey("groupEditorsCount",0,(0,m.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new S.RawContextKey("activeEditorGroupEmpty",!1,(0,m.localize)(12,null)),e.ActiveEditorGroupIndexContext=new S.RawContextKey("activeEditorGroupIndex",0,(0,m.localize)(13,null)),e.ActiveEditorGroupLastContext=new S.RawContextKey("activeEditorGroupLast",!1,(0,m.localize)(14,null)),e.MultipleEditorGroupsContext=new S.RawContextKey("multipleEditorGroups",!1,(0,m.localize)(15,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new S.RawContextKey("editorIsOpen",!1,(0,m.localize)(16,null)),e.InEditorZenModeContext=new S.RawContextKey("inZenMode",!1,(0,m.localize)(17,null)),e.IsCenteredLayoutContext=new S.RawContextKey("isCenteredLayout",!1,(0,m.localize)(18,null)),e.SplitEditorsVertically=new S.RawContextKey("splitEditorsVertically",!1,(0,m.localize)(19,null)),e.EditorAreaVisibleContext=new S.RawContextKey("editorAreaVisible",!0,(0,m.localize)(20,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function k(o){return typeof o?.getViewState=="function"}e.isTextEditorPane=k;function l(o){if(u(o))return!1;const P=o;return D.URI.isUri(P?.resource)}e.isResourceEditorInput=l;function h(o){if(u(o))return!1;const P=o;return P?.original!==void 0&&P.modified!==void 0}e.isResourceDiffEditorInput=h;function a(o){if(u(o))return!1;const P=o;return P?P?.resource===void 0||P.resource.scheme===n.Schemas.untitled||P.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=a;var d;(function(o){o[o.SHORT=0]="SHORT",o[o.MEDIUM=1]="MEDIUM",o[o.LONG=2]="LONG"})(d=e.Verbosity||(e.Verbosity={}));var f;(function(o){o[o.EXPLICIT=1]="EXPLICIT",o[o.AUTO=2]="AUTO",o[o.FOCUS_CHANGE=3]="FOCUS_CHANGE",o[o.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(f=e.SaveReason||(e.SaveReason={}));var E;(function(o){o[o.None=0]="None",o[o.Readonly=2]="Readonly",o[o.Untitled=4]="Untitled",o[o.Singleton=8]="Singleton",o[o.RequiresTrust=16]="RequiresTrust"})(E=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class w extends _.Disposable{}e.AbstractEditorInput=w;function u(o){return o instanceof w}e.isEditorInput=u;function p(o){const P=o;return D.URI.isUri(P?.preferredResource)}function b(o){const P=o;return u(P?.primary)&&u(P?.secondary)}e.isSideBySideEditorInput=b;function t(o){return u(o?.editor)}e.isEditorInputWithOptions=t;function s(o){const P=o;return t(o)&&P?.group!==void 0}e.isEditorInputWithOptionsAndGroup=s;function r(o){const P=o;return typeof P?.groupId=="number"&&u(P.editor)}e.isEditorIdentifier=r;var i;(function(o){o[o.PRIMARY=1]="PRIMARY",o[o.SECONDARY=2]="SECONDARY",o[o.BOTH=3]="BOTH"})(i=e.SideBySideEditor||(e.SideBySideEditor={}));class c{getOriginalUri(P,L){if(!P)return;const $=b(P)?P.primary:h(P)?P.modified:void 0,re=b(P)?P.secondary:h(P)?P.original:void 0;if(L?.supportSideBySide&&$&&re){if(L?.supportSideBySide===i.BOTH)return{primary:this.getOriginalUri($,{filterByScheme:L.filterByScheme}),secondary:this.getOriginalUri(re,{filterByScheme:L.filterByScheme})};P=L.supportSideBySide===i.PRIMARY?$:re}if(h(P))return;const he=p(P)?P.preferredResource:P.resource;return!he||!L||!L.filterByScheme?he:this.filterUri(he,L.filterByScheme)}getCanonicalUri(P,L){if(!P)return;const $=b(P)?P.primary:h(P)?P.modified:void 0,re=b(P)?P.secondary:h(P)?P.original:void 0;if(L?.supportSideBySide&&$&&re){if(L?.supportSideBySide===i.BOTH)return{primary:this.getCanonicalUri($,{filterByScheme:L.filterByScheme}),secondary:this.getCanonicalUri(re,{filterByScheme:L.filterByScheme})};P=L.supportSideBySide===i.PRIMARY?$:re}if(h(P))return;const he=P.resource;return!he||!L||!L.filterByScheme?he:this.filterUri(he,L.filterByScheme)}filterUri(P,L){if(Array.isArray(L)){if(L.some($=>P.scheme===$))return P}else if(L===P.scheme)return P}}e.EditorResourceAccessor=new c;var g;(function(o){o[o.LEFT=0]="LEFT",o[o.RIGHT=1]="RIGHT"})(g=e.CloseDirection||(e.CloseDirection={}));class v{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(P){const L=this.instantiationService=P.get(I.IInstantiationService);for(const[$,re]of this.editorSerializerConstructors)this.createEditorSerializer($,re,L);this.editorSerializerConstructors.clear()}createEditorSerializer(P,L,$){const re=$.createInstance(L);this.editorSerializerInstances.set(P,re)}registerFileEditorFactory(P){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=P}getFileEditorFactory(){return(0,F.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(P,L){if(this.editorSerializerConstructors.has(P)||this.editorSerializerInstances.has(P))throw new Error(`A editor serializer with type ID '${P}' was already registered.`);return this.instantiationService?this.createEditorSerializer(P,L,this.instantiationService):this.editorSerializerConstructors.set(P,L),(0,_.toDisposable)(()=>{this.editorSerializerConstructors.delete(P),this.editorSerializerInstances.delete(P)})}getEditorSerializer(P){return this.editorSerializerInstances.get(typeof P=="string"?P:P.typeId)}}y.Registry.add(e.EditorExtensions.EditorFactory,new v);async function A(o,P){if(!o||!o.length)return[];const L=await Promise.all(o.map(async $=>{const re=D.URI.revive($.fileUri);if(!re||(await P.activateProvider(re.scheme),!P.canHandleResource(re)))return;const he=typeof $.exists=="boolean"?$.exists:await P.exists(re);if(!he&&$.openOnlyIfExists)return;const Q=he&&typeof $.lineNumber=="number"?{selection:{startLineNumber:$.lineNumber,startColumn:$.columnNumber||1},pinned:!0,override:$.editorOverrideId}:{pinned:!0,override:$.editorOverrideId};let z;return he?z={resource:re,options:Q,forceFile:!0}:z={resource:re,options:Q,forceUntitled:!0},z}));return(0,C.coalesce)(L)}e.pathsToEditors=A;var R;(function(o){o[o.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",o[o.SEQUENTIAL=1]="SEQUENTIAL"})(R=e.EditorsOrder||(e.EditorsOrder={}))}),define(Ee[166],_e([0,1,3,16,137]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class _{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new m.Emitter,this._onExit=new m.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(S){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=S}onEvent(S){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=S}onRequest(S){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=S}sendResponse(S){S.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${S.command}`)):this.internalSend("response",S)}sendRequest(S,y,C,n){const k={command:S};if(y&&Object.keys(y).length>0&&(k.arguments=y),this.internalSend("request",k),typeof n=="number"){const l=setTimeout(()=>{clearTimeout(l);const h=this.pendingRequests.get(k.seq);if(h){this.pendingRequests.delete(k.seq);const a={type:"response",seq:0,request_seq:k.seq,success:!1,command:S,message:(0,D.localize)(0,null,n,S)};h(a)}},n)}return C&&this.pendingRequests.set(k.seq,C),k.seq}acceptMessage(S){this.messageCallback?this.messageCallback(S):(this.queue.push(S),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(S,y){return S.type!=="event"||y.type!=="event"}async processQueue(){let S;for(;this.queue.length;){if((!S||this.needsTaskBoundaryBetween(this.queue[0],S))&&await(0,F.timeout)(0),S=this.queue.shift(),!S)return;switch(S.type){case"event":this.eventCallback&&this.eventCallback(S);break;case"request":this.requestCallback&&this.requestCallback(S);break;case"response":const y=S,C=this.pendingRequests.get(y.request_seq);C&&(this.pendingRequests.delete(y.request_seq),C(y));break}}}internalSend(S,y){y.type=S,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const S=new Map;this.pendingRequests.forEach((y,C)=>S.set(C,y)),await(0,F.timeout)(500),S.forEach((y,C)=>{y({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(C)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=_}),define(Ee[167],_e([0,1,8,2,14,24,11]),function(ee,e,m,F,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const S=/{([^}]+)}/g;function y(s,r,i){return s.replace(S,function(c,g){return r&&g.length>0&&g[0]!=="_"?c:i&&i.hasOwnProperty(g)?i[g]:c})}e.formatPII=y;function C(s){const r={};for(const i of Object.keys(s))i.startsWith("!")||(r[i]=s[i]);return r}e.filterExceptionsFromTelemetry=C;function n(s){return s.configuration.request==="attach"&&!k(s)&&(!s.parentSession||n(s.parentSession))}e.isSessionAttach=n;function k(s){let r=s.configuration.type;if(!!r)return r==="vslsShare"&&(r=s.configuration.adapterProxy.configuration.type),(0,m.equalsIgnoreCase)(r,"extensionhost")||(0,m.equalsIgnoreCase)(r,"pwa-extensionhost")?s:s.parentSession?k(s.parentSession):void 0}e.getExtensionHostDebugSession=k;function l(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=l;function h(s,r,i){let c,g=0,v=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,A=null;for(;A=v.exec(s);){let R=A.index+1,o=R+A[0].length;if(R<=r&&o>=i){c=A[0],g=R;break}}if(c){let R=/\w+/g,o=null;for(;(o=R.exec(c))&&!(o.index+1+g+o[0].length>=i););o&&(c=c.substring(0,R.lastIndex))}return c?{start:g,end:g+c.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(s){return!!(s&&s.match(a))}e.isUri=d;function f(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(d(s.path))return F.URI.parse(s.path);if((0,D.isAbsolute)(s.path))return F.URI.file(s.path)}return s.path}function E(s){if(typeof s.path=="object"){const r=F.URI.revive(s.path);if(r)return r.scheme===I.Schemas.file?r.fsPath:r.toString()}return s.path}function w(s,r){const i=r?f:E,c=(0,_.deepClone)(s);return p(c,(g,v)=>{g&&v&&(v.path=i(v))}),c}e.convertToDAPaths=w;function u(s,r){const i=r?f:E,c=(0,_.deepClone)(s);return p(c,(g,v)=>{!g&&v&&(v.path=i(v))}),c}e.convertToVSCPaths=u;function p(s,r){switch(s.type){case"event":const i=s;switch(i.event){case"output":r(!1,i.body.source);break;case"loadedSource":r(!1,i.body.source);break;case"breakpoint":r(!1,i.body.breakpoint.source);break;default:break}break;case"request":const c=s;switch(c.command){case"setBreakpoints":r(!0,c.arguments.source);break;case"breakpointLocations":r(!0,c.arguments.source);break;case"source":r(!0,c.arguments.source);break;case"gotoTargets":r(!0,c.arguments.source);break;case"launchVSCode":c.arguments.args.forEach(v=>r(!1,v));break;default:break}break;case"response":const g=s;if(g.success&&g.body)switch(g.command){case"stackTrace":g.body.stackFrames.forEach(v=>r(!1,v.source));break;case"loadedSources":g.body.sources.forEach(v=>r(!1,v));break;case"scopes":g.body.scopes.forEach(v=>r(!1,v.source));break;case"setFunctionBreakpoints":g.body.breakpoints.forEach(v=>r(!1,v.source));break;case"setBreakpoints":g.body.breakpoints.forEach(v=>r(!1,v.source));break;default:break}break}}function b(s){return s.filter(r=>!r.presentation?.hidden).sort((r,i)=>r.presentation?i.presentation?r.presentation.group?i.presentation.group?r.presentation.group!==i.presentation.group?r.presentation.group.localeCompare(i.presentation.group):t(r.presentation.order,i.presentation.order):-1:i.presentation.group?1:t(r.presentation.order,i.presentation.order):-1:i.presentation?1:0)}e.getVisibleAndSorted=b;function t(s,r){return typeof s!="number"?typeof r!="number"?0:1:typeof r!="number"?-1:s-r}}),define(Ee[69],_e([0,1,27,83,11,14,21,59]),function(ee,e,m,F,D,_,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var y;(function(o){o[o.Markup=1]="Markup",o[o.Code=2]="Code"})(y=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",F.Mimes.markdown,"image/png","image/jpeg",F.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[F.Mimes.markdown,"application/json",F.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var C;(function(o){o[o.Running=1]="Running",o[o.Idle=2]="Idle"})(C=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(o){o[o.Pending=2]="Pending",o[o.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var k;(function(o){o[o.WithHardKernelDependency=0]="WithHardKernelDependency",o[o.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",o[o.Pure=2]="Pure",o[o.Never=3]="Never"})(k=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var l;(function(o){o.Always="always",o.Never="never",o.Optional="optional"})(l=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(o){o[o.ModelChange=1]="ModelChange",o[o.Move=2]="Move",o[o.ChangeLanguage=5]="ChangeLanguage",o[o.Initialize=6]="Initialize",o[o.ChangeCellMetadata=7]="ChangeCellMetadata",o[o.Output=8]="Output",o[o.OutputItem=9]="OutputItem",o[o.ChangeCellContent=10]="ChangeCellContent",o[o.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",o[o.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",o[o.ChangeCellMime=13]="ChangeCellMime",o[o.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var a;(function(o){o[o.Handle=0]="Handle",o[o.Index=1]="Index"})(a=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(o){o[o.Replace=1]="Replace",o[o.Output=2]="Output",o[o.Metadata=3]="Metadata",o[o.CellLanguage=4]="CellLanguage",o[o.DocumentMetadata=5]="DocumentMetadata",o[o.Move=6]="Move",o[o.OutputItems=7]="OutputItems",o[o.PartialMetadata=8]="PartialMetadata",o[o.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var f;(function(o){o.scheme=D.Schemas.vscodeNotebookCell;const P=/^ch(\d{7,})/;function L(z,V){return z.with({scheme:o.scheme,fragment:`ch${V.toString().padStart(7,"0")}${z.scheme!==D.Schemas.file?z.scheme:""}`})}o.generate=L;function $(z){if(z.scheme!==o.scheme)return;const V=P.exec(z.fragment);return V?{handle:Number(V[1]),notebook:z.with({scheme:z.fragment.substr(V[0].length)||D.Schemas.file,fragment:null})}:void 0}o.parse=$;function re(z){if(z.scheme!==D.Schemas.vscodeNotebookCellMetadata)return;const V=P.exec(z.fragment);return V?{handle:Number(V[1]),notebook:z.with({scheme:z.fragment.substr(V[0].length)||D.Schemas.file,fragment:null})}:void 0}o.parseCellMetadataUri=re;function he(z,V,T){return z.with({scheme:T,fragment:`ch${V.toString().padStart(7,"0")}${z.scheme!==D.Schemas.file?z.scheme:""}`})}o.generateCellUri=he;function Q(z,V){if(z.scheme!==V)return;const T=P.exec(z.fragment);return T?{handle:Number(T[1]),notebook:z.with({scheme:z.fragment.substr(T[0].length)||D.Schemas.file,fragment:null})}:void 0}o.parseCellUri=Q})(f=e.CellUri||(e.CellUri={}));const E=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function w(o){return E.get(o)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=w;function u(o){return E.get(o)?.supportedByCore??!1}e.mimeTypeSupportedByCore=u;function p(o){return E.get(o)?.mergeable??!1}e.mimeTypeIsMergeable=p;function b(o,P){return I.isWindows&&(o=o.replace(/\//g,"\\"),P=P.replace(/\//g,"\\")),m.match(o,P)}function t(o,P,L){let $=0;for(let re=0;re<P.length;re++){if(b(P[re],o))return $;$++}for(let re=0;re<L.length;re++){if(b(L[re],o))return $;$++}return $}function s(o,P,L){return o.sort(($,re)=>t($,P,L)-t(re,P,L))}e.sortMimeTypes=s;function r(o,P,L,$=(re,he)=>re===he){const re=[];function he(V,T,G){if(T===0&&G.length===0)return;const B=re[re.length-1];B&&B.start+B.deleteCount===V?(B.deleteCount+=T,B.toInsert.push(...G)):re.push({start:V,deleteCount:T,toInsert:G})}let Q=0,z=0;for(;;){if(Q===o.length){he(Q,0,P.slice(z));break}if(z===P.length){he(Q,o.length-Q,[]);break}const V=o[Q],T=P[z];if($(V,T)){Q+=1,z+=1;continue}L(T)?(he(Q,1,[]),Q+=1):(he(Q,0,[T]),z+=1)}return re}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(o){o.default="default",o.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function c(o){const P=o;return!!((typeof P.include=="string"||m.isRelativePattern(P.include))&&(typeof P.exclude=="string"||m.isRelativePattern(P.exclude)))}e.isDocumentExcludePattern=c;function g(o,P,L){if(Array.isArray(o.viewType)&&o.viewType.indexOf(P)>=0||o.viewType===P)return!0;if(o.filenamePattern){let $=c(o.filenamePattern)?o.filenamePattern.include:o.filenamePattern,re=c(o.filenamePattern)?o.filenamePattern.exclude:void 0;if(m.match($,(0,_.basename)(L.fsPath).toLowerCase()))return!(re&&m.match(re,(0,_.basename)(L.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=g;class v{constructor(P){this.textModel=P}getElements(){const P=new Int32Array(this.textModel.cells.length);for(let L=0;L<this.textModel.cells.length;L++)P[L]=this.textModel.cells[L].getHashValue();return P}}e.CellSequence=v,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var A;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(A=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class R{static create(P){return`${R._prefix}${P}`}static parse(P){if(P.startsWith(R._prefix))return P.substr(R._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=R,R._prefix="notebook/"}),define(Ee[168],_e([0,1,139,4,59]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new D.RawContextKey("customExecutionSupported",!0,m.localize(0,null)),e.ShellExecutionSupportedContext=new D.RawContextKey("shellExecutionSupported",!1,m.localize(1,null)),e.ProcessExecutionSupportedContext=new D.RawContextKey("processExecutionSupported",!1,m.localize(2,null)),e.ITaskService=(0,F.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(Ee[169],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function m(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=m;function F(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=F}),define(Ee[96],_e([0,1,6]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.testRunConfigurationBitsetList=e.TestRunConfigurationBitset=e.identifyTest=e.TestResultState=void 0,Object.defineProperty(e,"TestResultState",{enumerable:!0,get:function(){return m.TestResultState}});const F=k=>({testId:k.item.extId,controllerId:k.controllerId});e.identifyTest=F;var D;(function(k){k[k.Run=2]="Run",k[k.Debug=4]="Debug",k[k.Coverage=8]="Coverage",k[k.HasNonDefaultConfig=16]="HasNonDefaultConfig",k[k.HasConfigurable=32]="HasConfigurable"})(D=e.TestRunConfigurationBitset||(e.TestRunConfigurationBitset={})),e.testRunConfigurationBitsetList=[2,4,8,16];var _;(function(k){k[k.NotExpandable=0]="NotExpandable",k[k.Expandable=1]="Expandable",k[k.BusyExpanding=2]="BusyExpanding",k[k.Expanded=3]="Expanded"})(_=e.TestItemExpandState||(e.TestItemExpandState={}));const I=(k,l)=>{l.expand!==void 0&&(k.expand=l.expand),l.item!==void 0&&(k.item=k.item?Object.assign(k.item,l.item):l.item)};e.applyTestItemUpdate=I;var S;(function(k){k[k.Function=0]="Function",k[k.Statement=1]="Statement"})(S=e.DetailType||(e.DetailType={}));var y;(function(k){k[k.Add=0]="Add",k[k.Update=1]="Update",k[k.Remove=2]="Remove",k[k.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",k[k.Retire=4]="Retire"})(y=e.TestDiffOpType||(e.TestDiffOpType={}));class C{add(l){}update(l){}remove(l,h){}complete(){}}e.IncrementalChangeCollector=C;class n{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(l){const h=this.createChangeCollector();for(const a of l)switch(a[0]){case 0:{const d=a[1];if(d.parent){if(this.items.has(d.parent)){const f=this.items.get(d.parent);f.children.add(d.item.extId);const E=this.createItem(d,f);this.items.set(d.item.extId,E),h.add(E)}}else{const f=this.createItem(d);this.roots.add(f),this.items.set(d.item.extId,f),h.add(f)}d.expand===2&&this.busyControllerCount++;break}case 1:{const d=a[1],f=this.items.get(d.extId);if(!f)break;d.expand!==void 0&&(f.expand===2&&this.busyControllerCount--,d.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(f,d),h.update(f);break}case 2:{const d=this.items.get(a[1]);if(!d)break;d.parent?this.items.get(d.parent).children.delete(d.item.extId):this.roots.delete(d);const f=[[a[1]]];for(;f.length;)for(const E of f.pop()){const w=this.items.get(E);w&&(f.push(w.children),this.items.delete(E),h.remove(w,w!==d),w.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(a[1]);break;case 3:this.updatePendingRoots(a[1]);break}h.complete()}retireTest(l){}updatePendingRoots(l){this.pendingRootCount+=l}createChangeCollector(){return new C}}e.AbstractIncrementalTestCollection=n}),define(Ee[170],_e([0,1,14,40,10,24,21,82,140]),function(ee,e,m,F,D,_,I,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class C{constructor(k,l,h){this._contributedVariables=new Map,this._context=k,this._labelService=l,h&&(this._envVariablesPromise=h.then(a=>this.prepareEnv(a)))}prepareEnv(k){if(I.isWindows){const l=Object.create(null);return Object.keys(k).forEach(h=>{l[h.toLowerCase()]=k[h]}),l}return k}resolveWithEnvironment(k,l,h){return this.recursiveResolve(this.prepareEnv(k),l?l.uri:void 0,h)}async resolveAsync(k,l){return this.recursiveResolve(await this._envVariablesPromise,k?k.uri:void 0,l)}async resolveAnyBase(k,l,h,a){const d=_.deepClone(l);return I.isWindows&&d.windows?Object.keys(d.windows).forEach(f=>d[f]=d.windows[f]):I.isMacintosh&&d.osx?Object.keys(d.osx).forEach(f=>d[f]=d.osx[f]):I.isLinux&&d.linux&&Object.keys(d.linux).forEach(f=>d[f]=d.linux[f]),delete d.windows,delete d.osx,delete d.linux,this.recursiveResolve(await this._envVariablesPromise,k?k.uri:void 0,d,h,a)}async resolveAnyAsync(k,l,h){return this.resolveAnyBase(k,l,h)}async resolveAnyMap(k,l,h){const a=new Map;return{newConfig:await this.resolveAnyBase(k,l,h,a),resolvedVariables:a}}resolveWithInteractionReplace(k,l,h,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,l,h,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,l){if(this._contributedVariables.has(k))throw new Error("Variable "+k+" is contributed twice.");this._contributedVariables.set(k,l)}recursiveResolve(k,l,h,a,d){if(D.isString(h))return this.resolveString(k,l,h,a,d);if(D.isArray(h))return h.map(f=>this.recursiveResolve(k,l,f,a,d));if(D.isObject(h)){let f=Object.create(null);return Object.keys(h).forEach(E=>{const w=this.resolveString(k,l,E,a,d);f[w]=this.recursiveResolve(k,l,h[E],a,d)}),f}return h}resolveString(k,l,h,a,d){return h.replace(C.VARIABLE_REGEXP,(E,w)=>{if(w.includes(C.VARIABLE_LHS))return E;let u=this.evaluateSingleVariable(k,E,w,l,a);return d&&d.set(w,u),u!==E&&D.isString(u)&&u.match(C.VARIABLE_REGEXP)&&(u=this.resolveString(k,l,u,a,d)),u})}fsPath(k){return this._labelService?this._labelService.getUriLabel(k,{noPrefix:!0}):k.fsPath}evaluateSingleVariable(k,l,h,a,d){let f;const E=h.split(":");E.length>1&&(h=E[0],f=E[1]);const w=()=>{const b=this._context.getFilePath();if(b)return b;throw new Error((0,y.localize)(0,null,l))},u=()=>{const b=w();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,y.localize)(1,null,l,m.basename(b)))},p=()=>{if(f){const b=this._context.getFolderUri(f);if(b)return b;throw new Error((0,y.localize)(2,null,l,f))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,l)):new Error((0,y.localize)(4,null,l))};switch(h){case"env":if(f){if(k){const b=k[I.isWindows?f.toLowerCase():f];if(D.isString(b))return b}return""}throw new Error((0,y.localize)(5,null,l));case"config":if(f){const b=this._context.getConfigurationValue(a,f);if(D.isUndefinedOrNull(b))throw new Error((0,y.localize)(6,null,l,f));if(D.isObject(b))throw new Error((0,y.localize)(7,null,l,f));return b}throw new Error((0,y.localize)(8,null,l));case"command":return this.resolveFromMap(l,f,d,"command");case"input":return this.resolveFromMap(l,f,d,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,S.normalizeDriveLetter)(this.fsPath(p()));case"cwd":return a||f?(0,S.normalizeDriveLetter)(this.fsPath(p())):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return m.basename(this.fsPath(p()));case"lineNumber":const b=this._context.getLineNumber();if(b)return b;throw new Error((0,y.localize)(9,null,l));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,y.localize)(10,null,l));case"file":return w();case"fileWorkspaceFolder":return u();case"relativeFile":return a||f?m.relative(this.fsPath(p()),w()):w();case"relativeFileDirname":const s=m.dirname(w());if(a||f){const g=m.relative(this.fsPath(p()),s);return g.length===0?".":g}return s;case"fileDirname":return m.dirname(w());case"fileExtname":return m.extname(w());case"fileBasename":return m.basename(w());case"fileBasenameNoExtension":const r=m.basename(w());return r.slice(0,r.length-m.extname(r).length);case"fileDirnameBasename":return m.basename(m.dirname(w()));case"execPath":const i=this._context.getExecPath();return i||l;case"execInstallFolder":const c=this._context.getAppRoot();return c||l;case"pathSeparator":return m.sep;default:try{const g=f?`${h}:${f}`:h;return this.resolveFromMap(l,g,d,void 0)}catch(g){return l}}}}resolveFromMap(k,l,h,a){if(l&&h){const d=a===void 0?h[l]:h[a+":"+l];if(typeof d=="string")return d;throw new Error((0,y.localize)(11,null,k))}return k}}e.AbstractVariableResolverService=C,C.VARIABLE_LHS="${",C.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ee[97],_e([0,1,4,165]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,m.createDecorator)("editorGroupsService");var D;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var _;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(_=e.GroupOrientation||(e.GroupOrientation={}));var I;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(I=e.GroupLocation||(e.GroupLocation={}));var S;(function(d){d[d.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",d[d.EVEN=1]="EVEN",d[d.TOGGLE=2]="TOGGLE"})(S=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function C(d){const f=d;return(0,F.isEditorInput)(f?.editor)&&(0,F.isEditorInput)(f?.replacement)}e.isEditorReplacement=C;var n;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(n=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(d){d[d.GROUP_ACTIVE=0]="GROUP_ACTIVE",d[d.GROUP_INDEX=1]="GROUP_INDEX",d[d.EDITOR_OPEN=2]="EDITOR_OPEN",d[d.EDITOR_CLOSE=3]="EDITOR_CLOSE",d[d.EDITOR_MOVE=4]="EDITOR_MOVE",d[d.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",d[d.EDITOR_LABEL=6]="EDITOR_LABEL",d[d.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",d[d.EDITOR_PIN=8]="EDITOR_PIN",d[d.EDITOR_STICKY=9]="EDITOR_STICKY",d[d.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(k=e.GroupChangeKind||(e.GroupChangeKind={}));var l;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(l=e.OpenEditorContext||(e.OpenEditorContext={}));function h(d){const f=d;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.isEditorGroup=h;function a(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=a}),define(Ee[171],_e([0,1,4,97]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,m.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(_){const I=_;return typeof _=="number"||(0,F.isEditorGroup)(I)}e.isPreferredGroup=D}),define(Ee[9],_e([0,1,17,81,227,54,24,10,2,30,58,141,90,65,69,171,6]),function(ee,e,m,F,D,_,I,S,y,C,n,k,l,h,a,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var E;(function(pe){function Ce(U){const{selectionStartLineNumber:Fe,selectionStartColumn:xe,positionLineNumber:Ye,positionColumn:Ge}=U,ut=new f.Position(Fe-1,xe-1),mt=new f.Position(Ye-1,Ge-1);return new f.Selection(ut,mt)}pe.to=Ce;function le(U){const{anchor:Fe,active:xe}=U;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:xe.line+1,positionColumn:xe.character+1}}pe.from=le})(E=e.Selection||(e.Selection={}));var w;(function(pe){function Ce(U){if(!U)return;const{start:Fe,end:xe}=U;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:xe.line+1,endColumn:xe.character+1}}pe.from=Ce;function le(U){if(!U)return;const{startLineNumber:Fe,startColumn:xe,endLineNumber:Ye,endColumn:Ge}=U;return new f.Range(Fe-1,xe-1,Ye-1,Ge-1)}pe.to=le})(w=e.Range||(e.Range={}));var u;(function(pe){function Ce(le){switch(le){case 1:return f.StandardTokenType.Comment;case 0:return f.StandardTokenType.Other;case 4:return f.StandardTokenType.RegEx;case 2:return f.StandardTokenType.String}}pe.to=Ce})(u=e.TokenType||(e.TokenType={}));var p;(function(pe){function Ce(U){return new f.Position(U.lineNumber-1,U.column-1)}pe.to=Ce;function le(U){return{lineNumber:U.line+1,column:U.character+1}}pe.from=le})(p=e.Position||(e.Position={}));var b;(function(pe){function Ce(U){switch(U){case f.DiagnosticTag.Unnecessary:return 1;case f.DiagnosticTag.Deprecated:return 2}}pe.from=Ce;function le(U){switch(U){case 1:return f.DiagnosticTag.Unnecessary;case 2:return f.DiagnosticTag.Deprecated;default:return}}pe.to=le})(b=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(pe){function Ce(U){let Fe;return U.code&&((0,S.isString)(U.code)||(0,S.isNumber)(U.code)?Fe=String(U.code):Fe={value:String(U.code.value),target:U.code.target}),{...w.from(U.range),message:U.message,source:U.source,code:Fe,severity:r.from(U.severity),relatedInformation:U.relatedInformation&&U.relatedInformation.map(s.from),tags:Array.isArray(U.tags)?(0,m.coalesce)(U.tags.map(b.from)):void 0}}pe.from=Ce;function le(U){const Fe=new f.Diagnostic(w.to(U),U.message,r.to(U.severity));return Fe.source=U.source,Fe.code=(0,S.isString)(U.code)?U.code:U.code?.value,Fe.relatedInformation=U.relatedInformation&&U.relatedInformation.map(s.to),Fe.tags=U.tags&&(0,m.coalesce)(U.tags.map(b.to)),Fe}pe.to=le})(t=e.Diagnostic||(e.Diagnostic={}));var s;(function(pe){function Ce(U){return{...w.from(U.location.range),message:U.message,resource:U.location.uri}}pe.from=Ce;function le(U){return new f.DiagnosticRelatedInformation(new f.Location(U.resource,w.to(U)),U.message)}pe.to=le})(s=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var r;(function(pe){function Ce(U){switch(U){case f.DiagnosticSeverity.Error:return l.MarkerSeverity.Error;case f.DiagnosticSeverity.Warning:return l.MarkerSeverity.Warning;case f.DiagnosticSeverity.Information:return l.MarkerSeverity.Info;case f.DiagnosticSeverity.Hint:return l.MarkerSeverity.Hint}return l.MarkerSeverity.Error}pe.from=Ce;function le(U){switch(U){case l.MarkerSeverity.Info:return f.DiagnosticSeverity.Information;case l.MarkerSeverity.Warning:return f.DiagnosticSeverity.Warning;case l.MarkerSeverity.Error:return f.DiagnosticSeverity.Error;case l.MarkerSeverity.Hint:return f.DiagnosticSeverity.Hint;default:return f.DiagnosticSeverity.Error}}pe.to=le})(r=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var i;(function(pe){function Ce(U){return typeof U=="number"&&U>=f.ViewColumn.One?U-1:U===f.ViewColumn.Beside?d.SIDE_GROUP:d.ACTIVE_GROUP}pe.from=Ce;function le(U){if(typeof U=="number"&&U>=0)return U+1;throw new Error("invalid 'EditorGroupColumn'")}pe.to=le})(i=e.ViewColumn||(e.ViewColumn={}));function c(pe){return typeof pe.range!="undefined"}function g(pe){return pe.length===0?!0:!!c(pe[0])}e.isDecorationOptionsArr=g;var v;(function(pe){function Ce(Ge){return Ge.map(pe.from)}pe.fromMany=Ce;function le(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function U(Ge){let ut;if(le(Ge)){const{language:bt,value:gt}=Ge;ut={value:"```"+bt+`
`+gt+"\n```\n"}}else f.MarkdownString.isMarkdownString(Ge)?ut={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons}:typeof Ge=="string"?ut={value:Ge}:ut={value:""};const mt=Object.create(null);ut.uris=mt;const kt=bt=>{try{let gt=y.URI.parse(bt,!0);gt=gt.with({query:Fe(gt.query,mt)}),mt[bt]=gt}catch(gt){}return""},St=new D.Renderer;return St.link=kt,St.image=bt=>kt(F.parseHrefAndDimensions(bt).href),D(ut.value,{renderer:St}),ut}pe.from=U;function Fe(Ge,ut){if(!Ge)return Ge;let mt;try{mt=(0,_.parse)(Ge)}catch(St){}if(!mt)return Ge;let kt=!1;return mt=(0,I.cloneAndChange)(mt,St=>{if(y.URI.isUri(St)){const bt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[bt]=St,kt=!0,bt}else return}),kt?JSON.stringify(mt):Ge}function xe(Ge){const ut=new f.MarkdownString(Ge.value,Ge.supportThemeIcons);return ut.isTrusted=Ge.isTrusted,ut}pe.to=xe;function Ye(Ge){if(!!Ge)return typeof Ge=="string"?Ge:pe.from(Ge)}pe.fromStrict=Ye})(v=e.MarkdownString||(e.MarkdownString={}));function A(pe){return g(pe)?pe.map(Ce=>({range:w.from(Ce.range),hoverMessage:Array.isArray(Ce.hoverMessage)?v.fromMany(Ce.hoverMessage):Ce.hoverMessage?v.from(Ce.hoverMessage):void 0,renderOptions:Ce.renderOptions})):pe.map(Ce=>({range:w.from(Ce)}))}e.fromRangeOrRangeWithMessage=A;function R(pe){return typeof pe=="undefined"?pe:typeof pe=="string"?y.URI.file(pe):pe}e.pathOrURIToURI=R;var o;(function(pe){function Ce(le){return typeof le=="undefined"?le:{contentText:le.contentText,contentIconPath:le.contentIconPath?R(le.contentIconPath):void 0,border:le.border,borderColor:le.borderColor,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,color:le.color,backgroundColor:le.backgroundColor,margin:le.margin,width:le.width,height:le.height}}pe.from=Ce})(o=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var P;(function(pe){function Ce(le){return typeof le=="undefined"?le:{backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?R(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?o.from(le.before):void 0,after:le.after?o.from(le.after):void 0}}pe.from=Ce})(P=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var L;(function(pe){function Ce(le){if(typeof le=="undefined")return le;switch(le){case f.DecorationRangeBehavior.OpenOpen:return 0;case f.DecorationRangeBehavior.ClosedClosed:return 1;case f.DecorationRangeBehavior.OpenClosed:return 2;case f.DecorationRangeBehavior.ClosedOpen:return 3}}pe.from=Ce})(L=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var $;(function(pe){function Ce(le){return{isWholeLine:le.isWholeLine,rangeBehavior:le.rangeBehavior?L.from(le.rangeBehavior):void 0,overviewRulerLane:le.overviewRulerLane,light:le.light?P.from(le.light):void 0,dark:le.dark?P.from(le.dark):void 0,backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?R(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?o.from(le.before):void 0,after:le.after?o.from(le.after):void 0}}pe.from=Ce})($=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var re;(function(pe){function Ce(U){return{text:U.newText,eol:U.newEol&&X.from(U.newEol),range:w.from(U.range)}}pe.from=Ce;function le(U){const Fe=new f.TextEdit(w.to(U.range),U.text);return Fe.newEol=typeof U.eol=="undefined"?void 0:X.to(U.eol),Fe}pe.to=le})(re=e.TextEdit||(e.TextEdit={}));var he;(function(pe){function Ce(U,Fe,xe){const Ye={edits:[]};if(U instanceof f.WorkspaceEdit)for(let Ge of U._allEntries())if(Ge._type===1)Ye.edits.push({_type:1,oldUri:Ge.from,newUri:Ge.to,options:Ge.options,metadata:Ge.metadata});else if(Ge._type===2){const ut=Fe?.getDocument(Ge.uri);Ye.edits.push({_type:2,resource:Ge.uri,edit:re.from(Ge.edit),modelVersionId:ut?.version,metadata:Ge.metadata})}else Ge._type===3?Ye.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:xe?.getNotebookDocument(Ge.uri,!0)?.apiNotebook.version}):Ge._type===5&&Ye.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:xe?.getNotebookDocument(Ge.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(ve.from)}});return Ye}pe.from=Ce;function le(U){const Fe=new f.WorkspaceEdit;for(const xe of U.edits)xe.edit?Fe.replace(y.URI.revive(xe.resource),w.to(xe.edit.range),xe.edit.text):Fe.renameFile(y.URI.revive(xe.oldUri),y.URI.revive(xe.newUri),xe.options);return Fe}pe.to=le})(he=e.WorkspaceEdit||(e.WorkspaceEdit={}));var Q;(function(pe){const Ce=Object.create(null);Ce[f.SymbolKind.File]=0,Ce[f.SymbolKind.Module]=1,Ce[f.SymbolKind.Namespace]=2,Ce[f.SymbolKind.Package]=3,Ce[f.SymbolKind.Class]=4,Ce[f.SymbolKind.Method]=5,Ce[f.SymbolKind.Property]=6,Ce[f.SymbolKind.Field]=7,Ce[f.SymbolKind.Constructor]=8,Ce[f.SymbolKind.Enum]=9,Ce[f.SymbolKind.Interface]=10,Ce[f.SymbolKind.Function]=11,Ce[f.SymbolKind.Variable]=12,Ce[f.SymbolKind.Constant]=13,Ce[f.SymbolKind.String]=14,Ce[f.SymbolKind.Number]=15,Ce[f.SymbolKind.Boolean]=16,Ce[f.SymbolKind.Array]=17,Ce[f.SymbolKind.Object]=18,Ce[f.SymbolKind.Key]=19,Ce[f.SymbolKind.Null]=20,Ce[f.SymbolKind.EnumMember]=21,Ce[f.SymbolKind.Struct]=22,Ce[f.SymbolKind.Event]=23,Ce[f.SymbolKind.Operator]=24,Ce[f.SymbolKind.TypeParameter]=25;function le(Fe){return typeof Ce[Fe]=="number"?Ce[Fe]:6}pe.from=le;function U(Fe){for(const xe in Ce)if(Ce[xe]===Fe)return Number(xe);return f.SymbolKind.Property}pe.to=U})(Q=e.SymbolKind||(e.SymbolKind={}));var z;(function(pe){function Ce(U){switch(U){case f.SymbolTag.Deprecated:return 1}}pe.from=Ce;function le(U){switch(U){case 1:return f.SymbolTag.Deprecated}}pe.to=le})(z=e.SymbolTag||(e.SymbolTag={}));var V;(function(pe){function Ce(U){return{name:U.name,kind:Q.from(U.kind),tags:U.tags&&U.tags.map(z.from),containerName:U.containerName,location:ce.from(U.location)}}pe.from=Ce;function le(U){const Fe=new f.SymbolInformation(U.name,Q.to(U.kind),U.containerName,ce.to(U.location));return Fe.tags=U.tags&&U.tags.map(z.to),Fe}pe.to=le})(V=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var T;(function(pe){function Ce(U){const Fe={name:U.name||"!!MISSING: name!!",detail:U.detail,range:w.from(U.range),selectionRange:w.from(U.selectionRange),kind:Q.from(U.kind),tags:U.tags?.map(z.from)??[]};return U.children&&(Fe.children=U.children.map(Ce)),Fe}pe.from=Ce;function le(U){const Fe=new f.DocumentSymbol(U.name,U.detail,Q.to(U.kind),w.to(U.range),w.to(U.selectionRange));return(0,m.isNonEmptyArray)(U.tags)&&(Fe.tags=U.tags.map(z.to)),U.children&&(Fe.children=U.children.map(le)),Fe}pe.to=le})(T=e.DocumentSymbol||(e.DocumentSymbol={}));var G;(function(pe){function Ce(U){const Fe=new f.CallHierarchyItem(Q.to(U.kind),U.name,U.detail||"",y.URI.revive(U.uri),w.to(U.range),w.to(U.selectionRange));return Fe._sessionId=U._sessionId,Fe._itemId=U._itemId,Fe}pe.to=Ce;function le(U,Fe,xe){if(Fe=Fe??U._sessionId,xe=xe??U._itemId,Fe===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:xe,name:U.name,detail:U.detail,kind:Q.from(U.kind),uri:U.uri,range:w.from(U.range),selectionRange:w.from(U.selectionRange),tags:U.tags?.map(z.from)}}pe.from=le})(G=e.CallHierarchyItem||(e.CallHierarchyItem={}));var B;(function(pe){function Ce(le){return new f.CallHierarchyIncomingCall(G.to(le.from),le.fromRanges.map(U=>w.to(U)))}pe.to=Ce})(B=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var j;(function(pe){function Ce(le){return new f.CallHierarchyOutgoingCall(G.to(le.to),le.fromRanges.map(U=>w.to(U)))}pe.to=Ce})(j=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ce;(function(pe){function Ce(U){return{range:U.range&&w.from(U.range),uri:U.uri}}pe.from=Ce;function le(U){return new f.Location(y.URI.revive(U.uri),w.to(U.range))}pe.to=le})(ce=e.location||(e.location={}));var W;(function(pe){function Ce(U){const Fe=U,xe=U;return{originSelectionRange:Fe.originSelectionRange?w.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:xe.uri,range:w.from(Fe.targetRange?Fe.targetRange:xe.range),targetSelectionRange:Fe.targetSelectionRange?w.from(Fe.targetSelectionRange):void 0}}pe.from=Ce;function le(U){return{targetUri:y.URI.revive(U.uri),targetRange:w.to(U.range),targetSelectionRange:U.targetSelectionRange?w.to(U.targetSelectionRange):void 0,originSelectionRange:U.originSelectionRange?w.to(U.originSelectionRange):void 0}}pe.to=le})(W=e.DefinitionLink||(e.DefinitionLink={}));var te;(function(pe){function Ce(U){return{range:w.from(U.range),contents:v.fromMany(U.contents)}}pe.from=Ce;function le(U){return new f.Hover(U.contents.map(v.to),w.to(U.range))}pe.to=le})(te=e.Hover||(e.Hover={}));var ue;(function(pe){function Ce(U){return{range:w.from(U.range),expression:U.expression}}pe.from=Ce;function le(U){return new f.EvaluatableExpression(w.to(U.range),U.expression)}pe.to=le})(ue=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ye;(function(pe){function Ce(U){if(U instanceof f.InlineValueText)return{type:"text",range:w.from(U.range),text:U.text};if(U instanceof f.InlineValueVariableLookup)return{type:"variable",range:w.from(U.range),variableName:U.variableName,caseSensitiveLookup:U.caseSensitiveLookup};if(U instanceof f.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(U.range),expression:U.expression};throw new Error("Unknown 'InlineValue' type")}pe.from=Ce;function le(U){switch(U.type){case"text":return{range:w.to(U.range),text:U.text};case"variable":return{range:w.to(U.range),variableName:U.variableName,caseSensitiveLookup:U.caseSensitiveLookup};case"expression":return{range:w.to(U.range),expression:U.expression}}}pe.to=le})(ye=e.InlineValue||(e.InlineValue={}));var Te;(function(pe){function Ce(U){return{frameId:U.frameId,stoppedLocation:w.from(U.stoppedLocation)}}pe.from=Ce;function le(U){return new f.InlineValueContext(U.frameId,w.to(U.stoppedLocation))}pe.to=le})(Te=e.InlineValueContext||(e.InlineValueContext={}));var Re;(function(pe){function Ce(U){return{range:w.from(U.range),kind:U.kind}}pe.from=Ce;function le(U){return new f.DocumentHighlight(w.to(U.range),U.kind)}pe.to=le})(Re=e.DocumentHighlight||(e.DocumentHighlight={}));var $e;(function(pe){function Ce(le){switch(le){case 1:return f.CompletionTriggerKind.TriggerCharacter;case 2:return f.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return f.CompletionTriggerKind.Invoke}}pe.to=Ce})($e=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ze;(function(pe){function Ce(le){return{triggerKind:$e.to(le.triggerKind),triggerCharacter:le.triggerCharacter}}pe.to=Ce})(Ze=e.CompletionContext||(e.CompletionContext={}));var Ve;(function(pe){function Ce(U){switch(U){case f.CompletionItemTag.Deprecated:return 1}}pe.from=Ce;function le(U){switch(U){case 1:return f.CompletionItemTag.Deprecated}}pe.to=le})(Ve=e.CompletionItemTag||(e.CompletionItemTag={}));var je;(function(pe){const Ce=new Map([[f.CompletionItemKind.Method,0],[f.CompletionItemKind.Function,1],[f.CompletionItemKind.Constructor,2],[f.CompletionItemKind.Field,3],[f.CompletionItemKind.Variable,4],[f.CompletionItemKind.Class,5],[f.CompletionItemKind.Interface,7],[f.CompletionItemKind.Struct,6],[f.CompletionItemKind.Module,8],[f.CompletionItemKind.Property,9],[f.CompletionItemKind.Unit,12],[f.CompletionItemKind.Value,13],[f.CompletionItemKind.Constant,14],[f.CompletionItemKind.Enum,15],[f.CompletionItemKind.EnumMember,16],[f.CompletionItemKind.Keyword,17],[f.CompletionItemKind.Snippet,27],[f.CompletionItemKind.Text,18],[f.CompletionItemKind.Color,19],[f.CompletionItemKind.File,20],[f.CompletionItemKind.Reference,21],[f.CompletionItemKind.Folder,23],[f.CompletionItemKind.Event,10],[f.CompletionItemKind.Operator,11],[f.CompletionItemKind.TypeParameter,24],[f.CompletionItemKind.Issue,26],[f.CompletionItemKind.User,25]]);function le(xe){return Ce.get(xe)??9}pe.from=le;const U=new Map([[0,f.CompletionItemKind.Method],[1,f.CompletionItemKind.Function],[2,f.CompletionItemKind.Constructor],[3,f.CompletionItemKind.Field],[4,f.CompletionItemKind.Variable],[5,f.CompletionItemKind.Class],[7,f.CompletionItemKind.Interface],[6,f.CompletionItemKind.Struct],[8,f.CompletionItemKind.Module],[9,f.CompletionItemKind.Property],[12,f.CompletionItemKind.Unit],[13,f.CompletionItemKind.Value],[14,f.CompletionItemKind.Constant],[15,f.CompletionItemKind.Enum],[16,f.CompletionItemKind.EnumMember],[17,f.CompletionItemKind.Keyword],[27,f.CompletionItemKind.Snippet],[18,f.CompletionItemKind.Text],[19,f.CompletionItemKind.Color],[20,f.CompletionItemKind.File],[21,f.CompletionItemKind.Reference],[23,f.CompletionItemKind.Folder],[10,f.CompletionItemKind.Event],[11,f.CompletionItemKind.Operator],[24,f.CompletionItemKind.TypeParameter],[25,f.CompletionItemKind.User],[26,f.CompletionItemKind.Issue]]);function Fe(xe){return U.get(xe)??f.CompletionItemKind.Property}pe.to=Fe})(je=e.CompletionItemKind||(e.CompletionItemKind={}));var O;(function(pe){function Ce(le,U){const Fe=new f.CompletionItem(le.label);return Fe.insertText=le.insertText,Fe.kind=je.to(le.kind),Fe.tags=le.tags?.map(Ve.to),Fe.detail=le.detail,Fe.documentation=F.isMarkdownString(le.documentation)?v.to(le.documentation):le.documentation,Fe.sortText=le.sortText,Fe.filterText=le.filterText,Fe.preselect=le.preselect,Fe.commitCharacters=le.commitCharacters,C.Range.isIRange(le.range)?Fe.range=w.to(le.range):typeof le.range=="object"&&(Fe.range={inserting:w.to(le.range.insert),replacing:w.to(le.range.replace)}),Fe.keepWhitespace=typeof le.insertTextRules=="undefined"?!1:Boolean(le.insertTextRules&1),typeof le.insertTextRules!="undefined"&&le.insertTextRules&4?Fe.insertText=new f.SnippetString(le.insertText):(Fe.insertText=le.insertText,Fe.textEdit=Fe.range instanceof f.Range?new f.TextEdit(Fe.range,Fe.insertText):void 0),le.additionalTextEdits&&le.additionalTextEdits.length>0&&(Fe.additionalTextEdits=le.additionalTextEdits.map(xe=>re.to(xe))),Fe.command=U&&le.command?U.fromInternal(le.command):void 0,Fe}pe.to=Ce})(O=e.CompletionItem||(e.CompletionItem={}));var K;(function(pe){function Ce(U){return{label:U.label,documentation:U.documentation?v.fromStrict(U.documentation):void 0}}pe.from=Ce;function le(U){return{label:U.label,documentation:F.isMarkdownString(U.documentation)?v.to(U.documentation):U.documentation}}pe.to=le})(K=e.ParameterInformation||(e.ParameterInformation={}));var J;(function(pe){function Ce(U){return{label:U.label,documentation:U.documentation?v.fromStrict(U.documentation):void 0,parameters:Array.isArray(U.parameters)?U.parameters.map(K.from):[],activeParameter:U.activeParameter}}pe.from=Ce;function le(U){return{label:U.label,documentation:F.isMarkdownString(U.documentation)?v.to(U.documentation):U.documentation,parameters:Array.isArray(U.parameters)?U.parameters.map(K.to):[],activeParameter:U.activeParameter}}pe.to=le})(J=e.SignatureInformation||(e.SignatureInformation={}));var se;(function(pe){function Ce(U){return{activeSignature:U.activeSignature,activeParameter:U.activeParameter,signatures:Array.isArray(U.signatures)?U.signatures.map(J.from):[]}}pe.from=Ce;function le(U){return{activeSignature:U.activeSignature,activeParameter:U.activeParameter,signatures:Array.isArray(U.signatures)?U.signatures.map(J.to):[]}}pe.to=le})(se=e.SignatureHelp||(e.SignatureHelp={}));var q;(function(pe){function Ce(U){return{text:U.text,position:p.from(U.position),kind:ne.from(U.kind??f.InlayHintKind.Other),whitespaceBefore:U.whitespaceBefore,whitespaceAfter:U.whitespaceAfter}}pe.from=Ce;function le(U){const Fe=new f.InlayHint(U.text,p.to(U.position),ne.to(U.kind));return Fe.whitespaceAfter=U.whitespaceAfter,Fe.whitespaceBefore=U.whitespaceBefore,Fe}pe.to=le})(q=e.InlayHint||(e.InlayHint={}));var ne;(function(pe){function Ce(U){return U}pe.from=Ce;function le(U){return U}pe.to=le})(ne=e.InlayHintKind||(e.InlayHintKind={}));var ge;(function(pe){function Ce(U){return{range:w.from(U.range),url:U.target,tooltip:U.tooltip}}pe.from=Ce;function le(U){let Fe;if(U.url)try{Fe=typeof U.url=="string"?y.URI.parse(U.url,!0):y.URI.revive(U.url)}catch(xe){}return new f.DocumentLink(w.to(U.range),Fe)}pe.to=le})(ge=e.DocumentLink||(e.DocumentLink={}));var Me;(function(pe){function Ce(U){const Fe=new f.ColorPresentation(U.label);return U.textEdit&&(Fe.textEdit=re.to(U.textEdit)),U.additionalTextEdits&&(Fe.additionalTextEdits=U.additionalTextEdits.map(xe=>re.to(xe))),Fe}pe.to=Ce;function le(U){return{label:U.label,textEdit:U.textEdit?re.from(U.textEdit):void 0,additionalTextEdits:U.additionalTextEdits?U.additionalTextEdits.map(Fe=>re.from(Fe)):void 0}}pe.from=le})(Me=e.ColorPresentation||(e.ColorPresentation={}));var We;(function(pe){function Ce(U){return new f.Color(U[0],U[1],U[2],U[3])}pe.to=Ce;function le(U){return[U.red,U.green,U.blue,U.alpha]}pe.from=le})(We=e.Color||(e.Color={}));var be;(function(pe){function Ce(U){return{range:w.from(U.range)}}pe.from=Ce;function le(U){return new f.SelectionRange(w.to(U.range))}pe.to=le})(be=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(pe){function Ce(le){switch(le){case 2:return f.TextDocumentSaveReason.AfterDelay;case 1:return f.TextDocumentSaveReason.Manual;case 3:case 4:return f.TextDocumentSaveReason.FocusOut}}pe.to=Ce})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var H;(function(pe){function Ce(U){switch(U){case f.TextEditorLineNumbersStyle.Off:return 0;case f.TextEditorLineNumbersStyle.Relative:return 2;case f.TextEditorLineNumbersStyle.On:default:return 1}}pe.from=Ce;function le(U){switch(U){case 0:return f.TextEditorLineNumbersStyle.Off;case 2:return f.TextEditorLineNumbersStyle.Relative;case 1:default:return f.TextEditorLineNumbersStyle.On}}pe.to=le})(H=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var X;(function(pe){function Ce(U){if(U===f.EndOfLine.CRLF)return 1;if(U===f.EndOfLine.LF)return 0}pe.from=Ce;function le(U){if(U===1)return f.EndOfLine.CRLF;if(U===0)return f.EndOfLine.LF}pe.to=le})(X=e.EndOfLine||(e.EndOfLine={}));var de;(function(pe){function Ce(le){if(typeof le=="object")return le.viewId;switch(le){case f.ProgressLocation.SourceControl:return 3;case f.ProgressLocation.Window:return 10;case f.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}pe.from=Ce})(de=e.ProgressLocation||(e.ProgressLocation={}));var Be;(function(pe){function Ce(le){const U={start:le.start+1,end:le.end+1};return le.kind&&(U.kind=Ue.from(le.kind)),U}pe.from=Ce})(Be=e.FoldingRange||(e.FoldingRange={}));var Ue;(function(pe){function Ce(le){if(le)switch(le){case f.FoldingRangeKind.Comment:return n.FoldingRangeKind.Comment;case f.FoldingRangeKind.Imports:return n.FoldingRangeKind.Imports;case f.FoldingRangeKind.Region:return n.FoldingRangeKind.Region}}pe.from=Ce})(Ue=e.FoldingRangeKind||(e.FoldingRangeKind={}));var tt;(function(pe){function Ce(le){if(le)return{pinned:typeof le.preview=="boolean"?!le.preview:void 0,inactive:le.background,preserveFocus:le.preserveFocus,selection:typeof le.selection=="object"?w.from(le.selection):void 0,override:typeof le.override=="boolean"?k.EditorResolution.DISABLED:void 0}}pe.from=Ce})(tt=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Se;(function(pe){function Ce(U){return U instanceof f.RelativePattern||typeof U=="string"?U:le(U)?new f.RelativePattern(U.base,U.pattern):U}pe.from=Ce;function le(U){const Fe=U;return Fe&&typeof Fe.base=="string"&&typeof Fe.pattern=="string"}})(Se=e.GlobPattern||(e.GlobPattern={}));var De;(function(pe){function Ce(le){if(le){if(Array.isArray(le))return le.map(Ce);if(typeof le=="string")return le;{const U=le;return{language:U.language,scheme:U.scheme,pattern:typeof U.pattern=="undefined"?void 0:Se.from(U.pattern),exclusive:U.exclusive}}}else return}pe.from=Ce})(De=e.LanguageSelector||(e.LanguageSelector={}));var Pe;(function(pe){function Ce(U){return{start:U.start,end:U.end}}pe.from=Ce;function le(U){return new f.NotebookRange(U.start,U.end)}pe.to=le})(Pe=e.NotebookRange||(e.NotebookRange={}));var ie;(function(pe){function Ce(U){return{timing:typeof U.runStartTime=="number"&&typeof U.runEndTime=="number"?{startTime:U.runStartTime,endTime:U.runEndTime}:void 0,executionOrder:U.executionOrder,success:U.lastRunSuccess}}pe.to=Ce;function le(U){return{lastRunSuccess:U.success,runStartTime:U.timing?.startTime,runEndTime:U.timing?.endTime,executionOrder:U.executionOrder}}pe.from=le})(ie=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var oe;(function(pe){function Ce(U){switch(U){case f.NotebookCellKind.Markup:return a.CellKind.Markup;case f.NotebookCellKind.Code:default:return a.CellKind.Code}}pe.from=Ce;function le(U){switch(U){case a.CellKind.Markup:return f.NotebookCellKind.Markup;case a.CellKind.Code:default:return f.NotebookCellKind.Code}}pe.to=le})(oe=e.NotebookCellKind||(e.NotebookCellKind={}));var fe;(function(pe){function Ce(U){const Fe={metadata:U.metadata??Object.create(null),cells:[]};for(let xe of U.cells)f.NotebookCellData.validate(xe),Fe.cells.push(ve.from(xe));return Fe}pe.from=Ce;function le(U){const Fe=new f.NotebookData(U.cells.map(ve.to));return(0,S.isEmptyObject)(U.metadata)||(Fe.metadata=U.metadata),Fe}pe.to=le})(fe=e.NotebookData||(e.NotebookData={}));var ve;(function(pe){function Ce(U){return{cellKind:oe.from(U.kind),language:U.languageId,mime:U.mime,source:U.value,metadata:U.metadata,internalMetadata:ie.from(U.executionSummary??{}),outputs:U.outputs?U.outputs.map(me.from):[]}}pe.from=Ce;function le(U){return new f.NotebookCellData(oe.to(U.cellKind),U.source,U.language,U.mime,U.outputs?U.outputs.map(me.to):void 0,U.metadata,U.internalMetadata?ie.to(U.internalMetadata):void 0)}pe.to=le})(ve=e.NotebookCellData||(e.NotebookCellData={}));var x;(function(pe){function Ce(U){return{mime:U.mime,valueBytes:Array.from(U.data)}}pe.from=Ce;function le(U){return new f.NotebookCellOutputItem(new Uint8Array(U.valueBytes),U.mime)}pe.to=le})(x=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var me;(function(pe){function Ce(U){return{outputId:U.id,items:U.items.map(x.from),metadata:U.metadata}}pe.from=Ce;function le(U){const Fe=U.items.map(x.to);return new f.NotebookCellOutput(Fe,U.outputId,U.metadata)}pe.to=le})(me=e.NotebookCellOutput||(e.NotebookCellOutput={}));var we;(function(pe){function Ce(xe){if(xe!=null){if(xe instanceof f.RelativePattern||typeof xe=="string")return xe;if(Fe(xe))return new f.RelativePattern(xe.base,xe.pattern);if(U(xe))return{include:Se.from(xe.include)||void 0,exclude:Se.from(xe.exclude)||void 0}}}pe.from=Ce;function le(xe){return typeof xe=="string"?xe:Fe(xe)?{base:xe.base,pattern:xe.pattern}:{include:xe.include,exclude:xe.exclude}}pe.to=le;function U(xe){const Ye=xe,Ge=Se.from(Ye.include);if(!(Ge&&Ge instanceof f.RelativePattern||typeof Ge=="string"))return!1;const ut=Se.from(Ye.exclude);return!!(ut&&ut instanceof f.RelativePattern||typeof ut=="string")}function Fe(xe){const Ye=xe;return Ye&&typeof Ye.base=="string"&&typeof Ye.pattern=="string"}})(we=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ie;(function(pe){function Ce(le){return{backgroundColor:le.backgroundColor,borderColor:le.borderColor,top:le.top?o.from(le.top):void 0}}pe.from=Ce})(Ie=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ne;(function(pe){function Ce(le,U,Fe){const xe=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{alignment:le.alignment===f.NotebookCellStatusBarAlignment.Left?1:2,command:U.toInternal(xe,Fe),text:le.text,tooltip:le.tooltip,accessibilityInformation:le.accessibilityInformation,priority:le.priority}}pe.from=Ce})(Ne=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var He;(function(pe){function Ce(le){return{transientOutputs:le?.transientOutputs??!1,transientCellMetadata:le?.transientCellMetadata??{},transientDocumentMetadata:le?.transientDocumentMetadata??{}}}pe.from=Ce})(He=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var et;(function(pe){function Ce(U){return{uri:U.uri,provides:U.provides}}pe.from=Ce;function le(U){return new f.NotebookRendererScript(y.URI.revive(U.uri),U.provides)}pe.to=le})(et=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Ke;(function(pe){function Ce(U){return{message:v.fromStrict(U.message)||"",severity:U.severity,expectedOutput:U.expectedOutput,actualOutput:U.actualOutput,location:U.location?ce.from(U.location):void 0}}pe.from=Ce;function le(U){const Fe=new f.TestMessage(typeof U.message=="string"?U.message:v.to(U.message));return Fe.severity=U.severity,Fe.actualOutput=U.actualOutput,Fe.expectedOutput=U.expectedOutput,Fe}pe.to=le})(Ke=e.TestMessage||(e.TestMessage={}));var Qe;(function(pe){function Ce(Ye){return{extId:Ye.id,label:Ye.label,uri:Ye.uri,range:w.from(Ye.range)||null,description:Ye.description||null,error:Ye.error&&v.fromStrict(Ye.error)||null}}pe.from=Ce;function le(Ye){return{extId:Ye.id,label:Ye.label,uri:Ye.uri,range:w.from(Ye.range)||null,description:Ye.description||null,error:null}}pe.fromResultSnapshot=le;function U(Ye){return{id:Ye.extId,label:Ye.label,uri:y.URI.revive(Ye.uri),range:w.to(Ye.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Ye.description||void 0}}pe.toPlain=U;function Fe(Ye){const Ge=new h.TestItemImpl(Ye.extId,Ye.label,y.URI.revive(Ye.uri));return Ge.range=w.to(Ye.range||void 0),Ge.description=Ye.description||void 0,Ge}pe.to=Fe;function xe(Ye){let Ge;for(const ut of Ye.tests){const mt=Fe(ut.item);(0,h.getPrivateApiFor)(mt).parent=Ge,Ge=mt}return Ge}pe.toItemFromContext=xe})(Qe=e.TestItem||(e.TestItem={}));var lt;(function(pe){const Ce=(U,Fe)=>({...Qe.toPlain(U.item),taskStates:U.tasks.map(xe=>({state:xe.state,duration:xe.duration,messages:xe.messages.map(Ke.to)})),children:U.children.map(xe=>Fe.get(xe)).filter(S.isDefined).map(xe=>Ce(xe,Fe))});function le(U){const Fe=[],xe=new Map;for(const Ye of U.items)xe.set(Ye.item.extId,Ye),U.request.targets.some(Ge=>Ge.controllerId===Ye.controllerId&&Ge.testIds.includes(Ye.item.extId))&&Fe.push(Ye);return{completedAt:U.completedAt,results:Fe.map(Ye=>Ce(Ye,xe))}}pe.to=le})(lt=e.TestResults||(e.TestResults={}));var dt;(function(pe){function Ce(xe){return{covered:xe.covered,total:xe.covered}}function le(xe){return"line"in xe?p.from(xe):w.from(xe)}function U(xe){return"branches"in xe?{count:xe.executionCount,location:le(xe.location),type:1,branches:xe.branches.length?xe.branches.map(Ye=>({count:Ye.executionCount,location:Ye.location&&le(Ye.location)})):void 0}:{type:0,count:xe.executionCount,location:le(xe.location)}}pe.fromDetailed=U;function Fe(xe){return{uri:xe.uri,statement:Ce(xe.statementCoverage),branch:xe.branchCoverage&&Ce(xe.branchCoverage),function:xe.functionCoverage&&Ce(xe.functionCoverage),details:xe.detailedCoverage?.map(U)}}pe.fromFile=Fe})(dt=e.TestCoverage||(e.TestCoverage={}));var _t;(function(pe){function Ce(le){switch(le){case 1:return f.CodeActionTriggerKind.Invoke;case 2:return f.CodeActionTriggerKind.Automatic}}pe.to=Ce})(_t=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var at;(function(pe){function Ce(U){const Fe=new f.TypeHierarchyItem(Q.to(U.kind),U.name,U.detail||"",y.URI.revive(U.uri),w.to(U.range),w.to(U.selectionRange));return Fe._sessionId=U._sessionId,Fe._itemId=U._itemId,Fe}pe.to=Ce;function le(U,Fe,xe){if(Fe=Fe??U._sessionId,xe=xe??U._itemId,Fe===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:xe,kind:Q.from(U.kind),name:U.name,detail:U.detail??"",uri:U.uri,range:w.from(U.range),selectionRange:w.from(U.selectionRange),tags:U.tags?.map(z.from)}}pe.from=le})(at=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(Ee[172],_e([0,1,2,12,6,9,78]),function(ee,e,m,F,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class S{constructor(C,n,k,l={timeout:1500,errors:3}){this._logService=C,this._documents=n,this._mainThreadBulkEdits=k,this._thresholds=l,this._callbacks=new I.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(n,k,l)=>{const a={dispose:this._callbacks.push([n,k,C])};return Array.isArray(l)&&l.push(a),a}}async $participateInSave(C,n){const k=m.URI.revive(C);let l=!1;const h=setTimeout(()=>l=!0,this._thresholds.timeout),a=[];try{for(let d of[...this._callbacks]){if(l)break;const f=this._documents.getDocument(k),E=await this._deliverEventAsyncAndBlameBadListeners(d,{document:f,reason:_.TextDocumentSaveReason.to(n)});a.push(E)}}finally{clearTimeout(h)}return a}_deliverEventAsyncAndBlameBadListeners([C,n,k],l){const h=this._badListeners.get(C);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,C,n,l).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const d=this._badListeners.get(C);this._badListeners.set(C,d?d+1:1),typeof d=="number"&&d>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,n,k,l){const h=[],a=Date.now(),{document:d,reason:f}=l,{version:E}=d,w=Object.freeze({document:d,reason:f,waitUntil(u){if(Object.isFrozen(h))throw(0,F.illegalState)("waitUntil can not be called async");h.push(Promise.resolve(u))}});try{n.apply(k,[w])}catch(u){return Promise.reject(u)}return Object.freeze(h),new Promise((u,p)=>{const b=setTimeout(()=>p(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(b),u(t)}).catch(t=>{clearTimeout(b),p(t)})}).then(u=>{const p={edits:[]};for(const b of u)if(Array.isArray(b)&&b.every(t=>t instanceof D.TextEdit))for(const{newText:t,newEol:s,range:r}of b)p.edits.push({_type:2,resource:d.uri,edit:{range:r&&_.Range.from(r),text:t,eol:s&&_.EndOfLine.from(s)}});if(p.edits.length!==0)return E===d.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(p):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=S}),define(Ee[173],_e([0,1,3,27,2,9,6]),function(ee,e,m,F,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{constructor(n,k,l,h,a){this._onDidCreate=new m.Emitter,this._onDidChange=new m.Emitter,this._onDidDelete=new m.Emitter,this._config=0,l&&(this._config+=1),h&&(this._config+=2),a&&(this._config+=4);const d=(0,F.parse)(k),f=n(E=>{if(!l)for(let w of E.created){const u=D.URI.revive(w);d(u.fsPath)&&this._onDidCreate.fire(u)}if(!h)for(let w of E.changed){const u=D.URI.revive(w);d(u.fsPath)&&this._onDidChange.fire(u)}if(!a)for(let w of E.deleted){const u=D.URI.revive(w);d(u.fsPath)&&this._onDidDelete.fire(u)}});this._disposable=I.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,f)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class y{constructor(n,k,l){this._logService=k,this._extHostDocumentsAndEditors=l,this._onFileSystemEvent=new m.Emitter,this._onDidRenameFile=new m.Emitter,this._onDidCreateFile=new m.Emitter,this._onDidDeleteFile=new m.Emitter,this._onWillRenameFile=new m.AsyncEmitter,this._onWillCreateFile=new m.AsyncEmitter,this._onWillDeleteFile=new m.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(n,k,l,h){return new S(this._onFileSystemEvent.event,n,k,l,h)}$onFileEvent(n){this._onFileSystemEvent.fire(n)}$onDidRunFileOperation(n,k){switch(n){case 2:this._onDidRenameFile.fire(Object.freeze({files:k.map(l=>({oldUri:D.URI.revive(l.source),newUri:D.URI.revive(l.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:k.map(l=>D.URI.revive(l.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:k.map(l=>D.URI.revive(l.target))}));break;default:}}getOnWillRenameFileEvent(n){return this._createWillExecuteEvent(n,this._onWillRenameFile)}getOnWillCreateFileEvent(n){return this._createWillExecuteEvent(n,this._onWillCreateFile)}getOnWillDeleteFileEvent(n){return this._createWillExecuteEvent(n,this._onWillDeleteFile)}_createWillExecuteEvent(n,k){return(l,h,a)=>{const d=function(E){l.call(h,E)};return d.extension=n,k.event(d,void 0,a)}}async $onWillRunFileOperation(n,k,l,h){switch(n){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:k.map(a=>({oldUri:D.URI.revive(a.source),newUri:D.URI.revive(a.target)}))},l,h);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:k.map(a=>D.URI.revive(a.target))},l,h);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:k.map(a=>D.URI.revive(a.target))},l,h)}}async _fireWillEvent(n,k,l,h){const a=new Set,d=[];if(await n.fireAsync(k,h,async(E,w)=>{const u=Date.now(),p=await Promise.resolve(E);p instanceof I.WorkspaceEdit&&(d.push(p),a.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-u>l&&this._logService.warn("SLOW file-participant",w.extension.identifier)}),h.isCancellationRequested||d.length===0)return;const f={edits:[]};for(let E of d){let{edits:w}=_.WorkspaceEdit.from(E,this._extHostDocumentsAndEditors);f.edits=f.edits.concat(w)}return{edit:f,extensionNames:Array.from(a)}}}e.ExtHostFileSystemEventService=y}),define(Ee[174],_e([0,1,11,24,2,9,6,69]),function(ee,e,m,F,D,_,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(l,h,a,d){this.start=l,this.deletedCount=h,this.deletedItems=a,this.items=d}static asApiEvents(l){return l.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(a=>a.apiCell)}))}}class C{constructor(l,h,a){this.notebook=l,this._extHostDocument=h,this._cellData=a,this.handle=a.handle,this.uri=D.URI.revive(a.uri),this.cellKind=a.cellKind,this._outputs=a.outputs.map(_.NotebookCellOutput.to),this._internalMetadata=a.internalMetadata??{},this._metadata=a.metadata??{},this._previousResult=_.NotebookCellExecutionSummary.to(a.internalMetadata??{})}static asModelAddData(l,h){return{EOL:h.eol,lines:h.source,modeId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:l}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const l=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return l.notebook.getCellIndex(l)},notebook:l.notebook.apiNotebook,kind:_.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get mime(){return l._mime},set mime(a){l._mime=a},get outputs(){return l._outputs.slice(0)},get metadata(){return l._metadata},get executionSummary(){return l._previousResult}})}return this._apiCell}setOutputs(l){this._outputs=l.map(_.NotebookCellOutput.to)}setOutputItems(l,h,a){const d=a.map(_.NotebookCellOutputItem.to),f=this._outputs.find(E=>E.id===l);f&&(h||(f.items.length=0),f.items.push(...d))}setMetadata(l){this._metadata=l}setInternalMetadata(l){this._internalMetadata=l,this._previousResult=_.NotebookCellExecutionSummary.to(l)}setMime(l){}}e.ExtHostCell=C;class n{constructor(l,h,a,d,f,E){this._proxy=l,this._textDocumentsAndEditors=h,this._textDocuments=a,this._emitter=d,this.uri=f,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=E.viewType,this._metadata=E.metadata??Object.create(null),this._spliceNotebookCells([[0,0,E.cells]],!0),this._versionId=E.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const l=this;this._notebook={get uri(){return l.uri},get version(){return l._versionId},get notebookType(){return l._notebookType},get isDirty(){return l._isDirty},get isUntitled(){return l.uri.scheme===m.Schemas.untitled},get isClosed(){return l._disposed},get metadata(){return l._metadata},get cellCount(){return l._cells.length},cellAt(h){return h=l._validateIndex(h),l._cells[h].apiCell},getCells(h){return(h?l._getCells(h):l._cells).map(d=>d.apiCell)},save(){return l._save()}}}return this._notebook}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(l){l.metadata&&(this._metadata={...this._metadata,...l.metadata})}acceptDirty(l){this._isDirty=l}acceptModelChanged(l,h){this._versionId=l.versionId,this._isDirty=h;for(const a of l.rawEvents)a.kind===S.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1):a.kind===S.NotebookCellsChangeType.Move?this._moveCell(a.index,a.newIdx):a.kind===S.NotebookCellsChangeType.Output?this._setCellOutputs(a.index,a.outputs):a.kind===S.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems):a.kind===S.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(a.index,a.language):a.kind===S.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(a.index,a.mime):a.kind===S.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(a.index,a.metadata):a.kind===S.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(a.index,a.internalMetadata)}_validateIndex(l){return l=l|0,l<0?0:l>=this._cells.length?this._cells.length-1:l}_validateRange(l){let h=l.start|0,a=l.end|0;return h<0&&(h=0),a>this._cells.length&&(a=this._cells.length),l.with({start:h,end:a})}_getCells(l){l=this._validateRange(l);const h=[];for(let a=l.start;a<l.end;a++)h.push(this._cells[a]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(l,h){if(this._disposed)return;const a=[],d=[],f=[];l.reverse().forEach(E=>{const u=E[2].map(t=>{const s=new C(this,this._textDocumentsAndEditors,t);return h||d.push(C.asModelAddData(this.apiNotebook,t)),s}),p=new y(E[0],E[1],[],u),b=this._cells.splice(E[0],E[1],...u);for(const t of b)f.push(t.uri),p.deletedItems.push(t.apiCell);a.push(p)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:f}),h||this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(a)}))}_moveCell(l,h){const a=this._cells.splice(l,1);this._cells.splice(h,0,...a);const d=[new y(l,1,a.map(f=>f.apiCell),[]),new y(h,0,[],a)];this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(d)}))}_setCellOutputs(l,h){const a=this._cells[l];a.setOutputs(h),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[a.apiCell]}))}_setCellOutputItems(l,h,a,d){const f=this._cells[l];f.setOutputItems(h,a,d),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[f.apiCell]}))}_changeCellLanguage(l,h){const a=this._cells[l];a.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(a.uri,h)}_changeCellMime(l,h){const a=this._cells[l];a.apiCell.mime=h}_changeCellMetadata(l,h){const a=this._cells[l],d=a.apiCell.metadata;a.setMetadata(h);const f=a.apiCell.metadata;(0,F.equals)(d,f)||this._emitter.emitCellMetadataChange((0,F.deepFreeze)({document:this.apiNotebook,cell:a.apiCell}))}_changeCellInternalMetadata(l,h){const a=this._cells[l],d=a.internalMetadata;if(a.setInternalMetadata(h),d.runState!==h.runState){const f=h.runState??I.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,F.deepFreeze)({document:this.apiNotebook,cell:a.apiCell,state:f}))}}getCellFromApiCell(l){return this._cells.find(h=>h.apiCell===l)}getCellFromIndex(l){return this._cells[l]}getCell(l){return this._cells.find(h=>h.handle===l)}getCellIndex(l){return this._cells.indexOf(l)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(Ee[98],_e([0,1,6,9,12]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class _{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,C){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:y,metadata:C})}replaceCells(y,C,n){this._throwIfFinalized(),!(y===C&&n.length===0)&&this._collectedEdits.push({editType:1,index:y,count:C-y,cells:n.map(F.NotebookCellData.from)})}}class I{constructor(y,C,n,k,l,h){this.id=y,this._proxy=C,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._visibleRanges=k,this._viewColumn=h}get apiEditor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.apiNotebook},get selections(){return y._selections},set selections(C){if(!Array.isArray(C)||!C.every(m.NotebookRange.isNotebookRange))throw(0,D.illegalArgument)("selections");y._selections=C,y._trySetSelections(C)},get visibleRanges(){return y._visibleRanges},revealRange(C,n){y._proxy.$tryRevealRange(y.id,F.NotebookRange.from(C),n??m.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},edit(C){const n=new _(this.document.version);return C(n),y._applyEdit(n.finalize())},setDecorations(C,n){return y.setDecorations(C,n)}},I.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_trySetSelections(y){this._proxy.$trySetSelections(this.id,y.map(F.NotebookRange.from))}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const C=[];let n=-1;for(let k=0;k<y.cellEdits.length;k++){if(n<0){C.push(y.cellEdits[k]),n++;continue}const h=C[n],a=y.cellEdits[k];if(h.editType===1&&a.editType===1&&h.index===a.index){h.cells.push(...y.cellEdits[k].cells),h.count+=y.cellEdits[k].count;continue}C.push(y.cellEdits[k]),n++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,C)}setDecorations(y,C){if(!(C.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return C.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,F.NotebookRange.from(C),y.key)}}e.ExtHostNotebookEditor=I,I.apiEditorsToExtHost=new WeakMap}),define(Ee[175],_e([0,1,9,151,131,18,48]),function(ee,e,m,F,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(k){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=k}withProgress(k,l,h){const a=this._handles++,{title:d,location:f,cancellable:E}=l,w={label:(0,D.localize)(0,null,k.displayName||k.name),id:k.identifier.value};return this._proxy.$startProgress(a,{location:m.ProgressLocation.from(f),title:d,source:w,cancellable:E},k),this._withProgress(a,h,!!E)}_withProgress(k,l,h){let a;h&&(a=new _.CancellationTokenSource,this._mapHandleToCancellationSource.set(k,a));const d=E=>{this._proxy.$progressEnd(E),this._mapHandleToCancellationSource.delete(E),a&&a.dispose()};let f;try{f=l(new C(this._proxy,k),h&&a?a.token:_.CancellationToken.None)}catch(E){throw d(k),E}return f.then(E=>d(k),E=>d(k)),f}$acceptProgressCanceled(k){const l=this._mapHandleToCancellationSource.get(k);l&&(l.cancel(),this._mapHandleToCancellationSource.delete(k))}}e.ExtHostProgress=S;function y(n,k){return n.message=k.message,typeof k.increment=="number"&&(typeof n.increment=="number"?n.increment+=k.increment:n.increment=k.increment),n}class C extends F.Progress{constructor(k,l){super(h=>this.throttledReport(h));this._proxy=k,this._handle=l}throttledReport(k){this._proxy.$progressReport(this._handle,k)}}ze([(0,I.throttle)(100,(n,k)=>y(n,k),()=>Object.create(null))],C.prototype,"throttledReport",null)}),define(Ee[99],_e([0,1,39,12,50,9,6]),function(ee,e,m,F,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class S{constructor(l,h,a){const d=S._Keys.nextId();l.$registerTextEditorDecorationType(h.identifier,d,_.DecorationRenderOptions.from(a)),this.value=Object.freeze({key:d,dispose(){l.$removeTextEditorDecorationType(d)}})}}e.TextEditorDecorationType=S,S._Keys=new D.IdGenerator("TextEditorDecorationType");class y{constructor(l,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,h){this._throwIfFinalized();let a=null;if(l instanceof I.Position)a=new I.Range(l,l);else if(l instanceof I.Range)a=l;else throw new Error("Unrecognized location");this._pushEdit(a,h,!1)}insert(l,h){this._throwIfFinalized(),this._pushEdit(new I.Range(l,l),h,!0)}delete(l){this._throwIfFinalized();let h=null;if(l instanceof I.Range)h=l;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(l,h,a){const d=this._document.validateRange(l);this._collectedEdits.push({range:d,text:h,forceMoveMarkers:a})}setEndOfLine(l){if(this._throwIfFinalized(),l!==I.EndOfLine.LF&&l!==I.EndOfLine.CRLF)throw(0,F.illegalArgument)("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=y;class C{constructor(l,h,a,d){this._proxy=l,this._id=h,this._accept(a),this._logService=d;const f=this;this.value={get tabSize(){return f._tabSize},set tabSize(E){f._setTabSize(E)},get insertSpaces(){return f._insertSpaces},set insertSpaces(E){f._setInsertSpaces(E)},get cursorStyle(){return f._cursorStyle},set cursorStyle(E){f._setCursorStyle(E)},get lineNumbers(){return f._lineNumbers},set lineNumbers(E){f._setLineNumbers(E)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=_.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const h=Math.floor(l);return h>0?h:null}if(typeof l=="string"){const h=parseInt(l,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(l){const h=this._validateTabSize(l);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const h=this._validateInsertSpaces(l);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:_.TextEditorLineNumbersStyle.from(l)})))}assign(l){const h={};let a=!1;if(typeof l.tabSize!="undefined"){const d=this._validateTabSize(l.tabSize);d==="auto"?(a=!0,h.tabSize=d):typeof d=="number"&&this._tabSize!==d&&(this._tabSize=d,a=!0,h.tabSize=d)}if(typeof l.insertSpaces!="undefined"){const d=this._validateInsertSpaces(l.insertSpaces);d==="auto"?(a=!0,h.insertSpaces=d):this._insertSpaces!==d&&(this._insertSpaces=d,a=!0,h.insertSpaces=d)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,a=!0,h.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,a=!0,h.lineNumbers=_.TextEditorLineNumbersStyle.from(l.lineNumbers)),a&&this._warnOnError(this._proxy.$trySetOptions(this._id,h))}_warnOnError(l){l.catch(h=>this._logService.warn(h))}}e.ExtHostTextEditorOptions=C;class n{constructor(l,h,a,d,f,E,w,u){this.id=l,this._proxy=h,this._logService=a,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=f,this._options=new C(this._proxy,this.id,E,a),this._visibleRanges=w,this._viewColumn=u;const p=this;this.value=Object.freeze({get document(){return d.getValue()},set document(b){throw(0,F.readonly)("document")},get selection(){return p._selections&&p._selections[0]},set selection(b){if(!(b instanceof I.Selection))throw(0,F.illegalArgument)("selection");p._selections=[b],p._trySetSelection()},get selections(){return p._selections},set selections(b){if(!Array.isArray(b)||b.some(t=>!(t instanceof I.Selection)))throw(0,F.illegalArgument)("selections");p._selections=b,p._trySetSelection()},get visibleRanges(){return p._visibleRanges},set visibleRanges(b){throw(0,F.readonly)("visibleRanges")},get options(){return p._options.value},set options(b){p._disposed||p._options.assign(b)},get viewColumn(){return p._viewColumn},set viewColumn(b){throw(0,F.readonly)("viewColumn")},edit(b,t={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new y(d.getValue(),t);return b(s),p._applyEdit(s)},insertSnippet(b,t,s={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=p._selections.map(i=>_.Range.from(i));else if(t instanceof I.Position){const{lineNumber:i,column:c}=_.Position.from(t);r=[{startLineNumber:i,startColumn:c,endLineNumber:i,endColumn:c}]}else if(t instanceof I.Range)r=[_.Range.from(t)];else{r=[];for(const i of t)if(i instanceof I.Range)r.push(_.Range.from(i));else{const{lineNumber:c,column:g}=_.Position.from(i);r.push({startLineNumber:c,startColumn:g,endLineNumber:c,endColumn:g})}}return h.$tryInsertSnippet(l,b.value,r,s)},setDecorations(b,t){const s=t.length===0;s&&!p._hasDecorationsForKey.has(b.key)||(s?p._hasDecorationsForKey.delete(b.key):p._hasDecorationsForKey.add(b.key),p._runOnProxy(()=>{if(_.isDecorationOptionsArr(t))return h.$trySetDecorations(l,b.key,_.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let i=0,c=t.length;i<c;i++){const g=t[i];r[4*i]=g.start.line+1,r[4*i+1]=g.start.character+1,r[4*i+2]=g.end.line+1,r[4*i+3]=g.end.character+1}return h.$trySetDecorationsFast(l,b.key,r)}}))},revealRange(b,t){p._runOnProxy(()=>h.$tryRevealRange(l,_.Range.from(b),t||I.TextEditorRevealType.Default))},show(b){h.$tryShowEditor(l,_.ViewColumn.from(b))},hide(){h.$tryHideEditor(l)}})}dispose(){(0,m.ok)(!this._disposed),this._disposed=!0}_acceptOptions(l){(0,m.ok)(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){(0,m.ok)(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){(0,m.ok)(!this._disposed),this._viewColumn=l}_acceptSelections(l){(0,m.ok)(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(_.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const h=l.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const a=h.edits.map(f=>f.range);a.sort((f,E)=>f.end.line===E.end.line?f.end.character===E.end.character?f.start.line===E.start.line?f.start.character-E.start.character:f.start.line-E.start.line:f.end.character-E.end.character:f.end.line-E.end.line);for(let f=0,E=a.length-1;f<E;f++){const w=a[f].end;if(a[f+1].start.isBefore(w))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=h.edits.map(f=>({range:_.Range.from(f.range),text:f.text,forceMoveMarkers:f.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,d,{setEndOfLine:typeof h.setEndOfLine=="number"?_.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=n}),define(Ee[176],_e([0,1,134,25,2,3,7,16,6,10,17,9,18]),function(ee,e,m,F,D,_,I,S,y,C,n,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(f,E){if((0,C.isString)(f))return{label:f};if(f&&typeof f=="object"&&typeof f.label=="string"){let w;return Array.isArray(f.highlights)&&(w=f.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),w=w.length?w:void 0),{label:f.label,highlights:w}}}class a{constructor(E,w,u){this._proxy=E,this.commands=w,this.logService=u,this.treeViews=new Map;function p(b){return b&&b.$treeViewId&&b.$treeItemHandle}w.registerArgumentProcessor({processArgument:b=>p(b)?this.convertArgument(b):Array.isArray(b)&&b.length>0?b.map(t=>p(t)?this.convertArgument(t):t):b})}registerTreeDataProvider(E,w,u){const p=this.createTreeView(E,{treeDataProvider:w},u);return{dispose:()=>p.dispose()}}createTreeView(E,w,u){if(!w||!w.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const p=w.dragAndDropController!==void 0,b=this._proxy.$registerTreeViewDataProvider(E,{showCollapseAll:!!w.showCollapseAll,canSelectMany:!!w.canSelectMany,canDragAndDrop:p}),t=this.createExtHostTreeView(E,w,u);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(s){t.message=s},get title(){return t.title},set title(s){t.title=s},get description(){return t.description},set description(s){t.description=s},reveal:(s,r)=>t.reveal(s,r),dispose:async()=>{await b,this.treeViews.delete(E),t.dispose()}}}$getChildren(E,w){const u=this.treeViews.get(E);return u?u.getChildren(w):Promise.reject(new Error((0,m.localize)(0,null,E)))}$onDrop(E,w,u){const p=this.treeViews.get(E);return p?p.onDrop(w,u):Promise.reject(new Error((0,m.localize)(1,null,E)))}async $hasResolve(E){const w=this.treeViews.get(E);if(!w)throw new Error((0,m.localize)(2,null,E));return w.hasResolve}$resolve(E,w,u){const p=this.treeViews.get(E);if(!p)throw new Error((0,m.localize)(3,null,E));return p.resolveTreeItem(w,u)}$setExpanded(E,w,u){const p=this.treeViews.get(E);if(!p)throw new Error((0,m.localize)(4,null,E));p.setExpanded(w,u)}$setSelection(E,w){const u=this.treeViews.get(E);if(!u)throw new Error((0,m.localize)(5,null,E));u.setSelection(w)}$setVisible(E,w){const u=this.treeViews.get(E);if(!u)throw new Error((0,m.localize)(6,null,E));u.setVisible(w)}createExtHostTreeView(E,w,u){const p=new d(E,w,this._proxy,this.commands.converter,this.logService,u);return this.treeViews.set(E,p),p}convertArgument(E){const w=this.treeViews.get(E.$treeViewId);return w?w.getExtensionElement(E.$treeItemHandle):null}}e.ExtHostTreeViews=a;class d extends I.Disposable{constructor(E,w,u,p,b,t){super();if(this.viewId=E,this.proxy=u,this.commands=p,this.logService=b,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new _.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new _.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new _.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new _.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new _.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new l.CancellationTokenSource,t.contributes&&t.contributes.views)for(const i in t.contributes.views)for(const c of t.contributes.views[i])c.id===E&&(this._title=c.name);this.dataProvider=w.treeDataProvider,this.dndController=w.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(i=>this._onDidChangeData.fire({message:!1,element:i}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(i=>this._onDidChangeData.fire({message:!1,element:i})));let s,r;this._register(_.Event.debounce(this._onDidChangeData.event,(i,c)=>(i||(i={message:!1,elements:[]}),c.element!==!1&&(s||(s=new Promise(g=>r=g),this.refreshPromise=this.refreshPromise.then(()=>s)),Array.isArray(c.element)?i.elements.push(...c.element):i.elements.push(c.element)),c.message&&(i.message=!0),i),200,!0)(({message:i,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const g=r;return s=null,this.refresh(c).then(()=>g())})),i&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(E=>this.getExtensionElement(E)).filter(E=>!(0,C.isUndefinedOrNull)(E))}getChildren(E){const w=E?this.getExtensionElement(E):void 0;if(E&&!w)return this.logService.error(`No tree item with id '${E}' found.`),Promise.resolve([]);const u=this.getChildrenNodes(E);return(u?Promise.resolve(u):this.fetchChildrenNodes(w)).then(p=>p.map(b=>b.item))}getExtensionElement(E){return this.elements.get(E)}reveal(E,w){w=w||{select:!0,focus:!1};const u=(0,C.isUndefinedOrNull)(w.select)?!0:w.select,p=(0,C.isUndefinedOrNull)(w.focus)?!1:w.focus,b=(0,C.isUndefinedOrNull)(w.expand)?!1:w.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):E?this.refreshPromise.then(()=>this.resolveUnknownParentChain(E)).then(t=>this.resolveTreeNode(E,t[t.length-1]).then(s=>this.proxy.$reveal(this.viewId,{item:s.item,parentChain:t.map(r=>r.item)},{select:u,focus:p,expand:b})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:u,focus:p,expand:b})}get message(){return this._message}set message(E){this._message=E,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(E){this._title=E,this.proxy.$setTitle(this.viewId,E,this._description)}get description(){return this._description}set description(E){this._description=E,this.proxy.$setTitle(this.viewId,this._title,E)}setExpanded(E,w){const u=this.getExtensionElement(E);u&&(w?this._onDidExpandElement.fire(Object.freeze({element:u})):this._onDidCollapseElement.fire(Object.freeze({element:u})))}setSelection(E){(0,n.equals)(this._selectedHandles,E)||(this._selectedHandles=E,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(E){E!==this._visible&&(this._visible=E,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(E,w){const u=E.map(b=>this.getExtensionElement(b)).filter(b=>!(0,C.isUndefinedOrNull)(b)),p=this.getExtensionElement(w);return u&&p?(0,S.asPromise)(()=>this.dndController?.onDrop(u,p)):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(E,w){if(!this.dataProvider.resolveTreeItem)return;const u=this.elements.get(E);if(u){const p=this.nodes.get(u);if(p){const b=await this.dataProvider.resolveTreeItem(p.extensionItem,u,w)??p.extensionItem;return p.item.tooltip=this.getTooltip(b.tooltip),p.item.command=this.getCommand(p.disposableStore,b.command),p.item}}}resolveUnknownParentChain(E){return this.resolveParent(E).then(w=>w?this.resolveUnknownParentChain(w).then(u=>this.resolveTreeNode(w,u[u.length-1]).then(p=>(u.push(p),u))):Promise.resolve([]))}resolveParent(E){const w=this.nodes.get(E);return w?Promise.resolve(w.parent?this.elements.get(w.parent.item.handle):void 0):(0,S.asPromise)(()=>this.dataProvider.getParent(E))}resolveTreeNode(E,w){const u=this.nodes.get(E);return u?Promise.resolve(u):(0,S.asPromise)(()=>this.dataProvider.getTreeItem(E)).then(p=>this.createHandle(E,p,w,!0)).then(p=>this.getChildren(w?w.item.handle:void 0).then(()=>{const b=this.getExtensionElement(p);if(b){const t=this.nodes.get(b);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${p}`)}))}getChildrenNodes(E){if(E){let w;if(typeof E=="string"){const u=this.getExtensionElement(E);w=u?this.nodes.get(u):void 0}else w=E;return w&&w.children||null}return this.roots}async fetchChildrenNodes(E){this.clearChildren(E);const w=new l.CancellationTokenSource(this._refreshCancellationSource.token);try{const u=E?this.nodes.get(E):void 0,p=await this.dataProvider.getChildren(E);if(w.token.isCancellationRequested)return[];const b=await Promise.all((0,n.coalesce)(p||[]).map(async t=>{const s=await this.dataProvider.getTreeItem(t);return s&&!w.token.isCancellationRequested?this.createAndRegisterTreeNode(t,s,u):null}));return w.token.isCancellationRequested?[]:(0,n.coalesce)(b)}finally{w.dispose()}}refresh(E){if(E.some(u=>!u))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new l.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const u=this.getHandlesToRefresh(E);if(u.length)return this.refreshHandles(u)}return Promise.resolve(void 0)}getHandlesToRefresh(E){const w=new Set,u=E.map(b=>this.nodes.get(b));for(const b of u)if(b&&!w.has(b.item.handle)){let t=b;for(;t&&t.parent&&u.findIndex(s=>t&&t.parent&&s&&s.item.handle===t.parent.item.handle)===-1;){const s=this.elements.get(t.parent.item.handle);t=s?this.nodes.get(s):void 0}t&&!t.parent&&w.add(b.item.handle)}const p=[];return w.forEach(b=>{const t=this.elements.get(b);if(t){const s=this.nodes.get(t);s&&(!s.parent||!w.has(s.parent.item.handle))&&p.push(b)}}),p}refreshHandles(E){const w={};return Promise.all(E.map(u=>this.refreshNode(u).then(p=>{p&&(w[u]=p.item)}))).then(()=>Object.keys(w).length?this.proxy.$refresh(this.viewId,w):void 0)}refreshNode(E){const w=this.getExtensionElement(E);if(w){const u=this.nodes.get(w);if(u)return this.clearChildren(w),(0,S.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(p=>{if(p){const b=this.createTreeNode(w,p,u.parent);return this.updateNodeCache(w,b,u,u.parent),u.dispose(),b}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(E,w,u){const p=this.createTreeNode(E,w,u);if(w.id&&this.elements.has(p.item.handle))throw new Error((0,m.localize)(7,null,w.id));return this.addNodeToCache(E,p),this.addNodeToParentCache(p,u),p}getTooltip(E){return y.MarkdownString.isMarkdownString(E)?k.MarkdownString.from(E):E}getCommand(E,w){return w?this.commands.toInternal(w,E):void 0}createTreeNode(E,w,u){const p=new I.DisposableStore,b=this.createHandle(E,w,u),t=this.getLightIconPath(w);return{item:{handle:b,parentHandle:u?u.item.handle:void 0,label:h(w.label,this.extension),description:w.description,resourceUri:w.resourceUri,tooltip:this.getTooltip(w.tooltip),command:this.getCommand(p,w.command),contextValue:w.contextValue,icon:t,iconDark:this.getDarkIconPath(w)||t,themeIcon:this.getThemeIcon(w),collapsibleState:(0,C.isUndefinedOrNull)(w.collapsibleState)?y.TreeItemCollapsibleState.None:w.collapsibleState,accessibilityInformation:w.accessibilityInformation},extensionItem:w,parent:u,children:void 0,disposableStore:p,dispose(){p.dispose()}}}getThemeIcon(E){return E.iconPath instanceof y.ThemeIcon?E.iconPath:void 0}createHandle(E,{id:w,label:u,resourceUri:p},b,t){if(w)return`${d.ID_HANDLE_PREFIX}/${w}`;const s=h(u,this.extension),r=b?b.item.handle:d.LABEL_HANDLE_PREFIX;let i=s?s.label:p?(0,F.basename)(p):"";i=i.indexOf("/")!==-1?i.replace("/","//"):i;const c=this.nodes.has(E)?this.nodes.get(E).item.handle:void 0,g=this.getChildrenNodes(b)||[];let v,A=0;do{if(v=`${r}/${A}:${i}`,t||!this.elements.has(v)||c===v)break;A++}while(A<=g.length);return v}getLightIconPath(E){if(E.iconPath&&!(E.iconPath instanceof y.ThemeIcon))return typeof E.iconPath=="string"||D.URI.isUri(E.iconPath)?this.getIconPath(E.iconPath):this.getIconPath(E.iconPath.light)}getDarkIconPath(E){if(E.iconPath&&!(E.iconPath instanceof y.ThemeIcon)&&E.iconPath.dark)return this.getIconPath(E.iconPath.dark)}getIconPath(E){return D.URI.isUri(E)?E:D.URI.file(E)}addNodeToCache(E,w){this.elements.set(w.item.handle,E),this.nodes.set(E,w)}updateNodeCache(E,w,u,p){this.elements.delete(w.item.handle),this.nodes.delete(E),w.item.handle!==u.item.handle&&this.elements.delete(u.item.handle),this.addNodeToCache(E,w);const b=this.getChildrenNodes(p)||[],t=b.filter(s=>s.item.handle===u.item.handle)[0];t&&b.splice(b.indexOf(t),1,w)}addNodeToParentCache(E,w){w?(w.children||(w.children=[]),w.children.push(E)):(this.roots||(this.roots=[]),this.roots.push(E))}clearChildren(E){if(E){const w=this.nodes.get(E);if(w){if(w.children)for(const u of w.children){const p=this.elements.get(u.item.handle);p&&this.clear(p)}w.children=void 0}}else this.clearAll()}clear(E){const w=this.nodes.get(E);if(w){if(w.children)for(const u of w.children){const p=this.elements.get(u.item.handle);p&&this.clear(p)}this.nodes.delete(E),this.elements.delete(w.item.handle),w.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(E=>E.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}d.LABEL_HANDLE_PREFIX="0",d.ID_HANDLE_PREFIX="1"}),define(Ee[177],_e([0,1,16,3,7,10,65,9,96]),function(ee,e,m,F,D,_,I,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=void 0;var C;(function(l){l[l.Disconnected=0]="Disconnected",l[l.IsChild=1]="IsChild",l[l.IsParent=2]="IsParent",l[l.IsSame=3]="IsSame"})(C=e.TestPosition||(e.TestPosition={}));class n{constructor(){this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(h){if(this.map.has(h.actual.id))throw new Error(`Attempted to insert a duplicate test item ID ${h.actual.id}`);this.map.set(h.actual.id,h),h.parent||this._roots.add(h)}has(h){return this.map.has(h)}delete(h){const a=this.map.get(h);return a?(this.map.delete(h),this._roots.delete(a),!0):!1}get(h){return this.map.get(h)}comparePositions(h,a){const d=typeof h=="string"?this.map.get(h):h,f=typeof a=="string"?this.map.get(a):a;if(!d||!f)return 0;if(d===f)return 3;for(let E=this.map.get(f.parent);E;E=this.map.get(E.parent))if(E===d)return 1;for(let E=this.map.get(d.parent);E;E=this.map.get(E.parent))if(E===f)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=n;class k extends D.Disposable{constructor(h){super();this.controllerId=h,this.debounceSendDiff=this._register(new m.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new F.Emitter),this.root=new I.TestItemImpl(`${this.controllerId}Root`,this.controllerId,void 0),this.tree=new n,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.upsertItem(this.root,null)}set resolveHandler(h){this._resolveHandler=h;for(const a of this.tree)this.updateExpandability(a)}collectDiff(){const h=this.diff;return this.diff=[],h}pushDiff(h){const a=this.diff[this.diff.length-1];if(a&&h[0]===1){if(a[0]===1&&a[1].extId===h[1].extId){(0,y.applyTestItemUpdate)(a[1],h[1]);return}if(a[0]===0&&a[1].item.extId===h[1].extId){(0,y.applyTestItemUpdate)(a[1],h[1]);return}}this.diff.push(h),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(h,a){const d=this.tree.get(h);if(!!d){if((d.expandLevels===void 0||a>d.expandLevels)&&(d.expandLevels=a),d.expand===1){const f=this.resolveChildren(d);return f.isOpen()?this.expandChildren(d,a-1):f.wait().then(()=>this.expandChildren(d,a-1))}else if(d.expand===3)return d.resolveBarrier?.isOpen()===!1?d.resolveBarrier.wait().then(()=>this.expandChildren(d,a-1)):this.expandChildren(d,a-1)}}dispose(){for(const h of this.tree)(0,I.getPrivateApiFor)(h.actual).listener=void 0;this.diff=[],super.dispose()}onTestItemEvent(h,a){const d=h?.actual.id;switch(a.op){case 2:this.pushDiff([4,d]);break;case 1:this.removeItem(a.id);break;case 0:this.upsertItem(a.item,h);break;case 4:for(const w of a.ops)this.onTestItemEvent(h,w);break;case 3:const{key:f,value:E}=a;switch(f){case"canResolveChildren":this.updateExpandability(h);break;case"range":this.pushDiff([1,{extId:d,item:{range:S.Range.from(E)}}]);break;case"error":this.pushDiff([1,{extId:d,item:{error:S.MarkdownString.fromStrict(E)||null}}]);break;default:this.pushDiff([1,{extId:d,item:{[f]:E??null}}]);break}break;default:(0,_.assertNever)(a)}}upsertItem(h,a){if(!(h instanceof I.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${h.id} did not`);let d=this.tree.get(h.id);if(d&&d.parent!==a?.actual.id&&((d.actual.parent??this.root).children.remove(h.id),d=void 0),!d){const u=a?a.actual.id:null,p=a?a.expandLevels:1;d={actual:h,parent:u,expandLevels:p?p-1:void 0,expand:0},this.tree.add(d),this.pushDiff([0,{parent:u,controllerId:this.controllerId,expand:d.expand,item:S.TestItem.from(h)}]),this.connectItemAndChildren(h,d,a);return}if(d.actual===h){this.connectItem(h,d,a);return}const f=d.actual.children.all,E=d.actual,w=(0,I.diffTestItems)(E,h);(0,I.getPrivateApiFor)(E).listener=void 0,d.actual=h,d.expand=0;for(const[u,p]of w)this.onTestItemEvent(d,{op:3,key:u,value:p});this.connectItemAndChildren(h,d,a);for(const u of f)!h.children.get(u.id)&&this.tree.get(u.id)?.parent===h.id&&this.removeItem(u.id)}connectItem(h,a,d){const f=(0,I.getPrivateApiFor)(h);f.parent=d&&d.actual!==this.root?d.actual:void 0,f.listener=E=>this.onTestItemEvent(a,E),this.updateExpandability(a)}connectItemAndChildren(h,a,d){this.connectItem(h,a,d);for(const f of h.children.all)this.upsertItem(f,a)}updateExpandability(h){let a;this._resolveHandler?h.resolveBarrier?a=h.resolveBarrier.isOpen()?3:2:a=h.actual.canResolveChildren?1:0:a=0,a!==h.expand&&(h.expand=a,this.pushDiff([1,{extId:h.actual.id,expand:a}]),a===1&&h.expandLevels!==void 0&&this.resolveChildren(h))}expandChildren(h,a){if(a<0)return;const d=h.actual.children.all.map(f=>this.expand(f.id,a)).filter(m.isThenable);if(d.length)return Promise.all(d).then(()=>{})}resolveChildren(h){if(h.resolveBarrier)return h.resolveBarrier;if(!this._resolveHandler){const f=new m.Barrier;return f.open(),f}h.expand=2,this.pushExpandStateUpdate(h);const a=h.resolveBarrier=new m.Barrier;let d;try{d=this._resolveHandler(h.actual)}catch(f){h.actual.error=f.stack||f.message}return(0,m.isThenable)(d)?d.catch(f=>h.actual.error=f.stack||f.message).then(()=>{a.open(),this.updateExpandability(h)}):(a.open(),this.updateExpandability(h)),h.resolveBarrier}pushExpandStateUpdate(h){this.pushDiff([1,{extId:h.actual.id,expand:h.expand}])}removeItem(h){const a=this.tree.get(h);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff([2,h]);const d=[a];for(;d.length;){const f=d.pop();if(!!f){(0,I.getPrivateApiFor)(f.actual).listener=void 0,this.tree.delete(f.actual.id);for(const E of f.actual.children.all)d.push(this.tree.get(E.id))}}}flushDiff(){const h=this.collectDiff();h.length&&this.diffOpEmitter.fire(h)}}e.SingleUseTestCollection=k}),define(Ee[178],_e([0,1,4,146]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,m.refineServiceDecorator)(F.IEnvironmentService)}),define(Ee[179],_e([0,1,26,3,14]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class _{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=_;class I{constructor(n){this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(m.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(m.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let k of n.activationEvents)k==="onUri"&&(k=`onUri:${m.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(k)||this._activationMap.set(k,[]),this._activationMap.get(k).push(n)}}keepOnly(n){const k=new Set;n.forEach(l=>k.add(m.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>k.has(m.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,k){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const l=I._findLoopingExtensions(this._extensionDescriptions);if(k=k.concat(l.map(h=>h.identifier)),k.length>0){const h=new Set;k.forEach(a=>h.add(m.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!h.has(m.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new _(l)}static _findLoopingExtensions(n){const k=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(f){this._nodesSet.has(f)||(this._nodesSet.add(f),this._nodesArr.push(f))}addArc(f,E){this.addNode(f),this.addNode(E),this._arcs.has(f)?this._arcs.get(f).push(E):this._arcs.set(f,[E])}getArcs(f){return this._arcs.has(f)?this._arcs.get(f):[]}hasOnlyGoodArcs(f,E){const w=k.getArcs(f);for(let u=0;u<w.length;u++)if(!E.has(w[u]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let f of n){const E=m.ExtensionIdentifier.toKey(f.identifier);if(l.set(E,f),f.extensionDependencies)for(let w of f.extensionDependencies){const u=m.ExtensionIdentifier.toKey(w);k.addArc(E,u)}}let h=new Set;k.getNodes().filter(f=>k.getArcs(f).length===0).forEach(f=>h.add(f));let a=k.getNodes().filter(f=>!h.has(f)),d;do{d=!1;for(let f=0;f<a.length;f++){const E=a[f];k.hasOnlyGoodArcs(E,h)&&(a.splice(f,1),f--,h.add(E),d=!0)}}while(d);return a.map(f=>l.get(f))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(m.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const k=this._activationMap.get(n);return k?k.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const k=this._extensionsMap.get(m.ExtensionIdentifier.toKey(n));return k||void 0}}e.ExtensionDescriptionRegistry=I;var S;(function(C){C[C.Builtin=0]="Builtin",C[C.User=1]="User",C[C.Dev=2]="Dev"})(S||(S={}));function y(C,n){const k=C.isBuiltin?0:C.isUnderDevelopment?2:1,l=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(k!==l)return k-l;const h=D.posix.basename(C.extensionLocation.path),a=D.posix.basename(n.extensionLocation.path);return h<a?-1:h>a?1:0}}),define(Ee[180],_e([0,1,23]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var F;(function(S){S[S.VersionMismatch=55]="VersionMismatch",S[S.UnexpectedError=81]="UnexpectedError"})(F=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var D;(function(S){S[S.Initialized=0]="Initialized",S[S.Ready=1]="Ready",S[S.Terminate=2]="Terminate"})(D=e.MessageType||(e.MessageType={}));function _(S){const y=m.VSBuffer.alloc(1);switch(S){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=_;function I(S,y){if(S.byteLength!==1)return!1;switch(S.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=I}),define(Ee[29],_e([0,1,3,2,4,26,147]),function(ee,e,m,F,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new _.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");class S{constructor(w){this.dependency=w}}e.MissingExtensionDependency=S;var y;(function(E){E[E.LocalProcess=0]="LocalProcess",E[E.LocalWebWorker=1]="LocalWebWorker",E[E.Remote=2]="Remote"})(y=e.ExtensionHostKind||(e.ExtensionHostKind={}));class C{constructor(w,u,p,b){this.codeLoadingTime=w,this.activateCallTime=u,this.activateResolvedTime=p,this.activationReason=b}}e.ActivationTimes=C;class n{constructor(w,u){this.description=w,this.value=u}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var k;(function(E){E[E.Normal=0]="Normal",E[E.Immediate=1]="Immediate"})(k=e.ActivationKind||(e.ActivationKind={}));function l(E){E.enableProposedApi||h(E)}e.checkProposedApiEnabled=l;function h(E){throw new Error(`[${E.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${E.identifier.value}`)}e.throwProposedApiError=h;function a(E){return{type:E.isBuiltin?0:1,isBuiltin:E.isBuiltin||E.isUserBuiltin,identifier:{id:(0,I.getGalleryExtensionId)(E.publisher,E.name),uuid:E.uuid},manifest:E,location:E.extensionLocation}}e.toExtension=a;function d(E,w){return{identifier:new _.ExtensionIdentifier(E.identifier.id),isBuiltin:E.type===0,isUserBuiltin:E.type===1&&E.isBuiltin,isUnderDevelopment:!!w,extensionLocation:E.location,...E.manifest,uuid:E.identifier.uuid}}e.toExtensionDescription=d;class f{constructor(){this.onDidRegisterExtensions=m.Event.None,this.onDidChangeExtensionsStatus=m.Event.None,this.onDidChangeExtensions=m.Event.None,this.onWillActivateByEvent=m.Event.None,this.onDidChangeResponsiveChange=m.Event.None}activateByEvent(w){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(w){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(w){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(w){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(w,u){return Promise.resolve()}_onWillActivateExtension(w){}_onDidActivateExtension(w,u,p,b,t){}_onDidActivateExtensionError(w,u){}_onExtensionRuntimeError(w,u){}_onExtensionHostExit(w){}}e.NullExtensionService=f}),define(Ee[181],_e([0,1,26,29,15]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const _=Promise.resolve(void 0);class I{constructor(a,d,f,E){this.startup=a,this.codeLoadingTime=d,this.activateCallTime=f,this.activateResolvedTime=E}}e.ExtensionActivationTimes=I,I.NONE=new I(!1,-1,-1,-1);class S{constructor(a){this._startup=a,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(a,d){return a===-1||d===-1?-1:d-a}build(){return new I(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class y{constructor(a,d,f,E,w,u){this.activationFailed=a,this.activationFailedError=d,this.activationTimes=f,this.module=E,this.exports=w,this.subscriptions=u}}e.ActivatedExtension=y;class C extends y{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=C;class n extends y{constructor(){super(!1,null,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class k extends y{constructor(a){super(!0,a,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=k;let l=class{constructor(a,d,f,E,w){this._logService=w,this._registry=a,this._resolvedExtensionsSet=new Set,d.forEach(u=>this._resolvedExtensionsSet.add(m.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,f.forEach(u=>this._hostExtensionsMap.set(m.ExtensionIdentifier.toKey(u),u)),this._host=E,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(a){const d=m.ExtensionIdentifier.toKey(a);return this._activatedExtensions.has(d)}getActivatedExtension(a){const d=m.ExtensionIdentifier.toKey(a),f=this._activatedExtensions.get(d);if(!f)throw new Error("Extension `"+a.value+"` is not known or not activated");return f}activateByEvent(a,d){if(this._alreadyActivatedEvents[a])return _;const f=this._registry.getExtensionDescriptionsForActivationEvent(a);return this._activateExtensions(f.map(E=>({id:E.identifier,reason:{startup:d,extensionId:E.identifier,activationEvent:a}}))).then(()=>{this._alreadyActivatedEvents[a]=!0})}activateById(a,d){const f=this._registry.getExtensionDescription(a);if(!f)throw new Error("Extension `"+a+"` is not known");return this._activateExtensions([{id:f.identifier,reason:d}])}_handleActivateRequest(a,d,f){if(this._hostExtensionsMap.has(m.ExtensionIdentifier.toKey(a.id))){d[m.ExtensionIdentifier.toKey(a.id)]=a;return}const E=this._registry.getExtensionDescription(a.id);if(!E){const p=new Error(`Cannot activate unknown extension '${a.id.value}'`);this._host.onExtensionActivationError(a.id,p,new F.MissingExtensionDependency(a.id.value)),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(a.id),new k(p));return}const w=typeof E.extensionDependencies=="undefined"?[]:E.extensionDependencies;let u=!0;for(let p=0,b=w.length;p<b;p++){const t=w[p];if(this._resolvedExtensionsSet.has(m.ExtensionIdentifier.toKey(t)))continue;const s=this._activatedExtensions.get(m.ExtensionIdentifier.toKey(t));if(s&&!s.activationFailed)continue;if(s&&s.activationFailed){const g=E.displayName||E.identifier.value,v=this._registry.getExtensionDescription(t),A=v&&v.displayName||t,R=new Error(`Cannot activate the '${g}' extension because its dependency '${A}' failed to activate`);R.detail=s.activationFailedError,this._host.onExtensionActivationError(E.identifier,R,null),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(E.identifier),new k(R));return}if(this._hostExtensionsMap.has(m.ExtensionIdentifier.toKey(t))){u=!1,d[m.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(m.ExtensionIdentifier.toKey(t)),reason:a.reason};continue}const r=this._registry.getExtensionDescription(t);if(r){u=!1,d[m.ExtensionIdentifier.toKey(t)]={id:r.identifier,reason:a.reason};continue}const i=E.displayName||E.identifier.value,c=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(E.identifier,c,new F.MissingExtensionDependency(t)),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(E.identifier),new k(c));return}u?d[m.ExtensionIdentifier.toKey(E.identifier)]=a:f.push(a)}_activateExtensions(a){if(a.length===0||(a=a.filter(w=>!this._activatedExtensions.has(m.ExtensionIdentifier.toKey(w.id))),a.length===0))return Promise.resolve(void 0);const d=Object.create(null),f=[];for(let w=0,u=a.length;w<u;w++)this._handleActivateRequest(a[w],d,f);for(let w=0,u=f.length;w<u;w++){const p=m.ExtensionIdentifier.toKey(f[w].id);d[p]&&delete d[p]}const E=Object.keys(d).map(w=>d[w]);return f.length===0?Promise.all(E.map(w=>this._activateExtension(w.id,w.reason))).then(w=>{}):this._activateExtensions(E).then(w=>this._activateExtensions(f))}_activateExtension(a,d){const f=m.ExtensionIdentifier.toKey(a);if(this._activatedExtensions.has(f))return Promise.resolve(void 0);const E=this._activatingExtensions.get(f);if(E)return E;const w=this._host.actualActivateExtension(a,d).then(void 0,u=>{const p=new Error;return u&&u.name&&(p.name=u.name),u&&u.message?p.message=`Activating extension '${a.value}' failed: ${u.message}.`:p.message=`Activating extension '${a.value}' failed: ${u}.`,u&&u.stack&&(p.stack=u.stack),this._host.onExtensionActivationError(a,p,null),this._logService.error(`Activating extension ${a.value} failed due to an error:`),this._logService.error(u),new k(u)}).then(u=>{this._activatedExtensions.set(f,u),this._activatingExtensions.delete(f)});return this._activatingExtensions.set(f,w),w}};l=ze([qe(4,D.ILogService)],l),e.ExtensionsActivator=l}),define(Ee[182],_e([0,1,12]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class F{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((_,I)=>{this._actualOk=_,this._actualErr=I,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(_){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=_,this._actual&&this._actualOk(_))}resolveErr(_){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=_,this._actual?this._actualErr(_):(0,m.onUnexpectedError)(_))}then(_,I){return this._ensureActual().then(_,I)}catch(_){return this._ensureActual().then(void 0,_)}finally(_){return this._ensureActual().finally(_)}}e.LazyPromise=F}),define(Ee[100],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class m{constructor(y,C){this._proxyIdentifierBrand=void 0,this.isMain=y,this.sid=C,this.nid=++m.count}}e.ProxyIdentifier=m,m.count=0;const F=[];function D(S){const y=new m(!0,S);return F[y.nid]=y,y}e.createMainContextProxyIdentifier=D;function _(S){const y=new m(!1,S);return F[y.nid]=y,y}e.createExtHostContextProxyIdentifier=_;function I(S){return F[S].sid}e.getStringIdentifierForProxy=I}),define(Ee[5],_e([0,1,54,2,100]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var _;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(_=e.UIKind||(e.UIKind={}));var I;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(I=e.TextEditorRevealType||(e.TextEditorRevealType={}));var S;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(S=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var C;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(C=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var k;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(k=e.CandidatePortSource||(e.CandidatePortSource={}));var l;(function(u){u.name="$ident";function p(t,s){return Object.defineProperty(t,u.name,{value:s,enumerable:!0}),t}u.mixin=p;function b(t){return t[u.name]}u.of=b})(l=e.ObjectIdentifier||(e.ObjectIdentifier={}));class h{static mixin(p){return p._id=h._n++,p}}e.IdObject=h,h._n=0;var a;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n"})(a=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var d;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(d=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var f;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(f=e.WorkspaceEditType||(e.WorkspaceEditType={}));function E(u){if(u&&u.edits)for(const p of u.edits)typeof p.resource=="object"?p.resource=F.URI.revive(p.resource):(p.newUri=F.URI.revive(p.newUri),p.oldUri=F.URI.revive(p.oldUri)),p.metadata&&p.metadata.iconPath&&(p.metadata=(0,m.revive)(p.metadata));return u}e.reviveWorkspaceEditDto=E;var w;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,D.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,D.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,D.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,D.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,D.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,D.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,D.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,D.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,D.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,D.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,D.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,D.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,D.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,D.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,D.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,D.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,D.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,D.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,D.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,D.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,D.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,D.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,D.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,D.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,D.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,D.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,D.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,D.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,D.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,D.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,D.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,D.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,D.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,D.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,D.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,D.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,D.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,D.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,D.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,D.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,D.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,D.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,D.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,D.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,D.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,D.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,D.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,D.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,D.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,D.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,D.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,D.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,D.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,D.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,D.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,D.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,D.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,D.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,D.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,D.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,D.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,D.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(Ee[70],_e([0,1,5,3,4]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class _{constructor(S){this._onDidChangePassword=new F.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=S.getProxy(m.MainContext.MainThreadSecretState)}async $onDidChangePassword(S){this._onDidChangePassword.fire(S)}get(S,y){return this._proxy.$getPassword(S,y)}store(S,y,C){return this._proxy.$setPassword(S,y,C)}delete(S,y){return this._proxy.$deletePassword(S,y)}}e.ExtHostSecretState=_,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")}),define(Ee[71],_e([0,1,4,15,5,13]),function(ee,e,m,F,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,m.createDecorator)("IExtHostApiDeprecationService");let I=class{constructor(y,C){this._extHostLogService=C,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(D.MainContext.MainThreadTelemetry)}report(y,C,n){const k=this.getUsageKey(y,C);this._reportedUsages.has(k)||(this._reportedUsages.add(k),C.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:y}))}getUsageKey(y,C){return`${y}-${C.identifier.value}`}};I=ze([qe(0,_.IExtHostRpcService),qe(1,F.ILogService)],I),e.ExtHostApiDeprecationService=I,e.NullApiDeprecationService=Object.freeze(new class{report(S,y,C){}})}),define(Ee[183],_e([0,1,3,5,6,26]),function(ee,e,m,F,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class I{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new m.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(F.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,C,n,k={}){const l=_.ExtensionIdentifier.toKey(y.identifier),h=this._inFlightRequests.get(l)||[],a=[...n].sort().join(" ");let d=h.find(f=>f.scopes===a);if(d)return d.result;{const f=this._getSession(y,l,C,n,k);d={scopes:a,result:f},h.push(d),this._inFlightRequests.set(l,h);try{await f}finally{const E=h.findIndex(w=>w.scopes===a);E>-1&&(h.splice(E),this._inFlightRequests.set(l,h))}return f}}async _getSession(y,C,n,k,l={}){await this._proxy.$ensureProvider(n);const h=y.displayName||y.name;return this._proxy.$getSession(n,k,C,h,l)}async removeSession(y,C){const n=this._authenticationProviders.get(y);return n?n.provider.removeSession(C):this._proxy.$removeSession(y,C)}registerAuthenticationProvider(y,C,n,k){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:C,provider:n,options:k??{supportsMultipleAccounts:!1}}),this._providers.find(h=>h.id===y)||this._providers.push({id:y,label:C});const l=n.onDidChangeSessions(h=>{this._proxy.$sendDidChangeSessions(y,{added:h.added??[],changed:h.changed??[],removed:h.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,C,k?.supportsMultipleAccounts??!1),new D.Disposable(()=>{l.dispose(),this._authenticationProviders.delete(y);const h=this._providers.findIndex(a=>a.id===y);h>-1&&this._providers.splice(h),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,C){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,C){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,C){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,C){return this._onDidChangeSessions.fire({provider:{id:y,label:C}}),Promise.resolve()}}e.ExtHostAuthentication=I}),define(Ee[184],_e([0,1,5,13,9]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let _=class{constructor(S,y){this._extHostDocumentsAndEditors=y,this._proxy=S.getProxy(m.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(S){const y=D.WorkspaceEdit.from(S,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};_=ze([qe(0,F.IExtHostRpcService)],_),e.ExtHostBulkEdits=_}),define(Ee[185],_e([0,1,5]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class F{constructor(_){const I=_.getProxy(m.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return I.$readText()},writeText(S){return I.$writeText(S)}})}}e.ExtHostClipboard=F}),define(Ee[72],_e([0,1,10,6,9,24,5,17,15,54,30,36,2,7,4,13]),function(ee,e,m,F,D,_,I,S,y,C,n,k,l,h,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let f=class{constructor(t,s){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(I.MainContext.MainThreadCommands),this._logService=s,this.converter=new E(this,r=>{const i=this._apiCommands.get(r);return i?.result===u.Void?i:void 0},s),this._argumentProcessors=[{processArgument(r){return(0,C.revive)(r)}},{processArgument(r){return(0,_.cloneAndChange)(r,function(i){if(n.Range.isIRange(i))return D.Range.to(i);if(k.Position.isIPosition(i))return D.Position.to(i);if(n.Range.isIRange(i.range)&&l.URI.isUri(i.uri))return D.location.to(i);if(!Array.isArray(i))return i})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const s=this.registerCommand(!1,t.id,async(...r)=>{const i=t.args.map((g,v)=>{if(!g.validate(r[v]))throw new Error(`Invalid argument '${g.name}' when running '${t.id}', received: ${r[v]}`);return g.convert(r[v])}),c=await this.executeCommand(t.internalId,...i);return t.result.convert(c,r,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new F.Disposable(()=>{s.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,s,r,i,c){if(this._logService.trace("ExtHostCommands#registerCommand",s),!s.trim().length)throw new Error("invalid id");if(this._commands.has(s))throw new Error(`command '${s}' already exists`);return this._commands.set(s,{callback:r,thisArg:i,description:c}),t&&this._proxy.$registerCommand(s),new F.Disposable(()=>{this._commands.delete(s)&&t&&this._proxy.$unregisterCommand(s)})}executeCommand(t,...s){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,s,!0)}async _doExecuteCommand(t,s,r){if(this._commands.has(t))return this._executeContributedCommand(t,s);{const i=(0,_.cloneAndChange)(s,function(c){if(c instanceof F.Position)return D.Position.from(c);if(c instanceof F.Range)return D.Range.from(c);if(c instanceof F.Location)return D.location.from(c);if(F.NotebookRange.isNotebookRange(c))return D.NotebookRange.from(c);if(!Array.isArray(c))return c});try{const c=await this._proxy.$executeCommand(t,i,r);return(0,C.revive)(c)}catch(c){if(c instanceof Error&&c.message==="$executeCommand:retry")return this._doExecuteCommand(t,s,!1);throw c}}}async _executeContributedCommand(t,s){const r=this._commands.get(t);if(!r)throw new Error("Unknown command");let{callback:i,thisArg:c,description:g}=r;if(g)for(let v=0;v<g.args.length;v++)try{(0,m.validateConstraint)(s[v],g.args[v].constraint)}catch(A){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${g.args[v].name}' - ${g.args[v].description}`)}try{return await i.apply(c,s)}catch(v){if(t===this.converter.delegatingCommandId){const A=this.converter.getActualCommand(...s);A&&(t=A.command)}throw this._logService.error(v,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...s){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(s=s.map(r=>this._argumentProcessors.reduce((i,c)=>c.processArgument(i),r)),this._executeContributedCommand(t,s)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(s=>(t&&(s=s.filter(r=>r[0]!=="_")),s))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[s,r]of this._commands){let{description:i}=r;i&&(t[s]=i)}return Promise.resolve(t)}};f=ze([qe(0,d.IExtHostRpcService),qe(1,y.ILogService)],f),e.ExtHostCommands=f,e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class E{constructor(t,s,r){this._commands=t,this._lookupApiCommand=s,this._logService=r,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,s){if(!t)return;const r={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return r;const i=this._lookupApiCommand(t.command);if(i)r.id=i.internalId,r.arguments=i.args.map((c,g)=>c.convert(t.arguments&&t.arguments[g]));else if((0,S.isNonEmptyArray)(t.arguments)){const c=++this._cachIdPool;this._cache.set(c,t),s.add((0,h.toDisposable)(()=>{this._cache.delete(c),this._logService.trace("CommandsConverter#DISPOSE",c)})),r.$ident=c,r.id=this.delegatingCommandId,r.arguments=[c],this._logService.trace("CommandsConverter#CREATE",t.command,c)}return r}fromInternal(t){const s=I.ObjectIdentifier.of(t);return typeof s=="number"?this._cache.get(s):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const s=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],s?s.command:"MISSING"),s?this._commands.executeCommand(s.command,...s.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=E;class w{constructor(t,s,r,i){this.name=t,this.description=s,this.validate=r,this.convert=i}optional(){return new w(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,s){return new w(t??this.name,s??this.description,this.validate,this.convert)}}e.ApiCommandArgument=w,w.Uri=new w("uri","Uri of a text document",b=>l.URI.isUri(b),b=>b),w.Position=new w("position","A position in a text document",b=>F.Position.isPosition(b),D.Position.from),w.Range=new w("range","A range in a text document",b=>F.Range.isRange(b),D.Range.from),w.Selection=new w("selection","A selection in a text document",b=>F.Selection.isSelection(b),D.Selection.from),w.Number=new w("number","",b=>typeof b=="number",b=>b),w.String=new w("string","",b=>typeof b=="string",b=>b),w.CallHierarchyItem=new w("item","A call hierarchy item",b=>b instanceof F.CallHierarchyItem,D.CallHierarchyItem.from),w.TypeHierarchyItem=new w("item","A type hierarchy item",b=>b instanceof F.TypeHierarchyItem,D.TypeHierarchyItem.from);class u{constructor(t,s){this.description=t,this.convert=s}}e.ApiCommandResult=u,u.Void=new u("no result",b=>b);class p{constructor(t,s,r,i,c){this.id=t,this.internalId=s,this.description=r,this.args=i,this.result=c}}e.ApiCommand=p}),define(Ee[186],_e([0,1,9,6,58,72,17,87]),function(ee,e,m,F,D,_,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const y=[new _.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(m.DocumentHighlight.to))),new _.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,h)=>{if((0,I.isFalsyOrEmpty)(l))return;class a extends F.SymbolInformation{static to(f){const E=new a(f.name,m.SymbolKind.to(f.kind),f.containerName||"",new F.Location(h[0],m.Range.to(f.range)));return E.detail=f.detail,E.range=E.location.range,E.selectionRange=m.Range.to(f.selectionRange),E.children=f.children?f.children.map(a.to):[],E}}return l.map(a.to)})),new _.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new _.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range,new _.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new _.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,new _.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new _.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new _.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new _.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new _.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new _.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new _.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(m.location.to))),new _.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(m.Hover.to))),new _.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(h=>F.Position.isPosition(h)),l=>l.map(m.Position.from))],new _.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(h=>{let a;for(const d of h.reverse())a=new F.SelectionRange(m.Range.to(d),a);return a}))),new _.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[_.ApiCommandArgument.String.with("query","Search string")],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>{const h=[];if(Array.isArray(l))for(let a of l)h.push(...a[1].map(m.WorkspaceSymbol.to));return h})),new _.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(m.CallHierarchyItem.to))),new _.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(m.CallHierarchyIncomingCall.to))),new _.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(m.CallHierarchyOutgoingCall.to))),new _.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("newName","The new symbol name")],new _.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return m.WorkspaceEdit.to(l)}})),new _.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new _.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(m.DocumentLink.to))),new _.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new F.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const h=(0,S.decodeSemanticTokensDto)(l);if(h.type==="full")return new F.SemanticTokens(h.data,void 0)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new F.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const h=(0,S.decodeSemanticTokensDto)(l);if(h.type==="full")return new F.SemanticTokens(h.data,void 0)})),new _.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new _.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,h,a)=>{if(!l)return new F.CompletionList([]);const d=l.suggestions.map(f=>m.CompletionItem.to(f,a));return new F.CompletionList(d,l.incomplete)})),new _.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new _.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return m.SignatureHelp.to(l)})),new _.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new _.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,h,a)=>n(d=>new F.CodeLens(m.Range.to(d.range),d.command&&a.fromInternal(d.command)))(l))),new _.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>F.Range.isRange(l),l=>F.Selection.isSelection(l)?m.Selection.from(l):m.Range.from(l)),_.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new _.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,h,a)=>n(d=>{if(d._isSynthetic){if(!d.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(d.command)}else{const f=new F.CodeAction(d.title,d.kind?new F.CodeActionKind(d.kind):void 0);return d.edit&&(f.edit=m.WorkspaceEdit.to(d.edit)),d.command&&(f.command=a.fromInternal(d.command)),f.isPreferred=d.isPreferred,f}})(l))),new _.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(h=>new F.ColorInformation(m.Range.to(h.range),m.Color.to(h.color))):[])),new _.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new _.ApiCommandArgument("color","The color to show and insert",l=>l instanceof F.Color,m.Color.from),new _.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:m.Range.from(l.range)}))],new _.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(m.ColorPresentation.to):[])),new _.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of Inlay objects",l=>l.map(m.InlayHint.to))),new _.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new _.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(h=>m.NotebookExclusiveDocumentPattern.to(h))})))),new _.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(m.InlineValue.to))),new _.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[m.ViewColumn.from(l.viewColumn),m.TextEditorOpenOptions.from(l)])).optional(),_.ApiCommandArgument.String.with("label","").optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[_.ApiCommandArgument.Uri.with("resource","Resource to open"),_.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[m.ViewColumn.from(l.viewColumn),m.TextEditorOpenOptions.from(l)])).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[_.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),_.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),_.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[m.ViewColumn.from(l.viewColumn),m.TextEditorOpenOptions.from(l)]).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(m.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(m.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(m.TypeHierarchyItem.to)))];class C{static register(h){y.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=C;function n(l){return h=>{if(Array.isArray(h))return h.map(l)}}function k(l){if(!Array.isArray(l))return;const h=[];for(const a of l)D.isLocationLink(a)?h.push(m.DefinitionLink.to(a)):h.push(m.location.to(a));return h}}),define(Ee[187],_e([0,1,16,48,3,7,2,58,26,9,6,5]),function(ee,e,m,F,D,_,I,S,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function l(h,a,d){const f=h.getProxy(k.MainContext.MainThreadComments);class E{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,a.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const c=this._commentControllers.get(i.handle);return c||i}else if(i&&i.$mid===7){const c=this._commentControllers.get(i.commentControlHandle);if(!c)return i;const g=c.getCommentThread(i.commentThreadHandle);return g||i}else if(i&&i.$mid===8){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const g=c.getCommentThread(i.thread.commentThreadHandle);return g?{thread:g,text:i.text}:i}else if(i&&i.$mid===9){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const g=c.getCommentThread(i.thread.commentThreadHandle);if(!g)return i;let v=i.commentUniqueId,A=g.getCommentByUniqueId(v);return A||i}else if(i&&i.$mid===10){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const g=c.getCommentThread(i.thread.commentThreadHandle);if(!g)return i;let v=i.text,A=i.commentUniqueId,R=g.getCommentByUniqueId(A);return R?(R.body=v,R):i}return i}})}createCommentController(i,c,g){const v=E.handlePool++,A=new u(i,v,c,g);this._commentControllers.set(A.handle,A);const R=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(i.identifier))||[];return R.push(A),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(i.identifier),R),A.value}$createCommentThreadTemplate(i,c,g){const v=this._commentControllers.get(i);!v||v.$createCommentThreadTemplate(c,g)}async $updateCommentThreadTemplate(i,c,g){const v=this._commentControllers.get(i);!v||v.$updateCommentThreadTemplate(c,g)}$deleteCommentThread(i,c){const g=this._commentControllers.get(i);g&&g.$deleteCommentThread(c)}$provideCommentingRanges(i,c,g){const v=this._commentControllers.get(i);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const A=d.getDocument(I.URI.revive(c));return(0,m.asPromise)(()=>v.commentingRangeProvider.provideCommentingRanges(A,g)).then(R=>R?R.map(o=>C.Range.from(o)):void 0)}$toggleReaction(i,c,g,v,A){const R=this._commentControllers.get(i);return!R||!R.reactionHandler?Promise.resolve(void 0):(0,m.asPromise)(()=>{const o=R.getCommentThread(c);if(o){const P=o.getCommentByUniqueId(v.uniqueIdInThread);if(R!==void 0&&P&&R.reactionHandler)return R.reactionHandler(P,t(A))}return Promise.resolve(void 0)})}dispose(){}}E.handlePool=0;class w{constructor(i,c,g,v,A,R,o){this._commentControllerHandle=c,this._id=g,this._uri=v,this._range=A,this._comments=R,this.handle=w._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new _.MutableDisposable,this._acceptInputDisposables.value=new _.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),f.$createCommentThread(c,this.handle,this._id,this._uri,C.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=R,this._localDisposables.push({dispose:()=>{f.$deleteCommentThread(c,this.handle)}});const P=this;this.value={get uri(){return P.uri},get range(){return P.range},set range(L){P.range=L},get comments(){return P.comments},set comments(L){P.comments=L},get collapsibleState(){return P.collapsibleState},set collapsibleState(L){P.collapsibleState=L},get canReply(){return P.canReply},set canReply(L){P.canReply=L},get contextValue(){return P.contextValue},set contextValue(L){P.contextValue=L},get label(){return P.label},set label(L){P.label=L},dispose:()=>{P.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new _.DisposableStore);const i=g=>Object.prototype.hasOwnProperty.call(this.modifications,g),c={};i("range")&&(c.range=C.Range.from(this._range)),i("label")&&(c.label=this.label),i("contextValue")&&(c.contextValue=this.contextValue),i("comments")&&(c.comments=this._comments.map(g=>p(this,g,this._commentsMap))),i("collapsibleState")&&(c.collapseState=s(this._collapseState)),i("canReply")&&(c.canReply=this.canReply),this.modifications={},f.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(i){for(let c of this._commentsMap){let g=c[0],v=c[1];if(i===v)return g}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}w._handlePool=0,ze([(0,F.debounce)(100)],w.prototype,"eventuallyUpdateCommentThread",null);class u{constructor(i,c,g,v){this._extension=i,this._handle=c,this._id=g,this._label=v,this._threads=new Map,f.$registerCommentController(this.handle,g,v);const A=this;this.value=Object.freeze({id:A.id,label:A.label,get options(){return A.options},set options(R){A.options=R},get commentingRangeProvider(){return A.commentingRangeProvider},set commentingRangeProvider(R){A.commentingRangeProvider=R},get reactionHandler(){return A.reactionHandler},set reactionHandler(R){A.reactionHandler=R},createCommentThread(R,o,P){return A.createCommentThread(R,o,P).value},dispose:()=>{A.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{f.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,f.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,f.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,c,g,v){if(typeof i=="string"){const A=new w(this.id,this.handle,i,c,g,v,this._extension.identifier);return this._threads.set(A.handle,A),A}else{const A=new w(this.id,this.handle,void 0,i,c,g,this._extension.identifier);return this._threads.set(A.handle,A),A}}$createCommentThreadTemplate(i,c){const g=new w(this.id,this.handle,void 0,I.URI.revive(i),C.Range.to(c),[],this._extension.identifier);return g.collapsibleState=S.CommentThreadCollapsibleState.Expanded,this._threads.set(g.handle,g),g}$updateCommentThreadTemplate(i,c){let g=this._threads.get(i);g&&(g.range=C.Range.to(c))}$deleteCommentThread(i){let c=this._threads.get(i);c&&c.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function p(r,i,c){let g=c.get(i);g||(g=++r.commentHandle,c.set(i,g));const v=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:g,body:C.MarkdownString.from(i.body),userName:i.author.name,userIconPath:v,label:i.label,commentReactions:i.reactions?i.reactions.map(A=>b(A)):void 0}}function b(r){return{label:r.label,iconPath:r.iconPath?C.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function t(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?I.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function s(r){if(r!==void 0)switch(r){case n.CommentThreadCollapsibleState.Expanded:return S.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return S.CommentThreadCollapsibleState.Collapsed}return S.CommentThreadCollapsibleState.Collapsed}return new E}e.createExtHostComments=l}),define(Ee[101],_e([0,1,2,5,6,4,13,15,17,8,14]),function(ee,e,m,F,D,_,I,S,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class wn{constructor(h,a){this._logService=a,this._provider=new Map,this._proxy=h.getProxy(F.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,a){const d=wn._handlePool++;this._provider.set(d,{provider:h,extensionId:a}),this._proxy.$registerDecorationProvider(d,a.value);const f=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(E=>{if(!E){this._proxy.$onDidChange(d,null);return}let w=(0,y.asArray)(E);if(w.length<=wn._maxEventSize){this._proxy.$onDidChange(d,w);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,w.length);const u=w.map(t=>({uri:t,rank:(0,C.count)(t.path,"/")})),p=(0,y.groupBy)(u,(t,s)=>t.rank-s.rank||(0,C.compare)(t.uri.path,s.uri.path));let b=[];e:for(let t of p){let s;for(let r of t){let i=(0,n.dirname)(r.uri.path);if(s!==i&&(s=i,b.push(r.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(d,b)});return new D.Disposable(()=>{f?.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(h,a,d){if(!this._provider.has(h))return Object.create(null);const f=Object.create(null),{provider:E,extensionId:w}=this._provider.get(h);return await Promise.all(a.map(async u=>{try{const{uri:p,id:b}=u,t=await Promise.resolve(E.provideFileDecoration(m.URI.revive(p),d));if(!t)return;try{D.FileDecoration.validate(t),f[b]=[t.propagate,t.tooltip,t.badge,t.color]}catch(s){this._logService.warn(`INVALID decoration from extension '${w.value}': ${s}`)}}catch(p){this._logService.error(p)}})),f}};k._handlePool=0,k._maxEventSize=250,k=ze([qe(0,I.IExtHostRpcService),qe(1,S.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=(0,_.createDecorator)("IExtHostDecorations")}),define(Ee[188],_e([0,1,129,90,2,5,6,9,3,15,22]),function(ee,e,m,F,D,_,I,S,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class k{constructor(a,d,f,E,w){this._name=a,this._owner=d,this._maxDiagnosticsPerFile=f,this._proxy=E,this._onDidChangeDiagnostics=w,this._isDisposed=!1,this._data=new n.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,d){if(!a){this.clear();return}this._checkDisposed();let f=[];if(D.URI.isUri(a)){if(!d){this.delete(a);return}this._data.set(a,d.slice()),f=[a]}else if(Array.isArray(a)){f=[];let w;a=[...a].sort(k._compareIndexedTuplesByUri);for(const u of a){const[p,b]=u;if((!w||p.toString()!==w.toString())&&(w&&this._data.get(w).length===0&&this._data.delete(w),w=p,f.push(p),this._data.set(p,[])),b){const t=this._data.get(p);t&&t.push(...b)}else{const t=this._data.get(p);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(f),!this._proxy)return;const E=[];for(let w of f){let u=[];const p=this._data.get(w);if(p)if(p.length>this._maxDiagnosticsPerFile){u=[];const b=[I.DiagnosticSeverity.Error,I.DiagnosticSeverity.Warning,I.DiagnosticSeverity.Information,I.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let s of p)if(s.severity===b[t]&&u.push(S.Diagnostic.from(s))===this._maxDiagnosticsPerFile)break e;u.push({severity:F.MarkerSeverity.Info,message:(0,m.localize)(0,null,p.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=p.map(b=>S.Diagnostic.from(b));E.push([w,u])}this._proxy.$changeMany(this._owner,E)}delete(a){this._checkDisposed(),this._onDidChangeDiagnostics.fire([a]),this._data.delete(a),this._proxy&&this._proxy.$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(a,d){this._checkDisposed();for(let f of this._data.keys())a.apply(d,[f,this.get(f),this])}get(a){this._checkDisposed();const d=this._data.get(a);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(this._data.get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,d){return a[0].toString()<d[0].toString()?-1:a[0].toString()>d[0].toString()?1:0}}e.DiagnosticCollection=k;let l=class Gt{constructor(a,d){this._logService=d,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:f=>f.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,Gt._mapper),this._proxy=a.getProxy(_.MainContext.MainThreadDiagnostics)}static _mapper(a){const d=new n.ResourceMap;for(const f of a)d.set(f,f);return{uris:Object.freeze(Array.from(d.values()))}}createDiagnosticCollection(a,d){const{_collections:f,_proxy:E,_onDidChangeDiagnostics:w,_logService:u}=this,p=new class{$changeMany(s,r){E.$changeMany(s,r),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,s,r.length===0?"CLEARING":r)}$clear(s){E.$clear(s),u.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,s)}dispose(){E.dispose()}};let b;if(!d)d="_generated_diagnostic_collection_name_#"+Gt._idPool++,b=d;else if(!f.has(d))b=d;else{this._logService.warn(`DiagnosticCollection with name '${d}' does already exist.`);do b=d+Gt._idPool++;while(f.has(b))}return new class extends k{constructor(){super(d,b,Gt._maxDiagnosticsPerFile,p,w);f.set(b,this)}dispose(){super.dispose(),f.delete(b)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const d=new Map,f=[];for(const E of this._collections.values())E.forEach((w,u)=>{let p=d.get(w.toString());typeof p=="undefined"&&(p=f.length,d.set(w.toString(),p),f.push([w,[]])),f[p][1]=f[p][1].concat(...u)});return f}}_getDiagnostics(a){let d=[];for(let f of this._collections.values())f.has(a)&&(d=d.concat(f.get(a)));return d}$acceptMarkersChange(a){if(!this._mirrorCollection){const d="_generated_mirror",f=new k(d,d,Gt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(d,f),this._mirrorCollection=f}for(const[d,f]of a)this._mirrorCollection.set(D.URI.revive(d),f.map(S.Diagnostic.to))}};l._idPool=0,l._maxDiagnosticsPerFile=1e3,l=ze([qe(1,C.ILogService)],l),e.ExtHostDiagnostics=l}),define(Ee[189],_e([0,1,2,5]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(I){this._proxy=I.getProxy(F.MainContext.MainThreadDialogs)}showOpenDialog(I){return this._proxy.$showOpenDialog(I).then(S=>S?S.map(y=>m.URI.revive(y)):void 0)}showSaveDialog(I){return this._proxy.$showSaveDialog(I).then(S=>S?m.URI.revive(S):void 0)}}e.ExtHostDialogs=D}),define(Ee[190],_e([0,1,12,2,6,5,11,18,8]),function(ee,e,m,F,D,_,I,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(k,l,h){this._documentsAndEditors=l,this._logService=h,this._documentContentProviders=new Map,this._proxy=k.getProxy(_.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,l){if(Object.keys(I.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const h=C._handlePool++;this._documentContentProviders.set(h,l),this._proxy.$registerTextContentProvider(h,k);let a;return typeof l.onDidChange=="function"&&(a=l.onDidChange(d=>{if(d.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(d)&&this.$provideTextDocumentContent(h,d).then(f=>{if(!f&&typeof f!="string")return;const E=this._documentsAndEditors.getDocument(d);if(!E)return;const w=(0,y.splitLines)(f);if(!E.equalLines(w))return this._proxy.$onVirtualDocumentChange(d,f)},m.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(k,l){const h=this._documentContentProviders.get(k);return h?Promise.resolve(h.provideTextDocumentContent(F.URI.revive(l),S.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=C,C._handlePool=0}),define(Ee[191],_e([0,1,3,7,2,5,95,9,10,24,6]),function(ee,e,m,F,D,_,I,S,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class k{constructor(h,a){this._onDidAddDocument=new m.Emitter,this._onDidRemoveDocument=new m.Emitter,this._onDidChangeDocument=new m.Emitter,this._onDidSaveDocument=new m.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new F.DisposableStore,this._documentLoader=new Map,this._proxy=h.getProxy(_.MainContext.MainThreadDocuments),this._documentsAndEditors=a,this._documentsAndEditors.onDidRemoveDocuments(d=>{for(const f of d)this._onDidRemoveDocument.fire(f.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(d=>{for(const f of d)this._onDidAddDocument.fire(f.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(h){if(!h)return;const a=this._documentsAndEditors.getDocument(h);if(a)return a}getDocument(h){const a=this.getDocumentData(h);if(!a?.document)throw new Error(`Unable to retrieve document from URI '${h}'`);return a.document}ensureDocumentData(h){const a=this._documentsAndEditors.getDocument(h);if(a)return Promise.resolve(a);let d=this._documentLoader.get(h.toString());return d||(d=this._proxy.$tryOpenDocument(h).then(f=>{this._documentLoader.delete(h.toString());const E=D.URI.revive(f);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(E))},f=>(this._documentLoader.delete(h.toString()),Promise.reject(f))),this._documentLoader.set(h.toString(),d)),d}createDocumentData(h){return this._proxy.$tryCreateDocument(h).then(a=>D.URI.revive(a))}$acceptModelModeChanged(h,a){const d=D.URI.revive(h),f=this._documentsAndEditors.getDocument(d);if(!f)throw new Error("unknown document");this._onDidRemoveDocument.fire(f.document),f._acceptLanguageId(a),this._onDidAddDocument.fire(f.document)}$acceptModelSaved(h){const a=D.URI.revive(h),d=this._documentsAndEditors.getDocument(a);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(h,!1),this._onDidSaveDocument.fire(d.document)}$acceptDirtyStateChanged(h,a){const d=D.URI.revive(h),f=this._documentsAndEditors.getDocument(d);if(!f)throw new Error("unknown document");f._acceptIsDirty(a),this._onDidChangeDocument.fire({document:f.document,contentChanges:[],reason:void 0})}$acceptModelChanged(h,a,d){const f=D.URI.revive(h),E=this._documentsAndEditors.getDocument(f);if(!E)throw new Error("unknown document");E._acceptIsDirty(d),E.onEvents(a);let w;a.isUndoing?w=n.TextDocumentChangeReason.Undo:a.isRedoing&&(w=n.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,C.deepFreeze)({document:E.document,contentChanges:a.changes.map(u=>({range:S.Range.to(u.range),rangeOffset:u.rangeOffset,rangeLength:u.rangeLength,text:u.text})),reason:w}))}setWordDefinitionFor(h,a){(0,I.setWordDefinitionFor)(h,a)}}e.ExtHostDocuments=k}),define(Ee[46],_e([0,1,39,3,7,2,4,5,95,13,99,9,15,22,11,51,109]),function(ee,e,m,F,D,_,I,S,y,C,n,k,l,h,a,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class E{constructor(p){this.value=p,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let w=class{constructor(p,b){this._extHostRpc=p,this._logService=b,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new F.Emitter,this._onDidRemoveDocuments=new F.Emitter,this._onDidChangeVisibleTextEditors=new F.Emitter,this._onDidChangeActiveTextEditor=new F.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(p){this.acceptDocumentsAndEditorsDelta(p)}acceptDocumentsAndEditorsDelta(p){const b=[],t=[],s=[];if(p.removedDocuments)for(const r of p.removedDocuments){const i=_.URI.revive(r),c=this._documents.get(i);c?.unref()&&(this._documents.delete(i),b.push(c.value))}if(p.addedDocuments)for(const r of p.addedDocuments){const i=_.URI.revive(r.uri);let c=this._documents.get(i);if(c&&i.scheme!==a.Schemas.vscodeNotebookCell&&i.scheme!==a.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);c||(c=new E(new y.ExtHostDocumentData(this._extHostRpc.getProxy(S.MainContext.MainThreadDocuments),i,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(i,c),t.push(c.value)),c.ref()}if(p.removedEditors)for(const r of p.removedEditors){const i=this._editors.get(r);this._editors.delete(r),i&&s.push(i)}if(p.addedEditors)for(const r of p.addedEditors){const i=_.URI.revive(r.documentUri);m.ok(this._documents.has(i),`document '${i}' does not exist`),m.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const c=this._documents.get(i).value,g=new n.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(S.MainContext.MainThreadTextEditors),this._logService,new f.Lazy(()=>c.document),r.selections.map(k.Selection.to),r.options,r.visibleRanges.map(v=>k.Range.to(v)),typeof r.editorPosition=="number"?k.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,g)}p.newActiveEditor!==void 0&&(m.ok(p.newActiveEditor===null||this._editors.has(p.newActiveEditor),`active editor '${p.newActiveEditor}' does not exist`),this._activeEditorId=p.newActiveEditor),(0,D.dispose)(b),(0,D.dispose)(s),p.removedDocuments&&this._onDidRemoveDocuments.fire(b),p.addedDocuments&&this._onDidAddDocuments.fire(t),(p.removedEditors||p.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),p.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(p){return this._documents.get(p)?.value}allDocuments(){return d.Iterable.map(this._documents.values(),p=>p.value)}getEditor(p){return this._editors.get(p)}activeEditor(p){if(!this._activeEditorId)return;const b=this._editors.get(this._activeEditorId);return p?b:b?.value}allEditors(){return[...this._editors.values()]}};w=ze([qe(0,C.IExtHostRpcService),qe(1,l.ILogService)],w),e.ExtHostDocumentsAndEditors=w,e.IExtHostDocumentsAndEditors=(0,I.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ee[192],_e([0,1,2,5,7,6,9,119,8,23]),function(ee,e,m,F,D,_,I,S,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const a=this._schemes.indexOf(h);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),a=[];let d,f,E=14,w=14;for(const u of h){let p=d?(0,y.commonPrefixLength)(d,u):0;for(p===0?f=1:f=w;p<u.length;p++)p+1===u.length?(E=w,w=9):w+=1,a.push([f,u.toUpperCase().charCodeAt(p),w]),a.push([f,u.toLowerCase().charCodeAt(p),w]),f=w;d=u,w=E}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new S.StateMachine(a)}}provideDocumentLinks(h){this._initStateMachine();const a=[],d=S.LinkComputer.computeLinks({getLineContent(f){return h.lineAt(f-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const f of d){const E=I.DocumentLink.to(f);E.target&&a.push(E)}return a}}class k{constructor(h,a){this._extHostLanguageFeatures=a,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=h.getProxy(F.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,a,d,f={},E){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const w=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(w,d),this._enableProposedApi.set(w,E??!1);let u=2;f.isCaseSensitive&&(u+=1024),f.isReadonly&&(u+=2048),typeof d.copy=="function"&&(u+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&(u+=4),this._proxy.$registerFileSystemProvider(w,a,u).catch(b=>{console.error(`FAILED to register filesystem provider of ${h.value}-extension for the scheme ${a}`),console.error(b)});const p=d.onDidChangeFile(b=>{const t=[];for(const s of b){let{uri:r,type:i}=s;if(r.scheme!==a)continue;let c;switch(i){case _.FileChangeType.Changed:c=0;break;case _.FileChangeType.Created:c=1;break;case _.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:r,type:c})}this._proxy.$onFileSystemChange(w,t)});return(0,D.toDisposable)(()=>{p.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(w),this._enableProposedApi.delete(w),this._proxy.$unregisterProvider(w)})}static _asIStat(h,a){const{type:d,ctime:f,mtime:E,size:w,permissions:u}=h;return a?{type:d,ctime:f,mtime:E,size:w,permissions:u}:{type:d,ctime:f,mtime:E,size:w}}$stat(h,a){return Promise.resolve(this._getFsProvider(h).stat(m.URI.revive(a))).then(d=>k._asIStat(d,this._enableProposedApi.get(h)??!1))}$readdir(h,a){return Promise.resolve(this._getFsProvider(h).readDirectory(m.URI.revive(a)))}$readFile(h,a){return Promise.resolve(this._getFsProvider(h).readFile(m.URI.revive(a))).then(d=>C.VSBuffer.wrap(d))}$writeFile(h,a,d,f){return Promise.resolve(this._getFsProvider(h).writeFile(m.URI.revive(a),d.buffer,f))}$delete(h,a,d){return Promise.resolve(this._getFsProvider(h).delete(m.URI.revive(a),d))}$rename(h,a,d,f){return Promise.resolve(this._getFsProvider(h).rename(m.URI.revive(a),m.URI.revive(d),f))}$copy(h,a,d,f){const E=this._getFsProvider(h);if(!E.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(E.copy(m.URI.revive(a),m.URI.revive(d),f))}$mkdir(h,a){return Promise.resolve(this._getFsProvider(h).createDirectory(m.URI.revive(a)))}$watch(h,a,d,f){const E=this._getFsProvider(h).watch(m.URI.revive(d),f);this._watches.set(a,E)}$unwatch(h,a){const d=this._watches.get(a);d&&(d.dispose(),this._watches.delete(a))}$open(h,a,d){const f=this._getFsProvider(h);if(!f.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(f.open(m.URI.revive(a),d))}$close(h,a){const d=this._getFsProvider(h);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(a))}$read(h,a,d,f){const E=this._getFsProvider(h);if(!E.read)throw new Error('FileSystemProvider does not implement "read"');const w=C.VSBuffer.alloc(f);return Promise.resolve(E.read(a,d,w.buffer,0,f)).then(u=>w.slice(0,u))}$write(h,a,d,f){const E=this._getFsProvider(h);if(!E.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(E.write(a,d,f.buffer,0,f.byteLength))}_getFsProvider(h){const a=this._fsProvider.get(h);if(!a){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return a}}e.ExtHostFileSystem=k}),define(Ee[73],_e([0,1,5,60,6,23,4,13,45]),function(ee,e,m,F,D,_,I,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let C=class Wt{constructor(k,l){const h=k.getProxy(m.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(a){return h.$stat(a).catch(Wt._handleError)},readDirectory(a){return h.$readdir(a).catch(Wt._handleError)},createDirectory(a){return h.$mkdir(a).catch(Wt._handleError)},async readFile(a){return h.$readFile(a).then(d=>d.buffer).catch(Wt._handleError)},writeFile(a,d){return h.$writeFile(a,_.VSBuffer.wrap(d)).catch(Wt._handleError)},delete(a,d){return h.$delete(a,{recursive:!1,useTrash:!1,...d}).catch(Wt._handleError)},rename(a,d,f){return h.$rename(a,d,{overwrite:!1,...f}).catch(Wt._handleError)},copy(a,d,f){return h.$copy(a,d,{overwrite:!1,...f}).catch(Wt._handleError)},isWritableFileSystem(a){const d=l.getCapabilities(a);if(typeof d=="number")return!(d&2048)}})}static _handleError(k){if(!(k instanceof Error))throw new D.FileSystemError(String(k));if(k.name==="ENOPRO")throw D.FileSystemError.Unavailable(k.message);switch(k.name){case F.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(k.message);case F.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(k.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(k.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(k.message);case F.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(k.message);case F.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(k.message);default:throw new D.FileSystemError(k.message,k.name)}}};C=ze([qe(0,S.IExtHostRpcService),qe(1,y.IExtHostFileSystemInfo)],C),e.ExtHostConsumerFileSystem=C,e.IExtHostConsumerFileSystem=(0,I.createDecorator)("IExtHostConsumerFileSystem")}),define(Ee[193],_e([0,1,7,5]),function(ee,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(I){this._handlePool=0,this._proxy=I.getProxy(F.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(I){const S=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(S,I),(0,m.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(S)})}}e.ExtHostLabelService=D}),define(Ee[194],_e([0,1,2,24,9,6,5,8,30,17,10,116,7,87,50,63,52,12,3]),function(ee,e,m,F,D,_,I,S,y,C,n,k,l,h,a,d,f,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class u{constructor(O,K){this._documents=O,this._provider=K}async provideDocumentSymbols(O,K){const J=this._documents.getDocument(O),se=await this._provider.provideDocumentSymbols(J,K);if(!(0,C.isFalsyOrEmpty)(se))return se[0]instanceof _.DocumentSymbol?se.map(D.DocumentSymbol.from):u._asDocumentSymbolTree(se)}static _asDocumentSymbolTree(O){O=O.slice(0).sort((se,q)=>{let ne=se.location.range.start.compareTo(q.location.range.start);return ne===0&&(ne=q.location.range.end.compareTo(se.location.range.end)),ne});const K=[],J=[];for(const se of O){const q={name:se.name||"!!MISSING: name!!",kind:D.SymbolKind.from(se.kind),tags:se.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:se.containerName,range:D.Range.from(se.location.range),selectionRange:D.Range.from(se.location.range),children:[]};for(;;){if(J.length===0){J.push(q),K.push(q);break}const ne=J[J.length-1];if(y.Range.containsRange(ne.range,q.range)&&!y.Range.equalsRange(ne.range,q.range)){ne.children&&ne.children.push(q),J.push(q);break}J.pop()}}return K}}class p{constructor(O,K,J){this._documents=O,this._commands=K,this._provider=J,this._cache=new d.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(O,K){const J=this._documents.getDocument(O),se=await this._provider.provideCodeLenses(J,K);if(!se||K.isCancellationRequested)return;const q=this._cache.add(se),ne=new l.DisposableStore;this._disposables.set(q,ne);const ge={cacheId:q,lenses:[]};for(let Me=0;Me<se.length;Me++)ge.lenses.push({cacheId:[q,Me],range:D.Range.from(se[Me].range),command:this._commands.toInternal(se[Me].command,ne)});return ge}async resolveCodeLens(O,K){const J=O.cacheId&&this._cache.get(...O.cacheId);if(!J)return;let se;if(typeof this._provider.resolveCodeLens!="function"||J.isResolved?se=J:se=await this._provider.resolveCodeLens(J,K),se||(se=J),K.isCancellationRequested)return;const q=O.cacheId&&this._disposables.get(O.cacheId[0]);if(!!q)return O.command=this._commands.toInternal(se.command??p._badCmd,q),O}releaseCodeLenses(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}}p._badCmd={command:"missing",title:"!!MISSING: command!!"};function b(je){return Array.isArray(je)?je.map(D.DefinitionLink.from):je?[D.DefinitionLink.from(je)]:[]}class t{constructor(O,K){this._documents=O,this._provider=K}async provideDefinition(O,K,J){const se=this._documents.getDocument(O),q=D.Position.to(K),ne=await this._provider.provideDefinition(se,q,J);return b(ne)}}class s{constructor(O,K){this._documents=O,this._provider=K}async provideDeclaration(O,K,J){const se=this._documents.getDocument(O),q=D.Position.to(K),ne=await this._provider.provideDeclaration(se,q,J);return b(ne)}}class r{constructor(O,K){this._documents=O,this._provider=K}async provideImplementation(O,K,J){const se=this._documents.getDocument(O),q=D.Position.to(K),ne=await this._provider.provideImplementation(se,q,J);return b(ne)}}class i{constructor(O,K){this._documents=O,this._provider=K}async provideTypeDefinition(O,K,J){const se=this._documents.getDocument(O),q=D.Position.to(K),ne=await this._provider.provideTypeDefinition(se,q,J);return b(ne)}}class c{constructor(O,K){this._documents=O,this._provider=K}async provideHover(O,K,J){const se=this._documents.getDocument(O),q=D.Position.to(K),ne=await this._provider.provideHover(se,q,J);if(!(!ne||(0,C.isFalsyOrEmpty)(ne.contents)))return ne.range||(ne.range=se.getWordRangeAtPosition(q)),ne.range||(ne.range=new _.Range(q,q)),D.Hover.from(ne)}}class g{constructor(O,K){this._documents=O,this._provider=K}async provideEvaluatableExpression(O,K,J){const se=this._documents.getDocument(O),q=D.Position.to(K),ne=await this._provider.provideEvaluatableExpression(se,q,J);if(ne)return D.EvaluatableExpression.from(ne)}}class v{constructor(O,K){this._documents=O,this._provider=K}async provideInlineValues(O,K,J,se){const q=this._documents.getDocument(O),ne=await this._provider.provideInlineValues(q,D.Range.to(K),D.InlineValueContext.to(J),se);if(Array.isArray(ne))return ne.map(ge=>D.InlineValue.from(ge))}}class A{constructor(O,K){this._documents=O,this._provider=K}async provideDocumentHighlights(O,K,J){const se=this._documents.getDocument(O),q=D.Position.to(K),ne=await this._provider.provideDocumentHighlights(se,q,J);if(Array.isArray(ne))return ne.map(D.DocumentHighlight.from)}}class R{constructor(O,K){this._documents=O,this._provider=K}async provideLinkedEditingRanges(O,K,J){const se=this._documents.getDocument(O),q=D.Position.to(K),ne=await this._provider.provideLinkedEditingRanges(se,q,J);if(ne&&Array.isArray(ne.ranges))return{ranges:(0,C.coalesce)(ne.ranges.map(D.Range.from)),wordPattern:ne.wordPattern}}}class o{constructor(O,K){this._documents=O,this._provider=K}async provideReferences(O,K,J,se){const q=this._documents.getDocument(O),ne=D.Position.to(K),ge=await this._provider.provideReferences(q,ne,J,se);if(Array.isArray(ge))return ge.map(D.location.from)}}class P{constructor(O,K,J,se,q,ne,ge){this._documents=O,this._commands=K,this._diagnostics=J,this._provider=se,this._logService=q,this._extension=ne,this._apiDeprecation=ge,this._cache=new d.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(O,K,J,se){const q=this._documents.getDocument(O),ne=k.Selection.isISelection(K)?D.Selection.to(K):D.Range.to(K),ge=[];for(const X of this._diagnostics.getDiagnostics(O))if(ne.intersection(X.range)&&ge.push(X)>P._maxCodeActionsPerFile)break;const Me={diagnostics:ge,only:J.only?new _.CodeActionKind(J.only):void 0,triggerKind:D.CodeActionTriggerKind.to(J.trigger)},We=await this._provider.provideCodeActions(q,ne,Me,se);if(!(0,C.isNonEmptyArray)(We)||se.isCancellationRequested)return;const be=this._cache.add(We),Xe=new l.DisposableStore;this._disposables.set(be,Xe);const H=[];for(let X=0;X<We.length;X++){const de=We[X];!de||(P._isCommand(de)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),H.push({_isSynthetic:!0,title:de.title,command:this._commands.toInternal(de,Xe)})):(Me.only&&(de.kind?Me.only.contains(de.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${de.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),H.push({cacheId:[be,X],title:de.title,command:de.command&&this._commands.toInternal(de.command,Xe),diagnostics:de.diagnostics&&de.diagnostics.map(D.Diagnostic.from),edit:de.edit&&D.WorkspaceEdit.from(de.edit),kind:de.kind&&de.kind.value,isPreferred:de.isPreferred,disabled:de.disabled?.reason})))}return{cacheId:be,actions:H}}async resolveCodeAction(O,K){const[J,se]=O,q=this._cache.get(J,se);if(!q||P._isCommand(q)||!this._provider.resolveCodeAction)return;const ne=await this._provider.resolveCodeAction(q,K)??q;return ne?.edit?D.WorkspaceEdit.from(ne.edit):void 0}releaseCodeActions(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}static _isCommand(O){return typeof O.command=="string"&&typeof O.title=="string"}}P._maxCodeActionsPerFile=1e3;class L{constructor(O,K){this._documents=O,this._provider=K}async provideDocumentFormattingEdits(O,K,J){const se=this._documents.getDocument(O),q=await this._provider.provideDocumentFormattingEdits(se,K,J);if(Array.isArray(q))return q.map(D.TextEdit.from)}}class ${constructor(O,K){this._documents=O,this._provider=K}async provideDocumentRangeFormattingEdits(O,K,J,se){const q=this._documents.getDocument(O),ne=D.Range.to(K),ge=await this._provider.provideDocumentRangeFormattingEdits(q,ne,J,se);if(Array.isArray(ge))return ge.map(D.TextEdit.from)}}class re{constructor(O,K){this._documents=O,this._provider=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,K,J,se,q){const ne=this._documents.getDocument(O),ge=D.Position.to(K),Me=await this._provider.provideOnTypeFormattingEdits(ne,ge,J,se,q);if(Array.isArray(Me))return Me.map(D.TextEdit.from)}}class he{constructor(O,K){this._provider=O,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(O,K){const J=I.IdObject.mixin({symbols:[]}),se=await this._provider.provideWorkspaceSymbols(O,K);if((0,C.isNonEmptyArray)(se))for(const q of se){if(!q)continue;if(!q.name){this._logService.warn("INVALID SymbolInformation, lacks name",q);continue}const ne=I.IdObject.mixin(D.WorkspaceSymbol.from(q));this._symbolCache.set(ne._id,q),J.symbols.push(ne)}return J.symbols.length>0&&this._resultCache.set(J._id,[J.symbols[0]._id,J.symbols[J.symbols.length-1]._id]),J}async resolveWorkspaceSymbol(O,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return O;const J=this._symbolCache.get(O._id);if(J){const se=await this._provider.resolveWorkspaceSymbol(J,K);return se&&(0,F.mixin)(O,D.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols(O){const K=this._resultCache.get(O);if(K){for(let[J,se]=K;J<=se;J++)this._symbolCache.delete(J);this._resultCache.delete(O)}}}class Q{constructor(O,K,J){this._documents=O,this._provider=K,this._logService=J}static supportsResolving(O){return typeof O.prepareRename=="function"}async provideRenameEdits(O,K,J,se){const q=this._documents.getDocument(O),ne=D.Position.to(K);try{const ge=await this._provider.provideRenameEdits(q,ne,J,se);return ge?D.WorkspaceEdit.from(ge):void 0}catch(ge){const Me=Q._asMessage(ge);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(ge)}}async resolveRenameLocation(O,K,J){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const se=this._documents.getDocument(O),q=D.Position.to(K);try{const ne=await this._provider.prepareRename(se,q,J);let ge,Me;if(_.Range.isRange(ne)?(ge=ne,Me=se.getText(ne)):(0,n.isObject)(ne)&&(ge=ne.range,Me=ne.placeholder),!ge||!Me)return;if(ge.start.line>q.line||ge.end.line<q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(ge),text:Me}}catch(ne){const ge=Q._asMessage(ne);return ge?{rejectReason:ge,range:void 0,text:void 0}:Promise.reject(ne)}}static _asMessage(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class z{constructor(O,K){this.resultId=O,this.tokens=K}}class V{constructor(O,K){this._documents=O,this._provider=K,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(O,K,J){const se=this._documents.getDocument(O),q=K!==0?this._previousResults.get(K):null;let ne=typeof q?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(se,q.resultId,J):await this._provider.provideDocumentSemanticTokens(se,J);return q&&this._previousResults.delete(K),ne?(ne=V._fixProvidedSemanticTokens(ne),this._send(V._convertToEdits(q,ne),ne)):null}async releaseDocumentSemanticColoring(O){this._previousResults.delete(O)}static _fixProvidedSemanticTokens(O){return V._isSemanticTokens(O)?V._isCorrectSemanticTokens(O)?O:new _.SemanticTokens(new Uint32Array(O.data),O.resultId):V._isSemanticTokensEdits(O)?V._isCorrectSemanticTokensEdits(O)?O:new _.SemanticTokensEdits(O.edits.map(K=>new _.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),O.resultId):O}static _isSemanticTokens(O){return O&&!!O.data}static _isCorrectSemanticTokens(O){return O.data instanceof Uint32Array}static _isSemanticTokensEdits(O){return O&&Array.isArray(O.edits)}static _isCorrectSemanticTokensEdits(O){for(const K of O.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(O,K){if(!V._isSemanticTokens(K)||!O||!O.tokens)return K;const J=O.tokens,se=J.length,q=K.data,ne=q.length;let ge=0;const Me=Math.min(se,ne);for(;ge<Me&&J[ge]===q[ge];)ge++;if(ge===se&&ge===ne)return new _.SemanticTokensEdits([],K.resultId);let We=0;const be=Me-ge;for(;We<be&&J[se-We-1]===q[ne-We-1];)We++;return new _.SemanticTokensEdits([{start:ge,deleteCount:se-ge-We,data:q.subarray(ge,ne-We)}],K.resultId)}_send(O,K){if(V._isSemanticTokens(O)){const J=this._nextResultId++;return this._previousResults.set(J,new z(O.resultId,O.data)),(0,h.encodeSemanticTokensDto)({id:J,type:"full",data:O.data})}if(V._isSemanticTokensEdits(O)){const J=this._nextResultId++;return V._isSemanticTokens(K)?this._previousResults.set(J,new z(K.resultId,K.data)):this._previousResults.set(J,new z(O.resultId)),(0,h.encodeSemanticTokensDto)({id:J,type:"delta",deltas:(O.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}e.DocumentSemanticTokensAdapter=V;class T{constructor(O,K){this._documents=O,this._provider=K}async provideDocumentRangeSemanticTokens(O,K,J){const se=this._documents.getDocument(O),q=await this._provider.provideDocumentRangeSemanticTokens(se,D.Range.to(K),J);return q?this._send(q):null}_send(O){return(0,h.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}e.DocumentRangeSemanticTokensAdapter=T;class G{constructor(O,K,J,se,q){this._documents=O,this._commands=K,this._provider=J,this._apiDeprecation=se,this._extension=q,this._cache=new d.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}async provideCompletionItems(O,K,J,se){const q=this._documents.getDocument(O),ne=D.Position.to(K),ge=q.getWordRangeAtPosition(ne)||new _.Range(ne,ne),Me=ge.with({end:ne}),We=new f.StopWatch(!0),be=await this._provider.provideCompletionItems(q,ne,se,D.CompletionContext.to(J));if(!be||se.isCancellationRequested)return;const Xe=Array.isArray(be)?new _.CompletionList(be):be,H=G.supportsResolving(this._provider)?this._cache.add(Xe.items):this._cache.add([]),X=new l.DisposableStore;this._disposables.set(H,X);const de=[],Be={x:H,b:de,a:{replace:D.Range.from(ge),insert:D.Range.from(Me)},c:Xe.isIncomplete||void 0,d:We.elapsed()};for(let Ue=0;Ue<Xe.items.length;Ue++){const tt=Xe.items[Ue],Se=this._convertCompletionItem(tt,[H,Ue],Me,ge);de.push(Se)}return Be}async resolveCompletionItem(O,K){if(typeof this._provider.resolveCompletionItem!="function")return;const J=this._cache.get(...O);if(!J)return;const se=await this._provider.resolveCompletionItem(J,K);if(!!se)return this._convertCompletionItem(se,O)}releaseCompletionItems(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_convertCompletionItem(O,K,J,se){const q=this._disposables.get(K[0]);if(!q)throw Error("DisposableStore is missing...");const ne={x:K,a:O.label,b:O.kind!==void 0?D.CompletionItemKind.from(O.kind):void 0,n:O.tags&&O.tags.map(D.CompletionItemTag.from),c:O.detail,d:typeof O.documentation=="undefined"?void 0:D.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters,l:O.additionalTextEdits&&O.additionalTextEdits.map(D.TextEdit.from),m:this._commands.toInternal(O.command,q)};O.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ne.h=O.textEdit.newText):typeof O.insertText=="string"?ne.h=O.insertText:O.insertText instanceof _.SnippetString&&(ne.h=O.insertText.value,ne.i|=4);let ge;return O.textEdit?ge=O.textEdit.range:O.range&&(ge=O.range),_.Range.isRange(ge)?ne.j=D.Range.from(ge):ge&&(!J?.isEqual(ge.inserting)||!se?.isEqual(ge.replacing))&&(ne.j={insert:D.Range.from(ge.inserting),replace:D.Range.from(ge.replacing)}),ne}}class B{constructor(O,K,J){this._documents=O,this._provider=K,this._commands=J,this._cache=new d.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(O,K,J,se){const q=this._documents.getDocument(O),ne=D.Position.to(K),ge=await this._provider.provideInlineCompletionItems(q,ne,J,se);if(!ge||se.isCancellationRequested)return;const Me=(0,n.isArray)(ge)?{items:ge}:ge,We=this._cache.add(Me.items);let be;return{pid:We,items:Me.items.map((Xe,H)=>{let X;return Xe.command&&(be||(be=new l.DisposableStore,this._disposables.set(We,be)),X=this._commands.toInternal(Xe.command,be)),{text:Xe.text,range:Xe.range?D.Range.from(Xe.range):void 0,command:X,idx:H}})}}disposeCompletions(O){this._cache.delete(O);const K=this._disposables.get(O);K&&K.clear(),this._disposables.delete(O)}handleDidShowCompletionItem(O,K){const J=this._cache.get(O,K);J&&j.get(this._provider).fireOnDidShowCompletionItem({completionItem:J})}}class j{constructor(){this._onDidShowCompletionItemEmitter=new w.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(O){let K=j.map.get(O);return K||(K=new j,j.map.set(O,K)),K}fireOnDidShowCompletionItem(O){this._onDidShowCompletionItemEmitter.fire(O)}}e.InlineCompletionController=j,j.map=new WeakMap;class ce{constructor(O,K){this._documents=O,this._provider=K,this._cache=new d.Cache("SignatureHelp")}async provideSignatureHelp(O,K,J,se){const q=this._documents.getDocument(O),ne=D.Position.to(K),ge=this.reviveContext(J),Me=await this._provider.provideSignatureHelp(q,ne,se,ge);if(Me){const We=this._cache.add([Me]);return{...D.SignatureHelp.from(Me),id:We}}}reviveContext(O){let K;if(O.activeSignatureHelp){const J=D.SignatureHelp.to(O.activeSignatureHelp),se=this._cache.get(O.activeSignatureHelp.id,0);se?(K=se,K.activeSignature=J.activeSignature,K.activeParameter=J.activeParameter):K=J}return{...O,activeSignatureHelp:K}}releaseSignatureHelp(O){this._cache.delete(O)}}class W{constructor(O,K){this._documents=O,this._provider=K}async provideInlayHints(O,K,J){const se=this._documents.getDocument(O),q=await this._provider.provideInlayHints(se,D.Range.to(K),J);return q?{hints:q.map(D.InlayHint.from)}:void 0}}class te{constructor(O,K){this._documents=O,this._provider=K,this._cache=new d.Cache("DocumentLink")}async provideLinks(O,K){const J=this._documents.getDocument(O),se=await this._provider.provideDocumentLinks(J,K);if(!(!Array.isArray(se)||se.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:se.filter(te._validateLink).map(D.DocumentLink.from)};{const q=this._cache.add(se),ne={links:[],id:q};for(let ge=0;ge<se.length;ge++){if(!te._validateLink(se[ge]))continue;const Me=D.DocumentLink.from(se[ge]);Me.cacheId=[q,ge],ne.links.push(Me)}return ne}}}static _validateLink(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,K){if(typeof this._provider.resolveDocumentLink!="function")return;const J=this._cache.get(...O);if(!J)return;const se=await this._provider.resolveDocumentLink(J,K);if(!(!se||!te._validateLink(se)))return D.DocumentLink.from(se)}releaseLinks(O){this._cache.delete(O)}}class ue{constructor(O,K){this._documents=O,this._provider=K}async provideColors(O,K){const J=this._documents.getDocument(O),se=await this._provider.provideDocumentColors(J,K);return Array.isArray(se)?se.map(ne=>({color:D.Color.from(ne.color),range:D.Range.from(ne.range)})):[]}async provideColorPresentations(O,K,J){const se=this._documents.getDocument(O),q=D.Range.to(K.range),ne=D.Color.to(K.color),ge=await this._provider.provideColorPresentations(ne,{document:se,range:q},J);if(!!Array.isArray(ge))return ge.map(D.ColorPresentation.from)}}class ye{constructor(O,K){this._documents=O,this._provider=K}async provideFoldingRanges(O,K,J){const se=this._documents.getDocument(O),q=await this._provider.provideFoldingRanges(se,K,J);if(!!Array.isArray(q))return q.map(D.FoldingRange.from)}}class Te{constructor(O,K,J){this._documents=O,this._provider=K,this._logService=J}async provideSelectionRanges(O,K,J){const se=this._documents.getDocument(O),q=K.map(D.Position.to),ne=await this._provider.provideSelectionRanges(se,q,J);if(!(0,C.isNonEmptyArray)(ne))return[];if(ne.length!==q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ge=[];for(let Me=0;Me<q.length;Me++){const We=[];ge.push(We);let be=q[Me],Xe=ne[Me];for(;;){if(!Xe.range.contains(be))throw new Error("INVALID selection range, must contain the previous range");if(We.push(D.SelectionRange.from(Xe)),!Xe.parent)break;be=Xe.range,Xe=Xe.parent}}return ge}}class Re{constructor(O,K){this._documents=O,this._provider=K,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(O,K,J){const se=this._documents.getDocument(O),q=D.Position.to(K),ne=await this._provider.prepareCallHierarchy(se,q,J);if(!ne)return;const ge=this._idPool.nextId();return this._cache.set(ge,new Map),Array.isArray(ne)?ne.map(Me=>this._cacheAndConvertItem(ge,Me)):[this._cacheAndConvertItem(ge,ne)]}async provideCallsTo(O,K,J){const se=this._itemFromCache(O,K);if(!se)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyIncomingCalls(se,J);if(!!q)return q.map(ne=>({from:this._cacheAndConvertItem(O,ne.from),fromRanges:ne.fromRanges.map(ge=>D.Range.from(ge))}))}async provideCallsFrom(O,K,J){const se=this._itemFromCache(O,K);if(!se)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyOutgoingCalls(se,J);if(!!q)return q.map(ne=>({to:this._cacheAndConvertItem(O,ne.to),fromRanges:ne.fromRanges.map(ge=>D.Range.from(ge))}))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,K){const J=this._cache.get(O),se=D.CallHierarchyItem.from(K,O,J.size.toString(36));return J.set(se._itemId,K),se}_itemFromCache(O,K){return this._cache.get(O)?.get(K)}}class $e{constructor(O,K){this._documents=O,this._provider=K,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(O,K,J){const se=this._documents.getDocument(O),q=D.Position.to(K),ne=await this._provider.prepareTypeHierarchy(se,q,J);if(!ne)return;const ge=this._idPool.nextId();return this._cache.set(ge,new Map),Array.isArray(ne)?ne.map(Me=>this._cacheAndConvertItem(ge,Me)):[this._cacheAndConvertItem(ge,ne)]}async provideSupertypes(O,K,J){const se=this._itemFromCache(O,K);if(!se)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySupertypes(se,J);if(!!q)return q.map(ne=>this._cacheAndConvertItem(O,ne))}async provideSubtypes(O,K,J){const se=this._itemFromCache(O,K);if(!se)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySubtypes(se,J);if(!!q)return q.map(ne=>this._cacheAndConvertItem(O,ne))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,K){const J=this._cache.get(O),se=D.TypeHierarchyItem.from(K,O,J.size.toString(36));return J.set(se._itemId,K),se}_itemFromCache(O,K){return this._cache.get(O)?.get(K)}}class Ze{constructor(O,K){this.adapter=O,this.extension=K}}class Ve{constructor(O,K,J,se,q,ne,ge){this._adapter=new Map,this._uriTransformer=K,this._proxy=O.getProxy(I.MainContext.MainThreadLanguageFeatures),this._documents=J,this._commands=se,this._diagnostics=q,this._logService=ne,this._apiDeprecation=ge}_transformDocumentSelector(O){return(0,C.coalesce)((0,C.asArray)(O).map(K=>this._doTransformDocumentSelector(K)))}_doTransformDocumentSelector(O){if(typeof O=="string")return{$serialized:!0,language:O};if(O)return{$serialized:!0,language:O.language,scheme:this._transformScheme(O.scheme),pattern:typeof O.pattern=="undefined"?void 0:D.GlobPattern.from(O.pattern),exclusive:O.exclusive}}_transformScheme(O){return this._uriTransformer&&typeof O=="string"?this._uriTransformer.transformOutgoingScheme(O):O}_createDisposable(O){return new _.Disposable(()=>{this._adapter.delete(O),this._proxy.$unregister(O)})}_nextHandle(){return Ve._handlePool++}_withAdapter(O,K,J,se,q=!1){const ne=this._adapter.get(O);if(!ne)return Promise.resolve(se);if(ne.adapter instanceof K){let ge;ne.extension&&(ge=Date.now(),this._logService.trace(`[${ne.extension.identifier.value}] INVOKE provider '${K.name}'`));const Me=J(ne.adapter,ne.extension),We=ne.extension;return We&&Promise.resolve(Me).then(()=>this._logService.trace(`[${We.identifier.value}] provider DONE after ${Date.now()-ge}ms`),be=>{q&&be instanceof E.CancellationError||(this._logService.error(`[${We.identifier.value}] provider FAILED`),this._logService.error(be))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(O,K){const J=this._nextHandle();return this._adapter.set(J,new Ze(O,K)),J}static _extLabel(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,K,J,se){const q=this._addNewAdapter(new u(this._documents,J),O),ne=se&&se.label||Ve._extLabel(O);return this._proxy.$registerDocumentSymbolProvider(q,this._transformDocumentSelector(K),ne),this._createDisposable(q)}$provideDocumentSymbols(O,K,J){return this._withAdapter(O,u,se=>se.provideDocumentSymbols(m.URI.revive(K),J),void 0)}registerCodeLensProvider(O,K,J){const se=this._nextHandle(),q=typeof J.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(se,new Ze(new p(this._documents,this._commands.converter,J),O)),this._proxy.$registerCodeLensSupport(se,this._transformDocumentSelector(K),q);let ne=this._createDisposable(se);if(q!==void 0){const ge=J.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(q));ne=_.Disposable.from(ne,ge)}return ne}$provideCodeLenses(O,K,J){return this._withAdapter(O,p,se=>se.provideCodeLenses(m.URI.revive(K),J),void 0)}$resolveCodeLens(O,K,J){return this._withAdapter(O,p,se=>se.resolveCodeLens(K,J),void 0)}$releaseCodeLenses(O,K){this._withAdapter(O,p,J=>Promise.resolve(J.releaseCodeLenses(K)),void 0)}registerDefinitionProvider(O,K,J){const se=this._addNewAdapter(new t(this._documents,J),O);return this._proxy.$registerDefinitionSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDefinition(O,K,J,se){return this._withAdapter(O,t,q=>q.provideDefinition(m.URI.revive(K),J,se),[])}registerDeclarationProvider(O,K,J){const se=this._addNewAdapter(new s(this._documents,J),O);return this._proxy.$registerDeclarationSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDeclaration(O,K,J,se){return this._withAdapter(O,s,q=>q.provideDeclaration(m.URI.revive(K),J,se),[])}registerImplementationProvider(O,K,J){const se=this._addNewAdapter(new r(this._documents,J),O);return this._proxy.$registerImplementationSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideImplementation(O,K,J,se){return this._withAdapter(O,r,q=>q.provideImplementation(m.URI.revive(K),J,se),[])}registerTypeDefinitionProvider(O,K,J){const se=this._addNewAdapter(new i(this._documents,J),O);return this._proxy.$registerTypeDefinitionSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideTypeDefinition(O,K,J,se){return this._withAdapter(O,i,q=>q.provideTypeDefinition(m.URI.revive(K),J,se),[])}registerHoverProvider(O,K,J,se){const q=this._addNewAdapter(new c(this._documents,J),O);return this._proxy.$registerHoverProvider(q,this._transformDocumentSelector(K)),this._createDisposable(q)}$provideHover(O,K,J,se){return this._withAdapter(O,c,q=>q.provideHover(m.URI.revive(K),J,se),void 0)}registerEvaluatableExpressionProvider(O,K,J,se){const q=this._addNewAdapter(new g(this._documents,J),O);return this._proxy.$registerEvaluatableExpressionProvider(q,this._transformDocumentSelector(K)),this._createDisposable(q)}$provideEvaluatableExpression(O,K,J,se){return this._withAdapter(O,g,q=>q.provideEvaluatableExpression(m.URI.revive(K),J,se),void 0)}registerInlineValuesProvider(O,K,J,se){const q=typeof J.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ne=this._addNewAdapter(new v(this._documents,J),O);this._proxy.$registerInlineValuesProvider(ne,this._transformDocumentSelector(K),q);let ge=this._createDisposable(ne);if(q!==void 0){const Me=J.onDidChangeInlineValues(We=>this._proxy.$emitInlineValuesEvent(q));ge=_.Disposable.from(ge,Me)}return ge}$provideInlineValues(O,K,J,se,q){return this._withAdapter(O,v,ne=>ne.provideInlineValues(m.URI.revive(K),J,se,q),void 0)}registerDocumentHighlightProvider(O,K,J){const se=this._addNewAdapter(new A(this._documents,J),O);return this._proxy.$registerDocumentHighlightProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDocumentHighlights(O,K,J,se){return this._withAdapter(O,A,q=>q.provideDocumentHighlights(m.URI.revive(K),J,se),void 0)}registerLinkedEditingRangeProvider(O,K,J){const se=this._addNewAdapter(new R(this._documents,J),O);return this._proxy.$registerLinkedEditingRangeProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideLinkedEditingRanges(O,K,J,se){return this._withAdapter(O,R,async q=>{const ne=await q.provideLinkedEditingRanges(m.URI.revive(K),J,se);if(ne)return{ranges:ne.ranges,wordPattern:ne.wordPattern?Ve._serializeRegExp(ne.wordPattern):void 0}},void 0)}registerReferenceProvider(O,K,J){const se=this._addNewAdapter(new o(this._documents,J),O);return this._proxy.$registerReferenceSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideReferences(O,K,J,se,q){return this._withAdapter(O,o,ne=>ne.provideReferences(m.URI.revive(K),J,se,q),void 0)}registerCodeActionProvider(O,K,J,se){const q=new l.DisposableStore,ne=this._addNewAdapter(new P(this._documents,this._commands.converter,this._diagnostics,J,this._logService,O,this._apiDeprecation),O);return this._proxy.$registerQuickFixSupport(ne,this._transformDocumentSelector(K),{providedKinds:se?.providedCodeActionKinds?.map(ge=>ge.value),documentation:se?.documentation?.map(ge=>({kind:ge.kind.value,command:this._commands.converter.toInternal(ge.command,q)}))},Ve._extLabel(O),Boolean(J.resolveCodeAction)),q.add(this._createDisposable(ne)),q}$provideCodeActions(O,K,J,se,q){return this._withAdapter(O,P,ne=>ne.provideCodeActions(m.URI.revive(K),J,se,q),void 0)}$resolveCodeAction(O,K,J){return this._withAdapter(O,P,se=>se.resolveCodeAction(K,J),void 0)}$releaseCodeActions(O,K){this._withAdapter(O,P,J=>Promise.resolve(J.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider(O,K,J){const se=this._addNewAdapter(new L(this._documents,J),O);return this._proxy.$registerDocumentFormattingSupport(se,this._transformDocumentSelector(K),O.identifier,O.displayName||O.name),this._createDisposable(se)}$provideDocumentFormattingEdits(O,K,J,se){return this._withAdapter(O,L,q=>q.provideDocumentFormattingEdits(m.URI.revive(K),J,se),void 0)}registerDocumentRangeFormattingEditProvider(O,K,J){const se=this._addNewAdapter(new $(this._documents,J),O);return this._proxy.$registerRangeFormattingSupport(se,this._transformDocumentSelector(K),O.identifier,O.displayName||O.name),this._createDisposable(se)}$provideDocumentRangeFormattingEdits(O,K,J,se,q){return this._withAdapter(O,$,ne=>ne.provideDocumentRangeFormattingEdits(m.URI.revive(K),J,se,q),void 0)}registerOnTypeFormattingEditProvider(O,K,J,se){const q=this._addNewAdapter(new re(this._documents,J),O);return this._proxy.$registerOnTypeFormattingSupport(q,this._transformDocumentSelector(K),se,O.identifier),this._createDisposable(q)}$provideOnTypeFormattingEdits(O,K,J,se,q,ne){return this._withAdapter(O,re,ge=>ge.provideOnTypeFormattingEdits(m.URI.revive(K),J,se,q,ne),void 0)}registerWorkspaceSymbolProvider(O,K){const J=this._addNewAdapter(new he(K,this._logService),O);return this._proxy.$registerNavigateTypeSupport(J),this._createDisposable(J)}$provideWorkspaceSymbols(O,K,J){return this._withAdapter(O,he,se=>se.provideWorkspaceSymbols(K,J),{symbols:[]})}$resolveWorkspaceSymbol(O,K,J){return this._withAdapter(O,he,se=>se.resolveWorkspaceSymbol(K,J),void 0)}$releaseWorkspaceSymbols(O,K){this._withAdapter(O,he,J=>J.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider(O,K,J){const se=this._addNewAdapter(new Q(this._documents,J,this._logService),O);return this._proxy.$registerRenameSupport(se,this._transformDocumentSelector(K),Q.supportsResolving(J)),this._createDisposable(se)}$provideRenameEdits(O,K,J,se,q){return this._withAdapter(O,Q,ne=>ne.provideRenameEdits(m.URI.revive(K),J,se,q),void 0)}$resolveRenameLocation(O,K,J,se){return this._withAdapter(O,Q,q=>q.resolveRenameLocation(m.URI.revive(K),J,se),void 0)}registerDocumentSemanticTokensProvider(O,K,J,se){const q=this._nextHandle(),ne=typeof J.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(q,new Ze(new V(this._documents,J),O)),this._proxy.$registerDocumentSemanticTokensProvider(q,this._transformDocumentSelector(K),se,ne);let ge=this._createDisposable(q);if(ne){const Me=J.onDidChangeSemanticTokens(We=>this._proxy.$emitDocumentSemanticTokensEvent(ne));ge=_.Disposable.from(ge,Me)}return ge}$provideDocumentSemanticTokens(O,K,J,se){return this._withAdapter(O,V,q=>q.provideDocumentSemanticTokens(m.URI.revive(K),J,se),null,!0)}$releaseDocumentSemanticTokens(O,K){this._withAdapter(O,V,J=>J.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider(O,K,J,se){const q=this._addNewAdapter(new T(this._documents,J),O);return this._proxy.$registerDocumentRangeSemanticTokensProvider(q,this._transformDocumentSelector(K),se),this._createDisposable(q)}$provideDocumentRangeSemanticTokens(O,K,J,se){return this._withAdapter(O,T,q=>q.provideDocumentRangeSemanticTokens(m.URI.revive(K),J,se),null,!0)}registerCompletionItemProvider(O,K,J,se){const q=this._addNewAdapter(new G(this._documents,this._commands.converter,J,this._apiDeprecation,O),O);return this._proxy.$registerSuggestSupport(q,this._transformDocumentSelector(K),se,G.supportsResolving(J),`${O.identifier.value}(${se.join("")})`),this._createDisposable(q)}$provideCompletionItems(O,K,J,se,q){return this._withAdapter(O,G,ne=>ne.provideCompletionItems(m.URI.revive(K),J,se,q),void 0)}$resolveCompletionItem(O,K,J){return this._withAdapter(O,G,se=>se.resolveCompletionItem(K,J),void 0)}$releaseCompletionItems(O,K){this._withAdapter(O,G,J=>J.releaseCompletionItems(K),void 0)}registerInlineCompletionsProvider(O,K,J){const se=this._addNewAdapter(new B(this._documents,J,this._commands.converter),O);return this._proxy.$registerInlineCompletionsSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideInlineCompletions(O,K,J,se,q){return this._withAdapter(O,B,ne=>ne.provideInlineCompletions(m.URI.revive(K),J,se,q),void 0)}$handleInlineCompletionDidShow(O,K,J){this._withAdapter(O,B,async se=>{se.handleDidShowCompletionItem(K,J)},void 0)}$freeInlineCompletionsList(O,K){this._withAdapter(O,B,async J=>{J.disposeCompletions(K)},void 0)}registerSignatureHelpProvider(O,K,J,se){const q=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,ne=this._addNewAdapter(new ce(this._documents,J),O);return this._proxy.$registerSignatureHelpProvider(ne,this._transformDocumentSelector(K),q),this._createDisposable(ne)}$provideSignatureHelp(O,K,J,se,q){return this._withAdapter(O,ce,ne=>ne.provideSignatureHelp(m.URI.revive(K),J,se,q),void 0)}$releaseSignatureHelp(O,K){this._withAdapter(O,ce,J=>J.releaseSignatureHelp(K),void 0)}registerInlayHintsProvider(O,K,J){const se=typeof J.onDidChangeInlayHints=="function"?this._nextHandle():void 0,q=this._addNewAdapter(new W(this._documents,J),O);this._proxy.$registerInlayHintsProvider(q,this._transformDocumentSelector(K),se);let ne=this._createDisposable(q);if(se!==void 0){const ge=J.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(se));ne=_.Disposable.from(ne,ge)}return ne}$provideInlayHints(O,K,J,se){return this._withAdapter(O,W,q=>q.provideInlayHints(m.URI.revive(K),J,se),void 0)}registerDocumentLinkProvider(O,K,J){const se=this._addNewAdapter(new te(this._documents,J),O);return this._proxy.$registerDocumentLinkProvider(se,this._transformDocumentSelector(K),typeof J.resolveDocumentLink=="function"),this._createDisposable(se)}$provideDocumentLinks(O,K,J){return this._withAdapter(O,te,se=>se.provideLinks(m.URI.revive(K),J),void 0)}$resolveDocumentLink(O,K,J){return this._withAdapter(O,te,se=>se.resolveLink(K,J),void 0)}$releaseDocumentLinks(O,K){this._withAdapter(O,te,J=>J.releaseLinks(K),void 0)}registerColorProvider(O,K,J){const se=this._addNewAdapter(new ue(this._documents,J),O);return this._proxy.$registerDocumentColorProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDocumentColors(O,K,J){return this._withAdapter(O,ue,se=>se.provideColors(m.URI.revive(K),J),[])}$provideColorPresentations(O,K,J,se){return this._withAdapter(O,ue,q=>q.provideColorPresentations(m.URI.revive(K),J,se),void 0)}registerFoldingRangeProvider(O,K,J){const se=this._nextHandle(),q=typeof J.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(se,new Ze(new ye(this._documents,J),O)),this._proxy.$registerFoldingRangeProvider(se,this._transformDocumentSelector(K),q);let ne=this._createDisposable(se);if(q!==void 0){const ge=J.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(q));ne=_.Disposable.from(ne,ge)}return ne}$provideFoldingRanges(O,K,J,se){return this._withAdapter(O,ye,q=>q.provideFoldingRanges(m.URI.revive(K),J,se),void 0)}registerSelectionRangeProvider(O,K,J){const se=this._addNewAdapter(new Te(this._documents,J,this._logService),O);return this._proxy.$registerSelectionRangeProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideSelectionRanges(O,K,J,se){return this._withAdapter(O,Te,q=>q.provideSelectionRanges(m.URI.revive(K),J,se),[])}registerCallHierarchyProvider(O,K,J){const se=this._addNewAdapter(new Re(this._documents,J),O);return this._proxy.$registerCallHierarchyProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$prepareCallHierarchy(O,K,J,se){return this._withAdapter(O,Re,q=>Promise.resolve(q.prepareSession(m.URI.revive(K),J,se)),void 0)}$provideCallHierarchyIncomingCalls(O,K,J,se){return this._withAdapter(O,Re,q=>q.provideCallsTo(K,J,se),void 0)}$provideCallHierarchyOutgoingCalls(O,K,J,se){return this._withAdapter(O,Re,q=>q.provideCallsFrom(K,J,se),void 0)}$releaseCallHierarchy(O,K){this._withAdapter(O,Re,J=>Promise.resolve(J.releaseSession(K)),void 0)}registerTypeHierarchyProvider(O,K,J){const se=this._addNewAdapter(new $e(this._documents,J),O);return this._proxy.$registerTypeHierarchyProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$prepareTypeHierarchy(O,K,J,se){return this._withAdapter(O,$e,q=>Promise.resolve(q.prepareSession(m.URI.revive(K),J,se)),void 0)}$provideTypeHierarchySupertypes(O,K,J,se){return this._withAdapter(O,$e,q=>q.provideSupertypes(K,J,se),void 0)}$provideTypeHierarchySubtypes(O,K,J,se){return this._withAdapter(O,$e,q=>q.provideSubtypes(K,J,se),void 0)}$releaseTypeHierarchy(O,K){this._withAdapter(O,$e,J=>Promise.resolve(J.releaseSession(K)),void 0)}static _serializeRegExp(O){return{pattern:O.source,flags:(0,S.regExpFlags)(O)}}static _serializeIndentationRule(O){return{decreaseIndentPattern:Ve._serializeRegExp(O.decreaseIndentPattern),increaseIndentPattern:Ve._serializeRegExp(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?Ve._serializeRegExp(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?Ve._serializeRegExp(O.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(O){return{beforeText:Ve._serializeRegExp(O.beforeText),afterText:O.afterText?Ve._serializeRegExp(O.afterText):void 0,previousLineText:O.previousLineText?Ve._serializeRegExp(O.previousLineText):void 0,action:O.action}}static _serializeOnEnterRules(O){return O.map(Ve._serializeOnEnterRule)}setLanguageConfiguration(O,K,J){let{wordPattern:se}=J;if(se&&(0,S.regExpLeadsToEndlessLoop)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this._documents.setWordDefinitionFor(K,se):this._documents.setWordDefinitionFor(K,void 0),J.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),J.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const q=this._nextHandle(),ne={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?Ve._serializeRegExp(J.wordPattern):void 0,indentationRules:J.indentationRules?Ve._serializeIndentationRule(J.indentationRules):void 0,onEnterRules:J.onEnterRules?Ve._serializeOnEnterRules(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport};return this._proxy.$setLanguageConfiguration(q,K,ne),this._createDisposable(q)}$setWordDefinitions(O){for(const K of O)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=Ve,Ve._handlePool=0}),define(Ee[195],_e([0,1,5,9,6]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class _{constructor(S,y){this._proxy=S.getProxy(m.MainContext.MainThreadLanguages),this._documents=y}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(S,y){await this._proxy.$changeLanguage(S,y);const C=this._documents.getDocumentData(S);if(!C)throw new Error(`document '${S.toString}' NOT found`);return C.document}async tokenAtPosition(S,y){const C=S.version,n=F.Position.from(y),k=await this._proxy.$tokensAtPosition(S.uri,n),l={type:D.StandardTokenType.Other,range:S.getWordRangeAtPosition(y)??new D.Range(y.line,y.character,y.line,y.character)};if(!k)return l;const h={range:F.Range.to(k.range),type:F.TokenType.to(k.type)};return!h.range.contains(y)||C!==S.version?l:h}}e.ExtHostLanguages=_}),define(Ee[196],_e([0,1,5,15,29]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function _(S){return S&&S.title}let I=class{constructor(y,C){this._logService=C,this._proxy=y.getProxy(m.MainContext.MainThreadMessageService)}showMessage(y,C,n,k,l){const h={extension:y};let a;typeof k=="string"||_(k)?a=[k,...l]:(h.modal=k?.modal,h.useCustom=k?.useCustom,h.detail=k?.detail,a=l),h.useCustom&&(0,D.checkProposedApiEnabled)(y);const d=[];for(let f=0;f<a.length;f++){const E=a[f];if(typeof E=="string")d.push({title:E,handle:f,isCloseAffordance:!1});else if(typeof E=="object"){let{title:w,isCloseAffordance:u}=E;d.push({title:w,isCloseAffordance:!!u,handle:f})}else this._logService.warn("Invalid message item:",E)}return this._proxy.$showMessage(C,n,h,d).then(f=>{if(typeof f=="number")return a[f]})}};I=ze([qe(1,F.ILogService)],I),e.ExtHostMessageService=I}),define(Ee[197],_e([0,1,23,3,41,7,22,8,10,2,63,5,9,6,174,98]),function(ee,e,m,F,D,_,I,S,y,C,n,k,l,h,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class f{constructor(w,u,p,b,t){this._textDocumentsAndEditors=p,this._textDocuments=b,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new I.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new F.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new F.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new F.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new F.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new F.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new F.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new F.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new F.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new n.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=w.getProxy(k.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=w.getProxy(k.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=w.getProxy(k.MainContext.MainThreadNotebookEditors),this._commandsConverter=u.converter,u.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const r=s.notebookEditor?.notebookUri,i=s.cell.handle,g=this._documents.get(r)?.getCell(i);if(g)return g.apiCell}return s}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(w=>w.apiEditor)}getEditorById(w){const u=this._editors.get(w);if(!u)throw new Error(`unknown text editor: ${w}. known editors: ${[...this._editors.keys()]} `);return u}getIdByEditor(w){for(const[u,p]of this._editors)if(p.apiEditor===w)return u}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(w,u){const p=this._documents.get(w);if(!p&&!u)throw new Error(`NO notebook document for '${w}'`);return p}_getProviderData(w){const u=this._notebookContentProviders.get(w);if(!u)throw new Error(`NO provider for '${w}'`);return u}registerNotebookContentProvider(w,u,p,b,t){if((0,S.isFalsyOrWhitespace)(u))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(u))throw new Error(`Notebook provider for '${u}' already registered`);this._notebookContentProviders.set(u,{extension:w,provider:p});let s;return p.onDidChangeNotebookContentOptions&&(s=p.onDidChangeNotebookContentOptions(()=>{const r=l.NotebookDocumentContentOptions.from(p.options);this._notebookProxy.$updateNotebookProviderOptions(u,r)})),this._notebookProxy.$registerNotebookProvider({id:w.identifier,location:w.extensionLocation},u,l.NotebookDocumentContentOptions.from(b),f._convertNotebookRegistrationData(w,t)),new h.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(u),this._notebookProxy.$unregisterNotebookProvider(u)})}static _convertNotebookRegistrationData(w,u){if(!u)return;const p=u.filenamePattern.map(b=>l.NotebookExclusiveDocumentPattern.from(b)).filter(b=>b!==void 0);if(u.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${u.filenamePattern}`);return}return{extension:w.identifier,providerDisplayName:w.displayName||w.name,displayName:u.displayName,filenamePattern:p,exclusive:u.exclusive||!1}}registerNotebookCellStatusBarItemProvider(w,u,p){const b=f._notebookStatusBarItemProviderHandlePool++,t=typeof p.onDidChangeCellStatusBarItems=="function"?f._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(b,p),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(b,t,u);let s;return t!==void 0&&(s=p.onDidChangeCellStatusBarItems(r=>this._notebookProxy.$emitCellStatusBarEvent(t))),new h.Disposable(()=>{this._notebookStatusBarItemProviders.delete(b),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(b,t),s&&s.dispose()})}async createNotebookDocument(w){const u=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:w.viewType,content:w.content&&l.NotebookData.from(w.content)});return C.URI.revive(u)}async openNotebookDocument(w){const u=this._documents.get(w);if(u)return u.apiNotebook;const p=await this._notebookDocumentsProxy.$tryOpenNotebook(w),b=this._documents.get(C.URI.revive(p));return(0,y.assertIsDefined)(b?.apiNotebook)}async showNotebookDocument(w,u){C.URI.isUri(w)&&(w=await this.openNotebookDocument(w));let p;typeof u=="object"?p={position:l.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selections:u.selections&&u.selections.map(l.NotebookRange.from),pinned:typeof u.preview=="boolean"?!u.preview:void 0}:p={preserveFocus:!1};const b=await this._notebookEditorsProxy.$tryShowNotebookDocument(w.uri,w.notebookType,p),t=b&&this._editors.get(b)?.apiEditor;if(t)return t;throw b?new Error(`Could NOT open editor for "${w.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(w,u,p,b){const t=this._notebookStatusBarItemProviders.get(w),s=C.URI.revive(u),r=this._documents.get(s);if(!r||!t)return;const i=r.getCellFromIndex(p);if(!i)return;const c=await t.provideCellStatusBarItems(i.apiCell,b);if(!c)return;const g=new _.DisposableStore,v=this._statusBarCache.add([g]),R=(Array.isArray(c)?c:[c]).map(o=>l.NotebookStatusBarItem.from(o,this._commandsConverter,g));return{cacheId:v,items:R}}$releaseNotebookCellStatusBarItems(w){this._statusBarCache.delete(w)}registerNotebookSerializer(w,u,p,b,t){if((0,S.isFalsyOrWhitespace)(u))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,p),this._notebookProxy.$registerNotebookSerializer(s,{id:w.identifier,location:w.extensionLocation},u,l.NotebookDocumentContentOptions.from(b),f._convertNotebookRegistrationData(w,t)),(0,_.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(w,u,p){const b=this._notebookSerializer.get(w);if(!b)throw new Error("NO serializer found");const t=await b.deserializeNotebook(u.buffer,p);return l.NotebookData.from(t)}async $notebookToData(w,u,p){const b=this._notebookSerializer.get(w);if(!b)throw new Error("NO serializer found");const t=await b.serializeNotebook(l.NotebookData.to(u),p);return m.VSBuffer.wrap(t)}async $openNotebook(w,u,p,b,t){const{provider:s}=this._getProviderData(w),r=await s.openNotebook(C.URI.revive(u),{backupId:p,untitledDocumentData:b?.buffer},t);return{metadata:r.metadata??Object.create(null),cells:r.cells.map(l.NotebookCellData.from)}}async $saveNotebook(w,u,p){const b=this.getNotebookDocument(C.URI.revive(u)),{provider:t}=this._getProviderData(w);return await t.saveNotebook(b.apiNotebook,p),!0}async $saveNotebookAs(w,u,p,b){const t=this.getNotebookDocument(C.URI.revive(u)),{provider:s}=this._getProviderData(w);return await s.saveNotebookAs(C.URI.revive(p),t.apiNotebook,b),!0}async $backupNotebook(w,u,p){const b=this.getNotebookDocument(C.URI.revive(u)),t=this._getProviderData(w),s=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension),r=String((0,D.hash)([b.uri.toString(),this._backupIdPool++])),i=C.URI.joinPath(s,r),c=await t.provider.backupNotebook(b.apiNotebook,{destination:i},p);return b.updateBackup(c),c.id}_createExtHostEditor(w,u,p){if(this._editors.has(u))throw new Error(`editor with id ALREADY EXSIST: ${u}`);const b=new d.ExtHostNotebookEditor(u,this._notebookEditorsProxy,w,p.visibleRanges.map(l.NotebookRange.to),p.selections.map(l.NotebookRange.to),typeof p.viewColumn=="number"?l.ViewColumn.to(p.viewColumn):void 0);this._editors.set(u,b)}$acceptDocumentAndEditorsDelta(w){if(w.removedDocuments)for(const p of w.removedDocuments){const b=C.URI.revive(p),t=this._documents.get(b);t&&(t.dispose(),this._documents.delete(b),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:t.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(t.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===b.toString()&&this._editors.delete(s.id)}if(w.addedDocuments){const p=[];for(const b of w.addedDocuments){const t=C.URI.revive(b.uri);if(this._documents.has(t))throw new Error(`adding EXISTING notebook ${t} `);const s=this,r=new a.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(i){s._onDidChangeNotebookCells.fire(i)},emitCellOutputsChange(i){s._onDidChangeCellOutputs.fire(i)},emitCellMetadataChange(i){s._onDidChangeCellMetadata.fire(i)},emitCellExecutionStateChange(i){s._onDidChangeCellExecutionState.fire(i)}},t,b);p.push(...b.cells.map(i=>a.ExtHostCell.asModelAddData(r.apiNotebook,i))),this._documents.get(t)?.dispose(),this._documents.set(t,r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this._onDidOpenNotebookDocument.fire(r.apiNotebook)}}if(w.addedEditors)for(const p of w.addedEditors){if(this._editors.has(p.id))return;const b=C.URI.revive(p.documentUri),t=this._documents.get(b);t&&this._createExtHostEditor(t,p.id,p)}const u=[];if(w.removedEditors)for(const p of w.removedEditors){const b=this._editors.get(p);b&&(this._editors.delete(p),this._activeNotebookEditor?.id===b.id&&(this._activeNotebookEditor=void 0),u.push(b))}if(w.visibleEditors){this._visibleNotebookEditors=w.visibleEditors.map(b=>this._editors.get(b)).filter(b=>!!b);const p=new Set;this._visibleNotebookEditors.forEach(b=>p.add(b.id));for(const b of this._editors.values()){const t=p.has(b.id);b._acceptVisibility(t)}this._visibleNotebookEditors=[...this._editors.values()].map(b=>b).filter(b=>b.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}w.newActiveEditor===null?this._activeNotebookEditor=void 0:w.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(w.newActiveEditor)),w.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=f,f._notebookStatusBarItemProviderHandlePool=0}),define(Ee[198],_e([0,1,3,50,15,5,13,9]),function(ee,e,m,F,D,_,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class y{constructor(k,l){const h=y._Keys.nextId();k.$registerNotebookEditorDecorationType(h,S.NotebookDecorationRenderOptions.from(l)),this.value={key:h,dispose(){k.$removeNotebookEditorDecorationType(h)}}}}y._Keys=new F.IdGenerator("NotebookEditorDecorationType");let C=class{constructor(k,l,h){this._logService=k,this._extHostRpc=l,this._notebooksAndEditors=h,this._onDidChangeNotebookEditorSelection=new m.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new m.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(k){return new y(this._extHostRpc.getProxy(_.MainContext.MainThreadNotebookEditors),k).value}$acceptEditorPropertiesChanged(k,l){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",k,l);const h=this._notebooksAndEditors.getEditorById(k);l.visibleRanges&&h._acceptVisibleRanges(l.visibleRanges.ranges.map(S.NotebookRange.to)),l.selections&&h._acceptSelections(l.selections.selections.map(S.NotebookRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:h.apiEditor,visibleRanges:h.apiEditor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:h.apiEditor,selections:h.apiEditor.selections}))}$acceptEditorViewColumns(k){for(const l in k)this._notebooksAndEditors.getEditorById(l)._acceptViewColumn(S.ViewColumn.to(k[l]))}};C=ze([qe(0,D.ILogService),qe(1,I.IExtHostRpcService)],C),e.ExtHostNotebookEditors=C}),define(Ee[199],_e([0,1,3,7,5,26,2,9,68,22,16,69,18,17,15,6,29]),function(ee,e,m,F,D,_,I,S,y,C,n,k,l,h,a,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let E=class{constructor(t,s,r,i){this._initData=s,this._extHostNotebook=r,this._logService=i,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(D.MainContext.MainThreadNotebookKernels)}createNotebookController(t,s,r,i,c,g){for(let B of this._kernelData.values())if(B.controller.id===s&&_.ExtensionIdentifier.equals(t.identifier,B.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const v=this._handlePool++,A=this;this._logService.trace(`NotebookController[${v}], CREATED by ${t.identifier.value}, ${s}`);const R=()=>console.warn(`NO execute handler from notebook controller '${re.id}' of extension: '${t.identifier}'`);let o=!1;const P=new F.DisposableStore,L=new m.Emitter,$=new m.Emitter,re={id:`${t.identifier.value}/${s}`,notebookType:r,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:i||t.identifier.value,preloads:g?g.map(S.NotebookRendererScript.from):[]};let he=c??R,Q;this._proxy.$addKernel(v,re).catch(B=>{console.log(B),o=!0});let z=0;const V=()=>{if(o)return;const B=++z;Promise.resolve().then(()=>{B===z&&this._proxy.$updateKernel(v,re)})},T=new C.ResourceMap,G={get id(){return s},get notebookType(){return re.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return re.label},set label(B){re.label=B??t.displayName??t.name,V()},get detail(){return re.detail??""},set detail(B){re.detail=B,V()},get description(){return re.description??""},set description(B){re.description=B,V()},get supportedLanguages(){return re.supportedLanguages},set supportedLanguages(B){re.supportedLanguages=B,V()},get supportsExecutionOrder(){return re.supportsExecutionOrder??!1},set supportsExecutionOrder(B){re.supportsExecutionOrder=B,V()},get rendererScripts(){return re.preloads?re.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return he},set executeHandler(B){he=B??R},get interruptHandler(){return Q},set interruptHandler(B){Q=B,re.supportsInterrupt=Boolean(B),V()},createNotebookCellExecution(B){if(o)throw new Error("notebook controller is DISPOSED");if(!T.has(B.notebook.uri))throw A._logService.trace(`NotebookController[${v}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(T.keys()).map(j=>j.toString())),new Error(`notebook controller is NOT associated to notebook: ${B.notebook.uri.toString()}`);return A._createNotebookCellExecution(B)},dispose:()=>{o||(this._logService.trace(`NotebookController[${v}], DISPOSED`),o=!0,this._kernelData.delete(v),P.dispose(),L.dispose(),$.dispose(),this._proxy.$removeKernel(v))},updateNotebookAffinity(B,j){A._proxy.$updateNotebookPriority(v,B.uri,j)},onDidReceiveMessage:$.event,postMessage(B,j){return(0,f.checkProposedApiEnabled)(t),A._proxy.$postMessage(v,j&&A._extHostNotebook.getIdByEditor(j),B)},asWebviewUri(B){return(0,f.checkProposedApiEnabled)(t),(0,y.asWebviewUri)(B,A._initData.remote)}};return this._kernelData.set(v,{extensionId:t.identifier,controller:G,onDidReceiveMessage:$,onDidChangeSelection:L,associatedNotebooks:T}),G}$acceptNotebookAssociation(t,s,r){const i=this._kernelData.get(t);if(i){const c=this._extHostNotebook.getNotebookDocument(I.URI.revive(s));r?i.associatedNotebooks.set(c.uri,!0):i.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,c.uri.toString(),r),i.onDidChangeSelection.fire({selected:r,notebook:c.apiNotebook})}}async $executeCells(t,s,r){const i=this._kernelData.get(t);if(!i)return;const c=this._extHostNotebook.getNotebookDocument(I.URI.revive(s)),g=[];for(let v of r){const A=c.getCell(v);A&&g.push(A.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,c.uri.toString(),g.length),await i.controller.executeHandler.call(i.controller,g,c.apiNotebook,i.controller)}catch(v){this._logService.error(`NotebookController[${t}] execute cells FAILED`,v),console.error(v)}}async $cancelCells(t,s,r){const i=this._kernelData.get(t);if(!i)return;const c=this._extHostNotebook.getNotebookDocument(I.URI.revive(s));if(i.controller.interruptHandler)await i.controller.interruptHandler.call(i.controller,c.apiNotebook);else for(let g of r){const v=c.getCell(g);v&&this._activeExecutions.get(v.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,s,r){const i=this._kernelData.get(t);if(!i)return;const c=this._extHostNotebook.getEditorById(s);i.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:r}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const r=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!r)throw new Error("invalid cell");if(this._activeExecutions.has(r.uri))throw new Error(`duplicate execution for ${r.uri}`);const i=new u(r.notebook,r,this._proxy);this._activeExecutions.set(r.uri,i);const c=i.onDidChangeState(()=>{i.state===w.Resolved&&(i.dispose(),c.dispose(),this._activeExecutions.delete(r.uri))});return i.asApiObject()}};E=ze([qe(3,a.ILogService)],E),e.ExtHostNotebookKernels=E;var w;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(w||(w={}));class u extends F.Disposable{constructor(t,s,r){super();this._document=t,this._cell=s,this._proxy=r,this._onDidChangeState=new m.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=w.Init,this._tokenSource=this._register(new l.CancellationTokenSource),this._collector=new p(10,i=>this.applyEdits(i)),this._executionOrder=s.internalMetadata.executionOrder,this.mixinMetadata({runState:k.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyExecutionEdits(this._document.uri,t)}verifyStateForOutput(){if(this._state===w.Init)throw new Error("Must call start before modifying cell output");if(this._state===w.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){this.applyEdits([{editType:9,handle:this._cell.handle,internalMetadata:t}])}cellIndexToHandle(t){let s=this._cell;if(t&&(s=this._document.getCellFromApiCell(t)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(t){return t.map(s=>{const r=d.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return r===s.items?S.NotebookCellOutput.from(s):S.NotebookCellOutput.from({items:r,id:s.id,metadata:s.metadata})})}async updateOutputs(t,s,r){const i=this.cellIndexToHandle(s),c=this.validateAndConvertOutputs((0,h.asArray)(t));return this.applyEditSoon({editType:2,handle:i,append:r,outputs:c})}async updateOutputItems(t,s,r){return t=d.NotebookCellOutput.ensureUniqueMimeTypes((0,h.asArray)(t),!0),this.applyEditSoon({editType:7,items:t.map(S.NotebookCellOutputItem.from),outputId:s.id,append:r})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(r){t._executionOrder=r,t.mixinMetadata({executionOrder:r})},start(r){if(t._state===w.Resolved||t._state===w.Started)throw new Error("Cannot call start again");t._state=w.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:k.NotebookCellExecutionState.Executing,runStartTime:r??null})},end(r,i){if(t._state===w.Resolved)throw new Error("Cannot call resolve twice");t._state=w.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:r??null,runEndTime:i??null})},clearOutput(r){return t.verifyStateForOutput(),t.updateOutputs([],r,!1)},appendOutput(r,i){return t.verifyStateForOutput(),t.updateOutputs(r,i,!0)},replaceOutput(r,i){return t.verifyStateForOutput(),t.updateOutputs(r,i,!1)},appendOutputItems(r,i){return t.verifyStateForOutput(),t.updateOutputItems(r,i,!0)},replaceOutputItems(r,i){return t.verifyStateForOutput(),t.updateOutputItems(r,i,!1)}})}}class p{constructor(t,s){this.delay=t,this.callback=s,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=(0,n.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const s=this.batch;return this.batch=[],this.callback(s)})),this.waitPromise}}}),define(Ee[200],_e([0,1,3,5,98]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class _{constructor(S,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=S.getProxy(F.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(S,y,C){const n=this._extHostNotebook.getEditorById(S);this._rendererMessageEmitters.get(y)?.fire({editor:n.apiEditor,message:C})}createRendererMessaging(S){return{onDidReceiveMessage:(...C)=>this.getOrCreateEmitterFor(S).event(...C),postMessage:(C,n)=>{const k=D.ExtHostNotebookEditor.apiEditorsToExtHost.get(C);if(!k)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(k.id,S,n)}}}getOrCreateEmitterFor(S){let y=this._rendererMessageEmitters.get(S);return y||(y=new m.Emitter({onLastListenerRemove:()=>{y?.dispose(),this._rendererMessageEmitters.delete(S)}}),this._rendererMessageEmitters.set(S,y),y)}}e.ExtHostNotebookRenderers=_}),define(Ee[102],_e([0,1,5,3,7,23,4,13]),function(ee,e,m,F,D,_,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends D.Disposable{constructor(a,d,f,E,w){super();this._onDidAppend=this._register(new F.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=a,this._proxy=w,this._id=w.$register(this.name,d,f,E),this._disposed=!1,this._offset=0}get name(){return this._name}append(a){this.validate(),this._offset+=a?_.VSBuffer.fromString(a).byteLength:0}update(){this._id.then(a=>this._proxy.$update(a))}appendLine(a){this.validate(),this.append(a+`
`)}clear(){this.validate();const a=this._offset;this._id.then(d=>this._proxy.$clear(d,a))}show(a,d){this.validate(),this._id.then(f=>this._proxy.$reveal(f,!!(typeof a=="boolean"?a:d)))}hide(){this.validate(),this._id.then(a=>this._proxy.$close(a))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(a=>this._proxy.$dispose(a)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class C extends y{constructor(a,d,f){super(a,!1,void 0,d,f)}append(a){super.append(a),this._id.then(d=>this._proxy.$append(d,a)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=C;class n extends y{constructor(a,d,f){super(a,!0,d,void 0,f)}append(a){throw new Error("Not supported")}}class k{constructor(a,d){this.name=a,this._channel=d}append(a){this._channel.then(d=>d.append(a))}appendLine(a){this._channel.then(d=>d.appendLine(a))}clear(){this._channel.then(a=>a.clear())}show(a,d){this._channel.then(f=>f.show(a,d))}hide(){this._channel.then(a=>a.hide())}dispose(){this._channel.then(a=>a.dispose())}}e.LazyOutputChannel=k;let l=class{constructor(a){this._proxy=a.getProxy(m.MainContext.MainThreadOutputService)}$setVisibleChannel(a){}createOutputChannel(a,d){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");return new C(d.identifier.value,a,this._proxy)}createOutputChannelFromLogFile(a,d){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");if(!d)throw new Error("illegal argument `file`. must not be falsy");return new n(a,d,this._proxy)}};l=ze([qe(0,S.IExtHostRpcService)],l),e.ExtHostOutputService=l,e.IExtHostOutputService=(0,I.createDecorator)("IExtHostOutputService")}),define(Ee[201],_e([0,1,16,18,3,7,5,2,6,12,17,42]),function(ee,e,m,F,D,_,I,S,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function l(h,a,d){const f=h.getProxy(I.MainContext.MainThreadQuickOpen);class E{constructor(i,c){this._sessions=new Map,this._instances=0,this._workspace=i,this._commands=c}showQuickPick(i,c,g,v=F.CancellationToken.None){this._onDidSelectItem=void 0;const A=Promise.resolve(i),R=++this._instances,o=f.$show(R,{title:g?.title,placeHolder:g?.placeHolder,matchOnDescription:g?.matchOnDescription,matchOnDetail:g?.matchOnDetail,ignoreFocusLost:g?.ignoreFocusOut,canPickMany:g?.canPickMany},v),P={},L=o.then(()=>P);return Promise.race([L,A]).then($=>{if($!==P)return A.then(re=>{const he=[];for(let Q=0;Q<re.length;Q++){const z=re[Q];let V,T,G,B,j;typeof z=="string"?V=z:(V=z.label,T=z.description,G=z.detail,B=z.picked,j=z.alwaysShow),he.push({label:V,description:T,handle:Q,detail:G,picked:B,alwaysShow:j})}return g&&typeof g.onDidSelectItem=="function"&&(this._onDidSelectItem=Q=>{g.onDidSelectItem(re[Q])}),f.$setItems(R,he),o.then(Q=>{if(typeof Q=="number")return re[Q];if(Array.isArray(Q))return Q.map(z=>re[z])})})}).then(void 0,$=>{if(!(0,C.isPromiseCanceledError)($))return f.$setError(R,$),Promise.reject($)})}$onItemSelected(i){this._onDidSelectItem&&this._onDidSelectItem(i)}showInput(i,c=F.CancellationToken.None){return this._validateInput=i?i.validateInput:void 0,f.$input(i,typeof this._validateInput=="function",c).then(void 0,g=>{if(!(0,C.isPromiseCanceledError)(g))return Promise.reject(g)})}$validateInput(i){return this._validateInput?(0,m.asPromise)(()=>this._validateInput(i)):Promise.resolve(void 0)}async showWorkspaceFolderPick(i,c=F.CancellationToken.None){const g=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!g)return;const v=await this._workspace.getWorkspaceFolders2();if(!!v)return v.find(A=>A.uri.toString()===g.uri.toString())}createQuickPick(i,c){const g=new t(i,c,()=>this._sessions.delete(g._id));return this._sessions.set(g._id,g),g}createInputBox(i){const c=new s(i,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}$onDidChangeValue(i,c){const g=this._sessions.get(i);g&&g._fireDidChangeValue(c)}$onDidAccept(i){const c=this._sessions.get(i);c&&c._fireDidAccept()}$onDidChangeActive(i,c){const g=this._sessions.get(i);g instanceof t&&g._fireDidChangeActive(c)}$onDidChangeSelection(i,c){const g=this._sessions.get(i);g instanceof t&&g._fireDidChangeSelection(c)}$onDidTriggerButton(i,c){const g=this._sessions.get(i);g&&g._fireDidTriggerButton(c)}$onDidHide(i){const c=this._sessions.get(i);c&&c._fireDidHide()}}class w{constructor(i,c){this._extensionId=i,this._onDidDispose=c,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new D.Emitter,this._onDidChangeValueEmitter=new D.Emitter,this._onDidTriggerButtonEmitter=new D.Emitter,this._onDidHideEmitter=new D.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(i){this._title=i,this.update({title:i})}get step(){return this._steps}set step(i){this._steps=i,this.update({step:i})}get totalSteps(){return this._totalSteps}set totalSteps(i){this._totalSteps=i,this.update({totalSteps:i})}get enabled(){return this._enabled}set enabled(i){this._enabled=i,this.update({enabled:i})}get busy(){return this._busy}set busy(i){this._busy=i,this.update({busy:i})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(i){this._ignoreFocusOut=i,this.update({ignoreFocusOut:i})}get value(){return this._value}set value(i){this._value=i,this.update({value:i})}get placeholder(){return this._placeholder}set placeholder(i){this._placeholder=i,this.update({placeholder:i})}get buttons(){return this._buttons}set buttons(i){this._buttons=i.slice(),this._handlesToButtons.clear(),i.forEach((c,g)=>{const v=c===y.QuickInputButtons.Back?-1:g;this._handlesToButtons.set(v,c)}),this.update({buttons:i.map((c,g)=>({iconPath:u(c.iconPath),tooltip:c.tooltip,handle:c===y.QuickInputButtons.Back?-1:g}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(i){this._value=i,this._onDidChangeValueEmitter.fire(i)}_fireDidTriggerButton(i){const c=this._handlesToButtons.get(i);c&&this._onDidTriggerButtonEmitter.fire(c)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,_.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),f.$dispose(this._id))}update(i){if(!this._disposed){for(const c of Object.keys(i)){const g=i[c];this._pendingUpdate[c]=g===void 0?null:g}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){f.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}w._nextId=1;function u(r){if(r instanceof y.ThemeIcon)return{id:r.id};const i=b(r),c=p(r);return{dark:typeof i=="string"?S.URI.file(i):i,light:typeof c=="string"?S.URI.file(c):c}}function p(r){return typeof r=="object"&&"light"in r?r.light:r}function b(r){return typeof r=="object"&&"dark"in r?r.dark:r}class t extends w{constructor(i,c,g){super(i,g);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new D.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new D.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(i){this._items=i.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),i.forEach((c,g)=>{this._handlesToItems.set(g,c),this._itemsToHandles.set(c,g)}),this.update({items:i.map((c,g)=>({label:c.label,description:c.description,handle:g,detail:c.detail,picked:c.picked,alwaysShow:c.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(i){this._canSelectMany=i,this.update({canSelectMany:i})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(i){this._matchOnDescription=i,this.update({matchOnDescription:i})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(i){this._matchOnDetail=i,this.update({matchOnDetail:i})}get sortByLabel(){return this._sortByLabel}set sortByLabel(i){this._sortByLabel=i,this.update({sortByLabel:i})}get activeItems(){return this._activeItems}set activeItems(i){this._activeItems=i.filter(c=>this._itemsToHandles.has(c)),this.update({activeItems:this._activeItems.map(c=>this._itemsToHandles.get(c))})}get selectedItems(){return this._selectedItems}set selectedItems(i){this._selectedItems=i.filter(c=>this._itemsToHandles.has(c)),this.update({selectedItems:this._selectedItems.map(c=>this._itemsToHandles.get(c))})}_fireDidChangeActive(i){const c=(0,n.coalesce)(i.map(g=>this._handlesToItems.get(g)));this._activeItems=c,this._onDidChangeActiveEmitter.fire(c)}_fireDidChangeSelection(i){const c=(0,n.coalesce)(i.map(g=>this._handlesToItems.get(g)));this._selectedItems=c,this._onDidChangeSelectionEmitter.fire(c)}}class s extends w{constructor(i,c){super(i,c);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(i){this._password=i,this.update({password:i})}get prompt(){return this._prompt}set prompt(i){this._prompt=i,this.update({prompt:i})}get validationMessage(){return this._validationMessage}set validationMessage(i){this._validationMessage=i,this.update({validationMessage:i,severity:i?k.default.Error:k.default.Ignore})}}return new E(a,d)}e.createExtHostQuickOpen=l}),define(Ee[202],_e([0,1,2,3,48,7,16,5,17,113,15,26,29,156]),function(ee,e,m,F,D,_,I,S,y,C,n,k,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function a(c){if(c)return typeof c.iconPath=="string"?m.URI.file(c.iconPath):m.URI.isUri(c.iconPath)||h.ThemeIcon.isThemeIcon(c.iconPath)?c.iconPath:void 0}function d(c,g){if(!c.iconPath&&!g.iconPath)return 0;if(c.iconPath){if(!g.iconPath)return 1}else return-1;const v=typeof c.iconPath=="string"?c.iconPath:m.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id,A=typeof g.iconPath=="string"?g.iconPath:m.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id;return(0,C.comparePaths)(v,A)}function f(c,g){let v=0;if(c.strikeThrough!==g.strikeThrough)return c.strikeThrough?1:-1;if(c.faded!==g.faded)return c.faded?1:-1;if(c.tooltip!==g.tooltip)return(c.tooltip||"").localeCompare(g.tooltip||"");if(v=d(c,g),v!==0)return v;if(c.light&&g.light)v=d(c.light,g.light);else{if(c.light)return 1;if(g.light)return-1}if(v!==0)return v;if(c.dark&&g.dark)v=d(c.dark,g.dark);else{if(c.dark)return 1;if(g.dark)return-1}return v}function E(c,g){if(c.command!==g.command)return c.command<g.command?-1:1;if(c.title!==g.title)return c.title<g.title?-1:1;if(c.tooltip!==g.tooltip){if(c.tooltip!==void 0&&g.tooltip!==void 0)return c.tooltip<g.tooltip?-1:1;if(c.tooltip!==void 0)return 1;if(g.tooltip!==void 0)return-1}if(c.arguments===g.arguments)return 0;if(c.arguments)if(g.arguments){if(c.arguments.length!==g.arguments.length)return c.arguments.length-g.arguments.length}else return 1;else return-1;for(let v=0;v<c.arguments.length;v++){const A=c.arguments[v],R=g.arguments[v];if(A!==R)return A<R?-1:1}return 0}function w(c,g){let v=(0,C.comparePaths)(c.resourceUri.fsPath,g.resourceUri.fsPath,!0);if(v!==0)return v;if(c.command&&g.command)v=E(c.command,g.command);else{if(c.command)return 1;if(g.command)return-1}if(v!==0)return v;if(c.decorations&&g.decorations)v=f(c.decorations,g.decorations);else{if(c.decorations)return 1;if(g.decorations)return-1}return v}function u(c,g){for(let v=0;v<c.length;v++)if(c[v]!==g[v])return!1;return!0}function p(c,g){return c.command===g.command&&c.title===g.title&&c.tooltip===g.tooltip&&(c.arguments&&g.arguments?u(c.arguments,g.arguments):c.arguments===g.arguments)}function b(c,g){return(0,y.equals)(c,g,p)}class t{constructor(g,v,A){this._extension=g,this._proxy=v,this._sourceControlHandle=A,this._value="",this._onDidChange=new F.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(g){this._proxy.$setInputBoxValue(this._sourceControlHandle,g),this.updateValue(g)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(g){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,g),this._placeholder=g}get validateInput(){return(0,l.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(g){if((0,l.checkProposedApiEnabled)(this._extension),g&&typeof g!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=g,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!g)}get visible(){return this._visible}set visible(g){g=!!g,this._visible!==g&&(this._visible=g,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,g))}focus(){(0,l.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(g,v){(0,l.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,g,v)}$onInputBoxValueChange(g){this.updateValue(g)}updateValue(g){this._value=g,this._onDidChange.fire(g)}}e.ExtHostSCMInputBox=t;class s{constructor(g,v,A,R,o){this._proxy=g,this._commands=v,this._sourceControlHandle=A,this._id=R,this._label=o,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new F.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=s._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(g){this._label=g,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,g)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(g){this._hideWhenEmpty=g,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(g){this._resourceStates=[...g],this._onDidUpdateResourceStates.fire()}getResourceState(g){return this._resourceStatesMap.get(g)}$executeResourceCommand(g,v){const A=this._resourceStatesCommandsMap.get(g);return A?(0,I.asPromise)(()=>this._commands.executeCommand(A.command,...A.arguments||[],v)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const g=[...this._resourceStates].sort(w),A=(0,y.sortedDiff)(this._resourceSnapshot,g,w).map(P=>{const L=P.toInsert.map($=>{const re=this._resourceHandlePool++;this._resourceStatesMap.set(re,$);const he=$.resourceUri;let Q;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const ue=new _.DisposableStore;Q=this._commands.converter.toInternal($.command,ue),this._resourceStatesDisposablesMap.set(re,ue)}else this._resourceStatesCommandsMap.set(re,$.command);const z=a($.decorations),V=$.decorations&&a($.decorations.light)||z,T=$.decorations&&a($.decorations.dark)||z,G=[V,T],B=$.decorations&&$.decorations.tooltip||"",j=$.decorations&&!!$.decorations.strikeThrough,ce=$.decorations&&!!$.decorations.faded,W=$.contextValue||"";return{rawResource:[re,he,G,B,j,ce,W,Q],handle:re}});return{start:P.start,deleteCount:P.deleteCount,toInsert:L}}),R=A.map(({start:P,deleteCount:L,toInsert:$})=>[P,L,$.map(re=>re.rawResource)]),o=A.reverse();for(const{start:P,deleteCount:L,toInsert:$}of o){const re=$.map(Q=>Q.handle),he=this._handlesSnapshot.splice(P,L,...re);for(const Q of he)this._resourceStatesMap.delete(Q),this._resourceStatesCommandsMap.delete(Q),this._resourceStatesDisposablesMap.get(Q)?.dispose(),this._resourceStatesDisposablesMap.delete(Q)}return this._resourceSnapshot=g,R}dispose(){this._disposed=!0,this._onDidDispose.fire()}}s._handlePool=0;class r{constructor(g,v,A,R,o,P){this._proxy=v,this._commands=A,this._id=R,this._label=o,this._rootUri=P,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new _.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new _.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new F.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=r._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new t(g,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,R,o,P)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(g){this._count!==g&&(this._count=g,this._proxy.$updateSourceControl(this.handle,{count:g}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(g){this._quickDiffProvider=g,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!g})}get commitTemplate(){return this._commitTemplate}set commitTemplate(g){g!==this._commitTemplate&&(this._commitTemplate=g,this._proxy.$updateSourceControl(this.handle,{commitTemplate:g}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(g){this._acceptInputDisposables.value=new _.DisposableStore,this._acceptInputCommand=g;const v=this._commands.converter.toInternal(g,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:v})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(g){if(this._statusBarCommands&&g&&b(this._statusBarCommands,g))return;this._statusBarDisposables.value=new _.DisposableStore,this._statusBarCommands=g;const v=(g||[]).map(A=>this._commands.converter.toInternal(A,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:v})}get selected(){return this._selected}createResourceGroup(g,v){const A=new s(this._proxy,this._commands,this.handle,g,v),R=F.Event.once(A.onDidDispose)(()=>this.createdResourceGroups.delete(A));return this.createdResourceGroups.set(A,R),this.eventuallyAddResourceGroups(),A}eventuallyAddResourceGroups(){const g=[],v=[];for(const[A,R]of this.createdResourceGroups){R.dispose();const o=A.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(A),this.eventuallyUpdateResourceStates()});F.Event.once(A.onDidDispose)(()=>{this.updatedResourceGroups.delete(A),o.dispose(),this._groups.delete(A.handle),this._proxy.$unregisterGroup(this.handle,A.handle)}),g.push([A.handle,A.id,A.label,A.features]);const P=A._takeResourceStateSnapshot();P.length>0&&v.push([A.handle,P]),this._groups.set(A.handle,A)}this._proxy.$registerGroups(this.handle,g,v),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const g=[];this.updatedResourceGroups.forEach(v=>{const A=v._takeResourceStateSnapshot();A.length!==0&&g.push([v.handle,A])}),g.length>0&&this._proxy.$spliceResourceStates(this.handle,g),this.updatedResourceGroups.clear()}getResourceGroup(g){return this._groups.get(g)}setSelectionState(g){this._selected=g,this._onDidChangeSelection.fire(g)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(g=>g.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}r._handlePool=0,ze([(0,D.debounce)(100)],r.prototype,"eventuallyAddResourceGroups",null),ze([(0,D.debounce)(100)],r.prototype,"eventuallyUpdateResourceStates",null);let i=class Un{constructor(g,v,A){this._commands=v,this.logService=A,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new F.Emitter,this._proxy=g.getProxy(S.MainContext.MainThreadSCM),this._telemetry=g.getProxy(S.MainContext.MainThreadTelemetry),v.registerArgumentProcessor({processArgument:R=>{if(R&&R.$mid===3){const o=this._sourceControls.get(R.sourceControlHandle);if(!o)return R;const P=o.getResourceGroup(R.groupHandle);return P?P.getResourceState(R.handle):R}else if(R&&R.$mid===4){const o=this._sourceControls.get(R.sourceControlHandle);return o?o.getResourceGroup(R.groupHandle):R}else if(R&&R.$mid===5){const o=this._sourceControls.get(R.handle);return o||R}return R}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(g,v,A,R){this.logService.trace("ExtHostSCM#createSourceControl",g.identifier.value,v,A,R),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:g.identifier.value});const o=Un._handlePool++,P=new r(g,this._proxy,this._commands,v,A,R);this._sourceControls.set(o,P);const L=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(g.identifier))||[];return L.push(P),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(g.identifier),L),P}getLastInputBox(g){this.logService.trace("ExtHostSCM#getLastInputBox",g.identifier.value);const v=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(g.identifier)),A=v&&v[v.length-1];return A&&A.inputBox}$provideOriginalResource(g,v,A){const R=m.URI.revive(v);this.logService.trace("ExtHostSCM#$provideOriginalResource",g,R.toString());const o=this._sourceControls.get(g);return!o||!o.quickDiffProvider||!o.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,I.asPromise)(()=>o.quickDiffProvider.provideOriginalResource(R,A)).then(P=>P||null)}$onInputBoxValueChange(g,v){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",g);const A=this._sourceControls.get(g);return A&&A.inputBox.$onInputBoxValueChange(v),Promise.resolve(void 0)}$executeResourceCommand(g,v,A,R){this.logService.trace("ExtHostSCM#$executeResourceCommand",g,v,A);const o=this._sourceControls.get(g);if(!o)return Promise.resolve(void 0);const P=o.getResourceGroup(v);return P?P.$executeResourceCommand(A,R):Promise.resolve(void 0)}$validateInput(g,v,A){this.logService.trace("ExtHostSCM#$validateInput",g);const R=this._sourceControls.get(g);return!R||!R.inputBox.validateInput?Promise.resolve(void 0):(0,I.asPromise)(()=>R.inputBox.validateInput(v,A)).then(o=>o?Promise.resolve([o.message,o.type]):Promise.resolve(void 0))}$setSelectedSourceControl(g){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",g),g!==void 0&&this._sourceControls.get(g)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=g,Promise.resolve(void 0)}};i._handlePool=0,i=ze([qe(2,n.ILogService)],i),e.ExtHostSCM=i});var nt=this&&this.__classPrivateFieldSet||function(ee,e,m,F,D){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?D.call(ee,m):D?D.value=m:e.set(ee,m),m},Oe=this&&this.__classPrivateFieldGet||function(ee,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(ee):F?F.value:e.get(ee)};define(Ee[203],_e([0,1,6,5,132,7,9]),function(ee,e,m,F,D,_,I){"use strict";var S,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class C{constructor(h,a,d,f,E=m.StatusBarAlignment.Left,w){S.set(this,void 0),y.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new _.DisposableStore,nt(this,S,h,"f"),nt(this,y,a,"f"),this._entryId=C.ID_GEN++,this._extension=d,this._id=f,this._alignment=E,this._priority=w}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!C.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){this._command?.fromApi!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:Oe(this,y,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:Oe(this,y,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let h;this._extension?this._id?h=`${this._extension.identifier.value}.${this._id}`:h=this._extension.identifier.value:h=this._id;let a;this._name?a=this._name:a=(0,D.localize)(0,null,this._extension.displayName||this._extension.name);let d=this._color;this._backgroundColor&&(d=C.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const f=this._tooltip?I.MarkdownString.fromStrict(this._tooltip):void 0;Oe(this,S,"f").$setEntry(this._entryId,h,a,this._text,f,this._command?.internal,d,this._backgroundColor,this._alignment===m.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=C,S=new WeakMap,y=new WeakMap,C.ID_GEN=0,C.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new m.ThemeColor("statusBarItem.errorForeground")]]);class n{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",m.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,D.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const a={message:h};return this._messages.unshift(a),this._update(),new m.Disposable(()=>{const d=this._messages.indexOf(a);d>=0&&(this._messages.splice(d,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class k{constructor(h,a){this._proxy=h.getProxy(F.MainContext.MainThreadStatusBar),this._commands=a,this._statusMessage=new n(this)}createStatusBarEntry(h,a,d,f){return new C(this._proxy,this._commands,h,a,d,f)}setStatusBarMessage(h,a){const d=this._statusMessage.setMessage(h);let f;return typeof a=="number"?f=setTimeout(()=>d.dispose(),a):typeof a!="undefined"&&a.then(()=>d.dispose(),()=>d.dispose()),new m.Disposable(()=>{d.dispose(),clearTimeout(f)})}}e.ExtHostStatusBar=k}),define(Ee[74],_e([0,1,5,3,4]),function(ee,e,m,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class _{constructor(S){this._onDidChangeStorage=new F.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=S.getProxy(m.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(S,y){this._proxy.$registerExtensionStorageKeysToSync(S,y)}getValue(S,y,C){return this._proxy.$getValue(S,y).then(n=>n||C)}setValue(S,y,C){return this._proxy.$setValue(S,y,C)}$acceptValue(S,y,C){this._onDidChangeStorage.fire({shared:S,key:y,value:C})}}e.ExtHostStorage=_,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(Ee[75],_e([0,1,4,28,15,73,2]),function(ee,e,m,F,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,m.createDecorator)("IExtensionStoragePaths");let S=class{constructor(C,n,k){this._logService=n,this._extHostFileSystem=k,this._workspace=C.workspace??void 0,this._environment=C.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(l=>this._value=l)}async _getWorkspaceStorageURI(C){return I.URI.joinPath(this._environment.workspaceStorageHome,C)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const C=this._workspace.id,n=await this._getWorkspaceStorageURI(C);try{return await this._extHostFileSystem.value.stat(n),this._logService.trace("[ExtHostStorage] storage dir already exists",n),n}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",n),await this._extHostFileSystem.value.createDirectory(n),await this._extHostFileSystem.value.writeFile(I.URI.joinPath(n,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:I.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),n}catch(k){this._logService.error("[ExtHostStorage]",k);return}}workspaceValue(C){if(this._value)return I.URI.joinPath(this._value,C.identifier.value)}globalValue(C){return I.URI.joinPath(this._environment.globalStorageHome,C.identifier.value.toLowerCase())}onWillDeactivateAll(){}};S=ze([qe(0,F.IExtHostInitDataService),qe(1,D.ILogService),qe(2,_.IExtHostConsumerFileSystem)],S),e.ExtensionStoragePaths=S}),define(Ee[37],_e([0,1,3,5,4,2,13,7,6,133,12,169,18,35,154,10]),function(ee,e,m,F,D,_,I,S,y,C,n,k,l,h,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class f{constructor(r,i,c,g){this._proxy=r,this._id=i,this._creationOptions=c,this._name=g,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(A=>this._pidPromiseComplete=A);const v=this;this.value={get name(){return v._name||""},get processId(){return v._pidPromise},get creationOptions(){return v._creationOptions},get exitStatus(){return v._exitStatus},sendText(A,R=!0){v._checkDisposed(),v._proxy.$sendText(v._id,A,R)},show(A){v._checkDisposed(),v._proxy.$show(v._id,A)},hide(){v._checkDisposed(),v._proxy.$hide(v._id)},dispose(){v._disposed||(v._disposed=!0,v._proxy.$dispose(v._id))},get dimensions(){if(!(v._cols===void 0||v._rows===void 0))return{columns:v._cols,rows:v._rows}}}}async create(r,i){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:r.name,shellPath:(0,d.withNullAsUndefined)(r.shellPath),shellArgs:(0,d.withNullAsUndefined)(r.shellArgs),cwd:(0,d.withNullAsUndefined)(r.cwd),env:(0,d.withNullAsUndefined)(r.env),icon:(0,d.withNullAsUndefined)(t(r.iconPath)),initialText:(0,d.withNullAsUndefined)(r.message),strictEnv:(0,d.withNullAsUndefined)(r.strictEnv),hideFromUser:(0,d.withNullAsUndefined)(r.hideFromUser),isFeatureTerminal:(0,d.withNullAsUndefined)(i?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,d.withNullAsUndefined)(i?.useShellEnvironment),isSplitTerminal:i?.isSplitTerminal,target:i?.target})}async createExtensionTerminal(r,i,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:c,isSplitTerminal:r,target:i}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(r){this._name=r}setExitCode(r){this._exitStatus=Object.freeze({code:r})}setDimensions(r,i){return r===this._cols&&i===this._rows||r===0||i===0?!1:(this._cols=r,this._rows=i,!0)}_setProcessId(r){this._pidPromiseComplete?(this._pidPromiseComplete(r),this._pidPromiseComplete=void 0):this._pidPromise.then(i=>{i!==r&&(this._pidPromise=Promise.resolve(r))})}}e.ExtHostTerminal=f;class E{constructor(r){this._pty=r,this.id=0,this.shouldPersist=!1,this._onProcessData=new m.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new m.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new m.Emitter,this._onProcessTitleChanged=new m.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new m.Emitter,this._onProcessShellTypeChanged=new m.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(r){this._pty.handleInput&&this._pty.handleInput(r)}resize(r,i){this._pty.setDimensions&&this._pty.setDimensions({columns:r,rows:i})}async processBinary(r){}acknowledgeDataEvent(r){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(r){this._pty.onDidWrite(i=>this._onProcessData.fire(i)),this._pty.onDidClose&&this._pty.onDidClose((i=void 0)=>{this._onProcessExit.fire(i===void 0?void 0:i)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(i=>this._onProcessOverrideDimensions.fire(i&&{cols:i.columns,rows:i.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(i=>this._onProcessTitleChanged.fire(i)),this._pty.open(r||void 0),this._pty.setDimensions&&r&&this._pty.setDimensions(r),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=E;let w=1,u=class extends S.Disposable{constructor(r,i){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new m.Emitter,this._onDidOpenTerminal=new m.Emitter,this._onDidChangeActiveTerminal=new m.Emitter,this._onDidChangeTerminalDimensions=new m.Emitter,this._proxy=i.getProxy(F.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new m.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(r),this._register({dispose:()=>{for(const[c,g]of this._terminalProcesses)g.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(r=>r.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(r){return(r?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(r){return(r?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(r,i){const c=new f(this._proxy,(0,h.generateUuid)(),r,r.name),g=new E(r.pty);return c.createExtensionTerminal(i?.isSplitTerminal,i?.target,t(r.iconPath)).then(v=>{const A=this._setupExtHostProcessListeners(v,g);this._terminalProcessDisposables[v]=A}),this._terminals.push(c),c.value}attachPtyToTerminal(r,i){if(!this._getTerminalById(r))throw new Error(`Cannot resolve terminal with id ${r} for virtual process`);const g=new E(i),v=this._setupExtHostProcessListeners(r,g);this._terminalProcessDisposables[r]=v}async $acceptActiveTerminalChanged(r){const i=this._activeTerminal;if(r===null){this._activeTerminal=void 0,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const c=this._getTerminalById(r);c&&(this._activeTerminal=c,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(r,i){const c=this._getTerminalById(r);c&&this._onDidWriteTerminalData.fire({terminal:c.value,data:i})}async $acceptTerminalDimensions(r,i,c){const g=this._getTerminalById(r);g&&g.setDimensions(i,c)&&this._onDidChangeTerminalDimensions.fire({terminal:g.value,dimensions:g.value.dimensions})}async $acceptTerminalMaximumDimensions(r,i,c){this._terminalProcesses.get(r)?.resize(i,c)}async $acceptTerminalTitleChange(r,i){const c=this._getTerminalById(r);c&&(c.name=i)}async $acceptTerminalClosed(r,i){const c=this._getTerminalObjectIndexById(this._terminals,r);if(c!==null){const g=this._terminals.splice(c,1)[0];g.setExitCode(i),this._onDidCloseTerminal.fire(g.value)}}$acceptTerminalOpened(r,i,c,g){if(i){const R=this._getTerminalObjectIndexById(this._terminals,i);if(R!==null){this._terminals[R]._id=r,this._onDidOpenTerminal.fire(this.terminals[R]),this._terminals[R].isOpen=!0;return}}const v={name:g.name,shellPath:g.executable,shellArgs:g.args,cwd:typeof g.cwd=="string"?g.cwd:_.URI.revive(g.cwd),env:g.env,hideFromUser:g.hideFromUser},A=new f(this._proxy,r,v,c);this._terminals.push(A),this._onDidOpenTerminal.fire(A.value),A.isOpen=!0}async $acceptTerminalProcessId(r,i){const c=this._getTerminalById(r);c&&c._setProcessId(i)}async $startExtensionTerminal(r,i){const c=this._getTerminalById(r);if(!c)return{message:(0,C.localize)(0,null,r)};c.isOpen||await new Promise(v=>{const A=this.onDidOpenTerminal(async R=>{R===c.value&&(A.dispose(),v())})});const g=this._terminalProcesses.get(r);g?g.startSendingEvents(i):this._extensionTerminalAwaitingStart[r]={initialDimensions:i}}_setupExtHostProcessListeners(r,i){const c=new S.DisposableStore;c.add(i.onProcessReady(v=>this._proxy.$sendProcessReady(r,v.pid,v.cwd))),c.add(i.onProcessTitleChanged(v=>this._proxy.$sendProcessTitle(r,v))),this._bufferer.startBuffering(r,i.onProcessData),c.add(i.onProcessExit(v=>this._onProcessExit(r,v))),i.onProcessOverrideDimensions&&c.add(i.onProcessOverrideDimensions(v=>this._proxy.$sendOverrideDimensions(r,v))),this._terminalProcesses.set(r,i);const g=this._extensionTerminalAwaitingStart[r];return g&&i instanceof E&&(i.startSendingEvents(g.initialDimensions),delete this._extensionTerminalAwaitingStart[r]),c}$acceptProcessAckDataEvent(r,i){this._terminalProcesses.get(r)?.acknowledgeDataEvent(i)}$acceptProcessInput(r,i){this._terminalProcesses.get(r)?.input(i)}$acceptProcessResize(r,i,c){try{this._terminalProcesses.get(r)?.resize(i,c)}catch(g){if(g.code!=="EPIPE"&&g.code!=="ERR_IPC_CHANNEL_CLOSED")throw g}}$acceptProcessShutdown(r,i){this._terminalProcesses.get(r)?.shutdown(i)}$acceptProcessRequestInitialCwd(r){this._terminalProcesses.get(r)?.getInitialCwd().then(i=>this._proxy.$sendProcessInitialCwd(r,i))}$acceptProcessRequestCwd(r){this._terminalProcesses.get(r)?.getCwd().then(i=>this._proxy.$sendProcessCwd(r,i))}$acceptProcessRequestLatency(r){return r}registerLinkProvider(r){return this._linkProviders.add(r),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(r),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(r,i,c){if(this._profileProviders.has(i))throw new Error(`Terminal profile provider "${i}" already registered`);return this._profileProviders.set(i,c),this._proxy.$registerProfileProvider(i,r.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(i),this._proxy.$unregisterProfileProvider(i)})}async $createContributedProfileTerminal(r,i){const c=new l.CancellationTokenSource().token,g=await this._profileProviders.get(r)?.provideTerminalProfile(c);if(!c.isCancellationRequested){if(!g||!("options"in g))throw new Error(`No terminal profile options provided for id "${r}"`);if("pty"in g.options){this.createExtensionTerminal(g.options,i);return}this.createTerminalFromOptions(g.options,i)}}async $provideLinks(r,i){const c=this._getTerminalById(r);if(!c)return[];this._terminalLinkCache.delete(r);const g=this._terminalLinkCancellationSource.get(r);g&&g.dispose(!0);const v=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(r,v);const A=[],R={terminal:c.value,line:i},o=[];for(const $ of this._linkProviders)o.push(new Promise(async re=>{v.token.onCancellationRequested(()=>re({provider:$,links:[]}));const he=await $.provideTerminalLinks(R,v.token)||[];v.token.isCancellationRequested||re({provider:$,links:he})}));const P=await Promise.all(o);if(v.token.isCancellationRequested)return[];const L=new Map;for(const $ of P)$&&$.links.length>0&&A.push(...$.links.map(re=>{const he={id:w++,startIndex:re.startIndex,length:re.length,label:re.tooltip};return L.set(he.id,{provider:$.provider,link:re}),he}));return this._terminalLinkCache.set(r,L),A}$activateLink(r,i){const c=this._terminalLinkCache.get(r)?.get(i);!c||c.provider.handleTerminalLink(c.link)}_onProcessExit(r,i){this._bufferer.stopBuffering(r),this._terminalProcesses.delete(r),delete this._extensionTerminalAwaitingStart[r];const c=this._terminalProcessDisposables[r];c&&(c.dispose(),delete this._terminalProcessDisposables[r]),this._proxy.$sendProcessExit(r,i)}_getTerminalById(r){return this._getTerminalObjectById(this._terminals,r)}_getTerminalObjectById(r,i){const c=this._getTerminalObjectIndexById(r,i);return c!==null?r[c]:null}_getTerminalObjectIndexById(r,i){let c=null;return r.some((g,v)=>g._id===i?(c=v,!0):!1),c}getEnvironmentVariableCollection(r){let i=this._environmentVariableCollections.get(r.identifier.value);return i||(i=new p,this._setEnvironmentVariableCollection(r.identifier.value,i)),i}_syncEnvironmentVariableCollection(r,i){const c=(0,k.serializeEnvironmentVariableCollection)(i.map);this._proxy.$setEnvironmentVariableCollection(r,i.persistent,c.length===0?void 0:c)}$initEnvironmentVariableCollections(r){r.forEach(i=>{const c=i[0],g=new p(i[1]);this._setEnvironmentVariableCollection(c,g)})}$acceptDefaultProfile(r,i){this._defaultProfile=r,this._defaultAutomationProfile=i}_setEnvironmentVariableCollection(r,i){this._environmentVariableCollections.set(r,i),i.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(r,i)})}};u=ze([qe(1,I.IExtHostRpcService)],u),e.BaseExtHostTerminalService=u;class p{constructor(r){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new m.Emitter,this.map=new Map(r)}get persistent(){return this._persistent}set persistent(r){this._persistent=r,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(r,i){this._setIfDiffers(r,{value:i,type:y.EnvironmentVariableMutatorType.Replace})}append(r,i){this._setIfDiffers(r,{value:i,type:y.EnvironmentVariableMutatorType.Append})}prepend(r,i){this._setIfDiffers(r,{value:i,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(r,i){const c=this.map.get(r);(!c||c.value!==i.value||c.type!==i.type)&&(this.map.set(r,i),this._onDidChangeCollection.fire())}get(r){return this.map.get(r)}forEach(r,i){this.map.forEach((c,g)=>r.call(i,g,c,this))}delete(r){this.map.delete(r),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=p;let b=class extends u{constructor(r){super(!1,r)}createTerminal(r,i,c){throw new n.NotSupportedError}createTerminalFromOptions(r,i){throw new n.NotSupportedError}};b=ze([qe(0,I.IExtHostRpcService)],b),e.WorkerExtHostTerminalService=b;function t(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}});var nt=this&&this.__classPrivateFieldSet||function(ee,e,m,F,D){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?D.call(ee,m):D?D.value=m:e.set(ee,m),m},Oe=this&&this.__classPrivateFieldGet||function(ee,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(ee):F?F.value:e.get(ee)};define(Ee[204],_e([0,1,16,23,18,3,49,41,51,7,24,10,35,5,13,65,9,6,177,96]),function(ee,e,m,F,D,_,I,S,y,C,n,k,l,h,a,d,f,E,w,u){"use strict";var p,b,t,s,r,i,c;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunConfigurationImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let g=class{constructor(T,G){this.resultsChangedEmitter=new _.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=T.getProxy(h.MainContext.MainThreadTesting),this.observer=new he(this.proxy),this.runTracker=new A(this.proxy),G.registerArgumentProcessor({processArgument:B=>B?.$mid===13?f.TestItem.toItemFromContext(B):B})}createTestController(T,G){const B=new C.DisposableStore,j=B.add(new w.SingleUseTestCollection(T)),ce=B.add(new m.RunOnceScheduler(()=>j.expand(j.root.id,0),0)),W=new Map,te=this.proxy,ue={items:j.root.children,get label(){return G},set label(Te){G=Te,j.root.label=Te,te.$updateControllerLabel(T,G)},get id(){return T},createRunConfiguration:(Te,Re,$e,Ze)=>{let Ve=(0,S.hash)(Te);for(;W.has(Ve);)Ve++;const je=new Q(this.proxy,T,Ve,Te,Re,$e,Ze);return W.set(Ve,je),je},createTestRun:(Te,Re,$e=!0)=>this.runTracker.createTestRun(T,j,Te,Re,$e),set resolveChildrenHandler(Te){j.resolveHandler=Te,Te&&ce.schedule()},get resolveChildrenHandler(){return j.resolveHandler},dispose:()=>{B.dispose()}};ue.createTestITem=this.createTestItem.bind(this),te.$registerTestController(T,G),B.add((0,C.toDisposable)(()=>te.$unregisterTestController(T)));const ye={controller:ue,collection:j,configurations:W};return this.controllers.set(T,ye),B.add((0,C.toDisposable)(()=>this.controllers.delete(T))),B.add(j.onDidGenerateDiff(Te=>te.$publishDiff(T,Te))),ue}createTestItem(T,G,B){return new d.TestItemImpl(T,G,B)}createTestObserver(){return this.observer.checkout()}async runTests(T,G=D.CancellationToken.None){const B=R(T);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a configuration");const j=this.controllers.get(B.controllerId);if(!j)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:T.include?.map(ce=>ce.id)??[j.collection.root.id],profileGroup:z[B.group],profileId:B.configId,controllerId:B.controllerId}],exclude:T.exclude?.map(ce=>({testId:ce.id,controllerId:B.controllerId}))},G)}$provideFileCoverage(T,G,B){return y.Iterable.find(this.runTracker.trackers,j=>j.id===T)?.getCoverage(G)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(T,G,B,j){return y.Iterable.find(this.runTracker.trackers,ce=>ce.id===T)?.getCoverage(G)?.resolveFileCoverage(B,j)??Promise.resolve([])}$configureRunConfig(T,G){this.controllers.get(T)?.configurations.get(G)?.configureHandler?.()}$publishTestResults(T){this.results=Object.freeze(T.map(G=>(0,n.deepFreeze)(f.TestResults.to(G))).concat(this.results).sort((G,B)=>B.completedAt-G.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest({controllerId:T,testId:G},B){const j=this.controllers.get(T)?.collection;j&&(await j.expand(G,B<0?Infinity:B),j.flushDiff())}$acceptDiff(T){this.observer.applyDiff(T)}async $runControllerTests(T,G){const B=this.controllers.get(T.controllerId);if(!B)return;const{collection:j,configurations:ce}=B,W=ce.get(T.configId);if(!W)return;const te=T.testIds.map(Re=>j.tree.get(Re)).filter(k.isDefined),ue=T.excludeExtIds.map(Re=>B.collection.tree.get(Re)).filter(k.isDefined).filter(Re=>te.some($e=>j.tree.comparePositions($e,Re)===1));if(!te.length)return;const ye=new E.TestRunRequest(te.map(Re=>Re.actual),ue.map(Re=>Re.actual),W),Te=this.runTracker.prepareForMainThreadTestRun(ye,o.fromInternal(T,B.collection),G);try{await W.runHandler(ye,G)}finally{Te.isRunning&&!G.isCancellationRequested&&await _.Event.toPromise(Te.onEnd),this.runTracker.cancelRunById(T.runId)}}$cancelExtensionTestRun(T){T===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(T)}};g=ze([qe(0,a.IExtHostRpcService)],g),e.ExtHostTesting=g;class v extends C.Disposable{constructor(T,G,B){super();this.dto=T,this.proxy=G,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new _.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new D.CancellationTokenSource(B)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:j}of this.tasks.values())j.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(T){return this.tasks.get(T)?.coverage}createRun(T){const G=(0,l.generateUuid)(),B=new P(this.proxy,this.dto.id,G),j=new L(T,this.cts.token,G,B,this.dto,this.sharedTestIds,this.proxy,()=>{this.tasks.delete(j.taskId),this.isRunning||this.dispose()});return this.tasks.set(j.taskId,{run:j,coverage:B}),j}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}}class A{constructor(T){this.proxy=T,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(T,G,B){return this.getTracker(T,G,B)}cancelRunById(T){for(const G of this.tracked.values())if(G.id===T){G.dispose();return}}cancelAllRuns(){for(const T of this.tracked.values())T.dispose()}createTestRun(T,G,B,j,ce){const W=this.tracked.get(B);if(W)return W.createRun(j);const te=o.fromPublic(T,G,B),ue=R(B);this.proxy.$startedExtensionTestRun({controllerId:T,config:ue&&{group:z[ue.group],id:ue.configId},exclude:B.exclude?.map(Te=>Te.id)??[],id:te.id,include:B.include?.map(Te=>Te.id)??[G.root.id],persist:ce});const ye=this.getTracker(B,te);return ye.onEnd(()=>this.proxy.$finishedExtensionTestRun(te.id)),ye.createRun(j)}getTracker(T,G,B){const j=new v(G,this.proxy,B);return this.tracked.set(T,j),j.onEnd(()=>this.tracked.delete(T)),j}}e.TestRunCoordinator=A;const R=V=>{if(!!V.configuration){if(!(V.configuration instanceof Q))throw new Error("TestRunRequest.configuration is not an instance created from TestController.createRunConfiguration");return V.configuration}};class o{constructor(T,G,B,j,ce){this.controllerId=T,this.id=G,this.include=B,this.exclude=j,this.colllection=ce}static fromPublic(T,G,B){return new o(T,(0,l.generateUuid)(),B.include&&new Set(B.include.map(j=>j.id)),new Set(B.exclude?.map(j=>j.id)??y.Iterable.empty()),G)}static fromInternal(T,G){return new o(T.controllerId,T.runId,T.testIds.includes(G.root.id)?void 0:new Set(T.testIds),new Set(T.excludeExtIds),G)}isIncluded(T){for(let G=T;G;G=G.parent){if(this.include?.has(G.id))return!0;if(this.exclude.has(G.id))return!1}return this.include===void 0}}e.TestRunDto=o;class P{constructor(T,G,B){this.proxy=T,this.runId=G,this.taskId=B}set coverageProvider(T){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!T||(this._coverageProvider=T,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(T){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(T))());try{return(await this.fileCoverage)?.map(f.TestCoverage.fromFile)??[]}catch(G){throw this.fileCoverage=void 0,G}}async resolveFileCoverage(T,G){const B=await this.fileCoverage;let j=B?.[T];return!this._coverageProvider||!B||!j?[]:(j.detailedCoverage||(j=B[T]=await this._coverageProvider.resolveFileCoverage?.(j,G)??j),j.detailedCoverage?.map(f.TestCoverage.fromDetailed)??[])}}class L{constructor(T,G,B,j,ce,W,te,ue){this.name=T,this.token=G,this.taskId=B,p.set(this,void 0),b.set(this,void 0),t.set(this,void 0),s.set(this,void 0),r.set(this,void 0),i.set(this,!1),nt(this,s,ue,"f"),nt(this,p,te,"f"),nt(this,b,ce,"f"),nt(this,r,j,"f"),nt(this,t,W,"f"),te.$startedTestRunTask(ce.id,{id:this.taskId,name:T,running:!0})}set coverageProvider(T){Oe(this,r,"f").coverageProvider=T}get coverageProvider(){return Oe(this,r,"f").coverageProvider}setState(T,G,B){!Oe(this,i,"f")&&Oe(this,b,"f").isIncluded(T)&&(this.ensureTestIsKnown(T),Oe(this,p,"f").$updateTestStateInRun(Oe(this,b,"f").id,this.taskId,T.id,G,B))}appendMessage(T,G){!Oe(this,i,"f")&&Oe(this,b,"f").isIncluded(T)&&(this.ensureTestIsKnown(T),Oe(this,p,"f").$appendTestMessageInRun(Oe(this,b,"f").id,this.taskId,T.id,f.TestMessage.from(G)))}appendOutput(T){Oe(this,i,"f")||Oe(this,p,"f").$appendOutputToRun(Oe(this,b,"f").id,this.taskId,F.VSBuffer.fromString(T))}end(){Oe(this,i,"f")||(nt(this,i,!0,"f"),Oe(this,p,"f").$finishedTestRunTask(Oe(this,b,"f").id,this.taskId),Oe(this,s,"f").call(this))}ensureTestIsKnown(T){const G=Oe(this,t,"f");if(G.has(T.id))return;const B=[];for(;B.unshift(f.TestItem.from(T)),!(G.has(T.id)||(G.add(T.id),!T.parent));)T=T.parent;const j=Oe(this,b,"f").colllection.root;G.has(j.id)||(G.add(j.id),B.unshift(f.TestItem.from(j))),Oe(this,p,"f").$addTestsToRun(Oe(this,b,"f").controllerId,Oe(this,b,"f").id,B)}}p=new WeakMap,b=new WeakMap,t=new WeakMap,s=new WeakMap,r=new WeakMap,i=new WeakMap;class $ extends u.IncrementalChangeCollector{constructor(T){super();this.emitter=T,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(T){this.added.add(T)}update(T){Object.assign(T.revived,f.TestItem.toPlain(T.item)),this.added.has(T)||this.updated.add(T)}remove(T){if(this.added.has(T)){this.added.delete(T);return}if(this.updated.delete(T),T.parent&&this.alreadyRemoved.has(T.parent)){this.alreadyRemoved.add(T.item.extId);return}this.removed.add(T)}getChangeEvent(){const{added:T,updated:G,removed:B}=this;return{get added(){return[...T].map(j=>j.revived)},get updated(){return[...G].map(j=>j.revived)},get removed(){return[...B].map(j=>j.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class re extends u.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new _.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(T){return this.items.get(T)}getMirroredTestDataByReference(T){return this.items.get(T.id)}createItem(T,G){return{...T,revived:f.TestItem.toPlain(T.item),depth:G?G.depth+1:0,children:new Set}}createChangeCollector(){return new $(this.changeEmitter)}}e.MirroredTestCollection=re;class he{constructor(T){this.proxy=T}checkout(){this.current||(this.current=this.createObserverData());const T=this.current;return T.observers++,{onDidChangeTest:T.tests.onDidChangeTests,get tests(){return[...T.tests.rootTests].map(G=>G.revived)},dispose:(0,I.once)(()=>{--T.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(T){return this.current?.tests.getMirroredTestDataByReference(T)}applyDiff(T){this.current?.tests.apply(T)}createObserverData(){const T=new re;return this.proxy.$subscribeToDiffs(),{observers:0,tests:T}}}class Q{constructor(T,G,B,j,ce,W,te=!1){this.controllerId=G,this.configId=B,this._label=j,this.group=ce,this.runHandler=W,this._isDefault=te,c.set(this,void 0),nt(this,c,T,"f");const ue=z[ce];if(typeof ue!="number")throw new Error(`Unknown TestRunConfiguration.group ${ce}`);Oe(this,c,"f").$publishTestRunConfig({profileId:B,controllerId:G,label:j,group:ue,isDefault:te,hasConfigurationHandler:!1})}get label(){return this._label}set label(T){T!==this._label&&(this._label=T,Oe(this,c,"f").$updateTestRunConfig(this.controllerId,this.configId,{label:T}))}get isDefault(){return this._isDefault}set isDefault(T){T!==this._isDefault&&(this._isDefault=T,Oe(this,c,"f").$updateTestRunConfig(this.controllerId,this.configId,{isDefault:T}))}get configureHandler(){return this._configureHandler}set configureHandler(T){T!==this._configureHandler&&(this._configureHandler=T,Oe(this,c,"f").$updateTestRunConfig(this.controllerId,this.configId,{hasConfigurationHandler:!!T}))}dispose(){Oe(this,c,"f").$removeTestRunConfig(this.controllerId,this.configId)}}e.TestRunConfigurationImpl=Q,c=new WeakMap;const z={[E.TestRunConfigurationGroup.Coverage]:8,[E.TestRunConfigurationGroup.Debug]:4,[E.TestRunConfigurationGroup.Run]:2}}),define(Ee[205],_e([0,1,3,17,5,99,9,6]),function(ee,e,m,F,D,_,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(n,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new m.Emitter,this._onDidChangeTextEditorOptions=new m.Emitter,this._onDidChangeTextEditorVisibleRanges=new m.Emitter,this._onDidChangeTextEditorViewColumn=new m.Emitter,this._onDidChangeActiveTextEditor=new m.Emitter,this._onDidChangeVisibleTextEditors=new m.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(D.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const k=this._extHostDocumentsAndEditors.allEditors();return n?k:k.map(l=>l.value)}async showTextDocument(n,k,l){let h;typeof k=="number"?h={position:I.ViewColumn.from(k),preserveFocus:l}:typeof k=="object"?h={position:I.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?I.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:h={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(n.uri,h),d=a&&this._extHostDocumentsAndEditors.getEditor(a);if(d)return d.value;throw a?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,k){return new _.TextEditorDecorationType(this._proxy,n,k).value}$acceptEditorPropertiesChanged(n,k){const l=this._extHostDocumentsAndEditors.getEditor(n);if(!l)throw new Error("unknown text editor");if(k.options&&l._acceptOptions(k.options),k.selections){const h=k.selections.selections.map(I.Selection.to);l._acceptSelections(h)}if(k.visibleRanges){const h=F.coalesce(k.visibleRanges.map(I.Range.to));l._acceptVisibleRanges(h)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:{...k.options,lineNumbers:I.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const h=S.TextEditorSelectionChangeKind.fromValue(k.selections.source),a=k.selections.selections.map(I.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:a,kind:h})}if(k.visibleRanges){const h=F.coalesce(k.visibleRanges.map(I.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:h})}}$acceptEditorPositionData(n){for(const k in n){const l=this._extHostDocumentsAndEditors.getEditor(k);if(!l)throw new Error("Unknown text editor");const h=I.ViewColumn.to(n[k]);l.value.viewColumn!==h&&(l._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:h}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=y}),define(Ee[206],_e([0,1,2,4,5,7,6]),function(ee,e,m,F,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,F.createDecorator)("IExtHostTimeline");class S{constructor(n,k){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(D.MainContext.MainThreadTimeline),k.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===11){const h=l.uri===void 0?void 0:m.URI.revive(l.uri);return this._itemsBySourceAndUriMap.get(l.source)?.get(y(h))?.get(l.handle)}return l}})}async $getTimeline(n,k,l,h,a){return this._providers.get(n)?.provideTimeline(m.URI.revive(k),l,h,a)}registerTimelineProvider(n,k,l,h){const a=new _.DisposableStore,d=this.convertTimelineItem(k.id,h,a).bind(this);let f;k.onDidChange&&(f=k.onDidChange(w=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...w,id:k.id}),this));const E=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...k,scheme:n,onDidChange:void 0,async provideTimeline(w,u,p,b){b?.resetCache&&(a.clear(),E.get(k.id)?.clear());const t=await k.provideTimeline(w,u,p);if(t==null)return;const s=d(w,b);return{...t,source:k.id,items:t.items.map(s)}},dispose(){for(const w of E.values())w.get(k.id)?.clear();f?.dispose(),a.dispose()}})}convertTimelineItem(n,k,l){return(h,a)=>{let d;if(a?.cacheResults){let f=this._itemsBySourceAndUriMap.get(n);f===void 0&&(f=new Map,this._itemsBySourceAndUriMap.set(n,f));const E=y(h);d=f.get(E),d===void 0&&(d=new Map,f.set(E,d))}return f=>{const{iconPath:E,...w}=f,u=`${n}|${f.id??f.timestamp}`;d?.set(u,f);let p,b,t;return f.iconPath&&(E instanceof I.ThemeIcon?t={id:E.id,color:E.color}:m.URI.isUri(E)?(p=E,b=E):{light:p,dark:b}=E),{...w,id:w.id??void 0,handle:u,source:n,command:f.command?k.toInternal(f.command,l):void 0,icon:p,iconDark:b,themeIcon:t,accessibilityInformation:f.accessibilityInformation}}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),(0,_.toDisposable)(()=>{for(const l of this._itemsBySourceAndUriMap.values())l.get(n.id)?.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=S;function y(C){return C?.toString()}}),define(Ee[207],_e([0,1,7,11,2,5]),function(ee,e,m,F,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class I{constructor(y){this._openers=new Map,this._proxy=y.getProxy(_.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,C,n,k){if(this._openers.has(C))throw new Error(`Opener with id '${C}' already registered`);const l=k.schemes.find(h=>!I.supportedSchemes.has(h));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(C,n),this._proxy.$registerUriOpener(C,k.schemes,y,k.label),(0,m.toDisposable)(()=>{this._openers.delete(C),this._proxy.$unregisterUriOpener(C)})}async $canOpenUri(y,C,n){const k=this._openers.get(y);if(!k)throw new Error(`Unknown opener with id: ${y}`);const l=D.URI.revive(C);return k.canOpenExternalUri(l,n)}async $openUri(y,C,n){const k=this._openers.get(y);if(!k)throw new Error(`Unknown opener id: '${y}'`);return k.openExternalUri(D.URI.revive(C.resolvedUri),{sourceUri:D.URI.revive(C.sourceUri)},n)}}e.ExtHostUriOpeners=I,I.supportedSchemes=new Set([F.Schemas.http,F.Schemas.https])}),define(Ee[208],_e([0,1,5,2,7,12,26]),function(ee,e,m,F,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class S{constructor(C){this.handles=new Set,this.handlers=new Map,this._proxy=C.getProxy(m.MainContext.MainThreadUrls)}registerUriHandler(C,n){if(this.handles.has(I.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const k=S.HandlePool++;return this.handles.add(I.ExtensionIdentifier.toKey(C)),this.handlers.set(k,n),this._proxy.$registerUriHandler(k,C),(0,D.toDisposable)(()=>{this.handles.delete(I.ExtensionIdentifier.toKey(C)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(C,n){const k=this.handlers.get(C);if(!k)return Promise.resolve(void 0);try{k.handleUri(F.URI.revive(n))}catch(l){(0,_.onUnexpectedError)(l)}return Promise.resolve(void 0)}async createAppUri(C){return F.URI.revive(await this._proxy.$createAppUri(C))}}e.ExtHostUrls=S,S.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(ee,e,m,F,D){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?D.call(ee,m):D?D.value=m:e.set(ee,m),m},Oe=this&&this.__classPrivateFieldGet||function(ee,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(ee):F?F.value:e.get(ee)};define(Ee[47],_e([0,1,3,2,142,163,68,5]),function(ee,e,m,F,D,_,I,S){"use strict";var y,C,n,k,l,h,a,d,f,E,w,u;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class p{constructor(v,A,R,o,P,L,$){y.set(this,void 0),C.set(this,void 0),n.set(this,void 0),k.set(this,void 0),l.set(this,void 0),h.set(this,void 0),a.set(this,""),d.set(this,void 0),f.set(this,!1),E.set(this,!1),w.set(this,!1),this._onMessageEmitter=new m.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,u.set(this,new m.Emitter),this._onDidDispose=Oe(this,u,"f").event,nt(this,y,v,"f"),nt(this,C,A,"f"),nt(this,d,R,"f"),nt(this,k,o,"f"),nt(this,l,P,"f"),nt(this,h,L,"f"),nt(this,w,b(L),"f"),nt(this,n,$,"f")}dispose(){nt(this,f,!0,"f"),Oe(this,u,"f").fire(),Oe(this,u,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(v){return nt(this,E,!0,"f"),(0,I.asWebviewUri)(v,Oe(this,k,"f").remote)}get cspSource(){return I.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,a,"f")}set html(v){this.assertNotDisposed(),Oe(this,a,"f")!==v&&(nt(this,a,v,"f"),!Oe(this,E,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(v)&&(nt(this,E,!0,"f"),Oe(this,n,"f").report("Webview vscode-resource: uris",Oe(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,C,"f").$setHtml(Oe(this,y,"f"),v))}get options(){return this.assertNotDisposed(),Oe(this,d,"f")}set options(v){this.assertNotDisposed(),Oe(this,C,"f").$setOptions(Oe(this,y,"f"),r(Oe(this,h,"f"),Oe(this,l,"f"),v)),nt(this,d,v,"f")}async postMessage(v){if(Oe(this,f,"f"))return!1;const A=(0,_.serializeWebviewMessage)(v,{serializeBuffersForPostMessage:Oe(this,w,"f")});return Oe(this,C,"f").$postMessage(Oe(this,y,"f"),A.message,...A.buffers)}assertNotDisposed(){if(Oe(this,f,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=p,y=new WeakMap,C=new WeakMap,n=new WeakMap,k=new WeakMap,l=new WeakMap,h=new WeakMap,a=new WeakMap,d=new WeakMap,f=new WeakMap,E=new WeakMap,w=new WeakMap,u=new WeakMap;function b(g){try{const v=(0,D.normalizeVersion)((0,D.parseVersion)(g.engines.vscode));return!!v&&v.majorBase>=1&&v.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=b;class t{constructor(v,A,R,o,P){this.initData=A,this.workspace=R,this._logService=o,this._deprecationService=P,this._webviews=new Map,this._webviewProxy=v.getProxy(S.MainContext.MainThreadWebviews)}$onMessage(v,A,...R){const o=this.getWebview(v);if(o){const{message:P}=(0,_.deserializeWebviewMessage)(A,R);o._onMessageEmitter.fire(P)}}$onMissingCsp(v,A){this._logService.warn(`${A} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(v,A,R){const o=new p(v,this._webviewProxy,i(A),this.initData,this.workspace,R,this._deprecationService);return this._webviews.set(v,o),o._onDidDispose(()=>{this._webviews.delete(v)}),o}deleteWebview(v){this._webviews.delete(v)}getWebview(v){return this._webviews.get(v)}}e.ExtHostWebviews=t;function s(g){return{id:g.identifier,location:g.extensionLocation}}e.toExtensionData=s;function r(g,v,A){return{enableCommandUris:A.enableCommandUris,enableScripts:A.enableScripts,portMapping:A.portMapping,localResourceRoots:A.localResourceRoots||c(g,v)}}e.serializeWebviewOptions=r;function i(g){return{enableCommandUris:g.enableCommandUris,enableScripts:g.enableScripts,portMapping:g.portMapping,localResourceRoots:g.localResourceRoots?.map(v=>F.URI.from(v))}}e.reviveOptions=i;function c(g,v){return[...(v?.getWorkspaceFolders()||[]).map(A=>A.uri),g.extensionLocation]}}),define(Ee[209],_e([0,1,18,41,7,11,25,2,9,47,63,5,6]),function(ee,e,m,F,D,_,I,S,y,C,n,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(t,s){this.document=t,this._storagePath=s,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,s){await this.getEdit(t).undo(),s||this.disposeBackup()}async redo(t,s){await this.getEdit(t).redo(),s||this.disposeBackup()}disposeEdits(t){for(const s of t)this._edits.delete(s)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=p(this.document.uri)+this._backupCounter++;return(0,I.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const s=this._edits.get(t,0);if(!s)throw new Error("No edit found");return s}}class a{constructor(){this._documents=new Map}get(t,s){return this._documents.get(this.key(t,s))}add(t,s,r){const i=this.key(t,s.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${s.uri}`);const c=new h(s,r);return this._documents.set(i,c),c}delete(t,s){const r=this.key(t,s.uri);this._documents.delete(r)}key(t,s){return`${t}@@@${s}`}}var d;(function(b){b[b.Text=0]="Text",b[b.Custom=1]="Custom"})(d||(d={}));class f{constructor(){this._providers=new Map}addTextProvider(t,s,r){return this.add(0,t,s,r)}addCustomProvider(t,s,r){return this.add(1,t,s,r)}get(t){return this._providers.get(t)}add(t,s,r,i){if(this._providers.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this._providers.set(s,{type:t,extension:r,provider:i}),new l.Disposable(()=>this._providers.delete(s))}}class E{constructor(t,s,r,i,c){this._extHostDocuments=s,this._extensionStoragePaths=r,this._extHostWebview=i,this._extHostWebviewPanels=c,this._editorProviders=new f,this._documents=new a,this._proxy=t.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,s,r,i){const c=new D.DisposableStore;return w(r)?(c.add(this._editorProviders.addTextProvider(s,t,r)),this._proxy.$registerTextEditorProvider((0,C.toExtensionData)(t),s,i.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,C.shouldSerializeBuffersForPostMessage)(t))):(c.add(this._editorProviders.addCustomProvider(s,t,r)),this.supportEditing(r)&&c.add(r.onDidChangeCustomDocument(g=>{const v=this.getCustomDocumentEntry(s,g.document.uri);if(u(g)){const A=v.addEdit(g);this._proxy.$onDidEdit(g.document.uri,s,A,g.label)}else this._proxy.$onContentChange(g.document.uri,s)})),this._proxy.$registerCustomEditorProvider((0,C.toExtensionData)(t),s,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,C.shouldSerializeBuffersForPostMessage)(t))),l.Disposable.from(c,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(s)}))}async $createCustomDocument(t,s,r,i,c){const g=this._editorProviders.get(s);if(!g)throw new Error(`No provider found for '${s}'`);if(g.type!==1)throw new Error(`Invalid provide type for '${s}'`);const v=S.URI.revive(t),A=await g.provider.openCustomDocument(v,{backupId:r,untitledDocumentData:i?.buffer},c);let R;return this.supportEditing(g.provider)&&this._extensionStoragePaths&&(R=this._extensionStoragePaths.workspaceValue(g.extension)??this._extensionStoragePaths.globalValue(g.extension)),this._documents.add(s,A,R),{editable:this.supportEditing(g.provider)}}async $disposeCustomDocument(t,s){const r=this._editorProviders.get(s);if(!r)throw new Error(`No provider found for '${s}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${s}'`);const i=S.URI.revive(t),{document:c}=this.getCustomDocumentEntry(s,i);this._documents.delete(s,c),c.dispose()}async $resolveWebviewEditor(t,s,r,i,c,g){const v=this._editorProviders.get(r);if(!v)throw new Error(`No provider found for '${r}'`);const A=y.ViewColumn.to(c),R=this._extHostWebview.createNewWebview(s,i.webviewOptions,v.extension),o=this._extHostWebviewPanels.createNewWebviewPanel(s,r,i.title,A,i.panelOptions,R),P=S.URI.revive(t);switch(v.type){case 1:{const{document:L}=this.getCustomDocumentEntry(r,P);return v.provider.resolveCustomEditor(L,o,g)}case 0:{const L=this._extHostDocuments.getDocument(P);return v.provider.resolveCustomTextEditor(L,o,g)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,s,r){this.getCustomDocumentEntry(s,t).disposeEdits(r)}async $onMoveCustomEditor(t,s,r){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const c=this._extHostWebviewPanels.getWebviewPanel(t);if(!c)throw new Error("No webview found");const g=S.URI.revive(s),v=this._extHostDocuments.getDocument(g);await i.provider.moveCustomTextEditor(v,c,m.CancellationToken.None)}async $undo(t,s,r,i){return this.getCustomDocumentEntry(s,t).undo(r,i)}async $redo(t,s,r,i){return this.getCustomDocumentEntry(s,t).redo(r,i)}async $revert(t,s,r){const i=this.getCustomDocumentEntry(s,t);await this.getCustomEditorProvider(s).revertCustomDocument(i.document,r),i.disposeBackup()}async $onSave(t,s,r){const i=this.getCustomDocumentEntry(s,t);await this.getCustomEditorProvider(s).saveCustomDocument(i.document,r),i.disposeBackup()}async $onSaveAs(t,s,r,i){const c=this.getCustomDocumentEntry(s,t);return this.getCustomEditorProvider(s).saveCustomDocumentAs(c.document,S.URI.revive(r),i)}async $backup(t,s,r){const i=this.getCustomDocumentEntry(s,t),g=await this.getCustomEditorProvider(s).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},r);return i.updateBackup(g),g.id}getCustomDocumentEntry(t,s){const r=this._documents.get(t,S.URI.revive(s));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(t){const r=this._editorProviders.get(t)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=E;function w(b){return typeof b.resolveCustomTextEditor=="function"}function u(b){return typeof b.undo=="function"&&typeof b.redo=="function"}function p(b){const t=b.scheme===_.Schemas.file||b.scheme===_.Schemas.untitled?b.fsPath:b.toString();return(0,F.hash)(t)+""}});var nt=this&&this.__classPrivateFieldSet||function(ee,e,m,F,D){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?D.call(ee,m):D?D.value=m:e.set(ee,m),m},Oe=this&&this.__classPrivateFieldGet||function(ee,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(ee):F?F.value:e.get(ee)};define(Ee[210],_e([0,1,3,7,2,35,9,47,5,6]),function(ee,e,m,F,D,_,I,S,y,C){"use strict";var n,k,l,h,a,d,f,E,w,u,p,b,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends F.Disposable{constructor(g,v,A,R,o,P,L){super();n.set(this,void 0),k.set(this,void 0),l.set(this,void 0),h.set(this,void 0),a.set(this,void 0),d.set(this,void 0),f.set(this,void 0),E.set(this,void 0),w.set(this,!0),u.set(this,!0),p.set(this,!1),b.set(this,this._register(new m.Emitter)),this.onDidDispose=Oe(this,b,"f").event,t.set(this,this._register(new m.Emitter)),this.onDidChangeViewState=Oe(this,t,"f").event,nt(this,n,g,"f"),nt(this,k,v,"f"),nt(this,l,A,"f"),nt(this,a,P,"f"),nt(this,E,o,"f"),nt(this,d,R,"f"),nt(this,h,L,"f")}dispose(){Oe(this,p,"f")||(nt(this,p,!0,"f"),Oe(this,b,"f").fire(),Oe(this,k,"f").$disposeWebview(Oe(this,n,"f")),Oe(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,h,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,l,"f")}get title(){return this.assertNotDisposed(),Oe(this,d,"f")}set title(g){this.assertNotDisposed(),Oe(this,d,"f")!==g&&(nt(this,d,g,"f"),Oe(this,k,"f").$setTitle(Oe(this,n,"f"),g))}get iconPath(){return this.assertNotDisposed(),Oe(this,f,"f")}set iconPath(g){this.assertNotDisposed(),Oe(this,f,"f")!==g&&(nt(this,f,g,"f"),Oe(this,k,"f").$setIconPath(Oe(this,n,"f"),D.URI.isUri(g)?{light:g,dark:g}:g))}get options(){return Oe(this,a,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,E,"f")=="number"&&Oe(this,E,"f")<0))return Oe(this,E,"f")}get active(){return this.assertNotDisposed(),Oe(this,u,"f")}get visible(){return this.assertNotDisposed(),Oe(this,w,"f")}_updateViewState(g){Oe(this,p,"f")||(this.active!==g.active||this.visible!==g.visible||this.viewColumn!==g.viewColumn)&&(nt(this,u,g.active,"f"),nt(this,w,g.visible,"f"),nt(this,E,g.viewColumn,"f"),Oe(this,t,"f").fire({webviewPanel:this}))}reveal(g,v){this.assertNotDisposed(),Oe(this,k,"f").$reveal(Oe(this,n,"f"),{viewColumn:g?I.ViewColumn.from(g):void 0,preserveFocus:!!v})}assertNotDisposed(){if(Oe(this,p,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,k=new WeakMap,l=new WeakMap,h=new WeakMap,a=new WeakMap,d=new WeakMap,f=new WeakMap,E=new WeakMap,w=new WeakMap,u=new WeakMap,p=new WeakMap,b=new WeakMap,t=new WeakMap;class r{constructor(g,v,A){this.webviews=v,this.workspace=A,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=g.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,_.generateUuid)()}createWebviewPanel(g,v,A,R,o={}){const P=typeof R=="object"?R.viewColumn:R,L={viewColumn:I.ViewColumn.from(P),preserveFocus:typeof R=="object"&&!!R.preserveFocus},$=(0,S.shouldSerializeBuffersForPostMessage)(g),re=r.newHandle();this._proxy.$createWebviewPanel((0,S.toExtensionData)(g),re,v,{title:A,panelOptions:i(o),webviewOptions:(0,S.serializeWebviewOptions)(g,this.workspace,o),serializeBuffersForPostMessage:$},L);const he=this.webviews.createNewWebview(re,o,g);return this.createNewWebviewPanel(re,v,A,P,o,he)}$onDidChangeWebviewPanelViewStates(g){const v=Object.keys(g);v.sort((A,R)=>{const o=g[A],P=g[R];return o.active?1:P.active?-1:+o.visible-+P.visible});for(const A of v){const R=this.getWebviewPanel(A);if(!R)continue;const o=g[A];R._updateViewState({active:o.active,visible:o.visible,viewColumn:I.ViewColumn.to(o.position)})}}async $onDidDisposeWebviewPanel(g){this.getWebviewPanel(g)?.dispose(),this._webviewPanels.delete(g),this.webviews.deleteWebview(g)}registerWebviewPanelSerializer(g,v,A){if(this._serializers.has(v))throw new Error(`Serializer for '${v}' already registered`);return this._serializers.set(v,{serializer:A,extension:g}),this._proxy.$registerSerializer(v,{serializeBuffersForPostMessage:(0,S.shouldSerializeBuffersForPostMessage)(g)}),new C.Disposable(()=>{this._serializers.delete(v),this._proxy.$unregisterSerializer(v)})}async $deserializeWebviewPanel(g,v,A,R){const o=this._serializers.get(v);if(!o)throw new Error(`No serializer found for '${v}'`);const{serializer:P,extension:L}=o,$=this.webviews.createNewWebview(g,A.webviewOptions,L),re=this.createNewWebviewPanel(g,v,A.title,R,A.panelOptions,$);await P.deserializeWebviewPanel(re,A.state)}createNewWebviewPanel(g,v,A,R,o,P){const L=new s(g,this._proxy,v,A,R,o,P);return this._webviewPanels.set(g,L),L}getWebviewPanel(g){return this._webviewPanels.get(g)}}e.ExtHostWebviewPanels=r;function i(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(ee,e,m,F,D){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?D.call(ee,m):D?D.value=m:e.set(ee,m),m},Oe=this&&this.__classPrivateFieldGet||function(ee,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(ee):F?F.value:e.get(ee)};define(Ee[211],_e([0,1,3,7,47,5,6]),function(ee,e,m,F,D,_,I){"use strict";var S,y,C,n,k,l,h,a,d,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class E extends F.Disposable{constructor(p,b,t,s,r,i){super();S.set(this,void 0),y.set(this,void 0),C.set(this,void 0),n.set(this,void 0),k.set(this,!1),l.set(this,void 0),h.set(this,void 0),a.set(this,void 0),d.set(this,this._register(new m.Emitter)),this.onDidChangeVisibility=Oe(this,d,"f").event,f.set(this,this._register(new m.Emitter)),this.onDidDispose=Oe(this,f,"f").event,nt(this,C,t,"f"),nt(this,h,s,"f"),nt(this,S,p,"f"),nt(this,y,b,"f"),nt(this,n,r,"f"),nt(this,l,i,"f")}dispose(){Oe(this,k,"f")||(nt(this,k,!0,"f"),Oe(this,f,"f").fire(),Oe(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,h,"f")}set title(p){this.assertNotDisposed(),Oe(this,h,"f")!==p&&(nt(this,h,p,"f"),Oe(this,y,"f").$setWebviewViewTitle(Oe(this,S,"f"),p))}get description(){return this.assertNotDisposed(),Oe(this,a,"f")}set description(p){this.assertNotDisposed(),Oe(this,a,"f")!==p&&(nt(this,a,p,"f"),Oe(this,y,"f").$setWebviewViewDescription(Oe(this,S,"f"),p))}get visible(){return Oe(this,l,"f")}get webview(){return Oe(this,n,"f")}get viewType(){return Oe(this,C,"f")}_setVisible(p){p===Oe(this,l,"f")||Oe(this,k,"f")||(nt(this,l,p,"f"),Oe(this,d,"f").fire())}show(p){this.assertNotDisposed(),Oe(this,y,"f").$show(Oe(this,S,"f"),!!p)}assertNotDisposed(){if(Oe(this,k,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,y=new WeakMap,C=new WeakMap,n=new WeakMap,k=new WeakMap,l=new WeakMap,h=new WeakMap,a=new WeakMap,d=new WeakMap,f=new WeakMap;class w{constructor(p,b){this._extHostWebview=b,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=p.getProxy(_.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(p,b,t,s){if(this._viewProviders.has(b))throw new Error(`View provider for '${b}' already registered`);return this._viewProviders.set(b,{provider:t,extension:p}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(p),b,{retainContextWhenHidden:s?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new I.Disposable(()=>{this._viewProviders.delete(b),this._proxy.$unregisterWebviewViewProvider(b)})}async $resolveWebviewView(p,b,t,s,r){const i=this._viewProviders.get(b);if(!i)throw new Error(`No view provider found for '${b}'`);const{provider:c,extension:g}=i,v=this._extHostWebview.createNewWebview(p,{},g),A=new E(p,this._proxy,b,t,v,!0);this._webviewViews.set(p,A),await c.resolveWebviewView(A,{state:s},r)}async $onDidChangeWebviewViewVisibility(p,b){this.getWebviewView(p)._setVisible(b)}async $disposeWebviewView(p){const b=this.getWebviewView(p);this._webviewViews.delete(p),b.dispose(),this._extHostWebview.deleteWebview(p)}getWebviewView(p){const b=this._webviewViews.get(p);if(!b)throw new Error("No webview found");return b}}e.ExtHostWebviewViews=w}),define(Ee[103],_e([0,1,3,5,2,11,8,4,13]),function(ee,e,m,F,D,_,I,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class xn{constructor(k){this._onDidChangeWindowState=new m.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=xn.InitialState,this._proxy=k.getProxy(F.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state={...this._state,focused:k},this._onDidChangeWindowState.fire(this._state))}openUri(k,l){let h;if(typeof k=="string"){h=k;try{k=D.URI.parse(k)}catch(a){return Promise.reject(`Invalid uri - '${k}'`)}}return(0,I.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===_.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,h,l)}async asExternalUri(k,l){if((0,I.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this._proxy.$asExternalUri(k,l);return D.URI.from(h)}};C.InitialState={focused:!0},C=ze([qe(0,y.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=(0,S.createDecorator)("IExtHostWindow")}),define(Ee[212],_e([0,1,15,5,28,13]),function(ee,e,m,F,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let I=class extends m.AbstractLogger{constructor(y,C){super();this._proxy=y.getProxy(F.MainContext.MainThreadLog),this._logFile=C.logFile.toJSON(),this.setLevel(C.logLevel)}$setLevel(y){this.setLevel(y)}trace(y,...C){this.getLevel()<=m.LogLevel.Trace&&this._proxy.$log(this._logFile,m.LogLevel.Trace,Array.from(arguments))}debug(y,...C){this.getLevel()<=m.LogLevel.Debug&&this._proxy.$log(this._logFile,m.LogLevel.Debug,Array.from(arguments))}info(y,...C){this.getLevel()<=m.LogLevel.Info&&this._proxy.$log(this._logFile,m.LogLevel.Info,Array.from(arguments))}warn(y,...C){this.getLevel()<=m.LogLevel.Warning&&this._proxy.$log(this._logFile,m.LogLevel.Warning,Array.from(arguments))}error(y,...C){this.getLevel()<=m.LogLevel.Error&&this._proxy.$log(this._logFile,m.LogLevel.Error,Array.from(arguments))}critical(y,...C){this.getLevel()<=m.LogLevel.Critical&&this._proxy.$log(this._logFile,m.LogLevel.Critical,Array.from(arguments))}flush(){}};I=ze([qe(0,_.IExtHostRpcService),qe(1,D.IExtHostInitDataService)],I),e.ExtHostLogService=I}),define(Ee[213],_e([0,1,16,18,12,3,7,114,182,100,23]),function(ee,e,m,F,D,_,I,S,y,C,n){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function l(i,c){try{return JSON.stringify(i,c)}catch(g){return"null"}}function h(i,c){return JSON.stringify(i,c)}function a(i){return i?(c,g)=>g&&g.$mid===1?i.transformOutgoing(g):g:null}var d;(function(i){i[i.LocalSide=0]="LocalSide",i[i.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));var f;(function(i){i[i.Responsive=0]="Responsive",i[i.Unresponsive=1]="Unresponsive"})(f=e.ResponsiveState||(e.ResponsiveState={}));const E=()=>{},w=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class p extends I.Disposable{constructor(c,g=null,v=null){super();this[k]=!0,this._onDidChangeResponsiveState=this._register(new _.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=c,this._logger=g,this._uriTransformer=v,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let A=0,R=C.ProxyIdentifier.count;A<R;A++)this._locals[A]=null,this._proxies[A]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new m.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(A=>this._receiveOneMessage(A))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(c=>{this._pendingRPCReplies[c].resolveErr(D.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(c){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+p.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(c){this._unresponsiveTime=Date.now()+p.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(c){this._responsiveState!==c&&(this._responsiveState=c,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(c){return this._uriTransformer?(0,S.transformIncomingURIs)(c,this._uriTransformer):c}getProxy(c){const{nid:g,sid:v}=c;return this._proxies[g]||(this._proxies[g]=this._createProxy(g,v)),this._proxies[g]}_createProxy(c,g){let v={get:(A,R)=>(typeof R=="string"&&!A[R]&&R.charCodeAt(0)===36&&(A[R]=(...o)=>this._remoteCall(c,R,o)),R===u?g:A[R])};return new Proxy(Object.create(null),v)}set(c,g){return this._locals[c.nid]=g,g}assertRegistered(c){for(let g=0,v=c.length;g<v;g++){const A=c[g];if(!this._locals[A.nid])throw new Error(`Missing actor ${A.sid} (isMain: ${A.isMain})`)}}_receiveOneMessage(c){if(this._isDisposed)return;const g=c.byteLength,v=b.read(c,0),A=v.readUInt8(),R=v.readUInt32();switch(A){case 1:case 2:{let{rpcId:o,method:P,args:L}=t.deserializeRequestJSONArgs(v);this._uriTransformer&&(L=(0,S.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(g,R,o,P,L,A===2);break}case 3:case 4:{let{rpcId:o,method:P,args:L}=t.deserializeRequestMixedArgs(v);this._uriTransformer&&(L=(0,S.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(g,R,o,P,L,A===4);break}case 5:{this._logger&&this._logger.logIncoming(g,R,0,"ack"),this._onDidReceiveAcknowledge(R);break}case 6:{this._receiveCancel(g,R);break}case 7:{this._receiveReply(g,R,void 0);break}case 9:{let o=t.deserializeReplyOKJSON(v);this._uriTransformer&&(o=(0,S.transformIncomingURIs)(o,this._uriTransformer)),this._receiveReply(g,R,o);break}case 8:{let o=t.deserializeReplyOKVSBuffer(v);this._receiveReply(g,R,o);break}case 10:{let o=t.deserializeReplyErrError(v);this._uriTransformer&&(o=(0,S.transformIncomingURIs)(o,this._uriTransformer)),this._receiveReplyErr(g,R,o);break}case 11:{this._receiveReplyErr(g,R,void 0);break}default:console.error("received unexpected message"),console.error(c)}}_receiveRequest(c,g,v,A,R,o){this._logger&&this._logger.logIncoming(c,g,1,`receiveRequest ${(0,C.getStringIdentifierForProxy)(v)}.${A}(`,R);const P=String(g);let L,$;if(o){const he=new F.CancellationTokenSource;R.push(he.token),L=this._invokeHandler(v,A,R),$=()=>he.cancel()}else L=this._invokeHandler(v,A,R),$=E;this._cancelInvokedHandlers[P]=$;const re=t.serializeAcknowledged(g);this._logger&&this._logger.logOutgoing(re.byteLength,g,1,"ack"),this._protocol.send(re),L.then(he=>{delete this._cancelInvokedHandlers[P];const Q=t.serializeReplyOK(g,he,this._uriReplacer);this._logger&&this._logger.logOutgoing(Q.byteLength,g,1,"reply:",he),this._protocol.send(Q)},he=>{delete this._cancelInvokedHandlers[P];const Q=t.serializeReplyErr(g,he);this._logger&&this._logger.logOutgoing(Q.byteLength,g,1,"replyErr:",he),this._protocol.send(Q)})}_receiveCancel(c,g){this._logger&&this._logger.logIncoming(c,g,1,"receiveCancel");const v=String(g);this._cancelInvokedHandlers[v]&&this._cancelInvokedHandlers[v]()}_receiveReply(c,g,v){this._logger&&this._logger.logIncoming(c,g,0,"receiveReply:",v);const A=String(g);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const R=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A],R.resolveOk(v)}_receiveReplyErr(c,g,v){this._logger&&this._logger.logIncoming(c,g,0,"receiveReplyErr:",v);const A=String(g);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const R=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A];let o;v&&(v.$isError?(o=new Error,o.name=v.name,o.message=v.message,o.stack=v.stack):o=v),R.resolveErr(o)}_invokeHandler(c,g,v){try{return Promise.resolve(this._doInvokeHandler(c,g,v))}catch(A){return Promise.reject(A)}}_doInvokeHandler(c,g,v){const A=this._locals[c];if(!A)throw new Error("Unknown actor "+(0,C.getStringIdentifierForProxy)(c));let R=A[g];if(typeof R!="function")throw new Error("Unknown method "+g+" on actor "+(0,C.getStringIdentifierForProxy)(c));return R.apply(A,v)}_remoteCall(c,g,v){if(this._isDisposed)return Promise.reject(D.canceled());let A=null;if(v.length>0&&F.CancellationToken.isCancellationToken(v[v.length-1])&&(A=v.pop()),A&&A.isCancellationRequested)return Promise.reject(D.canceled());const R=t.serializeRequestArguments(v,this._uriReplacer),o=++this._lastMessageId,P=String(o),L=new y.LazyPromise;A&&A.onCancellationRequested(()=>{const re=t.serializeCancel(o);this._logger&&this._logger.logOutgoing(re.byteLength,o,0,"cancel"),this._protocol.send(t.serializeCancel(o))}),this._pendingRPCReplies[P]=L,this._onWillSendRequest(o);const $=t.serializeRequest(o,c,g,R,!!A);return this._logger&&this._logger.logOutgoing($.byteLength,o,0,`request: ${(0,C.getStringIdentifierForProxy)(c)}.${g}(`,v),this._protocol.send($),L}}e.RPCProtocol=p,k=w,p.UNRESPONSIVE_TIME=3*1e3;class b{constructor(c,g){this._buff=c,this._offset=g}static alloc(c,g,v){let A=new b(n.VSBuffer.alloc(v+1+4),0);return A.writeUInt8(c),A.writeUInt32(g),A}static read(c,g){return new b(c,g)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(c){this._buff.writeUInt8(c,this._offset),this._offset+=1}readUInt8(){const c=this._buff.readUInt8(this._offset);return this._offset+=1,c}writeUInt32(c){this._buff.writeUInt32BE(c,this._offset),this._offset+=4}readUInt32(){const c=this._buff.readUInt32BE(this._offset);return this._offset+=4,c}static sizeShortString(c){return 1+c.byteLength}writeShortString(c){this._buff.writeUInt8(c.byteLength,this._offset),this._offset+=1,this._buff.set(c,this._offset),this._offset+=c.byteLength}readShortString(){const c=this._buff.readUInt8(this._offset);this._offset+=1;const v=this._buff.slice(this._offset,this._offset+c).toString();return this._offset+=c,v}static sizeLongString(c){return 4+c.byteLength}writeLongString(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}readLongString(){const c=this._buff.readUInt32BE(this._offset);this._offset+=4;const v=this._buff.slice(this._offset,this._offset+c).toString();return this._offset+=c,v}writeBuffer(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}static sizeVSBuffer(c){return 4+c.byteLength}writeVSBuffer(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}readVSBuffer(){const c=this._buff.readUInt32BE(this._offset);this._offset+=4;const g=this._buff.slice(this._offset,this._offset+c);return this._offset+=c,g}static sizeMixedArray(c,g){let v=0;v+=1;for(let A=0,R=c.length;A<R;A++){const o=c[A],P=g[A];switch(v+=1,P){case 1:v+=this.sizeLongString(o);break;case 2:v+=this.sizeVSBuffer(o);break;case 3:break}}return v}writeMixedArray(c,g){this._buff.writeUInt8(c.length,this._offset),this._offset+=1;for(let v=0,A=c.length;v<A;v++){const R=c[v];switch(g[v]){case 1:this.writeUInt8(1),this.writeLongString(R);break;case 2:this.writeUInt8(2),this.writeVSBuffer(R);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const c=this._buff.readUInt8(this._offset);this._offset+=1;let g=new Array(c);for(let v=0;v<c;v++)switch(this.readUInt8()){case 1:g[v]=this.readLongString();break;case 2:g[v]=this.readVSBuffer();break;case 3:g[v]=void 0;break}return g}}class t{static _arrayContainsBufferOrUndefined(c){for(let g=0,v=c.length;g<v;g++)if(c[g]instanceof n.VSBuffer||typeof c[g]=="undefined")return!0;return!1}static serializeRequestArguments(c,g){if(this._arrayContainsBufferOrUndefined(c)){let v=[],A=[];for(let R=0,o=c.length;R<o;R++){const P=c[R];P instanceof n.VSBuffer?(v[R]=P,A[R]=2):typeof P=="undefined"?(v[R]=n.VSBuffer.alloc(0),A[R]=3):(v[R]=n.VSBuffer.fromString(h(P,g)),A[R]=1)}return{type:"mixed",args:v,argsType:A}}return{type:"simple",args:h(c,g)}}static serializeRequest(c,g,v,A,R){return A.type==="mixed"?this._requestMixedArgs(c,g,v,A.args,A.argsType,R):this._requestJSONArgs(c,g,v,A.args,R)}static _requestJSONArgs(c,g,v,A,R){const o=n.VSBuffer.fromString(v),P=n.VSBuffer.fromString(A);let L=0;L+=b.sizeUInt8(),L+=b.sizeShortString(o),L+=b.sizeLongString(P);let $=b.alloc(R?2:1,c,L);return $.writeUInt8(g),$.writeShortString(o),$.writeLongString(P),$.buffer}static deserializeRequestJSONArgs(c){const g=c.readUInt8(),v=c.readShortString(),A=c.readLongString();return{rpcId:g,method:v,args:JSON.parse(A)}}static _requestMixedArgs(c,g,v,A,R,o){const P=n.VSBuffer.fromString(v);let L=0;L+=b.sizeUInt8(),L+=b.sizeShortString(P),L+=b.sizeMixedArray(A,R);let $=b.alloc(o?4:3,c,L);return $.writeUInt8(g),$.writeShortString(P),$.writeMixedArray(A,R),$.buffer}static deserializeRequestMixedArgs(c){const g=c.readUInt8(),v=c.readShortString(),A=c.readMixedArray(),R=new Array(A.length);for(let o=0,P=A.length;o<P;o++){const L=A[o];typeof L=="string"?R[o]=JSON.parse(L):R[o]=L}return{rpcId:g,method:v,args:R}}static serializeAcknowledged(c){return b.alloc(5,c,0).buffer}static serializeCancel(c){return b.alloc(6,c,0).buffer}static serializeReplyOK(c,g,v){return typeof g=="undefined"?this._serializeReplyOKEmpty(c):g instanceof n.VSBuffer?this._serializeReplyOKVSBuffer(c,g):this._serializeReplyOKJSON(c,l(g,v))}static _serializeReplyOKEmpty(c){return b.alloc(7,c,0).buffer}static _serializeReplyOKVSBuffer(c,g){let v=0;v+=b.sizeVSBuffer(g);let A=b.alloc(8,c,v);return A.writeVSBuffer(g),A.buffer}static deserializeReplyOKVSBuffer(c){return c.readVSBuffer()}static _serializeReplyOKJSON(c,g){const v=n.VSBuffer.fromString(g);let A=0;A+=b.sizeLongString(v);let R=b.alloc(9,c,A);return R.writeLongString(v),R.buffer}static deserializeReplyOKJSON(c){const g=c.readLongString();return JSON.parse(g)}static serializeReplyErr(c,g){return g?this._serializeReplyErrEror(c,g):this._serializeReplyErrEmpty(c)}static _serializeReplyErrEror(c,g){const v=n.VSBuffer.fromString(l(D.transformErrorForSerialization(g),null));let A=0;A+=b.sizeLongString(v);let R=b.alloc(10,c,A);return R.writeLongString(v),R.buffer}static deserializeReplyErrError(c){const g=c.readLongString();return JSON.parse(g)}static _serializeReplyErrEmpty(c){return b.alloc(11,c,0).buffer}}var s;(function(i){i[i.RequestJSONArgs=1]="RequestJSONArgs",i[i.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",i[i.RequestMixedArgs=3]="RequestMixedArgs",i[i.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",i[i.Acknowledged=5]="Acknowledged",i[i.Cancel=6]="Cancel",i[i.ReplyOKEmpty=7]="ReplyOKEmpty",i[i.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",i[i.ReplyOKJSON=9]="ReplyOKJSON",i[i.ReplyErrError=10]="ReplyErrError",i[i.ReplyErrEmpty=11]="ReplyErrEmpty"})(s||(s={}));var r;(function(i){i[i.String=1]="String",i[i.VSBuffer=2]="VSBuffer",i[i.Undefined=3]="Undefined"})(r||(r={}))}),define(Ee[214],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const m=function(_){const I=S=>{self.removeEventListener("message",I);const y=S.data;Object.defineProperties(self,{postMessage:{value(C,n){y.postMessage(C,n)}},onmessage:{get(){return y.onmessage},set(C){y.onmessage=C}}}),y.addEventListener("message",C=>{self.dispatchEvent(new MessageEvent("message",{data:C.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(_)};self.addEventListener("message",I)}.toString();class F extends EventTarget{constructor(_,I,S){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${m})('${I}'))`,C=new Blob([y],{type:"application/javascript"}),n=URL.createObjectURL(C),k=new MessageChannel,l=n,h={type:"_newWorker",id:l,port:k.port2,url:n,options:S};_(h,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{const a={type:"_terminateWorker",id:l};k.port1.postMessage(a),URL.revokeObjectURL(n),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(a){k.port1.onmessage=a}},onmessageerror:{get(){return k.port1.onmessageerror},set(a){k.port1.onmessageerror=a}}}),k.port1.addEventListener("messageerror",a=>{const d=new MessageEvent("messageerror",{data:a.data});this.dispatchEvent(d)}),k.port1.addEventListener("message",a=>{const d=new MessageEvent("message",{data:a.data});this.dispatchEvent(d)}),k.port1.start()}}e.NestedWorker=F}),define(Ee[215],_e([0,1,4]),function(ee,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,m.createDecorator)("remoteAgentService")}),define(Ee[216],_e([0,1,11,14,21,2,4,93,44,178,215]),function(ee,e,m,F,D,_,I,S,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,I.createDecorator)("pathService");let k=class Bn{constructor(h,a,d,f){this.localUserHome=h,this.remoteAgentService=a,this.environmentService=d,this.contextService=f,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||D.OS)(),this.resolveUserHome=(async()=>{const E=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=E?.userHome||h})()}get defaultUriScheme(){return Bn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,a){if(h.remoteAuthority)return m.Schemas.vscodeRemote;const d=(0,S.getVirtualWorkspaceScheme)(a.getWorkspace());if(d)return d;const f=a.getWorkspace().folders[0];if(f)return f.uri.scheme;const E=a.getWorkspace().configuration;return E?E.scheme:m.Schemas.file}async userHome(h){return h?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?F.win32:F.posix)}async fileURI(h){let a="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const f=h.indexOf("/",2);f===-1?(a=h.substring(2),h="/"):(a=h.substring(2,f),h=h.substring(f)||"/")}return _.URI.from({scheme:m.Schemas.file,authority:a,path:h,query:"",fragment:""})}};k=ze([qe(1,n.IRemoteAgentService),qe(2,C.IWorkbenchEnvironmentService),qe(3,y.IWorkspaceContextService)],k),e.AbstractPathService=k}),define(Ee[104],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class m{constructor(I,S){this.line=I,this.character=S}isBefore(I){return!1}isBeforeOrEqual(I){return!1}isAfter(I){return!1}isAfterOrEqual(I){return!1}isEqual(I){return!1}compareTo(I){return 0}translate(I,S){return new m(0,0)}with(I){return new m(0,0)}}e.Position=m;class F{constructor(I,S,y,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new m(I,S),this.end=new m(y,C)}contains(I){return!1}isEqual(I){return!1}intersection(I){}union(I){return new F(0,0,0,0)}with(I){return new F(0,0,0,0)}}e.Range=F;var D;(function(_){_[_.Information=1]="Information",_[_.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ee[38],_e([0,1,17,27,24,43,8,4,14,12,104]),function(ee,e,m,F,D,_,I,S,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const k="\u27EA ",l=" characters skipped \u27EB",h=(k.length+l.length+5)*2;e.ISearchService=(0,S.createDecorator)("searchService");var a;(function(T){T[T.file=0]="file",T[T.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(T){T[T.File=1]="File",T[T.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function f(T){return!!T.preview}e.resultIsMatch=f;function E(T){return!!T.resource}e.isFileMatch=E;function w(T){return!!T.message}e.isProgressMessage=w;var u;(function(T){T[T.Normal=0]="Normal",T[T.NewSearchStarted=1]="NewSearchStarted"})(u=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(G){this.resource=G,this.results=[]}}e.FileMatch=p;class b{constructor(G,B,j){this.ranges=B;const ce=Array.isArray(B)?B:[B];if(j&&j.matchLines===1&&t(ce)){G=(0,I.getNLines)(G,j.matchLines);let W="",te=0,ue=0;const ye=Math.floor(j.charsPerLine/5),Te=[];for(const Re of ce){const $e=Math.max(Re.startColumn-ye,0),Ze=Re.startColumn+j.charsPerLine;if($e>ue+ye+h){const Ve=k+($e-ue)+l;W+=Ve+G.slice($e,Ze),te+=$e-(ue+Ve.length)}else W+=G.slice(ue,Ze);Te.push(new r(0,Re.startColumn-te,Re.endColumn-te)),ue=Ze}this.preview={text:W,matches:Array.isArray(this.ranges)?Te:Te[0]}}else{const W=Array.isArray(B)?B[0].startLineNumber:B.startLineNumber;this.preview={text:G,matches:(0,m.mapArrayOrNot)(B,te=>new s(te.startLineNumber-W,te.startColumn,te.endLineNumber-W,te.endColumn))}}}}e.TextSearchMatch=b;function t(T){const G=T[0].startLineNumber;for(const B of T)if(B.startLineNumber!==G||B.endLineNumber!==G)return!1;return!0}class s{constructor(G,B,j,ce){this.startLineNumber=G,this.startColumn=B,this.endLineNumber=j,this.endColumn=ce}}e.SearchRange=s;class r extends s{constructor(G,B,j){super(G,B,G,j)}}e.OneLineRange=r;var i;(function(T){T.Default="default",T.FileNames="fileNames",T.Type="type",T.Modified="modified",T.CountDescending="countDescending",T.CountAscending="countAscending"})(i=e.SearchSortOrder||(e.SearchSortOrder={}));function c(T,G=!0){const B=T&&T.files&&T.files.exclude,j=G&&T&&T.search&&T.search.exclude;if(!B&&!j)return;if(!B||!j)return B||j;let ce=Object.create(null);return ce=D.mixin(ce,D.deepClone(B)),ce=D.mixin(ce,D.deepClone(j),!0),ce}e.getExcludes=c;function g(T,G){return T.excludePattern&&F.match(T.excludePattern,G)?!1:T.includePattern||T.usingSearchPaths?T.includePattern&&F.match(T.includePattern,G)?!0:T.usingSearchPaths?!!T.folderQueries&&T.folderQueries.some(B=>{const j=B.folder.fsPath;if(_.isEqualOrParent(G,j)){const ce=y.relative(j,G);return!B.includePattern||!!F.match(B.includePattern,ce)}else return!1}):!1:!0}e.pathIncludedInQuery=g;var v;(function(T){T[T.unknownEncoding=1]="unknownEncoding",T[T.regexParseError=2]="regexParseError",T[T.globParseError=3]="globParseError",T[T.invalidLiteral=4]="invalidLiteral",T[T.rgProcessError=5]="rgProcessError",T[T.other=6]="other",T[T.canceled=7]="canceled"})(v=e.SearchErrorCode||(e.SearchErrorCode={}));class A extends Error{constructor(G,B){super(G);this.code=B}}e.SearchError=A;function R(T){const G=T.message;if((0,C.isPromiseCanceledError)(T))return new A(G,v.canceled);try{const B=JSON.parse(G);return new A(B.message,B.code)}catch(B){return new A(G,v.other)}}e.deserializeSearchError=R;function o(T){const G={message:T.message,code:T.code};return new Error(JSON.stringify(G))}e.serializeSearchError=o;function P(T){return T.type==="error"?!0:T.type==="success"}e.isSerializedSearchComplete=P;function L(T){return T.type==="success"}e.isSerializedSearchSuccess=L;function $(T){return!!T.path}e.isSerializedFileMatch=$;function re(T,G){const B=T.searchPath?T.searchPath:T.relativePath;return(0,I.fuzzyContains)(B,G)}e.isFilePatternMatch=re;class he{constructor(G){this.path=G,this.results=[]}addMatch(G){this.results.push(G)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=he;function Q(T,G){const B={...T||{},...G||{}};return Object.keys(B).filter(j=>{const ce=B[j];return typeof ce=="boolean"&&ce})}e.resolvePatternsForProvider=Q;class z{constructor(G,B){this._parsedIncludeExpression=null,this._excludeExpression={...G.excludePattern||{},...B.excludePattern||{}},this._parsedExcludeExpression=F.parse(this._excludeExpression);let j=G.includePattern;B.includePattern&&(j?j={...j,...B.includePattern}:j=B.includePattern),j&&(this._parsedIncludeExpression=F.parse(j))}includedInQuerySync(G,B,j){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(G,B,j)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(G,B,j))}includedInQuery(G,B,j){return Promise.resolve(this._parsedExcludeExpression(G,B,j)).then(W=>!!W).then(W=>W?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(G,B,j)).then(te=>!!te):Promise.resolve(!0)).then(W=>W)}hasSiblingExcludeClauses(){return V(this._excludeExpression)}}e.QueryGlobTester=z;function V(T){for(const G in T)if(typeof T[G]!="boolean")return!0;return!1}}),define(Ee[32],_e([0,1,17,16,18,3,22,11,79,25,8,10,2,135,4,15,149,44,45,28,13,6,38,5]),function(ee,e,m,F,D,_,I,S,y,C,n,k,l,h,a,d,f,E,w,u,p,b,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(P,L,$){return new C.ExtUri(re=>v(re,$)).isEqual(P,L)}function i(P,L,$){return r(P.uri,L.uri,$)?0:(0,n.compare)(P.uri.toString(),L.uri.toString())}function c(P,L,$){return P.index!==L.index?P.index<L.index?-1:1:r(P.uri,L.uri,$)?(0,n.compare)(P.name,L.name):(0,n.compare)(P.uri.toString(),L.uri.toString())}function g(P,L,$,re){const he=P.slice(0).sort((z,V)=>$(z,V,re)),Q=L.slice(0).sort((z,V)=>$(z,V,re));return(0,m.delta)(he,Q,(z,V)=>$(z,V,re))}function v(P,L){const $=L.getCapabilities(P.scheme);return!($&&$&1024)}class A extends E.Workspace{constructor(L,$,re,he,Q,z){super(L,re.map(V=>new E.WorkspaceFolder(V)),he,z);this._name=$,this._isUntitled=Q,this._workspaceFolders=[],this._structure=I.TernarySearchTree.forUris(z),re.forEach(V=>{this._workspaceFolders.push(V),this._structure.set(V.uri,V)})}static toExtHostWorkspace(L,$,re,he){if(!L)return{workspace:null,added:[],removed:[]};const{id:Q,name:z,folders:V,configuration:T,isUntitled:G}=L,B=[],j=$;$?V.forEach((ue,ye)=>{const Te=l.URI.revive(ue.uri),Re=A._findFolder(re||$,Te,he);Re?(Re.name=ue.name,Re.index=ue.index,B.push(Re)):B.push({uri:Te,name:ue.name,index:ye})}):B.push(...V.map(({uri:ue,name:ye,index:Te})=>({uri:l.URI.revive(ue),name:ye,index:Te}))),B.sort((ue,ye)=>ue.index<ye.index?-1:1);const ce=new A(Q,z,B,T?l.URI.revive(T):null,!!G,ue=>v(ue,he)),{added:W,removed:te}=g(j?j.workspaceFolders:[],ce.workspaceFolders,i,he);return{workspace:ce,added:W,removed:te}}static _findFolder(L,$,re){for(let he=0;he<L.folders.length;he++){const Q=L.workspaceFolders[he];if(r(Q.uri,$,re))return Q}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,$){return $&&this._structure.get(L)&&(L=(0,C.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let R=class{constructor(L,$,re,he){this._onDidChangeWorkspace=new _.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new _.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=he,this._extHostFileSystemInfo=re,this._requestIdProvider=new y.Counter,this._barrier=new F.Barrier,this._proxy=L.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(s.MainContext.MainThreadMessageService);const Q=$.workspace;this._confirmedWorkspace=Q?new A(Q.id,Q.name,[],Q.configuration?l.URI.revive(Q.configuration):null,!!Q.isUntitled,z=>v(z,re)):void 0}$initializeWorkspace(L,$){this._trusted=$,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:S.Schemas.untitled,path:(0,C.basename)((0,C.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,$,re,...he){const Q=[];if(Array.isArray(he)&&he.forEach(B=>{l.URI.isUri(B.uri)&&!Q.some(j=>r(j.uri,B.uri,this._extHostFileSystemInfo))&&Q.push({uri:B.uri,name:B.name||(0,C.basenameOrAuthority)(B.uri)})}),this._unconfirmedWorkspace||[$,re].some(B=>typeof B!="number"||B<0)||re===0&&Q.length===0)return!1;const z=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if($+re>z.length)return!1;const V=z.slice(0);V.splice($,re,...Q.map(B=>({uri:B.uri,name:B.name||(0,C.basenameOrAuthority)(B.uri),index:void 0})));for(let B=0;B<V.length;B++){const j=V[B];if(V.some((ce,W)=>W!==B&&r(j.uri,ce.uri,this._extHostFileSystemInfo)))return!1}V.forEach((B,j)=>B.index=j);const{added:T,removed:G}=g(z,V,c,this._extHostFileSystemInfo);if(T.length===0&&G.length===0)return!1;if(this._proxy){const B=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(B,$,re,Q).then(void 0,j=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(f.Severity.Error,(0,h.localize)(0,null,B,j.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(V),!0}getWorkspaceFolder(L,$){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,$)}async getWorkspaceFolder2(L,$){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,$)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,$){let re,he="";if(typeof L=="string"?(re=l.URI.file(L),he=L):typeof L!="undefined"&&(re=L,he=L.fsPath),!re)return he;const Q=this.getWorkspaceFolder(re,!0);if(!Q)return he;typeof $=="undefined"&&this._actualWorkspace&&($=this._actualWorkspace.folders.length>1);let z=(0,C.relativePath)(Q.uri,re);return $&&Q.name&&(z=`${Q.name}/${z}`),z}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=A.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:$,added:re,removed:he}=A.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=$||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:re,removed:he}))}findFiles(L,$,re,he,Q=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${he.value}, entryPoint: findFiles`);let z;if($===null?z=!1:$&&(typeof $=="string"?z=$:z=$.pattern),Q&&Q.isCancellationRequested)return Promise.resolve([]);const{includePattern:V,folder:T}=o(L);return this._proxy.$startFileSearch((0,k.withUndefinedAsNull)(V),(0,k.withUndefinedAsNull)(T),(0,k.withUndefinedAsNull)(z),(0,k.withUndefinedAsNull)(re),Q).then(G=>Array.isArray(G)?G.map(B=>l.URI.revive(B)):[])}async findTextInFiles(L,$,re,he,Q=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${he.value}, entryPoint: findTextInFiles`);const z=this._requestIdProvider.getNext(),V=typeof $.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:T,folder:G}=o($.include),B=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,j={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:V,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:T,excludePattern:B},ce=!1;if(this._activeSearchCallbacks[z]=W=>{if(ce)return;const te=l.URI.revive(W.resource);W.results.forEach(ue=>{(0,t.resultIsMatch)(ue)?re({uri:te,preview:{text:ue.preview.text,matches:(0,m.mapArrayOrNot)(ue.preview.matches,ye=>new b.Range(ye.startLineNumber,ye.startColumn,ye.endLineNumber,ye.endColumn))},ranges:(0,m.mapArrayOrNot)(ue.ranges,ye=>new b.Range(ye.startLineNumber,ye.startColumn,ye.endLineNumber,ye.endColumn))}):re({uri:te,text:ue.text,lineNumber:ue.lineNumber})})},Q.isCancellationRequested)return{};try{const W=await this._proxy.$startTextSearch(L,(0,k.withUndefinedAsNull)(G),j,z,Q);return delete this._activeSearchCallbacks[z],W||{}}catch(W){throw delete this._activeSearchCallbacks[z],W}}$handleTextSearchResult(L,$){this._activeSearchCallbacks[$]&&this._activeSearchCallbacks[$](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};R=ze([qe(0,p.IExtHostRpcService),qe(1,u.IExtHostInitDataService),qe(2,w.IExtHostFileSystemInfo),qe(3,d.ILogService)],R),e.ExtHostWorkspace=R,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function o(P){let L,$;return P&&(typeof P=="string"?L=P:(L=P.pattern,$=P.baseFolder||l.URI.file(P.base))),{includePattern:L,folder:$}}}),define(Ee[33],_e([0,1,24,3,32,5,6,153,62,10,16,4,13,15,2]),function(ee,e,m,F,D,_,I,S,y,C,n,k,l,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(s,r){if(r){const i=r.split(".");let c=s;for(let g=0;c&&g<i.length;g++)c=c[i[g]];return c}}function f(s){return s instanceof a.URI}function E(s){return s&&s.uri instanceof a.URI&&s.languageId&&typeof s.languageId=="string"}function w(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function u(s){return s&&s.uri instanceof a.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function p(s){if(f(s))return{resource:s};if(E(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(w(s))return{overrideIdentifier:s.languageId};if(u(s))return{resource:s.uri};if(s===null)return{resource:null}}let b=class{constructor(r,i,c){this._proxy=r.getProxy(_.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=c,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new t(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,i){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(r,i))}};b=ze([qe(0,l.IExtHostRpcService),qe(1,D.IExtHostWorkspace),qe(2,h.ILogService)],b),e.ExtHostConfiguration=b;class t{constructor(r,i,c,g){this._onDidChangeConfiguration=new F.Emitter,this._proxy=r,this._logService=g,this._extHostWorkspace=i,this._configuration=S.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,i){const c={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=S.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,c))}getConfiguration(r,i,c){const g=p(i)||{},v=this._toReadonlyValue(r?d(this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,g,c?.identifier);function A(o){if(o==null)return null;if(typeof o=="boolean")return o?1:4;switch(o){case I.ConfigurationTarget.Global:return 1;case I.ConfigurationTarget.Workspace:return 4;case I.ConfigurationTarget.WorkspaceFolder:return 5}}const R={has(o){return typeof d(v,o)!="undefined"},get:(o,P)=>{this._validateConfigurationAccess(r?`${r}.${o}`:o,g,c?.identifier);let L=d(v,o);if(typeof L=="undefined")L=P;else{let $;const re=(he,Q)=>{let z;const V=()=>{$=$||(0,m.deepClone)(v),z=z||d($,Q)};return(0,C.isObject)(he)?new Proxy(he,{get:(T,G)=>{if(typeof G=="string"&&G.toLowerCase()==="tojson")return V(),()=>z;if($)return z=z||d($,Q),z[G];const B=T[G];return typeof G=="string"?re(B,`${Q}.${G}`):B},set:(T,G,B)=>(V(),z&&(z[G]=B),!0),deleteProperty:(T,G)=>(V(),z&&delete z[G],!0),defineProperty:(T,G,B)=>(V(),z&&Object.defineProperty(z,G,B),!0)}):he};L=re(L,o)}return L},update:(o,P,L,$)=>{o=r?`${r}.${o}`:o;const re=A(L);return P!==void 0?this._proxy.$updateConfigurationOption(re,o,P,g,$):this._proxy.$removeConfigurationOption(re,o,g,$)},inspect:o=>{o=r?`${r}.${o}`:o;const P=(0,m.deepClone)(this._configuration.inspect(o,g,this._extHostWorkspace.workspace));if(P)return{key:o,defaultValue:P.default?.value,globalValue:P.user?.value,workspaceValue:P.workspace?.value,workspaceFolderValue:P.workspaceFolder?.value,defaultLanguageValue:P.default?.override,globalLanguageValue:P.user?.override,workspaceLanguageValue:P.workspace?.override,workspaceFolderLanguageValue:P.workspaceFolder?.override,languageIds:P.overrideIdentifiers}}};return typeof v=="object"&&(0,m.mixin)(R,v,!1),Object.freeze(R)}_toReadonlyValue(r){const i=c=>(0,C.isObject)(c)?new Proxy(c,{get:(g,v)=>i(g[v]),set:(g,v,A)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(g,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(g,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return i(r)}_validateConfigurationAccess(r,i,c){const g=y.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),v=c?`[${c.value}] `:"";if(g===4){typeof i?.resource=="undefined"&&this._logService.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){i?.resource&&this._logService.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,i){const c=new S.ConfigurationChangeEvent(r,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(g,v)=>c.affectsConfiguration(g,p(v))})}_toMap(r){return r.reduce((i,c)=>(i.set(c[0],c[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(ee,e,m,F,D){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?D.call(ee,m):D?D.value=m:e.set(ee,m),m},Oe=this&&this.__classPrivateFieldGet||function(ee,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(ee):F?F.value:e.get(ee)};define(Ee[105],_e([0,1,2,16,3,5,6,32,46,33,18,37,13,28,4,11,21,15,71,168,12]),function(ee,e,m,F,D,_,I,S,y,C,n,k,l,h,a,d,f,E,w,u,p){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(he){function Q(V){if(V!=null)return V}he.from=Q;function z(V){if(V!=null)return V}he.to=z})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var s;(function(he){function Q(V){if(V!=null)return V}he.from=Q;function z(V){if(V!=null)return V}he.to=z})(s=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(he){function Q(V){if(V!=null)return V}he.from=Q;function z(V){if(V!=null)return V}he.to=z})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(he){function Q(T){if(T){const G=T;return G&&!!G.process}else return!1}he.is=Q;function z(T){if(T==null)return;const G={process:T.process,args:T.args};return T.options&&(G.options=r.from(T.options)),G}he.from=z;function V(T){if(T!=null)return new I.ProcessExecution(T.process,T.args,T.options)}he.to=V})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var c;(function(he){function Q(V){if(V!=null)return V}he.from=Q;function z(V){if(V!=null)return V}he.to=z})(c=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var g;(function(he){function Q(T){if(T){const G=T;return G&&(!!G.commandLine||!!G.command)}else return!1}he.is=Q;function z(T){if(T==null)return;const G={};return T.commandLine!==void 0?G.commandLine=T.commandLine:(G.command=T.command,G.args=T.args),T.options&&(G.options=c.from(T.options)),G}he.from=z;function V(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new I.ShellExecution(T.commandLine,T.options):new I.ShellExecution(T.command,T.args?T.args:[],T.options)}he.to=V})(g=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var v;(function(he){function Q(T){if(T){let G=T;return G&&G.customExecution==="customExecution"}else return!1}he.is=Q;function z(T){return{customExecution:"customExecution"}}he.from=z;function V(T,G){return G.get(T)}he.to=V})(v=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var A;(function(he){function Q(z,V){let T;return z.scope!==void 0&&typeof z.scope!="number"?T=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===I.TaskScope.Workspace&&V&&V.workspaceFile?T=V.workspaceFile:T=u.USER_TASKS_GROUP_KEY),{id:z._id,workspaceFolder:T}}he.from=Q})(A=e.TaskHandleDTO||(e.TaskHandleDTO={}));var R;(function(he){function Q(T,G){if(T==null)return[];const B=[];for(let j of T){const ce=z(j,G);ce&&B.push(ce)}return B}he.fromMany=Q;function z(T,G){if(T==null)return;let B;T.execution instanceof I.ProcessExecution?B=i.from(T.execution):T.execution instanceof I.ShellExecution?B=g.from(T.execution):T.execution&&T.execution instanceof I.CustomExecution&&(B=v.from(T.execution));const j=t.from(T.definition);let ce;if(T.scope?typeof T.scope=="number"?ce=T.scope:ce=T.scope.uri:ce=I.TaskScope.Workspace,!j||!ce)return;const W=T.group?T.group.id:void 0;return{_id:T._id,definition:j,name:T.name,source:{extensionId:G.identifier.value,label:T.source,scope:ce},execution:B,isBackground:T.isBackground,group:W,presentationOptions:s.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}he.from=z;async function V(T,G,B){if(T==null)return;let j;i.is(T.execution)?j=i.to(T.execution):g.is(T.execution)?j=g.to(T.execution):v.is(T.execution)&&(j=v.to(T._id,B));const ce=t.to(T.definition);let W;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?W=T.source.scope:W=await G.resolveWorkspaceFolder(m.URI.revive(T.source.scope)):W=I.TaskScope.Workspace),!ce||!W)return;const te=new I.Task(ce,W,T.name,T.source.label,j,T.problemMatchers);return T.isBackground!==void 0&&(te.isBackground=T.isBackground),T.group!==void 0&&(te.group=I.TaskGroup.from(T.group)),T.presentationOptions&&(te.presentationOptions=s.to(T.presentationOptions)),T._id&&(te._id=T._id),T.detail&&(te.detail=T.detail),te}he.to=V})(R=e.TaskDTO||(e.TaskDTO={}));var o;(function(he){function Q(V){return V}he.from=Q;function z(V){if(!!V)return Object.assign(Object.create(null),V)}he.to=z})(o=e.TaskFilterDTO||(e.TaskFilterDTO={}));class P{constructor(Q,z,V){this._id=z,this._task=V,b.set(this,void 0),nt(this,b,Q,"f")}get task(){return this._task}terminate(){Oe(this,b,"f").terminateTask(this)}fireDidStartProcess(Q){}fireDidEndProcess(Q){}}b=new WeakMap;var L;(function(he){function Q(z){return{id:z._id,task:void 0}}he.from=Q})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let $=class{constructor(Q,z,V,T,G,B,j,ce){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=Q.getProxy(_.MainContext.MainThreadTask),this._workspaceProvider=V,this._editorService=T,this._configurationService=G,this._terminalService=B,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=j,this._deprecationService=ce,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(Q,z,V){if(!V)return new I.Disposable(()=>{});const T=this.nextHandle();return this._handlers.set(T,{type:z,provider:V,extension:Q}),this._proxy.$registerTaskProvider(T,z),new I.Disposable(()=>{this._handlers.delete(T),this._proxy.$unregisterTaskProvider(T)})}registerTaskSystem(Q,z){this._proxy.$registerTaskSystem(Q,z)}fetchTasks(Q){return this._proxy.$fetchTasks(o.from(Q)).then(async z=>{const V=[];for(let T of z){const G=await R.to(T,this._workspaceProvider,this._providedCustomExecutions2);G&&V.push(G)}return V})}get taskExecutions(){const Q=[];return this._taskExecutions.forEach(z=>Q.push(z)),Q}terminateTask(Q){if(!(Q instanceof P))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(Q._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(Q,z,V){const T=this._providedCustomExecutions2.get(Q.id);if(T){if(this._activeCustomExecutions2.get(Q.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(Q.id,T),this._terminalService.attachPtyToTerminal(z,await T.callback(V))}this._lastStartedTask=Q.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(Q)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(Q){const z=await this.getTaskExecution(Q);this._taskExecutionPromises.delete(Q.id),this._taskExecutions.delete(Q.id),this.customExecutionComplete(Q),this._onDidTerminateTask.fire({execution:z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(Q){const z=await this.getTaskExecution(Q.id);this._onDidTaskProcessStarted.fire({execution:z,processId:Q.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(Q){const z=await this.getTaskExecution(Q.id);this._onDidTaskProcessEnded.fire({execution:z,exitCode:Q.exitCode})}$provideTasks(Q,z){const V=this._handlers.get(Q);if(!V)return Promise.reject(new Error("no handler found"));const T=[],G=(0,F.asPromise)(()=>V.provider.provideTasks(n.CancellationToken.None)).then(B=>this.provideTasksInternal(z,T,V,B));return new Promise(B=>{G.then(j=>{Promise.all(T).then(()=>{B(j)})})})}async $resolveTask(Q,z){const V=this._handlers.get(Q);if(!V)return Promise.reject(new Error("no handler found"));if(z.definition.type!==V.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${V.type}].`);const T=await R.to(z,this._workspaceProvider,this._providedCustomExecutions2);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const G=await V.provider.resolveTask(T,n.CancellationToken.None);if(!G)return;this.checkDeprecation(G,V);const B=R.from(G,V.extension);if(!B)throw new Error("Unexpected: Task cannot be resolved.");if(G.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return v.is(B.execution)&&await this.addCustomExecution(B,G,!0),await this.resolveTaskInternal(B)}nextHandle(){return this._handleCounter++}async addCustomExecution(Q,z,V){const T=await this._proxy.$createTaskId(Q);!V&&!this._providedCustomExecutions2.has(T)&&this._notProvidedCustomExecutions.add(T),this._providedCustomExecutions2.set(T,z.execution)}async getTaskExecution(Q,z){if(typeof Q=="string"){const G=this._taskExecutionPromises.get(Q);if(!G)throw new Error("Unexpected: The specified task is missing an execution");return G}let V=this._taskExecutionPromises.get(Q.id);if(V)return V;const T=new Promise(async(G,B)=>{const j=z||await R.to(Q.task,this._workspaceProvider,this._providedCustomExecutions2);j?G(new P(this,Q.id,j)):B("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(Q.id,T),T.then(G=>(this._taskExecutions.set(Q.id,G),G),G=>Promise.reject(G))}checkDeprecation(Q,z){Q._deprecated&&this._deprecationService.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(Q){this._activeCustomExecutions2.get(Q.id)&&this._activeCustomExecutions2.delete(Q.id),this._notProvidedCustomExecutions.has(Q.id)&&this._lastStartedTask!==Q.id&&(this._providedCustomExecutions2.delete(Q.id),this._notProvidedCustomExecutions.delete(Q.id));let V=this._notProvidedCustomExecutions.values(),T=V.next();for(;!T.done;)!this._activeCustomExecutions2.has(T.value)&&this._lastStartedTask!==T.value&&(this._providedCustomExecutions2.delete(T.value),this._notProvidedCustomExecutions.delete(T.value)),T=V.next()}};$=ze([qe(0,l.IExtHostRpcService),qe(1,h.IExtHostInitDataService),qe(2,S.IExtHostWorkspace),qe(3,y.IExtHostDocumentsAndEditors),qe(4,C.IExtHostConfiguration),qe(5,k.IExtHostTerminalService),qe(6,E.ILogService),qe(7,w.IExtHostApiDeprecationService)],$),e.ExtHostTaskBase=$;let re=class extends ${constructor(Q,z,V,T,G,B,j,ce){super(Q,z,V,T,G,B,j,ce);this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:f.PlatformToString(0)})}async executeTask(Q,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const V=R.from(z,Q);if(V===void 0)throw new Error("Task is not valid");if(v.is(V.execution))await this.addCustomExecution(V,z,!1);else throw new p.NotSupportedError;const T=await this.getTaskExecution(await this._proxy.$getTaskExecution(V),z);return this._proxy.$executeTask(V).catch(G=>{throw new Error(G)}),T}provideTasksInternal(Q,z,V,T){const G=[];if(T)for(let B of T){this.checkDeprecation(B,V),(!B.definition||!Q[B.definition.type])&&this._logService.warn(`The task [${B.source}, ${B.name}] uses an undefined task type. The task will be ignored in the future.`);const j=R.from(B,V.extension);j&&v.is(j.execution)?(G.push(j),z.push(this.addCustomExecution(j,B,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:G,extension:V.extension}}async resolveTaskInternal(Q){if(v.is(Q.execution))return Q;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(Q,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(Q,z,V){}};re=ze([qe(0,l.IExtHostRpcService),qe(1,h.IExtHostInitDataService),qe(2,S.IExtHostWorkspace),qe(3,y.IExtHostDocumentsAndEditors),qe(4,C.IExtHostConfiguration),qe(5,k.IExtHostTerminalService),qe(6,E.ILogService),qe(7,w.IExtHostApiDeprecationService)],re),e.WorkerExtHostTask=re,e.IExtHostTask=(0,a.createDecorator)("IExtHostTask")}),define(Ee[217],_e([0,1,17,77,27,82,22,11,14,25,8,10,2,117,138,91,44,97,216,38]),function(ee,e,m,F,D,_,I,S,y,C,n,k,l,h,a,d,f,E,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(A,R,o,P){this.configurationService=A,this.workspaceContextService=R,this.editorGroupsService=o,this.pathService=P}text(A,R,o={}){A=this.getContentPattern(A,o);const P=this.configurationService.getValue(),L=R&&R.some(re=>!this.configurationService.getValue({resource:re}).search.useRipgrep);return{...this.commonQuery(R?.map(f.toWorkspaceFolder),o),type:2,contentPattern:A,previewOptions:o.previewOptions,maxFileSize:o.maxFileSize,usePCRE2:P.search.usePCRE2||L||!1,beforeContext:o.beforeContext,afterContext:o.afterContext,userDisabledExcludesAndIgnoreFiles:o.disregardExcludeSettings&&o.disregardIgnoreFiles}}getContentPattern(A,R){const o=this.configurationService.getValue();A.isRegExp&&(A.pattern=A.pattern.replace(/\r?\n/g,"\\n"));const P={...A,wordSeparators:o.editor.wordSeparators};return this.isCaseSensitive(A,R)&&(P.isCaseSensitive=!0),this.isMultiline(A)&&(P.isMultiline=!0),P}file(A,R={}){return{...this.commonQuery(A,R),type:1,filePattern:R.filePattern?R.filePattern.trim():R.filePattern,exists:R.exists,sortByScore:R.sortByScore,cacheKey:R.cacheKey}}handleIncludeExclude(A,R){return A?(A=Array.isArray(A)?A.map(i):i(A),R?this.parseSearchPaths(A):{pattern:t(...Array.isArray(A)?A:[A])}):{}}commonQuery(A=[],R={}){const o=this.handleIncludeExclude(R.includePattern,R.expandPatterns),P=this.handleIncludeExclude(R.excludePattern,R.expandPatterns),L=A.length>1,$=(o.searchPaths&&o.searchPaths.length?o.searchPaths.map(Q=>this.getFolderQueryForSearchPath(Q,R,P)):A.map(Q=>this.getFolderQueryForRoot(Q,R,P,L))).filter(Q=>!!Q),re={_reason:R._reason,folderQueries:$,usingSearchPaths:!!(o.searchPaths&&o.searchPaths.length),extraFileResources:R.extraFileResources,excludePattern:P.pattern,includePattern:o.pattern,onlyOpenEditors:R.onlyOpenEditors,maxResults:R.maxResults};if(R.onlyOpenEditors){const z=m.coalesce(m.flatten(this.editorGroupsService.groups.map(T=>T.editors.map(G=>G.resource)))).filter(T=>(0,u.pathIncludedInQuery)(re,T.fsPath)),V=this.commonQueryFromFileList(z);return{...re,...V}}const he=R.extraFileResources&&R.extraFileResources.filter(Q=>(0,u.pathIncludedInQuery)(re,Q.fsPath));return re.extraFileResources=he&&he.length?he:void 0,re}commonQueryFromFileList(A){const R=[],o=new I.ResourceMap,P={};let L=!1;return A.forEach($=>{if($.scheme===S.Schemas.walkThrough)return;if((0,C.isAbsolutePath)($)){const he=this.workspaceContextService.getWorkspaceFolder($)?.uri??$.with({path:y.dirname($.fsPath)});let Q=o.get(he);Q||(L=!0,Q={folder:he,includePattern:{}},R.push(Q),o.set(he,Q));const z=y.relative(he.fsPath,$.fsPath);(0,k.assertIsDefined)(Q.includePattern)[z.replace(/\\/g,"/")]=!0}else $.fsPath&&(L=!0,P[$.fsPath]=!0)}),{folderQueries:R,includePattern:P,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(A,R){if(R.isSmartCase){if(A.isRegExp){if(n.containsUppercaseCharacter(A.pattern,!0))return!0}else if(n.containsUppercaseCharacter(A.pattern))return!0}return!!A.isCaseSensitive}isMultiline(A){return A.isMultiline||A.isRegExp&&(0,h.isMultilineRegexSource)(A.pattern)||A.pattern.indexOf(`
`)>=0?!0:!!A.isMultiline}parseSearchPaths(A){const R=V=>y.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),P=(Array.isArray(A)?A:s(A)).map(V=>{const T=this.pathService.resolvedUserHome;return T?(0,_.untildify)(V,T.scheme===S.Schemas.file?T.fsPath:T.path):V}),L=F.groupBy(P,V=>R(V)?"searchPaths":"exprSegments"),$=(L.exprSegments||[]).map(V=>n.rtrim(V,"/")).map(V=>n.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),r(V))),re={},he=this.expandSearchPathPatterns(L.searchPaths||[]);he&&he.length&&(re.searchPaths=he);const Q=m.flatten($),z=t(...Q);return z&&(re.pattern=z),re}getExcludesForFolder(A,R){return R.disregardExcludeSettings?void 0:(0,u.getExcludes)(A,!R.disregardSearchExcludeSettings)}expandSearchPathPatterns(A){if(!A||!A.length)return[];const R=m.flatten(A.map(P=>{let{pathPortion:L,globPortion:$}=b(P);$&&($=c($));const re=this.expandOneSearchPath(L);return m.flatten(re.map(he=>this.resolveOneSearchPathPattern(he,$)))})),o=new Map;return R.forEach(P=>{const L=P.searchPath.toString(),$=o.get(L);$?P.pattern&&($.pattern=$.pattern||{},$.pattern[P.pattern]=!0):o.set(L,{searchPath:P.searchPath,pattern:P.pattern?t(P.pattern):void 0})}),Array.from(o.values())}expandOneSearchPath(A){if(y.isAbsolute(A)){const R=this.workspaceContextService.getWorkspace().folders;return R[0]&&R[0].uri.scheme!==S.Schemas.file?[{searchPath:R[0].uri.with({path:A})}]:[{searchPath:l.URI.file(y.normalize(A))}]}if(this.workspaceContextService.getWorkbenchState()===2){const R=this.workspaceContextService.getWorkspace().folders[0].uri;if(A=i(A),A.startsWith("../")||A===".."){const P=y.posix.resolve(R.path,A);return[{searchPath:R.with({path:P})}]}const o=c(A);return[{searchPath:R,pattern:o}]}else{if(A==="./"||A===".\\")return[];{const R=A.replace(/^\.[\/\\]/,""),P=this.workspaceContextService.getWorkspace().folders.map(L=>{const $=R.match(new RegExp(`^${n.escapeRegExpCharacters(L.name)}(?:/(.*)|$)`));return $?{match:$,folder:L}:null}).filter(k.isDefined);if(P.length)return P.map(L=>{const $=L.match[1];return{searchPath:L.folder.uri,pattern:$&&c($)}});{const L=A.match(/\.[\/\\](.+)[\/\\]?/),$=L?L[1]:A,re=a.localize(0,null,$);throw new Error(re)}}}}resolveOneSearchPathPattern(A,R){const o=A.pattern&&R?`${A.pattern}/${R}`:A.pattern||R,P=[{searchPath:A.searchPath,pattern:o}];return o&&!o.endsWith("**")&&P.push({searchPath:A.searchPath,pattern:o+"/**"}),P}getFolderQueryForSearchPath(A,R,o){const P=this.getFolderQueryForRoot((0,f.toWorkspaceFolder)(A.searchPath),R,o,!1);return P?{...P,includePattern:A.pattern}:null}getFolderQueryForRoot(A,R,o,P){let L;const $=l.URI.isUri(A)?A:A.uri;if(o.searchPaths){const V=o.searchPaths.filter(T=>(0,C.isEqual)(T.searchPath,$))[0];if(V&&!V.pattern)return null;V&&(L=V.pattern)}const re=this.configurationService.getValue({resource:$}),Q={...this.getExcludesForFolder(re,R)||{},...L||{}},z=l.URI.isUri(A)?(0,C.basename)(A):A.name;return{folder:$,folderName:P?z:void 0,excludePattern:Object.keys(Q).length>0?Q:void 0,fileEncoding:re.files&&re.files.encoding,disregardIgnoreFiles:typeof R.disregardIgnoreFiles=="boolean"?R.disregardIgnoreFiles:!re.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof R.disregardGlobalIgnoreFiles=="boolean"?R.disregardGlobalIgnoreFiles:!re.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof R.ignoreSymlinks=="boolean"?R.ignoreSymlinks:!re.search.followSymlinks}}};p=ze([qe(0,d.IConfigurationService),qe(1,f.IWorkspaceContextService),qe(2,E.IEditorGroupsService),qe(3,w.IPathService)],p),e.QueryBuilder=p;function b(v){const A=v.match(/[\*\{\}\(\)\[\]\?]/);if(A){const R=A.index,o=v.substr(0,R).match(/[/|\\][^/\\]*$/);if(o){let P=v.substr(0,o.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:v.substr((o.index||0)+1)}}}return{pathPortion:v}}function t(...v){return v.length?v.reduce((A,R)=>(A[R]=!0,A),Object.create(null)):void 0}function s(v){return D.splitGlobAware(v,",").map(A=>A.trim()).filter(A=>!!A.length)}function r(v){return[`**/${v}/**`,`**/${v}`].map(R=>R.replace(/\*\*\/\*\*/g,"**"))}function i(v){return v.replace(/\\/g,"/")}function c(v){return i(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function g(v,A){v=m.distinct(v,P=>P.toString());const R=[],o=A.getWorkspace();return v&&v.forEach(P=>{let L;if(A.getWorkbenchState()===2)L=(0,C.relativePath)(o.folders[0].uri,P),L&&L!=="."&&(L="./"+L);else{const $=A.getWorkspaceFolder(P);if($){const re=$.name;if(o.folders.filter(Q=>Q.name===re).length===1){const Q=(0,C.relativePath)($.uri,P);Q===""?L=`./${$.name}`:L=`./${$.name}/${Q}`}else L=P.fsPath}}L&&R.push(L)}),R}e.resolveResourcesForSearchIncludes=g}),define(Ee[218],_e([0,1,25,2,18,12,4,217,38,44]),function(ee,e,m,F,D,_,I,S,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function k(d,f){const E=f.activationEvents;if(!E)return Promise.resolve(void 0);const w=[],u=[];for(const i of E)if(/^workspaceContains:/.test(i)){const c=i.substr("workspaceContains:".length);c.indexOf("*")>=0||c.indexOf("?")>=0||d.forceUsingSearch?u.push(c):w.push(c)}if(w.length===0&&u.length===0)return Promise.resolve(void 0);let p;const b=new Promise((i,c)=>{p=i}),t=i=>p({activationEvent:i}),s=Promise.all(w.map(i=>l(d,i,t))).then(()=>{}),r=h(d,f.identifier,u,t);return Promise.all([s,r]).then(()=>{p(void 0)}),b}e.checkActivateWorkspaceContainsExtension=k;async function l(d,f,E){for(const w of d.folders)if(await d.exists(m.joinPath(F.URI.revive(w),f))){E(`workspaceContains:${f}`);return}}async function h(d,f,E,w){if(E.length===0)return Promise.resolve(void 0);const u=new D.CancellationTokenSource,p=d.checkExists(d.folders,E,u.token),b=setTimeout(async()=>{u.cancel(),w(`workspaceContainsTimeout:${E.join(",")}`)},n);let t=!1;try{t=await p}catch(s){_.isPromiseCanceledError(s)||_.onUnexpectedError(s)}u.dispose(),clearTimeout(b),t&&w(`workspaceContains:${E.join(",")}`)}function a(d,f,E,w){const u=d.get(I.IInstantiationService),p=d.get(y.ISearchService),t=u.createInstance(S.QueryBuilder).file(f.map(s=>(0,C.toWorkspaceFolder)(F.URI.revive(s))),{_reason:"checkExists",includePattern:E,exists:!0});return p.fileSearch(t,w).then(s=>!!s.limitHit,s=>_.isPromiseCanceledError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=a});var nt=this&&this.__classPrivateFieldSet||function(ee,e,m,F,D){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!D:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?D.call(ee,m):D?D.value=m:e.set(ee,m),m},Oe=this&&this.__classPrivateFieldGet||function(ee,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(ee):F?F.value:e.get(ee)};define(Ee[34],_e([0,1,130,14,76,25,16,7,22,2,15,5,33,181,74,32,29,179,12,26,23,158,6,92,4,28,75,13,61,66,37,3,218,70,160]),function(ee,e,m,F,D,_,I,S,y,C,n,k,l,h,a,d,f,E,w,u,p,b,t,s,r,i,c,g,v,A,R,o,P,L,$){"use strict";var re,he,Q;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let z=class $n extends S.Disposable{constructor(B,j,ce,W,te,ue,ye,Te,Re,$e){super();this._onDidChangeRemoteConnectionData=this._register(new o.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=j,this._extHostContext=ce,this._initData=ye,this._extHostWorkspace=W,this._extHostConfiguration=te,this._logService=ue,this._extHostTunnelService=Re,this._extHostTerminalService=$e,this._disposables=new S.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new I.Barrier,this._readyToStartExtensionHost=new I.Barrier,this._readyToRunExtensions=new I.Barrier,this._eagerExtensionsActivated=new I.Barrier,this._registry=new E.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new L.ExtHostSecretState(this._extHostContext),this._storagePath=Te,this._instaService=B.createChild(new v.ServiceCollection([a.IExtHostStorage,this._storage],[L.IExtHostSecretState,this._secretState]));const Ze=new Set;this._initData.hostExtensions.forEach(Ve=>Ze.add(u.ExtensionIdentifier.toKey(Ve))),this._activator=new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ve,je,O)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ve,w.transformErrorForSerialization(je),O)},actualActivateExtension:async(Ve,je)=>{if(Ze.has(u.ExtensionIdentifier.toKey(Ve)))return await this._mainThreadExtensionsProxy.$activateExtension(Ve,je),new h.HostExtension;const O=this._registry.getExtensionDescription(Ve);return this._activateExtension(O,je)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(B){w.onUnexpectedError(B)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let B=[];try{B=this._registry.getAllExtensionDescriptions().map(te=>te.identifier).filter(te=>this.isActivated(te)).map(te=>this._deactivate(te))}catch(j){}await Promise.all(B)}isActivated(B){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(B):!1}_activateByEvent(B,j){return this._activator.activateByEvent(B,j)}_activateById(B,j){return this._activator.activateById(B,j)}activateByIdWithErrors(B,j){return this._activateById(B,j).then(()=>{const ce=this._activator.getActivatedExtension(B);if(ce.activationFailed)return Promise.reject(ce.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(B=>this._registry)}getExtensionExports(B){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(B).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const B=y.TernarySearchTree.forPaths(),j=this._registry.getAllExtensionDescriptions().map(ce=>{if(!!this._getEntryPoint(ce))return this._hostUtils.realpath(ce.extensionLocation.fsPath).then(W=>B.set(C.URI.file(W).fsPath,ce))});this._extensionPathIndex=Promise.all(j).then(()=>B)}return this._extensionPathIndex}_deactivate(B){let j=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(B))return j;const ce=this._activator.getActivatedExtension(B);if(!ce)return j;try{typeof ce.module.deactivate=="function"&&(j=Promise.resolve(ce.module.deactivate()).then(void 0,W=>(this._logService.error(W),Promise.resolve(void 0))))}catch(W){this._logService.error(W)}try{(0,S.dispose)(ce.subscriptions)}catch(W){this._logService.error(W)}return j}async _activateExtension(B,j){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(B.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(B.identifier),this._doActivateExtension(B,j).then(ce=>{const W=ce.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(B.identifier,W.codeLoadingTime,W.activateCallTime,W.activateResolvedTime,j),this._logExtensionActivationTimes(B,j,"success",W),ce},ce=>{throw this._logExtensionActivationTimes(B,j,"failure"),ce})}_logExtensionActivationTimes(B,j,ce,W){const te=V(B,j);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...te,...W||{},outcome:ce})}_doActivateExtension(B,j){const ce=V(B,j);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ce);const W=this._getEntryPoint(B);if(!W)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${B.identifier.value} ${JSON.stringify(j)}`),this._logService.flush();const te=new h.ExtensionActivationTimesBuilder(j.startup);return Promise.all([this._loadCommonJSModule(B.identifier,(0,_.joinPath)(B.extensionLocation,W),te),this._loadExtensionContext(B)]).then(ue=>(D.mark(`code/extHost/willActivateExtension/${B.identifier.value}`),$n._callActivate(this._logService,B.identifier,ue[0],ue[1],te))).then(ue=>(D.mark(`code/extHost/didActivateExtension/${B.identifier.value}`),ue))}_loadExtensionContext(B){const j=new b.ExtensionGlobalMemento(B,this._storage),ce=new b.ExtensionMemento(B.identifier.value,!1,this._storage),W=new $.ExtensionSecrets(B,this._secretState),te=B.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ue=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${B.identifier.value}`),Promise.all([j.whenReady,ce.whenReady,this._storagePath.whenReady]).then(()=>{const ye=this;let Te;return Object.freeze({globalState:j,workspaceState:ce,secrets:W,subscriptions:[],get extensionUri(){return B.extensionLocation},get extensionPath(){return B.extensionLocation.fsPath},asAbsolutePath(Re){return F.join(B.extensionLocation.fsPath,Re)},get storagePath(){return ye._storagePath.workspaceValue(B)?.fsPath},get globalStoragePath(){return ye._storagePath.globalValue(B).fsPath},get logPath(){return F.join(ye._initData.logsLocation.fsPath,B.identifier.value)},get logUri(){return C.URI.joinPath(ye._initData.logsLocation,B.identifier.value)},get storageUri(){return ye._storagePath.workspaceValue(B)},get globalStorageUri(){return ye._storagePath.globalValue(B)},get extensionMode(){return te},get extension(){return Te===void 0&&(Te=new T(ye,B.identifier,B,ue)),Te},get extensionRuntime(){return(0,f.checkProposedApiEnabled)(B),ye.extensionRuntime},get environmentVariableCollection(){return ye._extHostTerminalService.getEnvironmentVariableCollection(B)}})})}static _callActivate(B,j,ce,W,te){return ce=ce||{activate:void 0,deactivate:void 0},this._callActivateOptional(B,j,ce,W,te).then(ue=>new h.ActivatedExtension(!1,null,te.build(),ce,ue,W.subscriptions))}static _callActivateOptional(B,j,ce,W,te){if(typeof ce.activate=="function")try{te.activateCallStart(),B.trace(`ExtensionService#_callActivateOptional ${j.value}`);const ue=typeof global=="object"?global:self,ye=ce.activate.apply(ue,[W]);return te.activateCallStop(),te.activateResolveStart(),Promise.resolve(ye).then(Te=>(te.activateResolveStop(),Te))}catch(ue){return Promise.reject(ue)}else return Promise.resolve(ce)}_activateOneStartupFinished(B,j){this._activateById(B.identifier,{startup:!1,extensionId:B.identifier,activationEvent:j}).then(void 0,ce=>{this._logService.error(ce)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks());for(const B of this._registry.getAllExtensionDescriptions())if(B.activationEvents)for(const j of B.activationEvents)j==="onStartupFinished"&&this._activateOneStartupFinished(B,j)}_handleEagerExtensions(){const B=this._activateByEvent("*",!0).then(void 0,te=>{this._logService.error(te)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(te=>this._handleWorkspaceContainsEagerExtensions(te.added)));const j=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ce=this._handleWorkspaceContainsEagerExtensions(j),W=Promise.all([B,ce]).then(()=>{});return Promise.race([W,(0,I.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),W}_handleWorkspaceContainsEagerExtensions(B){return B.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(j=>this._handleWorkspaceContainsEagerExtension(B,j))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(B,j){if(this.isActivated(j.identifier))return;const ce=!this._initData.remote.isRemote&&!!this._initData.remote.authority,W={folders:B.map(ue=>ue.uri),forceUsingSearch:ce,exists:ue=>this._hostUtils.exists(ue.fsPath),checkExists:(ue,ye,Te)=>this._mainThreadWorkspaceProxy.$checkExists(ue,ye,Te)},te=await(0,P.checkActivateWorkspaceContainsExtension)(W,j);if(!!te)return this._activateById(j.identifier,{startup:!0,extensionId:j.identifier,activationEvent:te.activationEvent}).then(void 0,ue=>this._logService.error(ue))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(B){throw console.error(B),B}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:B,extensionTestsLocationURI:j}=this._initData.environment;if(!B||!j)throw new Error(m.localize(0,null));const ce=await this._loadCommonJSModule(null,j,new h.ExtensionActivationTimesBuilder(!1));if(!ce||typeof ce.run!="function")throw new Error(m.localize(1,null,j.toString()));return new Promise((W,te)=>{const ue=(Re,$e)=>{Re?te(Re):W(typeof $e=="number"&&$e>0?1:0)},ye=(0,_.originalFSPath)(j),Te=ce.run(ye,ue);Te&&Te.then&&Te.then(()=>{W(0)}).catch(Re=>{te(Re.toString())})})}async $extensionTestsExit(B){this._logService.info(`extension host terminating: test runner requested exit with code ${B}`),this._logService.info(`exiting with code ${B}`),this._logService.flush(),this._hostUtils.exit(B)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(B,j){return this._resolvers[B]=j,(0,S.toDisposable)(()=>{delete this._resolvers[B]})}async _activateAndGetResolver(B){const j=B.indexOf("+");if(j===-1)throw new Error("Not an authority that can be resolved!");const ce=B.substr(0,j);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ce}`,!1),{authorityPrefix:ce,resolver:this._resolvers[ce]}}async $resolveAuthority(B,j){const{authorityPrefix:ce,resolver:W}=await this._activateAndGetResolver(B);if(!W)return{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ce}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(W)),D.mark(`code/extHost/willResolveAuthority/${ce}`);const te=await W.resolve(B,{resolveAttempt:j});D.mark(`code/extHost/didResolveAuthorityOK/${ce}`);const ue={authority:B,host:te.host,port:te.port,connectionToken:te.connectionToken},ye={extensionHostEnv:te.extensionHostEnv,isTrusted:te.isTrusted};return{type:"ok",value:{authority:ue,options:ye,tunnelInformation:{environmentTunnels:te.environmentTunnels}}}}catch(te){if(D.mark(`code/extHost/didResolveAuthorityError/${ce}`),te instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:te._code,message:te._message,detail:te._detail}};throw te}}async $getCanonicalURI(B,j){const{authorityPrefix:ce,resolver:W}=await this._activateAndGetResolver(B);if(!W)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ce}`);const te=C.URI.revive(j);if(typeof W.getCanonicalURI=="undefined")return te;const ue=await(0,I.asPromise)(()=>W.getCanonicalURI(te));return ue||te}$startExtensionHost(B){return this._registry.keepOnly(B),this._startExtensionHost()}$activateByEvent(B,j){return j===1?this._activateByEvent(B,!1):this._readyToRunExtensions.wait().then(ce=>this._activateByEvent(B,!1))}async $activate(B,j){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(B)?(await this._activateById(B,j),!0):!1}async $deltaExtensions(B,j){B.forEach(W=>W.extensionLocation=C.URI.revive(W.extensionLocation));const ce=await this.getExtensionPathIndex();return await Promise.all(j.map(async W=>{const te=this._registry.getExtensionDescription(W);if(!te)return;const ue=await this._hostUtils.realpath(te.extensionLocation.fsPath);ce.delete(C.URI.file(ue).fsPath)})),await Promise.all(B.map(async W=>{const te=await this._hostUtils.realpath(W.extensionLocation.fsPath);ce.set(C.URI.file(te).fsPath,W)})),this._registry.deltaExtensions(B,j),Promise.resolve(void 0)}async $test_latency(B){return B}async $test_up(B){return B.byteLength}async $test_down(B){let j=p.VSBuffer.alloc(B),ce=Math.random()%256;for(let W=0;W<B;W++)j.writeUInt8(ce,W);return j}async $updateRemoteConnectionData(B){this._remoteConnectionData=B,this._onDidChangeRemoteConnectionData.fire()}};z=ze([qe(0,r.IInstantiationService),qe(1,e.IHostUtils),qe(2,g.IExtHostRpcService),qe(3,d.IExtHostWorkspace),qe(4,l.IExtHostConfiguration),qe(5,n.ILogService),qe(6,i.IExtHostInitDataService),qe(7,c.IExtensionStoragePaths),qe(8,A.IExtHostTunnelService),qe(9,R.IExtHostTerminalService)],z),e.AbstractExtHostExtensionService=z;function V(G,B){return{id:G.identifier.value,name:G.name,extensionVersion:G.version,publisherDisplayName:G.publisher,activationEvents:G.activationEvents?G.activationEvents.join(","):null,isBuiltin:G.isBuiltin,reason:B.activationEvent,reasonId:B.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class T{constructor(B,j,ce,W){re.set(this,void 0),he.set(this,void 0),Q.set(this,void 0),nt(this,re,B,"f"),nt(this,he,j,"f"),nt(this,Q,ce.identifier,"f"),this.id=ce.identifier.value,this.extensionUri=ce.extensionLocation,this.extensionPath=F.normalize((0,_.originalFSPath)(ce.extensionLocation)),this.packageJSON=ce,this.extensionKind=W}get isActive(){return Oe(this,re,"f").isActivated(Oe(this,Q,"f"))}get exports(){if(this.packageJSON.api!=="none")return Oe(this,re,"f").getExtensionExports(Oe(this,Q,"f"))}activate(){return Oe(this,re,"f").activateByIdWithErrors(Oe(this,Q,"f"),{startup:!1,extensionId:Oe(this,he,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=T,re=new WeakMap,he=new WeakMap,Q=new WeakMap}),define(Ee[106],_e([0,1,14,2,3,16,5,6,166,32,34,46,170,33,167,13,4,10,40,64]),function(ee,e,m,F,D,_,I,S,y,C,n,k,l,h,a,d,f,E,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,f.createDecorator)("IExtHostDebugService");let p=class{constructor(v,A,R,o,P,L){this._workspaceService=A,this._extensionService=R,this._editorsService=o,this._configurationService=P,this._editorTabs=L,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new D.Emitter,this._onDidTerminateDebugSession=new D.Emitter,this._onDidChangeActiveDebugSession=new D.Emitter,this._onDidReceiveDebugSessionCustomEvent=new D.Emitter,this._debugServiceProxy=v.getProxy(I.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new D.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then($=>{$.onDidChange(re=>{this.registerAllDebugTypes($)}),this.registerAllDebugTypes($)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(v,A){const R=v;if(typeof R.sourceReference=="number"&&R.sourceReference>0){let o=`debug:${encodeURIComponent(R.path||"")}`,P="?";return A&&(o+=`${P}session=${encodeURIComponent(A.id)}`,P="&"),o+=`${P}ref=${R.sourceReference}`,F.URI.parse(o)}else{if(R.path)return F.URI.file(R.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(v){const A=[];for(const R of v.getAllExtensionDescriptions())if(R.contributes){const o=R.contributes.debuggers;if(o&&o.length>0)for(const P of o)(0,a.isDebuggerMainContribution)(P)&&A.push(P.type)}this._debugServiceProxy.$registerDebugTypes(A)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const v=[];return this._breakpoints.forEach(A=>v.push(A)),v}addBreakpoints(v){this.startBreakpoints();const A=v.filter(P=>{const L=P.id;return this._breakpoints.has(L)?!1:(this._breakpoints.set(L,P),!0)});this.fireBreakpointChanges(A,[],[]);const R=[],o=new Map;for(const P of A)if(P instanceof S.SourceBreakpoint){let L=o.get(P.location.uri.toString());L||(L={type:"sourceMulti",uri:P.location.uri,lines:[]},o.set(P.location.uri.toString(),L),R.push(L)),L.lines.push({id:P.id,enabled:P.enabled,condition:P.condition,hitCondition:P.hitCondition,logMessage:P.logMessage,line:P.location.range.start.line,character:P.location.range.start.character})}else P instanceof S.FunctionBreakpoint&&R.push({type:"function",id:P.id,enabled:P.enabled,hitCondition:P.hitCondition,logMessage:P.logMessage,condition:P.condition,functionName:P.functionName});return this._debugServiceProxy.$registerBreakpoints(R)}removeBreakpoints(v){this.startBreakpoints();const A=v.filter(L=>this._breakpoints.delete(L.id));this.fireBreakpointChanges([],A,[]);const R=A.filter(L=>L instanceof S.SourceBreakpoint).map(L=>L.id),o=A.filter(L=>L instanceof S.FunctionBreakpoint).map(L=>L.id),P=A.filter(L=>L instanceof S.DataBreakpoint).map(L=>L.id);return this._debugServiceProxy.$unregisterBreakpoints(R,o,P)}startDebugging(v,A,R){return this._debugServiceProxy.$startDebugging(v?v.uri:void 0,A,{parentSessionID:R.parentSession?R.parentSession.id:void 0,repl:R.consoleMode===S.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:R.noDebug,compact:R.compact})}stopDebugging(v){return this._debugServiceProxy.$stopDebugging(v?v.id:void 0)}registerDebugConfigurationProvider(v,A,R){if(!A)return new S.Disposable(()=>{});const o=this._configProviderHandleCounter++;return this._configProviders.push({type:v,handle:o,provider:A}),this._debugServiceProxy.$registerDebugConfigurationProvider(v,R,!!A.provideDebugConfigurations,!!A.resolveDebugConfiguration,!!A.resolveDebugConfigurationWithSubstitutedVariables,o),new S.Disposable(()=>{this._configProviders=this._configProviders.filter(P=>P.provider!==A),this._debugServiceProxy.$unregisterDebugConfigurationProvider(o)})}registerDebugAdapterDescriptorFactory(v,A,R){if(!R)return new S.Disposable(()=>{});if(!this.definesDebugType(v,A))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${A}' debugger.`);if(this.getAdapterDescriptorFactoryByType(A))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const o=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:A,handle:o,factory:R}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(A,o),new S.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(P=>P.factory!==R),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(o)})}registerDebugAdapterTrackerFactory(v,A){if(!A)return new S.Disposable(()=>{});const R=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:v,handle:R,factory:A}),new S.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(o=>o.factory!==A)})}async $runInTerminal(v,A){return Promise.resolve(void 0)}async $substituteVariables(v,A){if(!this._variableResolver){const[P,L]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(P||[],this._editorsService,L)}let R;const o=await this.getFolder(v);return o&&(R={uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(R,A)}createDebugAdapter(v,A){if(v.type==="implementation")return new i(v.implementation)}createSignService(){}async $startDASession(v,A){const R=this,o=await this.getSession(A);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(o.type),o).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}' (extension might have failed to activate)`);const L=this.convertToDto(P),$=this.createDebugAdapter(L,o);if(!$)throw new Error(`Couldn't create a debug adapter for type '${o.type}'.`);const re=$;return this._debugAdapters.set(v,re),this.getDebugAdapterTrackers(o).then(he=>(he&&this._debugAdaptersTrackers.set(v,he),re.onMessage(async Q=>{if(Q.type==="request"&&Q.command==="handshake"){const z=Q,V={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const T=await this._signService.sign(z.arguments.value);V.body={signature:T},re.sendResponse(V)}else throw new Error("no signer")}catch(T){V.success=!1,V.message=T.message,re.sendResponse(V)}}else he&&he.onDidSendMessage&&he.onDidSendMessage(Q),Q=(0,a.convertToVSCPaths)(Q,!0),R._debugServiceProxy.$acceptDAMessage(v,Q)}),re.onError(Q=>{he&&he.onError&&he.onError(Q),this._debugServiceProxy.$acceptDAError(v,Q.name,Q.message,Q.stack)}),re.onExit(Q=>{he&&he.onExit&&he.onExit((0,E.withNullAsUndefined)(Q),void 0),this._debugServiceProxy.$acceptDAExit(v,(0,E.withNullAsUndefined)(Q),void 0)}),he&&he.onWillStartSession&&he.onWillStartSession(),re.startSession()))})}$sendDAMessage(v,A){A=(0,a.convertToDAPaths)(A,!1);const R=this._debugAdaptersTrackers.get(v);R&&R.onWillReceiveMessage&&R.onWillReceiveMessage(A);const o=this._debugAdapters.get(v);o&&o.sendMessage(A)}$stopDASession(v){const A=this._debugAdaptersTrackers.get(v);this._debugAdaptersTrackers.delete(v),A&&A.onWillStopSession&&A.onWillStopSession();const R=this._debugAdapters.get(v);return this._debugAdapters.delete(v),R?R.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(v){const A=[],R=[],o=[];if(v.added)for(const P of v.added){const L=P.id;if(L&&!this._breakpoints.has(L)){let $;if(P.type==="function")$=new S.FunctionBreakpoint(P.functionName,P.enabled,P.condition,P.hitCondition,P.logMessage);else if(P.type==="data")$=new S.DataBreakpoint(P.label,P.dataId,P.canPersist,P.enabled,P.hitCondition,P.condition,P.logMessage);else{const re=F.URI.revive(P.uri);$=new S.SourceBreakpoint(new S.Location(re,new S.Position(P.line,P.character)),P.enabled,P.condition,P.hitCondition,P.logMessage)}$._id=L,this._breakpoints.set(L,$),A.push($)}}if(v.removed)for(const P of v.removed){const L=this._breakpoints.get(P);L&&(this._breakpoints.delete(P),R.push(L))}if(v.changed){for(const P of v.changed)if(P.id){const L=this._breakpoints.get(P.id);if(L){if(L instanceof S.FunctionBreakpoint&&P.type==="function"){const $=L;$.enabled=P.enabled,$.condition=P.condition,$.hitCondition=P.hitCondition,$.logMessage=P.logMessage,$.functionName=P.functionName}else if(L instanceof S.SourceBreakpoint&&P.type==="source"){const $=L;$.enabled=P.enabled,$.condition=P.condition,$.hitCondition=P.hitCondition,$.logMessage=P.logMessage,$.location=new S.Location(F.URI.revive(P.uri),new S.Position(P.line,P.character))}o.push(L)}}}this.fireBreakpointChanges(A,R,o)}$provideDebugConfigurations(v,A,R){return(0,_.asPromise)(async()=>{const o=this.getConfigProviderByHandle(v);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const P=await this.getFolder(A);return o.provideDebugConfigurations(P,R)}).then(o=>{if(!o)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return o})}$resolveDebugConfiguration(v,A,R,o){return(0,_.asPromise)(async()=>{const P=this.getConfigProviderByHandle(v);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.getFolder(A);return P.resolveDebugConfiguration(L,R,o)})}$resolveDebugConfigurationWithSubstitutedVariables(v,A,R,o){return(0,_.asPromise)(async()=>{const P=this.getConfigProviderByHandle(v);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.getFolder(A);return P.resolveDebugConfigurationWithSubstitutedVariables(L,R,o)})}async $provideDebugAdapter(v,A){const R=this.getAdapterDescriptorFactoryByHandle(v);if(!R)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const o=await this.getSession(A);return this.getAdapterDescriptor(R,o).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}'`);return this.convertToDto(P)})}async $acceptDebugSessionStarted(v){const A=await this.getSession(v);this._onDidStartDebugSession.fire(A)}async $acceptDebugSessionTerminated(v){const A=await this.getSession(v);A&&(this._onDidTerminateDebugSession.fire(A),this._debugSessions.delete(A.id))}async $acceptDebugSessionActiveChanged(v){this._activeDebugSession=v?await this.getSession(v):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(v,A){const R=await this.getSession(v);R&&R._acceptNameChanged(A)}async $acceptDebugSessionCustomEvent(v,A){const o={session:await this.getSession(v),event:A.event,body:A.body};this._onDidReceiveDebugSessionCustomEvent.fire(o)}convertToDto(v){if(v instanceof S.DebugAdapterExecutable)return{type:"executable",command:v.command,args:v.args,options:v.options};if(v instanceof S.DebugAdapterServer)return{type:"server",port:v.port,host:v.host};if(v instanceof S.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:v.path};if(v instanceof S.DebugAdapterInlineImplementation)return{type:"implementation",implementation:v.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(v){const A=this._adapterFactories.filter(R=>R.type===v);if(A.length>0)return A[0].factory}getAdapterDescriptorFactoryByHandle(v){const A=this._adapterFactories.filter(R=>R.handle===v);if(A.length>0)return A[0].factory}getConfigProviderByHandle(v){const A=this._configProviders.filter(R=>R.handle===v);if(A.length>0)return A[0].provider}definesDebugType(v,A){if(v.contributes){const R=v.contributes.debuggers;if(R&&R.length>0){for(const o of R)if(o.label&&o.type&&o.type===A)return!0}}return!1}getDebugAdapterTrackers(v){const R=v.configuration.type,o=this._trackerFactories.filter(P=>P.type===R||P.type==="*").map(P=>(0,_.asPromise)(()=>P.factory.createDebugAdapterTracker(v)).then(L=>L,L=>null));return Promise.race([Promise.all(o).then(P=>{const L=P.filter($=>!!$);if(L.length>0)return new r(L)}),new Promise((P,L)=>{const $=setTimeout(()=>{clearTimeout($),L(new Error("timeout"))},1e3)})]).catch(P=>{})}async getAdapterDescriptor(v,A){const R=A.configuration.debugServer;if(typeof R=="number")return Promise.resolve(new S.DebugAdapterServer(R));if(v){const P=await this._extensionService.getExtensionRegistry();return(0,_.asPromise)(()=>v.createDebugAdapterDescriptor(A,this.daExecutableFromPackage(A,P))).then(L=>{if(L)return L})}const o=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(A,o))}daExecutableFromPackage(v,A){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(v,A,R){(v.length>0||A.length>0||R.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:v,removed:A,changed:R}))}async getSession(v){if(v)if(typeof v=="string"){const A=this._debugSessions.get(v);if(A)return A}else{let A=this._debugSessions.get(v.id);if(!A){const R=await this.getFolder(v.folderUri),o=v.parent?this._debugSessions.get(v.parent):void 0;A=new b(this._debugServiceProxy,v.id,v.type,v.name,R,v.configuration,o),this._debugSessions.set(A.id,A),this._debugServiceProxy.$sessionCached(A.id)}return A}throw new Error("cannot find session")}getFolder(v){if(v){const A=F.URI.revive(v);return this._workspaceService.resolveWorkspaceFolder(A)}return Promise.resolve(void 0)}};p=ze([qe(0,d.IExtHostRpcService),qe(1,C.IExtHostWorkspace),qe(2,n.IExtHostExtensionService),qe(3,k.IExtHostDocumentsAndEditors),qe(4,h.IExtHostConfiguration),qe(5,u.IExtHostEditorTabs)],p),e.ExtHostDebugServiceBase=p;class b{constructor(v,A,R,o,P,L,$){this._debugServiceProxy=v,this._id=A,this._type=R,this._name=o,this._workspaceFolder=P,this._configuration=L,this._parentSession=$}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(v){this._name=v,this._debugServiceProxy.$setDebugSessionName(this._id,v)}get parentSession(){return this._parentSession}_acceptNameChanged(v){this._name=v}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(v,A){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,v,A)}getDebugProtocolBreakpoint(v){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,v.id)}}e.ExtHostDebugSession=b;class t{constructor(v){this.value=Object.freeze({append(A){v.$appendDebugConsole(A)},appendLine(A){this.append(A+`
`)}})}}e.ExtHostDebugConsole=t;class s extends l.AbstractVariableResolverService{constructor(v,A,R,o,P){function L(){if(A){const $=A.activeEditor();if($)return $.document.uri;const re=o.tabs.filter(he=>he.isActive);if(re.length>0)return re[0].resource}}super({getFolderUri:$=>{const re=v.filter(he=>he.name===$);if(re&&re.length>0)return re[0].uri},getWorkspaceFolderCount:()=>v.length,getConfigurationValue:($,re)=>R.getConfiguration(void 0,$).get(re),getAppRoot:()=>w.cwd(),getExecPath:()=>w.env.VSCODE_EXEC_PATH,getFilePath:()=>{const $=L();if($)return m.normalize($.fsPath)},getWorkspaceFolderPathForFile:()=>{if(P){const $=L();if($){const re=P.getWorkspaceFolder($);if(re)return m.normalize(re.uri.fsPath)}}},getSelectedText:()=>{if(A){const $=A.activeEditor();if($&&!$.selection.isEmpty)return $.document.getText($.selection)}},getLineNumber:()=>{if(A){const $=A.activeEditor();if($)return String($.selection.end.line+1)}}},void 0,Promise.resolve(w.env))}}e.ExtHostVariableResolverService=s;class r{constructor(v){this.trackers=v}onWillStartSession(){this.trackers.forEach(v=>v.onWillStartSession?v.onWillStartSession():void 0)}onWillReceiveMessage(v){this.trackers.forEach(A=>A.onWillReceiveMessage?A.onWillReceiveMessage(v):void 0)}onDidSendMessage(v){this.trackers.forEach(A=>A.onDidSendMessage?A.onDidSendMessage(v):void 0)}onWillStopSession(){this.trackers.forEach(v=>v.onWillStopSession?v.onWillStopSession():void 0)}onError(v){this.trackers.forEach(A=>A.onError?A.onError(v):void 0)}onExit(v,A){this.trackers.forEach(R=>R.onExit?R.onExit(v,A):void 0)}}class i extends y.AbstractDebugAdapter{constructor(v){super();this.implementation=v,v.onDidSendMessage(A=>{this.acceptMessage(A)})}startSession(){return Promise.resolve(void 0)}sendMessage(v){this.implementation.handleMessage(v)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let c=class extends p{constructor(v,A,R,o,P,L){super(v,A,R,o,P,L)}createVariableResolver(v,A,R){return new s(v,A,R,this._editorTabs)}};c=ze([qe(0,d.IExtHostRpcService),qe(1,C.IExtHostWorkspace),qe(2,n.IExtHostExtensionService),qe(3,k.IExtHostDocumentsAndEditors),qe(4,h.IExtHostConfiguration),qe(5,u.IExtHostEditorTabs)],c),e.WorkerExtHostDebugService=c}),define(Ee[219],_e([0,1,76,2,5,33,29,26,13,28,4,34,40,15]),function(ee,e,m,F,D,_,I,S,y,C,n,k,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(u,p,b,t,s,r,i){this._apiFactory=u,this._extensionRegistry=p,this._instaService=b,this._extHostConfiguration=t,this._extHostExtensionService=s,this._initData=r,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),m.mark("code/extHost/willWaitForConfig");const u=await this._extHostConfiguration.getConfigProvider();m.mark("code/extHost/didWaitForConfig");const p=await this._extHostExtensionService.getExtensionPathIndex();this.register(new d(this._apiFactory,p,this._extensionRegistry,u,this._logService)),this.register(this._instaService.createInstance(f)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(E,p,this._initData.environment.appUriScheme))}register(u){if(Array.isArray(u.nodeModuleName))for(let p of u.nodeModuleName)this._factories.set(p,u);else this._factories.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this._alternatives.push(p=>u.alternativeModuleName(p))}};a=ze([qe(2,n.IInstantiationService),qe(3,_.IExtHostConfiguration),qe(4,k.IExtHostExtensionService),qe(5,C.IExtHostInitDataService),qe(6,h.ILogService)],a),e.RequireInterceptor=a;class d{constructor(u,p,b,t,s){this._apiFactory=u,this._extensionPaths=p,this._extensionRegistry=b,this._configProvider=t,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(u,p){const b=this._extensionPaths.findSubstr(p.fsPath);if(b){let t=this._extApiImpl.get(S.ExtensionIdentifier.toKey(b.identifier));return t||(t=this._apiFactory(b,this._extensionRegistry,this._configProvider),this._extApiImpl.set(S.ExtensionIdentifier.toKey(b.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((s,r)=>t+=`	${r} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${p.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(I.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let f=class{constructor(u,p){this.nodeModuleName="keytar";const{environment:b}=p,t=u.getProxy(D.MainContext.MainThreadKeytar);if(b.appRoot){let s=b.appRoot.fsPath;l.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,r)=>t.$getPassword(s,r),setPassword:(s,r,i)=>t.$setPassword(s,r,i),deletePassword:(s,r)=>t.$deletePassword(s,r),findPassword:s=>t.$findPassword(s),findCredentials(s){return t.$findCredentials(s)}}}load(u,p){return this._impl}alternativeModuleName(u){const p=u.length;if(p<=7||!this.alternativeNames)return;const b=p-7;if((u.charAt(b)==="/"||u.charAt(b)==="\\")&&u.endsWith("keytar")&&(u=u.replace(/\\/g,"/"),this.alternativeNames.has(u)))return"keytar"}};f=ze([qe(0,y.IExtHostRpcService),qe(1,C.IExtHostInitDataService)],f);let E=class{constructor(u,p,b){this._extensionPaths=u,this._appUriScheme=p,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=b.getProxy(D.MainContext.MainThreadTelemetry);const t=b.getProxy(D.MainContext.MainThreadWindow);this._impl=(s,r)=>{const i=F.URI.parse(s);return r?this.callOriginal(s,r):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,s,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,s,{}):this.callOriginal(s,r)}}load(u,p,b){const t=this._extensionPaths.findSubstr(p.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=b(u),this._impl}callOriginal(u,p){return this.sendNoForwardTelemetry(),this._original(u,p)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};E=ze([qe(2,y.IExtHostRpcService)],E)}),define(Ee[220],_e([0,1,16,12,76,7,2,5,213,15,57,61,28,148,13,67,34,37]),function(ee,e,m,F,D,_,I,S,y,C,n,k,l,h,a,d,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class w{constructor(p,b,t,s){this._disposables=new _.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new y.RPCProtocol(p,null,s),b=w._transform(b,this._rpcProtocol);const r=new k.ServiceCollection(...(0,n.getSingletonServiceDescriptors)());r.set(l.IExtHostInitDataService,{_serviceBrand:void 0,...b}),r.set(a.IExtHostRpcService,new a.ExtHostRpcService(this._rpcProtocol)),r.set(d.IURITransformerService,new d.URITransformerService(s)),r.set(f.IHostUtils,t);const i=new h.InstantiationService(r,!0),c=i.invokeFunction(R=>R.get(E.IExtHostTerminalService));this._disposables.add(c),this._logService=i.invokeFunction(R=>R.get(C.ILogService)),D.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",b),this._extensionService=i.invokeFunction(R=>R.get(f.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const g=new WeakMap;this._extensionService.getExtensionPathIndex().then(R=>{Error.prepareStackTrace=(o,P)=>{let L="",$,re;for(const he of P)L+=`
	at ${he.toString()}`,re=he.getFileName(),!$&&re&&($=R.findSubstr(re));return g.set(o,$),`${o.name||"Error"}: ${o.message||""}${L}`}});const v=this._rpcProtocol.getProxy(S.MainContext.MainThreadExtensionService),A=this._rpcProtocol.getProxy(S.MainContext.MainThreadErrors);F.setUnexpectedErrorHandler(R=>{const o=F.transformErrorForSerialization(R),P=g.get(R);P?v.$onExtensionRuntimeError(P.identifier,o):A.$onUnexpectedError(o)})}terminate(p){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${p}`),this._logService.flush(),this._disposables.dispose(),F.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const b=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,m.timeout)(4e3),b]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(p,b){p.extensions.forEach(s=>s.extensionLocation=I.URI.revive(b.transformIncomingURIs(s.extensionLocation))),p.environment.appRoot=I.URI.revive(b.transformIncomingURIs(p.environment.appRoot));const t=p.environment.extensionDevelopmentLocationURI;return t&&(p.environment.extensionDevelopmentLocationURI=t.map(s=>I.URI.revive(b.transformIncomingURIs(s)))),p.environment.extensionTestsLocationURI=I.URI.revive(b.transformIncomingURIs(p.environment.extensionTestsLocationURI)),p.environment.globalStorageHome=I.URI.revive(b.transformIncomingURIs(p.environment.globalStorageHome)),p.environment.workspaceStorageHome=I.URI.revive(b.transformIncomingURIs(p.environment.workspaceStorageHome)),p.logsLocation=I.URI.revive(b.transformIncomingURIs(p.logsLocation)),p.logFile=I.URI.revive(b.transformIncomingURIs(p.logFile)),p.workspace=b.transformIncomingURIs(p.workspace),p}}e.ExtensionHostMain=w}),define(Ee[221],_e([0,1,14,18,56,27,25,52,38]),function(ee,e,m,F,D,_,I,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(l,h,a){this.config=l,this.provider=h,this.sessionToken=a,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&_.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&_.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const h=this.config.folderQueries||[];return new Promise((a,d)=>{const f=E=>{this.resultCount++,l(E)};if(this.isCanceled)return a({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(E=>{const w=E.toString(),u=m.basename(w);this.globalExcludePattern&&this.globalExcludePattern(w,u)||this.matchFile(f,{base:E,basename:u})}),Promise.all(h.map(E=>this.searchInFolder(E,f))).then(E=>{a({limitHit:this.isLimitHit,stats:E[0]||void 0})},E=>{d(new Error((0,D.toErrorMessage)(E)))})})}async searchInFolder(l,h){const a=new F.CancellationTokenSource,d=this.getSearchOptionsForFolder(l),f=this.initDirectoryTree(),E=new y.QueryGlobTester(this.config,l),w=!E.hasSiblingExcludeClauses();let u;try{this.activeCancellationTokens.add(a),u=S.StopWatch.create();const p=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},d,a.token),b=u.elapsed(),t=S.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(p&&p.forEach(s=>{const r=m.posix.relative(l.folder.path,s.path);if(w){const i=m.basename(s.path);this.matchFile(h,{base:l.folder,relativePath:r,basename:i});return}this.addDirectoryEntries(f,l.folder,r,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(f,E,h),{providerTime:b,postProcessTime:t.elapsed()})}finally{a.dispose(),this.activeCancellationTokens.delete(a)}}getSearchOptionsForFolder(l){const h=(0,y.resolvePatternsForProvider)(this.config.includePattern,l.includePattern),a=(0,y.resolvePatternsForProvider)(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:a,includes:h,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},h,a,d){if(a===this.filePattern){const E=m.basename(this.filePattern);this.matchFile(d,{base:h,relativePath:this.filePattern,basename:E})}function f(E){const w=m.basename(E),u=m.dirname(E);let p=l[u];p||(p=l[u]=[],f(u)),p.push({base:h,relativePath:E,basename:w})}f(a)}matchDirectoryTree({rootEntries:l,pathToEntries:h},a,d){const f=this,E=this.filePattern;function w(u){const p=_.hasSiblingFn(()=>u.map(b=>b.basename));for(let b=0,t=u.length;b<t;b++){const s=u[b],{relativePath:r,basename:i}=s;if(!a.includedInQuerySync(r,i,E!==i?p:void 0))continue;const c=h[r];if(c)w(c);else{if(r===E)continue;f.matchFile(d,s)}if(f.isLimitHit)break}}w(l)}matchFile(l,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(h))}}class n{constructor(){this.sessions=new Map}fileSearch(l,h,a,d){const f=this.getSessionTokenSource(l.cacheKey),E=new C(l,h,f&&f.token);let w=0;const u=p=>{w+=p.length,a(p.map(b=>this.rawMatchToSearchItem(b)))};return this.doSearch(E,n.BATCH_SIZE,u,d).then(p=>({limitHit:p.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:w,detailStats:p.stats}}))}clearCache(l){const h=this.getSessionTokenSource(l);h&&h.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new F.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:I.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,h,a,d){d.onCancellationRequested(()=>{l.cancel()});const f=w=>{w&&(E.push(w),h>0&&E.length>=h&&(a(E),E=[]))};let E=[];return l.search(f).then(w=>(E.length&&a(E),w),w=>(E.length&&a(E),Promise.reject(w)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(Ee[222],_e([0,1,14,17,18,56,25,27,2,38,11,10]),function(ee,e,m,F,D,_,I,S,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class l{constructor(u,p,b){this.query=u,this.provider=p,this.fileUtils=b,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(u,p){const b=this.query.folderQueries||[],t=new D.CancellationTokenSource;return p.onCancellationRequested(()=>t.cancel()),new Promise((s,r)=>{this.collector=new a(u);let i=!1;const c=(g,v)=>{if(!i&&!this.isLimitHit){const A=this.resultSize(g);f(g)&&typeof this.query.maxResults=="number"&&this.resultCount+A>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),g=this.trimResultToSize(g,this.query.maxResults-this.resultCount));const R=this.resultSize(g);this.resultCount+=R,(R>0||!f(g))&&this.collector.add(g,v)}};Promise.all(b.map((g,v)=>this.searchInFolder(g,A=>c(A,v),t.token))).then(g=>{t.dispose(),this.collector.flush();const v=g.some(A=>!!A&&!!A.limitHit);s({limitHit:this.isLimitHit||v,messages:(0,F.flatten)(g.map(A=>A?.message?(0,k.isArray)(A.message)?A.message:[A.message]:[])),stats:{type:"textSearchProvider"}})},g=>{t.dispose();const v=(0,_.toErrorMessage)(g);r(new Error(v))})})}resultSize(u){return f(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}trimResultToSize(u,p){const b=Array.isArray(u.ranges)?u.ranges:[u.ranges],t=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:b.slice(0,p),preview:{matches:t.slice(0,p),text:u.preview.text},uri:u.uri}}async searchInFolder(u,p,b){const t=new C.QueryGlobTester(this.query,u),s=[],r={report:g=>{if(!this.validateProviderResult(g))return;const v=u.folder.scheme===n.Schemas.file?S.hasSiblingPromiseFn(()=>this.fileUtils.readdir(I.dirname(g.uri))):void 0,A=I.relativePath(u.folder,g.uri);A&&s.push(t.includedInQuery(A,m.basename(A),v).then(R=>{R&&p(g)}))}},i=this.getSearchOptionsForFolder(u),c=await this.provider.provideTextSearchResults(h(this.query.contentPattern),i,r,b);return await Promise.all(s),c}validateProviderResult(u){if(f(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(u){const p=(0,C.resolvePatternsForProvider)(this.query.includePattern,u.includePattern),b=(0,C.resolvePatternsForProvider)(this.query.excludePattern,u.excludePattern),t={folder:y.URI.from(u.folder),excludes:b,includes:p,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.fileUtils.toCanonicalName(u.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=l;function h(w){return{isCaseSensitive:w.isCaseSensitive||!1,isRegExp:w.isRegExp||!1,isWordMatch:w.isWordMatch||!1,isMultiline:w.isMultiline||!1,pattern:w.pattern}}class a{constructor(u){this._onResult=u,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new E(512,p=>this.sendItems(p))}add(u,p){this._currentFileMatch&&(this._currentFolderIdx!==p||!I.isEqual(this._currentUri,u.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=p,this._currentFileMatch={resource:u.uri,results:[]}),this._currentFileMatch.results.push(d(u))}pushToCollector(){const u=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,u)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(u){this._onResult(u)}}e.TextSearchResultsCollector=a;function d(w){return f(w)?{preview:{matches:(0,F.mapArrayOrNot)(w.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:w.preview.text},ranges:(0,F.mapArrayOrNot)(w.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:w.text,lineNumber:w.lineNumber}}function f(w){return!!w.preview}e.extensionResultIsMatch=f;class E{constructor(u,p){this.maxBatchSize=u,this.cb=p,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(u,p){!u||this.addItemToBatch(u,p)}addItems(u,p){!u||this.addItemsToBatch(u,p)}addItemToBatch(u,p){this.batch.push(u),this.batchSize+=p,this.onUpdate()}addItemsToBatch(u,p){this.batch=this.batch.concat(u),this.batchSize+=p,this.onUpdate()}onUpdate(){this.totalNumberCompleted<E.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},E.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=E,E.TIMEOUT=4e3,E.START_BATCH_AFTER_COUNT=50}),define(Ee[107],_e([0,1,7,5,4,221,13,67,15,2,222]),function(ee,e,m,F,D,_,I,S,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let k=class{constructor(d,f,E){this.extHostRpc=d,this._uriTransformer=f,this._logService=E,this._proxy=this.extHostRpc.getProxy(F.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new _.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProvider(d,f){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const E=this._handlePool++;return this._textSearchProvider.set(E,f),this._proxy.$registerTextSearchProvider(E,this._transformScheme(d)),(0,m.toDisposable)(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(E),this._proxy.$unregisterProvider(E)})}registerFileSearchProvider(d,f){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const E=this._handlePool++;return this._fileSearchProvider.set(E,f),this._proxy.$registerFileSearchProvider(E,this._transformScheme(d)),(0,m.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(E),this._proxy.$unregisterProvider(E)})}$provideFileSearchResults(d,f,E,w){const u=l(E),p=this._fileSearchProvider.get(d);if(p)return this._fileSearchManager.fileSearch(u,p,b=>{this._proxy.$handleFileMatch(d,f,b.map(t=>t.resource))},w);throw new Error("unknown provider: "+d)}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,f,E,w){const u=this._textSearchProvider.get(d);if(!u||!u.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const p=l(E);return this.createTextSearchManager(p,u).search(t=>this._proxy.$handleTextMatch(d,f,t),w)}createTextSearchManager(d,f){return new n.TextSearchManager(d,f,{readdir:E=>Promise.resolve([]),toCanonicalName:E=>E})}};k=ze([qe(0,I.IExtHostRpcService),qe(1,S.IURITransformerService),qe(2,y.ILogService)],k),e.ExtHostSearch=k;function l(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(h),extraFileResources:a.extraFileResources&&a.extraFileResources.map(d=>C.URI.revive(d))}}e.reviveQuery=l;function h(a){return{...a,folder:C.URI.revive(a.folder)}}}),define(Ee[223],_e([0,1,18,12,3,42,2,124,85,118,55,60,5,186,185,72,187,33,188,189,190,172,191,46,34,192,173,194,195,196,102,175,201,202,203,74,37,205,176,9,6,208,47,103,32,29,77,164,193,93,101,105,106,107,15,67,13,28,197,162,66,71,183,206,161,75,73,211,209,210,184,45,204,207,70,64,94,199,104,200,11,150,198,159,157]),function(ee,e,m,F,D,_,I,S,y,C,n,k,l,h,a,d,f,E,w,u,p,b,t,s,r,i,c,g,v,A,R,o,P,L,$,re,he,Q,z,V,T,G,B,j,ce,W,te,ue,ye,Te,Re,$e,Ze,Ve,je,O,K,J,se,q,ne,ge,Me,We,be,Xe,H,X,de,Be,Ue,tt,Se,De,Pe,ie,oe,fe,ve,x,me,we,Ie,Ne,He){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function et(Ke){const Qe=Ke.get(J.IExtHostInitDataService),lt=Ke.get(tt.IExtHostFileSystemInfo),dt=Ke.get(H.IExtHostConsumerFileSystem),_t=Ke.get(r.IExtHostExtensionService),at=Ke.get(ce.IExtHostWorkspace),pe=Ke.get(oe.IExtHostTelemetry),Ce=Ke.get(E.IExtHostConfiguration),le=Ke.get(O.IURITransformerService),U=Ke.get(K.IExtHostRpcService),Fe=Ke.get(re.IExtHostStorage),xe=Ke.get(Xe.IExtensionStoragePaths),Ye=Ke.get(je.ILogService),Ge=Ke.get(ne.IExtHostTunnelService),ut=Ke.get(ge.IExtHostApiDeprecationService),mt=Ke.get(j.IExtHostWindow),kt=Ke.get(Pe.IExtHostSecretState),St=Ke.get(ie.IExtHostEditorTabs);U.set(l.ExtHostContext.ExtHostFileSystemInfo,lt),U.set(l.ExtHostContext.ExtHostLogService,Ye),U.set(l.ExtHostContext.ExtHostWorkspace,at),U.set(l.ExtHostContext.ExtHostConfiguration,Ce),U.set(l.ExtHostContext.ExtHostExtensionService,_t),U.set(l.ExtHostContext.ExtHostStorage,Fe),U.set(l.ExtHostContext.ExtHostTunnelService,Ge),U.set(l.ExtHostContext.ExtHostWindow,mt),U.set(l.ExtHostContext.ExtHostSecretState,kt),U.set(l.ExtHostContext.ExtHostTelemetry,pe),U.set(l.ExtHostContext.ExtHostEditorTabs,St);const bt=U.set(l.ExtHostContext.ExtHostDecorations,Ke.get(Re.IExtHostDecorations)),gt=U.set(l.ExtHostContext.ExtHostDocumentsAndEditors,Ke.get(s.IExtHostDocumentsAndEditors)),ht=U.set(l.ExtHostContext.ExtHostCommands,Ke.get(d.IExtHostCommands)),Et=U.set(l.ExtHostContext.ExtHostTerminalService,Ke.get(he.IExtHostTerminalService)),ft=U.set(l.ExtHostContext.ExtHostDebugService,Ke.get(Ze.IExtHostDebugService)),Ot=U.set(l.ExtHostContext.ExtHostSearch,Ke.get(Ve.IExtHostSearch)),Pt=U.set(l.ExtHostContext.ExtHostTask,Ke.get($e.IExtHostTask)),Kt=U.set(l.ExtHostContext.ExtHostOutputService,Ke.get(R.IExtHostOutputService)),Ut=U.set(l.ExtHostContext.ExtHostUrls,new G.ExtHostUrls(U)),Ct=U.set(l.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(U,gt)),Qt=U.set(l.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(U,gt,Ye)),Yt=U.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new b.ExtHostDocumentSaveParticipant(Ye,Ct,U.getProxy(l.MainContext.MainThreadBulkEdits))),pt=U.set(l.ExtHostContext.ExtHostNotebook,new se.ExtHostNotebookController(U,ht,gt,Ct,xe)),qt=U.set(l.ExtHostContext.ExtHostNotebookDocuments,new Ne.ExtHostNotebookDocuments(Ye,pt)),zt=U.set(l.ExtHostContext.ExtHostNotebookEditors,new Ie.ExtHostNotebookEditors(Ye,U,pt)),Jt=U.set(l.ExtHostContext.ExtHostNotebookKernels,new fe.ExtHostNotebookKernels(U,Qe,pt,Ye)),Xt=U.set(l.ExtHostContext.ExtHostNotebookRenderers,new x.ExtHostNotebookRenderers(U,pt)),At=U.set(l.ExtHostContext.ExtHostEditors,new Q.ExtHostEditors(U,gt)),jt=U.set(l.ExtHostContext.ExtHostTreeViews,new z.ExtHostTreeViews(U.getProxy(l.MainContext.MainThreadTreeViews),ht,Ye)),Zt=U.set(l.ExtHostContext.ExtHostEditorInsets,new ue.ExtHostEditorInsets(U.getProxy(l.MainContext.MainThreadEditorInsets),At,Qe)),Ht=U.set(l.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(U,Ye)),ct=U.set(l.ExtHostContext.ExtHostLanguageFeatures,new g.ExtHostLanguageFeatures(U,le,Ct,ht,Ht,Ye,ut)),En=U.set(l.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(U,ct)),Rt=U.set(l.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(U,Ye,gt)),xt=U.set(l.ExtHostContext.ExtHostQuickOpen,(0,P.createExtHostQuickOpen)(U,at,ht)),cn=U.set(l.ExtHostContext.ExtHostSCM,new L.ExtHostSCM(U,ht,Ye)),_n=U.set(l.ExtHostContext.ExtHostComments,(0,f.createExtHostComments)(U,ht,Ct)),dn=U.set(l.ExtHostContext.ExtHostProgress,new o.ExtHostProgress(U.getProxy(l.MainContext.MainThreadProgress))),yn=U.set(l.ExtHostContext.ExtHosLabelService,new ye.ExtHostLabelService(U)),hn=U.set(l.ExtHostContext.ExtHostTheming,new q.ExtHostTheming(U)),Vt=U.set(l.ExtHostContext.ExtHostAuthentication,new Me.ExtHostAuthentication(U)),en=U.set(l.ExtHostContext.ExtHostTimeline,new We.ExtHostTimeline(U,ht)),tn=U.set(l.ExtHostContext.ExtHostWebviews,new B.ExtHostWebviews(U,{remote:Qe.remote},at,Ye,ut)),nn=U.set(l.ExtHostContext.ExtHostWebviewPanels,new Be.ExtHostWebviewPanels(U,tn,at)),Sn=U.set(l.ExtHostContext.ExtHostCustomEditors,new de.ExtHostCustomEditors(U,Ct,xe,tn,nn)),Dn=U.set(l.ExtHostContext.ExtHostWebviewViews,new X.ExtHostWebviewViews(U,tn)),Ft=U.set(l.ExtHostContext.ExtHostTesting,new Se.ExtHostTesting(U,ht)),Cn=U.set(l.ExtHostContext.ExtHostUriOpeners,new De.ExtHostUriOpeners(U));U.set(l.ExtHostContext.ExtHostInteractive,new He.ExtHostInteractive(U,pt,gt));const kn=(0,te.values)(l.ExtHostContext);U.assertRegistered(kn);const rn=new Ue.ExtHostBulkEdits(U,gt),In=new a.ExtHostClipboard(U),Bt=new A.ExtHostMessageService(U,Ye),Lt=new u.ExtHostDialogs(U),fn=new $.ExtHostStatusBar(U,ht.converter),Tt=new v.ExtHostLanguages(U,Ct);return h.ExtHostApiCommands.register(ht),function(Le,sn,mn){const vt=function(){let Y=!Le.isUnderDevelopment;function ae(Ae){Y||(Ye.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Y=!0)}return function Ae(st){if(Array.isArray(st))st.forEach(Ae);else if(typeof st=="string")ae(st);else{const wt=st;typeof wt.scheme=="undefined"&&ae(st),!Le.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,W.throwProposedApiError)(Le)}return st}}(),Pn={getSession(Y,ae,Ae){return Vt.getSession(Le,Y,ae,Ae)},get onDidChangeSessions(){return Vt.onDidChangeSessions},registerAuthenticationProvider(Y,ae,Ae,st){return Vt.registerAuthenticationProvider(Y,ae,Ae,st)}},An={registerCommand(Y,ae,Ae){return ht.registerCommand(!0,Y,ae,Ae)},registerTextEditorCommand(Y,ae,Ae){return ht.registerCommand(!0,Y,(...st)=>{const wt=At.getActiveTextEditor();if(!wt){Ye.warn("Cannot execute "+Y+" because there is no active text editor.");return}return wt.edit(Dt=>{ae.apply(Ae,[wt,Dt,...st])}).then(Dt=>{Dt||Ye.warn("Edits from command "+Y+" were not applied.")},Dt=>{Ye.warn("An error occurred while running command "+Y,Dt)})})},registerDiffInformationCommand:(Y,ae,Ae)=>((0,W.checkProposedApiEnabled)(Le),ht.registerCommand(!0,Y,async(...st)=>{const wt=gt.activeEditor(!0);if(!wt){Ye.warn("Cannot execute "+Y+" because there is no active text editor.");return}const Dt=await At.getDiffInformation(wt.id);ae.apply(Ae,[Dt,...st])})),executeCommand(Y,...ae){return ht.executeCommand(Y,...ae)},getCommands(Y=!1){return ht.getCommands(Y)}},gn={get machineId(){return Qe.telemetryInfo.machineId},get sessionId(){return Qe.telemetryInfo.sessionId},get language(){return Qe.environment.appLanguage},get appName(){return Qe.environment.appName},get appRoot(){return Qe.environment.appRoot?.fsPath??""},get uriScheme(){return Qe.environment.appUriScheme},get clipboard(){return In.value},get shell(){return Et.getDefaultShell(!1)},get isTelemetryEnabled(){return pe.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return pe.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Y=Date.now()-new Date(Qe.telemetryInfo.firstSessionDate).getTime();return isNaN(Y)?!1:Y<1e3*60*60*24},openExternal(Y,ae){return mt.openUri(Y,{allowTunneling:!!Qe.remote.authority,allowContributedOpeners:ae?.allowContributedOpeners})},async asExternalUri(Y){if(Y.scheme===Qe.environment.appUriScheme)return Ut.createAppUri(Y);try{return await mt.asExternalUri(Y,{allowTunneling:!!Qe.remote.authority})}catch(ae){if((0,we.matchesScheme)(Y,me.Schemas.http)||(0,we.matchesScheme)(Y,me.Schemas.https))return Y;throw ae}},get remoteName(){return(0,Te.getRemoteName)(Qe.remote.authority)},get uiKind(){return Qe.uiKind}};Qe.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=Qe.remote.isRemote?T.ExtensionKind.Workspace:T.ExtensionKind.UI,on={createTestController(Y,ae){return(0,W.checkProposedApiEnabled)(Le),Ft.createTestController(Y,ae)},createTestItem(Y,ae,Ae){return(0,W.checkProposedApiEnabled)(Le),Ft.createTestItem(Y,ae,Ae)},createTestObserver(){return(0,W.checkProposedApiEnabled)(Le),Ft.createTestObserver()},runTests(Y){return(0,W.checkProposedApiEnabled)(Le),Ft.runTests(Y)},get onDidChangeTestResults(){return(0,W.checkProposedApiEnabled)(Le),Ft.onResultsChanged},get testResults(){return(0,W.checkProposedApiEnabled)(Le),Ft.results}},Tn={getExtension(Y){const ae=sn.getExtensionDescription(Y);if(ae)return new r.Extension(_t,Le.identifier,ae,pn)},get all(){return sn.getAllExtensionDescriptions().map(Y=>new r.Extension(_t,Le.identifier,Y,pn))},get onDidChange(){return sn.onDidChange}},Rn={createDiagnosticCollection(Y){return Ht.createDiagnosticCollection(Le.identifier,Y)},get onDidChangeDiagnostics(){return Ht.onDidChangeDiagnostics},getDiagnostics:Y=>Ht.getDiagnostics(Y),getLanguages(){return Tt.getLanguages()},setTextDocumentLanguage(Y,ae){return Tt.changeLanguage(Y.uri,ae)},match(Y,ae){return(0,n.score)(V.LanguageSelector.from(Y),ae.uri,ae.languageId,!0)},registerCodeActionsProvider(Y,ae,Ae){return ct.registerCodeActionProvider(Le,vt(Y),ae,Ae)},registerCodeLensProvider(Y,ae){return ct.registerCodeLensProvider(Le,vt(Y),ae)},registerDefinitionProvider(Y,ae){return ct.registerDefinitionProvider(Le,vt(Y),ae)},registerDeclarationProvider(Y,ae){return ct.registerDeclarationProvider(Le,vt(Y),ae)},registerImplementationProvider(Y,ae){return ct.registerImplementationProvider(Le,vt(Y),ae)},registerTypeDefinitionProvider(Y,ae){return ct.registerTypeDefinitionProvider(Le,vt(Y),ae)},registerHoverProvider(Y,ae){return ct.registerHoverProvider(Le,vt(Y),ae,Le.identifier)},registerEvaluatableExpressionProvider(Y,ae){return ct.registerEvaluatableExpressionProvider(Le,vt(Y),ae,Le.identifier)},registerInlineValuesProvider(Y,ae){return ct.registerInlineValuesProvider(Le,vt(Y),ae,Le.identifier)},registerDocumentHighlightProvider(Y,ae){return ct.registerDocumentHighlightProvider(Le,vt(Y),ae)},registerLinkedEditingRangeProvider(Y,ae){return ct.registerLinkedEditingRangeProvider(Le,vt(Y),ae)},registerReferenceProvider(Y,ae){return ct.registerReferenceProvider(Le,vt(Y),ae)},registerRenameProvider(Y,ae){return ct.registerRenameProvider(Le,vt(Y),ae)},registerDocumentSymbolProvider(Y,ae,Ae){return ct.registerDocumentSymbolProvider(Le,vt(Y),ae,Ae)},registerWorkspaceSymbolProvider(Y){return ct.registerWorkspaceSymbolProvider(Le,Y)},registerDocumentFormattingEditProvider(Y,ae){return ct.registerDocumentFormattingEditProvider(Le,vt(Y),ae)},registerDocumentRangeFormattingEditProvider(Y,ae){return ct.registerDocumentRangeFormattingEditProvider(Le,vt(Y),ae)},registerOnTypeFormattingEditProvider(Y,ae,Ae,...st){return ct.registerOnTypeFormattingEditProvider(Le,vt(Y),ae,[Ae].concat(st))},registerDocumentSemanticTokensProvider(Y,ae,Ae){return ct.registerDocumentSemanticTokensProvider(Le,vt(Y),ae,Ae)},registerDocumentRangeSemanticTokensProvider(Y,ae,Ae){return ct.registerDocumentRangeSemanticTokensProvider(Le,vt(Y),ae,Ae)},registerSignatureHelpProvider(Y,ae,Ae,...st){return typeof Ae=="object"?ct.registerSignatureHelpProvider(Le,vt(Y),ae,Ae):ct.registerSignatureHelpProvider(Le,vt(Y),ae,typeof Ae=="undefined"?[]:[Ae,...st])},registerCompletionItemProvider(Y,ae,...Ae){return ct.registerCompletionItemProvider(Le,vt(Y),ae,Ae)},registerInlineCompletionItemProvider(Y,ae){return(0,W.checkProposedApiEnabled)(Le),ct.registerInlineCompletionsProvider(Le,vt(Y),ae)},registerDocumentLinkProvider(Y,ae){return ct.registerDocumentLinkProvider(Le,vt(Y),ae)},registerColorProvider(Y,ae){return ct.registerColorProvider(Le,vt(Y),ae)},registerFoldingRangeProvider(Y,ae){return ct.registerFoldingRangeProvider(Le,vt(Y),ae)},registerSelectionRangeProvider(Y,ae){return ct.registerSelectionRangeProvider(Le,Y,ae)},registerCallHierarchyProvider(Y,ae){return ct.registerCallHierarchyProvider(Le,Y,ae)},setLanguageConfiguration:(Y,ae)=>ct.setLanguageConfiguration(Le,Y,ae),getTokenInformationAtPosition(Y,ae){return(0,W.checkProposedApiEnabled)(Le),Tt.tokenAtPosition(Y,ae)},registerInlayHintsProvider(Y,ae){return(0,W.checkProposedApiEnabled)(Le),ct.registerInlayHintsProvider(Le,Y,ae)},registerTypeHierarchyProvider(Y,ae){return(0,W.checkProposedApiEnabled)(Le),ct.registerTypeHierarchyProvider(Le,Y,ae)}},Fn={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return Et.activeTerminal},get terminals(){return Et.terminals},async showTextDocument(Y,ae,Ae){const st=await(I.URI.isUri(Y)?Promise.resolve(vn.openTextDocument(Y)):Promise.resolve(Y));return At.showTextDocument(st,ae,Ae)},createTextEditorDecorationType(Y){return At.createTextEditorDecorationType(Le,Y)},onDidChangeActiveTextEditor(Y,ae,Ae){return At.onDidChangeActiveTextEditor(Y,ae,Ae)},onDidChangeVisibleTextEditors(Y,ae,Ae){return At.onDidChangeVisibleTextEditors(Y,ae,Ae)},onDidChangeTextEditorSelection(Y,ae,Ae){return At.onDidChangeTextEditorSelection(Y,ae,Ae)},onDidChangeTextEditorOptions(Y,ae,Ae){return At.onDidChangeTextEditorOptions(Y,ae,Ae)},onDidChangeTextEditorVisibleRanges(Y,ae,Ae){return At.onDidChangeTextEditorVisibleRanges(Y,ae,Ae)},onDidChangeTextEditorViewColumn(Y,ae,Ae){return At.onDidChangeTextEditorViewColumn(Y,ae,Ae)},onDidCloseTerminal(Y,ae,Ae){return Et.onDidCloseTerminal(Y,ae,Ae)},onDidOpenTerminal(Y,ae,Ae){return Et.onDidOpenTerminal(Y,ae,Ae)},onDidChangeActiveTerminal(Y,ae,Ae){return Et.onDidChangeActiveTerminal(Y,ae,Ae)},onDidChangeTerminalDimensions(Y,ae,Ae){return(0,W.checkProposedApiEnabled)(Le),Et.onDidChangeTerminalDimensions(Y,ae,Ae)},onDidWriteTerminalData(Y,ae,Ae){return(0,W.checkProposedApiEnabled)(Le),Et.onDidWriteTerminalData(Y,ae,Ae)},get state(){return mt.state},onDidChangeWindowState(Y,ae,Ae){return mt.onDidChangeWindowState(Y,ae,Ae)},showInformationMessage(Y,...ae){return Bt.showMessage(Le,_.default.Info,Y,ae[0],ae.slice(1))},showWarningMessage(Y,...ae){return Bt.showMessage(Le,_.default.Warning,Y,ae[0],ae.slice(1))},showErrorMessage(Y,...ae){return Bt.showMessage(Le,_.default.Error,Y,ae[0],ae.slice(1))},showQuickPick(Y,ae,Ae){return xt.showQuickPick(Y,!!Le.enableProposedApi,ae,Ae)},showWorkspaceFolderPick(Y){return xt.showWorkspaceFolderPick(Y)},showInputBox(Y,ae){return xt.showInput(Y,ae)},showOpenDialog(Y){return Lt.showOpenDialog(Y)},showSaveDialog(Y){return Lt.showSaveDialog(Y)},createStatusBarItem(Y,ae,Ae){let st,wt,Dt;return typeof Y=="string"?(st=Y,wt=ae,Dt=Ae):(wt=Y,Dt=ae),fn.createStatusBarEntry(Le,st,wt,Dt)},setStatusBarMessage(Y,ae){return fn.setStatusBarMessage(Y,ae)},withScmProgress(Y){return ut.report("window.withScmProgress",Le,"Use 'withProgress' instead."),dn.withProgress(Le,{location:T.ProgressLocation.SourceControl},(ae,Ae)=>Y({report(st){}}))},withProgress(Y,ae){return dn.withProgress(Le,Y,ae)},createOutputChannel(Y){return Kt.createOutputChannel(Y,Le)},createWebviewPanel(Y,ae,Ae,st){return nn.createWebviewPanel(Le,Y,ae,Ae,st)},createWebviewTextEditorInset(Y,ae,Ae,st){return(0,W.checkProposedApiEnabled)(Le),Zt.createWebviewEditorInset(Y,ae,Ae,st,Le)},createTerminal(Y,ae,Ae){return typeof Y=="object"?"pty"in Y?Et.createExtensionTerminal(Y):Et.createTerminalFromOptions(Y):Et.createTerminal(Y,ae,Ae)},registerTerminalLinkProvider(Y){return Et.registerLinkProvider(Y)},registerTerminalProfileProvider(Y,ae){return Et.registerProfileProvider(Le,Y,ae)},registerTreeDataProvider(Y,ae){return jt.registerTreeDataProvider(Y,ae,Le)},createTreeView(Y,ae){return jt.createTreeView(Y,ae,Le)},registerWebviewPanelSerializer:(Y,ae)=>nn.registerWebviewPanelSerializer(Le,Y,ae),registerCustomEditorProvider:(Y,ae,Ae={})=>Sn.registerCustomEditorProvider(Le,Y,ae,Ae),registerFileDecorationProvider(Y){return bt.registerFileDecorationProvider(Y,Le.identifier)},registerUriHandler(Y){return Ut.registerUriHandler(Le.identifier,Y)},createQuickPick(){return xt.createQuickPick(Le.identifier,!!Le.enableProposedApi)},createInputBox(){return xt.createInputBox(Le.identifier)},get activeColorTheme(){return hn.activeColorTheme},onDidChangeActiveColorTheme(Y,ae,Ae){return hn.onDidChangeActiveColorTheme(Y,ae,Ae)},registerWebviewViewProvider(Y,ae,Ae){return Dn.registerWebviewViewProvider(Le,Y,ae,Ae?.webviewOptions)},get activeNotebookEditor(){return(0,W.checkProposedApiEnabled)(Le),pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Y,ae,Ae){return(0,W.checkProposedApiEnabled)(Le),pt.onDidChangeActiveNotebookEditor(Y,ae,Ae)},get visibleNotebookEditors(){return(0,W.checkProposedApiEnabled)(Le),pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,W.checkProposedApiEnabled)(Le),pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Y,ae,Ae){return(0,W.checkProposedApiEnabled)(Le),zt.onDidChangeNotebookEditorSelection(Y,ae,Ae)},onDidChangeNotebookEditorVisibleRanges(Y,ae,Ae){return(0,W.checkProposedApiEnabled)(Le),zt.onDidChangeNotebookEditorVisibleRanges(Y,ae,Ae)},showNotebookDocument(Y,ae){return(0,W.checkProposedApiEnabled)(Le),pt.showNotebookDocument(Y,ae)},registerExternalUriOpener(Y,ae,Ae){return(0,W.checkProposedApiEnabled)(Le),Cn.registerExternalUriOpener(Le.identifier,Y,ae,Ae)},get openEditors(){return(0,W.checkProposedApiEnabled)(Le),St.tabs},get onDidChangeOpenEditors(){return(0,W.checkProposedApiEnabled)(Le),St.onDidChangeTabs},getInlineCompletionItemController(Y){return(0,W.checkProposedApiEnabled)(Le),g.InlineCompletionController.get(Y)}},vn={get rootPath(){return ut.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),at.getPath()},set rootPath(Y){throw F.readonly()},getWorkspaceFolder(Y){return at.getWorkspaceFolder(Y)},get workspaceFolders(){return at.getWorkspaceFolders()},get name(){return at.name},set name(Y){throw F.readonly()},get workspaceFile(){return at.workspaceFile},set workspaceFile(Y){throw F.readonly()},updateWorkspaceFolders:(Y,ae,...Ae)=>at.updateWorkspaceFolders(Le,Y,ae||0,...Ae),onDidChangeWorkspaceFolders:function(Y,ae,Ae){return at.onDidChangeWorkspace(Y,ae,Ae)},asRelativePath:(Y,ae)=>at.getRelativePath(Y,ae),findFiles:(Y,ae,Ae,st)=>at.findFiles(V.GlobPattern.from(Y),V.GlobPattern.from(ae),Ae,Le.identifier,st),findTextInFiles:(Y,ae,Ae,st)=>{let wt,Dt;return typeof ae=="object"?(wt=ae,Dt=Ae):(wt={},Dt=ae,st=Ae),at.findTextInFiles(Y,wt||{},Dt,Le.identifier,st)},saveAll:Y=>at.saveAll(Y),applyEdit(Y){return rn.applyWorkspaceEdit(Y)},createFileSystemWatcher:(Y,ae,Ae,st)=>Rt.createFileSystemWatcher(V.GlobPattern.from(Y),ae,Ae,st),get textDocuments(){return Ct.getAllDocumentData().map(Y=>Y.document)},set textDocuments(Y){throw F.readonly()},openTextDocument(Y){let ae;const Ae=Y;if(typeof Y=="string")ae=Promise.resolve(I.URI.file(Y));else if(I.URI.isUri(Y))ae=Promise.resolve(Y);else if(!Ae||typeof Ae=="object")ae=Ct.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ae.then(st=>Ct.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(Y,ae,Ae)=>Ct.onDidAddDocument(Y,ae,Ae),onDidCloseTextDocument:(Y,ae,Ae)=>Ct.onDidRemoveDocument(Y,ae,Ae),onDidChangeTextDocument:(Y,ae,Ae)=>Ct.onDidChangeDocument(Y,ae,Ae),onDidSaveTextDocument:(Y,ae,Ae)=>Ct.onDidSaveDocument(Y,ae,Ae),onWillSaveTextDocument:(Y,ae,Ae)=>Yt.getOnWillSaveTextDocumentEvent(Le)(Y,ae,Ae),get notebookDocuments(){return pt.notebookDocuments.map(Y=>Y.apiNotebook)},async openNotebookDocument(Y,ae){let Ae;if(I.URI.isUri(Y))Ae=Y,await pt.openNotebookDocument(Y);else if(typeof Y=="string")Ae=I.URI.revive(await pt.createNotebookDocument({viewType:Y,content:ae}));else throw new Error("Invalid arguments");return pt.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return pt.onDidCloseNotebookDocument},registerNotebookSerializer(Y,ae,Ae,st){return pt.registerNotebookSerializer(Le,Y,ae,Ae,Le.enableProposedApi?st:void 0)},registerNotebookContentProvider:(Y,ae,Ae,st)=>((0,W.checkProposedApiEnabled)(Le),pt.registerNotebookContentProvider(Le,Y,ae,Ae,Le.enableProposedApi?st:void 0)),onDidChangeConfiguration:(Y,ae,Ae)=>mn.onDidChangeConfiguration(Y,ae,Ae),getConfiguration(Y,ae){return ae=arguments.length===1?void 0:ae,mn.getConfiguration(Y,ae,Le)},registerTextDocumentContentProvider(Y,ae){return Qt.registerTextDocumentContentProvider(Y,ae)},registerTaskProvider:(Y,ae)=>(ut.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),Pt.registerTaskProvider(Le,Y,ae)),registerFileSystemProvider(Y,ae,Ae){return En.registerFileSystemProvider(Le.identifier,Y,ae,Ae,Le.enableProposedApi)},get fs(){return dt.value},registerFileSearchProvider:(Y,ae)=>((0,W.checkProposedApiEnabled)(Le),Ot.registerFileSearchProvider(Y,ae)),registerTextSearchProvider:(Y,ae)=>((0,W.checkProposedApiEnabled)(Le),Ot.registerTextSearchProvider(Y,ae)),registerRemoteAuthorityResolver:(Y,ae)=>((0,W.checkProposedApiEnabled)(Le),_t.registerRemoteAuthorityResolver(Y,ae)),registerResourceLabelFormatter:Y=>((0,W.checkProposedApiEnabled)(Le),yn.$registerResourceLabelFormatter(Y)),onDidCreateFiles:(Y,ae,Ae)=>Rt.onDidCreateFile(Y,ae,Ae),onDidDeleteFiles:(Y,ae,Ae)=>Rt.onDidDeleteFile(Y,ae,Ae),onDidRenameFiles:(Y,ae,Ae)=>Rt.onDidRenameFile(Y,ae,Ae),onWillCreateFiles:(Y,ae,Ae)=>Rt.getOnWillCreateFileEvent(Le)(Y,ae,Ae),onWillDeleteFiles:(Y,ae,Ae)=>Rt.getOnWillDeleteFileEvent(Le)(Y,ae,Ae),onWillRenameFiles:(Y,ae,Ae)=>Rt.getOnWillRenameFileEvent(Le)(Y,ae,Ae),openTunnel:Y=>((0,W.checkProposedApiEnabled)(Le),Ge.openTunnel(Le,Y).then(ae=>{if(!ae)throw new Error("cannot open tunnel");return ae})),get tunnels(){return(0,W.checkProposedApiEnabled)(Le),Ge.getTunnels()},onDidChangeTunnels:(Y,ae,Ae)=>((0,W.checkProposedApiEnabled)(Le),Ge.onDidChangeTunnels(Y,ae,Ae)),registerPortAttributesProvider:(Y,ae)=>((0,W.checkProposedApiEnabled)(Le),Ge.registerPortsAttributesProvider(Y,ae)),registerTimelineProvider:(Y,ae)=>((0,W.checkProposedApiEnabled)(Le),en.registerTimelineProvider(Y,ae,Le.identifier,ht.converter)),get isTrusted(){return at.trusted},requestWorkspaceTrust:Y=>((0,W.checkProposedApiEnabled)(Le),at.requestWorkspaceTrust(Y)),onDidGrantWorkspaceTrust:(Y,ae,Ae)=>at.onDidGrantWorkspaceTrust(Y,ae,Ae)},Mn={get inputBox(){return ut.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),cn.getLastInputBox(Le)},createSourceControl(Y,ae,Ae){return cn.createSourceControl(Le,Y,ae,Ae)}},Ln={createCommentController(Y,ae){return _n.createCommentController(Le,Y,ae)}},bn={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},onDidStartDebugSession(Y,ae,Ae){return ft.onDidStartDebugSession(Y,ae,Ae)},onDidTerminateDebugSession(Y,ae,Ae){return ft.onDidTerminateDebugSession(Y,ae,Ae)},onDidChangeActiveDebugSession(Y,ae,Ae){return ft.onDidChangeActiveDebugSession(Y,ae,Ae)},onDidReceiveDebugSessionCustomEvent(Y,ae,Ae){return ft.onDidReceiveDebugSessionCustomEvent(Y,ae,Ae)},onDidChangeBreakpoints(Y,ae,Ae){return ft.onDidChangeBreakpoints(Y,ae,Ae)},registerDebugConfigurationProvider(Y,ae,Ae){return ft.registerDebugConfigurationProvider(Y,ae,Ae||T.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Y,ae){return ft.registerDebugAdapterDescriptorFactory(Le,Y,ae)},registerDebugAdapterTrackerFactory(Y,ae){return ft.registerDebugAdapterTrackerFactory(Y,ae)},startDebugging(Y,ae,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?ft.startDebugging(Y,ae,{parentSession:Ae}):ft.startDebugging(Y,ae,Ae||{})},stopDebugging(Y){return ft.stopDebugging(Y)},addBreakpoints(Y){return ft.addBreakpoints(Y)},removeBreakpoints(Y){return ft.removeBreakpoints(Y)},asDebugSourceUri(Y,ae){return ft.asDebugSourceUri(Y,ae)}},Nn={registerTaskProvider:(Y,ae)=>Pt.registerTaskProvider(Le,Y,ae),fetchTasks:Y=>Pt.fetchTasks(Y),executeTask:Y=>Pt.executeTask(Le,Y),get taskExecutions(){return Pt.taskExecutions},onDidStartTask:(Y,ae,Ae)=>Pt.onDidStartTask(Y,ae,Ae),onDidEndTask:(Y,ae,Ae)=>Pt.onDidEndTask(Y,ae,Ae),onDidStartTaskProcess:(Y,ae,Ae)=>Pt.onDidStartTaskProcess(Y,ae,Ae),onDidEndTaskProcess:(Y,ae,Ae)=>Pt.onDidEndTaskProcess(Y,ae,Ae)},an={createNotebookController(Y,ae,Ae,st,wt){return Jt.createNotebookController(Le,Y,ae,Ae,st,Le.enableProposedApi?wt:void 0)},registerNotebookCellStatusBarItemProvider:(Y,ae)=>pt.registerNotebookCellStatusBarItemProvider(Le,Y,ae),get onDidSaveNotebookDocument(){return(0,W.checkProposedApiEnabled)(Le),qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Y){return(0,W.checkProposedApiEnabled)(Le),zt.createNotebookEditorDecorationType(Y)},createRendererMessaging(Y){return(0,W.checkProposedApiEnabled)(Le),Xt.createRendererMessaging(Y)},onDidChangeNotebookDocumentMetadata(Y,ae,Ae){return(0,W.checkProposedApiEnabled)(Le),qt.onDidChangeNotebookDocumentMetadata(Y,ae,Ae)},onDidChangeNotebookCells(Y,ae,Ae){return(0,W.checkProposedApiEnabled)(Le),pt.onDidChangeNotebookCells(Y,ae,Ae)},onDidChangeNotebookCellExecutionState(Y,ae,Ae){return(0,W.checkProposedApiEnabled)(Le),pt.onDidChangeNotebookCellExecutionState(Y,ae,Ae)},onDidChangeCellOutputs(Y,ae,Ae){return(0,W.checkProposedApiEnabled)(Le),pt.onDidChangeCellOutputs(Y,ae,Ae)},onDidChangeCellMetadata(Y,ae,Ae){return(0,W.checkProposedApiEnabled)(Le),pt.onDidChangeCellMetadata(Y,ae,Ae)},createConcatTextDocument(Y,ae){return(0,W.checkProposedApiEnabled)(Le),new be.ExtHostNotebookConcatDocument(pt,Ct,Y,ae)}};return{version:Qe.version,authentication:Pn,commands:An,comments:Ln,debug:bn,env:gn,extensions:Tn,languages:Rn,notebooks:an,scm:Mn,tasks:Nn,test:on,window:Fn,workspace:vn,Breakpoint:T.Breakpoint,CallHierarchyIncomingCall:T.CallHierarchyIncomingCall,CallHierarchyItem:T.CallHierarchyItem,CallHierarchyOutgoingCall:T.CallHierarchyOutgoingCall,CancellationError:F.CancellationError,CancellationTokenSource:m.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:T.CodeAction,CodeActionKind:T.CodeActionKind,CodeActionTriggerKind:T.CodeActionTriggerKind,CodeLens:T.CodeLens,Color:T.Color,ColorInformation:T.ColorInformation,ColorPresentation:T.ColorPresentation,ColorThemeKind:T.ColorThemeKind,CommentMode:T.CommentMode,CommentThreadCollapsibleState:T.CommentThreadCollapsibleState,CompletionItem:T.CompletionItem,CompletionItemKind:T.CompletionItemKind,CompletionItemTag:T.CompletionItemTag,CompletionList:T.CompletionList,CompletionTriggerKind:T.CompletionTriggerKind,ConfigurationTarget:T.ConfigurationTarget,CustomExecution:T.CustomExecution,DebugAdapterExecutable:T.DebugAdapterExecutable,DebugAdapterInlineImplementation:T.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:T.DebugAdapterNamedPipeServer,DebugAdapterServer:T.DebugAdapterServer,DebugConfigurationProviderTriggerKind:T.DebugConfigurationProviderTriggerKind,DebugConsoleMode:T.DebugConsoleMode,DecorationRangeBehavior:T.DecorationRangeBehavior,Diagnostic:T.Diagnostic,DiagnosticRelatedInformation:T.DiagnosticRelatedInformation,DiagnosticSeverity:T.DiagnosticSeverity,DiagnosticTag:T.DiagnosticTag,Disposable:T.Disposable,DocumentHighlight:T.DocumentHighlight,DocumentHighlightKind:T.DocumentHighlightKind,DocumentLink:T.DocumentLink,DocumentSymbol:T.DocumentSymbol,EndOfLine:T.EndOfLine,EnvironmentVariableMutatorType:T.EnvironmentVariableMutatorType,EvaluatableExpression:T.EvaluatableExpression,InlineValueText:T.InlineValueText,InlineValueVariableLookup:T.InlineValueVariableLookup,InlineValueEvaluatableExpression:T.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:T.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:T.ExtensionKind,ExtensionMode:T.ExtensionMode,ExternalUriOpenerPriority:T.ExternalUriOpenerPriority,FileChangeType:T.FileChangeType,FileDecoration:T.FileDecoration,FileSystemError:T.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:T.FoldingRange,FoldingRangeKind:T.FoldingRangeKind,FunctionBreakpoint:T.FunctionBreakpoint,InlineCompletionItem:T.InlineSuggestion,InlineCompletionList:T.InlineSuggestions,Hover:T.Hover,IndentAction:C.IndentAction,Location:T.Location,MarkdownString:T.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:T.ParameterInformation,PortAutoForwardAction:T.PortAutoForwardAction,Position:T.Position,ProcessExecution:T.ProcessExecution,ProgressLocation:T.ProgressLocation,QuickInputButtons:T.QuickInputButtons,Range:T.Range,RelativePattern:T.RelativePattern,Selection:T.Selection,SelectionRange:T.SelectionRange,SemanticTokens:T.SemanticTokens,SemanticTokensBuilder:T.SemanticTokensBuilder,SemanticTokensEdit:T.SemanticTokensEdit,SemanticTokensEdits:T.SemanticTokensEdits,SemanticTokensLegend:T.SemanticTokensLegend,ShellExecution:T.ShellExecution,ShellQuoting:T.ShellQuoting,SignatureHelp:T.SignatureHelp,SignatureHelpTriggerKind:T.SignatureHelpTriggerKind,SignatureInformation:T.SignatureInformation,SnippetString:T.SnippetString,SourceBreakpoint:T.SourceBreakpoint,StandardTokenType:T.StandardTokenType,StatusBarAlignment:T.StatusBarAlignment,SymbolInformation:T.SymbolInformation,SymbolKind:T.SymbolKind,SymbolTag:T.SymbolTag,Task:T.Task,TaskGroup:T.TaskGroup,TaskPanelKind:T.TaskPanelKind,TaskRevealKind:T.TaskRevealKind,TaskScope:T.TaskScope,TerminalLink:T.TerminalLink,TerminalProfile:T.TerminalProfile,TextDocumentSaveReason:T.TextDocumentSaveReason,TextEdit:T.TextEdit,TextEditorCursorStyle:S.TextEditorCursorStyle,TextEditorLineNumbersStyle:T.TextEditorLineNumbersStyle,TextEditorRevealType:T.TextEditorRevealType,TextEditorSelectionChangeKind:T.TextEditorSelectionChangeKind,TextDocumentChangeReason:T.TextDocumentChangeReason,ThemeColor:T.ThemeColor,ThemeIcon:T.ThemeIcon,TreeItem:T.TreeItem,TreeItemCollapsibleState:T.TreeItemCollapsibleState,TypeHierarchyItem:T.TypeHierarchyItem,UIKind:l.UIKind,Uri:I.URI,ViewColumn:T.ViewColumn,WorkspaceEdit:T.WorkspaceEdit,InlayHint:T.InlayHint,InlayHintKind:T.InlayHintKind,RemoteAuthorityResolverError:T.RemoteAuthorityResolverError,ResolvedAuthority:T.ResolvedAuthority,SourceControlInputBoxValidationType:T.SourceControlInputBoxValidationType,ExtensionRuntime:T.ExtensionRuntime,TimelineItem:T.TimelineItem,NotebookRange:T.NotebookRange,NotebookCellKind:T.NotebookCellKind,NotebookCellExecutionState:T.NotebookCellExecutionState,NotebookCellData:T.NotebookCellData,NotebookData:T.NotebookData,NotebookRendererScript:T.NotebookRendererScript,NotebookCellStatusBarAlignment:T.NotebookCellStatusBarAlignment,NotebookEditorRevealType:T.NotebookEditorRevealType,NotebookCellOutput:T.NotebookCellOutput,NotebookCellOutputItem:T.NotebookCellOutputItem,NotebookCellStatusBarItem:T.NotebookCellStatusBarItem,NotebookControllerAffinity:T.NotebookControllerAffinity,PortAttributes:T.PortAttributes,LinkedEditingRanges:T.LinkedEditingRanges,TestResultState:T.TestResultState,TestRunRequest:T.TestRunRequest,TestMessage:T.TestMessage,TestRunConfigurationGroup:T.TestRunConfigurationGroup,TextSearchCompleteMessageType:ve.TextSearchCompleteMessageType,TestMessageSeverity:T.TestMessageSeverity,CoveredCount:T.CoveredCount,FileCoverage:T.FileCoverage,StatementCoverage:T.StatementCoverage,BranchCoverage:T.BranchCoverage,FunctionCoverage:T.FunctionCoverage,WorkspaceTrustState:T.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=et}),define(Ee[224],_e([0,1,57,102,32,101,33,72,46,37,105,106,107,74,66,71,103,73,45,70,94,64]),function(ee,e,m,F,D,_,I,S,y,C,n,k,l,h,a,d,f,E,w,u,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(d.IExtHostApiDeprecationService,d.ExtHostApiDeprecationService),(0,m.registerSingleton)(S.IExtHostCommands,S.ExtHostCommands),(0,m.registerSingleton)(I.IExtHostConfiguration,I.ExtHostConfiguration),(0,m.registerSingleton)(E.IExtHostConsumerFileSystem,E.ExtHostConsumerFileSystem),(0,m.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService),(0,m.registerSingleton)(_.IExtHostDecorations,_.ExtHostDecorations),(0,m.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,m.registerSingleton)(w.IExtHostFileSystemInfo,w.ExtHostFileSystemInfo),(0,m.registerSingleton)(F.IExtHostOutputService,F.ExtHostOutputService),(0,m.registerSingleton)(l.IExtHostSearch,l.ExtHostSearch),(0,m.registerSingleton)(h.IExtHostStorage,h.ExtHostStorage),(0,m.registerSingleton)(n.IExtHostTask,n.WorkerExtHostTask),(0,m.registerSingleton)(C.IExtHostTerminalService,C.WorkerExtHostTerminalService),(0,m.registerSingleton)(a.IExtHostTunnelService,a.ExtHostTunnelService),(0,m.registerSingleton)(f.IExtHostWindow,f.ExtHostWindow),(0,m.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace),(0,m.registerSingleton)(u.IExtHostSecretState,u.ExtHostSecretState),(0,m.registerSingleton)(p.IExtHostTelemetry,p.ExtHostTelemetry),(0,m.registerSingleton)(b.IExtHostEditorTabs,b.ExtHostEditorTabs)}),define(Ee[225],_e([0,1,223,34,219,6,16,5,11]),function(ee,e,m,F,D,_,I,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var C;(function(a){const d=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(E,...w)=>{w.forEach(t=>{if(!self.trustedTypes?.isScript(t))throw new Error("TrustedScripts only, please")});const u=w.slice(0,-1).join(","),p=w.pop().toString();return`(function anonymous(${u}) {
${p}
})`}});function f(...E){return d?self.eval(d.createScript("",...E)):new Function(...E)}a.create=f})(C||(C={}));class n extends D.RequireInterceptor{_installInterceptor(){}getModule(d,f){for(let E of this._alternatives){let w=E(d);if(w){d=w;break}}if(this._factories.has(d))return this._factories.get(d).load(d,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class k extends F.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=_.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const d=this._extHostContext.getProxy(S.MainContext.MainThreadConsole);h(d,this._initData.environment.isExtensionDevelopmentDebug);const f=this._instaService.invokeFunction(m.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(n,f,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(d){return d.browser}async _loadCommonJSModule(d,f,E){f=f.with({path:l(f.path,".js")}),d&&performance.mark(`code/extHost/willFetchExtensionCode/${d.value}`);const w=await fetch(y.FileAccess.asBrowserUri(f).toString(!0));if(d&&performance.mark(`code/extHost/didFetchExtensionCode/${d.value}`),w.status!==200)throw new Error(w.statusText);const u=await w.text(),p=`${f.toString(!0)}#vscode-extension`,b=`${u}
//# sourceURL=${p}`;let t;try{t=C.create(k._ttpExtensionScripts?.createScript("module")??"module",k._ttpExtensionScripts?.createScript("exports")??"exports",k._ttpExtensionScripts?.createScript("require")??"require",k._ttpExtensionScripts?.createScript(b)??b)}catch(c){throw console.error(d?`Loading code for extension ${d.value} failed: ${c.message}`:`Loading code failed: ${c.message}`),console.error(`${f.toString(!0)}${typeof c.line=="number"?` line ${c.line}`:""}${typeof c.column=="number"?` column ${c.column}`:""}`),console.error(c),c}const s={},r={exports:s},i=c=>{const g=this._fakeModules.getModule(c,f);if(g===void 0)throw new Error(`Cannot load module '${c}'`);return g};try{return E.codeLoadingStart(),d&&performance.mark(`code/extHost/willLoadExtensionCode/${d.value}`),t(r,s,i),r.exports!==s?r.exports:s}finally{d&&performance.mark(`code/extHost/didLoadExtensionCode/${d.value}`),E.codeLoadingStop()}}async $setRemoteEnvironment(d){throw new Error("Not supported")}async _waitForDebuggerAttachment(d=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+d;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,I.timeout)(10)}}e.ExtHostExtensionService=k,k._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:a=>a});function l(a,d){return a.endsWith(d)?a:a+d}function h(a,d){f("info","log"),f("log","log"),f("warn","warn"),f("error","error");function f(u,p){const b=console[u];console[u]=function(){a.$logExtensionHostMessage({type:"__$console",severity:p,arguments:w(arguments)}),d&&b.apply(console,arguments)}}const E=1e5;function w(u){const p=[],b=[];if(u.length)for(let t=0;t<u.length;t++){if(typeof u[t]=="undefined")u[t]="undefined";else if(u[t]instanceof Error){const s=u[t];s.stack?u[t]=s.stack:u[t]=s.toString()}b.push(u[t])}try{const t=JSON.stringify(b,function(s,r){if(r&&typeof r=="object"){if(p.indexOf(r)!==-1)return"[Circular]";p.push(r)}return r});return t.length>E?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(Ee[226],_e([0,1,57,15,34,75,225,212]),function(ee,e,m,F,D,_,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(D.IExtHostExtensionService,I.ExtHostExtensionService),(0,m.registerSingleton)(F.ILogService,S.ExtHostLogService),(0,m.registerSingleton)(_.IExtensionStoragePaths,_.ExtensionStoragePaths)}),define(Ee[228],_e([0,1,23,3,180,220,214,14,76,11,2,224,226]),function(ee,e,m,F,D,_,I,S,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const w=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:p=>p}),u=self.Worker;Worker=function(p,b){/^file:/i.test(p.toString())&&(p=C.FileAccess.asBrowserUri(n.URI.parse(p.toString())).toString(!0));const t=`(function() {
	const ttPolicy = self.trustedTypes ? self.trustedTypes.createPolicy('extensionHostWorker', { createScriptURL: (value) => value }) : undefined;
	const stringUrl = '${p}';
	importScripts(ttPolicy ? ttPolicy.createScriptURL(stringUrl) : stringUrl);
})();
`;b=b||{},b.name=b.name||S.basename(p.toString());const s=new Blob([t],{type:"application/javascript"}),r=URL.createObjectURL(s);return new u(w?w.createScriptURL(r):r,b)}}else self.Worker=class extends I.NestedWorker{constructor(w,u){super(l,w,{name:S.basename(w.toString()),...u})}};const h=new class{exit(w){k()}async exists(w){return!0}async realpath(w){return w}};class a{constructor(){const u=new MessageChannel,p=new F.Emitter;let b=!1;l(u.port2,[u.port2]),u.port1.onmessage=t=>{const{data:s}=t;if(!(s instanceof ArrayBuffer)){console.warn("UNKNOWN data received",s);return}const r=m.VSBuffer.wrap(new Uint8Array(s,0,s.byteLength));if((0,D.isMessageOfType)(r,2)){b=!0,f("received terminate message from renderer");return}p.fire(r)},this.protocol={onMessage:p.event,send:t=>{if(!b){const s=t.buffer.buffer.slice(t.buffer.byteOffset,t.buffer.byteOffset+t.buffer.byteLength);u.port1.postMessage(s,[s])}}}}}function d(w){return new Promise(u=>{const p=w.onMessage(b=>{p.dispose();const t=JSON.parse(b.toString());w.send((0,D.createMessageOfType)(0)),u({protocol:w,initData:t})});w.send((0,D.createMessageOfType)(1))})}let f=w=>k();function E(){const w=new a;y.mark("code/extHost/willConnectToRenderer"),d(w.protocol).then(u=>{y.mark("code/extHost/didWaitForInitData");const p=new _.ExtensionHostMain(u.protocol,u.initData,h,null);f=b=>p.terminate(b)})}e.create=E})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/599f5d2c67571f84a045a59eb3423bc254ee87d9/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
